function ToolTip()
{
	this.target = null;
}

ToolTip.prototype.__construct = function()
{
	document.body.appendChild(this.DOM);
	setTimeout($.proxy(this.createDestroyer, this), 500);
}

ToolTip.prototype.setPosition = function(x, y)
{
	var c = {x: window.innerWidth, y: window.innerHeight};
	var r = {x: this.content.offsetWidth, y: this.content.offsetHeight};
	
	this.content.style.left = Math.max(0, Math.min(c.x - r.x, x*1 - r.x / 2)) + 'px';
	this.content.style.top = Math.max(0, Math.min(c.y - r.y, y*1 - r.y / 2)) + 'px';
}

ToolTip.prototype.setContent = function(val)
{
	$(this.content).html(val['DOM'] || val);
}

ToolTip.prototype.hide = function()
{
	var target = this.target;
	this.destroy();
	if (target) 
	{
		$(target).removeClass('tooltip-target');
	}
}

ToolTip.prototype.createDestroyer = function()
{
	var self = this;
	$(document).one(CLICK_EVENT, $.proxy(this.hide, this));
}

ToolTip.createAtEvent = function(content, event)
{
	var e = event['originalEvent'] || event;
	e = e['changedTouches'] ? e['changedTouches'][0] : e;
	var t = ToolTip.create(content, e.pageX, e.pageY);
	t.target = e.currentTarget;
	$(t.target).addClass('tooltip-target');
}

ToolTip.create = function(content, x, y)
{
	if (!content) return;
	
	var t = COM.create('ToolTip');
	
	t.setContent(content);
	t.setPosition(x, y);
	
	return t;
}

