function CheckBox()
{
	callParentConstructor(CheckBox.prototype, this);
	
	this._checked = null;
	this.__defineGetter__('checked', this.getChecked);
	this.__defineSetter__('checked', this.setChecked);
}

extendClass(CheckBox.prototype, Input.prototype);

CheckBox.prototype.__construct = function()
{
	superMethod(CheckBox.prototype, '__construct', this)();
	
	this.checked = this.DOM.hasAttribute('checked');
	if (!this.label)
	{
		this.label = this.__inlineData;
	}
	
	this.setClickArea();
}

CheckBox.prototype.onClick = function(e)
{
	superMethod(CheckBox.prototype, 'onClick', this)(e);
	
	if (this.disabled) 
	{
		e.stopImmediatePropagation();
		return false;
	}
	
	this.change();
}

CheckBox.prototype.change = function()
{
	this.checked = !this.checked;
	$(this.DOM).triggerHandler('change');
}

CheckBox.prototype.setLabel = function(v)
{
	superMethod(CheckBox.prototype, 'setLabel', this)(v);
	this.labelText.innerHTML = String(this.label);
}

CheckBox.prototype._checked = false;
CheckBox.prototype.getChecked = function()
{ 
	return Boolean(this._checked); 
}
CheckBox.prototype.setChecked = function(v)
{
	v = Boolean(v);
	
	if (v != this._checked)
	{
		if (this.DOM) $(this.DOM).toggleClass('checked', v);
	}
	
	this._checked = v; 
}
