function Input()
{
	this._value = null;
	this.__defineGetter__('value', this.getValue);
	this.__defineSetter__('value', this.setValue);
	
	this._disabled = false;
	this.__defineGetter__('disabled', this.getDisabled);
	this.__defineSetter__('disabled', this.setDisabled);
	
	this._skin = 'default';
	this.__defineGetter__('skin', this.getSkin);
	this.__defineSetter__('skin', this.setSkin);
	
	this._label = '';
	this.__defineGetter__('label', this.getLabel);
	this.__defineSetter__('label', this.setLabel);
	this.__defineGetter__('caption', this.getLabel);
	this.__defineSetter__('caption', this.setLabel);
	
	this.onClick = $.proxy(this.onClick, this);	
	this._clickArea = null;
	this.__defineGetter__('clickArea', this.getClickArea);
	this.__defineSetter__('clickArea', this.setClickArea);
}

Input.prototype._value = null;
Input.prototype._disabled = false;
Input.prototype._skin = null;
Input.prototype._label = null;
Input.prototype._clickArea = null;

Input.prototype.__construct = function()
{
	this.value = this.DOM.hasAttribute('value') ? this.DOM.getAttribute('value') : null;
	this.disabled = this.DOM.hasAttribute('disabled');
	this.skin = this.DOM.hasAttribute('skin') ? this.DOM.getAttribute('skin') : 'default';
	
	this.caption = this.DOM.hasAttribute('caption') ? this.DOM.getAttribute('caption') : '';
	this.label = this.DOM.hasAttribute('label') ? this.DOM.getAttribute('label') : '';
}

Input.prototype.validate = function(val)
{
	return val;
}

Input.prototype.getValue = function()
{
	return this.validate(this._value);
}

Input.prototype.setValue = function(v)
{
	this._value = this.validate(v);
}

Input.prototype.getDisabled = function()
{
	return Boolean(this._disabled); 
}

Input.prototype.setDisabled = function(v)
{
	v = Boolean(v);
	
	if (v != this._disabled && this.DOM)
	{
		$(this.DOM).toggleClass('disabled', v);
	}
	
	this._disabled = v; 
}

Input.prototype.getSkin = function()
{
	return this._skin;
}

Input.prototype.setSkin = function(v)
{
	if (this.DOM)
	{
		$(this.DOM).removeClass(this._skin).addClass(v);
	}
	this._skin = v;
}

Input.prototype.getLabel = function()
{
	return this._label;
}

Input.prototype.setLabel = function(v)
{
	this._label = v;
}

Input.prototype.getClickArea = function()
{ 
	return this._clickArea || this.DOM; 
}

Input.prototype.setClickArea = function(v)
{
	$(this.clickArea).off(CLICK_EVENT, this.onClick);
	this._clickArea = v;
	
	$(this.clickArea).css('cursor', this.disabled ? 'default' : 'pointer'); 
	$(this.clickArea).on(CLICK_EVENT, this.onClick);
}

Input.prototype.onClick = function(e)
{
}
