function NumericStepper()
{
	this.__defineGetter__('icon', function(){ return COM(this.input).icon; });
	this.__defineSetter__('icon', function(val){ return COM(this.input).icon = val; });
	
	this.__defineGetter__('max', function(){ return COM(this.input).max; });
	this.__defineSetter__('max', function(val){ return COM(this.input).max = val; });
	
	this.__defineGetter__('min', function(){ return COM(this.input).min; });
	this.__defineSetter__('min', function(val){ return COM(this.input).min = val; });
	
	this.__defineGetter__('placeholder', function(){ return COM(this.input).placeholder; });
	this.__defineSetter__('placeholder', function(val){ return COM(this.input).placeholder = val; });
	
	this.__defineGetter__('size', function(){ return COM(this.input).size; });
	this.__defineSetter__('size', function(val){ return COM(this.input).size = val; });
	
	this.__defineGetter__('step', function(){ return COM(this.input).step; });
	this.__defineSetter__('step', function(val){ return COM(this.input).step = val; });
	
	this.__defineGetter__('value', function(){ return COM(this.input).value; });
	this.__defineSetter__('value', function(val){ return COM(this.input).value = val; });
	
	this.__defineGetter__('skin', function(){ return COM(this.input).skin; });
	this.__defineSetter__('skin', function(val){ return COM(this.input).skin = val; });
	
	this.__defineGetter__('disabled', function(){ return COM(this.input).disabled; });
	this.__defineSetter__('disabled', function(val){ 
		COM(this.input).disabled = val;
		COM(this.less).enabled = !val; 
		COM(this.more).enabled = !val; 
	});

	this.__defineGetter__('reason', function(){ return COM(this.less).reason; });
	this.__defineSetter__('reason', function(val){ 
		COM(this.less).reason = val; 
		COM(this.more).reason = val;
		COM(this.input).disabled = !!val;
	});
}

NumericStepper.prototype.__construct = function()
{
	this.disabled = this.DOM.hasAttribute('disabled');
	this.skin = this.DOM.hasAttribute('skin') ? this.DOM.getAttribute('skin') : 'default';
	if (this.DOM.hasAttribute('value')) this.value = this.DOM.getAttribute('value');
	if (this.DOM.hasAttribute('size')) this.size = this.DOM.getAttribute('size') * 1;
	if (this.DOM.hasAttribute('icon')) this.icon = this.DOM.getAttribute('icon');
	if (this.DOM.hasAttribute('placeholder')) this.placeholder = this.DOM.getAttribute('placeholder');
	if (this.DOM.hasAttribute('min')) this.min = this.DOM.getAttribute('min') * 1;
	if (this.DOM.hasAttribute('max')) this.max = this.DOM.getAttribute('max') * 1;
	if (this.DOM.hasAttribute('step')) this.step = this.DOM.getAttribute('step') * 1;
	
	COM.bindExclusiveClick(this.less, $.proxy(this.decrease, this));
	COM.bindExclusiveClick(this.more, $.proxy(this.increase, this));
	$(this.input).on('change', $.proxy(function(){ $(this.DOM).triggerHandler('change'); }, this));
}

NumericStepper.prototype.increase = function()
{
	return this.doStep(1);
}

NumericStepper.prototype.decrease = function()
{
	return this.doStep(-1);
}

NumericStepper.prototype.doStep = function(dir)
{
	var ret = COM(this.input).doStep(dir*1);
	$(this.DOM).triggerHandler('change');
	return ret;
}
