function RadioGroup()
{
	callParentConstructor(RadioGroup.prototype, this);
	
	this.items = [];
	this.__defineGetter__('selectedIndex', this.getSelectedIndex);
	this.__defineSetter__('selectedIndex', this.setSelectedIndex);
}

extendClass(RadioGroup.prototype, Input.prototype);

RadioGroup.prototype.__construct = function()
{
	superMethod(RadioGroup.prototype, '__construct', this)();
	
	$('>*', $('<span>'+this.__inlineData+'</span>')).each($.proxy(function(n, obj){
		
		var btn = 
		{
			disabled: obj.hasAttribute('disabled'),
			checked: obj.hasAttribute('checked'),
			label: obj.getAttribute('label') || obj.innerHTML,
			value: obj.getAttribute('value'),
			skin: obj.getAttribute('skin') || 'default',
		}
		this.addRadioButton(btn);
		
	}, this));
}

RadioGroup.prototype.setButtons = function(buttons)
{
	this.clear();
	var len = buttons.length;
	while (this.items.length < len) 
	{
		this.addRadioButton(buttons[i]);
	}
}

RadioGroup.prototype.clear = function(idx)
{
	while (this.items.length > 0) 
	{
		this.destroyRadioButton();
	}
}

RadioGroup.prototype.addRadioButton = function(params)
{
	var item = COM.create('RadioButton');
	for (var prop in params)
	{
		item[prop] = params[prop];
	}
	
	this.wrapper.appendChild(item.DOM);
	
	$(item.DOM).on('change', $.proxy(function(e){
		
		var target = COM(e.currentTarget), idx = this.selectedIndex;
		var n = -1;
		for (var i = 0, len = this.items.length; i < len; i++)
		{
			if (this.items[i].ID == target.ID) 
			{
				n = i; break;
			}
		}
		
		this.selectedIndex = n;
		$(this.DOM).triggerHandler('change');
		
	}, this))
	
	this.items.push(item);
}

RadioGroup.prototype.destroyRadioButton = function(idx)
{
	if (typeof idx == 'undefined') idx = this.items.length - 1;
	if (idx < 0 || idx >= this.items.length) return;
	
	var item = this.items.splice(idx);
	item.destroy();
}

RadioGroup.prototype.getValue = function()
{
	var idx = this.selectedIndex;
	return idx < 0 ? null : this.items[idx].value; 
}
RadioGroup.prototype.setValue = function(v)
{
	for (var i = 0, len = this.items.length; i < len; i++)
	{
		if (this.items[i].value == v) return this.selectedIndex = i;
	}
	this.selectedIndex = -1;
}

RadioGroup.prototype.onClick = function(e)
{
	if (this.disabled)
	{
		e.stopImmediatePropagation();
		return false;
	}
	superMethod(RadioGroup.prototype, 'onClick', this)(e);
}

RadioGroup.prototype.getSelectedIndex = function()
{
	for (var i = 0, len = this.items.length; i < len; i++)
	{
		if (this.items[i].checked) return i;
	}
	return -1;
}
RadioGroup.prototype.setSelectedIndex = function(v)
{
	for (var i = 0, len = this.items.length; i < len; i++)
	{
		this.items[i].checked = (i == v);
	}
}
