function NumericKeyboard()
{
	callParentConstructor(NumericKeyboard.prototype, this);
}

extendClass(NumericKeyboard.prototype, VirtualKeyboard.prototype);

NumericKeyboard.prototype.__className__ = 'NumericKeyboard';

NumericKeyboard.prototype.__construct = function(input, target)
{
	superMethod(NumericKeyboard.prototype, '__construct', this)(input, target);
	this.target.DOM.style.visibility = 'hidden';
}

NumericKeyboard.prototype.__destruct = function()
{
	this.target.DOM.style.visibility = '';
	superMethod(NumericKeyboard.prototype, '__destruct', this)();
}

NumericKeyboard.prototype.show = function()
{
	superMethod(NumericKeyboard.prototype, 'show', this)();
	this.updateDisplayValue();
}

NumericKeyboard.prototype.processKey = function(e, alias)
{
	superMethod(NumericKeyboard.prototype, 'processKey', this)(e, alias);
	if (this.input.value.length > 12) this.input.value = this.input.value.substring(0, 12);
	this.updateDisplayValue();
	return false;
}

NumericKeyboard.prototype.updateDisplayValue = function()
{
	$(this.displayValue).toggleClass('original', !this.edited);
	if (this.displayValue.firstChild) this.displayValue.firstChild.innerHTML = this.edited ? this.input.value : this.originalValue;
}

NumericKeyboard.prototype.fitLayout = function(fit)
{
	// window bounds
	var w = {w: window.innerWidth, h: window.innerHeight};
	
	function intersects(r1, r2)
	{
		if (r1.x < r2.x && r1.x + r1.w < r2.x) return false;
		if (r1.y < r2.y && r1.y + r1.h < r2.y) return false;
		
		if (r1.x > r2.x + r2.w && r1.x + r1.w > r2.x + r2.w) return false;
		if (r1.y > r2.y + r2.h && r1.y + r1.h > r2.y + r2.h) return false;
		
		return true;
	}
	
	function fitK(obj, extend)
	{
		var k = $.extend(obj, extend || {});
		k.x = Math.max(0, Math.min(w.w - k.w, k.x*1));
		k.y = Math.max(0, Math.min(w.h - k.h, k.y*1));
		return k;
	}
	
	// input rectangle
	var offset = $(this.target.DOM).offset();
	var i = {
		x: offset.left,
		y: offset.top,
		w: this.target.DOM.offsetWidth,
		h: this.target.DOM.offsetHeight
	};
	// keyboard rectangle
	var k = {
		w: this.DOM.offsetWidth, 
		h: this.DOM.offsetHeight,
	}
	// default position and check window bounds
	k = fitK(k, {x: i.x - (k.w - i.w) / 2, y: i.y});
	
	this.DOM.style.left = k.x + 'px';
	this.DOM.style.top = k.y + 'px';
}
