function ScrollableListItem()
{
	this._data = null;
	this._skin = 'default';
	
	this.__defineGetter__('data', this.getData);
	this.__defineSetter__('data', this.setData);
	
	this.__defineGetter__('skin', this.getSkin);
	this.__defineSetter__('skin', this.setSkin);
	
	this.__defineGetter__('selected', this.getSelected);
	this.__defineSetter__('selected', this.setSelected);
	
	this.__defineGetter__('disabled', this.getDisabled);
	this.__defineSetter__('disabled', this.setDisabled);
	
}

ScrollableListItem.prototype.__construct = function()
{
}

ScrollableListItem.prototype.getData = function()
{
	return this._data;
}

ScrollableListItem.prototype.setData = function(val)
{
	this._data = val;
	this.refresh();
}

ScrollableListItem.prototype.getSkin = function()
{
	return this._skin;
}

ScrollableListItem.prototype.setSkin = function(val)
{
	if (this._skin) 
	{
		$(this.DOM).removeClass(this._skin);
	}
	this._skin = val;
	$(this.DOM).addClass(this._skin);
}

ScrollableListItem.prototype.getSelected = function()
{
	return $(this.DOM).hasClass('selected');
}

ScrollableListItem.prototype.setSelected = function(val)
{
	$(this.DOM).toggleClass('selected', Boolean(val));
}

ScrollableListItem.prototype.getDisabled = function()
{
	return $(this.DOM).hasClass('disabled');
}

ScrollableListItem.prototype.setDisabled = function(val)
{
	$(this.DOM).toggleClass('disabled', Boolean(val));
}

ScrollableListItem.prototype.clear = function()
{
	$('>*', this.DOM).remove();
}

ScrollableListItem.prototype.refresh = function()
{
	if (!this._data)
	{
		return this.clear();
	}
	
	var data = (typeof this._data == 'object' && this._data['length']) ? this._data : [this._data];
	var len = this.DOM.children.length, items = data.length;
	while (len > items)
	{
		this.DOM.removeChild(0);
		len--;
	}
	while (len < items)
	{
		var cell = document.createElement('cell');
		this.DOM.appendChild(cell);
		len++;
	}
	
	for (var i = 0; i < len; i++)
	{
		this.DOM.children[i].innerHTML = String(data[i]);
	}
}
