function Army(army)
{
	callParentConstructor(Army.prototype, this);
	
	this.__defineGetter__('scavenger', function()
	{
		return this.units[UnitType.SCAVENGER.ordinal];
	});
	
	this.__defineSetter__('scavenger', function(value)
	{
		this.units[UnitType.SCAVENGER.ordinal] = value;
	});
	
	this.__defineGetter__('melee', function()
	{
		return this.units[UnitType.MELEE.ordinal];
	});
	
	this.__defineSetter__('melee', function(value)
	{
		this.units[UnitType.MELEE.ordinal] = value;
	});
	
	this.__defineGetter__('cavalry', function()
	{
		return this.units[UnitType.CAVALRY.ordinal];
	});
	
	this.__defineSetter__('cavalry', function(value)
	{
		this.units[UnitType.CAVALRY.ordinal] = value;
	});
	
	this.__defineGetter__('flyer', function()
	{
		return this.units[UnitType.FLYER.ordinal];
	});
	
	this.__defineSetter__('flyer', function(value)
	{
		this.units[UnitType.FLYER.ordinal] = value;
	});
	
	this.__defineGetter__('ranger', function()
	{
		return this.units[UnitType.RANGER.ordinal];
	});
	
	this.__defineSetter__('ranger', function(value)
	{
		this.units[UnitType.RANGER.ordinal] = value;
	});
	
	this.__defineGetter__('healer', function()
	{
		return this.units[UnitType.HEALER.ordinal];
	});
	
	this.__defineSetter__('healer', function(value)
	{
		this.units[UnitType.HEALER.ordinal] = value;
	});
	
	this.__defineGetter__('miner', function()
	{
		return this.units[UnitType.MINER.ordinal];
	});
	
	this.__defineSetter__('miner', function(value)
	{
		this.units[UnitType.MINER.ordinal] = value;
	});
	
	this.__defineGetter__('mage', function()
	{
		return this.units[UnitType.MAGE.ordinal];
	});
	
	this.__defineSetter__('mage', function(value)
	{
		this.units[UnitType.MAGE.ordinal] = value;
	});

	
	this.units = [];
	for (var i = 0; i < UnitType.MILITARY.length; i++)
	{
		this.units.push(0);
	}
	
	if (typeof army != "undefined") 
	{
        this.add(army);
    }

};

extendClass(Army.prototype, Arithmetical.prototype);

Army.prototype.__CLS__ = 'game.model.unit.Army';

$.extend(Army.prototype,
{
	units: [],
	
	prepareForRequest: function()
	{
		return {
			__CLS__: "game.model.unit.Army",
			melee: Math.floor(this.melee),
	        scavenger: Math.floor(this.scavenger),
	        ranger: Math.floor(this.ranger),
	        healer: Math.floor(this.healer),
	        miner: Math.floor(this.miner),
	        cavalry: Math.floor(this.cavalry),
	        flyer: Math.floor(this.flyer),
	        mage: Math.floor(this.mage)
		};
	},
	
    getCapacity: function(race, science)
	{
	    var level = science.getLevel(Science.SCAVENGER);
	    return this.scavenger * FConfig.getStat(race, UnitType.SCAVENGER, level).capacity;
	},

    getTotalUnitCount: function()
	{
        return this.melee*1 + this.scavenger*1 + this.ranger*1 + this.healer*1 +
        + this.miner*1 + this.cavalry*1 + this.flyer*1 + this.mage*1;
   	},

    getValue: function(u)
	{
        switch(u.name) 
        {
            case UnitType.MELEE.name:		return this.melee;
            case UnitType.SCAVENGER.name:	return this.scavenger;
            case UnitType.RANGER.name:		return this.ranger;
            case UnitType.HEALER.name:		return this.healer;
            case UnitType.MINER.name:		return this.miner;
            case UnitType.CAVALRY.name:		return this.cavalry;
            case UnitType.FLYER.name:		return this.flyer;
            case UnitType.MAGE.name:		return this.mage;
            default: throw new Error("Can't get unit: {0}", u);
        }
  	},
    setValue: function(u, amount)
	{
        switch(u.name) 
        {
            case UnitType.MELEE.name:		this.melee = amount; break;
            case UnitType.SCAVENGER.name:	this.scavenger = amount; break;
            case UnitType.RANGER.name:		this.ranger = amount; break;
            case UnitType.HEALER.name:		this.healer = amount; break;
            case UnitType.MINER.name:		this.miner = amount; break;
            case UnitType.CAVALRY.name:		this.cavalry = amount; break;
            case UnitType.FLYER.name:		this.flyer = amount; break;
            case UnitType.MAGE.name:		this.mage = amount; break;
            default: throw new Error("Can't set unit: {0}", u);
        }
   	},

    addUnit: function(u, amount)
	{
        this.setValue(u, this.getValue(u) + amount);
   	},

    killUnit: function(type, amount)
	{
        this.setValue(type, this.getValue(type) - amount);
        if (this.getValue(type) < 0) {
            throw new Error("Trying to kill more units than we have: {0}", this);
        }
   	},

    getByOrdinal: function(ordinal)
	{
        return this.units[ordinal];
    },

    setByOrdinal: function(ordinal, value)
	{
        this.units[ordinal] = value;
    },

    toArray: function()
	{
        return Arrays.clone(this.units);
    },

    isEmpty: function()
	{
        for (var i = 0; i < 8; i++) 
        {
            if (this.units[i] != 0) 
            {
                return false;
            }
        }
        return true;
    },

    toFunds: function(race, levels)
	{
        var result = new Funds();
        for (var i = 0; i < UnitType.MILITARY.length; i++) 
        {
            var ut = UnitType.MILITARY[i];
            result.add(FConfig.getStat(race, ut, levels[i]).cost.multiplyCopy(this.getValue(ut)));
        }
        return result;
    },
        
    cacheProps: function()
	{
	    return this.supportedProps = ["scavenger", "melee", "cavalry", "flyer", "ranger", "healer", "miner", "mage"];
	}
       
});

Army.create = function(units)
{
    var result = new Army();
    result.units = units;
    return result;
};

Army.addArmies = function(one, another)
{
    var result = new Array(UnitType.MILITARY.length);
    for (var i = 0; i < result.length; i++) 
    {
        result[i] = one[i] + another[i];
    }
    return result;
};

//////////////////////////////////////////////////////////////////////



