function BuffType(name, type)
{
	this.name = name;
	
	this.__defineGetter__('type', this.getType);
	this.__defineSetter__('type', this.setType);
	this.type = (typeof type == "undefined") ? 'percent' : type;
}

extendClass(BuffType.prototype, Enum.prototype);

BuffType.__isEnum__ = true;

BuffType.prototype.__CLS__ = "game.model.buff.BuffType";

BuffType.prototype.prepareForRequest = function()
{
	return {
		__CLS__: this.__CLS__,
		name: this.name
	};
}

BuffType.prototype.getType = function()
{
    return this._type;
}

BuffType.prototype.setType = function(val)
{
    this._type = val;
}

BuffType.prototype.isMilitary = function(b, attacker, ally)
{
	var checkTarget = function(b, t)
	{
		for (var i = 0, len = b.targets.length; i < len; i++) 
		{
			if (b.targets[i].name == t.name) 
			{
				return true;
			}
		}
		return false;
	}
	
	var findBuff = function(b, lst)
	{
		for (var i = 0, len = lst.length; i < len; i++) 
		{
			if (b.name == lst[i].name) return i;
		}
		return -1;
	}
	
    // todo(sp): check meaning/usage of ally (looks like inconsistent usage / bug)
    var affectsDefender = attacker && checkTarget(b, BuffTarget.ENEMY)
        || !attacker && (ally && checkTarget(b, BuffTarget.ALLY)
        || !ally && checkTarget(b, BuffTarget.SELF)
	);
    if (b.btype && affectsDefender) 
    {
        if(b.btype.name == BType.MAGIC_TOWER.name 
        	|| b.btype.name == BType.TOWER.name 
        	|| b.btype.name == BType.FORTIFICATION.name 
        	|| b.btype.name == BType.CASTLEGATE.name
        )
        {
            return true;
        }
    }
    var affectsAttacker = attacker && (checkTarget(b, BuffTarget.SELF) || checkTarget(b, BuffTarget.ALLY))
		|| !attacker && checkTarget(b, BuffTarget.ENEMY)
	;
    
    if (affectsDefender && findBuff(this, BuffType.defenderBuffs) >= 0) 
    {
        return true;
    }
    if (affectsAttacker && findBuff(this, BuffType.attackerBuffs) >= 0) 
    {
        return true;
    }
    if (findBuff(this, BuffType.militaryBuffs) >= 0) 
    {
        return true;
    }
    
    return false;
}

BuffType.prototype.isGlobal = function() 
{
    var lst = [
        BuffType.GATES_CANT_BE_CLOSED,
        BuffType.SENSE_THREATS_TO_ALLIES,
        BuffType.RADAR,
        BuffType.SHOW_GATE_STATE,
        BuffType.SHOW_FLAGS,
        BuffType.PERSONAL_NEGATIVE_EVENTS_STOP,
        BuffType.EVENT_HAPPEN_CHANCE,
        BuffType.EVENT_EXTEND_CHANCE,
        BuffType.SCIENCE_BOOST,
        BuffType.SCIENCE_VALUE,
        BuffType.GLOBAL_ARMY_CONSUMPTION
    ];
    
	for (var i = 0, len = lst.length; i < len; i++) 
	{
		if (this.name == lst[i].name) return true;
	}
	return false;
}

BuffType.BOOST_BUILDING = new BuffType("BOOST_BUILDING");
BuffType.BOOST_BUILDING_CUMULATIVE = new BuffType("BOOST_BUILDING_CUMULATIVE");
BuffType.STOP_BUILDING = new BuffType("STOP_BUILDING");
BuffType.CONSTRUCTION_TIME = new BuffType("CONSTRUCTION_TIME");
BuffType.REPAIR_TIME = new BuffType("REPAIR_TIME");
BuffType.SCIENCE_STOP = new BuffType("SCIENCE_STOP");
BuffType.SCIENCE_BOOST = new BuffType("SCIENCE_BOOST");
BuffType.SCIENCE_VALUE = new BuffType("SCIENCE_VALUE");
BuffType.GATES_CANT_BE_CLOSED = new BuffType("GATES_CANT_BE_CLOSED");
BuffType.PERSONAL_NEGATIVE_EVENTS_STOP = new BuffType("PERSONAL_NEGATIVE_EVENTS_STOP");
BuffType.MILITARY_PRODUCTION_STOP = new BuffType("MILITARY_PRODUCTION_STOP");
BuffType.TENDER_CAPTURE = new BuffType("TENDER_CAPTURE");
BuffType.RUIN_LEGACY = new BuffType("RUIN_LEGACY");
BuffType.NO_DESERTION = new BuffType("NO_DESERTION");
BuffType.SAVE_RESOURCES_OVERFLOW = new BuffType("SAVE_RESOURCES_OVERFLOW");
BuffType.SAVE_PEOPLE_OVERFLOW = new BuffType("SAVE_PEOPLE_OVERFLOW");
BuffType.SENSE_THREATS_TO_ALLIES = new BuffType("SENSE_THREATS_TO_ALLIES");
BuffType.DECONSTRUCTION = new BuffType("DECONSTRUCTION");
BuffType.ARTIFACT_SEEKER = new BuffType("ARTIFACT_SEEKER");
BuffType.ATTACK_TERRAIN_BONUS = new BuffType("ATTACK_TERRAIN_BONUS");
BuffType.ATTACK_BONUS = new BuffType("ATTACK_BONUS");
BuffType.DEFENSE_BONUS = new BuffType("DEFENSE_BONUS");
BuffType.HEALTH_BONUS = new BuffType("HEALTH_BONUS");
BuffType.PERSECUTION_BONUS = new BuffType("PERSECUTION_BONUS");
BuffType.ENRAGE = new BuffType("ENRAGE");
BuffType.HEALING_BONUS = new BuffType("HEALING_BONUS");
BuffType.MAGE_TOWER_RESISTANCE = new BuffType("MAGE_TOWER_RESISTANCE");
BuffType.MILITARY_PRODUCTION = new BuffType("MILITARY_PRODUCTION", "percent-reversed");
BuffType.EXPEDITORS_MISSION_TIME = new BuffType("EXPEDITORS_MISSION_TIME", "percent-reversed");
BuffType.EXPEDITORS_SPEED_STOP = new BuffType("EXPEDITORS_SPEED_STOP");
BuffType.MERCHANTS_MISSION_TIME = new BuffType("MERCHANTS_MISSION_TIME", "percent-reversed");
BuffType.MERCHANTS_CAPACITY = new BuffType("MERCHANTS_CAPACITY");
BuffType.HERO_MISSION_TIME = new BuffType("HERO_MISSION_TIME", "percent-reversed");
BuffType.MILITARY_MISSION_TIME = new BuffType("MILITARY_MISSION_TIME", "percent-reversed");
BuffType.INCOMING_ATTACK_TIME = new BuffType("INCOMING_ATTACK_TIME", "percent-reversed");
BuffType.INCOMING_ASSIST_TIME = new BuffType("INCOMING_ASSIST_TIME", "percent-reversed");
BuffType.INCOMING_MOVE_ARMY_TIME = new BuffType("INCOMING_MOVE_ARMY_TIME", "percent-reversed");
BuffType.INCOMING_MONSTER_ATTACK_TIME = new BuffType("INCOMING_MONSTER_ATTACK_TIME", "percent-reversed");
BuffType.INCOMING_EXPEDITORS_MISSION_TIME = new BuffType("INCOMING_EXPEDITORS_MISSION_TIME", "percent-reversed");
BuffType.INCOMING_MERCHANTS_MISSION_TIME = new BuffType("INCOMING_MERCHANTS_MISSION_TIME", "percent-reversed");
BuffType.INCOMING_CAMP_MISSION_TIME = new BuffType("INCOMING_CAMP_MISSION_TIME", "percent-reversed");
BuffType.HERO_CANNOT_MOVE = new BuffType("HERO_CANNOT_MOVE");
BuffType.HERO_MISSION_INVISIBLE = new BuffType("HERO_MISSION_INVISIBLE");
BuffType.MAGIC_DISABLE = new BuffType("MAGIC_DISABLE");
BuffType.HERO_EXPERIENCE = new BuffType("HERO_EXPERIENCE");
BuffType.AUTO_PRODUCE_MILITARY = new BuffType("AUTO_PRODUCE_MILITARY");
BuffType.AUTO_PRODUCE_SPECIAL = new BuffType("AUTO_PRODUCE_SPECIAL");
BuffType.BUILD_QUEUE = new BuffType("BUILD_QUEUE");
BuffType.ARMY_RATION = new BuffType("ARMY_RATION");
BuffType.ARMY_CONSUMPTION = new BuffType("ARMY_CONSUMPTION");
BuffType.GLOBAL_ARMY_CONSUMPTION = new BuffType("GLOBAL_ARMY_CONSUMPTION");
BuffType.NO_ARMY_CONSUMPTION = new BuffType("NO_ARMY_CONSUMPTION");
BuffType.ATTACKER_CAUTION = new BuffType("ATTACKER_CAUTION");
BuffType.DEFENDER_CAUTION = new BuffType("DEFENDER_CAUTION");
BuffType.MAX_ATTACK = new BuffType("MAX_ATTACK");
BuffType.MIN_ATTACK = new BuffType("MIN_ATTACK");
BuffType.CREMATION = new BuffType("CREMATION");
BuffType.HERO_CAPTURE = new BuffType("HERO_CAPTURE");
BuffType.MONSTER_RACE = new BuffType("MONSTER_RACE");
BuffType.PARTIAL_RETREAT = new BuffType("PARTIAL_RETREAT");
BuffType.BUILDING_MARAUDER = new BuffType("BUILDING_MARAUDER");
BuffType.ARMY_MARAUDER = new BuffType("ARMY_MARAUDER");
BuffType.SLAVES_TO_SELF = new BuffType("SLAVES_TO_SELF");
BuffType.SLAVES_TO_CLAN = new BuffType("SLAVES_TO_CLAN");
BuffType.NECROMANCY_FROM_SELF = new BuffType("NECROMANCY_FROM_SELF");
BuffType.NECROMANCY_FROM_ALLIES = new BuffType("NECROMANCY_FROM_ALLIES");
BuffType.NECROMANCY_FROM_ENEMIES = new BuffType("NECROMANCY_FROM_ENEMIES");
BuffType.NECROMANCY_FROM_ALL = new BuffType("NECROMANCY_FROM_ALL");
BuffType.ILLUSION = new BuffType("ILLUSION");
BuffType.ILLUSION_ADD = new BuffType("ILLUSION_ADD");
BuffType.COUNT_INACCURACY = new BuffType("COUNT_INACCURACY");
BuffType.CAPITAL_AS_RUIN = new BuffType("CAPITAL_AS_RUIN");
BuffType.LOOT_PERCENT_CITY = new BuffType("LOOT_PERCENT_CITY");
BuffType.LOOT_PERCENT_PIT_MINE_LAKE = new BuffType("LOOT_PERCENT_PIT_MINE_LAKE");
BuffType.BERSERK = new BuffType("BERSERK");
BuffType.BETRAYER_RATING_PENALTY = new BuffType("BETRAYER_RATING_PENALTY");
BuffType.INFECTION = new BuffType("INFECTION");
BuffType.SUPPRESS_BUILDING = new BuffType("SUPPRESS_BUILDING");
BuffType.DISABLE_GOD_PROTECTION = new BuffType("DISABLE_GOD_PROTECTION");
BuffType.CONVERT_MONSTERS_ATTACK = new BuffType("CONVERT_MONSTERS_ATTACK");
BuffType.SUMMON = new BuffType("SUMMON");
BuffType.MAGES_SUPPRESS_ATTACK = new BuffType("MAGES_SUPPRESS_ATTACK");
BuffType.ECONOMY_TRAINING_MILITARY_RESOURCES = new BuffType("ECONOMY_TRAINING_MILITARY_RESOURCES", "percent-reversed");
BuffType.ECONOMY_TRAINING_MILITARY_PEOPLE = new BuffType("ECONOMY_TRAINING_MILITARY_PEOPLE", "percent-reversed");
BuffType.ECONOMY_TRAINING_SPECIAL_RESOURCES = new BuffType("ECONOMY_TRAINING_SPECIAL_RESOURCES", "percent-reversed");
BuffType.ECONOMY_TRAINING_SPECIAL_PEOPLE = new BuffType("ECONOMY_TRAINING_SPECIAL_PEOPLE", "percent-reversed");
BuffType.EXPEDITOR_DEATH = new BuffType("EXPEDITOR_DEATH");
BuffType.MERCHANT_DEATH = new BuffType("MERCHANT_DEATH");
BuffType.MONSTER_INVASION = new BuffType("MONSTER_INVASION");
BuffType.MONSTER_CANT_ATTACK = new BuffType("MONSTER_CANT_ATTACK");
BuffType.CAST_RADIUS = new BuffType("CAST_RADIUS");
BuffType.PRICE_LIMIT = new BuffType("PRICE_LIMIT", "signed-int");
BuffType.KINGDOM_ANIMATION = new BuffType("KINGDOM_ANIMATION");
BuffType.HERO_MANA_REGEN_BASE = new BuffType("HERO_MANA_REGEN_BASE", "signed-int");
BuffType.HERO_MANA_REGEN_MAGE = new BuffType("HERO_MANA_REGEN_MAGE", "real");
BuffType.HERO_MAX_MANA = new BuffType("HERO_MAX_MANA", "signed-int");
BuffType.HERO_BAG_SIZE = new BuffType("HERO_BAG_SIZE", "signed-int");
BuffType.MAGIC_DEFENSE = new BuffType("MAGIC_DEFENSE");
BuffType.CONSTRUCTION_CHAOS = new BuffType("CONSTRUCTION_CHAOS");
BuffType.AUTO_HIDEOUT = new BuffType("AUTO_HIDEOUT");
BuffType.MONSTER_MOBILIZATION = new BuffType("MONSTER_MOBILIZATION");
BuffType.GIVE_FUNDS_PER_HOUR = new BuffType("GIVE_FUNDS_PER_HOUR");
BuffType.TAKE_FUNDS_PER_HOUR = new BuffType("TAKE_FUNDS_PER_HOUR");
BuffType.INCREASE_MAX_DEFENCE = new BuffType("INCREASE_MAX_DEFENCE");
BuffType.MAX_DEFENCE = new BuffType("MAX_DEFENCE");
BuffType.ARMY_CANNOT_MOVE = new BuffType("ARMY_CANNOT_MOVE");
BuffType.SHOW_GATE_STATE = new BuffType("SHOW_GATE_STATE");
BuffType.SHOW_FLAGS = new BuffType("SHOW_FLAGS");
BuffType.HERO_NO_UPSET = new BuffType("HERO_NO_UPSET");
BuffType.HERO_UPSET_TIME = new BuffType("HERO_UPSET_TIME");
BuffType.MANA_SUCK = new BuffType("MANA_SUCK");
BuffType.MANA_BURN = new BuffType("MANA_BURN");
BuffType.DAMAGE_TO_DESTROY_BUILDING_LEVEL = new BuffType("DAMAGE_TO_DESTROY_BUILDING_LEVEL");
BuffType.CHANCE_TO_HIT_BUILDING = new BuffType("CHANCE_TO_HIT_BUILDING");
BuffType.ADDITIONAL_ATTACK = new BuffType("ADDITIONAL_ATTACK");
BuffType.ADDITIONAL_ATTACK_MULTIPLIER = new BuffType("ADDITIONAL_ATTACK_MULTIPLIER");
BuffType.ADDITIONAL_FORTIFICATION_KILLS = new BuffType("ADDITIONAL_FORTIFICATION_KILLS");
BuffType.EARTHQUAKE = new BuffType("EARTHQUAKE");
BuffType.TOWER_DOWNGRADE = new BuffType("TOWER_DOWNGRADE");
BuffType.TRUE_SIGHT = new BuffType("TRUE_SIGHT");
BuffType.RADAR = new BuffType("RADAR");
BuffType.SCAVENGERS_CAPACITY = new BuffType("SCAVENGERS_CAPACITY");
BuffType.CASTER_CAN_ATTACK = new BuffType("CASTER_CAN_ATTACK");
BuffType.EVENT_HAPPEN_CHANCE = new BuffType("EVENT_HAPPEN_CHANCE");
BuffType.EVENT_EXTEND_CHANCE = new BuffType("EVENT_EXTEND_CHANCE");
BuffType.CASTER_SILENCE = new BuffType("CASTER_SILENCE");
BuffType.PROHIBIT_ATTACK = new BuffType("PROHIBIT_ATTACK");
BuffType.SPIES_COUNT_BONUS = new BuffType("SPIES_COUNT_BONUS");
BuffType.NULL = new BuffType("NULL");
BuffType.EXPEDITORS_FLAG_CHANCE_MULTIPLIER = new BuffType("EXPEDITORS_FLAG_CHANCE_MULTIPLIER");
BuffType.ARMY_MARAUDER_IMMUNITY = new BuffType("ARMY_MARAUDER_IMMUNITY");
BuffType.BUILDING_MARAUDER_IMMUNITY = new BuffType("BUILDING_MARAUDER_IMMUNITY");

BuffType.attackerBuffs = [
    BuffType.MAGE_TOWER_RESISTANCE,
    BuffType.SCAVENGERS_CAPACITY,
    BuffType.LOOT_PERCENT_CITY,
    BuffType.LOOT_PERCENT_PIT_MINE_LAKE,
    BuffType.ARTIFACT_SEEKER,
    BuffType.DAMAGE_TO_DESTROY_BUILDING_LEVEL,
    BuffType.CHANCE_TO_HIT_BUILDING,
];

BuffType.militaryBuffs = [
    BuffType.HERO_EXPERIENCE,
    BuffType.MAX_ATTACK,
    BuffType.MIN_ATTACK,
    BuffType.PERSECUTION_BONUS,
    BuffType.ENRAGE,
    BuffType.HEALING_BONUS,
    BuffType.CREMATION,
    BuffType.HERO_CAPTURE,
    BuffType.MONSTER_RACE,
    BuffType.PARTIAL_RETREAT,
    BuffType.MAGIC_DISABLE,
    BuffType.BUILDING_MARAUDER,
    BuffType.ARMY_MARAUDER,
    BuffType.MAGES_SUPPRESS_ATTACK,
    BuffType.ATTACK_BONUS,
    BuffType.DEFENSE_BONUS,
    BuffType.HEALTH_BONUS,
    BuffType.ATTACK_TERRAIN_BONUS,
    BuffType.INCREASE_MAX_DEFENCE,
    BuffType.BERSERK,
    BuffType.BETRAYER_RATING_PENALTY,
    BuffType.INFECTION,
    BuffType.MANA_SUCK,
    BuffType.MANA_BURN,
    BuffType.SLAVES_TO_SELF,
    BuffType.SLAVES_TO_CLAN,
    BuffType.NECROMANCY_FROM_SELF,
    BuffType.NECROMANCY_FROM_ALLIES,
    BuffType.NECROMANCY_FROM_ENEMIES,
    BuffType.NECROMANCY_FROM_ALL,
    BuffType.ADDITIONAL_ATTACK,
    BuffType.ADDITIONAL_ATTACK_MULTIPLIER,
    BuffType.ADDITIONAL_FORTIFICATION_KILLS,
    BuffType.EARTHQUAKE,
    BuffType.HERO_NO_UPSET,
    BuffType.HERO_UPSET_TIME
];

BuffType.defenderBuffs = [
	BuffType.TOWER_DOWNGRADE
];
