var EstateType = function(name)
{
	this.name = name;
	
	this.__defineGetter__('hallType', function()
	{
		switch (this.name)
		{
			case "CITY":
				return BType.CITYHALL;
			case "PIT":
				return BType.PITHALL;
			case "MINE":
				return BType.MINEHALL;
			case "LAKE":
				return BType.LAKEHALL;
			case "RUIN":
				return BType.RUINHALL;
			case "CAMP":
				return BType.CAMPHALL;
			case "EVIL":
				return BType.EVILHALL;
			case "CASTLE":
				return BType.CASTLEHALL;
			case "GROTTO":
				return BType.GROTTOHALL;
			case "GRAIL":
				return BType.GRAILHALL;
			case "STONEHENGE":
			    return BType.STONEHENGEHALL;
			default:
				return null;
		}
	});
};

extendClass(EstateType.prototype, Enum.prototype);

EstateType.__isEnum__ = true;

$.extend(EstateType.prototype,
{
	__CLS__ : "game.model.EstateType",

	getMaxJoinedAttackers : function()
	{
		return this.equals(this.CASTLE) ? FConfig.MAX_INVITED_ALLIES_VS_CASTLE + 1 : FConfig.MAX_INVITED_ALLIES + 1;
	},

	getNumberOfAssistanceSlots : function()
	{
		return this.equals(this.CASTLE) ? 3 : 2;
	}
});

EstateType.findEstate = function(estate)
{
	for (var i = 0; i < this.ESTATES.length; i++)
	{
		if (this.ESTATES[i].equals(estate))
		{
			return this.ESTATES[i];
		}
	}
	return false;
};

EstateType.isAnyEstate = function(array)
{
	for (var i = 0; i < array.length; i++)
	{
		if (EstateType.findEstate(array[i]))
		{
			return true;
		}
	}
	return false;
};

EstateType.EMPTY_FIELD = new EstateType("EMPTY_FIELD");
EstateType.CITY = new EstateType("CITY");
EstateType.PIT = new EstateType("PIT");
EstateType.MINE = new EstateType("MINE");
EstateType.LAKE = new EstateType("LAKE");
EstateType.RUIN = new EstateType("RUIN");
EstateType.CAMP = new EstateType("CAMP");
EstateType.EVIL = new EstateType("EVIL");
EstateType.CASTLE = new EstateType("CASTLE");
EstateType.GROTTO = new EstateType("GROTTO");
EstateType.GRAIL = new EstateType("GRAIL");
EstateType.STONEHENGE = new EstateType("STONEHENGE");
EstateType.CATAPULT = new EstateType("CATAPULT");

EstateType.ESTATES = [EstateType.CITY, EstateType.PIT, EstateType.MINE, EstateType.LAKE, EstateType.RUIN, EstateType.CAMP, EstateType.EVIL, EstateType.CASTLE, EstateType.GROTTO, EstateType.GRAIL, EstateType.STONEHENGE, EstateType.CATAPULT];
