function FBuff()
{
	this.value = 0; // Number
	this.cast = {}; // FCast
	this.buffType = null; // BuffType
	this.buffCause = null; // BuffCause
	this.btype = null; // BType
	this.terrain = null; // Terrain
	this.science = null; // Science
	this.unitType = null; // UnitType
	this.estateType = null; // EstateType
	this.funds = null; // Funds
	this.consumedFunds = null; // Funds //transient
	this.army = null; // Army
	this.againstRaces = null; // Array
	this.myRaces = null; // Array
	this.spellName = ''; // String
	this.spellLevel = 0; // int
	this.targets = []; // ArrayCollection //<BuffTarget>;
	this.delta = 0; // Number
	this.combatPosition = null; // CombatPosition
	this.againstFraction = null; // UserFraction
};

FBuff.prototype.__CLS__ = "game.model.buff.FBuff";

FBuff.prototype.value = 0; // Number
FBuff.prototype.cast = {}; // FCast
FBuff.prototype.buffType = null; // BuffType
FBuff.prototype.buffCause = null; // BuffCause
FBuff.prototype.btype = null; // BType
FBuff.prototype.terrain = null; // Terrain
FBuff.prototype.science = null; // Science
FBuff.prototype.unitType = null; // UnitType
FBuff.prototype.estateType = null; // EstateType
FBuff.prototype.funds = null; // Funds
FBuff.prototype.consumedFunds = null; // Funds //transient
FBuff.prototype.army = null; // Army
FBuff.prototype.againstRaces = null; // Array
FBuff.prototype.myRaces = null; // Array
FBuff.prototype.spellName = ''; // String
FBuff.prototype.spellLevel = 0; // int
FBuff.prototype.targets = []; // ArrayCollection //<BuffTarget>;
FBuff.prototype.delta = 0; // Number
FBuff.prototype.combatPosition = null; // CombatPosition
FBuff.prototype.againstFraction = null; // UserFraction

FBuff.prototype.prepareForRequest = function()
{
	var ret = {
		__CLS__: this.__CLS__,
		value: this.value,
		cast: this.cast ? this.cast.prepareForRequest() : null, //FCast;
		buffType: this.buffType.prepareForRequest(), //BuffType;
		btype: this.btype, //BType;
		terrain: this.terrain, //Terrain;
		science: this.science, //Science;
		unitType: this.unitType, //UnitType;
		estateType: this.estateType, //EstateType;
		funds: this.funds ? this.funds.prepareForRequest() : null, //Funds;
		army: this.army ? this.army.prepareForRequest() : null , //Army;
		againstRaces: this.againstRaces, //Array;
		myRaces: this.myRaces, //Array;
		spellName: this.spellName, //String;
		spellLevel: this.spellLevel, //int;
		targets: this.targets, //ArrayCollection; //<BuffTarget>;
		delta: this.delta, //Number;
		combatPosition: this.combatPosition, //CombatPosition;
		againstFraction: this.againstFraction //UserFraction;
	};
	
	return ret;
}

FBuff.prototype.isActiveAt = function(tick)
{
    return this.cast.isStarted(tick) && this.cast.tillTick >= tick;
}

FBuff.getBuffs = function(buffs, type, ut, tick)
{
    return !buffs ? [] : Arrays.filter(buffs, function(buff)
    {
        return buff.buffType.name == type.name && buff.isActiveAt(tick) && (!ut || !buff.unitType || ut.name == buff.unitType.name);
    });
}

FBuff.getBuildingBuffs = function(buffs, type, btype, time)
{
    return !buffs ? [] : Arrays.filter(buffs, function(b)
    {
        return b.isActiveAt(time) && b.buffType.name == type.name && b.btype.name == btype.name;
    });
}

FBuff.sumOfBuffs = function(buffs, bt, ut, time)
{
    var sum = 0;
    if (buffs)
    {
        var buff;
        for(var i=0; i<buffs.length; i++)
        {
        	buff = buffs[i];
        	if (buff.buffType.name == bt.name && buff.isActiveAt(time) && (!ut || !buff.unitType || ut.name == buff.unitType.name))
        	{
                sum += buff.value;
            }
        }
    }
    return sum;
}

FBuff.findMaxBuff = function(buffs, bt, ut, time)
{
    var maxAbs = null;
    if (buffs)
    {
        var buff;
        for(var i=0; i<buffs.length; i++)
        {
        	buff = buffs[i];
        	if (buff.buffType.name == bt.name && buff.isActiveAt(time) && (!ut || !buff.unitType || ut.name == buff.unitType.name))
        	{
                if (!maxAbs)
                {
                    maxAbs = buff;
                }
                else
                {
                    if (Math.abs(maxAbs.value) < Math.abs(buff.value))
                    {
                        maxAbs = buff;
                    }
                }
            }
        }
    }
    return maxAbs;
}

FBuff.sumOfCauseBuffs = function(buffs, buffType, castCause, time)
{
    var sum = 0;
    if (buffs) 
    {
        for (var i = 0; i < buffs.length; i++)
        {
        	var buff = buffs[i];
            if (buff.buffType.name == buffType.name && buff.isActiveAt(time) && buff.cast.cause.name == castCause.name) 
            {
                sum += buff.value;
            }
        }
    }
    return sum;
}

FBuff.sumOfTerrainBuffs = function(buffs, bt, estate, field)
{
    var sum = 0;
    if (buffs) 
    {
        for (var i = 0; i < buffs.length; i++)
        {
        	var buff = buffs[i];
            if (buff.buffType.name == bt.name && buff.isActiveAt(FEstate.tickNowForEstate(estate)) && buff.affectsEstateField(estate, field)) 
            {
                sum += buff.value;
            }
        }
    }
    return sum;
}

FBuff.sumOfBuildingBuffs = function(buffs, bt, btype, time)
{
    var sum = 0;
    if (buffs) 
    {
        for (var i = 0; i < buffs.length; i++)
        {
        	var buff = buffs[i];
            if (buff.isActiveAt(time) && buff.buffType.name == bt.name && buff.btype.name == btype.name) 
            {
                sum += buff.value;
            }
        }
    }
    return sum;
}

FBuff.hasBuff = function(buffs, type, ut, time)
{
	return FBuff.findFirst(buffs, type, ut, time) != null;
}

FBuff.hasMagicDisable = function(buffs, time)
{
    return this.hasBuff(buffs, BuffType.MAGIC_DISABLE, null, time);
}

FBuff.findFirst = function(buffs, type, ut, time)
{
	return !buffs ? null : Arrays.firstWith(buffs, function(buff)
	{
		return buff.buffType.name == type.name && buff.isActiveAt(time) && (!ut || !buff.unitType || ut.name == buff.unitType.name);
	});
}

FBuff.buffActiveTill = function(buffs, type)
{
    var till = 0;
    if (buffs) 
    {
        for (var i = 0; i < buffs.length; i++)
        {
        	var buff = buffs[i];
            if (buff.buffType.name == type.name) 
            {
                till = Math.max(till, buff.cast.tillTick);
            }
        }
    }
    return till;
}

FBuff.prototype.isTerrainOk = function(terrain1, terrain2)
{
    return !this.terrain || this.terrain == terrain1 || this.terrain == terrain2;
}

FBuff.prototype.affectsEstateField = function(estate, field)
{
    return this.affectsEstate(estate) || this.affectsField(estate.race, field);
}

FBuff.prototype.affectsField = function(myRace, field)
{
    return this.affectsTo(field.terrain, field.getEstateType(), myRace, field.getRace());
}

FBuff.prototype.affectsTo = function(t, et, myRace, againstRace)
{
    return this.affectsTerrain(t) && this.affectsEstateType(et) && this.affectsMyRace(myRace) && this.affectsAgainstRace(againstRace) && this.affectsFraction(myRace, againstRace);
}

FBuff.prototype.affectsTerrain = function(t)
{
    return (!this.terrain || this.terrain == t);
}

FBuff.prototype.affectsEstateType = function(et)
{
    return (!this.estateType || this.estateType == et);
}

FBuff.prototype.affectsMyRace = function(r)
{
    return (!this.myRaces || Arrays.contains(this.myRaces, r));
}

FBuff.prototype.affectsAgainstRace = function(r)
{
    return (!this.againstRaces || Arrays.contains(this.againstRaces, r));
}

FBuff.prototype.affectsAgainstRaces = function(rr)
{
    return !this.againstRaces || Arrays.intersectionOf(this.againstRaces, rr).length > 0;
}

FBuff.prototype.affectsEstate = function(estate)
{
    return this.affectsTo(estate.terrain, estate.getEstateType(), estate.race, null);
}

FBuff.prototype.affectsFraction = function(myRace, againstRace)
{
	if (!this.againstFraction || this.againstFraction.name == UserFraction.ANY.name) 
	{
		return true;
	}
	if (!againstRace || myRace.isSameRace(Race.MONSTER) || myRace.isSameRace(Race.CASTLE_MONSTER) || againstRace.isSameRace(Race.MONSTER) || againstRace.isSameRace(Race.CASTLE_MONSTER)) 
	{
		return false;
	}
	if (this.againstFraction.name == UserFraction.SAME.name) 
	{
		return myRace.isSameSide(againstRace);
	}
	if (this.againstFraction.name == UserFraction.OPPOSITE.name) 
	{
		return !myRace.isSameSide(againstRace);
	}
	console.error('Should never reach here!');
}

FBuff.prototype.isIllusion = function()
{
    return this.buffType.name == BuffType.ILLUSION.name || this.buffType.name == BuffType.ILLUSION_ADD.name;
}

FBuff.contains = function(buffs, b)
{
	
}

FBuff.getBuffsForGarrison = function(e, buffs)
{
    return this.filter(buffs, function(b)
    {
        return b.affectsEstate(e);
    });
}

FBuff.getBuffsForField = function(f, myRace, buffs)
{
    return this.filter(buffs, function(b) 
    {
        return b.affectsField(myRace, f);
    });
}

FBuff.getBuffsTo = function(t, et, myRace, againstRace, buffs)
{
    return this.filter(buffs, function(b) 
    {
        return b.affectsTo(t, et, myRace, againstRace);
    });
}

FBuff.filter = function(ac, pr)
{
    var res = [];
    for (var i = 0; i < ac.length; i++)
    {
    	if (pr(ac[i]))
    	{
    		res.push(ac[i]);
    	}
    }
    return res;
}

FBuff.prototype.getConsumedFunds = function()
{
    return this.consumedFunds;
}

FBuff.prototype.setConsumedFunds = function(consumedFunds)
{
    this.consumedFunds = consumedFunds;
}

FBuff.prototype.toString = function()
{
    return "FBuff{value=" + String(this.value) + ",cast=" + String(this.cast) + ",buffType=" + String(this.buffType) + ",btype=" + String(this.btype) + ",terrain=" + String(this.terrain) + ",science=" + String(this.science) + ",unitType=" + String(this.unitType) + ",estateType=" + String(this.estateType) + ",funds=" + String(this.funds) + ",consumedFunds=" + String(this.consumedFunds) + ",army=" + String(this.army) + ",againstRaces=" + String(this.againstRaces) + ",myRaces=" + String(this.myRaces) + ",spellName=" + String(this.spellName) + ",spellLevel=" + String(this.spellLevel) + ",targets=" + String(this.targets) + ",delta=" + String(this.delta) + "}";
}

FBuff.getMissionBuffs = function(t, et, myRace, againstRace, allowIllusion, buffs)
{
    return FBuff.filter(buffs, function(b)
    {
        return b.affectsTo(t, et, myRace, againstRace) && (allowIllusion || !b.isIllusion());
    });
}