function FUser()
{
	this.__defineGetter__("maxHeroCount", this.getMaxHeroCount);
	this.__defineGetter__("attackWarning", this.getAttackWarning);
	
	this.__defineGetter__("tournamentExists", this.getTournamentExists);
	this.__defineGetter__("tournamentGrottoExists", this.getTournamentGrottoExists);

	this.__defineGetter__("hasOneMoreHeroScienceSlot", this.getHasOneMoreHeroScienceSlot);
	this.__defineGetter__("hasTitleToHireHero", this.getHasTitleToHireHero);
}

FUser.prototype.__className__ = "FUser";

FUser.MONSTER_PLAYER_NAME = "%monster%";
FUser.NEUTRAL_PLAYER_NAME = "%neutral%";
FUser.ANCIENTS_PLAYER_NAME = "%ancients%";
FUser.GUEST_PLAYER_NAME_PREFIX = "%guest%";

FUser.CURRENT_USER = null;
FUser.LINKS = []; // FKingdomEstateLink[]
FUser.MAIL_BOX_STATUS = null; //:FMailBoxStatus;
FUser.SHOWN_MAGICS = new FMap(); // String (estateId.toString) -> tick
FUser.alertOnClanmateAttack = true;
FUser.pwnedDialogShown = false;
FUser.postingToSocialWall = false;

FUser.prototype.portalId  = '';  // String
FUser.prototype.username  = '';  // String
FUser.prototype.role  = null;  // Role
FUser.prototype.race  = null;  // Race
FUser.prototype.titleIndex  = 0;  // int
FUser.prototype.frags  = 0;  // int
FUser.prototype.nearestIncomingAttackTick  = 0;  // Number
FUser.prototype.diplomacy  = null;  // FDiplomacy
FUser.prototype.betrayerTill  = 0;  // Number
FUser.prototype.promoExpirationTick  = 0;  // Number
FUser.prototype.subscriptionExpirationTick  = 0;  // Number
FUser.prototype.premiumExpirationTick  = 0;  // Number

FUser.prototype.deletionTick  = 0;  // Number
FUser.prototype.avatarState  = '';  // String
FUser.prototype.showAdvisor  = false;  // Boolean
FUser.prototype.showRebellion  = false;  // Boolean
FUser.prototype.haveSeenQuestAdvisor  = false;  // Boolean
FUser.prototype.deficiency  = null;  // Funds
FUser.prototype.ratingPoints  = 0;  // Number
FUser.prototype.silencedTill  = 0;  // Number
FUser.prototype.bannedTill  = 0;  // Number
FUser.prototype.banReason  = '';  // String
FUser.prototype.pearl  = 0;  // Number
FUser.prototype.currentMissionsCount  = 0;  // int
FUser.prototype.missionsLimit  = 0;  // int
FUser.prototype.science  = null;  // FScience
FUser.prototype.pearlSpeedPerTick  = 0;  // Number
FUser.prototype.questsInfo  = null;  // FQuestsInfo
FUser.prototype.settings  = null;  // UserSettings
FUser.prototype.isAuctionAvailable  = false;  // Boolean = false
FUser.prototype.canAttackAnyRuinTill  = 0;  // Number
FUser.prototype.heroesCount  = 0;  // int
FUser.prototype.traderArtifacts  = null;  // FArtifactList
FUser.prototype.altar  = null;  // FArtifactList
FUser.prototype.artifactTraderCredit  = 0;  // int
FUser.prototype.tournament  = null;  // FTournamentData
FUser.prototype.tournamentGrotto  = null;  // FTournamentData
FUser.prototype.tournamentVictoriesCount  = 0;  // int
FUser.prototype.tournamentGrottoVictoriesCount  = 0;  // int

FUser.prototype.buffs  = null;  // ArrayCollection //List<FBuff>
FUser.prototype.casts  = null;  // ArrayCollection //List<FCast>

FUser.prototype.vacationEndTick  = 0;  // Number
FUser.prototype.survivalWinner  = false;  // Boolean
FUser.prototype.survivalBounty  = 0;  // int
FUser.prototype.apocalypseStartedBy  = null;  // Race
FUser.prototype.hasArtifacts  = false;  // Boolean
FUser.prototype.hasArtifactStore  = false;  // Boolean
FUser.prototype.illusionRate  = 0;  // Number

FUser.prototype.servicesCooldowns  = null, // FMap  // <String;  Long>
FUser.prototype.servicesValues  = null, // FMap  // <String;  Long>
FUser.prototype.servicesAutoOrder  = null;  // ArrayCollection  // <String>
FUser.prototype.pausedAutoExpeditions  = null, // FMap  // <XY;  Long>
// warning mechanism
FUser.prototype.globalWarnings  = null;  // ArrayCollection //<String>
FUser.prototype.localWarnings  = null, // FMap //<EstateId.mapKey(); String>

FUser.prototype.nextTheBestGameClickAvailable  = 0;  // Number

FUser.prototype.hints  = null;  // ArrayCollection  // <FHint>
FUser.prototype.brotherhoodEnabled  = false;  // Boolean
FUser.prototype.brotherhoodAttackTick  = 0;  // Number
FUser.prototype.pendingQuestsToSocialWall  = null;  // ArrayCollection    // <String>
FUser.prototype.postedQuestsToSocialWall  = 0;  // int
FUser.prototype.lastNewsTick  = 0;  // Number
FUser.prototype.withdrawalEnabled  = false;  // Boolean
FUser.prototype.withdrawalForbiddenInSession  = false;  // Boolean
FUser.prototype.artifactsStoreIncreased  = false;  // Boolean

FUser.prototype.age = -1;

FUser.prototype.getAttackWarning = function()
{
    if (FUser.shouldShowAttackWarn(this.nearestIncomingAttackTick))
    {
        return true;
    }
    for(var i=0; i<this.diplomacy.allies.length; i++)
    {
    	var ally = this.diplomacy.allies[i];
    	if (FUser.shouldShowAttackWarn(ally.user.nearestIncomingAttackTick))
    	{
            return true;
        }
    }
    
    if (FUser.alertOnClanmateAttack)
    {
        if (this.diplomacy.clan)
        {
            for(var i=0; i<this.diplomacy.clan.members.length; i++)
            {
            	var clanMate = this.diplomacy.clan.members[i];
            	if (FUser.shouldShowAttackWarn(clanMate.user.nearestIncomingAttackTick))
            	{
                    return true;
                }
            }
            if (FUser.shouldShowAttackWarn(this.diplomacy.clan.nearestCastleAttackTick))
            {
                return true;
            }
        }
    }
    return false;
}

FUser.shouldShowAttackWarn = function(tick)
{
    return !Tick.isInfinity(tick) && (FUser.CURRENT_USER.settings.showFarFutureAttacks || Tick.ticksTill(tick) < FConfig.FAR_FUTURE);
}

FUser.prototype.equals = function(user)
{
    return user && user.username == this.username;
}

FUser.prototype.isInClan  = function()
{
	return this.diplomacy != null && this.diplomacy.clan != null;
}

FUser.prototype.canHaveClans = function()
{
	return this.science.getLevel(Science.CLANS) > 0;
}

FUser.prototype.isClanLeader  = function()
{
	return this.isInClan() && this.username == this.diplomacy.clan.leaderName;
}

FUser.prototype.isInRegisteredClan  = function()
{
	return this.isInClan() && this.diplomacy.clan.isRegistered;
}

FUser.prototype.hasNewClanQuestions = function()
{
    return this.diplomacy.clan && this.diplomacy.clan.lastQuestionStartTick > this.settings.clanQuestionsLastClickTick.int52;
}

FUser.prototype.getScienceValue  = function(s)
{
	var level = this.science.getLevel(s);

    if (level == 0)
    {
        return 0;
    }
    
    var result = s.getLevel(level - 1).value;
    
    for(var i=0; i<this.buffs.length; i++)
    {
    	if(this.buffs[i].buffType.name == "SCIENCE_VALUE" && this.buffs[i].science.name == s.name)
    	{
    		result += this.buffs[i].value;
    	}
    	
    }
    
    if (result < 0)
    {
        return 0;
    }
    
    return Math.round(result);
}

FUser.prototype.isOnVacation = function()
{
    return this.vacationEndTick > Tick.now();
}

FUser.prototype.tick = function(delta)
{
	// tick science
    if (this.science.currentScience)
    {
		var cost = this.science.getNextLevelCost(this.science.currentScience);
        this.science.knowledge = Math.min(this.science.knowledge + delta * this.science.speedPerTick, cost);
    }
    if (this.science.clanSpeedPerTick > 0)
    {
        var clanCost = this.science.getNextLevelCost(Science.CASTLES);
        this.science.clanKnowledge = Math.min(this.science.clanKnowledge + delta * this.science.clanSpeedPerTick, clanCost);
    }
    
    this.pearl += delta * this.pearlSpeedPerTick;
}

FUser.prototype.maxUnitTypeBuff = function(bt, ut, tick)
{
    var buff = FBuff.findMaxBuff(this.buffs, bt, ut, tick);
    return !buff ? 0 : buff.value;
}

FUser.prototype.findMaxUnitTypeBuff = function(bt, ut, tick)
{
    return FBuff.findMaxBuff(this.buffs, bt, ut, tick);
}

FUser.isFeatureWarning = function(featureExpTick)
{
    return featureExpTick > Tick.now() && featureExpTick - 3600 * 24 < Tick.now();
}

FUser.prototype.isSomeFeatureWarning = function()
{
    return this.isGlobalFeatureWarning()
            || this.isLocalFeatureWarning()
            || this.isPromoFeatureWarning();
}

FUser.prototype.isPremiumFeatureWarning = function()
{
    return this.globalWarnings.contains(ServiceDecl.PREMIUM);
}

FUser.prototype.isPromoFeatureWarning = function()
{
    return FUser.isFeatureWarning(this.promoExpirationTick);
}

FUser.prototype.isGlobalFeatureWarning = function()
{
    return this.globalWarnings.length > 0;
}

FUser.prototype.isAlly = function(otherUsername)
{
    return this.getAlly(otherUsername) ? true : false;
}

FUser.prototype.getAlly = function(allyName)
{
    var ally;
    for(var i=0; i<this.diplomacy.allies.length; i++)
    {
    	ally = this.diplomacy.allies[i];
    	if (FUser.isSameName(allyName, ally.user.username) && ally.status.name != AllianceStatus.PROPOSED.name)
    	{
            return ally;
        }
    }
    
    return null;
}

FUser.prototype.isClanMate = function(otherUsername)
{
    if (otherUsername) otherUsername = htmlEscape(otherUsername);
    return this.getClanMate(otherUsername) || this.diplomacy.clan && otherUsername == '$' + this.diplomacy.clan.clanName;
}

FUser.prototype.getClanMate = function(name)
{
    if (this.diplomacy.clan)
    {
        var member;
        for(var i=0; i<this.diplomacy.clan.members.length; i++)
        {
        	member = this.diplomacy.clan.members[i];
        	if (FUser.isSameName(name, member.user.username))
        	{
                return member;
            }
        }
    }
    return null;
}
    
FUser.prototype.getEstateWithFeatureWarning = function()
{
    var link;
    for(var i=0; i<FUser.LINKS.length; i++)
    {
    	link = FUser.LINKS[i].estateInfo;
    	if (link.id.x >= 0 && link.id.y >= 0 && link.id.z >= 0 && this.localWarnings.containsKey(link.id.mapKey()) && this.localWarnings.getValue(link.id.mapKey()).length > 0)
    	{
            return link.id;
        }
    }
    return null;
}

FUser.prototype.isLocalFeatureWarning = function()
{
    return this.getEstateWithFeatureWarning() != null;
}

FUser.prototype.isFake = function()
{
    return FUser.isFakeUserName(this.username);
}

FUser.prototype.hasBuff = function(bt)
{
    for(var i=0; i<this.buffs.length; i++)
    {
    	if(this.buffs[i].buffType.name == bt.name)
    	{
    		return true;
    	}
    }
    return false;
}

FUser.prototype.getUsernameForMessages = function()
{
    return FUser.getUserNameForMessages(this.username);
}

FUser.getUserNameForMessages = function(username)
{
    if (username == null || username.length == 0) 
    {
        return I18.f("UNKNOWN_PLAYER");
    } 
    else if (Strings.startsWith(username, FUser.NEUTRAL_PLAYER_NAME)) 
    {
        return I18.f("NEUTRAL_PLAYER");
    } 
    else if (Strings.startsWith(username, FUser.MONSTER_PLAYER_NAME)) 
    {
        return I18.f("MONSTER_PLAYER");
    } 
    else if (Strings.startsWith(username, FUser.ANCIENTS_PLAYER_NAME)) 
    {
        return I18.f("ANCIENTS_PLAYER");
    } 
    else if (FUser.isClanUser(username)) 
    {
        return I18.f("CLAN") + " " + FUser.parseClanName(username);
    }
    return username;
}

FUser.isClanUser = function(username) 
{
    return username.length > 0 && username.charAt(0) == '$';
}


FUser.parseClanName = function(username)
{
    return this.isClanUser(username) ? username.substr(1) : "";
}

FUser.isFakeUserName = function(username)
{
    return !username || username == "" || Strings.startsWith(username, FUser.MONSTER_PLAYER_NAME) || Strings.startsWith(username, FUser.NEUTRAL_PLAYER_NAME) || Strings.startsWith(username, FUser.ANCIENTS_PLAYER_NAME);
}

FUser.isSameName = function(one, another)
{
	return (!one || !another) ? (one == another) : (one.toLowerCase() == another.toLowerCase());
}

FUser.isCurrentUser = function(username)
{
	return FUser.isSameName(FUser.CURRENT_USER.username, username);
}

FUser.isSpectator = function()
{
	return !FUser.LINKS || FUser.LINKS.length == 0;
}

FUser.updateCurrentUser = function(user)
{
	FUser.CURRENT_USER = user;

	//FlexGlobals.topLevelApplication.showAdvisors();
	//FlexGlobals.topLevelApplication.updateCurrentUserFooter();

	/*
	 if (user.pendingQuestsToSocialWall.length > 0 && !postingToSocialWall)
	 {
	 var listText:String = "";
	 var i:int = 1;
	 for each (var localizedName:String in user.pendingQuestsToSocialWall) {
	 listText += (user.postedQuestsToSocialWall + i) + ". " + localizedName + "\n";
	 i++;
	 }

	 postingToSocialWall = true;
	 SocialNetworkApi.i.postOnWall(I18.COMPLETED_QUESTS_ON_SOCIAL_WALL.f(), listText, SocialNetworkApi.i.getAppPicture(FConfig.i.PORTAL_ADDRESS));
	 Service.quest.removeQuestsProposedToSocialWall(user.pendingQuestsToSocialWall).handle(function(ignore:*):void {
	 postingToSocialWall = false;
	 });
	 }
	 */
}

FUser.prototype.getBoostTick = function(type)
{
    for (var i = 0; i < this.casts.length; i++) 
    {
    	var cast = this.casts[i];
        for (var j = 0; j < cast.buffs.length; j++) 
        {
        	var buff = cast.buffs[j];
            if (buff.cast.cause.name == CastCause.SERVICE.name && buff.cast.spell.name == type.name) 
            {
                return buff.cast.tillTick;
            }
        }
    }
    return 0;
}

FUser.prototype.isBoosted = function(type)
{
	return this.getBoostTick(type) >= Tick.now();
}

FUser.prototype.isPremium = function()
{
	return (this.premiumExpirationTick > Tick.now()) || (this.premiumExpirationTick == -1);
}

FUser.prototype.isBuildQueueEnabled = function()
{
	if (this.hasBuff(BuffType.BUILD_QUEUE)) 
	{
	    return true;
	}
	return this.isPremium();
}

FUser.prototype.blinkNews = function()
{
	return !this.settings.disableNewsBlinking && this.lastNewsTick > this.settings.newsLastClickTick.int52;
}

FUser.prototype.isBetrayer = function(tick)
{
	if(typeof tick == "undefined")
	{
		tick = -1;
	}
	
	if (tick == -1)
	{
        tick = Tick.now();
    }
    return this.betrayerTill >= tick;
}

FUser.prototype.getTournamentExists = function()
{
    return (this.tournament != null) && (this.tournament.tournamentStartTick > 0);
}

FUser.prototype.getTournamentGrottoExists = function()
{
    return (this.tournamentGrotto != null) && (this.tournamentGrotto.tournamentStartTick > 0);
}


FUser.prototype.getHasOneMoreHeroScienceSlot = function()
{
    return this.maxHeroCount > this.heroesCount;
}

FUser.prototype.getHasTitleToHireHero = function()
{
    return this.titleIndex >= FConfig.USER_TITLE_FOR_HERO;
}

FUser.prototype.hasClanRole = function(r)
{
    return this.diplomacy && this.diplomacy.clan && this.diplomacy.clan.getMember(this.username).hasRole(r);
}

FUser.prototype.isCurrent = function()
{
    return FUser.isSameName(FUser.CURRENT_USER.username, this.username);
}

FUser.prototype.getMaxHeroCount = function()
{
    return Math.min(FConfig.MAX_HEROES, this.getScienceValue(Science.HEROES));
}

FUser.prototype.canAttackAnyRuin = function()
{
    return this.canAttackAnyRuinTill >= Tick.now();
}

FUser.getCapitalLink = function(links)
{
    var arr = links ? links : FUser.LINKS;
    
    for(var i=0; i<arr.length; i++)
    {
    	if(arr[i].isCapital)
    	{
    		return arr[i];
    	}
    }
    throw Error("Could not find capital");
}

FUser.splitNames = function(str)
{
    return Arrays.filter(str.split(/[^a-zA-Z0-9_]/), function (part)
    {
        return part.length > 0;
    });
}

FUser.isGuestUser = function(username)
{
    return username.indexOf(FUser.GUEST_PLAYER_NAME_PREFIX) == 0;
}

FUser.getBank = function(estateType)
{
    var funds = new Funds();
    for (var i = 0, len =  FUser.LINKS.length; i < len; i++) 
    {
    	var link = FUser.LINKS[i];
        if (!estateType || link.estateInfo.estateType.name == estateType.name) 
        {
            funds.add(link.bank);
        }
    }
    return funds;
}

FUser.isMonster = function(username)
{
	return username == FUser.MONSTER_PLAYER_NAME;
}

FUser.isHomelessMonster = function(username)
{
    //return Strings.startsWith(username, FUser.MONSTER_PLAYER_NAME);
    return username == FUser.MONSTER_PLAYER_NAME;
}

FUser.prototype.findHint = function(type, quest)
{
    var hint;
    for(var i=0; i<this.hints.length; i++)
    {
    	hint = this.hints[i];
    	if (hint.type.name == type.name && (!quest || quest == hint.quest))
    	{
            return hint;
        }
    }
    return null;
}

FUser.prototype.findConstructHint = function(estate)
{
    var hint;
    for(var i=0; i<this.hints.length; i++)
    {
    	hint = this.hints[i];
    	if (hint.type.name == HintType.CONSTRUCT_FIRST_BUILDING.name && estate.countBuildings(hint.btype) == hint.index)
    	{
            return hint;
        }
    }
    return null;
}

FUser.prototype.getServicesActiveTill = function()
{
    var r = new FMap();
    
    var buff;
    for(var i=0; i<this.buffs.length; i++)
    {
    	buff = this.buffs[i];
    	
    	if (buff.cast.cause.name == CastCause.SERVICE.name)
    	{
            r.put(buff.cast.spell, buff.cast.tillTick);
        }
    }
	
    return r;
}