var Race = function(name)
{
	this.name = name;
	
	this.__defineGetter__('displayName', function()
	{
		return I18.s("RACE_NAME", this.name);
	});
	
	this.__defineGetter__('pluralName', function()
	{
		return I18.s("RACE", this.name);
	});
};

extendClass(Race.prototype, Enum.prototype);

Race.__isEnum__ = true;

Race.prototype.__CLS__ = "game.model.user.Race";

Race.prototype.isSameRace = function(other)
{
	if(!other) return false;
	return this.name == other.name;
};

Race.prototype.isSameSide = function(other)
{
	if (this.isSameRace(other))
	{
		return true;
	}

	switch (this.name)
	{
		case "ELF":
			return other.isSameRace(Race.HUMAN);
		case "HUMAN":
			return other.isSameRace(Race.ELF);
		case "DEMON":
			return other.isSameRace(Race.DROW);
		case "DROW":
			return other.isSameRace(Race.DEMON);
		default:
			return false;
	}
};

Race.prototype.toString = function()
{
	return this.displayName;
};

Race.HUMAN = new Race("HUMAN");
Race.DEMON = new Race("DEMON");
Race.ELF = new Race("ELF");
Race.DROW = new Race("DROW");
Race.MONSTER = new Race("MONSTER");
Race.CASTLE_MONSTER = new Race("CASTLE_MONSTER"); 

Race.ALL = [Race.HUMAN, Race.DEMON, Race.ELF, Race.DROW, Race.MONSTER, Race.CASTLE_MONSTER];
