function Role(name)
{
	this.name = name;
}

extendClass(Role.prototype, Enum.prototype);

Role.__isEnum__ = true;

Role.prototype.__CLS__ = "game.model.user.Role";

Role.ADMIN      = new Role("ADMIN");
Role.SUPERMODER = new Role("SUPERMODER");
Role.MODER      = new Role("MODER");
Role.SUPPORT    = new Role("SUPPORT");
Role.INVESTOR   = new Role("INVESTOR");
Role.TESTER     = new Role("TESTER");
Role.SEO        = new Role("SEO");
Role.USER       = new Role("USER");
Role.ANONYM     = new Role("ANONYM");

Role.valuesNoAnonym = [Role.USER, Role.INVESTOR, Role.SUPPORT, Role.SEO, Role.TESTER, Role.MODER, Role.SUPERMODER, Role.ADMIN];

Role.prototype.hasAdminRights = function()
{
    return this.name == Role.ADMIN.name;
}

Role.prototype.hasModerRights = function()
{
    return this.hasAdminRights() || this.name == Role.SUPERMODER.name || this.name == Role.MODER.name;
}

Role.prototype.hasSeoRights = function()
{
    return this.hasAdminRights() || this.name == Role.SEO.name;
}

Role.prototype.canSendOuterMail = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name || this.name == Role.MODER.name;
}

Role.prototype.canReadConfig = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.TESTER.name || this.name == Role.SUPERMODER.name;
}

Role.prototype.canEditConfig = function()
{
    return this.name == Role.ADMIN.name;
}

Role.prototype.canTimeJump = function()
{
    return this.name == Role.ADMIN.name;
}

Role.prototype.canFinishBuilding = function()
{
    return this.name == Role.ADMIN.name;
}

Role.prototype.canResearchAll = function()
{
    return this.name == Role.ADMIN.name;
}

Role.prototype.canSetEstateBank = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name;
}

Role.prototype.canSetEstateGarrison = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name;
}

Role.prototype.canSetWarPeacePoints = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name;
}

Role.prototype.canHitBuilding = function()
{
    return this.name == Role.ADMIN.name;
}

Role.prototype.canAddHeroExp = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name;
}

Role.prototype.canSetFlags = function()
{
    return this.name == Role.ADMIN.name;
}

Role.prototype.canDestroyEstate = function()
{
    return this.name == Role.ADMIN.name;
}

Role.prototype.canCreateEstate = function()
{
    return this.name == Role.ADMIN.name;
}

Role.prototype.canSpyAndObserve = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name || this.name == Role.MODER.name || this.name == Role.TESTER.name;
}

Role.prototype.canExploreKingdom = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.TESTER.name || this.name == Role.SUPERMODER.name;
}

Role.prototype.canTerraform = function()
{
    return this.name == Role.ADMIN.name;
}

Role.prototype.canViewLog = function()
{
    return true;
}

Role.prototype.canBanOnPortal = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name || this.name == Role.MODER.name;
}

Role.prototype.canChangeQuests = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name;
}

Role.prototype.canAccessDebugPanel = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name || this.name == Role.MODER.name || this.name == Role.TESTER.name;
}

Role.prototype.canSeeRealSender = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name;
}

Role.prototype.canSeeStatistics = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name;
}

Role.prototype.canGiveArts = function()
{
    return this.name == Role.ADMIN.name || this.name == Role.SUPERMODER.name;
}