function UserSettings()
{
}

UserSettings.prototype.__className__ = "UserSettings";


UserSettings.prototype.slogan = '';
UserSettings.prototype.disableQuestBlinking = false;
UserSettings.prototype.disableNewsBlinking = false;
UserSettings.prototype.simpleExpeditor = false;
UserSettings.prototype.estateAnimationEnabled = false;
UserSettings.prototype.heroAnimationEnabled = false;
UserSettings.prototype.resourceChooserStepIndex = 0;
UserSettings.prototype.armyChooserStepIndex = 0;
UserSettings.prototype.missionRetreatLimit = 0;
UserSettings.prototype.kingdomGridVisible = false;
UserSettings.prototype.mailBoxFilter = '';
UserSettings.prototype.expeditionHexState = 0;
UserSettings.prototype.estateHexState = 0;
UserSettings.prototype.questLastClickTick = 0;
UserSettings.prototype.tournamentLastTabClickTick = 0;
UserSettings.prototype.tournamentGrottoLastTabClickTick = 0;
UserSettings.prototype.clanQuestionsLastClickTick = 0;
UserSettings.prototype.brotherhoodLastClickTick = 0;
UserSettings.prototype.newsLastClickTick = 0;
UserSettings.prototype.soundsDisabled = false;
UserSettings.prototype.musicDisabled = false;
UserSettings.prototype.calculatorPredictionPolicy = null; // PredictionPolicy

UserSettings.prototype.lastEspionageFromEstateId = null;//EstateId
UserSettings.prototype.lastObservationFromEstateId = null;//EstateId

UserSettings.prototype.expeditionMissionSpeed = 0;
UserSettings.prototype.moveResourcesMissionSpeed = 0;
UserSettings.prototype.settlerMissionSpeed = 0;

UserSettings.prototype.calculatorAttackerRetreatLimit = 0;
UserSettings.prototype.calculatorMainDefenderRetreatLimit = 0;
UserSettings.prototype.calculatorDefenderRetreatLimit = 0;
UserSettings.prototype.receiveClanResourceMessages = false;
UserSettings.prototype.showFarFutureAttacks = false;

UserSettings.prototype.__construct = function()
{
	this.slogan = htmlEscape(this.slogan);
}

UserSettings.prototype.splitSlogan = function()
{
    if (!this.slogan)
    {
        return ["", ""];
    }
    var parts = this.slogan.split(/\n|\r/);
    var result = [];
    if (parts.length == 0)
    {
        result.push("");
        result.push("");
    }
    else if (parts.length == 1)
    {
        result.push(parts[0]);
        result.push("");
    }
    else
    {
        result.push(parts[0]);
        result.push(parts[1]);
    }
    
    return result;
}

UserSettings.mergeSlogan = function(slogan1, slogan2)
{
    if (slogan1 == "" && slogan2 == "") 
    {
        return "";
    } 
    else if (slogan2 == "") 
    {
        return slogan1;
    } 
    else 
    {
        return slogan1 + "\r" + slogan2;
    }
}

UserSettings.prototype.getMissionRetreatLimit = function()
{
    return this.missionRetreatLimit < FConfig.MIN_RETREAT_PERCENT ? FConfig.MIN_RETREAT_PERCENT : this.missionRetreatLimit;
}

UserSettings.prototype.getMailBoxFilter = function()
{
    return this.mailBoxFilter == null || this.mailBoxFilter == "" ? "filterAll" : this.mailBoxFilter;
}

UserSettings.prototype.getLastFromCityId = function(ut/*:UnitType*/, defaultValue/*:EstateId*/)
{
    var id = null;
    switch (ut) 
    {
        case UnitType.SPY:
        {
        	id = this.lastEspionageFromEstateId;
            break;
        }
        case UnitType.PROPHET:
        {
        	id = this.lastObservationFromEstateId;
            break;
        }
    }
    return id != null ? id : defaultValue;
}

UserSettings.prototype.getCalculatorRetreatLimit = function(cr/*:CombatRole*/)
{
    var result = 0;
    switch (cr.name) 
    {
        case CombatRole.ATTACKER.name:
        {
            result = this.calculatorAttackerRetreatLimit;
            break;
        }
		case CombatRole.MAIN_DEFENDER.name:
        {
        	result = this.calculatorMainDefenderRetreatLimit;
            break;
        }
        case CombatRole.DEFENDER.name:
        {
        	result = this.calculatorDefenderRetreatLimit;
            break;
        }
    }
    return result < FConfig.MIN_RETREAT_PERCENT ? FConfig.MIN_RETREAT_PERCENT : result;
}

