function FAccount()
{
	callParentConstructor(FAccount.prototype, this);
	
	this.id = 0; // Number;
	this.username = ''; // String;
	this.email = ''; // String;
	this.balance = ''; // String;
	this.servers = []; // ArrayCollection; // List<FGameServer>
	this.totalOnlineInfo = null; // FBriefOnlineInfo ;
	this.percent = ''; // String;
	this.banned = false; // Boolean;
	this.withdrawalEnabled = false; // Boolean;
	this.frodEnabled = false; // Boolean;
	this.giftFrodEnabled = false; // Boolean;
	this.totalOutcome = 0; // Number;
	this.offersEnabledServers = []; // ArrayCollection; // List<String>
	this.country = ''; // String;
	
	// only for portalka
	this.role = null; // Role;
	this.regDate = null; // Number;
	
	this.socialId = ''; // String;
}

extendClass(FAccount.prototype, FPortalResponse.prototype);

FAccount.prototype.__CLS__ = "game.service.FAccount";

FAccount.prototype.id = 0; // Number;
FAccount.prototype.username = ''; // String;
FAccount.prototype.email = ''; // String;
FAccount.prototype.balance = ''; // String;
FAccount.prototype.servers = []; // ArrayCollection; // List<FGameServer>
FAccount.prototype.totalOnlineInfo = null; // FBriefOnlineInfo ;
FAccount.prototype.percent = ''; // String;
FAccount.prototype.banned = false; // Boolean;
FAccount.prototype.withdrawalEnabled = false; // Boolean;
FAccount.prototype.frodEnabled = false; // Boolean;
FAccount.prototype.giftFrodEnabled = false; // Boolean;
FAccount.prototype.totalOutcome = 0; // Number;
FAccount.prototype.offersEnabledServers = []; // ArrayCollection; // List<String>
FAccount.prototype.country = ''; // String;

// only for portalka
FAccount.prototype.role = null; // Role;
FAccount.prototype.regDate = null; // Number;

FAccount.prototype.socialId = ''; // String;

FAccount.prototype.findServer = function(serverId)
{
    for (var i = 0; i < this.servers.length; i++) 
    {
        if (this.servers[i].id == serverId) 
        {
            return this.servers[i];
        }
    }
    return null;
}

FAccount.prototype.isPercentDefault = function()
{
    return this.percent*1 < 0 ;
}

FAccount.prototype.getActualPercent = function()
{
    return this.isPercentDefault() ? FPortalConfig.PARTNER_DEFAULT_PERCENT : this.percent*1;
}

FAccount.prototype.canFrod = function(receiver)
{
    return this.frodEnabled && (!this.receiver || this.receiver == this.username || this.giftFrodEnabled);
}
