function FGameServer()
{
    this.id = ''; // String;
    this.displayName = ''; // String;
    this.type = null; // GameServerType;
    this.saveWorldTimeout = 0; // Number;
    this.onlineInfo = null; // FBriefOnlineInfo;
    this.config = null; // FGameServerConfig;
    this.available = false; // Boolean;
    this.allowRegister = false; // Boolean;
    this.hasInvite = false; // Boolean;

    this.avatarExists = false; // Boolean;
    this.subscribedTill = 0; // Number;

    this.mergeToServerId = ''; // String;
    this.deletionPending = false; // Boolean;
    this.race = null; // Race;
    
    this.__defineGetter__('canPlayOrRegister', this.getCanPlayOrRegister);
    this.__defineGetter__('subscriptionActive', this.getSubscriptionActive);
    this.__defineGetter__('registrationAllowed', this.getRegistrationAllowed);
    this.__defineGetter__('isSaveInProgress', this.getIsSaveInProgress);
}

FGameServer.prototype.__CLS__ = "game.service.FGameServer";

FGameServer.prototype.id = ''; // String;
FGameServer.prototype.displayName = ''; // String;
FGameServer.prototype.type = null; // GameServerType;
FGameServer.prototype.saveWorldTimeout = 0; // Number;
FGameServer.prototype.onlineInfo = null; // FBriefOnlineInfo;
FGameServer.prototype.config = null; // FGameServerConfig;
FGameServer.prototype.available = false; // Boolean;
FGameServer.prototype.allowRegister = false; // Boolean;
FGameServer.prototype.hasInvite = false; // Boolean;

FGameServer.prototype.avatarExists = false; // Boolean;
FGameServer.prototype.subscribedTill = 0; // Number;

FGameServer.prototype.mergeToServerId = ''; // String;
FGameServer.prototype.deletionPending = false; // Boolean;
FGameServer.prototype.race = null; // Race;

FGameServer.prototype.getCanPlayOrRegister = function()
{
    return this.available && (this.avatarExists || this.registrationAllowed);
}

FGameServer.prototype.toString = function()
{
    return this.displayName;
}

FGameServer.prototype.hasSpaceFor = function(race)
{
    return this.config.canRegister.getValue(race);
}

FGameServer.prototype.getProposalRace = function()
{
    return this.config.proposalRace;
}

FGameServer.prototype.getSubscriptionActive = function()
{
    return this.subscribedTill > Tick.now();
}

FGameServer.prototype.getRegistrationAllowed = function()
{
    return this.allowRegister && this.config.proposalRace && !this.config.registrationPeriodExpired;
}

FGameServer.prototype.getIsSaveInProgress = function()
{
    return this.saveWorldTimeout > 0;
}
