function FPortalConfig()
{
	this.DOMAIN = null;
    this.OFFER_PAYMENTS = null;
    this.TAPJOY_ENABLED = null;
    this.PAYMENTS = null;
    this.OUT_TRANSACTION_PERCENT = null;
    this.OUT_TRANSACTION_CHARGE = null;
    this.OUT_TRANSACTION_MIN = null;
    this.OUT_TRANSACTION_DELAY = null;
    this.MAX_TRANSACTION_PENDINGS_PER_USER = null;
    this.PARTNER_DEFAULT_PERCENT = null;
    this.SHOW_MONEY_TEXT = null;
    this.LOCALE_STRINGS = null;
    this.MEDAL = null;
    this.SOCIAL_NETWORK = null;
    this.ZONE_IMAGE_ROOT = null;
    this.PAYMENTS_ALLOWED = null;
    this.WEBMONEY_OUTCOME_ENABLED = null;
    this.MANUAL_OUTCOME_ENABLED = null;
    this.MANUAL_OUTCOME_ACCOUNT = null;
    this.EPAY_OUTCOME_ENABLED = null;
    this.EPAY_OUTPUT_IFRAME_URL = null;
    this.PAYMENT_SYSTEMS = null;
    this.PEARLS_IN_MLD = null;
    this.ADMIN_EMAIL_ADDRESS = null;
    this.MANUAL_WITHDRAW_DELAY = null;
    this.AFFILIATE_BANNERS_LINK = null;
    this.MERGE_SERVER_TARGETS = null;
    this.MERGE_SERVER_TIME = null;
    this.WIKI_URL = null;
    this.FORUM_URL = null;

    this.FB_INTERPOLATION = null;
    this.FB_PROFIT_RATE = null;
    this.FB_MIN_TARIFF_PRICE = null;

    this.TIMEZONE_OFFSET = null;

    this.IOS_REGISTER_REDIRECT_URL = null;
    this.ANDROID_REGISTER_REDIRECT_URL = null;

    this.MAT_REGISTRATION_EVENT = null;

    this.SHOW_USER_COUNTERS = null;

    this.SHOW_DLC = null;

    this.SHOW_SEND_MESSAGE_TO_ADMIN = null;

    this.SHOW_FINANCE_HELP = null;

    this.SHOW_INVITE_FRIENDS = null;

    this.MANDATORY_OFFERS_PEARL_REQUIRED = null;
    this.MANDATORY_OFFERS_PEARL_REWARD = null;

    this.portalsessionid = null;
}

FPortalConfig.prototype.__CLS__ = "game.service.FPortalConfig";

FPortalConfig._instance = null;

FPortalConfig.getInstance = function()
{
    return FPortalConfig._instance;
}

FPortalConfig.load = function(config)
{
    if(config)
    {
        $.extend(FPortalConfig, config);
    }

    I18.load(FPortalConfig.LOCALE_STRINGS || new FMap());
    
    Tick.TICK_INFINITY = 9223372036854776000;
	
	DateUtils.TIMEZONE_OFFSET = ~~FPortalConfig['TIMEZONE_OFFSET'];
	
	var month = I18.f("SHORT_MONTHS_NAMES").split("|");
	dateFormat.i18n.monthNames = month.concat(month);
    
    /*
    DateUtils.TIMEZONE_OFFSET = FlashVars.timeZoneOffset;
    */
}

FPortalConfig.toMld = function(pearls)
{
    return pearls / FPortalConfig.PEARLS_IN_MLD;
}

FPortalConfig.toPearlInt = function(mdollars)
{
    return Math.round(mdollars * FPortalConfig.PEARLS_IN_MLD);
}

FPortalConfig.toPearlStr = function(mdollars)
{
    return I18.formatNumber(FPortalConfig.toPearlInt(mdollars), 0);
}

FPortalConfig.formatPearl = function(mdollars)
{
    return I18.f("PORTAL_CURRENCY_VALUE", FPortalConfig.toPearlStr(mdollars));
}

FPortalConfig.calcOutputAmount = function(bruttoPearls)
{
    return Math.max(0, FPortalConfig.toMld(bruttoPearls) * (1 - FPortalConfig.OUT_TRANSACTION_PERCENT) - FPortalConfig.OUT_TRANSACTION_CHARGE);
}