function Payment()
{
    this.id = ''; // String;
    this.paymentSystem = null; // PaymentSystem;
    this.icon = ''; // String;
    this.url = ''; // String;
    this.isFrod = false; // Boolean;
    this.options = []; // ArrayCollection; // PaymentOption
    this.action = ''; // String;
}

Payment.prototype.__CLS__ = "game.config.payment.Payment";

Payment.prototype.id = ''; // String;
Payment.prototype.paymentSystem = null; // PaymentSystem;
Payment.prototype.icon = ''; // String;
Payment.prototype.url = ''; // String;
Payment.prototype.isFrod = false; // Boolean;
Payment.prototype.options = []; // ArrayCollection; // PaymentOption
Payment.prototype.action = ''; // String;

Payment.prototype.onAction = function(receiverUsername, payerAccount, option, t, serverId, phone)
{
    receiverUsername = receiverUsername || payerAccount.username;
    if (t) 
    {
        PortalService.account.callMethod('logPaymentClick', [t.id]);
    }
    var factory = Payment[this.action + "_FACTORY"];
    if (!factory) 
    {
        throw new Error("unknown action: " + action)
    }
    var handler = factory();
    handler.handle(receiverUsername, payerAccount, this, option, t, serverId, phone);
    return handler;
}

Payment.URL_FACTORY = function() { return new UrlActionHandler(); }
Payment.VK_FACTORY = function() { return new VkActionHandler(); }
Payment.MM_FACTORY = function() { return new MmActionHandler(); }
Payment.OK_FACTORY = function() { return new OkActionHandler(); }
Payment.FB_FACTORY = function(){ return new FbActionHandler(); }

Payment.formatUrl = function(urlPattern, receiver, account, serverId, option, t, phone)
{
    return Payment.format(urlPattern,
            [
                ["username", receiver],
                ["initiator", account.username],
                ["email", account.email],
                ["price", t ? t.price : null],
                ["currency", t ? t.currency : null],
                ["mdollars", t ? t.mdollars : null],
                ["pearls", t ? FPortalConfig.toPearlInt(t.mdollars) : null],
                ["optionId", option ? option.id : null],
                ["tariffId", t ? t.id : null],
                ["serverId", serverId],
                ["serverAndInitiator", serverId ? (serverId + ":" + account.username) : "" ],
                ["phone", !phone ? null : phone]
            ]);
}

Payment.format = function(str, repl)
{
    for (var i = 0; i < repl.length; i++) 
    {
    	var template = repl[i];
        var pattern = new RegExp("{" + template[0] + "\\?([^}]*)}");
        str = str.replace(pattern, function (match, match1, index, input)
        {
            return template[1] ? match1 + template[1] : '';
        });
    }
    
    for (var i = 0; i < repl.length; i++) 
    {
    	var template = repl[i];
    	str = str.replace("{" + template[0] + "}", template[1]);
    }
    
    return str;
}

