var Terrain = function(name, asset, blocker)
{
	this.name = name;

	this._assetGroup = asset;
	this._blocker = blocker;
	
	this.__defineGetter__('assetGroup', function()
	{
		return this._assetGroup;
	});
	
	this.__defineGetter__('blocker', function()
	{
		return this._blocker;
	});
	
	this.__defineGetter__('displayName', function()
	{
		return I18.s("TERRAIN", this.name);
	});

};

extendClass(Terrain.prototype, Enum.prototype);

Terrain.__isEnum__ = true;

Terrain.prototype.__CLS__ = "game.model.terrain.Terrain";

Terrain.prototype.__construct = function()
{
	this._assetGroup = Terrain[this.name]._assetGroup;
	this._blocker = Terrain[this.name]._blocker;
}

Terrain.prototype.prepareForRequest = function()
{
	return {
		__CLS__: this.__CLS__,
		name: this.name
	};
}

Terrain.prototype.findTile = function(subType, hasEstate)
{
	var prefix = "T_" + this.name + "_";
	var suffix = hasEstate ? "B" : subType;
	return KingdomAssets[prefix + suffix];
}

Terrain.prototype.toString = function()
{
	return this.displayName;
}

Terrain.NULL = new Terrain("NULL");
Terrain.MOUNTAIN = new Terrain("MOUNTAIN", Assets.bg.Mountain, CellBlocker.ROCK);
Terrain.DESERT = new Terrain("DESERT", Assets.bg.Desert, CellBlocker.TREE);
Terrain.FOREST = new Terrain("FOREST", Assets.bg.Forest, CellBlocker.LAKE);
Terrain.STEPPE = new Terrain("STEPPE", Assets.bg.Steppe, CellBlocker.TREE);
Terrain.MAGICFOREST = new Terrain("MAGICFOREST", Assets.bg.MagicForest, CellBlocker.LAKE);
Terrain.CURSEDFOREST = new Terrain("CURSEDFOREST", Assets.bg.CursedForest, CellBlocker.DARKTREE);
Terrain.HOLYLAND = new Terrain("HOLYLAND", Assets.bg.HolyLand, CellBlocker.LAKE);
Terrain.DEADLAND = new Terrain("DEADLAND", Assets.bg.DeadLand, CellBlocker.ROCK);
Terrain.UNDERGROUND = new Terrain("UNDERGROUND", Assets.bg.Mine, CellBlocker.NULL);

Terrain.ALL = [Terrain.MAGICFOREST, Terrain.CURSEDFOREST, Terrain.HOLYLAND, Terrain.DEADLAND, Terrain.MOUNTAIN, Terrain.DESERT, Terrain.FOREST, Terrain.STEPPE, Terrain.UNDERGROUND];