var UnitType = function(name, science, ordinal)
{
	if (typeof ordinal == "undefined") ordinal = -1;
	
	this.name = name;
	this._ordinal = ordinal;
	this._science = science;
	
	this.__defineGetter__('ordinal', function()
	{
		return this._ordinal;
	});
	
	this.__defineGetter__('science', function()
	{
		return this._science;
	});
};

extendClass(UnitType.prototype, Enum.prototype);

UnitType.__isEnum__ = true;

UnitType.prototype.__CLS__  = "game.model.unit.UnitType";

UnitType.prototype.__construct = function(data)
{
	this._science = UnitType[this.name]._science;
	this._ordinal = UnitType[this.name]._ordinal;
}

UnitType.prototype.isMilitary = function()
{
	for (var i = 0; i < UnitType.MILITARY.length; i++)
	{
		if (UnitType.MILITARY[i].name == this.name)
		{
			return i;
		}
	}
	return -1;
}

UnitType.normalize = function(level)
{
	return (level == 0 ? 1 : level);
}

UnitType.SCAVENGER = new UnitType("SCAVENGER", Science.SCAVENGER, 0);
UnitType.MELEE = new UnitType("MELEE", Science.MELEE, 1);
UnitType.CAVALRY = new UnitType("CAVALRY", Science.CAVALRY, 2);
UnitType.FLYER = new UnitType("FLYER", Science.FLYER, 3);
UnitType.RANGER = new UnitType("RANGER", Science.RANGER, 4);
UnitType.HEALER = new UnitType("HEALER", Science.HEALER, 5);
UnitType.MINER = new UnitType("MINER", Science.MINER, 6);
UnitType.MAGE = new UnitType("MAGE", Science.MAGE, 7);

UnitType.MERCHANT = new UnitType("MERCHANT", Science.MERCHANT);
UnitType.SETTLER = new UnitType("SETTLER", Science.COLONIZATION);
UnitType.SPY = new UnitType("SPY", Science.ESPIONAGE);
UnitType.ANTISPY = new UnitType("ANTISPY", Science.ANTI_ESPIONAGE);
UnitType.EXPEDITOR = new UnitType("EXPEDITOR", Science.CARTOGRAPHY);
UnitType.PROPHET = new UnitType("PROPHET", Science.OBSERVATION);
UnitType.MIRROR = new UnitType("MIRROR", Science.ANTI_OBSERVATION);
UnitType.CATAPULT = new UnitType("CATAPULT");

UnitType.MILITARY = [UnitType.SCAVENGER, UnitType.MELEE, UnitType.CAVALRY, UnitType.FLYER, UnitType.RANGER, UnitType.HEALER, UnitType.MINER, UnitType.MAGE];
