function FUserBrotherhood()
{
	this.attackers = null; // ArrayCollection FAttacker
	this.orders = null; // ArrayCollection FBrotherhoodOrder
	this.orderInExecution = null; // FBrotherhoodOrder 
	this.rewards = null; //  ArrayCollection FArtifact
	this.takeIsOnCooldown = false;
	this.nextTakeOrderTime = 0;
	this.recentlyFinishedOrdersCount = 0;
	this.oldestOrderCreationTime = 0;
	
	this.__defineGetter__('nextCreateOrderTime', this.getNextCreateOrderTime);
}

FUserBrotherhood.prototype.__CLS__ = 'game.model.user.brotherhood.FUserBrotherhood';

FUserBrotherhood.prototype.attackers = null; // ArrayCollection FAttacker
FUserBrotherhood.prototype.orders = null; // ArrayCollection FBrotherhoodOrder
FUserBrotherhood.prototype.orderInExecution = null; // FBrotherhoodOrder 
FUserBrotherhood.prototype.rewards = null; //  ArrayCollection FArtifact
FUserBrotherhood.prototype.takeIsOnCooldown = false;
FUserBrotherhood.prototype.nextTakeOrderTime = 0;
FUserBrotherhood.prototype.recentlyFinishedOrdersCount = 0;
FUserBrotherhood.prototype.oldestOrderCreationTime = 0;

FUserBrotherhood.prototype.canCreateOrderByLimit = function()
{
	var count = this.recentlyFinishedOrdersCount;
	for (var i = 0; i < this.orders.length; i++)
	{
		if (Tick.now() - this.orders[i].creationTime < FConfig.BROTHERHOOD_ORDER_MAX_COUNT_TIME) 
		{
			count++;
		}
	}
	return count < FConfig.BROTHERHOOD_ORDER_MAX_COUNT;
}

FUserBrotherhood.prototype.getNextCreateOrderTime = function()
{
	return this.oldestOrderCreationTime + FConfig.BROTHERHOOD_ORDER_MAX_COUNT_TIME;
}

