function OrderRewardType(v, itemType, itemLevel)
{
	this.name = v;
	this.itemType = itemType || null;
	this.itemLevel = itemLevel || 0;
	
	this.__defineGetter__('price', function()
	{
		return FConfig.BROTHERHOOD_ORDER_REWARDS.getValue(this.itemType)[this.itemLevel - 1];
	});
}

extendClass(OrderRewardType.prototype, Enum.prototype);

OrderRewardType.prototype.__CLS__ = 'game.model.user.brotherhood.OrderRewardType';

OrderRewardType.__isEnum__ = true;

OrderRewardType.prototype.itemType = null; // ArtifactType
OrderRewardType.prototype.itemLevel = 0;

OrderRewardType.ANY = new OrderRewardType("ANY");
OrderRewardType.SCROLL_1 = new OrderRewardType("SCROLL_1", ArtifactType.SCROLL, 1);
OrderRewardType.SCROLL_2 = new OrderRewardType("SCROLL_2", ArtifactType.SCROLL, 2);
OrderRewardType.SCROLL_3 = new OrderRewardType("SCROLL_3", ArtifactType.SCROLL, 3);
OrderRewardType.SCROLL_4 = new OrderRewardType("SCROLL_4", ArtifactType.SCROLL, 4);
OrderRewardType.SCROLL_5 = new OrderRewardType("SCROLL_5", ArtifactType.SCROLL, 5);
OrderRewardType.ARTIFACT_1 = new OrderRewardType("ARTIFACT_1", ArtifactType.ARTIFACT, 1);
OrderRewardType.ARTIFACT_2 = new OrderRewardType("ARTIFACT_2", ArtifactType.ARTIFACT, 2);
OrderRewardType.ARTIFACT_3 = new OrderRewardType("ARTIFACT_3", ArtifactType.ARTIFACT, 3);
OrderRewardType.ARTIFACT_4 = new OrderRewardType("ARTIFACT_4", ArtifactType.ARTIFACT, 4);
OrderRewardType.ARTIFACT_5 = new OrderRewardType("ARTIFACT_5", ArtifactType.ARTIFACT, 5);

OrderRewardType.ALL = [
	OrderRewardType.ANY,
	OrderRewardType.SCROLL_1,
	OrderRewardType.SCROLL_2,
	OrderRewardType.SCROLL_3,
	OrderRewardType.SCROLL_4,
	OrderRewardType.SCROLL_5,
	OrderRewardType.ARTIFACT_1,
	OrderRewardType.ARTIFACT_2,
	OrderRewardType.ARTIFACT_3,
	OrderRewardType.ARTIFACT_4,
	OrderRewardType.ARTIFACT_5,
]

OrderRewardType.getRewardType = function(itemType, itemLevel)
{
	var lst = OrderRewardType.ALL;
	for (var i = 0, len = OrderRewardType.ALL.length; i < len; i++) 
	{
		var t = OrderRewardType.ALL[i];
		if ((!t.itemType && !itemType) || String(t.itemType) == String(itemType) && t.itemLevel == itemLevel) 
		{
			return t;
		}
	}
	return null;
}

OrderRewardType.prototype.toString = function()
{
    if (OrderRewardType.ANY.name == this.name) 
    {
        return I18.f('REWARD_ANY');
    } 
    else if (String(this.itemType) == String(ArtifactType.SCROLL)) 
    {
        return I18.f('SCROLL_NAME') + I18.f('LVL_X', this.itemLevel);
    } 
    else 
    {
        return I18.f('ARTIFACT_NAME') + I18.f('LVL_X', this.itemLevel);
    }
}
