var FConfig =
{
	_isNewYearAssets: false,
	
	fetch: function(ignoreCache)
	{
		console.log('fetch config');
	},
	
	cache: function(ignoreCache)
	{
		console.log('cache config');
	},
	
	load: function()
	{
		Tick.TICK_INFINITY = FConfig.TICK_INFINITY;
		I18.load(FConfig.LOCALE_STRINGS || new FMap());
		
		DateUtils.TIMEZONE_OFFSET = ~~FConfig['TIMEZONE_OFFSET'];
		if(FConfig.TICK_INFINITY) Tick.TICK_INFINITY = FConfig.TICK_INFINITY;
		
		var month = I18.f("SHORT_MONTHS_NAMES").split("|");
		dateFormat.i18n.monthNames = month.concat(month);
		
		delete FConfig.LOCALE_STRINGS;
	},
	
	map: function(section)
	{
	},

	getMaxRemainderOf : function(r)
	{
		return this.cell.getValue(r);
	},
	
	isNewYearAssets: function()
	{
		return FConfig._isNewYearAssets;
	},
	
	getSciencePrice: function(s, level)
	{
		return FConfig.science.getValue(s)[level - 1];
	},
	
	getStat: function(r, type, level)
	{
        var stats = FConfig.getUnitParams(r, type).levels;
        if (!stats)
        {
            throw Error("Cannot find stats for " + type.name);
        }
        return stats[level] ? stats[level] : stats[stats.length-1];
	},
   
	getUnitParams: function(r, type)
	{
        return this.races.getValue(r).getValue(type);
	},
	
	getTerrainConfig: function(terrain)
	{
        return this.terrainConfig.getValue(terrain);
	},

	ratio: function(value)
	{
        return value / 100;
	},
   
	getCitySkinPrice: function(r, skinIndex)
	{
		return FConfig.CITY_SKIN_PRICES.getValue(r)[skinIndex].price;
	},
	
	getSmiles: function(st, all)
	{
        var result = [];
        var smiles = FConfig.SMILES.getValue(st);
        var g;
        
        for(var i=0; i<smiles.length; i++)
        {
        	g = smiles[i];
        	
        	if (!g.from || !g.to)
        	{
                result.push(g);
                continue;
            }
            
            var serverNow = DateUtils.getNow();
            
            if(typeof g.from == "string")
            {
            	g.from = FConfig.parseDate(g.from);
            }
            if(typeof g.to == "string")
            {
            	g.to = FConfig.parseDate(g.to);
            }
            
            g.from.setFullYear(serverNow.getFullYear());
            g.to.setFullYear(serverNow.getFullYear());
            if (all)
            {
                result.push(g);
                continue;
            }
            var now = serverNow.getTime();
            var from = g.from.getTime();
            var to = g.to.getTime();
            if (from > to)
            {
                if (from < now || now < to)
                {
                    result.push(g);
                }
            }
            else
            {
                if (from < now && now < to)
                {
                    result.push(g);
                }
            }
        }
        
        return result;
    },
	
    getVictimFor: function(type)
    {
        return FConfig.combatConfig.PERSECUTOR_VICTIM.getValueOrNull(type);
    },
    
    getPersecutorFor: function(type)
    {
        var v = FConfig.combatConfig.PERSECUTOR_VICTIM;
        for(var i = 0, len = v.raw.length; i < len; i++) 
        {
            var k = v.raw[i].key;
            if (type.equals(v.getValueOrNull(k))) 
            {
                return k;
            }
        }
        return null;
    },
    
    parseDate: function(str)
    {
    	/*
    	var tmp = str.split(" ");
    	var date = tmp[0].split("-");
    	var time = tmp[1].split(":");
    	
    	return new Date(date[0], date[1], date[2], time[0], time[1], time[2]);
    	*/
    	return new Date(str);
    },
    
    resolveDate: function(date, now)
    {
        var result = date;
        if (date.getFullYear() <= 1970)
        {
            result = new Date();
            result.setTime(date.getTime());
            result.setFullYear(now.getFullYear());
        }
        return result.getTime();
    },
    
    getGifts: function(gt)
    {
        var result = [];
        
        var gifts = FConfig.GIFTS.getValue(gt);
        
        var g;
        for(var i=0; i<gifts.length; i++)
        {
        	g = gifts[i];
        	
        	if (!g.from || !g.to)
        	{
                result.push(g);
                continue;
            }
            
            var serverNow = DateUtils.getNow();
            var now = serverNow.getTime();
            
            if(typeof g.from == "string")
            {
            	g.from = FConfig.parseDate(g.from);
            }
            if(typeof g.to == "string")
            {
            	g.to = FConfig.parseDate(g.to);
            }
            
            /*
            serverNow.setDate(8);
            serverNow.setMonth(2);
            now = serverNow.getTime();
            console.log(g, serverNow, g.from, g.to);
            */
            
            var from = FConfig.resolveDate(g.from, serverNow);
            var to = FConfig.resolveDate(g.to, serverNow);
            
            if (from > to)
            {
                if (from < now || now < to)
                {
                    result.push(g);
                }
            }
            else
            {
                if (from < now && now < to)
                {
                    result.push(g);
                }
            }
        }
        
        return result;
    },
    
    getMerchantCapacity: function(e)
    {
        if (!e)
        {
            return 0;
        }
        else if (e.owner.science.getLevel(Science.MERCHANT) == 0)
        {
            return Science.MERCHANT.getLevel(0).value;
        }
        else
        {
            return e.owner.getScienceValue(Science.MERCHANT);
        }
    },
    
    /*
    getMerchantCapacity: function(r)
    {
        return FConfig.getStat(r, UnitType.MERCHANT, 1).capacity;
    },
    */

    getMerchantDeathRate: function(r)
    {
        return FConfig.getStat(r, UnitType.MERCHANT, 1).deathRate;
    },

    getSpell: function(name, level)
    {
        var spells = FConfig.spells.getValueOrNull(name);
        return spells ? spells.getValueOrNull(level) : null;
    },

	getMaxSkillLevel: function(decl)
	{
		if (!decl.minLevels.isEmpty()) 
		{
			return decl.minLevels.size;
		}
		
		var levels = FConfig.spells.getValueOrNull(decl.name);
		if (levels) 
		{
			return levels.size;
		}
		
		levels = FConfig.passives.getValueOrNull(decl.name);
		if (levels) 
		{
			return levels.size;
		}
		
		return 0;
	},

    getPassive: function(name, level)
    {
        var spells = FConfig.passives.getValueOrNull(name);
        return spells ? spells.getValueOrNull(level) : null; 
    },

    getMarketPriceStep: function()
    {
        return Math.pow(0.1, FConfig.MARKET_PRECISION);
    },

    getCitySkin: function(r, skinIndex)
    {
        if (skinIndex < 0) 
        {
            r = Race.MONSTER;
            skinIndex = 0;
        }
        return FConfig.CITY_SKIN_PRICES.getValue(r)[skinIndex];
    },

    getCitySkinPriceRange: function(r, currentSkin)
    {
        var min = Number.MAX_VALUE;
        var max = Number.MIN_VALUE;

        var racePrices = FConfig.CITY_SKIN_PRICES.getValue(r);
        if (racePrices) 
        {
            for (var i = 0; i < racePrices.length; i++) 
            {
                if (i != currentSkin) 
                {
                    var price = FConfig.getCitySkinPrice(r, i);
                    min = Math.min(min, price);
                    max = Math.max(max, price);
                }
            }
        }

        var ret = new Range();
        ret.min = min;
        ret.max = max;
        return ret;
    },

    updateNewYearAssets: function()
    {
        if(!FConfig.NY_ASSETS_PERIOD) return;
        
        var serverNow = DateUtils.getNow();

        var startDate = new Date();
        startDate.setTime(Tick.toMs(FConfig.NY_ASSETS_PERIOD.start));
        startDate.setFullYear(serverNow.getFullYear());

        var endDate = new Date();
        endDate.setTime(Tick.toMs(FConfig.NY_ASSETS_PERIOD.end));
        endDate.setFullYear(serverNow.getFullYear());
        
        FConfig._isNewYearAssets = FConfig.periodContains(startDate, endDate, serverNow);
    },

    periodContains: function(startDate, endDate, now)
    {
        var result = false;
        if (endDate.getTime() < startDate.getTime()) 
        {
            startDate.setFullYear(now.getFullYear() - 1);
            // checking the beginning of year
            result = FConfig.isBetween(startDate, endDate, now);
            if (!result) 
            {
                startDate.setFullYear(now.getFullYear());
                endDate.setFullYear(now.getFullYear() + 1);
                // checking the ending of year
                result = FConfig.isBetween(startDate, endDate, now);
            }
        } 
        else 
        {
            result = FConfig.isBetween(startDate, endDate, now);
        }
        return result;
    },

    isBetween: function(startDate, endDate, now)
    {
        return now.getTime() >= startDate.getTime() && now.getTime() <= endDate.getTime();
    },

    getStandards: function(peace) 
    {
        return peace ? FConfig.PEACE_STANDARDS : FConfig.WAR_STANDARDS;
    },

    computeMentorLink: function(username) 
    {
        return FConfig.HTTP_PORTAL_ADDRESS +  "?state=register_simple_new&user=" + username + "&server=" + FConfig.SERVER_ID.replace("$", "");
    },

    computeShortRefLink: function(portalId)
    {
        return FConfig.HTTP_PORTAL_ADDRESS +  "?state=register_simple_new&f=" + portalId + "&server=" + FConfig.SERVER_ID.replace("$", "");
    },

    getServerShortName: function() 
    {
        return StringUtil.trim(FConfig.SERVER_NAME.substr(Math.max(0, FConfig.SERVER_NAME.indexOf(":") + 1)));
    },
    
    getPortalAddress: function()
    {
    	return PortalService.getUrl().indexOf("https") == 0 ? FConfig.HTTPS_PORTAL_ADDRESS : FConfig.HTTP_PORTAL_ADDRESS;
    }
}; 

