function ServiceHelper()
{
}

ServiceHelper.estate = null;

ServiceHelper.getGloabalServiceDecl = function(service, level)
{
    var items = ServiceHelper.getGlobalServiceItems(service);
    if (items && level >= 0 && level < items.length)
    {
        return items[level];
    }
    return null;
}

ServiceHelper.getGlobalServiceItems = function(service)
{
    var decl = ServiceHelper.getGlobalService(service);
    return !decl ? null : decl.items;
}

ServiceHelper.getGlobalService = function(service)
{
    for(var i in FConfig.GLOBAL_SERVICES)
    {
    	if(FConfig.GLOBAL_SERVICES[i].service == service)
    	{
    		return FConfig.GLOBAL_SERVICES[i];
    	}
    }
    return null;
}

ServiceHelper.setGlobalServiceAutoOrder = function(service, value, estateId)
{
    Service.city.callMethod("autoOrderGlobalService", [estateId, service, value], function (e)
    {
		Alert.create(value ? I18.f("AUTO_ORDER_ON") : I18.f("AUTO_ORDER_OFF"));
	});
}

ServiceHelper.orderGlobalService = function(service, level, rewardData, estateId, onOrdered, active)
{
    if ((typeof active == "undefined") || active === null)
    {
        active = FUser.CURRENT_USER.isBoosted(service);
    }
    
    var handleResult = function(c)
    {
        if (service == "MERCHANT" || service == "EXPEDITION")
        {
            Alert.create(I18.f("BOOST_MISSION_SPEED_WARNING"));
        }
        else
        {
            Alert.create(active ? I18.f("FEATURE_PROLONGATED") : I18.f("FEATURE_ACTIVATED"));
        }
        
        if (onOrdered)
        {
            onOrdered(c);
        }
    };
    
    ServiceHelper.orderGlobalServiceSimple(service, level, rewardData, estateId, handleResult);
}

ServiceHelper.orderGlobalServiceSimple = function(service, level, rewardData, estateId, onOrdered)
{
    Service.city.callMethod("buyGlobalService", [estateId, service, level, rewardData, true], onOrdered, function (e)
    {
        var cls = e.__className__;
                
        var warning = null;
		var type = e.type;
		var buff = e.buff;
		
        if (cls == "PearlBoostException")
        {
            if (type == "NO_BUILDINGS")
            {
                warning = I18.f("PEARL_BOOST_WARNING_NO_BUILDINGS");
            }
            else if (type == "PERSONAL_EVENT_STOPPER")
            {
                warning = I18.f("PEARL_BOOST_WARNING_PERSONAL_EVENT_STOPPER", I18.getBuffCause(e.buff));
            }
        }
        
        if (warning)
        {
            Alert.create(warning, "", function ()
            {
                Service.city.callMethod("buyGlobalService", [estateId, service, level, rewardData, false], onOrdered, function (e)
                {
                    if (GameException.isDisplayable(e))
                    {
                        Alert.create(e.getMessage());
                        return true;
                    }
                    return false;
                });
            });
            return true;
        }
        else if (true)
        {
            Alert.create(e.getMessage());
            return true;
        }
        return false;
    });
}

ServiceHelper.getLocalServiceDecl = function(service, level)
{
    var items = ServiceHelper.getLocalServiceItems(service);
    if (items && level >= 0 && level < items.length)
    {
        return items[level];
    }
    return null;
}

ServiceHelper.getLocalServiceItems = function(service)
{
	for(var i in FConfig.LOCAL_SERVICES)
    {
    	if(FConfig.LOCAL_SERVICES[i].service == service)
    	{
    		return FConfig.LOCAL_SERVICES[i].items;
    	}
    }
}

ServiceHelper.setLocalAutoOrder = function(service, value, estateId)
{
    Service.city.callMethod("autoOrderLocalService", [estateId, service, value], function (e)
    {
        ServiceHelper.estate = e;
        Alert.create(value ? I18.f("AUTO_ORDER_ON") : I18.f("AUTO_ORDER_OFF"));
	});
}


ServiceHelper.orderLocalService = function(service, level, rewardData, estateId, onOrdered, active)
{
    var handleResult = function (c)
    {
        if (service == "MERCHANT" || service == "EXPEDITION")
        {
            Alert.create(I18.f("BOOST_MISSION_SPEED_WARNING"));
        }
        if (onOrdered)
        {
            onOrdered(c);
        }
    };
    
    Service.city.callMethod("buyLocalService", [estateId, service, level, rewardData, true],
	    function (e)
	    {
	        ServiceHelper.estate = e;
	        Alert.create(active ? I18.f("FEATURE_PROLONGATED") : I18.f("FEATURE_ACTIVATED"));
	        handleResult(e);
	    },
        function (e)
        {
            var warning = null;
            if ((e.__className__ == 'PearlBoostException')) 
            {
                var type = e.type;
                var buff = e.buff;
                if (type == "NO_BUILDINGS") 
                {
                    warning = I18.f('PEARL_BOOST_WARNING_NO_BUILDINGS');
                } 
                else if (type == "PERSONAL_EVENT_STOPPER") 
                {
                    warning = I18.f('PEARL_BOOST_WARNING_PERSONAL_EVENT_STOPPER', I18.getBuffCause(buff));
                }
            }
            if (warning) 
            {
                Alert.create(warning, '', function ()
                {
                    Service.city.callMethod('buyLocalService', [estateId, service, level, rewardData, false],
						function (e)
						{
						    estate = e;
						    Alert.create(active ? I18.f('FEATURE_PROLONGATED') : I18.f('FEATURE_ACTIVATED'));
						    handleResult(e);
						},
						function (e)
						{
						    if (GameException.isDisplayable(e)) 
						    {
						        Alert.create(e.getMessage());
						        return true;
						    }
						    return false;
						}
					);
                });
                return true;
            } 
            else if (GameException.isDisplayable(e)) 
            {
                Alert.create(e.getMessage());
                return true;
            }
            return false;
        }
	);
}