function mapResponseClasses(data)
{
	if (!data)
	{
		return data;
	}
	
	data.__isMapped__ = true;
	
	for (var i in data)
	{
		if (typeof data.__lookupGetter__(i) == "function" || typeof data.__lookupSetter__(i) == "function")
		{
			continue;
		}
		if (typeof data[i] == "object" && data[i] && data[i].__isMapped__ !== true)
		{
			data[i] = mapResponseClasses(data[i]);
		}
	}
	
	var cls = null, classRef, instance;
	if (data.__CLS__)
	{
		cls = (data.__CLS__.split('.')).pop();
		if (cls)
		{
			classRef = window[cls];
			
			if (typeof classRef != "function")
			{
				return data;
			}

			if(classRef.__isEnum__)
			{
				instance = classRef[data.name];
			}
			else
			{
				instance = new window[cls](data);
				$.extend(instance, data);
				
				if (typeof instance.__construct == "function")
				{
					instance.__construct(data);
				}
			}
			
			data = instance;
		}
	}

	return data;
}

function restoreResponseLinks(data, links)
{
	var lnk, from, to, from_path, to_path, key, n, s;
	
	function parseLinkString(link)
	{
		if(link == "") return [];
		var s = link.substring(1, link.length-1);
		var path = s.split("][");
		for(var i=0, len = path.length; i<len; i++)
		{
			s = path[i].substring(0, 1);
			if(s == "'" || s == '"') path[i] = path[i].substring(1, path[i].length-1);
		}
		return path;
	}
	
	if (links)
	{
		if($.isArray(links))
		{
			for (var i=0; i<links.length; i++)
			{
				lnk = links[i];
				
				from_path = lnk[0];
				from = data;
				
				for(n=0; n<from_path.length; n++)
				{
					from = from[from_path[n]];
				}
				
				for(var k=1; k<lnk.length; k++)
				{
					to_path = lnk[k];
					to = data;
					key = to_path[to_path.length-1];
					for(n=0; n<to_path.length-1; n++)
					{
						to = to[to_path[n]];
					}
					
					to[key] = from;
				}
				
				/*
				to_path = links[i][0];
				to = data;
				key = to_path[to_path.length-1];
				for(n=0; n<to_path.length-1; n++)
				{
					to = to[to_path[n]];
				}
				
				from_path = links[i][1];
				from = data;
				
				for(n=0; n<from_path.length; n++)
				{
					from = from[from_path[n]];
				}
				
				to[key] = from;
				*/
			}
		}
		else
		{
			//var classes = {};
			for (var i in links)
			{
				to_path = parseLinkString(i);
				to = data;
				key = to_path.pop();
				for(n=0; n<to_path.length; n++)
				{
					to = to[to_path[n]];
				}
				
				from_path = parseLinkString(links[i]);
				from = data;
				for(n=0; n<from_path.length; n++)
				{
					from = from[from_path[n]];
				}
				
				/*
				if(from && from.__CLS__)
				{
					if(!classes[from.__CLS__]) classes[from.__CLS__] = 0;
					classes[from.__CLS__]++;
				}
				*/
				
				to[key] = from;
			}
			//console.log(classes);
		}
	}
	
	return data;
}

function responsePostProcessing(data, linkOnce)
{
	var links = data ? data.__LNK__ : null;
	if (data) delete (data.__LNK__);
	if (data && data.data) data = data.data;
	
	if(!linkOnce) data = restoreResponseLinks(data, links);
	data = mapResponseClasses(data);
	data = restoreResponseLinks(data, links);
	
	delete(links);
	
	return data;
}

function cloneRequestParam(p)
{
	
	if (!( typeof p == "object") || !p)
	{
		if (typeof p == 'undefined') p = null;
		return p;
		//return (typeof p == 'string') ? quoteRequestString(p) : String(p);
	}
	
	var ret;
	
	if ($.isArray(p))
	{
		ret = Array.prototype.slice.call(p, 0);
		
		for (var i=0; i<p.length; i++)
		{
			if (typeof p[i] == "function")
			{
				continue;
			}
		
			ret[i] = cloneRequestParam(p[i]);
		}
	}
	else
	{
		ret = {};
		
		for (var i in p)
		{
			if (typeof p.__lookupGetter__(i) == "function" || typeof p.__lookupSetter__(i) == "function")
			{
				continue;
			}
			
			if (typeof p[i] == "function")
			{
				continue;
			}
			
			if(i == "superClass" || i == "__isMapped__")
			{
				continue;
			}
		
			ret[i] = cloneRequestParam(p[i]);
		}
	}

	return ret;
}

function quoteRequestString(str)
{
	str = str || '';
	
	// escape backslashes
	str = str.replace('\\', '\\\\');
	if (str[0] == '"') str = '\\' + str;
	
	for (var i = 1; i < str.length; i++)
	{
		if (str[i] == '"')
		{
			// before is not backslash or escaped backslash
			if ((str[i-1] != '\\') ^ (i > 1 && str[i-2] == '\\'))
			{
				str = str.substring(0,i-1) + '\\' + str.substring(i);
				i++;
			}
		}
	}
	return '"' + str + '"';
}

function prepareRequestParams(params)
{
	if (!params)
	{
		return params;
	}
	if (!$.isArray(params))
	{
		params = [params];
	}
	
	var ret = params.slice();

	for (var i = 0; i < ret.length; i++)
	{
		var p = cloneRequestParam(ret[i]);

		//if (p === null || typeof p == 'undefined') p = 'null';
		//if ($.isArray(p) && p.length == 0) p = '[]';
		//if ($.isPlainObject(p) && $.isEmptyObject(p)) p = '{}';
		ret[i] = JSON.stringify(p);
	}

	/*
	for (var i = 0, len = params.length; i < len; i++)
	{
		if (params[i] !== null && params[i] !== true && params[i] !== false)
		{
			params[i] = JSON.stringify(params[i]);
		}
	}
	*/
	
	return ret;
}

function quoteRequestString(str)
{
	str = str || '';
	
	// escape backslashes
	str = str.replace('\\', '\\\\');
	if (str[0] == '"') str = '\\' + str;
	
	for (var i = 1; i < str.length; i++)
	{
		if (str[i] == '"')
		{
			// before is not backslash or escaped backslash
			if ((str[i-1] != '\\') ^ (i > 1 && str[i-2] == '\\'))
			{
				str = str.substring(0,i-1) + '\\' + str.substring(i);
				i++;
			}
		}
	}
	return '"' + str + '"';
}

var Quarantine =
{
    GATE: "GATE",
    HALL: "HALL",
    TRANSFER: "TRANSFER",
    PREMIUM: "PREMIUM",
    REORDER: "REORDER",

    objects: [], 
     
    contains: function(o)
    {
		for(var i=0; i<Quarantine.objects.length; i++)
		{
			if(Quarantine.objects[i] == o) return true;
		}
		return false;
    },

    put: function(o)
    {
		Quarantine.objects.push(o); 
    },

    clear: function()
    {
		Quarantine.objects = [];
		if(APP.updateHints) APP.updateHints();
    }
}

var ResponseHandler =
{
	handlers: [],
	
	init: function()
	{
		Events.onError.add(ResponseHandler, ResponseHandler.processErrors);
	},
	
	processErrors: function(e)
	{
		var cls = e.__className__;
		
		// game session expired
		if(cls == "SessionExpiredException")
		{
			Alert.create(I18.f("SESSION_EXPIRED")).onClose = Service.logout;
			APP.stopAllTickers();
			console.error('SESSION EXPIRED ' + APP.PORTAL_AUTH_TOKEN + ' ' + APP.PORTAL_SESSION);
			return true;
		}
		
		// portal session expired
		if (cls == "ClientKnowsException" && e.type == 'SESSION_EXPIRED')
		{
			Alert.create(I18.f("SESSION_EXPIRED")).onClose = function(){
				PortalService.logout();
				if(APP.route) APP.route('LoginScreenView');
				else Service.goToPortal();
			};
			console.error('SESSION EXPIRED ' + APP.PORTAL_AUTH_TOKEN + ' ' + APP.PORTAL_SESSION, e);
			return true;
		}
		
		if (cls == "ObsoleteClientException")
		{
            Alert.create(I18.f("OBSOLETE_CLIENT")).onClose = Service.reloadPage;
			return true;
		}
		
		if (cls == "RegistrationRequiredException")
		{
            // Should not happen. Registration is done in index.html 
			throw Error("Need registration... something wrong!");
			return true;
		}
		
		if(cls == "UserBannedException")
		{
			var till = e.till;
            var message = e.getMessage();
            var d;
            if (Strings.isEmpty(message))
            {
                d = Alert.create(Tick.isInfinity(till) ? I18.f("YOU_WERE_BANNED") : I18.f("YOU_WERE_BANNED_TILL", Tick.toTimeFutureSeconds(till)));
            }
            else
            {
                d = Alert.create(Tick.isInfinity(till) ? I18.f("YOU_WERE_BANNED_DETAIL", message) : I18.f("YOU_WERE_BANNED_DETAIL_TILL", [Tick.toTimeFutureSeconds(till), message]));
            }
            d.onClose = Service.logout;
            return true;
		}
		
		if (cls == "GarrisonIsBlockedException")
		{
            Alert.create(I18.f("MISSION_FAIL_BLOCKED_GARRISON"));
            return true;
        }
        
        if (cls == "EspionageException")
        {
            Alert.create(e.getMessage());
            return true;
        }
        
        if (cls == "AccessDeniedException")
        {
            
            if (e.type == "SURVIVAL_IS_OVER")
            {
                Alert.create(I18.accessDeniedError(e.type, I18.formatEstateName(e.estateName, e.location))).onClose = Service.goToPortal;
            }
            else
            {
                Alert.create(I18.accessDeniedError(e.type, I18.formatEstateName(e.estateName, e.location))).onClose = function()
                {
                	if(e.location) Events.onShowKingdom.fire(e.location);
				};
            }
            return true;
        }
        
        if (cls == "BuildingException" ||
            cls == "PearlBoostException" ||
            cls == "MarketException")
        {
        	Alert.create(e.getMessage());
            return true;
        }
        
        if (cls == "NotEnoughResourcesException")
        {
            Alert.create(I18.f("BANK_DESYNC_MESSAGE"));
            return true;
        }
        
        if (cls == "NotEnoughArmyException")
        {
            Alert.create(I18.f("ARMY_DESYNC_MESSAGE"));
            return true;
        }
        
        if (cls == "NotEnoughUnitsCapacityException" ||
            cls == "TooManyOrderedUnitsException")
		{
            Alert.create(I18.f("BUILDING_DESYNC_MESSAGE"));
            return true;
        }
        
        if (cls == "BuildQueueException")
        {
            return true;
        }

        if (cls == "MandatoryPaymentNotPayedException")
        {
            MandatoryPaymentDialog.popup();
            return true;
        }

        if (cls == "MandatoryOffersException")
        {
            MandatoryOffersDialog.popup();
            return true;
        }

        if (cls == "SubscriptionExpiredException" ||
            cls == "PromoExpiredException")
		{
            SubscriptionExpiredDialog.popup();
            return true;
        }
        
        if (cls == "SaveInProgressException")
        {
            ServerSavingAlert.onException(e.timeout);
            return true;
        }
        
        if (cls == "EstateNotFoundException")
        {
            e.showMessageAndGo();
            return true;
        }
        
        if (cls == "TemplateException")
        {
            Alert.create(e.getBox());
            return true;
        }
        
        if (cls == "ClientKnowsException")
        {
        	Alert.create(e.getMessage());
        	return true;
		}
        
		console.error("Not handled error: " + JSON.stringify(e));
	},
	
	estatesClasses: ["FEstate", "FCity", "FCastle", "FCamp", "FLake", "FMine", "FGrotto", "FPit", "FRuin", "FGrail", "FCatapult"],
	
	isEstate: function(data)
	{
		return ResponseHandler.estatesClasses.indexOf(data.__className__) >= 0;
	},
	
	serverResultReceived: function(data)
	{
		if(!data) return true;
		
		if (data.IS_EXCEPTION)
		{
			return false;
		}
		
		if (typeof data['__className__'] == 'undefined')
		{
			data['__className__'] = data['__CLS__'] ? data['__CLS__'].split('.').pop() : '';
		}
		
		var newUser = (data.__className__ == "FUser") ? data : null;
		
		if (!(ResponseHandler.isEstate(data) && data.isExpeditionReport))
		{
            var firstTime = (Tick.now() == 0);
            if(data.responseTick)
            {
				Tick.updateTick(data.responseTick);
            	
            	if (firstTime)
	            {
	                FConfig.updateNewYearAssets();
	            }
            }
            
            if(data.currentUser) newUser = data.currentUser;
            
			if (data.configId && data.configId > 0 && data.configId != FConfig.id)
            {
				Events.onReloadConfig.fire();
            }
		}
		
		if (data.__className__ == "FCastResult")
		{
            if (data.estate)
            {
                newUser = data.estate.currentUser;
            }
            else if (data.kingdom)
            {
                newUser = data.kingdom.currentUser;
            }
		}
		
		if (newUser)
		{
            FUser.updateCurrentUser(newUser);
            Events.onFUserUpdated.fire(newUser);
		}
		
		if (ResponseHandler.isEstate(data))
		{
			ResponseHandler.onEstateReceived(data);
		}
		else if (data.__className__ == "FKingdom")
		{
			ResponseHandler.onKingdomReceived(data);
		}
		else if (data.__className__ == "FCastResult")
		{
			if (data.estate)
			{
			    ResponseHandler.onEstateReceived(data.estate);
			}
			else if (data.kingdom)
			{
			    ResponseHandler.onKingdomReceived(data.kingdom);
			}
		}
		
		return true;
	},
	
	onEstateReceived: function(estate)
	{
        /*
        if(estate.nextUpdateTick - Tick.now() == 30)
        {
        	estate.nextUpdateTick += 30;
        }
        */
        
        if (estate.accessManageble && !(estate.__className__ == "FCastle"))
        {
            FUser.LINKS = estate.links;
            FUser.MAIL_BOX_STATUS = estate.mailBoxStatus;
        }
        
        Events.onFEstateUpdated.fire(estate);
   },
   
	onKingdomReceived: function(kingdom)
	{
		FUser.LINKS = kingdom.links;
        Events.onFKingdomUpdated.fire(kingdom);
	}
};
ResponseHandler.init();

//var RECONNECT_CALLBACK = null;
var APP_IS_OFFLINE = false;

function processLostConnection(callback, timeout, xhr, errorText)
{
	//if(APP_IS_OFFLINE && callback != RECONNECT_CALLBACK) return;
	
	if(!APP_IS_OFFLINE && APP.stopAllTickers) APP.stopAllTickers();
	
	APP_IS_OFFLINE = true;
	//RECONNECT_CALLBACK = callback;
	
	var err = document.createElement('div');
	
	var t = timeout * 1 || 30;
	var retryTO = null;

	var btn = document.createElement('button');
	
	function retry()
	{
		clearInterval(retryTO);
		retryTO = null;
		var loader = '<div class="loaderPartContainer"><div class="loaderPart loaderPart1"></div></div><div class="loaderPartContainer"><div class="loaderPart loaderPart2"></div></div><div class="loaderPartContainer"><div class="loaderPart loaderPart3"></div></div>';
		$(btn).off(CLICK_EVENT).addClass('disabled').html(loader);
		APP.showLoader();
		if (typeof callback == 'function')
		{
			callback();
		}
	}
	
	COM.bindExclusiveClick(btn, retry);
	
	var message;
	var lang = (APP ? APP.language : navigator.language.toUpperCase().split(/[^a-zA-Z]/).shift());
	var errStr = CONNECTION_ERROR_STRINGS[String(lang).toUpperCase()] || CONNECTION_ERROR_STRINGS['EN'];

	btn.innerHTML = btn.innerHTML = errStr['ERROR_RETRY_BUTTON'] + ' (' + t + ')';

	if (xhr && xhr.status)
	{
		message = errStr['ERROR_TITLE_SERVER_DOWN'];
		message += '<div class="text-normal text-small" style="color:#F00;">' + xhr.status + " " + errorText + '</div>';
		message += '<div class="text-normal text-small">' + errStr['ERROR_MESSAGE_SERVER_DOWN'] + '</div>';
	}
	else
	{
		message = errStr['ERROR_TITLE_CONNECTION_DOWN'];
		message += '<div class="text-normal text-small">' + errStr['ERROR_MESSAGE_CONNECTION_DOWN'] + '</div>';
	}
	$(err).append("<div>" + message + "</div>").append(btn);
	
	retryTO = setInterval(function(){
		t--;
		if (t > 0)
		{
			btn.innerHTML = errStr['ERROR_RETRY_BUTTON'] + ' (' + t + ')';
		}
		else
		{
			retry();
		}
	}, 1000);
	
	APP.globalError(err);
}

function AmfProxy(destination, server)
{
	var destination = destination;
	var server = (server || ENTRY_POINT) + '';
	if (server.charAt(server.length-1) != '/') server += '/';

	this.xhr = null;
	this.status = null;
	
	this.callMethod = function(method, params, okCallback, errCallback, logName)
	{
		var p =	{};
		
		if(!params)
		{
			params = [];
		}
		
		p.service = destination + "." + method;
		p.params = prepareRequestParams(params);
		
		var url = server + "/bridge;portalsessionid=" + APP.PORTAL_SESSION;
		
		ajaxInit();
		
		var self = this;
		var successHandler = function(data, status, xhr)
		{
			this.xhr = xhr; this.status = status;
			
			data = responsePostProcessing(data);
			
			if(data && data.__CLS__ && data.__CLS__.indexOf("Exception") >= 0)
			{
				if(data.cause)
				{
					data = data.cause;
				}
				if (!data['IS_EXCEPTION'])
				{
					data = $.extend(new Exception(), data);
				}
			}
			
			if(ResponseHandler.serverResultReceived(data))
			{
				// check for scalar values
				if (data && (typeof data == 'object') && data.hasOwnProperty('data') && ((typeof data['data'] != 'object') || data['data'] === null))
				{
					data = data['data'];
				}
		
				if (typeof okCallback == "function")
				{
					okCallback(data, this);
				}
			}
			else
			{
				if (typeof errCallback != "function" || errCallback(data, this) !== true)
				{
					Events.onError.fire(data);
				}
			}
			
			Quarantine.clear();
			this.xhr = null; this.status = null;
			
		}
		
		var errorHandler = function(xhr, status, error)
		{
			if (!xhr || !xhr.status || xhr.status > 400)
			{
				processLostConnection(function(){
					self.callMethod(method, params, okCallback, errCallback, logName);
				});
				return;
			}
			
			this.xhr = xhr; this.status = status;
			if (typeof errCallback == 'function') 
			{
				errCallback(error, this);
			}
			this.xhr = null; this.status = null;
		}

		this.xhr = $.post(url, p, successHandler, 'json').error(errorHandler);
	}

	this.reconnectTo = function(newServer)
	{
		server = newServer;
	}
}

function ajaxInit()
{
	$.ajaxSetup({
		//crossDomain: true,
		beforeSend: function(xhr) 
		{
			xhr.setRequestHeader('X-Session-Id', APP.PORTAL_SESSION || 'no-session'); 
			xhr.setRequestHeader('X-Portal-Auth-Token', APP.PORTAL_AUTH_TOKEN || 'anonymous');
		},
		error: function (xhr, ajaxOptions, thrownError)
		{
    		return;
    		
    		if(APP_IS_OFFLINE) return;
    		APP_IS_OFFLINE = true;
    		
    		if (xhr.status > 400)
    		{
    			console.error('Server error (%s)', xhr.status, thrownError);
    			return;
    		}
    		
    		var str = "Connection lost. Maybe you have disabled WiFi or your device is in Airplane mode.";
    		if(I18 && I18.loaded) str = /*I18.f("CONNECTION_STATUS") + " " + I18.f("CONNECTION_STATUS_LOST") + ". " + */ I18.f("CONNECTION_STATUS_LOST_EXPLAIN");
    		
    		/*
    		if(window["Alert"])
    		{
        		Alert.create(str).onClose = function()
        		{
        			console.error('Request error', xhr.status, thrownError);
        			//Session.clear();
    				//Service.goToPortal();
        		};
    		}
    		else
    		{
       			console.error('Request error', xhr.status, thrownError);
    			//Session.clear();
    			//Service.goToPortal();
    		}
    		*/
		},
		complete: function(xhr, status)
		{
			if (xhr && xhr.status && xhr.status <= 400)
			{
				if(APP_IS_OFFLINE)
				{
					if(APP.resumeAllTickers) APP.resumeAllTickers();
				}
				
				APP_IS_OFFLINE = false;
				//RECONNECT_CALLBACK = null;
				APP.globalError(null);
				
				APP.hideLoader();
			}
		}
	});
}

var PortalService =
{
	account : new AmfProxy("accountService", null),
	admin : new AmfProxy("portalAdminService", null),
	spam : new AmfProxy("spamService", null),

	services : [],

	mobilePlatform: "",
	mobileToken: "",
	
	portalInfo: null,
	zone: null,
    
    setMobileEnvironment: function(platform, token)
    {
        PortalService.mobilePlatform = platform;
        PortalService.mobileToken = token;
    },
	
	signupInfo: function(callback)
	{
	    $.get(PortalService.getUrl('/signup-info'), function(data){
			
			APP.globalError(null);
	    	data = JSON.parse(data);
	    	for (var i = 0; i < data.servers.length; i++)
	    	{
	    		data.servers[i].name = Base64.decode(data.servers[i].name);
	    		//wtf... stupid-stupid hack
	    		var about = ((typeof data.servers[i].about == "string") ? data.servers[i].about : data.servers[i].about[""] + "");
	    		data.servers[i].about = Base64.decode(about);
	    	}
	    	if (typeof callback == 'function') callback(data);
	    	
	    }).error(function(xhr, status, errorText)
		{
			processLostConnection(function(){
				
				PortalService.signupInfo(callback);
				
			}, 30, xhr, errorText);
		});
	},

	getZones : function(callback)
	{
		if (ZoneInfo.zones)
		{
			if (callback) callback(ZoneInfo.zones);
			return;
		}
		
		var url = ENTRY_POINT + "bridge;portalsessionid=fake";
		
		/*
		var p =	{
			service: 'accountService.getPortalInfo', 
			params: prepareRequestParams([])
		};
		*/
		
		var p =	{
			service: 'accountService.getPortalZoneInfo',
			params: prepareRequestParams([ANDROID_MODE ? "android" : "ios"])
		};

		ajaxInit();
		$.post(url, p, function(data)
		{
			APP.globalError(null);
			data = responsePostProcessing(data);
			ZoneInfo.zones = data.zones;
			
			if (window['ZONE_LOCK'])
			{
				if (!$.isArray(ZONE_LOCK)) ZONE_LOCK = [ZONE_LOCK];
				for (var i = 0; i < ZoneInfo.zones._entries.length; i++)
				{
					if (ZONE_LOCK.indexOf(ZoneInfo.zones._entries[i].key) < 0)
					{
						ZoneInfo.zones._entries.splice(i, 1);
						i--;
					}
				}
			}
			if (callback) callback(ZoneInfo.zones);
			
		}, 'json').error(function(xhr, status, errorText)
		{
			processLostConnection(function(){
				
				PortalService.getZones(callback);
				
			}, 30, xhr, errorText);
		});
	},

	switchToZone: function(key, callback)
	{
		key = key || Storage.get('lastZone') || navigator.language;
		
		var zone = ZoneInfo.find(key);
		
		if (!zone) 
		{
			console.error("Zone not found: " + JSON.stringify(key));
			console.log(JSON.stringify(ZoneInfo.zones));
			return;
		}
		
		PortalService.switchTo(zone.flagUrl);
		PortalService.zone = zone;
		Storage.set('lastZone', zone.key);
		
		// load new config
		APP.reloadConfig(function(){
			
			// load portal info
			PortalService.getInfo(function(){
				
				if (callback) callback();
				APP.language = PortalService.zone.language;
				
			});
			
		});
	},
	
	getInfo : function(callback)
	{
		PortalService.account.callMethod('getPortalInfo', [], function(data)
		{
			data = responsePostProcessing(data, true);
			PortalService.portalInfo = data;
			callback(data);
		});
	},

	getConfig : function(callback)
	{
		PortalService.account.callMethod('getConfigMobile', [], function(data)
		{
			data = responsePostProcessing(data, true);
			APP.PORTAL_SESSION = data.portalsessionid;
			callback(data);
		});
	},

	login : function(params, callback)
	{
		
		$.get(PortalService.getUrl("/salt;portalsessionid=" + APP.PORTAL_SESSION), function(response)
		{
			PortalService.doLogin(params, response.salt, callback);
		}, "json");
	},
	
	doLogin: function(params, salt, callback)
	{
		ajaxInit();
		
		var version = ANDROID_MODE 
			// ? ('android' + MATHelper.VERSION.split('.').pop())
			? ('android' + MATHelper.VERSION)
			: ('ios' + MATHelper.VERSION)
		;
		if (typeof window['OVERRIDE_CLIENT_VERSION'] != 'undefined') 
		{
			version = OVERRIDE_CLIENT_VERSION + '';
		}
		
		var p = {
			username: params.username,
			password: MD5(MD5(params.password) + salt),
			autologin: params.autologin,
			captcha: params.captcha,
			version: version, 
		};
		
		console.log('CLIENT VERSION: ' + version);
		
		if(PortalService.mobilePlatform && PortalService.mobileToken)
		{
			p.mobileToken = PortalService.mobilePlatform + ":" + PortalService.mobileToken;
		}
		
		console.log("SESSION = " + APP.PORTAL_SESSION);
		
		$.post(PortalService.getUrl("/auth;portalsessionid=" + APP.PORTAL_SESSION),	p,
		function(data, status, xhr)
		{
			var sid = APP.PORTAL_SESSION;
			if (typeof data['sessionId'] != 'undefined') sid = data.sessionId;
			if (!sid) sid = xhr.getResponseHeader('X-Session-Id');
			if (sid && sid != APP.PORTAL_SESSION) APP.PORTAL_SESSION = sid;
			
			APP.PORTAL_AUTH_TOKEN = data['token'] || null;
			
			if(callback)
			{
				callback(data)
			}
		}, "json");
	},

	restorePassword : function(text, callback)
	{
		$.post(PortalService.getUrl("/bridge?service=restore_pass"), { usernameOrEmail : text }, callback);
	},

	getUrl : function(relative)
	{
		var url = PortalService.portalUrl;
		if (!url) return '';
		if (typeof relative == 'undefined') relative = '';
		while (url.charAt(url.length-1) == '/') url = url.substring(0, url.length-1);
		if (relative && relative.charAt(0) != '/') relative = '/' + relative;
		if (relative == '/') { relative = ''; }
		return url + relative;
	},

	switchTo : function(url)
	{
		if (url && url.length > 0)
		{
			PortalService.portalUrl = url;
			url = PortalService.getUrl();
			for (var i = 0; i < this.services.length; i++)
			{
				this.services[i].reconnectTo(url);
			}
		}
		Session.set('portalURL', url || null);
	},

	assignSession : function(portalsessionid)
	{
		APP.PORTAL_SESSION = portalsessionid;
		var url = this.getUrl();
		if (url)
		{
			for (var i = 0; i < this.services.length; i++)
			{
				this.services[i].reconnectTo(url);
			}
		}
	},

	loginFromServer : function(onOk, onFail)
	{
		this.account.callMethod("loginFromServer", [APP.PORTAL_AUTH_TOKEN], function(fpc)
		{
			PortalService.assignSession(fpc.portalsessionid);
			onOk(fpc);
		}, onFail);
	},
	
	logout: function(callback)
	{
		var completed = function(data, proxy)
		{
			var xhr = proxy.xhr;
			//PortalService.assignSession(xhr.getResponseHeader('X-Session-Id'));
			
			APP.PORTAL_AUTH_TOKEN = null;
			Session.set('portalAccount', null);
			
			if (typeof callback == 'function') 
			{
				callback();
			}
		}
		
		PortalService.account.callMethod('logout', [], completed, completed);
	},
	
	ping: function(server)
	{
		if (server)
		{
			var url = PortalService.getUrl("/bridge?service=ping");
			$.post(url, { server : server });
		}
		PortalService.account.callMethod('ping', []);
	},
	
	enterGame: function(server, success, error)
	{
		if (!server) return;
		
		success = success || function(){};
		error = error || function(){};
	
		//PortalService.account.callMethod("enterGame", [server.id, APP.PORTAL_AUTH_TOKEN, MATHelper.DEVICE_ID], 
		PortalService.account.callMethod("enterGame", [server.id, MATHelper.getDeviceId(), ''],
			function(response)
			{
				if (typeof response != "string") 
				{
					return error(response);
				}

				var url = response.split("?")[0];
				APP.changeGameServer(server, url);
				
				Service.switchTo(url);
				
				Service.user.callMethod('login', [APP.PORTAL_AUTH_TOKEN],
					function(response)
					{
						console.debug('LOGIN OK ' + url);
						success(response);
					},
					function(response)
					{
						error(response);
						console.error('LOGIN ERROR ' + url + ' ' + APP.PORTAL_AUTH_TOKEN + ' ' + JSON.stringify(response));
					}
				);
			}, 
			function(response)
			{
				console.error('ENTER GAME ERROR: ' + JSON.stringify(response));
				error(response);
			}
		);
	},
}

PortalService.services = [PortalService.account, PortalService.admin, PortalService.spam];

var Service =
{
	url : "",

	kingdom : new AmfProxy("kingdomService"),
	city : new AmfProxy("cityService"),
	market : new AmfProxy("marketService"),
	mission : new AmfProxy("missionService"),
	mail : new AmfProxy("mailService"),
	alliance : new AmfProxy("allianceService"),
	ban : new AmfProxy("banService"),
	user : new AmfProxy("userService"),
	quest : new AmfProxy("questService"),
	hero : new AmfProxy("heroService"),

	admin : new AmfProxy("adminService"),
	stat : new AmfProxy("statisticsService"),
	debug : new AmfProxy("debugService"),

	services : [],

	switchTo : function(url)
	{
		if (url && url.length > 0)
		{
			this.url = url;

			for (var i = 0; i < this.services.length; i++)
			{
				this.services[i].reconnectTo(url);
			}
		}
	},

	goToPortal : function()
	{
		APP.stopBackgroundMusic();
		APP.navigate("index.html");
	},

	getConfig : function(callback)
	{
		//ajaxInit();
		$.get(Service.getUrl("/config?type=mobile"), function(data)
		{
			data = responsePostProcessing(data, true);
			callback(data);
		}, 'json').error(function(){
			
			processLostConnection(function(){
				Service.getConfig(callback);
			});
			
		});
	},

	ping : function()
	{
		PortalService.ping(Service.getUrl());
	},

	getUrl : function(relative)
	{
		var url = this.url;
		if (!url) return '';
		if (typeof relative == 'undefined') relative = '';
		while (url.charAt(url.length-1) == '/') url = url.substring(0, url.length-1);
		if (relative && relative.charAt(0) != '/') relative = '/' + relative;
		if (relative == '/') relative = '';
		return url + relative;
	},
	
	logout: function()
	{
		Session.clear();
		Service.user.callMethod("logout", null, Service.goToPortal, Service.goToPortal);
	},

}

Service.services = [Service.kingdom, Service.city, Service.market, Service.mission, Service.mail, Service.alliance, Service.ban, Service.user, Service.quest, Service.hero, Service.admin, Service.stat, Service.debug];
