function Arithmetical()
{
	this.cacheProps();
}

Arithmetical.prototype.supportedProps = [];

Arithmetical.prototype.copy = function() 
{
    var res = $.extend({}, this);
    return res;
}

Arithmetical.prototype.add = function(value)
{
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
    	this[prop] += value[prop] || 0;
    }
}




Arithmetical.prototype.subtract = function(value, dieIfNegative) 
{

	if (typeof dieIfNegative == 'undefined') dieIfNegative = true;
    var hasNegative = true;
    for (var i = 0; i<this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        this[prop] -= value[prop];
        if (dieIfNegative && this[prop] < 0) 
        {
            hasNegative = false;
        }
    }
    if (dieIfNegative && !hasNegative) 
    {
        throw new Error("Trying to substract more than we have");
    }
}

Arithmetical.prototype.addCopy = function(value)
{
    var res = this.copy();
    res.add(value);
    return res;
}

Arithmetical.prototype.substractCopy = function(value, shouldBePositive)
{
	if (typeof shouldBePositive == 'undefined') shouldBePositive = true;
    var res = this.copy();
    res.subtract(value, shouldBePositive);
    return res;
}

Arithmetical.prototype.substractOrZeroCopy = function(value)
{
    var res = this.createThis();
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        res[prop] = this[prop] - value[prop];
        if(res[prop] < 0) res[prop] = 0;
    }
    return res;
}

Arithmetical.prototype.multiply = function(value)
{
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        this[prop] *= value;
    }
}

Arithmetical.prototype.multiplyCopy = function(value)
{
    var res = this.copy();
    res.multiply(value);
    return res;
}

Arithmetical.prototype.extract = function(value)
{
    var res = this.createThis();
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        var amount = value[prop];
        var available = this[prop];
        if (available < amount) 
        {
            res[prop] = available;
            this[prop] = 0;
        } 
        else 
        {
            res[prop] = amount;
            this[prop] = available - amount;
        }
        if (this[prop] < 0) 
        {
            throw new Error('shouldNeverReachHere');
            //Errors.shouldNeverReachHere();
        }
    }
    return res;
}

Arithmetical.prototype.greaterOrEqualsTo = function(value)
{
    if(!value) return false;
    
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        if (!NumberUtils.greaterThanOrEqualsTo(this[prop], value[prop])) 
        {
            return false;
        }
    }
    return true;
}

Arithmetical.prototype.limitByCopy = function(value)
{
    var res = this.copy();
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        res[prop] = Math.min(this[prop], value[prop]);
    }
    return res;
}

Arithmetical.prototype.isZero = function()
{
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        if (this[prop] != 0 && !isNaN(this[prop])) 
        {
            return false;
        }
    }
    return true;
}

Arithmetical.prototype.ceil = function() 
{
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        this[prop] = NumberUtils.ceil(this[prop]);
    }
    return this;
}

Arithmetical.prototype.floor = function() 
{
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        this[prop] = NumberUtils.floor(this[prop]);
    }
    return this;
}

Arithmetical.prototype.sum = function()
{
    var result = 0;
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        result += this[prop];
    }
    return result;
}

Arithmetical.prototype.absLowerThan = function(value)
{
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        if (NumberUtils.greaterThanOrEqualsTo(Math.abs(this[prop]), value)) 
        {
            return false;
        }
    }
    return true;
}

Arithmetical.prototype.equals = function(value) 
{
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        if (!NumberUtils.equals(this[prop], value[prop])) 
        {
            return false;
        }
    }
    return true;
}

Arithmetical.prototype.toString = function() 
{
    var res = "";
    for (var i = 0; i < this.supportedProps.length; i++)
    {
    	var prop = this.supportedProps[i];
        if (NumberUtils.greaterThan(Math.abs(this[prop]), 0)) 
        {
            res += this.propertyToString(prop) + " " + prop + " ";
        }
    }
    return res;
}

Arithmetical.prototype.propertyToString = function(prop) 
{
    return this[prop] + '';
}

Arithmetical.prototype.cacheProps = function() 
{
    this.supportedProps = [];
    return this.supportedProps;
},

Arithmetical.prototype.isSupported = function(prop)
{
    return true;
}

Arithmetical.prototype.createThis = function()
{
    var ret = this.multiplyCopy(0);
    return ret;
}
