function ArrayCollection(data)
{
	this.data = data ? data : [];
}

ArrayCollection.prototype.__CLS__ = "ArrayCollection";
ArrayCollection.prototype.__dataType__ = null;
ArrayCollection.prototype.toArray = function(){ return this.data; };

//-----------------------------------------------------------------------------
// Upgrade native Array to ArrayCollection
//-----------------------------------------------------------------------------

//Добавляет список элементов к текущему списку, помещая их в конце списка в порядке передачи.
Array.prototype.addAll = function(addList)
{
	return this.addAllAt(addList, this.length);
};

//Добавляет список элементов к текущему списку, помещая их в позиции индекса, передаваемого в функцию.
Array.prototype.addAllAt = function(addList, index)
{
	addList = addList || [];
	index = index*1;
	
	for (var i = 0; i < addList.length; i++)
	{
		this.addItemAt(addList[i], index + i);
	}
};

//Добавляет указанный элемент в конец списка.
Array.prototype.addItem = function(item)
{
	this.addItemAt(item, this.length);
};

//Добавляет элемент в заданный индекс.
Array.prototype.addItemAt = function(item, index)
{
	this.splice(index, 0, item);
};

//Возвращает значение, определяющее, содержит ли данное представление указанный объект.
Array.prototype.contains = function(item)
{
	return (this.getItemIndex(item) >= 0);
};

Array.prototype.getItemAt = function(index)
{
	index = index*1;
	if (index < 0 || index >= this.length) return null;
	return this[index];
};

//Возвращает индекс элемента, если он находится в списке, где, например getItemAt(индекс) == элемент.
Array.prototype.getItemIndex = function(item)
{
	for (var i = 0; i < this.length; i++)
	{
		if (item === this[i]) return i;
	}
	return -1;
};

//Удаляет все элементы из списка.
Array.prototype.removeAll = function()
{
	return this.splice(0, this.length);
};

//Удаляет элемент в указанной позиции индекса и возвращает его.
Array.prototype.removeItemAt = function(index)
{
	return (this.splice(index*1, 1) || []).shift();
};

Array.prototype.setItemAt = function(item, index)
{
	return (this.splice(index*1, 1, item) || []).shift();
};

Array.prototype.toArray = function(){ return this; };
