var Effects = {}

// TODO: EFFECTS: move consts to Style class or css
Effects.RED = '#e7baa9';
Effects.DARK_RED = '#a53b13';
Effects.GREEN = '#d1d7ab';
Effects.YELLOW = '#FFFF00';
Effects.BLUE = '#000099';
Effects.ORANGE = '#edca8f';
Effects.WHITE = '#ffffff';
Effects.BLACK = '#000000';
Effects.LIGHT_ORANGE = '#ffe0c0';
Effects.LIGHT_GREEN = '#AAFFAA';
Effects.DARK_GREEN = '#378b39';
Effects.LIGHT_RED = '#FFAAAA';
Effects.SUPER_LIGHT_RED = '#fedcdb';
Effects.SUPER_LIGHT_GREEN = '#ddffde';          
Effects.SUPER_LIGHT_ORANGE = '#ffe8d8';
Effects.BROWN = '#ffe84b';
Effects.GREY = '#dddddd';
Effects.DARK_GREY = '#e1d3b8';
Effects.PURPLE = '#D090F5';

Effects.ENEMY = '#a7dcff';
Effects.ALLY = '#ffff00';
Effects.BETRAYER = '#FF5555';

Effects.RATING_YELLOW = '#ffe102';
Effects.RATING_ORANGE = '#ffb164';
Effects.RATING_GREY = '#e2dbcb';

Effects.GREYSCALE_MATRIX = [0.212671,0.715160,0.072169,0,0,0.212671,0.715160,0.072169,0,0,0.212671,0.715160,0.072169,0,0,0,0,0,1,0];

Effects.tintRed = function(t, amount) 
{
	if (typeof amount == 'undefined') amount = 0.3;
    Effects.tint(Effects.RED, amount, t);
}
Effects.tintGreen = function(t, amount) {
	if (typeof amount == 'undefined') amount = 0.3;
    Effects.tint(Effects.GREEN, amount, t);
}

Effects.darken = function(t, amount) 
{
	if (typeof amount == 'undefined') amount = 0.3;
    Effects.tint(Effects.BLACK, amount, t);
}

Effects.brighten = function(t, amount) 
{
	if (typeof amount == 'undefined') amount = 0.3;
    Effects.tint(Effects.WHITE, amount, t);
}

Effects.removeTint = function(c) 
{
    // TODO: EFFECTS: implement with CSS 
    //c.transform.colorTransform = new ColorTransform(1, 1, 1, c.alpha, 0, 0, 0, 0);
}

Effects.tint = function(color, amount, target) 
{
    // TODO: EFFECTS: implement with CSS 
    /* 
    var multiplier = 1 - amount;

    var red = color >> 16;
    var green = (color ^ (red << 16)) >> 8;
    var blue = (color ^ (red << 16)) ^ (green << 8);

    target.transform.colorTransform = new ColorTransform(
            multiplier, multiplier, multiplier, target.alpha,
            red * amount, green * amount, blue * amount, 0);
    */
}

Effects.shadow = function(c, color, strength, distance, angle) 
{
    // TODO: EFFECTS: implement with CSS 
	if (typeof color == 'undefined') color = 0;
	if (typeof strength == 'undefined') strength = 3;
	if (typeof distance == 'undefined') distance = 0;
	if (typeof angle == 'undefined') angle = 0;
	
	/*
	removeShadow(c);
	
    var f:DropShadowFilter = new DropShadowFilter();
    f.strength = strength;
    f.distance = distance;
    f.angle = angle;
    f.color = color;
    addFilter(c, f);
    */ 
}

Effects.removeShadow = function(c) 
{
    // TODO: EFFECTS: implement with CSS 
    //removeFilter(c, DropShadowFilter);
}

Effects.greyScale = function(c) 
{
    // TODO: EFFECTS: implement with CSS or canvas? 
	//removeGreyScale(c);
    //addFilter(c, new ColorMatrixFilter(GREYSCALE_MATRIX));
}

Effects.greyScaleColored = function(c) 
{
    // TODO: EFFECTS: implement with CSS or canvas? 
	/*
	removeGreyScale(c);

    addFilter(c,
        new ColorMatrixFilter([
            1, 0, 0, 0, 0,
            0, 1, 0, 0, 0,
            0, 0, 1, 0, 0,
            0, 0, 0, 0.5, 0
        ]));
    */
}

Effects.blueScaleColored = function(c) 
{
    // TODO: EFFECTS: implement with CSS or canvas? 
	/*
	removeGreyScale(c);

    addFilter(c,
        new ColorMatrixFilter([
            1, 0, -0.4, 0, 0,
            0, 1, -0.4, 0, 0,
            0, 0, 1, 0, 0,
            0, 0, 0, 1, 0
        ]));
    */
}

Effects.removeGreyScale = function(c) 
{
    // TODO: EFFECTS: implement with CSS or canvas? 
	//removeFilter(c, ColorMatrixFilter);
}

Effects.pearlServiceActive = function(obj, flag)
{
	$(obj['DOM'] || obj).toggleClass('pearl-service-active', (typeof flag == 'undefined') ? true : !!flag);
}

Effects.glow = function(c, doHighlight, strength, color) 
{
    // TODO: EFFECTS: implement with CSS or canvas? 
	if (typeof doHighlight == 'undefined') doHighlight = true;
	if (typeof strength == 'undefined') strength = 2;
	if (typeof color == 'undefined') color = Effects.BLUE;
    /*
    removeFilter(c, GlowFilter);
	if (doHighlight) {
		var glow:GlowFilter = new GlowFilter(color, 1, 20, 20, strength, BitmapFilterQuality.HIGH);
        addFilter(c, glow);
	}
	*/
}

Effects.addFilter = function(c, f) 
{
    // TODO: EFFECTS: AS3 only. Remove it 
    /*
    var filters = c.filters;
    filters.push(f); 
    c.filters = filters; // apply filters (don't remove reassigning)
    */
}

Effects.removeFilter = function(c, clazz) 
{
    // TODO: EFFECTS: AS3 only. Remove it 
    /*
    var filters = c.filters;
    for (var i = filters.length - 1; i >= 0; i--) {
        if (filters[i] is clazz) {
            Arrays.removeByIndex(filters, i);
        }
    }
    c.filters = filters; // apply filters (don't remove reassigning)
    */
}

Effects.createChargedScienceEffect = function() 
{
    return Effects.createBlinkingEffect(Effects.GREEN);
}

Effects.createBlinkingEffect = function(color) 
{
    // TODO: EFFECTS: implement with CSS+jQuery
    /*
    var sequence:Sequence = new Sequence();
    var duration = 1000;
    var chargedScienceEffectIn:Dissolve = new Dissolve();
    chargedScienceEffectIn.alphaFrom = 1.0;
    chargedScienceEffectIn.alphaTo = 0.5;
    chargedScienceEffectIn.duration = duration;
    chargedScienceEffectIn.color = color;

    var chargedScienceEffectOut:Dissolve = new Dissolve();
    chargedScienceEffectOut.alphaFrom = 0.5;
    chargedScienceEffectOut.alphaTo = 1.0;
    chargedScienceEffectOut.duration = duration;
    chargedScienceEffectOut.color = color;

    sequence.addChild(chargedScienceEffectIn);
    sequence.addChild(chargedScienceEffectOut);
    sequence.repeatCount = 0;
    return sequence;
    */
}

Effects.createBlinkingEffect2 = function(color) 
{
    // TODO: EFFECTS: implement with CSS+jQuery
    /*
    var sequence:Sequence = new Sequence();
    var chargedScienceEffect1:Dissolve = new Dissolve();
    chargedScienceEffect1.alphaFrom = 1.0;
    chargedScienceEffect1.alphaTo = 0.5;
    chargedScienceEffect1.duration = 500;
    chargedScienceEffect1.color = color;

    var chargedScienceEffect2:Dissolve = new Dissolve();
    chargedScienceEffect2.alphaFrom = 0.5;
    chargedScienceEffect2.alphaTo = 1.0;
    chargedScienceEffect2.duration = 500;
    chargedScienceEffect2.color = color;

    sequence.addChild(chargedScienceEffect1);
    sequence.addChild(chargedScienceEffect2);

    sequence.repeatCount = 0;
    return sequence;
    */
}

Effects.tintGreenAndGlow = function(t, value) 
{
	if (typeof value == 'undefined') value = true;
    if (value) 
    {
        Effects.tintGreen(t);
    } 
    else 
    {
        Effects.removeTint(t);
    }
    Effects.glow(t, value, 1.2, Effects.GREEN);
}

Effects.coloredText = function(text, color) 
{
    return "<span style='color:'#" + Number(color).toString(16) + ";'>" + text + "</span>";
}

Effects.moveTo = function(component, x, y, duration, onComplete, easingFunction) 
{
    // TODO: EFFECTS: implement with CSS+jQuery
    /*
    var move:Move = new Move();
    move.xTo = x;
    move.yTo = y;
    move.duration = duration;
    if (onComplete) {
        move.addEventListener(EffectEvent.EFFECT_END, function (e) {
            onComplete();
        });
    }
    move.easingFunction = easingFunction;
    move.play([component]);
    return move;
    */
}
