function Texts()
{
	
};
	
Texts.t = function(key/*:String*/)
{
    if (FConfig.clientTexts.containsKey(key)) 
    {
        return FConfig.clientTexts.getValue(key);
    }
	return "{" + key + "}";
}
   
Texts.skillName = function(slotName/*:String*/)
{
	return Texts.spellName(slotName);
}
   
Texts.spellName = function(name/*:String*/)
{
	return name == null ? "?" : Texts.t("SPELL_" + name + "_NAME");
}

Texts.artifactSetName = function(name/*:String*/)
{
    return name == null ? "?" : Texts.t("SET_" + name + "_NAME");
}

Texts.crystalName = function(name/*:String*/)
{
    return Texts.spellName(name);
}

Texts.runeName = function(rune)
{
    return Texts.t(rune.toUpperCase() + "_NAME");
}

Texts.artifactName = function(decl/*:ArtifactDeclaration*/)
{
    switch (decl.type) 
    {
        case ArtifactType.SCROLL: return I18.f("SCROLL_NAME") + "  " + Texts.spellName(decl.spell); 
		case ArtifactType.MANA_BOTTLE: return Texts.t("SPELL_ELEKSIR_MANI_NAME");
		case ArtifactType.EXP_BOTTLE: return Texts.t("SPELL_ELEKSIR_OPITA_NAME");
		case ArtifactType.ARTIFACT: return Texts.t("ARTIFACT_" + decl.name.toUpperCase());
		case ArtifactType.RUNE: return Texts.runeName(decl.name);
    	case ArtifactType.CRYSTAL: return Texts.crystalName(decl.name);
	}
    throw new Error("Cannot find name for artifact: " + decl.name);
}

Texts.artifactTypeNameLvl = function(type/*:ArtifactType*/, level/*:int*/)
{
    var r = "unknown";
	if (ArtifactType.SCROLL.equals(type)) 
	{
	    r = I18.f("SCROLL_NAME") + "  " + " " + I18.f("LVL_X",level);
	} 
	else if (ArtifactType.MANA_BOTTLE.equals(type)) 
	{
	    r = t("SPELL_ELEKSIR_MANI_NAME");
	} 
	else if (ArtifactType.EXP_BOTTLE.equals(type)) 
	{
	    r = t("SPELL_ELEKSIR_OPITA_NAME");
	} 
	else if (ArtifactType.ARTIFACT.equals(type)) 
	{
	    r = I18.f("ARTIFACT_NAME") + "  " + " " + I18.f("LVL_X",level);
	} 
	else if (ArtifactType.CRYSTAL.equals(type)) 
	{
	    r = I18.f("CRYSTALS");
	} 
	else 
	{
    	throw new Error("Cannot find name for artifact type: " + type);
    }
    return r;
}

Texts.artifactNameLvl = function(decl/*:ArtifactDeclaration*/)
{
    return Texts.artifactName(decl) + " " + I18.f("LVL_X",decl.level);
}