function Ticker(delay, onTick)
{
	var timer;
	var lastUpdateTick = 0;
	var _started = false;
	var onTick = onTick;

	this.update = function()
	{
		var t = Tick.now();
		onTick(t - lastUpdateTick);
		lastUpdateTick = t;
	}

	this.start = function()
	{
		timer = setInterval(this.update, delay);
		lastUpdateTick = Tick.now();
		_started = true;
	}

	this.stop = function()
	{
		clearInterval(timer);
		_started = false;
	}

	this.__defineGetter__("started", function()
	{
		return _started;
	});

	this.pause = function()
	{
		clearInterval(timer);
		_started = true;
	}
};