function EspionageResultDialog()
{
	callParentConstructor(EspionageResultDialog.prototype, this);
	
	this.spyAccessLevel = 0;
}

extendClass(EspionageResultDialog.prototype, Dialog.prototype);

EspionageResultDialog.prototype.__construct = function()
{
	COM(this.spiesView).utype = UnitType.SPY;
	COM(this.antispiesView).utype = UnitType.ANTISPY;
}

EspionageResultDialog.prototype.popup = function(parent, result)
{
    superMethod(EspionageResultDialog.prototype, "popup", this)();
    
    this.spyAccessLevel = result.spyAccessLevel;
    
    var estate = result.estate;
    COM(this.spiesView).race = FUser.CURRENT_USER.race;
    COM(this.antispiesView).race = estate.owner.race;

    var cityNameAndLocation = estate.getNameAndLocation();
    if (result.antispiesPresent)
    {
        this.actionDescription.innerHTML = I18.f("ESPIONAGE_BATTLE", cityNameAndLocation);
    }
    else
    {
        this.actionDescription.innerHTML = I18.f("ESPIONAGE_BATTLE_NO_ANTISPIES", cityNameAndLocation);
    }
    if (estate.accessInsideView)
    {
        this.accessDescription.innerHTML = I18.f("ESPIONAGE_SUCCESS", result.spyAccessLevel);
        this.accessLevel.innerHTML = result.spyAccessLevel.toString();
    }
    else
    {
        this.accessDescription.innerHTML = I18.f("ESPIONAGE_FAILURE");
        UI.show(false, [this.accessLevel, this.acccessText]);
    }

    COM(this.spiesView).update(1, result.spiesKilled, -1);
    COM(this.spiesView).setInitialKilledPresent(result.spiesTotal, result.spiesKilled);

    if (result.antispiesPresent)
    {
        COM(this.antispiesView).update(1, result.antispiesKilled, -1);
        COM(this.antispiesView).setInitialKilledPresent(result.antispiesTotal != 0 ? result.antispiesTotal : -1, result.antispiesKilled);
    }
    else
    {
        COM(this.antispiesView).showUnitBackIfZero = true;
        COM(this.antispiesView).update(1, 0, -1);
    }
}

EspionageResultDialog.prototype.getAccessLevelTooltip = function(e)
{
    //e.toolTip = Tip.create(I18h.getSpyLevelDescription(spyAccessLevel));
}