function ObservationResultDialog()
{
	callParentConstructor(ObservationResultDialog.prototype, this);
	
	this._ownerRace = null;
    this._userRace = null;
}

extendClass(ObservationResultDialog.prototype, Dialog.prototype);

ObservationResultDialog.prototype.__construct = function()
{
	//COM.bindExclusiveClick(this.okButton, $.proxy(this.close, this));
	
	var ut = COM(this.prophetsView);
	ut.utype = UnitType.PROPHET;
	ut.showZero = true;
	ut.showCount = true;
	
	var ut = COM(this.mirrorsView);
	ut.utype = UnitType.MIRROR;
	ut.showZero = true;
	ut.showCount = true;
}

ObservationResultDialog.prototype.popup = function(parent, result, userRace)
{
    superMethod(ObservationResultDialog.prototype, "popup", this)();
    
    this.onClose = function()
    {
        //COM.create("MissionListDialog").showObservationResult(result);
        MissionListDialog.showObservationResult(result);
    };
    
    var target = result.target;
    this._ownerRace = result.targetOwner.race;
    this._userRace = userRace;
    
    COM(this.prophetsView).race = this._userRace;
    COM(this.mirrorsView).race = this._ownerRace;
    
    if (result.mirrorsPresent)
    {
        this.actionDescription.innerHTML = I18.f("PROPHETS_BATTLE", target.toString());
    }
    else
    {
        this.actionDescription.innerHTML = I18.f("PROPHETS_BATTLE_NO_MIRRORS", target.toString());
    }
    this.accessDescription.innerHTML = result.isSuccess ? I18.f("OBSERVATION_SUCCESS") : I18.f("OBSERVATION_FAILURE");

    COM(this.prophetsView).update(1, result.prophetsKilled, -1);
    COM(this.prophetsView).setInitialKilledPresent(result.prophetsTotal, result.prophetsKilled);

    if (result.mirrorsPresent)
    {
        COM(this.mirrorsView).update(1, result.mirrorsKilled, -1);
        COM(this.mirrorsView).setInitialKilledPresent(-1, result.mirrorsKilled);
    }
    else
    {
        COM(this.mirrorsView).showUnitBackIfZero = true;
        COM(this.mirrorsView).update(1, 0, -1);
    }
}