function AllianceConstraints()
{
	
}

AllianceConstraints.PROPOSE_ALLIANCE_ROUTINES = 
{
	template: function(estate, allies, username)
	{
	    return CheckResult.success();   // do nothing
	},
	
	checkAlliancesCapacity: function(estate, allies, ignoreMeToo)
	{
	    var capacity = estate.owner.getScienceValue(Science.DIPLOMACY);
	    return allies.length == capacity 
	    	? CheckResult.fail(I18.f('ALLIANCE_ERROR_CAPACITY_EXCEEDED', capacity)) 
	    	: CheckResult.success()
	    ;
	},
	
	checkAllianceExists: function(ignore, allies, username)
	{
	    for (var i = 0, len = allies.length; i < len; i++) 
	    {
	    	var ally = allies[i];
	        if (ally.user.username.toLowerCase() == username.toLowerCase()) 
	        {
	            return CheckResult.fail(I18.f('ALLIANCE_ERROR_ALREADY_EXISTS'));
	        }
	    }
	    return CheckResult.success();
	},
	
	checkNotMyself: function(estate, ignore, username)
	{
	    return estate.owner.username.toLowerCase() == username.toLowerCase() 
	    	? CheckResult.fail(I18.f('ALLIANCE_ERROR_MYSELF')) 
	    	: CheckResult.success()
	    ;
	}
};

AllianceConstraints.proposeAllianceValid = function(estate, allies, username)
{
	for (var f in AllianceConstraints.PROPOSE_ALLIANCE_ROUTINES) 
	{
		var result = AllianceConstraints.PROPOSE_ALLIANCE_ROUTINES[f](estate, allies, username);
		if (!result.isSuccess) 
		{
			return result;
		}
	}
	return CheckResult.success();
}
