function AllyDetails()
{
	callParentConstructor(this);
	this.__defineGetter__('ally', this.getData);
	this.__defineSetter__('ally', this.setData);
}

extendClass(AllyDetails.prototype, ScrollableListItem.prototype);

AllyDetails.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.sendMailButton, $.proxy(function(){
		if (this.ally) MailBoxView.i().sendMessage(this.ally.user.username);		
	}, this));
	
	COM.bindExclusiveClick(this.editButton, $.proxy(function(){
		if (this.ally) this.onEdit(this, this.ally);		
	}, this));
	
	COM.bindExclusiveClick(this.cancelButton, $.proxy(function(){
		if (this.ally) this.onCancel(this, this.ally);		
	}, this));
}

AllyDetails.ALLY_MODE = 0;
AllyDetails.PROPOSAL_MODE = 1;

AllyDetails.prototype.mode = 0;
AllyDetails.prototype.readOnly = false;
AllyDetails.prototype.isEspionage = false;

AllyDetails.prototype.onCancel = function (view, ally){};

AllyDetails.prototype.onEdit = function (view, ally){};

AllyDetails.prototype.setData = function(value)
{
	this._data = value;
	if (this.ally)
	{
		this.mode = this.ally.isProposedToMe() ? AllyDetails.PROPOSAL_MODE : AllyDetails.ALLY_MODE;
		this.status.src = STATIC_INTERFACE_URL + MailAssets.getAllyStatusIcon(this.ally.status, this.ally.proposedToMe);

		UI.show(!this.readOnly && !this.isEspionage, [this.sendMailButton, this.editButton]);
		UI.show(!this.readOnly && !this.isEspionage && (this.ally.status.name != AllianceStatus.BREAKING.name), [this.cancelButton]);
		if (this.mode == AllyDetails.ALLY_MODE) 
		{
			COM(this.editButton).icon = STATIC_INTERFACE_URL + CommonAssets.CLAN_SETTINGS;
			$(this.editButton).title = I18.f('EDIT');
			$(this.cancelButton).title = (this.ally.status.name == AllianceStatus.PROPOSED.name) 
				? I18.f('CANCEL_ALLIANCE_OFFER') 
				: I18.f('BREAK_ALLIANCE')
			;
		} 
		else 
		{
			COM(this.editButton).icon = STATIC_INTERFACE_URL + CommonAssets.BUTTON_ACCEPT;
			$(this.editButton).title = I18.f('ACCEPT_ALLIANCE_OFFER');
			$(this.cancelButton).title = I18.f('DECLINE_ALLIANCE_OFFER');
		}
		
		var uiFlag = !this.isEspionage && this.ally.status.name == AllianceStatus.BREAKING.name;
		UI.show(uiFlag, [this.breakTimeLabel]);
		
		this.username.innerHTML = this.ally.user.username;
		this.breakTimeLabel.innerHTML = uiFlag ? this.ally.timeLeft : '';
	}
}

AllyDetails.prototype.onTooltip = function(e)
{
    //e.toolTip = EstateStarsClanView.createAsTip(ally.user);
}
