function FDiplomacy()
{
	this.__defineGetter__('isMentor', function(){ 
		return this.mentorLevel > 0;
	});
	
	this.__defineGetter__('allApprenticeCount', function(){
		return this.apprentices.length + this.apprenticeInvitations.length + this.rejectedApprenticeInvitations.length;
	});
}

FDiplomacy.prototype.myDeputy = null; // FDeputy
FDiplomacy.prototype.deputyOf = null; // FDeputy
FDiplomacy.prototype.allies = null; // ArrayCollection // FAlly[]
FDiplomacy.prototype.clan = null; // FClan
FDiplomacy.prototype.clanInvitations = null; // ArrayCollection // FClanInvitation[]
FDiplomacy.prototype.accessEstatesForClan = false; // Boolean
FDiplomacy.prototype.accessMissionsForClan = false; // Boolean
FDiplomacy.prototype.heroesForRedemption = null; // ArrayCollection// FHero[]
FDiplomacy.prototype.mentorLevel = 0; // int
FDiplomacy.prototype.mentorCapacity = 0; // int
FDiplomacy.prototype.releasedApprentices = 0; // int
FDiplomacy.prototype.currentMentor = null; // String
FDiplomacy.prototype.apprenticeInvitations = null; // ArrayCollection // FApprentice[]
FDiplomacy.prototype.rejectedApprenticeInvitations = null; // ArrayCollection // FApprentice[]
FDiplomacy.prototype.apprentices = null; // ArrayCollection // FApprentice[]
FDiplomacy.prototype.canBecomeApprentice = false; // Boolean
FDiplomacy.prototype.invitationQuestionTillTick = 0; // Number
FDiplomacy.prototype.invitationQuestionClanName = ''; // String
FDiplomacy.prototype.friends = null; // ArrayCollection // FFriend[]
FDiplomacy.prototype.helpers = null; // FMap // <String, Boolean> username -> rewardTaken of friends who help this user
FDiplomacy.prototype.userHelpedCount = 0; // int


FDiplomacy.prototype.hasActiveAlliances = function()
{
    for (var i = 0, len = this.allies.length; i < len; i++) 
    {
        if (this.allies[i].isActive()) 
        {
            return true;
        }
    }
    return false;
}

FDiplomacy.prototype.canBeDeputyOfMine = function(username)
{
    for (var i = 0, len = this.allies.length; i < len; i++) 
    {
        if (this.allies[i].user.username == username) 
        {
            return this.allies[i].canBeDeputyOfMine;
        }
    }
    return true;// used when username=""
}

FDiplomacy.prototype.getAlly = function(allyName)
{
    for (var i = 0, len = this.allies.length; i < len; i++) 
    {
        if (FUser.isSameName(this.allies[i].user.username, allyName)) 
        {
            return this.allies[i];
        }
    }
    return null;
}

FDiplomacy.prototype.hasAlly = function(allyName)
{
    return this.getAlly(allyName) != null;
}

FDiplomacy.prototype.getFriend = function(name)
{
    if (this.friends) 
    {
	    for (var i = 0, len = this.friends.length; i < len; i++) 
	    {
	        if (FUser.isSameName(this.friends[i].user.username, name)) 
	        {
	            return this.friends[i];
	        }
	    }
    }
    return null;
}

FDiplomacy.prototype.hasFriend = function(name)
{
    return this.getFriend(name) != null;
}
