function BuyCalculationsDialog()
{
	callParentConstructor(BuyCalculationsDialog.prototype, this);
	
	this.updateCalculationsLeft = $.proxy(this.updateCalculationsLeft, this);
}

extendClass(BuyCalculationsDialog.prototype, Dialog.prototype);

BuyCalculationsDialog.popup = function(parent)
{
    var c = COM.create("BuyCalculationsDialog");
    c.popup(parent);
}

BuyCalculationsDialog.prototype.__construct = function()
{
    this.setCaption(I18.f("ANCIENT_MAGIC_NAME"));
    
    var items = ServiceHelper.getGlobalServiceItems(ServiceDecl.BUY_CALCULATIONS);
    var countArray = [];
    
    for(var i=0; i<items.length; i++)
    {
    	countArray.push(items[i].label);
    }
    
    COM(this.countCombo).dataProvider = countArray;
    COM(this.countCombo).selectedIndex = 0;
    $(this.countCombo).on("change", $.proxy(this.onChangeCount, this));
    COM.bindExclusiveClick(this.yesButton, $.proxy(this.buyCalculations, this));
    Events.onFUserUpdated.add(this, this.updateCalculationsLeft);
    this.updateCalculationsLeft(FUser.CURRENT_USER);
}

BuyCalculationsDialog.prototype.onClose = function()
{
    Events.onFUserUpdated.remove(this, this.updateCalculationsLeft);
}

BuyCalculationsDialog.prototype.onChangeCount = function()
{
    var price = ServiceHelper.getGloabalServiceDecl(ServiceDecl.BUY_CALCULATIONS, COM(this.countCombo).selectedIndex).price;
    COM(this.priceLabel).update(price);
    COM(this.yesButton).reason = FUser.CURRENT_USER.pearl >= price ? "" : I18.f("NOT_ENOUGH_PEARL");
}

BuyCalculationsDialog.prototype.updateCalculationsLeft = function(u)
{
    var calculations = u.servicesValues.getValueOrNull(ServiceDecl.BUY_CALCULATIONS);
    if (!calculations)
    {
        calculations = 0;
    }
    this.countLeft.innerHTML = I18.f("CALCULATIONS_LEFT", calculations);
    this.onChangeCount();
}

BuyCalculationsDialog.prototype.buyCalculations = function()
{
    if (!Quarantine.contains(this))
    {
        Quarantine.put(this);
		
        var estateId = null;
        var mediator = APP.getCurrentMediator();
        if (mediator == APP.getCityMediator())
        {
            var estate = mediator.estate;
            estateId = !estate || estate.isEspionage ? null : estate.id;
        }

        ServiceHelper.orderGlobalService(ServiceDecl.BUY_CALCULATIONS, COM(this.countCombo).selectedIndex, null, estateId, $.proxy(this.close, this), null);
    }
}