function CalcTowerView()
{
	this.onRemove = function(){};
    this.onDecrease = function(){};

    this.btype = null;
    this.level = null;
    this.count = null;
    this.isPerfect = false;
    
    this._count = 0;
    this.__defineGetter__("count", function()
    {
    	return this._count;
    });
    this.__defineSetter__("count", function(val)
    {
    	this._count = val;
    	this.countChanged();
    });
}

CalcTowerView.MAX_COUNT = 50;

CalcTowerView.create = function(btype, level, onRemove, onDecrease)
{
    var c = COM.create("CalcTowerView");
    c.btype = btype;
    c.level = level;
    c.count = 1;
    if(typeof onRemove != "undefined")
    {
    	c.onRemove = onRemove;
    }
    if(typeof onDecrease != "undefined")
    {
    	c.onDecrease = onDecrease;
    }
    c.isPerfect = CalcTowerView.isPerfect(btype, level);
    c.init();
    return c;
}

CalcTowerView.isPerfect = function(btype, level)
{
    var levels = btype.getParams(FUser.CURRENT_USER.race).levels;
    if (levels && levels.length > level)
    {
        return levels[level].perfect;
    }
    return false;
}

CalcTowerView.prototype.init = function()
{
    this.btypeImage.src = STATIC_URL + CommonAssets[this.btype.name];
    if(this.isPerfect)
    {
    	this.levelLabel.style.display = "none";
    	this.crystalSign.style.display = "";
    }
    else
    {
    	this.crystalSign.style.display = "none";
    	this.levelLabel.style.display = "";
    	this.levelLabel.innerHTML = this.level.toString();
    }
    
    $(this.DOM).on(MOUSE_UP_EVENT, $.proxy(this.decreaseCount, this));
}

CalcTowerView.prototype.matches = function(btype, level)
{
    return this.btype == btype && this.level == level;
}

CalcTowerView.prototype.increaseCount = function(cnt)
{
    if(typeof cnt == "undefined")
    {
    	cnt = 1;
    }
    
    this.count += cnt;
    if(this.count > CalcTowerView.MAX_COUNT) this.count = CalcTowerView.MAX_COUNT;
    this.countChanged();
}

CalcTowerView.prototype.decreaseCount = function()
{
    this.count--;
    this.onDecrease(this);
    this.countChanged();
}

CalcTowerView.prototype.countChanged = function()
{
    this.countLabel.innerHTML = "x" + this.count.toString();
    if(this.count < 0)
    {
    	this.count = 0;
    }
    if (this.count == 0)
    {
        this.onRemove(this);
    }
}
