function CombatResultView()
{
	callParentConstructor(CombatResultView.prototype, this);
	
	this.canSave = false;
}

extendClass(CombatResultView.prototype, Dialog.prototype);

CombatResultView.popup = function(parent, message, canSave)
{
    var d = COM.create("CombatResultView");
    d.canSave = canSave;
    
    var box = COM.create("CombatResultBox");
    box.message = message;
    box.showAsCalculatorReport = true;
    box.createChildren();
    d.resultBox.appendChild(box.DOM);
    COM(d.saveButton).enabled = canSave;
    d.popup(parent);
}

CombatResultView.prototype.__construct = function()
{
	this.setCaption(I18.f("COMBAT_CALCULATOR"));
	
	COM.bindExclusiveClick(this.saveButton, $.proxy(this.saveMessage, this));
	
	this.fullScreen();
}

CombatResultView.prototype.fitLayout = function(container)
{
	superMethod(CombatResultView.prototype, "fitLayout", this)(container);
	
	this.windowWrapper.style.width = this.content.offsetWidth + "px";
	this.windowWrapper.style.height = (this.content.offsetHeight-8) + "px";
	
	this.container.style.width = this.content.offsetWidth + "px";
}

CombatResultView.prototype.onShow = function()
{
	this.scroll = new iScroll(this.container.parentNode, {scrollbarColor: '#784f0b'});
	this.refreshScroll();
}

CombatResultView.prototype.refreshScroll = function()
{
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
}

CombatResultView.prototype.saveMessage = function()
{
    Service.mail.callMethod("saveHiddenCombatReport", [], $.proxy(function()
    {
        Alert.create(I18.f("SAVE_REPORT_SUCCESS"));
        COM(this.saveButton).enabled = false;
        this.canSave = false;
    }, this));
}

CombatResultView.prototype.discardReport = function()
{
    if (this.canSave)
    {
        Service.mail.callMethod("discardHiddenCombatReport");
    }
}