function LevelSwitcher()
{
	this.showZero = false;
	this.showPerfect = false;
	this.level = 0;
	this.maxLevel = 4;
	this.onChange = function (){};
}

LevelSwitcher.prototype.__construct = function()
{
    var attr = $(this.DOM).attr();
    
    this.showZero = (attr['showzero'] ? Boolean(attr['showzero']) : false);
    this.showPerfect = (attr['showperfect'] ? Boolean(attr['showperfect']) : false);
    this.maxLevel = (attr['maxlevel'] ? attr['maxlevel']*1 : 4);
    
    COM(this.levels).onChange = $.proxy(function()
    {
    	this.level = COM(this.levels).value;
    	this.onChange();
    }, this);
    
    this.init();
}

LevelSwitcher.prototype.init = function()
{
	var item;
    var box = COM(this.levels);
    box.clear();
    
    for (var i = 0; i <= this.maxLevel; i++)
    {
        if(i != 0 || this.showZero)
        {
	        item = box.addItem(i, i);
	        if(i == this.maxLevel && this.showPerfect)
	        {
	        	item.caption = "";
	        	item.icon = STATIC_INTERFACE_URL + CommonAssets.CRYSTAL_SIGN_SMALL;
	        }
        }
    }
    
	if(this.showZero)
	{
		box.value = 0;
		this.level = 0;
	}
    else
	{
		box.value = 1;
		this.level = 1;
	}
}

LevelSwitcher.prototype.setLevel = function(val)
{
	this.level = val;
	COM(this.levels).value = val;
}