function ArenaProductionView()
{
	
}

ArenaProductionView.prototype.building = null; // FBuilding
ArenaProductionView.prototype.level = -1;

ArenaProductionView.prototype.update = function(building, level) 
{
    this.building = building;
    this.level = (typeof level == 'undefined') ? -1 : level;
    var production = this.building.getLevel(this.level).expProduction;
    var bonus = this.building.estate.sumOfBuildingBuffs(BuffType.BOOST_BUILDING, this.building.type);
    
    this.levelLabel.innerHTML = this.building.isPerfect(this.level) 
    	? I18.f('PERFECT_BUILDING') 
    	: I18.f('LEVEL_X', this.level >= 0 ? this.level : this.building.level)
    ;
    this.valueLabel.innerHTML = I18.f('PER_TIME', production * (1 + bonus));

	var buffs = building.estate.getBuildingBuffs(BuffType.BOOST_BUILDING, building.type);
	var len = buffs.length;
	this._refreshRows(len + 1); // 1 row always exists
	
    for (var i = 0; i < len; i++) 
    {
        var buff = buffs[i], row = this.productionDetails.children[i + 1];
        row.children[0].innerHTML = I18.getBuffCause(buff);
        row.children[1].innerHTML = I18.percentText(buff.value);
    }
	
}

ArenaProductionView.prototype._refreshRows = function(n)
{
    n = Math.max(1, n*1);
    var len = this.productionDetails.children.length;
    while (n > len)
    {
    	var row = this.productionDetails.children[0].cloneNode();
    	for (var i = 0; i < row.children.length; i++) 
    	{
    		row.children[i].innerHTML = '';
    	}
    	this.productionDetails.appendChild(row);
    	len++;
    }
    while (n < len)
    {
    	this.productionDetails.removeChild(this.productionDetails.children[len-1]);
    	len--;
    }
}
