function BasePeriodicMagicDialog()
{
	callParentConstructor(BasePeriodicMagicDialog.prototype, this);
	
	this.bonusDescriptionLine1 = "";
    this.bonusDescriptionLine2 = "";
    this.bonusDuration = 0;
    this.bonusEffect = "";
    this.bonusPrice = 0;
    this.btype = null;
    this.boostMethod = null;
    this.user = null;
    this.toUpdate = false;
    
    this.scroll = null;
}

extendClass(BasePeriodicMagicDialog.prototype, Dialog.prototype);

BasePeriodicMagicDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.yesButton, $.proxy(function()
	{
		this.doAction();
		this.close();
	}, this));
	
	this.setCaption(I18.f("ANCIENT_MAGIC_NAME").toUpperCase());
	this.boostIcon.src = STATIC_INTERFACE_URL + "shared/science/cheast_icon.png";
	
	$(COM.get(this.priceLabel).text).addClass("text-normal text-middle");
	$(COM.get(this.priceLabel).text).addClass("bold");
	
	COM.get(this.priceLabel).source = STATIC_INTERFACE_URL + "shared/icons/pearl2.png";
	
	//this.noButton.on(CLICK_EVENT, this.close);
	
	this.scroll = new iScroll(this.contentWrapper.parentNode, {scrollbarColor: '#784f0b'});
}

BasePeriodicMagicDialog.prototype.popup = function(parent)
{
    superMethod(BasePeriodicMagicDialog.prototype, "popup", this)();
    
    COM.get(this.bonusTime).value = this.bonusDuration;
    
    this.bonusDescriptionLine1Label.innerHTML = this.bonusDescriptionLine1;
	this.bonusDescriptionLine2Label.innerHTML = this.bonusDescriptionLine2;
	this.bonusEffectLabel.innerHTML = this.bonusEffect;
    
    this.toUpdate = true;
    
    return this;
}

BasePeriodicMagicDialog.prototype.onShow = function()
{
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
}

BasePeriodicMagicDialog.prototype.doAction = function()
{
    if (!Quarantine.contains(this))
    {
        Quarantine.put(this);
        this.boostMethod();
    }
}

BasePeriodicMagicDialog.prototype.updateFromUser = function(owner)
{
    this.user = owner;
    if (this.toUpdate)
    {
        this.tick();
    }
}

BasePeriodicMagicDialog.prototype.update = function(estate)
{
    this.estate = estate;
    this.updateFromUser(estate.owner);
    COM.get(this.obtainPearl).update(estate.owner);
    this.priceLabel.ownerUser = this.user;
}

BasePeriodicMagicDialog.prototype.tick = function()
{
    var canBoost = true;
    this.problemText.innerHTML = "";

    var magicTick = !this.estate ? 0 : this.estate.getMagicActiveTick(this.btype);
    var isBoosted = magicTick >= Tick.now();
    this.infoText.innerHTML = isBoosted ? I18.activeMagicTip(magicTick) : "";
    
    var reason = null;
    if (Tick.now() + FConfig.PEARL_MAX_ADVANCE_DURATION < magicTick)
    {
        canBoost = false;
        //this.problemText.innerHTML = I18.f("PEARL_PAYMENT_REACHED_MAX_ADVANCE");
        reason = I18.f("PEARL_PAYMENT_REACHED_MAX_ADVANCE");
    }
    if (this.user.pearl < this.bonusPrice)
    {
        canBoost = false;
        reason = I18.f("NOT_ENOUGH_PEARL");
    }
    //this.priceLabel.update(this.bonusPrice);
    COM.get(this.priceLabel).value = this.bonusPrice;
    
    COM.get(this.yesButton).caption = isBoosted ? I18.f("PAYMENT_PROLONGATE") : I18.f("ORDER_SERVICE");
    COM.get(this.yesButton).reason = reason;
}