function BuildDialogElement()
{
	this.race = null;
	this.visible = true;
	this.active = true;
	this.selected = false;
	this.btype = null;
}

BuildDialogElement.prototype.race = null;
BuildDialogElement.prototype.visible = true;
BuildDialogElement.prototype.active = true;
BuildDialogElement.prototype.selected = false;
BuildDialogElement.prototype.btype = null;

BuildDialogElement.prototype.init = function(race, onClick)
{
	if(!race) return;
	
	this.race = race;
	this.btype = $(this.DOM).attr("btype");
	
	var src = Assets.B_findByOrNull(this.race, BType[this.btype]);
	
	if(src)
	{
		$(this.image).css({"background-image": "url('" + STATIC_URL + src + "')"});
		this.description.innerHTML = I18.getBuildingName(this.btype, this.race);
		
		$(this.DOM).off(CLICK_EVENT);
		COM.bindExclusiveClick(this.DOM, onClick);
		
		this.updateTint();
	}
	else
	{
		this.DOM.style.display = "none";
	}
};

BuildDialogElement.prototype.select = function(value)
{
    this.selected = value;
    this.updateTint();
}

BuildDialogElement.prototype.setActive = function(value)
{
	this.active = value;
	this.updateTint();
};

BuildDialogElement.prototype.updateTint = function()
{
	//$(this.image).css("-webkit-filter", "grayscale("+(this.active ? 0 : 100)+"%)");
	this.description.style.color = this.active ? "" : "#777";
};

