function BuildQueueView()
{
	callParentConstructor(BuildQueueView.prototype, this);
	
	this.estateId = null;
	this.onRemoveFromQueue = $.proxy(this.onRemoveFromQueue, this);
}

extendClass(BuildQueueView.prototype, Dialog.prototype);

BuildQueueView.prototype.__construct = function()
{
	for (var i = 0; i < this.queueElements.length; i++)
	{
		this.queueWrappers[i].qID = i;
		COM.bindExclusiveClick(this.queueWrappers[i], this.onRemoveFromQueue);
	}
	
	this.setCaption(I18.f("BUILD_QUEUE"));
}

BuildQueueView.prototype.changeState = function(doExpand)
{
    this.DOM.style.display = doExpand ? "" : "none";
}

BuildQueueView.prototype.update = function(estate)
{
    this.estateId = estate.id;
    var view = new BuildingView();
    var src;
    for (var i = 0; i < this.queueElements.length; i++)
    {
        var order = this.getElementOrNull(estate.buildQueue, i);
        var building = order ? estate.getCellByIndex(order.cellIndex).building : null;
        
        src = view.getImage(building, order, estate.race);
        if(src)
        {
        	this.queueWrappers[i].style.display = "";
        	this.queueElements[i].src = STATIC_URL + src;
        	this.queueElementsName[i].innerHTML = I18.getBuildingName(order.type, estate.race);
        }
        else
        {
        	this.queueWrappers[i].style.display = "none";
        }
    }
    
    /*
    toolTip = estate.owner.isBuildQueueEnabled() ? I18.BUILD_QUEUE.f() :
            estate is FCastle ? I18.AVAILABLE_WHEN_STANDARD_ACTIVE.f() : I18.BUILD_QUEUE_ONLY_FOR_PREMIUM.f();
	*/
}

BuildQueueView.prototype.getElementOrNull = function(queue, i)
{
    return queue && i < queue.length ? queue[i] : null;
}

BuildQueueView.prototype.onRemoveFromQueue = function(e)
{
    var index = e.currentTarget.qID*1;
    APP.showLoader();
    Service.city.callMethod("removeFromBuildQueue", [this.estateId, index], function()
    {
        APP.hideLoader();
        Events.onForceCityUpdate.fire();
    });
}