function CastTip()
{
}

CastTip.prototype.__construct = function()
{
}

CastTip.prototype.cast = null; // FCast
CastTip.prototype.doesntWork = null; // Array

CastTip.alert = function(cast, doesntWork, holderIsHero)
{
	var tip = CastTip.create(cast, doesntWork, holderIsHero);
	var caption = I18.f('CAST_CAUSE_' + cast.cause.name + '_NAME');
	var a = TipDialog.create(tip.DOM.outerHTML, caption);
	return a;
}

CastTip.create = function(cast, doesntWork, holderIsHero)
{
    var tip = COM.create('CastTip');
    tip.update(cast, doesntWork, holderIsHero);
    return tip;
}

CastTip.prototype.update = function(cast, doesntWork, holderIsHero)
{
    this.cast = cast;
    this.doesntWork = doesntWork;
    
    this.nameLabel.innerHTML = I18.getCastCause(this.cast);
    
    var caster = htmlEscape(FUser.getUserNameForMessages(this.cast.caster));
    this.casterLabel.innerHTML = I18.flow('CAST_CREATED_BY', caster);
	
	var normalBuffs = [];
	var perfectBuffs = [];
	var runeBuffs = [];
	var runeWordBuffs = [];
	
	for(var i=0; i<cast.buffs.length; i++)
	{
	    var buff = cast.buffs[i];
	    
	    if (buff.buffCause.name == BuffCause.PERFECT_ARTIFACT.name)
	    {
            perfectBuffs.push(buff);
        }
        else if (buff.buffCause.name == BuffCause.RUNE.name)
        {
            runeBuffs.push(buff);
        }
        else if (buff.buffCause.name == BuffCause.RUNE_WORD.name)
        {
            runeWordBuffs.push(buff);
        }
        else
        {
            normalBuffs.push(buff);
        }
	}

	this.spellEffects.innerHTML = '';
    EffectsView.createCastView(this.spellEffects, this.cast.actions, normalBuffs, holderIsHero);

	this.spellEffectsPerfect.innerHTML = '';
	if (perfectBuffs.length > 0)
	{
		UIh.addItem(this.spellEffectsPerfect, I18.f("UPGRADE_SKILLS"));
		EffectsView.createCastView(this.spellEffectsPerfect, cast.actions, perfectBuffs, holderIsHero);
		this.spellEffectsPerfect.style.color = Effects.BLUE;
	}

	this.spellEffectsRune.innerHTML = '';
	if (runeBuffs.length > 0)
	{
		UIh.addItem(this.spellEffectsRune, I18.f("RUNE_PASSIVE_SKILLS"));
		EffectsView.createCastView(this.spellEffectsRune, cast.actions, runeBuffs, holderIsHero);
	}

	this.spellEffectsRuneWord.innerHTML = '';
	if (runeWordBuffs.length > 0)
	{
		UIh.addItem(this.spellEffectsRuneWord, I18.f("RUNE_WORD_SKILLS"));
		EffectsView.createCastView(this.spellEffectsRuneWord, cast.actions, runeWordBuffs, holderIsHero);
	}

    this.timeLabel.innerHTML = this.cast.isStarted(Tick.now()) 
    	? I18.f('CAST_LASTS_TILL', Tick.toTimeFuture(this.cast.tillTick)) 
    	: I18.f('CAST_START', Tick.toTimeWithDate(this.cast.startTick)
    );
    
    COM(this.doesntWorkText).update(doesntWork);
}