function CastleGateInfoView()
{
	this.buffs = null; // ArrayCollection
	this.time = null; // Number
}

CastleGateInfoView.prototype.__construct = function()
{
}

CastleGateInfoView.prototype.buffs = null; // ArrayCollection
CastleGateInfoView.prototype.time = null; // Number

CastleGateInfoView.prototype.update = function(healthCurrent, healthTotal, help, shield, buffs, time, showHealth, showBonusTip)
{
	if (typeof showHealth == 'undefined') showHealth = true;
	if (typeof showBonusTip == 'undefined') showBonusTip = true;
	
    this.buffs = buffs;
    this.time = time;
    
    var health = showHealth ? NumberUtils.equals(healthCurrent, healthTotal) ? healthCurrent : (healthCurrent + "/" + healthTotal) : "";
    var bonus = buffs ? FBuff.sumOfBuildingBuffs(buffs, BuffType.BOOST_BUILDING, BType.CASTLEGATE, time) : 0;
    
    COM(this.healthLabel).update(health, bonus, FConfig.MIN_HEALTH_PERCENT - 1);
    COM.bindExclusiveClick(this.healthLabel, $.proxy(function(){
    	
    	if (showBonusTip) 
    	{
    		this.onBonusTooltip();
    	}
    	
    }, this));
    
    if (UI.show(healthCurrent > 0, [this.garrisonHelpLabel]))
    {
		this.garrisonHelpLabel.innerHTML = I18.f('CASTLEGATE_GARRISON_HELP', help);
    }
    
    this.shieldLabel.innerHTML = I18.f('CASTLEGATE_SHIELD_DESCRIPTION', shield);
}

CastleGateInfoView.prototype.onBonusTooltip = function(event)
{
}