function CastleHexesView()
{
	callParentConstructor(CastleHexesView.prototype, this);
	
	this.emptyGateView = null;
	this.gateView = null;
}

extendClass(CastleHexesView.prototype, CityHexesView.prototype);

CastleHexesView.prototype.emptyGateView = null;
CastleHexesView.prototype.gateView = null;

CastleHexesView.prototype.initHexes = function()
{
    superMethod(CastleHexesView.prototype, "initHexes", this)();
    
    UI.show(false, [this.gateCountdown]);
    
    if(!this.emptyGateView)
    {
    	this.emptyGateView = document.createElement("img");
    	this.emptyGateView.src = STATIC_URL + Assets.B_findBy(Race.CASTLE_MONSTER, BType.CASTLEGATE, null, 0, "EMPTY");
    	$(this.emptyGateView).css({display: "", position: "absolute", left: 200, top: 200});
    	COM.bindExclusiveClick(this.emptyGateView, $.proxy(this.gateClickHandler, this));
        $(this.hexContainer).append(this.emptyGateView);
    }
    
    if(!this.gateView)
    {
		this.gateView = new BuildingView();
		this.gateView.__construct({ctx: this.ctx});
    }
};

CastleHexesView.prototype.alignHallView = function()
{
    this.hallView.x = this.CENTRAL_COBBLES_COORDS[1][0] + 94;
    this.hallView.y = this.CENTRAL_COBBLES_COORDS[0][1] + 108;
    this.hallView.zIndex = 270;
    superMethod(CastleHexesView.prototype, 'alignHallView', this)();
    ////this.hallView.css({'left': x, 'top': y, 'z-index': 270});
};

CastleHexesView.prototype.gateClickHandler = function(event)
{
    this.onGateClick(this.gateView);
};

CastleHexesView.prototype.onGateTip = function(e)
{
    /*
    if (castle.castleGate == null) {
        e.toolTip = CastleGateTip.createDestroyed();
    } else {
        var help:int = castle.calcGateGarrisonHelp();
        e.toolTip = CastleGateTip.create(castle.castleGate.level, castle.castleGate.currentHealth, help, estate.buffs, FEstate.tickNowForEstate(estate), true, castle);
    }
    */
};

CastleHexesView.prototype.updateHexState = function(state)
{
    superMethod(CastleHexesView.prototype, "updateHexState", this)(state);
    this.gateView.showLevel = state.levels;
    this.gateView.showCountdown = state.countDown;
    if (this.estate)
    {
        this.gateView.update(this.estate.castleGate, null, this.estate.owner.race);
    }
};

CastleHexesView.prototype.tick = function(force)
{
    superMethod(CastleHexesView.prototype, "tick", this)(force);
    this.gateView.tick();
    /*
    if (ToolTipManager.currentToolTip is CastleGateTip && castle.castleGate != null) {
        var blevel:BLevelCastleGate = BLevelCastleGate(BType.CASTLEGATE.getLevels(Race.CASTLE_MONSTER).getItemAt(castle.castleGate.level));
        var help:int = castle.calcGateGarrisonHelp();
        (ToolTipManager.currentToolTip as CastleGateTip).update(castle.castleGate.currentHealth, blevel.health, help, blevel.shield, estate.buffs, FEstate.tickNowForEstate(estate), true, castle);
    }
    */
};

CastleHexesView.prototype.updateGate = function()
{
    if (!this.estate.isExpeditionReport)
    {
        var gate = this.estate.castleGate;
        var gateHex = this.allHexes[HexNeighbours.getGateIndex(this.estate)];
        //gateHex.onGateTip = onGateTip;

        this.gateView.x = gateHex.x;
        this.gateView.y = gateHex.y;
        this.gateView.buildingCenterX = gateHex.x + APP.hexesOffset.left + gateHex.WIDTH;
		this.gateView.buildingBottomY = gateHex.y + APP.hexesOffset.top + gateHex.HEIGHT + gateHex.HEIGHT/2;
        this.gateView.update(gate, null, this.estate.owner.race);

        var img = APP.getPreloadImage(Assets.Monster.Buildings.CASTLEGATE_EMPTY);
        this.emptyGateView.style.left = (this.gateView.buildingCenterX - img.width/2) + "px";
        this.emptyGateView.style.top = (this.gateView.buildingBottomY - img.height) + "px";
        
        this.emptyGateView.style.display = this.estate.castleGate ? "none" : "";
    }
};

CastleHexesView.prototype.onGateClick = function(parent)
{
    if (!this.estate.castleGate)
    {
        this.showBuildGateDialog();
    }
    else
    {
        this.showGateMenu();
    }
};

CastleHexesView.prototype.showGateMenu = function()
{
        //this.selectCell(FCastle.GATE_FAKE_CELL_INDEX);
    this.menuCellIndex = FCastle.GATE_FAKE_CELL_INDEX;
    
    var reason = this.canEnterBuildingReason(FCastle.GATE_FAKE_CELL_INDEX, this.estate.castleGate);
    if (this.manageDialog)
    {
    	this.manageDialog.destroy();
    	this.manageDialog = null;
    }
    
    this.manageDialog = COM.create('ManageDialog', null, {estate: this.estate, _cellIndex: FCastle.GATE_FAKE_CELL_INDEX, reason: reason});
    
    this.manageDialog.switchBuilding = $.proxy(this.switchBuilding, this);
    this.manageDialog.switchDialog = this.ownDialog;
    
    this.manageDialog.popup(this, FCastle.GATE_FAKE_CELL_INDEX, this.estate);
    
    this.ownDialog(this.manageDialog);
    
    this.updateMenu(FCastle.GATE_FAKE_CELL_INDEX, this.estate.castleGate);
    this.manageDialog.onClose = $.proxy(function()
    {
    	if (ManageDialog.prototype.onClose.call(this.manageDialog) === false) return false;
    	this.ownDialog(null);
    	this.manageDialog = null;
    	
    }, this);

    /*
    showMenu(gateView);
    updateMenu(FCastle.GATE_FAKE_CELL_INDEX, castle.castleGate);
    */
};

CastleHexesView.prototype.showBuildGateDialog = function()
{
    if (this.estate.accessDeputy)
    {
        var dialog = COM.create("BuildDialog");
        dialog.init(this.estate, FCastle.GATE_FAKE_CELL_INDEX);
        dialog.popup();
        
        this.ownDialog(dialog);
    }
};

CastleHexesView.prototype.getCastle = function()
{
    return this.estate;
};