function CastsView()
{
	this.__defineGetter__('emptyText', function(){ return this.emptyTextLabel.innerHTML; });
	this.__defineSetter__('emptyText', function(val){ this.emptyTextLabel.innerHTML = val; });
	
	this.__defineGetter__('vertical', function(){ return !$(this.DOM).hasClass('horizontal'); });
	this.__defineSetter__('vertical', function(val){ $(this.DOM).toggleClass('horizontal', !val); });
	
	this.casts = null; // Array
	this.estate = null; // FEstate
	this.hero = null; // FHero
	this.disabled = null; // Boolean
	this.visibleItems = 0; // limit of visible items
}

CastsView.prototype.__construct = function()
{
	this.emptyText = this.DOM.getAttribute('emptyText') || this.__inlineData;
	if (this.DOM.hasAttribute('items')) this.visibleItems = Math.max(0, this.DOM.getAttribute('items')*1);
	if (this.DOM.hasAttribute('vertical')) this.vertical = (this.DOM.getAttribute('vertical') != 'false');
	COM.bindExclusiveClick(this.DOM, $.proxy(this.showCastsDialog, this));
}

CastsView.prototype.casts = null; // Array
CastsView.prototype.estate = null; // FEstate
CastsView.prototype.hero = null; // FHero
CastsView.prototype.disabled = null; // Boolean
CastsView.prototype.visibleItems = 0;

CastsView.prototype.init = function()
{
}

CastsView.prototype.showCastsDialog = function()
{
	CastsViewDialog.create(this.estate, this.hero, this.casts);
}

CastsView.prototype.getDoesntWork = function(cast)
{
    var res = [];
    if (this.hero && this.estate && (!this.estate.garrisonHero || this.estate.garrisonHeroId != this.hero.id)) 
    {
        res.push(I18.f('DOESNT_WORK_NON_GARRISON_HERO'));
    }
    if (this.hero && this.hero.isUpset()) 
    {
        if (this.hero.upsetByFight) 
        {
            res.push(I18.f('DOESNT_WORK_UPSET_HERO'));
        }
        if (this.hero.upsetByTitle) 
        {
            res.push(I18.f('HERO_ERROR_REQUIRED_MAX_TITLE'));
        }
    }
    if (this.disabled && cast.isMagicDisableable() && !cast.isMagicDisable() && !cast.isGlobal()) 
    {
        res.push(I18.f('DOESNT_WORK_MAGIC_DISABLE'));
    }
    if (res.length > 0) 
    {
        res.unshift(I18.f('CAST_DOESNT_WORK'));
    }
    return res;
}

CastsView.prototype.update = function(estate, hero, casts, disabled)
{
    this.estate = estate;
    this.hero = hero;
    this.disabled = disabled;
    this.casts = casts;
    
    var n = this.visibleItems ? Math.min(this.visibleItems, this.casts.length) : this.casts.length;
    var len = this.castsContainer.children.length;
    while (len < n)
    {
    	var c = this.createCastView();
    	this.castsContainer.appendChild(c.DOM);
    	len++;
    }
    while (len > n)
    {
    	COM(this.castsContainer.children[len-1]).destroy();
    	len--;
    }
    for (var i = 0; i < n; i++)
    {
    	var c = COM(this.castsContainer.children[i]);
        var fc = this.casts[i];
    	c.update(fc, this.getDoesntWork(fc), Boolean(this.hero));
    }
    
    UI.show(n > 0, [this.castsContainer]);
    UI.show(n == 0, [this.emptyTextLabel]);
    
    if (UI.show(this.visibleItems && (this.casts.length > this.visibleItems), [this.counterLabelBox]))
    {
    	this.counterLabel.innerHTML = '+' + (this.casts.length - this.visibleItems);
    }
}

CastsView.prototype.createCastView = function()
{
    var com = COM.create('CastView');
    return com;
}

CastsView.prototype.reset = function()
{
}
