function CityGarrisonAllies()
{
	callParentConstructor(CityGarrisonAllies.prototype, this);
	
	this.estate = null;
}

extendClass(CityGarrisonAllies.prototype, Dialog.prototype);

CityGarrisonAllies.prototype.__construct = function()
{
	for(var i=0; i<3; i++)
	{
		COM(this["ally"+i]).onCloseClick = this.sendBackHandler(i);
	}
	
	//this.noAlliesText.innerHTML = I18.f('NO_ALLIED_ARMIES');
}

CityGarrisonAllies.prototype.popup = function()
{
	superMethod(CityGarrisonAllies.prototype, "popup", this)();
	
	this.skin = "black";
	COM(this._closeButton).skin = "transparent";
	
	this.setCaption(I18.f('ALLIED_ARMIES').split("{")[0]);
	
	this.fullScreen();
}

CityGarrisonAllies.prototype.onShow = function()
{
	COM(this._closeButton).icon = STATIC_INTERFACE_URL + "icons/back2.png";
}

CityGarrisonAllies.prototype.update = function(e)
{
	this.estate = e;
	
	var acnt = 0;
    for (var i = 0; i < e.assistances.length; i++)
    {
        UI.visible(true, [this['ally' + i]]);
        
        if(this.displayAssist(e, e.assistances[i], this['ally' + i], e.assistantBonuses[i], e.monsterRace()))
        {
        	acnt++;
        }
    }

    for (var j = e.assistances.length; j < 3; j++)
    {
        UI.visible(false, [this['ally' + i]]);
    }
    
    //this.noAlliesText.style.display = acnt > 0 ? "none" : "block";
    
    //this.setCaption(StringUtil.substitute(I18.f('ALLIED_ARMIES'), Arrays.antidot([acnt, e.assistances.length])));
}

CityGarrisonAllies.prototype.tick = function()
{
	for (var i = 0; i < this.estate.assistances.length; i++)
    {
        this.tickAssist(this.estate, this.estate.assistances[i], this['ally' + i]);
    }
}

CityGarrisonAllies.prototype.displayAssist = function(estate, missions, allyArmy, bonuses, monsterRace)
{
    allyArmy = COM(allyArmy);
    
    if (missions.length != 0)
    {
        var mission = missions[0];
        mission.updateTransient();
        COM(allyArmy.armyView).setUnits(mission.owner.race, mission.ownerUnitLevels, monsterRace, new UnitAura(bonuses), mission.armyBuffs);
        var totalArmy = new Army();
        var hero = null;
        
        for(var i=0; i<missions.length; i++)
        {
        	totalArmy.add(missions[i].army);
        	if (!hero && missions[i].hero)
        	{
                hero = missions[i].hero;
            }
        }
        
        COM(allyArmy.armyView).setHero(hero, mission.owner.race, this.estate.accessHideout ? -1 : FEstate.HIDEOUT_ACCESS_LEVEL);
        
        COM(allyArmy.armyView).setCount(totalArmy, mission.armyFaded);
        allyArmy.comment.innerHTML = this.constructAssistanceComment(this.estate, missions);
        allyArmy.comment.style.display = "";
        allyArmy.button.style.display = this.estate.accessHideout ? "" : "none";
        
        if(!(mission.cancelable &&
            (this.estate.accessManageble ||
               ((this.estate.__className__ == "FCastle" || this.estate.__className__ == "FCatapult") && FUser.CURRENT_USER.hasClanRole(ClanRole.WARMINISTER)))
            ))
        {
            allyArmy.button.style.display = "none";
        }
        
        if (!mission.cancelable && this.estate.accessDeputy)
        {
            if (this.estate.__className__ == "FCastle")
            {
                //allyArmy.button.toolTip = "";
            }
            else if (this.estate.__className__ == "FCity")
            {
                //allyArmy.button.toolTip = I18.f("CANNOT_CANCEL_ASSISTANCE_GATE_CLOSED");
            }
            else
            {
                //allyArmy.button.toolTip = I18.f("CANNOT_CANCEL_ASSISTANCE_TUNNEL_CLOSED");
            }
        }
        else
        {
            //allyArmy.button.toolTip = "";
        }
        
        allyArmy.armyView.style.display = "";
    }
    else
    {
        if (this.estate.accessHideout)
        {
            COM(allyArmy.armyView).setAllBacks(this.estate.owner.race);
            //allyArmy.armyView.style.display = "none";
        }
        else
        {
            COM(allyArmy.armyView).setAccessLevelRequired(FEstate.HIDEOUT_ACCESS_LEVEL);
        }
        
        allyArmy.comment.style.display = "none";
        allyArmy.button.style.display = "none";
        
        return false;
    }
    
    return true;
}

CityGarrisonAllies.prototype.constructAssistanceComment = function(estate, missions)
{
    if (missions.length == 0)
    {
        return "";
    }
    
    if (missions.length == 1)
    {
        var m = missions[0];
        return I18.f("ASSISTANCE_ARMY_ONE", FUser.getUserNameForMessages(m.owner.username), m.from, this.timeLeft(this.estate, m));
    }
    
    var mission0 = missions[0];
    var mission1 = missions[1];
    if (mission0.nextUpdateTick >= mission1.nextUpdateTick)
    {
        mission0 = missions[1];
        mission1 = missions[0];
    }

    if (missions.length == 2)
    {
        return I18.f("ASSISTANCE_ARMY_TWO", [FUser.getUserNameForMessages(mission0.owner.username),
                     mission0.from, this.timeLeft(this.estate, mission0),
                     mission1.from, this.timeLeft(this.estate, mission1)]);
    }
    
    for (var i = 2; i < missions.length; i++)
    {
        var mission = missions[i];
        if (mission.nextUpdateTick < mission0.nextUpdateTick)
        {
            mission1 = mission0;
            mission0 = mission;
        }
        else if (mission.nextUpdateTick < mission1.nextUpdateTick)
        {
            mission1 = mission;
        }
    }
    
    return I18.f("ASSISTANCE_ARMY_MANY", [FUser.getUserNameForMessages(mission0.owner.username),
            mission0.from, this.timeLeft(this.estate, mission0),
            mission1.from, this.timeLeft(this.estate, mission1)]);
}

CityGarrisonAllies.prototype.tickAssist = function(estate, missions, allyArmy)
{
    if (missions.length != 0)
    {
        COM(allyArmy).comment.innerHTML = this.constructAssistanceComment(estate, missions);
    }
}

CityGarrisonAllies.prototype.timeLeft = function(estate, mission)
{
    return Tick.toTimeLeft(Tick.isInfinity(mission.nextUpdateTick) ? mission.nextUpdateTick : (mission.nextUpdateTick - this.estate.responseTick));
}

CityGarrisonAllies.prototype.sendBackHandler = function(assistant)
{
    var ret = $.proxy(function()
    {
        var mission0 = this.estate.assistances[assistant][0];
        if (mission0.isAncientsAssist)
        {
            Alert.create(I18.f("CANCEL_ANCIENTS_WARNING"), "", function()
            {
                Service.mission.callMethod("cancelMission", [this.estate.owner.username, mission0.id, null]);
                Events.onShowCity.fire(this.estate.id);
                COM(COM(this["ally"+assistant]).armyView).setAllBacks(this.estate.owner.race);
            });
        }
        else
        {
            Service.city.callMethod("cancelAssistsFromUser", [this.estate.id, mission0.owner.username]);
            APP.showLoader();
            setTimeout($.proxy(function()
            {
	            Events.onShowCity.fire(this.estate.id);
	            COM(COM(this["ally"+assistant]).armyView).setAllBacks(this.estate.owner.race);
	            //this["ally"+assistant].style.display = "none";
            }, this), 1000);
        }
    }, this);
    
    return ret;
}