function CityGarrisonHideout()
{
	callParentConstructor(CityGarrisonHideout.prototype, this);
	
	this.estate = null;
}

extendClass(CityGarrisonHideout.prototype, Dialog.prototype);

CityGarrisonHideout.prototype.__construct = function()
{
	this.setCaption(I18.f("HIDEOUT"));
	
	COM(this.equalizer).onChange = $.proxy(this.updateCost, this);
	
	this.costLabel.innerHTML = I18.f('MOVE_TO_HIDEOUT_COST');
	COM(this.moveToHideoutCost).alwaysShow = [Resource.GOLD];
	
	COM.bindExclusiveClick(this.applyButton, $.proxy(this.onApply, this));
	
	this.fullScreen();
	
	$("cell", this.arrowsRow).on(CLICK_EVENT, $.proxy(this.onArrowClick, this));
}

CityGarrisonHideout.prototype.onArrowClick = function(e)
{
	var uid = e.currentTarget.getAttribute("unitid")*1;
	COM(this.equalizer).showSlider({currentTarget: $("militaryunitview", COM(this.equalizer).DOM)[uid]});
}

CityGarrisonHideout.prototype.update = function(e)
{
	this.estate = e;
	
	COM(this.equalizer).update(e);
	COM(this.equalizer).active = true;
	
	if(!e.accessDeputy)
	{
		this.controlBar.style.display = "none";
	}
}

CityGarrisonHideout.prototype.onShow = function()
{
	this.arrowsContainer.style.top = ($("armylistview", COM(this.equalizer).DOM)[0].offsetHeight+22) + "px";
}

CityGarrisonHideout.prototype.tick = function()
{
	COM(this.equalizer).tick();
}

CityGarrisonHideout.prototype.updateCost = function()
{
    var moveCount = COM(this.equalizer).getMovedUnitsCount();
    var moveCost = FConfig.HIDEOUT_ENTRANCE_FEE.multiplyCopy(moveCount);
    
    COM(this.moveToHideoutCost).updateAll(moveCost, this.estate.bank, this.estate.race);
    //COM(this.moveToHideoutCost).style.display = moveCost.isZero() ? "none" : "";
    //COM(this.applyButton).enabled = COM(this.equalizer).changed && !this.estate.isGarrisonBlocked && this.estate.accessDeputy && this.estate.bank.greaterOrEqualsTo(moveCost);
    
    var reason = "";
    if (this.estate.isGarrisonBlocked) reason = I18.f("MISSION_BLOCKED_GARRISON");
    else if(!COM(this.equalizer).changed) reason = I18.f("MISSION_EMPTY_SQUAD");
    else if(!this.estate.accessDeputy) reason = I18.f("ACCESS_DENIED_ERROR_DEPUTY_LEVEL_NEEDED");
    else if(!this.estate.bank.greaterOrEqualsTo(moveCost)) reason = I18.f("NOT_ENOUGH_RESOURCES");
    
    COM(this.applyButton).reason = reason;
    
    
    /*
    if (this.estate.isGarrisonBlocked)
    {
        this.equalizer.applyButton.toolTip = I18.f("MISSION_BLOCKED_GARRISON");
    }
    else
    {
        this.equalizer.applyButton.toolTip = "";
    }
    */
}

CityGarrisonHideout.prototype.onApply = function()
{
	var equalizer = COM(this.equalizer);
	
	Service.city.callMethod("setHideout", [this.estate.id, equalizer.newHideout.prepareForRequest(), equalizer.garrisonHeroId], $.proxy(function(e)
	{
        equalizer.update(e);
        equalizer.reset();
        COM(this.applyButton).enabled = true;
        this.tick();
        
        //this.close();
    }, this));
    
    if (equalizer.stepIndex != FUser.CURRENT_USER.settings.resourceChooserStepIndex)
    {
        Events.onArmyChooserStepIndexChanged.fire(equalizer.stepIndex);
    }
    
    COM(this.applyButton).enabled = false;
}