function CityHexesView()
{
	callParentConstructor(CityHexesView.prototype, this);
	
	this.needToUpdateWall = true;
}

extendClass(CityHexesView.prototype, CellularView.prototype);

CityHexesView.prototype.addEach = function(indices, shift)
{
	for (var i = 0; i < indices.length; i++)
	{
		indices[i] += shift;
	}
	return indices;
}

CityHexesView.prototype.correctCobblesPos = function(data)
{
	for(var i=0; i<data.length; i++)
	{
		data[i][0] += -142;
		data[i][1] += 15;
	}
	
	return data;
}

$.extend(CityHexesView.prototype,
{
	hexesX : [591, 683, 545, 637, 729, 315, 407, 499, 591, 683, 775, 867, 959, 361, 453, 545, 729, 821, 913, 407, 499, 775, 867, 959, 361, 453, 545, 729, 821, 913, 315, 407, 499, 591, 683, 775, 867, 959, 269, 361, 453, 545, 637, 729, 821, 913, 499, 591, 683, 545, 637],
	hexesY : [112, 112, 152, 152, 152, 192, 192, 192, 192, 192, 192, 192, 192, 232, 232, 232, 232, 232, 232, 272, 272, 272, 272, 272, 312, 312, 312, 312, 312, 312, 352, 352, 352, 352, 352, 352, 352, 352, 392, 392, 392, 392, 392, 392, 392, 392, 432, 432, 432, 472, 472],
	indices : CityHexesView.prototype.addEach([40, 41, 39, 16, 42, 36, 37, 38, 15, 17, 43, 44, 45, 35, 13, 14, 18, 19, 46, 34, 12, 0, 20, 47, 33, 11, 8, 1, 21, 48, 32, 10, 9, 7, 3, 2, 22, 49, 31, 30, 29, 6, 4, 24, 23, 50, 28, 5, 25, 27, 26], 32),

	sectorHexX : [[98, 190, 282, 144, 236, 98, 190, 144], [999, 1091, 1183, 1137, 1045, 1183, 1091, 1137], [1138, 1092, 1184, 1046, 1138, 1000, 1092, 1184], [145, 99, 191, 145, 237, 99, 191, 283]],

	sectorHexY : [[35, 35, 35, 75, 75, 115, 115, 155], [36, 36, 36, 76, 76, 116, 116, 156], [473, 513, 513, 553, 553, 593, 593, 593], [476, 516, 516, 556, 556, 596, 596, 596]],

	sectorIndices : APP.LTR ? [[7, 6, 5, 3, 4, 1, 2, 0], [13, 14, 15, 11, 12, 9, 10, 8], [16, 18, 17, 20, 19, 21, 22, 23], [24, 25, 26, 27, 28, 31, 30, 29]] : [[13, 14, 15, 11, 12, 9, 10, 8], [7, 6, 5, 3, 4, 1, 2, 0], [24, 25, 26, 27, 28, 31, 30, 29], [16, 18, 17, 20, 19, 21, 22, 23]],

	CENTRAL_COBBLES_COORDS : CityHexesView.prototype.correctCobblesPos([[591, 205], [545, 245], [637, 245], [591, 285]]),
	
	centralCobbles: [],
    gateCountdown: null,
    
    connections: [],
	
	getHallIndex: function()
	{
		return 24;
	},
	
	initHexes: function()
	{
        //throw Error("initHexes is not implemented: " + this.estate.__className__);
        
        this.addHexes(this.hexesX, this.hexesY, this.indices);
        for (var j = 0; j < 4; j++)
        {
            this.addHexes(this.sectorHexX[j], this.sectorHexY[j], this.sectorIndices[j]);
        }
        
    	this.initWall();
    	
        this.centralCobbles = [];
        var coords = this.CENTRAL_COBBLES_COORDS;
        
        for (var i = 0; i < 4; i++)
        {
            var image = document.createElement("img");
            $(image).css({'position' : 'absolute', 'left' : coords[i][0] + 188, 'top' : coords[i][1] + 12});
            //this.hexContainer.append(image);
            this.centralCobbles.push(image);
        }
    	
        this.gateCountdown = COM.create("BuildingCountDown");
		this.gateCountdown.setPosition(-100, -100);
		this.gateCountdown.DOM.style.display = "none";
        $(this.hexContainer).append(this.gateCountdown.DOM);
   	},

    alignHallView: function()
    {
        //this.hallView.x = this.CENTRAL_COBBLES_COORDS[1][0] + 45 + APP.hexesSize.width * 0.5;
        //this.hallView.y = this.CENTRAL_COBBLES_COORDS[0][1] + 53 + APP.hexesSize.height * 0.5;
        
        /*
        this.hallView.x = this.CENTRAL_COBBLES_COORDS[1][0] 
        	+ APP.hexesSize.width - this.hallView.buildingWidth / 2
        	+ APP.hexesSize.width * 1
        ;
        this.hallView.y = this.CENTRAL_COBBLES_COORDS[0][1] 
        	+ APP.hexesSize.height - this.hallView.buildingHeight / 2
        	+ APP.hexesSize.height * 2
        ;
        */
        //this.hallView.y = this.CENTRAL_COBBLES_COORDS[0][1] + 53 + APP.hexesSize.height * 0.5;
        
        this.hallView.x = 728 - this.hallView.buildingWidth / 2;
        this.hallView.y = 447 - this.hallView.buildingHeight;
        this.hallView.zIndex = 270;
        
        superMethod(CityHexesView.prototype, 'alignHallView', this)();
        
		/*
		var fs = this.ctx.main.fillStyle;
		this.ctx.main.fillStyle = "rgba(0, 255, 255, 0.3)";
		this.ctx.main.fillRect(this.hallView.x, this.hallView.y, this.hallView.buildingWidth, this.hallView.buildingHeight);
		this.ctx.main.fillStyle = fs;
		*/
    },

    update: function(c, forceUpdate)
    {
        var old = this.estate;
        
        for(var i=0; i<this.centralCobbles.length; i++)
        {
        	$(this.centralCobbles[i]).attr('src', STATIC_URL + Assets.getRaceAssets(c.owner.race).specific.CELL_COBBLES);
        }
        
        superMethod(CityHexesView, "update", this)(c, forceUpdate);
        
        this.updateGate();
        
        this.updateHallView();
    },
    
    // wall and gate
    updateWall: function(old)
    {
        return;
        
        var newCellCount = this.estate.getInsideWallCellCount();
        
        var isNewCity = (!old) || !this.estate.equals(old);
        
        if (isNewCity || (newCellCount != old.getInsideWallCellCount()))
        {
            var context = this.hexCanvas[0].getContext("2d");
            var hex;
            for(var i=0; i<this.allHexes.length; i++)
            {
            	hex = this.allHexes[i];
            	if (hex.isInsideWall())
            	{
                    hex.updateWall(this.getNeighboursFor(hex.cellIndex), this.onGateClick, context);
                }
                else
                {
                    hex.removeJoints();
                }
            }
        }
    },

    tick: function(force)
    {
		superMethod(CityHexesView, "tick", this)(force);
		if (this.gateCountdown.DOM.style.display != "none")
		{
            this.gateCountdown.update(Tick.toTimeLeft(this.estate.gateChangeTick - FEstate.tickNowForEstate(this.estate)));
        }
    },

    findCityHexByCoords: function(p)
    {
        for(var i=0; i<this.allHexes.length; i++)
        {
        	if(p.x == this.allHexes[i].x && p.y == this.allHexes[i].y) return this.allHexes[i];
        }
        return null;
    },

    updateHallView: function()
    {
        if (!this.estate.isExpeditionReport)
        {
            //this.hallView.visible = true;
        }
        else
        {
            //this.hallView.visible = false;
        }
        
        //UI.show(!estate.isExpeditionReport, centralCobbles);
    },

    initWall: function()
    {
        this.connections = this.buildCellConnection(this.allHexes);
    },

    buildCellConnection: function(cityHexes)
    {
        var cons = [], hex;
        for(var i=0; i<cityHexes.length; i++)
        {
        	 hex = cityHexes[i];
        	 var res = [];
        	 var points = hex.getNeighbourPoints();
        	 
        	 for(var pi=0; pi<points.length; pi++)
        	 {
        	 	res.push(this.findCityHexByCoords(points[pi]));
        	 }
        	 
        	 cons[hex.cellIndex] = res;
        }
        
        return cons;
    },

    getNeighboursFor: function(cellIndex)
    {
        return new HexNeighbours(this.connections[cellIndex], cellIndex);
    },

    updateGate: function()
    {
        if (!this.estate.isExpeditionReport)
        {
            this.gateCountdown.DOM.style.display = this.estate.isGateChanging() ? "" : "none";
            for(var i=0; i<this.allHexes.length; i++)
            {
            	if(this.allHexes[i].gate && !this.allHexes[i].checkInvalid(this.estate))
            	{
            		this.moveGateCooldown(this.allHexes[i]);
            	}
            }
            //moveGateCooldown(gateHex);
            
        }
        else
        {
            this.gateCountdown.DOM.style.display = "none";
        }
    },

    moveGateCooldown: function(gateHex)
    {
        var x = (gateHex.x + APP.hexesOffset.left + gateHex.WIDTH)*GAME_IMAGES_PACK;
		var y = (gateHex.y + APP.hexesOffset.top + gateHex.HEIGHT)*GAME_IMAGES_PACK;
        
		this.gateCountdown.setPosition(x, y);
    },

    onHexClick: function(h)
    {
        HintArrow.CLICK_ON_CELL.understood();
		superMethod(CityHexesView, "onHexClick", this)(h);
    },

    findCellInsideWall: function(btype)
    {
        var whereOn = !btype ? null : btype.getWhereOn(this.estate.owner.race);
        var applicable = [];
        
        var h;
        for(var i=0; i<this.allHexes.length; i++)
        {
        	h = this.allHexes[i];
        	if (!this.estate.hasCell(h.cellIndex))
        	{
                continue;
            }
            var cell = this.estate.getCellByIndex(h.cellIndex);
            
            if (this.estate.isInsideCityWall(h.cellIndex) && !cell.blocked &&
                    !cell.building &&
                    ((whereOn.name == BWhereCell.ANYWHERE.name && cell.resource.name == Resource.NULL.name) || (whereOn.name != BWhereCell.ANYWHERE.name && whereOn.isSuccess(h.cellIndex, this.estate))) ) {
                applicable.push(h);
            }
        }
        
        if (applicable.length > 0)
        {
            return applicable[Math.floor(Math.random() * applicable.length)];
        }
        
		return null;
    }
}); 