function CityMediator()
{
	callParentConstructor(CityMediator, this);
	
	this.__defineGetter__("cityView", function()
	{
		return this._viewComponent;
	});
	
	
    this.__defineGetter__("estate", function()
    {
        return this._estate;
    });
	
	//Estate ticker
	this.ticker = new EstateTicker($.proxy(this.onUpdate, this), $.proxy(this.tick, this), $.proxy(function(e)
	{
		if(e.__className__ == "EstateNotFoundException")
		{
			this.ticker.stop();
			Alert.create(I18.f("ESTATE_NOT_FOUND"));
		}
	}, this));
	this.ticker.isReady = $.proxy(this.isReadyForUpdate, this);
	
	//Ping ticker
	this.pingTicker = new Ticker(30000, this.ping);
    
	this.firstTime = true;
    this._estate = null;
    this._espionageResult = null;
    this.readyForUpdate = true;
    
    this.fitLayout = $.proxy(function(container)
	{
		$("> wrapper", this.DOM).css("width", container.width);
		$("> wrapper", this.DOM).css("height", container.height);
		
		$("> wrapper > content", this.DOM).css("width", container.width);
		$("> wrapper > content", this.DOM).css("height", container.height);
		
		this.cityView.fitLayout(container);
	}, this);
}

extendClass(CityMediator.prototype, BaseMediator.prototype);

CityMediator.prototype.__construct = function()
{
	superMethod(CityMediator, "__construct", this)(COM.create("EstateView"));
}

CityMediator.prototype.tick = function()
{
	this.cityView.tick();
}

CityMediator.prototype.hideCityPanels = function()
{
	this.cityView.hideCityPanels();
}

CityMediator.prototype.showCityPanels = function()
{
	this.cityView.showCityPanels();
}

CityMediator.prototype.isReadyForUpdate = function()
{
	return this.readyForUpdate;
};

CityMediator.isReady = false;
CityMediator.prototype.onUpdate = function(estate)
{
	if(this.firstTime)
	{
		GlobalSelectionCitiesCombo._selectedCityId = estate.id;
        Service.city.callMethod("getById", [estate.id]);
	}
	this.firstTime = false;
	
	this.isNewEstate = !this._estate || !this._estate.equals(estate);

    this._estate = estate;
    this.readyForUpdate = false;
    //this.showWait();
    
    APP.setPreloaderTitle("Creating city view");
    APP.setPreloaderProgress(100);
    
    if(CityMediator.isReady) this.contentReceived();
    else setTimeout($.proxy(this.contentReceived, this), 100);
    
    CityMediator.isReady = true;
}

CityMediator.prototype.contentReceived = function()
{
    this._estate.tick(0.1);
    
    this.cityView.update(this._estate);
    //this.cityView.tick(true);
    
    if (this.cityView.initialized)
    {
        this.cityView.canShow();
    }
    this.readyForUpdate = true;
    
    /*
    if(!this.isFitted) this.cityView.fitLayout({width: window.innerWidth, height: window.innerHeight});
    this.isFitted = true;
    */
    
    if(this.isNewEstate) this.cityView.fitLayout({width: window.innerWidth, height: window.innerHeight});
    
    APP.hidePreloader();
}

CityMediator.prototype.showEstate = function(id, preloadedEstate)
{
    this.ticker.start(id, preloadedEstate);
}

CityMediator.prototype.toFullUpdateEstateMode = function()
{
	APP.hideMainContent();
	this.cityView.onReady = $.proxy(function()
	{
		this.cityView.onReady = null;
		APP.showMainContent();
	}, this);
}

CityMediator.prototype.ping = function(delta)
{
	Service.user.callMethod("getCurrentUser", []);
}

CityMediator.prototype.showEspionageResult = function(result, fromCity)
{
	this.toFullUpdateEstateMode();
    
    HintArrow.enabled = false;
    var mailboxOpened = MailBoxView.isVisible();
    var prevEstate;
    this.ticker.stop();
    if (mailboxOpened)
    {
        MailBoxView.toggle(true);
    }
    /*
	if (fromCity)
    {
        prevEstate = this.cityView.estate;
    }
	*/
	
	prevEstate = this.cityView.estate;
	
    //var isAnimationEnabled:Boolean = cityView.hexes.isShowingAnimation();
    //cityView.hexes.setShowingAnimation(false);
    //var isShowingHideout:Boolean = cityView.garrisonView.isShowingHideout();
    //cityView.garrisonView.setShowingHideout(false);
    //cityView.initHeader();
    this.ping();
    this.pingTicker.start();
    this.cityView.onReturnToKingdom = $.proxy(function()
    {
		this.pingTicker.stop();
        if (!result.saved)
        {
            Service.mail.callMethod("discardHiddenEspionageReport");
        }
        //cityView.hexes.setShowingAnimation(isAnimationEnabled);
        //cityView.garrisonView.setShowingHideout(isShowingHideout);
        if (mailboxOpened)
        {
            MailBoxView.toggle(false);
        }
        
		/*
		if (fromCity)
        {
            this.onUpdate(prevEstate);
            this.showEstate(this.ticker.estate.id);
        }
        else
        {
            Events.onShowKingdom.fire(null);
        }
		*/
		
		this.onUpdate(prevEstate);
        this.showEstate(this.ticker.estate.id);
		
		if(!fromCity) Events.onShowKingdom.fire(null);
		
        this.cityView.onReturnToKingdom = this.cityView.returnToKingdomDefault;
    }, this);
    if (!result.saved)
    {
        this.cityView.onSaveReport = $.proxy(function()
        {
            Service.mail.callMethod("saveHiddenEspionageReport", [],
            $.proxy(function()
            {
                Alert.create(I18.f("SAVE_REPORT_SUCCESS"));
                COM(this.cityView.saveReportButton).enabled = false;
                result.saved = true;
            }, this));
        }, this);
    }
    else
    {
        this.cityView.onSaveReport = null;
    }
    this._espionageResult = result;
    //Assets.waitCanShowEstate(_espionageResult.estate, continueShowEspionageResult);
    this.continueShowEspionageResult();
}

CityMediator.prototype.continueShowEspionageResult = function()
{
    this.onUpdate(this._espionageResult.estate);
    if (!this._espionageResult.saved)
    {
        COM.create("EspionageResultDialog").popup(this.cityView, this._espionageResult);
    }
}

CityMediator.prototype.showExpeditionResult = function(city, fromCity)
{
    this.toFullUpdateEstateMode();
    
    HintArrow.enabled = false;
    var mailboxOpened = MailBoxView.isVisible();
    var prevEstate;
    this.ticker.stop();
    if (mailboxOpened)
    {
        MailBoxView.toggle(true);
    }
    if (fromCity)
    {
        prevEstate = this.cityView.estate;
    }
    //var animationEnabled:Boolean = cityView.hexes.isShowingAnimation();
    //cityView.hexes.setShowingAnimation(false);
    this.cityView.initHeader();

    if (!city._fromMail)
    {
        this.cityView.onSaveReport = $.proxy(function()
        {
            Service.kingdom.callMethod("saveExploredField", [city.location],
            $.proxy(function()
            {
                Alert.create(I18.f("SAVE_REPORT_SUCCESS"));
                COM(this.cityView.saveReportButton).enabled = false;
            }, this));
        }, this);
    }
    else
    {
        this.cityView.onSaveReport = null;
    }

    this.ping();
    this.pingTicker.start();
    this.cityView.onReturnToKingdom = $.proxy(function()
    {
        this.pingTicker.stop();
        //cityView.hexes.setShowingAnimation(animationEnabled);
        if (mailboxOpened)
        {
            MailBoxView.toggle(false);
        }
        if (fromCity)
        {
            this.onUpdate(prevEstate);
            this.showEstate(this.ticker.estate.id);
        }
        else
        {
            Events.onShowKingdom.fire(null);
        }
        this.cityView.onReturnToKingdom = this.cityView.returnToKingdomDefault;
    }, this);
    
    this.onUpdate(city);
}

CityMediator.prototype.onShow = function()
{
    this.cityView.onShow();
}

CityMediator.prototype.onHide = function()
{
    this.cityView.onHide();
    this.ticker.stop();
}

CityMediator.prototype.onConnectionGain = function()
{
    if(!this.ticker.estate || !this.ticker.estate.id)
    {
    	APP.navigate();
    	return;
    }
    
    this.ticker.pause();
    this.ticker.start(this.ticker.estate.id, this.ticker.estate);
}

CityMediator.prototype.forceUpdate = function()
{
	this.ticker.estate.nextUpdateTick = 0;
}

CityMediator.prototype.updateCurrentUserFooter = function()
{
	this.cityView.dashboard.update(FUser.CURRENT_USER);
}

CityMediator.prototype.stopAllTickers = function()
{
    this.pingTicker.stop();
    this.ticker.stop();
}