function CitySkinSelector()
{
	this.scroll = null;
}

CitySkinSelector.prototype.scroll = null;
CitySkinSelector.prototype.onSkinChanged = function(skinIndex){};

CitySkinSelector.prototype.__construct = function()
{
	this.scroll = new iScroll(this.DOM, {
		hScroll: true, vScroll: false, bounce: false,
		onScrollMove: $.proxy(this.refreshScrollMore, this),
		onScrollEnd: $.proxy(this.refreshScrollMore, this),
	});
}

CitySkinSelector.prototype.refreshScrollMore = function()
{
	if (!this.scroll) return;
	var more = {
		left: this.scroll.x < 0, 
		right: (this.scroll.x - this.scroll.maxScrollX > 0)
	};
	var cls = this.DOM.classList;
	for (var dir in more)
	{
		if (more[dir] ^ cls.contains('more-' + dir))
		{
			cls[more[dir] ? 'add' : 'remove']('more-' + dir);
		}
	}
}

CitySkinSelector.prototype.refreshScroll = function(timeout)
{
	if (timeout) return setTimeout($.proxy(this.refreshScroll, this), timeout * 1);
	if (this.scroll) this.scroll.refresh();
	this.refreshScrollMore();
}

CitySkinSelector.prototype.createCitySkin = function(race, type, level, skinIndex)
{
    var container = document.createElement('skin');
    
    var img = STATIC_URL + Assets.B_findBy(race, race.name == Race.CASTLE_MONSTER.name ? BType.CASTLEHALL : BType.CITYHALL, null, skinIndex);
    var tile = document.createElement('skin-tile');
	tile.style.backgroundImage = 'url("' + img + '")'; 
    
    container.setAttribute('tag', skinIndex);
    
    COM.bindExclusiveClick(container, $.proxy(function(e)
    {
        $('skin', container.parentNode).removeClass('selected');
        $(container).addClass('selected');
        
        if (typeof this.onSkinChanged == 'function')
        {
        	this.onSkinChanged(container.getAttribute('tag') * 1);
        }
        
    }, this));
	
    container.appendChild(tile);
	return container;
}

CitySkinSelector.prototype.update = function(race, type, level, skinIndex)
{
    $(this.skinsTile).find('*').remove();
    for (var imgSkinIndex = 0; imgSkinIndex < FConfig.CITY_SKIN_PRICES.getValue(race).length; imgSkinIndex++) 
    {
        var skin = this.createCitySkin(race, type, level, imgSkinIndex);
        if (skinIndex != imgSkinIndex) 
        {
            $(this.skinsTile).append(skin);
        }
    }
    this.refreshScroll(300);
}
