function DeleteDialog()
{
	callParentConstructor(this);
	
	this.b = null;	
	this.cellIndex = 0; 
}

extendClass(DeleteDialog.prototype, UpdatableEstateDialog.prototype);

DeleteDialog.prototype.b = null;//FBuilding;
DeleteDialog.prototype.cellIndex = 0; 

DeleteDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.doDestroy, $.proxy(this.onDestroy, this));
	COM.bindExclusiveClick(this.noDestroy, $.proxy(this.close, this));
}

DeleteDialog.prototype.onResult = function()
{
    APP.showLoader();
    Service.city.callMethod('deleteBuilding', [this.b.estate.id, this.b.id],
    	$.proxy(function(){
    		
    		APP.hideLoader();
    		this.close();
    		if (this.dialogParent && this.dialogParent.manageDialog)
    		{
    			this.dialogParent.manageDialog.close();
    		}
    		return true;
    		
    	}, this),
    	$.proxy(function(e){
    		
    		APP.hideLoader();
    		this.close();
    		Alert.error(I18.f('ERROR_INTERNAL_ERROR'), 'ERROR');
    		return true;
    		
    	}, this)
    );
};

DeleteDialog.prototype.popup = function(parent, estate, b, cellIndex)
{
	this.estate = estate;
    this.b = b;
    this.cellIndex = cellIndex;
    
    var uiFlag = b.type.isSpecialUnitProducer() && b.unitsTotal + b.unitsQueued > 0;
    UI.show(uiFlag, [this.supBox]);
    if (uiFlag)
    {
	    COM(this.unitView).utype = b.type.getUnitType(b.race);
	    COM(this.unitView).race = b.race;
	    this.unitName.innerHTML = I18.getUnitName(b.type.getUnitType(b.race), 1, b.race);
	    this.update(estate);
    }
    
    var buildingStr = b.isPerfect()
    	? I18.getBuildingName(b.type, b.race, b.resource)
    	: I18.getBuildingAndLevelFrom(b.race, b.type, b.level)
    ;
    buildingStr += ' (' + this.estate.getCellLocationText(cellIndex) + ')';
    buildingStr = buildingStr.replace(/\s+/g, '&nbsp;');

    this.confirmLabel.innerHTML = (b.isPerfect() 
    	? I18.f('BUILDING_DELETE_CONFIRM_PERFECT', buildingStr) 
    	: I18.f('BUILDING_DELETE_CONFIRM', buildingStr)
    );
    
    var title = b.getName(), subCaption = "";
    if (b.isPerfect())
    {
    	this.setCaption('<img src="' + (STATIC_INTERFACE_URL + 'icons/perfect.png') + '" />' + title);
    	if(cellIndex >= 0) subCaption = this.estate.getCellLocationText(cellIndex);
    }
    else
    {
    	this.setCaption(title);
    	subCaption = b.level && b.level > 0 ? I18.f('LEVEL_X', b.level) : '';
    	if(cellIndex >= 0) subCaption += (subCaption != "" ? ", " : "") + this.estate.getCellLocationText(cellIndex);
    }
    
    this.setSubCaption(subCaption);
    
    superMethod(this, 'popup')(parent);
}

DeleteDialog.prototype.update = function(estate) 
{
    this.estate = estate;
    this.tick();
}

DeleteDialog.prototype.tick = function()
{
    if (this.b && this.b.type.isUnitProducer()) 
    {
        COM(this.unitView).update(1, this.b.unitsTotal + this.b.unitsQueued, this.b.unitsCapacity);
    }
}

DeleteDialog.prototype.onDestroy = function()
{
    this.onResult();
    this.onResult = Dialog.EMPTY_FUNCTION;
}
