function EstateTicker(onUpdate, onTick, onError)
{
	this.ticker = new Ticker(1000, $.proxy(this.tick, this));
	
	this._estate = null;
    
    this.lastRequestTime = 0;
	
	this.onTick = onTick;
    this.onUpdate = onUpdate;
    this.onError = onError;
    
    this.__defineGetter__("estate", function()
    {
        return this._estate;
    });
    
    this.renew = true;
};

EstateTicker.prototype.isReady = function ()
{
	return true;
};

EstateTicker.prototype.start = function(cityId, preloadedEstate)
{
    this.ticker.pause();
    Events.onFEstateUpdated.add(this, this.updateCity);
    Events.onMissionCancel.add(this, this.refreshCityOnMissionAssistCancel);
    if (!preloadedEstate)
    {
        this.requestNewCity(cityId);
    }
    else
    {
        this.updateCity(preloadedEstate);
    }
};

EstateTicker.prototype.pause = function()
{
    this.ticker.pause();
    Events.onFEstateUpdated.remove(this, this.updateCity);
    Events.onMissionCancel.remove(this, this.refreshCityOnMissionAssistCancel);
};

EstateTicker.prototype.stop = function()
{
    this.ticker.stop();
    Events.onFEstateUpdated.remove(this, this.updateCity);
    Events.onMissionCancel.remove(this, this.refreshCityOnMissionAssistCancel);
};

//var gcrt = null;
EstateTicker.prototype.requestNewCity = function(cityId)
{
    this.ticker.pause();
    var id = !cityId && this._estate ? this._estate.id : cityId;
    //gcrt = new Date().getTime();
    Service.city.callMethod("getById", [id]);
};

EstateTicker.prototype.refreshCityOnMissionAssistCancel = function(m)
{
    if (!this.ticker.started)
    {
        return;
    }

    if (m.isAssist && MissionState.EXECUTING.equals(m.state) && m.to.id.equals(this._estate.id))
    {
        this.requestNewCity(this._estate.id);
    }
};

EstateTicker.prototype.updateCity = function(c)
{
    if (c.requestTime < this.lastRequestTime || !this.ticker.started)
    {
        return;
    }

    this.lastRequestTime = c.requestTime;
    this.ticker.pause();
    Tick.updateTick(c.responseTick);
	
	//console.log("RESPONSE", c.responseTick, c.nextUpdateTick);
    
    this.ticker.start();

    this._estate = c;
    
    if (this.onUpdate)
    {  
        this.onUpdate(this._estate);
    }
};

EstateTicker.prototype.tick = function(delta)
{
    if(!FUser.CURRENT_USER || !this._estate) return;
    
    FUser.CURRENT_USER.tick(delta);
    this._estate.responseTick += delta;
    
    if (this.isReady() && !APP.ticksIsPaused)
    {
        //this._estate.nextUpdateTick += 100;
        if (Tick.now() > this._estate.nextUpdateTick)
        {
			this.requestNewCity(this._estate.id);
            this.renew = true;
        }
        else
        {
            this._estate.owner.tick(delta);
           	this._estate.tick(delta);
           	
            if (this.onTick /*&& this.renew*/)
            {
                this.onTick();
                this.renew = false;
            }
        }
    }
};