function EstateView()
{
	this._estate = null;
	
    this.hexes = null;
    this.garrisonView = null;
    this.estateCombo = null;
    this.resourcesToLoot = null;
    this.peopleToLoot = null;
    this.pearlToLoot = null;
    this.allyNameLabel = null;
    this.accountDestructionLabel = null;
    this.sectorCorruptionLabel = null;
    this.specializationImage = null;
    this.dashboard = null;
    this.sendMessageToOwner = null;
    this.saveReportButton = null;
    this.questAdvisor = null;
    this.distributeWorkers = null;
    this.toolbar = null;
    this.settingsButton = null;
    this.serverTimeLabel = null;
    this.pearlBox = null;
    this.bankView = null;
    this.allPeople = null;
    this.busyPeople = null;
    this.freePeople = null;
    
    this.buildQueue = null;
	
	this.updatableDialog = null; //UpdatableEstateDialog;

	this.autofireAdvisorShown = false;
	this.rebellionAdvisorShown = false;
	
	this.onReturnToKingdom = this.returnToKingdomDefault;
	this.onSaveReport;
	
	this.rightPanelExpanded = false;
	this.leftPanelExpanded = false;
	
	this.__defineGetter__("estate", function()
	{
		return this._estate;
	});
	
	this.__defineSetter__("estate", function(value)
	{
		this._estate = value;
	    
	    this.estateCombo.links = value.links;
	    
	    this.allPeople.source = STATIC_INTERFACE_URL + Assets.getAllPeopleIcon(this.estate.owner.race);
        this.freePeople.source = STATIC_INTERFACE_URL + Assets.getFreePeopleIcon(this.estate.owner.race);
        this.busyPeople.source = STATIC_INTERFACE_URL + Assets.getBusyPeopleIcon(this.estate.owner.race);
        this.peopleToLoot.source = STATIC_INTERFACE_URL + Assets.getFreePeopleIcon(this.estate.owner.race);
	});
	
	this.onReady = null;
}

EstateView.prototype.__construct = function()
{
    this.wrapper = $(this.estateWrapper);
    
    this.hexes = COM.create('HexesCanvas');
	this.wrapper.append(this.hexes.DOM);

    this.garrisonView = COM.create('CityGarrisonPanel');
	this.DOM.appendChild(this.garrisonView.DOM);

    this.estateCombo = COM.create('GlobalSelectionCitiesCombo');
	this.DOM.appendChild(this.estateCombo.DOM);

	//this.wrapper.append(this.resourcesToLoot);
	
	var rl = COM(this.resourcesToLoot);
	rl.showZero = true;
	rl.alwaysHide = [Resource.PEOPLE];
	rl.shortView = true;
	
    this.peopleToLoot = COM.create('IconAndValue');
    $("div[name='icons']", this.resourcesToLoot).append(this.peopleToLoot.DOM);
    var label = document.createElement("div");
	label.name = "resourceToLootContainer";
	label.innerHTML = I18.f('RESOURCES_TO_LOOT');
	$("div[name='icons']", this.resourcesToLoot).append(label);

    //this.pearlToLoot = COM.create('IconAndValue');
	//this.wrapper.append(this.pearlToLoot);

    this.allyNameLabel = COM.create('ShadowedLabel');
	//this.wrapper.append(this.allyNameLabel);

    this.accountDestructionLabel = $(document.createElement('div'));
    this.accountDestructionLabel.css({
    	'position': 'absolute',
    	'display': 'none',
    	'left': 10, 'top': 350,
    	'width': 300, 'text-align': 'center',
    	'color': 'red',
    	'font-size': '20px',
    	'padding': '5px',
    	'background': 'rgba(255,255,128,0.8)',
    	'border-radius': '5px',
    	'cursor': 'pointer' 
    });
	
	this.wrapper.append(this.accountDestructionLabel);
	
	this.accountDestructionLabel.one(CLICK_EVENT, $.proxy(function(){
		this.accountDestructionLabel.slideUp('fast');
	}, this));

    this.sectorCorruptionLabel = $(document.createElement('div'));
    this.sectorCorruptionLabel.css({
    	'position': 'absolute',
    	'display': 'none',
    	'left': 10, 'top': 150,
    	'width': 300, 'text-align': 'center',
    	'color': 'red',
    	'font-size': '20px',
    	'padding': '5px',
    	'background': 'rgba(255,255,128,0.8)',
    	'border-radius': '5px',
    	'cursor': 'pointer' 
    });
	this.wrapper.append(this.sectorCorruptionLabel);
	this.sectorCorruptionLabel.one(CLICK_EVENT, $.proxy(function(){
		this.sectorCorruptionLabel.slideUp('fast');
	}, this));

    this.specializationImage = COM.create('HitImage');
	//this.wrapper.append(this.specializationImage);

    //this.dashboard = COM.create('Dashboard');
	//this.wrapper.append(this.dashboard);

	COM(this.sendMessageToOwner).icon = STATIC_INTERFACE_URL + "city/send_message_to_owner.png";
	COM(this.sendMessageToOwner).skin = "green";

	COM(this.saveReportButton).icon = STATIC_INTERFACE_URL + "city/save_report.png";

    this.questAdvisor = COM.create('QuestButton');
	this.wrapper.append(this.questAdvisor.DOM);
	
    this.toolbar = COM.create('ScreenToolbar');
	//this.wrapper.append(this.toolbar);

    this.settingsButton = COM.create('RoundButton');
	//this.wrapper.append(this.settingsButton);
	
	this.showCityPanels = $.proxy(this.showCityPanels, this);

    this.serverTimeLabel = COM.create('ServerTimeLabel');
	this.wrapper.append(this.serverTimeLabel.DOM);
	COM.bindExclusiveClick(this.serverTimeLabel.DOM, this.showCityPanels);

    //this.pearlBox = COM.create('PearlBox');
	//this.wrapper.append(this.pearlBox);
	
	var bv = COM(this.bankView), icons = bv.DOM.querySelector('div[name="icons"]');
	bv.showZero = true;
	bv.doHighlightIfEquals = true;
	bv.alwaysHide = [Resource.PEOPLE];
	bv.shortView = true;
	
	icons.appendChild(this.allPeople);
	icons.appendChild(this.freePeople);
	icons.appendChild(this.busyPeople);

	this.allPeople = COM(this.allPeople);
	this.freePeople = COM(this.freePeople);
	this.busyPeople = COM(this.busyPeople);

    this.onPreinitialize();
    this.onInit();
    this.onCreated();
    
    //$(this.questAdvisor.DOM).css({"position": "absolute", "left": "0", "top": 0, "z-index": 10000, "-webkit-transform": "translate3d(0px, 0px, 0px)"});
    
    /////////////// Events //////////////
    
    COM.bindExclusiveClick(this.locker, $.proxy(this.hidePanels, this));
    COM.bindExclusiveClick(this.changeEstateButton, $.proxy(this.toggleRightPanel, this));
	COM.bindExclusiveClick(this.garrisonButton, $.proxy(this.toggleLeftPanel, this));
	
	//Navigation
	var btnNav = COM(this.dashboard).navigationButton;
	COM.bindExclusiveClick(btnNav, $.proxy(this.onShowKingdom, this))
	$('picker', COM(btnNav).pickers).removeClass('active');
	$('picker', COM(btnNav).pickers)[0].className = 'active';
	
	var btnHero = COM(this.dashboard).heroFaceButton;
	COM(COM(this.dashboard).heroView).onHeroClick = $.proxy(this.createHeroDialog, this);
	
	COM.bindExclusiveClick(this.buildQueueButton, $.proxy(this.showBuildQueue, this));
	
	/*
	COM.bindExclusiveClick(this.showOtherScience, $.proxy(function()
	{
		COM(COM(this.dashboard).showScience).onShowScience();
	}, this));
	*/
	
	COM(this.pearlToLoot).icon = STATIC_INTERFACE_URL + CommonAssets.ICON_PEARL;

	COM(this.changeViewLevel).icon = STATIC_INTERFACE_URL + "icons/show_grid.png";
	COM.bindExclusiveClick(this.changeViewLevel, $.proxy(this.switchViewLevel, this));
	
	Events.onForceCityUpdate.add(APP, $.proxy(function()
    {
        if(this.estate) this.hexes.update(this.estate, true);
    }, this));
	
	this.cityPanelsHidden = false;
}

EstateView.prototype.fitLayout = function(container)
{
	$(this.locker).css({
			width: container.width,
			height: container.height
	});
	
	var toppanel = $("> toppanel", this.DOM);
	var bottompanel = $("> bottompanel", this.DOM);
	
	toppanel.css("width", container.width);
	$("> estate", this.DOM).css("width", container.width);
	bottompanel.css("width", container.width);
	
	$(this.bankView).css("width", container.width);
	$(this.resourcesToLoot).css("width", container.width);
	
	$(this.estateCombo.DOM).css("left", container.width);
	$("> wrapper", this.estateCombo.DOM).css("height", container.height - bottompanel.height());
	
	this.garrisonView.fitLayout(container);
	
	this.alignQuestAdvisor();
	this.alignBuildQueueButton();
	
	this.alignServerTimeLabel(container);
	
	var height = container.height - toppanel.height()
	height -= (this.bankView.clientHeight + this.resourcesToLoot.clientHeight);
	height -= bottompanel.css("display") != "none" ? bottompanel.height() : 0;
	
	$("> estate", this.DOM).css("height", height);
	
	//$(this.serverTimeLabel.DOM).css("top", toppanel.height() + $(this.bankView).height() + $(this.resourcesToLoot).height() + container.height - $("> wrapper", this.serverTimeLabel.DOM).height() + 3);
	
	container.height = height;
	this.hexes.fitLayout(container);
}

EstateView.prototype.switchViewLevel = function()
{
	this.hexes.switchHexState();
	Service.user.callMethod('updateHexState', [this.hexes.getHexStateIndex(), this.estate.isExpeditionReport]);
}

EstateView.prototype.alignServerTimeLabel = function(container)
{
	if(!container)
	{
		container = {width: window.innerWidth, height: window.innerHeight};
	}
	
	var bottompanel = $("> bottompanel", this.DOM);
	
	/*
	var top = bottompanel.css("display") != "none" ? container.height - bottompanel.height() : container.height;
	$(this.serverTimeLabel.DOM).css("top", top - $("> wrapper", this.serverTimeLabel.DOM).height() + 3);
	*/
	
	$(this.serverTimeLabel.DOM).css("bottom", bottompanel.css("display") != "none" ? bottompanel.height()-3 : 0);
	$(this.serverTimeLabel.DOM).css("left", (container.width - $("> wrapper", this.serverTimeLabel.DOM).width())/2);
}

EstateView.prototype.alignQuestAdvisor = function()
{
	//this.questAdvisor.DOM.style.left = (window.innerWidth - 37*INTERFACE_IMAGES_PACK)+"px";
	//this.questAdvisor.DOM.style.top = (window.innerHeight - 75*INTERFACE_IMAGES_PACK)+"px";
}

EstateView.prototype.alignBuildQueueButton = function()
{
	//this.buildQueueButton.style.left = (2*INTERFACE_IMAGES_PACK)+"px";
	//this.buildQueueButton.style.top = (window.innerHeight - 75*INTERFACE_IMAGES_PACK)+"px";
}

EstateView.prototype.hideCityPanels = function()
{
	this.cityPanelsHidden = true;
	
	UI.show(false, [this.questAdvisor.DOM, this.buildQueueButton, this.estateCasts, this.ownerCastsView]);
	
	clearTimeout(this.returnCityPanelsTimer);
	this.returnCityPanelsTimer = setTimeout(this.showCityPanels, 2000);
	
	return;
	
	/*
	clearTimeout(this.returnCityPanelsTimer);
	this.returnCityPanelsTimer = setTimeout(this.showCityPanels, 3000);
	
	if(this.cityPanelsHidden) return;
	
	var toppanel = $("> toppanel", this.DOM);
	var bottompanel = $("> bottompanel", this.DOM);
	
	var height = window.innerHeight;

	var view = $("> estate", this.DOM);
	view.css({"height": window.innerHeight, "top": 0});
	this.hexes.fitLayout({width: window.innerWidth, height: window.innerHeight});
	
	var h = this.hexes.getCurrentView();
	
	h.cityScroll.scrollTo(h.cityScroll.x, h.cityScroll.y + toppanel.height() + $(this.bankView).height(), 0);
	
	UI.show(false, [toppanel, this.bankView, this.resourcesToLoot, bottompanel]);
	//this.serverTimeLabel.DOM.style.top = (window.innerHeight - $("> wrapper", this.serverTimeLabel.DOM).height() + 3) + "px";
	
	var p = $(this.questAdvisor.DOM).position();
	this.questAdvisor.DOM.style.top = p.top + bottompanel.height() + "px";
	
	this.fieldInfo.style.display = "none";
	
	this.alignServerTimeLabel();
	
	this.cityPanelsHidden = true;
	*/
}

EstateView.prototype.showCityPanels = function()
{
	this.cityPanelsHidden = false;
	
	UI.show((COM(this.estateCasts).casts || []).length /*&& this.estate.accessManageble*/, [this.estateCasts]);
	UI.show((COM(this.ownerCastsView).casts || []).length /*&& this.estate.accessManageble*/, [this.ownerCastsView]);
	
	this.questAdvisor.DOM.style.display = (this.estate.accessManageble && !(this.estate.__className__ == "FCastle" || this.estate.__className__ == "FCatapult")) ? "block" : "none";
	
	this.updateBuildQueueState();
	
	clearTimeout(this.returnCityPanelsTimer);
	
	return;
	
	/*
	if(!this.cityPanelsHidden) return;
	
	clearTimeout(this.returnCityPanelsTimer);
	
	var toppanel = $("> toppanel", this.DOM);
	var bottompanel = $("> bottompanel", this.DOM);
	
	UI.show(true, [toppanel, this.bankView]);
	
	var h = this.hexes.getCurrentView();
	
	this.updateHeader(this.estate);
	this.updateLoot();
	this.updateFooter(this.estate);
	
	var top = h.cityScroll.y - toppanel.height() - $(this.bankView).height();
	top -= this.resourcesToLoot.style.display != "none" ? $(this.resourcesToLoot).height() : 0;
	h.cityScroll.scrollTo(h.cityScroll.x, top, 0);
	
	this.fitLayout({width: window.innerWidth, height: window.innerHeight});
	
	this.cityPanelsHidden = false;
	APP.resumeTicks();
	*/
}

EstateView.prototype.onShowKingdom = function()
{
	HintArrow.OPEN_KINGDOM.understood();
	HintArrow.hideAll();
	
	if(this.onReturnToKingdom)
	{
		this.onReturnToKingdom();
	}
	else
	{
		APP.showKingdom(this.estate.location);
	}
}

EstateView.prototype.toggleLeftPanel = function()
{
	if(this.leftPanelExpanded)
	{
		this.hidePanels();
	}
	else
	{
		this.showLeftPanel();
	}
}

EstateView.prototype.toggleRightPanel = function()
{
	if(this.rightPanelExpanded)
	{
		this.hidePanels();
	}
	else
	{
		this.showRightPanel();
	}
}

EstateView.prototype.hidePanels = function()
{
	//this.css({left: "0px"});
	//this.DOM.style.webkitTransitionDuration = "300ms";
	//this.DOM.style.webkitTransform = "translate3d(0px, 0px, 0px)";
	
	$(this.DOM).removeClass("leftPanelExpanded");
	$(this.DOM).removeClass("rightPanelExpanded");
	this.leftPanelExpanded = false;
	this.rightPanelExpanded = false;
	this.locker.style.display = "none";
}

EstateView.prototype.showLeftPanel = function()
{
	//this.css({left: "480px"});
	//this.DOM.style.webkitTransitionDuration = "300ms";
	//this.DOM.style.webkitTransform = "translate3d(480px, 0px, 0px)";
	
	$(this.DOM).addClass("leftPanelExpanded");
	this.leftPanelExpanded = true;
	this.locker.style.display = "block";
	
	COM(this.garrisonView).refreshScroll();
}

EstateView.prototype.showRightPanel = function()
{
	//this.DOM.style.webkitTransitionDuration = "300ms";
	//this.DOM.style.webkitTransform = "translate3d(-480px, 0px, 0px)";
	
	$(this.DOM).addClass("rightPanelExpanded");
	this.rightPanelExpanded = true;
	this.locker.style.display = "block";
	
	COM(this.estateCombo).refreshScroll();
}

EstateView.prototype.onPreinitialize = function() 
{
	//visible = false;
	//ToolTipManager.enabled = false;
}

EstateView.prototype.onInit = function()
{
    this.hexes.ownDialog = $.proxy(this.ownDialog, this);
    this.hexes.onInit();
    
    if (this.specializationImage) 
    {
        /*
        this.specializationImage.addEventListener(ToolTipEvent.TOOL_TIP_CREATE, function (event:ToolTipEvent):void {
            var spec:Science = estate.science.getResearchedSpecial();
            event.toolTip = spec != null ? ScienceTip.create(estate.science, spec, estate.owner.race, true, estate.owner.isInRegisteredClan()) : Tip.create(I18.NO_SPECIALIZATION.f());
        });
        */
    }
    this.estateCombo.onChange = $.proxy(function(e) 
    {
        this.hidePanels();
        var id = e.id ? e.id : e.estateInfo.id;
        Events.onShowCity.fire(id);
        APP.showLoader();
    }, this);
    
    COM(this.dashboard).onShowMissions = $.proxy(function()
    {
        var user = this.estate.owner.username == FUser.CURRENT_USER.username ? FUser.CURRENT_USER : this.estate.owner;
        MissionListDialog.popup(null, user, this.estate.id, null, null, this.estate.getMilitaryInfo());
    }, this);
    
    COM.bindExclusiveClick(this.saveReportButton, $.proxy(function()
    {
    	if(this.onSaveReport)
    	{
    		this.onSaveReport();
    	}
    }, this));
    
    COM.bindExclusiveClick(COM(this.dashboard).backToKingdom, $.proxy(function(e)
    {
        if(this.onReturnToKingdom)
        {
        	this.onReturnToKingdom();
        }
        
    }, this));
    
    COM.bindExclusiveClick(this.sendMessageToOwner, $.proxy(function(e)
    {
        if (this.estate.__className__ == "FRuin") 
        {
            MailBoxView.i().sendMessageToMonsters(this.estate.id);
        } 
        else 
        {
            MailBoxView.i().sendMessage(FUser.getUserNameForMessages(this.estate.owner.username));
        }
    }, this));
    
    COM.bindExclusiveClick(this.questAdvisor.DOM, $.proxy(this.questAdvisorClick, this));

    COM(this.bankView).onTip = $.proxy(this.onCapacityTip, this);
    COM(this.resourcesToLoot).onTip = $.proxy(this.onLootTip, this);
    
    $(this.allPeople.DOM).off(CLICK_EVENT);
    COM.bindExclusiveClick(this.allPeople.DOM, $.proxy(this.onAllPeopleTip, this));
    
    $(this.freePeople.DOM).off(CLICK_EVENT);
    COM.bindExclusiveClick(this.freePeople.DOM, $.proxy(this.onFreePeopleTip, this));
    
    $(this.busyPeople.DOM).off(CLICK_EVENT);
    COM.bindExclusiveClick(this.busyPeople.DOM, $.proxy(this.onBusyPeopleTip, this));
}

EstateView.prototype.questAdvisorClick = function() 
{
	if(this.cityPanelsHidden)
    {
    	this.showCityPanels();
    	return;
    }
    
    var firstTime = !FUser.CURRENT_USER.haveSeenQuestAdvisor;
    if (firstTime) 
    {
        Service.user.callMethod('iHaveSeenQuestAdvisor', [], function(user)
        {
			//Service.user.callMethod('pleaseBelieveMe_IReallyHaveSeenQuestAdvisor', []);
			FUser.updateCurrentUser(user);
		});
    }
    
    QuestsView.showDialog();
    return firstTime;
}

EstateView.prototype.onCreated = function(e) 
{
    //this.hexes.setShowingAnimation(FUser.CURRENT_USER.settings.estateAnimationEnabled);
    if (this.estate) 
    {
        this.callLater(this.canShow);
    }
    
    Events.onFUserUpdated.add(this, this.updateArrows);
}

EstateView.prototype.heroClickFactory = function(buffsGetter)
{
    return $.proxy(function (h, r)
    {
        this.ownDialog(HeroDialog.popup(this.estate, h, r, buffsGetter(), NaN, false, true));
        
    }, this);
}

EstateView.prototype.canShow = function()
{
}

EstateView.prototype.updateEstateCombo = function(e)
{
    this.estateCombo.selected = e.getLink();
    this.changeEstateButton.enabled = e.accessCombo;
}

EstateView.prototype.updateBuildQueueState = function()
{
	this.buildQueueButton.style.display = (this.estate.buildQueue && this.estate.buildQueue.length > 0) && !this.cityPanelsHidden ? "block" : "none";
}

EstateView.prototype.showBuildQueue = function()
{
	this.buildQueue = COM.create("BuildQueueView");
	this.buildQueue.popup();
	this.buildQueue.update(this.estate);
	
	this.buildQueue.onClose = $.proxy(function()
	{
		this.buildQueue = null;
	}, this);
}

EstateView.prototype.update = function(e)
{
    var isNewEstate = !this.estate || !this.estate.equals(e);
    this.estate = e;
    
    var shouldValidate = this.hexes.update(e);
    
    /* Button */
	var b = COM.get(this.changeEstateButton);
    b.caption = e.name;
    b.subCaption = e.id.toString();
    b.icon = STATIC_INTERFACE_URL + e.getLink().estateInfo.getEstateIcon();
    
    var b = COM.get(this.estateInfoLabel);
    b.subCaption = "[" + e.id.toString() + "]";
    
    if(e.isExpeditionReport)
    {
    	b.caption = e.terrain.displayName;
    	b.icon = null;
    }
    else
    {
    	b.icon = STATIC_INTERFACE_URL + e.getLink().estateInfo.getEstateIcon();
    	b.caption = e.name;
    }
    
    this.updateEstateCombo(e);
    
    this.updateHeader(e);
    this.updateFooter(e);
    
    if (this.updatableDialog) 
    {
        this.updatableDialog.update(this.estate);
    }
    
    if(!this.debugAction)
    {
		this.debugAction = true;
	}
	
	this.updateLoot();
	
	if(isNewEstate)
	{
		COM(this.fieldInfoView).terrain = e.terrain;
		COM(this.fieldInfoView).init();
	}
	
	if(!e.isExpeditionReport)
	{
        this.garrisonView.update(e);
    }
	
	if (FUser.CURRENT_USER.isOnVacation())
	{
        OnVacationDialog.spawn();
    }
    
    var magicDisabled = FBuff.hasMagicDisable(this.estate.buffs, FEstate.tickNowForEstate(this.estate));
    
    var estateSpells = Arrays.filter(this.estate.casts, function (c) { return !c.fromOwner && c.isVisible; });
    COM(this.estateCasts).update(this.estate, null, estateSpells, magicDisabled);
    UI.show(estateSpells.length, [this.estateCasts]);
    
    /*
    if (UI.show(estateSpells.length, [this.estateCasts]))
    {
    	COM(this.estateCasts).update(this.estate, null, estateSpells, magicDisabled);
    }
    */
    
    var ownerSpells = Arrays.filter(this.estate.casts, function (c) { return c.fromOwner && c.isVisible; });
    COM(this.ownerCastsView).update(this.estate, null, ownerSpells, magicDisabled);
    UI.show(ownerSpells.length, [this.ownerCastsView]);
    
    /*
    if (UI.show(ownerSpells.length, [this.ownerCastsView]))
    {
    	COM(this.ownerCastsView).update(this.estate, null, ownerSpells, magicDisabled);
    }
    */
    
    this.updateBuildQueueState();
    
    if(this.buildQueue) this.buildQueue.update(this.estate);
    
	if (isNewEstate)
	{
        this.hexes.setHexStateIndex(e.isExpeditionReport ? FUser.CURRENT_USER.settings.expeditionHexState : FUser.CURRENT_USER.settings.estateHexState);
    }
	
	var advisorsToShow = [];
    if (e.__className__ == "FCity")
    {
        var c = e;
        if (isNewEstate && c.requestRename && c.accessManageble)
        {
            var showRename = true;
            if (c.isFirstEnteringToFirstCity())
            {
                advisorsToShow.push(AdvisorInfoDialog.create(I18.f("ADVISOR_WELCOME"), e.owner.race));
                showRename = FConfig.SHOW_RENAME_DIALOG_TO_NEWBIES;
            }
            if (showRename)
            {
                advisorsToShow.push(RenameDialog.create(c, FConfig.PLAY_ADVISOR_ANIMATION_TO_NEWBIES && c.isFirstEnteringToFirstCity() ? this.playAdvisorAnimation : null));
            }
            else
            {
                Service.city.callMethod("rename", [estate.id, null]);
            }
        }
    }
    
    if (FUser.CURRENT_USER.showAdvisor && e.accessDeputy && !this.autofireAdvisorShown)
    {
        advisorsToShow.push(AdvisorDialog.create(e));
        this.autofireAdvisorShown = true;
    }
    if (FUser.CURRENT_USER.showRebellion && e.accessDeputy && !this.rebellionAdvisorShown)
    {
        advisorsToShow.push(AdvisorInfoDialog.create(I18.f("ADVISOR_GATE_WAS_OPENED_BY_FORCE"), FUser.CURRENT_USER.race));
        this.rebellionAdvisorShown = true;
    }
    if (advisorsToShow.length > 0)
    {
        advisorsToShow[advisorsToShow.length - 1].onClose = $.proxy(function()
        {
            Service.user.callMethod("iHaveSeenAdvisors");
            this.autofireAdvisorShown = false;
            this.rebellionAdvisorShown = false;
        }, this);
    }
    
    for(var i=0; i<advisorsToShow.length; i++)
    {
    	advisorsToShow[i].popup();
    }
	
	this.updateArrows();
	
	this.tick(true);
	
	if(this.onReady) this.onReady();
}

EstateView.prototype.updateArrows = function()
{
	if(!this.estate) return;
	if(!APP.currentScreenIsCity()) return;
	
	this.hexes.updateArrow(this.estate);
	this.updateFooterArrows();
}

EstateView.prototype.createHeroDialog = function()
{
	if (!this.estate) return;
	
	var heroView = COM(COM(this.dashboard).heroView);
	
	HeroDialog.create(
		this.estate, 
		heroView.hero, 
		this.estate.garrison, 
		heroView.race, 
		FBuff.getBuffsForGarrison(this.estate, this.estate.buffs) || [], 
		NaN, 
		false
	);
}

EstateView.prototype.playAdvisorAnimation = function()
{
    //var center:Point = questAdvisor.parent.globalToLocal(localToGlobal(new Point((width - questAdvisor.width) / 2, (height - questAdvisor.height) / 2)));
    //questAdvisor.playMoveAnimation(center);
}

EstateView.prototype.updateLoot = function()
{
    var doShowLoot = this.estate.isEspionage && !this.estate.isExpeditionReport;
    
    var uiFlag;
    
    uiFlag = doShowLoot;
    
    this.resourcesToLoot.style.display = uiFlag ? "" : "none";
    this.peopleToLoot.DOM.style.display = uiFlag ? "" : "none";
    if (uiFlag)
    {
        COM(this.resourcesToLoot).update(this.estate.canLoot, this.estate.race);
        this.peopleToLoot.value = this.estate.canLoot.people.toString();
    }

    uiFlag = doShowLoot && (this.estate.__className__ == "FRuin" || this.estate.__className__ == "FEvil");
    this.pearlToLoot.style.display = uiFlag ? "" : "none";
    if (uiFlag)
    {
    	COM(this.pearlToLoot).caption = this.estate.owner.pearl.toString();
    }
}

EstateView.prototype.tick = function(force)
{
    if (this.estate.isEspionage || this.estate.isExpeditionReport) 
    {
        this.serverTimeLabel.setFrozen(this.estate.responseTick);
    } 
    else 
    {
        this.serverTimeLabel.tick();
    }
	
	//this.hexes.tick(force);
	this.hexes.tick();
	
	APP.scienceView.tick();
	
	COM(this.dashboard).tick(this.estate);
	
	var uiFlag;
	
	uiFlag = this.estate.accessDeputy && (this.estate.__CLS__.split('.').pop() == 'FCity') && this.estate.nextCorruptionTick > 0;
    var v = uiFlag ? "" : "none";
    if(this.sectorCorruptionLabel.css("display") != v)
    {
    	this.sectorCorruptionLabel.css("display", uiFlag ? "" : "none");
    }
    if (uiFlag)
    {
    	this.sectorCorruptionLabel.html(I18.f('TIME_TO_SECTOR_CORRUPTION', Tick.toTimeLeft(Tick.ticksTill(this.estate.nextCorruptionTick))));
    }
	
	uiFlag = this.estate.accessDeputy && this.estate.owner.deletionTick > 0;
	var v = uiFlag ? "" : "none";
    if(this.accountDestructionLabel.css("display") != v)
    {
    	this.accountDestructionLabel.css("display", v);
    }
    if (uiFlag)
    {
    	this.accountDestructionLabel.html(I18.f('TIME_TO_ACCOUNT_DELETION', Tick.toDays(Tick.ticksTill(this.estate.owner.deletionTick))));
    }
    
    if(!force && !GLOBAL_TICKS_ENABLED)
    {
    	return;
    }
    
    this.tickHeader();
    
    if (this.updatableDialog)
    {
        this.updatableDialog.tick();
    }
    
    //if(!this.dashboard.showScience.scienceView && this.dashboard.showScience.userScience) this.dashboard.showScience.onShowScience();
    
    if (this.garrisonView.DOM.style.display != "none") 
    {
        this.garrisonView.tick();
    }
}

EstateView.prototype.resetDialog = function()
{
    if (this.updatableDialog && this.updatableDialog.onClose == this.resetDialog) 
    {
        this.updatableDialog.onClose = Dialog.EMPTY_FUNCTION;
    }
    this.updatableDialog = null;
}

EstateView.prototype.onHide = function()
{
    if (this.updatableDialog) 
    {
        this.updatableDialog.close();
        this.updatableDialog = null;
    }
}

EstateView.prototype.ownDialog = function(dialog)
{
    if (this.updatableDialog)
    {
        //this.updatableDialog.close();
        this.resetDialog();
    }
    if (dialog)
    {
	    this.updatableDialog = COM.get(dialog);
	    this.updatableDialog.onClose = $.proxy(this.resetDialog, this);
    }
    else
    {
    	this.resetDialog();
    }
}



EstateView.prototype.returnToKingdomDefault = function()
{
    if (GlobalSelectionCitiesCombo.returnEstateId) 
    {
        Events.onShowCity.fire(GlobalSelectionCitiesCombo.returnEstateId);
        GlobalSelectionCitiesCombo.returnEstateId = null;
    } 
    else 
    {
        Events.onShowKingdom.fire(this.estate.location);
    }
}

EstateView.prototype.updateFooter = function(e)
{
    COM(this.dashboard).updateEstate(e);

    /*
    $("> bottompanel", this.DOM).css("display", e.isExpeditionReport ? "none" : "");
    COM(this.dashboard).navigationButton.style.display = e.isEspionage ? "none" : "";
    */
    
    this.questAdvisor.DOM.style.display = (e.accessManageble && !(e.__className__ == "FCastle")) ? "" : "none";
    this.questAdvisor.update(FUser.CURRENT_USER.race, FUser.CURRENT_USER.questsInfo);
    
    var outer = (e.isEspionage || e.isExpeditionReport);
    
    COM(this.dashboard).navigationButton.style.display =  !outer ? "" : "none";
    COM(this.dashboard).backToKingdom.style.display =  outer ? "" : "none";
    
    this.fieldInfo.style.display =  e.isExpeditionReport ? "" : "none";
    
    this.updateFooterArrows();
    
    this.alignServerTimeLabel();
}

EstateView.prototype.updateFooterArrows = function()
{
    if(!APP.currentScreenIsCity()) return;
    
    var hint = FUser.CURRENT_USER.findHint(HintType.OPEN_KINGDOM);
    
    if (hint) 
    {
        HintArrow.OPEN_KINGDOM.show(COM(this.dashboard).navigationButton, hint, this.DOM);
    }
    if (APP.currentScreenIsCity()) 
    {
        //setTimeout($.proxy(this.questAdvisor.updateArrow, this.questAdvisor), 300);
        this.questAdvisor.updateArrow(this.estate);
    }
}

EstateView.prototype.initHeader = function() 
{
    //this.switchViewButton.source = this.hexes.getStateIcon();
}

EstateView.prototype.updateHeader = function(e) 
{
    this.distributeWorkers.style.display = e.accessDeputy ? "inherit" : "none";
    COM(this.distributeWorkers).estate = e;
    
    if(e.isExpeditionReport || e.isEspionage)
    {
    	this.changeEstateButton.style.display = "none";
    	this.pearlBox.style.display = "none";
    }
    else
    {
    	this.changeEstateButton.style.display = "";
    	this.pearlBox.style.display = "";
    }
    
    COM(this.garrisonButton).visible = !e.isExpeditionReport;
    
    COM(this.sendMessageToOwner).visible = (e.isEspionage && !(e.__className__ == "FCastle" || e.__className__ == "FCatapult") && (!this.estate.owner.isFake() || e.__className__ == "FRuin"));
    COM(this.saveReportButton).visible = (e.isEspionage || e.isExpeditionReport);
    COM(this.saveReportButton).enabled = this.onSaveReport;
    COM(this.estateInfoLabel).visible = (e.isEspionage || e.isExpeditionReport);
    
    if(e.isExpeditionReport)
    {
    	this.saveReportButton.style.float = "right";
    }
    else
    {
    	this.saveReportButton.style.float = "left";
    }
    
    //UI.show(e.accessManageble || e.__className__ == "FRuin" || FUser.CURRENT_USER.role.canSpyAndObserve() || (e.__className__ == "FCastle" && !e.isEspionage), [this.pearlBox]);

    UI.visible(!e.isExpeditionReport, [this.bankView]);
    UI.visible(!e.isExpeditionReport && !(e.__className__ == "FRuin"), [this.allPeople, this.busyPeople]);
    UI.visible(!e.isExpeditionReport, [this.freePeople]);
    
    UI.show(!this.estate.owner.isFake() && !e.isExpeditionReport, [COM(this.dashboard).showRating]);
    UI.show(e.accessManageble, [COM(this.dashboard).showSettings]);
}

EstateView.prototype.tickHeader = function()
{
    if (!this.estate.isExpeditionReport) 
    {
        this.updateBank();
    }
}

EstateView.prototype.updateBank = function() 
{
    COM.get(this.pearlBox).update(this.estate.owner);
    
    COM.get(this.bankView).capacity = this.estate.capacity;
    COM.get(this.bankView).update(this.estate.bank, this.estate.race);
    
    this.allPeople.value = Math.max(0, Math.floor(this.estate.totalCitizens));
    this.freePeople.value = Math.max(0, Math.floor(this.estate.freeCitizens));
    this.busyPeople.value = Math.max(0, Math.floor(this.estate.plodders));
    
    if (!this.estate.isExpeditionReport && this.estate.hall.accessInfo) 
    {
        this.busyPeople.styleFunds(this.estate.getWorkingPlaces() > 0);
    }
    this.allPeople.styleFunds(this.estate.totalCitizens >= this.estate.capacity.people);
}

EstateView.prototype.onCapacityTip = function(r)
{
    return BankTip.create(this.estate, r);
}

EstateView.prototype.onLootTip = function(r)
{
    return LootViewTip.create(r, this.estate);
}

EstateView.prototype.onAllPeopleTip = function(e) 
{
    return PeopleTip.create(I18.getResourceName(Resource.PEOPLE), I18.f("PEOPLE_CAPACITY") + " " + Math.max(0, Math.floor(this.estate.capacity.people)));
}

EstateView.prototype.onFreePeopleTip = function(e)
{
	return PeopleTip.create(I18.f("FREE_PEOPLE"), I18.f("FREE_PEOPLE") + ": " + Math.max(0, Math.floor(this.estate.freeCitizens)));
}

EstateView.prototype.onBusyPeopleTip = function(e) 
{
    return PeopleTip.create(I18.f("BUSY_PEOPLE"), I18.f("WORKING_PLACES") + ": " + this.estate.getWorkingPlaces());
}

EstateView.prototype.onShow = function() 
{
    this.onEstateChanged();
}

EstateView.prototype.onEstateChanged = function()
{
    //if (skin is EstateSkinSocial) EstateSkinSocial(skin).onEstateChanged();
}