function FinishConstructionMagicDialog()
{
	callParentConstructor(this);
	
	this.__defineGetter__('building', function()
	{
	    return this.estate.getCellByIndex(this._cellIndex).building;
	});

	this.updateMe = false;
	this._cellIndex = -1;
}

extendClass(FinishConstructionMagicDialog.prototype, UpdatableEstateDialog.prototype);

FinishConstructionMagicDialog.prototype.updateMe = false;
FinishConstructionMagicDialog.prototype._cellIndex = -1;

FinishConstructionMagicDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.yesButton, $.proxy(this.doAction, this));
	COM.bindExclusiveClick(this.noButton, $.proxy(this.close, this));
	
	this.setCaption(I18.f("ANCIENT_MAGIC_NAME"));
}

FinishConstructionMagicDialog.prototype.popup = function(parent, estate, cellIndex)
{
    COM(this.priceView).update(ServiceHelper.getLocalServiceDecl(ServiceDecl.FINISH_BUILDING, 0).price);
    this.updateMe = true;
    this._cellIndex = cellIndex;
    this.update(estate);
    
    superMethod(this, 'popup')(parent);
}

FinishConstructionMagicDialog.prototype.onCloseHandler = function()
{
    this.updateMe = false;
}

FinishConstructionMagicDialog.prototype.doAction = function()
{
    if (!this.estate.accessManageble) 
    {
        return;
    }
    if (!Quarantine.contains(this.ID)) 
    {
        Quarantine.put(this.ID);
        ServiceHelper.orderLocalService(ServiceDecl.FINISH_BUILDING, 0, null, this.estate.id, $.proxy(function()
        {
            this.close();
        
        }, this), false);
    }
    else
    {
    	this.close();
    }
}

FinishConstructionMagicDialog.prototype.update = function(estate)
{
    this.estate = estate;
    if (this.updateMe) 
    {
        this.tick();
    }
}

FinishConstructionMagicDialog.prototype.tick = function()
{
    var canBoost = true;
    this.problemText.innerHTML = "";

    if (!this.building) 
    {
        canBoost = false;
        this.problemText.innerHTML = I18.f('MAGIC_FINISH_CONSTRUCTION_NOW_NO_BUILDING');
        $(this.problemText).addClass('negative');
    } 
    else if (BuildingState.BUILDING_OR_UPGRADING.name != this.building.state.name) 
    {
        canBoost = false;
        this.problemText.innerHTML = I18.f('MAGIC_FINISH_CONSTRUCTION_NOW_WRONG_BUILDING_STATE');
        $(this.problemText).addClass('negative');
    } 
    else if (this.estate.isEstateUnderSiege) 
    {
        canBoost = false;
        this.problemText.innerHTML = I18.f('MAGIC_FINISH_CONSTRUCTION_NOW_DISABLED_UNDER_ATTACK');
        $(this.problemText).addClass('negative');
    }
    
    var reason = this.problemText.innerHTML;
    if(this.estate.owner.pearl < ServiceHelper.getLocalServiceDecl(ServiceDecl.FINISH_BUILDING, 0).price)
    {
    	reason = I18.f("NOT_ENOUGH_PEARL");
    }
    
    COM(this.priceView).update(ServiceHelper.getLocalServiceDecl(ServiceDecl.FINISH_BUILDING, 0).price);
    //COM(this.yesButton).enabled = canBoost && this.estate.owner.pearl >= ServiceHelper.getLocalServiceDecl(ServiceDecl.FINISH_BUILDING, 0).price;
    COM(this.yesButton).reason = reason;
}
