function FortificationDetails()
{
	this.estate = null;
	this.building = null;
	this.level = 0;
}

FortificationDetails.prototype.estate = null;
FortificationDetails.prototype.building = null;
FortificationDetails.prototype.level = 0;

FortificationDetails.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.attackBox).css('cursor', 'pointer', $.proxy(this.showSummaryTip, this));
	COM.bindExclusiveClick(this.defenseBox).css('cursor', 'pointer', $.proxy(this.showSummaryTip, this));
}

FortificationDetails.prototype.update = function(estate, levelNo, level)
{
    this.estate = estate;
    this.building = null;
    this.level = levelNo;
    this.attackerLoss.innerHTML = this.attackerLossString(estate, level);
    this.armorBonus.innerHTML = this.armorBonusString(estate, level);
}

FortificationDetails.prototype.updateFromBuilding = function(b, showTooltip)
{
    if (typeof showTooltip == 'undefined') showTooltip = true;
    
    this.estate = b.estate;
    this.building = b;
    
    if (!b.isWorking) 
    {
        this.attackerLoss.innerHTML = "0";
        this.attackerLoss.style.color = Effects.RED;
        this.armorBonus.innerHTML = "0";
        this.armorBonus.style.color = Effects.RED;
    } 
    else 
    {
        if (this.attackerLossValue(this.estate, b.getLevel()) < 0) 
        {
            this.attackerLoss.style.color = Style.COLOR_OVERFLOW;
        } 
        else 
        {
            this.attackerLoss.style.color = '';
        }
        
        this.attackerLoss.innerHTML = this.attackerLossString(this.estate, b.getLevel());
        this.armorBonus.style.color = '';
        this.armorBonus.innerHTML = this.armorBonusString(this.estate, b.getLevel());
    }
    if (!showTooltip) 
    {
        this.attackerLoss.style.textDecoration = "none";
        this.armorBonus.style.textDecoration = "none";
    }
}

FortificationDetails.prototype.attackerLossValue = function(estate, level)
{
    if (this.building && this.building.isForeign) 
    {
        return this.building.fortificationKills;
    }

    var defenderLevel = this.estate.getScienceLevel(Science.SPEC_DEFENDER);
    return (level.attackerLoss + Science.getFortificationKillsBonus(defenderLevel)) * (1 + estate.sumOfBuildingBuffs(BuffType.BOOST_BUILDING, BType.FORTIFICATION));
}

FortificationDetails.prototype.attackerLossString = function(estate, level)
{
    return I18.f('ATTACKER_LOSS_FORMAT', Math.max(0, this.attackerLossValue(estate, level)));
}

FortificationDetails.prototype.armorBonusValue = function(estate, level)
{
    if (this.building && this.building.isForeign) 
    {
        return this.building.fortificationDefence;
    }
    var defenderLevel = estate.getScienceLevel(Science.SPEC_DEFENDER);
    return level.armorBonus + Science.getFortificationDefenceBonus(defenderLevel);
}

FortificationDetails.prototype.armorBonusString = function(estate, level)
{
    var bonus = this.armorBonusValue(estate, level);
    return (bonus < 0 ? "-" : "+") + bonus;
}

FortificationDetails.prototype.showSummaryTip = function(e)
{
	var d = COM($(this.DOM).closest('ManageFortification')[0]).showSummaryTip();
	
	d.addTip(ManageFortificationTip[this.building ? 'create' : 'createForLevel'](this.estate, this.building, false), this.attackLabel.innerHTML);
	d.addTip(ManageFortificationTip[this.building ? 'create' : 'createForLevel'](this.estate, this.building, true), this.defenseLabel.innerHTML);
}
