function GateChestDialog()
{
	callParentConstructor(GateChestDialog.prototype, this);
	
	this._gateAdvisor = null;
	this.userCanClose = false;
}

extendClass(GateChestDialog.prototype, UpdatableEstateDialog.prototype);

GateChestDialog.prototype.__construct = function()
{
	this.setCaption(I18.f("ANCIENT_MAGIC_NAME"));
	
	this.tipLabel.innerHTML = I18.getString("GATE_SPEEDUP_CLOSING_TEXT").replace("{timeView}", "");
	
	COM.bindExclusiveClick(this.yesButton, $.proxy(function()
	{
		if(this._gateAdvisor)
		{
			this._gateAdvisor.close();
		}
		
		this.doAction();
		this.close();
	}, this));
	
	COM.bindExclusiveClick(this.noButton, $.proxy(this.close, this));
}

GateChestDialog.stateText = function(e, state)
{
    return I18.getEntranceStateText(e.isOuterEstate, state);
}

GateChestDialog.prototype.popup = function(parent, advisor, e)
{
    superMethod(GateChestDialog.prototype, "popup", this)(parent);
    
    this.estate = e;
    this._gateAdvisor = advisor;
    
    if(e.isGateChanging())
    {
        this.gateStatus.innerHTML = e.isGateOpen() ? GateChestDialog.stateText(e, "IS_CLOSING") : GateChestDialog.stateText(e, "IS_OPENING");
        this.gateTime.innerHTML = DateUtils.formatWithSeconds(Tick.toMs(e.gateChangeTick));
    }
    else {};
    /*
    UI.show(c.isGateChanging(), [timeBox], function():void {
        status.text = c.isGateOpen() ? stateText(c, "IS_CLOSING") : stateText(c, "IS_OPENING");
        time.text = DateUtils.formatWithSeconds(Tick.toMs(c.gateChangeTick));
    });
    */
    
    var decl = ServiceHelper.getLocalServiceDecl(ServiceDecl.CLOSE_GATE, 0);
    COM(this.priceLabel).update(decl.price);
    COM(this.timeView).value = decl.duration;
    if (!this.estate.isGateClosed())
    {
        this.tick();
    }
    
    return this;
}

GateChestDialog.prototype.doAction = function()
{
    if (!this.estate.isGateOpen() || !this.estate.accessManageble)
    {
        return;
    }
    if (!Quarantine.contains(Quarantine.GATE))
    {
        Quarantine.put(Quarantine.GATE);
        ServiceHelper.orderLocalService(ServiceDecl.CLOSE_GATE, 0, null, this.estate.id, null, false);
    }
}

GateChestDialog.prototype.update = function(estate)
{
    this.estate = estate;
    this.tick();
}

GateChestDialog.prototype.tick = function()
{
    if (this.estate.isGateClosed())
    {
        this.close();
        return;
    }
    var decl = ServiceHelper.getLocalServiceDecl(ServiceDecl.CLOSE_GATE, 0);
    var canBoost = true;
    var problemText = "";
    if (this.estate.gateClosingByMagic)
    {
        canBoost = false;
        problemText = I18.f("GATE_SPEEDUP_ALREADY_DONE");
        //Style.PROBLEM_INFO.applyTo(timeView);
        //Style.PROBLEM_INFO.applyTo(problemText);
    }
    else if (this.estate.isGateChanging() && this.estate.gateChangeTick <= Tick.now() + decl.duration)
    {
        canBoost = false;
        problemText = I18.f("GATE_SPEEDUP_TOO_LATE");
        //Style.PROBLEM_INFO.applyTo(timeView);
        //Style.PROBLEM_INFO.applyTo(problemText);
    }
    else if (this.estate.isEstateUnderSiege)
    {
        canBoost = false;
        problemText = I18.getMegaString(I18.f("PEARL_BOOST_ERROR_GATE_UNDER_ATTACK"), FConfig);
        //Style.PROBLEM_INFO.applyTo(timeView);
        //Style.PROBLEM_INFO.applyTo(problemText);
    }

    if (this.estate.owner.pearl < decl.price)
    {
        problemText = I18.f("NOT_ENOUGH_PEARL");
        canBoost = false;
    }

    if (canBoost)
    {
        //Style.FUNDS.applyTo(timeView);
    }
    COM(this.yesButton).reason = problemText;
}