function HallTip()
{
	this.estate = null; // FEstate
}

HallTip.prototype.__construct = function()
{
}

HallTip.prototype.estate = null; // FEstate

HallTip.create = function(c)
{
	var t = COM.create('HallTip');
    t.update(c);
	return t;
}

HallTip.prototype.getTitle = function()
{
	return this.estate ? this.estate.hall.getNameAndLevel() : '';
}

HallTip.prototype.update = function(estate)
{
	this.estate = estate;
	var hall = estate.hall;
	if (this.estate instanceof FRuin || this.estate instanceof FEvil) 
	{
		UI.show(false, [this.producesBox, this.peopleCapacityBox, this.upgradeBox, this.populationIncreaseBox, this.occupiedPeople]);
		
		this.resourceCapacityValue.innerHTML = I18.f('UNLIMITED');
		this.ruinPopulationLabel.innerHTML = '';

		for (var i = 0, len = UnitType.MILITARY.length; i < len; i++) 
		{
			var unit = UnitType.MILITARY[i];
			var reproduction = estate.unitReproductionPerDay[unit.ordinal];
			var baseReproduction = estate.baseUnitReproductionPerDay[unit.ordinal];
			if (baseReproduction > 0) 
			{
				var box = document.createElement('div');
				var label = document.createElement('span');
				label.innerHTML = I18.getUnitName(unit, estate.unitLevels[unit.ordinal], Race.MONSTER) + ": " + I18.f('PER_DAY', baseReproduction);
				box.appendChild(label);
				
				if (reproduction != baseReproduction) 
				{
					var bonus = document.createElement('span');
					bonus.innerHTML = I18.getMegaString("{0:percent}", [(reproduction - baseReproduction) / baseReproduction]);
					box.appendChild(bonus);
					if (reproduction == 0) 
					{
                    	bonus.className = 'overflow';
					} 
					else if (reproduction > baseReproduction) 
					{
                    	bonus.className = 'positive';
					}
					else 
					{
                    	bonus.className = 'negative';
					}
            	}
				this.ruinPopulation.appendChild(box);
			}
		}
		UI.show(true, [this.ruinLootBox]);
		UI.show(FConfig.CAN_FIND_ART_IN_RUIN[estate.hall.level], [this.ruinArtifactBox]);
		COM(this.flags).updateFlags(estate.flags, estate.flagSetsCount);
	    
	    if (UI.show(estate.crystal, [this.crystal]))
	    {
	        COM(this.crystal).update(estate.crystal, []);
	    }
	    UI.show(estate.crystal || estate.garrisonHero, [this.crystalLootLabel]);
	}
	else if (this.estate instanceof FStonehenge)
	{
		UI.show(false, [
			this.producesBox, this.peopleCapacityBox, this.resourceCapacityBox, this.upgradeBox, 
			this.populationIncreaseBox, this.ruinPopulationBox, this.ruinLootBox, this.ruinArtifactBox
		]);
	}
	else 
	{
		UI.show(false, [this.producesBox, this.resourceCapacityBox, this.peopleCapacityBox, this.upgradeBox, this.populationIncreaseBox, this.ruinLootBox, this.ruinArtifactBox, this.occupiedPeople]);
	}
	
	UI.show((this.estate instanceof FStonehenge), [this.stonehengeLootBox]);
	
	COM(this.populationIncrease).source = STATIC_INTERFACE_URL + Assets.getFreePeopleIcon(estate.race);
	COM(this.occupiedPeople).source = STATIC_INTERFACE_URL + Assets.getBusyPeopleIcon(estate.race);
	if (UI.show(estate.__className__ == 'FCamp' && estate.isSettingUp, [this.settingUpLabel])) 
	{
		this.settingUpLabel.innerHTML = I18.mega(I18.f('SETTING_UP_CAMP'), estate.setUpTill);
	}

	if (UI.show(estate.__className__ == 'FCastle', [this.castleHeader, this.castleFooter]))
	{
		var clan = estate.owner.diplomacy ? estate.owner.diplomacy.clan : null;
		this.castleOwner.innerHTML = clan ? I18.f('OWNED_BY_CLAN', htmlEscape(clan.clanName)) : I18.f('OWNED_BY_MONSTER');
		
		if (UI.show(clan, [this.clanMembersCount, this.peacePoints, this.warPoints])) 
		{
			this.clanMembersCount.innerHTML = I18.f('CLAN_MEMBERS_COUNT', clan.members.length);
			var pointsProduction = I18.f('PER_TIME', hall.getLevel().pointsProduction);
			COM(this.peacePointsProduction).value = pointsProduction;
			COM(this.warPointsProduction).value = pointsProduction;
		}
	}
	
	var passive = hall.getLevel() ? hall.getLevel().passive : null;
	if (UI.show(passive, [this.passivesBox]))
	{
    	EffectsView.createDescriptiveView(this.passivesBox, passive.dtoActions, false, false, false, false);
	}

	this.tick();
	
}

HallTip.prototype.tick = function()
{
	var estate = this.estate, hall = estate.hall, cls = estate.__className__;
	UI.show(hall.accessInfo && (['FLake', 'FRuin', 'FCamp', 'FGrotto', 'FEvil', 'FGrail', 'FStonehenge'].indexOf(cls) < 0), [this.producesBox]);
	UI.show((cls == 'FLake' || cls == 'FGrail'), [this.pearlBox]);

	if (!hall.accessInfo || cls == 'FRuin' || cls == 'FStonehenge') 
	{
    	return;
	}
	
	this.resourceCapacityValue.innerHTML = hall.getCapacity().toString();
	this.peopleCapacityValue.innerHTML = hall.getPeopleCapacity().toString();
	
	if (cls == 'FCamp') 
	{
		UI.show(false, [this.upgradeBox, this.populationIncreaseBox, this.occupiedPeople]);
		return;
	}

	if (cls == 'FLake') 
	{
    	COM(this.pearl).value = I18.f('PER_TIME', FConfig.LAKE_PRODUCTION);
	}
	else if (cls == 'FGrail')
	{
        COM(this.pearl).value = I18.f('PER_TIME', FConfig.GRAIL_PRODUCTION);
    }
	else 
	{
		var speed = hall.getLastWorkSpeedPerHour().copy();
		COM(this.produces).alwaysShow = hall.resource ? [hall.resource] : [];
		COM(this.produces).update(speed, estate.race);
	}

	UI.show(hall.accessInfo && cls != 'FGrotto', [this.populationIncreaseBox]);

	COM(this.populationIncrease).value = I18.f('PER_TIME', hall.getPeopleProductionSpeedPerHour());
	var overfill = hall.isHousesOverfilled();
	$(this.populationIncrease)
		.toggleClass('positive', !overfill)
		.toggleClass('negative', !!overfill)
	;
	
	if (UI.show(hall.isUpgradePending, [this.upgradeBox, this.occupiedPeople]))
	{
		this.curLevel.innerHTML = hall.level;
		this.nextLevel.innerHTML = (hall.level + 1) + " " + I18.f('LVL');
		
		if (UI.show(!hall.isStopped, [this.finishBox]))
		{
			this.finishTime.innerHTML = Tick.toTimeFuture(Tick.now() + hall.estimateCurrentWork());
		}
		COM(this.occupiedPeople).value = hall.builders + '/' + hall.getNextLevel().builders;
	}
	
	if (UI.show(hall.isBuildingOrUpgrading && hall.isStopped, [this.stoppedBox]))
	{
		this.stoppedReason.className = 'negative';
		if (hall.isBuildPending) 
		{
			stoppedReason.text = I18.f('BUILD_STOPPED');
		} 
		else if (hall.isUpgradePending) 
		{
			stoppedReason.text = I18.f('UPGRADE_STOPPED');
		}
		this.percent.innerHTML = I18.f('READINESS', hall.percentCompleted());
	}
}