function HexesCanvas()
{
	this.ownDialog = null; // Function
	this.hexStateIndex = 0; // int
	
	this.animationSource = null; // * = null
	this.blambaAnimationSource = null; // * = null
	
	this.startMagicAnimationTick = 0; // Number
	this.startMagicAnimationEstateId = null; // EstateId
	
	this.fitLayout = $.proxy(function(container)
	{
		$("> wrapper", this.DOM).css("width", container.width);
		$("> wrapper", this.DOM).css("height", container.height);
		
		this.walkHexes(function(el)
		{
			el.fitLayout(container);
		});
	}, this);
	
	this.clickHandler = $.proxy(this.clickHandler, this);
	//this.dblClickHandler = $.proxy(this.dblClickHandler, this);
}

HexesCanvas.prototype.MAGIC_ANIMATION_MAX_DURATION = 30;
HexesCanvas.HEX_VIS_STATES =
[
    {
        icon:"BUTTON_VIEW_MODE1",
        buildings:true,
        countDown:true
    },
    {
        icon:"BUTTON_VIEW_MODE2",
        buildings:true,
        levels:true,
        countDown:true,
        grid:false
    },
    {
        icon:"BUTTON_VIEW_MODE3",
        numbers:true,
        grid:true,
        countDown:false
    }
];

HexesCanvas.prototype.ownDialog = null; // Function
HexesCanvas.prototype.hexStateIndex = 0; // int

HexesCanvas.prototype.animationSource = null; // * = null
HexesCanvas.prototype.blambaAnimationSource = null; // * = null

HexesCanvas.prototype.startMagicAnimationTick = 0; // Number
HexesCanvas.prototype.startMagicAnimationEstateId = null; // EstateId

HexesCanvas.prototype.cityViews =
[
	{"__className__": "FCity", component: "CityHexesView", view: null},
	{"__className__": "FCastle", component: "CastleHexesView", view: null},
	{"__className__": "FCamp", component: "CampHexesView", view: null},
	{"__className__": "FGrotto", component: "GrottoHexesView", view: null},
	{"__className__": "FLake", component: "LakeHexesView", view: null},
	{"__className__": "FMine", component: "MineHexesView", view: null},
	{"__className__": "FPit", component: "PitHexesView", view: null},
	{"__className__": "FRuin", component: "RuinHexesView", view: null},
	{"__className__": "FEvil", component: "EvilHexesView", view: null},
	{"__className__": "FGrail", component: "GrailHexesView", view: null},
	{"__className__": "FStonehenge", component: "StonehengeHexesView", view: null},
	{"__className__": "FCatapult", component: "CatapultHexesView", view: null},
];

HexesCanvas.prototype.__construct = function()
{
	/*
	if("ontouchstart" in window)
	{
		$(this.DOM).on(MOUSE_UP_EVENT, $.proxy(function(e)
		{
			if(e.originalEvent.changedTouches && e.originalEvent.changedTouches.length > 1)
			{
				e.stopImmediatePropagation();
				return this.dblClickHandler(e);
			}
		}, this));
	}
	else
	{
		$(this.DOM).on("dblclick", this.dblClickHandler);
	}
	*/
	
	COM.bindExclusiveClick(this.DOM, $.proxy(this.clickHandler, this));
}

HexesCanvas.prototype.onInit = function()
{
	var view;
	for(var i=0; i < this.cityViews.length; i++)
	{
		view = COM.create(this.cityViews[i].component);
		//view.init();
		view.__className__ = this.cityViews[i].__className__;
		view.ownDialog = this.ownDialog;
		view.DOM.style.display = "none";
		
		$("wrapper", this.DOM).append(view.DOM);
		
		this.cityViews[i].view = view;
	}
}

/*
HexesCanvas.prototype.dblClickHandler = function(e)
{
	this.switchHexState();
	
	e.stopImmediatePropagation();
	return false;
}
*/

HexesCanvas.prototype.clickHandler = function(e)
{
	var view = this.getCurrentView();
	if (!view) return;
	
	var hexes = $(view.hexContainer);
	var scale = view.cityScroll.scale ? view.cityScroll.scale : 1;
	
	e.stopImmediatePropagation();
	
	if (e.originalEvent.touches)
	{
		var touches = e.originalEvent.changedTouches.length > 0 ? e.originalEvent.changedTouches : e.originalEvent.touches;
		if(touches.length > 1) return;
		e = touches[0];
	}
	
	if(!e || APP.ticksIsPaused)
	{
		return;
	}
	
	function globalToLocal(pos, y)
	{
		if (typeof y != 'undefined') 
		{
			return globalToLocal({x:pos, y:y});
		}
		var p = 
		{
			x: pos.x - hexes.offset().left,
			y: pos.y - hexes.offset().top
		}
		return p;
	}
	
	function pointInTriangle(p, t, strict)
	{
		var n1 = (t[0].x - p.x) * (t[1].y - t[0].y) - (t[1].x - t[0].x) * (t[0].y - p.y);
		var n2 = (t[1].x - p.x) * (t[2].y - t[1].y) - (t[2].x - t[1].x) * (t[1].y - p.y);
		var n3 = (t[2].x - p.x) * (t[0].y - t[2].y) - (t[0].x - t[2].x) * (t[2].y - p.y);
		// point belongs to triangle side
		if (n1 == 0 || n2 == 0 || n3 == 0) return !Boolean(strict);
		// point belongs to triangle area
		if ((n1 > 0 && n2 > 0 && n3 > 0) || (n1 < 0 && n2 < 0 && n3 < 0)) return true;
		return false;
	}
	
	var self = this;
	function hexAt(p, lst)
	{
		var min = Number.MAX_VALUE, el = null;
		for (var i = 0; i < lst.length; i++)
		{
			var drawDebug = false;
			var x = (lst[i].x + APP.hexesOffset.left)*GAME_IMAGES_PACK;
			var y = (lst[i].y + APP.hexesOffset.top)*GAME_IMAGES_PACK;
			var w = APP.hexesSize.width*GAME_IMAGES_PACK;
			var h = APP.hexesSize.height*GAME_IMAGES_PACK;
			var p2 = globalToLocal(x, y);
			var tw = w/2, th = h/4; // corner triangle
			var t, tt = [
				[{x:x,y:y}, {x:x+tw,y:y}, {x:x,y:y+th}],
				[{x:x,y:y+h-th}, {x:x,y:y+h}, {x:x+tw,y:y+h}],
				[{x:x+tw,y:y}, {x:x+w,y:y}, {x:x+w,y:y+th}],
				[{x:x+w-tw,y:y+h}, {x:x+w,y:y+h}, {x:x+w,y:y+h-th}]
			];
			
			if (drawDebug)
			{
				var ctx = self.getCurrentView().ctx.main;
				with (ctx) { lineWidth = 2.0; }
				with (ctx) { strokeStyle = '#F00'; beginPath(); rect(x, y, w, h); stroke(); }
			}
				
			// check AABB
			if (p.x < x || p.x > x + w) continue;
			if (p.y < y || p.y > y + h) continue;
			
			if (drawDebug) with (ctx) {strokeStyle = '#FF0'; beginPath(); rect(x, y, w, h); stroke(); }
			
			// cut corner triangles for hex (tw,th - triangle size)
			var out = false; 
			while (t = tt.shift())
			{
				if (pointInTriangle(p, t))
				{
					if (drawDebug) with (ctx) { fillStyle = '#F00'; beginPath(); moveTo(t[0].x, t[0].y); lineTo(t[1].x, t[1].y); lineTo(t[2].x, t[2].y); fill(); }
					break;
				}
			} 
			if (t) continue;
			
			if (drawDebug) with (ctx) {fillStyle = 'rgba(0,255,0,0.2)'; beginPath(); rect(x, y, w, h); fill(); }
			
			return lst[i];
		}
		return el;
	}
	
	var p = globalToLocal(e.pageX, e.pageY);
	
	p.x /= scale;
	p.y /= scale;
	
	var h = hexAt(p, view.allHexes);
	
	if (h)
	{
		if (h.onClick) 
		{
			var doClick = true;
			if(h.gate)
			{
				var x1 = (h.x + APP.hexesOffset.left + h.WIDTH/2)*GAME_IMAGES_PACK;
				var y1 = (h.y + APP.hexesOffset.top + h.HEIGHT/2)*GAME_IMAGES_PACK;
				var x2 = x1 + h.WIDTH/2;
				var y2 = y1 + h.HEIGHT/2;
				
				if(p.x >= x1 && p.x <= x2 && p.y >= y1 && p.y <= y2)
				{
					h.onGateClick();
					doClick = false;
				}
			}
			if(doClick)
			{
				if(!h.isInsideWall() && h.estate.__className__ == "FCastle") h.onGateClick();
				else h.onClick(h);
			}
		}
	}
	else
	{
		var x = (COM(view.hallView).buildingCenterX - view.hallView.buildingWidth/2) * GAME_IMAGES_PACK;
		var y = (COM(view.hallView).buildingCenterY - view.hallView.buildingHeight/2) * GAME_IMAGES_PACK;
		
		if (p.x >= x &&
			p.x <= x + view.hallView.buildingWidth &&
			p.y >= y &&
			p.y <= y + view.hallView.buildingHeight)
		{
			view.onHallClick();
		}
	}
	
	return false;
}

HexesCanvas.prototype.tick = function(force) 
{
	for(var i = 0; i < this.cityViews.length; i++)
	{
		var el = $(this.cityViews[i].view.DOM).filter(':visible');
		if (el.length > 0)
		{
			COM(el).tick(force);
			break;
		}
	}
}

HexesCanvas.prototype.applyHexState = function(state) 
{
    this.getCurrentView().applyHexState(state);
    
    /*
    this.walkHexes(function(hexes)
    {
        hexes.applyHexState(state);
    });
    */
}

HexesCanvas.prototype.walkHexes = function(handler)
{
	for(var i = 0; i < this.cityViews.length; i++)
	{
		handler(this.cityViews[i].view);
	}
}

HexesCanvas.prototype.hideAllViews = function()
{
	this.walkHexes(function(el)
	{
		if (el)
		{
			el.DOM.style.display = "none";
		}
	});
}

HexesCanvas.prototype.getCurrentView = function()
{
	for (var i = 0; i < this.cityViews.length; i++)
	{
		if (this.cityViews[i].view.DOM.style.display != 'none')
		{
			return this.cityViews[i].view;
		}
	}
}

HexesCanvas.prototype.getHexesFor = function(e)
{
	for(var i=0; i<this.cityViews.length; i++)
	{
		if(e.__className__ == this.cityViews[i].__className__) return this.cityViews[i].view;
	}
}

HexesCanvas.prototype.getHexState = function()
{
	return HexesCanvas.HEX_VIS_STATES[this.hexStateIndex];
}

HexesCanvas.prototype.update = function(e, forceUpdate)
{
    var old = this.getCurrentView();
    var viewHexes = this.getHexesFor(e);
    
    if(viewHexes.DOM.style.display == "none" || viewHexes.__className__ != e.__className__)
    {
    	this.hideAllViews();
    	viewHexes.DOM.style.display = "block";
    	
    	if(old) old.estate = null;
    }
    
    var shouldValidate = false;
    
    if (!viewHexes.wasInit)
    {
        viewHexes.init(this.getHexState());
        shouldValidate = true;
    }
    
    viewHexes.update(e, forceUpdate);
    
    return shouldValidate;
}

HexesCanvas.prototype.isShowingAnimation = function() 
{
    return false;
}

HexesCanvas.prototype.refreshAnimationSource = function() 
{
	//this.bgAnimationImage.source = this.isShowingAnimation() ? this.animationSource : null;
	//this.blambaAnimationImage.source = this.isShowingAnimation() ? this.blambaAnimationSource : null;
}

HexesCanvas.prototype.setShowingAnimation = function(val) 
{
    //this.bgAnimationImage.visible = val;
    //this.blambaAnimationImage.visible = val;
    //this.refreshAnimationSource();
}

HexesCanvas.prototype.getHexState = function()
{
    return HexesCanvas.HEX_VIS_STATES[this.hexStateIndex];
}

HexesCanvas.prototype.getStateIcon = function() 
{
    var state = this.getHexState();
    return CommonAssets.getPlatform(false)[state.icon];
}

HexesCanvas.prototype.getHexStateIndex = function() 
{
    return this.hexStateIndex;
}

HexesCanvas.prototype.switchHexState = function()
{
    this.setHexStateIndex(this.hexStateIndex + 1);
}

HexesCanvas.prototype.setHexStateIndex = function(value) 
{
    this.hexStateIndex = value % HexesCanvas.HEX_VIS_STATES.length;
    this.applyHexState(this.getHexState());
}

HexesCanvas.prototype.updateArrow = function(estate) 
{
	if (!estate || !estate.isCity || !estate.accessManageble) 
    {
        return;
    }

    var constructHint = FUser.CURRENT_USER.findConstructHint(estate);
    if (constructHint && !HintArrow.CLICK_ON_CELL.isShowing() && !HintArrow.CLICK_ON_CELL.isUnderstood(constructHint)) 
    {
		var view = this.getCurrentView();
		var hex = view.findCellInsideWall(constructHint.btype);
		var scale = HEXES_SCALE;
		var x = (hex.x + APP.hexesOffset.left) * GAME_IMAGES_PACK;
		var y = (hex.y + APP.hexesOffset.top) * GAME_IMAGES_PACK;
		
		setTimeout(function()
		{
			view.cityScroll.scrollTo((-x)*scale+view.wrapper.offsetWidth/2-(hex.WIDTH * GAME_IMAGES_PACK)/2, (-y)*scale+view.wrapper.offsetHeight/2, 0);
		}, 500);
		
        if (hex) 
        {
			HintArrow.CLICK_ON_CELL.show(null, constructHint, view.hexContainer, {
				left: x,
				top: y,
				width: hex.WIDTH * GAME_IMAGES_PACK,
				height: hex.HEIGH * GAME_IMAGES_PACK
			});
        }
    }
    
    var upgradeHint = FUser.CURRENT_USER.findHint(HintType.UPGRADE_HALL);
    if (upgradeHint) 
    {
		setTimeout($.proxy(function()
		{
			var hv = this.getCurrentView().hallView;
			
			HintArrow.OPEN_CITYHALL_MENU.show(null, upgradeHint, this.getCurrentView().hexContainer, {
					left: hv.buildingCenterX * GAME_IMAGES_PACK,
					top: hv.buildingCenterY * GAME_IMAGES_PACK,
					width: 0,
					height: 0
				});
		}, this), 500);
    }
}

HexesCanvas.prototype.updateMagicAnimation = function(magic, doShow, estate) 
{
    /*
    if (magic.visible) 
    {
        if (doShow) 
        {
            magic.source = null; // to restart animation
        } 
        else if (Tick.now() - this.startMagicAnimationTick <= MAGIC_ANIMATION_MAX_DURATION && this.startMagicAnimationEstateId.equals(this.estate.id)) 
        {
            return; // allow to finish current magic animation
        }
    }
    magic.source = doShow ? CommonHeroAssets.MAGIC_ANIMATION : null;
    $(magic).toggle(doShow);
    if (doShow)
    {
        this.startMagicAnimationTick = Tick.now();
        this.startMagicAnimationEstateId = this.estate.id;
    }
    */
}