function IncreaseDefenceDialog()
{
	callParentConstructor(IncreaseDefenceDialog.prototype, this);
}

extendClass(IncreaseDefenceDialog.prototype, UpdatableEstateDialog.prototype);

IncreaseDefenceDialog.prototype.__construct = function()
{
	this.animatedPopup = true;
	this.shaderOpacity = 0.5;
	
	COM.bindExclusiveClick(this.okButton, $.proxy(this.onFinish, this));
}

IncreaseDefenceDialog.prototype.popup = function(parent, e)
{
    this.estate = e;
	COM(this.priceLabel).ownerUser = this.estate.owner;
	this.init();
    superMethod(this, 'popup')(parent);
}

IncreaseDefenceDialog.prototype.tick = function()
{
    this.problemInfo.innerHTML = '';
    
	var reason = "";
    
    this.pearlInfo.innerHTML = Tick.hasPassed(this.estate.maxDefenceFinishTick) ? "" : I18.activeMagicTip(this.estate.maxDefenceFinishTick);
    if (this.estate.maxDefenceFinishTick > Tick.now() + FConfig.PEARL_MAX_ADVANCE_DURATION) 
    {
        //COM(this.okButton).enabled = false;
        reason = I18.f('PEARL_PAYMENT_REACHED_MAX_ADVANCE');
		this.problemInfo.innerHTML = reason;
    } 
    else if (this.estate.isEstateUnderAttack) 
    {
        //COM(this.okButton).enabled = false;
        reason = I18.f('CANNOT_INCREASE_DEFENCE_UNDER_SIEGE');
		this.problemInfo.innerHTML = reason;
    }
    
    var decl = ServiceHelper.getLocalServiceDecl(ServiceDecl.MAX_DEFENCE, 0);
    if (!decl || decl.price > FUser.CURRENT_USER.pearl) 
    {
        //COM(this.okButton).enabled = false;
		reason = I18.f('NOT_ENOUGH_PEARL');
    }
    
    UI.show(this.problemInfo.innerHTML.length > 0, [this.problemInfo, this.pearlInfo]);
	
	COM(this.okButton).reason = reason;
}

IncreaseDefenceDialog.prototype.init = function()
{
    $(this.description).html(I18.f('YOU_CAN_INCREASE_DEFENCE', Math.min(FConfig.MAX_MAX_DEFENCE, FConfig.MAX_DEFENCE + NumberUtils.floor(this.estate.sumOfBuffs(BuffType.INCREASE_MAX_DEFENCE)))));

    var decl = ServiceHelper.getLocalServiceDecl(ServiceDecl.MAX_DEFENCE, 0);
    COM(this.bonusTime).value = decl.duration;
    COM(this.priceLabel).update(decl.price);
    this.tick();
}

IncreaseDefenceDialog.prototype.onFinish = function()
{
    ServiceHelper.orderLocalService(ServiceDecl.MAX_DEFENCE, 0, null, this.estate.id, $.proxy(function()
    {
        this.close();
        
    }, this), false);
}
