function MarketViewInfo()
{
	this.__defineGetter__('filterResource', this.getFilterResource);
	this.__defineSetter__('filterResource', this.setFilterResource);
	
	this.__defineGetter__('filterIndex', this.getFilterIndex);
	this.__defineSetter__('filterIndex', this.setFilterIndex);

	this.sortColumn = 2;
	this.sortAscending = true;
	this.pageIndex = 0;
	
	this._filterResource = Resource.NULL;
	this._filterIndex = 0;   // transient
}

MarketViewInfo.prototype.__CLS__ = 'game.service.city.MarketViewInfo';

MarketViewInfo.prototype.sortColumn = 2;
MarketViewInfo.prototype.sortAscending = true;
MarketViewInfo.prototype.pageIndex = 0;

MarketViewInfo.prototype._filterResource = Resource.NULL;
MarketViewInfo.prototype._filterIndex = 0;   // transient

MarketViewInfo.prototype.getFilterResource = function()
{
    return this._filterResource;
}
MarketViewInfo.prototype.setFilterResource = function(value)
{
    this._filterResource = value;
    for (var i = 0, len = Resource.RESOURCES_FOR_FILTER.length; i < len; i++)
    {
    	if (Resource.RESOURCES_FOR_FILTER[i].name == value.name)
    	{
    		this._filterIndex = i;
    		break;
    	}
    }
}

MarketViewInfo.prototype.getFilterIndex = function()
{
    return this._filterIndex;
}

MarketViewInfo.prototype.setFilterIndex = function(value)
{
    this._filterIndex = value;
    this._filterResource = Resource.RESOURCES_FOR_FILTER[value];
}

MarketViewInfo.prototype.prepareForRequest = function()
{
	var ret = $.extend({}, this);
	
	ret['filterIndex'] = ret['_filterIndex'];
	delete ret['_filterIndex'];
	
	ret['filterResource'] = ret['_filterResource'];
	delete ret['_filterResource'];
	
	return ret;
}
