function PrepareMissionTicker(dialog, target)
{
	callParentConstructor(this, null, $.proxy(this.updateDialog, this), $.proxy(dialog.tick, dialog), $.proxy(this.handleError, this));
	
	this._prepare = null;
    this.initialized = false;
    
    this.dialog = dialog;
    this.target = target;
    dialog.onClose = $.proxy(this.stop, this);
    dialog.onCityChange = $.proxy(function(id)
    {
		this.requestNewCity(id);
    }, this);
}

extendClass(PrepareMissionTicker.prototype, EstateTicker.prototype);

PrepareMissionTicker.prototype.requestNewCity = function(cityId)
{
	this.ticker.pause();
	var targetId = this.dialog.isAttackOrAssistance && this.target.hasEstate() ? this.target.estate.id : null;
	APP.showLoader();
    Service.city.callMethod("getPrepareInfo", [cityId, targetId], $.proxy(this.update, this), $.proxy(this.handleError, this), "mission");
}

PrepareMissionTicker.prototype.start = function(cityId, preloadedEstate)
{
	superMethod(PrepareMissionTicker.prototype, "start", this)(cityId, preloadedEstate);
	
	Events.onFEstateUpdated.remove(this, this.updateCity);
}

PrepareMissionTicker.prototype.update = function(prepare)
{
    APP.hideLoader();
    
    if (!this.ticker.started)
    {
        return;
    }
    
    this._prepare = prepare;
    if (!this.initialized)
    {
        this.initDialog(prepare);
        this.initialized = true;
    }
    
    this.updateCity(prepare.estate);
}

PrepareMissionTicker.prototype.initDialog = function(prepare)
{
    this.dialog.init(prepare, this.target);
    this.dialog.popup();
}

PrepareMissionTicker.prototype.updateDialog = function(estate)
{
    if(!this._prepare)
	{
		return;
	}
	
	if (this._prepare.estate.id.equals(estate.id))
    {
        this._prepare.estate = estate;
    }
    
    this.dialog.update(this._prepare);
}

PrepareMissionTicker.prototype.handleError = function(e)
{
    if ((e.__className__ == 'AccessDeniedException'))
	{
        this.stop();
        Alert.create(e.getMessage());
        if (this.initialized)
		{
            dialog.close();
        }
        Events.onShowKingdom.fire(null);
        return true;
    }
    if (e.__className__ == 'EstateNotFoundException')
	{
        this.stop();
        e.showMessageAndStay();
        if (initialized)
		{
            dialog.close();
        }
        return true;
    }
    return false;
}