function RenameDialog()
{
	callParentConstructor(RenameDialog.prototype, this);
	this.estate = null;
}

extendClass(RenameDialog.prototype, Dialog.prototype);

RenameDialog.prototype.__construct = function()
{
	COM(this.nameText).maxlength = FConfig.CITY_NAME_LENGTH;
	$(this.nameText).on('keyup', $.proxy(this.validate, this));
	COM.bindExclusiveClick(this.renameButton, $.proxy(this.onRename, this));
}

RenameDialog.prototype.estate = null;

RenameDialog.create = function(estate, onRenamedHandler)
{
    var renameDialog = COM.create('RenameDialog');
    
    renameDialog.setCaption(I18.f('RENAME_CITY'));
    
    renameDialog.estate = estate;
    COM(renameDialog.nameText).value = htmlUnescape(estate.name);
    
    renameDialog.userCanClose = true;
    renameDialog.shaderOpacity = 0.5;
    renameDialog.animatedPopup = true;
    
    renameDialog.onClose = function()
    {
        renameDialog.onCloseDialog.call(renameDialog);
        if (typeof onRenamedHandler == 'function') 
        {
            onRenamedHandler();
        }
    }
    return renameDialog;
}

RenameDialog.popup = function(estate, parent)
{
	var renameDialog = RenameDialog.create(estate);
	renameDialog.popup(parent);
}

RenameDialog.prototype.validate = function()
{
	var txt = COM(this.nameText); 
	txt.valid = txt.value.length > 0;
	txt.reason = txt.valid ? null : I18.f('NEED_TO_FILL_DATA');
} 

RenameDialog.prototype.onRename = function() 
{
    this.estate.requestRename = false;
    Service.city.callMethod('rename', [this.estate.id, COM(this.nameText).value]);
    this.close();
}

RenameDialog.prototype.onCloseDialog = function() 
{
    if (this.estate.requestRename) 
    {
        Service.city.callMethod('rename', [this.estate.id, null]);
    }
}
