function RepairDialog()
{
	callParentConstructor(RepairDialog.prototype, this);
	this._b = null;
}

extendClass(RepairDialog.prototype, UpdatableEstateDialog.prototype);

RepairDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.doRepair, $.proxy(this.onRepair, this));
	COM.bindExclusiveClick(this.noButton, $.proxy(this.close, this));
} 

RepairDialog.prototype.onResult = function(builders)
{
    Service.city.callMethod('repairBuilding', [this._b.estate.id, this._b.id, builders]);
};

RepairDialog.prototype._b = null;

RepairDialog.prototype.popup = function(parent, estate, b)
{
    this.estate = estate;
    this._b = b;
    
	this.setCaption(I18.getBuildingName(this._b.type, this._b.race));
	this.building.src = STATIC_URL + Assets.B_findBy(this.estate.race, this._b.type, this._b.resource);
	this.current.innerHTML = I18.f('STATE_X_PERCENT', NumberUtils.floor(this._b.getHealthRatio() * 100));
	this.currentPercent.innerHTML = I18.f('STATE_X_PERCENT', 100);
	
	this.update(this.estate);
	
	superMethod(this, 'popup')(parent);
}

RepairDialog.prototype.update = function(estate)
{
    this.estate = estate;
    this.tick();
}

RepairDialog.prototype.tick = function()
{
    COM(this.builders).updateMaximized(this.estate, this._b.maxRepairBuilders);
    COM(this.cost).capacity = this.estate.bank;
    COM(this.time).value = this._b.estimateRepairDuration(COM(this.builders).value);
    repairCost = this._b.estimateRepairCost();
    COM(this.cost).update(repairCost, this._b.race);
    
    var reason = [];
    if (!this.estate.bank.greaterOrEqualsTo(repairCost))
    {
    	reason.push(I18.f('NOT_ENOUGH_RESOURCES'));
    }
    if (!this.estate.canPerformOneMoreRepairing())
    {
    	reason.push(I18.getConcurrentRepairingLimitText(this.estate.getMaxConcurrentRepairings()));
    }
    COM(this.doRepair).reason = reason;
    //SpecializationsTooltipHelper.manageRepairTimeTooltip(time, estate);
}

RepairDialog.prototype.onBuildingTimeTip = function(e)
{
    var time = this._b.estimateRepairBaseDuration(COM(this.builders).value);
    //e.toolTip = SpecializationsTooltipHelper.onRepairTimeTip(time, this._b.level + 1, this.estate);
}

RepairDialog.prototype.onRepair = function()
{
    this.onResult(COM(this.builders).value);
    this.onResult = Dialog.EMPTY_FUNCTION;
    this.close();
}
