function TempleChestDialog()
{
	callParentConstructor(TempleChestDialog.prototype, this);
	this.estate = null;
}

extendClass(TempleChestDialog.prototype, Dialog.prototype);

TempleChestDialog.prototype.estate = null;

TempleChestDialog.prototype.__construct = function()
{
	superMethod(TempleChestDialog.prototype, '__construct', this)();
	COM.bindExclusiveClick(this.okButton, $.proxy(this.buyGodpoints, this))
}

TempleChestDialog.create = function(parent)
{
	var d = COM.create('TempleChestDialog');
	d.estate = parent.estate;
	d.popup(parent);
	return d;
}

TempleChestDialog.prototype.onShow = function()
{
	var decl = ServiceHelper.getGloabalServiceDecl(ServiceDecl.BUY_TEMPLE_POINTS, 0);
	COM(this.pointsCount).value = decl.getValue();
	COM(this.priceLabel).update(decl.price);

	var cooldown = FUser.CURRENT_USER.servicesCooldowns.getValueOrNull(ServiceDecl.BUY_TEMPLE_POINTS) || 0;
	var reason = null;
	if (!Tick.hasPassed(cooldown)) 
	{
	    reason = [I18.f('GODPOINTS_BUY_TOO_OFTEN', Tick.toTimeFuture(cooldown))];
	}
	else if (decl.price > FUser.CURRENT_USER.pearl)
	{
		reason = I18.f('NOT_ENOUGH_PEARL');
	}
	COM(this.okButton).reason = reason;
}

TempleChestDialog.prototype.buyGodpoints = function()
{
	APP.showLoader();
	COM(this.okButton).enabled = false;
	
	var handler = $.proxy(function (){ this.close(); APP.hideLoader(); }, this);
	ServiceHelper.orderGlobalService(
		ServiceDecl.BUY_TEMPLE_POINTS, 0, null, this.estate.id, 
		handler, false
	);
}