function UnitUpgradeDialog()
{
	callParentConstructor(this);
	
	this.onResult = null;
	this._price = new Funds();
	this._race = null;
}

extendClass(UnitUpgradeDialog.prototype, Dialog.prototype);

UnitUpgradeDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.doUpgrade, $.proxy(this.onUpgrade, this));
	
	COM(this.cost).setDefaultFundsClass("text-normal-bold text-middle");
	COM(this.cost).allZeroText = I18.f("NO_RESOURCES_REQUIRED");
	
	COM(this.consumptionBefore).alwaysShow = [Resource.GOLD];
	COM(this.consumptionAfter).alwaysShow = [Resource.GOLD];
	
	this.arrow.src = STATIC_INTERFACE_URL + "shared/icons/unit_upgrade_arrow.png";
	
	this.setCaption(I18.f("UPGRADE_UNITS").toUpperCase());
}

UnitUpgradeDialog.prototype.popup = function(parent, owner, utype, info)
{
    superMethod(UnitUpgradeDialog.prototype, "popup", this)();

    this._race = owner.race;

    var curLevel = owner.science.getLevel(utype.science);
    this._price = owner.science.getUnitUpgradeCost(utype, owner.race);
    this._price.multiply(info.unitsCount);

    var el = COM.get(this.unitBefore);
    el.race = owner.race;
    el.utype = utype;
    el.update(curLevel, info.unitsCount);

    var el = COM.get(this.unitAfter);
    el.race = owner.race;
    el.utype = utype;
    el.update(curLevel + 1, info.unitsCount);

    COM.get(this.cost).update(this._price, owner.race);

    var consumeBefore = FConfig.getStat(owner.race, utype, curLevel).consume;
    var consumeAfter = FConfig.getStat(owner.race, utype, curLevel + 1).consume;
    
    COM.get(this.consumptionBefore).update(new Funds().setValue(Resource.GOLD, NumberUtils.ceil(consumeBefore * info.unitsCount)), owner.race);
    COM.get(this.consumptionAfter).update(new Funds().setValue(Resource.GOLD, NumberUtils.ceil(consumeAfter * info.unitsCount)), owner.race);
    
    COM.get(COM.get(this.consumptionBefore).getIcon(Resource.GOLD)).setTextClass("text-normal-bold text-middle");
    COM.get(COM.get(this.consumptionAfter).getIcon(Resource.GOLD)).setTextClass("text-normal-bold text-middle");

    this.update(info.availableFunds);
}

UnitUpgradeDialog.prototype.update = function(funds)
{
    COM.get(this.cost).capacity = funds;
    COM.get(this.doUpgrade).reason = funds.greaterOrEqualsTo(this._price) ? "" : I18.f("NOT_ENOUGH_RESOURCES");
}

UnitUpgradeDialog.prototype.onUpgrade = function()
{
    if(this.onResult) this.onResult();
    
    this.close();
}