var WorkersAssigner = function()
{
	this.__defineGetter__('caption', function()
	{
		return COM(this.slider).caption || '';
	});
	this.__defineSetter__('caption', function(value)
	{
		COM(this.slider).caption = value || '';
	});
	
	this._icon = ''; // workers | builders
	this.__defineGetter__('icon', function()
	{
		return this._icon;
	});
	this.__defineSetter__('icon', function(value)
	{
		this._icon = value;
		COM(this.slider).icon = STATIC_INTERFACE_URL + 'icons/' + this._icon + '.png';
		this.iconImage.src = STATIC_INTERFACE_URL + 'city/distribute_' + this._icon + '.png';
	});
	
	this.__defineGetter__('value', function()
	{
		return COM(this.slider).value;
	});
	this.__defineSetter__('value', function(v)
	{
		var old = COM(this.slider).value + 0;
		COM(this.slider).value = v;
		//COM(this.slider).updateUI();
		
		this.valueLabel.innerHTML = Math.round(v);
		if (old != v) 
		{
			this.changed = true;
			this.updateValue(v);
		}
	});
	
	this.__defineGetter__('enabled', function()
	{
		return this._enabled;
	});
	this.__defineSetter__('enabled', function(value)
	{
		this._enabled = !!value;
		//UI.show(value, [this.DOM]);
		$(this.DOM).toggleClass('grayscale', !value).css('opacity', value ? 1 : 0.5);
		COM(this.slider).enabled = value;
	});
	
	this.__defineGetter__('inProgress', function()
	{
		return $('picker', this.slider).hasClass('grayscale');
	});
	this.__defineSetter__('inProgress', function(value)
	{
		$('picker', this.slider)[value ? 'addClass' : 'removeClass']('grayscale');
	});
	
}

WorkersAssigner.prototype._enabled = true;
WorkersAssigner.prototype._current = 0;
WorkersAssigner.prototype.estate = null; // FEstate
WorkersAssigner.prototype.changed = false;

WorkersAssigner.prototype.__construct = function(value)
{
	if (this.DOM.hasAttribute('caption')) this.caption = this.DOM.getAttribute('caption');
	if (this.DOM.hasAttribute('value')) this.value = this.DOM.getAttribute('value');
	if (!this.value) this.value = 0;
	$(this.slider).on('change', $.proxy(function()
	{
		this.changed = true;
		this.updateValue(COM(this.slider).value);
		
	}, this));
	
	COM(this.slider).min = 0;
	
	COM.bindExclusiveClick(this.iconImage.parentNode, $.proxy(function(e){
		
		if (!this.caption) return;
		var tip = document.createElement('div'), img = this.iconImage.cloneNode();
		tip.className = 'text-narrow text-big';
		img.style.float = 'left'; img.style.margin = '0px 8px -4px -8px';
		tip.style.padding = '0px 8px';
		tip.appendChild(img);
		tip.innerHTML += this.caption;
		ToolTip.createAtEvent(tip, e);
		
	}, this));
}

WorkersAssigner.prototype.updateValue = function(v)
{
	this.updateSliderTip();
    
    this.valueLabel.innerHTML = Math.round(COM(this.slider).value);
    this.maxLabel.innerHTML = Math.round(COM(this.slider).max);

	this.onChange(v);
	this.onSelect(v);
}

WorkersAssigner.prototype.onChange = function(value)
{
}

WorkersAssigner.prototype.onSelect = function(value)
{
}

WorkersAssigner.prototype.setMaximum = function(v)
{
	COM(this.slider).max = v;
    this.maxLabel.innerHTML = Math.round(v);
}

WorkersAssigner.prototype.updateMaximized = function(city, max)
{
	this.update(city, max, Math.min(city.freeCitizens, max), max);
}

WorkersAssigner.prototype.updateLimited = function(city, limit, max)
{
	this.update(city, max, limit, max);
}

WorkersAssigner.prototype.update = function(estate, current, limit, max)
{
    if (typeof limit == 'undefined') limit = -1;
    if (typeof max == 'undefined') max = -1;
    
    this.estate = estate;

    if (max >= 0) 
    {
        this.setMaximum(max);
    }
    if (limit >= 0) 
    {
        COM(this.slider).limit = limit;
    }
    this._current = Math.min(Math.min(current, limit), COM(this.slider).max);

    if (!this.changed) 
    {
        this.value = this._current;
    }
    
    this.updateSliderTip();
}

WorkersAssigner.prototype.resetChanged = function()
{
    this.changed = false;
}

WorkersAssigner.prototype.rollback = function()
{
    this.value = this._current;
    this.resetChanged();
}

WorkersAssigner.prototype.updateSliderTip = function()
{
    return;
    var available = this.estate.freeCitizens + this._current - this.value;
    var tax = NumberUtils.equals(this.estate.freeCitizens, 0) ? 0 : this.estate.lastTaxPerHour * available / this.estate.freeCitizens;
    var selfProduction = this.estate.getPeopleSelfreproductionPerHour(available);
    COM(this.slider).update(NumberUtils.floor(selfProduction), NumberUtils.floor(tax), this.estate.race);
}

