function AdvisorDialog()
{
	callParentConstructor(AdvisorDialog.prototype, this);
	
	this._estate = null;
}

extendClass(AdvisorDialog.prototype, Dialog.prototype);

AdvisorDialog.create = function(estate)
{
    var me = COM.create("AdvisorDialog");
    me.init(estate);
    return me;
}

AdvisorDialog.prototype.init = function(estate)
{
    COM(this.deficiency).alwaysHide = [Resource.PEOPLE];
    
    COM(this.distributeWorkers).estate = estate;
    COM(this.distributeWorkers).distributeAll = true;
    
    this._estate = estate;
    this.advisor.src = STATIC_INTERFACE_URL + Assets.getAdvisor(estate.race);
    this.workersHasBeenFired.innerHTML = I18.f("ADVISOR_WORKERS_HAS_BEEN_FIRED", 
            Tick.toDays(FConfig.WORKERS_AUTOFIRE_DELAY),
            FConfig.WORKERS_AUTOFIRE_RATIO * 100);

    UI.show(true, [this.deficiencyBox], $.proxy(function()
    {
        var def = FUser.CURRENT_USER.deficiency.floor();
        if (def.isZero())
        {
            this.deficiencyExplanation.innerHTML = I18.f("ADVISOR_DEFICIENCY_NOTHING");
            this.deficiency.style.display = "none";
        }
        else
        {
            COM(this.deficiency).update(def, estate.race);
            this.deficiency.style.display = "";
            this.deficiencyExplanation.innerHTML = I18.f("ADVISOR_DEFICIENCY");
        }
    }, this));
}