function GateAdvisorDialog()
{
	callParentConstructor(GateAdvisorDialog.prototype, this);
	
	this._estate = null;
	this.userCanClose = false;
}

extendClass(GateAdvisorDialog.prototype, Dialog.prototype);

GateAdvisorDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.yesButton, $.proxy(this.doAction, this));
	COM.bindExclusiveClick(this.noButton, $.proxy(this.close, this));
	COM.bindExclusiveClick(this.magic, $.proxy(this.onSpeedUp, this));
	
	COM(this.magic).icon = STATIC_INTERFACE_URL + "shared/icons/pearl/speed_up_gate.png";
}

GateAdvisorDialog.prototype.popup = function(parent, estate)
{
    superMethod(GateAdvisorDialog.prototype, "popup", this)();
    
    this._estate = estate;
    
    this.advisor.src = STATIC_INTERFACE_URL + Assets.getAdvisor(estate.owner.race);
    this.magic.style.display = this._estate.isCity && this._estate.accessManageble && this._estate.isGateOpen() ? "" : "none";
    if (estate.__className__ == "FOuterEstate")
    {
        if (this._estate.isGateOpen())
        {
            this.messageText.innerHTML = I18.f("ADVISOR_CLOSE_TONNEL");
            this.processName.innerHTML = I18.f("TONNEL_CLOSE_TIME");
            COM(this.time).value = FConfig.GATE_CLOSE_TIME;
        }
        else
        {
            this.messageText.innerHTML = I18.f("ADVISOR_OPEN_TONNEL");
            this.processName.innerHTML = I18.f("TONNEL_OPEN_TIME");
            COM(this.time).value = FConfig.GATE_OPEN_TIME;
        }
    }
    else
    {
        if (this._estate.isGateOpen())
        {
            this.messageText.innerHTML = this.gateClosingText();
            this.processName.innerHTML = I18.f("GATE_CLOSE_TIME");
            COM(this.time).value = FConfig.GATE_CLOSE_TIME;
        }
        else if (estate.science.getLevel(Science.GATE) == 0)
        {
            this.messageText.innerHTML = I18.f("ADVISOR_GATE_NO_SCIENCE");
            UI.show(false, [this.yesButton, this.time]);
            COM(this.noButton).caption = I18.f("OK");
        }
        else
        {
            this.messageText.innerHTML = I18.f("ADVISOR_OPEN_GATE", I18.getBuildingName(BType.CITYHALL, estate.owner.race));
            this.processName.innerHTML = I18.f("GATE_OPEN_TIME");
            //COM(this.time).value = FConfig.GATE_OPEN_TIME;
            COM(this.time).value = this._estate.gateAfterCityMove ? FConfig.GATE_OPEN_AFTER_CITY_MOVE_TIME : FConfig.GATE_OPEN_TIME;
        }
    }
    
    return this;
}

GateAdvisorDialog.prototype.gateClosingText = function()
{
    if (FConfig.GATE_STATE_AFFECTS_EXPEDITORS)
    {
        return I18.f("ADVISOR_CLOSE_GATE_WITH_EXPEDITORS");
    }
    else
    {
        return I18.f("ADVISOR_CLOSE_GATE");
    }
}

GateAdvisorDialog.prototype.doAction = function()
{
    if (this._estate.isGateChanging() || !this._estate.accessDeputy ||
            !this._estate.isGateOpen() && this._estate.science.getLevel(Science.GATE) == 0)
	{
        return;
    }
    if (!Quarantine.contains(Quarantine.GATE))
    {
        Quarantine.put(Quarantine.GATE);
        Service.city.callMethod("openGate", [this._estate.id, !this._estate.isGateOpen()], null, function (e)
        {
            return e.__className__ == "IllegalGateStateException";
        });
    }
    
    this.close();
}

GateAdvisorDialog.prototype.onSpeedUp = function()
{
    COM.create("GateChestDialog").popup(this, this, this._estate);
}