function AbstractReducer()
{
	this.vanish = 0;
}

AbstractReducer.prototype.vanish = 0;

AbstractReducer.prototype.getVanishPerTick = function(c, overflow)
{
	throw new Error('Abstract method');
}

AbstractReducer.prototype.getOverflow = function(c)
{
	throw new Error('Abstract method');
}

AbstractReducer.prototype.reduce = function(c, toVanish)
{
	throw new Error('Abstract method');
}

AbstractReducer.prototype.getVanishPerHour = function(estate)
{
    return this.computeVanishPerTick(estate) * Tick.TICKS_PER_HOUR;
}

AbstractReducer.prototype.computeVanishPerTick = function(estate)
{
    return this.getVanishPerTick(estate, Math.max(this.getOverflow(estate) , 0));
}

AbstractReducer.prototype.tick = function(estate, delta)
{
    this.vanish += this.computeVanishPerTick(estate) * delta;

    if (NumberUtils.isPositive(this.vanish)) 
    {
        var toVanish = NumberUtils.floor(this.vanish);
        if (toVanish > 0) 
        {
            this.vanish -= toVanish;
            this.reduce(estate, toVanish);
        }
    }
}
