function ArmyReducer()
{
	this.starved = null;
	this.died = null;
}

extendClass(ArmyReducer.prototype, AbstractReducer.prototype);

ArmyReducer.prototype.starved = null;
ArmyReducer.prototype.died = null;

ArmyReducer.prototype.getVanishPerTick = function(c, overflow)
{
    if (c.hasBuff(BuffType.NO_DESERTION)) 
    {
        return 0;
    }
    return overflow * FConfig.UNPAID_UNITS_DEATH_RATE / Tick.TICKS_PER_HOUR;
}

ArmyReducer.prototype.getOverflow = function(c)
{
    var requiredGold = c.getConsumptionPerHour() / Tick.TICKS_PER_HOUR;
    if (NumberUtils.equals(requiredGold, 0)) 
    {
        return 0;
    }
    return (c.garrison.getTotalUnitCount() + c.hideout.getTotalUnitCount()) * c.consumptionDeficit / requiredGold;
}

ArmyReducer.prototype.reduce = function(c, toVanish)
{
    for (var i = 0; i < toVanish; i++) 
    {
        this.reduceOneUnit(c);
    }
}

ArmyReducer.prototype.reduceOneUnit = function(c)
{
    var minRatio = 1;
    var minI = -1;
    var garrison = c.garrison;
    var hideout = c.hideout;
    for (var i = 0; i < UnitType.MILITARY.length * 2; i++) 
    {
        var units = i < UnitType.MILITARY.length ? garrison.getByOrdinal(i) : hideout.getByOrdinal(i - UnitType.MILITARY.length);
        if (units > 0) 
        {
            this.starved[i] += units;
            var ratio = this.died[i] / this.starved[i];
            if (ratio < minRatio) 
            {
                minRatio = ratio;
                minI = i;
            }
        }
    }
    if (minI == -1) 
    {
        throw new Error("Can not kill units from empty garrison");
    }

    this.died[minI]++;
    
    if (minI < UnitType.MILITARY.length) 
    {
        c.garrison.killUnit(UnitType.MILITARY[minI], 1);
    } 
    else 
    {
        c.hideout.killUnit(UnitType.MILITARY[minI - UnitType.MILITARY.length], 1);
    }
}
