var FDrainCalculator = function()
{
	this.reducers = [];
}

FDrainCalculator.prototype.reducers = [];

FDrainCalculator.prototype.tick = function(estate, delta)
{
    for (var i = 0; i < this.reducers.length; i++)
    {
    	this.reducers[i].tick(estate, delta);
    }
}

FDrainCalculator.prototype.getResourceReducer = function(r)
{
    for (var i = 0; i < this.reducers.length; i++)
    {
        var reducer = this.reducers[i];
        var cls = reducer ? reducer.__CLS__.split('.').pop() : '';
        if (cls == 'ResourceReducer' && reducer.resource.equals(r)) 
        {
            return reducer;
        }
    }
    return null;
}

FDrainCalculator.prototype.getDrainPerHour = function(estate) 
{
    var res = new Funds();
    for (var i = 0; i < this.reducers.length; i++)
    {
        var reducer = this.reducers[i];
        var cls = reducer ? reducer.__CLS__.split('.').pop() : '';
        if (cls == 'ResourceReducer') 
        {
            res.addResource(reducer.resource, reducer.getVanishPerHour(estate));
        } 
        else if (reducer instanceof PopulationReducer) 
        {
            res.addResource(Resource.PEOPLE, reducer.getVanishPerHour(estate));
        }
    }
    return res;
}

FDrainCalculator.prototype.getPopulationReducer = function() 
{
    for (var i = 0; i < this.reducers.length; i++)
    {
        var reducer = this.reducers[i];
        var cls = reducer ? reducer.__CLS__.split('.').pop() : '';
        if (cls == 'PopulationReducer') 
        {
            return reducer;
        }
    }
    return null;
}
