function PopulationReducer(r)
{
	this.nextBuildingIndex = 0;
}

extendClass(PopulationReducer.prototype, AbstractReducer.prototype);

PopulationReducer.prototype.nextBuildingIndex = 0;

PopulationReducer.prototype.getVanishPerTick = function(c, overflow)
{
    var rest = 1 + c.peopleDrainReduction;
    if (rest < 0) 
    {
        return 0;
    }
    return overflow * (overflow * FConfig.HOMELESS_PEOPLE_DEATH_OVERFLOW_RATE + FConfig.HOMELESS_PEOPLE_DEATH_RATE) / Tick.TICKS_PER_HOUR * rest;
}

PopulationReducer.prototype.getOverflow = function(c)
{
    return c.totalCitizens - c.capacity.getValue(Resource.PEOPLE);
}

PopulationReducer.prototype.reduce = function(c, toVanish)
{
    var freeCitizens = c.freeCitizens;
    if (toVanish > freeCitizens) 
    {
        c.bank.subtractResource(Resource.PEOPLE, freeCitizens);
        var plodders = toVanish - freeCitizens;
        for (var i = 0; i < plodders; i++) 
        {
            this.reduceOnePlodder(c);
        }
    } 
    else 
    {
        c.bank.subtractResource(Resource.PEOPLE, toVanish);
    }
}

PopulationReducer.prototype.reduceOnePlodder = function(c)
{
    var total = c.workers + c.builders;
    if (total <= 0) 
    {
        console.warn("ERROR! Could not kill plodder from a city: no plodders found");
        return;
    }
    var killed = false;
    var size = c.getOwnedBuildings().length;
    for (var i = 0; i < size; i++) 
    {
        var building = c.getOwnedBuildings()[this.nextBuildingIndex++ % size];
        if (building.builders > 0) 
        {
            building.killBuilder();
            killed = true;
            break;
        } 
        else if (building.workers > 0 && c.builders == 0) 
        {
            building.killWorker();
            killed = true;
            break;
        }
    }
    if (!killed) 
    {
        console.warn("ERROR! Could not kill plodder from a city: unknown reason");
    }
}
