function HexNeighbours(hexes, cell)
{
	this.hexes = hexes;
	this.cellIndex = cell;
	
	this.__defineGetter__('length', function()
	{
		return this.hexes.length;
	});
};

HexNeighbours.CELLS_WITH_GATE = [50 + 32, 22 + 32, 21 + 32];
HexNeighbours.LAST_CELL_THAT_TOUCHES_CITYHALL = 18 + 32;

HexNeighbours.prototype =
{
    cellIndex: 0,

    hexes: [],

    hasSimpleJointAt: function(m, n, city)
    {
        return this.hasWallWith(m, city) && this.hasWallWith(n, city);
    },

    hasWallWith: function(i, city)
    {
        // not inside the wall?
        if (!city.isInsideCityWall(this.cellIndex))
        {
            return false;
        }

        var h = this.hexes[i];

        // absent (outer edge only) OR present + not inside the wall?
        return (!h && this.cellIndex > HexNeighbours.LAST_CELL_THAT_TOUCHES_CITYHALL) ||
               (h && !city.isInsideCityWall(h.cellIndex));
    },

    hasGate: function()
    {
        for(var i=0; i<HexNeighbours.CELLS_WITH_GATE.length; i++)
        {
        	if(HexNeighbours.CELLS_WITH_GATE[i] == this.cellIndex) return true;
        }
        return false;
    }
};

HexNeighbours.getGateIndex = function(city)
{
    for(var i=0; i<HexNeighbours.CELLS_WITH_GATE.length; i++)
    {
    	if (city.isInsideCityWall(HexNeighbours.CELLS_WITH_GATE[i]))
    	{
            return HexNeighbours.CELLS_WITH_GATE[i];
        }
    }
    throw Error("Could not find gate index with cell count " + city.getMaxCellIndex());
}