function ManageAutoExpedition()
{
	this.changeAutoExpedition = $.proxy(this.changeAutoExpedition, this);
	this.buyPremium = $.proxy(this.buyPremium, this);
}

ManageAutoExpedition.prototype.estate = null; // FEstate;
ManageAutoExpedition.prototype.building = null; // FBuilding;

ManageAutoExpedition.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.autoExpSwitch, this.changeAutoExpedition);
	COM.bindExclusiveClick(this.autoExpIcon, this.buyPremium);
}

ManageAutoExpedition.prototype.startAutoExpedition = function()
{
    var toXY = COM(this.coordsChooser).getCoordsXY();
    if (this.estate.location.isInRadiusFrom(toXY, this.estate.owner.getScienceValue(Science.CARTOGRAPHY))) 
    {
        for (var i = 0; i < FUser.CURRENT_USER.pausedAutoExpeditions.keys.length; i++) 
        {
        	var paused = FUser.CURRENT_USER.pausedAutoExpeditions.keys[i];
            if ((paused.x == toXY.x) && (paused.y == toXY.y)) 
            {
                var tick = FUser.CURRENT_USER.pausedAutoExpeditions.getValue(paused);
                
                var d;
                var actions = [
                	{
                		caption: I18.f('CONTINUE'), skin: 'green', 
                		onclick: $.proxy(function(){ this.doStartAE(paused, false); d.close(); }, this) 
                	},
                	{
                		caption: I18.f('START_OVER'), skin: 'yellow', 
                		onclick: $.proxy(function(){ this.doStartAE(paused, true); d.close(); }, this) 
                	},
                ]
                d = Alert.createWithActions(
                	I18.mega(I18.f('AUTOEXPEDITION_PAUSED'), [tick]),
                	I18.f('PREMIUM_ACCOUNT_AUTOEXPEDITION_KINGDOM'),
                	actions, this
                );
                d.hideDefaultActions = true;
                return;
            }
        }
        this.doStartAE(toXY, false);
    } 
    else 
    {
        Alert.create(I18.f('MISSION_EXPEDITION_IS_TO_FAR'), I18.f('ERROR'));
    }
}

ManageAutoExpedition.prototype.doStartAE = function(xy, reset)
{
    Service.city.callMethod('startAutoExpedition', [this.estate.id, this.building.id, xy, reset], 
	    $.proxy(function(e){
	    	
	    	// e:FEstate. update?
	    	
	    }, this),
	    $.proxy(function(e)
	    {
            Alert.create(e.getMessage(), I18.f('ERROR'));
            return true;
            
	    }, this)
	);
}

ManageAutoExpedition.prototype.stopAutoExpedition = function()
{
    Service.city.callMethod('stopAutoExpedition', [this.estate.id, this.building.id]);
}

ManageAutoExpedition.prototype.changeAutoExpedition = function()
{
    if (this.building.autoExpeditionEnabled) 
    {
        this.stopAutoExpedition();
    } 
    else 
    {
        this.startAutoExpedition();
    }
}

ManageAutoExpedition.prototype.buyPremium = function()
{
    PaymentDialog.popup(this.estate.owner);
}

ManageAutoExpedition.prototype.tick = function(_estate, _building)
{
    if (!_estate || !_building) return;
    this.estate = _estate;
    this.building = _building;

    COM(this.autoExpSwitch).reason = null;
    if (!this.estate.accessManageble) 
    {
        COM(this.autoExpSwitch).reason = I18.f('ACCOUNT_OWNER_ONLY');
    } 
    else if (!this.estate.owner.isPremium()) 
    {
        COM(this.autoExpSwitch).reason = I18.f('PREMIUM_ACCOUNT_OWNER_ONLY');
    }
    
    var reason = '';
    if (this.building.autoExpeditionEnabled && this.building.unitsTotal == 0) 
    {
        reason = I18.f('AUTOEXPEDITION_NO_EXPEDITORS');
    } 
    else if (this.building.autoExpeditionEnabled && this.estate.isGateClosed()) 
    {
        reason = I18.f('AUTOEXPEDITION_OPEN_GATE');
    } 
    
    UI.show(!reason, [this.titleBox]);
    if (UI.show(reason, [this.reasonBox]))
    {
    	this.cantAutoExpeditReason.innerHTML = reason;
    }
    
    COM(this.coordsChooser).enableInput = !COM(this.autoExpSwitch).reason && !this.building.autoExpeditionEnabled;

    COM(this.autoExpSwitch).caption = this.building.autoExpeditionEnabled ? I18.f('STOP') : I18.f('START');
    COM(this.autoExpIcon).activate(this.estate.owner.premiumExpirationTick);
    //COM(this.autoExpIcon).visible = this.estate.accessManageble;
}

ManageAutoExpedition.prototype.firstUpdate = function()
{
	//var d = Dialog.find(this);
	//if (d) d.headerRightBox.appendChild(this.autoExpIcon);
	//this.firstUpdate = function(){};
}

ManageAutoExpedition.prototype.update = function(_estate, _building)
{
	this.firstUpdate();
    // updating selected/enabled/tooltips
    this.tick(_estate, _building);
    // display coords
    var xy = this.building.autoExpeditionKingdom 
    	? this.building.autoExpeditionKingdom 
    	: this.estate.location
    ;
    // updating texts
    COM(this.coordsChooser).setCoordsXY(xy);
}
