var ManageCapacitor = function()
{
	callParentConstructor(ManageCapacitor.prototype, this);
}

extendClass(ManageCapacitor.prototype, ManageDialogChild.prototype);

ManageCapacitor.prototype.__construct = function()
{
	var magic = COM.create('BoostPeriodicalButton');
	this.btnSpecial = magic.DOM;
	
	this.capacityBox.style.cursor = 'pointer';
	this.drainBox.style.cursor = 'pointer';
	this.populationIncreaseBox.style.cursor = 'pointer';
	COM.bindExclusiveClick(this.capacityBox, $.proxy(this.showSummaryTip, this));
	COM.bindExclusiveClick(this.drainBox, $.proxy(this.showSummaryTip, this));
	COM.bindExclusiveClick(this.populationIncreaseBox, $.proxy(this.showSummaryTip, this));
}

ManageCapacitor.prototype.onShow = function()
{
	this.populationIncreaseImage.src = STATIC_URL + Assets.getFreePeopleIcon(this.dialog.estate.owner.race);
}

ManageCapacitor.prototype.tick = function()
{
    var b = this.cell.building;
    COM(this.btnSpecial).update(b);
    var isHouse = b.type.isHouses();
    
    var uiFlag;
    
    uiFlag = isHouse;
    UI.show(uiFlag, [this.populationIncreaseBox, this.populationIncreaseLabel]);
    if (uiFlag)
    {
    	this.populationIncrease.innerHTML = I18.f('PER_TIME', b.getPeopleProductionSpeedPerHour());
    }
    
    uiFlag = (b.getLevel().drainReduction != 0);
    UI.show(uiFlag, [this.drainBox, this.drainLabel]);
    $(this.drainValue).removeClass('negative positive overflow');
    if (uiFlag)
    {
        this.drainLabel.innerHTML = isHouse ? I18.f('PEOPLE_DRAIN') : I18.f('RESOURCES_DRAIN');
        if (b.isWorking) 
        {
            this.drainValue.innerHTML = Strings.formatNumberPercent(b.getLevel().drainReduction * 100+'', true, 0);
            $(this.drainValue).addClass('positive');
        } 
        else 
        {
            this.drainValue.innerHTML = Strings.formatNumberPercent('0', true, 0);
            $(this.drainValue).addClass('negative');
        }
    }
    
    this.capacityLabel.innerHTML = isHouse ? I18.f('PEOPLE_CAPACITY') : I18.f('RESOURCE_CAPACITY');
    this.capacityValue.innerHTML = (isHouse ? b.getPeopleCapacity() : b.getCapacity()).toString();
    
    $(this.capacityValue).css('text-decoration', this.estate.getCapacityBonus(b.type) != 0 ? 'underline' : 'none');
    
    $(this.capacityValue).removeClass('negative positive overflow');
    $(this.populationIncrease).removeClass('negative positive overflow');
    if (b.isBroken || b.isRepairing || b.isBuildPending) 
    {
        $(this.capacityValue).addClass('negative');
        $(this.populationIncrease).addClass('negative');
    } 
    else 
    {
        this.capacityValue.className = "";
        $(this.populationIncrease).addClass(b.isHousesOverfilled() || this.estate.getStoppingBuff(b.type) ? 'negative' : 'positive');
    }
}

ManageCapacitor.prototype.showSummaryTip = function()
{
    superMethod(this, 'showSummaryTip')();
    
    var tip;
    
    tip = CapacityTipFactory.create(this.cell.building);
    this.summaryTipDialog.addTip(tip, this.capacityLabel.innerHTML);
    
    if (this.cell.building.type.isHouses())
    {
		tip = CapacityTipFactory.createAsRaiser(this.cell.building);
		this.summaryTipDialog.addTip(tip, this.populationIncreaseLabel.innerHTML);
    }
}
