function ManageCatapultMission()
{
	this.estate = null; // FEstate
	this.building = null; // FBuilding
	this.isSending = false;
}

ManageCatapultMission.prototype.estate = null; // FEstate
ManageCatapultMission.prototype.building = null; // FBuilding
ManageCatapultMission.prototype.isSending = false;

ManageCatapultMission.prototype.__construct = function()
{
	this.sendMission = $.proxy(this.sendMission, this);
	$(this.sendMissionButton).on(CLICK_EVENT, this.sendMission);
}

ManageCatapultMission.prototype.sendMission = function()
{
    var mission = new MissionCatapultOrder();
    mission.fromEstateXYZ = this.estate.location;
    mission.toFieldXYZ = COM(this.coordsChooser).getCoordsXYZ();
    mission.clientDuration = -1;
    
    this.isSending = true;
    
    Service.mission.callMethod('createMission', [mission],
    	$.proxy(function(f){
            Service.city.callMethod('getById', [this.estate.id], 
	            $.proxy(function (f) { this.isSending = false; }, this),
	            $.proxy(function (e) { this.isSending = false; return false; }, this)
            );
    	}, this),
    	$.proxy(function(error){
            if (error.IS_GAME_EXCEPTION && error.type == "DURATION_CHANGED") 
            {
                Alert.create(I18.f('DURATION_HAS_CHANGED'), I18.f('ERROR'));
                return true;
            }
            if (error.__className__ == 'CantStartMissionException' || error.__className__ == 'NotEnoughResourcesException' || error.__className__ == 'NotEnoughArmyException') 
            {
                Alert.create(error.getMessage(), I18.f('ERROR'));
                return true;
            }
            
            Alert.create(I18.f('MISSION_WAS_NOT_SENT'), I18.f('ERROR'));
            return false;
    	}, this)
    );
}

ManageCatapultMission.prototype.tick = function(_estate, _building)
{
    this.estate = _estate;
    this.building = _building;

    var reason = null;
	if (!this.estate.accessCatapultManageble) 
	{
		reason = I18.f('CATAPULT_NO_PERMISSIONS');
	} 
	else if (this.building.unitsPresent == 0) 
	{
		reason = I18.f('CATAPULT_EXPEDITION_NO_UNITS');
	} 
	else if (this.building.autoExpeditionEnabled && this.estate.isGateClosed()) 
	{
		reason = I18.f('CATAPULT_EXPEDITION_GATE_CLOSED');
	} 
	
	COM(this.sendMissionButton).reason = reason;
	//COM(this.sendMissionButton).enabled = !reason && !this.isSending;
    COM(this.coordsChooser).enableInput = !reason;
}

ManageCatapultMission.prototype.update = function(_estate, _building)
{
    // updating selected/enabled/tooltips
    this.tick(_estate, _building);
    // display coords
    var xy = this.building.autoExpeditionKingdom ? this.building.autoExpeditionKingdom : this.estate.location;
    // updating texts
    COM(this.coordsChooser).setCoordsXY(xy);
}
