var ManageCatapultSiege = function()
{
	callParentConstructor(ManageCatapultSiege.prototype, this);

	this.isChangingState = false; // Boolean
	this.targetBuildingType = null; // BType
	
	this.__defineGetter__('catapult', function(){ return this.estate; });
}

extendClass(ManageCatapultSiege.prototype, ManageDialogChild.prototype);

ManageCatapultSiege.prototype.isChangingState = false; // Boolean
ManageCatapultSiege.prototype.targetBuildingType = null; // BType

ManageCatapultSiege.prototype.__construct = function()
{
	this.handleSuccess = $.proxy(this.handleSuccess, this);
	this.handleError = $.proxy(this.handleError, this);
	this.setTargetBuildingType = $.proxy(this.setTargetBuildingType, this);
	this.onSelectBuildingType = $.proxy(this.onSelectBuildingType, this);
	this.changeSiege = $.proxy(this.changeSiege, this);
	
	$(this.buildingType).on(CLICK_EVENT, this.onSelectBuildingType);
	$(this.changeSiegeButton).on(CLICK_EVENT, this.changeSiege);
}

ManageCatapultSiege.prototype.onShow = function()
{
    this.setTargetBuildingType(null);
    this.update(this.estate);
}

ManageCatapultSiege.prototype.tick = function()
{
    hasPermissions = !this.estate ? false : this.estate.accessCatapultManageble;
    
    COM(this.changeSiegeButton).reason = null;
    if (!this.catapult || this.catapult.isSettingUp || !hasPermissions) 
    {
        COM(this.coords).enableInput = false;
        COM(this.buildingType).enabled = false;
        this.buildingLabel.innerHTML = '&nbsp;';
        
        COM(this.changeSiegeButton).reason = hasPermissions 
        	? I18.f('CATAPULT_IS_SETTINGUP') 
        	: I18.f('CATAPULT_SIEGE_NO_PERMISSIONS')
        ;
    }
    else 
    {
        this.setTargetBuildingType(this.catapult.targetBuilding || this.targetBuildingType);
        if (this.catapult.siegeStarted) 
        {
            COM(this.coords).enableInput = false;
            COM(this.buildingType).enabled = false;
            this.buildingLabel.innerHTML = '&nbsp;';
            COM(this.changeSiegeButton).caption = I18.f('STOP');
            COM(this.changeSiegeButton).skin = 'yellow';
            COM(this.coords).setCoordsXYZ(this.catapult.targetLocation);
        } 
        else 
        {
            COM(this.coords).enableInput = true;
            COM(this.buildingType).enabled = true;
            this.buildingLabel.innerHTML = I18.f('SELECT_BUILDING_TO_DESTROY');
            COM(this.changeSiegeButton).caption = I18.f('START');
            COM(this.changeSiegeButton).skin = 'green';
            COM(this.coords).setCoordsXY(this.estate.location);
        }
    }

}

ManageCatapultSiege.prototype.update = function(estate)
{
	this.tick();
}

ManageCatapultSiege.prototype.changeSiege = function()
{
    if (!this.catapult) return;
    
    this.isChangingState = true;
    if (this.catapult.siegeStarted) 
    {
        Service.city.callMethod('stopSiege', [this.estate.id], this.handleSuccess, this.handleError);
    } 
    else 
    {
        var coords = COM(this.coords).getCoordsXYZ();
        Service.city.callMethod('startSiege', [this.estate.id, coords, this.targetBuildingType], this.handleSuccess, this.handleError);
    }
}

ManageCatapultSiege.prototype.handleSuccess = function(estate)
{
    this.isChangingState = false;
    this.tick();
}

ManageCatapultSiege.prototype.handleError = function(e)
{
    this.isChangingState = false;
    this.tick();
    if (e instanceof CatapultException) 
    {
        CatapultException.errorHandler(e);
        return true;
    }
    if (e.IS_GAME_EXCEPTION) 
    {
        Alert.create(e.getMessage(), I18.f('ERROR'));
        return true;
    }
    return false;
}

ManageCatapultSiege.prototype.setTargetBuildingType = function(bt)
{
    this.targetBuildingType = bt;
    
    var img = COM(this.buildingType).buildingImage;
    var src = STATIC_URL + CommonAssets.BLOCKER_DARKTREE;
    if (this.targetBuildingType)
    {
		src = STATIC_URL + (
			Assets.B_findByOrNull(FUser.CURRENT_USER.race, this.targetBuildingType) 
			|| 
			Assets.B_findBy(Race.CASTLE_MONSTER, this.targetBuildingType)
		);
		img.style.backgroundPosition = '35% 60%';
    }
    else
    {
    	img.style.backgroundPosition = '50% 60%';
    }
    img.style.backgroundImage = 'url("' + src + '")';
    
	COM(this.changeSiegeButton).reason = this.targetBuildingType 
		? null 
		: I18.f('SELECT_BUILDING_TO_DESTROY')
	;
    
}

ManageCatapultSiege.prototype.onSelectBuildingType = function()
{
    SelectBuildingToSiegeDialog.popup(FUser.CURRENT_USER.race, null, this.setTargetBuildingType);
}
