var ManageClanCapacitor = function()
{
	callParentConstructor(ManageClanCapacitor.prototype, this);
}

extendClass(ManageClanCapacitor.prototype, ManageDialogChild.prototype);

ManageClanCapacitor.prototype.update = function(estate)
{
    superMethod(this, 'update')(estate);
    COM(this.transferUI).update(this.building,  estate.owner.diplomacy.clan, estate.gateState);
    COM(this.transferUI).onTransfer = $.proxy(this.onTransfer, this);
    COM(this.transferUI).onTransferToCastle = $.proxy(this.onTransferToCastle, this);
    COM(this.transferUI).onDistribute = $.proxy(this.onDistribute, this);
    this.tick();
}

ManageClanCapacitor.prototype.tick = function()
{
    superMethod(this, 'tick')();
    COM(this.transferUI).tick();
}

ManageClanCapacitor.prototype.reset = function()
{
    superMethod(this, 'reset')();
    COM(this.transferUI).reset();
}

ManageClanCapacitor.prototype.onError = function(e)
{
    if (e instanceof ClanException) 
    {
        Alert.create(e.getMessage(), I18.f('ERROR'));
        return true;
    }
    return false;
}

ManageClanCapacitor.prototype.onSuccess = function(estate)
{
    this.reset();
    this.update(estate);
}

ManageClanCapacitor.prototype.onTransfer = function(username, funds)
{
    Service.alliance.callMethod('transferClanResources', 
    	[this.estate.id, this.building.type, username, funds],
    	$.proxy(this.onSuccess, this), 
    	$.proxy(this.onError, this) 
    );
}

ManageClanCapacitor.prototype.onTransferToCastle = function(xyz, funds)
{
    Service.alliance.callMethod('transferClanResourcesToCastle', 
    	[this.estate.id, this.building.type, xyz, funds],
    	$.proxy(this.onSuccess, this), 
    	$.proxy(this.onError, this) 
    );
}

ManageClanCapacitor.prototype.onDistribute = function(funds)
{
    Service.alliance.callMethod('distributeClanResources', 
    	[this.estate.id, funds, this.building.type],
    	$.proxy(this.onSuccess, this), 
    	$.proxy(this.onError, this) 
    );
}
