var ManageDialog = function(params)
{
	this.switchBuilding = function(){};
	this.switchDialog = function(){};
	this.workers = 0;
	this.reason = 0;
	this._child = null//:ManageDialogChild;
	this._cellIndex = 0;
	
	if (params) 
	{
		for (var prop in params) 
		{
			this[prop] = params[prop];
		}
	}
	
	this.__defineGetter__('cell', function() { return this.estate.getCellByIndex(this._cellIndex); });
	this.__defineGetter__('building', function()
	{
		if (this._child) return this._child.building || this.cell.building;
		return this.cell.building;
	});
	
	this.__defineGetter__('cellIndex', function() { return this._cellIndex; });
	
	this.onFinishConstructionNow = $.proxy(this.onFinishConstructionNow, this);
	
	this.scroll = null;
	this.actionsVisible = true;
}

extendClass(ManageDialog.prototype, UpdatableEstateDialog.prototype);

ManageDialog.prototype.scroll = null;
ManageDialog.prototype.actionsVisible = true;
ManageDialog.prototype.__getLayout = function()
{
    if (this.reason) return 'default';
    
    var b = this.building;
    
    var layout = 'default';
    if (b.type.isEstateHall()) 
    {
        return 'cityhall';
    } 
    else if (
    	(b.type.isMilitaryUnitProducer() || b.type.isSpecialUnitProducer())
    	|| b.type.isMarket()
    	|| b.type.isTemple()
    	|| b.type.isDiplomatHall()
    	|| b.type.isResurrector()
    	|| (b.type.name == BType.TAVERN.name)
    ) 
    {
        return 'dark';
    } 
    return 'default';
}

ManageDialog.prototype.__getTemplate = function()
{
	var layouts = $('<span>' + COM.getData(this.__templateClass, 'template') + '</span>');
	
	var layoutClass = this.__getLayout();
	layout = layouts.find('layout[class=' + layoutClass + ']').html() || layouts.find('layout[class=default]').html();
	layout = $('<layout>' + layout + '</layout>');
	
	var manageActions = layouts.find('manage-actions').html();
	if (!layout.find('HeaderRight').length) layout.prepend('<HeaderRight></HeaderRight>');
	layout.find('HeaderRight').append(manageActions);
	
	var tpl = superMethod(this, '__getTemplate')(layout.html());
	
	return tpl;
}

ManageDialog.prototype.__getSkin = function()
{
	var layout = this.__getLayout(), skin = 'default';
	if (this.reason) return 'default';
	switch (layout)
	{
		//case 'unitproducer':
		case 'dark':
			return 'darkwood';
			
		default:
			return 'default';
	}
}

ManageDialog.prototype.__construct = function()
{
	COM.bindProperties(this);
	callParentConstructor(ManageDialog.prototype, this);
	COM.bindExclusiveClick(this.actionMagicFinishConstruction, $.proxy(this.onFinishConstructionNow, this));
}

ManageDialog.prototype.__destruct = function()
{
	UnitTip.clear();
}

ManageDialog.prototype.manageInProgress = false;
ManageDialog.prototype.onResult = function (b, builders, workers)
{
    if (this.manageInProgress) return false;
    this.manageInProgress = COM(this.workersAssigner).inProgress = COM(this.buildersAssigner).inProgress = true;
    var b = this.building;
    Service.city.callMethod('manageBuilding', [b.estate.id, b.id, builders, workers],
    	$.proxy(function(){
    		this.manageInProgress = COM(this.workersAssigner).inProgress = COM(this.buildersAssigner).inProgress = false;
    	}, this), 
    	$.proxy(function(){
    		this.manageInProgress = COM(this.workersAssigner).inProgress = COM(this.buildersAssigner).inProgress = false;
    	}, this) 
    );
};

ManageDialog.prototype.popup = function(parent, cellIndex, estate)
{
    if (this._child)
    {
    	this._child.destroy();
    }
    
    this.estate = estate || this.estate;
    this._cellIndex = cellIndex;
	
    var b = this.building;
    
    // only building without additional controls by default
    var childClass = 'ManageDialogChild', fullScreen = false;
    
    if (b.type.isMilitaryUnitProducer()) 
    {
        childClass = 'ManageMilitaryUnitProducer';
        fullScreen = true;
    } 
    else if (b.type.isSpecialUnitProducer()) 
    {
        childClass = 'ManageSpecialUnitProducer';
        fullScreen = true;
    } 
    else if (b.type.isEstateHall()) 
    {
        childClass = 'ManageHall';
        fullScreen = true;
    } 
    else if (b.type.isRaiser() || b.type.isRecovery()) 
    {
        childClass = 'ManageRaiser';
    } 
    else if (b.type.isAlchemist()) 
    {
        childClass = 'ManageAlchemist';
    } 
    else if (b.type.isMarket()) 
    {
        childClass = 'ManageMarket';
        fullScreen = true;
    } 
    else if (b.type.isTemple()) 
    {
        childClass = 'ManageTemple';
        fullScreen = true;
    } 
    else if (b.type.isDiplomatHall()) 
    {
        childClass = 'ManageDiplomatHall';
        fullScreen = true;
    } 
    else if (b.type.isResurrector()) 
    {
        childClass = 'ManageResurrector';
        fullScreen = true;
    } 
    else if (b.type.isFortification()) 
    {
        childClass = 'ManageFortification';
    } 
    else if (b.type.isTower()) 
    {
        childClass = 'ManageTower';
    } 
    else if (b.type.isHouses() || b.type.isWarehouse()) 
    {
        childClass = 'ManageCapacitor';
    } 
    else if (b.type.isClanCapacitor()) 
    {
        childClass = 'ManageClanCapacitor';
        fullScreen = true;
    } 
    else if (b.type.name == BType.TAVERN.name) 
    {
        childClass = 'ManageTavern';
        fullScreen = true;
    } 
    else if (b.type.name == BType.ARTIFACT_STORE.name) 
    {
        childClass = 'ManageArtifactStore';
    } 
    else if (b.type.name == BType.PRISON.name) 
    {
        childClass = 'ManagePrison';
    } 
    else if (b.type.name == BType.ARENA.name) 
    {
        childClass = 'ManageArena';
    } 
    else if (b.type.name == BType.CLAN_DIPLOMAT.name) 
    {
        childClass = 'ManageClanDiplomatHall';
    } 
    else if (b.type.name == BType.CASTLEGATE.name) 
    {
        childClass = 'ManageCastleGate';
    }
    else if (b.type.name == BType.TERRAFORMER.name) 
    {
        childClass = 'ManageTerraformer';
    }
    else if (b.type.name == BType.CATAPULTHALL.name) 
    {
        childClass = 'ManageCatapultSiege';
    }
	
	if (this.reason)
	{
		childClass = 'ManageDialogChild';
		$(this.DOM).addClass('manage-dialog-reason');
		fullScreen = false;
	}
	
	if (childClass)
	{
		this._child = ManageDialogChild.create(childClass);
        this._child.dialog = this;
        
        this.initBasicBuildingControls();
        
        this.childHolder.innerHTML = '';
        this.childHolder.appendChild(this._child.DOM);
        
        if (this._child.btnSpecial)
        {
        	$('.citymenu-button-special', this.DOM).append(this._child.btnSpecial);
        }
		$(this.DOM).addClass('child-' + childClass);
	}
	
	var layout = this.__getLayout();
	$(this.DOM).addClass('layout-' + layout);
	
	this.skin = this.__getSkin();
	
	superMethod(this, 'popup')();
	if (fullScreen)
	{
		this.fullScreen();
	}
	
	this.scroll = this._child['scroll'] || new iScroll(this.childHolder);
	
	this.update(estate);
}

ManageDialog.prototype.initBasicBuildingControls = function()
{
	if (this._child)
	{
		if (typeof this._child['initBasicBuildingControls'] == 'function')
		{
			this._child.initBasicBuildingControls();
		}
		this.buildingView = this._child.buildingView;
		this.workersAssigner = this._child.workersAssigner;
		this.buildersAssigner = this._child.buildersAssigner;
	}
	
	if (!this.buildingView)
	{
	    this.buildingView = COM.create('SwitchBuildingView').DOM;
	    this.buildingWrapper.appendChild(this.buildingView);
	}
	$(this.buildingView).on('change', $.proxy(function(e)
	{
		this.switchBuilding(this, e.dir);
		
	}, this));
	
	if (!this.workersAssigner)
	{
		this.workersAssigner = COM.create('WorkersAssigner').DOM;
		$(this.slidersWrapper).append(this.workersAssigner);
	}
	$(this.workersAssigner).on('select', $.proxy(this.onWorkersChange, this));
	$(this.workersAssigner).on('finish', $.proxy(this.onWorkersChangeFinish, this));
	
	if (!this.buildersAssigner)
	{
		this.buildersAssigner = COM.create('WorkersAssigner').DOM;
		$(this.slidersWrapper).append(this.buildersAssigner);
	}
	
	$(this.buildersAssigner).on('change', $.proxy(this.updateTime, this));
	$(this.buildersAssigner).on('select', $.proxy(this.updateTime, this));
}

ManageDialog.prototype.init = function()
{
    var uiFlag = false;
    
    this.updateSwitchCells();
    
    var b = this.building;
    COM(this.buildingView).update(b, this.estate.getOrderByCellIndex(this._cellIndex), this.estate.race, this.switchCells, this.switchCellsIndex);
    
    //Effects.shadow(buildingView.statusIcon, Effects.RED, 15);
    
    uiFlag = b.type.isRequiresWorkers(b.race);
    if (UI.show(uiFlag, [this.workersAssigner]))
    {
	    COM(this.workersAssigner).caption = I18.getWorkers(b.type);
	    COM(this.workersAssigner).icon = 'workers';
	    COM(this.workersAssigner).setMaximum(b.getLevel().workers);
    }
    
    COM(this.buildersAssigner).caption = I18.f('BUILDERS');
    COM(this.buildersAssigner).icon = 'builders';
    if (b.isRepairing) 
    {
        COM(this.buildersAssigner).setMaximum(b.getLevel().builders);
    } 
    else 
    {
        COM(this.buildersAssigner).setMaximum(b.getNextLevel().builders);
    }
    
    if (this._child) 
    {
        this._child.onShow();
    }
    
    UI.show(true, [this.childHolder]);
    this.setSliders();
    
    this.refreshScroll(300);
}

ManageDialog.prototype.switchCells = [];
ManageDialog.prototype.switchCellsIndex = 0;
ManageDialog.prototype.updateSwitchCells = function()
{
    if(!this.building) return;
    
    this.switchCells = [];
    this.switchCellsIndex = 0;
    var max = this.estate.getMaxCellIndex();
    var hexes = APP.getCurrentMediator().cityView.hexes.getCurrentView().allHexes;
	var building = this.building;
	for (var i = 0; i < max; i++)
    {
    	var b = hexes[i].building;
    	if (b && !b.isForeign && b.typeName == building.typeName)
    	{
    		if (i == this._cellIndex) 
    		{
    			this.switchCellsIndex = this.switchCells.length;
    		}
    		this.switchCells.push(i);
    	}
    }
    
    if (this.switchCells.length == 0)
    {
    	this.switchCells.push(this._cellIndex);
    	this.switchCellsIndex = 0;
    }
    
    // update UI here...
} 

ManageDialog.prototype.update = function(estate) 
{
    // current estate was switched while this dialog is open
    if (this.estate && estate && !this.estate.id.equals(estate.id)) 
    {
        this.close();
        return;
    }
    
    // current building was destroyed while this dialog is open
	var b = this.building;
    if (!b) 
    {
    	return;
    }
    
    this.estate = estate;
    
    // if (this.building.isSuppressed) this.close();
	
    this.updateSwitchCells();
    
    COM.get(this.buildingView).update(b, this.estate.getOrderByCellIndex(this._cellIndex), this.estate.race, this.switchCells, this.switchCellsIndex);
    
    if (this.reason)
    {
    	$(this.childHolder).html('<manage-dialog-reason class="text-normal text-middle negative">' + this.reason + '</manage-dialog-reason>');
    	UI.show(false, [this.slidersWrapper]); 
    }
    
    if (this._child) 
    {
        this._child.update(estate);
    }
    
    this.tick();
}

ManageDialog.prototype.onShow = function()
{
	this.init();
	this.refreshScroll(300);
}
	
ManageDialog.prototype.refreshScroll = function(timeout)
{
	if (!this.scroll) return;
	if (timeout)
	{
		return setTimeout($.proxy(this.refreshScroll, this), timeout*1);
	}
	this.scroll.refresh();
}

ManageDialog.prototype.tick = function() 
{
    if (!this.cell || !this.cell.hasBuilding()) 
    {
        this.close();
        return;
    }
    
    this.updateSliders();

    var b = this.building;
    
    COM.get(this.buildingView).tick(COM.get(this.buildersAssigner).value);

    var uiFlag;
    
    this.updateCaption();
    
    if (COM.get(this.workersAssigner).changed || true) 
    {
        b.workers = COM.get(this.workersAssigner).value;
        this.workers = b.workers;
    }
    
    if (this._child) 
    {
        this._child.tick();
    }

    var magicDialog = COM($('FinishConstructionMagicDialog')[0]);
    if (this.estate.accessManageble && magicDialog)
    {
        magicDialog.update(this.estate);
    }
    
    this.updateActions();
}

ManageDialog.prototype.updateCaption = function()
{
    var b = this.building, title = b.getName();
    var subCaption = "";
    
	if (b.isPerfect())
    {
    	this.setCaption('<img src="' + (STATIC_INTERFACE_URL + 'icons/perfect.png') + '" />' + title);
    	
    	if(this._cellIndex >= 0) subCaption = this.estate.getCellLocationText(this._cellIndex);
    }
    else
    {
    	this.setCaption(title);
    	
    	subCaption = b.level && b.level > 0 ? I18.f('LEVEL_X', b.level) : '';
    	if(this._cellIndex >= 0) subCaption += (subCaption != "" ? ", " : "") + this.estate.getCellLocationText(this._cellIndex)
    }
    
    this.setSubCaption(subCaption);
} 

ManageDialog.prototype.updateActions = function()
{
	var cityhall = (FEstate.HALL_FAKE_CELL_INDEX == this.cellIndex);
	var hasChaos = this.estate.hasBuff(BuffType.CONSTRUCTION_CHAOS);
	var b = this.building;
	var cell = b.cell;
	
	COM(this.actionDestroy).caption = '';
	COM(this.actionRepair).caption = '';
	COM(this.actionUpgrade).caption = '';
	COM(this.actionMagicFinishConstruction).caption = '';
	
	if (UI.show(b.isBrokenOrRepairing && b.accessInfo, [this.brokenStateBox]))
	{
        this.brokenState.innerHTML = I18.f(b.isBroken ? 'DAMAGED' : 'REPAIRING');
        this.brokenStateRatio.innerHTML = I18.f('STATE_X_PERCENT', Math.floor(b.getHealthRatio() * 100));
	}
	
	if (!this.estate.accessDeputy)
	{
		UI.show(false, [this.actionDestroy, this.actionRepair, this.actionUpgrade, this.actionMagicFinishConstruction]);
		return;
	}
	
	if (UI.show(this.actionsVisible && this.estate.canDeleteBuilding(cell), [this.actionDestroy]))
	{
		// update destroy here...
	}
	
	if (UI.show(this.actionsVisible && b.isBroken, [this.actionRepair]))
	{
		UI.show(false, [this.actionUpgrade, this.actionMagicFinishConstruction]);
		
		COM(this.actionRepair).reason = null;
		if (hasChaos)
		{
			COM(this.actionRepair).reason = BuffCauseTip.create(this.estate.getBuffs(BuffType.CONSTRUCTION_CHAOS));
		}
	}
	else
	{
		if (UI.show(this.actionsVisible && b.isBuildingOrUpgrading, [this.actionMagicFinishConstruction]))
		{
			UI.show(false, [this.actionUpgrade]);
			
			if (!b.canFinishConstructionForPearl())
			{
				COM(this.actionMagicFinishConstruction).reason = I18.getMegaString(I18.f('MAGIC_FINISH_CONSTRUCTION_NOW_DISABLED_UNDER_ATTACK'), FConfig);
			}
			else if (!this.estate.accessManageble)
			{
				COM(this.actionMagicFinishConstruction).reason = I18.f('DEPUTY_CAN_NOT_USE_PEARL');
			}
			COM(this.actionMagicFinishConstruction).caption = this.getCountDownText(COM(this.buildersAssigner).value);
		}
		else 
		{
	        var upgradeVisible = this.actionsVisible && (
	        	this.estate.canUpgradeBuilding(this.cellIndex)
	        	||
	        	// as an exception, we show UP button for our buildings on sectors when gates are closed
	        	(!cityhall && this.estate.canManageOnSectors() && this.estate.isOnSector(this.cellIndex) && b.canUpgrade())
	        )
			if (UI.show(upgradeVisible, [this.actionUpgrade]))
			{
		        COM(this.actionUpgrade).reason = null;
		        if (b.isNextLevelPerfect() && (FUser.CURRENT_USER.science.getLevel(Science.ALCHEMY) == 0))
		        {
		        	COM(this.actionUpgrade).reason = I18.f('ALCHEMY_REQUIRED');
		        } 
		        else if (hasChaos) 
		        {
		            COM(this.actionUpgrade).reason = BuffCauseTip.create(this.estate.getBuffs(BuffType.CONSTRUCTION_CHAOS));
		        } 
		        else if (b.type.isExtractor() && (cell.remainder*1 == 0) && !b.isNextLevelPerfect()) 
		        {
		            COM(this.actionUpgrade).reason = I18.f('CANT_UPGRADE_ON_EMPTY_CELL');
		        }

	            //COM(this.actionUpgrade).caption = b.isNextLevelPerfect() ? I18.f('MAKE_PERFECT') : I18.f('UPGRADE');
		        COM(this.actionUpgrade).icon = STATIC_URL + (b.isNextLevelPerfect() ? CommonAssets.BUTTON_PERFECT : CommonAssets.BUTTON_UPGRADE);
			}
		}
	}
	
}

ManageDialog.prototype.onFinishConstructionNow = function() 
{
	var magicDialog = COM($('FinishConstructionMagicDialog')[0]);
    if (this.estate.accessManageble)
    {
        if (!magicDialog) 
        {
            magicDialog = COM.create('FinishConstructionMagicDialog');
            magicDialog.popup(this, this.estate, this._cellIndex);
        }
        else
        {
        	magicDialog.update(this.estate);
        }
    }
}

ManageDialog.prototype.getCountDownText = function(builders)
{
    /* for "finish now" button */
	var b = this.building;   
	
	if (!this.estate.accessManageble) return '';
	if (!b.isBuildingOrUpgrading && !b.isRepairing) return '';
    if (builders <= 0 && b.builders <= 0) return Tick.INFINITY_SYMBOL;
    
    if (b.isBuildingOrUpgrading)
    {
        return Tick.timeTill(Tick.now() + (b.isForeign
            ? b.estimateCurrentWork()
            : (b.estimateBuildDuration(builders == -1 ? b.builders : builders)))
		);
    }
    else if (b.isRepairing)
    {
        return Tick.timeTill(Tick.now() + (b.isForeign
            ? b.estimateCurrentRepair()
            : (b.estimateRepairDuration(builders == -1 ? b.builders : builders)))
        );
    }
} 

ManageDialog.prototype.updateTime = function(e) 
{
   	COM(this.actionMagicFinishConstruction).caption = this.getCountDownText(COM(this.buildersAssigner).value);
   	if (e.type == 'select')
   	{
   		this.commit();
   	}
    //COM.get(this.buildingView).tick(count);
}

ManageDialog.prototype.setSliders = function()
{
    var b = this.building;
    COM.get(this.workersAssigner).value = b.workers;
    COM.get(this.buildersAssigner).value = b.builders;
}

ManageDialog.prototype.updateSliders = function()
{
    var b = this.building;

    var buildersLimit = b.builders + this.estate.freeCitizens - (COM.get(this.workersAssigner).value - b.workers);
    var workersLimit = b.workers + this.estate.freeCitizens - (COM.get(this.buildersAssigner).value - b.builders);

    if (b.isBuildingOrUpgrading || b.isRepairing) 
    {
        // the following couple of lines (manipulations with Max) fix bug #230.
        var maxBuilders = b.isRepairing ? b.maxRepairBuilders : b.getLevel(b.level + 1).builders;
        COM.get(this.buildersAssigner).setMaximum(maxBuilders);
        if (!this.manageInProgress) 
        {
        	COM.get(this.buildersAssigner).update(this.estate, b.builders, Math.min(buildersLimit, maxBuilders));
        }
    }
    COM.get(this.buildersAssigner).enabled = this.estate.canManageBuilders(this.cell);

    if (COM.get(this.buildersAssigner).enabled) 
    {
        COM.get(this.buildersAssigner).enabled = this.estate.accessDeputy;
    }

    if (b.type.isRequiresWorkers(b.race)) 
    {
        COM.get(this.workersAssigner).setMaximum(b.getLevel().workers);
        if (!this.manageInProgress) 
        {
        	COM.get(this.workersAssigner).update(this.estate, b.workers, workersLimit);
        }
        COM.get(this.workersAssigner).enabled = this.estate.canManageWorkers(this.cell);
        if (COM.get(this.workersAssigner).enabled) 
        {
            COM.get(this.workersAssigner).enabled = this.estate.accessDeputy;
        }
    } 
    else 
    {
        COM.get(this.workersAssigner).enabled = false;
    }
}

ManageDialog.prototype.commit = function(force)
{
    var b = this.building;
    if (COM.get(this.workersAssigner).enabled || COM.get(this.buildersAssigner).enabled) 
    {
        this.onResult(b, COM.get(this.buildersAssigner).value, COM.get(this.workersAssigner).value);
    }
    COM.get(this.workersAssigner).resetChanged();
    COM.get(this.buildersAssigner).resetChanged();
}

ManageDialog.prototype.revert = function()
{
    if (this['oldWorkers'] === undefined || this['oldBuilders'] === undefined) return;
    var b = this.building;
    b.workers = ~~this['oldWorkers'];
    b.builders = ~~this['oldBuilders'];
    COM.get(this.workersAssigner).resetChanged();
    COM.get(this.buildersAssigner).resetChanged();
}

ManageDialog.prototype.onClose = function()
{
    if (this._child && (typeof this._child['onClose'] == 'function'))
    {
    	if (this._child.onClose() === false) 
    	{
    		return false;
    	}
    }
    superMethod(this, 'onClose')();
}

ManageDialog.prototype.onWorkersChange = function(count)
{
    this.workers = count;
    this.tick();
}

ManageDialog.prototype.onWorkersChangeFinish = function(count)
{
	this.onWorkersChange(count);
	this.commit();
}

ManageDialog.prototype.switchCell = function(cellIndex)
{
    if (this['oldWorkers'] === undefined) this['oldWorkers'] = this.building ? this.building.workers : 0;
    if (this['oldBuilders'] === undefined) this['oldBuilders'] = this.building ? this.building.builders : 0;
   	this.revert();

    this._cellIndex = cellIndex;
    this.update(this.estate);
    this.setSliders();
    
    var b = this.building;
    COM.get(this.buildingView).update(b, this.estate.getOrderByCellIndex(this._cellIndex), this.estate.race, this.switchCells, this.switchCellsIndex);
    this['oldWorkers'] = b ? b.workers : 0;
    this['oldBuilders'] = b ? b.builders : 0;
    //console.log('%s W:%s B:%s', b.id, this['oldWorkers'], this['oldBuilders']);
    
    if (this._child)
    {
        this._child.cellSwitched();
    }
}

ManageDialog.prototype.onBuildingTooltip = function(e)
{
    var msg = '';
    var b = this.building;
    if (b.isBuildPending && !b.isStopped) 
    {
        msg = I18.f('BUILDING_IS_BUILDING');
    } 
    else if (b.isUpgradePending && !b.isStopped) 
    {
        msg = I18.f('BUILDING_IS_UPGRADING');
    } 
    else if (b.isStopped) 
    {
        msg = I18.f('BUILDING_HAS_NO_PLODDERS');
    } 
    else if (b.isBroken) 
    {
        msg = I18.f('BUILDING_IS_BROKEN_ALERT_TITLE');
    } 
    else if (b.isRepairing) 
    {
        msg = I18.f('BUILDING_IS_REPAIRING');
    } 
    else if (this.estate instanceof FCity && !this.estate.canManageOnSector(this.cell)) 
    {
        msg = I18.f('CITYHALL_IS_NOT_MAX_LEVEL');
    } 
    else if (this.estate instanceof FCity && !estate.canManageWhenGateClosed(this.cell)) 
    {
        msg = I18.f('OPEN_THE_GATE_WARNING');
    } 
    else 
    {
        msg = '';
    }

    if (!b.isBuildingOrUpgrading && !b.isRepairing) 
    {
        if (b.isWarehouseOverfilled() && b.hasSpeedProblems()) 
        {
            var overfilledAlert = I18.getOverfilledAlertTitle(b.type);
            msg = msg ? (msg + "\n\n" + overfilledAlert) : overfilledAlert;
        }
    }
    if (b.type.isExtractor() && b.cell.remainder == 0) 
    {
        msg = msg
            ? (msg + "\n\n" + I18.f('NEEDS_RECOVERY_MESSAGE'))
            : I18.f('NEEDS_RECOVERY_MESSAGE')
        ;
    }

    if (msg) 
    {
        //e.toolTip = Tip.create(msg);
    } 
    else 
    {
        //e.toolTip = Tip.invisible();
    }
}
