var ManageDiplomatHall = function()
{
	callParentConstructor(ManageDiplomatHall.prototype, this);
	
	this.updateAfterCompletion = true;
	this.isConstructed = false;

	this.__defineGetter__('selectedTab', function()
	{
		return this.currentTab;
	});
}

extendClass(ManageDiplomatHall.prototype, ManageDialogChild.prototype);

ManageDiplomatHall.prototype.updateAfterCompletion = true;
ManageDiplomatHall.prototype.isConstructed = false;

ManageDiplomatHall.prototype.__construct = function()
{
	
	var onTabClick = $.proxy(function(e){
		
		var btn = e.currentTarget;
		this.showTab(btn.getAttribute('tabClass'));
		this.dialog.setSubCaption($('td', btn)[1].innerHTML);
		
	}, this);
	$('tab', this.tabButtons).each(function(){COM.bindExclusiveClick(this, onTabClick)});
	
    $(this.tabButtons).toggleClass('survival', !!FConfig.IS_SURVIVAL);
}

ManageDiplomatHall.prototype.onShow = function()
{
    this.isConstructed = this.estate.getDiplomatHall().isConstructed;
    this.dialog.updateCaption = $.proxy(this.updateCaption, this);
    
    var dialog = Dialog.find(this), btn = COM.create('SimpleButton', {skin:'green'});
    dialog.btnTabAction = btn.DOM;
    UI.show(false, [btn.DOM]);
    $(dialog.headerRightBox).prepend(btn.DOM);
    $(btn.DOM).on(CLICK_EVENT, $.proxy(function(){
    	if (this.currentTab) return this.currentTab.onActionClick();
    	return false;
    }, this))
    
    var fit = dialog.fitLayout;
    dialog.fitLayout = $.proxy(function()
    {
    	var args = Array.prototype.slice.call(arguments, 0);
    	fit.apply(this, arguments);
    	
    	this.content.style.height = (this.content.parentNode.offsetHeight - this.header.offsetHeight) + 'px';
    	
    }, dialog);
}

ManageDiplomatHall.prototype.initBasicBuildingControls = function()
{
	//this.dialog.actionDestroy = this.demolishButton;
}

ManageDiplomatHall.prototype.reset = function()
{
    this.updateAfterCompletion = true;
}

ManageDiplomatHall.prototype.update = function(estate)
{
    superMethod(this, 'update')(estate);
    this.updateData(estate.owner.diplomacy);
    if (this.currentTab)
    {
    	UI.show(false, [this.dialog.actionDestroy]);
    }
}

ManageDiplomatHall.prototype.updateCaption = function(d)
{
	if (!this.currentTab)
	{
		ManageDialog.prototype.updateCaption.call(this.dialog);
	}
}

ManageDiplomatHall.prototype.updateData = function(d)
{
    this.estate.owner.diplomacy = d;
    if (this.currentTab && d) 
    {
        this.currentTab.update(this.estate);
    }
    
    this.alliesCounterLabel.innerHTML = (d.allies 
    	? d.allies.length 
    	: 0
    ) || I18.f('NO_ALLIES');

    this.deputyOfLabel.innerHTML = d.myDeputy.isPresent
    	? d.myDeputy.person
    	: I18.f('NO_DEPUTY')//I18.f('DEPUTY_OF_NOONE')
    ;

    this.clanNameLabel.innerHTML = d.clan 
    	? htmlEscape(d.clan.clanName) 
    	: I18.f('NOT_CLAN_MEMBER')
    ;

    this.heroRedemptionLabel.innerHTML = (d.heroesForRedemption 
    	? d.heroesForRedemption.length 
    	: 0
    ) || I18.f('NO_PRISONED_HEROES');
    
    this.apprenticesLabel.innerHTML = d.isMentor 
    	? I18.f('APPRENTICES_COUNT', d.allApprenticeCount, d.mentorCapacity)
    	: I18.f('NO_APPRENTICES')
    ;
}

ManageDiplomatHall.prototype.tick = function()
{
    this.isConstructed = this.estate.getDiplomatHall().isConstructed;

    if (this.updateAfterCompletion && this.isConstructed) 
    {
        this.updateAfterCompletion = false;
        this.onTabChange();
    }
    
    if (this.currentTab)
    {
    	this.currentTab.tick();
    }
    
    /*
    this.friendsTab.enabled = this.isConstructed;
    this.alliesTab.enabled = this.isConstructed;
    this.deputyTab.enabled = this.isConstructed;
    this.clansTab.enabled = this.isConstructed && this.estate.owner.canHaveClans();
    this.clansTab.tabToolTip = this.estate.owner.canHaveClans() ? "" : I18.f('NO_CLANS_SCIENCE');

    var haveHeroesForRedemption = (this.estate.owner.diplomacy != null && this.estate.owner.diplomacy.heroesForRedemption.length > 0);
    this.heroesTab.enabled = this.isConstructed && haveHeroesForRedemption && this.estate.accessManageble && (this.estate.owner.username == FUser.CURRENT_USER.username);
    this.heroesTab.tabToolTip = haveHeroesForRedemption ? "" : I18.f('NO_HERO_REDEMPTION');
    this.mentorTab.enabled = this.isConstructed && this.estate.owner.diplomacy.isMentor;
    this.mentorTab.tabToolTip = this.estate.owner.diplomacy.isMentor ? "" : I18.f('NEED_QUEST_FOR_MENTORSHIP');
    */

    /*
    if (this.isConstructed) 
    {
        this.selectedTab.tick();
        if (this.selectedTab.needUpdate) 
        {
            this.onTabChange();
        }
    }

    if (this.tabs.selectedChild != this.clansTab && FUser.CURRENT_USER.hasNewClanQuestions()) 
    {
        var tab = this.tabs.getTabAt(this.tabs.getElementIndex(this.clansTab));
        if (tab) 
        {
            //tab.setStyle("color", tab.getStyle("color") != Effects.RED ? Effects.RED : Effects.BLACK);
        }
    }
    */
}

ManageDiplomatHall.prototype.onTabChange = function()
{
    /*
    if (this.tabs.selectedChild == this.clansTab) 
    {
        var tab = this.tabs.getTabAt(this.tabs.getElementIndex(this.clansTab));
        //tab.setStyle("color", Effects.BLACK);
    }
    if (this.isConstructed) 
    {
        if (!this.estate.isEspionage) 
        {
            Service.alliance.callMethod('getDiplomacy', [this.estate.owner.username], $.proxy(this.updateData, this));
        } 
        else 
        {
            this.updateData(this.estate.owner.diplomacy);
        }
    }
    */
}

ManageDiplomatHall.prototype.currentTab = false;

ManageDiplomatHall.prototype.showTab = function(cls)
{
	this.currentTab = COM.create(cls, null, Dialog.find(this));
	
	this.tabHolder.innerHTML = '';
	this.tabHolder.appendChild(this.currentTab.DOM);
	
	UI.show(false, [this.dialog.actionDestroy]);
	
	UI.show(false, [this.mainContent]);
	UI.show(true, [this.tabHolder]);
	
	this.dialog.skin = 'light';
	this.dialog.showFooter = true;
	this.dialog.actionsVisible = false;
	
	this.currentTab.update(this.estate);
	
	this.dialog.fitLayout();
	this.dialog.refreshScroll(300);
}

ManageDiplomatHall.prototype.onClose = function()
{
	if (this.currentTab)
	{
    	$(this.dialog.footer).html('');
		this.dialog.showFooter = false;
		
		UI.show(true, [this.mainContent]);
		UI.show(false, [this.tabHolder]);
		
		this.currentTab.destroy();
		this.currentTab = false;
		
		this.updateCaption();
		
		this.dialog.actionsVisible = true;
		UI.show(true, [this.dialog.actionDestroy]);
		UI.show(false, [this.dialog.btnTabAction]);

		this.dialog.skin = 'darkwood';
		
		this.dialog.fitLayout();
		this.dialog.refreshScroll(300);

		return false;
	}
}
