function ManageFortificationTip()
{
	
}

ManageFortificationTip.create = function(estate, b, isArmor)
{
    var t = COM.create('ManageFortificationTip');
    t.update(estate, b, isArmor);
    return t;
}

ManageFortificationTip.createForLevel = function(estate, level, isArmor) 
{
    var t = COM.create('ManageFortificationTip');
    t.updateForLevel(estate, level, estate.owner.race, isArmor);
    return t;
}

ManageFortificationTip.prototype.__construct = function()
{
	this.bonusName.innerHTML = I18.getScience(Science.SPEC_DEFENDER);
}

ManageFortificationTip.prototype.update = function(estate, b, isArmor) 
{
    this.updateForLevel(estate, b.level, b.race, isArmor);

    UI.show(b.isWorking, [this.grid]);
    UI.show(!b.isWorking, [this.problemInfo]);
    if (!b.isWorking)
    {
    	this.problemInfo.innerHTML = b.getProblem();
    }
}

ManageFortificationTip.prototype.updateForLevel = function(estate, level, r, isArmor) 
{
    $(this.baseValue).addClass('positive');
    $(this.bonus).addClass('positive');

    var levelFortification = BType.FORTIFICATION.getLevels(r)[level];
    this.baseName.innerHTML = levelFortification.perfect ? I18.f('PERFECT_BUILDING') : I18.f('LEVEL_X', level);
    this.baseValue.innerHTML = (isArmor ? levelFortification.armorBonus : levelFortification.attackerLoss).toString();

    var defenderLevel = estate.getScienceLevel(Science.SPEC_DEFENDER);
    UI.show(defenderLevel > 0, [this.defenderBonus]);
    if (defenderLevel > 0)
    {
        bonus.innerHTML = "+" + (isArmor
			? Science.SPEC_DEFENDER.getLevel(defenderLevel - 1).fortificationDefenceBonus
			: Science.SPEC_DEFENDER.getLevel(defenderLevel - 1).fortificationBonus
		);
    }

    if (!isArmor) 
    {
        // clear old buffs
        while (this.grid.rows.length > 2) 
        {
        	this.grid.deleteRow(2);
        }
        
        var buffs = estate.getBuildingBuffs(BuffType.BOOST_BUILDING, BType.FORTIFICATION);
        for (var i = 0, len = buffs.length; i < len; i++) 
        {
            var buff = buffs[i];
            var tr = this.grid.insertRow(this.grid.rows.length), td;
            $(tr.insertCell(0)).append(I18.getBuffCause(buff));
            $(tr.insertCell(1)).append(I18.percentText(buff.value));
        }
    }

    UI.show(isArmor, [this.armorIconForBonus, this.armorIconForValue]);
}
