var ManageMarket = function()
{
	callParentConstructor(ManageMarket.prototype, this);
	
	this.remoteUpdateLater = false;
	this.skipInitialShow = true;
	
	this.__defineGetter__('selectedTab', function()
	{
		return this.currentTab;
	});
}

extendClass(ManageMarket.prototype, ManageDialogChild.prototype);

ManageMarket.prototype.remoteUpdateLater = false;
ManageMarket.prototype.skipInitialShow = true;

ManageMarket.prototype.__construct = function()
{
	var onTabClick = $.proxy(function(e){
		
		var btn = e.currentTarget;
		this.showTab(btn.getAttribute('tabClass'));
		this.dialog.setSubCaption($('td', btn)[1].innerHTML);
		
	}, this);
	$('CustomButton', this.tabButtons).each(function(){COM.bindExclusiveClick(this, onTabClick)});
	
}


ManageMarket.prototype.currentTab = null;
ManageMarket.prototype.showTab = function(cls)
{
	this.closeTab();
	this.currentTab = MarketTabParent.create(this, cls, this.estate);
	if (this.currentTab)
	{
		this.currentTab.onClose = $.proxy(function(){ this.currentTab = null; }, this);
		this.currentTab.update(this.estate);
	}
}

ManageMarket.prototype.closeTab = function()
{
	if (this.currentTab)
	{
		this.currentTab.close();
	}
}

ManageMarket.prototype.update = function(estate)
{
    superMethod(this, 'update')(estate);
    if (this.currentTab)
    {
		this.currentTab.update(estate);
    }
    
    var castle = (estate.getEstateType().name == EstateType.CASTLE.name);
    
    var btn;
   	btn = COM(this.tabButtons.querySelector('CustomButton[tabClass=MarketBuy]'));
   	btn.enabled = !castle;

   	btn = COM(this.tabButtons.querySelector('CustomButton[tabClass=MarketSell]'));
   	btn.enabled = !castle;
   	
   	btn = COM(this.tabButtons.querySelector('CustomButton[tabClass=MarketAuction]'));
	btn.enabled = !castle && !FConfig.IS_SURVIVAL;
	
	this.tick();
}

ManageMarket.prototype.tick = function()
{
    if (this.currentTab)
    {
		this.currentTab.tick();
    }
    
    var btn, castle = (this.estate.getEstateType().name == EstateType.CASTLE.name);
    
   	btn = COM(this.tabButtons.querySelector('CustomButton[tabClass=MarketBuy]'));
    btn.enabled = !castle && this.estate.getMarket().isConstructed;
    
   	btn = COM(this.tabButtons.querySelector('CustomButton[tabClass=MarketSell]'));
    btn.enabled = !castle && this.estate.getMarket().isConstructed;
    
   	btn = COM(this.tabButtons.querySelector('CustomButton[tabClass=MarketExchange]'));
    btn.enabled = this.estate.getMarket().isConstructed;
    btn.reason = this.estate.isEstateUnderAttack
    	? I18.getMegaString(I18.f('MARKET_ERROR_CANT_EXCHANGE_UNDER_SIEGE'), FConfig)
    	: null
    ;
    	
   	btn = COM(this.tabButtons.querySelector('CustomButton[tabClass=MarketAuction]'));
    btn.enabled = !castle && !FConfig.IS_SURVIVAL && this.estate.getMarket().isConstructed;
    if (!this.dialog.estate.owner.isAuctionAvailable) 
    {
        btn.reason = I18.f('AUCTION_UNAVAILABLE', FConfig.AUCTION_OPEN_RATING);
    } 
    else if (!Tick.hasPassed(this.estate.auctionBanTill)) 
    {
        btn.reason = I18.f('AUCTION_ERROR_BAN', Tick.toTimeFuture(this.estate.auctionBanTill));
    } 
    else if (!this.estate.accessManageble) 
    {
        btn.reason = I18.f('NO_ACCESS');
    }
    else
    {
    	btn.reason = null;
    }
}

ManageMarket.prototype.onTabChange = function()
{
    var tab = this.tabs.selectedChild;
    if (tab.tabVisible) 
    {
        tab.reset();
        if (this.estate.getMarket().isConstructed) 
        {
            tab.onShow(this.estate, this);
        }
    }
}

ManageMarket.prototype.reset = function()
{
    for (var i = 0; i < this.tabs.length; i++)
    {
    	this.tabs[i].reset();
    }
}
