var ManagePrison = function()
{
	callParentConstructor(ManagePrison.prototype, this);
}

extendClass(ManagePrison.prototype, ManageDialogChild.prototype);

ManagePrison.prototype.__construct = function()
{
	COM(this.heroesBox).setHeader([I18.f('HERO'), I18.f('HERO_OWNER'), I18.f('ESTATE')]);
   	$(this.heroesBox).on('select', $.proxy(this.onHeroSelect, this));
}

ManagePrison.prototype.update = function(estate)
{
    this.prisonerCaptureRate.innerHTML = PrisonTip.getCaptureRate(estate, this.building.level);
    
    COM(this.heroesBox).clearChildren();
    var len = this.building.heroesToHire.length;
    for(var i = 0; i < len; i++) 
    {
        var item = COM.create('ScrollableListItem');
        item.data = [
			this.building.heroesToHire[i].name,
			FUser.getUserNameForMessages(this.building.heroesToHire[i].owner),
			I18.formatEstateName(this.building.heroesToHire[i].prisonedFromEstateName ? this.building.heroesToHire[i].prisonedFromEstateName : "-", this.building.heroesToHire[i].prisonedFromEstateXYZ),
		];
		item.hero = this.building.heroesToHire[i];
		item.race = estate.owner.race;
		COM(this.heroesBox).addItem(item);
        /*
        var hi = COM.create('HeroRedemptionInfo');
        hi.hero = newHeroes[i];
        hi.race = this.estate.owner.race;
        hi.managable = this.estate.accessManageble;
        hi.onPayRedemption = $.proxy(this.onPayRedemption, this);
        hi.init();
        COM(this.heroesBox).addItem(hi.createListItem());
        */
    }
    UI.show(len > 0, [this.heroesBox]);
    
    $('*[role=component]', this.heroesHolder).each(function(n, obj){ COM(obj).destroy(); });
    this.heroesHolder.innerHTML = '';
    /*
    for (var i = 0; i < this.building.heroesToHire.length; i++)
    {
    	var heroView = this.createHeroView(this.building.heroesToHire[i], estate.owner.race, estate);
    	$(this.heroesHolder).append(heroView.DOM);
    	
    	heroView.update(this.building.heroesToHire[i], estate.owner.race, estate.id);
    	UI.show(estate.accessManageble, [heroView.releaseButton]);
    }
    */
    UI.show(this.building.heroesToHire.length > 0, [this.heroesHolder]);
    UI.show(this.building.heroesToHire.length == 0, [this.noheroes]);
}

ManagePrison.prototype.onHeroSelect = function()
{
	var item = COM(this.heroesBox).selectedItem;
	if (!item) return;
	
	this.heroDialog = PrisonedHeroDialog.create(item.hero, item.race, this.estate);
	this.heroDialog.onRelease = $.proxy(this.onReleaseHero, this);
	
	this.heroDialog.onClose = $.proxy(function(){ 
		this.heroDialog = null; 
	}, this);
	
	COM(this.heroesBox).selectedIndex = -1;
}

ManagePrison.prototype.createHeroView = function(hero, race, estate)
{
    var hi = COM.create('HeroPrisonInfo');
    hi.onReleaseClicked = $.proxy(this.onReleaseHero, this);
    return hi;
}

ManagePrison.prototype.onReleaseHero = function(estate, hero)
{
    estate = estate || this.estate;
    Alert.create(I18.f('ARE_YOU_SURE_WANT_TO_RELEASE_HERO'), I18.f('RELEASE_HERO'), $.proxy(function() 
    {
        this.heroDialog.close();
        if (!hero) return;
        
        Service.hero.callMethod('releaseHeroFromPrison', [estate.id, hero.id], null, function(e)
        {
            if (e.__CLS__ == 'HeroException') 
            {
                Alert.create(e.getMessage(), I18.f('ERROR'));
                return true;
            }
            return false;
        });
        
    }, this));
}
