var ManageRaiser = function()
{
	callParentConstructor(ManageRaiser.prototype, this);
	this.magicDialog = null;
	
	this.__defineGetter__('btype', function()
	{
	    return this.cell.building.type;
	});

}

extendClass(ManageRaiser.prototype, ManageDialogChild.prototype);

ManageRaiser.prototype.magicDialog = null;

ManageRaiser.prototype.__construct = function()
{
	var magic = COM.create('BoostPeriodicalButton');
	magic.skin = 'green';
	this.btnSpecial = magic.DOM;
	
   	this.productionBox.style.cursor = 'pointer';
   	this.shopBox.style.cursor = 'pointer';
   	this.resourceBox.style.cursor = 'pointer';
   	
	$(this.shopBox).on(CLICK_EVENT, $.proxy(this.showSummaryTip, this));
	$(this.productionBox).on(CLICK_EVENT, $.proxy(this.showSummaryTip, this));
	//COM.bindExclusiveClick(this.resourceBox, $.proxy(this.showSummaryTip, this));
}

ManageRaiser.prototype.tick = function()
{
    var b = this.cell.building;

    this.productionLabel.innerHTML = b.type.isRecovery() ? I18.f('RECOVERY_SPEED') : I18.f('EXTRACTS');

    var speed = b.getLastWorkSpeedPerHour();
    speed.multiply(this.workers / b.workers);
    speed.floor();

    var resources = [b.resource];
    with (COM(this.workSpeedPerHour))
    {
	    alwaysShow = resources;
	    update(speed, b.race);
	    styleFunds(resources, b.hasSpeedProblems(this.workers));
	}

    if (UI.show(b.type.isShop(), [this.shopBox, this.shopLabel]))
    {
    	$(this.shopRatio).removeClass('negative positive overflow');
        this.shopRatio.innerHTML = Strings.formatNumber(b.shopRatioToDisplay(), 3);
        if (b.isWorking && b.estate.isFullTaxUsed() && this.shopRatio.innerHTML != "0") 
        {
            $(this.shopRatio).addClass('positive');
        } 
        else 
        {
            $(this.shopRatio).addClass('negative');
        }
    }
    
    if (this.btnSpecial)
    {
    	COM(this.btnSpecial).update(b);
    }
    
	if (this.dialog && this.dialog._cellIndex >= 0)
	{
		var cell = this.dialog.estate.getCellByIndex(this.dialog._cellIndex);
		if (cell && cell.hasResource())
		{
            var available = (this.dialog.estate.isExpeditionReport && cell.onSector) ? '?' : NumberUtils.floor(cell.remainder);
            var max = NumberUtils.floor(FConfig.getMaxRemainderOf(cell.resource));
            
            this.resourceLabel.innerHTML = I18.f('DEPOSIT');
            this.resourceValue.innerHTML = I18.f('CURRENT_MAX', available, max);
            //this.resourceImage.src = STATIC_URL + Assets.getCellResource(cell.resource, !this.dialog.estate.isExpeditionReport && this.dialog.estate.isCellReachable(this.dialog._cellIndex));
            this.resourceImage.title = I18.f('RESOURCE_' + cell.resource.name);
            this.resourceImage.src = STATIC_INTERFACE_URL + Assets.ICON_findBy(cell.resource);
            UI.show(!b.type.isShop(), [this.resourceBox, this.resourceLabel]);
		}
		else
		{
            UI.show(false, [this.resourceBox, this.resourceLabel]);
		}
	}
}

ManageRaiser.prototype.showSummaryTip = function()
{
    superMethod(this, 'showSummaryTip')();
    
    var tip;
    
    tip = COM.create('ManageTip');
    tip.update(this.estate, this.cellIndex, this.workers);
    this.summaryTipDialog.addTip(tip, this.productionLabel.innerHTML);
    
    if (this.cell.building.type.isShop())
    {
	    tip = COM.create('ShopRatioTip');
	    tip.update(this.estate, this.cellIndex);
	    this.summaryTipDialog.addTip(tip, this.shopLabel.innerHTML);
    }
}
