var ManageResurrector = function()
{
	callParentConstructor(ManageResurrector.prototype, this);
}

extendClass(ManageResurrector.prototype, ManageDialogChild.prototype);

ManageResurrector.prototype.__construct = function()
{
    COM(this.armyView).zeroAsCardsAllowed = false;
    COM(this.armyView).showHero = false;
    COM(this.resurectingArmyView).zeroAsCardsAllowed = false;
    COM(this.resurectingArmyView).showHero = false;
    
    COM.bindExclusiveClick(this.resurect, $.proxy(this.onStartResurection, this));
    
    this.tick();
}

ManageResurrector.prototype.tick = function()
{
    if (!this.cell) return;
    
    var b = this.cell.building;
    
    UI.show(Tick.isInfinity(b.resurrectionTick), [this.armyView]);
    COM(this.armyView).setUnits(this.estate.race, this.estate.science.unitLevels, this.estate.monsterRace(), this.estate);
    COM(this.armyView).setCount(b.accumulatedArmy);
    var resurrectionPercent = BType.RESURRECTOR.getParams(this.estate.race).levels[b.level].getResurrectionPercent(this.estate);
    var costChange = BType.RESURRECTOR.getParams(this.estate.race).levels[b.level].costChange;
    if (b.isBuildPending || b.isBroken || b.isRepairing) 
    {
        resurrectionPercent = 0;
    }
    this.percent.innerHTML = Strings.formatPercent(resurrectionPercent);

    var totalCost = FConfig.RESURRECTION_COST.multiplyCopy(b.accumulatedArmy.getTotalUnitCount() * (1 + costChange)).ceil();
    COM(this.cost).update(totalCost, this.estate.race);
    COM(this.cost).capacity = this.estate.bank;
    UI.show(!b.accumulatedArmy.isZero(), [this.fundsTimeBox, this.time]);
    COM(this.time).value = FConfig.RESURRECTION_TIME;

    COM(this.resurectingArmyView).setUnits(this.estate.race, this.estate.science.unitLevels, this.estate.monsterRace(), this.estate);
    COM(this.resurectingArmyView).setCount(b.resurrectingArmy ? b.resurrectingArmy : new Army());

    COM(this.resurect).reason = null;
    if (UI.show(!Tick.isInfinity(b.resurrectionTick), [this.busy]))
    {
    	COM(this.resurect).reason = I18.f('RESURRECTOR_BUSY');
    }
    else if (b.accumulatedArmy.getTotalUnitCount() <= 0)
    {
    	COM(this.resurect).reason = I18.f('RESURRECTOR_NO_ARMY');
    }
    else if (!this.estate.bank.greaterOrEqualsTo(totalCost))
    {
    	COM(this.resurect).reason = I18.f('NOT_ENOUGH_RESOURCES');
    }
    else if (this.estate.isEspionage || !this.estate.accessDeputy)
    {
    	COM(this.resurect).reason = I18.f('ACCESS_DENIED_ERROR_DEPUTY_LEVEL_NEEDED');
    }
    
    UI.show(b.resurrectingArmy, [this.resurectingArmyView, this.armyWillBeResurected]);
    this.resurectTimer.innerHTML = Tick.toTimeLeft(Tick.isInfinity(b.resurrectionTick) ? b.resurrectionTimeAfterRepair : b.resurrectionTick - this.estate.responseTick);

    if (this.estate.science.getLevel(Science.SPEC_CLERIC) > 0 || this.estate.sumOfBuildingBuffs(BuffType.BOOST_BUILDING, BType.RESURRECTOR)) 
    {
        //Style.assignTip(percent, " ");
    } 
    else 
    {
        //Style.removeTip(percent);
    }

}

ManageResurrector.prototype.onStartResurection = function()
{
    Service.city.callMethod('startResurrection', [this.estate.id, this.cell.building.id], $.proxy(this.tick, this));
}

ManageResurrector.prototype.onPercentTooltip = function(e)
{
    //e.toolTip = ManageResurrectorTip.create(this.estate, this.cell.building);
}

ManageResurrector.prototype.onCostTip = function(r)
{
    var b = this.cell.building;
    if (BType.RESURRECTOR.getParams(this.estate.race).levels[b.level].costChange == 0) 
    {
        //return Tip.invisible();
    } 
    else 
    {
        /*
        var gt = new GridTip();
        var costChange = BType.RESURRECTOR.getParams(this.estate.race).levels[b.level].costChange;
        gt.addLine(I18.f('RESURRECTOR_COST'), Assets.ICON_findBy(r), FConfig.RESURRECTION_COST.multiplyCopy(b.accumulatedArmy.getTotalUnitCount()).getValue(r));
        gt.addLine(I18.f('PERFECT_BUILDING'), "", Strings.formatPercent(costChange * 100, true));
        return gt;
        */
    }
}
