var ManageSpecialUnitProducer = function()
{
	callParentConstructor(ManageSpecialUnitProducer.prototype, this);
}

extendClass(ManageSpecialUnitProducer.prototype, ManageUnitProducerParent.prototype);

ManageSpecialUnitProducer.prototype.__construct = function() 
{
	superMethod(this, '__construct')();
    UI.hide(this.consumptionBox);
    UI.hide(this.cannotOrderReasonBox);
    COM(this.unitView).showCount = true;
    COM(this.unitView).showMaximum = true;
}

ManageSpecialUnitProducer.prototype.onShow = function()
{
	superMethod(this, 'onShow')();
}

ManageSpecialUnitProducer.prototype.tick = function()
{
    if (!this.estate) return;
    superMethod(this, 'tick')();
    
    if (this.isExpedition()) 
    {
        COM(this.automaticExpedition).tick(this.estate, this._b);
	    if (this.boostExpeditors && UI.show(this.estate.accessManageble, [this.boostExpeditors]))
	    {
			COM(this.boostExpeditors).update(this.estate);
	    }
    }
    if (this.isMerchant()) 
    {
	    if (this.boostMerchants && UI.show(this.estate.accessManageble, [this.boostMerchants]))
	    {
			COM(this.boostMerchants).update(this.estate);
	    }
    }
    if (this.isWorkshop()) 
    {
		COM(this.catapultMission).tick(this.estate, this._b);
    }
    
	var b = this._b;
	var unitsTotal = (b.unitsPresent + b.unitsOnMission);
	if (UI.show(b.isConstructed && !b.isBrokenOrRepairing, [this.totalUnitsBox]))
	{
		var capacity = b.getLevel().capacity;
		this.totalUnitsQuantity.innerHTML = unitsTotal + "/" + capacity;
	}
	
	if (UI.show(b.isConstructed && !b.isBrokenOrRepairing && unitsTotal > 0 && b.sendsMissions, [this.presentUnitsBox]))
	{
		this.presentUnitsQuantity.innerHTML = b.unitsPresent + "/" + unitsTotal;
	}
    
}

ManageSpecialUnitProducer.prototype.userHasAccess = function()
{
	var btn = COM(this.doTrain);
	if (this.isWorkshop())
	{
		btn.reason = this.estate.accessCatapultManageble ? null : I18.f('NO_ACCESS');
		return !!this.estate.accessCatapultManageble;
	}
	else if (!this.estate.accessOrderUnit)
	{
		btn.reason = I18.f('ACCESS_DENIED_ERROR_OWNER_LEVEL_NEEDED');
		return false;
	}
	return true;
}

ManageSpecialUnitProducer.prototype.updateCost = function(unitCount)
{
    if (superMethod(ManageSpecialUnitProducer.prototype, 'updateCost', this)(unitCount) === false)
    {
    	return false;
    }

	if (this._b.maxOrderCount < unitCount)
	{
		COM(this.doTrain).reason = I18.f('QUEUE_LIMIT_REACHED', this._b.unitsCapacity);
		return false;
	}
	return Boolean(COM(this.doTrain).enabled && !COM(this.doTrain).reason);
}

ManageSpecialUnitProducer.prototype.updateCount = function()
{
    superMethod(ManageSpecialUnitProducer.prototype, 'updateCount', this)();
    COM(this.count).max = Math.floor(Math.max(1, Math.min(COM(this.count).max, this._b.maxOrderCount)));
    if (COM(this.count).value > COM(this.count).max)
    {
    	COM(this.count).value = COM(this.count).max;
    }
}

ManageSpecialUnitProducer.prototype.canTrainUnits = function(count, unitsCost)
{
	return superMethod(this, 'canTrainUnits')(count, unitsCost) && (this._b.maxOrderCount > 0);
}

ManageSpecialUnitProducer.prototype.isExpedition = function() 
{
    return this._b && this._b.type.name == BType.EXPEDITION.name;
}

ManageSpecialUnitProducer.prototype.isMerchant = function() 
{
    return this._b && this._b.type.name == BType.MERCHANT.name;
}

ManageSpecialUnitProducer.prototype.isWorkshop = function() 
{
    return this._b && this._b.type.name == BType.WORKSHOP.name;
}

ManageSpecialUnitProducer.prototype.cellSwitched = function() 
{
	superMethod(ManageSpecialUnitProducer.prototype, 'cellSwitched', this)();
    
    if (this.boostExpeditors && UI.show(this.isExpedition() && this.estate.accessManageble, [this.boostExpeditors]))
    {
		COM(this.boostExpeditors).update(this.estate);
    }
    
    if (this.automaticExpedition && UI.show(this.isExpedition(), [this.automaticExpedition]))
    {
		COM(this.automaticExpedition).update(this.estate, this._b);
    }
    
    if (this.boostMerchants && UI.show(this.isMerchant() && this.estate.accessManageble, [this.boostMerchants]))
    {
		COM(this.boostMerchants).update(this.estate);
    }
    
    if (this.catapultMission && UI.show(this.isWorkshop() && this.estate.accessCatapultManageble, [this.catapultMission]))
    {
		COM(this.catapultMission).update(this.estate, this._b);
    }
}

ManageSpecialUnitProducer.prototype.autoProduceBuffType = function() 
{
    return BuffType.AUTO_PRODUCE_SPECIAL;
}

ManageSpecialUnitProducer.prototype.getOneUnitCost = function() 
{
    var resourcesDiscount = NumberUtils.limit(1 + this._b.estate.sumOfBuffs(BuffType.ECONOMY_TRAINING_SPECIAL_RESOURCES, this.utype), FConfig.MIN_SPECIAL_RESOURCES, 9);
    var peoplesDiscount = NumberUtils.limit(1 + this._b.estate.sumOfBuffs(BuffType.ECONOMY_TRAINING_SPECIAL_PEOPLE, this.utype), FConfig.MIN_SPECIAL_PEOPLE, 9);
    return superMethod(ManageSpecialUnitProducer.prototype, 'getOneUnitCost', this)().multiplyCopyResourcesPeople(resourcesDiscount, peoplesDiscount);
}

ManageSpecialUnitProducer.prototype.onChangeUnitsCount = function()
{
	superMethod(ManageSpecialUnitProducer.prototype, 'onChangeUnitsCount', this)();
	if (this.isWorkshop()) 
	{
		if (UI.show(ServiceHelper.getLocalServiceDecl(this._b.type.getUnitType(this._b.race).name, 0), [this.fastFinish]))
		{
			var reason = null;
			if (!this._b.estate.accessCatapultManageble)
			{
				reason = I18.f('NO_ACCESS');
			}
			else if (this._b.unitsQueued < 1)
			{
				reason = I18.f('PEARL_BOOST_ERROR_UNIT_NOT_ORDERED');
			}
			COM(this.fastFinish).reason = reason;
		}
	}
}

ManageSpecialUnitProducer.prototype.updateConsumptionBoxVision = function()
{
	UI.show(false, [this.consumptionBox]);
}
