var ManageTemple = function()
{
	callParentConstructor(ManageTemple.prototype, this);
	this.banInfo = null;
	this.updatePending = false;
}

extendClass(ManageTemple.prototype, ManageDialogChild.prototype);

ManageTemple.prototype.banInfo = null;
ManageTemple.prototype.updatePending = false;

ManageTemple.prototype.__construct = function()
{
	COM(this.banGrid).setHeader([
		I18.f('PLAYER'),
		I18.f('FINISH'),
		I18.f('MISSION_NEAREST')
	]);
	
	COM.bindExclusiveClick(this.magicIcon, $.proxy(function(){
		TempleChestDialog.create(this);
	}, this));
	
	COM.bindExclusiveClick(this.protectButton, $.proxy(this.doProtect, this));
	
	$(this.hoursCount).on('change', $.proxy(this.tick, this));
	COM(this.banGrid).onItemClick = $.proxy(this.rowSelected, this);
}

ManageTemple.prototype.onShow = function()
{
	Dialog.find(this).headerRightBox.appendChild(this.magicIcon);
}

ManageTemple.prototype.update = function(estate)
{
	superMethod(ManageTemple.prototype, 'update', this)(estate);
	this.estate = estate;
	UI.show(estate.accessManageble, [this.magicIcon]);
}

ManageTemple.prototype.reset = function()
{
    superMethod(this, 'reset')();
    this.banInfo = null;
    COM(this.playerName).value = '';
}

ManageTemple.prototype.refreshBanList = function()
{
    var needUpdate = false;
    if (!this.banInfo && this.estate.isEspionage) 
    {
        this.banInfo = new FBanInfo();
        this.banInfo.bans = this.cell.building.protections;
        var data = [];
        for (var i = 0, len = this.banInfo.bans.length; i < len; i++)
        {
        	var ban = this.banInfo.bans[i];
        	ban.timeLeft = Tick.toTimeLeft(ban.tillTick - this.cell.building.estate.responseTick);
        	data.push([ban.username, ban.finishDate, ban.timeLeft]);
        }
        //UI.show(data.length, [this.banGrid]);
        COM(this.banGrid).dataProvider = data;
        needUpdate = false;
    } 
    else if (!this.banInfo && !this.cell.building.isBuildPending) 
    {
        needUpdate = true;
    } 
    else if (this.banInfo && !this.estate.isEspionage) 
    {
        for (var i = 0, len = this.banInfo.bans.length; i < len; i++)
        {
        	var ban = this.banInfo.bans[i];
        	ban.refresh();
        	if (ban.isExpired)
        	{
        		needUpdate - true;
        	}
        }
    }
    if (needUpdate) 
    {
        this.updatePending = true;
        Service.ban.callMethod('getBanList', 
        	[this.estate.owner.username], 
        	$.proxy(this.handleResult, this), 
        	$.proxy(this.handleFault, this)
        );
    }
}

ManageTemple.prototype.tick = function()
{
    var b = this.cell.building;
    
    //this.enabled = !b.isBuildPending;
    
    this.refreshBanList();
    
    if (b.isBuildPending || !this.banInfo) 
    {
        //COM(this.protectButton).enabled = false;
        return;
    }
    
    COM(this.speed).value = b.getGodpointsProductionPerHour();
    COM(this.available).update(b.godpointsAvailable, b.getLevel().godpointLimit);
    COM(this.hoursCount).max = Math.max(1, NumberUtils.floor(b.godpointsAvailable / FConfig.GOD_PROTECTION_HOUR_TAX));
    COM(this.cost).value = COM(this.hoursCount).value * FConfig.GOD_PROTECTION_HOUR_TAX;
    var godpointsDeficit = b.godpointsAvailable < FConfig.GOD_PROTECTION_HOUR_TAX;
    COM(this.cost).highlight = godpointsDeficit;
    //this.cost.css('border', godpointsDeficit ? '1px solid red' : '0px');
    var reason = null;
    if (!this.estate.accessDeputy)
    {
    	reason = I18.f('ACCESS_DENIED_ERROR_DEPUTY_LEVEL_NEEDED');
    }
    else if (godpointsDeficit)
    {
    	reason = I18.f('GODPROTECT_ERROR_NOT_ENOUGH_GODPOINTS');
    }
    COM(this.hoursCount).reason = reason;
    COM(this.playerName).disabled = !this.estate.accessDeputy;
    //COM(this.protectButton).enabled = !godpointsDeficit && !this.updatePending && COM(this.playerName).value.length > 0 && this.estate.accessDeputy;
    this.refreshProtectReason();
    
    var items = COM(this.banGrid).items;
    for (var i = 0, len = this.banInfo.bans.length; i < len; i++)
    {
    	var ban = this.banInfo.bans[i], data = COM(items[i]).data;
    	ban.timeLeft = Tick.toTimeLeft(ban.tillTick - this.cell.building.estate.responseTick);
    	data[2] = ban.timeLeft;
    	COM(items[i]).data = data;
    }
}

ManageTemple.prototype.refreshProtectReason = function()
{
    var name = COM(this.playerName).value;
    var notification = null;
    var godpointsDeficit = this.cell.building.godpointsAvailable < FConfig.GOD_PROTECTION_HOUR_TAX;
    
    if (!this.estate.accessDeputy)
    {
    	notification = I18.f('ACCESS_DENIED_ERROR_DEPUTY_LEVEL_NEEDED');
    }
    else if (this.banInfo.allies.indexOf(name) >= 0) 
    {
        notification = I18.f('GODPROTECT_ERROR_ALLY');
    } 
    else if (this.banInfo.victims.indexOf(name) >= 0) 
    {
        notification = I18.f('GODPROTECT_ERROR_VICTIM', NumberUtils.floor(FConfig.GOD_PROTECTION_VICTIM_TIMEOUT / 60 / 60 / 24));
    } 
    else if (this.banInfo.attackers.indexOf(name) >= 0) 
    {
        notification = I18.f('GODPROTECT_ERROR_ATTACKER');
    } 
    else if ((this.banInfo.bans.length >= FConfig.MAX_GOD_PROTECTIONS_COUNT) && !this.banInfo.hasBanForUser(name)) 
    {
        notification = I18.f('GODPROTECT_ERROR_LIMIT_REACHED');
    }
    else if (godpointsDeficit) 
    {
        notification = I18.f('GODPROTECT_ERROR_NOT_ENOUGH_GODPOINTS');
    }
    COM(this.protectButton).reason = notification ? [notification] : null;
}

ManageTemple.prototype.doProtect = function()
{
    Service.ban.callMethod('requestGodProtection', 
    	[this.estate.owner.username, COM(this.playerName).value, COM(this.hoursCount).value*1],
    	$.proxy(this.handleResult, this), $.proxy(this.handleFault, this)
    );
}

ManageTemple.prototype.handleResult = function(banInfo)
{
    console.log('bans', banInfo);
    this.banInfo = banInfo;
    var data = [];
    for (var i = 0, len = this.banInfo.bans.length; i < len; i++)
    {
    	var ban = this.banInfo.bans[i];
    	ban.timeLeft = Tick.toTimeLeft(ban.tillTick - this.cell.building.estate.responseTick);
    	data.push([ban.username, ban.finishDate, ban.timeLeft]);
    }
    //UI.show(data.length, [this.banGrid]);
    COM(this.banGrid).dataProvider = data;
    
    if (this.banInfo.godpointLeft >= 0) 
    {
        this.cell.building.godpointsAvailable = this.banInfo.godpointLeft;
    }
    this.updatePending = false;
    this.tick();
}

ManageTemple.prototype.handleFault = function(error)
{
    if (error.__className__ == 'AvatarNotFoundException' || error.__className__ == 'GodProtectionException') 
    {
        Alert.create(error.getMessage());
        return true;
    }
    return false;
}

ManageTemple.prototype.rowSelected = function(item)
{
    COM(this.playerName).value = COM(item).data[0];
}
