function ManageTip()
{
	
}

ManageTip.prototype.__construct = function()
{
	
}

ManageTip.create = function(estate, cellIndex, workersCount)
{
    var t = COM.create('ManageTip');
    t.update(estate, cellIndex, workersCount);
    return t;
}

ManageTip.prototype.isMagicActive = function(estate, btype)
{
    return estate.isMagicActive(btype);
}

ManageTip.prototype.update = function(estate, cellIndex, workersCount)
{
    var cell = estate.getCellByIndex(cellIndex);
    var b = cell.building;
    var buff = estate.getStoppingBuff(b.type);
    var eCls = estate.__CLS__.split('.').pop();
    
    if (buff) 
    {
        var stopCause = I18.getBuffCause(buff);
        UI.show(true, [this.mainInfo]);
        this.mainInfo.innerHTML = stopCause;
        UI.show(false, [this.grid]);
        return;
    }
    
    var uiFlag = !b.isWorking;
    UI.show(uiFlag, [this.mainInfo]);
    if (uiFlag)
    {
        this.mainInfo.innerHTML = b.getProblem();
    }

    if (b.isWorking) 
    {
        UI.show(true, [this.grid]);
        this.infoLabel.innerHTML = this.getTextInfo(b);
        this.updateSpeed(b);

        uiFlag = estate.canManageOnSectors() && estate.isOnSector(cellIndex) && this.isShouldShowBonus(b);
        UI.show(uiFlag, [this.sectorBox])
        if (uiFlag)
        {
            this.sectorBonus.innerHTML = Strings.formatBonusPercent(FConfig.PRODUCTIVITY_RATIO_IN_SECTOR);
            $(this.sectorBonus)
            	.removeClass('positive negative')
            	.addClass(FConfig.PRODUCTIVITY_RATIO_IN_SECTOR > 0 
            		? 'positive' 
            		: 'negative'
            	)
            ;
        }
	
		uiFlag = (eCls == 'FPit') && this.isShouldShowBonus(b);
        UI.show(uiFlag, [this.pitBox]);
        if (uiFlag)
        {
            this.pitBonus.innerHTML = Strings.formatBonusPercent(FConfig.PRODUCTIVITY_BONUS_IN_PIT.getValue(cell.resource));
            $(this.pitBonus)
            	.removeClass('positive negative')
            	.addClass(FConfig.PRODUCTIVITY_BONUS_IN_PIT.getValue(cell.resource) > 0 
            		? 'positive' 
            		: 'negative'
            	)
            ;
        }

        var minerLevel = estate.science.getLevel(Science.SPEC_MINER);
        uiFlag = minerLevel > 0 && this.isShowMinerBonus(b);
        UI.show(uiFlag, [this.minerBox])
        if (uiFlag)
        {
            this.minerLabel.innerHTML = I18.getScience(Science.SPEC_MINER);
            this.minerBonus.innerHTML = Strings.formatBonusPercent(ScienceBonusUtil.getMinerBonus(minerLevel, b.type));
            $(this.minerBonus)
            	.removeClass('positive negative')
            	.addClass(ScienceBonusUtil.getMinerBonus(minerLevel, b.type) > 0 
            		? 'positive' 
            		: 'negative'
            	)
            ;
        }

        var magicActive = this.isMagicActive(estate, b.type);
        uiFlag = magicActive && this.isShouldShowBonus(b);
        UI.show(uiFlag, [this.ancientMagicBox]);
        if (uiFlag)
        {
            this.magicLabel.innerHTML = I18.f('ANCIENT_MAGIC_NAME');
            this.magicBonus.innerHTML = Strings.formatBonusPercent(ServiceHelper.getGloabalServiceDecl(b.type.name, 0).getValue());
            $(this.magicBonus).addClass('positive');
        };

        var workersBonusValue = workersCount / b.getLevel().workers - 1;
        uiFlag = workersBonusValue != 0 && this.isShouldShowBonus(b);
        UI.show(uiFlag, [this.workersBox]);
        if (uiFlag)
        {
            this.workersLabel.innerHTML = I18.getWorkers(b.type);
            this.workersBonus.innerHTML = Strings.formatBonusPercent(workersBonusValue);
            $(this.workersBonus)
            	.removeClass('positive negative')
            	.addClass(workersBonusValue > 0 
            		? 'positive' 
            		: 'negative'
            	)
            ;
        }

        if (estate.buffs) 
        {
            //aggregate friends help
            var box;
            var friendsHelpValue = 0;
            var friendsHelpCause = '';
            var buffsEffects = '';
            
            this.buffs.innerHTML = '';

            for (var i = 0, len = estate.buffs.length; i < len; i++)
            {
            	var buff = estate.buffs[i];
            	
            	if (buff.btype)
            	{
	                if (buff.buffType.name == BuffType.BOOST_BUILDING.name && buff.btype.name == b.type.name) 
	                {
	                    if (buff.cast.cause.name == CastCause.FRIENDS.name) 
	                    {
	                        friendsHelpValue += buff.value;
	                        if (!friendsHelpCause) 
	                        {
	                            friendsHelpCause = I18.getBuffCause(buff);
	                        }
	                    } 
	                    else 
	                    {
	                        if (!Tick.isInfinity(buff.cast.tillTick)) 
	                        {
	                            buffsEffects += I18.getMegaString("TILL", [buff.cast.tillTick]) + ' ';
	                        }
			                buffsEffects += I18.getBuffCause(buff) + ' ';
			                buffsEffects += '<b class="'+(buff.value > 0 ? 'positive' : 'negative')+'">' + Strings.formatBonusPercent(buff.value) + '</b><br/>';
	                    }
	                }
            	}
            }
            if (UI.show(friendsHelpCause, [this.friendsBox])) 
            {
                UI.show(true, [this.friendsBox]);
                this.friendsLabel.innerHTML = friendsHelpCause;
                this.friendsBonus.innerHTML = Strings.formatBonusPercent(friendsHelpValue);
	            $(this.friendsBonus)
	            	.removeClass('positive negative')
	            	.addClass(friendsHelpValue > 0 
	            		? 'positive' 
	            		: 'negative'
	            	)
	            ;
            }
            
            this.buffs.innerHTML = buffsEffects;
            UI.show(buffsEffects, [this.buffsBox]);
        }
    } 
    else 
    {
        UI.show(false, [this.grid]);
    }
}

ManageTip.prototype.updateSpeed = function(b)
{
    var hasProblems = true;
    var speed;
    var resource = b.resource;
    if (b.type.isRecovery()) 
    {
        hasProblems = false;
        resource = b.cell.resource;
        speed = b.getLevel().recovers.getValue(resource);
    } 
    else if (b.isWarehouseOverfilled()) 
    {
        speed = b.getLastWorkSpeedPerHour().getValue(resource);
        if (!b.hasSpeedProblems()) 
        {
            hasProblems = false;
        }
    } 
    else if (b.type.isExtractor() && b.cell.remainder == 0 && !b.isPerfect()) 
    {
        speed = b.type.getEmptyCellSpeed(b.race);
    } 
    else 
    {
        hasProblems = false;
        speed = b.getLevel().raises;
    }

    with (COM(this.baseSpeedPerHour))
    {
	    alwaysShow = [resource];
	    update(new Funds().setValue(resource, speed), b.race);
	    styleFunds([resource], hasProblems);
    }

    var terrainBonusValue = b.estate.terrainProductivityBonus.getValue(resource);
    UI.show(terrainBonusValue != 0, [this.terrainBox]);
    if (terrainBonusValue != 0)
    {
        this.terrainBonus.innerHTML = Strings.formatBonusPercent(terrainBonusValue);
        $(this.terrainBonus)
        	.removeClass('positive negative')
        	.addClass(terrainBonusValue > 0 
        		? 'positive' 
        		: 'negative'
        	)
        ;
    }
}

ManageTip.prototype.isShouldShowBonus = function(b)
{
    return true;
}

ManageTip.prototype.isShowMinerBonus = function(b)
{
    return b.type.name == BType.MINE_IRON.name || b.type.name == BType.MINE_STONE.name || b.type.name == BType.MINE_GOLD.name;
}

ManageTip.prototype.getTextInfo = function(b)
{
    if (b.isRepairing) 
    {
        return I18.f('BUILDING_IS_REPAIRING');
    } 
    else if (b.isBroken) 
    {
        return I18.f('BUILDING_IS_BROKEN');
    } 
    else if (!b.type.isRecovery() && b.isWarehouseOverfilled() && b.hasSpeedProblems()) 
    {
        return I18.f('WAREHOUSES_OVERFILLED');
    } 
    else if (b.type.isExtractor() && b.cell.remainder == 0 && !b.isPerfect()) 
    {
        return I18.f('CELL_IS_EMPTY');
    }
    return b.isPerfect() ? I18.f('PERFECT_BUILDING') : I18.f('LEVEL_X', b.level);
}

