function ManageTowerTip()
{
	
}

ManageTowerTip.prototype.__construct = function()
{
	
}

ManageTowerTip.create = function(b)
{
    var t = COM.create('ManageTowerTip');
    t.update(b);
    return t;
}

ManageTowerTip.createForLevel = function(bt, estate, level) 
{
    var t = COM.create('ManageTowerTip');
    t.updateForLevel(bt, level, estate.owner.race, estate);
    return t;
}

ManageTowerTip.prototype.update = function(b)
{
    this.updateForLevel(b.type, b.level, b.race, b.estate);

    UI.show(b.isWorking, [this.grid]);
    UI.show(!b.isWorking, [this.problemInfo]);
    if (!b.isWorking)
    {
    	this.problemInfo.innerHTML = b.getProblem();
    }
}

ManageTowerTip.prototype.updateForLevel = function(bt, level, r, estate) 
{
    var levelTower = bt.getLevels(r)[level];
    this.baseName.innerHTML = levelTower.perfect ? I18.f('PERFECT_BUILDING') : I18.f('LEVEL_X', level);
    this.baseValue.innerHTML = CombatBonusUtil.getTowerAttack(bt, level, estate, false).toString();

    var defenderLevel = estate.getScienceLevel(Science.SPEC_DEFENDER);
    UI.show(defenderLevel > 0 && BType.TOWER.equals(bt), [this.defenderBonus]);
    if (defenderLevel > 0 && BType.TOWER.equals(bt))
    {
        this.bonus.innerHTML = Strings.formatPercent(Science.SPEC_DEFENDER.getLevel(defenderLevel - 1).towersBonus, true);
        this.bonus.className = 'positive';
    }

    // clear old buffs
    while (this.grid.rows.length > 2) 
    {
    	this.grid.deleteRow(2);
    }
    
    var buffs = estate.getBuildingBuffs(BuffType.BOOST_BUILDING, bt);
    for (var i = 0, len = buffs.length; i < len; i++) 
    {
        var buff = buffs[i];
        var tr = this.grid.insertRow(this.grid.rows.length), td;
        $(tr.insertCell(0)).append(I18.getBuffCause(buff));
        $(tr.insertCell(1)).append(I18.percentText(buff.value));
    }
}
