var ManageUnitProducerParent = function()
{
	callParentConstructor(ManageUnitProducerParent.prototype, this);

	this._b = null;
	this._boostType = '';
	this._boostTypeImage = null;

	this.__defineGetter__('utype', function()
	{
		return this._b.type.getUnitType(this._b.race);
	});

	this.__defineGetter__('level', function()
	{
		return 1;
	});
	
	this.onChangeUnitsCount = $.proxy(this.onChangeUnitsCount, this);
	this.finishNow = $.proxy(this.finishNow, this);
	this.onOrderClick = $.proxy(this.onOrderClick, this);
	this.onAutoClick = $.proxy(this.onAutoClick, this);
	
	this.boostMerchants = null;
	this.boostExpeditors = null;
	
	this.unitTip = null;
}

extendClass(ManageUnitProducerParent.prototype, ManageDialogChild.prototype);

ManageUnitProducerParent.prototype._b = null;
ManageUnitProducerParent.prototype._boostType = '';
ManageUnitProducerParent.prototype._boostTypeImage = null;

ManageUnitProducerParent.prototype.__construct = function()
{
	$(this.count).on('change', this.onChangeUnitsCount);
	COM.bindExclusiveClick(this.fastFinish, this.finishNow);
	COM.bindExclusiveClick(this.doTrain, this.onOrderClick);
	COM(this.doTrain).reason = null;
	COM.bindExclusiveClick(this.auto, this.onAutoClick);
	this.updateConsumptionBoxVision();
	$(this.orderCost).on(CLICK_EVENT, $.proxy(this.onCostTip, this));
	$(this.orderTime).on(CLICK_EVENT, $.proxy(this.onTimeTooltip, this));
}

ManageUnitProducerParent.prototype.initBasicBuildingControls = function()
{
}

ManageUnitProducerParent.prototype.onShow = function()
{
	this.cellSwitched();
    
    UI.show(this._b.type.isMilitaryUnitProducer(), [this.typeIcon]);
    if (this._b.type.isMilitaryUnitProducer())
    {
    	this.typeIcon.src = STATIC_URL + Assets.getUnitTypeIcon(this.utype);
    }
    
	var d = Dialog.find(this);
	d.headerRightBox.appendChild(this.fastFinish);
	if (this.boostExpeditors) d.headerRightBox.appendChild(this.boostExpeditors);
	if (this.boostMerchants) d.headerRightBox.appendChild(this.boostMerchants);
}

ManageUnitProducerParent.prototype.updateConsumptionBoxVision = function()
{
	if (UI.show(!FConfig.NO_ARMY_CONSUMPTION, [this.consumptionBox]))
	{
		$(this.consumptionBox).on(CLICK_EVENT, $.proxy(this.onConsumeTip, this));
	}
};


ManageUnitProducerParent.prototype.cellSwitched = function()
{
	COM(this.count).max = Math.floor(COM(this.count).max) || 1;
	COM(this.count).value = COM(this.count).max;
	this.onChangeUnitsCount();
}

ManageUnitProducerParent.prototype.tick = function()
{
	if (!this.estate) return;
	
	this._b = this.cell.building;
	this._boostType = "MAGIC_FINISH_" + this._b.typeName;
	this._boostTypeImage = Assets[this._boostType] ? STATIC_INTERFACE_URL + Assets[this._boostType] : COM(this.fastFinish).icon;
	
	COM(this.fastFinish).boostType = this._boostType;
	COM(this.fastFinish).icon = this._boostTypeImage;
	
	var uv = COM(this.unitView);
	uv.utype = this.utype;
	uv.race = this.estate.race;
	uv.aura = this.estate;
	uv.buffs = this.estate.buffs;
	uv.time = FEstate.tickNowForEstate(this.estate);
	uv.update.apply(uv, this._b.type.isMilitaryUnitProducer() 
		? [this.level, 0] 
		: [1, this._b.unitsTotal, this._b.unitsCapacity]
	);
	
	var uName = I18.getUnitName(this.utype, this.level, this._b.race);
	$(this.unitName).html(uName);
	$(this.trainUnitName).html(uName);

	if (!this.unitTip)
	{
		this.unitTip = uv.getToolTip();
		this.unitTipBox.appendChild(this.unitTip.DOM);
	}

	this.onChangeUnitsCount();
	this.updateQueueTime();
	this.updateAuto();
	
	this.updateCost(COM(this.count).value);	
}

ManageUnitProducerParent.prototype.onChangeUnitsCount = function()
{
	this.updateCount();
	this.updateTime(COM(this.count).value);
	this.updateCost(COM(this.count).value);
	UI.show(this._b.estate.accessManageble && ServiceHelper.getLocalServiceDecl(this._b.type.getUnitType(this._b.race).name, 0), [this.fastFinish]);
}

ManageUnitProducerParent.prototype.queueLimitReached = function()
{
	var q = COM(this.count).value + this._b.unitsQueued*1;
	var max = this._b.getLevel().queueSize;
	
	return (this._b.isConstructed 
		&& this._b.type.isMilitaryUnitProducer() 
		&& (q > max)
	);
}

ManageUnitProducerParent.prototype.scienceResearched = function()
{
	return this._b.isConstructed 
		&& (!this._b.type.requiredScience || this._b.estate.science.getLevel(this._b.type.requiredScience) > 0)
	;
}

ManageUnitProducerParent.prototype.getOrderReasonLabel = function()
{
	if (this.queueLimitReached())
	{
		return I18.f('QUEUE_LIMIT_REACHED', this._b.getLevel().queueSize);
	}
	if (!this._b.isConstructed)
	{
		return I18.f('BUILDING_IS_NOT_CONSTRUCTED');
	}
	if (!this.scienceResearched())
	{
		return I18.f('SCIENCE_IS_NOT_RESEARCHED');
	}
	return null;
}

ManageUnitProducerParent.prototype.userHasAccess = function()
{
	var btn = COM(this.doTrain);
	if (!this.estate.accessOrderUnit)
	{
		btn.reason = I18.f('ACCESS_DENIED_ERROR_OWNER_LEVEL_NEEDED');
		return false;
	}
	return true;
}

ManageUnitProducerParent.prototype.updateCost = function(count)
{
	var unitsCost = this.getOneUnitCost().multiplyCopy(count).ceil();
	COM(this.orderCost).update(unitsCost, this._b.race);
	COM(this.orderCost).capacity = this.estate.bank.copy();
	
	var btn = COM(this.doTrain);
	btn.enabled = btn.enabled && !Quarantine.contains(btn.ID);
	if (!this.userHasAccess())
	{
		return false;
	}
	else if (this.estate.isGateClosed() && this._b.isOnSector)
	{
		btn.reason = I18.f('OPEN_THE_GATE_WARNING');
		return false;
	}
	else if (this._b.isBuildPending)
	{
		btn.reason = I18.f('BUILDING_IS_NOT_CONSTRUCTED');
		return false;
	}
	else if (this._b.isRepairing)
	{
		btn.reason = I18.f('REPAIRING');
		return false;
	}
	else if (this._b.isBroken)
	{
		btn.reason = I18.f('BUILDING_IS_BROKEN_ALERT_TITLE');
		return false;
	}
	else if (!this.estate.bank.greaterOrEqualsTo(unitsCost))
	{
		var f = FundsBox.create(unitsCost, this._b.race);
		f.capacity = this.estate.bank;
		btn.reason = '<div>'+I18.f('MISSION_NOT_ENOUGH_RESOURCES')+'</div>' + f.DOM.outerHTML;
		return false;
	}
	else if (count <= 0)
	{
		btn.reason = $.proxy(function(){
			COM(this.count).value = 1;
			//this.count.focus();
		}, this);
		return false;
	}
	else if (!this.canOrderUnits())
	{
		btn.reason = this.getOrderReasonLabel();
		return false;
	}
	btn.reason = null;
	return Boolean(btn.enabled && !btn.reason);
}

ManageUnitProducerParent.prototype.canOrderUnits = function()
{
	return (this._b.isConstructed && !this.queueLimitReached() && this.scienceResearched());
}

ManageUnitProducerParent.prototype.canTrainUnits = function(count, unitsCost)
{
	return this.canOrderUnits() 
		&& !this._b.isBroken 
		&& !this._b.isRepairing 
		&& this.estate.bank.greaterOrEqualsTo(unitsCost) 
		&& (count > 0) 
		&& !Quarantine.contains(this.doTrain) 
		&& this.estate.accessOrderUnit 
		&& !(this.estate.isGateClosed() && this._b.isOnSector)
	;
}

ManageUnitProducerParent.prototype.updateCount = function()
{
	var cost = this.getOneUnitCost();
	var maxCount = this.estate.bank.calcCountByCost(cost);
	if (this._b.type.isMilitaryUnitProducer())
	{
		maxCount = Math.min(maxCount, this._b.getLevel().queueSize - this._b.unitsQueued);
	}
	maxCount = Math.floor(maxCount);
	
	COM(this.count).max = Math.max(1, maxCount);
	//COM(this.count).value = COM(this.count).max;

	/*
	if (UI.show(!this.canOrderUnits(), [this.cannotOrderReasonBox]))
	{
		$(this.cannotOrderReasonBox).html(this.getOrderReasonLabel());
	}
	*/
}

ManageUnitProducerParent.prototype.updateQueueTime = function()
{
	var endQueueTick = this._b.getEndQueueTick();
	var unitCount = Math.ceil(this._b.unitsQueued);
	$(this.unitCount).html(unitCount);
	if ((this._b.isOnSector && this.estate.isGateClosed()) || endQueueTick == Tick.TICK_INFINITY)
	{
		COM(this.allUnitsTime).value = Tick.TICK_INFINITY;
		COM(this.nextUnitTime).value = Tick.TICK_INFINITY;
		
		UI.show(!!unitCount, [this.beingTrainedBox]);
		UI.show(!unitCount, [this.noTrainingBox]);
	}
	else
	{
		var ticksTill = endQueueTick - FEstate.tickNowForEstate(this.estate);
		
		UI.show(ticksTill > 0, [this.beingTrainedBox]);
		UI.show(ticksTill <= 0, [this.noTrainingBox]);
		
		COM(this.allUnitsTime).value = ticksTill <= 0 ? 0 : ticksTill;
		COM(this.nextUnitTime).value = ticksTill <= 0 ? 0 : ticksTill % this._b.getDefaultProduceTime();
	}
}

ManageUnitProducerParent.prototype.updateTime = function(unitsCount)
{
	var t = $(COM(this.orderTime).time);
	
	t.addClass('positive').removeClass('overflow');
	if (this._b.hasProduceTimeBonuses() && this._b.type.isMilitaryUnitProducer())
	{
		if (this._b.hasOverfilledBonuses())
		{
			t.removeClass('positive').addClass('overflow');
		}
	}

	var t = this._b.isConstructed ? this._b.getDefaultProduceTime() : this._b.getProduceTimeForLevel(1);
	if (t != Tick.TICK_INFINITY)
	{
		t *= unitsCount;
	}
	COM(this.orderTime).value = t;
}

ManageUnitProducerParent.prototype.onTimeTooltip = function(e)
{
	var tip = UnitProductionSpeedTip.create(this.estate, this.cell.building, COM(this.count).value);
	return TipDialog.create(tip.DOM, I18.f('TIME'));
}

ManageUnitProducerParent.prototype.onConsumeTip = function(e)
{
}

ManageUnitProducerParent.prototype.onCostTip = function(r)
{
	var tip = document.createElement('div');
	tip.className = 'text-narrow text-middle';
	
	tip.innerHTML += '<div class="text-bold text-middle">' + I18.f('RES_AVAILABLE') + '</div>';
	var availableBox = document.createElement('div');
	availableBox.className = 'lightbox';
	availableBox.style.width = '100%';
	
	var availableResources = COM.create('FundsBox');
	availableResources.shortView = true;
	availableResources.showZero = true;
	availableResources.update(this.estate.bank, this.estate.race);
	availableBox.appendChild(availableResources.DOM);
	
	tip.appendChild(availableBox);

	tip.innerHTML += '<div class="text-bold text-middle" style="margin-top: 0.4em;">' + I18.f('REQUIRED') + '</div>';
	var requiredBox = document.createElement('div');
	requiredBox.className = 'lightbox';
	requiredBox.style.width = '100%';
	
	var funds = COM(this.orderCost).funds;
	Resource.FUNDS_RESOURCES.forEach($.proxy(function(r, idx, arr){
		
		if (!funds.getValue(r)) return;
		
		var buffType = r.name != Resource.PEOPLE.name ? BuffType.ECONOMY_TRAINING_MILITARY_RESOURCES : BuffType.ECONOMY_TRAINING_MILITARY_PEOPLE;
		var box = this.createCostTip(r, buffType, this.utype);
		box.style.width = '100%';
		box.style.margin = '0.5em 0px';
		requiredBox.appendChild(box);
		
	}, this));
	
	tip.appendChild(requiredBox);
	
	return TipDialog.create(tip, I18.f('REQUIRED'));
}

ManageUnitProducerParent.prototype.createCostTip = function(r, buffType, ut)
{
	var t = document.createElement('table'), tr;
	
	var icon = COM(this.orderCost).getIcon(r);
	var src = COM(icon).source;
		
	tr = t.insertRow(-1);
    var baseReq = COM.create('IconAndValue');
    baseReq.source = src;
    baseReq.value = COM(this.orderCost).funds.getValue(r);
    baseReq.text.className = COM(icon).text.className;
	$(tr.insertCell(-1)).html(baseReq.DOM).css({"text-align":"left"}).attr('colspan', '2').addClass('text-normal-bold');
	
	tr = t.insertRow(-1);
    var req = COM.create('IconAndValue');
    req.source = src;
    req.value = FConfig.getStat(this._b.race, this.utype, this.level).cost.getValue(r) * COM(this.count).value;
	$(tr.insertCell(-1)).html(I18.f('LEVEL_X', this.level)).css({"text-align":"left", "width": "50%"});
	$(tr.insertCell(-1)).html(req.DOM).css({"text-align":"center", "width": "50%"});
	 
	var buffs = this.estate.getBuffs(buffType);
	for (var i = 0; i < buffs.length; i++) 
	{
		var buff = buffs[i];
	 	if (!buff.unitType || buff.unitType.name == ut.name) 
	 	{
			tr = t.insertRow(-1);
			$(tr.insertCell(-1)).html(I18.getBuffCause(buff)).css({"text-align":"left", "width": "50%"});
			$(tr.insertCell(-1)).html(I18.typedValue(buff.buffType.getType(), buff.value)).css({"text-align":"center", "width": "50%"});
	 	}
	 }
	 return t;
}

ManageUnitProducerParent.prototype.onOrderClick = function()
{
	if (!Quarantine.contains(this.doTrain.ID))
	{
		Quarantine.put(this.doTrain.ID);
		if (COM(this.count).value > COM(this.count).max)
		{
			COM(this.count).value = COM(this.count).max;
		}
		this.onOrder(this._b, COM(this.count).value);
		this.updateCount();
		this.updateQueueTime();
	}
}

ManageUnitProducerParent.prototype.autoProduceBuffType = function()
{
	return null;
}

ManageUnitProducerParent.prototype.updateAuto = function()
{
	var activeTill = FBuff.buffActiveTill(this._b.estate.buffs, this.autoProduceBuffType());
	if (UI.show((activeTill >= Tick.now()) && this._b.isConstructed, [this.auto]))
	{
		COM(this.auto).enabled = this._b.estate.accessOrderUnit;
		COM(this.auto).caption = this._b.autoProduceEnabled ? I18.f('STOP_AUTOPRODUCE') : I18.f('START_AUTOPRODUCE');
		COM(this.auto).skin = this._b.autoProduceEnabled ? 'green' : 'yellow';
	}
}

ManageUnitProducerParent.prototype.onAutoTip = function(e)
{
	//e.toolTip = BuffCauseTip.create(FBuff.getBuffs(this._b.estate.buffs, this.autoProduceBuffType(), null, FEstate.tickNowForEstate(this._b.estate)));
}

ManageUnitProducerParent.prototype.onAutoClick = function()
{
	if (!Quarantine.contains(this.auto.ID))
	{
		COM(this.auto).enabled = false;
		Quarantine.put(this.auto.ID);
		Service.city.callMethod('setAutoProduce', [this.estate.id, this._b.id, !this._b.autoProduceEnabled]);
	}
}

ManageUnitProducerParent.prototype.onOrder = function(building, amount)
{
	APP.showLoader();
	Service.city.callMethod('orderUnit', [this.estate.id, building.id, amount*1], 
		$.proxy(function(e)
		{
			APP.hideLoader();
		}, this),
		$.proxy(function(e)
		{
			// reread estate after any error
			this.estate.nextUpdateTick = Tick.now();
			APP.hideLoader();
			return false;
	
		}, this)
	);
}

ManageUnitProducerParent.prototype.finishNow = function()
{
	var d = COM.create('FinishUnitsDialog');
	d.popup(this, this._b);
}

ManageUnitProducerParent.prototype.getOneUnitCost = function()
{
	var cost = FConfig.getStat(this._b.race, this.utype, this.level).cost;
	return cost;
}
