function ResourceChooserV2()
{
	this.__defineGetter__('value', this.getFundsValue);
	this.__defineSetter__('value', this.setFundsValue);
	
	this.race = null;
	this.maximum = null; // Funds
	this.showResources = null; // Array
}

ResourceChooserV2.prototype.race = null;
ResourceChooserV2.prototype.maximum = null; // Funds
ResourceChooserV2.prototype.showResources = null; // Array

ResourceChooserV2.prototype.__construct = function()
{
	UI.show(false, [this.maxButton]);
	$('NumberInput', this.DOM).on('change', $.proxy(function(e){
		return this.onChange(e);
	}, this));
	
	COM.bindExclusiveClick(this.maxButton, $.proxy(function(){
		if (!this.maximum) return;
		this.value = this.maximum;
	}, this));
}

ResourceChooserV2.prototype.onChange = function(){}; // Function

ResourceChooserV2.prototype.showResource = function(r)
{
	for (var i = 0, len = this.showResources.length; i < len; i++) 
	{
    	if (this.showResources[i].name == r.name) return true;
    }
	return false;
}

ResourceChooserV2.prototype.setMaximum = function(r, max)
{
	COM(this[r.name]).max = max;
}

ResourceChooserV2.prototype.getValue = function(r)
{
	return COM(this[r.name]).value * 1;
}

ResourceChooserV2.prototype.setValue = function(r, value)
{
	COM(this[r.name]).value = value*1;
}

ResourceChooserV2.prototype.update = function(race, resources, maximum)
{
	this.showResources = resources;
	this.race = race;
	this.maximum = maximum;
	
	COM(this.PEOPLE).icon = STATIC_URL + Assets.getFreePeopleIcon(this.race);
	
	for (var i = 0; i < Resource.FUNDS_RESOURCES.length; i++) 
	{
	    var r = Resource.FUNDS_RESOURCES[i];
	    UI.show(this.showResource(r), [this[r.name]]);
	    this.setMaximum(r, this.maximum.getValue(r));
	}
	
	//if (this.value.sum() == 0) this.value = maximum;
}
	
ResourceChooserV2.prototype.getFundsValue = function()
{
	var result = new Funds();
	for (var i = 0; i < Resource.FUNDS_RESOURCES.length; i++)
	{ 
	    result.setValue(Resource.FUNDS_RESOURCES[i], this.getValue(Resource.FUNDS_RESOURCES[i]));
	}
	return result;
}
	
ResourceChooserV2.prototype.setFundsValue = function(funds) 
{
	for (var i = 0; i < Resource.FUNDS_RESOURCES.length; i++)
	{ 
	    var r = Resource.FUNDS_RESOURCES[i];
	    this.setValue(Resource.FUNDS_RESOURCES[i], funds.getValue(r));
	}
}
	
ResourceChooserV2.prototype.reset = function()
{
	for (var i = 0; i < Resource.WAREHOUSE_RESOURCES.length; i++)
	{ 
	    this.setValue(Resource.WAREHOUSE_RESOURCES[i], 0);
	}
}