function UnitProductionSpeedTip()
{
	callParentConstructor(UnitProductionSpeedTip.prototype, this);
}

extendClass(UnitProductionSpeedTip.prototype, Tip.prototype);

UnitProductionSpeedTip.create = function(estate, b, count)
{
    var t = COM.create('UnitProductionSpeedTip');
    t.DOM.style.display = 'block';
    t.update(estate, b, count);
    return t;
}

UnitProductionSpeedTip.createForLevel = function(estate, bt, level)
{
    var t = COM.create('UnitProductionSpeedTip');
    t.updateForLevelAndCount(estate, bt, level, 1);
    return t;
}

UnitProductionSpeedTip.prototype.update = function(estate, b, count)
{
    this.updateForLevelAndCount(estate, b.type, b.level, count);
    var t = b.getDefaultProduceTime();
    
    var uiFlag;
    
    UI.show(b.isWorking && t != Tick.TICK_INFINITY, [this.grid]);
    
    if (UI.show(!b.isWorking || t == Tick.TICK_INFINITY, [this.problemInfo]))
    {
        var buff = estate.getBuffs(BuffType.MILITARY_PRODUCTION_STOP);
        $(this.problemInfo).html(buff.length > 0
        	? I18.getBuffCause(buff[0])
        	: b.getProblem()
        );
    }
}

UnitProductionSpeedTip.prototype.updateForLevelAndCount = function(estate, bt, level, count)
{
    var levelUnitProduce = bt.getLevels(estate.owner.race)[level];
    $(this.baseName).html(levelUnitProduce.perfect ? I18.f('PERFECT_BUILDING') : I18.f('LEVEL_X', level));
    COM(this.baseValue).value = Tick.toTimeLeft(levelUnitProduce.produceTime) + ' x ' + count;
    COM(this.baseValueTotal).value = Tick.toTimeLeft(levelUnitProduce.produceTime * count);

    if (estate.buffs && bt.isMilitaryUnitProducer()) 
    {
        var clericLevel = estate.science.getLevel(Science.SPEC_CLERIC);
        if (UI.show((bt.name == BType.HEALER.name) && clericLevel > 0, [this.clericBonusBox]))
        {
            var clericBuff = Science.SPEC_CLERIC.getLevel(clericLevel - 1).healerTrainBonus;
            $(this.clericName).html(I18.getScience(Science.SPEC_CLERIC));
            $(this.clericBonus).html(Strings.formatPercent(-100 * clericBuff, true));
	    	$(this.clericBonus).addClass('funds');
        }
        NumberEffectTip.fillBuffs(FBuff.getBuffs(estate.buffs, BuffType.MILITARY_PRODUCTION, bt.getUnitType(estate.race), FEstate.tickNowForEstate(estate)), this);
    }
}

UnitProductionSpeedTip.prototype.addLine = function()
{
    var table = this.grid[0] || this.grid;
    var rowCount = table.rows.length;
    var row = table.insertRow(rowCount);
    
    for (var i = 0; i < arguments.length; i++)
    {
    	var cell = row.insertCell(i);
    	$(cell).html(arguments[i]);
    }
    
    return this;
}
