function BrotherhoodAvailablesTab()
{
	callParentConstructor(BrotherhoodAvailablesTab.prototype, this);
	this.xy = null; // XY
	this.onResult = function (brotherhood) {}
	this.info = null; // BrotherhoodViewInfo
	
	this.caption = I18.f('BROTHERHOOD_TAB_AVAILABLES');
}

extendClass(BrotherhoodAvailablesTab.prototype, BaseBrotherhoodTab.prototype);

BrotherhoodAvailablesTab.prototype.__construct = function()
{
	superMethod(BrotherhoodAvailablesTab.prototype, '__construct', this)();
	
	for (var i = 0; i < BrotherhoodGoalType.ALL.length; i++)
	{
		COM(this.goalType).addOption(BrotherhoodGoalType.ALL[i], BrotherhoodGoalType.ALL[i].toString());
	}
	COM(this.goalType).selectedIndex = 0;
	
	for (var i = 0; i < OrderRewardType.ALL.length; i++)
	{
		COM(this.rewardType).addOption(OrderRewardType.ALL[i], OrderRewardType.ALL[i].toString());
	}
	COM(this.rewardType).selectedIndex = 0;

	COM(this.orders).createRenderer = $.proxy(this.onCreateRenderer, this);
	COM(this.orders).onItemSelect = $.proxy(this.showOrderDetails, this);
	
	$(this.goalType).on('change', $.proxy(this.remoteUpdate, this));
	$(this.rewardType).on('change', $.proxy(this.remoteUpdate, this));
}

BrotherhoodAvailablesTab.prototype.xy = null; // XY
BrotherhoodAvailablesTab.prototype.onResult = function (brotherhood) {}
BrotherhoodAvailablesTab.prototype.info = null; // BrotherhoodViewInfo

BrotherhoodAvailablesTab.prototype.onCreateRenderer = function(order)
{
    var renderer = COM.create('BrotherhoodOrderRenderer');
    renderer.brotherhood = this.brotherhood;
    renderer.onResult = this.onResult;
    renderer.data = order;
    return renderer;
}

BrotherhoodAvailablesTab.prototype.update = function(brotherhood)
{
    UI.show(brotherhood.orderInExecution, [this.alreadyHave]);
    if (UI.show(!brotherhood.orderInExecution, [this.available]))
    {
        if (!this.info) 
        {
            this.info = new BrotherhoodViewInfo();
            this.remoteUpdate();
        }
    }
    
    this.brotherhood = brotherhood;
    var items = COM(this.orders).items;
    for (var i = 0; i < items.length; i++) 
    {
    	COM(items[i]).brotherhood = this.brotherhod;
    }
}

BrotherhoodAvailablesTab.prototype.onPageChange = function(index)
{
    this.info.pageIndex = index;
    this.remoteUpdate();
}

BrotherhoodAvailablesTab.prototype.remoteUpdate = function()
{
    APP.showLoader();
    this.info.filterOrderType = COM(this.goalType).value;
    this.info.filterRewardType = COM(this.rewardType).value;
    Service.user.callMethod('getAvailableOrders', [this.xy, this.info], 
		$.proxy(function (o)
		{
		    COM(this.orders).dataProvider = o.orders;
    		
    		var items = COM(this.orders).items;
		    for (var i = 0; i < items.length; i++) 
		    {
		    	COM(items[i]).brotherhood = this.brotherhod;
		    }
		    APP.hideLoader();
		    //this.pager.setIndexAndCount(o.pageIndex, o.pageCount);
		}, this),
		BrotherhoodException.errorHandler
	);
}

BrotherhoodAvailablesTab.prototype.showOrderDetails = function(item, idx, list)
{
	var order = COM(item).order;
	list.selectedIndex = -1;
	this.dialog.showOrderDetails(order);
}