function BrotherhoodDialog()
{
	callParentConstructor(BrotherhoodDialog.prototype, this);
	
	this.brotherhood = null; // FUserBrotherhood
	this.xy = null; // XY
	
	this.__defineGetter__('selectedChild', this.getSelectedChild);
	this.__defineSetter__('selectedChild', this.showTab);
}

extendClass(BrotherhoodDialog.prototype, Dialog.prototype);

BrotherhoodDialog.prototype.brotherhood = null; // FUserBrotherhood
BrotherhoodDialog.prototype.xy = null; // XY
BrotherhoodDialog.prototype.orderDialog = null; // BrotherhoodOrderDetailsDialog

BrotherhoodDialog.popup = function(xy)
{
	var d = COM.create('BrotherhoodDialog');
	d.xy = xy;
	
	Service.user.callMethod('getBrotherhood', [], $.proxy(d.update, d), BrotherhoodException.errorHandler);
	
	d.popup();
	return d;
}

BrotherhoodDialog.prototype.__construct = function()
{
	superMethod(BrotherhoodDialog.prototype, '__construct', this)();
	UI.show(false, [this.headerLeftBox, this.headerCaptionBox]);
	this.fullScreen();
	
	COM(this.tabSelector).onChange = $.proxy(this.showTab, this);
}

BrotherhoodDialog.prototype.onShow = function()
{
	var tab = COM(this.tabSelector).items[0].value;
	COM(this.tabSelector).value = tab;
	this.showTab(tab);
}

BrotherhoodDialog.prototype.update = function(brotherhood) 
{
    this.brotherhood = brotherhood;
    
    COM(this.tabSelector.children[0]).subCaption = brotherhood.orders.length + ' / ' + (brotherhood.attackers.length + brotherhood.orders.length);
    
    var currentOrder = brotherhood.orderInExecution;
    if (UI.show(!currentOrder, [this.tabSelector.children[1]]))
    {
    	COM(this.tabSelector.children[1]).subCaption = '';
    	if (this.selectedChild && this.selectedChild.DOM.nodeName.toLowerCase() == 'brotherhoodcurrenttab')
    	{
			var tab = COM(this.tabSelector).items[1].value;
			COM(this.tabSelector).value = tab;
			this.showTab(tab);
    	}
    }
    
    if (UI.show(currentOrder, [this.tabSelector.children[2]]))
    {
    	COM(this.tabSelector.children[2]).subCaption = I18.formatEstateName(currentOrder.targetUser.username, currentOrder.targetUser.capitalLocation);
    	if (this.selectedChild && this.selectedChild.DOM.nodeName.toLowerCase() == 'brotherhoodavailablestab')
    	{
			var tab = COM(this.tabSelector).items[2].value;
			COM(this.tabSelector).value = tab;
			this.showTab(tab);
    	}
    }
    
    COM(this.tabSelector.children[3]).subCaption = brotherhood.rewards.length;
    
    if (this.selectedChild)
    {
    	this.selectedChild.update(this.brotherhood);
    }
}

BrotherhoodDialog.prototype.onResult = function(brotherhood) 
{
	if (this.orderDialog) 
	{
		this.orderDialog.close();
		this.orderDialog = null;
	}
	this.update(brotherhood);
}

BrotherhoodDialog.prototype.showOrderDetails = function(order) 
{
	this.orderDialog = BrotherhoodOrderDetailsDialog.create(order, this.brotherhood, $.proxy(this.onResult, this));
	this.orderDialog.onClose = $.proxy(function(){
		this.orderDialog = null;
	}, this);
}

BrotherhoodDialog.prototype.getSelectedChild = function()
{
    return COM(this.content.children[0]);
}

BrotherhoodDialog.prototype.hideTab = function()
{
    var tab = this.selectedChild;
    if (tab)
    {
    	tab.destroy();
    }
}

BrotherhoodDialog.prototype.showTab = function(tab)
{
    this.hideTab();
    
    tab = (typeof tab == 'string') ? tab : COM(this.tabSelector).value;
    tab = COM.create(tab, null, this);
    this.content.appendChild(tab.DOM);
    
    tab.xy = this.xy;
    tab.onResult = $.proxy(this.update, this);
    tab.dialog = this;
    
    if (this.brotherhood) 
    {
    	tab.update(this.brotherhood);
    }
}
