function BrotherhoodOrdersTab()
{
	callParentConstructor(BrotherhoodOrdersTab.prototype, this);
	
	this.caption = I18.f('BROTHERHOOD_TAB_ORDERS');
}

extendClass(BrotherhoodOrdersTab.prototype, BaseBrotherhoodTab.prototype);

BrotherhoodOrdersTab.prototype.__construct = function(dialog)
{
	this.dialog = dialog;
	superMethod(BrotherhoodOrdersTab.prototype, '__construct', this)();
	
	COM.bindExclusiveClick(this.orderButton, $.proxy(this.onOrder, this));
	
	COM(this.orders).createRenderer = $.proxy(this.onCreateRenderer, this);
	COM(this.orders).onItemSelect = $.proxy(this.showOrderDetails, this);
}

BrotherhoodOrdersTab.prototype.onResult = function (brotherhood){};

BrotherhoodOrdersTab.prototype.onCreateRenderer = function(order)
{
    var renderer = COM.create('BrotherhoodOrderRenderer');
    renderer.brotherhood = this.brotherhood;
    renderer.onResult = this.onResult;
    renderer.data = order;
    return renderer;
}

BrotherhoodOrdersTab.prototype.update = function(brotherhood)
{
    this.brotherhood = brotherhood;
    
    COM(this.orders).dataProvider = brotherhood.orders;

    var items = COM(this.orders).items;
    for (var i = 0; i < items.length; i++) 
    {
    	COM(items[i]).brotherhood = this.brotherhod;
    }
    
    var reason = null;
    if (brotherhood.attackers.length < 1) reason = I18.mega(I18.f('BROTHERHOOD_NO_ATTACKERS'), FConfig.BROTHERHOOD_OFFEND_PERIOD);
    if (!brotherhood.canCreateOrderByLimit()) reason = I18.f('BROTHERHOOD_ERROR_ORDER_LIMIT', Tick.toTimeFuture(this.brotherhood.nextCreateOrderTime));
    COM(this.orderButton).reason = reason; 
}

BrotherhoodOrdersTab.prototype.onOrder = function()
{
    BrotherhoodOrderDialog.popup(this.brotherhood, this.onResult);
}

BrotherhoodOrdersTab.prototype.showOrderDetails = function(item, idx, list)
{
	var order = COM(item).order;
	list.selectedIndex = -1;
	this.dialog.showOrderDetails(order);
}