function BrotherhoodRewardsTab()
{
	callParentConstructor(BrotherhoodRewardsTab.prototype, this);
	this.caption = I18.f('YOUR_REWARDS');
	this.scroll = null;
}

extendClass(BrotherhoodRewardsTab.prototype, BaseBrotherhoodTab.prototype);

BrotherhoodRewardsTab.prototype.__construct = function()
{
	superMethod(BrotherhoodRewardsTab.prototype, '__construct', this)();
	this.scroll = new iScroll(this.rewardsHolder.parentNode, {});
}

BrotherhoodRewardsTab.prototype.onResult = function (brotherhood){};
BrotherhoodRewardsTab.prototype.refreshScroll = function (timeout)
{
	if (timeout) return setTimeout($.proxy(this.refreshScroll, this), timeout*1);
	if (this.scroll) this.scroll.refresh();
}

BrotherhoodRewardsTab.prototype.update = function(brotherhood)
{
    this.brotherhood = brotherhood;
    
    var hasRewards = brotherhood.rewards.length > 0;
    UI.show(!hasRewards, [this.noRewardsLabel]);
    if (UI.show(hasRewards, [this.rewardsHolder])) 
    {
        UI.makeNChilds(this.rewardsHolder, brotherhood.rewards.length, $.proxy(this.createRewardRenderer, this));
        for (var i = 0; i < this.rewardsHolder.children.length; i++) 
        {
            COM(this.rewardsHolder.children[i]).update(brotherhood.rewards[i]);
        }
    }
    
    this.refreshScroll(300);
}

BrotherhoodRewardsTab.prototype.createRewardRenderer = function()
{
    var r = COM.create('BrotherhoodOrderReward');
    r.onGetReward = $.proxy(this.getReward, this);
    return r;
}

BrotherhoodRewardsTab.prototype.getReward = function(a)
{
    Service.user.callMethod('takeBrotherhoodReward', [a.id], 
        $.proxy(function(b)
        {
		    this.onResult(b);
		    AdvisorInfoDialog.create(I18.mega(I18.f('BROTHERHOOD_GET_REWARD_SUCCESS'), a.declaration), FUser.CURRENT_USER.race);
        }, this), 
        BrotherhoodException.errorHandler
    );
}
