function ChooseOrderRewardDialog()
{
	callParentConstructor(ChooseOrderRewardDialog.prototype, this);
}

extendClass(ChooseOrderRewardDialog.prototype, Dialog.prototype);

ChooseOrderRewardDialog.prototype.__construct = function()
{
	superMethod(ChooseOrderRewardDialog.prototype, '__construct', this)();
	COM.bindExclusiveClick(this.okButton, $.proxy(this.onOk, this));
}

ChooseOrderRewardDialog.prototype.onResult = null; // Function
ChooseOrderRewardDialog.prototype.selectedPic = null; // ArtifactPic
ChooseOrderRewardDialog.prototype.selectedReward = null; // OrderRewardType

ChooseOrderRewardDialog.prototype.initialReward = null;
ChooseOrderRewardDialog.create = function(onResult, reward)
{
	var d = COM.create('ChooseOrderRewardDialog');
	d.onResult = onResult;
	d.initialReward = reward;
	d.popup();
	return d;
}

ChooseOrderRewardDialog.prototype.onShow = function()
{
    var initItem = $.proxy(function(n, item)
    {
		var itemType = ArtifactType[item.getAttribute('type')]; 
		var itemLevel = item.getAttribute('level')*1;
		var pic = COM(item.querySelector('ArtifactPic'));
		var reward = OrderRewardType.getRewardType(itemType, itemLevel);
		pic.updateReward(reward);
		
		if (this.inititalReward && String(this.inititalReward) == String(reward))
		{
			this.setCurrentItem(item);
			this.inititalReward = null;
		}
		
    }, this);
    
    $('item', this.rewards)
    	.on(CLICK_EVENT, $.proxy(this.onItemClick, this))
    	.each(initItem)
    ;
    
    COM(this.okButton).reason = I18.f('CHOOSE_REWARD');
}

ChooseOrderRewardDialog.prototype.setCurrentItem = function(item)
{
	var itemType = ArtifactType[item.getAttribute('type')]; 
	var itemLevel = item.getAttribute('level')*1;
	var pic = COM(item.querySelector('ArtifactPic'));
	var reward = OrderRewardType.getRewardType(itemType, itemLevel);
	
	$('items, item', this.rewards).removeClass('selected');
	$(item).addClass('selected');
	$(item.parentNode).addClass('selected');

    this.selectedPic = pic;
    this.selectedReward = reward;
    COM(this.price).update(reward.price);
    COM(this.okButton).reason = (reward.price > FUser.CURRENT_USER.pearl) ? I18.f('NOT_ENOUGH_PEARL') : null;
    
    this.setCaption(pic.getTitle());
}

ChooseOrderRewardDialog.prototype.onItemClick = function(e)
{
	var item = e.currentTarget;
	this.setCurrentItem(item); 
}

ChooseOrderRewardDialog.prototype.onOk = function()
{
    if (!this.selectedReward) return;
    
    this.onResult(this.selectedReward);
    this.close();
}