function StandardDialog()
{
	this.castle = null;
	this.standard = null;
}
extendClass(StandardDialog.prototype, Dialog.prototype)

StandardDialog.create = function(sv)
{
	var d = COM.create('StandardDialog');
	d.update(sv.castle, sv.standard);
	d.popup();
	return d;
}

StandardDialog.prototype.castle = null;
StandardDialog.prototype.standard = null;

StandardDialog.prototype.__construct = function()
{
	$(this.orderButton).on(CLICK_EVENT, $.proxy(this.onOrder, this));
}

StandardDialog.prototype.update = function(castle, standard)
{
	this.castle = castle;
	this.standard = standard;
	
	var declaration = standard.declaration;
	this.image.src = STATIC_URL + CommonAssets["STANDARD_" + standard.name];
	
	EffectsView.createDescriptiveView(this.effects, declaration.reward.dtoActions, true, true, false, false, "", !standard.active);
	this.target.innerHTML = declaration.forCastles ? I18.f('AFFECTS_CASTLES') : I18.f('AFFECTS_CLAN');
	
	var validPrice = (declaration.price <= (standard.peace ? castle.peacePoints : castle.warPoints));
	
	COM(this.orderButton).caption = !standard.active ? I18.f('BUY') : I18.f('EXTEND');
	COM(this.orderButton).subCaption = I18.f('PRICE') + ': ' + declaration.price;
	COM(this.orderButton).icon = STATIC_URL + (standard.peace ? CommonAssets.PEACE_POINT : CommonAssets.WAR_POINT);
	
	var reason = null;
	if (!(standard.peace ? castle.accessManageble : castle.accessWarManageble)) reason = I18.f('CLAN_ERROR_HAS_NO_RIGHTS');
	if (!validPrice) reason = I18.f('NOT_ENOUGH_RESOURCES');
	COM(this.orderButton).reason = reason;	
	
	this.tillTime.innerHTML = standard.active ? I18.f('CAST_LASTS_TILL', Tick.toTimeFuture(standard.till)) : '';
}

StandardDialog.prototype.onOrder = function()
{
	APP.showLoader();
	var onResult = $.proxy(function(){
		this.close();
		APP.hideLoader();
	}, this);
	
	Service.city.callMethod('orderStandard', [this.castle.id, this.standard.name], onResult, onResult);
} 

