
function CastleDonateDialog()
{
	callParentConstructor(CastleDonateDialog.prototype, this);
	
	this.__defineGetter__('city', $.proxy(this.getCity, this));
	this.__defineSetter__('city', $.proxy(this.setCity, this));
}

extendClass(CastleDonateDialog.prototype, UpdatableEstateDialog.prototype);

CastleDonateDialog.prototype.__construct = function()
{
	COM(this.payCitiesCombo).onCityChange = $.proxy(this.citySelected, this);
	
	var list = ['pearl'].concat(Funds.prototype.supportedProps);
	for (var i = 0; i < list.length; i++)
	{
		var res = list[i];
		$(this[res]).on('change', $.proxy(this.tick, this));
	}

	$(this.donateButton).on(CLICK_EVENT, $.proxy(this.onDonate, this));
}

CastleDonateDialog.prototype.onResult = function(info){};


CastleDonateDialog.create = function(estate, onResult)
{
    var d = COM.create('CastleDonateDialog');
    d.onResult = onResult;
    d.initCities();
    d.update(estate);
    d.popup();
    return d;
}

CastleDonateDialog.prototype.update = function(estate)
{
    this.estate = estate;
    var clan = estate.owner.diplomacy.clan;
    if (!clan) this.close();
    this.tick();
}

CastleDonateDialog.prototype.initCities = function()
{
    var cities = Arrays.filter(FUser.LINKS, function (link){ 
    	return link.estateInfo.estateType.name == EstateType.CITY.name; 
    });
    COM(this.payCitiesCombo).updateCities(cities);
    if (cities.length > 0) this.city = cities[0];
}

CastleDonateDialog.prototype.getCity = function()
{
    return COM(this.payCitiesCombo).city;
}

CastleDonateDialog.prototype.setCity = function(c)
{
    COM(this.payCitiesCombo).city = c;
    this.citySelected(COM(this.payCitiesCombo).city);
}

CastleDonateDialog.prototype.tick = function()
{
    var city = this.city;
    if (!city) return;

    var funds = city.bank;
	var list = ['pearl'].concat(funds.supportedProps);
	var total = 0;
	
	for (var i = 0; i < list.length; i++)
	{
		var res = list[i];
		var available = res == 'pearl' ? (Math.floor(FUser.CURRENT_USER.pearl) || 0) : funds[res];
		
		COM(this[res]).value = Math.min(COM(this[res]).value, available);
		COM(this[res]).max = available;
		total += COM(this[res]).value;
		
		COM(this[res+'Available']).value = available;
	}
    
    COM(this.donateButton).reason = (total > 0 ? null : I18.f('NEED_TO_FILL_DATA'));
}

CastleDonateDialog.prototype.onDonate = function()
{
    if (!Quarantine.contains('DonateCastleDialog.donateButton')) 
    {
        Quarantine.put('DonateCastleDialog.donateButton');
        
        this.close();
        
        var city = this.city;
        var funds = new Funds();
        for (var i = 0; i < funds.supportedProps.length; i++)
        {
        	var res = funds.supportedProps[i];
        	funds[res] = COM(this[res]).value * 1 || 0;
        }
        
        Service.alliance.callMethod('donateToClanCastle', [city.id, this.estate.id, funds, COM(this.pearl).value],
                $.proxy(function(fd)
                {
                    //city.bank.subtract(funds);
                    for (var i = 0; i < FUser.LINKS.length; i++)
                    {
                    	if (FUser.LINKS[i].id.toString() == city.id.toString())
                    	{
                    		FUser.LINKS[i].bank.subtract(funds);
                    	}
                    }
                    Alert.create(I18.f('DONATION_ACCEPTED')).onClose = $.proxy(function()
                    {
                        this.onResult(fd);
                        
                    }, this);
                }, this),
                
                $.proxy(function(e)
                {
                    if (e.__CLS__ == 'NotEnoughResourcesException' || e.__CLS__ == 'ClanException') 
                    {
                        Alert.create(e.getMessage());
                        return true;
                    }
                    return false;
                    
                }, this)
        );
    }
}

CastleDonateDialog.prototype.citySelected = function(c)
{
	COM(this.peopleAvailable).source = STATIC_INTERFACE_URL + Assets.getFreePeopleIcon(c.estateInfo.race);
	this.tick();
}
