function ClanActionsDialog()
{
	callParentConstructor(this);
	this.member = null; // FClanMember
}

extendClass(ClanActionsDialog.prototype, Dialog.prototype);

ClanActionsDialog.prototype.member = null; // FClanMember

ClanActionsDialog.prototype.__construct = function()
{
}

ClanActionsDialog.prototype.onGiveRole = function(role, member)
{
}
ClanActionsDialog.prototype.onTakeAwayRole = function(role, member)
{
}
ClanActionsDialog.prototype.onDestroyClan = function()
{
}
ClanActionsDialog.prototype.onEnterClanCapacitor = function(btype)
{
}
ClanActionsDialog.prototype.onTransformClan = function()
{
}

ClanActionsDialog.prototype.update = function(asUser, allowControl, member, clan)
{
    this.member = member;
    // adding roles
    this.setCaption(I18.f('CLAN_ACTIONS_MENU_FOR', member.user.username));
    var userIsMember = member.user.username == asUser;
    var userIsLeader = clan.leaderName == asUser;
    var canChangeRole = userIsLeader && allowControl && !member.isLeader;
    var isImpeachment = clan.findQuestion(QuestionType.LEADER_IMPEACHMENT);
    
    var r;
    for (var i = 0, len = ClanRole.VALUES.length; i < len; i++) 
    {
        var r = ClanRole.VALUES[i];
        
        
        var roleCheckBox = document.createElement('input');
        roleCheckBox.type = 'checkbox';
        roleCheckBox.setAttribute('role', r.name);
        roleCheckBox.checked = member.hasRole(r);
        roleCheckBox.disabled = !(canChangeRole && (!member.role || member.role.name == r.name) && (r.name != ClanRole.LEADER.name || !isImpeachment));
        COM.bindExclusiveClick(roleCheckBox, $.proxy(this.checkboxClicker, this));
        
        var roleContainer = document.createElement('div');
        roleContainer.appendChild(roleCheckBox);
        $(roleContainer).append(r.displayName);
        
        this.roles.appendChild(roleContainer);
    }
    
    var uiFlag = userIsMember && member.hasRole(ClanRole.TREASURER);
    UI.show(uiFlag, [this.enterClanReservation, this.enterClanWarehouse]);
    COM(this.enterClanReservation).enabled = allowControl && clan.hasReservation;
    COM(this.enterClanWarehouse).enabled = allowControl && clan.hasWarehouse;
    
    uiFlag = userIsMember && userIsLeader;
    UI.show(uiFlag, [this.destroyClan]);
    if (uiFlag)
    {
        if (clan.findQuestion(QuestionType.CLAN_DESTRUCTION)) 
        {
            COM(this.destroyClan).caption = I18.f('DESTROY_CLAN');
            COM(this.destroyClan).enabled = false;
            this.destroyClan.title = I18.f('CLAN_ERROR_DESTRUCTION_RUNNING');
        } 
        else if (clan.isInDestruction()) 
        {
            COM(this.destroyClan).caption = I18.f('UNDESTROY_CLAN');
            COM(this.destroyClan).enabled = allowControl;
            this.destroyClan.title = '';
        } 
        else 
        {
            COM(this.destroyClan).caption = I18.f('DESTROY_CLAN');
            COM(this.destroyClan).enabled = allowControl;
            this.destroyClan.title = '';
        }
    }
    
    uiFlag = userIsLeader && userIsMember;
    UI.show(uiFlag, [this.transformClan]);
    if (uiFlag)
    {
        if (!allowControl) 
        {
            COM(this.transformClan).enabled = false;
            this.transformClan.title = "";
        } 
        else if (clan.type == ClanType.MONARCHICAL && clan.members.length < FConfig.i.DEMOCRATIC_CLAN_MIN_MEMBERS) 
        {
            COM(this.transformClan).enabled = false;
            this.transformClan.title = I18.f('CLAN_TRANSFORM_MEMBERS_LIMIT', FConfig.DEMOCRATIC_CLAN_MIN_MEMBERS);
        } 
        else if (clan.type.name == ClanType.DEMOCRATIC.name && clan.findQuestion(QuestionType.TRANSFORM_TO_MONARCHIC_CLAN)) 
        {
            COM(this.transformClan).enabled = false;
            this.transformClan.title = "";
        } 
        else 
        {
            COM(this.transformClan).enabled = true;
            this.transformClan.title = "";
        }
    }
}

ClanActionsDialog.prototype.checkboxClicker = function(e)
{
    var c = e.target;
    r = ClanRole[c.getAttribute('role')];
    if (!r) return false;
    
    if (c.checked)
    {
    	this.onGiveRole(r, this.member);
    }
    else
    {
    	this.onTakeAwayRole(r, this.member);
    }
    
    this.close();
}
