function ClanCapacitorManagerDialog()
{
	callParentConstructor(ClanCapacitorManagerDialog.prototype, this);
	this.estateId = null; // EstateId
	this.manageData = null; // FClanCapacitorManageData
}

extendClass(ClanCapacitorManagerDialog.prototype, Dialog.prototype);

ClanCapacitorManagerDialog.prototype.__construct = function()
{
	superMethod(ClanCapacitorManagerDialog.prototype, '__construct', this)();
	
	this.headerRightBox.appendChild(COM(this.transferUI).distributeButton);
	COM(this.transferUI).onTransfer = $.proxy(this.onTransfer, this);
	COM(this.transferUI).onTransferToCastle = $.proxy(this.onTransferToCastle, this);
	COM(this.transferUI).onDistribute = $.proxy(this.onDistribute, this);
}

ClanCapacitorManagerDialog.prototype.estateId = null; // EstateId
ClanCapacitorManagerDialog.prototype.manageData = null; // FClanCapacitorManageData

ClanCapacitorManagerDialog.create = function(estateId, data)
{
    var d = COM.create('ClanCapacitorManagerDialog');
    d.estateId = estateId;
	d.update(data);
    d.popup();
    return d;
}

ClanCapacitorManagerDialog.prototype.update = function(data)
{
    this.manageData = data;
    COM(this.transferUI).update(data.building, data.clan, data.gateState);
    this.tick();
}

ClanCapacitorManagerDialog.prototype.tick = function()
{
	COM(this.transferUI).tick();
}

ClanCapacitorManagerDialog.prototype.onError = function(e)
{
    if ((e.__className__ == 'ClanException')) 
    {
        Alert.create(e.getMessage());
        return true;
    }
    return false;
}

ClanCapacitorManagerDialog.prototype.onSuccess = function(data)
{
    COM(COM(this.transferUI).resourceChooser).reset();
    this.update(data);
}

ClanCapacitorManagerDialog.prototype.onTransfer = function(username, funds)
{
    Service.alliance.callMethod('transferClanResourcesManager', [this.estateId, this.manageData.building.type, username, funds],
    	$.proxy(this.onSuccess, this), $.proxy(this.onError, this)
    );
}

ClanCapacitorManagerDialog.prototype.onTransferToCastle = function(xyz, funds)
{
    Service.alliance.callMethod('transferClanResourcesToCastleManager', [this.estateId, this.manageData.building.type, xyz, funds],
    	$.proxy(this.onSuccess, this), $.proxy(this.onError, this)
    );
}

ClanCapacitorManagerDialog.prototype.onDistribute = function(funds)
{
    Service.alliance.callMethod('distributeClanResourcesManager', [this.estateId, funds, this.manageData.building.type],
    	$.proxy(this.onSuccess, this), $.proxy(this.onError, this)
    );
}