function ClanDonateDialog()
{
	this.__defineGetter__('amount', function(){ return COM(this.donateAmount).value*1 || 0; });
	this.__defineGetter__('amountPearl', function(){ return COM(this.donateAmountPearl).value*1 || 0; });
}

extendClass(ClanDonateDialog.prototype, UpdatableEstateDialog.prototype);

ClanDonateDialog.create = function(estate, onResult)
{
    var d = COM.create('ClanDonateDialog');
    d.estate = estate;
    d.onResult = onResult;
    d.update(estate);
    return d;
}

ClanDonateDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.donateButton, $.proxy(this.onDonate, this));
	COM.bindExclusiveClick(this.cancelButton, $.proxy(this.close, this));
	$(this.donateAmount).on('change', $.proxy(this.tick, this));
	$(this.donateAmountPearl).on('change', $.proxy(this.tick, this));
}

ClanDonateDialog.prototype.onResult = function(info){};

ClanDonateDialog.prototype.update = function(estate)
{
    this.estate = estate;
    
    var clan = this.estate.owner.diplomacy.clan;
    if (!clan) 
    {
        this.close();
    }
    
   	this.setCaption(clan.canBeUpgraded() ? I18.f('DONATE') : I18.f('CLAN_MAX_LEVEL_REACHED'))
    this.setSubCaption(clan.canBeUpgraded() ? I18.f('LEVEL_X', clan.level + 2) : '');
    
    COM(this.currentDonation).value = Math.floor(clan.donation);
    COM(this.currentDonationPearl).value = Math.floor(clan.donationPearl);
    COM(this.nextDonation).value = Math.floor(clan.maxDonation);
    COM(this.nextDonationPearl).value = Math.floor(clan.nextLevelPearl);
    
    this.clanNextLevel.innerHTML = I18.f('CLAN_NEXT_LEVEL', clan.nextLevelCapacity - clan.capacity);
    
    this.tick();
}

ClanDonateDialog.prototype.tick = function()
{
    COM(this.donateAmount).max = NumberUtils.floor(this.estate.bank.gold);
    COM(this.donateAmount).disabled = COM(this.donateAmount).max <= 0;
    COM(this.donateAmountPearl).max = this.estate.owner.pearl;
    COM(this.donateAmountPearl).disabled = COM(this.donateAmountPearl).max <= 0;
    COM(this.myGold).value = NumberUtils.floor(this.estate.bank.gold);
    COM(this.myPearl).value = NumberUtils.floor(this.estate.owner.pearl);
    COM(this.donateButton).enabled = !Quarantine.contains('CLAN_DONATE_DIALOG.DONATE_BUTTON');
    COM(this.donateButton).reason = (this.amount > 0 || this.amountPearl > 0) ? null : I18.f('NEED_TO_FILL_DATA');
}

ClanDonateDialog.prototype.onDonate = function()
{
    if (!Quarantine.contains('CLAN_DONATE_DIALOG.DONATE_BUTTON')) 
    {
        Quarantine.put('CLAN_DONATE_DIALOG.DONATE_BUTTON');
        Service.alliance.callMethod('donateClan', [this.estate.id, this.amount, this.amountPearl],
        	$.proxy(this.onDonateResult, this), $.proxy(this.onDonateError, this)
        );
        this.close();
    }
}

ClanDonateDialog.prototype.onDonateResult = function(fd)
{
	//IScreenManager(FlexGlobals.topLevelApplication).updateCurrentScreen();
	var a = Alert.create(I18.f('DONATION_ACCEPTED'));
	a.onClose = $.proxy(function(){this.onResult(fd)}, this);
}

ClanDonateDialog.prototype.onDonateError = function(e)
{
    if ((e.__className__ == 'NotEnoughResourcesException') || (e.__className__ == 'ClanException')) 
    {
        Alert.create(e.getMessage());
        return true;
    }
    return false;
}
