function ClanInvitationRenderer()
{
	this._data = null;
	this.outerDocument = null;
	
	this.onResult = function(){};
	this.onError = function(){};
	
	this.__defineGetter__('invitation', function(){ 
		return this.data; 
	});
	this.__defineGetter__('data', function(){ 
		return this._data; 
	});
	this.__defineSetter__('data', this.setData);
}

ClanInvitationRenderer.prototype.__construct = function()
{
	$(this.acceptButton).on(CLICK_EVENT, $.proxy(function(){
		Service.alliance.callMethod('acceptClanInvitation', [this.invitation.clanName], this.onResult, this.onError);
	}, this));
	
	$(this.rejectButton).on(CLICK_EVENT, $.proxy(function(){
		Service.alliance.callMethod('rejectClanInvitation', [this.invitation.clanName], this.onResult, this.onError);
	}, this));

	$(this.sendMailButton).on(CLICK_EVENT, $.proxy(function(){
		MailBoxView.i().sendMessage(this.invitation.invitor.username);
	}, this));
}

ClanInvitationRenderer.prototype.setData = function(value)
{
    this._data = value;
    
    this.clanName.innerHTML = htmlEscape(this.invitation.clanName);
    this.invitorName.innerHTML = htmlEscape(this.invitation.invitor.username);
    
    var uiFlag = this.invitation && this.invitation.clanName != this.outerDocument.diplomacy.invitationQuestionClanName;
    if (UI.show(uiFlag, [this.actionGroup]))
    {
        if (UI.show(this.outerDocument.allowControl, [this.acceptButton, this.rejectButton]))
        {
        	if (this.outerDocument.diplomacy.invitationQuestionClanName)
        	{
        		COM(this.acceptButton).reason = I18.f('INVITATION_IS_VOTING', this.outerDocument.diplomacy.invitationQuestionClanName);
        	}
        }
    }
    
    var uiFlag = this.invitation && this.invitation.clanName == this.outerDocument.diplomacy.invitationQuestionClanName;
    if (UI.show(uiFlag, [this.timeView]))
    {
        COM(this.timeView).value = this.outerDocument.diplomacy.invitationQuestionTillTick;
    }
}
