function ClanMemberView()
{
	this.onResult = null;
	this.estate = null; //FEstate
	this.clan = null; //FClan
	this.dialog = null; // UpdatableEstateDialog
	this.scroll = null; // iScroll
}

ClanMemberView.prototype.estate = null; //FEstate
ClanMemberView.prototype.clan = null; //FClan
ClanMemberView.prototype.dialog = null; // UpdatableEstateDialog
ClanMemberView.prototype.scroll = null; // iScroll
ClanMemberView.prototype.onResult = null;

ClanMemberView.prototype.__construct = function(dialog)
{
	this.inviteButton = dialog.btnTabAction;
	COM.bindExclusiveClick(this.sendToClan, $.proxy(function(){
		MailBoxView.i().sendMessageToReceiverType(MailReceiverType.CLAN);
	}, this));
	
	COM.bindExclusiveClick(this.questionsButton, $.proxy(this.openQuestionsDialog, this));
	COM.bindExclusiveClick(this.donateButton, $.proxy(this.openDonationDialog, this));
	COM.bindExclusiveClick(this.clanSettings, $.proxy(this.openSettings, this));
	COM.bindExclusiveClick(this.leaveClan, $.proxy(this.onLeaveClan, this));
	
	this.sendToClan.style.width = '90px';
	this.questionsButton.style.width = '90px';
	this.donateButton.style.width = '90px';
	this.clanSettings.style.width = '90px';
	this.leaveClan.style.width = '90px';
}

ClanMemberView.prototype.update = function(e)
{
    Dialog.find(this).footer.appendChild(this.footerContent);
    Dialog.find(this).showFooter = true;
    
    this.estate = e;
    this.clan = e.owner.diplomacy.clan;
    this.clanPic.src = STATIC_INTERFACE_URL + this.clan.type.getPicture();
    this.clanPic.title = this.clan.type.toString();
    this.clanTypeName.innerHTML = this.clan.type.toString();
    this.clanName.innerHTML = htmlEscape(this.clan.clanName);
    this.clanLevel.innerHTML = "[" + (this.clan.level + 1) + "]";
    this.clanCapacity.innerHTML = this.clan.members.length + " / " + this.clan.capacity;
    UI.show(!this.clan.isRegistered || this.clan.isInDestruction(), [this.clanStatus]);
    var allowControl = e.accessManageble && !e.isEspionage;

	COM(this.membersList).onResult = this.onResult;
    COM(this.membersList).update(this.clan, e.owner.username, allowControl, this.estate.id, this.estate.isEspionage ? this.estate.responseTick : 0);

	COM(this.actionsMenu).onResult = this.onResult;
    COM(this.actionsMenu).update(this.clan, e.owner, allowControl, this.estate.id);
    
	UI.show(allowControl, [this.donateButton]);
    
	COM(this.donateButton).reason = this.clan.canBeUpgraded() ? null : I18.f('CLAN_MAX_LEVEL_REACHED');

    var uiFlag = this.clan.canSendInvitation(this.estate.owner.username) && allowControl;
    UI.show(uiFlag, [this.inviteButton]);
    if (uiFlag)
    {
        var haveCapacity = this.clan.members.length + this.clan.invitees.length < this.clan.capacity;
       	COM(this.inviteButton).reason = haveCapacity ? null : I18.f('CLAN_INVITATIONS_LIMIT_REACHED');
       	COM(this.inviteButton).caption = I18.f('INVITE');
    }
    
    uiFlag = allowControl && this.clan.type.name == ClanType.DEMOCRATIC.name;
    UI.show(uiFlag, [this.questionsButton]);
    
    UI.show(allowControl, [this.sendToClan, this.clanSettings]);
    UI.show(allowControl && !this.clan.getMember(FUser.CURRENT_USER.username).isLeaving, [this.leaveClan]);
    
    if (this.dialog) 
    {
        this.dialog.update(e);
    }
    
    this.tick();
}

ClanMemberView.prototype.tick = function()
{
    if (!this.clan) return;
    
    if (this.clan.isInDestruction()) 
    {
        this.clanStatus.innerHTML = I18.f('TILL_CLAN_DESTRUCTION', Tick.toTimeLeft(this.clan.destructionTick - Tick.now()));
    } 
    else if (!this.clan.isRegistered) 
    {
        this.clanStatus.innerHTML = I18.f('CLAN_IS_REGISTERING');
    } 
    else 
    {
        this.clanStatus.innerHTML = "";
    }
    
    if (this.dialog) 
    {
        this.dialog.tick();
    }
    
    COM(this.membersList).tick();
    COM(this.actionsMenu).tick();
    COM(this.questionsButton).skin = this.questionsButton.style.display != 'none' && FUser.CURRENT_USER.hasNewClanQuestions() 
    	? 'green' 
    	: 'yellow'
    ;
}

ClanMemberView.prototype.onSendInvitation = function()
{
    var invDialog = COM.create('SendInvitationDialog');
    invDialog.onResult = this.onResult;
    invDialog.textRequired = (this.clan.type.name == ClanType.DEMOCRATIC.name);
    invDialog.init();
    invDialog.popup(this);
}

ClanMemberView.prototype.openSettings = function()
{
    var d = this.estate.owner.diplomacy;
    ClanSettingsDialog.create(this, d.accessEstatesForClan, d.accessMissionsForClan, this.onResult);
}

ClanMemberView.prototype.onLeaveClan = function()
{
    Alert.create(I18.f('LEAVE_CLAN_CONFIRM'), '', 
    	$.proxy(function(){
        	Service.alliance.callMethod('leaveClan', [], this.onResult);
    	}, this)
    );
}

ClanMemberView.prototype.onCloseDialog = function()
{
    this.dialog = null;
}

ClanMemberView.prototype.openDonationDialog = function()
{
    this.dialog = ClanDonateDialog.create(this.estate, this.onResult);
    this.dialog.onClose = $.proxy(this.onCloseDialog, this);
    this.dialog.popup(this);
}

ClanMemberView.prototype.openQuestionsDialog = function()
{
    this.dialog = QuestionsDialog.create(this.estate, this.onResult);
    this.dialog.onClose = $.proxy(this.onCloseDialog, this);
}
