function ClanMembersList()
{
	callParentConstructor(this);
	this.__defineGetter__('selected', function()
	{
	    var selRenderer = null//membersList.selected as ClanMemberRenderer;
	    if (selRenderer) 
	    {
	        return selRenderer.data;
	    } 
        return null;
	});
	
	this.clan = null;
	this.asUser = null;
	this.allowControl = null;
	this.estateId = null;
	this.espionageTick = null;
	this.onResult = null;
}

ClanMembersList.prototype.clan = null;
ClanMembersList.prototype.asUser = null;
ClanMembersList.prototype.allowControl = null;
ClanMembersList.prototype.estateId = null;
ClanMembersList.prototype.espionageTick = null;

extendClass(ClanMembersList.prototype, ScrollableList.prototype);

ClanMembersList.prototype.__construct = function()
{
	superMethod(this, '__construct')();
	this.setHeader([I18.f('INVITEE_NAME'), I18.f('CAPITAL'), I18.f('RATING'), I18.f('TITLE')]);
}

ClanMembersList.sortMembers = function(users)
{
	return users;
}

ClanMembersList.prototype.onResult = null;

ClanMembersList.prototype.update = function(clan, asUser, allowControl, estateId, espionageTick)
{
    this.clan = clan;
    this.asUser = asUser;
    this.allowControl = allowControl;
    this.estateId = estateId;
    this.espionageTick = espionageTick;
    
    var data = ClanMembersList.sortMembers(clan.allUsers);
    this.dataProvider = clan.allUsers;
    for (var i = 0, len = clan.allUsers.length; i < len; i++)
    {
    	if (clan.allUsers[i].user.username == this.asUser)
    	{
    		this.selectedIndex = i;
    		break;
    	}
    }
}

ClanMembersList.prototype.tick = function()
{
    for (var i = 0, len = this.items.length; i < len; i++)
    {
    	COM(this.items[i]).tick();
    }
}

ClanMembersList.prototype.createRenderer = function(data)
{
	var renderer = COM.create('ClanMembersListItem');
	
	renderer.data = data;
    
    renderer.allowControl = this.allowControl;
    renderer.onResult = this.onResult;
    renderer.asUser = this.asUser;
    renderer.estateId = this.estateId;
    renderer.clan = this.clan;
    renderer.espionageTick = this.espionageTick;
    
    renderer.refresh();
    
    $(renderer.DOM).css({'cursor': this.allowControl ? 'pointer' : 'default'});
    if (this.allowControl) COM.bindExclusiveClick(renderer.DOM, $.proxy(this.showMemberInfo, this));
    
    return renderer;
}

ClanMembersList.prototype.clanMemberDialog = null;
ClanMembersList.prototype.showMemberInfo = function(e)
{
	if (this.scroll && !this.scroll.isReady()) return false;
	
	var renderer = COM(e.currentTarget);
	
	if (this.clanMemberDialog) this.clanMemberDialog.close();
	
	this.clanMemberDialog = COM.create('ClanMemberDialog');
    
    this.clanMemberDialog.allowControl = renderer.allowControl;
    this.clanMemberDialog.onResult = this.onResult;
    this.clanMemberDialog.asUser = renderer.asUser;
    this.clanMemberDialog.estateId = renderer.estateId;
    this.clanMemberDialog.clan = renderer.clan;
    this.clanMemberDialog.espionageTick = renderer.espionageTick;
    
    this.clanMemberDialog.data = renderer.data;
	
	this.clanMemberDialog.popup(this);
	this.clanMemberDialog.onClose = $.proxy(function(){ this.clanMemberDialog = null; }, this);
}

