function ClanMembersListItem()
{
	callParentConstructor(this);
	
	this.__defineGetter__('member', this.getMember);
	this.__defineSetter__('member', this.setMember);
	
	this.onResult = null; //Function
	this.allowControl = false; //Boolean
	this.espionageTick = 0; //Number
	this.asUser = ''; //String
	this.estateId = null; //EstateId
	this.clan = null; //FClan
	this.dialog = null; //ClanCapacitorManagerDialog
}

extendClass(ClanMembersListItem.prototype, ScrollableListItem.prototype);

ClanMembersListItem.prototype.onResult = null; //Function
ClanMembersListItem.prototype.allowControl = false; //Boolean
ClanMembersListItem.prototype.espionageTick = 0; //Number
ClanMembersListItem.prototype.asUser = ''; //String
ClanMembersListItem.prototype.estateId = null; //EstateId
ClanMembersListItem.prototype.clan = null; //FClan
ClanMembersListItem.prototype.dialog = null; //ClanCapacitorManagerDialog

ClanMembersListItem.prototype.__construct = function()
{
}

ClanMembersListItem.prototype.getMember = function()
{
    return this._data;
}
ClanMembersListItem.prototype.setMember = function(val)
{
    this.data = val;
}

ClanMembersListItem.prototype.onError = function(e)
{
    if ((e.__className__ == 'ClanException')) 
    {
        Alert.create(e.getMessage());
        return true;
    }
    return false;
}

ClanMembersListItem.prototype.refresh = function()
{
    if (!this.data) 
    {
        return;
    }
    
    this.memberName.innerHTML = this.member.user.username;
    
    UI.show(this.member.role, [this.memberIcon, this.memberRoleName]);
    if (this.member.role) 
    {
    	this.memberIcon.src = STATIC_INTERFACE_URL + CommonAssets.getClanRoleIcon(this.member.role);
    	this.memberIcon.title = this.member.role.toString();
    	this.memberRoleName.innerHTML = this.member.role.toString();
		if (UI.show(this.member.user.nextElectionTick > 0, [this.nextLeaderElection]))
		{
			this.nextLeaderElection.innerHTML = I18.f('NEXT_LEADER_ELECTION', DateUtils.formatSmart(Tick.toMs(this.member.user.nextElectionTick)));
		}    	
    }
    UI.show(false, [this.memberRoleName]);
        
    this.memberCapitalName.innerHTML = I18.fixName(this.member.user.capitalName);
    this.memberCapitalXYZ.innerHTML = this.member.user.capitalLocation.toString();
    
    this.disabled = !this.member.hasAccepted;
    
    COM(this.starsView).titleIndex = this.member.user.titleIndex;
}

ClanMembersListItem.prototype.tick = function()
{
    if (!this.member) return;
    
    var canExpel = this.allowControl 
    	&& !this.member.isLeader 
    	&& this.member.user.username != this.asUser
		&& (this.member.hasAccepted ? this.clan.canExpel(this.asUser, this.member) : this.clan.canTakeAwayInvitation(this.asUser, this.member))
	;
    
    uiFlag = this.member.isLeaving;
    UI.show(uiFlag, [this.tillLeave]);
    if (uiFlag)
    {
        COM(this.tillLeave).value = this.espionageTick > 0 
        	? this.member.leaveClanTick - this.espionageTick 
        	: Tick.ticksTill(this.member.leaveClanTick)
        ;
        this.tillLeave.title = I18.f('WILL_LEAVE_CLAN_IN', Tick.toTimeFuture(this.member.leaveClanTick));
    }
    
    if (this.dialog) 
    {
        this.dialog.tick();
    }
}

ClanMembersListItem.prototype.onTooltip = function(e)
{
    //e.toolTip = EstateStarsClanView.createAsTip(data.user, null, false, false, true)
}

