function ClanSettingsDialog()
{
	callParentConstructor(this);
}

extendClass(ClanSettingsDialog.prototype, Dialog.prototype);

ClanSettingsDialog.prototype.__construct = function()
{
	this.setCaption(I18.f('CLAN_SETTINGS'));
	
	COM.bindExclusiveClick(this.okButton, $.proxy(this.onEdit, this));
	$(this.allowAccessEstatesBox).on('change', $.proxy(this.accessEstatesChanged, this));
	$(this.allowAccessMissionsBox).on('change', $.proxy(this.accessEstatesChanged, this));
}

ClanSettingsDialog.prototype.onResult = function(info){};

ClanSettingsDialog.create = function(parent, allowAccessEstates, allowAccessMission, onResult)
{
    var d = COM.create('ClanSettingsDialog');
    
    d.onResult = onResult;
    COM(d.allowAccessEstatesBox).checked = Boolean(allowAccessEstates);
    COM(d.allowAccessMissionsBox).checked = Boolean(allowAccessMission);
    d.accessEstatesChanged();
    
    d.popup(parent);
    
    return d;
}

ClanSettingsDialog.prototype.onEdit = function()
{
    Service.alliance.callMethod(
    	'editClanSettings', 
    	[COM(this.allowAccessEstatesBox).checked, COM(this.allowAccessMissionsBox).checked], 
    	$.proxy(this.onEditComplete, this)
    );
}

ClanSettingsDialog.prototype.onEditComplete = function(d)
{
    this.onResult(d);
    this.close();
}

ClanSettingsDialog.prototype.accessEstatesChanged = function()
{
    if (COM(this.allowAccessEstatesBox).checked) 
    {
        COM(this.allowAccessMissionsBox).disabled = false;
    } 
    else 
    {
        COM(this.allowAccessMissionsBox).disabled = true;
        COM(this.allowAccessMissionsBox).checked = false;
    }
}
