function ClanWarRenderer()
{
	this.__defineGetter__('building', function() { return this.parent.building; });
	this.__defineGetter__('estate', function() { return this.parent.estate; });
	this.__defineGetter__('diplomacy', function() { return this.estate.owner.diplomacy.clan.diplomacy; });
	
	this.parent = null;
	this.declaration = null;
}

ClanWarRenderer.prototype.parent = null;
ClanWarRenderer.prototype.declaration = null;

ClanWarRenderer.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.cancelButton, $.proxy(this.onCancel, this));
	COM.bindExclusiveClick(this.sendMail, $.proxy(this.onSendMail, this));
	COM(this.timer).handler = $.proxy(this.onTimeout, this);
}

ClanWarRenderer.prototype.update = function(declaration, parent)
{
	this.parent = parent;
	this.declaration = declaration;
	
	this.status.src = STATIC_INTERFACE_URL + (this.declaration.startTick > Tick.now() 
		? CommonAssets.DECLARE_WAR_ICON 
		: CommonAssets.START_WAR_ICON
	);
    $(this.status).toggleClass('incoming', this.declaration.state.name == ClanDeclarationState.INCOMING.name);
    
    this.clanName.innerHTML = htmlEscape(this.declaration.clan.name);
    
    UI.show(this.declaration.startTick > Tick.now(), [this.timerBox]);
	$(this.DOM).toggleClass('timer', this.declaration.startTick > Tick.now());

    var allowAccess = this.estate.accessClanDiplomacy && this.building.isWorking;
    UI.show(allowAccess && this.declaration.state.name != ClanDeclarationState.INCOMING.name, [this.cancelButton]);
    UI.show(allowAccess, [this.sendMail]);
    
    this.tick();
}

ClanWarRenderer.prototype.tick = function()
{
	if (this.declaration.startTick > Tick.now())
	{
	    COM(this.timer).value = this.declaration.startTick;
	}
}

ClanWarRenderer.prototype.onTimeout = function()
{
    if (!this.estate.isEspionage && this.building.isWorking) 
    {
        Service.alliance.callMethod('getClanDiplomacy', [], this.parent.updateData);
    }
}

ClanWarRenderer.prototype.onCancel = function()
{
    var self = this;
    Alert.create(I18.f('CONFIRM_CANCEL_WAR'), '', function()
    {
        Service.alliance.callMethod('cancelWar', [self.declaration.clan.name], self.parent.updateData, ClanException.errorHandler);
    });
}

ClanWarRenderer.prototype.onSendMail = function()
{
    MailBoxView.i().sendMessage(this.declaration.clan.name, "", null, "", MailReceiverType.CLAN_WARMINISTER);
}

