function ClansTab(dialog)
{
	this._view = null;
	this._dialog = dialog;
	this.__defineGetter__('view', function()
	{
		if (!this.diplomacy) return null;
		return this._view;
	});
}

extendClass(ClansTab.prototype, DiplomatTabParent.prototype);

ClansTab.prototype.__construct = function(dialog)
{
	this.onActionClick = $.proxy(this.onTabAction, this);
}

ClansTab.prototype.tick = function()
{
    if (this.view)
    {
    	this.view.tick();
    }
}

ClansTab.prototype.refreshView = function(e)
{
	var needChange = !this.view || !this.diplomacy;
	if (!needChange) needChange = this.diplomacy.clan && !(this.view instanceof ClanMemberView);
	if (!needChange) needChange = !this.diplomacy.clan && (this.view instanceof ClanMemberView);
	if (needChange)
	{
		if (this._view)
		{
			this._view.destroy();
			this._view = null;
		}
		
		var cls = this.diplomacy.clan ? 'ClanMemberView' : 'NoClanView';
		this._view = COM.create(cls, null, this._dialog);
		this._view.onResult = $.proxy(this.handleResult, this);
		
		$(this.DOM).append(this._view.DOM);
		
		this.refreshTabAction();
	}
	if (this.view) this.view.update(e);
}

ClansTab.prototype.refreshTabAction = function()
{
	if (UI.show(this.view && this.diplomacy, [this._dialog.btnTabAction]))
	{
		COM(this._dialog.btnTabAction).caption = I18.f(this.diplomacy.clan ? 'INVITE' : 'CREATE_CLAN');
		if (!this.diplomacy.clan)
		{
			if (!this.estate.owner.canHaveClans()) 
			{
				COM(this._dialog.btnTabAction).reason = I18.f('NO_CLANS_SCIENCE');
			}			
		}
	}
	
}

ClansTab.prototype.onTabAction = function()
{
	if (!this.view || !this.diplomacy) return false;
	return this.diplomacy.clan ? this._view.onSendInvitation() : this._view.onCreateClan();
}

ClansTab.prototype.update = function(e)
{
    superMethod(this, 'update')(e);
    this.refreshView(e);
	FUser.CURRENT_USER.settings.clanQuestionsLastClickTick.int52 = Tick.now();
}
