function CreateClanDialog()
{
	callParentConstructor(CreateClanDialog.prototype, this);
	this.estate = null; // FEstate
}

extendClass(CreateClanDialog.prototype, Dialog.prototype);

CreateClanDialog.create = function(estate)
{
	var d = COM.create('CreateClanDialog');
	d.estate = estate;
	if (!d.canCreate)
	{
    	var err = document.createElement('div'), 
    		gold = IconAndValue.create(STATIC_INTERFACE_URL + CommonAssets.ICON_GOLD, this.estate.bank.gold);
    		gold2 = IconAndValue.create(STATIC_INTERFACE_URL + CommonAssets.ICON_GOLD, FConfig.CLAN_COST_GOLD);
    		pearl = IconAndValue.create(STATIC_INTERFACE_URL + CommonAssets.ICON_PEARL, this.estate.owner.pearl);
    		pearl2 = IconAndValue.create(STATIC_INTERFACE_URL + CommonAssets.ICON_PEARL, FConfig.CLAN_COST_PEARL);
    	;
    	
    	Style[this.estate.bank.gold >= FConfig.CLAN_COST_GOLD ? 'POSITIVE_BONUS' : 'NEGATIVE_BONUS'].applyTo(gold);
    	Style[this.estate.owner.pearl >= FConfig.CLAN_COST_PEARL ? 'POSITIVE_BONUS' : 'NEGATIVE_BONUS'].applyTo(pearl);
    	
    	$(err).append('<div class="text-big">' + I18.f('NOT_ENOUGH_RESOURCES') + '</div>')
    		.append(I18.f('REQUIRES')).append(gold2.DOM).append(pearl2.DOM)
    		.append(I18.f('RES_AVAILABLE')).append(gold.DOM).append(pearl.DOM)
    	;
		COM(d.createButton).reason = [err.outerHTML];
	}
	d.popup();
	return d;
}

CreateClanDialog.prototype.__construct = function()
{
	superMethod(CreateClanDialog.prototype, '__construct', this)();
	
	UI.show(FConfig.CLAN_COST_GOLD != 0 || FConfig.CLAN_COST_PEARL != 0, [this.priceBox]);
	COM.bindExclusiveClick(this.createButton, $.proxy(this.onCreateClan, this));
}

CreateClanDialog.prototype.estate = null; // FEstate

CreateClanDialog.prototype.onResult = function(info){};

CreateClanDialog.prototype.handleSuccess = function(info) // FDiplomacy
{
	this.close();
	Alert.create(I18.f('CLAN_CREATED_SUCCESSFULY'));
	Events.onShowCity.fire(this.estate.id);
	this.onResult(info);
}

CreateClanDialog.prototype.handleFail = function(e)
{
	if (e.__className__ == 'ClanException') 
	{
	    $(this.warningText).html(e.getMessage());
	    return true;
	}
	return false;
}

CreateClanDialog.prototype.onCreateClan = function()
{
	Service.alliance.callMethod('createClan', 
		[COM(this.clanName).value], 
		$.proxy(this.handleSuccess, this), $.proxy(this.handleFail, this)
	);
}

CreateClanDialog.prototype.canCreate = function()
{
	return this.estate.bank.gold >= FConfig.CLAN_COST_GOLD && this.estate.owner.pearl >= FConfig.CLAN_COST_PEARL;
}
