function NoClanView(dialog)
{
	this.createClanDialog = null;
	this.estate = null;
	this.diplomacy = null;
	this.allowControl = false;
}

NoClanView.prototype.__construct = function(dialog)
{
	this.createClanButton = dialog.btnTabAction;
	this.onAccept = $.proxy(this.onAccept, this);
	this.onReject = $.proxy(this.onReject, this);
}

NoClanView.prototype.createClanDialog = null;
NoClanView.prototype.estate = null;
NoClanView.prototype.diplomacy = null;
NoClanView.prototype.allowControl = false;

NoClanView.prototype.onResult = function(info)
{
}

NoClanView.prototype.update = function(e)
{
    this.allowControl = e.accessManageble && !e.isEspionage;
    this.estate = e;
    this.diplomacy = e.owner.diplomacy;
    
    var hasInvitations = this.diplomacy.clanInvitations.length > 0;
    UI.show(!hasInvitations, [this.noInvitationsWarning]);
    this.updateInvitations(this.diplomacy.clanInvitations);
    
    UI.show(this.allowControl, [this.createClanButton]);
    if (this.allowControl)
    {
	    var canCreate = !this.diplomacy.invitationQuestionClanName;
	    COM(this.createClanButton).enabled = canCreate;
	    this.createClanButton.title = canCreate || !e.accessManageble 
	    	? '' 
	    	: I18.f('INVITATION_IS_VOTING', this.diplomacy.invitationQuestionClanName)
	    ;
    }
    
}

NoClanView.prototype.updateInvitations = function(data)
{
	while (this.invitations.children.length)
	{
		COM(this.invitations.children.item(0)).destroy();
	}
	this.invitations.innerHTML = '';
	if (data) for (var i = 0, len = data.length; i < len; i++)
	{
		var item = COM.create('ClanInvitationRenderer');
		item.outerDocument = this;
		item.onResult = $.proxy(this.onResult, this);
		item.onError = $.proxy(this.onError, this);
		item.data = data[i];
		$(this.invitations).append(item.DOM);
	}
	this.refresh(300);
}

NoClanView.prototype.refresh = function(t)
{
	if (t) return setTimeout($.proxy(this.refresh, this), t);
	this.invitations.style.webkitTransform = "translate3d(0px, 0px, 0px)";
}

NoClanView.prototype.tick = function()
{
}

NoClanView.prototype.onCreateClan = function()
{
    this.createClanDialog = CreateClanDialog.create(this.estate);
    this.createClanDialog.onResult = $.proxy(this.onResult, this);
}

NoClanView.prototype.onAccept = function(clanName)
{
    Service.alliance.callMethod('acceptClanInvitation', [clanName], $.proxy(this.onResult, this), $.proxy(this.onError, this));
}

NoClanView.prototype.onReject = function(clanName)
{
    Service.alliance.callMethod('rejectClanInvitation', [clanName], $.proxy(this.onResult, this), $.proxy(this.onError, this));
}

NoClanView.prototype.onError = function(e)
{
    if ((e.__className__ == 'ClanException')) 
    {
        Alert.create(e.getMessage());
        return true;
    }
    return false;
}

NoClanView.prototype.onExpired = function()
{
    if (this.estate.accessManageble) 
    {
    	Service.alliance.callMethod('getDiplomacy', [this.estate.owner.username], $.proxy(this.onResult, this));
    }
}
