function SelectClanDialog()
{
	callParentConstructor(SelectClanDialog.prototype, this);
	this.handle = null;
}

extendClass(SelectClanDialog.prototype, Dialog.prototype);

SelectClanDialog.prototype.handle = null;

SelectClanDialog.create = function(text, buttonText, handle)
{
    var dialog = COM.create('SelectClanDialog');
    
    dialog.setCaption(text);
    COM(dialog.button).caption = buttonText || I18.f('OK');
    dialog.handle = handle || function(){};
    
    dialog.popup();
    
    return dialog;
}

SelectClanDialog.prototype.__construct = function()
{
	superMethod(SelectClanDialog.prototype, '__construct', this)();
	COM.bindExclusiveClick(this.search, $.proxy(this.onFindClanClick, this));
	COM.bindExclusiveClick(this.button, $.proxy(this.onClick, this));
}

SelectClanDialog.prototype.onClick = function()
{
    var name = COM(this.clanInput).value;
    if (!name) return false;
    
    this.handle(name);
    this.close();
}

SelectClanDialog.prototype.onFindClanClick = function()
{
    var name = COM(this.memberInput).value;
    if (!name) return false;
    
    Service.alliance.callMethod('getClanOfMember', [name],
    	$.proxy(this.onFindClan, this),
    	$.proxy(this.onFindClanError, this)
    );
}

SelectClanDialog.prototype.onFindClan = function(clan)
{
	COM(this.clanInput).value = clan;
}

SelectClanDialog.prototype.onFindClanError = function(e)
{
	Alert.create(e.getMessage());
	return true;
}
