function SendInvitationDialog()
{
	callParentConstructor(this);
	
	this.__defineGetter__('invitee', function(){return COM(this.inviteeName).value || ''; });
	this.__defineSetter__('invitee', function(val){return COM(this.inviteeName).value = val; });
	
	this.textRequired = false; // Boolean
}

extendClass(SendInvitationDialog.prototype, Dialog.prototype);

SendInvitationDialog.prototype.textRequired = false; // Boolean

SendInvitationDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.inviteButton, $.proxy(this.onInvite, this));
	$(this.inviteeName).on('keyup', $.proxy(this.onChange, this));
	$(this.customTextArea).on('keyup', $.proxy(this.onChange, this));
}

SendInvitationDialog.prototype.onResult = function(info)
{
}

SendInvitationDialog.prototype.init = function()
{
	UI.show(this.textRequired, [this.customTextGroup]);
	this.onChange();
}

SendInvitationDialog.prototype.handleSuccess = function(info)
{
	Alert.create(I18.f('USER_INVITED_SUCCESSFULY', this.invitee));
	this.onResult(info);
	this.close();
}

SendInvitationDialog.prototype.handleError = function(e)
{
	if ((e.__className__ == 'AvatarNotFoundException') || (e.__className__ == 'ClanException') || (e.__className__ == 'MentorshipException')) 
	{
	    this.warningText.innerHTML = e.getMessage();
	    return true;
	} 
	return false;
}

SendInvitationDialog.prototype.onChange = function()
{
	var ok = this.invitee && (!this.textRequired || !Strings.isEmpty(this.customTextArea.value));
	COM(this.inviteButton).reason = ok ? null : I18.f('NEED_TO_FILL_DATA'); 
}

SendInvitationDialog.prototype.onInvite = function()
{
	console.log('sendClanInvitation', this.invitee, this.textRequired ? this.customTextArea.value : null);
	Service.alliance.callMethod('sendClanInvitation', [this.invitee, this.textRequired ? this.customTextArea.value : null],
		$.proxy(this.handleSuccess, this), $.proxy(this.handleError, this)
	);
}
