function ClanMessageConfirmDialog()
{
	callParentConstructor(this);
}

extendClass(ClanMessageConfirmDialog.prototype, Dialog.prototype);

ClanMessageConfirmDialog.prototype.__construct = function()
{
	this.setCaption(I18.f('CLAN_MESSAGE'));
	
	$(this.customTextArea).on('change keyup blur focus', $.proxy(this.onChange, this));
	
	COM.bindExclusiveClick(this.yesButton, $.proxy(this.onYesClick, this));
	COM(this.yesButton).reason = I18.f('NEED_TO_FILL_DATA');
	
	COM.bindExclusiveClick(this.noButton, $.proxy(this.close, this));
	
}

ClanMessageConfirmDialog.prototype.onResult = function(customText){
};

ClanMessageConfirmDialog.create = function(confirmation, onResult)
{
    var dialog = COM.create('ClanMessageConfirmDialog');
    dialog.onResult = onResult;
    dialog.confirmationLabel.innerHTML = confirmation;
    dialog.popup();
    return dialog;
}

ClanMessageConfirmDialog.prototype.onChange = function()
{
    COM(this.yesButton).reason = Strings.isEmpty(this.customTextArea.value) ? I18.f('NEED_TO_FILL_DATA') : null;
}

ClanMessageConfirmDialog.prototype.onYesClick = function()
{
    this.onResult(this.customTextArea.value);
    this.close();
}
