function ClanQuestionDialog()
{
	this.estate = null;
	this.question = null;
	this.onResult = null; // Function
	this.votesRenderer = null; // QuestionVotesRenderer
}

extendClass(ClanQuestionDialog.prototype, Dialog.prototype);

ClanQuestionDialog.prototype.estate = null;
ClanQuestionDialog.prototype.question = null;
ClanQuestionDialog.prototype.onResult = null; // Function
ClanQuestionDialog.prototype.votesRenderer = null; // QuestionVotesRenderer

ClanQuestionDialog.create = function(estate, question, onResult)
{
	var d = COM.create('ClanQuestionDialog');
	d.onResult = onResult;
	d.question = question;
	d.update(estate, question);
	d.popup();
	return d;
}

ClanQuestionDialog.prototype.__construct = function()
{
	superMethod(ClanQuestionDialog.prototype, '__construct', this)();
	
	COM.bindExclusiveClick(this.sendMail, $.proxy(this.onSendMail, this));
	COM(this.timeView).handler = $.proxy(this.onExpired, this);
}

ClanQuestionDialog.prototype.update = function(estate)
{
	this.estate = estate;

    if (!this.votesRenderer)
    {
	    this.votesRenderer = this.createRenderer(this.question.displayType);
	    this.votesRenderer.init(this.question);
	    this.votesRenderer.onVote = $.proxy(this.onVote, this);
	    this.votesGroup.appendChild(this.votesRenderer.DOM);
    }
	this.votesRenderer.update(this.question);
    
    COM(this.timeView).value = this.question.tillTick;
    this.subjectText.innerHTML = this.question.getSubject();
    this.bodyText.innerHTML = this.question.getBody();
    
    if (UI.show(this.question.owner, [this.ownerGroup]))
    {
    	this.ownerText.innerHTML = this.question.owner.user.username;
    }
    
	this.tick();
}

ClanQuestionDialog.prototype.tick = function()
{
	if (!this.estate || !this.question) return;
}

ClanQuestionDialog.prototype.createRenderer = function(type)
{
    if (type.name == DisplayType.RADIO_BUTTONS.name)
    {
        return COM.create('RadioVotesRenderer');
    } 
    else if (type.name == DisplayType.COMBOBOX.name) 
    {
        return COM.create('ComboboxVotesRenderer');
    } 
    else if (type.name == DisplayType.BUTTONS.name) 
    {
        return COM.create('ButtonsVotesRenderer');
    } 
    else 
    {
        console.error("Invalid votes renderer:", type);
    }
}

ClanQuestionDialog.prototype.onOwnerTooltip = function(e)
{
    //e.toolTip = EstateStarsClanView.createAsTip(question.owner.user, null, false, false, true)
}

ClanQuestionDialog.prototype.onSendMail = function()
{
    MailBoxView.i().sendMessage(this.question.owner.user.username);
}

ClanQuestionDialog.prototype.handleResult = function(diplomacy)
{
	this.onResult(diplomacy);
	this.close();
}

ClanQuestionDialog.prototype.onVote = function(option)
{
    Service.alliance.callMethod('voteQuestion', [this.question.id, option*1], $.proxy(this.handleResult, this), ClanException.errorHandler);
}

ClanQuestionDialog.prototype.onExpired = function()
{
    Service.alliance.callMethod('getDiplomacy', [this.estate.owner.username], $.proxy(this.handleResult, this));
}
