function ComboboxVotesRenderer()
{
	callParentConstructor(ComboboxVotesRenderer.prototype, this);
}

extendClass(ComboboxVotesRenderer.prototype, QuestionVotesRenderer.prototype);

ComboboxVotesRenderer.prototype.__construct = function()
{
	$(this.combobox).on('change', $.proxy(this.onChange, this));
	COM.bindExclusiveClick(this.voteButton, $.proxy(function(){
		this.onVote(COM(this.combobox).selectedIndex);
	}, this));
}

ComboboxVotesRenderer.prototype.question = null; // FQuestion

ComboboxVotesRenderer.prototype.init = function(question)
{
    var options = question.options.map(function(val){
    	return {
    		value: val, 
    		label: (I18.strings[val] === undefined ? val : I18.f(val))
    	};
    });
    COM(this.combobox).dataProvider = options;
    COM(this.combobox).selectedIndex = question.vote;
    
    this.update(question);
}

ComboboxVotesRenderer.prototype.update = function(question)
{
    this.question = question;
    COM(this.combobox).disabled = !this.question.notVoted();
    this.onChange();
}

ComboboxVotesRenderer.prototype.onChange = function()
{
    var option = COM(this.combobox).selectedIndex;
    
    if (!this.question.notVoted() || option < 0) 
    {
        UI.show(false, [this.voteButton]);
        UI.show(false, [this.errorLabel]);
    } 
    else if (this.question.invalidOptions.indexOf(this.question.options[option]) >= 0) 
    {
        UI.show(false, [this.voteButton]);
        UI.show(true, [this.errorLabel]);
    } 
    else 
    {
        UI.show(true, [this.voteButton]);
        UI.show(false, [this.errorLabel]);
    }
}