function CreateQuestionDialog()
{
	callParentConstructor(CreateQuestionDialog.prototype, this);
	
	this.__defineGetter__('options', this.getOptions);
	this.scroll = null;
}

extendClass(CreateQuestionDialog.prototype, Dialog.prototype);

CreateQuestionDialog.prototype.__construct = function()
{
	superMethod(this, '__construct')();
	
	$(this.subject).on('keyup', $.proxy(this.validate, this));
	$(this.body).on('keyup', $.proxy(this.validate, this));
	
	COM.bindExclusiveClick(this.addOptionButton, $.proxy(this.onAddOption, this));
	
	COM.bindExclusiveClick(this.createButton, $.proxy(this.onCreate, this));
	
	this.scroll = new iScroll(this.optionsScroll, {hScroll: false});
	
	this.fullScreen();
}

CreateQuestionDialog.prototype.onResult = null; // Function

CreateQuestionDialog.create = function(estate, onResult)
{
    var dialog = COM.create('CreateQuestionDialog');
    dialog.onResult = onResult;
	dialog.onAddOption();
	dialog.onAddOption();
	dialog.update(estate);
    dialog.popup();
    return dialog;
}

CreateQuestionDialog.prototype.refreshScroll = function(t)
{
    if (t) return setTimeout($.proxy(this.refreshScroll, this), t*1);
    if (this.scroll) this.scroll.refresh();
}

CreateQuestionDialog.prototype.update = function(estate)
{
    this.estate = estate;
    this.validate();
}

CreateQuestionDialog.prototype.tick = function()
{
}

CreateQuestionDialog.prototype.onAddOption = function()
{
    var option = COM.create('QuestionOption');
    option.onChange = $.proxy(this.validate, this);
    option.onRemove = $.proxy(this.onRemoveOption, this);
    this.optionsBox.appendChild(option.DOM);
    this.onOptionsChanged();
}

CreateQuestionDialog.prototype.onRemoveOption = function(option)
{
    if (this.optionsBox.children.length <= 2) return false;
    COM(option).destroy();
    this.onOptionsChanged();
}

CreateQuestionDialog.prototype.onOptionsChanged = function()
{
    this.validate();
    UI.show(this.optionsBox.children.length < FConfig.QUESTION_OPTIONS_MAX_COUNT, [this.addOptionButton]);
    this.refreshScroll(300);
}

CreateQuestionDialog.prototype.validate = function()
{
    var valid = true;
    valid = valid && !Strings.isEmpty(COM(this.subject).value);
    valid = valid && !Strings.isEmpty(this.body.value);
    valid = valid && (this.optionsBox.children.length >= 2);
    var values = [];
    for (var i = 0, len = this.optionsBox.children.length; i < len; i++) 
    {
        var option = COM(this.optionsBox.children[i]);
        valid = valid && option.valid() && (values.indexOf(option.value) < 0);
        values.push(option.value);
        if (!valid) 
        {
            break;
        }
    }
    COM(this.createButton).reason = valid ? null : I18.f('NEED_TO_FILL_DATA');
}

CreateQuestionDialog.prototype.getOptions = function() 
{
    var options = [];
    for (var i = 0, len = this.optionsBox.children.length; i < len; i++) 
    {
        options.push(COM(this.optionsBox.children[i]).value);
    }
    return options;
}

CreateQuestionDialog.prototype.onCreate = function()
{
    Service.alliance.callMethod('createQuestion', [COM(this.subject).value, this.body.value, this.options],
    	$.proxy(this.onCreateComplete, this), ClanException.errorHandler
    );
}

CreateQuestionDialog.prototype.onCreateComplete = function(diplomacy)
{
    this.onResult(diplomacy);
    this.close();
}
