function QuestionRenderer()
{
	this.__defineGetter__('data', this.getData);
	this.__defineSetter__('data', this.setData);
	
	this.__defineGetter__('question', this.getData);
	this.__defineSetter__('question', this.setData);
	
	this._data = null;
	this.onResult = null; // Function
	this.estate = null; // FEstate
	this.votesRenderer = null; // QuestionVotesRenderer
}

QuestionRenderer.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.sendMail, $.proxy(this.onSendMail, this));
	COM(this.timeView).handler = $.proxy(this.onExpired, this);
}

QuestionRenderer.prototype._data = null;
QuestionRenderer.prototype.onResult = null; // Function
QuestionRenderer.prototype.estate = null; // FEstate
QuestionRenderer.prototype.votesRenderer = null; // QuestionVotesRenderer

QuestionRenderer.prototype.getData = function()
{
	return this._data;
}

QuestionRenderer.prototype.setData = function(data)
{
    var question = data;
    if (!this.question || this.question.id != question.id) 
    {
        if (this.votesRenderer) 
        {
            this.votesGroup.removeChild(this.votesRenderer.DOM);
        }
        
        this.votesRenderer = this.createRenderer(question.displayType);
        this.votesRenderer.init(question);
        this.votesRenderer.onVote = $.proxy(this.onVote, this);
        this.votesGroup.appendChild(this.votesRenderer.DOM);
    }
    
    this._data = data;
}

QuestionRenderer.prototype.createRenderer = function(type)
{
    if (type.name == DisplayType.RADIO_BUTTONS.name)
    {
        return COM.create('RadioVotesRenderer');
    } 
    else if (type.name == DisplayType.COMBOBOX.name) 
    {
        return COM.create('ComboboxVotesRenderer');
    } 
    else if (type.name == DisplayType.BUTTONS.name) 
    {
        return COM.create('ButtonsVotesRenderer');
    } 
    else 
    {
        console.error("Invalid votes renderer\n", type);
    }
}

QuestionRenderer.prototype.update = function(estate)
{
    this.estate = estate;
    this.subjectText.innerHTML = this.question.getSubject();
    
    $(this.subjectText).toggleClass('text-normal-bold', (this.question.vote < 0));
    COM(this.timeView).value = this.question.tillTick;
    
    this.bodyText.innerHTML = this.question.getBody();
    
    UI.show(this.question.owner, [this.ownerGroup])
    if (this.question.owner)
    {
        this.ownerText.innerHTML = this.question.owner.user.username;
    }
    
    COM(this.votesRenderer).update(this.question);
}

QuestionRenderer.prototype.onOwnerTooltip = function(e)
{
    //e.toolTip = EstateStarsClanView.createAsTip(question.owner.user, null, false, false, true)
}

QuestionRenderer.prototype.onSendMail = function()
{
    MailBoxView.i().sendMessage(this.question.owner.user.username);
}

QuestionRenderer.prototype.onVote = function(option)
{
    Service.alliance.callMethod('voteQuestion', [this.question.id, option*1], $.proxy(this.onResult, this), ClanException.errorHandler);
}

QuestionRenderer.prototype.onExpired = function()
{
    Service.alliance.callMethod('getDiplomacy', [this.estate.owner.username], $.proxy(this.onResult, this));
}
