function AltarView()
{
	this.tabVisible = true; // Boolean
	this.tabToolTip = I18.f('ALCHEMY'); // String
	
	this.mainArtifactSlot = null; // ArtifactSlotView
	this.crystalSlots = []; // Array
	this.artifactSlots = []; // Array
	this.estate = null; // FEstate
	this.hero = null; // FHero
}

AltarView.prototype.__construct = function()
{
	this.init();
	COM.bindExclusiveClick(this.improveButton, $.proxy(this.onImprove, this));
}

AltarView.JUNK = 3;

AltarView.prototype.tabVisible = true; // Boolean
AltarView.prototype.tabToolTip = I18.f('ALCHEMY'); // String

AltarView.prototype.mainArtifactSlot = null; // ArtifactSlotView
AltarView.prototype.crystalSlots = []; // Array
AltarView.prototype.artifactSlots = []; // Array
AltarView.prototype.estate = null; // FEstate
AltarView.prototype.hero = null; // FHero

AltarView.prototype.init = function()
{
	this.mainArtifactSlot = this.createMainArtifactSlot(162, 280);
	
	this.crystalSlots = [
	    this.createCrystalSlot(27, 280, 0),
	    this.createCrystalSlot(67, 185, 1),
	    this.createCrystalSlot(162, 145, 2),
	    this.createCrystalSlot(257, 185, 3),
	    this.createCrystalSlot(297, 280, 4)
	];
	
	this.artifactSlots = [
	    this.createArtifactSlot(67, 375, 0),
	    this.createArtifactSlot(162, 415, 1),
	    this.createArtifactSlot(257, 375, 2)
	];
	
	//Events.onArtifactDragBegin.add(this.onDragBegin);
	//Events.onArtifactDragEnd.add(this.onDragEnd);
}

AltarView.prototype.createMainArtifactSlot = function(x, y)
{
	var slot = this.createSlot(x, y, true);
	slot.title = I18.f('ARTIFACT_TO_IMPROVE');
	/*
	slot.artifactView.onTip = function (e:ToolTipEvent):void {
	    e.toolTip = ArtifactTip.create(slot.artifact, [], false, true);
	};
	*/
	slot.acceptsDrop = function (source)
	{
	    if (!ArtifactSlotView.checkDropTarget(source)) return false;
	    if (!source.artifact) 
	    {
	        return true;
	    }
	    return source.artifact.declaration.type.name == ArtifactType.ARTIFACT.name;
	};
	return slot;
}

AltarView.prototype.createCrystalSlot = function(x, y, p)
{
	var slot = this.createSlot(x, y, true);
	slot.title = " ";
	
	slot.acceptsDrop = function (source)
	{
	    if (!ArtifactSlotView.checkDropTarget(source)) return false;
	    if (!source.artifact) 
	    {
	        return true;
	    }
	    if (source.artifact.declaration.type.name != ArtifactType.CRYSTAL.name) 
	    {
	        return false;
	    }
	    return source.artifact.declaration.name == CrystalType.valuesCache[p].name;
	};
	
	return slot;
}

AltarView.prototype.createArtifactSlot = function(x, y, p)
{
	var slot = this.createSlot(x, y, true);
	slot.title = " ";
	/*
	slot.addEventListener(ToolTipEvent.TOOL_TIP_CREATE, function (e:ToolTipEvent):void {
	    var tip:Tip = Tip.create();
	    var cost:ArtifactUpgradeCost = getCost();
	    if (cost == null) {
	        tip.addLine(I18.ARTIFACT_OR_SCROLL);
	    } else {
	        tip.addLine(I18.SCIENCE_REQUIRES);
	        tip.addLine(I18.s(getType(cost, p).name, "NAME") + " " + I18.ARTIFACT_LEVEL.f(getLevel(cost, p)));
	    }
	    tip.addLine(I18.SACRIFICIAL_ITEM);
	    e.toolTip = tip;
	});
	slot.artifactView.onTip = function (e:ToolTipEvent):void {
	    e.toolTip = ArtifactTip.create(slot.artifact, [], true, false, function(toolTip:ArtifactTip):void {
	        var cost:ArtifactUpgradeCost = getCost();
	        if (cost == null) {
	            toolTip.altarLabel.text = I18.SACRIFICIAL_ITEM.f();
	            toolTip.altarLabel.setStyle("color", Effects.WHITE);
	        } else {
	            var decl:ArtifactDeclaration = slot.artifact.declaration;
	            toolTip.altarLabel.text = I18.SCIENCE_REQUIRES.f() + "\n" + I18.s(getType(cost, p).name, "NAME") + " " + I18.ARTIFACT_LEVEL.f(getLevel(cost, p));
	            toolTip.altarLabel.setStyle("color", decl.type == getType(cost, p) && decl.level == getLevel(cost, p) ? Effects.GREEN : Effects.RED);
	        }
	        toolTip.setBox.visible = false;
	        toolTip.setBox.includeInLayout = false;
	    });
	};
	*/
	
	slot.acceptsDrop = function (source)
	{
	    if (!ArtifactSlotView.checkDropTarget(source)) return false;
	    if (source.artifact) 
	    {
	        return true;
	    }
	    return source.artifact.declaration.type.name == ArtifactType.ARTIFACT.name || source.artifact.declaration.type.name == ArtifactType.SCROLL.name;
	};
	return slot;
}

AltarView.prototype.createSlot = function(x, y, active)
{
	var slot = COM.create('ArtifactSlotView');
	slot.DOM.style.position = 'absolute';
	slot.DOM.style.left = x + 'px';
	slot.DOM.style.top = y + 'px';
	this.slots.appendChild(slot.DOM);
	slot.active = Boolean(active);
	return slot;
}

AltarView.prototype.getCost = function()
{
	var main = COM(this.mainArtifactSlot).artifact;
	if (!main || ! main.isUpgradable()) 
	{
	    return null;
	}
	return (FConfig.ARTIFACT_UPGRADE_COSTS.getValue(main.declaration.level)).getValue(main.declaration.parts[0]);
}

AltarView.getType = function(cost, i)
{
	return i < cost.artifacts.length ? ArtifactType.ARTIFACT : ArtifactType.SCROLL;
}

AltarView.getLevel = function(cost, i)
{
	return i < cost.artifacts.length ? cost.artifacts[i] : cost.scrolls[i - cost.artifacts.length];
}

AltarView.prototype.update = function(estate, hero, parentDialog)
{
	var allArts = true;
	this.estate = estate;
	this.hero = hero;
	var artifacts = estate.owner.altar.artifacts;
	COM(this.mainArtifactSlot).update(this.estate, this.hero, this.estate.owner.altar, 0, artifacts[0], [], this.parentDialog, 1);
	var cost = this.getCost();
	var i, valid, slot;
	for (i = 0; i < AltarView.JUNK; i++) 
	{
	    var art = artifacts[i + 1];
	    var decl = art ? art.declaration : null;
	    slot = this.artifactSlots[i];
	    slot.update(this.estate, this.hero, this.estate.owner.altar, i + 1, art, [], this.parentDialog);
	    if (!cost) 
	    {
	        slot.assignCount(null);
	    } 
	    else 
	    {
	        valid = decl && decl.type.name == AltarView.getType(cost, i).name && decl.level == AltarView.getLevel(cost, i);
	        slot.assignCount("[" + AltarView.getLevel(cost, i) + "]", valid ? Effects.GREEN : Effects.RED);
	        allArts = allArts && valid;
	    }
	}
	
	for (i = 0; i < CrystalType.valuesCache.length; i++) 
	{
	    var count = 0;
	    var artifact = null;
	    
	    var artId = -1;
	    for (var j = 0, len = artifacts.length; j < len; j++) 
	    {
	        if (artifacts[j]) 
	        {
	            if (artifacts[j].declaration.name == CrystalType.valuesCache[i].name) 
	            {
	                count += 1;
	                artifact = artifacts[j];
	                artId = j;
	            }
	        }
	    }
	    
	    slot = this.crystalSlots[i];
	    slot.update(this.estate, this.hero, this.estate.owner.altar, artifacts.indexOf(artifact, 1 + AltarView.JUNK), artifact, [], this.parentDialog, count);
	    slot.toPosition = artifacts.indexOf(null, 1 + AltarView.JUNK);
	    var n = cost ? cost.crystals[i] : 0;
	    valid = (count >= n);
	    slot.assignCount(count + "/" + n, valid ? Effects.GREEN : Effects.RED);
	    allArts = allArts && valid;
	    
	    if (UI.show(count == 0, [slot.greyCrystal])) 
	    {
	        slot.greyCrystal.src = STATIC_INTERFACE_URL + ArtifactAssets[CrystalType.valuesCache[i].name];
	    }
	}
	
	COM(this.improveButton).skin = (allArts && this.mainArtifactSlot.artifact && this.mainArtifactSlot.artifact.isUpgradable()) ? 'green' : 'yellow';
	var reason = [];
	if (!this.mainArtifactSlot.artifact) 
	{
	    reason.push(I18.getString("NEED_MAIN_ITEM"));
	} 
	else if (!this.mainArtifactSlot.artifact.isUpgradable()) 
	{
	    reason.push(I18.getString("NOT_UPGRADABLE"));
	} 
	else if (!allArts) 
	{
	    reason.push(I18.getString("NEED_ALL_SACRIFICE_ITEMS"));
	} 
	COM(this.improveButton).reason = reason;
}

AltarView.prototype.onImprove = function()
{
	Alert.create(I18.getMegaBox("DO_YOU_WANT_SACRIFICE"), '', function ()
	{
	    Service.hero.callMethod('sacrifice', [estate.id],
	        function (e){},
	        function (e)
	        {
	            if (e.__className__ == 'HeroException') 
	            {
	                Alert.create(e.getMessage());
	                return true;
	            }
	            return false;
	        }
	    );
	});
}

AltarView.prototype.onDragBegin = function(source)
{
	Arrays.foreach(this.crystalSlots, function (target)
	{
	    this.highlightSlot(target, source);
	});
	Arrays.foreach(this.artifactSlots, function (target)
	{
	    this.highlightSlot(target, source);
	});
	
	this.highlightSlot(this.mainArtifactSlot, source);
}

AltarView.prototype.onDragEnd = function(ignore)
{
	Arrays.foreach(this.crystalSlots, function (target)
	{
	    target.highlight(false, false);
	});
	Arrays.foreach(this.artifactSlots, function (target)
	{
	    target.highlight(false, false);
	});
	this.mainArtifactSlot.highlight(false, false);
}

AltarView.prototype.highlightSlot = function(target, source)
{
	var canDrop = target.acceptsDrop(source);
	if (canDrop) 
	{
    	target.highlight(true, canDrop);
	}
}