function ArtifactPic()
{
	this.artifact = null; // FArtifact
	this.doesntWork = null; // Array
	this.actions = null; // Actions for tip dialog
	this.tipDialog = null;
}

ArtifactPic.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.DOM, $.proxy(function(){
		this.onTip();
	}, this));
}

ArtifactPic.prototype.artifact = null; // FArtifact
ArtifactPic.prototype.doesntWork = null; // Array
ArtifactPic.prototype.actions = null; // Actions for tip dialog
ArtifactPic.prototype.tipDialog = null;

ArtifactPic.prototype.onTip = function (e)
{
    this.closeTip();
    if (this.artifact)
    {
    	this.tipDialog = ArtifactTip.alert(this.artifact, this.doesntWork, null, null, null, this.actions);
    	this.tipDialog.onClose = $.proxy(function(){ this.tipDialog = null; }, this);
    }
}

ArtifactPic.prototype.closeTip = function()
{
    if (this.tipDialog) this.tipDialog.close();
    this.tipDialog = null;
}

ArtifactPic.create = function(artifact, doesntWork)
{
    var res = COM.create('ArtifactPic');
	res.update(artifact, doesntWork);
    return res;
}

ArtifactPic.createArray = function(artifacts, extra)
{
    var res = [];
    var i = 0;
    for (var i = 0, len = artifacts.length; i < len; i++) 
    {
        res.push(ArtifactPic.create(artifacts[i], []));
    }
    if (extra) 
    {
        res.push(extra);
    }
    return res;
}

ArtifactPic.prototype.setGreyScale = function(greyScale)
{
	$(this.DOM).toggleClass('grayscale', Boolean(greyScale));
}

ArtifactPic.prototype.update = function(art, doesntWork, count)
{
    if (typeof count == 'undefined') count = 1;
    
    this.artifact = art;
    this.doesntWork = doesntWork;

    if (UI.show(art.declaration.type.name != ArtifactType.SCROLL.name, [this.artPic]))
    {
        this.artPic.src = STATIC_INTERFACE_URL + Assets.getArtifact(this.artifact.declaration);
        if (this.artifact.upgradesCount > 0) 
        {
            //Effects.shadow(artPic, 0xAAAAAA, 4);
        } 
        else 
        {
            //Effects.removeShadow(artPic);
        }
    }
    
    if (UI.show(this.artifact.declaration.type.name == ArtifactType.SCROLL.name, [this.scrollPic, this.spellPic]))
    {
        this.scrollPic.src = STATIC_INTERFACE_URL + Assets.getScroll(this.artifact.declaration);
        this.spellPic.src = STATIC_INTERFACE_URL + Assets.getSpellImageForScroll(this.artifact.declaration.pic);
    }
    
	//setSrc(this.upgradePic, STATIC_INTERFACE_URL + ArtifactAssets.ARTIFACT_UPGRADE_EFFECT_STATIC); //(FUser.CURRENT_USER.settings.heroAnimationEnabled ? ArtifactAssets.ARTIFACT_UPGRADE_EFFECT : ArtifactAssets.ARTIFACT_UPGRADE_EFFECT_STATIC);
    //UI.show(this.artifact.upgradesCount > 0, [this.upgradePic]);
    
    var runes = this.runes.querySelectorAll('rune');
    for (var i = 0, len = runes.length; i < len; i++)
    {
    	var pic = runes[i];
    	var rune = art.runes.getItemAt ? art.runes.getItemAt(i) : art.runes[i];
    	var src = rune ? STATIC_INTERFACE_URL + ArtifactAssets[rune] : null;
    	if (UI.show(!!src, [pic]))
    	{
    		$(pic).addClass('active').css('background-image', 'url("' + src + '")');
    	}
    	else
    	{
    		$(pic).removeClass('active').css('background-image', null);
    	}
    }
    
    this.DOM.title = this.getTitle();
    this.DOM.className = Assets.hasGlow(art.declaration) ? "glow" : "";
}

ArtifactPic.prototype.getTitle = function()
{
    var name = '';
    if (this.artifact)
    {
    	name = Texts.artifactName(this.artifact.declaration);
	    if (this.artifact.declaration.type.name != ArtifactType.CRYSTAL.name && this.artifact.declaration.level > 0) 
	    {
	        name += " " + I18.f('ARTIFACT_LEVEL', this.artifact.declaration.level);
	    }
    }
	return name;
}

ArtifactPic.prototype.updateReward = function(reward)
{
    this.update(new FArtifact(ArtifactDeclaration.unknown(reward.itemType, reward.itemLevel)), []);
}