function ArtifactTraderView()
{
	this.tabVisible = true; // Boolean
	this.tabToolTip = I18.f('TRADER'); // String
	this.estate = null; // FEstate
}

ArtifactTraderView.prototype.__construct = function()
{
	COM(this.traderArtifacts).isTrader = true;
	COM.bindExclusiveClick(this.regenerateButton, $.proxy(this.refreshArtifactsList, this));
}

ArtifactTraderView.prototype.tabVisible = true; // Boolean
ArtifactTraderView.prototype.tabToolTip = I18.f('TRADER'); // String
ArtifactTraderView.prototype.estate = null; // FEstate

ArtifactTraderView.prototype.update = function(estate, hero, parentDialog)
{
	this.estate = estate;
	COM(this.traderArtifacts).update(estate, hero, estate.owner.traderArtifacts, parentDialog);
	COM(this.regeneratePrice).update(FConfig.ARTIFACT_REGENERATE_COST);
	
	if (estate.owner.pearl < FConfig.ARTIFACT_REGENERATE_COST) 
	{
	    COM(this.regenerateButton).enabled = false;
	    this.regenerateButton.title = I18.f('NOT_ENOUGH_RESOURCES');
	} 
	else 
	{
	    COM(this.regenerateButton).enabled = true;
	    this.regenerateButton.title = '';
	}
	
	COM(this.credit).update(estate.owner.artifactTraderCredit);
	this.creditText.title = I18.mega(I18.f('CREDIT_TIP'), FConfig.BUY_ARTIFACT_MAX_CREDIT_PART);
	UI.show(estate.owner.artifactTraderCredit != Number.MIN_VALUE, [this.creditBox]);
	UI.show(estate.accessManageble, [this.regenerateBox]);
}

ArtifactTraderView.prototype.refreshArtifactsList = function()
{
	if (!Quarantine.contains('refreshArtifactsList')) 
	{
	    Quarantine.put('refreshArtifactsList');
	    Service.hero.callMethod('regenerateArtifacts', [this.estate.id]);
	}
}

ArtifactTraderView.prototype.checkCreditPrice = function(price)
{
	return true;
}