function ArtifactsDialog()
{
	callParentConstructor(ArtifactsDialog.prototype, this);
	this.scroll = [];
}

extendClass(ArtifactsDialog.prototype, UpdatableEstateDialog.prototype);

ArtifactsDialog.prototype.scroll = null;

ArtifactsDialog.popup = function(estate)
{
    return ArtifactsDialog.createInstance(estate);
}

ArtifactsDialog.createInstance = function(estate)
{
	var instance = COM.create('ArtifactsDialog');
	
	COM(instance).update(estate);
	instance.popup();
	
	Events.onFEstateUpdated.add(instance, instance.update);
	instance.onClose = function(){
    	Events.onFEstateUpdated.remove(instance);
	}
	
	return instance;
}

ArtifactsDialog.prototype.__construct = function()
{
	superMethod(ArtifactsDialog.prototype, '__construct', this)();
	this.fullScreen();
	this.right = COM(this.right);
	
	COM(this.storeArtifacts).pager = this.leftPager;
	COM(this.rightPager).setIndexAndCount(0, 0);
	
	var tabButtonClick = $.proxy(this.tabButtonClick, this);
	$('> CustomButton', this.tabButtons).each(function(){ COM.bindExclusiveClick(this, tabButtonClick); });
}

ArtifactsDialog.prototype.onShow = function()
{
	this.scroll.push(COM(this.storeArtifacts).scroll);
	if (this.right['scroll'])
	{
		this.scroll.push(this.right.scroll);
	}
	this.refreshScroll(300);
}

ArtifactsDialog.prototype.refreshScroll = function(timeout)
{
	if (timeout)
	{
		return setTimeout($.proxy(this.refreshScroll, this), timeout*1);
	}
	
	for (var i = 0; i < this.scroll.length; i++)
	{
		this.scroll[i].refresh();
	}
}

ArtifactsDialog.prototype.tick = function()
{
}

ArtifactsDialog.prototype.tabButtonClick = function(e)
{
	var btn = e.currentTarget, cls = btn.getAttribute('tab');
	
	COM(this.right).destroy();
	
	this.right = COM.create(cls);
	this.rightBox.appendChild(this.right.DOM);
	
	$('> *', this.tabButtons).removeClass('active');
	$(btn).addClass('active');
	
	COM(this.rightPager).setIndexAndCount(0, 0);
	if (cls == 'StoreUI') this.right.pager = this.rightPager;
	COM(this.right).update(this.estate, null, this);

	if (this.scroll.length > 1) this.scroll.pop();
	this.scroll.push(this.right['scroll'] || new iScroll(this.rightBox, {}));
	
	this.refreshScroll(300);
}

ArtifactsDialog.prototype.update = function(estate)
{
    this.estate = estate;
	
	var artifactStore = this.estate ? this.estate.findBuilding(BType.ARTIFACT_STORE) : null;
	if (!(artifactStore && artifactStore.isWorking)) return this.close(); 

	UI.show(this.estate.accessManageble && FConfig.SET_TRADER_ENABLED, [this.btnSets]);
	COM(this.btnAlchemy).reason = null;
	if (UI.show(this.estate.accessManageble || FUser.CURRENT_USER.role.canSpyAndObserve(), [this.btnAlchemy]))
	{
		if (FUser.CURRENT_USER.science.getLevel(Science.ALCHEMY) < 1) 
		{
			COM(this.btnAlchemy).reason = I18.f('ALCHEMY_REQUIRED');
		}		
	}
	
	if (UI.show(Science.ALCHEMY.getMaxLevel() >= 2 && (this.estate.accessManageble || FUser.CURRENT_USER.role.canSpyAndObserve()), [this.btnRuneMaster]))
	{
		COM(this.btnRuneMaster).reason = FUser.CURRENT_USER.science.getLevel(Science.ALCHEMY) < 2
			? I18.f('ALCHEMY2_REQUIRED')
			: null
		;
	}
	
	COM(this.storeArtifacts).update(this.estate, null, artifactStore.storedArtifacts, this);
	COM(this.right).update(this.estate, null, this);
}