function BuySetDialog()
{
	callParentConstructor(BuySetDialog.prototype, this);
	
	this.estate = null; // FEstate
	this.setName = null; // String
	this.level = null; // int
	this.price = null; // Number
	this.priceWithDiscount = null; // Number
}

extendClass(BuySetDialog.prototype, Dialog.prototype);

BuySetDialog.prototype.__construct = function()
{
	superMethod(BuySetDialog.prototype, '__construct', this)();
	
	$(this.creditLabel).html(I18.mega(I18.f('ATRIFACT_COST_CREDIT_PART'), FConfig.BUY_ARTIFACT_MAX_CREDIT_PART));
	
	COM.bindExclusiveClick(this.buyButton, $.proxy(this.onBuy, this));
	COM.bindExclusiveClick(this.cancelButton, $.proxy(this.close, this));
	
	COM(this.pearlPrice).checkPrice = $.proxy(this.checkPrice, this);
	COM(this.pearlWithDiscount).checkPrice = $.proxy(this.checkPrice, this);
	COM(this.credit).checkPrice = $.proxy(this.checkPrice, this);
	COM(this.costWithCredit).checkPrice = $.proxy(this.checkPrice, this);
}

BuySetDialog.prototype.estate = null; // FEstate
BuySetDialog.prototype.setName = null; // String
BuySetDialog.prototype.level = null; // int
BuySetDialog.prototype.price = null; // Number
BuySetDialog.prototype.priceWithDiscount = null; // Number

BuySetDialog.create = function(estate, setName, level, price, priceWithDiscount)
{
	var result = COM.create('BuySetDialog');
	
	result.estate = estate;
	result.setName = setName;
	result.level = level;
	result.price = price;
	result.priceWithDiscount = priceWithDiscount;
	
	result.init();
	result.popup(null);
	
}

BuySetDialog.prototype.init = function()
{
	this.setLabel.innerHTML = Texts.artifactSetName(this.setName) + I18.f('ARTIFACT_LEVEL', this.level);
	Events.onFEstateUpdated.add(this, this.update);
	this.updatePrice();
}

BuySetDialog.prototype.update = function(e)
{
	this.estate = e;
	this.updatePrice();
}

BuySetDialog.prototype.updatePrice = function()
{
	COM(this.pearlPrice).update(this.price);
	COM(this.pearlWithDiscount).update(this.priceWithDiscount);
	
	var creditValue = Math.min(this.estate.owner.artifactTraderCredit, NumberUtils.floor(this.priceWithDiscount * FConfig.BUY_ARTIFACT_MAX_CREDIT_PART));
	COM(this.credit).update(creditValue);
	COM(this.costWithCredit).update(Math.max(0, this.priceWithDiscount - creditValue));
	
	var store = this.estate.findBuilding(BType.ARTIFACT_STORE);
	if (this.estate.owner.pearl < this.priceWithDiscount - creditValue) 
	{
	    COM(this.buyButton).reason = [I18.f('NOT_ENOUGH_RESOURCES')];
	} 
	else if (!store) 
	{
	    COM(this.buyButton).reason = [I18.f('ARTIFACT_STORE_ABSENT')];
	} 
	else if (!store.isWorking) 
	{
	    COM(this.buyButton).reason = [I18.f('ARTIFACT_STORE_NOT_WORKING')];
	} 
	else 
	{
	    COM(this.buyButton).reason = null;
	}
}

BuySetDialog.prototype.onBuy = function()
{
	// close must be here, not in success handler
	// because service call makes simult update -- NPE
	//close();
	COM(this.buyButton).enabled = false;
	APP.showLoader();
	Service.hero.callMethod('buyArtifactSetFor', [this.estate.id, this.setName, this.priceWithDiscount],
        $.proxy(function (e)
        {
            this.close();
            Alert.create(I18.f('ARTIFACT_SET_BOUGHT'));
            
        }, this),
        $.proxy(function (e)
        {
            this.close();
            if (e.__className__ == 'HeroException') 
            {
                Alert.create(e.getMessage());
                return true;
            }
            return false;
        }, this),
        'hero_buyArtifactSet'
	);
}

BuySetDialog.prototype.checkPrice = function(ignore)
{
	var creditValue = Math.min(this.estate.owner.artifactTraderCredit, NumberUtils.floor(this.priceWithDiscount * FConfig.BUY_ARTIFACT_MAX_CREDIT_PART));
	return this.estate.owner.pearl >= (this.priceWithDiscount - creditValue);
}

BuySetDialog.prototype.onClose = function()
{
    Events.onFEstateUpdated.remove(this);
	APP.hideLoader();
}

