function CastSpellDialog()
{
	callParentConstructor(CastSpellDialog.prototype, this);
	
	this.__defineGetter__('rewardBox', this.getRewardBox);
	
	this.estate = null; // FEstate
	this.spell = null; // FSpell
	this.castTarget = null; // CastTarget
	this.parentDialog = null; // HeroDialog
	this.isFromCity = null; // Boolean
}

extendClass(CastSpellDialog.prototype, ChooseRewardDialog.prototype);

CastSpellDialog.prototype.__construct = function()
{
	superMethod(CastSpellDialog.prototype, '__construct', this)();
	COM.bindExclusiveClick(this.castButton, $.proxy(function(){
		this.onAllChoosen(this);
	}, this))
}

CastSpellDialog.prototype.estate = null; // FEstate
CastSpellDialog.prototype.spell = null; // FSpell
CastSpellDialog.prototype.castTarget = null; // CastTarget
CastSpellDialog.prototype.parentDialog = null; // HeroDialog
CastSpellDialog.prototype.isFromCity = null; // Boolean

CastSpellDialog.create = function(estate, spell, castTarget, parentDialog, isFromCity)
{
	var result = COM.create('CastSpellDialog');
	result.estate = estate;
	result.spell = spell;
	result.castTarget = castTarget;
	result.parentDialog = parentDialog;
	result.isFromCity = isFromCity;
	
	var isBottle = spell.fromArtifact && spell.artifactDeclaration.isBottle();
	result.setCaption(Texts.spellName(spell.name));
	result.spellImage.src = STATIC_INTERFACE_URL + (isBottle 
		? ArtifactAssets[spell.artifactDeclaration.pic]
        : Assets.getSpellImageForScroll(spell.fromArtifact ? spell.artifactDeclaration.pic : spell.name)
	);
	
	result.popup();
	
	if (!isFromCity)
	{
		parentDialog.doClose(false);
	}
	
	result.onCreationComplete();	
}

CastSpellDialog.prototype.onCreationComplete = function()
{
    if (!this.isFromCity) 
    {
        this.parentDialog.close();
        this.parentDialog = null;
    }
}

CastSpellDialog.prototype.onCastError = function(e)
{
	APP.hideLoader();
	//castButton.enabled = true;
	
	if (e.__className__ == 'TemplateException') 
	{
    	Alert.create(e.getBox());
    	return true;
	}
	if (GameException.isDisplayable(e)) 
	{
    	Alert.create(e.getMessage());
    	return true;
	}
	
	console.error(e);
	return true;
}

CastSpellDialog.prototype.onCastSuccess = function(r, spell)
{
	var effects = [];
	
	for (var i = 0, len = r.castEffects.length; i < len; i++) 
	{
	    if (r.castEffects[i]) 
	    {
	        effects.push(I18.getCastEffectMessage(r.castEffects[i]));
	    }
	}
	
	for(var i = 0; i < effects.length; i++)
	{
		Alert.create(effects[i], I18.f('CAST_CAUSE_SPELL_NAME'));
	}
	
	Alert.create(I18.f('CAST_MESSAGE_SUBJECT_SELF', Texts.spellName(spell.name)), I18.f('CAST_CAUSE_SPELL_NAME'));
	
	/*
	var a = Alert.create(I18.f('CAST_MESSAGE_SUBJECT_SELF', Texts.spellName(spell.name)), I18.f('CAST_CAUSE_SPELL_NAME'));
	a.onClose = $.proxy(function()
	{
		if (this.message.innerHTML = effects.shift())
		{
			this.scroll.refresh();
			return false;
		}
		return true;
		
	}, a);
	*/

	APP.hideLoader();
	
}


CastSpellDialog.prototype.getRewardBox = function() 
{
	return this.spellDesc;
}

CastSpellDialog.prototype.onAllChosenSpecific = function(rewardData)
{
	var spell = this.spell;
	APP.showLoader();
	Service.hero.callMethod('castSpell', [this.estate.id, this.castTarget.location, this.spell.name, this.spell.level, this.spell.fromArtifact, rewardData, this.isFromCity],
		$.proxy(function(r){
			this.onCastSuccess(r, spell);
		}, this),
		$.proxy(this.onCastError, this),
		'cast_spell'
	);
	this.close();
}

CastSpellDialog.prototype.spawnRewardsDialog = function()
{
	return EffectsView.createCastActivationView(
		$.proxy(this.onOuterDialogChosen, this), 
		this.spellDesc, 
		this.spell.config.allActions, 
		this.estate, 
		this.castTarget
	);
}