function ChooseBranchDialog()
{
	callParentConstructor(ChooseBranchDialog.prototype, this);
	this.hero = null; // FHero
	this.estate = null; // FEstate
	
	this.scroll = null;
}

extendClass(ChooseBranchDialog.prototype, Dialog.prototype);

ChooseBranchDialog.prototype.__construct = function()
{
	superMethod(ChooseBranchDialog.prototype, '__construct', this)();
	this.branches = [];
	$('SkillsBranchView', this.DOM).each($.proxy(function(n, obj){
		this.branches.push(obj);
	}, this));
	this.fullScreen();
}

ChooseBranchDialog.prototype.hero = null; // FHero
ChooseBranchDialog.prototype.estate = null; // FEstate
ChooseBranchDialog.prototype.scroll = null;

ChooseBranchDialog.create = function(h, estate)
{
    var d = COM.create('ChooseBranchDialog');
    d.hero = h;
    d.estate = estate;
    d.init();
    d.popup();
    return d;
}

ChooseBranchDialog.prototype.onShow = function()
{
	this.scroll = new iScroll(this.content, {});
	this.refreshScroll(300);
}

ChooseBranchDialog.prototype.init = function()
{
    var allBranches = FConfig.heroClasses.getValue(this.hero.heroClass).branches;
    var heroBranches = Arrays.map(this.hero.branches, function (b){
        return b.name;
    });
    var toChoose = Arrays.filter(allBranches, function (name){
        return !Arrays.contains(heroBranches, name)
    });

    for (var i = 0, len = toChoose.length; i < len; i++)
    {
	    var obj = COM.create('SkillsBranchView');
	    obj.onSelect = $.proxy(this.onSelectBranch, this);
		COM(obj).update(null, this.hero, [], SkillBranch.createNewBranch(toChoose[i]), Number.MAX_VALUE);
	    $(this.branchBox).append(obj.DOM);
    }
}

ChooseBranchDialog.prototype.onSelectBranch = function(branchName)
{
    Service.hero.callMethod('chooseSkillBranch', [this.estate.id, this.hero.id, branchName], $.proxy(this.close, this));
}

ChooseBranchDialog.prototype.refreshScroll = function(timeout)
{
	if (timeout) return setTimeout($.proxy(this.refereshScroll, this), timeout*1);
	if (this.scroll) this.scroll.refresh();
}
