function HeroDollView()
{
	this.estate = null; // FEstate
	this.hero = null; // FHero
	this.buffs = null; // Array
}

HeroDollView.prototype.__construct = function()
{
	var doll = this;
	for (var i = 0, len = this.slots.children.length; i < len; i++)
	{
		var slot = COM(this.slots.children[i]);
		slot.isHeroDoll = true;
		slot.acceptsDrop = $.proxy(function(source)
		{
	    	if (!ArtifactSlotView.checkDropTarget(source)) return false;
			if (!doll.hero) 
			{
			    return false;
			}
			if (source.hero && source.hero.isUpset()) 
			{
			    return true;
			}
			if (!source.artifact) 
			{
			    return true;
			}
			var toPart = doll.getPart(this);
			if (toPart && toPart.isHand()) 
			{
			    var oppositeHand = COM(toPart.name == BodyPart.LEFT_HAND.name ? doll.rightHand : doll.leftHand);
			    if (oppositeHand.hasArtifact && (oppositeHand.artifact.declaration.twoHanded || source.artifact.declaration.twoHanded)) 
			    {
			        return false;
			    }
			}
			return source.artifact.declaration.fitsIn(toPart);
			
		}, slot);
	}
}

HeroDollView.prototype.estate = null; // FEstate
HeroDollView.prototype.hero = null; // FHero
HeroDollView.prototype.buffs = null; // Array

HeroDollView.prototype.init = function()
{
	Events.onArtifactDragBegin.add(this.onDragBegin);
	Events.onArtifactDragEnd.add(this.onDragEnd);
}

HeroDollView.prototype.onDragBegin = function(source)
{
	if (!this.hero) return false;
	/*
	Arrays.foreach(slots.getChildren(), function (target:ArtifactSlotView):void {
	    var part:BodyPart = getPart(target);
	    if (source.artifact.declaration.fitsIn(part)) {
	        target.highlight(true, target.canDropHere(source));
	    } else if (source.artifact.declaration.twoHanded && part.isHand() && target.artifact != null) {
	        target.highlight(true, false);
	    }
	});
	*/
}

HeroDollView.prototype.onDragEnd = function(ignore)
{
	if (!this.hero) return false;
	/*
	Arrays.foreach(slots.getChildren(), function (target:ArtifactSlotView):void {
	    target.highlight(false, false);
	});
	*/
}

HeroDollView.prototype.getDoesntWork = function(artifact)
{
	var res = [];
	// only for passives
	if (artifact && artifact.declaration.givesPassive()) 
	{
	    if (this.estate && (!this.estate.garrisonHero || this.estate.garrisonHeroId != this.hero.id)) 
	    {
	        res.push(I18.f('DOESNT_WORK_NON_GARRISON_HERO'));
	    }
	    if (this.hero.isUpset()) 
	    {
	        if (this.hero.upsetByFight) 
	        {
	            res.push(I18.f('DOESNT_WORK_UPSET_HERO'));
	        }
	        if (this.hero.upsetByTitle) 
	        {
	            res.push(I18.f('HERO_ERROR_REQUIRED_MAX_TITLE'));
	        }
	    }

	    if (FBuff.hasMagicDisable(this.buffs, FEstate.tickNowForEstate(this.estate))) 
	    {
	        res.push(I18.f('DOESNT_WORK_MAGIC_DISABLE'));
	    }
	}
	if (res.length > 0) 
	{
	    res.unshift(I18.f('ARTIFACT_DOESNT_WORK'));
	}
	
	return res;
}

HeroDollView.prototype.update = function(estate, hero, buffs, parentDialog)
{
	this.estate = estate;
	this.hero = hero;
	this.buffs = buffs;
	this.parentDialog = parentDialog;
	
	//this.dollBack.src = STATIC_INTERFACE_URL + Assets.getHeroDollBack(this.hero);
	if (this.hero) 
	{
		$(this.DOM).toggleClass('male', !!this.hero.male).toggleClass('female', !this.hero.male);
		this.displayArtifacts(this.hero.body.artifacts);
	}
}

HeroDollView.prototype.displayArtifacts = function(artifacts)
{
	if (!artifacts) artifacts = [];
	
	var hero = this.hero || null;
	var body = hero ? hero.body : null;
	for (var i = 0, len = this.slots.children.length; i < len; i++)
	{
		var art = null, slot = this.slots.children[i], bodyPart = this.getPart(slot);
		if (bodyPart)
		{
			var art = artifacts.filter(function(val){ 
				return (val && val.declaration.fitsIn(bodyPart)); 
			}).shift() || null;

			var buffs = hero ? this.getDoesntWork(art) : [];
			COM(slot).update(this.estate, hero, body, i, art, buffs, this.parentDialog);
			slot.title = I18.f('SLOT') + " " + I18.getForBodyPart(bodyPart);
		}
	}
	COM(this.rightHand).setMirrorMode(COM(this.leftHand).hasArtifact && COM(this.leftHand).artifact.declaration.twoHanded, COM(this.leftHand).artifact);
	COM(this.leftHand).setMirrorMode(COM(this.rightHand).hasArtifact && COM(this.rightHand).artifact.declaration.twoHanded, COM(this.rightHand).artifact);
}

HeroDollView.prototype.getPart = function(asv)
{
	return BodyPart[COM(asv).DOM.getAttribute('bodyPart')] || { name: '' };
	return BodyPart.VALUES[COM(asv).fromPosition];
}
