function HeroRedemptionInfo()
{
	this.race = null; // Race
	this.hero = null; // FHero
	this.estateId = null; // EstateId
	this.estateBank = new Funds(); // Funds
	this.managable = null; // Boolean
	this.onPayRedemption = null; // Function
}

HeroRedemptionInfo.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.payRedemptionButton, $.proxy(function(){
		return this.onPayRedemption(this.estateId, this.hero);
	}, this));
}

HeroRedemptionInfo.prototype.race = null; // Race
HeroRedemptionInfo.prototype.hero = null; // FHero
HeroRedemptionInfo.prototype.estateId = null; // EstateId
HeroRedemptionInfo.prototype.estateBank = new Funds(); // Funds
HeroRedemptionInfo.prototype.managable = null; // Boolean
HeroRedemptionInfo.prototype.onPayRedemption = null; // Function

HeroRedemptionInfo.prototype.init = function(event)
{
	if (this.hero) 
	{
    	this.update(this.hero, this.race);
	}
}

HeroRedemptionInfo.prototype.update = function(hero, race)
{
	this.hero = hero;
	this.race = race;
	
	COM(this.heroView).update(this.hero, this.race);
	this.nameLabel.innerHTML = this.hero.name;
	this.descLabel.innerHTML = I18.f('HERO_DESCRIPTION', I18.getHeroClassName(this.hero.heroClass), this.hero.level);
	this.prisonOwner.innerHTML = I18.f('HERO_PRISONER') + " : " + this.hero.prisonOwnerName;
	this.prisonEstate.innerHTML = I18.f('ESTATE') + " : " + I18.formatEstateName(this.hero.prisonEstateName ? this.hero.prisonEstateName : "-", this.hero.prisonXYZ);
	
	COM(this.redemptionCost).update(this.hero.heroLevel.redemptionCost.multiplyCopy(1 + this.hero.prisonCostBonus), this.race);
	COM(this.redemptionCost).capacity = this.estateBank;
	this.updateRedemptionButtonReason();
}

HeroRedemptionInfo.prototype.updateEstate = function(estateId, estateBank)
{
	this.estateId = estateId;
	this.estateBank = estateBank;
	
	COM(this.redemptionCost).capacity = estateBank;
	this.updateRedemptionButtonReason();
}

HeroRedemptionInfo.prototype.updateRedemptionButtonReason = function()
{
	var reason = null;
	if (!this.managable) reason = I18.f('NO_ACCESS');
	else if (!this.estateBank.greaterOrEqualsTo(FConfig.heroLevels[this.hero.level - 1].redemptionCost)) reason = I18.f('NOT_ENOUGH_RESOURCES');
	COM(this.payRedemptionButton).reason = reason;
}

HeroRedemptionInfo.prototype.onCostTip = function(r)
{
	//return new PrisonHeroCostTip(hero, r, false);
}

HeroRedemptionInfo.prototype.createListItem = function()
{
	var item = COM.create('ScrollableListItem');
	item.data = [
		this.hero.name,
		this.hero.prisonOwnerName,
		I18.formatEstateName(this.hero.prisonEstateName ? this.hero.prisonEstateName : "-", this.hero.prisonXYZ),
	];
	return item;
}