function HeroRedemptionTab()
{
	callParentConstructor(this);
}

extendClass(HeroRedemptionTab.prototype, DiplomatTabParent.prototype);

HeroRedemptionTab.prototype.__construct = function()
{
	$(this.citySelector).on('change', $.proxy(function(){
		this.onCityChange(COM(this.citySelector).city);
	}, this));
	COM(this.citySelector).nullText = 'FROM_ALL_CITIES';
	
	COM(this.heroesBox).setHeader([I18.f('HERO'), I18.f('HERO_PRISONER'), I18.f('ESTATE')]);
   	$(this.heroesBox).on('select', $.proxy(this.onHeroSelect, this));
}

HeroRedemptionTab.prototype.heroes = null; // ArrayCollection

HeroRedemptionTab.prototype.tick = function()
{
}

HeroRedemptionTab.prototype.isSame = function(heroes, newHeroes)
{
	if (!heroes && !newHeroes) 
	{
	    return true;
	} 
	else if (!heroes || !newHeroes || heroes.length != newHeroes.length) 
	{
	    return false;
	}
	for (var i = 0, len = heroes.length; i < len; i++) 
	{
	    if (heroes[i].id != newHeroes[i].id) 
	    {
	        return false;
	    }
	}
	return true;
}

HeroRedemptionTab.prototype.update = function(e)
{
	var selectedId = COM(this.citySelector).selectedIndex < 0 ? e.id : (!COM(this.citySelector).city ? null : COM(this.citySelector).city.id);
	COM(this.citySelector).updateCities(FUser.LINKS);
	COM(this.citySelector).cityId = selectedId;
    //COM(this.heroesBox).selectable = this.estate.accessManageble;
	
	superMethod(this, 'update')(e);
	var newHeroes = (!e || !e.owner || !e.owner.diplomacy) ? null : e.owner.diplomacy.heroesForRedemption;
	if (!this.isSame(this.heroes, newHeroes)) 
	{
	    COM(this.heroesBox).clearChildren();
	    var len = newHeroes.length;
	    for(var i = 0; i < len; i++) 
	    {
	        var item = COM.create('ScrollableListItem');
	        item.data = [
				newHeroes[i].name,
				newHeroes[i].prisonOwnerName,
				I18.formatEstateName(newHeroes[i].prisonEstateName ? newHeroes[i].prisonEstateName : "-", newHeroes[i].prisonXYZ),
			];
			item.hero = newHeroes[i];
			COM(this.heroesBox).addItem(item);
	        /*
	        var hi = COM.create('HeroRedemptionInfo');
	        hi.hero = newHeroes[i];
	        hi.race = this.estate.owner.race;
	        hi.managable = this.estate.accessManageble;
	        hi.onPayRedemption = $.proxy(this.onPayRedemption, this);
	        hi.init();
	        COM(this.heroesBox).addItem(hi.createListItem());
	        */
	    }
	    UI.show(len > 0, [this.heroesBox]);
	    UI.show(len < 1, [this.noHeroesBox]);
	}
	this.onCityChange(COM(this.citySelector).city);
	this.heroes = newHeroes;
}

HeroRedemptionTab.prototype.heroDialog = null;
HeroRedemptionTab.prototype.onHeroSelect = function()
{
	var item = COM(this.heroesBox).selectedItem;
	if (!item) return;
	
	this.heroDialog = PrisonedHeroDialog.create(item.hero, this.estate.owner.race, this.estate);
	this.heroDialog.onPayRedemption = $.proxy(this.onPayRedemption, this);
	
	this.heroDialog.onClose = $.proxy(function(){ 
		this.heroDialog = null; 
	}, this);
	
	this.heroDialog.update(this.estate);
	
	COM(this.heroesBox).selectedIndex = -1;
}

HeroRedemptionTab.prototype.onPayRedemption = function(estateId, hero)
{
	var onRelease = $.proxy(function(){
		Alert.create(I18.f('REDEMPTION_DONE'));
	}, this);
	
	var onReleaseError = $.proxy(function(e){
		if ((e.__className__ == 'HeroException')) 
		{
		    Alert.create(e.getMessage());
		    //IScreenManager(FlexGlobals.topLevelApplication).updateCurrentScreen();
		    return true;
		}
		return false;
		
	}, this);
	
	var doRelease = $.proxy(function(){
        console.log("doRelease", estateId ? estateId.id : null, hero);
        this.heroDialog.close();
		Service.hero.callMethod('payRedemptionForHero', [(estateId ? estateId.id : null), hero.id], onRelease, onReleaseError);
	}, this);
	
	Alert.create(I18.f('ARE_YOU_SURE_WANT_TO_RELEASE_HERO'), '', doRelease);
}

HeroRedemptionTab.prototype.onCityChange = function(link)
{
	var bank = (link ? link.bank : FUser.getBank(EstateType.CITY));
	COM(this.availableFunds).update(this.filterRedemptionFunds(bank), this.estate.owner.race);
	
	for (var i = 0, len = this.heroesBox.children.length; i < len; i++) 
	{
	    //COM(this.heroesBox.children[i]).updateEstate(!link ? null : link.id, bank);
	}
}

HeroRedemptionTab.prototype.canBePaydForRedemption = function(r)
{
	for (var i = 0, len = FConfig.heroLevels; i < len; i++)
	{
	    if (FConfig.heroLevels[i].redemptionCost.getValue(r) > 0) 
	    {
	        return true;
	    }
	}
	return false;
}

HeroRedemptionTab.prototype.filterRedemptionFunds = function(funds)
{
	var filtered = funds.copy();
	
	for (var i = 0, len = Resource.FUNDS_RESOURCES.length; i < len; i++)
	{
	    if (!this.canBePaydForRedemption(Resource.FUNDS_RESOURCES[i])) 
	    {
	        filtered.setValue(Resource.FUNDS_RESOURCES[i], 0);
	    }
	}
	return filtered;
}