function PrisonedHeroDialog()
{
}

extendClass(PrisonedHeroDialog.prototype, Dialog.prototype);

PrisonedHeroDialog.prototype.estate = null;
PrisonedHeroDialog.prototype.race = null;
PrisonedHeroDialog.prototype.hero = null;

PrisonedHeroDialog.prototype.onPayRedemption = function(){};
PrisonedHeroDialog.prototype.onRelease = function(){};

PrisonedHeroDialog.create = function(hero, race, estate)
{
	var d = COM.create('PrisonedHeroDialog');
	
	d.race = race;
	d.hero = hero;
	
	d.update(estate);
	
	d.popup();
	
	return d;
}

PrisonedHeroDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.payRedemptionButton, $.proxy(function(){
		
		this.onPayRedemption(COM(this.citySelector).city, this.hero);
		//this.close();
		
	}, this));
	
	COM.bindExclusiveClick(this.releaseButton, $.proxy(function(){
		
		this.onRelease(COM(this.citySelector).city, this.hero);
		
	}, this));
	
	$(this.citySelector).on('change', $.proxy(function(){
		this.onCityChange(COM(this.citySelector).city);
	}, this));
	COM(this.citySelector).nullText = 'FROM_ALL_CITIES';
}

PrisonedHeroDialog.prototype.update = function(e)
{
	this.estate = e;
	
	var 
		isPrison = (e.owner.username == this.hero.prisonOwnerName),
		canPayRedemption = e.accessManageble && (e.owner.username == this.hero.owner), 
		canRelease = e.accessManageble && isPrison
	;
	
	this.setCaption(this.hero.name);
	this.setSubCaption(I18.f('HERO_DESCRIPTION', I18.getHeroClassName(this.hero.heroClass), this.hero.level));
	
	this.heroName.innerHTML = this.hero.name;
	this.heroDesc.innerHTML = I18.f('HERO_DESCRIPTION', I18.getHeroClassName(this.hero.heroClass), this.hero.level);
	
	COM(this.heroView).update(this.hero, this.race);
	
	UI.show(isPrison, [this.ownerBox]);
	
	if (isPrison)
	{
		this.ownerName.innerHTML = FUser.getUserNameForMessages(this.hero.owner);
		this.ownerEstateName.innerHTML = I18.formatEstateName(this.hero.prisonedFromEstateName ? this.hero.prisonedFromEstateName : "-", this.hero.prisonedFromEstateXYZ);
	}
	
	UI.show(!isPrison, [this.prisonerBox]);
	if (!isPrison)
	{
		this.prisonerName.innerHTML = this.hero.prisonOwnerName;
		this.prisonerEstateName.innerHTML = I18.formatEstateName(this.hero.prisonEstateName ? this.hero.prisonEstateName : "-", this.hero.prisonXYZ);
	}
	
	//FConfig.heroLevels[this.hero.level - 1].redemptionCost
	var cost = this.hero.heroLevel.redemptionCost.multiplyCopy(1 + this.hero.prisonCostBonus)
	if (isPrison)
	{
		cost = cost.multiplyCopy(1 - FConfig.HEROES_REDEMPTION_TAX);
	}
	COM(this.redemptionCost).update(cost, this.race);
	
	UI.show(canRelease, [this.releaseButton]);
	UI.show(canPayRedemption, [this.payRedemptionButton, this.redemptionBox]);
	
	if (!isPrison)
	{
		var selectedId = COM(this.citySelector).selectedIndex < 0 ? e.id : (!COM(this.citySelector).city ? null : COM(this.citySelector).city.id);
		COM(this.citySelector).updateCities(FUser.LINKS);
		COM(this.citySelector).cityId = selectedId;
		this.onCityChange(COM(this.citySelector).city);
	}
	else
	{
		this.redemptionBox.style.visibility = 'hidden';
	}
}

PrisonedHeroDialog.prototype.onCityChange = function(link)
{
	var bank = (link ? link.bank : FUser.getBank(EstateType.CITY));
	
	COM(this.redemptionCost).capacity = bank;
	COM(this.availableFunds).update(this.filterRedemptionFunds(bank), this.estate.owner.race);
	
	var reason = null;
	if (!bank.greaterOrEqualsTo(FConfig.heroLevels[this.hero.level - 1].redemptionCost)) reason = I18.f('NOT_ENOUGH_RESOURCES');
	COM(this.payRedemptionButton).reason = reason;
}

PrisonedHeroDialog.prototype.canBePaydForRedemption = function(r)
{
	for (var i = 0, len = FConfig.heroLevels.length; i < len; i++)
	{
	    if (FConfig.heroLevels[i].redemptionCost.getValue(r) > 0) 
	    {
	        return true;
	    }
	}
	return false;
}

PrisonedHeroDialog.prototype.filterRedemptionFunds = function(funds)
{
	var filtered = funds.copy();
	
	for (var i = 0, len = Resource.FUNDS_RESOURCES.length; i < len; i++)
	{
	    if (!this.canBePaydForRedemption(Resource.FUNDS_RESOURCES[i])) 
	    {
	        filtered.setValue(Resource.FUNDS_RESOURCES[i], 0);
	    }
	}
	return filtered;
}
