function RenameHeroDialog()
{
	callParentConstructor(RenameHeroDialog.prototype, this);
	
	this.estate = null; // FEstate
	this.hero = null; // FHero
	this.race = null; // FRace
}

extendClass(RenameHeroDialog.prototype, Dialog.prototype);

RenameHeroDialog.prototype.__construct = function()
{
	superMethod(RenameHeroDialog.prototype, '__construct', this)();
	COM.bindExclusiveClick(this.renameButton, $.proxy(this.onRename, this));
	COM.bindExclusiveClick(this.deleteHeroButton, $.proxy(function(){
		this.onDelete();
	}, this));
	
	UI.show(false, [this.deleteHeroButton]);
	
	$(this.nameInput).on('change keyup', $.proxy(function(){
		
		COM(this.renameButton).enabled = Boolean(COM(this.nameInput).value.length);
		
	}, this));
}

RenameHeroDialog.prototype.estate = null; // FEstate
RenameHeroDialog.prototype.hero = null; // FHero
RenameHeroDialog.prototype.race = null; // FHero

RenameHeroDialog.create = function(estate, hero, race, parent)
{
	var renameDialog = COM.create('RenameHeroDialog');
	renameDialog.update(estate, hero);
	renameDialog.popup(parent);
	
	return renameDialog;
}

RenameHeroDialog.prototype.update = function(estate, hero)
{
	this.hero = hero;
	this.estate = estate;
	
	COM(this.nameInput).value = htmlUnescape(COM(this.nameInput).value || this.hero.name);
	COM(this.heroFace).update(this.hero, this.race);
	$(this.descLabel).html(I18.f('HERO_DESCRIPTION', I18.getHeroClassName(this.hero.heroClass), this.hero.level));
	
	
	COM(this.deleteHeroButton).reason = (this.estate && this.estate.accessManageble && this.estate.garrisonHeroId == this.hero.id)
		? null
		: I18.f('DOESNT_WORK_NON_GARRISON_HERO')
	;
}

RenameHeroDialog.prototype.onRename = function()
{
	var hero = this.hero, estate = this.estate, val = COM(this.nameInput).value;
	this.close();
	
	if (htmlUnescape(hero.name) != val)
	{
		Service.hero.callMethod('renameHero', [estate.id, hero.id, val], 
			function(){ Alert.create(I18.f('HERO_RENAMED_SUCCESSFULLY')); }
		);
	} 
}

RenameHeroDialog.prototype.onDelete = function()
{
	
}
