function ResetHeroSkillsDialog()
{
	callParentConstructor(ResetHeroSkillsDialog.prototype, this);
}

extendClass(ResetHeroSkillsDialog.prototype, Dialog.prototype);

ResetHeroSkillsDialog.prototype.__construct = function()
{
	superMethod(ResetHeroSkillsDialog.prototype, '__construct', this)();
	COM.bindExclusiveClick(this.yesButton, $.proxy(this.onYesClick, this));
}

ResetHeroSkillsDialog.prototype.estate = null; // FEstate
ResetHeroSkillsDialog.prototype.hero = null; // FHero

ResetHeroSkillsDialog.create = function(parent, estate, hero)
{
    var dialog = COM.create('ResetHeroSkillsDialog');
    dialog.estate = estate;
    dialog.hero = hero;
    dialog.userCanClose = false;
    dialog.init();
    dialog.popup(parent);
    return dialog;
}

ResetHeroSkillsDialog.prototype.init = function()
{
    this.update(this.estate, this.hero);
}

ResetHeroSkillsDialog.prototype.update = function(estate, hero)
{
    this.estate = estate;
    this.hero = hero;
	
	this.setCaption(I18.f('RESET_HERO_SKILLS'));
	this.setSubCaption(this.hero ? this.hero.name : '');
	
    COM(this.priceLabel).update(FConfig.RESET_HERO_SKILLS_PRICE, true);
	COM(this.yesButton).skin = this.getReason() ? 'yellow' : 'green';
}

ResetHeroSkillsDialog.prototype.onError = function(e)
{
    if (e.__className__ == 'HeroException') 
    {
        Alert.create(e.getMessage());
        return true;
    }
    return false;
}

ResetHeroSkillsDialog.prototype.getReason = function()
{
    if (FUser.CURRENT_USER.pearl < FConfig.RESET_HERO_SKILLS_PRICE) 
    {
        return I18.f('NOT_ENOUGH_PEARL');
    } 
    else if (!this.estate || !this.estate.garrisonHero || this.estate.garrisonHero.id != this.hero.id) 
    {
        return I18.f('HERO_ERROR_RESET_BUSY_HERO');
    }
    else if (this.estate.isEstateUnderAttack) 
    {
        return I18.getMegaString(I18.f('HERO_ERROR_RESET_UNDER_ATTACK'), FConfig);
    }
    return null; 
}

ResetHeroSkillsDialog.prototype.onYesClick = function()
{
	var reason = this.getReason();
	if (reason)
	{
		Alert.create(reason);
		return false;
	}
    
    Service.hero.callMethod('resetHeroSkills', [this.estate.id, this.hero.id], 
    	$.proxy(this.close, this), 
    	$.proxy(this.onError, this)
	);
}