function RuneMasterView()
{
    this.tabVisible = true;
    this.tabToolTip = I18.f("RUNE_MASTER");

    this.estate = null;
}

RuneMasterView.prototype.__construct = function()
{
    COM.bindExclusiveClick(this.performRiteButton, $.proxy(this.onPerformRiteClick, this));
    COM.bindExclusiveClick(this.extractButton, $.proxy(this.onExtractRuneClick, this));
    COM(this.pearlPrice).ownerUser = FUser.CURRENT_USER;
}

RuneMasterView.prototype.update = function(estate, hero, parentDialog)
{
    this.estate = estate;

    var artifacts = estate.owner.runeMasterCube.artifacts;

    UI.makeNChilds(this.cubeTile, artifacts.length, this.slotFactory);
    for (var i=0; i<artifacts.length; i++)
    {
        var art = artifacts[i];
        var com = COM(this.cubeTile.childNodes[i]);
        com.update(estate, hero, estate.owner.runeMasterCube, i, art, [], parentDialog);
    }

    var artifact = this.findSingleArt(artifacts);
    if (artifact && artifact.runes.length > 0)
    {
        var price = FConfig.RUNE_EXTRACT_PRICE.getValueOrNull(artifact.runes.length);
        this.pearlPrice.update(price);
        this.extractButton.reason = estate.owner.pearl >= price ? "" : I18.f("NOT_ENOUGH_PEARL");
    }
    else
    {
        this.pearlPrice.update(0);
        //extractButton.enabled = false;
        extractButton.reason = I18.f("EXTRACT_RUNE_TIP");
    }

}

RuneMasterView.prototype.onPerformRiteClick = function()
{
    Service.hero.callMethod("performRite", [estate.id], null, function (e) {
            if (e.__CLS__ == "HeroException")
            {
                GameAlert.create(e.getMessage());
                return true;
            }
            return false;
        }
    );
}

RuneMasterView.prototype.onExtractRuneClick = function()
{
    Service.hero.callMethod("extractRunes", [estate.id], null, function (e) {
            if (e.__CLS__ == "HeroException")
            {
                GameAlert.create(e.getMessage());
                return true;
            }
            return false;
        }
    );
}

RuneMasterView.prototype.findSingleArt = function(artifacts)
{
    var result = null;
    for(var i=0; i<artifacts.length; i++)
    {
        var art = artifacts[i];
        if (art)
        {
            if (result) return null;
            result = art;
        }
    }

    return result;
}

RuneMasterView.prototype.slotFactory = function()
{
    var slot = new ArtifactSlotView();
    slot.isCube = true;
    return slot;
}