function SellArtifactDialog()
{
	callParentConstructor(SellArtifactDialog.prototype, this);
	
	this.estate = null; // FEstate
	this.fromList = null; // FArtifactList
	this.fromPosition = null; // int
	this.toPosition = null; // int
	this.artifact = null; // FArtifact
}

extendClass(SellArtifactDialog.prototype, Dialog.prototype);

SellArtifactDialog.prototype.__construct = function()
{
	superMethod(SellArtifactDialog.prototype, '__construct', this)();
	
	$(this.creditLabel).html(I18.mega(I18.f('NEW_CREDIT'), FConfig.BUY_ARTIFACT_MAX_CREDIT_PART));
	
	COM.bindExclusiveClick(this.sellButton, $.proxy(this.onSell, this));
	COM.bindExclusiveClick(this.cancelButton, $.proxy(this.close, this));
	
	COM(this.sellPrice).checkPrice = $.proxy(this.checkPrice, this);
}

SellArtifactDialog.prototype.estate = null; // FEstate
SellArtifactDialog.prototype.fromList = null; // FArtifactList
SellArtifactDialog.prototype.fromPosition = null; // int
SellArtifactDialog.prototype.toPosition = null; // int
SellArtifactDialog.prototype.artifact = null; // FArtifact

SellArtifactDialog.create = function(estate, fromList, fromPosition, toPosition)
{
	var result = COM.create('SellArtifactDialog');
	
	result.estate = estate;
	result.fromList = fromList;
	result.fromPosition = fromPosition;
	result.toPosition = toPosition;
	result.artifact = fromList.artifacts[fromPosition];
	
	result.init();
	result.popup();
}

SellArtifactDialog.prototype.init = function()
{
	COM(this.artifactInfo).update(this.artifact);
	this.updatePrice(1);
}

SellArtifactDialog.prototype.updatePrice = function(count)
{
	COM(this.sellPrice).update(this.artifact.price * count);
}

SellArtifactDialog.prototype.onSell = function()
{
	COM(this.sellButton).enabled = false;
	APP.showLoader();
	Service.hero.callMethod('sellArtifact', [this.estate.id, this.fromList.id, this.fromPosition, this.toPosition],
        $.proxy(function(){
        	APP.hideLoader(); 
        	this.close(); 
        	Alert.create(I18.f('ARTIFACT_SOLD'));
        }, this),
        $.proxy(function (e){
        	APP.hideLoader(); 
        	this.close(); 
            if (e.__className__ == 'HeroException') 
            {
                Alert.create(e.getMessage());
                return true;
            }
            return false;
        }, this)
	);
}

SellArtifactDialog.prototype.checkPrice = function(ignore)
{
	return true;
}