function SkillsBranchView()
{
	this.onSelect = null; // Function
	this.estate = null; // FEstate
	this.hero = null; // FHero
	this.branch = null; // SkillBranch
	this.branchIndex = null; // int
}

SkillsBranchView.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.newBranchButton, $.proxy(this.showChooseBranchDialog, this));
	COM.bindExclusiveClick(this.selectBranchButton, $.proxy(function(){
		
		if (typeof this.onSelect == 'function')
		{
			this.onSelect(this.branch.name);
		}
		
	}, this));
}

SkillsBranchView.prototype.onSelect = null; // Function
SkillsBranchView.prototype.estate = null; // FEstate
SkillsBranchView.prototype.hero = null; // FHero
SkillsBranchView.prototype.branch = null; // SkillBranch
SkillsBranchView.prototype.branchIndex = null; // int

SkillsBranchView.prototype.update = function(estate, hero, buffs, branch, requiedLevel)
{
    this.estate = estate;
    this.hero = hero;
    this.branch = branch;

	UI.show(!this.branch.isDummy || Assets.getSkillStub(this.hero.heroClass), [this.DOM]);
	
    for (var i = 0, len = this.skillsContainer.children.length; i < len; i++) 
    {
        COM(this.skillsContainer.children[i]).update(this.branch, i, this.estate, this.hero, this.buffs, Boolean(this.onSelect));
    }

    if (UI.show(!this.branch.isDummy, [this.skillLabel])) 
    {
        this.skillLabel.innerHTML = I18.getBranchName(this.branch.name);
    }

	UI.show(this.branch.isDummy && this.estate && this.estate.accessManageble, [this.newBranchButton]);
    
    var newBranchEnabled = (this.hero.level >= requiedLevel);
    
    COM(this.newBranchButton).reason = newBranchEnabled ? null : I18.f('HERO_LEVEL_X_REQUIRED', requiedLevel);
    this.newBranchButton.title = newBranchEnabled ? I18.f('CHOOSE_NEW_SKILL_BRANCH') : I18.f('HERO_LEVEL_X_REQUIRED', requiedLevel);
    COM(this.newBranchButton).icon = STATIC_INTERFACE_URL + HeroAssets.ADD_BRANCH_BUTTON;
	
	$(this.skillsContainer).toggleClass('dummy', !!this.branch.isDummy);

    //console.log(Boolean(this.onSelect), this.onSelect, this);
    if (UI.show(Boolean(this.onSelect), [this.selectBranchButton]))
    {
    	UI.show(false, [this.skillLabel]);
    	COM(this.selectBranchButton).caption = I18.getBranchName(this.branch.name);
    }
}

SkillsBranchView.prototype.showChooseBranchDialog = function(e)
{
    if (COM(this.newBranchButton).enabled) 
    {
        if (this.hero.branches.length == 0) 
        {
            var filter = ["STRATEG", "GOVERNOR", "MAGE"];
            var classes = [];
            var items = [];
            for (var i = 0, len = FConfig.heroClasses.raw.length; i < len; i++) 
            {
                var name = FConfig.heroClasses.raw[i].key;
                if (filter.indexOf(name) >= 0) 
                {
                    items.push(I18.getHeroClassName(name));
                    classes.push(name);
                }
            }

		    var d = COM.create('Dialog');
		    d.content.style.width = '640px'; 
		    d.content.style.boxSizing = 'border-box';
		    d.setCaption(I18.f('SELECT_CLASS'));
		    d.userCanClose = false;
		    d.shader.style.opacity = 0.5;
		    
		    var select = COM.create('ComboBox');
		    select.dataProvider = items;
		    $(select.DOM).on('change', $.proxy(function(){
		    	this.hero.heroClass = classes[select.selectedIndex];
		    	d.close();
		    	ChooseBranchDialog.create(this.hero, this.estate);
		    }, this))
		    
		    d.content.appendChild(select.DOM);
		    d.popup();
		    
		    var h = parseInt(window.getComputedStyle(select.DOM).height), p = 24;    
		    d.content.style.height = (h+2*p)+'px';
		    d.content.style.padding = p+'px';
		    d.fitLayout();
        } 
        else 
        {
		    ChooseBranchDialog.create(this.hero, this.estate);
        }
    }
}