function SkillsView()
{
	this.tabVisible = true; // Boolean
	this.tabToolTip = I18.f('SKILLS'); // String
	
	this.hero = null; // FHero
	this.estate = null; // FEstate
	this.resetSkillsDialog = null; // ResetHeroSkillsDialog
	this.phase = null; // Boolean
}

SkillsView.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.resetSkillsButton, $.proxy(this.onResetClick, this));
}

SkillsView.prototype.tabVisible = true; // Boolean
SkillsView.prototype.tabToolTip = I18.f('SKILLS'); // String

SkillsView.prototype.hero = null; // FHero
SkillsView.prototype.estate = null; // FEstate
SkillsView.prototype.resetSkillsDialog = null; // ResetHeroSkillsDialog

SkillsView.prototype.phase = null; // Boolean

SkillsView.prototype.update = function(estate, h, buffs)
{
	this.hero = h;
	this.estate = estate;
	
	var hBranch = h.branches.length ? h.branches[0] : SkillBranch.createNewBranch(null, 3);
	for (var i = 0, len = this.commonSkills.children.length; i < len; i++)
	{
		COM(this.commonSkills.children[i]).update(hBranch, i, estate, h, buffs);
	}
	
	var branches = this.branches.getElementsByTagName('SkillsBranchView');
	for (var i = 0, len = branches.length; i < len; i++)
	{
	    var branch = h.branches.length > (i+1) 
	    	? h.getBranch(i+1) 
	    	: SkillBranch.createNewBranch(null, 7)
	    ;
		COM(branches.item(i)).update(estate, h, buffs, branch, FHero.getRequiredLevelForBranch(i+1));
	}
	
	if (UI.show(h && !FUser.isMonster(h.owner), [this.skillPointsLabel]))
	{
	    this.skillPointsLabel.innerHTML = I18.f('SKILL_POINTS_LEFT', h.skillPointsLeft);
	}
	
	UI.show(this.hero != null && this.hero.owner == FUser.CURRENT_USER.username, [this.resetSkillsButton]);
	
	if (!this.hero.hasSkillsToReset) 
	{
	    COM(this.resetSkillsButton).enabled = false;
	    this.resetSkillsButton.title = I18.f('HERO_ERROR_NOTHING_TO_RESET');
	} 
	else 
	{
	    COM(this.resetSkillsButton).enabled = true;
	    this.resetSkillsButton.title = '';
	}
	
	if (this.resetSkillsDialog) 
	{
	    this.resetSkillsDialog.update(this.estate, this.hero);
	}
	
	this.tick();
}

SkillsView.prototype.tick = function()
{
	var color = Effects.BLACK;
	if (this.estate && this.estate.isEstateUnderAttack) 
	{
	    color = Effects.DARK_GREY;
	} 
	else if (this.hero.skillPointsLeft > 0 && this.hero.needsAttention && this.phase) 
	{
	    color = Effects.RED;
	} 
	else 
	{
	    color = Effects.BLACK;
	}
	$(this.skillPointsLabel).css("color", color);
	this.phase = !this.phase;
}

SkillsView.prototype.onResetClick = function()
{
	if (this.hero.hasSkillsToReset) 
	{
	    this.resetSkillsDialog = ResetHeroSkillsDialog.create(this, this.estate, this.hero);
	    this.resetSkillsDialog.onClose = $.proxy(function(){
	    	this.resetSkillsDialog = null;
	    }, this);
	}
}