function SpellTip()
{
}

SpellTip.prototype.__construct = function()
{
}

SpellTip.alert = function(spell, buffs, cannotCastReasons, cannotCastAdditional, actions)
{
	var spellTip = SpellTip.create(spell, buffs, cannotCastReasons, cannotCastAdditional);
	
	var caption = I18.f((spell.fromArtifact 
		? 'ARTIFACT_TYPE_' + spell.artifactDeclaration.type.name 
		: 'SPELL'
	) + '_NAME'); 
	var a = TipDialog.createWithActions(spellTip.DOM.outerHTML, caption, actions);
	return a;
}

SpellTip.create = function(spell, buffs, cannotCastReasons, cannotCastAdditional)
{
	var spellTip = COM.create('SpellTip');
	spellTip.update(spell, buffs, cannotCastReasons, cannotCastAdditional);
	return spellTip;
}

SpellTip.prototype.update = function(spell, buffs, cannotCastReasons, cannotCastAdditional)
{
	var spellTypeText = !spell.fromArtifact ? I18.f('SPELL_NAME') : (spell.artifactDeclaration.type.name == ArtifactType.SCROLL.name ? I18.f('SCROLL_NAME') : '');
	if (UI.show(spellTypeText, [this.spellType]))
	{
	    this.spellType.innerHTML = spellTypeText;
	}
	this.spellName.innerHTML = Texts.spellName(spell.name);
	COM(this.spellText).update(spell.name, spell.config, spell.fromArtifact, spell.fromQuest, buffs, cannotCastReasons);
	
	var isBottle = spell.fromArtifact && spell.artifactDeclaration.isBottle();
	
	var pic = null;
	if(isBottle) pic = ArtifactAssets[spell.artifactDeclaration.pic];
	else pic = Assets.getSkillImageRaw(spell.fromArtifact ? spell.artifactDeclaration.pic : spell.name);
	
	if(pic) this.spellImage.src = STATIC_INTERFACE_URL + pic;
	else this.spellImage.style.display = "none";
	
	/*
	this.spellImage.src = STATIC_INTERFACE_URL + (isBottle 
		? ArtifactAssets[spell.artifactDeclaration.pic]
        : Assets.getSpellImageForScroll(spell.fromArtifact ? spell.artifactDeclaration.pic : spell.name)
	);
	*/
	
	COM(this.cantCastAdditional).update(cannotCastAdditional);
}