function HeroSwitcher()
{
	this.__defineGetter__('currentIndex', this.getCurrentIndex);
	this.__defineSetter__('currentIndex', this.setCurrentIndex);
	
	this.__defineGetter__('hero', this.getHero);
	this.__defineSetter__('hero', this.setHero);
	
	this.__defineGetter__('deleteHero', function(){
		return this._deleteHero;
	});
	this.__defineSetter__('deleteHero', function(fn){
		this._deleteHero = fn;
		for (var i = 0; i < this.heroes.children.length; i++)
		{
			COM(this.heroes.children[i]).deleteHero = fn;
		}
	});
	
	this.__defineGetter__('small', function(){
		return $(this.DOM).hasClass('small');
	});
	
	this.__defineSetter__('small', function(val){
		$(this.DOM).toggleClass('small', !!val);
		for (var i = 0; i < this.heroes.children.length; i++)
		{
			COM(this.heroes.children[i]).small = val;
		}
	});
	
	this.estate = null; // FEstate
	this.race = null; // Race
	this.army = null; // Army

	this.onSwitchHero = null;
	this.onDeleteHero = null;
	this.onLockChange = null;
}

HeroSwitcher.prototype.estate = null; // FEstate
HeroSwitcher.prototype.race = null; // Race
HeroSwitcher.prototype.army = null; // Army

HeroSwitcher.prototype.switchHero = null;
HeroSwitcher.prototype._deleteHero = null;

HeroSwitcher.prototype.__construct = function()
{
	this.init();
	this.small = this.DOM.hasAttribute('small') ? this.DOM.getAttribute('small') : false;
}

HeroSwitcher.prototype.init = function()
{
	var self = this;
	$(this.DOM).css('opacity', 0);
	
	this.scroll = new iScroll(this.heroes.parentNode, {
		hScroll: true, vScroll: false,
		hScrollbar: false, vScrollbar: false,
		snap: 'WideHeroInfo',
		bounce: false,
		momentum: false,

		onScrollMove: function(){ self.lock(true); },
		onScrollEnd: $.proxy(this.heroSwitched, this),
	});
	
	$(this.heroes).on('webkitTransitionEnd', function(e){
		self.lock(false);
	});
}

HeroSwitcher.prototype.onLockChange = null;
HeroSwitcher.prototype._locked = false;
HeroSwitcher.prototype.lock = function(flag)
{
	if (!(this._locked ^ (!!flag))) return;
	this._locked = !!flag;
	$('> *', this.heroes).toggleClass('disabled', this._locked);
	
	if (typeof this.onLockChange == 'function') this.onLockChange(this._locked);
}

HeroSwitcher.prototype.heroSwitched = function()
{
	var com = COM(this.heroes.children[this.currentIndex]);
	if (!com) return;
	
	var hero = com.hero;
	if (this._hero.id == hero.id) return;
	
	if (typeof this.switchHero == 'function')
	{
		this.switchHero(hero);
	}
	this.updateUIItems();
}

HeroSwitcher.prototype.heroDeleted = function()
{
	var com = COM(this.heroes.children[this.currentIndex]);
	if (typeof com.deleteHero == 'function')
	{
		com.deleteHero(this.hero);
	}
	// switch to nearest hero
	this.updateUIItems();
}

HeroSwitcher.prototype.getCurrentIndex = function()
{
	return this.scroll ? this.scroll.currPageX*1 : 0;
}

HeroSwitcher.prototype.setCurrentIndex = function(val)
{
	if (this.currentIndex != val)
	{
		if (!this.scroll || !this.scroll.scrollerW || !this.scroll.pagesX.length)
		{
			return setTimeout($.proxy(function(){ this.currentIndex = val; }, this), 50);
		}
		this.scroll.scrollToPage(val*1, 0, 0);
	}
	this.updateUIItems();
	$(this.DOM).css('opacity', 1);
}

HeroSwitcher.prototype._hero = null;
HeroSwitcher.prototype.getHero = function()
{
	return this._hero;
}

HeroSwitcher.prototype.setHero = function(val)
{
	this._hero = val;
	this.refreshScroll(50);
}

HeroSwitcher.prototype.updateUIItems = function(heroes)
{
	var cnt = heroes ? heroes.length : this.heroes.children.length;
	var len = this.heroes.children.length;
	while (len > cnt)
	{
		this.heroes.removeChild(this.heroes.children[0]);
		len--;
	}
	while (len < cnt)
	{
		var com = COM.create('WideHeroInfo');
		com.small = this.small;
		com.deleteHero = this._deleteHero;
		this.heroes.appendChild(com.DOM);
		if (len != 0) $(com.DOM).css('opacity', 0);
		len++;
	}
	
	if (UI.show(cnt > 1, [this.dots]))
	{
		len = this.dots.children.length;
		while (len > cnt)
		{
			$(this.dots.children[0]).remove();
			len--;
		}
		while (len < cnt)
		{
			var dot = document.createElement('dot');
			dot.setAttribute('n', len);
			COM.bindExclusiveClick(dot, $.proxy(function(e){
				this.currentIndex = e.currentTarget.getAttribute('n')*1;
			}, this))
			this.dots.appendChild(dot);
			len++;
		}
		
		$('dot', this.dots).removeClass('active');
		$('dot', this.dots)[this.currentIndex].className = 'active';
	}
	
	return cnt;
}

HeroSwitcher.prototype.update = function(estate, race, hero, army, buffs, heroes)
{
	this.estate = estate;
	this.race = race;
	this.army = army;
	
	heroes = heroes || (estate 
		? (estate.heroes.length ? estate.heroes : [null])
		: [hero || null]
	);
	
	// update views
	var len = this.updateUIItems(heroes);
	for (var i = 0; i < len; i++)
	{
		COM(this.heroes.children[i]).update(estate, race, heroes[i], army, buffs);
	}
	
	// update current view
	this.hero = hero;
	
	this.scroll.enabled = (heroes.length > 1);
	this.fitLayout(50);
	this.tick();
}

HeroSwitcher.prototype.tick = function()
{
	if (this.estate && this.hero)
	{
		this.currentIndex = HeroDialog.findHero(this.estate.heroes, this.hero);
	}
}

HeroSwitcher.prototype.fitLayout = function(timeout)
{
	if (timeout) return setTimeout($.proxy(this.fitLayout, this), timeout*1);
	
	var w = this.heroes.parentNode.offsetWidth;
	var len = this.heroes.children.length;
	for (var i = 0; i < len; i++)
	{
		this.heroes.children[i].style.width = (w+2) + 'px';
	}
	this.heroes.style.width = (len * w)+'px';
	
	this.refreshScroll(50);
}

HeroSwitcher.prototype.refreshScroll = function(timeout)
{
	if (timeout) return setTimeout($.proxy(this.refreshScroll, this), timeout*1);
	
	this.scroll.refresh();
	
	// update scroll position to current hero
	for (var i = 0; i < this.heroes.children.length; i++)
	{
		var hero = COM(this.heroes.children[i])['hero'] || null;
		/*
		if ((!hero && !this._hero) || (hero.id == this._hero.id))
		{
			this.currentIndex = i;
			break;
		}
		*/
		if (hero && this._hero && (hero.id == this._hero.id))
		{
			this.currentIndex = i;
			break;
		}
	}
	
	$('WideHeroInfo', this.heroes).css('opacity', 1);
}

HeroSwitcher.prototype.onMaxManaToolTip = function(e)
{
	//e.toolTip = NumberEffectTip.createTip("MAX_MANA", this.hero.buffs, 0, BuffType.HERO_MAX_MANA, FEstate.tickNowForEstate(this.estate));
}

HeroSwitcher.prototype.onManaToolTip = function(e)
{
	//e.toolTip = Tip.createGrid(UI.styledText(I18.f('MANA'), Style.BOLD));
}

HeroSwitcher.prototype.onMaxExpToolTip = function(e)
{
	//e.toolTip = Tip.createGrid(UI.styledText(I18.f('MAX_EXPERIENCE'), Style.BOLD));
}

HeroSwitcher.prototype.onExpToolTip = function(e)
{
	//e.toolTip = Tip.createGrid(UI.styledText(I18.f('EXPERIENCE'), Style.BOLD));
}

HeroSwitcher.prototype.onRegenToolTip = function()
{
	if (!this.hero) return;
	var tip;
	if (this.hero.manaRegenPerHour != 0) 
	{
	    tip = NumberEffectTip.createManaRegenTip(this.hero.buffs, this.army, FEstate.tickNowForEstate(this.estate));
	} 
	else if (this.hero.isMaxManaReached()) 
	{
	    tip = I18.f('MAX_MANA_LIMIT_REACHED');
	} 
	else 
	{
		tip = document.createElement('div');
	    if (!this.estate) 
	    {
	        $(tip).html(I18.f('MANA_REGEN_IN_MISSION', hero.manaRegenPerHour)).addClass('negative');
	    } 
	    else if (this.hero.isUpset()) 
	    {
	        if (this.hero.upsetByFight) 
	        {
	        	$(tip).html(I18.f('MANA_REGEN_UPSET', hero.manaRegenPerHour)).addClass('negative');
	        }
	        if (this.hero.upsetByTitle) 
	        {
	        	$(tip).html(I18.f('HERO_ERROR_REQUIRED_MAX_TITLE')).addClass('negative');
	        }
	    } 
	    else if (!this.estate.garrisonHero || this.estate.garrisonHero.id != this.hero.id) 
	    {
        	$(tip).html(I18.f('MANA_REGEN_IN_HIDEOUT', hero.manaRegenPerHour)).addClass('negative');
	    }
	}
    
    return Alert.create(tip, I18.f('MANA_REGEN'));
}
