function HeroTabParent()
{
	this.__defineGetter__('heroView', this.getHeroView);

	this.__defineGetter__('switchHero', this.getSwitchHero);
	this.__defineSetter__('switchHero', this.setSwitchHero);
	
	this.__defineGetter__('deleteHero', this.getDeleteHero);
	this.__defineSetter__('deleteHero', this.setDeleteHero);
	
	this.parentDialog = null; // HeroDialog
	this.estate = null; // FEstate
	this.race = null; // Race
	this.hero = null; // FHero
	this.army = null; // FArmy
	
	this.time = null; // Number
	
	this.scroll = [];
}

HeroTabParent.prototype.parentDialog = null; // HeroDialog
HeroTabParent.prototype.estate = null; // FEstate
HeroTabParent.prototype.race = null; // Race
HeroTabParent.prototype.hero = null; // FHero
HeroTabParent.prototype.army = null; // FArmy
HeroTabParent.prototype.buffs = null; // FArmy

HeroTabParent.prototype.time = null; // Number

HeroTabParent.prototype.__construct = function()
{
	var self = this;
	setTimeout(function()
	{
		self.addScroll(self.scrollWrapper);
	}, 1000);
}

HeroTabParent.prototype.update = function(parentDialog)
{
	if (this.hero && parentDialog.mainHero && this.hero.id != parentDialog.mainHero.id && this.bagView) 
	{
	    COM(this.bagView).reset();
	}
	
	this.parentDialog = parentDialog;
	this.race = parentDialog.race;
	this.estate = parentDialog.estate;
	this.hero = parentDialog.mainHero;
	this.army = parentDialog.army;
	this.buffs = parentDialog.buffs;
	
	COM(this.heroView).update(this.estate, this.race, this.hero, this.army, this.buffs);
	
	var doll = this.dollView ? (this.dollView instanceof Array ? this.dollView[0] : this.dollView) : null;
	if (doll) COM(doll).update(this.estate, this.hero, this.buffs, this.parentDialog);
	
	var bag = this.bagView ? (this.bagView instanceof Array ? this.bagView[0] : this.bagView) : null;
	if (bag) COM(bag).update(this.estate, this.hero, this.parentDialog);
}

HeroTabParent.prototype.tick = function(time)
{
	this.time = time;
	
	var lbl1 = this.bagSizeLabel1 ? (this.bagSizeLabel1 instanceof Array ? this.bagSizeLabel1[0] : this.bagSizeLabel1) : null;
	var lbl2 = this.bagSizeLabel2 ? (this.bagSizeLabel2 instanceof Array ? this.bagSizeLabel2[0] : this.bagSizeLabel2) : null;
	
	if (lbl1 && lbl2 && this.hero) 
	{
		var count = 0;
		for(var i = 0, len = this.hero.bag.artifacts.length; i < len; i++) 
		{
		    if (this.hero.bag.artifacts[i]) 
		    {
		        count++;
		    }
		}
		
		lbl1.innerHTML = count;
		lbl2.innerHTML = this.hero.bagSize;
	}
}

HeroTabParent.prototype.addScroll = function(nodes, params)
{
	var defaults = {
		hScroll: false, 
		vScroll: true, 
		scrollbarColor: '#784f0b',
		hideScrollbar: true,
		bounce: false,
		forcedRepaint: true
	};
	params = $.extend(defaults, params);
	
	if (!$.isArray(nodes)) nodes = [nodes];
	
	for (var i = 0; i < nodes.length; i++)
	{
		var s = (nodes[i] instanceof iScroll) ? nodes[i] : new iScroll(nodes[i], params);
		this.scroll.push(s);
	}
	
	var heroSwitchers = this.DOM.querySelectorAll('HeroSwitcher'), self = this;
	for (var i = 0, len = heroSwitchers.length; i < len; i++)
	{
		COM(heroSwitchers[i]).onLockChange = function(flag)
		{
			for (var j = 0; j < self.scroll.length; j++)
			{
				self.scroll[j][flag ? 'disable' : 'enable']();
			}
		}
	}
	
	this.refreshScroll(300);
}

HeroTabParent.prototype.fitLayout = function()
{
	COM(this.heroInfo).fitLayout();
	this.refreshScroll(300);
}

HeroTabParent.prototype.refreshScroll = function(timeout)
{
	if (!this.scroll.length) return;
	if (timeout*1)
	{
		return setTimeout($.proxy(this.refreshScroll, this), timeout*1);
	}
	for (var i = 0; i < this.scroll.length; i++)
	{
		this.scroll[i].refresh();
	}
}

HeroTabParent.prototype.getStore = function()
{
	return this.estate ? this.estate.findBuilding(BType.ARTIFACT_STORE) : null;
}

HeroTabParent.prototype.getHasStore = function()
{
	return Boolean(this.estate && this.estate.accessHideout && this.store && this.store.isWorking);
}

HeroTabParent.prototype.getHasHero = function()
{
	return Boolean(this.mainHero);
}

HeroTabParent.prototype.getHasAlchemy = function()
{
	return Boolean(FUser.CURRENT_USER.science.getLevel(Science.ALCHEMY) >= 1 || FUser.CURRENT_USER.role.canSpyAndObserve());
}

HeroTabParent.prototype.getHasAlchemy2 = function()
{
	return Boolean(FUser.CURRENT_USER.science.getLevel(Science.ALCHEMY) >= 2 || FUser.CURRENT_USER.role.canSpyAndObserve());
}

HeroTabParent.prototype.getHeroView = function()
{
	return (this.heroInfo instanceof Array) ? this.heroInfo[0] : this.heroInfo;
}

HeroTabParent.prototype.getSwitchHero = function()
{
	return COM(this.heroView).switchHero;
}

HeroTabParent.prototype.setSwitchHero = function(val)
{
	COM(this.heroView).switchHero = val;
}

HeroTabParent.prototype.getDeleteHero = function()
{
	return COM(this.heroView).deleteHero;
}

HeroTabParent.prototype.setDeleteHero = function(val)
{
	COM(this.heroView).deleteHero = val;
}

HeroTabParent.prototype.collectImages = function()
{
	return [];
	var heroes = this.estate 
		? (this.estate.heroes.length ? this.estate.heroes : [])
		: (this.hero ? [this.hero] : [])
	;
	
	var images = [
		STATIC_INTERFACE_URL + Assets.getHeroBack({male:true}),
		STATIC_INTERFACE_URL + Assets.getHeroBack({male:false}),
		STATIC_INTERFACE_URL + 'shared/heroes/pentagram.png',
		STATIC_INTERFACE_URL + SkillAssets.SKILL_BORDER,
		STATIC_INTERFACE_URL + SkillAssets.SKILL_ACTIVE_BORDER
	];

	for (var n = 0; n < heroes.length; n++)
	{
		var hero = heroes[n]; if (!hero) continue;
		
		images.push(STATIC_INTERFACE_URL + Assets.getSkillStub(hero.heroClass));
		
		for (var i = 0; i < hero.body.artifacts.length; i++)
		{
			var art = hero.body.artifacts[i];
			if (art) images.push(STATIC_INTERFACE_URL + Assets.getArtifact(art.declaration));
		}
		for (var i = 0; i < hero.bag.artifacts.length; i++)
		{
			var art = hero.bag.artifacts[i];
			if (art) images.push(STATIC_INTERFACE_URL + Assets.getArtifact(art.declaration));
		}
	}

	return images;
}

