function RuneMasterUI()
{
    this.tabVisible = true;
    this.tabToolTip = I18.f("RUNE_MASTER");

    this.estate = null;
}

RuneMasterUI.prototype.__construct = function()
{
    COM.bindExclusiveClick(this.performRiteButton, $.proxy(this.onPerformRiteClick, this));
    COM.bindExclusiveClick(this.extractButton, $.proxy(this.onExtractRuneClick, this));
    COM(this.pearlPrice).ownerUser = FUser.CURRENT_USER;
}

RuneMasterUI.prototype.update = function(estate, hero, parentDialog)
{
    this.estate = estate;

    var artifacts = this.estate.owner.runeMasterCube.artifacts;

    UI.makeNChilds(this.cubeTile, artifacts.length, this.slotFactory);
    for (var i=0; i<artifacts.length; i++)
    {
        var art = artifacts[i];
        var com = COM(this.cubeTile.childNodes[i]);
        com.update(this.estate, hero, this.estate.owner.runeMasterCube, i, art, [], parentDialog);
    }

    var artifact = this.findSingleArt(artifacts);
    if (artifact && artifact.runes.length > 0)
    {
        var price = FConfig.RUNE_EXTRACT_PRICE.getValueOrNull(artifact.runes.length);
        COM(this.pearlPrice).update(price);
        COM(this.extractButton).reason = this.estate.owner.pearl >= price ? null : I18.f("NOT_ENOUGH_PEARL");
    }
    else
    {
        COM(this.pearlPrice).update(0);
        COM(this.extractButton).reason = I18.f("EXTRACT_RUNE_TIP");
    }

}

RuneMasterUI.prototype.onPerformRiteClick = function()
{
    Service.hero.callMethod("performRite", [this.estate.id], null, function (e) {
            if (e.__className__ == "HeroException")
            {
                Alert.create(e.getMessage());
                return true;
            }
            return false;
        }
    );
}

RuneMasterUI.prototype.onExtractRuneClick = function()
{
    Service.hero.callMethod("extractRunes", [this.estate.id], null, function (e) {
            if (e.__className__ == "HeroException")
            {
                Alert.create(e.getMessage());
                return true;
            }
            return false;
        }
    );
}

RuneMasterUI.prototype.findSingleArt = function(artifacts)
{
    var result = null;
    for(var i=0; i<artifacts.length; i++)
    {
        var art = artifacts[i];
        if (art)
        {
            if (result) return null;
            result = art;
        }
    }

    return result;
}

RuneMasterUI.prototype.slotFactory = function()
{
    var slot = COM.create('ArtifactSlotView');
    slot.isCube = true;
    return slot;
}