function MarketAuctionDialog()
{
	callParentConstructor(MarketAuctionDialog.prototype, this);
	
	this.estate = null;
	this.lot = null;
	this.auction = null;

	this.onSuccess = null;
	this.onError = null;
}

extendClass(MarketAuctionDialog.prototype, Dialog.prototype);

MarketAuctionDialog.prototype.estate = null;
MarketAuctionDialog.prototype.lot = null;
MarketAuctionDialog.prototype.auction = null;

MarketAuctionDialog.prototype.onSuccess = null;
MarketAuctionDialog.prototype.onError = null;

MarketAuctionDialog.create = function(estate, lot, auction)
{
	var d = COM.create('MarketAuctionDialog');
	d.update(estate, lot, auction);
	d.popup();
	return d;
}

MarketAuctionDialog.prototype.__construct = function()
{
	superMethod(MarketAuctionDialog.prototype, '__construct', this);
	
    COM(this.currentStake).alwaysShow = [Resource.GOLD];
    COM(this.currentStake).showZero = false;
    COM.bindExclusiveClick(this.offerButton, $.proxy(this.doOffer, this));
    
}

MarketAuctionDialog.prototype.update = function(estate, lot, auction)
{
	this.estate = estate;
	this.lot = lot;
	this.auction = auction;
	
	if (!this.lot) this.close();
	
    COM(this.buyCount).value = this.lot.count;
    $(this.customerName).html(this.lot.lastCustomer);
    
    UI.show(this.lot.lastCustomer, [this.fromBox]);

    COM(this.currentStake).update((new Funds()).setValue(Resource.GOLD, this.lot.lastPrice), FUser.CURRENT_USER.race);
	COM(this.lotTimeLeft).value = this.lot.finishTick - Tick.now();

    COM(this.offerButton).reason = false;
    for (var i = 0; i < this.auction.lots.length; i++) 
    {
        if (this.auction.lots[i].lastCustomer == FUser.CURRENT_USER.username) 
        {
            COM(this.offerButton).reason = (this.auction.lots[i].id == this.lot.id) 
            	? false 
            	: [I18.f('CANT_TRADE_TWO_AUCTION_LOTS')]
            ;
            break;
        }
    }
    
    this.updateYourStake(this.lot);
    
	this.tick();
}

MarketAuctionDialog.prototype.tick = function()
{
	COM(this.lotTimeLeft).value = this.lot.finishTick - Tick.now();
}

MarketAuctionDialog.prototype.updateYourStake = function(lot)
{
	COM(this.yourStake).min = this.lot.lastCustomer ? this.lot.lastPrice + FConfig.AUCTION_MIN_RISE : this.lot.lastPrice;
	COM(this.yourStake).step = FConfig.AUCTION_MIN_RISE;
	COM(this.yourStake).value = this.yourStake.min*1;
	this.previousStake = COM(this.yourStake).value*1;
}

MarketAuctionDialog.prototype.doOffer = function()
{
    if (!this.lot) return;
    
    var val = COM(this.yourStake).value*1;
    
    this.userCanClose = false;
    COM(this.offerButton).enabled = false;
    
    APP.showLoader();
    Service.market.callMethod('offerPrice', [this.estate.id, this.lot.id, val],
    	$.proxy(this.handleSuccess, this), $.proxy(this.handleError, this)
    );
}

MarketAuctionDialog.prototype.handleSuccess = function(res)
{
	if (this.onSuccess) this.onSuccess(res);
	this.close();
    APP.hideLoader();
}

MarketAuctionDialog.prototype.handleError = function(res)
{
	if (this.onError) this.onError(res);
	this.close();
    APP.hideLoader();
}

