function MarketBuy()
{
	callParentConstructor(MarketBuy.prototype, this);
	
	this.info = new MarketViewInfo();
	this.buyRequestPending = false;
	this.buyBox = null;
}

extendClass(MarketBuy.prototype, MarketTabParent.prototype);

MarketBuy.prototype.info = null;
MarketBuy.prototype.buyRequestPending = false;
MarketBuy.prototype.buyBox = null;

MarketBuy.prototype.__construct = function()
{
	superMethod(MarketBuy.prototype, '__construct', this)();
	
    this.info = new MarketViewInfo();
    
	$(this.items).on('select', $.proxy(this.onSelectLot, this));
	this.lotsToBuy = COM(this.items);
	this.lotsToBuy.selectable = true;
	this.lotsToBuy.unselectable = false;
	this.lotsToBuy.loadMore = $.proxy(this.onPageChange, this);
	
	this.lotsToBuy.onChangePage = $.proxy(this.onPageChange, this);
	
    $(this.lotsToBuy.resourceFilter.DOM).on('change', $.proxy(this.onFilterByResource, this));
    $('>*', this.lotsToBuy.headerRow).each($.proxy(function(n, obj){
    	
    	COM.bindExclusiveClick(obj, $.proxy(function(){
    		if (n > 0) this.onHeaderRelease(n);
    	}, this))
    	
    }, this));
    
	COM(this.pager).onSelect = $.proxy(function(n, cnt){
		this.lotsToBuy.loadMore(n);
	}, this);
}

MarketBuy.prototype.onShow = function()
{
	superMethod(MarketBuy.prototype, "onShow", this)();
	this.lotsToBuy.loadMore(0);
}

MarketBuy.prototype.remoteUpdate = function(estateId)
{
    if (!estateId)
    {
        estateId = this.estate.id;
    }
    APP.showLoader();
    Service.market.callMethod('getAvailableSupplies', [estateId, this.info.prepareForRequest()], $.proxy(this.updateMarket, this), $.proxy(function(){
    	APP.hideLoader();
    }, this));
}

MarketBuy.prototype.tick = function()
{
	if (this.buyBox)
	{
		this.buyBox.tick();
	}
}

MarketBuy.prototype.reset = function()
{
    superMethod(MarketBuy.prototype, 'reset', this)();
    this.info.pageIndex = 0;
	COM(this.pager).enabled = true;
}

MarketBuy.prototype.updateMarket = function(m)
{
    superMethod(MarketBuy.prototype, 'updateMarket', this)(m);
    this.placeSortArrow();
    this.buyRequestPending = false;
	APP.hideLoader();
    
    this.lotsToBuy.pageLoaded(m);
    
    $('>*', this.lotsToBuy.headerRow).removeClass('positive negative');
    if (this.info.sortColumn > 0)
    {
    	$(this.lotsToBuy.headerRow.children[this.info.sortColumn]).addClass(this.info.sortAscending ? 'positive' : 'negative');
    }
    
    COM(this.pager).total = m.pageCount;
    COM(this.pager).page = m.pageIndex;
	COM(this.pager).enabled = true;
}

MarketBuy.prototype.placeSortArrow = function()
{
}

MarketBuy.prototype.onSelectLot = function()
{
    var lot = this.getSelectedLot();
    this.buyBox = MarketBuyDialog.create(this.estate, this.fmarket, this.info, lot);
    this.buyBox.buyLot = $.proxy(this.buyLot, this);
    this.buyBox.onClose = $.proxy(function(){
    	this.buyBox = null;
		this.lotsToBuy.selectedIndex = -1;
    }, this);
    this.tick();
}

MarketBuy.prototype.getSelectedLot = function()
{
    return this.lotsToBuy.value;
}

MarketBuy.prototype.onHeaderRelease = function(index)
{
    if (index > 4) return;
    if (this.info.sortColumn == index) 
    {
        this.info.sortAscending = !this.info.sortAscending;
    } 
    else 
    {
        this.info.sortAscending = true;
        this.info.sortColumn = index;
    }
    this.remoteUpdate();
}

MarketBuy.prototype.onFilterByResource = function()
{
	this.info.pageIndex = 0;
	this.info.filterResource = Resource.RESOURCES_FOR_FILTER[this.lotsToBuy.resourceFilter.selectedIndex];
	this.remoteUpdate();
}

MarketBuy.prototype.onPageChange = function(index)
{
    this.info.pageIndex = Math.max(0, index*1 || 0);
    this.remoteUpdate();
}

MarketBuy.prototype.buyLot = function(lot, amount)
{
    this.buyRequestPending = true;
    this.tick();
    
    APP.showLoader();
    Service.market.callMethod('buy', [this.fmarket.city.id, lot.username, lot.id, amount, this.info.prepareForRequest()],
    	$.proxy(this.onBuySuccess, this),
    	$.proxy(this.onBuyError, this)
    );
}

MarketBuy.prototype.onBuySuccess = function(f)
{
	this.updateMarket(f);
	this.buyRequestPending = false;
	Alert.create(I18.f('MECHANTS_HAVE_BEEN_SENT'));
	
	this.buyBox.close();
	
	this.tick();
    APP.hideLoader();
}

MarketBuy.prototype.onBuyError = function(e)
{
	this.buyBox.close();
    APP.hideLoader();
	if (e.__className__ == 'CantStartMissionException') 
	{
		Alert.create(e.getMessage());
		this.remoteUpdate();
		return true;
	}
	return false;
}


MarketBuy.prototype.fitLayout = function(container)
{
	superMethod(MarketTabParent.prototype, 'fitLayout', this)(container);
	setTimeout($.proxy(COM(this.items).refresh, COM(this.items)), 300);
}
