function MarketExchange()
{
	callParentConstructor(MarketExchange.prototype, this);
	MarketExchange.prototype.playerResources = new FMap();
	MarketExchange.prototype.allExchangeRates = null;
	MarketExchange.prototype.exchangeRates = new FMap();
	
	MarketExchange.prototype.selectedFrom = null;
	MarketExchange.prototype.selectedTo = null;
}

extendClass(MarketExchange.prototype, MarketTabParent.prototype);

MarketExchange.prototype.playerResources = null;
MarketExchange.prototype.allExchangeRates = null;
MarketExchange.prototype.exchangeRates = null;

MarketExchange.prototype.selectedFrom = null;
MarketExchange.prototype.selectedTo = null;

MarketExchange.prototype.__construct = function()
{
    APP.showLoader();
	superMethod(MarketExchange.prototype, '__construct', this)();
	
    for (var i = 0, len = FConfig.EXCHANGE_RESOURCES.length; i < len; i++) 
    {
        var res = FConfig.EXCHANGE_RESOURCES[i], btn;
        var btnProps = {
        	icon: STATIC_INTERFACE_URL + Assets.ICON_findBy(res),
        	skin: 'flat',
        	resource: res
        }
        
        btn = COM.create('SimpleButton');
        for (var prop in btnProps) btn[prop] = btnProps[prop];
        COM.bindExclusiveClick(btn.DOM, $.proxy(this.onFromClick, this));
        $(this.ownedSupplies).append(btn.DOM).append('<br/>');
        this.playerResources.put(res, btn);
        
        btn = COM.create('SimpleButton');
        for (var prop in btnProps) btn[prop] = btnProps[prop];
        COM.bindExclusiveClick(btn.DOM, $.proxy(this.onToClick, this));
        $(this.rates).append(btn.DOM).append('<br/>');
        this.exchangeRates.put(res, btn);
    }
    
	$(this.slider).on('change', $.proxy(this.onSliderMove, this));
	
	COM.bindExclusiveClick(this.exchangeButton, $.proxy(this.exchangeResource, this));
	
	$(this.fromQty).on('change', $.proxy(function(e){

		if (!COM(this.slider).data) return;
		COM(this.slider).value = Math.floor(COM(this.fromQty).value / COM(this.slider).data.min);
		this.onSliderMove();
		
	}, this));
	
	$(this.toQty).on('change', $.proxy(function(e){
		
		if (!COM(this.slider).data) return;
		COM(this.slider).value = Math.floor(COM(this.toQty).value / COM(this.slider).data.max);
		this.onSliderMove();
		
	}, this));
}

MarketExchange.prototype.onShow = function()
{
    superMethod(MarketBuy.prototype, "onShow", this)();
    Service.market.callMethod('getExchangeRates', [this.estate.id], $.proxy(this.handleRates, this));
}

MarketExchange.prototype.handleRates = function(r) // FMap
{
    APP.hideLoader();
	
	this.updateInvoked = true;
    this.allExchangeRates = r;
    
	this.selectFrom(FConfig.EXCHANGE_RESOURCES[0]);
	this.selectTo(FConfig.EXCHANGE_RESOURCES[1]);
}

MarketExchange.prototype.onFromClick = function(e)
{
	return this.selectFrom(COM(e.currentTarget).resource);
}

MarketExchange.prototype.selectFrom = function(res)
{
	res = res || this.selectedFrom;
	if (!res || (this.selectedFrom && res.name == this.selectedFrom.name)) return;
	
	if (this.selectedFrom)
	{
		this.playerResources.getValue(this.selectedFrom).skin = 'flat';
	}
	this.selectedFrom = res;
	this.playerResources.getValue(this.selectedFrom).skin = 'yellow';

    for (var i = 0, len = FConfig.EXCHANGE_RESOURCES.length; i < len; i++) 
    {
        var r2 = FConfig.EXCHANGE_RESOURCES[i], rng = this.allExchangeRates.getValue(this.selectedFrom).getValue(r2);
        this.exchangeRates.getValue(r2).caption = rng.min + "/" + rng.max;
    }
    
    this.selectTo();
}

MarketExchange.prototype.onToClick = function(e)
{
	return this.selectTo(COM(e.currentTarget).resource);
}

MarketExchange.prototype.selectTo = function(res)
{
	res = res || this.selectedTo;
	if (!res) return;
	
	if (this.selectedTo)
	{
		this.exchangeRates.getValue(this.selectedTo).skin = 'flat';
	}
	this.selectedTo = res;
	this.exchangeRates.getValue(this.selectedTo).skin = 'yellow';

    var r = this.allExchangeRates.getValue(this.selectedFrom).getValue(this.selectedTo);
    var amountFrom = this.estate.bank.getValue(this.selectedFrom);

	COM(this.fromQty).icon = STATIC_INTERFACE_URL + Assets.ICON_findBy(this.selectedFrom);
	COM(this.toQty).icon = STATIC_INTERFACE_URL + Assets.ICON_findBy(this.selectedTo);

    // preserve "fromQty" when changed "to" and
    // preserve "toQty" when changing "from"
    var oldR = COM(this.slider).data;
    if (oldR) 
    {
        var oldFromQty = COM(this.slider).value * oldR.min;
        var oldToQty = COM(this.slider).value * oldR.max;
        if (this.selectedFrom.name == oldR.fromResource.name) 
        {
            COM(this.slider).value = oldFromQty / r.min;
        } 
        else 
        {
            COM(this.slider).value = oldToQty / r.max;
        }
    }

    COM(this.slider).data = {min:r.min, max:r.max, fromResource:this.selectedFrom, toResource:this.selectedTo};
    this.adjustSliderMax();
    this.onSliderMove();
}

MarketExchange.prototype.onSliderMove = function()
{
    var value = COM(this.slider).value*1, 
    	from = this.getFromQty(value, COM(this.slider).data), 
    	to = this.getToQty(value, COM(this.slider).data)
    ;
    
    // resulting resources
    // COM(this.fromQty).value = Math.floor(this.estate.bank.getValue(this.selectedFrom) - from);
    // COM(this.toQty).value = Math.floor(this.estate.bank.getValue(this.selectedTo) + to);
    
    // exchanged resources
    COM(this.fromQty).value = Math.floor(from);
    COM(this.toQty).value = Math.floor(to);
    
    this.updateButton();
}

MarketExchange.prototype.updateButton = function()
{
    var reason = null;
    if (this.estate.isEspionage || !this.estate.accessDeputy || (this.estate.__className == 'FCastle' && !FUser.CURRENT_USER.hasClanRole(ClanRole.TREASURER)))
    {
    	reason = I18.f('NO_ACCESS');
    }
    else if (!COM(this.slider).data || COM(this.slider).value*1 == 0 || (COM(this.slider).data.fromResource == COM(this.slider).data.toResource))
    {
    	reason = I18.f('NEED_TO_FILL_DATA');
    }
    COM(this.exchangeButton).reason = reason;
    
    var canExchange = !this.estate.isEspionage && (this.estate.accessDeputy || this.estate.__className == 'FCastle' && FUser.CURRENT_USER.hasClanRole(ClanRole.TREASURER));
    var enabled = canExchange && COM(this.slider).data && COM(this.slider).data.fromResource != COM(this.slider).data.toResource;
    
    //COM(this.exchangeButton).enabled = enabled && COM(this.slider).value*1 != 0;
    COM(this.fromQty).disabled = !enabled || !COM(this.slider).enabled;
    COM(this.toQty).disabled = !enabled || !COM(this.slider).enabled;
}

MarketExchange.prototype.tick = function()
{
    for (var i = 0, len = FConfig.EXCHANGE_RESOURCES.length; i < len; i++)
    {
    	var res = FConfig.EXCHANGE_RESOURCES[i], btn = this.playerResources.getValue(res);
        var newAmount = Math.floor(this.estate.bank.getValue(res));
        btn.caption = newAmount;
    } 
    this.adjustSliderMax();
    this.updateButton();
}

MarketExchange.prototype.handleError = function(e)
{
    APP.hideLoader();
    if (e.__className == 'MarketException') 
    {
        Alert.create(e.getMessage());
        return true;
    }
	return false;
}

MarketExchange.prototype.handleSuccess = function(c)
{
    APP.hideLoader();
	this.tick();
    
    // reset values to zero
    COM(this.slider).value = 0;
    this.onSliderMove();
    
	Alert.create(I18.f('YOU_HAVE_PERFORMED_EXCHANGE'));
}

MarketExchange.prototype.exchangeResource = function()
{
    this.tick();
    var val = this.getFromQty(COM(this.slider).value*1, COM(this.slider).data);
    APP.showLoader();
    Service.market.callMethod('exchange', 
    	[this.estate.id, this.selectedFrom, this.selectedTo, val],
    	$.proxy(this.handleSuccess, this), $.proxy(this.handleError, this)
    );
}

MarketExchange.prototype.getFromQty = function(value, data)
{
    if (!data) 
    {
        return 0;
    }
    return value * data.min;
}

MarketExchange.prototype.getToQty = function(value, data)
{
    if (!data) 
    {
        return 0;
    }
    return value * data.max;
}

MarketExchange.prototype.adjustSliderMax = function()
{
    if (!COM(this.slider).data || !this.selectedFrom || !this.selectedTo) 
    {
        COM(this.slider).enabled = false;
        return;
    }
    
    var amountFrom = this.estate.bank.getValue(this.selectedFrom);
    var r = COM(this.slider).data;
    
    COM(this.slider).enabled = this.estate.accessDeputy && amountFrom >= r.min && this.selectedFrom.name != this.selectedTo.name;
    COM(this.slider).max = amountFrom / r.min;
    
    if (COM(this.slider).value*1 > COM(this.slider).max*1) 
    {
        COM(this.slider).value = COM(this.slider).max*1;
    }
    
    COM(this.fromQty).max = this.getFromQty(amountFrom, r);
    COM(this.toQty).max = this.getToQty(amountFrom, r);
}
