function MarketSell()
{
	callParentConstructor(MarketSell.prototype, this);
}

extendClass(MarketSell.prototype, MarketTabParent.prototype);

MarketSell.prototype.__construct = function()
{
	superMethod(MarketSell.prototype, '__construct', this)();
	
	//dataProviderArray="{Resource.MARKET_RESOURCES}" change="tick()"
	var resProvider = [];
	for (var i = 0, len = Resource.MARKET_RESOURCES.length; i < len; i++)
	{
		var r = Resource.MARKET_RESOURCES[i];
		resProvider.push({
			label: I18.getResourceName(r),
			value: r
		});
	}
	COM(this.supplyResource).dataProvider = resProvider;
	$(this.supplyResource).on('change', $.proxy(this.tick, this));
	
	$(this.supplyAmount).on('change', $.proxy(this.tick, this));
	
	$(this.supplyPrice).on('change', $.proxy(this.tick, this));
	COM(this.supplyPrice).min = FConfig.getMarketPriceStep();
	COM(this.supplyPrice).step = FConfig.getMarketPriceStep();
	
	$(this.editSupplyPrice).on('change', $.proxy(this.tick, this));
	COM(this.editSupplyPrice).min = FConfig.getMarketPriceStep();
	COM(this.editSupplyPrice).step = FConfig.getMarketPriceStep();
	
	COM.bindExclusiveClick(this.createSupply, $.proxy(this.onCreateSupply, this));
	COM.bindExclusiveClick(this.test, $.proxy(this.onEditSupply, this));
	
	COM(this.ownedSupplies).onItemClick = $.proxy(this.selectedItemChanged, this);
	
	COM.bindExclusiveClick(this.cancelEdit, $.proxy(function(){
		
		COM(this.ownedSupplies).selectedIndex = -1;
		this.selectedItemChanged();
		
	}, this))
	
	COM.bindExclusiveClick(this.removeSupply, $.proxy(function(){
		
		this.onRemoveSupply(COM(COM(this.ownedSupplies).selectedItem).data.id);
		
	}, this))
}

MarketSell.prototype.onCreateSupply = function(r, amount, price)
{
    var r = COM(this.supplyResource).value, amount = COM(this.supplyAmount).value*1, price = COM(this.supplyPrice).value*1;
    if (!Quarantine.contains(this.ID)) 
    {
        Quarantine.put(this.ID);
        APP.showLoader();
        Service.market.callMethod('createSupply', [this.fmarket.city.id, r, amount, price], $.proxy(this.updateMarket, this));
    }
};

MarketSell.prototype.onRemoveSupply = function(supplyId)
{
    Alert.create(I18.f('REMOVE_SUPPLY_CONFIRM'), '',
		$.proxy(function (){
        	APP.showLoader();
		    Service.market.callMethod('removeSupply', [this.fmarket.city.id, supplyId], 
		    	$.proxy(this.updateMarket, this),
		    	$.proxy(function(){ APP.hideLoader(); }, this)
		    );
		}, this)
	);
};

MarketSell.prototype.onEditSupply = function(s, amount, price)
{
	var s = COM(this.ownedSupplies).selectedItem.data, amount = COM(this.editSupplyAmount).value*1, price = COM(this.editSupplyPrice).value*1;    
	APP.showLoader();
    Service.market.callMethod('editSupply', [this.fmarket.city.id, s.id, amount, price], $.proxy(this.updateMarket, this));
};

MarketSell.prototype.onShow = function(c, parent)
{
    superMethod(MarketBuy.prototype, "onShow", this)();
	APP.showLoader();
    Service.market.callMethod('getOwnedSupplies', [this.estate.id], $.proxy(this.updateMarket, this));
}

MarketSell.prototype.tick = function(e)
{
    superMethod(MarketSell.prototype, 'tick', this)();
    
    if (!COM(this.supplyResource).value) COM(this.supplyResource).selectedIndex = 0;
    if (!this.fmarket) return;
    var res = COM(this.supplyResource).value;
     
    var price = Math.ceil(COM(this.supplyAmount).value * COM(this.supplyPrice).value * 1);
    COM(this.totalPrice).value = price;
    $(this.tax).html(this.calcTax());
	this.taxImage.src = STATIC_INTERFACE_URL + Assets.ICON_findBy(res);

    var priceRange = FConfig.SUPPLY_PRICE_LIMITS.getValue(res);
    this.fillPriceLimits(this.supplyPrice, priceRange);
    $(this.infoLineLots).html(I18.f('MARKET_SELL_INFO_LINE_LOTS', this.fmarket.supplies.length, FConfig.SUPPLY_MAX_COUNT));
    
    var market = this.estate.getMarket();
    $(this.infoLineSupplies).html(I18.f('MARKET_SELL_INFO_LINE_SUPPLIES', market.resources.sum(), market.getCapacity()));

	COM(this.supplyAmount).icon = STATIC_INTERFACE_URL + Assets.ICON_findBy(res);
    this.updateInput(this.supplyAmount);
    this.updateInput(this.supplyPrice);
    this.updateInput(this.editSupplyPrice);
    
    this.checkLimits();
}

MarketSell.prototype.getLimit = function()
{
    var market = this.estate.getMarket();
    return market.getCapacity() - market.resources.sum();
}

MarketSell.prototype.calcTax = function()
{
    var discount = Science.getMarketDiscount(this.estate.science.getLevel(Science.SPEC_TRADER));
    return Math.ceil(COM(this.supplyAmount).value * (FConfig.MARKET_SELL_TAX - discount) / 100);
}

MarketSell.prototype.checkLimits = function()
{
    var limit = this.getLimit();
    var capacityLimitReached = (limit == 0);
    var supplyCountLimitReached = this.fmarket.supplies.length >= FConfig.SUPPLY_MAX_COUNT;
    var resourcesDeficit = (COM(this.supplyAmount).value + this.calcTax()) > this.estate.bank.getValue(COM(this.supplyResource).value);

    if (limit > 0) 
    {
        COM(this.supplyAmount).max = limit;
    }

    COM(this.supplyAmount).disabled = !this.estate.accessDeputy;
    COM(this.supplyPrice).disabled = !this.estate.accessDeputy;
	COM(this.supplyResource).disabled = !this.estate.accessDeputy;

    var reason = null;
    if (!this.estate.accessDeputy) 
    {
        reason = I18.f('NO_ACCESS');
    } 
    if (capacityLimitReached) 
    {
        reason = I18.f('MARKET_CAPACITY_EXCEEDED');
    } 
    else if (supplyCountLimitReached) 
    {
        reason = I18.f('MARKET_CAPACITY_EXCEEDED');
    } 
    else if (resourcesDeficit) 
    {
        reason = I18.f('MISSION_NOT_ENOUGH_RESOURCES');
    } 
    
    COM(this.createSupply).reason = reason;
    if (UI.show(!!reason, [this.priceLimitText]))
    {
    	$(this.priceLimitText).html(I18.f('PRICE_LIMIT_TEXT', COM(this.supplyPrice).min, COM(this.supplyPrice).max));
    }
}

MarketSell.prototype.onLimitTooltip = function(e)
{
    //e.toolTip = NumberEffectTip.createTip("BUFF_PRICE_LIMIT_VALUELESS", estate.buffs, 0, BuffType.PRICE_LIMIT, FEstate.tickNowForEstate(estate));
}

MarketSell.prototype.setWarning = function(s, warning)
{
    $(this.priceLimitText).html(s).toggleClass('negative', Boolean(warning));
}

MarketSell.prototype.onTaxTip = function(e)
{
    //e.toolTip = MarketSellTaxTip.create(estate);
}

MarketSell.prototype.selectedItemChanged = function(item)
{
    item = COM(item);
    var selectedSupply = item ? item.data : null;
    
    if (UI.show(selectedSupply && !item.selected, [this.editBox]))
    {
        COM(this.editSupplyAmount).icon = STATIC_INTERFACE_URL + Assets.ICON_findBy(selectedSupply.resource);
        COM(this.editSupplyAmount).max = selectedSupply.amount;
        COM(this.editSupplyAmount).min = Math.max(this.minPrice(), selectedSupply.contractedAmount);
        COM(this.editSupplyAmount).value = selectedSupply.amount;
        COM(this.editSupplyAmount).disabled = COM(this.editSupplyAmount).min >= COM(this.editSupplyAmount).max;

        var priceRange = FConfig.SUPPLY_PRICE_LIMITS.getValue(selectedSupply.resource);
        this.fillPriceLimits(this.editSupplyPrice, priceRange);
        COM(this.editSupplyPrice).value = selectedSupply.price;
        COM(this.editSupplyPrice).disabled = selectedSupply.contractedAmount > 0;
        
        UI.show(false, [this.supplyBox]);
    }
    else
    {
        UI.show(true, [this.supplyBox]);
    }
    this.tick(); 
}

MarketSell.prototype.updateMarket = function(m)
{
    APP.showLoader();
    superMethod(MarketSell.prototype, 'updateMarket', this)(m);
    COM(this.ownedSupplies).selectedIndex = -1;
    COM(this.ownedSupplies).dataProvider = m.supplies;
    this.selectedItemChanged();
    this.tick();
    APP.hideLoader();
}

MarketSell.prototype.updateInput = function(input, val, min, max)
{
	if (isNaN(min)) min = COM(input).min;
	if (isNaN(max)) max = COM(input).max;
	if (isNaN(val)) val = COM(input).value;
	val = Math.max(min, Math.min(max, val));
	if (input.getAttribute('name') == 'supplyPrice') console.log(input.getAttribute('name'), min, max, val);
	COM(input).min = min;
	COM(input).max = max;
	COM(input).value = Math.max(min, Math.min(max, val));
}

MarketSell.prototype.fillPriceLimits = function(esp, priceRange)
{
    var limit = Math.max(this.estate.sumOfBuffs(BuffType.PRICE_LIMIT), (priceRange.min - priceRange.max) / 2),
		val = COM(esp).value, 
    	min = Math.max(this.minPrice(), priceRange.min - limit), 
    	max = priceRange.max + limit
    ;
    this.updateInput(esp, val, min, max);
}

MarketSell.prototype.minPrice = function()
{
    return Math.pow(0.1, FConfig.MARKET_PRECISION);
}

MarketSell.prototype.fitLayout = function(container)
{
	if (!this.DOM) return;
	superMethod(MarketTabParent.prototype, 'fitLayout', this)(container);
	COM(this.ownedSupplies).refresh();
}
