function ApprenticeInvitationDialog()
{
	this.__defineGetter__('invitee', function() { return COM(this.inviteeName).value; });
	this.__defineSetter__('invitee', function(val) { COM(this.inviteeName).value = val; });
}

extendClass(ApprenticeInvitationDialog.prototype, Dialog.prototype);

ApprenticeInvitationDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.inviteButton, $.proxy(function(){
		this.onInvite(this.invitee);
	}, this));
	
	COM(this.inviteButton).reason = this.invitee ? null : I18.f('NEED_TO_FILL_DATA');
	$(this.inviteeName).on('change', $.proxy(function(){
		COM(this.inviteButton).reason = this.invitee ? null : I18.f('NEED_TO_FILL_DATA');
	}, this));
	
	$(this.candidates).on('select', $.proxy(function(e){
		var val = COM(e.target).value;
		this.invitee = val[0];
		COM(this.inviteButton).reason = null;
		console.log("SELECTED %s FROM %s", val[0], val[1]);
	}, this));
	
	$(this.candidates).on('unselect', $.proxy(function(e){
		this.invitee = '';
		COM(this.inviteButton).reason = I18.f('NEED_TO_FILL_DATA');
		console.log("UNSELECTED");
	}, this));
	
	this.onChangePage(0);
}


ApprenticeInvitationDialog.prototype.onResult = function(info){}

ApprenticeInvitationDialog.prototype.handleSuccess = function(info)
{
    Alert.create(I18.f('USER_INVITED_SUCCESSFULY', this.invitee));
    this.close();
    this.onResult(info);
}

ApprenticeInvitationDialog.prototype.handleError = function(e)
{
    var cls = e.__className__;
    if (cls == 'AvatarNotFoundException') 
    {
        Alert.create(I18.f('NONEXISTENT_CONTACT_ERROR'), I18.f('ERROR'));
        return true;
    } 
    else if (cls == 'MentorshipException') 
    {
        Alert.create(I18.mentorshipError(e.type, e.username), I18.f('ERROR'));
        return true;
    }
    return false;
}

ApprenticeInvitationDialog.prototype.onInvite = function(invitee)
{
    Service.alliance.callMethod('sendApprenticeInvitation', [this.invitee, this.customText.value], $.proxy(this.handleSuccess, this), $.proxy(this.handleError, this));
}

ApprenticeInvitationDialog.prototype.onChangePage = function(index)
{
    Service.alliance.callMethod('getApprenticeCandidates', [index], $.proxy(function(candidates){
        
    	console.log("CANDIDATES %s", index, candidates);
    	
    	var data = COM(this.candidates).dataProvider || [];
        for (var i = 0, len = candidates.users.length; i < len; i++)
        {
        	var user = candidates.users[i]; 
        	data.push([user.username, I18.formatEstateName(null, user.capitalLocation)]);
        }
        COM(this.candidates).dataProvider = data;
        
        if (index < candidates.totalPageCount-1)
        {
        	this.onChangePage(index + 1);
        }
        
    }, this));
}
