function FApprentice()
{
	this.username = ''; //:String; // name of the apprentice
	this.user = null; //:FUserInfo;  // additional info, null if user is deleted from the server
	this.quests = null; //:ArrayCollection;// <FApprenticeQuest>
	this.isValid = false; //:Boolean; // apprentice refuse the mentor
	this.readyToRelease = false; //:Boolean;
	//transient
	this.hasAccepted = false; //:Boolean; // if false this FApprentice is just an invitation
	this.hasRejected = false; //:Boolean; // if true this FApprentice has rejected an invitation
	this.expelTick = 0; //Number;
}

FApprentice.prototype.username = ''; //:String; // name of the apprentice
FApprentice.prototype.user = null; //:FUserInfo;  // additional info, null if user is deleted from the server
FApprentice.prototype.quests = null; //:ArrayCollection;// <FApprenticeQuest>
FApprentice.prototype.isValid = false; //:Boolean; // apprentice refuse the mentor
FApprentice.prototype.readyToRelease = false; //:Boolean;
FApprentice.prototype.expelTick = 0; //Number;
//transient
FApprentice.prototype.hasAccepted = false; //:Boolean; // if false this FApprentice is just an invitation
FApprentice.prototype.hasRejected = false; //:Boolean; // if true this FApprentice has rejected an invitation

FApprentice.prototype.toString = function()
{
    return this.user.username;
}

FApprentice.prototype.compareTo = function(object)
{
    
    //if (!(object is FApprentice)) Errors.die("Could not compare apprentices: wrong type");

    var that = object;
    if (that.username == username) 
    {
        return 0;
    }

    if (this.hasAccepted != that.hasAccepted) 
    {
        return this.hasAccepted ? 1 : -1;
    }

    if (this.hasRejected != that.hasRejected) 
    {
        return this.hasRejected ? 1 : -1;
    }

    var thisDead = !this.user;
    var thatDead = !that.user;
    if (thisDead != thatDead) {
        return thisDead ? -1 : 1;
    }

    if (this.isValid != that.isValid) 
    {
        return this.isValid ? -1 : 1;
    }

    return 1;
}

FApprentice.prototype.questProgress = function()
{
    var progress = 0;
    for (var i = 0, len = this.quests.length; i < len; i++)
    {
    	var quest = this.quests[i];
        if (quest.state.name == QuestState.COMPLETED.name || quest.state.name == QuestState.WAIT_REWARD.name) 
        {
            progress++;
        }
    }
    return progress;
}
