function MentorshipTab()
{
	this.estate = null;
}

extendClass(MentorshipTab.prototype, DiplomatTabParent.prototype);

MentorshipTab.prototype.estate = null;

MentorshipTab.prototype.__construct = function(dialog)
{
	dialog.headerRightBox.appendChild(this.inviteButton);
	dialog.headerRightBox.appendChild(this.send2all);
	COM.bindExclusiveClick(this.send2all, $.proxy(this.onSentToAllClick, this));
	COM.bindExclusiveClick(this.inviteButton, $.proxy(this.onSendInvitation, this));
	
	COM(this.apprenticesList).createRenderer = $.proxy(this.createApprenticeRenderer, this);
}

MentorshipTab.prototype.__destruct = function()
{
	if (this.send2all.parentNode) this.send2all.parentNode.removeChild(this.send2all);
	if (this.inviteButton.parentNode) this.inviteButton.parentNode.removeChild(this.inviteButton);
}

MentorshipTab.prototype.tick = function()
{
	for (var i = 0, len = COM(this.apprenticesList).items.length; i < len; i++)
	{
		COM(COM(this.apprenticesList).items[i]).tick();
	}
}

MentorshipTab.prototype.update = function(e)
{
    this.estate = e;
    
    var diplomacy = e.owner.diplomacy;
    this.mentorLevel.innerHTML = I18.f('MENTORSHIP') + " " + I18.f('LVL_X', diplomacy.mentorLevel);
    this.apprenticesCount.innerHTML = I18.f('APPRENTICES_COUNT', diplomacy.allApprenticeCount, diplomacy.mentorCapacity);
    this.graduateCount.innerHTML = I18.f('GRADUATES_COUNT', diplomacy.releasedApprentices);
    
    UI.show(e.accessManageble && (diplomacy.apprentices.length > 0), [this.send2all]);
    
    if (UI.show(e.accessManageble, [this.inviteButton]))
    {
		var reason = "";
		if (diplomacy.allApprenticeCount >= diplomacy.mentorCapacity) reason = I18.f('MENTORSHIP_ERROR_CAPACITY');
		if (!diplomacy.isMentor) reason = I18.f('NEED_QUEST_FOR_MENTORSHIP');
		COM(this.inviteButton).reason = reason;    	
    }

    var list = [];
    
    for (var i = 0, len = diplomacy.apprenticeInvitations.length; i < len; i++)
    {
    	diplomacy.apprenticeInvitations[i].hasAccepted = false;
        list.push(diplomacy.apprenticeInvitations[i]);
    }
    for (var i = 0, len = diplomacy.rejectedApprenticeInvitations.length; i < len; i++)
    {
    	diplomacy.rejectedApprenticeInvitations[i].hasRejected = true;
        list.push(diplomacy.rejectedApprenticeInvitations[i]);
    }
    for (var i = 0, len = diplomacy.apprentices.length; i < len; i++)
    {
    	diplomacy.apprentices[i].hasAccepted = true;
        list.push(diplomacy.apprentices[i]);
    }

    COM(this.apprenticesList).dataProvider = list;
}

MentorshipTab.prototype.onSendInvitation = function()
{
    var invDialog = COM.create('ApprenticeInvitationDialog');
    invDialog.onResult = $.proxy(this.handleResult, this);
    invDialog.popup(this);
}

MentorshipTab.prototype.createApprenticeRenderer = function(data)
{
    var renderer = COM.create('ApprenticeRenderer');
    
    renderer.allowControl = this.estate.accessManageble;
    renderer.onResult = $.proxy(this.handleResult, this);
    renderer.data = data;
    
	return renderer;
}

MentorshipTab.prototype.onSentToAllClick = function()
{
    MailBoxView.i().sendMessageToReceiverType(MailReceiverType.APPRENTICES);
}
