function BWhereCell(name, success, message)
{
	this.name = name;
	this.isSuccess = success;
	if (message != null)
		this.message = message;
}

extendClass(BWhereCell.prototype, Enum.prototype);

BWhereCell.__isEnum__ = true;

$.extend(BWhereCell.prototype,
{
	__construct : function()
	{
		if (this.name && BWhereCell[this.name])
		{
			this.isSuccess = BWhereCell[this.name].isSuccess;
			this.message = BWhereCell[this.name].message;
		}
	},

	message : function(cellIndex, estate, context)
	{
		return I18.f("BUILDING_CONSTRAINT", I18.getBWhereOn(context.name));
	}
});

BWhereCell.ANYWHERE = new BWhereCell("ANYWHERE", function(cellIndex, estate)
{
	return true;
});

BWhereCell.GRAIN = new BWhereCell("GRAIN", function(cellIndex, estate)
{
	var res = estate.getCellByIndex(cellIndex).resource;
	return res ? res.name == Resource.GRAIN.name : false;
});

BWhereCell.STONE = new BWhereCell("STONE", function(cellIndex, estate)
{
	var res = estate.getCellByIndex(cellIndex).resource;
	return res ? res.name == Resource.STONE.name : false;
});

BWhereCell.IRON = new BWhereCell("IRON", function(cellIndex, estate)
{
	var res = estate.getCellByIndex(cellIndex).resource;
	return res ? res.name == Resource.IRON.name : false;
});

BWhereCell.GOLD = new BWhereCell("GOLD", function(cellIndex, estate)
{
	var res = estate.getCellByIndex(cellIndex).resource;
	return res ? res.name == Resource.GOLD.name : false;
});

BWhereCell.NOWHERE = new BWhereCell("NOWHERE", function(cellIndex, estate)
{
	return false;
});

BWhereCell.BLOCKED = new BWhereCell("BLOCKED",

function(cellIndex, estate)
{
	return estate.getCellByIndex(cellIndex).blocked;
},

function(cellIndex, estate, context)
{
	return I18.f("BUILDING_CONSTRAINT", I18.getBWhereOn(context.name, estate.terrain.blocker.tooltip));
});
