function CastTarget()
{
	this.location = null; // XYZ
	this.isOwn = false;
	this.isAlly = false;
	this.isInPeace = false;
	this.estateType = null; // EstateType
	this.field = null; // FKingdomField
	this.nearestAttackTick = 0;
}

CastTarget.prototype.location = null; // XYZ
CastTarget.prototype.isOwn = false;
CastTarget.prototype.isAlly = false;
CastTarget.prototype.isInPeace = false;
CastTarget.prototype.estateType = null; // EstateType
CastTarget.prototype.field = null; // FKingdomField
CastTarget.prototype.nearestAttackTick = 0;

CastTarget.prototype.getTargetType = function(from)
{
    if (this.isOwn) 
    {
		return this.location.equals(from) 
			? SpellTargetType.SELF_ESTATE 
			: SpellTargetType.OWN_ESTATE
		;
    }
    if (this.isAlly) 
    {
        return SpellTargetType.ALLIED_ESTATE;
    }
    if (this.isInPeace) 
    {
        return SpellTargetType.IN_PEACE_ESTATE;
    }
    return SpellTargetType.ENEMY_ESTATE;
}

CastTarget.fromOwnEstate = function(estate)
{
    var target = new CastTarget();
    target.location = estate.location;
    target.isOwn = true;
    target.estateType = estate.getEstateType();
    target.nearestAttackTick = estate.nearestIncomingAttackTick;
    return target;
}

CastTarget.fromField = function(field)
{
    var target = new CastTarget();
    target.location = field.getLocationXYZ();
    if (field.estate) 
    {
        target.isOwn = FUser.CURRENT_USER.username == field.estate.owner.username;
        target.isAlly = field.estate.canAssist;
        target.isInPeace = field.estate.ownedByFriend || field.estate.ownerInPeace ||
                FConfig.IS_SURVIVAL && field.estate.owner.race.isSameSide(FUser.CURRENT_USER.race);
        target.estateType = field.estate.type;
        target.nearestAttackTick = field.estate.underAttackAt;
    } 
    else 
    {
        target.estateType = EstateType.EMPTY_FIELD;
    }
    target.field = field;
    return target;
}
