function FBuilding()
{
	this.__defineGetter__('unitsAvailable', function()
	{
		return this.isSuppressed ? 0 : this.unitsPresent;
	});

	this.__defineGetter__('type', function()
	{
		return this.typeName == null ? BType.NULL : BType[this.typeName];
	});

	this.__defineGetter__('isBuildingOrUpgrading', function()
	{
		return this.state.equals(BuildingState.BUILDING_OR_UPGRADING);
	});

	this.__defineGetter__('isRepairing', function()
	{
		return BuildingState.REPAIRING.equals(this.state);
	});

	this.__defineGetter__('isBroken', function()
	{
		return BuildingState.BROKEN.equals(this.state);
	});

	this.__defineGetter__('isBrokenOrRepairing', function()
	{
		return this.isBroken || this.isRepairing;
	});

	this.__defineGetter__('isConstructed', function()
	{
		return this.level > 0;
	});

	this.__defineGetter__('isBuildPending', function()
	{
		return !this.isConstructed;
	});

	this.__defineGetter__('isUpgradePending', function()
	{
		return this.isBuildingOrUpgrading && !this.isBuildPending;
	});

	this.__defineGetter__('isStopped', function()
	{
		return (this.isBuildingOrUpgrading || this.isRepairing) ? (this.builders == 0) : (this.workers == 0 && this.type.isRequiresWorkers(this.race) && this.accessInfo);
	});

	this.__defineGetter__('maxRepairBuilders', function()
	{
		return this.getLevel().builders;
	});

	this.__defineGetter__('isOnSector', function()
	{
		return this.isForeign || this.cell && this.cell.onSector;
	});

	this.__defineGetter__('isInSectorWithClosedGates', function()
	{
		return this.isOnSector && this.estate.isGateClosed();
	});

	this.__defineGetter__('isWorking', function()
	{
		return this.isConstructed && !this.isBroken && !this.isRepairing && !this.isInSectorWithClosedGates && !this.isSuppressed;
	});

	this.__defineGetter__('completed', function()
	{
		return this.workDone / this.workToDo;
	});

	this.__defineGetter__('unitsCapacity', function()
	{
		return (this.getLevel().__CLS__.split('.').pop() == 'BLevelSpecialUnitProducer') ? this.getLevel().capacity : 0;
	});

	this.__defineGetter__('unitsTotal', function()
	{
		return this.unitsPresent + this.unitsOnMission;
	});

	this.__defineGetter__('maxOrderCount', function()
	{
		return this.unitsCapacity - this.unitsTotal - this.unitsQueued;
	});

	this.__defineGetter__('storedArtifactsCount', function()
	{
		if(!this.storedArtifacts)
		{
			return 0;
		}
		
		return Arrays.count(this.storedArtifacts.artifacts, function(a)
		{
			return Boolean(a);
		});
	});

	this.__defineGetter__('blinking', function()
	{
		if (!this.isWorking || !this.estate.accessManageble) return false;
		return (
			this.type.name == BType.DIPLOMAT.name && FUser.CURRENT_USER.hasNewClanQuestions() 
			|| 
			this.type.name == BType.TAVERN.name && FUser.CURRENT_USER.blinkNews()
		);
	});
	
	this.id = null;
	
	this.accessType = null;
	this.accessInfo = null;
	
	this.ownerCityId = null;
	this.ownerUserName = null;
	this.estate = null;
	this.isForeign = null;
	this.level = null;
	this.fullWorkersSpeedPerHour = null;
	this.isWarehousesOverfilled = null;
	this.isScienceNotSelected = null;
	this.isAlchemistBoosted = null;
	this.builders = null;
	this.workers = null;
	this.cell = null;
	this.workToDo = null;
	this.workDone = null;
	this.buildersEffectiveness = null;
	this.repairmenEffectiveness = null;
	this.currentHealth = null;
	this.maxHealth = null;
	this.state = null;
	this.isSuppressed = null;
	this.suppressedTill = null;
	
	this.race = null;
	
	// only for UnitBuilding
	this.unitsQueued = null;
	this.unitPartProduced = null;
	// special unit building
	this.unitsPresent = null;
	this.unitsOnMission = null;
	this.sendsMissions = null;
	
	// raised resource for all raisers
	this.resource = null;
	
	// only for Shop
	this.shopRatio = null;
	// only for Terraformer
	this.endTerraformingTick = null;
	//for market
	this.resources = null;
	// temple
	this.godpointsAvailable = null;
	this.protections = null;
	// resurrector
	this.accumulatedArmy = null;
	this.resurrectingArmy = null;
	this.resurrectionTick = null;
	this.resurrectionTimeAfterRepair = 0;
	// auto expedition
	this.autoExpeditionKingdom = null;
	this.autoExpeditionEnabled = null;
	
	// auto order units
	this.autoProduceEnabled = null;
	
	this.typeName = null;
	
	this._lastWorkSpeedPerTick = 0;
	// for clan buildings
	this.startTransferTick = null;
	this.accessManageble = null;
	
	this.heroesToHire = null;
	
	//artifact store
	this.storedArtifacts = null;
	
	// fortification
	this.fortificationKills = null;
	this.fortificationDefence = null;
	
	// tower
	this.towerDamage = null;
	
	this.type = null;
	this.level = 0;
	
};

FBuilding.prototype.id = null;

FBuilding.prototype.accessType = null;
FBuilding.prototype.accessInfo = null;

FBuilding.prototype.ownerCityId = null;
FBuilding.prototype.ownerUserName = null;
FBuilding.prototype.estate = null;
FBuilding.prototype.isForeign = null;
FBuilding.prototype.level = null;
FBuilding.prototype.fullWorkersSpeedPerHour = null;
FBuilding.prototype.isWarehousesOverfilled = null;
FBuilding.prototype.isScienceNotSelected = null;
FBuilding.prototype.isAlchemistBoosted = null;
FBuilding.prototype.builders = null;
FBuilding.prototype.workers = null;
FBuilding.prototype.cell = null;
FBuilding.prototype.workToDo = null;
FBuilding.prototype.workDone = null;
FBuilding.prototype.buildersEffectiveness = null;
FBuilding.prototype.repairmenEffectiveness = null;
FBuilding.prototype.currentHealth = null;
FBuilding.prototype.maxHealth = null;
FBuilding.prototype.state = null;
FBuilding.prototype.isSuppressed = null;
FBuilding.prototype.suppressedTill = null;

FBuilding.prototype.race = null;

// only for UnitBuilding
FBuilding.prototype.unitsQueued = null;
FBuilding.prototype.unitPartProduced = null;
// special unit building
FBuilding.prototype.unitsPresent = null;
FBuilding.prototype.unitsOnMission = null;
FBuilding.prototype.sendsMissions = null;

// raised resource for all raisers
FBuilding.prototype.resource = null;

// only for Shop
FBuilding.prototype.shopRatio = null;
// only for Terraformer
FBuilding.prototype.endTerraformingTick = null;
//for market
FBuilding.prototype.resources = null;
// temple
FBuilding.prototype.godpointsAvailable = null;
FBuilding.prototype.protections = null;
// resurrector
FBuilding.prototype.accumulatedArmy = null;
FBuilding.prototype.resurrectingArmy = null;
FBuilding.prototype.resurrectionTick = null;
FBuilding.prototype.resurrectionTimeAfterRepair = 0;
// auto expedition
FBuilding.prototype.autoExpeditionKingdom = null;
FBuilding.prototype.autoExpeditionEnabled = null;

// auto order units
FBuilding.prototype.autoProduceEnabled = null;

FBuilding.prototype.typeName = null;

FBuilding.prototype._lastWorkSpeedPerTick = 0;
// for clan buildings
FBuilding.prototype.startTransferTick = null;
FBuilding.prototype.accessManageble = null;

FBuilding.prototype.heroesToHire = null;

//artifact store
FBuilding.prototype.storedArtifacts = null;

// fortification
FBuilding.prototype.fortificationKills = null;
FBuilding.prototype.fortificationDefence = null;

// tower
FBuilding.prototype.towerDamage = null;

FBuilding.prototype.type = null;
FBuilding.prototype.level = 0;

FBuilding.prototype.__construct = function(){}

//-----------------------------------------------------------------------------------------

FBuilding.prototype.canUpgrade = function()
{
	return !this.isBuildingOrUpgrading && this.level < this.type.getLevels(this.race).length - 1 && !this.isBroken && !this.isRepairing;
}

FBuilding.prototype.isNextLevelPerfect = function()
{
	if (BType.NULL.equals(this.type))
	{
		return false;
	}
	return this.level < this.type.getLevels(this.race).length - 1 && this.type.getLevels(this.race)[this.level + 1].perfect;
}

FBuilding.prototype.isPerfect = function(level)
{
	if ( typeof level == 'undefined')
	{
		level = -1;
	}
	if (BType.NULL.equals(this.type))
	{
		return false;
	}
	var blevel = this.getLevel(level);
	return blevel ? blevel.perfect : false;
}

FBuilding.prototype.getLevel = function(index)
{
	if ( typeof index == 'undefined')
		index = -1;
	var levels = this.type.getLevels(this.race);
	var idx = index >= 0 ? index : this.level;
	return idx < levels.length ? levels[idx] : null;
}

FBuilding.prototype.getHealthRatio = function()
{
	var fraction = this.workToDo > 0 ? (this.workDone) / this.workToDo : 0;
	return (this.currentHealth + fraction * (this.maxHealth - this.currentHealth)) / this.maxHealth;
}

FBuilding.prototype.estimateRepairCost = function()
{
	var cost = new Funds();
	for (var i = 1; i <= this.level; i++)
	{
		cost.add(this.getLevel(i).cost);
	}
	cost.multiply((1 - this.getHealthRatio()) * FConfig.REPAIR_COST_RATIO);
	return cost.ceil();
}

FBuilding.prototype.estimateCurrentWork = function()
{
	if (!this.isBuildingOrUpgrading)
	{
		return 0;
	}
	if (this.builders == 0)
	{
		return FConfig.TICK_INFINITY;
	}
	return (this.workToDo - this.workDone) / this.buildersEffectiveness;
}

FBuilding.prototype.estimateCurrentRepair = function()
{
	if (!this.isBroken && !this.isRepairing)
	{
		return 0;
	}
	if (this.builders == 0)
	{
		return FConfig.TICK_INFINITY;
	}
	return (this.workToDo - this.workDone) / this.repairmenEffectiveness;
}

FBuilding.prototype.estimateBuildDuration = function(forBuilders)
{
	if (!this.isBuildingOrUpgrading)
	{
		return 0;
	}
	if (forBuilders == 0)
	{
		return FConfig.TICK_INFINITY;
	}
	return (this.workToDo - this.workDone) / this.estate.effectiveBuilders(forBuilders);
}

FBuilding.prototype.estimateRepairDuration = function(forBuilders)
{
	if (!this.isBroken && !this.isRepairing)
	{
		return 0;
	}
	if (forBuilders == 0)
	{
		return FConfig.TICK_INFINITY;
	}
	return (this.workToDo - this.workDone) / this.estate.effectiveRepairmen(forBuilders);
}

FBuilding.prototype.estimateRepairBaseDuration = function(forBuilders)
{
	if (!this.isBroken && !this.isRepairing)
	{
		return 0;
	}
	if (forBuilders == 0)
	{
		return FConfig.TICK_INFINITY;
	}
	return (this.workToDo - this.workDone) / forBuilders;
}

FBuilding.prototype.percentCompleted = function()
{
	return NumberUtils.floor(100 * this.completed);
}

FBuilding.prototype.tick = function(delta)
{
	if (this.workToDo > this.workDone)
	{
		this.workDone = Math.min(this.workDone + delta * this.buildersEffectiveness, this.workToDo);
	}
	
	if (!this.isForeign)
	{
		if (this.type.isExtractor())
		{
			var value = this.computeWorkSpeedPerTick(this.cell.resource) * delta;
			if (!this.isPerfect())
			{
				if (this.cell.remainder != 0)
				{
					value = Math.min(this.cell.remainder, value);
				}
			}

			var extracted = this.estate.addResourceToBank(this.cell.resource, value);
			if (!this.isPerfect())
			{
				if (this.cell.remainder > 0)
				{
					this.cell.remainder -= extracted;
				}
			}
			this._lastWorkSpeedPerTick = extracted / delta;
		}
		else if (this.type.isHouses())
		{
			this.tickPeople(delta);
		}
		else if (this.type.isProducer())
		{
			if (this.resource)
			{
				var produced = this.computeWorkSpeedPerTick(this.resource) * delta;
				//console.log("producer", this.resource);
				produced = this.estate.addResourceToBank(this.resource, produced);
				if (this.type.isEstateHall())
				{
					this.tickPeople(delta);
				}
				this._lastWorkSpeedPerTick = produced / delta;
			}
		}
		else if (this.type.isUnitProducer())
		{
			if (this.isConstructed)
			{
				this.produce(this.estate.garrison, delta);
			}
		}
		else if (this.type.isTemple())
		{
			var levelTemple = $.extend(new BLevelTemple(), this.getLevel());
			var pointsProduced = levelTemple.godpointProduction * delta / Tick.TICKS_PER_HOUR;
			var toAdd = Math.min(pointsProduced, Math.max(0, levelTemple.godpointLimit - this.godpointsAvailable));
			this.godpointsAvailable += toAdd;
		}
	}
	else
	{
		if (this.type.isRaiser())
		{
			this._lastWorkSpeedPerTick = this.isWarehousesOverfilled ? 0 : this.computeWorkSpeedPerTick(this.resource);
		}
	}
	if (this.type.isRecovery())
	{
		var recover = this.computeWorkSpeedPerTick(this.cell.resource);
		var oldRemainder = this.cell.remainder;
		this.cell.remainder = Math.min(this.cell.remainder + recover * delta, FConfig.getMaxRemainderOf(this.cell.resource));
		this._lastWorkSpeedPerTick = (this.cell.remainder - oldRemainder) / delta;
	}
}

FBuilding.prototype.tickPeople = function(delta)
{
	var peopleSpeed = this.getPeopleProductionSpeedPerHour() / Tick.TICKS_PER_HOUR;
	this.estate.addResourceToBank(Resource.PEOPLE, peopleSpeed * delta);
}

FBuilding.prototype.getLastWorkSpeedPerHour = function()
{
	var res = new Funds();
	if (this.resource)
	{
		res.setValue(this.resource, NumberUtils.floor(this._lastWorkSpeedPerTick * Tick.TICKS_PER_HOUR));
	}
	return res;
}

FBuilding.prototype.computeWorkSpeedPerTick = function(resource, curWorkers)
{
	if ( typeof curWorkers == 'undefined')
		curWorkers = -1;
	return this.computeWorkSpeedPerHour(resource, curWorkers) / Tick.TICKS_PER_HOUR;
}

FBuilding.prototype.computeWorkSpeedPerHour = function(r, curWorkers)
{
	if ( typeof curWorkers == 'undefined')
		curWorkers = -1;
	// does not take storage into account
	var res = 0;
	if (this.resource && String(this.resource) == String(r))
	{
		res = this.fullWorkersSpeedPerHour;
	}
	curWorkers = curWorkers == -1 ? this.workers : curWorkers;
	var workersEffectiveness = this.getLevel().workers > 0 ? curWorkers / this.getLevel().workers : 1;
	return NumberUtils.floor(res * workersEffectiveness);
}

FBuilding.prototype.computeSpeedPerHour = function(curWorkers)
{
	if ( typeof curWorkers == 'undefined')
		curWorkers = -1;
	// does not take storage into account
	var speed = new Funds();
	if (this.resource)
	{
		speed.setValue(this.resource, this.fullWorkersSpeedPerHour);
	}
	curWorkers = curWorkers == -1 ? this.workers : curWorkers;
	var workersEffectiveness = this.getLevel().workers > 0 ? curWorkers / this.getLevel().workers : 1;
	speed.multiply(workersEffectiveness);
	return speed.floor();
}

FBuilding.prototype.hasSpeedProblems = function(curWorkers)
{
	if ( typeof curWorkers == 'undefined')
		curWorkers = -1;
	if (this.isSuppressed)
	{
		return true;
	}
	if (this.isBroken)
	{
		return true;
	}
	if (!this.isConstructed)
	{
		return false;
	}
	if (this.type.isWarehouse())
	{
		return this.isOnSector && this.estate.isGateClosed();
	}
	if (this.type.isHouses())
	{
		if (this.isForeign)
		{
			return this.isWarehousesOverfilled;
		}
		return this.estate.isOverfilled(Resource.PEOPLE) || this.isOnSector && this.estate.isGateClosed();
	}

	var notFullWorkers = (curWorkers >= 0 ? curWorkers : this.workers) < this.getLevel().workers;
	if (this.type.isAlchemist())
	{
		return this.getScienceProductionPerHour() == 0 || notFullWorkers;
	}
	if (this.type.isRaiser())
	{
		if (this.isForeign)
		{
			return this.isWarehousesOverfilled || notFullWorkers;
		}
		else
		if (this.resource && this.estate.isOverfilled(this.resource))
		{
			return true;
		}
	}
	if (this.type.isEstateHall())
	{
		return false;
	}

	var speed = this.getLastWorkSpeedPerHour();
	return speed.isZero() || notFullWorkers || (this.type.isExtractor() && this.cell.remainder == 0 && !this.isPerfect()) || (!speed.equals(this.computeSpeedPerHour()));
}

FBuilding.prototype.hasUnitsInQueue = function()
{
	return this.unitsQueued > 0;
}

FBuilding.prototype.produce = function(garrison, delta)
{
	if (this.isWorking && this.hasUnitsInQueue())
	{
		this.unitPartProduced += delta / this.getDefaultProduceTime();
		var amount = Math.floor(Math.min(this.unitPartProduced, this.unitsQueued));
		if (this.type.isMilitaryUnitProducer())
		{
			garrison.addUnit(this.type.getUnitType(this.race), amount);
		}
		if (this.type.isSpecialUnitProducer())
		{
			this.unitsPresent += amount;
		}
		this.unitsQueued -= amount;
		this.unitPartProduced -= amount;

		if (!this.hasUnitsInQueue() && this.autoProduceEnabled)
		{
			this.estate.nextUpdateTick = Tick.now();
		}
	}
}

FBuilding.prototype.getDefaultProduceTime = function()
{
	return this.getProduceTimeForLevel(this.level);
}

FBuilding.prototype.hasProduceTimeBonuses = function()
{
	if (this.estate.hasBuff(BuffType.MILITARY_PRODUCTION, this.type.getUnitType(this.race)) || this.estate.hasBuff(BuffType.MILITARY_PRODUCTION_STOP))
	{
		return true;
	}
	return this.type == BType.HEALER && this.estate.science.getLevel(Science.SPEC_CLERIC) > 0;
}

FBuilding.prototype.hasOverfilledBonuses = function()
{
	return NumberUtils.compareTo(this.getMilitaryUnitProducerRate(), FConfig.MIN_MILITARY_PRODUCTION) < 0;
}

FBuilding.prototype.getProduceTimeForLevel = function(level)
{
	var produceTime = this.getLevel(level).produceTime;
	if (!this.type.isMilitaryUnitProducer())
	{
		return NumberUtils.ceil(produceTime);
	}
	var rate = this.getMilitaryUnitProducerRate();
	if (rate == Tick.TICK_INFINITY)
	{
		return Tick.TICK_INFINITY;
	}
	return NumberUtils.ceil(produceTime * Math.max(FConfig.MIN_MILITARY_PRODUCTION, rate));
}

FBuilding.prototype.getMilitaryUnitProducerRate = function()
{
	var rate = 1.0;
	if (this.estate.buffs)
	{
		if (FBuff.hasBuff(this.estate.buffs, BuffType.MILITARY_PRODUCTION_STOP, null, FEstate.tickNowForEstate(this.estate)))
		{
			return Tick.TICK_INFINITY;
		}
		rate += FBuff.sumOfBuffs(this.estate.buffs, BuffType.MILITARY_PRODUCTION, this.type.getUnitType(this.estate.race), FEstate.tickNowForEstate(this.estate));
	}
	if (this.type == BType.HEALER)
	{
		var clericLevel = this.estate.science.getLevel(Science.SPEC_CLERIC);
		if (clericLevel > 0)
		{
			rate -= FConfig.getSciencePrice(Science.SPEC_CLERIC, clericLevel).healerTrainBonus;
		}
	}
	return rate;
}

FBuilding.prototype.getEndQueueTick = function()
{
	var notBuilt = this.unitsQueued - this.unitPartProduced;
	if (NumberUtils.compareTo(notBuilt, 0) == 0)
	{
		notBuilt = 0;
	}
	var t = this.getDefaultProduceTime();
	if (t != Tick.TICK_INFINITY)
	{
		return FEstate.tickNowForEstate(this.estate) + notBuilt * t;
	}
	else
	{
		return Tick.TICK_INFINITY;
	}
}

FBuilding.prototype.getScienceProductionPerHour = function(curWorkers, level)
{
	if ( typeof curWorkers == 'undefined')
		curWorkers = -1;
	if ( typeof level == 'undefined')
		level = -1;

	var production = 0;
	if (this.isConstructed && this.type.isAlchemist() && (this.isForeign ? !this.isScienceNotSelected : this.estate.science.isScienceInProgress()) && this.estate.getStoppingBuff(this.type) == null)
	{
		curWorkers = curWorkers == -1 ? this.workers : curWorkers;
		production = this.getLevel(level).knowledgeProduction;
		production *= (1 + (this.isOnSector ? FConfig.PRODUCTIVITY_RATIO_IN_SECTOR / 100 : 0) + this.estate.sumOfBuildingBuffs(BuffType.BOOST_BUILDING, BType.ALCHEMIST));
		if (this.isForeign ? this.isAlchemistBoosted : this.estate.isMagicActive(BType.ALCHEMIST))
		{
			production *= (1 + ServiceHelper.getGloabalServiceDecl(BType.ALCHEMIST.name, 0).getValue());
		}
		production *= curWorkers / this.getLevel().workers;
	}
	return NumberUtils.floor(production);
}

FBuilding.prototype.getGodpointsProductionPerHour = function()
{
	var production = 0;
	if (this.isConstructed && this.type.isTemple())
	{
		var levelTemple = this.getLevel(this.level);
		if (this.godpointsAvailable < levelTemple.godpointLimit)
		{
			production = Math.floor(levelTemple.godpointProduction);
		}
	}
	return production;
}

FBuilding.prototype.isHousesOverfilled = function()
{
	if (this.type.isEstateHall() || this.type.isHouses())
	{
		return this.estate.isOverfilled(Resource.PEOPLE);
	}
	return false;
}

FBuilding.prototype.isWarehouseDoesntWork = function()
{
	return this.type.isWarehouse() && (this.isOnSector && !this.estate.isGateOpen() || this.isBroken || this.isSuppressed);
}

FBuilding.prototype.isWarehouseOverfilled = function()
{
	if (this.isForeign)
	{
		return this.isWarehousesOverfilled;
	}
	return this.resource && this.estate.isOverfilled(this.resource) && !this.type.isRecovery();
}

FBuilding.prototype.getNextLevel = function()
{
	if (this.level == this.type.getLevels(this.race).length - 1)
	{
		return new BLevel();
		// null object
	}
	return this.getLevel(this.level + 1) || new BLevel();
}

FBuilding.prototype.shopRatioToDisplay = function()
{
	if (!this.isWorking)
	{
		return 0;
	}

	if (this.isForeign)
	{
		return this.shopRatio;
	}

	if (this.estate.freeCitizens == 0)
	{
		return 0;
	}

	var koef = 1;
	if (NumberUtils.greaterThan(this.estate.lastNominalTaxPerHour, 0))
	{
		koef = this.estate.lastTaxPerHour / this.estate.lastNominalTaxPerHour;
	}
	return this.shopRatio * koef;
}

FBuilding.prototype.getProblem = function()
{
	if (this.isBuildPending)
	{
		return I18.f('BUILDING_IS_BUILDING');
	}
	else if (this.isBroken)
	{
		return I18.f('BUILDING_IS_BROKEN_ALERT_TITLE');
	}
	else if (this.isRepairing)
	{
		return I18.f('BUILDING_IS_REPAIRING');
	}
	else if (this.isInSectorWithClosedGates)
	{
		return I18.f('OPEN_THE_GATE_WARNING');
	}
	return "";
}

FBuilding.prototype.getNameAndLevel = function()
{
	if (this.type.name == BType.EVILHALL.name)
	{
		return I18.f('EVIL_NAME');
	}
	return this.isBuildPending || this.type.name == BType.MINEHALL.name 
		? I18.getBuildingName(this.type, this.race, this.resource) 
		: I18.getBuildingName(this.type, this.race, this.resource) + " " + I18.f('LVL_X', this.level)
	;
}

FBuilding.prototype.getName = function()
{
	if (this.type == BType.EVILHALL)
	{
		return I18.f('EVIL_NAME');
	}
	return this.isBuildPending || this.type == BType.MINEHALL ? I18.getBuildingName(this.type, this.race, this.resource) : I18.getBuildingName(this.type, this.race, this.resource);
}

FBuilding.prototype.compareTo = function(other)
{
	if (this.type.isEstateHall())
	{
		return -1;
	}
	if (other.type.isEstateHall())
	{
		return 1;
	}
	return 0;
}

FBuilding.prototype.canFinishConstructionForPearl = function()
{
	return BuildingState.BUILDING_OR_UPGRADING == this.state && !this.estate.isEstateUnderSiege;
}

FBuilding.prototype.killWorker = function()
{
	this.workers--;
	this.estate.workers--;
}

FBuilding.prototype.killBuilder = function()
{
	this.builders--;
	this.estate.builders--;
}

FBuilding.prototype.isOpenForTransfer = function()
{
	return Tick.now() >= this.startTransferTick;
}

FBuilding.prototype.getCapacity = function()
{
	return this.getCapacityFor(this.level);
}

FBuilding.prototype.getBaseRaise = function(level)
{
	if (!this.isConstructed || this.isBroken || this.isSuppressed)
	{
		return 0;
	}
	return FBuilding.staticGetBaseRaise(this.race, this.type, level, this.estate.getSkinIndex());
}

FBuilding.prototype.getBaseWarehouseCapacity = function(level)
{
	if (!this.isConstructed || this.isBroken || this.isSuppressed)
	{
		return 0;
	}
	return FBuilding.staticGetBaseWarehouseCapacity(this.race, this.type, this.resource, level, this.estate.getSkinIndex(), this.estate.owner && this.estate.owner.artifactsStoreIncreased);
}

FBuilding.prototype.getCapacityFor = function(level)
{
	var result = this.getBaseWarehouseCapacity(level);
	if (result != 0 && !this.isForeign)
	{
		result *= 1. + this.estate.getCapacityBonus(this.type);
	}
	return NumberUtils.floor(result);
}

FBuilding.prototype.getPeopleCapacity = function()
{
	if (!this.isWorking)
	{
		return 0;
	}
	return this.getPeopleCapacityFor(this.level);
}

FBuilding.prototype.getBasePeopleCapacityFor = function(level)
{
	return FBuilding.staticGetBasePeopleCapacity(this.race, this.type, level, this.estate.getSkinIndex());
}

FBuilding.prototype.getPeopleCapacityFor = function(level)
{
	var result = this.getBasePeopleCapacityFor(level);
	if (result != 0 && !this.isForeign)
	{
		result *= 1. + this.estate.getPeopleCapacityBonus(this.type);
		result += this.estate.getPeopleCapacityAbsoluteBonus(this.type);
	}
	return NumberUtils.floor(result);
}

FBuilding.prototype.getBasePeopleProduction = function(level)
{
	if (!this.isWorking || this.isHousesOverfilled() || this.estate.getStoppingBuff(this.type))
	{
		return 0;
	}
	return FBuilding.staticGetBasePeopleProduction(this.race, this.type, level, this.estate.getSkinIndex());
}

FBuilding.prototype.getPeopleProductionSpeedPerHourFor = function(level)
{
	var result = this.getBasePeopleProduction(level);
	if (result != 0 && !this.isForeign)
	{
		result += this.estate.getPeopleProductionBonus(this.type);
	}
	return Math.floor(Math.max(0, result));
}

FBuilding.prototype.getPeopleProductionSpeedPerHour = function()
{
	return this.getPeopleProductionSpeedPerHourFor(this.level);
}

FBuilding.staticGetBaseWarehouseCapacity = function(r, type, res, level, skinIndex, artifactsStoreIncreased)
{
	if ( typeof skinIndex == 'undefined')
		skinIndex = -1;

	var result = 0;

	var blevel = type.getLevels(r)[level];
	// as BLevel;
	if (type.isEstateHall())
	{
		if (BType.MINEHALL.equals(type))
		{
			result = FConfig.MINE_RESOURCE_STORAGE_CAPACITY.getValue(res);
		}
		else
		{
			var skinInfo = FConfig.getCitySkin(r, skinIndex);
			result = (blevel['capacity'] || 0) * (skinInfo ? skinInfo.capacity : 1);
		}
	}
	else if (type.isWarehouse() || type.isMarket() || type.isClanWarehouse() || type == BType.ARTIFACT_STORE || type == BType.PRISON)
	{
		result = blevel.capacity;
	}
	
	if (type == BType.ARTIFACT_STORE && level >= FConfig.INCREASE_ARTIFACTS_STORE_LEVEL && artifactsStoreIncreased) 
	{
		result += FConfig.INCREASE_ARTIFACTS_STORE_SIZE;
	}
	
	return result;
}

FBuilding.staticGetBaseRaise = function(r, type, level, skinIndex)
{
	if ( typeof skinIndex == 'undefined')
		skinIndex = -1;

	var result = 0;
	var blevel = type.getLevels(r)[level];
	if (type == BType.CASTLEHALL)
	{
		result = blevel.produces.getValue(type.getParams(r).raisedResource);
	}
	else if (type.isEstateHall())
	{
		var skinInfo = FConfig.CITY_SKIN_PRICES.getValue(r)[skinIndex];
		result = blevel.raises * skinInfo.raise;
	}
	else if (type.isRaiser())
	{
		result = blevel.raises;
	}
	return result;
}

FBuilding.staticGetBasePeopleCapacity = function(r, type, level, skinIndex)
{
	if ( typeof skinIndex == 'undefined')
		skinIndex = -1;

	var result = 0;
	var blevel = type.getLevels(r)[level];
	if (type.isEstateHall())
	{
		result = blevel.peopleCapacity * FConfig.getCitySkin(r, skinIndex).peopleCapacity;
		//var skinInfo = FConfig.CITY_SKIN_PRICES.getValue(r)[skinIndex];
		//result = blevel.peopleCapacity * skinInfo.peopleCapacity;
	}
	else
	if (type.isHouses() || type.isClanReservation())
	{
		result = blevel.capacity;
	}
	return result;
}

FBuilding.staticGetBasePeopleProduction = function(r, type, level, skinIndex)
{
	if ( typeof skinIndex == 'undefined')
		skinIndex = -1;

	var production = 0;
	var blevel = type.getLevels(r)[level];
	if (type.isHouses())
	{
		production = blevel.populationIncrease;
	}
	else if (type.isEstateHall())
	{
		var skinInfo = FConfig.getCitySkin(r, skinIndex);
		production = blevel.populationIncrease * skinInfo.populationIncrease;
	}
	return production;
}

