function FGrail()
{
    callParentConstructor(FGrail.prototype, this);
};

extendClass(FGrail.prototype, FOuterEstate.prototype);

FGrail.prototype.__className__ = "FGrail";

FGrail.prototype.getEstateType = function()
{
    return EstateType.GRAIL;
}

FGrail.prototype.isCellReachable = function(cellIndex)
{
    return this.isOnSector(cellIndex) ? this.isSectorsScienceLearned() : true;
}    

FGrail.prototype.isOnSector = function(cellIndex)
{
    return cellIndex < this.CELLS_ON_SECTORS;
}

FGrail.prototype.canManageOnSectors = function()
{
    return true;
}

FGrail.prototype.getVisualNumber = function(cellIndex)
{
    if (this.isOnSector(cellIndex))
    {
        return cellIndex % this.CELLS_PER_SECTOR + 1;
    }
    
    return superMethod(FGrail, "getVisualNumber", this)(this.getIndexWithoutSectors(cellIndex));
}

FGrail.prototype.getMaxCellIndex = function()
{
    return this.cells.length + this.CELLS_ON_SECTORS;
}