var Resource = function(name)
{
	this.name = name;
	
	this.__defineGetter__('icon', function()
	{
		return this.isNull() ? null : Assets.ICON_findBy(this);
	});
}

extendClass(Resource.prototype, Enum.prototype);

Resource.__isEnum__ = true;

Resource.prototype.__CLS__ = 'game.model.Resource';
Resource.prototype.__className__ = 'Resource';

Resource.prototype.isNull = function()
{
	return Resource.NULL.equals(this);
}

Resource.prototype.toString = function()
{
	return this.isNull() ? I18.f("ALL") : I18.getResourceName(this);
}

Resource.NULL = new Resource("NULL");

Resource.GOLD = new Resource("GOLD");
Resource.WOOD = new Resource("WOOD");
Resource.STONE = new Resource("STONE");
Resource.GRAIN = new Resource("GRAIN");
Resource.IRON = new Resource("IRON");
Resource.PEOPLE = new Resource("PEOPLE");

Resource.MARKET_RESOURCES = [Resource.WOOD, Resource.STONE, Resource.GRAIN, Resource.IRON];
Resource.RESOURCES_FOR_FILTER = [Resource.NULL].concat(Resource.MARKET_RESOURCES);
Resource.WAREHOUSE_RESOURCES = [Resource.GOLD].concat(Resource.MARKET_RESOURCES);
Resource.FUNDS_RESOURCES = [Resource.GOLD].concat(Resource.MARKET_RESOURCES).concat([Resource.PEOPLE]); 