function AddCellDialog()
{
	callParentConstructor(this);
	
	this.onResult = null;
	
	this.onCitySelect = $.proxy(this.onCitySelect, this);
	this.onCityChoose = $.proxy(this.onCityChoose, this);
}

extendClass(AddCellDialog.prototype, Dialog.prototype);

AddCellDialog.prototype.popup = function(parent, ownerUsername, onResult)
{
    superMethod(AddCellDialog.prototype, "popup", this)();
    
    this.onResult = onResult;
    Service.city.callMethod("getCityLinks", ownerUsername, $.proxy(function(links)
    {
    	this.updateButtons(links);
    }, this));
    
    this.scroll = new iScroll(this.buttons.parentNode, {scrollbarColor: '#784f0b'});
    
    COM(this.doButton).reason = I18.f("CHOOSE_CITY_FOR_ADD_CELL");
    COM.bindExclusiveClick(this.doButton, this.onCitySelect);
}

AddCellDialog.prototype.onShow = function()
{
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
}

AddCellDialog.prototype.updateButtons = function(cities)
{
	//this.buttons.empty();
	
	var b;
	for(var i=0; i<cities.length; i++)
	{
		b = COM.create("SimpleButton");
		
		b.caption = cities[i].estateInfo.toString();
		b.link = cities[i].estateInfo;
		$(b.DOM).on(CLICK_EVENT, this.onCityChoose);
		
		COM(this.buttons).addChild(b.DOM);
		
		if(!cities[i].canAddCells)
		{
			b.enabled = false;
		}
		
		//this.buttons.append($("<br/>"));
	}
	
	//b.on(CLICK_EVENT, this.close);
}

AddCellDialog.prototype.onCityChoose = function()
{
	COM(this.doButton).reason = "";
}

AddCellDialog.prototype.onCitySelect = function(e)
{
    var link = COM(this.buttons).selected.link;
    
    Service.city.callMethod("addCellToCity", link.id, $.proxy(function(us)
    {
    	if(this.onResult)
    	{
    		this.onResult(us);
    	}
    	
    	this.close();
    }, this));
}