function MoveCapitalDialog()
{
	callParentConstructor(this);
	
	this.scienceView = null;
	
	this.onSelect = $.proxy(this.onSelect, this);
	this.onCitySelect = $.proxy(this.onCitySelect, this);
}

extendClass(MoveCapitalDialog.prototype, Dialog.prototype);

MoveCapitalDialog.prototype.onSelect = function(e)
{
    var buttons = COM(this.buttons);
    var btn = COM(this.buttons).selected || COM($("SimpleButton", this.buttons)[0]);
    var capitalId = btn ? btn.cityId : '';
    
    APP.showLoader();
    
    Service.city.callMethod("getCapitalExtraBuildings", [], $.proxy(function(buildings)
    {
        if (buildings)
        {
            var names = [];
            
            for(var i=0; i<buildings.length; i++)
            {
            	names.push(buildings[i].getNameAndLevel());
            }
            
            var namesString = names.join("<br/>");
            
            var s = I18.f("CAPITAL_MOVE_WARNING_BUILDINGS", namesString);
            s = s.replace(/\r\n|\r|\n/g, "<br/>");
            
            Alert.create(s, "", $.proxy(function()
            {
            	this.moveCapital(capitalId);
            }, this));
        }
        else
        {
            this.moveCapital(capitalId);
        }
        
        APP.hideLoader();
        
    }, this));
};

MoveCapitalDialog.prototype.moveCapital = function(capitalId)
{
    var id = new EstateId(capitalId.x, capitalId.y, capitalId.z);
    
    Service.city.callMethod("moveCapitalTo", id,
    
    $.proxy(function(us)
    {
    	this.scienceView.updateScience(us);
    	this.close();
    }, this),
	
	$.proxy(function(e)
    {
    	if(e.__className__ == "MoveCapitalException")
    	{
    		Alert.create(e.getMessage());
    	}
    }, this));
}

MoveCapitalDialog.prototype.popup = function()
{
    superMethod(MoveCapitalDialog.prototype, "popup", this)();
    
    this.setCaption = I18.f("SCIENCE_CAPITAL").toUpperCase();
    
    var cities = [];
    var link;
    for(var i=0; i<FUser.LINKS.length; i++)
    {
    	link = FUser.LINKS[i];
    	if(link.estateInfo.estateType.name == "CITY")
    	{
    		cities.push(link);
    	}
    }
    
    this.updateButtons(cities);
    
    this.scroll = new iScroll(this.buttons.parentNode, {scrollbarColor: '#784f0b'});
	
	COM(this.moveButton).caption = I18.f('MOVE_CAPITAL');
	COM(this.moveButton).reason = I18.f('CHOOSE_CITY_FOR_CAPITAL');
	COM.bindExclusiveClick(this.moveButton, this.onSelect);
}

MoveCapitalDialog.prototype.onShow = function()
{
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
}

MoveCapitalDialog.prototype.updateButtons = function(cities)
{
	//this.buttons.empty();
	
	var b;
	for(var i=0; i<cities.length; i++)
	{
		b = COM.create("SimpleButton");
		
		b.caption = cities[i].estateInfo.toString();
		b.cityId = cities[i].estateInfo.location;
		$(b.DOM).on(CLICK_EVENT, this.onCitySelect);
		
		COM(this.buttons).addChild(b.DOM);
		
		if(cities[i].estateInfo.isCapital)
		{
			b.enabled = false;
		}
	}
	
	//b = $("<button/>");
	//b.html(I18.f("CANCEL"));
	//this.buttons.append(b);
	
	//b.on(CLICK_EVENT, this.close);
}

MoveCapitalDialog.prototype.onCitySelect = function(link)
{
    COM(this.moveButton).reason = "";
}

MoveCapitalDialog.prototype.isButtonEnabledFor = function(link)
{
    return !link.isCapital;
}