function ScienceButton()
{
	callParentConstructor(ScienceButton.prototype, this);
	this._science = null;
	this.sequence = null;
	this.sequenceResearch = null;
	this.scienceView = null;
	this.initialSkin = 1;
	
	this.lastSkin = null;
	this.noSkin = false;
	
	this.__defineGetter__("science", function()
	{
		return this._science;
	});

    this.__defineSetter__("science", function(s)
    {
        this._science = s;
        
        this.image.src = STATIC_INTERFACE_URL + Assets.getScienceImage(s);
        this.name.innerHTML = this.prepareName(I18.getScience(s));
    });
}

ScienceButton.prototype._science = null;
ScienceButton.prototype.sequence = null;
ScienceButton.prototype.sequenceResearch = null;
ScienceButton.prototype.scienceView = null;

ScienceButton.prototype.__construct = function()
{
	superMethod(ScienceButton.prototype, '__construct', this)();
}

ScienceButton.prototype.prepareName = function(name)
{
	var words = name.split(" ");
	for(var i=0; i<words.length; i++)
	{
		if(words[i].length > 14)
		{
			words[i] = words[i].substring(0, 12) + "-<br/>" + words[i].substring(12, words[i].length);
		}
	}
	
	return words.join(" ");
}

ScienceButton.prototype.setBorder = function()
{
}

ScienceButton.prototype.onInit = function()
{
}

ScienceButton.prototype.setSkin = function(val)
{
	if(this.lastSkin === val) return;
	if(this.noSkin) return;
	
	if(val)
	{
		this.imageContainer.style.backgroundImage = "url('" + STATIC_INTERFACE_URL + "shared/science/science_frame"+val+".png')";
	}
	else
	{
		this.imageContainer.style.backgroundImage = "";
	}
	
	this.lastSkin = val;
}

ScienceButton.prototype.handleError = function(e)
{
    if (e.__className__ == "IllegalScienceStateException")
    {
        Service.city.callMethod("research", [this.scienceView.getOwner().username, null], this.scienceView.updateScience);
        return true;
    }
    
    if (GameException.isDisplayable(e))
    {
        Alert.create(e.getMessage());
        return true;
    }
   
    return false;
}

ScienceButton.prototype.update = function(us)
{
	this.scienceView.userScience = us;

    var currentLevel = this.scienceView.userScience.getLevel(this._science);
    var maxLevel = this._science.getMaxLevel();
    
    var s = I18.f("CURRENT_MAX", currentLevel, maxLevel);
    this.curMaxLevel.innerHTML = s;

    var isCharged = this.scienceView.userScience.isCharged(this.science);
    
    if(isCharged) $(this.DOM).addClass("charged");
    else $(this.DOM).removeClass("charged");

    //var border = Style.SCIENCE_CANNOT_RESEARCH;
    
    if (this.scienceView.userScience.isResearchable(this._science, this.scienceView.getOwner()) || isCharged)
    {
        this.image.style.webkitFilter = "grayscale(0%)";
        $(this.curMaxLevel).removeClass("disabled");
        
        this.setSkin(this.initialSkin);
    }
    else if (currentLevel == maxLevel && maxLevel != 0)
    {
        this.image.style.webkitFilter = "grayscale(0%)";
        $(this.curMaxLevel).addClass("disabled");
        
        this.setSkin(this.initialSkin);
    }
    else
    {
    	this.image.style.webkitFilter = "grayscale(100%)";
    	$(this.curMaxLevel).addClass("disabled");
    	
    	this.setSkin(4);
    }
    
    //this.curMaxLevel.css("background", border);
    
    if(isCharged)
    {
    	this.alert.style.display = "";
    }
    else
    {
    	this.alert.style.display = "none";
    }
}

ScienceButton.prototype.isActive = function()
{
    return !Quarantine.contains(this) && this.scienceView.isDeputyAcess() &&
            (this.scienceView.userScience.isResearchable(this._science, this.scienceView.getOwner()) ||
                    this.scienceView.userScience.isCharged(this._science));
}