function ScienceDialog()
{
	callParentConstructor(this);
	
	this.science = null;
	this.scienceView = null;
	
	this.unchargeCallback = null;
	this.upgradeDialog = null;
	
	this.scienceButton = null;
	
	this.queueMode = false;
	this.currentScienceMode = false;
}

extendClass(ScienceDialog.prototype, Dialog.prototype);

ScienceDialog.prototype.popup = function(science, view)
{
	this.science = science;
	this.scienceView = view;
	
	superMethod(this, "popup")();
	
	this.onStartResearch = $.proxy(this.onStartResearch, this);
	this.onStartAddToQueue = $.proxy(this.onStartAddToQueue, this);
	
	COM.bindExclusiveClick(this.learnButton, this.onStartResearch);
	COM.bindExclusiveClick(this.replaceButton, this.onStartResearch);
	COM.bindExclusiveClick(this.addToQueueButton, this.onStartAddToQueue);
	COM.bindExclusiveClick(this.unchargeButton, $.proxy(function()
	{
		if(this.unchargeCallback) this.unchargeCallback();
	}, this));
	
	if(science.isSpecialization())
	{
		this.scienceButton = COM.create("ScienceSpecButton");
	}
	else
	{
		this.scienceButton = COM.create("ScienceButton");
	}
	
	this.scienceButton.scienceView = view;
	this.scienceButton.science = science;
	this.scienceButton.setSkin(1);
	this.scienceButton.name.style.display = "none";
	
	$(this.imgWrapper).append(this.scienceButton.DOM);
	
	this.scienceButton.DOM.style.position = "inherit";
	this.scienceButton.DOM.style.margin = "auto";
	
	this.update();
	
	this.scroll = new iScroll(this.contentContainer, {scrollbarColor: '#784f0b'});
	
	var hint = FUser.CURRENT_USER.findHint(HintType.STUDY_SCIENCE);
    if (hint && this.science.name == hint.science.name && !HintArrow.SELECT_SCIENCE.isShowing() && this.scienceView.userScience.isResearchable(hint.science, this.scienceView.getOwner()))
    {
		HintArrow.SELECT_SCIENCE.show(this.learnButton, hint, this.DOM);
    }
    
    UI.show(!view.estate.isEspionage, [this.buttonsContainer]);
}

ScienceDialog.prototype.onShow = function()
{
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
}

ScienceDialog.prototype.canBeAddedToQueue = function()
{
    return this.scienceView.isDeputyAcess() && this.scienceView.userScience.isResearchable(this.science, this.scienceView.getOwner()) && this.scienceView.getOwner().isPremium() &&
            this.scienceView.userScience.currentScience && this.scienceView.userScience.canAddToQueue(this.science);
}

ScienceDialog.prototype.update = function()
{
	//this.name.html(I18.getScience(this.science));
	//this.description.html(I18.getScienceDesc(this.science, this.scienceView.userScience.getLevel(this.science), this.scienceView.getOwner().race));
	
	//this.image.attr("src", STATIC_URL + Assets.getScienceImage(this.science));
	
	COM.get(this.obtainPearl).update(this.scienceView.getOwner());
	
	this.scienceButton.update(this.scienceView.userScience);
	this.setCaption(I18.getScience(this.science).toUpperCase());
	
	var chosen = this.scienceView.userScience.isScienceInProgress();
	
	var currentLevel = this.scienceView.userScience.getLevel(this.science);
    var maxLevel = this.science.getMaxLevel();
    //this.curMaxLevel.html(I18.f("CURRENT_MAX", currentLevel, maxLevel));
    
    var isCharged = this.scienceView.userScience.isCharged(this.science);
	
    //can reserch
    if (this.scienceView.userScience.isResearchable(this.science, this.scienceView.getOwner()))
    {
        if(this.scienceView.userScience.isScienceInProgress())
        {
        	this.learnButton.style.display = "none";
        	this.replaceButton.style.display = "";
        	
        	if(this.canBeAddedToQueue())
        	{
        		this.addToQueueButton.style.display = "";
        	}
        	else
        	{
        		this.addToQueueButton.style.display = "none";
        	}
        }
        else
        {
        	this.learnButton.style.display = "";
        	this.replaceButton.style.display = "none";
        	this.addToQueueButton.style.display = "none";
        }
    }
    //max level
    else if (currentLevel == maxLevel && maxLevel != 0)
    {
        this.learnButton.style.display = "none";
		this.replaceButton.style.display = "none";
		this.addToQueueButton.style.display = "none";
    }
    //cannot research
    else
    {
    	this.learnButton.style.display = "none";
		this.replaceButton.style.display = "none";
		this.addToQueueButton.style.display = "none";
    }
    
    if(this.science.equals(this.scienceView.userScience.currentScience))
    {
    	this.learnButton.style.display = "none";
		this.replaceButton.style.display = "none";
		this.addToQueueButton.style.display = "none";
    }
    
    COM(this.tip).update(this.scienceView.userScience, this.science, this.scienceView.getOwner().race, false, this.scienceView.getOwner().isInRegisteredClan());
    
    var isOwner = this.scienceView.getOwner().username == FUser.CURRENT_USER.username;
    
    if(isCharged)
    {
    	this.unchargeButton.style.display = "";
    	var caption = I18.f('IMPROVE');
    	
    	if(this.science.equals(Science.CAPITAL))
    	{
    		this.unchargeCallback = this.onUnchargeCapital;
    		caption = I18.f('MOVE_CAPITAL');
    		
    		if(!isOwner) this.unchargeButton.style.display = "none";
    	}
		else if(this.science.equals(Science.ADD_CELL))
		{
			this.unchargeCallback = this.onUnchargeAddCell;
			caption = I18.f('EXPAND'); 
		}
		else if(this.science.equals(Science.SCAVENGER)) this.unchargeCallback = this.onUnchargeUnit;
		else if(this.science.equals(Science.MELEE)) this.unchargeCallback = this.onUnchargeUnit;
		else if(this.science.equals(Science.CAVALRY)) this.unchargeCallback = this.onUnchargeUnit;
		else if(this.science.equals(Science.FLYER)) this.unchargeCallback = this.onUnchargeUnit;
		else if(this.science.equals(Science.RANGER)) this.unchargeCallback = this.onUnchargeUnit;
		else if(this.science.equals(Science.HEALER)) this.unchargeCallback = this.onUnchargeUnit;
		else if(this.science.equals(Science.MINER)) this.unchargeCallback = this.onUnchargeUnit;
		else if(this.science.equals(Science.MAGE)) this.unchargeCallback = this.onUnchargeUnit;
		else
		{
			this.unchargeCallback = this.onUncharge;
			caption = I18.f('DONATE');
			
			if(!isOwner) this.unchargeButton.style.display = "none";
		}
		
		if(this.unchargeButton.caption != caption)
		{
			COM.get(this.unchargeButton).caption = caption;
		}
    }
    else
    {
    	this.unchargeButton.style.display = "none";
    	this.unchargeCallback = null;
    }
    
    if(this.queueMode || this.currentScienceMode)
    {
    	UI.show(false, [this.learnButton, this.replaceButton, this.addToQueueButton, this.unchargeButton]);
    }
    
    UI.show(this.queueMode, [this.removeFromQueueButton]);
    
    if(!isOwner) this.obtainPearl.style.display = "none";
    
    if(!isOwner && !this.scienceView.estate.accessDeputy)
    {
        this.obtainPearl.style.display = "none";
        this.unchargeButton.style.display = "none";
        this.learnButton.style.display = "none";
        this.replaceButton.style.display = "none";
        this.addToQueueButton.style.display = "none";
        this.removeFromQueueButton.style.display = "none";
    }
}

ScienceDialog.prototype.gotoQueueMode = function(removeCallback)
{
	this.queueMode = true;
	COM.bindExclusiveClick(this.removeFromQueueButton, $.proxy(function()
	{
		removeCallback(this.science);
		this.close();
	}, this));
	
	this.update();
}

ScienceDialog.prototype.gotoCurrentScienceMode = function()
{
	this.currentScienceMode = true;
	this.update();
}

ScienceDialog.prototype.onResearch = function()
{
    if(HintArrow.SELECT_SCIENCE.isShowing())
    {
    	HintArrow.SELECT_SCIENCE.understood();
    	this.noClearHints = true;
    }
    
    if (!Quarantine.contains(this.science))
    {
        Quarantine.put(this.science);
        
        Service.city.callMethod("research", [this.scienceView.getOwner().username, this.science], $.proxy(function(us)
        {
        	this.scienceView.updateScience(us);
        	this.close();
        	
        	APP.updateHints();
        }, this));
    }
}

ScienceDialog.prototype.isActive = function()
{
    return !Quarantine.contains(this) && this.scienceView.isDeputyAcess() &&
            (this.scienceView.userScience.isResearchable(this.science, this.scienceView.getOwner()) ||
                    this.scienceView.userScience.isCharged(this.science));
}

ScienceDialog.prototype.onStartResearch = function()
{
    if (this.isActive())
    {
        if (!this.scienceView.userScience.isCharged(this.science))
        {
        	if (this.science.isSpecialization() && this.scienceView.userScience.isAnotherSpecialResearched(this.science))
        	{
                Alert.create(I18.f("SCIENCE_SPECIALIZATION_RESEARCHED_WARNING"), "", $.proxy(function()
                {
                    this.onResearch();
                }, this));
            }
            else if (this.science.isSpecialization() && this.scienceView.userScience.isAnotherSpecialAlreadyInQueue(this.science))
            {
                Alert.create(I18.f("SCIENCE_SPECIALIZATION_IN_QUEUE_WARNING"), "", $.proxy(function()
                {
                    this.onResearch();
                }, this));
            }
            else if (this.scienceView.userScience.currentScience && !this.scienceView.userScience.currentScience.isClannish()
                    && this.scienceView.userScience.knowledge > this.scienceView.userScience.getNextLevelCost(this.science))
			{
                Alert.create(I18.f("SCIENCE_POINTS_MOVE_QUESTION"), "", $.proxy(function()
                {
                    this.onResearch();
                }, this));
            }
            else if (this.scienceView.userScience.currentScience && this.science.isClannish()
                    && NumberUtils.floor(this.scienceView.userScience.knowledge) > 0)
			{
                Alert.create(I18.f("SCIENCE_POINTS_MOVE_CLANISH", NumberUtils.floor(this.scienceView.userScience.knowledge)), "", $.proxy(function()
                {
                    this.onResearch();
                }, this));
            }
            else
            {
                if (this.science.equals(this.scienceView.userScience.currentScience))
                {
                    Alert.create(I18.f("SCIENCE_ALREADY_IN_RESEARCH"));
                }
                else
                {
                    this.onResearch();
                }
            }
        }
    }
}

ScienceDialog.prototype.onStartAddToQueue = function()
{
    var isSpecial = this.science.isSpecialization();
    if (isSpecial && this.scienceView.userScience.isAnotherSpecialResearched(this.science))
    {
        Alert.create(I18.f("SCIENCE_SPECIALIZATION_RESEARCHED_WARNING"), "", $.proxy(this.onAddToQueue, this));
    }
    else
    {
        this.onAddToQueue();
    }
}

ScienceDialog.prototype.onAddToQueue = function()
{
    if (!Quarantine.contains(this.science))
    {
        Quarantine.put(this.science);
        Service.city.callMethod("addScienceToQueue", [this.scienceView.getOwner().username, this.science], $.proxy(function(us)
        {
        	this.scienceView.updateScience(us);
        	this.close();
        }, this));
    }
}

// default uncharge - pearl uncharge
ScienceDialog.prototype.onUncharge = function()
{
    if (this.scienceView.getOwner().username == FUser.CURRENT_USER.username)
    {
        var dialog = UnchargePearlScienceDialog.create(this.science);
        
        dialog.usePearl = $.proxy(function()
        {
            Service.city.callMethod("unchargePearlScience", this.science, $.proxy(function(us)
            {
            	this.scienceView.updateScience(us);
            	this.close();
            }, this), $.proxy(this.scienceView.handleError, this));
            
            dialog.close();
        }, this);
        /*
        dialog.afterUseFriendsPoints = function()
        {
            Service.city.getScience(scienceView.getOwner().username).handle(scienceView.updateScience, handleError);
            dialog.close();
        };
        */
        
        dialog.popup();
    }
}

ScienceDialog.prototype.onUnchargeCapital = function(s)
{
    if (!this.estate || this.estate.accessManageble)
    {
        var dialog = COM.create("MoveCapitalDialog");
        dialog.scienceView = this.scienceView;
        dialog.popup(this);
    }
}

ScienceDialog.prototype.onUnchargeAddCell = function(s)
{
	var dialog = COM.create("AddCellDialog");
    dialog.popup(this, this.scienceView.estate ? this.scienceView.estate.owner.username : FUser.CURRENT_USER.username, $.proxy(this.scienceView.updateScience, this.scienceView));
}

ScienceDialog.prototype.onUnchargeUnit = function()
{
    var utype = Science.getUTypeFor(this.science);
    var parent = this;
    
    APP.showLoader();
    
    Service.city.callMethod("getUpgradeUnitsInfo", [this.scienceView.getEstateId(), utype], $.proxy(function(info)
    {
        this.upgradeDialog = COM.create("UnitUpgradeDialog");
        
        this.upgradeDialog.onResult = $.proxy(function()
        {
            Service.city.callMethod("upgradeUnits", [this.scienceView.getEstateId(), utype], $.proxy(this.scienceView.updateScience, this.scienceView));
        }, this);
        
        this.upgradeDialog.onClose = $.proxy(function()
        {
            this.upgradeDialog = null;
        }, this);
        
        this.upgradeDialog.popup(this, this.scienceView.getOwner(), utype, info);
        
        APP.hideLoader();
    }, this), APP.hideLoader);
}