function ScienceStatusButton()
{
	callParentConstructor(ScienceStatusButton.prototype, this);
	
	this.scienceView = null;
    this.estate = null;
    this.userScience = null;
}

extendClass(ScienceStatusButton.prototype, RoundButton.prototype);

ScienceStatusButton.prototype.__construct = function()
{
	superMethod(ScienceStatusButton.prototype, "__construct", this)();
	
	this.icon = STATIC_INTERFACE_URL + "city/dashboard/science.png";
	this.caption = I18.f('SCIENCE');
	
	COM.bindExclusiveClick(this.DOM, $.proxy(this.onShowScience, this));
}

ScienceStatusButton.prototype.isEspionage = function()
{
    return this.estate ? this.estate.isEspionage : false;
}

ScienceStatusButton.prototype.canAccessScience = function()
{
    return this.estate ? this.estate.accessScience : true;
}

ScienceStatusButton.prototype.createChildren = function()
{
	console.log("SCIENCE CREATE CHILDREN");
}

ScienceStatusButton.prototype.update = function(userScience, estate)
{
    if(!userScience)
    {
    	return;
    }
    
    this.userScience = userScience;
    this.estate = estate;
    this.enabled = this.canAccessScience();
    this.refreshTint();
    
	if(this.canAccessScience())
	{
		APP.scienceView.update(userScience, estate);
	}
}

ScienceStatusButton.prototype.refreshTint = function()
{
    if (!this.enabled)
    {
        $(this.iconImage).css("-webkit-filter", "grayscale(100%)");
    }
    else
    {
        $(this.iconImage).css("-webkit-filter", "grayscale(0%)");
        
        var MODE_NORMAL = 1;
        var MODE_OLD_CHARGED = 2;
        var MODE_NEW_CHARGED = 3;
        var MODE_NO_SCIENCE = 4;
        var MODE_NO_SCIENTISTS = 5;

        if (this.canAccessScience())
        {
            var mode = MODE_NORMAL;
            if (this.userScience.isScienceInProgress())
            {
                if (NumberUtils.isPositive(this.userScience.speedPerHour))
                {
                    mode = MODE_NORMAL;
                } 
                else
                {
                    mode = MODE_NO_SCIENTISTS;
                }
            }
            else if (this.userScience.hasChargedSciences())
            {
                if (this.userScience.isChargedScienceVisited)
                {
                    mode = MODE_OLD_CHARGED;
                }
                else
                {
                    mode = MODE_NEW_CHARGED;
                }
            }
            else if (!this.userScience.isAllScienceResearched())
            {
                mode = MODE_NO_SCIENCE;
            }
			
			this.warning = false;
            switch (mode)
            {
                case MODE_NORMAL:
                    break;
                case MODE_OLD_CHARGED:
                    break;
                case MODE_NEW_CHARGED:
                    this.warning = true;
                    break;
                case MODE_NO_SCIENCE:
                case MODE_NO_SCIENTISTS:
                    this.warning = true;
                    break;
            }
        }
    }
}

ScienceStatusButton.prototype.createScienceTip = function(event)
{
}

ScienceStatusButton.prototype.onShowScience = function()
{
	APP.showLoader();
	setTimeout($.proxy(this.doShowScience, this), 100);
	
	//this.doShowScience();
}

ScienceStatusButton.prototype.doShowScience = function()
{
    /*
    this.scienceView = COM.create("ScienceView");
    
    this.scienceView.setCaption(this.caption.toUpperCase());
    this.scienceView.onClose = $.proxy(this.killView, this);
	this.scienceView.popup(this.userScience, this.estate);
	*/
	
	HintArrow.OPEN_SCIENCE.understood();
	
	var start = new Date().getTime();
	
	APP.scienceView.setCaption(this.caption.toUpperCase());
	APP.scienceView.popup(this.userScience, this.estate);
	
	APP.hideLoader();
	
	//alert(new Date().getTime() - start);
	//console.log(new Date().getTime() - start);
}

ScienceStatusButton.prototype.killView = function()
{
	this.scienceView = null;
}

ScienceStatusButton.prototype.onMouseOut = function()
{
}