function ScienceTip()
{
	
}

ScienceTip.prototype.__construct = function()
{
	COM.get(this.cost).asSpeed = false;
    COM.get(COM.get(this.cost).speed).setTextClass("text-normal text-small");
    
    COM.get(this.unchargePearlCost).source = STATIC_INTERFACE_URL + CommonAssets.ICON_PEARL;
    COM.get(this.unchargePearlCost2).source = STATIC_INTERFACE_URL + CommonAssets.ICON_PEARL;
    
    COM.get(this.unchargePearlCost).setTextClass("text-normal-bold text-small");
    COM.get(this.unchargePearlCost2).setTextClass("text-normal-bold text-small");
}

ScienceTip.prototype.update = function(us, what, race, currentLevelOnly, isInRegisteredClan)
{
    if (!us)
    {
        return;
    }

    var currentLevel = us.getLevel(what);
    var maxLevel = what.getMaxLevel();
    
    //this.title.html(I18.mega({key: "SCIENCE_TIP_LEVEL"}, [what, currentLevel, maxLevel]));
    
    if(currentLevel != 0 || maxLevel == 0)
    {
    	this.current.style.display = "";
    	this.updateDescription(this.description, currentLevel, us, what, race);
    }
    else
    {
    	this.current.style.display = "none";
    }
    
    if(us.isCharged(what))
    {
    	this.needHelp.style.display = "";
    }
    else
    {
    	this.needHelp.style.display = "none";
    }
    
    if(currentLevel < maxLevel && !currentLevelOnly)
    {
	    this.next.style.display = "";
	
	    if (what.isClannish())
	    {
			COM.get(this.cost).updateProgress(us.clanKnowledge, us.getNextLevelCost(what));
		}
		else
		{
			COM.get(this.cost).value = us.getNextLevelCost(what);
		}
		
		if(what.isClannish())
		{
			this.finishBox.style.display = "";
			this.finishLabel.innerHTML = Tick.toTimeFuture(us.clanEndTick);
		}
		else
		{
			this.finishBox.style.display = "none";
		}
	
	    var sciencePrice = what.getLevel(currentLevel);
	    if(sciencePrice.unchargePrice > 0 && sciencePrice.unchargeFriends <= 0)
	    {
	    	this.unchargePearlCost.style.display = "";
	    	COM.get(this.unchargePearlCost).value = sciencePrice.unchargePrice.toString();
	    }
	    else
	    {
	    	this.unchargePearlCost.style.display = "none";
	    }
	    
	    if(sciencePrice.unchargePrice > 0 && sciencePrice.unchargeFriends > 0)
	    {
		    this.costBox2.style.display = "";
		    this.unchargeFriendsCost.innerHTML = I18.f("OR_INVITE_FRIENDS", sciencePrice.unchargeFriends);
			COM.get(this.unchargePearlCost2).value = sciencePrice.unchargePrice.toString();
		}
		else
		{
			this.costBox2.style.display = "none";
		}
	    
	    if(what.isClannish() && !isInRegisteredClan)
	    {
	    	this.costBox3.style.display = "";
	    }
	    else
	    {
	    	this.costBox3.style.display = "none";
	    }
	    
	    var deps = [];
	    var unsatisfiedDeps = us.getUnsatisfiedDeps(what);
	    var dep;
	    for(var i=0; i<unsatisfiedDeps.raw.length; i++)
	    {
	    	dep = unsatisfiedDeps.raw[i].key;
	    	deps.push(I18.getScience(dep) + " " + unsatisfiedDeps.getValue(dep));
	    }
	    this.nextDeps.innerHTML = deps.join(", ");
	
	    var utype = Science.getUTypeFor(what);
	    if(utype && currentLevel > 0)
	    {
	    	this.upgradeBox.style.display = "";
	    	COM(this.upgradeCost).update(us.getUnitUpgradeCost(utype, race), race);
	    	COM(this.upgradeCost).setTextClass("text-normal-bold text-small");
	    }
	    else
	    {
	    	this.upgradeBox.style.display = "none";
	    }
	    
	    this.updateDescription(this.nextDescription, currentLevel+1, us, what, race);
    }
    else
    {
    	this.next.style.display = "none";
    }
}

ScienceTip.prototype.updateDescription = function(description, level, us, what, race)
{
    description = $(description);
    
    description.empty();
    var maxLevel = what.getMaxLevel();
    if (maxLevel == 0)
    {
        description.append(I18.f("HEROES_NOT_AVAILABLE"));
        return;
    }
	
	var s = I18.getScienceDesc(what, level, race);
	s = s.replace(/\r\n|\r|\n/g, "<br/>");
	
    description.append(s);

    if (what.equals(Science.HIDDEN_RESOURCES))
    {
        var box = $("<div/>");
        box.css("display", "inline-table");
         
        var fb = FundsBox.create(what.getLevel(level - 1).canHide, race);
        fb.setTextClass("text-normal-bold text-small");
        
        box.append(fb.DOM);
        description.append(box);
    }

    if (what.equals(Science.SPEC_DEFENDER))
    {
        var box = $("<div/>");
        
        box.append(I18.f("SCIENCE_TIP_SPEC_DEFENDER2", what.getLevel(level - 1).fortificationDefenceBonus));
        var img = $("<img/>");
        img.attr("src", STATIC_URL + CommonAssets.STAT_DEFENCE);
        box.append(img);
        description.append(box);
    }

    if (what.equals(Science.HEROES) && us.getLevel(Science.HEROES_SKILL) == 0)
    {
        description.append($("<br/>"));
        description.append(I18.f("SCIENCE_TIP_HEROES_SPECIAL", FConfig.MAX_HERO_LEVEL_BASE));
    }
}