function ScienceView()
{
	callParentConstructor(this);
	
	this.upgradeDialog = null;
	this.scienceButtons = null;
	this.estate = null;
	this.userScience = null;
	
	this.scienceDialog = null;
	
	this.scroll = null;
}

extendClass(ScienceView.prototype, Dialog.prototype);

ScienceView.prototype.upgradeDialog = null;
ScienceView.prototype.scienceButtons = null;
ScienceView.prototype.estate = null;
ScienceView.prototype.userScience = null;

ScienceView._instance = null;
ScienceView.createAndShow = function(userScience, estate)
{
    if (!ScienceView._instance)
    {
        ScienceView._instance = new ScienceView();
    }
    else
    {
        ScienceView._instance.update(userScience, estate);
    }
    return ScienceView._instance;
}

ScienceView.prototype.__construct = function()
{
	superMethod(ScienceView.prototype, "__construct", this)();
	
	this.decoration = false;
	
	var self = this;
	var x, y, science, width = 1024;
	
	this.onShowDialog = $.proxy(this.onShowDialog, this);
	this.showDialog = $.proxy(this.showDialog, this);
	
	this.walkScienceButton(function(b)
	{
		b = COM.get(b);
		
		//x = self.prepareAttribute(b.attr("x"));
		//y = self.prepareAttribute(b.attr("y"));
		science = eval(self.prepareAttribute(b.DOM.getAttribute("science")));
		
		/*
		if(x % 1 !== 0)
		{
			if(self[x]) x = self[x];
			else x = eval(x);
		}
		if(y % 1 !== 0)
		{
			if(self[y]) y = self[y];
			else y = eval(y)
		}
		*/
		
		b.scienceView = self;
		//b.css({left: x, top: y});
		b.science = science;
		
		if(b.DOM.getAttribute("noskin")) b.noSkin = true;
		
		var skin = b.DOM.getAttribute("skin");
		b.initialSkin = skin;
		b.setSkin(skin);
		
		COM.bindExclusiveClick(b.DOM, self.onShowDialog);
	});
	
	this.showCurrentScience = $.proxy(this.showCurrentScience, this);
	this.removeScienceFromQueue = $.proxy(this.removeScienceFromQueue, this);
	this.showQueueItem = $.proxy(this.showQueueItem, this);
	
	COM.bindExclusiveClick(this.currentScience, this.showCurrentScience);
	
	for(var i=0; i<4; i++)
	{
		COM.bindExclusiveClick(this["queueItem"+i], this.showQueueItem);
	}
	
	this.specLabel.innerHTML = I18.f('SPECIALIZATIONS').toUpperCase();
	
	this.scroll = new iScroll(this.scrollContainer, {scrollbarColor: '#784f0b'});
	
	COM.bindExclusiveClick(this.speedBox, $.proxy(this.onSpeedTip, this));
}

ScienceView.prototype.onShowDialog = function(e)
{
	if (this.scroll && !this.scroll.isReady()) return;
	
	this.showDialog(e);
	/*
	APP.showLoader();
	setTimeout($.proxy(function()
	{
		this.showDialog(e);
	}, this), 100);
	*/
}

ScienceView.prototype.showDialog = function(e)
{
	HintArrow.SELECT_SCIENCE.hide();
	
	//var start = new Date().getTime();
	
	var b =  COM(e.currentTarget ? e.currentTarget : e);
	
	this.scienceDialog = COM.create("ScienceDialog");
    this.scienceDialog.onClose = $.proxy(this.killDialog, this);
	
	this.scienceDialog.popup(b.science, this);
	
	//APP.hideLoader();
	
	//alert(new Date().getTime() - start);
	//console.log(new Date().getTime() - start);
}

ScienceView.prototype.killDialog = function()
{
	HintArrow.SELECT_SCIENCE.hide();
	this.scienceDialog = null;
	this.updateArrows();
}

ScienceView.prototype.prepareAttribute = function(val)
{
	if(val)
	{
		val = val.replace("{", "");
		val = val.replace("}", "");
	}
	return val;
}

ScienceView.prototype.getOwner = function()
{
    return this.estate ? this.estate.owner : FUser.CURRENT_USER;
}

ScienceView.prototype.isDeputyAcess = function()
{
    return this.estate ? this.estate.accessDeputy : true;
}

ScienceView.prototype.isEspionage = function()
{
    return this.estate ? this.estate.isEspionage : false;
}

ScienceView.prototype.getLinks = function()
{
    return this.estate ? this.estate.links : FUser.LINKS;
}

ScienceView.prototype.getEstateId = function()
{
    return this.estate ? this.estate.id : GlobalSelectionCitiesCombo.selectedCityId;
}

ScienceView.prototype.createTipCell = function()
{
	var cell = document.createElement("cell");
	cell.style.textAlign = "left";
	cell.style.padding = "6px";
	return cell;
}

ScienceView.prototype.createTipRow = function(val1, val2, val3)
{
	row = document.createElement("row");
	
	cell = this.createTipCell();
	if(val1) $(cell).append(val1);
	row.appendChild(cell);
	
	cell = this.createTipCell();
	if(val2) $(cell).append(val2);
	row.appendChild(cell);
	
	cell = this.createTipCell();
	if(val2) $(cell).append(val3);
	row.appendChild(cell);
	
	return row;
}

ScienceView.prototype.onSpeedTip = function()
{
    var tip;
    var buff;
    if (!this.userScience.currentScience)
    {
        tip = document.createElement("div");
        tip.innerHTML = I18.f("SCIENCE_NOT_CHOSEN");
    }
    else if (this.userScience.currentScience.isClannish())
    {
        tip = document.createElement("inline-table");
        var keys = this.userScience.contributors.keys;
        var row, cell;
        for(var i=0; i<keys.length; i++)
        {
        	tip.appendChild(this.createTipRow(keys[i], KnowledgeView.create(this.userScience.contributors.getValue(keys[i])).DOM));
        }
    }
    else
    {
        var isScienceStopped = false;
        
        var buffs = this.getOwner().buffs;
        var buff;
        for(var i=0; i<buffs.length; i++)
        {
        	buff = buffs[i];
        	if (buff.buffType.name == BuffType.SCIENCE_STOP.name)
        	{
                tip = document.createElement("div");
                tip.innerHTML = I18.getBuffCause(buff) + " " + I18.getMegaString("TILL", [buff.cast.tillTick]);
                isScienceStopped = true;
            }
        }
        
        if (!isScienceStopped)
        {
            tip = document.createElement("inline-table");
            
            var links = this.getLinks();
            var link, row, cell;
            for(var i=0; i<links.length; i++)
            {
            	link = links[i];
            	if (link.estateInfo.canHaveScience())
            	{
                    tip.appendChild(this.createTipRow(link.estateInfo.toString(), KnowledgeView.create(link.scienceSpeedPerHour).DOM));
                }
            }
            
            var buffs = this.getOwner().buffs;
            var buff;
            for(var i=0; i<buffs.length; i++)
	        {
	        	buff = buffs[i];
	        	if (buff.buffType.name == BuffType.SCIENCE_BOOST.name)
	        	{
	        		tip.appendChild(this.createTipRow(I18.getBuffCause(buff), KnowledgeView.create(buff.value).DOM, I18.getMegaString("TILL", [buff.cast.tillTick])));
	        	}
	        }
           
			if (this.userScience.magicBoost)
			{
	        	tip.appendChild(this.createTipRow(I18.f("ANCIENT_MAGIC_NAME_IS_ACTIVE")));
            }
        }
    }
    
    var d = TipDialog.create(tip, I18.f("SCIENCE_SPEED"));
    d.message.style.textAlign = "center";
}

ScienceView.prototype.popup = function(userScience, estate)
{
	if(!userScience) return;
	
	if(!this.DOM.parentNode)
	{
		superMethod(this, "popup")();
		this.fullScreen();
	}
	else
	{
		this.DOM.style.display = "";
		this.fitLayout();
		this.onShow();
	}
	
	this.update(userScience, estate);
}

ScienceView.prototype.refreshScroll = function()
{
	if($(this.DOM).is(':visible'))
    {
    	this.scroll.scrollTo(0, 0, 0);
		setTimeout($.proxy(this.scroll.refresh, this.scroll), 500);
    }
}

ScienceView.prototype.onShow = function()
{
	this.refreshScroll();
	
	this.bringToFront();
	console.debug('TO FRONT');
	
	this.tick();
}

ScienceView.prototype.fitLayout = function(container)
{
	superMethod(ScienceView.prototype, "fitLayout", this)(container);
	
	this.scrollContainer.style.width = this.content.offsetWidth + "px";
	this.scrollContainer.style.height = (this.content.offsetHeight-16) + "px";
	this.contentWrapper.style.width = this.content.offsetWidth + "px";
}

ScienceView.prototype.close = function()
{
	this.DOM.style.display = "none";
	Dialog.fullScreenDialogsCount--;
	//APP.getCurrentMediator().DOM.style.display = "";
	
	this.destroyChildArrows();
}

ScienceView.prototype.updateEstateInButtons = function()
{
    var buttons = this.getScienceButtons();
    for(var i=0; i<buttons.length; i++)
    {
    	buttons[i].scienceView = this;
    }
}

ScienceView.prototype.getScienceQueue = function()
{
    var res = [null, null, null, null];
    var queue = this.userScience.scienceQueue;
    
    if(!queue)
    {
    	return res;
    }
    
    for (var i = 0; i < queue.length; i++)
    {
        res[i] = queue[i];
    }
    return res;
}

ScienceView.prototype.update = function(userScience, estate)
{
    this.userScience = userScience;
    this.estate = estate;
    
    //this.castlesArrow.toggle(FConfig.CASTLES_ENABLED);
    //this.castlesButton.toggle(FConfig.CASTLES_ENABLED);
    
    if (this.isDeputyAcess() && this.userScience.hasChargedSciences() && !this.userScience.isChargedScienceVisited)
    {
        Service.city.callMethod("markVisitedChargedScience");
        this.userScience.isChargedScienceVisited = true;
    }
    
    this.updateQueueView();
    this.updateEstateInButtons();
    
    setTimeout($.proxy(this.updateArrows, this), 500);
    
    this.tick();
}

ScienceView.prototype.updateArrows = function()
{
	if (!this.userScience.currentScience && this.DOM.style.display != "none")
    {
        var hint = FUser.CURRENT_USER.findHint(HintType.STUDY_SCIENCE);
        
        if (hint && !this.scienceDialog && !HintArrow.SELECT_SCIENCE.isShowing() && this.userScience.isResearchable(hint.science, this.getOwner()))
        {
            this.walkScienceButton($.proxy(function(button)
	        {
	            if(COM(button).science.name == hint.science.name)
	            {
	            	HintArrow.SELECT_SCIENCE.show(button, hint, this.contentWrapper, null, {x: 0, y: -110});
	            }
	        }, this));
        }
    }
}

ScienceView.prototype.updateQueueView = function()
{
	var item;
	var queue = this.getScienceQueue();

	for(var i=0; i<4; i++)
	{
		item = COM.get(this["queueItem"+i]);
		
		if(queue[i])
		{
			item.icon = STATIC_INTERFACE_URL + Assets.getScienceImage(queue[i]);
			item.science = queue[i];
			
			if(queue[i].isSpecialization())
			{
				item.setBorder(false);
				$(item.DOM).addClass("spec");
			}
			else
			{
				item.setBorder(true);
				$(item.DOM).removeClass("spec");
			}
			
			this["queueItem"+i].style.display = "";
		}
		else
		{
			item.icon = null;
			item.science = null;
			item.setBorder(false);
			this["queueItem"+i].style.display = "none";
		}
	}
}

ScienceView.prototype.showQueueItem = function(e)
{
	this.showDialog(e);
	
	this.scienceDialog.gotoQueueMode(this.removeScienceFromQueue);
}

ScienceView.prototype.showCurrentScience = function(e)
{
	this.showDialog(this.currentScience);
	
	this.scienceDialog.gotoCurrentScienceMode();
}

ScienceView.prototype.removeScienceFromQueue = function(science)
{
	Service.city.callMethod("removeScienceFromQueue", [this.getOwner().username, science], $.proxy(this.updateScience, this));
}

ScienceView.prototype.updateScience = function(us)
{
    if (this.estate)
    {
        Service.city.callMethod("getById", this.estate.id, $.proxy(function(e)
        {
            this.update(us, e);
        }, this));
    }
    else
    {
        FUser.CURRENT_USER.science = us;
        this.update(us, null);
    }
}

ScienceView.prototype.tick = function()
{
    if(this.DOM.style.display == "none") return;
    
    COM(this.speed).value = this.userScience.speedPerHour;

    var chosen = this.userScience.isScienceInProgress();
    var progressing = !Tick.isInfinity(this.userScience.scienceEndTick);
    var stopped = (this.estate ? this.estate.owner : FUser.CURRENT_USER).hasBuff(BuffType.SCIENCE_STOP);
	
    if (chosen)
    {
        var nextLevel = this.userScience.getNextLevelCost(this.userScience.currentScience);
        this.setProgress(Math.min(this.userScience.knowledge, nextLevel), nextLevel);
        if (progressing)
        {
            COM(this.speed).speed.style.color = "#0000bb";
        }
        else
        {
            COM(this.speed).speed.style.color = "#bb0000";
        }
    }
    else
    {
        this.setProgress(0, 1);
        
        COM(this.speed).speed.style.color = "#bb0000";

        // refresh science if research complete
        if (this.userScience.currentScience)
        {
            Service.city.callMethod("research", [this.getOwner().username, null], $.proxy(this.updateScience, this));
        }
    }
    
    var buttons = this.getScienceButtons();
    for(var i=0; i<buttons.length; i++)
    {
    	COM.get(buttons[i]).update(this.userScience);
    }
    
    if(!this.estate || this.estate.accessManageble)
    {
    	this.magic.style.display = "";
    }
    else
    {
    	this.magic.style.display = "none";
    }
    
    if (this.estate)
    {
        COM.get(this.magic).update(this.estate);
    }
    else
    {
        COM.get(this.magic).updateFromUser(FUser.CURRENT_USER);
    }
    
    if(chosen)
    {
    	//this.currentScience.html(I18.getScience(this.userScience.currentScience));
    	var sv = COM(this.currentScience);
    	sv.icon = STATIC_INTERFACE_URL + Assets.getScienceImage(this.userScience.currentScience);
    	sv.science = this.userScience.currentScience;
    	this.progress.style.display = "";
    	
    	if(this.userScience.currentScience.isSpecialization())
    	{
    		sv.setBorder(false);
    		$(this.currentScience).addClass("spec");
    	}
    	else
    	{
    		sv.setBorder(true);
    		$(this.currentScience).removeClass("spec");
    	}
    	
		this.currentScience.style.display = ""
		this.currentScienceBox.style.display = "";
    }
    else
    {
    	this.currentScience.style.display = "none"
    	this.currentScienceBox.style.display = "none"
    	this.progress.style.display = "none";
    }
    
    if(progressing)
    {
		if (this.isEspionage())
		{
			this.currentScienceEnd.innerHTML = Tick.toTimeWithDate(this.userScience.scienceEndTick);
		}
		else
		{
			this.currentScienceEnd.innerHTML = Tick.toTimeFuture(this.userScience.scienceEndTick);
		}
		
		this.finishBox.style.display = "";
	}
	else
	{
		this.finishBox.style.display = "none";
	}
    
    if(!chosen || !progressing)
    {
    	this.warningLabel.style.display = "";
    }
    else
    {
    	this.warningLabel.style.display = "none";
    }
    
    if (stopped)
    {
        this.warningLabel.innerHTML = I18.f("SCIENCE_STOPPED");
    }
    else if (!chosen)
    {
        this.warningLabel.innerHTML = I18.f("SCIENCE_NOT_CHOSEN");
    }
    else if (!progressing)
    {
        this.warningLabel.innerHTML = I18.f("NO_SCIENTISTS");
    }
    
    if (this.upgradeDialog && this.estate)
    {
        this.upgradeDialog.update(this.estate.bank);
    }
    
    if (this.scienceDialog)
    {
    	this.scienceDialog.update();
    }
}

ScienceView.prototype.markInvisible = function()
{
    this.visible = false;
}

ScienceView.prototype.getScienceButtons = function()
{
    if (!this.scienceButtons)
    {
        this.scienceButtons = [];
        var self = this;
        this.walkScienceButton(function(button)
        {
            self.scienceButtons.push(button);
        });
    }
    return this.scienceButtons;
}

ScienceView.prototype.walkScienceButton = function(handler)
{
    var buttons = $("sciencebutton", this.DOM);
    for(var i=0; i<buttons.length; i++)
    {
    	handler(buttons.get(i));
    }
    
    var buttons = $("sciencespecbutton", this.DOM);
    for(var i=0; i<buttons.length; i++)
    {
    	handler(buttons.get(i));
    }
}

ScienceView.prototype.setProgress = function(value, total)
{
    if (value > total)
    {
        value = total;
    }
    COM.get(this.progress).update(NumberUtils.floor(value), NumberUtils.floor(total));
}

ScienceView.prototype.onAlchemistBoosted = function(u)
{
    FUser.updateCurrentUser(u);
    this.updateScience(u.science);
}

ScienceView.prototype.X00 = APP.isSocialNetwork ? 105 : 115;
ScienceView.prototype.X01 = APP.isSocialNetwork ? 175 : 192;
ScienceView.prototype.X02 = APP.isSocialNetwork ? 245 : 269;
ScienceView.prototype.X03 = APP.isSocialNetwork ? 280 : 283;
ScienceView.prototype.X04 = APP.isSocialNetwork ? 315 : 325;
ScienceView.prototype.X05 = APP.isSocialNetwork ? 350 : 374;
ScienceView.prototype.X06 = APP.isSocialNetwork ? 385 : 428;
ScienceView.prototype.X07 = APP.isSocialNetwork ? 420 : 465;
ScienceView.prototype.X08 = APP.isSocialNetwork ? 455 : 493;
ScienceView.prototype.X09 = APP.isSocialNetwork ? 490 : 535;
ScienceView.prototype.X10 = APP.isSocialNetwork ? 560 : 612;
ScienceView.prototype.X11 = APP.isSocialNetwork ? 630 : 738;

ScienceView.prototype.Y00 = APP.isSocialNetwork ? 65 : 70;
ScienceView.prototype.Y01 = APP.isSocialNetwork ? 130 : 140;
ScienceView.prototype.Y02 = APP.isSocialNetwork ? 195 : 210;
ScienceView.prototype.Y03 = APP.isSocialNetwork ? 260 : 290;
ScienceView.prototype.Y05 = APP.isSocialNetwork ? 325 : 365;
ScienceView.prototype.Y06 = APP.isSocialNetwork ? 390 : 440;
ScienceView.prototype.Y07 = APP.isSocialNetwork ? 455 : 515;
ScienceView.prototype.Y08 = APP.isSocialNetwork ? 520 : 590;
ScienceView.prototype.Y09 = APP.isSocialNetwork ? 585 : 670;