function UnchargePearlScienceDialog()
{
	callParentConstructor(this);
	
	this.science = null;
	this.cookies = null;
	this.presentFP = -1;
	this.neededFP = 0;
}

extendClass(UnchargePearlScienceDialog.prototype, Dialog.prototype);

UnchargePearlScienceDialog.create = function(science)
{
    var dialog = COM.create("UnchargePearlScienceDialog");
	dialog.science = science;
	dialog.initialUpdate();

    return dialog;
}

UnchargePearlScienceDialog.prototype.usePearl = null;
UnchargePearlScienceDialog.prototype.afterUseFriendsPoints = null;

UnchargePearlScienceDialog.prototype.__construct = function()
{
	this.usePearlButton.style.display = "none";
	this.useFriendPointsButton.style.display = "none";
	this.confirmButton.style.display = "none";
	
	COM.get(this.price).source = STATIC_INTERFACE_URL + CommonAssets.ICON_PEARL;
	COM.get(this.price).setTextClass("text-normal-bold text-small");
	
	this.setCaption(I18.f('DONATE'));
	
	COM.bindExclusiveClick(this.noButton, this.close);
	COM.bindExclusiveClick(this.confirmButton, $.proxy(function()
	{
		if(this.usePearl)
		{
			this.usePearl();
		}
	}, this));
}

UnchargePearlScienceDialog.prototype.update = function(user)
{
    var neededPearl = FConfig.getSciencePrice(this.science, FUser.CURRENT_USER.science.getLevel(this.science) + 1).unchargePrice;
    COM.get(this.price).value = neededPearl;
    
    /*
    UI.show(FlashVars.isSocialNetwork && neededFP > 0, [friendPointsPrice, useFriendPointsButton, usePearlButton], function ():void {
        friendPointsPrice.text = I18.OR_USE_FRIEND_POINTS.f(neededFP, presentFP < 0 ? "?" : presentFP);
        useFriendPointsButton.enabled = neededFP <= presentFP;
        usePearlButton.enabled = FUser.CURRENT_USER.pearl >= neededPearl;
    });
    */
	
	if(this.neededFP <= 0)
	{
		this.confirmButton.style.display = "";
		COM.get(this.confirmButton).reason = FUser.CURRENT_USER.pearl >= neededPearl ? "" : I18.f("NOT_ENOUGH_PEARL");
	}
	else
	{
		this.confirmButton.style.display = "none";
	}
}

UnchargePearlScienceDialog.prototype.initialUpdate = function()
{
    Events.onFUserUpdated.add(this.update);
    /*
    neededFP = FConfig.getSciencePrice(science, FUser.CURRENT_USER.science.getLevel(science) + 1).unchargeFriends;
    if (neededFP > 0)
    {
        PortalService.account.getSalt().handle(function (salt:String):void {
            Service.user.getCookie(salt, science).handle(function (c:String):void {
                cookies = c;
                PortalService.account.getFriendPoints(FUser.CURRENT_USER.username, FConfig.i.SERVER_ID, science.name, neededFP, cookies).handle(function (points:int):void {
                    presentFP = points;
                    update();
                });
            });
        });
    }
    */
    this.update();
}

UnchargePearlScienceDialog.prototype.doUseFriendsPoints = function()
{
    /*
    PortalService.account.useFriendPoints(
            FUser.CURRENT_USER.username, FConfig.i.SERVER_ID, science.name, neededFP, cookies
    ).handle(afterUseFriendsPoints, function (e:Error):Boolean {
                if ((e.__className__ == 'ClientKnowsException')) {
                    GameAlert.doShow(ClientKnowsException(e).getMessage());
                    return true;
                }
                GameAlert.doShow(I18.ERROR_INTERNAL_ERROR.f() + "\n" + e.name + "\n" + e.message);
                return true;
            });
	*/
}

UnchargePearlScienceDialog.prototype.close = function()
{
    Events.onFUserUpdated.remove(this.update);
    superMethod(UnchargePearlScienceDialog.prototype, "close", this)();
}