function BoostAlchemistsIcon()
{
	callParentConstructor(BoostAlchemistsIcon.prototype, this);
	
	this.user = null;
	
	this.onUserUpdated = function(u)
	{
    };
}

extendClass(BoostAlchemistsIcon.prototype, BoostPeriodicalIcon.prototype);

BoostAlchemistsIcon.prototype.__construct = function()
{
	superMethod(BoostAlchemistsIcon.prototype, "__construct", this)();
	this.skin = "green";
	
	COM.bindExclusiveClick(this.DOM, $.proxy(this.clickHandler, this));
}

BoostAlchemistsIcon.prototype.updateData = function()
{
    this.icon = STATIC_INTERFACE_URL + Assets.MAGIC_BOOST_ALCHEMIST;
    this.caption = null;
    this.btype = BType.ALCHEMIST;
    this.abilityToolTip = I18.f("MAGIC_RESEARCH_BETTER_TIP");
    this.description1 = I18.f("MAGIC_RESEARCH_BETTER_DESCRIPTION");
    this.description2 = I18.f("MAGIC_RESEARCH_BETTER_BONUS");
    var decl = ServiceHelper.getGloabalServiceDecl(BType.ALCHEMIST.name, 0);
    this.duration = decl.duration;
    
    this.effect = Strings.formatBonusPercent(decl.getValue());
    this.price = decl.price;
}

BoostAlchemistsIcon.prototype.update = function(e)
{
    this.user = null;
    superMethod(BoostAlchemistsIcon.prototype, "update", this)(e);
}

BoostAlchemistsIcon.prototype.updateFromUser = function(u)
{
    this.user = u;
    this.estate = null;        
    this.updateData();
    this.activate(user.getBoostTick(this.btype.name));
    if (this.magicDialog)
    {
        this.magicDialog.updateFromUser(user);
    }
}

BoostAlchemistsIcon.prototype.updateMagicDialog = function()
{
    if (this.estate)
    {
        superMethod(BoostAlchemistsIcon.prototype, "updateMagicDialog", this)();
    }
    else
    {
        this.magicDialog.updateFromUser(user);
    }
}

BoostAlchemistsIcon.prototype.onBuy = function()
{
    if (this.estate != null)
    {
        superMethod(BoostAlchemistsIcon.prototype, "onBuy", this)();
    }
    else
    {
        // from ScienceView from kingdom -- so we don' pass estate there
        ServiceHelper.orderGlobalService(BType.ALCHEMIST.name, 0, null, null, function (e)
        {
            this.updateFromUser(e.currentUser);
            this.onUserUpdated(e.currentUser);
        }, null);
    }
}

BoostAlchemistsIcon.prototype.clickHandler = function()
{
    if (this.estate)
    {
        superMethod(BoostAlchemistsIcon.prototype, "clickHandler", this)();
    }
    else
    {
        this.updateData();
        this.popupDialog();
    }
}