function BoostPeriodicalButton()
{
	callParentConstructor(BoostPeriodicalButton.prototype, this);
	
	this.btype = null; // BType;
	this.estate = null; // FEstate;
	this.magicDialog = null; // BasePeriodicMagicDialog;
	
	this.clickHandler = $.proxy(this.clickHandler, this);
}

extendClass(BoostPeriodicalButton.prototype, SimpleButton.prototype);

BoostPeriodicalButton.prototype.btype = null; // BType;
BoostPeriodicalButton.prototype.estate = null; // FEstate;
BoostPeriodicalButton.prototype.magicDialog = null; // BasePeriodicMagicDialog;

BoostPeriodicalButton.prototype.__construct = function()
{
	superMethod(BoostPeriodicalButton.prototype, '__construct', this)();
	this.skin = 'green';
	COM.bindExclusiveClick(this.DOM, this.clickHandler); 
}

BoostPeriodicalButton.prototype.clickHandler = function()
{
    if (this.estate.accessManageble) 
    {
        this.popupDialog();
    } 
    else 
    {
        Alert.error(I18.f('DEPUTY_CAN_NOT_USE_PEARL'));
    }
}

BoostPeriodicalButton.prototype.update = function(b)
{
    var e = b.estate;
    this.btype = b.type;
    this.estate = e;
    
    if (this.estate.accessManageble && (this.btype.isHouses() || this.btype.isRaiser()))
    {
    	this.visible = true;
    	
    	if (this.btype.isRaiser())
    	{
    		this.icon = STATIC_INTERFACE_URL + 'icons/fast_' + b.resource.name.toLowerCase() + '.png';
    	}
    	if (this.btype.isHouses())
    	{
    		this.icon = STATIC_INTERFACE_URL + Assets['MAGIC_BOOST_' + this.btype.name];
    	}
        //glow = estate.isMagicActive(btype);
        //
        if (this.magicDialog) 
        {
            this.magicDialog.update(this.estate);
        }
        
        var active = this.estate.isMagicActive(this.btype);
        Effects.pearlServiceActive(this, active);
        this.DOM.title = active 
        	? I18.activeMagicTip(this.estate.getMagicActiveTick(this.btype))
        	: I18.getMegaString("MAGIC_BOOST_" + this.btype.name + "_TIP")
        ;
    }
    else
    {
    	this.visible = false;
    }
}

BoostPeriodicalButton.prototype.popupDialog = function()
{
    if (!this.magicDialog) 
    {
        this.magicDialog = COM.create('BasePeriodicMagicDialog');
	    this.magicDialog.onClose = $.proxy(function(){
	    	this.magicDialog = null;
	    }, this);
    }
    
    this.magicDialog.btype = this.btype;
    this.magicDialog.bonusDescriptionLine1 = I18.getString("MAGIC_BOOST_" + this.btype.name + "_DESCRIPTION");
    if (this.btype.isRaiser()) 
    {
        this.magicDialog.bonusDescriptionLine2 = I18.getRaiserBoostPhrase(this.btype);
    } 
    else 
    {
        this.magicDialog.bonusDescriptionLine2 = I18.getMegaString("BOOST_" + this.btype.name);
    }
    if (this.btype.isRaiser()) 
    {
        var decl = ServiceHelper.getGloabalServiceDecl(this.btype.name, 0);
        this.magicDialog.bonusDuration = decl.duration;
        this.magicDialog.bonusEffect = Strings.formatBonusPercent(decl.getValue());
        this.magicDialog.bonusPrice = decl.price;
        this.magicDialog.boostMethod = function()
        {
            ServiceHelper.orderGlobalService(this.btype.name, 0, null, this.estate.id, null, null);
        };
    } 
    else if (this.btype.isHouses()) 
    {
        var itemDecl = ServiceHelper.getLocalServiceDecl(BType.HOUSES.name, 0);
        this.magicDialog.bonusDuration = itemDecl.duration;
        this.magicDialog.bonusEffect = Strings.formatBonusConst(itemDecl.getValue());
        this.magicDialog.bonusPrice = itemDecl.price;
        this.magicDialog.boostMethod = function ()
        {
            ServiceHelper.orderLocalService(this.btype.name, 0, null, this.estate.id, null, this.estate.isMagicActive(this.btype));
        };
    }
    
    this.magicDialog.popup(this);
    this.magicDialog.update(this.estate);
}
