// class for base choose reward functionality
function ChooseRewardDialog()
{
	callParentConstructor(ChooseRewardDialog.prototype, this);
	
	this.rewardResult = null; // Array
	this.outerDialogsChosenCount = 0; // int
}

extendClass(ChooseRewardDialog.prototype, Dialog.prototype);

ChooseRewardDialog.prototype.__construct = function()
{
	superMethod(ChooseRewardDialog.prototype, '__construct', this)();
}

ChooseRewardDialog.prototype.rewardResult = null; // Array
ChooseRewardDialog.prototype.outerDialogsChosenCount = 0; // int

ChooseRewardDialog.prototype.popup = function()
{
	superMethod(ChooseRewardDialog.prototype, "popup", this)();
	
	this.rewardResult = this.spawnRewardsDialog();
	
	this.checkAllChoosen();
	
	if (!this.rewardBox || !this.rewardBox.children.length) 
	{
	    this.close();
	}
} 

ChooseRewardDialog.prototype.onAllChosenSpecific = function(rewardData) 
{
    console.error('abstractMethod');
}

// this should be array [[function,boolean]...] where
// function - function object to call to get data from dialog
// boolean - wether it's outer dialog or not
// e.g it's somethign like this
// rewardResult = EffectsView.createActivationView()...

ChooseRewardDialog.prototype.spawnRewardsDialog = function()
{
	console.error('abstractMethod');	
}

ChooseRewardDialog.prototype.checkAllChoosen = function() 
{
    var totalOuterDialogsCount = 0;
    
    for (var i = 0, len = this.rewardResult.length; i < len; i++) 
    {
        if (this.rewardResult[i][1]) 
        {
            totalOuterDialogsCount++;
        }
    }
    // no children and all dialogs are chosen
    if ((!this.rewardBox || this.rewardBox.children.length == 0) && totalOuterDialogsCount <= this.outerDialogsChosenCount) 
    {
        this.onAllChoosen();
    }
}

ChooseRewardDialog.prototype.onOuterDialogChosen = function()
{
    this.outerDialogsChosenCount++;
    this.checkAllChoosen();
}

ChooseRewardDialog.prototype.onAllChoosen = function(sender) 
{
	if (!Quarantine.contains(ChooseRewardDialog)) 
    {
        Quarantine.put(ChooseRewardDialog);
		if (sender)
		{
			sender.enabled = false;
		}
		var rewardData = Arrays.map(this.rewardResult, function(o)
		{
			return o[0]();
		});
		
		this.onAllChosenSpecific(rewardData);
	}
}