function Dashboard()
{
	this.user = null;
	this.estate = null;
}

Dashboard.prototype.__construct = function()
{
	this.showSettings = COM.get(this.showSettings);
	this.showEncyclopedia = COM.get(this.showEncyclopedia);
	this.showRating = COM.get(this.showRating);
	this.showMissions = COM.get(this.showMissions);
	this.chestButton = COM.get(this.chestButton);
	
	
	COM.bindExclusiveClick(this.showEncyclopedia.DOM, $.proxy(function()
	{
		HelpDialog.show();
	}, this));
	
	COM.bindExclusiveClick(this.showRating.DOM, $.proxy(function()
	{
		RatingSheet.showDialog(this.estate && (this.estate.isEspionage || this.estate.isAlly) && !(this.estate.__className__ == "FCastle") ? this.estate.owner.username : "");
	}, this));
	
	COM.bindExclusiveClick(this.showMissions.DOM, $.proxy(function()
	{
		this.onShowMissions();
	}, this));
	
	
	COM.bindExclusiveClick(this.showSettings.DOM, $.proxy(function()
	{
		SettingsDialog.showDialog();
	}, this));
	
	COM.bindExclusiveClick(this.chestButton.DOM, $.proxy(function()
	{
		PaymentDialog.popup(this.user, this.estate);
	}, this));
	
	
	COM.bindExclusiveClick(this.showEncyclopedia.DOM, $.proxy(this.testSomething, this));
	
	this.heroView = COM(this.heroFaceButton).heroView;
	
	COM(this.backToKingdom).image.src = STATIC_INTERFACE_URL + "icons/back_to_kingdom.png";
	
	this.setNavButtonImage("map");
}

Dashboard.prototype.setNavButtonImage = function(type)
{
	COM(this.navigationButton).image.src = STATIC_INTERFACE_URL + "icons/"+type+".png";
}

Dashboard.prototype.onShowMissions = function()
{
}

Dashboard.prototype.testSomething = function()
{
	//console.debug('Nothing happened... :)');
}

Dashboard.prototype.tick = function(estate)
{
    this.estate = estate;
    
    if(!estate.isEspionage)
    {
	    if ((estate.accessDeputy || estate.isAlly) && estate.owner.attackWarning)
	    {
	        this.showMissions.iconColor = "red";
	    }
	    else
	    {
	        this.showMissions.iconColor = "green";
	    }
	    this.showMissions.subCaption = estate.owner.currentMissionsCount + "/" + estate.owner.missionsLimit;
    }
    
    if (COM.get(this.showScience).visible)
    {
        COM.get(this.showScience).update(estate.science, estate);
    }
}

Dashboard.prototype.update = function(currentUser)
{
    this.user = currentUser;
    
    if (currentUser.isSomeFeatureWarning())
    {
        this.chestButton.warning = true;
    }
    else
    {
        this.chestButton.warning = false;
    }
    this.updateArrows(currentUser);
}

Dashboard.prototype.updateKingdom = function(k)
{
    this.update(k.currentUser);

	var s = (k.links.length > 0);
	this.chestButton.visible = s;
	this.showScience.visible = s;
	this.showMissions.visible = s;
}

Dashboard.prototype.updateEstate = function(e)
{
    this.update(FUser.CURRENT_USER);
    UI.show(e.accessMail && !(e.__className__ == "FCastle" || e.__className__ == "FCatapult"), [this.showMessages]);
    COM(this.showMessages).ownerUsername = e.owner.username;
    UI.show(!(e.owner.isFake() || e.isExpeditionReport || e.__className__ == "FCastle" || e.__className__ == "FCatapult"), [this.showScience]);
    UI.show(e.accessMissions, [this.showMissions]);
    UI.show(e.__className__ != "FCatapult", [this.showRating]);
    UI.show((e.accessManageble && !(e.__className__ == "FCastle" || e.__className__ == "FCatapult")), [this.chestButton]);
    
    COM(this.heroView).update(e.garrisonHero, e.owner.race, e.accessGarrison ? -1 : FEstate.GARRISON_ACCESS_LEVEL);
    
    //this.setNavButtonImage(e.isAlly && e.__className__ != "FCastle" ? "return" : "map");
    this.setNavButtonImage(e.accessDeputy && e.owner.username == FUser.CURRENT_USER.username ? "map" : "return");
}

Dashboard.prototype.updateArrows = function(currentUser)
{
    var scienceHint = currentUser.findHint(HintType.STUDY_SCIENCE);

    if (scienceHint)
	{
        HintArrow.OPEN_SCIENCE.show(this.showScience, scienceHint, APP.getCityMediator().viewComponent.DOM);
    }

    var mailHint = currentUser.findHint(HintType.OPEN_MAIL);
    if (mailHint)
	{
        HintArrow.OPEN_MAILBOX.show(this.showMessages, mailHint, APP.getCityMediator().viewComponent.DOM);
    }
}