function Dialog()
{
	//profile(this.TYPE);
	
	$(this.DOM).addClass('Dialog');
	
	this.isModal = true; //Boolean = true
	this.showCloseButton = true; //Boolean = true
	this.closeOnClickOutside = true; //Boolean = true
	this.specificChild = null; //DisplayObject
	
	this._closing = false; //Boolean = false
	
	this.dialogParent = null; //DisplayObject
	this.center = null; //Boolean
	
	this.shaderOpacity = 0;
	
    this.close = $.proxy(this.close, this);
    
    this.fitLayout = $.proxy(this.fitLayout, this);
    $(window).on('fitlayout', this.fitLayout);
    
    this._isFullScreen = false;
    
    this._skin = '';
    this.__defineGetter__('skin', function()
    { 
    	return this._skin ? this._skin.substr(12) : ''; 
    });
    
    this.__defineSetter__('skin', function(v)
    {
    	v = 'dialog-skin-' + (v || 'default');
    	if (this._skin == v) return;
    	
    	$(this.DOM).removeClass(this._skin);
    	this._skin = v;
    	$(this.DOM).addClass(this._skin);
    });
    
    this.__defineGetter__('showFooter', function()
    { 
    	return $(this.DOM).hasClass('dialog-show-footer'); 
    });
    
    this.__defineSetter__('showFooter', function(v)
    {
    	$(this.DOM).toggleClass('dialog-show-footer', Boolean(v)); 
    })
    
    this.__defineGetter__('decoration', function(v)
    {
    	return $(this.DOM).hasClass("dialog-no-decor");
    });
    
    this.__defineSetter__('decoration', function(v)
    {
    	$(this.DOM).toggleClass("dialog-no-decor", !Boolean(v));
    });
    
	this._userCanClose = true; //Boolean = true
    this.__defineGetter__('userCanClose', function(v)
    {
    	return this._userCanClose;
    });
    
    this.__defineSetter__('userCanClose', function(v)
    {
    	this._userCanClose = Boolean(v);
    	
		if (this.DOM)
		{
			UI.show(this._userCanClose, [this._closeButton]);
			$(this.shader).off(CLICK_EVENT);
			if (this._userCanClose)
			{
				COM.bindExclusiveClick(this.shader, $.proxy(this.close, this));
			}
		}
    });
    
    this.popupTimeout = null;
    
    this.hintArrows = [];
    this.noClearHints = false;
}

Dialog.prototype.__construct = function()
{
	//console.info('CONSTRUCTOR:', this.DOM.nodeName);
}

Dialog.prototype.__destruct = function()
{
	//console.info('CONSTRUCTOR:', this.DOM.nodeName);
}

Dialog.prototype.forceTick = function()
{
	//if(!GLOBAL_TICKS_ENABLED && this.tick) this.tick();
}

Dialog.prototype.__getTemplate = function(content)
{
	var dialogTpl = COM.getData('Dialog', 'template');
	
	if (this.__templateClass != 'Dialog')
	{
		var wrapper = $('<span>' + dialogTpl + '</span>');
		if (typeof content == 'undefined') 
		{
			content =  COM.getData(this.__templateClass, 'template');
		}
		
		content = $('<span>' + content + '</span>');
		
		wrapper.find('*[name=headerLeftBox]').html(content.find('HeaderLeft').html());
		wrapper.find('*[name=headerRightBox]').html(content.find('HeaderRight').html());
		wrapper.find('*[name=caption]').html(content.find('DialogCaption').html());
		wrapper.find('*[name=subcaption]').html(content.find('DialogSubCaption').html());
		wrapper.find('*[name=footer]').html(content.find('DialogFooter').html());
		content.find('HeaderLeft, HeaderRight, DialogCaption, DialogSubCaption, DialogFooter').remove();
			
		wrapper.find('content').append(content.html());
		
		dialogTpl =  wrapper.html();
	}
	
	return dialogTpl;
}

Dialog.EMPTY_FUNCTION = function(){};
Dialog.EMPTY_ERROR_FUNCTION = function(){ throw new Error('Dialog error'); };
Dialog.APP_WIDTH = 960;
Dialog.APP_HEIGHT = 640;
Dialog.DEFAULT_PARENT = null;

Dialog.prototype.onShow = null;
Dialog.prototype.onClose = null;

Dialog.prototype.isModal = true; //Boolean = true
Dialog.prototype.showCloseButton = true; //Boolean = true
Dialog.prototype.closeOnClickOutside = true; //Boolean = true
Dialog.prototype.specificChild = null; //DisplayObject

Dialog.prototype._userCanClose = true; //Boolean = true
Dialog.prototype._closing = false; //Boolean = false

Dialog.prototype.dialogParent = null; //DisplayObject
Dialog.prototype.center = null; //Boolean

Dialog.prototype.shaderOpacity = 0;
Dialog.prototype.animatedPopup = false;

Dialog.prototype.popup = function(parent, center, initHandler) 
{
    this.DOM.style.opacity = 0;
    
    if(APP && APP.showLoader) APP.showLoader();
    
    if (!parent) 
    {
        parent = !Dialog.DEFAULT_PARENT ? $('#popup') : Dialog.DEFAULT_PARENT;
    }
    
    this.dialogParent = parent;
    
    if(APP && APP.pauseTicks) APP.pauseTicks();
    
    this.popupTimeout = setTimeout($.proxy(function()
    {
    	this.startPopup(parent, center, initHandler);
    }, this), 10);
    
    return this;
}

Dialog.prototype.startPopup = function(parent, center, initHandler)
{
	this._closing = false;
    this.center = center;
	
    var child = this.specificChild ? this : this.specificChild;

   	COM.bindExclusiveClick(this.shader, $.proxy(this.close, this));
   	this.userCanClose = this._userCanClose;
   	
	UI.show(this._userCanClose, [this._closeButton]);
   	COM.bindExclusiveClick(this._closeButton, $.proxy(this.close, this));
    
    if (!this.isModal)
    {
    	this.shader.style.background = 'transparent';
    }
    
    this.DOM.style.position = "absolute";
    this.DOM.style.display = "block";
    this.DOM.style.left = "0px";
    this.DOM.style.top = "0px";
    this.DOM.style.zIndex = 10000;
    
    COM.get(this._closeButton).icon = STATIC_INTERFACE_URL + "icons/back.png";
    
    APP.popup(this.DOM);
    
    this.fitLayout();
    
    //this.shader.css({left: -window.innerWidth, opacity:0});
    
    if (typeof initHandler == 'function')
    {
    	initHandler();
    }
    
    this.popupTimeout = setTimeout($.proxy(this.endPopup, this), 10);
}

Dialog.prototype.endPopup = function()
{
	if(this._isFullScreen)
    {
    	//APP.getContentContainer().style.display = "none";
    }
	
	this.DOM.style.opacity = 1;
	
	if (typeof this.onShow == 'function')
    {
    	this.onShow();
    }
	
	if(APP && APP.hideLoader) APP.hideLoader();
	if(APP && APP.resumeTicks) APP.resumeTicks();
}

Dialog.prototype.fitLayout = function(container)
{
	// closed?
	if(!this.DOM) return;
	if("ontouchstart" in window && document.body.scrollTop > 1)
	{
		return;
	}
	
	if (typeof container == 'undefined')
	{
		container = {width: window.innerWidth, height: window.innerHeight};
	}
	if (typeof container['container'] != 'undefined') 
	{
		container = container.container;
	}
	
	if (this._isFullScreen)
	{
		this.wrapper.style.width = container.width + "px";
		
		var d = this.header.offsetHeight + 
				this.footer.offsetHeight +  
				$("decor-top", this.wrapper).height() + 
				$("decor-bottom", this.wrapper).height() -
				parseFloat($("> contentwrapper", this.wrapper).css("padding-bottom"));
				
		if(this.skin == "darkwood-border")
		{
			var c1 = $("decor-top", this.DOM);
	    	var c2 = $("decor-bottom", this.DOM);
	    	var d1 = parseFloat(c1.css("marginTop")) - parseFloat(c1.css("marginBottom"));
	    	var d2 = parseFloat(c2.css("marginTop")) - parseFloat(c2.css("marginBottom"));
	    	
	    	d -= (Math.abs(d1)+Math.abs(d2));
		}
		$("> contentwrapper", this.wrapper).css("height", container.height);
		$("> contentwrapper > content", this.wrapper).css("height", container.height - d);
	}
	
	this.APP_WIDTH = container.width;
	this.APP_HEIGHT = container.height;
	
    this.DOM.style.width = container.width + "px";
    this.DOM.style.height = container.height + "px";
    
    this.shader.style.width = container.width + "px";
    this.shader.style.height = container.height + "px";
    
    //this.wrapper.style.position = "absolute";
    this.wrapper.style.left = Math.max(0, (container.width - this.wrapper.offsetWidth) * 0.5) + "px";
    this.wrapper.style.top = Math.max(0, (container.height - this.wrapper.offsetHeight) * 0.5) + "px";
    
    if (this._isFullScreen)
	{
    	var c1 = $("decor-top", this.DOM);
    	var c2 = $("decor-bottom", this.DOM);
    	var d1 = parseFloat(c1.css("marginTop")) - parseFloat(c1.css("marginBottom"));
    	var d2 = parseFloat(c2.css("marginTop")) - parseFloat(c2.css("marginBottom"));
    	
    	this.wrapper.style.left = "0px";
    	this.wrapper.style.top = (Math.abs(d1))+"px";
	}

    UI.show($(this.headerLeftBox).html(), [this.headerLeftBox]);
    UI.show($(this.headerRightBox).html(), [this.headerRightBox]);
    this.showFooter = Boolean($(this.footer).html());
}

Dialog.prototype.fullScreen = function()
{
	if(this._isFullScreen) return;
	
	this.decoration = false;
	this._isFullScreen = true;
	this.fitLayout();
	
	$(this.DOM).addClass("dialog-full-screen");
	
	Dialog.fullScreenDialogsCount++;
}

Dialog.fullScreenDialogsCount = 0;

Dialog.prototype.bringToFront = function()
{
	if (!this.DOM.parentNode) return;
	this.DOM.parentNode.appendChild(this.DOM);
}

Dialog.prototype.close = function()
{
    if (typeof this.onClose == 'function')
	{
		if (this.onClose() === false) 
		{
			return false;
		}
	}
	
    $(window).off('fitlayout', this.fitLayout);
    
    if(APP && APP.showLoader) APP.showLoader();
    
    preventScroll(true);
    
    clearTimeout(this.popupTimeout);
    this.popupTimeout = setTimeout($.proxy(this.endClose, this), 10);
}

Dialog.prototype.endClose = function()
{
	if(this._isFullScreen)
	{
		/*
		Dialog.fullScreenDialogsCount--;
		if(Dialog.fullScreenDialogsCount < 0) Dialog.fullScreenDialogsCount = 0;
		if(Dialog.fullScreenDialogsCount == 0) APP.getContentContainer().style.display = "";
		*/
	}
	this.destroy();
	
	if(APP && APP.hideLoader) APP.hideLoader();
	
	this.destroyChildArrows();
	
	clearTimeout(this.popupTimeout);
}

Dialog.prototype.destroyChildArrows = function()
{
	if(!this.hintArrows) return;
	
	for(var i=0; i<this.hintArrows.length; i++)
    {
    	this.hintArrows[i].hide();
    }
	
	setTimeout($.proxy(function()
	{
		if(window.HintArrow && !this.noClearHints) HintArrow.clearUnderstood();
		if(APP.updateHints) APP.updateHints();
	}, this), 1000);
}

Dialog.prototype.getCaption = function()
{
	return this.caption.innerHTML;
}

Dialog.prototype.setCaption = function(val)
{
	this.caption.innerHTML = val;
}

Dialog.prototype.getSubCaption = function()
{
	return this.subcaption.innerHTML;
}

Dialog.prototype.setSubCaption = function(val)
{
	this.subcaption.innerHTML = val;
	UI.show(val, [this.subcaption]);
}

Dialog.createFromComponent = function(content, caption, subcaption)
{
	var d = COM.create('Dialog');
	
	caption = caption || '';
	subcaption = subcaption || '';
	
	if (typeof content == 'string')
	{
		content = COM.create(content);
	}
	
	d.setCaption(caption);
	d.setSubCaption(subcaption);
	d.content.appendChild(content.DOM);
	
	return d;
}

Dialog.linkClose = function(dialog, addOnClose)
{
    var onClose = dialog.onClose;
    dialog.onClose = function ()
    {
        onClose();
        addOnClose();
    }
}

Dialog.link = function(dialog, nextDialog, parent)
{
    Dialog.linkClose(dialog, function ()
    {
        nextDialog.popup(parent, true);
    });
}

// chaining function needed to show dialogs
Dialog.showDialogs = function(dialogs, parent) 
{
    for (var i = 0; i < dialogs.length - 1; i++) 
    {
        Dialog.link(dialogs[i], dialogs[i + 1], parent);
    }
    if (dialogs.length > 0) 
    {
        dialogs[0].popup(parent, true);
    }
}

Dialog.getViewportRect = function() 
{
    var w = $(this.wrapper);
    return {
    	'width': w.width(),
    	'height': w.height(),
    	'left': w.offset().left,
    	'top': w.offset().top
    }
}

Dialog.center = function(o) 
{
    /*
    var viewport:Object = getViewportRect();
    o.x = (viewport.left + viewport.right) / 2 - o.width / 2;
    o.y = (viewport.top + viewport.bottom) / 2 - o.height / 2;
    */
}

Dialog.find = function(obj)
{
	if (typeof obj != 'object') return null;
	
	var node = obj['DOM'] || obj;
	var d = $(node).closest('.dialog-wrapper').parent()[0];
	
	return d ? COM(d) : null;
}
