function EstateStarsClanView()
{
}

EstateStarsClanView.create = function(info, estateIcon, estateName, estateType, showClan, showRole)
{
    if(typeof showClan == "undefined") showClan = true;
    
    var view = COM.create("EstateStarsClanView");
    view.update(estateIcon, estateName, estateType, info, showClan, showRole);
    return view;
}

EstateStarsClanView.createAsTip = function(info, estateIcon, showClan, showLeader, showRole)
{
    if(typeof showClan == "undefined") showClan = true;
    
    var capitalName = I18.formatEstateName(info.capitalName, info.capitalLocation);
    var view = EstateStarsClanView.create(info, estateIcon, capitalName, EstateType.CITY, showClan, showRole);
    return showLeader ? Tip.create(I18.CLAN_LEADER, info.username, view) : Tip.create(view);
}

EstateStarsClanView.prototype.update = function(estateIcon, estateName, estateType, info, showClan, showRole)
{
    if(typeof showClan == "undefined") showClan = true;
    
    this.iconImage.src = STATIC_INTERFACE_URL + (estateIcon ? estateIcon : Assets.ICON_CAPITAL);
    this.estateLabel.innerHTML = estateName;
    
    UI.show(!estateType || (estateType.name != EstateType.CASTLE.name && estateType.name != EstateType.CATAPULT.name), [this.starsView], $.proxy(function()
    {
        COM(this.starsView).titleIndex = info.titleIndex;
    }, this));
    
    UI.show(showClan && !Strings.isEmpty(info.clanName), [this.clanBox], $.proxy(function()
    {
        this.clanLabel.innerHTML = htmlEscape(info.clanName);
        this.clanLabel.style.color =  info.clanRegistered ? Effects.DARK_GREEN : "#999";
        
        UI.show(estateType && estateType.name == EstateType.CASTLE.name, [this.clanMembersCount], $.proxy(function()
        {
            this.clanMembersCount.innerHTML = I18.f("CLAN_MEMBERS_COUNT", info.clanMembersCount);
        }, this));
    }, this));
    
    UI.show(info.bannedTill > 0 && !info.deleted, [this.bannedBox], $.proxy(function()
    {
        this.bannedTill.innerHTML = I18.f("IS_BANNED_TILL", Tick.toTimeFuture(info.bannedTill));
        this.bannedReason.innerHTML = I18.f("IS_BANNED_FOR", I18.getBanReason(info.banReason));
    }, this));
    
    UI.show(!Strings.isEmpty(info.pwnedBy), [this.pwnedLabel], $.proxy(function()
    {
        this.pwnedLabel.innerHTML = FUser.isMonster(info.pwnedBy) ? I18.mega("PWNED_BY_MONSTER") : I18.mega("PWNED_BY", info.pwnedBy);
    }, this));
    
    UI.show(showRole && info.clanRole, [this.roleGroup], $.proxy(function()
    {
        this.roleLabel.innerHTML = info.clanRole.displayName;
        UI.show(info.nextElectionTick > 0, [this.nextLeaderElection], $.proxy(function()
        {
            this.nextLeaderElection.innerHTML = I18.f("NEXT_LEADER_ELECTION", DateUtils.formatSmart(Tick.toMs(info.nextElectionTick)));
        }, this));
    }, this));
    
    UI.show(info.friend, [this.friendLabel]);
}