function EstatesDropDown()
{
	this.__defineSetter__('nullText', function(nullText)
	{
	    this.nullLink = 
	    {
	    	toString: function(){return I18.f(nullText)}, 
	    	icon: STATIC_URL + Assets.ICON_FAKE_CITY
	    }
	})
	
	this.onCityChange = function(c){}
	this.nullLink = null;
	
	this._dataProviderArray = [];
	this.__defineGetter__('dataProviderArray', function(){
		return this._dataProviderArray;
	});
	this.__defineSetter__('dataProviderArray', function(arr){
		this._dataProviderArray = arr;
		COM(this.dropdown).dataProvider = this._dataProviderArray;
	});
	this.__defineGetter__('dataProvider', function(){
		return this._dataProviderArray;
	});
	this.__defineSetter__('dataProvider', function(arr){
		this._dataProviderArray = arr;
		COM(this.dropdown).dataProvider = this._dataProviderArray;
	});
	
	this.__defineGetter__('selectedIndex', function()
	{
	    return COM(this.dropdown).selectedIndex;
	});
	this.__defineSetter__('selectedIndex', function(v)
	{
    	COM(this.dropdown).selectedIndex = v;
	});
	
	this.__defineGetter__('selectedItem', function()
	{
	    return COM(this.dropdown).selectedOption;
	});
	this.__defineSetter__('selectedItem', function(link)
	{
    	this.selectedIndex = link ? this.getCityIndex(link.estateInfo.id) : 0;
	});
	
	this.__defineGetter__('city', function()
	{
	    var idx = this.selectedIndex, item = this.selectedItem;
	    if (idx < 0) return null;
	    return this.linkIsNull(item.value) ? null : this.selectedItem.value;
	});
	this.__defineSetter__('city', function(c)
	{
    	this.selectedIndex = this.getCityIndex(c ? null : c.id);
	});

	this.__defineSetter__('cityId', function(id)
	{
	    var cityIndex = this.getCityIndex(id);
				
	    if (cityIndex != -1) 
	    {
	        this.selectedIndex = cityIndex;
	    } 
	    else 
	    {
	        this.selectedIndex = 0;
	    }
	});

	
}

EstatesDropDown.prototype.linkIsNull = function(lnk)
{
	return this.nullLink ? (typeof lnk['id'] == 'undefined') : false;
}

EstatesDropDown.prototype.__construct = function()
{
	$(this.dropdown).on('change', $.proxy(this.cityChanged, this));
}

EstatesDropDown.prototype.onCityChange = function(c){}

// if not empty "null" choice added
EstatesDropDown.prototype.nullLink = null;

EstatesDropDown.prototype.updateCities = function(links)
{
    var data = Arrays.clone(links);
    if (this.nullLink) 
    {
        data.unshift(this.nullLink);
    }
    
    /*
    var dp = [];
    for(var i=0; i<data.length; i++)
    {
    	dp.push({"value": data[i], "label": data[i].toString()});
    }
    */
    
    this.dataProviderArray = data;
}

EstatesDropDown.prototype.getCityIndex = function(id)
{
    var links = this.dataProviderArray;
    if (!id)
    {
    	return 0;
    }
    for (var i = 0; i < links.length; i++) 
    {
        var lnk = links[i];
        if (this.linkIsNull(lnk)) continue;
        if (lnk && id.toString() == lnk.estateInfo.id.toString()) 
        {
            return i;
        }
    }
    return -1;
}

EstatesDropDown.prototype.cityChanged = function(e)
{
    if (typeof this.onCityChange == 'function')
    {
    	this.onCityChange(this.city);
    }
    $(this.DOM).triggerHandler('change');
}
