function ExtendedTabNavigator()
{
	this.numElements = 0;
	this.labels = [];
	this.tabs = [];
	
	this.showTab = $.proxy(this.showTab, this);
}

ExtendedTabNavigator.numElements = 0;
ExtendedTabNavigator.labels = [];
ExtendedTabNavigator.tabs = [];

ExtendedTabNavigator.prototype.__construct = function()
{
	var data = $('<span>' + this.__inlineData + '</span>');
	
	$.each(data.find('>*'), $.proxy(function(n, tab)
	{
		this.initTab(tab);
		
	}, this))
	
	COM.parseDOMElement(this.content);
	this.content.find('>*[tabIndex]').each($.proxy(function(n, tab){
		
		tab = COM.get(tab);
		tab.DOM.style.display = "none";
		this.tabs.push(tab);
				
	}, this))
		
	this.showTab(0);
}

ExtendedTabNavigator.prototype.initTab = function(tab)
{
	tab = $(tab);
	
	var btn = COM.create('SimpleButton');
	btn.caption = tab.attr('label');
	btn.attr('tabIndex', this.numElements);
	this.labels.push(btn);
	
	btn.on(CLICK_EVENT, $.proxy(function(e){
		
		this.showTab($(e.currentTarget).attr('tabIndex'));
		
	}, this));
	
	tab.attr('tabIndex', this.numElements);	
	
	this.buttons.append(btn);
	this.content.append(tab);
	
	this.numElements++;
}

ExtendedTabNavigator.prototype.showTab = function(idx)
{
	
	$.each(this.tabs, $.proxy(function(n, tab)
	{
		var current = (tab.attr('tabIndex') == idx);
		tab.style.display = current ? "" : "none";
		
		var btn = this.labels[n];
		btn.skin = current ? 'green' : 'gray';
		
	}, this))
}
