function GameProgress()
{
	this.__defineSetter__("label", this.setLabel);
	
	this.lastValue = null;
	this.lastTotal = null;
}

GameProgress.prototype.update = function(value, total)
{
    if(this.lastValue === value && this.lastTotal === total) return;
    
    this.lastValue = value;
    this.lastTotal = total;
    
    this.setProgress(value, total);
    this.label = I18.f("CURRENT_MAX", value, total);
}

GameProgress.prototype.setLabel = function(val)
{
	this.labelText.innerHTML = val;
}

GameProgress.prototype.setProgress = function(value, total)
{
	this.progressBar.style.width = (this.labelText.offsetWidth * (value/total)) + "px";
}