function GodpointsView()
{

	this.__defineSetter__('value', function(value) { this.update(value, this._max); });
	this.__defineSetter__('highlight', function(needHighlight) { COM(this.innerView).styleFunds(needHighlight); });

	this.asSpeed = true;
	this._value = 0;
	this._max = -1;
}

GodpointsView.prototype.asSpeed = true;
GodpointsView.prototype._value = 0;
GodpointsView.prototype._max = -1;

GodpointsView.prototype.__construct = function()
{
    this.asSpeed = (this.DOM.hasAttribute('asSpeed') ? this.DOM.getAttribute('asSpeed') != 'false' : true);
    this.value = (this.DOM.hasAttribute('value') ? parseFloat(this.DOM.getAttribute('value')) : 0);
    this._max = (this.DOM.hasAttribute('max') ? parseFloat(this.DOM.getAttribute('max')) : -1);
}

GodpointsView.prototype.update = function(value, max)
{
    this._value = value;
    this._max = max;
    if (this.asSpeed) 
    {
        COM(this.innerView).value = I18.f('PER_TIME', this._value);
    } 
    else 
    {
        var valueText = Math.floor(this._value);
        if (this._max >= 0) 
        {
            valueText += '/' + Math.floor(this._max);
        }
        COM(this.innerView).value = valueText;
    }
    
    $(this.innerView).removeClass('funds funds-full').addClass((this._value == 0 && this.asSpeed) ? 'funds-full' : 'funds');
}

