var IconAndValue = function()
{
	this._value = 0;
	
	this.__defineGetter__('source', function()
	{
		return this.image.src;
	});
	this.__defineSetter__('source', function(val)
	{
		this.image.src = val;
	});
	
	this.__defineGetter__('value', function()
	{
		return this._value;
	});
	this.__defineSetter__('value', function(val)
	{
		this._value = val;
		this.doSetValue(val);
	});
	
	this.defaultFundsClass = "funds";
}

IconAndValue.prototype._value = 0;

IconAndValue.prototype.__construct = function()
{
	var el = $(this.DOM);
	
	this.source = el.attr('source') || '';
	this.value = el.attr('value') || 0;
}

IconAndValue.create = function(source, value)
{
    var iav = COM.create('IconAndValue');
    iav.source = source;
    iav.value = value;
    return iav;
}

IconAndValue.prototype.doSetValue = function()
{
    //str = !this._value ? '' : this._value + "";
    var str = this._value + "";
    this.text.innerHTML = str;
    UI.show(!Strings.isEmpty(str), [this.text]);
}

IconAndValue.prototype.styleFunds = function(isBadValue)
{
    $(this.text).removeClass('positive negative overflow').addClass(!isBadValue ? this.defaultFundsClass : 'negative');
}

IconAndValue.prototype.underline = function(doUnderline)
{
    this.text.css('text-decoration', (doUnderline ? 'underline' : 'none'));
}

IconAndValue.prototype.setStyle = function(prop, value)
{
	this.text.css(prop, value);
}

IconAndValue.prototype.setDefaultFundsClass = function(val)
{
	if (this.text.className == this.defaultFundsClass) this.text.className = val;
	this.defaultFundsClass = val;
}

IconAndValue.prototype.setTextClass = function(name)
{
	this.text.className = name;
}

IconAndValue.prototype.showIconBack = function(val)
{
	$(this.DOM).toggleClass("darkBack", !!val);
}