function ObtainPearlDialog()
{
	callParentConstructor(ObtainPearlDialog.prototype, this);
}

extendClass(ObtainPearlDialog.prototype, Dialog.prototype);

ObtainPearlDialog.prototype.__construct = function()
{
	superMethod(ObtainPearlDialog.prototype, "__construct", this)();

    COM(this.buyPearls).caption = I18.f("BUY");
    COM.bindExclusiveClick(this.buyPearls, $.proxy(this.hideOptions, this));

    COM(this.freePearls).caption = I18.f("OBTAIN_PEARL_FREE_MOBILE");

	COM.bindExclusiveClick(this.freePearls, function()
	{
		TapJoyHelper.showOffers(FUser.CURRENT_USER.username + "@" + FConfig.SERVER_ID);
	});

	COM(this.transferButton).caption = I18.f("PORTAL_PERL_TRANSFER");

	COM(this.inputBox).parentDialog = this;
};

ObtainPearlDialog.prototype.hideOptions = function()
{
    this.optionsTab.style.display = "none";
    this.buyTab.style.display = "block";
};

ObtainPearlDialog.prototype.fitLayout = function(container)
{
	superMethod(ObtainPearlDialog.prototype, "fitLayout", this)(container);
	
	this.windowWrapper.style.width = this.content.offsetWidth + "px";
	this.windowWrapper.style.height = this.content.offsetHeight + "px";
	
	COM(this.inputBox).fitLayout({width: this.content.offsetWidth, height: this.content.offsetHeight});
};

ObtainPearlDialog.prototype.showTransferButton = function(val)
{
	this.transferButton.style.display = val ? "" : "none";
};

ObtainPearlDialog.prototype.setTransferButtonListener = function(listener)
{
	$(this.transferButton).off(CLICK_EVENT);
	COM.bindExclusiveClick(this.transferButton, listener);
};

ObtainPearlDialog.popup = function(receiver, hideMandatoryOffers)
{
    APP.showLoader();

	PortalService.loginFromServer(function(fpc)
    {
        PortalService.getConfig(function(config)
		{
        	$.extend(FPortalConfig, config);
        	FPortalConfig.load();
        	
        	PortalService.account.callMethod("getPaymentAccount", [receiver], $.proxy(function (account)
	        {
	            var d = COM.create("ObtainPearlDialog");
	            if(hideMandatoryOffers) d.hideOptions();

	            var ib = COM(d.inputBox);
	            ib.receiverUsername = receiver;
	            ib.update(account, FConfig.SERVER_ID);
	            ib.hideDestinationCombo();
	            ib.showPaymentMethods();

                var server = account.findServer(FConfig.SERVER_ID);
                var enabled = ib.isFromServer() && !ib.receiverUsername && FPortalConfig.TAPJOY_ENABLED && server && server.offersAccess.name == OffersAccess.ENABLED.name;
                if(!enabled) d.hideOptions();

                d.popup();
	            
	        }, this), ObtainPearlDialog.handleFault);
        });
       
    }, ObtainPearlDialog.handleFault);
};

ObtainPearlDialog.handleFault = function(e)
{
    Alert.create(I18.f("PAYMENT_SERVER_NOT_AVAILABLE"));
    return true;
};