function OnVacationDialog()
{
	callParentConstructor(OnVacationDialog.prototype, this);
	
	this.ticker = null;
}

extendClass(OnVacationDialog.prototype, Dialog.prototype);

OnVacationDialog.instance = null;

OnVacationDialog.spawn = function()
{
    if (!OnVacationDialog.instance)
    {
        OnVacationDialog.instance = COM.create("OnVacationDialog");
        OnVacationDialog.instance.init();
        OnVacationDialog.instance.popup();
        OnVacationDialog.instance.onTick();
    }
}

OnVacationDialog.prototype.init = function()
{
    this.userCanClose = false;
    this.ticker = setInterval($.proxy(this.onTick, this), 1000);;
}

OnVacationDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.btnStopVacation, $.proxy(this.onStopVacationClick, this));
	COM.bindExclusiveClick(this.btnExit, Service.goToPortal);
}

OnVacationDialog.prototype.__destruct = function()
{
    clearInterval(this.ticker);
}

OnVacationDialog.prototype.onTick = function()
{
    this.vacationText1.innerHTML = I18.f("VACATION_TEXT_1", Tick.toTimeFuture(FUser.CURRENT_USER.vacationEndTick));
    this.vacationText2.innerHTML = I18.f("VACATION_TEXT_2", Tick.timeTill(FUser.CURRENT_USER.vacationEndTick));
    this.closeIfNeeded();
}

OnVacationDialog.prototype.closeIfNeeded = function()
{
    if (!FUser.CURRENT_USER.isOnVacation())
    {
        this.close();
        OnVacationDialog.instance = null;
        APP.getCurrentMediator().forceUpdate();
    }
}

OnVacationDialog.prototype.onStopVacationClick = function()
{
    Alert.create(I18.f("STOP_VACATION_COMFIRMATION"), "", $.proxy(function()
    {
        if (!Quarantine.contains(this.btnStopVacation))
        {
            Quarantine.put(this.btnStopVacation);
            Service.user.callMethod("stopVacation", [], $.proxy(function(user)
            {
                FUser.updateCurrentUser(user);
                Tick.updateTick(user.vacationEndTick);
                this.closeIfNeeded();
            }, this));
        }
    }, this));
}