function Pager()
{
    this.glow = false;

    this._count = 0;
    this._index = 0;
    this._visibleDepth = 2;

    this._first = null;
    this._last = null;
    this._prev = null;
    this._next = null;
    this._numbers = [];
    
     this.__defineGetter__("index", this.getIndex);
     
     this.select = $.proxy(this.select, this);
}

Pager.prototype.onChange = function(index) {};

Pager.prototype.__construct = function()
{
	this.createChildren();
}

Pager.prototype.setIndexAndCount = function(index, count)
{
    if (count == 0)
    {
        count = 1;
    }
    if ((index < 0) || (count < 0))
    {
        throw Error("Wrong index and count provided (count "+count+", index "+index+")");
    }
    this._count = count;
    this._index = index;
    if (index >= count)
    {
        index = count - 1;
    }
    this.select(index, true);
}

Pager.prototype.createLabel = function(text, clickHandler)
{
    var label = document.createElement("span");
    label.innerHTML = text;
    label.style.cursor = "pointer";
    label.style.padding = "5px";
    this.wrapper.appendChild(label);
    COM.bindExclusiveClick(label, $.proxy(clickHandler, this));
    
    return label;
}

Pager.prototype.createChildren = function()
{
    this._first = this.createLabel("<<", function(e)
    {
        this.select(0);
    });
    
    this._prev = this.createLabel("<", function(e)
    {
        this.select(this._index - 1);
    });

    for (var i = 0; i < this._visibleDepth * 2 + 1; i++)
    {
        var label = this.createLabel("", function(e)
        {
            this.select(parseInt(e.currentTarget.innerHTML) - 1);
        });
        
        if (i == this._visibleDepth)
        {
            label.style.color = "#808080";
            this.clickable(label, false);
        }
        
        label.style.fontWeight = "bold";
        this._numbers.push(label);
    }

    this._next = this.createLabel(">", function(e)
    {
        this.select(this._index + 1);
    });
    
    this._last = this.createLabel(">>", function(e)
    {
        this.select(this._count - 1);
    });
    
    this.select(this._index, true);
}

Pager.prototype.select = function(newIndex, silent)
{
    if (this._count == 0)
    {
        this._count = 1;
    }
    
    if (newIndex < 0 || newIndex >= this._count)
    {
        return;
        //throw Error("Wrong index provided (count "+this._count+", index "+newIndex+")");
    }
    this._index = newIndex;

    for (var i = 1; i <= this._visibleDepth; i++)
    {
        if (this._index - i < 0)
        {
            this._numbers[this._visibleDepth - i].style.display = "none";
            this._numbers[this._visibleDepth - i].innerHTML = "";
        }
        else
        {
            this._numbers[this._visibleDepth - i].style.display = "";
            this._numbers[this._visibleDepth - i].innerHTML = (this._index - i + 1).toString();
        }
        
        if (this._index + i >= this._count)
        {
            this._numbers[this._visibleDepth + i].style.display = "none";
            this._numbers[this._visibleDepth + i].innerHTML = "";
        }
        else
        {
            this._numbers[this._visibleDepth + i].style.display = "";
            this._numbers[this._visibleDepth + i].innerHTML = (this._index + i + 1).toString();
        }
    }
    
    this._numbers[this._visibleDepth].innerHTML = (this._index + 1).toString();

    this.clickable(this._first, this._index > 0);
    this.clickable(this._prev, this._index > 0);
    this.clickable(this._next, this._index < this._count - 1);
    this.clickable(this._last, this._index < this._count - 1);

    if (!silent)
    {
        this.onChange(this._index);
    }
}

Pager.prototype.clickable = function(label, clickEnabled)
{
    label.disabled = !clickEnabled;
}

Pager.prototype.getIndex = function()
{
    return this._index;
}