function QuestButton()
{
	callParentConstructor(QuestButton.prototype, this);
	
	this._race = null;
    this._questInfo = null;
    this.originalPosXY = null;
    this.originalPosRelative = null;
}

extendClass(QuestButton.prototype, RoundButton.prototype);

QuestButton.prototype.onAdvisorClick = function()
{
	throw Error("Abstract method");
}

QuestButton.prototype.__construct = function()
{
	superMethod(QuestButton.prototype, '__construct', this)();
	$(this.DOM).on(CLICK_EVENT, $.proxy(this.handleClick, this));
}

QuestButton.prototype.update = function(race, fqi)
{
    this._race = race;
    this._questInfo = fqi;
    this.invalidatePicture();
}

QuestButton.testframes = 0;
QuestButton.prototype.handleClick = function(e)
{
    HintArrow.OPEN_ADVISOR.understood();
    //QuestsView.popup(onAdvisorClick(), onAdvisorClosed);
    //invalidatePicture();
}

QuestButton.prototype.updateArrow = function(estate)
{
    if(this.DOM.style.display != "none")
    {
        var hint = FUser.CURRENT_USER.findHint(HintType.READ_QUEST);
    	hint = !hint ? FUser.CURRENT_USER.findHint(HintType.GET_REWARD) : hint;
        
        if (hint && !QuestsView.isOpen)
        {
            HintArrow.OPEN_ADVISOR.show(this, hint, $("> wrapper > content > estateview", APP.getCityMediator().DOM)[0]);
        }
    }
    else
    {
        HintArrow.OPEN_ADVISOR.hide();
    }
}

QuestButton.prototype.shouldBlink = function()
{
    var user = FUser.CURRENT_USER;
    
    var questBlink = this._questInfo.isQuestsChanged(user.settings) && !user.settings.disableQuestBlinking;
    var tournamentBlink = user.tournament != null && user.tournament.isRunning && user.settings.questLastClickTick < user.tournament.tournamentStartTick;
    var tournamentGrottoBlink = user.tournamentGrotto && user.tournamentGrotto.isRunning && user.settings.questLastClickTick < user.tournamentGrotto.tournamentStartTick;
    return questBlink || tournamentBlink || tournamentGrottoBlink;
}

QuestButton.prototype.invalidatePicture = function()
{
    /*
    if (shouldBlink()) {
        source = Assets.getAdvisorAnimated(_race);
    } else {
        source = Assets.getAdvisor(_race);
    }
    */
	
	this.warning = this.shouldBlink();
   
	this.icon = STATIC_INTERFACE_URL + Assets.getAdvisor(this._race);
}

QuestButton.prototype.playMoveAnimation = function(to)
{
    /*
    originalPosXY = new Point(x, y);
    originalPosRelative = new Rectangle();
    originalPosRelative.left = getStyle("left");
    originalPosRelative.right = getStyle("right");
    originalPosRelative.top = getStyle("top");
    originalPosRelative.bottom = getStyle("bottom");
    left = right = top = bottom = NaN;
    Effects.moveTo(this, to.x, to.y, 2000);
    */
}

QuestButton.prototype.onAdvisorClosed = function()
{
    /*
    if (originalPosXY != null) {
        HintArrow.hideAll();
        Effects.moveTo(this, originalPosXY.x, originalPosXY.y, 2000, function ():void {
            left = originalPosRelative.left;
            right = originalPosRelative.right;
            top = originalPosRelative.top;
            bottom = originalPosRelative.bottom;
            originalPosXY = null;
            // refresh arrows
            IScreenManager(FlexGlobals.topLevelApplication).updateCurrentScreen();
        });
    }
    */
}