function ServerSavingAlert()
{
	callParentConstructor(ServerSavingAlert.prototype, this);
	
	this.ticker = null;
	this.manualOnEnd = null;
	
	this.onTick = $.proxy(this.onTick, this);
}

extendClass(ServerSavingAlert.prototype, Dialog.prototype);

ServerSavingAlert.prototype.__construct = function()
{
	COM(this.timeLeft).hideOnEnd = false;
	this.setCaption(I18.f("GAME_SERVER_IS_SAVING"));
	
	APP.hideLoader();
}

ServerSavingAlert.prototype.__destruct = function()
{
	ServerSavingAlert.currentInstance = null;
}

ServerSavingAlert.currentInstance = null;

ServerSavingAlert.onException = function(timeout, onEnd)
{
    if (!ServerSavingAlert.currentInstance)
    {
        ServerSavingAlert.currentInstance = COM.create("ServerSavingAlert");
        ServerSavingAlert.currentInstance.showError(timeout);
    }
    else
    {
        ServerSavingAlert.currentInstance.update(timeout);
    }
    ServerSavingAlert.currentInstance.manualOnEnd = onEnd;        
}

ServerSavingAlert.prototype.showError = function(t)
{
    this.userCanClose = false;
    this.isTitleWindow = false;
    this.popup();
    
    COM(this.timeLeft).handler = this.onTick;
    this.update(t);
    //this.alertText.innerHTML = I18.f("GAME_SERVER_IS_SAVING");
    //UI.show(true, [this.alertText]);
    
    this.ticker = setInterval(this.onTick, 30000);
}

ServerSavingAlert.prototype.update = function(t)
{
    var tl = COM(this.timeLeft);
    if (tl.value <= Tick.now() || tl.value > Tick.now() + t)
    {
        tl.value = Tick.now() + t;
        tl.fired = false;
    }
}

ServerSavingAlert.prototype.onSavingEnd = function()
{
    COM(this.timeLeft).fired = true;
    COM(this.timeLeft).value = -1;
    clearInterval(this.ticker);
    this.close();
    ServerSavingAlert.currentInstance = null;
}

ServerSavingAlert.prototype.onTick = function(e)
{
    Service.user.callMethod("ping", [],
            $.proxy(function()
            {
                this.onSavingEnd();
                if (typeof this.manualOnEnd == "function")
                {
                    this.manualOnEnd();
                }
                else
                {
                    var m = APP.getCurrentMediator();
                    if(m)
                    {
                    	m.onConnectionGain();
                    }
                }
            }, this),
            $.proxy(function(e)
            {
                if (e.__className__ == "SaveInProgressException")
                {
                    this.update(e.timeout);
                    return true;
                }
                return false;
            }, this)
     );
}