function SettingsDialog()
{
	callParentConstructor(this);
	this.scroll = null;
}

extendClass(SettingsDialog.prototype, Dialog.prototype);

SettingsDialog.prototype.__construct = function()
{
	superMethod(this, '__construct')();

	this.dontShowFarFutureAttacks.innerHTML = I18.getMegaString(I18.f('DONT_SHOW_FAR_FUTURE_ATTACKS'), FConfig.FAR_FUTURE);
	
	this.update(FUser.CURRENT_USER.settings);
	
	this.scroll = new iScroll(this.contentWrapper.parentNode);
	
	COM.bindExclusiveClick(this.apply, $.proxy(this.onApply, this));
    
    this.estateAnimation.style.display = "none";
    
    this.fullScreen();
}

SettingsDialog.prototype.fitLayout = function(container)
{
	superMethod(SettingsDialog.prototype, "fitLayout", this)(container);
	
	this.scrollContainer.style.width = this.content.offsetWidth + "px";
	this.scrollContainer.style.height = this.content.offsetHeight + "px";
	
	this.contentWrapper.style.width = this.content.offsetWidth + "px";
}

SettingsDialog.prototype.onShow = function()
{
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 600);
}

SettingsDialog.prototype.init = function()
{
    this.refreshToggleFs();
    stage.addEventListener(FullScreenEvent.FULL_SCREEN, this.refreshToggleFs);
    this.update(FUser.CURRENT_USER.settings);
}

SettingsDialog.prototype.cleanUp = function()
{
    stage.removeEventListener(FullScreenEvent.FULL_SCREEN, this.refreshToggleFs);
}

SettingsDialog.prototype.update = function(s/*:UserSettings*/)
{
	var parts = s.splitSlogan();
	
	$(this.slogan1).attr("value", htmlUnescape(parts[0]));
	$(this.slogan2).attr("value", htmlUnescape(parts[1]));
	
	if (s.simpleExpeditor) $(this.simpleExpeditor).attr("state","true");
	if (s.disableQuestBlinking) $(this.blinkQuest).attr("state","true");
	if (s.disableNewsBlinking) $(this.blinkNews).attr("state","true");
	if (s.estateAnimationEnabled) $(this.estateAnimation).attr("state","true");
	if (!s.receiveClanResourceMessages) $(this.dontReceiveClanResMessages).attr("state","true");
	if (!s.showFarFutureAttacks) $(this.dontShowFarFutureAttacks).attr("state","true");

	if (APP.SOUND_ENABLED) $(this.sound).attr("state","true");
	if (APP.MUSIC_ENABLED) $(this.music).attr("state","true");

    $(".content-dialog", this.DOM).each(function(index)
	{
		if (index%2 ==0) $(this).css("background-color","#E0D2B7");
		$(this).attr("index",index);
		$(this).append("<div class = 'switch' state = '"+$(this).attr("state")+"'></div>");
		$(this).on(MOUSE_UP_EVENT, SettingsDialog.changeSwitchState);
	});
            
    $(".switch",this.DOM).each(function()
    {
    	if ($(this).attr("state") == "true")
		{
			$(this).css("background-image","url('"+STATIC_INTERFACE_URL+"buttons/yes_settings_button.png')");
		}
		else if ($(this).attr("state") == "undefined")
		{
			$(this).css("background-image","url('"+STATIC_INTERFACE_URL+"buttons/no_settings_button.png')");
		}
    });
}

SettingsDialog.changeSwitchState = function()
{
	if ($(this).attr("index") % 2)
	{
		
		$(this).css("background-color","inherit");
	}
	else
	{
		$(this).css("background-color","#E0D2B7");
	}

	if ($(this).attr("state"))
	{
		$(this).attr("state",null);
		$(".switch", this).css("background-image","url('"+STATIC_INTERFACE_URL+"buttons/no_settings_button.png')");
	}
	else
	{
		$(this).attr("state","true");
		$(".switch", this).css("background-image","url('"+STATIC_INTERFACE_URL+"buttons/yes_settings_button.png')");
	}
}

SettingsDialog.prototype.onApply = function()
{
	var fus = FUser.CURRENT_USER.settings;
    
    fus.slogan = UserSettings.mergeSlogan($(this.slogan1).val(), $(this.slogan2).val());
    
    fus.simpleExpeditor = $(this.simpleExpeditor).attr("state") ? true : false;
   	fus.disableQuestBlinking = $(this.blinkQuest).attr("state") ? true : false;
    fus.disableNewsBlinking = $(this.blinkNews).attr("state") ? true : false;
    fus.estateAnimationEnabled = $(this.estateAnimation).attr("state") ? true : false;
    fus.receiveClanResourceMessages = !$(this.dontReceiveClanResMessages).attr("state") ? true : false;
    fus.showFarFutureAttacks = !$(this.dontShowFarFutureAttacks).attr("state") ? true : false;

	APP.SOUND_ENABLED = !!$(this.sound).attr("state");
	APP.MUSIC_ENABLED = !!$(this.music).attr("state");
	
    Service.user.callMethod("updateSettings", [fus], 
	function(){}, 
    function (e)
	{
        if (GameException.isDisplayable(e)) 
        {
        	Alert.create(e.getMessage());
        	return true;
        }
        return false;
    });
        
    superMethod(SettingsDialog.prototype, "close", this)();
}

SettingsDialog.showDialog = function(e)
{
	var dialog = COM.create("SettingsDialog");
	dialog.popup();
	return dialog;
}
