function TimeLeftView()
{
	this.date = -1;
	this.hideOnEnd = true;
	this.handler = null;
	this.fired = false;
	
	this.__defineGetter__("value", this.getValue);
	this.__defineSetter__("value", this.setValue);
}

TimeLeftView.prototype.__construct = function()
{
	Events.onMasterTimerTick.add(this, this.update);
}

TimeLeftView.prototype.__destruct = function()
{
	Events.onMasterTimerTick.remove(this, this.update);
}

TimeLeftView.prototype.getValue = function()
{
    return this.date;
}

TimeLeftView.prototype.setValue = function(v)
{
    this.date = v;
    this.update(null);
}

TimeLeftView.prototype.update = function(e)
{
    var ticksLeft = this.date - Tick.now();
    if (NumberUtils.compareTo(ticksLeft, 0) > 0)
    {
        this.time.innerHTML = Tick.toTimeLeft(ticksLeft);
        this.img.style.display = "";
        this.fired = false;
    }
    else
    {
        if (this.hideOnEnd)
        {
            this.time.innerHTML = "";
            this.img.style.display = "none";
        }
        else
        {
            this.time.innerHTML = "...";
            this.img.style.display = "";
        }
        if (!this.fired && (typeof this.handler == "function"))
        {
            this.fired = true;
            this.handler();
        }
    }
}
