function UserInfoDialog()
{
	callParentConstructor(UserInfoDialog.prototype, this);
	
	this.user = null;
}

extendClass(UserInfoDialog.prototype, Dialog.prototype);

UserInfoDialog.prototype.__construct = function()
{
	superMethod(UserInfoDialog.prototype, '__construct', this)();
}

UserInfoDialog.prototype.popup = function(user)
{
	superMethod(UserInfoDialog.prototype, "popup", this)();

	this.setCaption(user.username);
	
	Service.user.callMethod("getUserData",user.username,$.proxy(this.update,this));
	COM(this.sendMessage).setSkin("green");	
	COM(this.sendMessage).icon = STATIC_INTERFACE_URL + "shared/mail/new_mail_icon.png";
	
	if(user.bannedTill > 0 && !user.deleted)
	{
		this.bannedInfo.innerHTML = I18.f("IS_BANNED_TILL", Tick.toTimeFuture(user.bannedTill)) + "<br/>" + I18.f("IS_BANNED_FOR", I18.getBanReason(user.banReason));
	}
	
	COM.bindExclusiveClick(this.sendMessage, $.proxy(function()
	{
		MailBoxView.i().sendMessage(user.username);
	}, this))
	
	this.fullScreen();
}

UserInfoDialog.prototype.update = function(user)
{	
	this.user = user;
    
    UI.show(user.capitalName != "", [this.capitalRow], $.proxy(function()
    {
		this.capital.innerHTML = I18.formatEstateName(this.user.capitalName, this.user.capitalLocation);
    },this));
    
    this.title.innerHTML = I18.getTitleName(this.user.titleIndex);
    
    UI.show((this.user.clanName != "") && (this.user.clanName != null), [this.clanRow], $.proxy(function()
    {
        this.clan.innerHTML = htmlEscape(this.user.clanName);
    },this));    
    
    UI.show(user.slogan != "", [this.sloganGroup], $.proxy(function()
    {
        this.slogan.innerHTML = this.user.slogan;
    },this));
    
    COM(this.giftsView).update(FGift.buildGifts(
            user.tournamentVictories,
            user.tournamentGrottoVictories,
            user.frags, user.gifts));
}