function ArmyEqualizer()
{
	this.estate = null;
	this.sliderSize = null;
	this.heroSliderSize = null;
	this.arrowDistance = 40;
	this.switchButtonX = 0;
	
	this.oldHideout = new Army();
	this.newHideout = new Army();
	this.totalArmy = new Army();
	
	this._active = false;
	this.onChange = null;
	
	this.__defineGetter__("active", this.getActive);
	this.__defineSetter__("active", this.setActive);
	this.__defineGetter__("selectedArmy", this.getSelectedArmy);
	this.__defineGetter__("changed", this.getChanged);
	
	this.moveAllDirect = 1;
	
	this.showSlider = $.proxy(this.showSlider, this);
}

ArmyEqualizer.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.moveAllButton, $.proxy(this.moveAll, this));
	
	this.setListeners(COM(COM(this.availableArmyView).armyView));
	this.setListeners(COM(COM(this.selectedArmyView).armyView));
	
	//COM(this.moveAllButton).caption = I18.f("MOVE_ALL");
}

ArmyEqualizer.prototype.init = function()
{
    if (this.active)
    {
        this.toggle();
    }
}

ArmyEqualizer.prototype.setListeners = function(armyView)
{
	$("MilitaryUnitView", armyView.unitBox)
		.off(CLICK_EVENT)
		.on(CLICK_EVENT, this.showSlider)
	;
}

ArmyEqualizer.prototype.showSlider = function(e)
{
	if(!this.estate.accessDeputy)
	{
		return;
	}
	
	var uv = COM(e.currentTarget);
	
	var d = SliderDialog.create(
		uv.mutype, 
		this.totalArmy.substractCopy(this.newHideout).getValue(uv.mutype), 
		this.newHideout.getValue(uv.mutype),
		$.proxy(this.onMove, this),
		FUser.CURRENT_USER.settings.armyChooserStepIndex,
		[1, 10, 100, 1000],
		$.proxy(this.onChangeMultiplier, this)
	);
	
	if(e.stopImmediatePropagation) e.stopImmediatePropagation();
	return false;
}

ArmyEqualizer.prototype.onChangeMultiplier = function(newIndex)
{
	Events.onArmyChooserStepIndexChanged.fire(newIndex);
}

ArmyEqualizer.prototype.update = function(e)
{
    this.estate = e;
    
    this.updateMoveAllButton();
}

ArmyEqualizer.prototype.tick = function()
{
}

ArmyEqualizer.prototype.tickArmies = function()
{
    var selectedArmy;
    var remainingArmy;

    this.newHideout = this.newHideout.limitByCopy(this.totalArmy);
    remainingArmy = this.totalArmy.substractCopy(this.newHideout);

    selectedArmy = this.newHideout.copy();
    
    COM(COM(this.availableArmyView).armyView).setCount(remainingArmy, this.estate.garrisonFaded);
    COM(COM(this.selectedArmyView).armyView).setCount(selectedArmy);
}

ArmyEqualizer.prototype.reset = function()
{
    this.newHideout = this.oldHideout.copy();
    this.tickArmies();
	this.onChange();
}

ArmyEqualizer.prototype.toggle = function()
{
    this.active = !this.active;
}

ArmyEqualizer.prototype.getActive = function()
{
    return this._active;
}

ArmyEqualizer.prototype.setActive = function(value)
{
    this._active = value;
    if (this.estate)
    {
        if (!value)
        {
            this.reset();
        }
        this.tick();
    }
}

ArmyEqualizer.prototype.getSelectedArmy = function()
{
    return this.newHideout;
}

ArmyEqualizer.prototype.onMove = function(ut, value)
{
	this.newHideout.setValue(ut, value);
    this.tickArmies();
    this.onChange();
}

ArmyEqualizer.prototype.getChanged = function()
{
    return !this.newHideout.equals(this.oldHideout);
}

ArmyEqualizer.prototype.updateMoveAllButton = function()
{
	if(this.moveAllDirect > 0)
	{
		COM(this.moveAllButton).icon = STATIC_INTERFACE_URL + "icons/down_arrow.png";
	}
	else
	{
		COM(this.moveAllButton).icon = STATIC_INTERFACE_URL + "icons/up_arrow.png";
	}
	
	COM(this.moveAllButton).visible = this.estate.accessDeputy;
}

ArmyEqualizer.prototype.moveAll = function()
{
	APP.showLoader();
	
	setTimeout($.proxy(this.doMoveAll, this), 100);
}

ArmyEqualizer.prototype.doMoveAll = function()
{
	if(this.moveAllDirect > 0)
	{
		this.newHideout = new Army(this.totalArmy);
	}
	else
	{
		this.newHideout = new Army();
	}
	
	this.tickArmies();
    this.onChange();
	
	this.moveAllDirect *= -1;
	
	this.updateMoveAllButton();
	
	setTimeout(APP.hideLoader, 100);
}