function ArmyView()
{
	this.__defineSetter__('layout4x2', function(value)
	{
	    //unitBox.width = value ? 290 : UnitType.MILITARY.length * 68 + (UnitType.MILITARY.length - 1) * uint(getStyle("horizontalGap"));
	    //unitBox.height = value ? 82 * 2 + 12 : 82;
	});
	
	this._showHero = true;
	this.__defineGetter__('showHero', function(){ return this._showHero });
	this.__defineSetter__('showHero', function(isShow)
	{
	    this._showHero = !!isShow;
	    if (!this.heroContainer) return;
	    UI.show(this._showHero, [this.heroContainer]);
	    var pos = this.heroPosition + '';
	    this.heroPosition = pos;
	});
	
	this.__defineGetter__('heroPosition', function(pos)
	{
	    if (!this.heroContainer) return;
		var nodes = this.heroContainer.parentNode.children;
		for (var i = 0, len = nodes.length; i < len; i++)
		{
			if (this.heroContainer.isSameNode(nodes[i]))
			{
				return i;
			}
		}
		return 0;
	});
	
	this.__defineSetter__('heroPosition', function(pos)
	{
	    if (!this.heroContainer) return;
		if (isNaN(parseInt(pos)))
		{
			if (pos == 'before') pos = 0;
			else if (pos == 'inside') pos = UnitType.MILITARY.length/2+1;
			else if (pos == 'after') pos = UnitType.MILITARY.length;
			else pos = UnitType.MILITARY.length/2+1;
		}
		else
		{
			pos = Math.max(0, Math.min(UnitType.MILITARY.length-1, pos*1));
		}
		
		if (pos == this.heroPosition) return;
		
		var wrapper = this.heroContainer.parentNode;
		if (pos == UnitType.MILITARY.length)
		{
			wrapper.appendChild(this.heroContainer);
		}
		else
		{
			wrapper.insertBefore(this.heroContainer, wrapper.children[pos]);
		}
	});
	
	this.__defineSetter__('onHeroClick', function(f)
	{
	    COM(this.heroView).onHeroClick = f;
	});
	
	this.__defineGetter__('hero', function()
	{
	    return COM(this.heroView).hero;
	});
	
	this.__defineGetter__('time', function()
	{
	    return !this.frozenTime ? Tick.now() : this.frozenTime;
	});
	
	this._small = true;
	this.__defineGetter__('small', function()
	{
	    return this._small;
	});
	this.__defineSetter__('small', function(val)
	{
	    this._small = Boolean(val);
	    var lst = this.getUnitsViews();
	    for (var i = 0, len = lst.length; i < len; i++) 
	    {
	        var muv = lst[i];
	        muv.small = this._small;
	    }
	});
	
	this._labelStyle = 'dark';
	this.__defineGetter__('labelStyle', function()
	{
	    return this._labelStyle;
	});
	this.__defineSetter__('labelStyle', function(val)
	{
	    this._labelStyle = val;
	    var lst = this.getUnitsViews();
	    for (var i = 0, len = lst.length; i < len; i++) 
	    {
	        var muv = lst[i];
	        muv.labelStyle = this._labelStyle;
	    }
	});
	
	this.zeroAsCardsAllowed = true;
	
	this.aura = null;
	this.selectedAttack = [-1, -1, -1, -1, -1, -1, -1, -1];
	this.buffs = null;
	this.requiredLevel = -1;
	this.round = -1;
	this.frozenTime = 0;
	
	this.__unitViewClass__ = "MilitaryUnitView";
	
	this.onToolTip = $.proxy(this.onToolTip, this);
	this.showToolTip = true;
}

ArmyView.prototype.zeroAsCardsAllowed = true;

ArmyView.prototype.aura = null;
ArmyView.prototype.selectedAttack = [-1, -1, -1, -1, -1, -1, -1, -1];
ArmyView.prototype.buffs = null;
ArmyView.prototype.requiredLevel = -1;
ArmyView.prototype.round = -1;
ArmyView.prototype.frozenTime = 0;

ArmyView.createBuffsGetter = function(armyView)
{
    return function()
    {
        return armyView ? COM(armyView).buffs : [];
    };
}

ArmyView.prototype.__construct = function()
{
    this.layout4x2 = false;
    
    if (this.DOM.hasAttribute('small')) this.small = ['false', '0'].indexOf(this.DOM.getAttribute('small')) < 0;
    if (this.DOM.hasAttribute('labelStyle')) this.labelStyle = this.DOM.getAttribute('labelStyle');
    if (this.DOM.hasAttribute('showToolTip')) this.showToolTip = this.DOM.getAttribute('showToolTip') != 'false';
    
    var row = this.unitBox.children[0];
    for (var i = 0; i < UnitType.MILITARY.length; i++) 
    {
        var muv = this.createMUV(), cell = document.createElement('unit');
        cell.appendChild(muv.DOM);
        row.appendChild(cell);
    }
    
    this.heroPosition = this.DOM.hasAttribute('heroPosition') ? this.DOM.getAttribute('heroPosition') : 'inside';
    if (this.DOM.hasAttribute('showHero')) this.showHero = (['false', '0'].indexOf(this.DOM.getAttribute('showHero')) >= 0);
    
    // default onHeroClick
    COM(this.heroView).onHeroClick = $.proxy(this.defaultOnHeroClick, this);
}

ArmyView.prototype.defaultOnHeroClick = function(h, r)
{
    HeroDialog.create(null, h, null, r, this.buffs, this.time, true);
}

ArmyView.prototype.getBuffs = function()
{
    return this.buffs || [];
}

ArmyView.prototype.createMUV = function()
{
    var muv = COM.create(this.__unitViewClass__);
    muv.small = this.small;
    muv.labelStyle = this.labelStyle;
    //muv.addEventListener(ToolTipEvent.TOOL_TIP_CREATE, onToolTip);
    //muv.toolTip = " ";
    muv.onToolTip = this.onToolTip;
    return muv;
}

ArmyView.prototype.getUnitsViews = function()
{
	var lst = $(this.unitBox).find(this.__unitViewClass__);
	for (var i = 0; i < lst.length; i++)
	{
		lst[i] = COM(lst[i]);
	}
	return lst;
}

ArmyView.prototype.showAsReport = function()
{
	/*
	var lst = this.getUnitsViews();
    for (var i = 0; i < lst.length; i++)
    {
        lst[i].countBorder.children[0].className = "borderlabel";
    }
    */
}

//sets closed doors
ArmyView.prototype.setAccessLevelRequired = function(requiredLevel)
{
    this.requiredLevel = (typeof requiredLevel == 'undefined') ? 0 : requiredLevel;
    COM(this.heroView).update(null, Race.MONSTER, this.requiredLevel);
    
    var lst = this.getUnitsViews();
    for (var i = 0; i < lst.length; i++)
    {
        lst[i].initLocked();
        lst[i].locked = true;
    }
}

ArmyView.prototype.setUnits = function(race, levels, forceMonsterRace, aura, buffs, round)
{
	if (typeof round == 'undefined') round = -1;
    this.requiredLevel = -1;
    this.round = round;
    this.aura = aura || new EmptyUnitAura();
    this.buffs = buffs || [];
    
    var lst = this.getUnitsViews();
    for (var i = 0; i < lst.length; i++) 
    {
        var muv = lst[i];
        muv.initUnitView(race, UnitType.MILITARY[i], levels[i], forceMonsterRace ? Race.MONSTER : null);
        muv.locked = false;
        muv.emptyZero = this.zeroAsCardsAllowed 
        	? (Race.MONSTER.equals(race) && !(this.aura.__className__ == 'FCastle')) 
        	: false
        ;
    }
}

ArmyView.prototype.showAllUnitsCount = function()
{
	var lst = this.getUnitsViews();
    for (var i = 0; i < lst.length; i++) 
    {
        lst[i].turnOnBottomTexts();
	}
}

ArmyView.prototype.hideUnitsCountFake = function()
{
	var lst = this.getUnitsViews();
    for (var i = 0; i < lst.length; i++) 
    {
        lst[i].initFake(0);
	}
}

ArmyView.prototype.setHero = function(h, r, lockedLevel)
{
    this.requiredLevel = typeof lockedLevel == 'undefined' ? -1 : lockedLevel;
    COM(this.heroView).update(h, r, this.requiredLevel);
}

ArmyView.prototype.setFrozenTime = function(time)
{
    this.frozenTime = time;
}

ArmyView.prototype.setCountInitial = function(count, initial, losses, raisings)
{
    var lst = this.getUnitsViews();
    for (var i = 0; i < lst.length; i++) 
    {
        var currentLosses = (losses != raisings) ? losses : (count[i] <= initial[i]);
        lst[i].initCountInitial(count[i], initial[i], currentLosses);
    }
}

ArmyView.prototype.setSelectedAttack = function(attack)
{
    this.selectedAttack = attack;
}

ArmyView.prototype.setCount = function(count, faded)
{
    if (typeof faded == 'undefined') faded = false;
    
    var lst = this.getUnitsViews();
    for (var i = 0; i < lst.length; i++) 
    {
        var mut = UnitType.MILITARY[i];
        lst[i].initCount(count.getValue(mut), this.buffs, faded);
    }
}

//race backs without science and texts
ArmyView.prototype.setAllBacks = function(race)
{
    this.requiredLevel = -1;
    COM(this.heroView).update(null, race);
    var lst = this.getUnitsViews();
    for (var i = 0; i < lst.length; i++) 
    {
        var muv = lst[i];
        muv.locked = false;
        muv.initEmpty(race);
    }
}

ArmyView.prototype.onToolTip = function(e)
{
    if(APP.ticksIsPaused || !this.showToolTip)
    {
    	return;
	}
    
    if (this.requiredLevel >= 0) 
    {
        if(this.requiredLevel > 0)
        {
        	Alert.create(I18.f('ACCESS_LEVEL_REQUIRED', this.requiredLevel));
        }
    } 
    else 
    {
        var target = COM(e.currentTarget);
    	
        if (target.showTip()) 
        {
            var type = target.unitType;
            
            UnitTipDialog.create(type, target.level, target.race, this.aura, this.selectedAttack[type.ordinal], this.buffs, this.round, FEstate.tickNowForEstate(this.aura));
        } 
        else 
        {
            e.toolTip = Tip.invisible();
        }
    }
}
