function EstateArmyEqualizer()
{
	callParentConstructor(EstateArmyEqualizer.prototype, this);
	
	this.realGarrisonHeroId = -1;
    this.garrisonHeroId = -1;
}

extendClass(EstateArmyEqualizer.prototype, ArmyEqualizer.prototype);

EstateArmyEqualizer.prototype.__construct = function()
{
	superMethod(EstateArmyEqualizer.prototype, "__construct", this)();
	
	//COM(this.heroHideout).onMoveHero = this.moveHeroToGarrison;
	
	COM(COM(this.selectedArmyView).armyView).heroView.style.opacity = 0;
	COM(this.heroHideout).onHeroClick = $.proxy(this.moveHeroToGarrison, this);
	
	this.init();
}

EstateArmyEqualizer.prototype.init = function()
{
    superMethod(EstateArmyEqualizer.prototype, "init", this)();
    
    this.heroHideout.style.display = "";
}

EstateArmyEqualizer.prototype.update = function(e, aura, groupBuffs)
{
    var newEstate = !this.estate || !this.estate.id.equals(e.id);
    superMethod(EstateArmyEqualizer.prototype, "update", this)(e, aura, groupBuffs);
    if (e.accessGarrison)
    {
        COM(COM(this.availableArmyView).armyView).setUnits(e.race, e.science.unitLevels, e.monsterRace(), aura, FBuff.getBuffsForGarrison(e, e.buffs));
    }
    else
    {
        COM(COM(this.availableArmyView).armyView).setAccessLevelRequired(FEstate.GARRISON_ACCESS_LEVEL);
    }
    
    if (e.accessHideout)
    {
        COM(COM(this.selectedArmyView).armyView).setHero(null, e.race, -1);
        COM(COM(this.selectedArmyView).armyView).setUnits(e.race, e.science.unitLevels, e.monsterRace(), aura);
    }
    else
    {
        COM(COM(this.selectedArmyView).armyView).setAccessLevelRequired(FEstate.HIDEOUT_ACCESS_LEVEL);
    }
    
    if (newEstate)
    {
        this.reset();
        
    	if(e.garrison.isEmpty() && !e.hideout.isEmpty())
    	{
    		this.moveAllDirect = -1;
    		this.updateMoveAllButton();
    	}
    }
    
    if (this.realGarrisonHeroId != this.estate.garrisonHeroId)
    {
        this.resetHeroes();
    }
    if (e.accessGarrison)
    {
        this.updateHeroes();
    }
    
    var av = COM(COM(this.availableArmyView).armyView);
    if(e.accessDeputy)
    {
    	av.onHeroClick = $.proxy(this.moveHeroToHideout, this);
    }
    else
    {
    	av.onHeroClick = av.defaultOnHeroClick;
    }
   
	this.tick();
}

EstateArmyEqualizer.prototype.tick = function()
{
    superMethod(EstateArmyEqualizer.prototype, "tick", this)();
    
    var oldDelta = this.oldHideout.substractCopy(this.newHideout, false);
    this.oldHideout = this.estate.hideout.copy();
    this.totalArmy = this.estate.garrison.addCopy(this.estate.hideout);
    this.newHideout = this.active ? this.oldHideout.substractOrZeroCopy(oldDelta) : this.oldHideout.copy();
    //buttonHeroOut.visible = active && estate.accessDeputy && garrisonHeroId >= 0;
    this.tickArmies();
}

EstateArmyEqualizer.prototype.reset = function()
{
    this.resetHeroes();
    this.updateHeroes();
    
    superMethod(EstateArmyEqualizer.prototype, "reset", this)();
}

EstateArmyEqualizer.prototype.getMovedUnitsCount = function()
{
    var heroMovedToHideout = this.estate.garrisonHeroId >= 0 && this.estate.garrisonHeroId != this.garrisonHeroId;
    return this.newHideout.substractOrZeroCopy(this.oldHideout).getTotalUnitCount() + (heroMovedToHideout ? 1 : 0);
}

EstateArmyEqualizer.prototype.getChanged = function()
{
    return superMethod(EstateArmyEqualizer.prototype, "getChanged", this)() || this.estate.garrisonHeroId != this.garrisonHeroId;
}

EstateArmyEqualizer.prototype.resetHeroes = function()
{
    this.realGarrisonHeroId = this.estate.garrisonHeroId;
    this.garrisonHeroId = this.estate.garrisonHeroId;
}

EstateArmyEqualizer.prototype.updateHeroes = function()
{
    var garrisonHero = this.estate.findHero(this.garrisonHeroId);
    COM(COM(this.availableArmyView).armyView).setHero(garrisonHero, this.estate.owner.race, this.estate.accessGarrison ? -1 : FEstate.GARRISON_ACCESS_LEVEL);
    var hideoutHeroes = Arrays.remove(Arrays.clone(this.estate.heroes), garrisonHero);
    COM(this.heroHideout).update(this.estate, hideoutHeroes);
    this.tick();
}

EstateArmyEqualizer.prototype.moveHeroToHideout = function(e)
{
    this.garrisonHeroId = -1;
    this.updateHeroes();
    this.onChange();
}

EstateArmyEqualizer.prototype.moveHeroToGarrison = function(h)
{
    this.garrisonHeroId = h.id;
    this.updateHeroes();
    this.onChange();
}

EstateArmyEqualizer.prototype.moveAll = function()
{
	if(this.moveAllDirect > 0)
	{
		this.garrisonHeroId = -1;
    	this.updateHeroes();
	}
	else
	{
		for(var i=0; i<this.estate.heroes.length; i++)
		{
			if(this.garrisonHeroId != this.estate.heroes[i].id)
			{
				this.garrisonHeroId = this.estate.heroes[i].id;
				this.updateHeroes();
				break;
			}
		}
	}
	
	superMethod(EstateArmyEqualizer.prototype, "moveAll", this)();
}