function HeroFaceView()
{
	this._hero = null; // FHero
	this._race = null; // Race
	this.blinkOnAttention = true;
	this._lockedLevel = -1;
	
	this.__defineGetter__('hero', this.getHero);
	this.__defineSetter__('hero', this.setHero);
	
	this.__defineGetter__('race', this.getRace);
	this.__defineSetter__('race', this.setRace);
	
	this.__defineGetter__('label', this.getLabel);
	this.__defineSetter__('label', this.setLabel);
	
	this.__defineGetter__('small', function(){
		return !$(this.DOM).hasClass('big');
	});
	
	this.__defineSetter__('small', function(val){
		$(this.DOM).toggleClass('big', !val);
	});
	
}

HeroFaceView.prototype._hero = null; // FHero
HeroFaceView.prototype._race = null; // Race
HeroFaceView.prototype.blinkOnAttention = true;
HeroFaceView.prototype._lockedLevel = -1;

HeroFaceView.createWith = function(fh, r)
{
    var result = COM.create('HeroFaceView');
    result._hero = fh;
    result._race = r;
    return result;
}

HeroFaceView.prototype.__construct = function()
{
	
	// XXX: hack to fix double scrolls bug in hero dialog (RenameDialog is not prevented when switching heroes)
	var click = null, lock = false;
	$(this.DOM).on(MOUSE_DOWN_EVENT, $.proxy(function(e){
		lock = false;
		e = (e['originalEvent'] || e); e = e['touches'] ? e.touches[0] : e; 
		click = {x: e.pageX, y: e.pageY};
	}, this));
	$(this.DOM).on(MOUSE_MOVE_EVENT, $.proxy(function(e){
		if (!click) return;
		e = (e['originalEvent'] || e); e = e['touches'] ? e.touches[0] : e;
		if (Math.max(Math.abs(e.pageX-click.x), Math.abs(e.pageY-click.y)) >= 6) lock = true;
	}, this));
	COM.bindExclusiveClick(this.DOM, $.proxy(function(){
		if (lock) return false;
		return this.heroClicked();
	}, this));
	
	this.label = this.DOM.hasAttribute('label') ? this.DOM.getAttribute('label') : '';
}

HeroFaceView.prototype.getRace = function()
{
	return this._race;
}

HeroFaceView.prototype.setRace = function(val)
{
	this._race = val;
	this.heroBack.src = STATIC_INTERFACE_URL + Assets.getHeroBack(this._race);
}

HeroFaceView.prototype.getHero = function()
{
	return this._hero;
}

HeroFaceView.prototype.setHero = function(val)
{
	this._hero = val;
    
    this.heroImage.src = STATIC_INTERFACE_URL + (this._hero 
    	? Assets.getHeroFace(this._hero.face) 
    	: (this._lockedLevel == -1 ? Assets.getLockedHero(this._race) : CommonAssets.LOCKED_HERO)
    );
    UI.show(this._hero && this._hero.isUpset(), [this.upsetIcon]);
}

HeroFaceView.prototype.getLabel = function()
{
	return $(this.labelText).html();
}

HeroFaceView.prototype.setLabel = function(val)
{
	$(this.labelText).html(val);
	UI.show(!!val, [this.labelBox]);
}

HeroFaceView.prototype.onHeroClick = function(h, r)
{
    HeroDialog.create(null, h, null, r, [], NaN, true);
};

HeroFaceView.prototype.update = function(h, r, lockedLevel)
{
    this._lockedLevel = typeof(lockedLevel == 'undefined') ? -1 : lockedLevel;
    this.race = r;
    this.hero = h;
    
    var clickable = (this.hero && typeof this.onHeroClick == 'function');
    this.DOM.style.cursor = clickable ? 'cursor' : 'default';
    //$(this.heroImage).css('opacity', clickable ? 1.0 : 0.8);
}

HeroFaceView.prototype.createTip = function(event)
{
    if (this.toolTip == " ") 
    {
        if (this._lockedLevel >= 0) 
        {
            //event.toolTip = this._lockedLevel == 0 ? Tip.invisible() : Tip.create(I18.f('ACCESS_LEVEL_REQUIRED', this._lockedLevel));
        } 
        else 
        {
            //HeroTip.create(event, this._hero);
        }
    }
}

HeroFaceView.prototype.heroClicked = function()
{
    if (this.hero && typeof this.onHeroClick == 'function') 
    {
        this.onHeroClick(this.hero, this.race);
    }
}
