function MilitaryUnitView()
{
	this.emptyZero = true;
	this.locked = false;
	this.countInt = 0;
	this._race = Race.MONSTER;
	this._level = 1;
	this._forcedRace = null;
	this.mutype = null;
	
	this.__defineGetter__('race', function(){ return this._race; });
	this.__defineGetter__('level', function(){ return this._level; });
	this.__defineGetter__('unitType', function(){ return this.mutype; });
	
	this._small = false;
	this.__defineGetter__('baseCardUrl', function()
	{ 
		//return this._small ? STATIC_URL : STATIC_INTERFACE_URL; 
		return STATIC_INTERFACE_URL; 
	});
	this.__defineGetter__('small', function()
	{ 
		return this._small; 
	});
	this.__defineSetter__('small', function(val)
	{
		this._small = Boolean(val);
		
		$("unitview-wrapper", this.DOM).toggleClass('small', this._small);
		
		/*
		var search = this._small ? STATIC_INTERFACE_URL : STATIC_URL;
		var replace = this._small ? STATIC_URL : STATIC_INTERFACE_URL;
		if (this.card.src)
		{
			this.card.src = this.card.src.replace(search, replace);
		}
		*/
	});
	
	this._labelStyle = 'green';
	this.__defineGetter__('labelStyle', function()
	{ 
		return this._labelStyle; 
	})
	this.__defineSetter__('labelStyle', function(val)
	{
		if (this._labelStyle)
		{
			$(this.countBox).removeClass(this._labelStyle);
		}
		this._labelStyle = val;
		$(this.countBox).addClass(val);
	});
}

MilitaryUnitView.prototype.emptyZero = true;
MilitaryUnitView.prototype.locked = false;
MilitaryUnitView.prototype.countInt = 0;
MilitaryUnitView.prototype._race = Race.MONSTER;
MilitaryUnitView.prototype._level = 0;
MilitaryUnitView.prototype.mutype = null;

MilitaryUnitView.prototype.__construct = function()
{
    if (this.DOM.hasAttribute('labelStyle')) this.labelStyle = this.DOM.getAttribute('labelStyle');
    if (this.DOM.hasAttribute('small')) this.small = ['false', '0'].indexOf(this.DOM.getAttribute('small')) >= 0;
    
    this.countFake.style.color = UnitView.COLOR_BLUE;
    this.turnOffTexts();
    
    COM.bindExclusiveClick(this.DOM, $.proxy(this.onShowToolTip, this));
}

MilitaryUnitView.prototype.onShowToolTip = function(e)
{
	if(this.onToolTip) this.onToolTip(e);
}

MilitaryUnitView.prototype.turnOffTexts = function()
{
    this.turnOffBottomTexts();
    UI.show(false, [this.countFake]);
    UI.show(false, [this.countFake.parentNode]);
}

MilitaryUnitView.prototype.turnOffBottomTexts = function()
{
    UI.show(false, [this.countInitial, this.countLost, this.count]);
    UI.show(false, [this.countInitial.parentNode, this.countLost.parentNode, this.count.parentNode]);
    UI.show(false, [this.countBox]);
}

MilitaryUnitView.prototype.turnOnBottomTexts = function()
{
    UI.show(true, [this.countInitial, this.countLost, this.count]);
    UI.show(true, [this.countInitial.parentNode, this.countLost.parentNode, this.count.parentNode]);
    UI.show(true, [this.countBox]);
}

MilitaryUnitView.prototype.setGrayscale = function(on)
{
    //var flag = !!(on && !this.locked);
    //$(this.card).toggleClass('grayscale', flag);
    //$(this.countBox).toggleClass('grayscale', flag);
    //$(this.card).toggleClass('grayscale disabled', flag);
}

MilitaryUnitView.prototype.initCount = function(count, buffs, faded)
{
    if (this.locked) return;
    
    this.turnOffTexts();
    this.countInt = count;
    this.count.innerHTML = Math.floor(this.countInt);

    var fakeCount = 0;
    var multiplier = 0;
    if (buffs) 
    {
        for (var i = 0; i < buffs.length; i++) 
        {
        	var buff = buffs[i];
            if (buff.buffType.name == BuffType.ILLUSION.name && buff.value != 0) 
            {
                multiplier += buff.value + FUser.CURRENT_USER.illusionRate * buff.delta;
            } 
            else if (buff.buffType.name == BuffType.ILLUSION_ADD.name && this.mutype) 
            {
                fakeCount += buff.army.getValue(this.mutype);
            }
        }
    }
    fakeCount = (count + fakeCount) * Math.max(0, multiplier + 1) - count;
    this.initFake(fakeCount);
    if (count > 0 || fakeCount > 0 && Race.MONSTER.equals(this._race)) 
    {
        this.setGrayscale(false);
    } 
    else 
    {
        this.setGrayscale(true);
        if (this.emptyZero) 
        {
            this.initEmpty(this._race);
        }
    }
    if (faded && buffs && MilitaryUnitView.hasBuff(buffs, BuffType.COUNT_INACCURACY)) 
    {
        this.count.innerHTML = I18.getString("SIZE_" + NumberUtils.getFadedIndex(count, FConfig.ARMY_SIZES));
    }
    UI.show(true, [this.count, this.count.parentNode, this.countBox]);
}

MilitaryUnitView.hasBuff = function(ac, bt)
{
    for (var i = 0; i < ac.length; i++) if (ac[i].buffType.name == bt.name) return true;
    return false;
}

MilitaryUnitView.prototype.initFake = function(countFake)
{
    UI.show(countFake != 0, [this.countFake, this.countFake.parentNode]);
    this.countFake.innerHTML = Math.floor(countFake);
}

MilitaryUnitView.prototype.initCountInitial = function(count, initial, losses)
{
    if (this.locked) return;
    
    if (initial == 0 && count == 0) 
    {
        if (this.emptyZero) 
        {
            this.initEmpty(this._race);
        }
        this.turnOffTexts();
        this.setGrayscale(true);
        return;
    } 
    else 
    {
        this.setGrayscale(false);
    }

    UI.show(true, [this.countInitial, this.countLost, this.count]);
    UI.show(true, [this.countInitial.parentNode, this.countLost.parentNode, this.count.parentNode]);
    this.count.innerHTML = count || "0";
    this.countInitial.innerHTML = initial || "0";

    var difference = count - initial;
    if ((difference != 0) && ( ((difference < 0) && !losses) || ((difference > 0) && losses) )) 
    {
        console.error("Inconsistency of losses = %s and real difference: initial was %s, now is %s and difference is %s", losses, initial, count, difference);
    }
    
    difference = Math.abs(difference);
    this.countLost.innerHTML = (losses ? "-" : "+") + (difference || 0);
    //this.countLost.style.color = losses ? UnitView.COLOR_RED : UnitView.COLOR_BLUE;
}

MilitaryUnitView.prototype.initUnitView = function(race, mut, level, forcedRace)
{
    this._level = level;
    this.mutype = mut;
    this._race = race;
    this._forcedRace = forcedRace;
    this.card.src = STATIC_INTERFACE_URL + Assets.getUnitImageFor(forcedRace || race, mut, level);
    this.decor.className = Assets.getUnitBorderClassFor(forcedRace || race, level);
}

MilitaryUnitView.prototype.initUnitLevel = function(level)
{
    this._level = level;
    this.card.src = STATIC_INTERFACE_URL + Assets.getUnitImageFor(this._forcedRace || this._race, this.mutype, level);
    this.decor.className = Assets.getUnitBorderClassFor(this._forcedRace || this._race, level);
}

MilitaryUnitView.prototype.initEmpty = function(race)
{
    this._race = race;
    this.card.src = STATIC_INTERFACE_URL + Assets.getUnitBackFor(this._forcedRace || race);
    this.decor.className = "";
    this.setGrayscale(true);
    this.turnOffTexts();
}

MilitaryUnitView.prototype.initLocked = function()
{
    this.card.src = STATIC_INTERFACE_URL + CommonAssets.CARD_LOCKED;
    this.decor.className = "";
    UI.show(false, [this.countBox]);
    this.count.innerHTML = "???";
    this.turnOffTexts();
    this.setGrayscale(false);
}

MilitaryUnitView.prototype.initCastleGate = function(level)
{
    this.card.src = STATIC_INTERFACE_URL + Assets.getTowerImageFor(Race.CASTLE_MONSTER, BType.CASTLEGATE, level);
    this.decor.className = "";
    //this.turnOffTexts();
    this.setGrayscale(false);
}

MilitaryUnitView.prototype.showTip = function()
{
    //return !this.emptyZero || this.count.innerHTML*1 > 0;
    return true;
}

MilitaryUnitView.prototype.getCountInt = function()
{
    return this.countInt;
}

MilitaryUnitView.prototype.setButtonMode = function(b)
{
    this.card.style.cursor = b ? 'pointer' : 'default';
}
