function MissionArmyEqualizer()
{
	callParentConstructor(MissionArmyEqualizer.prototype, this);
	
	this.heroSelected = false;
    this.toField = null;
    this.aura = null;
    this.groupBuffs = null;
    
    this.__defineGetter__("selectedHeroId", this.getSelectedHeroId);
}

extendClass(MissionArmyEqualizer.prototype, ArmyEqualizer.prototype);

MissionArmyEqualizer.prototype.__construct = function()
{
    // static/images/interface/3/icons/arrow_up_down.png
    
    superMethod(MissionArmyEqualizer.prototype, "__construct", this)();
    
    //heroSlider.onChange = onMoveHero;
    this.heroHideout.style.display = "none";
    
    COM(COM(this.availableArmyView).armyView).onHeroClick = $.proxy(this.onSelectHero, this);
    COM(COM(this.selectedArmyView).armyView).onHeroClick = $.proxy(this.onUnSelectHero, this);
    
    $("cell", this.arrowsRow).on(CLICK_EVENT, $.proxy(this.showSliderByArrow, this));
}

MissionArmyEqualizer.prototype.update = function(e, aura, groupBuffs)
{
    this.aura = aura;
    this.groupBuffs = groupBuffs;
    superMethod(MissionArmyEqualizer.prototype, "update", this)(e, aura, groupBuffs);
    this.active = true;
    var selectedHero = this.heroSelected ? this.estate.garrisonHero : null;
    var availableHero = this.heroSelected ? null : this.estate.garrisonHero;
    
    var av = COM(COM(this.availableArmyView).armyView);
    var sv = COM(COM(this.selectedArmyView).armyView);
    
    av.setHero(availableHero, this.estate.race, e.accessGarrison ? -1 : FEstate.GARRISON_ACCESS_LEVEL);
    sv.setHero(selectedHero, this.estate.race, e.accessHideout ? -1 : FEstate.HIDEOUT_ACCESS_LEVEL);
    av.setUnits(e.race, e.science.unitLevels, e.monsterRace(), this.estate,
            FBuff.getBuffsForGarrison(this.estate, !selectedHero ? this.estate.buffs : Arrays.subtract(this.estate.buffs, selectedHero.getWorkingBuffs(this.estate.terrain))));

    
    var buffs = [];
    if (selectedHero)
    {
        buffs = buffs.concat(selectedHero.getWorkingBuffs(this.toField.terrain));
    }
    if (this.groupBuffs)
    {
        buffs = buffs.concat(this.groupBuffs);
    }
    
    var cast, buff;
    for(var i=0; i<this.estate.casts.length; i++)
    {
    	cast = this.estate.casts[i];
    	if (cast.fromOwner)
    	{
    		for(var n=0; n<cast.buffs.length; n++)
    		{
    			buff = cast.buffs[n];
    			
    			if (BuffTarget.contains(buff.targets, BuffTarget.SELF))
    			{
                    buffs.push(buff);
                }
    		}
    	}
    }
    
    sv.setUnits(e.race, e.science.unitLevels, e.monsterRace(), aura, FBuff.getBuffsForField(this.toField, e.race, buffs));

    /*
    heroSlider.sliderEnabled = estate.garrisonHero != null && !estate.garrisonHero.isUpset();
    heroSlider.value = heroSelected ? 1 : 0;
    heroSlider.maximum = 1;
    */
}

MissionArmyEqualizer.prototype.showSliderByArrow = function(e)
{
	var id = e.target.getAttribute("unitid")*1;
	var unit = $("militaryunitview", this.availableArmyView)[id];
	
	this.showSlider({currentTarget: unit});
}

MissionArmyEqualizer.prototype.tick = function()
{
    superMethod(MissionArmyEqualizer.prototype, "tick", this)();
    
    this.totalArmy = this.estate.garrison;
    if (this.heroSelected && !this.estate.garrisonHero)
    {
        this.heroSelected = false;
        this.updateHero();
    }
    this.tickArmies();
}

MissionArmyEqualizer.prototype.reset = function()
{
    this.heroSelected = false;
    superMethod(MissionArmyEqualizer.prototype, "reset", this)();
}

MissionArmyEqualizer.prototype.onMoveHero = function(value)
{
    this.heroSelected = value > 0;
    this.updateHero();
}

MissionArmyEqualizer.prototype.onSelectHero = function()
{
    this.heroSelected = true;
    this.updateHero();
}

MissionArmyEqualizer.prototype.onUnSelectHero = function()
{
    this.heroSelected = false;
    this.updateHero();
}

MissionArmyEqualizer.prototype.updateHero = function()
{
    COM(COM(this.availableArmyView).armyView).setHero(this.heroSelected ? null : this.estate.garrisonHero, this.estate.race, this.estate.accessGarrison ? -1 : FEstate.GARRISON_ACCESS_LEVEL);
    COM(COM(this.selectedArmyView).armyView).setHero(this.heroSelected ? this.estate.garrisonHero : null, this.estate.race, this.estate.accessHideout ? -1 : FEstate.HIDEOUT_ACCESS_LEVEL);

    this.update(this.estate, this.aura, this.groupBuffs);
    this.onChange();
}

MissionArmyEqualizer.prototype.moveAll = function()
{
	if(this.moveAllDirect > 0)
	{
		this.onMoveHero(1);
	}
	else
	{
		this.onMoveHero(0);
	}
	
	superMethod(MissionArmyEqualizer.prototype, "moveAll", this)();
}

MissionArmyEqualizer.prototype.getSelectedHeroId = function()
{
    return this.heroSelected ? this.estate.garrisonHero.id : -1;
}