function PictureValueBonus()
{
	this.__defineGetter__('source', function(){return this.image.src;});
	this.__defineSetter__('source', function(val){this.image.src = val;});
}

PictureValueBonus.prototype.__construct = function()
{
	this.source = this.DOM.getAttribute('source');
}

PictureValueBonus.prototype.update = function(value, bonusValue, minBonus)
{
    var bonusColor = '';
    if (bonusValue > 0) 
    {
        bonusColor = 'positive';
    } 
    else if (bonusValue < 0) 
    {
        bonusColor = 'negative';
    } 
    else 
    {
        bonusColor = '';
    }
    if (bonusValue < minBonus) 
    {
        this.setValueLabel(value, Strings.formatBonusPercent(minBonus), 'overflow');
    } 
    else 
    {
        this.setValueLabel(value, Strings.formatBonusPercent(bonusValue), bonusColor);
    }
}

PictureValueBonus.prototype.updateWithLimit = function(value, bonus, max, min)
{
    var tooBig = false;
    var tooSmall = false;
    var actual = bonus + 0;
    if (value + bonus >= max) 
    {
        actual = max - value;
        tooBig = true;
    }
    if (value + bonus <= min) 
    {
        actual = min - value;
        tooSmall = true;
    }
    var color = '';
    if (tooBig || tooSmall) 
    {
        color = 'overflow';
    } 
    else if (actual > 0) 
    {
        color = 'positive';
    } 
    else if (actual < 0) 
    {
        color = 'negative';
    }
    this.setValueLabel(value, Strings.formatBonusConst(actual, bonus), color);
}

PictureValueBonus.prototype.setValueLabel = function(valueText, bonusText, bonusColor)
{
    this.valueLabel.innerHTML = valueText;
    UI.show(bonusColor != '', [this.bonusLabel]);
    if (bonusColor != '')
    {
        $(this.bonusLabel).removeClass('positive negative overflow')
        	.addClass(bonusColor)
        	.html(bonusText)
        ;
    }
}
