function UnitView()
{

	this.onClick = function(ut, count){};
	
	this.utype = null; // UnitType
	this.race = null; // Race
	
	this.aura = new EmptyUnitAura();
	this.buffs = [];
	this.count = 0;
	this.maximum = 0;
	this.time = -1;
	
	this._level = 1;
	this.showZero = false;
	this.showCount = true;
	this.showMaximum = false;
	this.grayscaleZero = true;
	this.showUnitBackIfZero = false;
	this._locked = false;
	
	this.__defineSetter__('locked', function(value)
	{
		this._locked = value;
		this.update(1, 0);
	});
	
}

UnitView.COLOR_BLUE = '#88aaff';
UnitView.COLOR_RED = '#ff8888';
UnitView.COLOR_WHITE = '#FFFFFF';

UnitView.prototype.onClick = function(ut, count){};

UnitView.prototype.utype = null; // UnitType
UnitView.prototype.race = null; // Race

UnitView.prototype.aura = new EmptyUnitAura();
UnitView.prototype.buffs = [];
UnitView.prototype.count = 0;
UnitView.prototype.maximum = 0;
UnitView.prototype.time = -1;

UnitView.prototype._level = 0;
UnitView.prototype.showZero = false;
UnitView.prototype.showCount = true;
UnitView.prototype.showMaximum = false;
UnitView.prototype.grayscaleZero = true;
UnitView.prototype.showUnitBackIfZero = false;
UnitView.prototype._locked = false;

UnitView.prototype.__construct = function()
{
	if (this.DOM.hasAttribute('showZero')) this.showZero = (this.DOM.getAttribute('showZero') == 'true');
	if (this.DOM.hasAttribute('showCount')) this.showCount = (this.DOM.getAttribute('showCount') == 'true');
	if (this.DOM.hasAttribute('showMaximum')) this.showMaximum = (this.DOM.getAttribute('showMaximum') == 'true');
	if (this.DOM.hasAttribute('grayscaleZero')) this.grayscaleZero = (this.DOM.getAttribute('grayscaleZero') == 'true');
	if (this.DOM.hasAttribute('showUnitBackIfZero')) this.showUnitBackIfZero = (this.DOM.getAttribute('showUnitBackIfZero') == 'true');
}

UnitView.prototype.update = function(level, newCount, newMaximum)
{
    if (typeof newMaximum == 'undefined') newMaximum = -1;
    
    this.count = newCount;
    this.maximum = newMaximum;
    this._level = level;

    if (this.race && this.utype) 
    {
        if (newCount == 0 && this.showUnitBackIfZero) 
        {
            this.card.src = STATIC_INTERFACE_URL + Assets.getUnitBackFor(this.race);
        } 
        else 
        {
            this.card.src = STATIC_INTERFACE_URL + (this._locked
            	? CommonAssets.CARD_LOCKED
            	: Assets.getRaceAssets(this.race).cards[this.utype.name + "_" + UnitType.normalize(this._level)]
            );
        }
    }

    
    var cnt = Math.floor(this.count);
    this.unitCount.innerHTML = this.showMaximum ? cnt + '/' + Math.floor(this.maximum) : cnt;
    UI.show(this.showCount && (cnt > 0 || this.showZero) && !this._locked, [this.countBox]);

    this.decor.className = Assets.getUnitBorderClassFor(this.race, level);
    
    /*
	if (this.grayscaleZero && cnt == 0 && !this._locked) 
    {
        $(this.card).addClass('grayscale');
    } 
    else 
    {
        $(this.card).removeClass('grayscale');
    }
	*/
}

UnitView.prototype.setInitialKilledPresent = function(initial, lost, sign)
{
    if (typeof sign == 'undefined') sign = '-';
    var present = initial - lost;
    this.unitCountInitial.innerHTML = initial >= 0 ? initial : '?';

    lost = lost < 0 ? -lost : lost;
    this.unitCountLost.innerHTML = sign + lost.toString();
    this.unitCountLost.style.color = sign == "-" ? UnitView.COLOR_RED : UnitView.COLOR_BLUE;
    this.unitCount.innerHTML = initial >= 0 ? present : '?';
    
    UI.show(true, [this.unitCountInitial, this.unitCountLost, this.unitCount]);
}

UnitView.prototype.getToolTip = function()
{
    if (!this._locked && !this.showUnitBackIfZero) 
    {
		return UnitTip.create(this.utype, this._level, this.race, this.aura, -1, this.buffs, -1, this.time);
    } 
    else 
    {
        return {DOM: document.createElement('EmptyTip')};
    }
}
