function EstateCombo()
{
	this._links = [];
	this.linksLength = 0;
	this._selected = null;
	this._enabled = true;
	
	this.expanded = false;
	
	this.onChange = null;
	
	this.__defineSetter__("links", this.setLinks);
	this.__defineSetter__("enabled", this.setEnabled);
	this.__defineGetter__("selected", this.getSelected);
	this.__defineSetter__("selected", this.setSelected);
	
	this.scroll = null;
}

EstateCombo.prototype.__construct = function()
{
	this.scroll = new iScroll($('> wrapper', this.DOM).get(0));
	
	var icon = Session.get("gameServerIcon");
	if(icon) this.icon.src = icon;
	else this.icon.style.visibility = "hidden";
	
	var name = Session.get("gameServerName");
	if(name) this.name.innerHTML = name;
	else this.name.style.visibility = "hidden";
	//console.log(Session.get("gameServerName"));
	
	COM.bindExclusiveClick(this.logout, Service.goToPortal);
}

EstateCombo.prototype.onChange = function()
{
}

EstateCombo.prototype.setLinks = function(value)
{
	this._links = value;
		
	$("> wrapper > content", this.DOM).empty();
	
	var lnk, icon;
	for(var i=0; i<value.length; i++)
	{
		lnk = COM.create("EstateComboLine");
		lnk.update(value[i]);
		
		COM.bindExclusiveClick(lnk.DOM, $.proxy(function(e)
		{
			if(!APP.ticksIsPaused) this.onItemClick(e);
		}, this));
		
		$("> wrapper > content", this.DOM).append(lnk.DOM);
	}
	
	this.refreshScroll();
}

EstateCombo.prototype.refreshScroll = function()
{
	if($(this.DOM).is(':visible'))
	{
		setTimeout($.proxy(this.scroll.refresh, this.scroll), 500);
	}
}

EstateCombo.prototype.getSelected = function()
{
	return this._selected;
}

EstateCombo.prototype.setSelected = function(value)
{
	this._selected = value;
}

EstateCombo.prototype.expandOrCollapse = function()
{
    if (this.expanded)
    {
        this.collapse();
    }
    else
    {
        this.expand();
    }
}

EstateCombo.prototype.collapse = function()
{
}

EstateCombo.prototype.expand = function()
{
}

EstateCombo.prototype.onItemClick = function(e)
{
    this.collapse();

    var target = COM.get(e.currentTarget).link;
    
    if (!this._selected || !target.estateInfo.id.equals(this._selected.estateInfo.id))
    {
        this._selected = target;
        this.cityChanged(target);
    }
}

EstateCombo.prototype.cityChanged = function(e)
{
	this.onChange(e);
}

EstateCombo.prototype.containsId = function(id)
{
    for(var i=0; i<this._links.length; i++)
    {
    	if(this._links[i].id.equals(id)) return true;
    }
    return false;
}

EstateCombo.prototype.setEnabled = function(enable)
{
    if (!enable)
    {
        this.collapse();
    }
    this._enabled = enable;
}

/*
EstateCombo.prototype =
{
	_links: [],
	
	update: function(value)
	{
		
	},
	
	route: function()
	{
		APP.showLoading();
		Service.city.callMethod("getById", new EstateId(this.location.x, this.location.y, this.location.z));
	}
}
*/