var EffectsView = {}

EffectsView.REWARD_GIFT = "REWARD_GIFT";

EffectsView.REWARDS_WITH_CUSTOM_DURATION = [
    "REWARD_SUBSCRIPTION_PROMO",
    "REWARD_SEND_CONSTANT_DURATION_MOVE_ARMY",
    "REWARD_CLOSE_GATE"
];

EffectsView.createCastView = function(box, effects, buffs, holderIsHero)
{
    var common = EffectsView.extractCommon(buffs, effects);
    for (var i = 0; i < buffs.length; i++) 
    {
    	var b = buffs[i];
        var res = document.createElement('EV-buff')
        var params = EffectsView.toMapBuff(b, effects); // FMap
        if (common) 
        {
            for (var j = 0, k = common.keys; j < k.length; j++) 
            {
                params.remove(k[j]);
            }
        }
        
        if (BuffType.CASTER_CAN_ATTACK.name == b.buffType.name) 
        {
            $(res).html(I18.getMegaBox("CAST_" + b.buffType.name, [b.cast.caster]));
        } 
        else if (BuffType.INFECTION.name == b.buffType.name) 
        {
            var spellLevel = params.getValue("spellLevel");
            var spellName = params.getValue("spellName");
            
            var decl = FConfig.spells.getValue(spellName);
            if (decl) decl = decl.getValue(spellLevel); // SpellLevelDecl
            if (decl)
            {
	            if (decl.hero.dtoActions.length > 0) 
	            {
	                $(res).html(I18.getMegaBox("BUFF_INFECTION_HERO_HEAD", params));
	            } 
	            else 
	            {
	                $(res).html(I18.getMegaBox("BUFF_INFECTION_ESTATE_HEAD", params));
	            }
            }
        } 
        else if (BuffType.KINGDOM_ANIMATION.name == b.buffType.name) 
        {
            $(res).html(I18.getMegaBox("BUFF_KINGDOM_ANIMATION_" + b.value, params));
        } 
        else 
        {
            if (!b.btype && !b.unitType && I18.getStringOrNull("BUFF_" + b.buffType.name + "_ALL")) 
            {
                $(res).html(I18.getMegaBox("BUFF_" + b.buffType.name + "_ALL", params));
            } 
            else if (b.btype && I18.getStringOrNull("BUFF_" + b.buffType.name + "_" + b.btype.name)) 
            {
                $(res).html(I18.getMegaBox("BUFF_" + b.buffType.name + "_" + b.btype.name, params));
            } 
            else 
            {
                $(res).html(I18.getMegaBox("BUFF_" + b.buffType.name, params));
            }
        }
        
        EffectsView.addCommonLineContinue(res, params);
        $(box).append(res);
        EffectsView.addCommonLine(box, params, true, holderIsHero, true);
        if (BuffType.INFECTION.name == b.buffType.name) 
        {
            $(box).append(EffectsView.infectionDesc(params));
        }
    }
    if (common) 
    {
        EffectsView.addCommon(common, box, holderIsHero, false, true);
    }
}

EffectsView.addCommon = function(common, box, holderIsHero, showOn, showDelay)
{
    if (common.containsKey("terrain")) 
    {
        $(box).append(I18.getMegaString("ALL_TERRAIN", common));
    }
    if (common.containsKey("combatPosition")) 
    {
        var val = common.getValue("combatPosition");
        if (val) $(box).append(I18.getMegaString("ALL_IN_" + val.name));
    }
    if (common.containsKey("estateType")) 
    {
        var val = common.getValue("estateType")
        if (val) $(box).append(I18.getMegaString("ALL_IN_" + val.name));
    }
    if (common.containsKey("targets")) 
    {
        var targets = common.getValue("targets");
        if (targets)
        {
	        if ((targets.length > 1) || (targets[0].name != BuffTarget.SELF.name)) 
	        {
	            var s = I18.f('ALL_AFFECTS', Strings.join(Arrays.sorted(targets), ", ", function(target) 
	            {
	                return I18.getString(("ON_") + target.name);
	            }));
	            
	            $(box).append(s);
	        }
        }
    }
    if (common.containsKey("myRaces") && common.containsKey("againstRaces")) 
    {
        $(box).append(I18.getMegaString("MY_AGAINST_RACE_BUFF", common));
    } 
    else if (common.containsKey("myRaces")) 
    {
        $(box).append(I18.getMegaString("MY_RACE_BUFF", common));
    } 
    else if (common.containsKey("againstRaces")) 
    {
        $(box).append(I18.getMegaString("AGAINST_RACE_BUFF", common));
    }
    if (common.containsKey("againstFraction")) 
    {
        var val = common.getValue("againstFraction");
        if (val) $(box).append(I18.getMegaString("AGAINST_FRACTION_" + val.name));
    }
    if (holderIsHero && common.containsKey("global")) 
    {
        $(box).append(I18.f('ALL_WORKS_IF_HERO_IN_MISSION'));
    }
    if (showOn && common.containsKey("duration")) 
    {
        $(box).append(I18.getMegaString("ON_DURATION", common));
    }
    if (showDelay && common.containsKey("delay")) 
    {
        $(box).append(I18.getMegaString("BUFF_DELAY", common));
    }
}

EffectsView.extractCommon = function(buffs, effects)
{
    var common = null; // FMap
    if (buffs.length > 1) 
    {
        for (var i = 0, len = buffs.length; i < len; i++) 
        {
        	var b = buffs[i];
            var params = EffectsView.toMapBuff(b, effects);
            if (!common) 
            {
                common = EffectsView.copyCommon(params);
            } 
            else 
            {
                EffectsView.filterCommon(common, params);
            }
        }
    }
    return common;
}

EffectsView.copyCommon = function(params)
{
    var common = new FMap();
    common.put("targets", params.getValueOrNull("targets"));
    common.put("duration", params.getValueOrNull("duration"));
    common.put("terrain", params.getValueOrNull("terrain"));
    common.put("estateType", params.getValueOrNull("estateType"));
    common.put("combatPosition", params.getValueOrNull("combatPosition"));
    common.put("againstFraction", params.getValueOrNull("againstFraction"));
    common.put("myRaces", params.getValueOrNull("myRaces"));
    common.put("againstRaces", params.getValueOrNull("againstRaces"));
    common.put("global", params.getValueOrNull("global"));
    return common;
}

EffectsView.toMapBuff = function(b, effects)
{
    var params = new FMap();
    for (var prop in b) params.put(prop, b[prop]);
    if (BuffType.ILLUSION.name == b.buffType.name) 
    {
        params = EffectsView.findParams(effects, "BUFF_" + BuffType.ILLUSION.name);
        if (!params) 
        {
            params = new FMap();
        }
    } 
    else if (BuffType.SUMMON.name == b.buffType.name) 
    {
        params = EffectsView.findParams(effects, "BUFF_" + BuffType.SUMMON.name);
        if (!params) 
        {
            params = new FMap();
        } 
        else 
        {
            params = $.extend({}, params);
        }
        params.put("value", b.value + "/" + params.getValueOrNull("value"));
        params.put("unitType", b.unitType);
    }
    if (b.buffType.isGlobal()) 
    {
        params.put("global", "1");
    }
    return params;
}

EffectsView.addCommonLineContinue = function(b, o)
{
    if (o.containsKey("terrain")) 
    {
        $(b).append(I18.getMegaString("TERRAIN_BUFF_SUFFIX", o));
    }
    var typeAndPosition = null;
    if (o.containsKey("combatPosition") && o.containsKey("estateType")) 
    {
        var v1 = o.getValue("combatPosition"), v2 = o.getValue("estateType");
        if (v1 && v2) typeAndPosition = I18.getStringOrNull("IN_" + v1.name + "_IN_" + v2.name);
    }
    if (typeAndPosition) 
    {
        $(b).append(typeAndPosition);
    } 
    else 
    {
        if (o.containsKey("combatPosition")) 
        {
            var val = o.getValue("combatPosition");
            if (val) $(b).append(I18.getMegaString("IN_" + val.name));
        }
        if (o.containsKey("estateType")) 
        {
            var val = o.getValue("estateType");
            if (val) $(b).append(I18.getMegaString("IN_" + val.name));
        }
    }
}

EffectsView.addCommonLine = function(b, o, affectsOn, holderIsHero, showDelay)
{
    if (o.containsKey("targets")) 
    {
        EffectsView.addAffects(b, o.getValue("targets"), affectsOn);
    }
    if (o.containsKey("myRaces") && o.containsKey("againstRaces")) 
    {
        $(b).append(I18.getMegaString("MY_AGAINST_RACE_BUFF", o));
    } 
    else if (o.containsKey("myRaces")) 
    {
        $(b).append(I18.getMegaString("MY_RACE_BUFF", o));
    } 
    else if (o.containsKey("againstRaces")) 
    {
        $(b).append(I18.getMegaString("AGAINST_RACE_BUFF", o));
    }
    if (o.containsKey("againstFraction")) 
    {
        var val = o.getValue("againstFraction");
        if (val) $(b).append(I18.getMegaString("AGAINST_FRACTION_" + val.name));
    }

    if (holderIsHero && o.containsKey("global")) 
    {
        $(b).append(I18.f('WORKS_IF_HERO_IN_MISSION'));
    }
    if (showDelay && o.containsKey("delay")) 
    {
        $(b).append(I18.getMegaString("BUFF_DELAY", o));
    }
}

EffectsView.infectionDesc = function(params)
{
    var newBox = document.createElement('EV-infection');
    var spellName = params.getValue("spellName");
    var spellLevel = params.getValue("spellLevel");
    var decl = FConfig.getSpell(spellName, spellLevel);
    if (decl) 
    {
        EffectsView.createDescriptiveView(newBox, decl.allActions, false, false, true, false);
        if (decl.maxDuration > 0) 
        {
            $(newBox).append(I18.mega(I18.f('SPELL_DURATION'), decl.maxDuration) + (decl.stopsAfterCombat ? " " + I18.f('STOPS_AFTER_COMBAT') : ""));
        }
    }
    return newBox;
}

EffectsView.addAffects = function(box, targets, on)
{
    if (targets && (targets.length > 1 || targets[0].name != BuffTarget.SELF.name)) 
    {
        var s = I18.f('AFFECTS', Strings.join(Arrays.sorted(targets), ", ", function(target)
        {
            return I18.getString((on ? "ON_" : "AFFECTS_") + target.name);
        }));
        
        $(box).append(s);
    }
}

EffectsView.createDescriptiveView = function(box, effects, showOn, targetDescription, nestedInfection, holderIsHero, prefix, showDelay)
{
    if (typeof prefix == 'undefined') prefix = '';
    if (typeof showDelay == 'undefined') showDelay = true;
    
    if (effects.length == 0) 
    {
        return box;
    }
    
    var common = null; // FMap
    if (effects.length > 1) 
    {
        var delay = 0;
        for (var i = 0, len = effects.length; i < len; i++) 
        {
        	var reward = effects[i];
        	
            if (!common) 
            {
                common = EffectsView.copyCommon(reward.rewardParams);
            } 
            else 
            {
                EffectsView.filterCommon(common, reward.rewardParams);
            }
            
            if (Arrays.contains(EffectsView.REWARDS_WITH_CUSTOM_DURATION, reward.rewardType)) 
            {
                common.remove("duration");
            }
            var itemDelay = reward.rewardParams.getValueOrNull("delay");
            if (itemDelay) 
            {
                delay = Math.max(delay, itemDelay);
            }
        }
        if (delay > 0) 
        {
            common.put("delay", delay);
        }
    }

	for (var i = 0, len = effects.length; i < len; i++) 
    {
         if (effects[i]) 
         {
             EffectsView.descriptiveView(box, effects[i], showOn, targetDescription, nestedInfection, common, holderIsHero, prefix, showDelay);
         }
    }

    if (common) 
    {
		EffectsView.addCommon(common, box, holderIsHero, showOn, showDelay);
    }
    
    return box;
}

EffectsView.filterCommon = function(common, params)
{
    for (var i=0, k=common.keys, len=k.length; i < len; i++) 
    {
    	var key = k[i];
        
        var value1 = "";
        var v1 = common.getValueOrNull(key);
        if (v1) value1 += v1;
        
        var value2 = "";
        var v2 = params.getValueOrNull(key);
        if (v2) value2 += v2;

        if (value1 != value2) 
        {
            common.remove(key);
        }
    }
}

// returns [[function,boolean]...]:
EffectsView.createCastActivationView = function(onRewardDataChoosen, box, effects, src, target)
{
    var results = [];
    for (var i = 0, len = effects.length; i < len; i++) 
    {
        var effect = effects[i];
        results.push(EffectsView.activationView(onRewardDataChoosen, box, effect, src, target));
    }
    return results;
}

// returns [[function,boolean]...]:
EffectsView.createQuestActivationView = function(onRewardDataChoosen, box, effects, src)
{
	var results = [];
    for (var i = 0, len = effects.length; i < len; i++) 
    {
        var effect = effects[i];
        if (effect) 
        {
            EffectsView.descriptiveView(box, effect, true, false, false, null, false, "", true);
        }
        results.push(EffectsView.activationView(onRewardDataChoosen, box, effect, src, null));
    }
    return results;
}

EffectsView.addLine = function(box, content, isInline)
{
	var d = isInline ? $("<span/>") : $("<div/>");
	d.append(content);
	$(box).append(d);
}

EffectsView.descriptiveView = function(box, reward, showOn, targetDescription, nestedInfection, common, holderIsHero, prefix, showDelay)
{
    var params = $.extend({}, reward.rewardParams);
    
    if (reward.rewardType == "COMPLETE_CURRENT_SCIENCE") 
    {
        var forbidden = reward.rewardParams.getValueOrNull("forbidden");
        var list = [];
        if (FConfig.CASTLES_ENABLED) 
        {
            list.push({science:Science.CASTLES, level:null});
        }
        
        for (var i = 0, len = forbidden.raw.length; i < len; i++) 
        {
        	var entry = forbidden.raw[i];
            var s = entry[0];
            var levels = entry[1];
            for (var l = 0; l < levels.length; l++) 
            {
                list.push({science:s, level:l});
            }
        }
        if (list.length == 0) 
        {
            EffectsView.addLine(box, I18.f('COMPLETE_CURRENT_SCIENCE'));
        } 
        else 
        {
            var toolTip = document.createElement('EV-forbidden');
            EffectsView.addLine(toolTip, I18.f('COMPLETE_CURRENT_SCIENCE_FORBIDDEN_LIST'), true);
            
            for (var i = 0, len = list.length; i < len; i++) 
            {
                var item = list[i];
                if (item.level) 
                {
                    $(toolTip).append(': ').append(I18.getMegaBox("SCIENCE_WITH_LEVEL", item));
                } 
                else 
                {
                    $(toolTip).append(': ').append(I18.getScience(item.science));
                }
            }
            
            EffectsView.addLine(box, I18.getMegaBox("COMPLETE_CURRENT_SCIENCE_FORBIDDEN", {list:toolTip}));
        }
    } 
    else if (reward.rewardType == "REWARD_SHOW_OUTER_ESTATES") 
    {
        var type = params.getValue("type")
		if (type) type = type.resolve();
        
        var count = params.getValue("count");
        if (params.getValue("template") == "SERVICE" && type.name == EstateType.GROTTO.name && count == 1) 
        {
            EffectsView.addLine(box, I18.f('REWARD_SHOW_OUTER_ESTATES_GROTTO'));
        } 
        else 
        {
            EffectsView.addLine(box, I18.f('REWARD_SHOW_OUTER_ESTATES'));
            
            var r = [params.getValue("resource")];
            if (r[0]) r[0] = r[0].resolve();
            
            var level = params.getValue("level");
            var name = I18.getOuterEstateName(type, r);
            
            EffectsView.addLine(box, I18.f('TYPE_SEMICOLON_X', name));
            EffectsView.addLine(box, I18.f('COUNT_SEMICOLON_X', count));
            
            if (level != -1 && type.name != EstateType.MINE.name) 
            {
                EffectsView.addLine(box, I18.f('LEVEL_SEMICOLON_X', level));
            }
        }
    } 
    else if (reward.rewardType) 
    {
        if (reward.rewardType == "REWARD_MONSTER_ATTACK" && FConfig.IS_SURVIVAL) 
        {
            reward.rewardType = "REWARD_MONSTER_ATTACK_SURVIVAL";
        }
        if (common) 
        {
            for (var i = 0, k = common.keys, len = k.length; i < len; i++)
            {
                params.put(k[i], null);
            }
        }
        
        var b = document.createElement('EV-reward');
        if ("BUFF_INFECTION" == reward.rewardType) 
        {
            var spellLevel = params.getValue("spellLevel");
            var spellName = params.getValue("spellName");
            var decl = FConfig.getSpell(spellName, spellLevel);
            if (decl.hero.dtoActions.length > 0) 
            {
                EffectsView.addLine(b, I18.getMegaBox("BUFF_INFECTION_HERO" + (nestedInfection ? "" : "_HEAD"), params));
            } 
            else 
            {
			   EffectsView.addLine(b, I18.getMegaBox("BUFF_INFECTION_ESTATE" + (nestedInfection ? "" : "_HEAD"), params));
            }
        } 
        else if ("BECOME_MENTOR" == reward.rewardType) 
        {
            EffectsView.addLine(b, I18.f('BECOME_MEMBER_REWARD'));
        } 
        else if ("ENABLE_BROTHERHOOD" == reward.rewardType) 
        {
            EffectsView.addLine(b, I18.f('ENABLE_BROTHERHOOD_REWARD'));
        } 
        else if ("GIVE_INVITE" == reward.rewardType) 
        {
            EffectsView.addLine(b, I18.f('GIVE_INVITE_REWARD', I18.getServerTypeName(params.getValue("type"))));
        } 
        else if (EffectsView.REWARD_GIFT == reward.rewardType) 
        {
            EffectsView.addLine(b, I18.getMegaString(prefix + reward.rewardType, params));
            EffectsView.addLine(b, '<img src="'+STATIC_INTERFACE_URL+Assets.getGiftImage(params.getValue("giftName"))+'" />');
        } 
        else 
        {
            var btype = params.getValueOrNull("btype");
            var utype = params.getValueOrNull("unitType");
            var science = params.getValueOrNull("science");
            var rewardType = prefix + reward.rewardType;
            if (!btype && !utype && I18.getStringOrNull(rewardType + "_ALL")) 
            {
                EffectsView.addLine(b, I18.getMegaBox(rewardType + "_ALL", params));
            } 
            else if (btype && I18.getStringOrNull(rewardType + "_" + btype.name)) 
            {
                EffectsView.addLine(b, I18.getMegaBox(rewardType + "_" + btype.name, params));
            } 
            else if (science && I18.getStringOrNull(rewardType + "_" + science.name)) 
            {
                EffectsView.addLine(b, I18.getMegaBox(rewardType + "_" + science.name, params));
            } 
            else 
            {
                EffectsView.addLine(b, I18.getMegaBox(rewardType, params));
            }
        }
        
		if (showOn && params.containsKey("duration") && !Arrays.contains(EffectsView.REWARDS_WITH_CUSTOM_DURATION, reward.rewardType)) 
        {
            EffectsView.addLine(b, I18.getMegaString("ON_DURATION", params));
        }
        
        EffectsView.addCommonLineContinue(b, params);
        $(box).append(b);
        EffectsView.addCommonLine(box, params, targetDescription, holderIsHero, showDelay);
        if ("BUFF_INFECTION" == reward.rewardType && !nestedInfection)
        {
            $(box).append(EffectsView.infectionDesc(params));
        }
    }
}

// returns [function,boolean]: function to get choosen data, and whether data getter is outer dialog
EffectsView.activationView = function(onRewardDataChosen, box, reward, src, target)
{
    var dataFunction = EffectsView.nullReturningFunction;
    if (!reward) 
    {
        return [dataFunction, false];
    }
    var isOuterDialog = false;
    if (reward.rewardType == "REWARD_MONSTER_ATTACK" || reward.rewardType == "REWARD_MONSTER_ATTACK_SURVIVAL") 
    {
        var ruinChooser = CoordsChooser.create(I18.f('RUIN_COORDS'));
        $(box).append(ruinChooser.DOM);
        
        $(box).append("<br/>");
        
        var victimChooser = CoordsChooser.create(I18.f('VICTIM_COORDS'), true, !target ? null : target.location);
        $(box).append(victimChooser.DOM);
        
        $(box).append("<br/>");
        
        var textForVictim = COM.create("TextInput");
        textForVictim.DOM.style.width = "400px";
        
        $(box).append("<br/>");
        
        $(box).append(I18.f('TEXT_FOR_VICTIM')).append("<br/>").append(textForVictim.DOM);
        
        $(box).append("<br/>");
        $(box).append("<br/>");
        
        dataFunction = function()
        {
            return [ruinChooser.getCoordsXYZ(), victimChooser.getCoordsXYZ(), textForVictim.value];
        }
    }
    if (reward.rewardType == "REWARD_EXPLORE_KINGDOM") 
    {
        var chooser = CoordsChooser.create(I18.f('ENTER_COORDS'), false);
        $(box).append(chooser.DOM);
        
        dataFunction = function()
        {
            return chooser.getCoordsXY();
        }
    }
    if (reward.rewardType == "REWARD_ARTIFACT") 
    {
        var im = new Image();
        im.src = STATIC_INTERFACE_URL + Assets.getAdvisor(FUser.CURRENT_USER.race);
        $(box).append(im).append(I18.getMegaString("TEMP_ARTIFACT", reward.rewardParams));
        dataFunction = EffectsView.nullReturningFunction;
    }
    if (reward.rewardType == "REWARD_SELECT_ARTIFACT" || reward.rewardType == "REWARD_SELECT_ARTIFACT_PERFECT") 
    {
        var gdd = COM.create('ComboBox');
        var decls = [];
        var localizedNames = [];
        var perfect = reward.rewardParams.getValue("perfect");
        
        for (var i = 0, lst = reward.rewardParams.getValue("artifacts"), len = lst.length; i < len; i++) 
        {
            var decl = lst[i]
            decls.push(decl);
            localizedNames.push(Texts.artifactName(decl));
        }
        
        gdd.dataProvider = localizedNames;
        gdd.selectedIndex = 0;
        
        var pic = ArtifactPic.create(new FArtifact(decls[gdd.selectedIndex], perfect ? 1 : 0), []);
        $(gdd.DOM).on('change', function(e) 
        {
            pic.update(new FArtifact(decls[gdd.selectedIndex], perfect ? 1 : 0), []);
        });
        
        gdd.DOM.style.maxWidth = "400px";

        $(box).append(I18.f('SELECT_ARTIFACT')).append("<br/>").append(gdd.DOM).append("<br/>").append(pic.DOM);
        dataFunction = function() 
        {
            return decls[gdd.selectedIndex].name;
        };
    }
    
    if (reward.rewardType == "BUFF_" + BuffType.AUTO_PRODUCE_MILITARY.name || reward.rewardType == "BUFF_" + BuffType.AUTO_PRODUCE_SPECIAL.name) 
    {
        var check = COM.create('ComboBox');
        check.dataProvider = [I18.f('TURN_ON'), I18.f('TURN_OFF'), I18.f('DONT_CHANGE')];
        
        check.setSelectedIndex(0);            
        
        $(box).append(I18.f('START_AUTOPRODUCE_IN_ALL_BUILDINGS'))
			.append("<br/>")
        	.append(check.DOM)
			.append("<br/>")
        	.append(I18.f('START_AUTOPRODUCE_ADDITIONAL_INFO'))
        ;
		if (FUser.CURRENT_USER.hasBuff(BuffType[reward.rewardType.substr(5)])) 
        {
            $(box).append(I18.f('ALREADY_HAVE_BUFF'))
            	.append(I18.getMegaBox(reward.rewardType, reward.rewardParams))
            	.append(UI.styledLabel(I18.f('BUFF_COMFIRMATION'), Style.PROBLEM_INFO))
            ;
        }
        dataFunction = function()
        {
            return check.selectedIndex;
        }
    }
    

	// Свиток TELEPORT_RESURSOV_5
    if (reward.rewardType == "REWARD_TELEPORT_RESOURCES") 
    {
        var rc = TeleportResourcesView.create(src, reward.rewardParams.getValueOrNull(0));
        $(box).append(rc.DOM);
        dataFunction = $.proxy(rc.getSelected, rc);
    }
    
    // Свиток SMENA_SPECIALIZACII_5
    if (reward.rewardType == "REWARD_CHANGE_SPECIALIZATION") 
    {
        var sv = ChooseSpecializationView.create(FUser.CURRENT_USER.science.getResearchedSpecial());
        $(box).append(sv.DOM);
        dataFunction = $.proxy(sv.getSelected, sv);
    }
    
    // Свиток TUMANNYI_FANTOM_5
    if (reward.rewardType == "REWARD_SEND_PHANTOM_ATTACK") 
    {
        var d = SendPhantomAttackView.create(target);
        $(box).append(d.DOM);
        dataFunction = $.proxy(d.getGoal, d);
    }

    // Свиток DEMOBILIZACIYA_5
    if (reward.rewardType == "REWARD_TRANSFORM_ARMY_TO_RESOURCE") 
    {
        var tr = TransformArmyToResourceView.create(src, reward.rewardParams.getValueOrNull("percent"));
        $(box).append(tr.DOM);
        dataFunction = $.proxy(tr.getQuery, tr);
    }
	
	// Свиток PLANARNYI_PEREHOD_5
    if (reward.rewardType == "REWARD_SEND_CONSTANT_DURATION_MOVE_ARMY") 
    {
        var md = MissionDialogParent.create("ConstantDurationMoveArmyDialog");
        md.child.setConstantDuration(reward.rewardParams.getValueOrNull("duration"));
        new PrepareMissionTicker(md, target.field).start(src.id);
        
        dataFunction = function()
        {
            return md.child.missionOrder.prepareForRequest();
        };

        isOuterDialog = true;

        md.onResult = function(mo) 
        {
            onRewardDataChosen();
            md.close();
        };
    }
    return [dataFunction, isOuterDialog];
}

EffectsView.nullReturningFunction = function()
{
    return null;
}

EffectsView.findParams = function(effects, rewardType)
{
    for (var i = 0, len = effects.length; i < len; i++) 
    {
        if (effects[i].rewardType == rewardType) 
        {
            return effects[i].rewardParams;
        }
    }
    return null;
}

EffectsView.createPerfectBuildingEffectView = function(list, race)
{
    // CastEffectType, Array[EffectEntry]
    var byEffectTypeMap = FMap.groupBy(list, function (entry)
    {
        return entry.effect.type;
    });

    var group = document.createElement('EV-group');// :VGroup = new VGroup();
    for (var i=0, k=byEffectTypeMap.keys, len=k.length; i < len; i++) 
    {
    	var type = k[i];
        var castEffects = byEffectTypeMap.getValue(type);
        switch (type.name)
        {
            case CastEffectType.OBTAINED_RESOURCES.name:
                $(group).append(EffectsView.createObtainResourcesEffectView(castEffects, race));
                break;
                
            case CastEffectType.OBTAINED_ARTIFACT.name:
                $(group).append(EffectsView.createObtainArtifactEffectView(Arrays.map(castEffects, function (e) 
                {
                	return e.effect.params[0].declaration;
                }), I18.f('ARTIFACTS_DELIVERED')));
                break;
                
            case CastEffectType.MISSED_ARTIFACT.name:
                $(group).append(EffectsView.createObtainArtifactEffectView(Arrays.map(castEffects, function (e)
                {
                    return e.effect.params[0];
                
                }), I18.f('ARTIFACTS_NOT_DELIVERED')));
                break;
                
            case CastEffectType.OBTAINED_ARMY.name:
                $(group).append(EffectsView.createObtainArmyView(castEffects, race));
                break;
                
            default :
                console.error("Got unsupported cast effect type: " + type.name);
        }
    }
    return group;
}

EffectsView.createObtainArmyView = function(castEffects, race)
{
    var byEstateMap = FMap.groupBy(castEffects, function (entry)
    {
        return I18.formatEstateName(entry.estateName, entry.estateLocation);
    });

    var group = document.createElement('EV-obtain-army');// :VGroup = new VGroup();
    for (var i=0, k=byEstateMap.keys, len=k.length; i < len; i++) 
    {
    	var estateLabel = k[i];
    	var army = new Army();
       	var lst = byEstateMap.getValue(estateLabel);
        
        $(lst).each(function(n, entry){
        	army.add(entry.effect.params[0]);
        });
		
		$(UnitType.MILITARY).each(function(n, type)
        {
        	if (army.getValue(type) > 0) 
            {
                var unitView = document.createElement('div');
                $(unitView).append('<img src="'+STATIC_INTERFACE_URL+Assets.getUnitTypeIcon(type)+'" />');
                $(unitView).append('<span class="funds">+' + army.getValue(type) + '</span>');
                $(unitView).append(I18.f('BUILDING_EFFECT_TO_ESTATE',"",estateLabel));
                $(group).append(unitView);
             }
        });
    }
    
    $(group).append('<p>'+I18.f('ARMY_ESTATE_DELIVERED'));
    return group;
}

EffectsView.createObtainArtifactEffectView = function(artifactsDecls, footerText)
{
    var group = document.createElement('EV-obtain-artifact-effect');// :VGroup = new VGroup();
    
    $(artifactsDecls).each(function(n, decl){
        $(group).append(EffectsView.artifactLvlLabelTip(decl));
    });
    
    $(group).append(footerText);
    
    return group;
}

EffectsView.createObtainResourcesEffectView = function(castEffects, race)
{
    var byEstateMap = FMap.groupBy(castEffects, function (entry)
    {
        return I18.formatEstateName(entry.estateName, entry.estateLocation);
    });

    var group = document.createElement('EV-obtain-resources-effect');// :VGroup = new VGroup();
    
    for (var i=0, k=byEstateMap.keys, len=k.length; i < len; i++) 
    {
    	var estateLabel = k[i];
        var funds = new Funds();
        
        $(byEstateMap.getValue(estateLabel)).each(function(n, entry){
            funds.add(entry.effect.params[0]);
        });

        //$(group).append(I18.f('BUILDING_EFFECT_TO_ESTATE')).append(FundsBox.create(funds, race)).append(estateLabel);
        $(group).append($("<div/>").append(I18.box('BUILDING_EFFECT_TO_ESTATE', FundsBox.create(funds, race).DOM, estateLabel)));
    }
    
    $(group).append(I18.f('RESOURCES_ESTATE_DELIVERED'));
    return group;
}

EffectsView.artifactLvlLabelTip = function(artDecl)
{
    var label = document.createElement('EV-artifact-level-label');
    $(label).append(Texts.artifactNameLvl(artDecl));
    $(label).append(ArtifactPic.create(new FArtifact(artDecl), []).DOM);
    return label;
}
