function SendPhantomAttackView()
{
	this.target = null; // CastTarget
}

SendPhantomAttackView.prototype.__construct = function()
{
	var items = COM(this.goalGroup).items;
	
	this.lootRadio = items[0];
	this.slavesRadio = items[1];
	this.destroyRadio = items[2];
	this.captureRadio = items[3];
}

SendPhantomAttackView.prototype.target = null; // CastTarget

SendPhantomAttackView.create = function(castTarget)
{
    var res = COM.create('SendPhantomAttackView');
	res.update(castTarget);
    return res;
}

SendPhantomAttackView.prototype.update = function(castTarget)
{
    this.target = castTarget;
    
    this.slavesRadio.disabled = this.target.estateType.name == EstateType.RUIN.name;
    this.captureRadio.disabled = [EstateType.PIT.name, EstateType.MINE.name, EstateType.LAKE.name, EstateType.GRAIL.name].indexOf(this.target.estateType.name) < 0;
    
    var destroyLabel = "";
    var destroyValue =  MissionAttackGoal.DESTROY_BUILDINGS.name;
    switch (this.target.estateType.name) 
    {
        case EstateType.PIT.name:
        	destroyLabel = I18.f('MISSION_GOAL_DESTROYBUILDINGS_IN_PIT');
        	break;
        	
        case EstateType.LAKE.name:
        	destroyLabel = I18.f('MISSION_GOAL_DESTROYBUILDINGS_IN_LAKE');
        	break;
		
		case EstateType.GRAIL.name:
			destroyLabel = I18.f("MISSION_GOAL_DESTROYBUILDINGS_IN_GRAIL");
			break;
		
        case EstateType.CITY.name:
        	destroyLabel = I18.f('MISSION_GOAL_DESTROYBUILDINGS_IN_SECTORS');
        	break;

        case EstateType.CATAPULT.name:
        	destroyLabel = I18.f('MISSION_GOAL_DESTROYCATAPULT');
        	destroyValue = MissionAttackGoal.DESTROY_CATAPULT.name;
        	break;
    } 
    if (UI.show(destroyLabel, [this.destroyRadio]))
    {
    	this.destroyRadio.label = destroyLabel;
    	this.destroyRadio.value = destroyValue;
    }
    
    if (UI.show(this.target.estateType.name != EstateType.CATAPULT.name, [this.lootRadio, this.slavesRadio, this.captureRadio]))
    {
        COM(this.goalGroup).selectedIndex = 0;
    }
    else
    {
        COM(this.goalGroup).selectedIndex = 2;
    }
}

SendPhantomAttackView.prototype.getGoal = function()
{
    return MissionAttackGoal[COM(this.goalGroup).value];
}
