function TransformArmyToResourceView()
{
	this.estate = null; // FEstate
	this.army = null; // FArmy
	this.selectedArmy = new Army(); // FArmy
	this.percent = 0; // Number
}

TransformArmyToResourceView.prototype.__construct = function()
{
	for (var i = 0; i < Resource.WAREHOUSE_RESOURCES.length; i++)
	{
		COM(this.resource).addOption(
			Resource.WAREHOUSE_RESOURCES[i].name,
			I18.getResourceName(Resource.WAREHOUSE_RESOURCES[i])
		);
	}
	COM(this.resource).selectedIndex = 0;
	$(this.resource).on('change', $.proxy(this.selectionChanged, this));
}

TransformArmyToResourceView.prototype.estate = null; // FEstate
TransformArmyToResourceView.prototype.army = null; // FArmy
TransformArmyToResourceView.prototype.selectedArmy = null; // FArmy
TransformArmyToResourceView.prototype.percent = 0; // Number

TransformArmyToResourceView.create = function(estate, percent)
{
    var res = COM.create('TransformArmyToResourceView');
	
	res.update(estate, percent);
	
    return res;
}

TransformArmyToResourceView.prototype.update = function(estate, percent, army)
{
    this.estate = estate;
    this.percent = percent*1;
	
	this.army = army || this.estate.garrison.copy();
	
	COM(this.units).showHero = false;
	COM(this.units).setUnits(this.estate.race, this.estate.owner.science.unitLevels, this.estate.monsterRace());
	COM(this.units).setCount(this.selectedArmy);
	
	var lst = COM(this.units).getUnitsViews();
	for (var i = 0; i < lst.length; i++)
	{
		$(lst[i].DOM).off(CLICK_EVENT).on(CLICK_EVENT, $.proxy(function(e){
			
			var mut = COM(e.currentTarget).mutype;
			if (!this.army.getValue(mut)) return false;
			
			var to = this.selectedArmy.getValue(mut), from = this.army.getValue(mut) - to; 
			var d = SliderDialog.create(mut, from, to, $.proxy(function(mut, val){
				
				this.selectedArmy.setValue(mut, val);
				COM(this.units).setCount(this.selectedArmy);
				this.selectionChanged();
				
			}, this),
			FUser.CURRENT_USER.settings.armyChooserStepIndex,
			[1, 10, 100, 1000],
			$.proxy(this.onChangeMultiplier, this));
			
		}, this));
	}

    this.selectionChanged();
}

TransformArmyToResourceView.prototype.onChangeMultiplier = function(newIndex)
{
	Events.onArmyChooserStepIndexChanged.fire(newIndex);
}

TransformArmyToResourceView.prototype.selectionChanged = function()
{
    var res = Resource[COM(this.resource).value];
    var resPrice = res.name == Resource.GOLD.name ? 1 : FConfig.SUPPLY_PRICE_LIMITS.getValue(res.name).average;
    var funds = this.selectedArmy.toFunds(this.estate.race, this.estate.science.unitLevels);
    var costToTransform = NumberUtils.floor(this.percent * funds.toCost());
    var resCount = NumberUtils.floor(costToTransform / resPrice);
    
    COM(this.resourceCount).value = resCount*1;
    COM(this.resourceCount).source = STATIC_INTERFACE_URL + Assets.ICON_findBy(res);
}

TransformArmyToResourceView.prototype.getQuery = function()
{
    return [
    	this.selectedArmy.prepareForRequest(), 
    	Resource[COM(this.resource).value]
    ];
}
