function FundsBox()
{
	callParentConstructor(FundsBox, this);
	
	this.doHighlightIfEquals = false;
	this._doShadow = false;
	this.shadowColor = '#000000';
	this.highlightNegative = true;
	this._capacity = null;
	
	this.__defineGetter__('capacity', function()
	{
		return this._capacity;
	});	
	this.__defineSetter__('capacity', function(val)
	{
		this._capacity = val;
		this.refreshHighlight();
	});	
	this.__defineGetter__('doShadow', function()
	{
		return this._doShadow;
	});	
	this.__defineSetter__('doShadow', function(val)
	{
		var update = this._doShadow ^ val;
		this._doShadow = val;
		if (update)
		{
			this.updateShadow();
		}
	});
}

extendClass(FundsBox.prototype, BaseResourceBox.prototype);

FundsBox.prototype.doHighlightIfEquals = false;
FundsBox.prototype.doShadow = false;
FundsBox.prototype.shadowColor = 'rgba(0,0,0,0.5)';
FundsBox.prototype.highlightNegative = true;

FundsBox.prototype._capacity = null;

FundsBox.createAskMentorFunds = function()
{
    var funds = COM.create('FundsBox');
	funds.update(FConfig.APPRENTICE_ASK_RESOURCES, FUser.CURRENT_USER.race);
    return funds;
}

FundsBox.create = function(funds, race)
{
    var box = COM.create('FundsBox');
    box.update(funds, race);
    return box;
}

FundsBox.prototype.updateAll = function(f, capacity, race)
{
    this._capacity = capacity;
    this.update(f, race);
}

FundsBox.prototype.refreshHighlight = function()
{
    for (var i = 0; i < Resource.FUNDS_RESOURCES.length; i++)
    {
    	var r = Resource.FUNDS_RESOURCES[i];
        var needHighlight = false;
        if (this._capacity) 
        {
            if (this.doHighlightIfEquals) 
            {
                needHighlight = Math.floor(this._funds.getValue(r)) >= Math.floor(this._capacity.getValue(r));
            } 
            else 
            {
                needHighlight = Math.floor(this._funds.getValue(r)) > Math.floor(this._capacity.getValue(r));
            }
        } 
        else if (this.highlightNegative && this._funds.getValue(r) < 0) 
        {
            needHighlight = true;
        }
        needHighlight = needHighlight && this._neverHighlight.indexOf(r) == -1;
        
        try
        {
        	COM.get(this.getIcon(r)).styleFunds(needHighlight);
        }
        catch(e){};
    }
}

/*
FundsBox.prototype.update = function(f, race)
{
	superMethod(this, 'update')(f, race);
}
*/

FundsBox.prototype.updateShadow = function()
{
	this.find('iconandvalue').toggleClass('shadow', this.doShadow);
}

FundsBox.prototype.setDefaultFundsClass = function(val)
{
	var icons = $('iconandvalue', this.DOM);
	for(var i=0; i<icons.length; i++)
	{
		var c = COM.get(icons[i]);
		c.defaultFundsClass = val;
	}
}

FundsBox.prototype.setTextClass = function(name)
{
	var icons = $('iconandvalue', this.DOM);
	for(var i=0; i<icons.length; i++)
	{
		var c = COM.get(icons[i]);
		c.setTextClass(name);
	}
}

FundsBox.prototype.showIconBacks = function(val)
{
	if(val) $("iconandvalue", this.DOM).addClass("darkBack");
	else $("iconandvalue", this.DOM).removeClass("darkBack");
}