function Slider()
{
	this.__defineGetter__('value', function()
	{ 
		return COM(this.slider).value; 
	});
	this.__defineSetter__('value', function(v)
	{ 
		COM(this.slider).value = v;
	});
	
	this.__defineGetter__('min', function()
	{
		return COM(this.slider).min;
	});
	this.__defineSetter__('min', function(v)
	{
		COM(this.slider).min = v; 
	});
	
	this.__defineGetter__('max', function()
	{
		return COM(this.slider).max; 
	});
	this.__defineSetter__('max', function(v)
	{
		COM(this.slider).max = v;
	});
	
	this.__defineGetter__('limit', function()
	{
		return COM(this.slider).limit; 
	});
	this.__defineSetter__('limit', function(v)
	{
		COM(this.slider).limit = v;
	});
	
	this.__defineGetter__('enabled', function()
	{
		return COM(this.slider).enabled; 
	});
	this.__defineSetter__('enabled', function(v)
	{
		COM(this.slider).enabled = v;
	});
	
	this.__defineGetter__('icon', function()
	{
		return COM(this.tip).icon;
	});
	this.__defineSetter__('icon', function(v)
	{
		COM(this.tip).icon = v;
	});
	
	this.__defineGetter__('caption', function()
	{
		return COM(this.tip).caption;
	});
	this.__defineSetter__('caption', function(v)
	{
		COM(this.tip).caption = v;
	});
}

Slider.prototype.__construct = function()
{
	var tip = COM(this.tip), slider = COM(this.slider);
	
	$(this.slider).on('start', $.proxy(this.onStart, this));
	$(this.slider).on('finish', $.proxy(this.onFinish, this));
	$(this.slider).on('change', $.proxy(this.onChange, this));
	
	tip.hide(0, 0);
	
	this.updateUI();
	slider.updateUI();
	tip.updateUI();
}

Slider.prototype.__destruct = function()
{
}

Slider.prototype.onStart = function(e)
{
	this.updateUI();
	COM(this.tip).show();
	$(this.DOM).trigger($.Event('start'));
}

Slider.prototype.onFinish = function(e)
{
	COM(this.tip).hide();
	$(this.DOM).trigger($.Event('finish'));
}

Slider.prototype.onChange = function(e)
{
	this.updateUI();
	$(this.DOM).trigger($.Event('change'));
}

Slider.prototype.update = function(peopleIncrease, goldCharge, race)
{
	COM(this.tip).update(peopleIncrease, goldCharge, race);
}

Slider.prototype.updateUI = function()
{
	var tip = COM(this.tip), slider = COM(this.slider);
	
	tip.value = Math.round(slider.value);
	tip.max = Math.round(slider.max);
	
	var t = $(this.tip), p = $(slider.picker);
	var offset = p.position();//p.offset();
	t.css({
		'left': offset.left - p.outerWidth(),
		'top': 0 - t.outerHeight()
	});
	
	tip.updateUI();
}

