function SliderTip()
{
	this.__defineGetter__('showCaption', this.getShowCaption);
	this.__defineSetter__('showCaption', this.setShowCaption);
	this.__defineGetter__('icon', this.getIcon);
	this.__defineSetter__('icon', this.setIcon);
	this.__defineGetter__('caption', this.getCaption);
	this.__defineSetter__('caption', this.setCaption);
	
	this.__defineGetter__('showValue', this.getShowValue);
	this.__defineSetter__('showValue', this.setShowValue);
	this.__defineGetter__('showMax', this.getShowMax);
	this.__defineSetter__('showMax', this.setShowMax);
	this.__defineGetter__('value', this.getValue);
	this.__defineSetter__('value', this.setValue);
	this.__defineGetter__('max', this.getMax);
	this.__defineSetter__('max', this.setMax);
	
	this.showSpeed = 200;
	this.hideSpeed = 300;
	this.hideTimeout = 500;
	this.hideTO = null;
}

SliderTip.prototype.showSpeed = 200;
SliderTip.prototype.hideSpeed = 300;
SliderTip.prototype.hideTimeout = 500;
SliderTip.prototype.hideTO = null;

SliderTip.prototype.__construct = function()
{
	$(this.DOM).addClass('no-select');
	
	this.showCaption = this.DOM.hasAttribute('showCaption') ? this.DOM.getAttribute('showCaption') != 'false' : true;
	this.showValue = this.DOM.hasAttribute('showValue') ? this.DOM.getAttribute('showValue') != 'false' : true;
	this.showMax = this.DOM.hasAttribute('showMax') ? this.DOM.getAttribute('showMax') != 'false' : true;
	
	this.icon = this.DOM.hasAttribute('icon') ? this.DOM.getAttribute('icon') : null;
	this.caption = this.DOM.hasAttribute('caption') ? this.DOM.getAttribute('caption') : '';
	this.value = this.DOM.hasAttribute('value') ? this.DOM.getAttribute('value') : 0;
	this.max = this.DOM.hasAttribute('max') ? this.DOM.getAttribute('max') : 0;
}

SliderTip.prototype.updateUI = function()
{
	var dom = $(this.DOM);
	var w = dom.innerWidth();
	var h = dom.innerHeight();
	
	// arrow, top left/rigth/center, bottom left/rigth/center, middle left/rigth/center
	var size = [
		'22px 13px',
		'auto', 'auto', Math.max(0, w - 205) + 'px 50px',
		'auto', 'auto', Math.max(0, w - 65) + 'px 32px',
		'33px ' + Math.max(0, h - 81) + 'px', 
		'33px ' + Math.max(0, h - 81) + 'px', 
		Math.max(0, w - 64) + 'px ' + Math.max(0, h - 79) + 'px'
	]
	var pos = [Math.max(0, (w - 22)/2) + 'px ' + Math.max(0, h - 20) + 'px', '0% 0%', '100% 0%', '102px 0%', '0% 100%', '100% 100%', '33px 100%', '0% 50px', '100% 50px', '32px 49px'];
	
	dom.css({'background-size': size.join(','), 'background-position': pos.join(',')});
}

SliderTip.prototype.show = function(speed)
{
	if (typeof speed == 'undefined') speed = this.showSpeed;
	this.hideTO = clearTimeout(this.hideTO);
	$(this.DOM)
		.clearQueue()
		.css({'display': '', opacity: 1})
	;
}

SliderTip.prototype.hide = function(speed, timeout)
{
	if (typeof speed == 'undefined') speed = this.hideSpeed;
	if (typeof timeout == 'undefined') timeout = this.hideTimeout;
	
	clearTimeout(this.hideTO);
	this.hideTO = setTimeout($.proxy(function(){
		$(this.DOM)
			.clearQueue()
			//.css('display', 'none')
			.css({opacity: 0, display: 'none'})
		;
	}, this), timeout);
}

SliderTip.prototype.getShowMax = function() { return this.maxBox.style.display != 'none'; }
SliderTip.prototype.setShowMax = function(val) { return this.maxBox.style.display = val ? '' : 'none'; }

SliderTip.prototype.getShowValue = function() { return this.valueBox.style.display != 'none'; }
SliderTip.prototype.setShowValue = function(val) { return this.valueBox.style.display = val ? '' : 'none'; }

SliderTip.prototype.getShowCaption = function() { return this.captionBox.style.display != 'none'; }
SliderTip.prototype.setShowCaption = function(val) { return this.captionBox.style.display = val ? '' : 'none'; }

SliderTip.prototype.getCaption = function(){ return this.captionLabel.innerHTML; }
SliderTip.prototype.setCaption = function(val) { return this.captionLabel.innerHTML = val; }

SliderTip.prototype.getValue = function()
{ 
	var val = parseFloat(this.valueLabel.innerHTML);
	if (isNaN(val)) val = 0;
	return val; 
}
SliderTip.prototype.setValue = function(val) 
{ 
	val = parseFloat(val);
	if (isNaN(val)) val = 0;
	this.valueLabel.innerHTML = val; 
}

SliderTip.prototype.getMax = function()
{ 
	var val = parseFloat(this.maxLabel.innerHTML);
	if (isNaN(val)) val = 0;
	return val; 
}
SliderTip.prototype.setMax = function(val) 
{ 
	val = parseFloat(val);
	if (isNaN(val)) val = 0;
	this.maxLabel.innerHTML = val; 
}

SliderTip.prototype.getIcon = function() 
{ 
	return this.iconImage.style.display == 'none' ? null : this.iconImage.src; 
}

SliderTip.prototype.setIcon = function(val) 
{ 
	this.iconImage.style.display = val ? '' : 'none'; 
	if (val)
	{
		this.iconImage.src = val;
	}
}

SliderTip.prototype.update = function(peopleIncrease, goldCharge, race)
{
	COM(this.people).source = STATIC_URL + Assets.getFreePeopleIcon(race);
	COM(this.people).value = I18.f('PER_TIME', peopleIncrease);
	COM(this.gold).value = I18.f('PER_TIME', goldCharge);
}

