function TariffRenderer()
{
	this.tariff = null;
	
	this.onClick = null;
	
	this._data = null;
	
	this.__defineGetter__("data", this.getData);
	this.__defineSetter__("data", this.setData);
}

TariffRenderer.prototype.getData = function()
{
	return this._data;
}

TariffRenderer.prototype.setData = function(val)
{
	this._data = val;
	
	this.init(this._data.position, this._data.tariff);
}

TariffRenderer.prototype.init = function(position, t)
{
    this.tariff = t;
    this.tariffCaption.innerHTML = this.tariff.getDisplayName(position);
    UI.show(this.tariff.mdollars > 0, [this.pearls], $.proxy(function()
    {
        COM(this.pearls).value = FPortalConfig.toPearlStr(this.tariff.mdollars);
    }, this));
    UI.show(this.tariff.price > 0, [this.price], $.proxy(function()
    {
        this.price.innerHTML = TariffRenderer.formatPrice(this.tariff.price, this.tariff.currency);
    }, this));
    UI.show(this.tariff.price <= 0 && this.tariff.mdollars <= 0, [this.continueLabel]);
}

TariffRenderer.prototype.getTariff = function()
{
    return this.tariff;
}

TariffRenderer.formatPrice = function(price, currency)
{
    currency = currency.toUpperCase();
    if (currency == "FB")
    {
        //return FBApi.formatPrice(Number(price));
    }
    else
    {
        return I18.getStringOrNull("CURRENCY_" + currency, [price]) || I18.f("CURRENCY", price, currency);
    }
}