function TransferDialog()
{
	callParentConstructor(TransferDialog.prototype, this);
	
	this._balance = null;
	
	this.update = $.proxy(this.update, this);
	
	this.__defineGetter__("balance", this.getBalance);
	
	this.fromServerTabButton = null;
}

extendClass(TransferDialog.prototype, Dialog.prototype);

TransferDialog.prototype.__construct = function()
{
	COM(this.toServer).onResult = this.update;
	COM(this.fromServer).onResult = this.update;
	
	var cb = COM(this.tabs);
	cb.addItem(I18.f("TRANSFER_TO_SERVER"), 0, true);
	this.fromServerTabButton = cb.addItem(I18.f("TRANSFER_FROM_SERVER"), 1, false);
	
	cb.onChange = $.proxy(this.changeTab, this);
	this.changeTab();
}

TransferDialog.popup = function(parent, serverId, onClose)
{
    var d = COM.create("TransferDialog");
    PortalService.account.callMethod("getAvatarServerBalance", [serverId], $.proxy(function(balance)
    {
        d.popup(parent);
        d.onClose = onClose;
		d.update(balance);
    }, this));
    return d;
}

TransferDialog.prototype.update = function(balance)
{
    this._balance = balance;
    COM(this.toServer).update(balance);
    COM(this.fromServer).update(balance);
    
    var reason;
    if (balance.outputableAmount >= 0 && !balance.withdrawForbiddenInSession)
    {
        reason = "";
    }
    else if (this.balance.withdrawForbiddenInSession)
    {
        reason = I18.f("CANT_OUTPUT_PEARL_IN_SESSION");
    }
    else
    {
        reason = I18.f("CANT_OUTPUT_PEARL_FROM_FREE_ACCOUNT");
    }
    
    this.fromServerTabButton.reason = reason;
}

TransferDialog.prototype.getBalance = function()
{
    return this._balance;
}

TransferDialog.prototype.changeTab = function()
{
	var val = COM(this.tabs).value;
	
	this.toServer.style.display = val == 0 ? "" : "none";
	this.fromServer.style.display = val == 1 ? "" : "none";
}