function TransferFromServerTab()
{
	callParentConstructor(TransferFromServerTab.prototype, this);
}

extendClass(TransferFromServerTab.prototype, TransferTabParent.prototype);

TransferFromServerTab.prototype.updateValues = function()
{
    this.leftInitialPearls = Math.max(0, this.balance.outputableAmount);
    this.rightInitialPearls = FPortalConfig.toPearlInt(this.balance.portalBalance);
    this.minTransfer = this.balance.pearl - Math.max(0, this.balance.outputableAmount);
}

TransferFromServerTab.prototype.onApply = function()
{
    if (!Quarantine.contains(Quarantine.TRANSFER))
    {
        Quarantine.put(Quarantine.TRANSFER);
        PortalService.account.callMethod("transferFromServer", [this.balance.serverId, this.exchangePearls], $.proxy(this.handleResult, this), $.proxy(this.handleError, this));
    }
}

TransferFromServerTab.prototype.handleError = function(e)
{
    if (e.__className__ == "NotEnoughResourcesException")
    {
        Alert.create(I18.f("NOT_ENOUGH_PEARL"));
        return true;
    }
    
    return superMethod(TransferFromServerTab.prototype, "handleError", this)(e);
}