function TransferTabParent()
{
	this._balance = null;

    this.leftInitialPearls = null;
    this.rightInitialPearls = null;
    this.exchangePearls = null;

    this.minTransfer = null;

    this.onResult = null;
    this.onAddMoneyClick = null;
    
    this.__defineGetter__("balance", this.getBalance);
}

TransferTabParent.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.addMoneyButton, $.proxy(this.addMoney, this));
	
	this.addMoneyButton.style.display = "none";
	
	COM.bindExclusiveClick(this.okBtn, $.proxy(this.onApply, this));
	$(this.slider).on("change", $.proxy(this.onChangeSlider, this));
}

TransferTabParent.prototype.update = function(balance)
{
    this._balance = balance;

    this.serverLabel.innerHTML = balance.serverName;
    this.updateValues();
    this.exchangePearls = 0;
    COM(this.slider).value = 0;
    this.updateComponents();
}

TransferTabParent.prototype.getBalance = function()
{
    return this._balance;
}

TransferTabParent.prototype.updateComponents = function()
{
    COM(this.slider).max = this.leftInitialPearls;
    this.initialLeft.innerHTML = this.leftInitialPearls.toString();
    this.initialRight.innerHTML = this.rightInitialPearls.toString();
    this.exchangeLeft.innerHTML = '-' + this.exchangePearls.toString();
    this.exchangeRight.innerHTML = '+' + this.exchangePearls.toString();
    UI.show(this.minTransfer > 0, [this.minTransferGroup], $.proxy(function()
    {
        this.minTransferLabel.innerHTML = this.minTransfer.toString();
    }, this));
    
    COM(this.okBtn).reason = this.exchangePearls > 0 ? null : I18.f('AMOUNT_TOO_SMALL');
}

TransferTabParent.prototype.onChangeSlider = function()
{
    this.exchangePearls = COM(this.slider).value;
    this.updateComponents();
}

TransferTabParent.prototype.updateValues = function()
{
}

TransferTabParent.prototype.onApply = function()
{
}

TransferTabParent.prototype.handleResult = function(balance)
{
    this.update(balance);
    this.onResult(balance);
}

TransferTabParent.prototype.handleError = function(e)
{
    return false;
}

TransferTabParent.toStr = function(isInt, value)
{
    if (isInt)
    {
        return NumberUtils.floor(value).toString();
    }
    return value.toFixed(2);
}

TransferTabParent.prototype.addMoney = function()
{
    if(this.onAddMoneyClick) this.onAddMoneyClick();
}