function FSpell(name, level, artifactDeclaration, fromQuest, cooldownExpirationTick)
{
    this.name = name;
    this.artifactDeclaration = artifactDeclaration;
    this.fromQuest = fromQuest;
    this.level = level;
    this.cooldownExpirationTick = cooldownExpirationTick;

    if (this.name && this.level)
    {
	    this._levelDecl = FConfig.getSpell(this.name, this.level);
	    this._text = Texts.spellName(this.name) + " " + I18.f('LVL_X', this.level);
    }
    
    this.__defineGetter__('fromArtifact', this.getFromArtifact);
    this.__defineGetter__('config', this.getConfig);
    this.__defineGetter__('image', this.getImage);
    this.__defineGetter__('text', this.getText);
}

FSpell.prototype.name = '';
FSpell.prototype.artifactDeclaration = null; // ArtifactDeclaration
FSpell.prototype.fromQuest = false;
FSpell.prototype.level = 0;
FSpell.prototype.cooldownExpirationTick = 0;

FSpell.prototype._text = '';
FSpell.prototype._levelDecl = null; // SpellLevelDecl

FSpell.prototype.isInCooldown = function(time)
{
    return this.cooldownExpirationTick >= time;
}

FSpell.prototype.cooldownTicksLeft = function(time)
{
    return this.cooldownExpirationTick == 0 ? -1 : this.cooldownExpirationTick - time;
}

FSpell.prototype.getFromArtifact = function()
{
    return Boolean(this.artifactDeclaration);
}

FSpell.prototype.getConfig = function() 
{
    return this._levelDecl;
}

FSpell.prototype.getImage = function() 
{
    return Assets.getSpellImage(this.name);
}

FSpell.prototype.getText = function()
{
    return this._text;
}
