function NumberEffectTip()
{
	
}

NumberEffectTip.createTip = function(head, buffs, baseValue, bt, time)
{
    var tip = Tip.create();
    NumberEffectTip.fillSimple(tip, head, buffs, baseValue, bt, time);
    return tip;
}

NumberEffectTip.createSpeedTip = function(head, baseValue, speedupBuffs, speedupAncientMagic, constantDurationMoveArmy, forUser)
{
    var tip = Tip.create();
    if (head) 
    {
        tip.addLine('<b>'+I18.getString(head)+'</b>', (baseValue != 0 ? TimeView.create(baseValue).DOM : ''));
    }
	var buff;
    for (var i = 0; i < speedupBuffs.length; i++) 
    {
    	buff = speedupBuffs[i];
        tip.addLine(I18.getBuffCause(buff, "", forUser), I18.typedValue(buff.buffType.getType(), buff.value));
    }
    if (speedupAncientMagic != 0) 
    {
        tip.addLine('', '');
        // (bi) it's ok to reuse last buff's I18
        tip.addLine(I18.f("ANCIENT_MAGIC_NAME"), I18.percentReversedText(speedupAncientMagic));
    }
    if (constantDurationMoveArmy >= 0) 
    {
        tip.addLine(I18.getMegaString(I18.f('REWARD_SEND_CONSTANT_DURATION_MOVE_ARMY'), {duration:null}), TimeView.create(constantDurationMoveArmy));
    }
    return tip;
}

NumberEffectTip.createManaRegenTip = function(buffs, army, tick)
{
    var tip = document.createElement('div'), grid = document.createElement('table'), row, cell;
    
    row = grid.insertRow(-1);
    $(row.insertCell(-1)).html(I18.f('MANA_REGEN_BASE')).css({'font-weight': 'bold'});
    $(row.insertCell(-1)).html('&nbsp;');
    $(row.insertCell(-1)).html(FBuff.sumOfCauseBuffs(buffs, BuffType.HERO_MANA_REGEN_BASE, CastCause.PASSIVE, tick));
	    
    var tmpBuffs = FBuff.getBuffs(buffs, BuffType.HERO_MANA_REGEN_BASE, null, tick);
    for (var i = 0; i < tmpBuffs.length; i++) 
    {
    	var buff = tmpBuffs[i];
        if (buff.cast.cause.name == CastCause.PASSIVE.name) 
        {
            continue;
        }
	    row = grid.insertRow(-1);
	    $(row.insertCell(-1)).html(I18.getBuffCause(buff));
	    $(row.insertCell(-1)).html('&nbsp;');
	    $(row.insertCell(-1)).html(Strings.formatBonusConst(buff.value));
    }
    
    var tmpBuffs = FBuff.getBuffs(buffs, BuffType.HERO_MANA_REGEN_MAGE, null, tick);
    for (var i = 0; i < tmpBuffs.length; i++) 
    {
    	var buff = tmpBuffs[i];
    	var value = Math.floor(buff.value * army.mage);
    	
	    row = grid.insertRow(-1);
	    $(row.insertCell(-1)).html(I18.getBuffCause(buff));
	    $(row.insertCell(-1)).html(I18.f('MANA_REGEN_MAGE_COUNT', buff.value));
	    $(row.insertCell(-1)).html(Strings.formatBonusConst(value));
    }
    if (!grid.rows.length) return tip;
    
    grid.style.width = '100%';
    grid.style.boxSizing = 'border-box';
    tip.appendChild(grid);
    
    return tip;
}

NumberEffectTip.fillSimple = function(tip, head, buffs, baseValue, bt, time)
{
    tip.addLine('<b>'+I18.getString(head)+'</b>', (baseValue != 0 ? '<b>' + baseValue + '</b>' : ''));
    NumberEffectTip.fillBuffs(FBuff.getBuffs(buffs, bt, null, time), tip);
}

NumberEffectTip.fillBuffs = function(buffs, tip)
{
    for (var i = 0; i < buffs.length; i++) 
    {
    	var buff = buffs[i];
        var box = document.createElement('div');
        
        $(box).append(I18.typedValue(buff.buffType.getType(), buff.value));
        if (!Tick.isInfinity(buff.cast.tillTick)) 
        {
        	$(box).append(I18.getMegaString("TILL", [buff.cast.tillTick]));
        }
        tip.addLine(I18.getBuffCause(buff), box);
    }
}
