function SkillBranch()
{
	this.__defineGetter__('isDummy', function(){
		return (this.name === null);
	});
	
	this.name = null;
	this.levels = null;
}

SkillBranch.prototype.name = null;
SkillBranch.prototype.levels = null; // int[]

SkillBranch.createNewBranch = function(name, skillCount)
{
    if (typeof skillCount == 'undefined') skillCount = 7;
    
    var ret = new SkillBranch();
    ret.name = name;
    ret.levels = [];
    for (var i = 0; i < skillCount; i++) 
    {
        ret.levels.push(0);
    }
    
    return ret;
}

SkillBranch.prototype.getLevel = function(skillName)
{
    if (this.isDummy) 
    {
        return -1;
    }
    var skillDecls = FConfig.branches.getValueOrNull(this.name);
    if (!skillDecls) 
    {
        return -1;
    }
    var i = 0;
    for (var decl in skillDecls) 
    {
        if (skillDecls[decl].name == skillName) 
        {
            return this.levels[i];
        }
        i++;
    }
    return -1;
}

SkillBranch.prototype.getDistributedSkillPoints = function(defaultLevel)
{
    var points = 0;
    for (var i = 0, len = this.levels.length; i < len; i++) 
    {
        points += (this.levels[i] - defaultLevel);
    }
    return points;
}

SkillBranch.prototype.getUnsatisfiedDeps = function(depsMap)
{
    var unsatisfied = new FMap();
    for (var i = 0, len = depsMap.keys.length; i < len; i++) 
    {
    	var skillName = depsMap.keys[i];
        var requiredLevel = depsMap.getValue(skillName);
        var curLevel = this.getLevel(skillName);
        if (curLevel < requiredLevel) 
        {
            unsatisfied.put(skillName, requiredLevel);
        }
    }
    return unsatisfied;
}

SkillBranch.prototype.skillsCount = function()
{
	return this.levels ? this.levels.length : 0;
}

SkillBranch.DUMMY_BRANCH = SkillBranch.createNewBranch(null);
