function SpellLevelDecl()
{
	this.manaCost = 0;
	this.radius = 0;
	this.cooldown = 0;
	this.stopsAfterCombat = 0;
	this.target = null; // SpellTargetType
	this.estateType = null; // EstateType
	this.blocked = null; //ArrayCollection; // Blocked
	this.immediate = null; //ActionsDecl;
	this.owner = null; //ActionsDecl;
	this.estate = null; //ActionsDecl;
	this.hero = null; //ActionsDecl;
	
	// private static...
	var addAll = function(target, source)
	{
	    for (var i = 0, len = source.length; i < len; i++) 
	    {
	        target.push(source[i]);
	    }
	}
	
	this.__defineGetter__('allActions', function() 
	{
	    var res = this.withoutImmediate;
	    addAll(res, this.immediate.dtoActions);
	    return res;
	});
	
	this.__defineGetter__('withoutImmediate', function() 
	{
	    var res = [];
	    addAll(res, this.owner.dtoActions);
	    addAll(res, this.estate.dtoActions);
	    addAll(res, this.hero.dtoActions);
	    return res;
	});
	
	this.__defineGetter__('maxDuration', function() 
	{
	    var result = 0, withoutImmediate = this.withoutImmediate;
	    for (var i = 0, len = withoutImmediate.length; i < len; i++) 
	    {
	        var fqr = withoutImmediate[i]; // FQuestReward
	        if (fqr.rewardParams.containsKey("duration")) 
	        {
	            result = Math.max(result, fqr.rewardParams.getValue("duration"));
	        }
	    }
	    return result;
	});
}

SpellLevelDecl.prototype.manaCost = 0;
SpellLevelDecl.prototype.radius = 0;
SpellLevelDecl.prototype.cooldown = 0;
SpellLevelDecl.prototype.stopsAfterCombat = 0;
SpellLevelDecl.prototype.target = null; // SpellTargetType
SpellLevelDecl.prototype.estateType = null; // EstateType
SpellLevelDecl.prototype.blocked = null; //ArrayCollection; // Blocked
SpellLevelDecl.prototype.immediate = null; //ActionsDecl;
SpellLevelDecl.prototype.owner = null; //ActionsDecl;
SpellLevelDecl.prototype.estate = null; //ActionsDecl;
SpellLevelDecl.prototype.hero = null; //ActionsDecl;
