function CrystalType(v, ordinal)
{
	if (typeof v == 'object') return CrystalType[v.name];
	
	callParentConstructor(CrystalType.prototype, this, v);
	this.ordinal = ordinal;
	this.name = v;
	
	CrystalType.count++;
	CrystalType.valuesCache.push(this);
}

extendClass(CrystalType.prototype, Enum.prototype);

CrystalType.__isEnum__ = true;

CrystalType.count = 0;

CrystalType.valuesCache = [];

CrystalType.RED_CRYSTAL = new CrystalType("RED_CRYSTAL", 0);
CrystalType.GREEN_CRYSTAL = new CrystalType("GREEN_CRYSTAL", 1);
CrystalType.BLUE_CRYSTAL = new CrystalType("BLUE_CRYSTAL", 2);
CrystalType.YELLOW_CRYSTAL = new CrystalType("YELLOW_CRYSTAL", 3);
CrystalType.PINK_CRYSTAL = new CrystalType("PINK_CRYSTAL", 4);

CrystalType.ALL = [CrystalType.RED_CRYSTAL, CrystalType.GREEN_CRYSTAL, CrystalType.BLUE_CRYSTAL, CrystalType.YELLOW_CRYSTAL, CrystalType.PINK_CRYSTAL];

CrystalType.prototype.ordinal = 0;

CrystalType.prototype.getOrdinal = function()
{
    return this.ordinal;
}

CrystalType.getCrystals = function(e)
{
    var result = [];
    for (var i = 0; i < CrystalType.count; i++) 
    {
    	result.push(0);
    }
    
    for (var i = 0; i < e.heroes.length; i++) 
    {
    	var h = e.heroes[i];
    	if (h) 
    	{
    		result = CrystalType.fillCrystalCount(h.bag, result);
    	}
    }
    
    var fb = e.findBuilding(BType.ARTIFACT_STORE);
    if (fb && fb.storedArtifacts) 
    {
        result = CrystalType.fillCrystalCount(fb.storedArtifacts, result);
        if (e.owner.altar) 
        {
        	result = CrystalType.fillCrystalCount(e.owner.altar, result);
        }
    }
    return result;
}

CrystalType.fillCrystalCount = function(list, result)
{
    for (var i = 0; i < list.artifacts.length; i++) 
    {
    	var a = list.artifacts[i];
        if (a && a.declaration.type.name == ArtifactType.CRYSTAL.name) 
        {
            result[CrystalType[a.declaration.name].ordinal] += 1;
        }
    }
    return result;
}
