function ForgiveBetrayerDialog()
{
	callParentConstructor(ForgiveBetrayerDialog.prototype, this);
	
	this.requireUpdate = false;
}

extendClass(ForgiveBetrayerDialog.prototype, Dialog.prototype);

ForgiveBetrayerDialog.popup = function(parent, closeHandler)
{
    var dlg = COM.create("ForgiveBetrayerDialog");
    dlg.onClose = closeHandler;
    
    dlg.messageText.innerHTML = I18.f("FORGIVE_BETRAYER_TEXT");
	dlg.tick();
    
    dlg.popup();
    return dlg;
}

ForgiveBetrayerDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.yesButton, $.proxy(this.doAction, this));
	COM.bindExclusiveClick(this.noButton, $.proxy(this.close, this));
	
	this.setCaption(I18.f("ANCIENT_MAGIC_NAME"));
}

ForgiveBetrayerDialog.prototype.doAction = function()
{
    ServiceHelper.orderGlobalService(ServiceDecl.CLEAR_BETRAYER, 0, null, null, $.proxy(function()
    {
        this.requireUpdate = true;
        this.close();
    }, this), false);
}

ForgiveBetrayerDialog.prototype.tick = function()
{
    var price = ServiceHelper.getGloabalServiceDecl(ServiceDecl.CLEAR_BETRAYER, 0).price;
    COM(this.priceView).update(price);

    var user = FUser.CURRENT_USER;
    if (user.betrayerTill <= Tick.now())
    {
        this.problemText.innerHTML = I18.f("FORGIVE_BETRAYER_TEXT_NOT_BETRAYER");
        COM(this.yesButton).enabled = false;
    }
    else if (user.isUserUnderSiege)
    {
        this.problemText.innerHTML = I18.getMegaString(I18.f("PEARL_BOOST_ERROR_FORGIVE_BETRAYER_UNDER_ATTACK"), FConfig);
        COM(this.yesButton).enabled = false;
    }
    else
    {
        this.problemText.innerHTML = "";
        COM(this.yesButton).enabled = true;
    }

    if (user.pearl < price)
    {
        COM(this.yesButton).enabled = false;
    }
}