function KingdomFieldInfoView()
{
	this.terrain = null;
}

KingdomFieldInfoView.prototype.init = function()
{
    this.productivityBonuses.innerHTML = "";
    this.combatBonuses.innerHTML = "";
    
    var config = FConfig.getTerrainConfig(this.terrain);
    var nullBonus = new AuraBonus();
    
    var showProductivityBonuses = false;
    var resource;
    for(var i=0; i<Resource.FUNDS_RESOURCES.length; i++)
    {
    	resource = Resource.FUNDS_RESOURCES[i];
    	var resourceBonus = config.productivity.getValue(resource);
        if (NumberUtils.compareTo(resourceBonus, 0) != 0)
        {
            this.productivityBonuses.appendChild(this.createProductivityBonusView(resource, resourceBonus).DOM);
            showProductivityBonuses = true;
        }
    }
    
    this.productivityBonuses.style.display = showProductivityBonuses ? "block" : "none";
    
    var race, raceBonus;
    for(var i=0; i<config.raceBonuses.raw.length; i++)
    {
    	race = config.raceBonuses.raw[i].key;
    	raceBonus = config.raceBonuses.raw[i].value;
        this.combatBonuses.appendChild(this.createRaceBonusView(race, raceBonus));
    }
    
    if (!config.raceBonuses.isEmpty())
    {
        this.combatBonuses.appendChild(this.createEmptyRow(5));
    }
    
    var unit, unitBonus;
    for(var i=0; i<config.unitBonuses.raw.length; i++)
    {
    	unit = config.unitBonuses.raw[i].key;
    	unitBonus = config.unitBonuses.raw[i].value;
        this.combatBonuses.appendChild(this.createUnitBonusView(unit, unitBonus));
    }
    
    this.combatBonuses.style.display = (!config.raceBonuses.isEmpty() || !config.unitBonuses.isEmpty()) ? "block" : "none";
}

KingdomFieldInfoView.prototype.createEmptyRow = function(height)
{
    var gr = document.createElement("div");
    gr.style.height = (height*INTERFACE_IMAGES_PACK) + "px";
    return gr;
}

KingdomFieldInfoView.prototype.createBonusGridRow = function(text, childs)
{
    var gr = document.createElement("inline-table");
    gr.className = "bonus-grid";
    var row = document.createElement("row");
    var leftItem = document.createElement("cell");
    
    var label = document.createElement("span");
    label.innerHTML = text;
    leftItem.appendChild(label);
    
    var rightItem = document.createElement("cell");
    
    var rightHbox = document.createElement("span");
    
    if(childs)
    {
	    for(var i=0; i<childs.length; i++)
	    {
	        rightHbox.appendChild(childs[i].DOM ? childs[i].DOM : childs[i]);
	    }
    }
    rightItem.appendChild(rightHbox);

    row.appendChild(leftItem);
    row.appendChild(rightItem);
    
    gr.appendChild(row);
    
    return gr;
}

KingdomFieldInfoView.prototype.createBonusViews = function(bonus)
{
    var childs = [];
    
    if (NumberUtils.compareTo(bonus.damage, 0) != 0)
    {
        childs.push(IconValueBonusView.create(STATIC_URL + CommonAssets.STAT_ATTACK, bonus.damage));
    }
    if (NumberUtils.compareTo(bonus.defence, 0) != 0)
    {
        childs.push(IconValueBonusView.create(STATIC_URL + CommonAssets.STAT_DEFENCE, bonus.defence, false));
    }
    return childs;
}

KingdomFieldInfoView.prototype.createRaceBonusView = function(race, raceBonus)
{
    return this.createBonusGridRow(race.pluralName, this.createBonusViews(raceBonus));
}

KingdomFieldInfoView.prototype.createProductivityBonusView = function(r, bonus)
{
    return IconValueBonusView.create(STATIC_URL + Assets.ICON_findBy(r), bonus);
}

KingdomFieldInfoView.prototype.createUnitBonusView = function(unit, unitBonus)
{
    return this.createBonusGridRow(I18.getUnitClassName(unit), this.createBonusViews(unitBonus));
}