function KingdomInfoDialog()
{
	callParentConstructor(KingdomInfoDialog.prototype, this);
	
	this.kingdom = null;
}

extendClass(KingdomInfoDialog.prototype, Dialog.prototype);

KingdomInfoDialog.popup = function(k)
{
	var d = COM.create("KingdomInfoDialog");
	d.setCaption(I18.f("INFORMATION"));
	d.update(k);
	d.popup();
}

KingdomInfoDialog.prototype.update = function(k)
{
	this.kingdom = k;
	
	if(FConfig.IS_SURVIVAL)
	{
		this.survivalInfoBox.style.display = "";
		
		COM(this.prize).value = k.prize;
	    this.destroyedDarkLabel.innerHTML = I18.f("DESTROYED_PLAYERS_DARK", k.destroyedDark);
	    this.destroyedLightLabel.innerHTML = I18.f("DESTROYED_PLAYERS_LIGHT", k.destroyedLight);
	    UI.show(k.aliveDark + k.aliveLight > 0, [this.aliveLabel, this.aliveDarkLabel, this.aliveLightLabel], $.proxy(function()
	    {
	        this.aliveDarkLabel.innerHTML = I18.f("ALIVE_PLAYERS_DARK", k.aliveDark);
	        this.aliveLightLabel.innerHTML = I18.f("ALIVE_PLAYERS_LIGHT", k.aliveLight);
	    }, this));
    }
    else
    {
    	this.survivalInfoBox.style.display = "none";
    }
    
    if(k.currentUser.canAttackAnyRuin())
    {
    	this.ruinAttackBox.style.display = "";
    	
    	this.attackAnyRuinTime.innerHTML = Tick.toTimeLeft(k.currentUser.canAttackAnyRuinTill - Tick.now());
    }
    else
    {
    	this.ruinAttackBox.style.display = "none";
    }
}