function MakeGiftDialog()
{
	callParentConstructor(MakeGiftDialog.prototype, this);
	
	this.username = "";
	this.location = null;
	
	this.allTabs = [];
	
	this.onTabClick = $.proxy(this.onTabClick, this);
}

extendClass(MakeGiftDialog.prototype, Dialog.prototype);

MakeGiftDialog.prototype.__construct = function()
{
	this.allTabs = [this.tabFriend, this.tabEnemy, this.tabHoliday];
	
	COM(this.tabFriend).giftType = GiftType.FRIENDLY;
	COM(this.tabEnemy).giftType = GiftType.OFFENSIVE;
	COM(this.tabHoliday).giftType = GiftType.HOLIDAY;
	
	var bg = COM(this.buttons);
	bg.addItem(I18.f("FOR_FRIEND"), 0, true);
	bg.addItem(I18.f("FOR_ENEMY"), 1);
	
	this.buttonHoliday = bg.addItem(I18.f("FOR_HOLIDAY"), 2);
	bg.onChange = this.onTabClick;
	
	COM.bindExclusiveClick(this.giftPearlsButton, $.proxy(function()
	{
		ObtainPearlDialog.popup(this.username);
	}, this));
	
	this.setCaption(" ");
	
	this.scroll = new iScroll(this.windowWrapper, {scrollbarColor: '#784f0b'});
}

MakeGiftDialog.prototype.hideAllTabs = function()
{
	for(var i=0; i<this.allTabs.length; i++)
	{
		this.allTabs[i].style.display = "none";
	}
}

MakeGiftDialog.prototype.onTabClick = function(e)
{
	this.showTab(COM(this.buttons).getValue());
}

MakeGiftDialog.prototype.showTab = function(ix)
{
	this.hideAllTabs();
	this.allTabs[ix].style.display = "";
	
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
}

MakeGiftDialog.prototype.popup = function(parent, location, username)
{
    this.location = location;
    this.username = username;
    
    superMethod(MakeGiftDialog.prototype, "popup", this)();
    
    var tab;
    for(var i=0; i<this.allTabs.length; i++)
	{
		tab = COM(this.allTabs[i]);
		tab.username = this.username;
        tab.location = this.location;
        tab.onGiftSent = $.proxy(this.close, this);
        tab.init();
	}
	
	var hv = FConfig.getGifts(GiftType.HOLIDAY).length > 0;
    
    this.tabHoliday.style.display = hv ? "" : "none";
    this.buttonHoliday.DOM.style.display = hv ? "" : "none";
    
    this.showTab(0);
}