function MoveCityDialog()
{
    callParentConstructor(MoveCityDialog.prototype, this);

    this.buildingsToDestroy = null;
    this.fromEstateInfo = null;
    this.locationTo = null;
}

extendClass(MoveCityDialog.prototype, Dialog.prototype);

MoveCityDialog.prototype.__construct = function()
{
    COM.bindExclusiveClick(this.yesButton, $.proxy(function()
    {
        this.doAction();
        this.close();
    }, this));

    COM.bindExclusiveClick(this.closeButton, $.proxy(this.close, this));
};

MoveCityDialog.prototype.update = function()
{
    this.setCaption("  ");

    this.moveCityLabel.innerHTML = I18.f("MOVE_CITY_QUESTION", this.fromEstateInfo.getName(), this.fromEstateInfo.location, this.locationTo);
    COM(this.price).update(FConfig.PEARL_MOVE_CITY_PRICE);
    COM(this.yesButton).reason = COM(this.price).checkPrice(FConfig.PEARL_MOVE_CITY_PRICE) ? "" : I18.f("NOT_ENOUGH_RESOURCES");
    UI.show(this.buildingsToDestroy && this.buildingsToDestroy.length > 0, [this.buildingsWillBeDestroyedLabel], $.proxy(function()
    {
        var names = Arrays.map(this.buildingsToDestroy, function(b)
        {
            return b.getNameAndLevel();
        });
        var namesString = Strings.join(names, "<br/>", null);
        this.buildingsWillBeDestroyedLabel.innerHTML = I18.f("MOVE_CITY_WARNING_BUILDINGS", namesString);
    }, this));
};

MoveCityDialog.prototype.onShow = function()
{
    if(!this.scroll)
    {
        var params = {
            hScroll: false,
            vScroll: true,
            scrollbarColor: '#784f0b',
            hideScrollbar: true,
            bounce: false,
            forcedRepaint: true
        };
        this.scroll = new iScroll(this.descrWrapper, params);
    }
    this.scroll.refresh();
};

MoveCityDialog.prototype.popup = function(parent, fromEstateInfo, locationTo)
{
    this.fromEstateInfo = fromEstateInfo;
    this.locationTo = locationTo;
    Service.kingdom.callMethod("checkBuildingsForMoveCity", [fromEstateInfo.location, locationTo],
            $.proxy(function(buildings)
            {
                this.buildingsToDestroy = buildings;
                superMethod(MoveCityDialog, "popup", this)(null, true);
                this.update();
            }, this),
            $.proxy(function(e)
            {
                if (e.__className__ == "MoveCityException")
                {
                    Alert.create(e.getMessage());
                }
                this.close();
                return true;
            }, this)
    );
};

MoveCityDialog.prototype.doAction = function()
{
    Service.kingdom.callMethod("moveCity", [this.fromEstateInfo.location, this.locationTo],
            $.proxy(function(kingdom)
            {
                // check whether city move was successful
                var xy = FKingdom.getFieldLocationByZ(this.locationTo.z);
                var field = kingdom.getField(xy.x, xy.y);
                if (!field.hasEstate())
                {
                    Alert.create(I18.f("MOVE_CITY_FAIL_EXPLORED"));
                }
                else if (!field.hasCity() || !field.isOwnedByUser(FUser.CURRENT_USER))
                {
                    Alert.create(I18.f("MOVE_CITY_FAIL_EXPLORED_ESTATE"));
                }
            }, this),
            function(e)
            {
                if (e.__className__ == "MoveCityException")
                {
                    Alert.create(e.getMessage());
                }
                return true;
            }
    );
};