function SendGiftDialog()
{
	callParentConstructor(SendGiftDialog.prototype, this);
	
	this.gift = null;
    this.username = null;
    this.location = null;
    this.onGiftSent = null;
}

extendClass(SendGiftDialog.prototype, Dialog.prototype);

SendGiftDialog.MAX_COMMENT_LENGTH = 300;

SendGiftDialog.popup = function(gift, username, location, onGiftSent)
{
    var d = COM.create("SendGiftDialog");
    d.gift = gift;
    d.username = username;
    d.location = location;
    d.onGiftSent = onGiftSent;
    d.init();
    d.popup();
}

SendGiftDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.okButton, $.proxy(this.makeGift, this));
	$(this.comment).on("keyup", $.proxy(this.onCommentChange, this));
	
	this.setCaption(I18.f("MAKE_A_GIFT"));
}

SendGiftDialog.prototype.init = function()
{
    this.giftImage.src = STATIC_INTERFACE_URL + Assets.getGiftImage(this.gift.name);
    var price = this.gift.price;
    var duration = this.gift.duration;
    
    COM(this.priceLabel).update(price);
    COM(this.durationLabel).value = duration;
    
    this.nameLabel.innerHTML = I18.f("GIFT_NAME", I18.getGiftName(this.gift.name));
    COM(this.okButton).reason = price <= FUser.CURRENT_USER.pearl ? "" : I18.f("NOT_ENOUGH_PEARL");
    this.onCommentChange();
}

SendGiftDialog.prototype.onCommentChange = function()
{
	this.charsLabel.innerHTML = this.comment.value.length + ' / ' + SendGiftDialog.MAX_COMMENT_LENGTH;
}

SendGiftDialog.prototype.makeGift = function()
{
    Service.kingdom.callMethod("makeGift", [this.location, this.username, this.gift.name, this.comment.value],
            $.proxy(function (k)
            {
                Alert.create(I18.f("GIFT_WAS_SENT"));
                this.onGiftSent();
            }, this),
            $.proxy(function (e)
            {
                if (e.__className__ == "GiftException")
                {
                    Alert.create(e.getMessage());
                    return true;
                }
                return false;
            }, this));
    this.close();
}