function FKingdomEstate()
{
	this.id = null;
	this.level = null;
	this.owner = null;
	this.info = null;
	this.slogan = null;
	this.gifts = null;
	this.ancientsDefense = null;
	this.gatesClosed = null;
	this.hasFlags = null;
	this.maxTitleIndexToAttack = null;
	this.canObserve = null;
	this.canEnter = null;
	this.lastCastTick = null;
	this.magicDefenseTillTick = null;
	this.magicDisableTillTick = null;
	this.type = null;
	this.hasImprisonedHero = null;
	this.hasIncomingAttackMissions = null;
	this.underAttackAt = null;
	this.ownedByEnemy = null;
	this.ownedByAlly = null;
	this.ownedByClanMate = null;
	this.ownedByFriend = null;
	this.ownerInPeace = null;
	this.skinIndex = null;
	
	this.isOuterEstate = false;
	
	this.__defineGetter__("canAssist", this.getCanAssist);
	this.__defineGetter__("ownerUserName", this.getOwnerUserName);
	this.__defineGetter__("ownerTitleIndex", this.getOwnerTitleIndex);
	this.__defineGetter__("ownedByMe", this.getOwnedByMe);
}

FKingdomEstate.prototype.__CLS__ = "game.service.kingdom.FKingdomEstate";

FKingdomEstate.prototype.getName = function()
{
}

FKingdomEstate.prototype.hasOwner = function()
{
    return this.owner && !this.owner.isFake();
}

FKingdomEstate.prototype.hasRealOwner = function()
{
    return this.hasOwner();
}

FKingdomEstate.prototype.hasLevel = function()
{
    return true;
}

FKingdomEstate.prototype.getCanAssist = function()
{
    return this.ownedByAlly || this.ownedByClanMate;
}

FKingdomEstate.prototype.getOwnerUserName = function()
{
    return !this.owner ? null : this.owner.username;
}

FKingdomEstate.prototype.getOwnerTitleIndex = function()
{
    return this.owner.titleIndex;
}

FKingdomEstate.prototype.getOwnedByMe = function()
{
    return FUser.CURRENT_USER.username == this.owner.username;
}