function FKingdomEstateLink()
{
	this.estateInfo = null; 
    this.locationInKingdom = null;
    this.scienceSpeedPerHour = null;
    this.isExpeditionReport = null;
    this.canAddCells = null;
    this.bank = null;
    this.hasGarrisonHero = null;
    
    this.__defineGetter__("id", this.getId);
    this.__defineGetter__("icon", this.getIcon);
    this.__defineGetter__("isCapital", this.getIsCapital);
}

FKingdomEstateLink.MAX_NAME_LENGTH = 16;

FKingdomEstateLink.prototype.__CLS__ = "game.service.kingdom.FKingdomEstateLink"

FKingdomEstateLink.prototype.toString = function()
{
    var name = this.estateInfo.getName();
    var fixedName = name ? Strings.ellipsis(name, FKingdomEstateLink.MAX_NAME_LENGTH) : "";
    return I18.formatEstateName(fixedName, this.estateInfo.location);
}

FKingdomEstateLink.prototype.getId = function()
{
    return this.estateInfo.id;
}
FKingdomEstateLink.prototype.getIcon = function()
{
    if (this.isExpeditionReport)
    {
        return Assets.ICON_FAKE_CITY;
    }
    return this.estateInfo.getEstateIcon();
}

FKingdomEstateLink.prototype.getIsCapital = function()
{
    return this.estateInfo.isCapital;
}