function FKingdomField()
{
	this.screen = null;

    this.cellCount = null;
    this.exploreTick = null;
    this.terrain = null;
    this.terrainSubType = null;
    this.z = null;
    this.estate = null;
    this.buffs = null;
    this.isVoid = null;
    
    this.__defineGetter__("city", this.getCity);
}

FKingdomField.prototype.__CLS__ = "game.service.kingdom.FKingdomField";

FKingdomField.prototype.hasEstate = function()
{
    if(this.estate)
    {
    	return true;
    }
    return false;
}

FKingdomField.prototype.hasEvil = function()
{
    return this.estate  && this.estate.type.name == EstateType.EVIL.name;
}

FKingdomField.prototype.hasCity = function()
{
    return this.estate && this.estate.__className__ == "FKingdomCity";
}

FKingdomField.prototype.hasFakeRuin = function()
{
    return this.estate && this.estate.__className__ == "FKingdomCity" && this.estate.type.name == EstateType.RUIN.name;
}

FKingdomField.prototype.hasPit = function()
{
    return this.estate && this.estate.isOuterEstate && this.estate.type.name == EstateType.PIT.name;
}

FKingdomField.prototype.hasMine = function()
{
    return this.estate && this.estate.isOuterEstate && this.estate.type.name == EstateType.MINE.name;
}

FKingdomField.prototype.hasLake = function()
{
    return this.estate && this.estate.isOuterEstate && this.estate.type.name == EstateType.LAKE.name;
}

FKingdomField.prototype.hasGrail = function()
{
	return this.estate && this.estate.isOuterEstate && this.estate.type.name == EstateType.GRAIL.name;
}

FKingdomField.prototype.hasCamp = function()
{
    return this.estate && this.estate.isOuterEstate && this.estate.type.name == EstateType.CAMP.name;
}

FKingdomField.prototype.hasCatapult = function()
{
    return this.estate && this.estate.isOuterEstate && this.estate.type.name == EstateType.CATAPULT.name;
}

FKingdomField.prototype.hasRuin = function()
{
    return this.estate && this.estate.isOuterEstate && (this.estate.type.name == EstateType.RUIN.name || this.estate.type.name == EstateType.EVIL.name);
}

FKingdomField.prototype.hasCastle = function()
{
    return this.estate && this.estate.isOuterEstate && this.estate.type.name == EstateType.CASTLE.name;
}

FKingdomField.prototype.hasGrotto = function()
{
    return this.estate && this.estate.isOuterEstate && this.estate.type.name == EstateType.GROTTO.name;
}

FKingdomField.prototype.hasStonehenge = function()
{
    return this.estate && this.estate.isOuterEstate && this.estate.type.name == EstateType.STONEHENGE.name;
}

FKingdomField.prototype.getEstateType = function()
{
    return this.estate ? this.estate.type : EstateType.EMPTY_FIELD;
}

FKingdomField.prototype.getRace = function()
{
    return this.estate ? this.estate.owner.race : null;
}

FKingdomField.prototype.canSendSettler = function()
{
    return !this.hasEstate() && (this.exploreTick <= 0 || this.cellCount > 0);
}

FKingdomField.prototype.isOwnedByUser = function(user)
{
    return this.hasEstate() && user.equals(this.estate.owner);
}

FKingdomField.prototype.getLocationXYZ = function()
{
    return new XYZ(this.screen.location.x, this.screen.location.y, this.z);
}

FKingdomField.prototype.toString = function()
{
    return this.getLocationXYZ().toString();
}

FKingdomField.prototype.hasOuterEstate = function()
{
    return this.estate && this.estate.isOuterEstate;
}

FKingdomField.prototype.getCity = function()
{
    return this.estate;
}