function ClanArchiveDialog()
{
	callParentConstructor(ClanArchiveDialog.prototype, this);
}

extendClass(ClanArchiveDialog.prototype, Dialog.prototype);

ClanArchiveDialog.prototype.__construct = function()
{
	superMethod(this, '__construct')();
	
	this.setCaption(I18.f('CLAN_HISTORY_HEAD', FConfig.CLAN_ARCHIVE_SIZE));
	
	COM(this.list).createRenderer = $.proxy(this.onCreateRenderer, this);
	COM(this.pager).onSelect = $.proxy(this.pageChanged, this);
}

ClanArchiveDialog.create = function(parent)
{
	var dialog = COM.create('ClanArchiveDialog');
	
	dialog.popup(parent);
	dialog.onChangePage(0);
	
	return dialog;
}

ClanArchiveDialog.prototype.onCreateRenderer = function()
{
	var r = COM.create('MessageDetails');
	r.showCheck(false);
	return r;
}

ClanArchiveDialog.prototype.onChangePage = function(index)
{
	Service.alliance.callMethod('getClanArchive', [index], $.proxy(this.onPageData, this));
}

ClanArchiveDialog.prototype.onPageData = function(page)
{
	this.pageData = page;
	COM(this.list).dataProvider = this.pageData.messages;
	COM(this.pager).setIndexAndCount(this.pageData.pageIndex, this.pageData.pageCount);
   	setTimeout($.proxy(this.fitLayout, this), 300);
}

ClanArchiveDialog.prototype.pageData = null; // FMailBoxPage

ClanArchiveDialog.prototype.update = function(page)
{
	this.pageData = page;
   	COM(this.pager).setIndexAndCount(this.pageData.pageIndex, this.pageData.pageCount);
}

ClanArchiveDialog.prototype.selectAll = function(doSelect)
{
	for (var i = 0, len = COM(this.list).items; i < len; i++) 
	{
	    var md = COM(COM(this.list).items[i]);
	    md.checkbox.selected = doSelect;
	    md.data.selected = doSelect;
	}
}

ClanArchiveDialog.prototype.pageChanged = function(index)
{
	this.onChangePage(index);
}