function ContactDetails()
{
	this._data = null;
	
	this.__defineGetter__("contact", this.getContact);
	this.__defineSetter__("data", this.setData);
}

ContactDetails.prototype.__construct = function()
{
	this.setButtonIcon(this.ask, MailAssets.BUTTON_HAT);
	this.setButtonIcon(this.sendMail, "shared/mail/new_mail_icon.png");
	this.setButtonIcon(this.editButton, "shared/mail/edit_contact.png");
	this.setButtonIcon(this.removeButton, "shared/mail/delete_contact.png");
	
	COM.bindExclusiveClick(this.ask, $.proxy(function()
	{
		this.onAsk(this.contact);
	}, this));
	
	COM.bindExclusiveClick(this.sendMail, $.proxy(function()
	{
		this.createMail();
	}, this));
	COM.bindExclusiveClick(this.editButton, $.proxy(function()
	{
		this.onEdit(this.contact);
	}, this));
	COM.bindExclusiveClick(this.removeButton, $.proxy(function()
	{
		this.onRemove(this.contact);
	}, this));
	
	COM.bindExclusiveClick(this.content, $.proxy(this.toggleExpandBox, this));
}

ContactDetails.prototype.setButtonIcon = function(button, icon)
{
	button.style.backgroundImage = "url("+(STATIC_INTERFACE_URL + icon)+")";
}

ContactDetails.prototype.onEdit = function() {};
ContactDetails.prototype.onAsk = function() {};
ContactDetails.prototype.onRemove = function() {};
ContactDetails.prototype.update = function() {};
ContactDetails.prototype.onContactTooltip = function() {};

ContactDetails.prototype.toggleExpandBox = function()
{
	$(this.content).toggleClass("expandBox");
}

ContactDetails.prototype.createMail = function()
{
	MailBoxView.i().sendMessage(this.contact.user.username);
}

ContactDetails.prototype.getContact = function()
{
	return this._data;
};

ContactDetails.prototype.updateDefaults = function()
{
	this.status.src = STATIC_INTERFACE_URL + CommonAssets.getContactStatus(this.contact.status);
	this.name.innerHTML = Strings.safeHtml(this.contact.user.username);
	var img = MailAssets.getAllyStatusIcon(this.contact.allianceStatus, false);
	if(img) this.allianceStatus.src = STATIC_INTERFACE_URL + img;

	this.comment.innerHTML = this.contact.comment;
    this.estateLocation.innerHTML = I18.formatEstateName(Strings.safeHtml(this.contact.user.capitalName), this.contact.user.capitalLocation);
	
	COM(this.raiting).titleIndex = this.contact.user.titleIndex;
	this.raiting.style.display = this.contact.user.titleIndex > 0 ? "" : "none";
	
	this.clanName.innerHTML = this.contact.user.clanName ? I18.f("CLAN") + ": " + htmlEscape(this.contact.user.clanName) : I18.f('CONTACT_NOT_IN_CLAN');
}

ContactDetails.prototype.setData = function(value)
{
	this._data = value;
	this.updateDefaults();
	this.update(this.contact);
};