function ContactList()
{
	this.dataProvider = null;
	this.onCreateRenderer = null;
}

ContactList.prototype.update = function(addAdminContact)
{
	if(!this.dataProvider) return;
	
	this.clear();
	
	var renderer;
	for(var i=0; i<this.dataProvider.length; i++)
	{
		renderer = this.onCreateRenderer();
		renderer.data = this.dataProvider[i];
		
		this.content.appendChild(renderer.DOM);
	}
	
	//admin
	if(addAdminContact)
	{
		renderer = this.onCreateRenderer();
		$(renderer.DOM).addClass("admin-contact");
		
		renderer.status.src = STATIC_INTERFACE_URL + CommonAssets.getContactStatus(ContactStatus.ONLINE);
		renderer.name.innerHTML = I18.f('ADMINISTRATION_CONTACT');
		renderer.clanName.innerHTML = I18.f('ADMINISTRATION_CONTACT_DESCR');
		renderer.raiting.style.display = "none";
		
		renderer.ask.style.display = "none";
		renderer.editButton.style.display = "none";
		renderer.removeButton.style.display = "none";
		
		renderer.createMail = function()
		{
			MailBoxView.i().sendMessageToAdmin(new SubjectSelector(FConfig.ADMIN_MAIL_SUBJECTS_USER), null, "");
		}
		
		this.content.appendChild(renderer.DOM);
	}
}

ContactList.prototype.clear = function()
{
	var c = $("com", this.content);
    for(var i=0; i<c.length; i++)
    {
    	COM.get(c[i]).destroy();
    }
    
    $(this.content).empty();
}