function EspionageReportMessageView()
{
	callParentConstructor(EspionageReportMessageView.prototype, this);
	
	this.isVictim = true;
    this.isInitiator = false;
}

extendClass(EspionageReportMessageView.prototype, SystemMessageView.prototype);

EspionageReportMessageView.prototype.getMessage = function()
{
    return this._message;
}

EspionageReportMessageView.prototype.getSubject = function()
{	
    return this.isVictim
            ? I18.f("ESPIONAGE_VICTIM_SUBJECT", this.message.initiatorUsername, this.message.estateNameAndLocation)
            : I18.f("ESPIONAGE_INITIATOR_SUBJECT", this.message.estateNameAndLocation);
}

EspionageReportMessageView.prototype.createChildren = function()
{
    superMethod(EspionageReportMessageView.prototype, "createChildren", this)();
    /*
    var showReport = COM.create("SimpleButton");
    showReport.setCaption(I18.f("SHOW_REPORT"));
    COM.bindExclusiveClick(showReport.DOM, $.proxy(function()
    {
    	this.onShowReport();
    	this.parent.close();
    }, this));    
        
    */
    var result = this.message.espionageResult;
    
	var estateOwnerName = FUser.getUserNameForMessages(result.targetUsername ? result.targetUsername : result.targetOwner.username);
	
    var estateOwner = result.targetOwner;
    
    var accessDescription = document.createElement("div");
    accessDescription.className = "message-text-small-bold";
    var accessLevel = document.createElement("div");
    accessLevel.className = "message-text-small-bold";        
        
    if (result.spyAccessLevel > 0)
    {
        accessDescription.innerHTML = this.isVictim
                ? I18.f("YOU_WERE_SPIED", Strings.safeHtml(this.message.initiatorUsername))
                : I18.f("YOU_GOT_ACCESS", Strings.safeHtml(estateOwnerName));
        accessLevel.innerHTML = I18.f("ACCESS_LEVEL") + " " + this.message.espionageResult.spyAccessLevel.toString();
       
        //UI.show(!this.isVictim, [showReport]);       
    }
    else
    {
        accessDescription.innerHTML = this.isVictim
                ? I18.f("YOU_WERE_SPIED_NO_ACCESS", Strings.safeHtml(this.message.initiatorUsername))
                : I18.f("YOU_GOT_NO_ACCESS", Strings.safeHtml(estateOwnerName));
        accessLevel.style.display = "none";
  		//UI.show(false, [showReport]);
    }
    
    this.addLine(accessDescription, accessLevel);
    
    var spiesLabel = document.createElement("div");
    spiesLabel.style.display = "inline-block";
    spiesLabel.style.width = "30%";
    spiesLabel.style.textAlign = "center";
    spiesLabel.className = "message-text-small";
    spiesLabel.innerHTML = this.isInitiator ? I18.f("YOUR_SPIES") : I18.f("SPIES_OF", Strings.safeHtml(this.message.initiatorUsername));
    
    var antispiesLabel = document.createElement("div");
    antispiesLabel.style.display = "inline-block";
    antispiesLabel.style.width = "30%";
    antispiesLabel.style.textAlign = "center";
    antispiesLabel.className = "message-text-small";
    antispiesLabel.innerHTML = this.isVictim ? I18.f("YOUR_ANTISPIES") : I18.f("ANTISPIES_OF", Strings.safeHtml(estateOwnerName));
    
    this.addLine(spiesLabel, antispiesLabel);
    
    var spiesView = COM.create("UnitView");
    spiesView.utype = UnitType.SPY;
    spiesView.showZero = true;
    spiesView.grayscaleZero = false;
    spiesView.showCount = true;
    spiesView.race = this.message.initiatorRace;
    spiesView.update(1, result.spiesKilled, -1);
    spiesView.setInitialKilledPresent(result.spiesTotal, result.spiesKilled);
    
    var antispiesView = COM.create("UnitView");
    antispiesView.utype = UnitType.ANTISPY;
    antispiesView.showZero = true;
    antispiesView.grayscaleZero = false;
    antispiesView.showCount = true;
    antispiesView.race = result.targetRace ? result.targetRace : result.targetOwner.race;
    if (result.antispiesPresent)
    {
        antispiesView.update(1, result.antispiesKilled, -1);
        antispiesView.setInitialKilledPresent(result.antispiesTotal != 0 ? result.antispiesTotal : -1, result.antispiesKilled);
    }
    else
    {
        antispiesView.showUnitBackIfZero = true;
        antispiesView.update(1, 0, -1);
    }
    
    var c1 = document.createElement("div");
    c1.style.display = "inline-block";
    c1.style.width = "30%";
    c1.style.textAlign = "center";
    c1.appendChild(spiesView.DOM);
    
    var c2 = document.createElement("div");
    c2.style.display = "inline-block";
    c2.style.width = "30%";
    c2.style.textAlign = "center";
    c2.appendChild(antispiesView.DOM);
    
    this.addLine(c1, c2);        
        
        
        
        
    /*
    var mailForvard = COM.create("SimpleButton");
    mailForvard.setCaption(I18.f("MAIL_FORWARD"));
        
    COM.bindExclusiveClick(mailForvard.DOM, $.proxy(function()
    {
    	this.renderer.onForwardMessage(this.message);
    }, this));

    this.addLine(showReport.DOM, mailForvard.DOM);
    */
    
    
    
    /*
    if(this.isVictim)
    {    	
	    var replyButton = COM.create("SimpleButton");
    	replyButton.setCaption(I18.f("SEND_MESSAGE"));
	    
	    COM.bindExclusiveClick(replyButton.DOM, $.proxy(function()
	    {
	    	this.renderer.onReplyOnMessage(this.message.initiatorUsername, '', '', '');
	    }, this));
	    
	    var addContactButton = COM.create("SimpleButton");
    	addContactButton.setCaption(I18.f("ADD_CONTACT"));
	    COM.bindExclusiveClick(addContactButton.DOM, $.proxy(function()
	    {
	    	this.renderer.onAddContactFromMessage(this.message.initiatorUsername);
	    }, this));
	    
	    this.addLine(replyButton.DOM, addContactButton.DOM);
    }
    */
    
}

/*
EspionageReportMessageView.prototype.setButtons = function()
{
	var replyButton = COM.create("SimpleButton");
	replyButton.setCaption(I18.f("SEND_MESSAGE"));
    
    COM.bindExclusiveClick(replyButton.DOM, $.proxy(function()
    {
    	this.renderer.onReplyOnMessage(this.message.initiatorUsername, '', '', '');
    }, this));
    
    var addContactButton = COM.create("SimpleButton");
	addContactButton.setCaption(I18.f("ADD_CONTACT"));
    COM.bindExclusiveClick(addContactButton.DOM, $.proxy(function()
    {
    	this.renderer.onAddContactFromMessage(this.message.initiatorUsername);
    }, this));
		
	return replyButton,addContactButton;
}
*/

EspionageReportMessageView.prototype.setReplyButton = function()
{
	if (!this.isVictim) return false;	
	var replyButton = COM.create("SimpleButton");
	COM.bindExclusiveClick(replyButton.DOM, $.proxy(function()
    {
    	this.renderer.onReplyOnMessage(this.message.initiatorUsername, '', '', '');
    }, this));
	return replyButton;
}

EspionageReportMessageView.prototype.setAddContactButton = function()
{
	if (!this.isVictim) return false;	
	var addContactButton = COM.create("SimpleButton");
    COM.bindExclusiveClick(addContactButton.DOM, $.proxy(function()
    {
    	this.renderer.onAddContactFromMessage(this.message.initiatorUsername);
    }, this));
    return addContactButton;
}

EspionageReportMessageView.prototype.setForwardButton = function()
{
	var mailForvard = COM.create("SimpleButton"); 
    COM.bindExclusiveClick(mailForvard.DOM, $.proxy(function()
    {
    	this.renderer.onForwardMessage(this.message);
    }, this));

	return mailForvard;
}

EspionageReportMessageView.prototype.setReportButton = function()
{
	var showReport = COM.create("SimpleButton");
    COM.bindExclusiveClick(showReport.DOM, $.proxy(function()
    {
    	this.onShowReport();
    	this.parent.close();
    }, this));
    var result = this.message.espionageResult;
    
    if (result.spyAccessLevel > 0)
    {
        UI.show(!this.isVictim, [showReport]);   
    }
    else
    {
  		UI.show(false, [showReport]);
	}
    return showReport;
}

EspionageReportMessageView.prototype.setMessage = function(m)
{
    superMethod(EspionageReportMessageView.prototype, "setMessage", this)(m);
    this.isVictim = !this.message.isForwarded && this.message.initiatorUsername != this.message.receiver;
    this.isInitiator = !this.message.isForwarded && this.message.initiatorUsername == this.message.receiver;
}

EspionageReportMessageView.prototype.onShowReport = function()
{
    Service.mail.callMethod("getEspionageDetails", [MailBoxView.i().ownerUsername, this.message.id], Events.onShowEspionageResult.fire);
}