function MailBoxButton()
{
	callParentConstructor(MailBoxButton.prototype, this);
	
	this.ownerUsername = "";
	
	Events.onMailboxStatusChange.add(this, this.refreshNotificationStatus);
	Events.onFEstateUpdated.add(this, function(e)
	{
	    if (!e.isExpeditionReport)
	    {
	        this.refreshNotificationStatus(e.mailBoxStatus);
	    }
	});
	Events.onFKingdomUpdated.add(this, function(k)
	{
	    this.refreshNotificationStatus(k.mailBoxStatus);
	});
}

extendClass(MailBoxButton.prototype, RoundButton.prototype);

MailBoxButton.prototype.__construct = function()
{
	superMethod(this, '__construct')();
	
	this.icon = STATIC_INTERFACE_URL + "city/dashboard/messages.png";
	this.caption = I18.f('MAILBOX');
	
	COM.bindExclusiveClick(this.DOM, $.proxy(function()
	{
		MailBoxView.i().popup(this.ownerUsername);
		HintArrow.OPEN_MAILBOX.understood();
	}, this));
}

MailBoxButton.prototype.refreshNotificationStatus = function(value)
{
    FUser.MAIL_BOX_STATUS = value;
    this.subCaption = value.unreadMessages > 0 ? value.unreadMessages.toString() : "";
}