function MailBoxFolders()
{
	this.hostComponent = null;
	
	this.hideInfo = $.proxy(this.hideInfo, this);
}

MailBoxFolders.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.markReadButton, $.proxy(function()
	{
		MailBoxView.i().markRead();
	}, this));
	
	COM.bindExclusiveClick(this.archiveButton, $.proxy(function()
	{
		MailBoxView.i().onArchiveClick();
	}, this));
	
	COM.bindExclusiveClick(this.deleteButton, $.proxy(function()
	{
		MailBoxView.i().onDelete();
	}, this));
	
	COM.bindExclusiveClick(this.closePanelButton, $.proxy(function()
	{
		this.unselectAll();
		this.hidePanel();
	}, this));
	
	COM.bindExclusiveClick(this.selectCount, $.proxy(this.setAllSelection, this));
	
	this.markReadButton.style.background = "url('"+STATIC_INTERFACE_URL + "shared/mail/button_com_mark_read.png"+"')";
	this.archiveButton.style.background = "url('"+STATIC_INTERFACE_URL + "shared/mail/button_com_archive.png"+"')";
	this.deleteButton.style.background = "url('"+STATIC_INTERFACE_URL + "shared/mail/button_com_delete.png"+"')";
}

MailBoxFolders.prototype.fitLayout = function(container)
{
	this.wrapper.style.width = container.width + "px";
	this.wrapper.style.height = container.height + "px";
	
	this.actionsPanel.style.width = container.width + "px";
	this.infoPanel.style.width = container.width + "px";
	
	COM(this.inboxPage).fitLayout(container);
	COM(this.outboxPage).fitLayout(container);
	COM(this.archivePage).fitLayout(container);
}

MailBoxFolders.prototype.showPanel = function()
{
	this.hideInfo();
	$(this.actionsPanel).removeClass("hide").addClass("show");
	
	this.setListPadding(94);
}

MailBoxFolders.prototype.hidePanel = function()
{
	$(this.actionsPanel).removeClass("show").addClass("hide");
	this.setListPadding(0);
}

MailBoxFolders.prototype.setListPadding = function(val)
{
	var tab = this.getCurrentTab();
	var list = COM(COM(tab).list);
	
	if(parseInt(list.content.style.paddingBottom) === val) return;
	
	list.content.style.paddingBottom = val+"px";
	list.refresh();
	
	if(val > 0)
	{
		setTimeout(function()
		{
			list.scroll.scrollTo(0, list.scroll.y-val, 100);
		}, 300);
	}
}

MailBoxFolders.prototype.onPagerChanged = function()
{
	this.unselectAll();
	this.hidePanel();
}

MailBoxFolders.prototype.showInfo = function(txt)
{
	this.infoPanel.innerHTML = txt;
	$(this.infoPanel).removeClass("hide").addClass("show");
	setTimeout(this.hideInfo, 3000);
}

MailBoxFolders.prototype.hideInfo = function()
{
	$(this.infoPanel).removeClass("show").addClass("hide");
}

MailBoxFolders.prototype.setSelectCount = function(cnt)
{
	this.selectCount.innerHTML = cnt;
}

MailBoxFolders.prototype.resetScroll = function()
{
	COM(this.getCurrentTab()).resetScroll();
}

MailBoxFolders.prototype.clear = function()
{
	COM(this.inboxPage).clear();
	COM(this.outboxPage).clear();
	COM(this.archivePage).clear();
}

MailBoxFolders.prototype.hideAllTabs = function()
{
	this.inboxPage.style.display = "none";
	this.outboxPage.style.display = "none";
	this.archivePage.style.display = "none";
}

MailBoxFolders.prototype.setAllSelection = function()
{
	var tab = this.getCurrentTab();
	
	var items = COM(COM(tab).list).items;
	var item, state = false;
	for(var i=0; i<items.length; i++)
	{
		item = COM(items[i]);
		if(!COM(item.checkbox).checked) state = true;
	}
	
	this.selectUnselectAll(tab, state);
	
	this.setSelectCount(state ? items.length : 0);
}

MailBoxFolders.prototype.selectAll = function(tab)
{
	this.selectUnselectAll(tab, true);
}

MailBoxFolders.prototype.unselectAll = function(tab)
{
	this.selectUnselectAll(tab, false);
}

MailBoxFolders.prototype.selectUnselectAll = function(tab, val)
{
	if(!tab)
	{
		tab = this.getCurrentTab();
	}
	
	var list = COM(COM(tab).list);
	var items = list.items;
	var item;
	for(var i=0; i<items.length; i++)
	{
		item = COM(items[i]);
		COM(item.checkbox).checked = val;
		item.skin = val ? "mailChecked" : "";
	}
}

MailBoxFolders.prototype.showTab = function(tab)
{
	this.hideAllTabs();
	tab.style.display = "";
	
	this.unselectAll(tab);
	this.hidePanel();
	
	this.markReadButton.style.display = (tab == this.inboxPage || tab == this.archivePage ? "" : "none");
	this.archiveButton.style.display = (tab != this.archivePage ? "" : "none");
	
	MailBoxView.i().archiveCount.style.display = ((tab == this.archivePage && MailBoxView.i().isOwner) ? "" : "none");
	
	this.resetScroll();
	
	COM(tab).fitItems();
	
	var list = COM(COM(tab).list);
	setTimeout($.proxy(list.refresh, list), 500);
}

MailBoxFolders.prototype.getCurrentTab = function()
{
	if(this.inboxPage.style.display != "none") return this.inboxPage;
	if(this.outboxPage.style.display != "none") return this.outboxPage;
	if(this.archivePage.style.display != "none") return this.archivePage;
	
	return null;
}

MailBoxFolders.prototype.reset = function()
{
}