function MailBoxPageView()
{
	this.dataProvider = null;
	
	this.onCreateRenderer = null;
    this.onExpand = null;
    this.onCollapse = null;
    this.onChange = null;
    
    this.changePageDirection = 0;
}

MailBoxPageView.prototype.__construct = function()
{
	COM(this.list).createRenderer = $.proxy(function()
	{
		return this.onCreateRenderer();
	}, this);
	
	var scroll = COM(this.list).scroll;
	
	scroll.options.onScrollMove = $.proxy(function()
	{
		this.changePageDirection = scroll.y < 0 ? 1 : -1;
	}, this);
	
	scroll.options.onScrollEnd = $.proxy(function()
	{
		if(!this.changePageDirection) return;
		
		var pager = COM(this.pager);
		var p = pager.page + this.changePageDirection;
		if (p < 0 || p >= pager.total) return;
		
		pager.page = p;
		pager.showHint(true);
		
		if(pager.onChange) pager.onChange(pager.page, pager.total);
		if(pager.onSelect) pager.onSelect(pager.page, pager.total);
		
		this.changePageDirection = 0;
	}, this);
}

MailBoxPageView.prototype.fitLayout = function(container)
{
	var w = parseInt($(this.pager).css("width"));
	
	this.list.style.width = (container.width-w) + "px";
	this.list.style.height = container.height + "px";
	
	this.pager.style.height = container.height + "px";
	this.pager.style.left = container.width-w + "px";
}

MailBoxPageView.prototype.clear = function()
{
	COM(this.list).dataProvider = [];
}

MailBoxPageView.prototype.update = function()
{
	if(!this.dataProvider) return;
	
	COM(this.list).dataProvider = this.dataProvider;
	
	var items = COM(this.list).items;
	if(!items) return;
		
	var item;
	for(var i=0; i<items.length; i++)
	{
		item = COM(items[i]);
		item.skin = "";
		item.onExpand = this.onExpand;
		item.onCollapse = this.onCollapse;
	}
	
	this.changePageDirection = 0;
	
	this.fitItems();
}

MailBoxPageView.prototype.fitItems = function()
{
	var items = COM(this.list).items;
	if(!items) return;
	
	var h = Math.floor(this.list.offsetHeight / ClientMailBoxState.PAGE_SIZE) + 1;
		
	var item;
	for(var i=0; i<items.length; i++)
	{
		item = COM(items[i]);
		item.DOM.style.height = h+"px";
		item.subjectWrapper.style.maxHeight = (h-40)+"px";
	}
}

MailBoxPageView.prototype.resetScroll = function()
{
	COM(this.list).scroll.scrollTo(0, 0, 0);
	this.changePageDirection = 0;
}