function MessageDetails()
{
	callParentConstructor(MessageDetails.prototype, this);
	
	this.onReplyOnMessage = null;
    this.onChangeCheckbox = null;
    this.onAddContactFromMessage = null;
    this.onIgnoreContactFromMessage = null;
    this.onAbuseContactFromMessage = null;
    this.onForwardMessage = null;
    this.onChangeAdminSubject = null;
    this.onReplyToAdmin = null;

    this._showFrom = false;
    this._showTo = false;
    this._showCheck = true;
    this._view = null;
    this._headerColor = "";
    this._showRealSeder = false;
    
    this.onSelected = null;
    this.onExpand = null;
    this.onCollapse = null;
    
    /*
    this._data = null;
    
    this.__defineGetter__("data", this.getData);
    this.__defineSetter__("data", this.setData);
    */
    
    this.__defineSetter__("unread", this.setUnread);
}

MessageDetails.dialog = null;

extendClass(MessageDetails.prototype, ScrollableListItem.prototype);

MessageDetails.prototype.__construct = function()
{
	superMethod(MessageDetails.prototype, '__construct', this)();
	
	COM.bindExclusiveClick(this.checkbox, $.proxy(this.onCheckboxClick, this));
	COM.bindExclusiveClick(this.DOM, $.proxy(this.showMessage, this));
}

MessageDetails.prototype.showMessage = function(e)
{
	if(APP.ticksIsPaused) return;
	
	if(this.onExpand)
	{
		this.onExpand(this);
	}
	
	var dialog = COM.create("MessageDialog");
	dialog.popup(this._view);
	
	MessageDetails.dialog = dialog;
	
	this.setUnread(false);
}

MessageDetails.prototype.closeMessage = function()
{
	if(this.onCollapse)
	{
		this.onCollapse(this);
	}
}

MessageDetails.prototype.getData = function()
{
	return this._data;
}

MessageDetails.prototype.setData = function(value)
{
    this._data = value;

    this._view = value.createView(this);
    
    this._view.setRenderer(this);
    
    this._headerColor = this._view.headerColor;
    
    COM(this.checkbox).checked = value.selected;
    UI.show(this._showCheck, [this.checkboxCell]);
    //this.checkboxCell.style.display = this._showCheck ? "" : "none";
    
	this.DOM.style.backgroundColor = this._headerColor ? this._headerColor : "transparent";
    
    this.icon.src = STATIC_INTERFACE_URL + this._data.icon;
    
    this.senderBox.style.display = this._showFrom ? "" : "none";
    
    this.senderName.innerHTML = this._view.getSender();
    
    this.realSenderBox.style.display = this._showRealSeder ? "" : "none";
    this.realSenderName.innerHTML = I18.f("SENDER") + this._data.realSender;
    
    this.receiverBox.style.display = this._showTo ? "" : "none";
    this.receiverName.innerHTML = Strings.safeHtml(this._view.getReceiver());
    
    this.subject.innerHTML = this._view.getSubjectWithFW();
    
    this.creationDate.innerHTML = this._data.getCreationDateString();
    
    this.unread = this._data.unread;
    
    if(MessageDetails.dialog &&
       MessageDetails.dialog.messageView && 
       MessageDetails.dialog.messageView.message &&
       MessageDetails.dialog.messageId == value.id.asNumber())
    {
        MessageDetails.dialog.close();
        this.showMessage();
    }
}

MessageDetails.prototype.setUnread = function(val)
{
	this._data.unread = val;
    
    if(val)
    {
    	$(this.DOM).addClass("unread");
    }
    else
    {
    	$(this.DOM).removeClass("unread");
    }
}

MessageDetails.prototype.showRealSeder = function(b)
{
    this._showRealSeder = b;
    return this;
}

MessageDetails.prototype.showFrom = function(b)
{
    this._showFrom = b;
    return this;
}

MessageDetails.prototype.showTo = function(b)
{
    this._showTo = b;
    return this;
}

MessageDetails.prototype.showCheck = function(b)
{
    this._showCheck = b;
    return this;
}

MessageDetails.prototype.setOnChangeCheckbox = function(f)
{
    this.onChangeCheckbox = f;
    return this;
}

MessageDetails.prototype.clearBody = function()
{
	var c = $("com", this.messageBody);
    for(var i=0; i<c.length; i++)
    {
    	COM.get(c[i]).destroy();
    }
    
    $(this.messageBody).empty();
}

MessageDetails.prototype.turnOffBody = function()
{
    this.clearBody();
}

MessageDetails.prototype.turnOnBody = function()
{
    this.addBody();
    this._headerColor = this._view.headerColor;
}

MessageDetails.prototype.addBody = function()
{
    this.clearBody();
    $(this.messageBody).append(this._view.DOM);
}

MessageDetails.prototype.onCheckboxClick = function(e)
{
    this.data.selected = COM(this.checkbox).checked;
    this.skin = this.data.selected ? "mailChecked" : "";
    this.onChangeCheckbox();
    
    e.stopImmediatePropagation();
    return false;
}