function MessageDialog()
{
	callParentConstructor(MessageDialog.prototype, this);
	this.messageView = null;
	this.scroll = null;
	
	this.messageId = 0;
}

extendClass(MessageDialog.prototype, Dialog.prototype);

MessageDialog.prototype.__construct = function()
{
	this.scroll = new iScroll(this.scrollContainer, {scrollbarColor: '#784f0b'});
}

MessageDialog.prototype.__destruct = function()
{
    MessageDetails.dialog = null;
}

MessageDialog.prototype.popup = function(messageView)
{
	this.fullScreen();
	
	//console.log(messageView);
	
	superMethod(MessageDialog.prototype, "popup", this)();
	
	this.senderReceiver.innerHTML = messageView.message.isSentByMe ? messageView.message.receiver : messageView.message.getSender();
	
	this.setView(messageView);

	this.update();
}

MessageDialog.prototype.setView = function(messageView)
{
    this.messageView = messageView;
    this.messageView.parent = this;
    
    this.messageId = messageView.message.id.asNumber();
}

MessageDialog.prototype.refreshScroll = function()
{
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 500);
}

MessageDialog.prototype.fitLayout = function(container)
{
	superMethod(MessageDialog.prototype, "fitLayout", this)(container);	
	var w = $("> contentwrapper > content", this.wrapper);
	this.scrollContainer.style.width = w.width()+"px";
	this.scrollContainer.style.height = (w.height() - this.scrollContainer.offsetTop)-100+"px";
}

MessageDialog.prototype.update = function()
{
	this.subjectTitle.innerHTML = I18.f("SUBJECT");
	this.subject.innerHTML = this.messageView.getSubjectWithFW();
	
	this.subjectTime.innerHTML = this.messageView.message.getCreationDateString();
	
	var s = this.messageView.message.getBody ? this.messageView.message.getBody() : this.messageView.message.messageBody;
	if(s)
	{
		s = s.replace(/\r\n|\r|\n/g, "<br/>");
		s = SmileResolver.split(s, this.messageView.message.createdWithPremium);
		this.messageBody.innerHTML = s;
	}
	
	if(this.messageView.createChildren)
	{
		this.messageView.DOM = this.messageBody;
		this.messageView.createChildren();
	}
	
	if(this.messageView.addReaction)
	{
		var r = this.messageView.addReaction();
	
		//HeaderPanel
		var button1 = COM(r.forwardButton);
		button1.setIcon(STATIC_INTERFACE_URL + "shared/mail/arrow_right.png");
		this.headerRightBox.appendChild(button1.DOM);
		
		var button2 = COM(r.replyButton);
		button2.setIcon(STATIC_INTERFACE_URL + "shared/mail/arrow_left.png");
		button2.setSkin("green");
		this.headerRightBox.appendChild(button2.DOM);
		
		//BottomPanel

		var button3 = COM(r.addContactButton);
		button3.setCaption(I18.f("ADD_CONTACT"));
		button3.setSkin("yellow");
		this.bottomPanel.appendChild(button3.DOM);		
		
		if(!this.messageView.message.isAbuseReported && this.messageView.message.canReportAbuse)
		{
			var button4 = COM(r.mailAbuseButton);
			button4.setCaption(I18.f("MAIL_ABUSE"));
			button4.setSkin("orange");
			this.bottomPanel.appendChild(button4.DOM);
		}

		var button5 = COM(r.ignoreContactButton);
		button5.setIcon(STATIC_INTERFACE_URL + "shared/mail/black_list_icon.png");
		button5.setSkin("yellow");
		this.bottomPanel.appendChild(button5.DOM);	

	}
	
	if (this.messageView.setSendButton)
	{
		var button = this.messageView.setSendButton();
		if (button)
		{
			button.setIcon(STATIC_INTERFACE_URL + "shared/mail/new_mail_icon.png");
			button.setSkin("green");
			this.headerRightBox.appendChild(button.DOM);
		}
	}
	
	if (this.messageView.setForwardButton)
	{
		var button = this.messageView.setForwardButton();
		if (button)
		{
			button.setIcon(STATIC_INTERFACE_URL + "shared/mail/arrow_right.png");
			this.headerRightBox.appendChild(button.DOM);
		}
		
	}	
	
	if (this.messageView.setReplyButton)
	{		
		var button = this.messageView.setReplyButton();
		if (button)
		{
			button.setIcon(STATIC_INTERFACE_URL + "shared/mail/arrow_left.png");
			button.setSkin("green");
			this.headerRightBox.appendChild(button.DOM);
		}
	}
	
	//BottomPanel
	if (this.messageView.setAddContactButton)
	{
		var button = this.messageView.setAddContactButton();
		if (button)
		{
			button.setCaption(I18.f("ADD_CONTACT"));
			button.setSkin("yellow");
			this.bottomPanel.appendChild(button.DOM);
		}		
	}
	
	if (this.messageView.setDetailsButton)
	{
		var button = this.messageView.setDetailsButton();
		if (button)
		{
			button.setCaption(I18.f("DETAILS"));
			button.setSkin("yellow");
			this.bottomPanel.appendChild(button.DOM);
		}		
	}
	
	if (this.messageView.setReportButton)
	{
		var button = this.messageView.setReportButton();
		if (button)
		{
			//button.setIcon(STATIC_INTERFACE_URL + "shared/mail/report_icon.png");
			button.setCaption(I18.f("SHOW_REPORT"));
			button.setSkin("yellow");
			this.bottomPanel.appendChild(button.DOM);
		}
	}
	
	if (this.messageView.setBlackListButton)
	{
		var button = this.messageView.setBlackListButton();
		if (button)
		{
			button.setIcon(STATIC_INTERFACE_URL + "shared/mail/black_list_icon.png");
			button.setSkin("yellow");
			this.bottomPanel.appendChild(button.DOM);
		}		
	}	
	
	if (this.messageView.setAbuseButton)
	{
		var button = this.messageView.setAbuseButton();
		if (button)
		{
			button.setCaption(I18.f("MAIL_ABUSE"));
			button.setSkin("orange");
			this.bottomPanel.appendChild(button.DOM);
		}		
	}
	
	this.refreshScroll();
}