function MessageReactionView()
{
	this.renderer = null;
	
	this.__defineGetter__("message", this.getMessage);
}

MessageReactionView.prototype.update = function()
{
	COM.bindExclusiveClick(this.replyButton, $.proxy(this.reply, this));
	COM.bindExclusiveClick(this.forwardButton, $.proxy(this.forward, this));
	COM.bindExclusiveClick(this.addContactButton, $.proxy(this.contact, this));
	COM.bindExclusiveClick(this.mailAbuseButton, $.proxy(this.complain, this));
	COM.bindExclusiveClick(this.ignoreContactButton, $.proxy(this.ignore, this));
	
	UI.show(this.message.canReply, [this.replyButton]);
	UI.show(this.message.canForward, [this.forwardButton]);
	UI.show(this.message.canReply, [this.addContactButton]);
	this.addContactButton.enabled = MailBoxView.i().isOwner;
	UI.show(!this.renderer.data.isAbuseReported && this.renderer.data.canReportAbuse, [this.mailAbuseButton]);
	this.mailAbuseButton.enabled = !this.renderer.data.isAbuseReported;
	UI.show(this.message.canReply, [this.ignoreContactButton]);
	this.ignoreContactButton.enabled = MailBoxView.i().isOwner;
}

MessageReactionView.prototype.getMessage = function()
{
    return this.renderer.data;
}

MessageReactionView.prototype.reply = function()
{
	var m = this.message;
    if (!m)
    {
        return;
    }
    
    this.renderer.onReplyOnMessage(m.otherUser(),
            m.createReplySubject(),
            m.adminSubject,
            m.createReplyMessageBody());
}

MessageReactionView.prototype.forward = function()
{
    this.renderer.onForwardMessage(this.message);
}

MessageReactionView.prototype.contact = function()
{
    this.renderer.onAddContactFromMessage(this.message.otherUser());
}

MessageReactionView.prototype.ignore = function()
{
    this.renderer.onIgnoreContactFromMessage(this.message.otherUser());
}

MessageReactionView.prototype.complain = function()
{
    var box = document.createElement("MailComplainBox");
    
    var b1  = document.createElement("div");
    b1.innerHTML = I18.f("SPAM");

    COM.bindExclusiveClick(b1, $.proxy(function()
    {
		this.renderer.onAbuseContactFromMessage(this.message, true, this.mailAbuseButton);
    }, this));
    box.appendChild(b1);
    
    var b2  = document.createElement("div");
    b2.innerHTML = I18.f("OFFENSE");
    COM.bindExclusiveClick(b2, $.proxy(function()
    {
    	this.renderer.onAbuseContactFromMessage(this.message, false, this.mailAbuseButton);
    }, this));
    box.appendChild(b2);
    
    $("#popup").append(box);
    
    box.style.left = getObjectX(this.mailAbuseButton) + "px";
    box.style.top = (getObjectY(this.mailAbuseButton) - box.offsetHeight) + "px";
    
    setTimeout(function()
    {
	    $(document.body).one(CLICK_EVENT, function()
	    {
	    	$(box).remove();
	    });
    }, 100);
}