function NewMessageDialog()
{
	callParentConstructor(NewMessageDialog.prototype, this);
	
	this.silencedTill = 0;
    this.subject = null;
    
    this.__defineGetter__("isBodyLengthOk", this.getIsBodyLengthOk);
    this.__defineGetter__("maxMessageLength", this.getMaxMessageLength);
}

extendClass(NewMessageDialog.prototype, Dialog.prototype);

NewMessageDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.outerMail, $.proxy(this.update, this));
	
	COM.bindExclusiveClick(this.okButton, $.proxy(this.onOk, this));
	COM.bindExclusiveClick(this.closeButton, this.close);
	
	//this.userCanClose = false;
	this.setCaption(I18.f("NEW_MESSAGE"));
}

NewMessageDialog.prototype.onResult = function (username, subject, messageBody, receiverType) {};

NewMessageDialog.prototype.popup = function(parent, receiver, subj, body, receiverType, toUserOnly, withOuterMail)
{
    superMethod(NewMessageDialog.prototype, "popup", this)();
    
    this.fullScreen();
    
    this.subject = subj;
    
    /*
    var r = document.createElement("row");
    var c = document.createElement("cell");
    r.appendChild(c);
    c.appendChild(subj.DOM);
    */
    
    this.mailHeader.appendChild(subj.DOM);
    COM(this.messageBody).text = htmlUnescape(body);
    COM(this.messageBody).content.oninput = $.proxy(this.onTextChanged, this);
    
    var el = COM(this.receiverSelector);
    el.switchMode(!receiverType ? MailReceiverType.USER : receiverType);
    if (receiver && receiver != "")
    {
        el.setReceiver(receiver);
    }
    el.onChange = $.proxy(this.update, this);
    el.setToUserOnly(toUserOnly);
    
    COM(this.outerMail).disabled = !UI.show(withOuterMail && FUser.CURRENT_USER.role.canSendOuterMail(), [this.outerMail/*, this.outerMailLabel*/]);
    
    this.update();
	
	var hint = FUser.CURRENT_USER.findHint(HintType.SEND_LETTER);
    if (hint)
	{
        HintArrow.TYPE_LETTER_TEXT.show(this.messageBody, hint, this.DOM);
    }
}

NewMessageDialog.prototype.onShow = function()
{
	//this.mailHeaderCell1.style.width = COM(this.receiverSelector).modeBox.offsetWidth + "px";
	var input = COM(this.receiverSelector).receiverInput;
	var x = getObjectX(input);
	var width = input.offsetWidth;
	
	var diff = (window.innerWidth - width)/2 - x;
	
	this.mailHeaderContainer.style.paddingLeft = Math.floor(diff - 16)+"px";
}

NewMessageDialog.prototype.focus = function()
{
    var el = COM(this.receiverSelector);
    if (el.getReceiver() == "")
    {
        el.startEdit();
    }
    else if (this.subject.text == "")
    {
        COM(this.subject).startEdit();
    }
    else
    {
        //COM(this.messageBody).focus();
    }
}

NewMessageDialog.prototype.onOk = function()
{
    var checkResult = MailConstraints.sendMessageValid(COM(this.receiverSelector).getReceiver(), this.subject.text.toString(), COM(this.messageBody).text);
    if (checkResult.isSuccess)
    {
        if(HintArrow.TYPE_LETTER_TEXT.isShowing())
        {
        	Alert.create(I18.f("ENTER_TEXT"));
        	return;
        }
        
        this.onResult(COM(this.receiverSelector).getReceiver(), this.subject.text, COM(this.messageBody).text, COM(this.receiverSelector).receiverType, $.proxy(function()
        {
        	if (HintArrow.CLICK_SEND_BUTTON.isShowing())
			{
	            HintArrow.TYPE_LETTER_TEXT.understood();
	            HintArrow.CLICK_SEND_BUTTON.understood();
	            this.noClearHints = true;
	        }
        }, this));
    }
}

NewMessageDialog.prototype.updateSendButton = function()
{
	var btn = COM(this.okButton);
	if (this.silencedTill >= Tick.now())
	{
		btn.reason = I18.f('YOU_WERE_SILENCED_TILL', Tick.toTimeFuture(this.silencedTill));
		return;
	}

	var receiver = COM(this.receiverSelector).getReceiver();
	var checkResult = MailConstraints.sendMessageValid(receiver, this.subject.text.toString(), COM(this.messageBody).text);
	
	var reason = [];
	if (!COM(this.receiverSelector).getReceiver().length)
	{
		reason.push(I18.f('NEED_TO_FILL_DATA'));
	}
	
	if (!checkResult.isSuccess)
	{
		reason.push(checkResult.text);
	}
	
	btn.reason = reason;
}

NewMessageDialog.prototype.showSmiles = function()
{
    /*
    var slv:SmileListView = new SmileListView();
    slv.isPremium = FUser.CURRENT_USER.isPremium();
    slv.onSmileClick = onSmileClick;
    var popup:UIComponent = slv.show(this);
    var pos:Point = smileButton.localToGlobal(new Point(smileButton.width + 5, 40 - popup.height));
    popup.move(pos.x, pos.y);
    */
}

NewMessageDialog.prototype.onSmileClick = function(smileName)
{
    //messageBody.insertSmile(smileName);
}

NewMessageDialog.prototype.onTextChanged = function()
{
    this.update();
    
	var hint = FUser.CURRENT_USER.findHint(HintType.SEND_LETTER);
    if (hint && StringUtil.trim(COM(this.messageBody).text).length > 0)
	{
        HintArrow.CLICK_SEND_BUTTON.show(this.okButton, hint, this.DOM);
        HintArrow.TYPE_LETTER_TEXT.understood();
    }
}

NewMessageDialog.prototype.update = function()
{
    this.counter.innerHTML = COM(this.messageBody).text.length + "/" + this.maxMessageLength;
    this.counter.style.color = this.isBodyLengthOk ? "" : "red";
    COM(this.messageBody).content.maxlength = this.maxMessageLength;
    this.updateSendButton();
}

NewMessageDialog.prototype.getIsBodyLengthOk = function()
{
    return COM(this.messageBody).text.length <= this.maxMessageLength;
}

NewMessageDialog.prototype.getMaxMessageLength = function()
{
    return !COM(this.outerMail).disabled && COM(this.outerMail).checked ? FConfig.MAX_ADMIN_OUTER_MAIL_LENGTH : FConfig.MESSAGE_BODY_LENGTH_MAX;
}