function ReceiverSelector()
{
	this.receiverType = MailReceiverType.USER;
}

ReceiverSelector.prototype.onChange = function() {};

ReceiverSelector.prototype.__construct = function()
{
	$(this.receiverInput).on("change", $.proxy(function()
	{
		this.onChange();
	}, this));
}

ReceiverSelector.prototype.switchMode = function(value, selected)
{
    if(typeof selected == "undefined") selected = true;
    
    if (selected)
    {
        this.receiverType = value;
    }
    else
    {
        this.receiverType = MailReceiverType.USER;
    }
    
    var md = COM(this.modeBox);
    md.noOneSelect = true;
    this.clanMode = md.addItem(I18.f("CLAN"), MailReceiverType.CLAN, this.receiverType.name == MailReceiverType.CLAN.name);
    this.clanWarMinisterMode = md.addItem(I18.f('CLAN_WARMINISTER'), MailReceiverType.CLAN_WARMINISTER);
    this.apprenticeMode = md.addItem(I18.f("APPRENTICES"), MailReceiverType.APPRENTICES, this.receiverType.name == MailReceiverType.APPRENTICES.name);
    
    md.onChange = $.proxy(function()
    {
    	var val = md.value;
    	this.onReceiverTypeChanged(val ? val : MailReceiverType.USER);
    }, this);
    
    UI.show(FUser.CURRENT_USER.isInClan(), [this.clanMode]);
    UI.show(FUser.CURRENT_USER.diplomacy.apprentices.length > 0, [this.apprenticeMode]);
    
    UI.show(false, [this.clanWarMinisterMode]);
    
    this.onReceiverTypeChanged(this.receiverType);
}

ReceiverSelector.prototype.onReceiverTypeChanged = function(receiverType)
{
    if (receiverType.name == MailReceiverType.CLAN.name)
    {
        COM(this.receiverInput).disabled = true;
        COM(this.receiverInput).value = I18.f("CLAN");
    }
    else if (receiverType.name == MailReceiverType.APPRENTICES.name)
    {
        COM(this.receiverInput).disabled = true;
        COM(this.receiverInput).value = I18.f("APPRENTICES");
    }
    else if (receiverType.name == MailReceiverType.CLAN_WARMINISTER.name)
    {
        COM(this.receiverInput).disabled = true;
        UI.show(false, [this.clanWarMinisterMode, this.clanMode, this.apprenticeMode]);
    }
    else
    {
        COM(this.receiverInput).disabled = false;
        COM(this.receiverInput).value = "";
        this.startEdit();
    }
    this.receiverType = receiverType;
    this.onChange();
}

ReceiverSelector.prototype.setReceiver = function(receiver)
{
    COM(this.receiverInput).value = receiver;
}

ReceiverSelector.prototype.getReceiver = function()
{
    return COM(this.receiverInput).value;
}

ReceiverSelector.prototype.startEdit = function()
{
    //COM(this.receiverInput).focus();
}

ReceiverSelector.prototype.setToUserOnly = function(toUserOnly)
{
    if (toUserOnly)
    {
        UI.show(false, [this.clanWarMinisterMode, this.clanMode, this.apprenticeMode]);
    }
}