function SmileResolver()
{
}

SmileResolver._smiles = null;

SmileResolver.split = function(text, showPremiumSmiles)
{
	SmileResolver.cacheSmiles();

    var res = text;
    var smile;

	for(var i in SmileResolver._smiles)
	{
		smile = SmileResolver._smiles[i];
		
		if(!smile.premium || showPremiumSmiles)
		{
			res = res.replace(smile.code, "<img src='" + STATIC_URL + smile.asset + "' />");
		}
	}

    return res;
}

SmileResolver.cacheSmiles = function()
{
    if (!SmileResolver._smiles)
    {
        SmileResolver._smiles = [];
        SmileResolver.addSmilesToCache(SmileType.FREE, false);
        SmileResolver.addSmilesToCache(SmileType.PREMIUM, true);
    }
}

SmileResolver.addSmilesToCache = function(st, isPremium)
{
	var smiles = FConfig.getSmiles(st, true);
	for(var i=0; i<smiles.length; i++)
	{
		smiles[i].premium = isPremium;
		SmileResolver._smiles[smiles[i].code] = smiles[i];
	}
}

SmileResolver.smileByCode = function(code)
{
    SmileResolver.cacheSmiles();
    return SmileResolver._smiles[code];
}

SmileResolver.isFree = function(code)
{
    return !SmileResolver._smiles[code].premium;
}

SmileResolver.reset = function()
{
    SmileResolver._smiles = null;
}