function FBaseMessage()
{
    this.__defineGetter__("icon", this.getIcon);
    this.__defineGetter__("isForwarded", this.getIsForwarded);
	this.__defineGetter__("isForwardedAndNotNews", this.getIsForwardedAndNotNews);
	this.__defineGetter__("tick", this.getTick);
	this.__defineGetter__("canReply", this.getCanReply);
	this.__defineGetter__("canForward", this.getCanForward);
	this.__defineGetter__("canReportAbuse", this.getCanReportAbuse);
	this.__defineGetter__("isOwner", this.getIsOwner);
	
	this.messageClass = null;

    this.id = null;
    this.realSender = null;
    this.receiver = null;
    this.creationTick = null;
    this.unread = null;
    this.forwarder = null;
    this.originalMessageTick = null;
    this.receiverType = null;
    this.clanName = null;
    this.replyable = null;
    this.isAbuseReported = null;

    this.selected = false;
}

FBaseMessage.prototype.__CLS__ = "game.service.mail.FBaseMessage";

FBaseMessage.prototype.getSubject = function()
{
	
}

FBaseMessage.prototype.getSender = function()
{
    return this.isForwarded 
    	? (this.isForwardedAndNotNews ? this.getForwarder() : I18.f('GLOBAL_NEWS')) 
    	: this.getActualSender()
    ;
}

FBaseMessage.prototype.getActualSender = function()
{
}

FBaseMessage.prototype.createView = function(renderer)
{
}

FBaseMessage.prototype.getReceiver = function()
{
    if (!this.receiverType || this.receiverType.name == MailReceiverType.USER.name)
    {
        return FUser.getUserNameForMessages(this.receiver);
    }
    return I18.getMegaString("MAIL_RECEIVER_" + this.receiverType.name, this);
}

FBaseMessage.prototype.getIcon = function()
{
    return null;
}

FBaseMessage.prototype.compareTo = function(other)
{
    var timeStampDifference = other.creationTick - this.creationTick;
    if (timeStampDifference == 0)
    {
        return other.id - this.id;
    }
    return timeStampDifference;
}

FBaseMessage.prototype.getCreationDateString = function()
{
    return DateUtils.formatSmart(Tick.toMs(this.creationTick));
}

FBaseMessage.prototype.formatSender = function(username)
{
    if (!this.receiverType || this.receiverType.name == MailReceiverType.USER.name)
    {
        return username;
    }
    
    return I18.getMegaString("MAIL_SENDER_" + this.receiverType.name, {sender: username, clanName: htmlEscape(this.clanName)});
}

FBaseMessage.prototype.getForwarder = function()
{
    return this.formatSender(this.forwarder);
}

FBaseMessage.prototype.otherUser = function()
{
    return null;
}

FBaseMessage.prototype.getIsForwarded = function()
{
    return Boolean(this.forwarder);
}

FBaseMessage.prototype.getIsForwardedAndNotNews = function()
{
    return this.forwarder && "%NEWS%" != this.forwarder;
}

FBaseMessage.prototype.getTick = function()
{
    return this.isForwardedAndNotNews ? this.originalMessageTick : this.creationTick;
}

FBaseMessage.prototype.getCanReply = function()
{
    return false;
}

FBaseMessage.prototype.getCanForward = function()
{
    return false;
}

FBaseMessage.prototype.getCanReportAbuse = function()
{
    return this.otherUser() && this.receiver == FUser.CURRENT_USER.username;
}

FBaseMessage.prototype.getIsOwner = function()
{
    return FUser.isCurrentUser(this.receiver);
}