function FMailBox()
{
	this.clanList = null;  // FContact[]
    this.messagesValid = true;
    this.inboxPagesCount = 0;
    this.outboxPagesCount = 0;
    this.archivePagesCount = 0;
    this.state = null;
    this.inbox = null; // FMessage[]
    this.sentMessages = null; // FMessage[]
    this.archive = null; // FMessage[]
    this.archiveMessageCount = 0;
    this.mailBoxStatus = null;
    this.ownerUsername = "";
    this.ownerPremiumUntil = 0;
    this.cannotAskResourcesTill = 0;
    
    this.contactList = null;
    
    this.__defineGetter__("archiveCapacity", this.getArchiveCapacity);
    this.__defineGetter__("friendsList", this.getFriendsList);
    this.__defineGetter__("ignoreList", this.getIgnoreList);
    this.__defineGetter__("notIgnoredList", this.getNotIgnoredList);
}

FMailBox.prototype.__CLS__ = "game.service.mail.FMailBox";

FMailBox.getContact = function(list, name)
{
    for(var i=0; i<list.length; i++)
    {
        if (list[i].user.username == name)
        {
            return list[i];
        }
    }
    return null;
}

FMailBox.prototype.getMaxContacts = function()
{
    if (this.isOwnerPremium())
    {
        return FConfig.PREMIUM_CONTACT_LIST_CAPACITY;
    }
    return FConfig.CONTACT_LIST_CAPACITY;
}


FMailBox.prototype.getArchiveCapacity = function()
{
    return this.isOwnerPremium() ? FConfig.PREMIUM_MESSAGE_ARCHIVE_CAPACITY : FConfig.MESSAGE_ARCHIVE_CAPACITY;
}

FMailBox.prototype.isOwnerPremium = function()
{
    return (this.ownerPremiumUntil >= Tick.now()) || (this.ownerPremiumUntil == -1);
}

FMailBox.prototype.filterContactList = function(relation, result)
{
	if(typeof result == "undefined") result = true;
	
	var ret = [];
    
    for(var i=0; i<this.contactList.length; i++)
    {
    	if((this.contactList[i].relation.name == relation.name) == result)
    	{
    		ret.push(this.contactList[i]);
    	}
    }
    
    return ret;
}

FMailBox.prototype.getFriendsList = function()
{
    return this.filterContactList(Relation.FRIEND);
}

FMailBox.prototype.getIgnoreList = function()
{
	return this.filterContactList(Relation.IGNORE);
}

FMailBox.prototype.getNotIgnoredList = function()
{
	return this.filterContactList(Relation.IGNORE, false);
}