function FSystemMessage()
{
	callParentConstructor(FSystemMessage.prototype, this);
	
	this.sender = null;
    this.senderType = null;
    this.template = null;
    this.params = null;
    this.iconPath = null;

    // Building message
    this.buildingTypeId = null;
    this.estateXYZ = null;
    this.estateName = null;
    this.cellNo = null;
    this.sectorNo = null;
    this.cellResource = null;

    // Science message
    this.scienceLevel = null;
    this.science = null;
    this.auto = null;

    // Alliance message
    this.username = null;
    this.allianceBreakingTick = null;
    // Group mission message
    this.goal = null;
    //auction
    this.pearlCount = null;
    this.price = null;
    this.bannedTill = null;

    //gift message
    this.subject = null;
    this.text = null;
    this.gift = null;

    // autoExpedition message
    this.kingdomXY = null;
    this.cellIndex = null;

    // clan messages
    this.invitor = null;
    this.invitee = null;
    this.expelledByLeader = null;
    this.clanLeaderLeft = null;
    this.resourceAdders = null;
    this.reportPeriod = null;
    this.resources = null;
    this.toSelf = null;
    //apprentice invitations
    this.invitationValid = null;


    // deputy messages
    this.ally = null;
    this.canceledByOwner = null;

    //show ruin message
    this.ruinCoords = null;
    //show outer estates message
    this.estatesInfo = null;

    // brotherhood
    this.executor = null;
    this.goalType = null;
    
    this.__defineGetter__("buildingType", this.getBuildingType);
    this.__defineGetter__("estateNameAndLocation", this.getEstateNameAndLocation);
}

extendClass(FSystemMessage.prototype, FBaseMessage.prototype);

FSystemMessage.prototype.__CLS__ = "game.service.mail.FSystemMessage";

FSystemMessage.prototype.getBuildingType = function()
{
    return BType.byId(this.buildingTypeId);
}

FSystemMessage.prototype.getEstateNameAndLocation = function()
{
    return I18.formatEstateName(this.estateName, this.estateXYZ);
}

FSystemMessage.prototype.getIcon = function()
{
    return this.senderType.icon();
}

FSystemMessage.prototype.getActualSender = function()
{
    return this.senderType.name == MailSenderType.USER.name ? this.sender : this.senderType.senderName();
}

FSystemMessage.prototype.getSubject = function()
{
    return this.subject;
}

FSystemMessage.prototype.createView = function(renderer)
{
    var v = SystemMessageView.create(this, renderer);
    
    /*
    console.log("----------------");
    console.log(this);
    console.log(v);
    */
    
    return v;
}

FSystemMessage.prototype.getAttackGoalText = function()
{
    return I18.getAttackMissionGoal(this.goal);
}

FSystemMessage.prototype.otherUser = function()
{
    return this.username;
}

FSystemMessage.prototype.getCanForward = function()
{
    return this.messageClass == "MonsterMessage";
}