function MissionExpeditionResult(name)
{
	this.name = name;
}

MissionExpeditionResult.prototype.__CLS__ = "game.model.mail.mission.MissionExpeditionResult";

MissionExpeditionResult.__isEnum__ = true;

MissionExpeditionResult.EXISTING_CITY_FOUND         = new MissionExpeditionResult("EXISTING_CITY_FOUND");
MissionExpeditionResult.FOUND_BUILDABLE_FIELD       = new MissionExpeditionResult("FOUND_BUILDABLE_FIELD");
MissionExpeditionResult.FOUND_NOT_BUILDABLE_FIELD   = new MissionExpeditionResult("FOUND_NOT_BUILDABLE_FIELD");
MissionExpeditionResult.PIT_FOUND                   = new MissionExpeditionResult("PIT_FOUND");
MissionExpeditionResult.MINE_FOUND                  = new MissionExpeditionResult("MINE_FOUND");
MissionExpeditionResult.RUIN_FOUND                  = new MissionExpeditionResult("RUIN_FOUND");
MissionExpeditionResult.LAKE_FOUND                  = new MissionExpeditionResult("LAKE_FOUND");
MissionExpeditionResult.CAMP_FOUND                  = new MissionExpeditionResult("CAMP_FOUND");
MissionExpeditionResult.CASTLE_FOUND                = new MissionExpeditionResult("CASTLE_FOUND");
MissionExpeditionResult.GROTTO_FOUND                = new MissionExpeditionResult("GROTTO_FOUND");
MissionExpeditionResult.FOUND_SOMETHING_STRANGE     = new MissionExpeditionResult("FOUND_SOMETHING_STRANGE");
MissionExpeditionResult.GRAIL_FOUND                 = new MissionExpeditionResult("GRAIL_FOUND");
MissionExpeditionResult.STONEHENGE_FOUND            = new MissionExpeditionResult("STONEHENGE_FOUND");
MissionExpeditionResult.CATAPULT_FOUND            = new MissionExpeditionResult("CATAPULT_FOUND");

MissionExpeditionResult.prototype.getEstateType = function()
{
    switch(this.name)
    {
        case MissionExpeditionResult.PIT_FOUND.name:  return EstateType.PIT;
        case MissionExpeditionResult.MINE_FOUND.name: return EstateType.MINE;
        case MissionExpeditionResult.RUIN_FOUND.name: return EstateType.RUIN;
        case MissionExpeditionResult.LAKE_FOUND.name: return EstateType.LAKE;
        case MissionExpeditionResult.CAMP_FOUND.name: return EstateType.CAMP;
        case MissionExpeditionResult.CASTLE_FOUND.name: return EstateType.CASTLE;
        case MissionExpeditionResult.GROTTO_FOUND.name: return EstateType.GROTTO;
        case MissionExpeditionResult.EXISTING_CITY_FOUND.name: return EstateType.CITY;
        case MissionExpeditionResult.STONEHENGE_FOUND.name: return EstateType.STONEHENGE;
        case MissionExpeditionResult.GRAIL_FOUND.name: return EstateType.GRAIL;
        case MissionExpeditionResult.CATAPULT_FOUND.name: return EstateType.CATAPULT;
        default: return null;
    }
}