function MissionAssistanceMessageView()
{
	callParentConstructor(MissionAssistanceMessageView.prototype, this);
}

extendClass(MissionAssistanceMessageView.prototype, SystemMessageView.prototype);

MissionAssistanceMessageView.prototype.getSubject = function()
{
    var m = this._message;
    switch (m.result.name)
    {
        case MissionResult.FAIL.name:
            return I18.assistanceFailMessageSubject(m.failReason, m.toFieldXYZ);
        case MissionResult.UNKNOWN.name:
            return I18.f("SYSTEM_MESSAGE_SUBJECT_ASSISTANCE_ARRIVED");
        case MissionResult.CANCELED.name:
            return I18.f("SYSTEM_MESSAGE_SUBJECT_ASSISTANCE_CANCELED");
    }
    return superMethod(MissionAssistanceMessageView.prototype, "getSubject", this)();
}

MissionAssistanceMessageView.prototype.createChildren = function()
{
    superMethod(MissionAssistanceMessageView.prototype, "createChildren", this)();
    
    var m = this._message;
    switch (m.result.name)
    {
        case MissionResult.FAIL.name:
            this.addText(I18.assistanceFailMessageBody(m.failReason, m.toEstateOwnerUsername,
                    m.toEstateNameAndLocation()));
            break;
        case MissionResult.UNKNOWN.name:
            this.addText(I18.f("SYSTEM_MESSAGE_BODY_ASSISTANCE_ARRIVED", m.toEstateNameAndLocation(),
                    m.estateOwner.username, m.fromEstateNameAndLocation()));
            break;
        case MissionResult.CANCELED.name:
            this.addText(I18.f("SYSTEM_MESSAGE_BODY_ASSISTANCE_CANCELED", m.toEstateOwnerUsername,
                    m.toEstateNameAndLocation()));
            break;
    }
}