function MissionCampView()
{
	callParentConstructor(MissionCampView.prototype, this);
}

extendClass(MissionCampView.prototype, SystemMessageView.prototype);

MissionCampView.prototype.getSubject = function()
{
    return this._message.result.equals(MissionResult.SUCCESS) ?
           I18.f("SYSTEM_MESSAGE_SUBJECT_CAMP_SUCCESS") : I18.f("SYSTEM_MESSAGE_SUBJECT_CAMP_FAIL");
}

MissionCampView.prototype.createChildren = function()
{
   	superMethod(MissionCampView.prototype, "createChildren", this)();
    var message = this._message;
    var army = ArmyUtils.createArmy(message.attackersForces[0].initial);
    var hero = message.estateOwner.hero;
    
    var view = COM.create("ArmyView");
    view.setUnits(message.estateOwner.race, message.estateOwner.levels, FBuff.hasBuff(message.estateOwner.buffs, BuffType.MONSTER_RACE, null, 0));
    view.setCount(army);
    view.setHero(message.estateOwner.hero, message.estateOwner.race);

	switch (message.result.name) 
    {
        case "SUCCESS":
            var text1 = this.createText(I18.f("FROM") +" "+ message.fromEstateNameAndLocation());
            this.addLine(text1);
            
            var text2 = this.createText(I18.f("TO") +" "+ message.toEstateNameAndLocation());
            this.addLine(text2);
            
            this.addLine(this.createText(I18.f("ARMY")));
            this.addLine(view.DOM);
            break;
        case "FAIL":
            this.addText(I18.f("SYSTEM_MESSAGE_BODY_CAMP_FAIL",message.fromEstateNameAndLocation(), message.toFieldXYZ));
            break;
    }
}