function MissionMoveArmyView()
{
	callParentConstructor(MissionMoveArmyView.prototype, this);
}

extendClass(MissionMoveArmyView.prototype, SystemMessageView.prototype);

MissionMoveArmyView.prototype.getSubject = function()
{
    return this._message.result.equals(MissionResult.SUCCESS) ?
           I18.f("SYSTEM_MESSAGE_SUBJECT_MOVE_ARMY_SUCCESS") : I18.f("SYSTEM_MESSAGE_SUBJECT_MOVE_ARMY_FAIL");
}

MissionMoveArmyView.prototype.createChildren = function()
{
    superMethod(MissionMoveArmyView.prototype, "createChildren", this)();
        
    var message = this._message;
    var army = ArmyUtils.createArmy(message.attackersForces[0].initial);
    var hero = message.estateOwner.hero;
    
    var view = COM.create("ArmyView");
    view.setUnits(message.estateOwner.race, message.estateOwner.levels, FBuff.hasBuff(message.estateOwner.buffs, BuffType.MONSTER_RACE, null, message.tick));
    
    view.setCount(army);
    view.setHero(message.estateOwner.hero, message.estateOwner.race);
    
	switch (message.result.name) 
	{
		case "SUCCESS":
			this.addLine(this.createText(I18.f("FROM") + " "), this.createText(message.fromEstateNameAndLocation()));
			this.addLine(this.createText(I18.f("TO") + " "), this.createText(message.toEstateNameAndLocation()));

		    this.addLine(this.createText(I18.f("ARMY")));
		    this.addLine(view.DOM);
		    
		    break;
		case "FAIL":
		    this.addText(I18.f("SYSTEM_MESSAGE_BODY_MOVE_ARMY_FAIL",message.fromEstateNameAndLocation(), message.toFieldXYZ));
		    break;
    }
}
