function ConstantDurationMoveArmyDialog()
{
	callParentConstructor(ConstantDurationMoveArmyDialog.prototype, this);
	
	this.constantDuration = -1;
	
	this.__defineGetter__("missionMoveArmyOrder", this.getMissionMoveArmyOrder);
}

extendClass(ConstantDurationMoveArmyDialog.prototype, MissionMoveArmyDialog.prototype);

ConstantDurationMoveArmyDialog.prototype.setupParentComponentsVisibility = function()
{
    superMethod(ConstantDurationMoveArmyDialog.prototype, "setupParentComponentsVisibility", this)();
    
    COM(this.parentDialog.speedSlider).selectedIndex = 3;
    COM(this.parentDialog.speedSlider).disabled = true;
}

ConstantDurationMoveArmyDialog.prototype.setConstantDuration = function(cd)
{
    this.constantDuration = cd;
    if (this.missionOrder)
    {
        this.missionOrder.constantDuration = cd;
    }
}

ConstantDurationMoveArmyDialog.prototype.getMissionMoveArmyOrder = function()
{
    return this.missionOrder;
}

ConstantDurationMoveArmyDialog.prototype.checkMissionConstraints = function(estate)
{
    if (!superMethod(ConstantDurationMoveArmyDialog.prototype, "checkMissionConstraints", this)(estate))
    {
        return false;
    }
    else if (this.missionMoveArmyOrder.constantDuration > this.missionMoveArmyOrder.normalDuration)
    {
        this.setNotification(I18.f("CAST_ERROR_TO_SMALL_DISTANCE"));
        return false;
    }
    else
    {
        return true;
    }
}

ConstantDurationMoveArmyDialog.prototype.createMissionOrder = function()
{
    superMethod(ConstantDurationMoveArmyDialog.prototype, "createMissionOrder", this)();
    this.setConstantDuration(this.constantDuration);
}

ConstantDurationMoveArmyDialog.prototype.onArriveTimeTooltip = function(e)
{
    var tip = NumberEffectTip.createSpeedTip("MISSION_DURATION", this.constantDuration, [], 0, this.constantDuration, this.missionOrder.getFromEstate().owner.username);
    TipDialog.create(tip);
}
