function EspionageDialog()
{
	callParentConstructor(EspionageDialog.prototype, this);
}

extendClass(EspionageDialog.prototype, InstantActionDialog.prototype);

EspionageDialog.prototype.getSpecialUnitType = function()
{
    return UnitType.SPY;
}

EspionageDialog.prototype.createMissionOrder = function()
{
    this.missionOrder = new MissionEspionageOrder();
}

EspionageDialog.prototype.setOrderCount = function(value)
{
    this.missionOrder.count = value*1;
}

EspionageDialog.prototype.onResult = function(order)
{
    var spyCount = order.count;
    if (this.parentDialog.estate && this.target.estate)
    {
        Service.city.callMethod("performEspionage", [this.parentDialog.estate.id, this.target.estate.id, spyCount],
            $.proxy(function(result)
            {
                this.parentDialog.close();
                if (result.estate.accessInsideView)
                {
                    Events.onShowEspionageResult.fire(result);
                }
                else
                {
                    COM.create("EspionageResultDialog").popup(null, result);
                }
            }, this),
            $.proxy(function(e)
            {
                if (e.__className__ == "EstateNotFoundException")
                {
                    Alert.create(e.getMessage());
                    return true;
                }
                
                this.parentDialog.close();
                return false;
            }, this));
    }
}

EspionageDialog.prototype.getNecessaryScience = function()
{
    return Science.ESPIONAGE;
}