function InstantActionDialog()
{
	callParentConstructor(InstantActionDialog.prototype, this);
	
	this.oldEstate = null;
}

extendClass(InstantActionDialog.prototype, MissionDialogChild.prototype);

InstantActionDialog.prototype.onApply = function()
{
    this.setOrderCount(COM(this.parentDialog.specialUnitCount).value);
    superMethod(InstantActionDialog.prototype, "onApply", this)();
}

InstantActionDialog.prototype.tick = function()
{
    var e = this.info.estate;
    var count = Math.floor(e.countFreeSpecialUnits(this.getSpecialUnitType()));
    COM(this.parentDialog.specialUnitCount).max = count;
    if (!this.oldEstate || !e.id.equals(this.oldEstate.id))
    {
        this.oldEstate = e;
        COM(this.parentDialog.specialUnitCount).value = count;
    }
    this.parentDialog.maxUnits.innerHTML = I18.f("FROM_N", count);
    if (count == 0)
    {
        if (this.info.estate.hasSpecialUnits(this.getSpecialUnitType()))
        {
            this.parentDialog.specialUnitsInUnavailableSector(this.getSpecialUnitType());
        }
        else
        {
            this.parentDialog.noSpecialUnitsAvailable(this.getSpecialUnitType());
        }
    }
    else if (!this.info.estate.location.isInRadiusFrom(this.target.getLocationXYZ(), FUser.CURRENT_USER.getScienceValue(this.getNecessaryScience())))
    {
        this.setNotification(I18.targetLocatedTooFar(this.getSpecialUnitType()));
        //COM(this.parentDialog.apply).enabled = false;
    }
    else if (COM(this.parentDialog.specialUnitCount).value == 0)
    {
        this.setNotification(I18.selectedNoneUnitsMessage(this.getSpecialUnitType()));
        //COM(this.parentDialog.apply).enabled = false;
    }
}

InstantActionDialog.prototype.getOriginId = function(combo)
{
    var prevId = FUser.CURRENT_USER.settings.getLastFromCityId(this.getSpecialUnitType(), combo.selected.id);
    return combo.containsId(prevId) ? prevId : combo.selected.id;
}

InstantActionDialog.prototype.getSpecialUnitType = function()
{
}

InstantActionDialog.prototype.setOrderCount = function(value)
{
}

InstantActionDialog.prototype.getNecessaryScience = function()
{
}

InstantActionDialog.prototype.setupParentComponentsVisibility = function()
{
    UI.show(true, [this.parentDialog.specialUnitImage, this.parentDialog.specialUnitCountRow, this.parentDialog.fromCityBox]);
}

InstantActionDialog.prototype.updateTicks = function()
{
}

InstantActionDialog.prototype.setupParentComponentsProperties = function()
{
    //this.parentDialog.goal.innerHTML = I18.actionGoal(this.getSpecialUnitType());
	this.parentDialog.setCaption(I18.actionGoal(this.getSpecialUnitType()));
    var ut = COM(this.parentDialog.specialUnit);
    ut.utype = this.getSpecialUnitType();
    ut.showCount = false;
    ut.update(0, -1);
    this.updateFromEstate();
}

InstantActionDialog.prototype.updateFromEstate = function()
{
    var unitsCount = this.parentDialog.estate.countFreeSpecialUnits(this.getSpecialUnitType());
    COM(this.parentDialog.specialUnitCount).max = unitsCount;
    COM(this.parentDialog.specialUnitCount).value = unitsCount;
    COM(this.parentDialog.citiesCombo).updateCities(FUser.LINKS);
    COM(this.parentDialog.citiesCombo).cityId = this.parentDialog.estate.id;
}