function MissionAssistanceDialog()
{
	callParentConstructor(MissionAssistanceDialog.prototype, this);
	
	this.changeListener = $.proxy(this.changeListener, this);
}

extendClass(MissionAssistanceDialog.prototype, MilitaryMissionDialog.prototype);

MissionAssistanceDialog.prototype.setupParentComponentsVisibility = function()
{
    UI.show(true, [this.parentDialog.etaGridRow, this.parentDialog.assistanceBox, this.parentDialog.missionCostBox]);
    this.showTravelMissionsComponents();
    COM(this.parentDialog.etaGridRow).showReturnTime = true;
    this.showRetreatLimit();
}

MissionAssistanceDialog.prototype.changeListener = function(e)
{
    var input = COM(e.currentTarget);
	if(!input) return;
	
    if(input.value < FConfig.ASSISTANCE_DURATION_MIN / Tick.TICKS_PER_HOUR)
    {
    	input.value = FConfig.ASSISTANCE_DURATION_MIN / Tick.TICKS_PER_HOUR;
    }
    
    if(input.value > FConfig.ASSISTANCE_DURATION_MAX / Tick.TICKS_PER_HOUR)
    {
    	input.value = FConfig.ASSISTANCE_DURATION_MAX / Tick.TICKS_PER_HOUR;
    }
	
	input.value = Math.floor(input.value);
    
    this.missionOrder.assistanceDurationTicks = input.value * Tick.TICKS_PER_HOUR;
	
    this.parentDialog.tick();
}

MissionAssistanceDialog.prototype.setupParentComponentsProperties = function()
{
    //this.parentDialog.goal.innerHTML = I18.f("MISSION_GOAL_ASSISTANCE");
	this.parentDialog.setCaption(I18.f("MISSION_SQUAD_WAGE"));
    this.parentDialog.costLabel.innerHTML = I18.f("MISSION_SQUAD_WAGE");
    COM(this.parentDialog.assistanceDuration).value = FConfig.ASSISTANCE_DURATION_MIN / Tick.TICKS_PER_HOUR;
    $(this.parentDialog.assistanceDuration).on("change", this.changeListener);
}


MissionAssistanceDialog.prototype.reset = function()
{
    superMethod(MissionAssistanceDialog.prototype, "reset", this)();
    $(this.parentDialog.assistanceDuration).off("change", this.changeListener);
}

MissionAssistanceDialog.prototype.createMissionOrder = function()
{
    this.missionOrder = new MissionAssistanceOrder();
}

MissionAssistanceDialog.prototype.onApply = function()
{
    superMethod(MissionAssistanceDialog.prototype, "onApply", this)();
    this.missionOrder.retreatLimit = COM(this.parentDialog.retreatLimit).value;
}


MissionAssistanceDialog.prototype.tick = function()
{
    superMethod(MissionAssistanceDialog.prototype, "tick", this)();
    if (this.parentDialog.prepareInfo.retreatLimitForAssistance != -1)
    {
        COM(this.parentDialog.retreatLimit).disabled = true;
        COM(this.parentDialog.retreatLimit).value = this.parentDialog.prepareInfo.retreatLimitForAssistance;
        //parentDialog.retreatLimit.toolTip = I18.ASSISTANCES_MUST_HAVE_SAME_RETREAT_LIMIT.f();
    }
    else
    {
        COM(this.parentDialog.retreatLimit).disabled = false;
        //parentDialog.retreatLimit.toolTip = "";
    }
}