function MissionCampDialog()
{
	callParentConstructor(MissionCampDialog.prototype, this);
}

extendClass(MissionCampDialog.prototype, MilitaryMissionDialog.prototype);

MissionCampDialog.prototype.setupParentComponentsProperties = function()
{
    //this.parentDialog.goal.innerHTML = I18.f("MISSION_GOAL_CAMP");
	this.parentDialog.setCaption(I18.f("MISSION_GOAL_CAMP"));
}

MissionCampDialog.prototype.setupParentComponentsVisibility = function()
{
    this.showTravelMissionsComponents();
    UI.show(true, [this.parentDialog.campTravelCostBox, this.parentDialog.campCostBox]);
}

MissionCampDialog.prototype.createMissionOrder = function()
{
    this.missionOrder = new MissionCampOrder();
}

MissionCampDialog.prototype.checkMissionConstraints = function(estate)
{
    if (!superMethod(MissionCampDialog.prototype, "checkMissionConstraints", this)(estate))
    {
        return false;
    }
    else if (!COM(this.equalizer).heroSelected)
    {
        this.setNotification(I18.f("MISSION_START_ERROR_HERO_IS_REQUIRED"));
        return false;
    }
    else if (this.parentDialog.prepareInfo.campsLimitReached)
    {
        this.setNotification(I18.f("MISSION_START_ERROR_CAMPS_LIMIT_REACHED"));
        return false;
    }
    return true;
}


MissionCampDialog.prototype.tick = function()
{
    superMethod(MissionCampDialog.prototype, "tick", this)();
    
    var totalCost = this.missionOrder.getCostGold();
    var campCost = this.missionOrder.getBaseExecutionCost();
    var travelCost = totalCost - campCost;
    COM(this.parentDialog.travelCost).update(Funds.createWithGold(NumberUtils.ceil(travelCost)), this.race);
    COM(this.parentDialog.travelCost).capacity = this.parentDialog.isEnoughCost() ? this.estate.bank.copy() : new Funds();
    COM(this.parentDialog.campCost).update(Funds.createWithGold(NumberUtils.ceil(campCost)), this.race);
    COM(this.parentDialog.campCost).capacity = this.parentDialog.isEnoughCost() ? this.estate.bank.copy() : new Funds();
}