function MissionDetailsTip()
{
    callParentConstructor(MissionDetailsTip.prototype, this);
}

extendClass(MissionDetailsTip.prototype, Dialog.prototype);

MissionDetailsTip.create = function(m, showInitiator, snapshotTick)
{
    var mdv = COM.create("MissionDetailsTip");
    mdv.update(m.owner.race, m.army, m.ownerUnitLevels, m.hero, m.armyBuffs, m.armyFaded, m, showInitiator, snapshotTick);
    return mdv;
}

MissionDetailsTip.createTipText = function(text, info)
{
    var l = document.createElement("span");
    l.innerHTML = text;
    l.style.textDecoration = "underline";
    l.style.fontWeight = "bold";
    COM.bindExclusiveClick(l, function()
    {
        if (!info.army.isEmpty() || info.hero)
        {
            var mdv = COM.create("MissionDetailsTip");
            mdv.update(info.race, info.army, info.unitLevels, info.hero, [], false, null, false, 0);
            mdv.popup()
        }
        else
        {
            Alert.create(I18.f("NOTHING"));
        }
    });

    return l;
}

MissionDetailsTip.prototype.popup = function(parent)
{
    superMethod(MissionDetailsTip.prototype, "popup", this)(parent);

    this.skin = "black";
    this.header.style.display = "none";
}

MissionDetailsTip.prototype.update = function(ownerRace, army, ownerUnitLevels, hero, armyBuffs, armyFaded, m, showInitiator, snapshotTick)
{
    COM(this.unitView).race = ownerRace;
    UI.show(army && !army.isZero(), [this.armyBox, this.lootCaption], $.proxy(function()
    {
        this.lootCaption.innerHTML = (m && m.className == "MissionCamp") ? I18.f("MISSION_CAMP") : I18.f("MISSION_LOOT");

        var unitTypes = UnitType.MILITARY;
        var monsterRace = FBuff.hasBuff(armyBuffs, BuffType.MONSTER_RACE, null, snapshotTick >= 0 ? snapshotTick : Tick.now())

        for (var i = 0; i < unitTypes.length; i++)
        {
            var mut = unitTypes[i];
            if (army.getValue(mut) == 0)
            {
                continue;
            }
            var muv = COM.create("MilitaryUnitView");
            muv.small = true;
            muv.labelStyle = 'dark';
            muv.initUnitView(ownerRace, mut, ownerUnitLevels[i], monsterRace ? Race.MONSTER : null);
            muv.initCount(army.getValue(mut), armyBuffs, armyFaded);
            this.armyView.appendChild(muv.DOM);
        }

    }, this));

    UI.show(m && m.isSpecial(), [this.unitView], $.proxy(function ()
    {
        COM(this.unitView).utype = m.specialUnit;
        COM(this.unitView).update(1, m.unitCount);
    }, this));

    UI.show(!!hero, [this.heroView], $.proxy(function ()
    {
        COM(this.heroView).update(hero, ownerRace);
    }, this));

    var race = ownerRace;
    var showRes = m && !m.res.isZero();

    if (showRes)
    {
        if (m.specialUnit && m.specialUnit.name == UnitType.SETTLER.name || m.className == "MissionCamp")
        {
            showRes = m.state.name != MissionState.RETURNING.name;
        }
        else
        {
            race = m.to.race ? m.to.race : Race.MONSTER;
        }
    }

    UI.show(showRes, [this.resources], $.proxy(function ()
    {
        COM(this.resView).update(m.res, race);
    }, this));

    this.ownerLabel.innerHTML = !m ? "" : I18.f("OPPONENT_ARMY", FUser.getUserNameForMessages(m.owner.username));

    UI.show(m && showInitiator, [this.initiatorLabel], $.proxy(function ()
    {
        this.initiatorLabel.innerHTML = I18.f("GROUP_INITIATOR", FUser.getUserNameForMessages(m.groupInitiator)
                + (m.groupInitiatorAttackIndex >= 0 ? " (" + (m.groupInitiatorAttackIndex + 1) + ")" : "" ));
    }, this));
}