function MissionDialogParent()
{
	callParentConstructor(MissionDialogParent.prototype, this);
	
	this.target = null;
	this.child = null;
	this._prepare = null;
	this.shouldStart = false;
	this._isEnoughCost = null;
	
	this.childClass = "";
	
	this.__defineGetter__("estate", this.getEstate);
	this.__defineGetter__("prepareInfo", this.getPrepareInfo);
	this.__defineGetter__("isAttackOrAssistance", this.getIsAttackOrAssistance);
	this.__defineGetter__("selectedGoal", this.getSelectedGoal);
	
	this.onChangeSpeed = $.proxy(this.onChangeSpeed, this);
}

extendClass(MissionDialogParent.prototype, Dialog.prototype);

MissionDialogParent._instance = null;

MissionDialogParent.create = function(childClass)
{
    var result;
    
    if (MissionDialogParent._instance)
    {
        MissionDialogParent._instance.shouldStart = true;
        MissionDialogParent._instance.reset();
        result = MissionDialogParent._instance;
    }
    else
    {
        result = COM.create("MissionDialogParent");
    }
    
    result.childClass = childClass;
    result.child = MissionDialogChild.create(childClass, result);
    
    return result;
}

MissionDialogParent.prototype.onInviteOrAssistChange = function() {};
MissionDialogParent.prototype.onInviteComboChange = function() {};
MissionDialogParent.prototype.onCityChange = function() {};
MissionDialogParent.prototype.onResult = function() {};
MissionDialogParent.prototype.onRetreatLimitTip = function() {};

MissionDialogParent.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.apply, $.proxy(this.onApply, this));
	
	COM(this.retreatLimit).min = FConfig.MIN_RETREAT_PERCENT;
	COM(this.retreatLimit).max = 100;
	COM(this.retreatLimit).value = FConfig.MIN_RETREAT_PERCENT;
	
	COM(this.assistanceDuration).min = FConfig.ASSISTANCE_DURATION_MIN / Tick.TICKS_PER_HOUR;
	COM(this.assistanceDuration).max = FConfig.ASSISTANCE_DURATION_MAX / Tick.TICKS_PER_HOUR;
	
	COM(this.citiesCombo).onCityChange = $.proxy(this.cityChanged, this);
	
	COM(this.specialUnit).race = FUser.CURRENT_USER.race;
	
	var sl = COM(this.speedSlider);
	sl.addOption(0, I18.f("MISSION_SPEED_SLOW"));
	sl.addOption(1, I18.f("MISSION_SPEED_NORMAL"));
	sl.addOption(2, I18.f("MISSION_SPEED_FAST"));
	sl.addOption(3, I18.f("MISSION_SPEED_VERY_FAST"));
	sl.selectedIndex = 3;
	$(sl.DOM).on("change", this.onChangeSpeed);
	sl.refresh();
	
	sl = COM(this.inviteOrAssist);
	sl.addOption(0, I18.f("INVITE_TO_ATTACK"));
	sl.addOption(1, I18.f("JOIN_MISSION"));
	sl.selectedIndex = 0;
	$(sl.DOM).on("change", $.proxy(function()
	{
		this.onInviteOrAssistChange();
	}, this));
	sl.refresh();
	
	$(this.inviteCombo).on("change", $.proxy(function()
	{
		this.onInviteComboChange();
	}, this));
	
	sl = COM(this.goalRadioButtons);
	this.lootRadio = sl.addOption(MissionAttackGoal.LOOT, I18.f("MISSION_GOAL_LOOT"));
	this.slavesRadio = sl.addOption(MissionAttackGoal.SLAVES_TAKING, I18.f("MISSION_GOAL_SLAVESTAKING"));
	this.rescueHeroRadio = sl.addOption(MissionAttackGoal.RESCUE_HERO, I18.f("MISSION_GOAL_RESCUEHERO"));
	this.destroyRadio = sl.addOption(MissionAttackGoal.DESTROY_BUILDINGS, "");
	this.captureRadio = sl.addOption(MissionAttackGoal.CAPTURE, I18.f("MISSION_GOAL_CAPTURE"));
	this.captureCastleRadio = sl.addOption(MissionAttackGoal.CAPTURE_CASTLE, I18.f("MISSION_GOAL_CAPTURECASTLE"));
	this.destroyCampRadio = sl.addOption(MissionAttackGoal.DESTROY_CAMP, I18.f("MISSION_GOAL_DESTROYCAMP"));
	this.destroyCityRadio = sl.addOption(MissionAttackGoal.DESTROY_CITY, I18.f("MISSION_GOAL_DESTROYCITY"));
	this.destroyCatapultRadio = sl.addOption(MissionAttackGoal.DESTROY_CATAPULT, I18.f("MISSION_GOAL_DESTROYCATAPULT"));
	$(sl.DOM).on("change", $.proxy(this.tick, this));
	sl.refresh();
	
	this.allGoalRadios = [this.lootRadio, this.slavesRadio, this.rescueHeroRadio, this.destroyRadio, this.captureRadio, this.captureCastleRadio, this.destroyCampRadio, this.destroyCityRadio, this.destroyCatapultRadio];
	
	this.setCaption(I18.f("MISSION_DIALOG_TITLE"));
	
	COM(this.cost).alwaysShow = [Resource.GOLD];
	COM(this.travelCost).alwaysShow = [Resource.GOLD];
	COM(this.campCost).alwaysShow = [Resource.GOLD];
	
	COM.bindExclusiveClick(this.capacity, $.proxy(this.onCapacityTooltip, this));
	COM.bindExclusiveClick(this.deathRate, $.proxy(this.onDeathTooltip, this));
	
	this.scroll = new iScroll(this.contentContainer.parentNode, {scrollbarColor: '#784f0b'});
}

MissionDialogParent.prototype.popup = function(parent)
{
	superMethod(MissionDialogParent.prototype, "popup", this)(parent);
	
	this.fullScreen();
}

MissionDialogParent.prototype.onShow = function()
{
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
}

MissionDialogParent.prototype.__destruct = function()
{
	MissionDialogParent._instance = null;
}

MissionDialogParent.prototype.fitLayout = function(container)
{
	superMethod(MissionDialogParent.prototype, "fitLayout", this)(container);
	
	/*
	this.windowWrapper.style.width = this.content.offsetWidth+"px";
	this.windowWrapper.style.height = (this.wrapper.offsetHeight - this.header.offsetHeight - 16)+"px";
	console.log(this.wrapper.offsetHeight, this.header.offsetHeight);
	console.log(this.content.offsetHeight);
	*/
	
	this.windowWrapper.style.width = this.content.offsetWidth+"px";
	this.windowWrapper.style.height = this.content.offsetHeight+"px";
	
	this.contentHolder.style.width = (this.content.offsetWidth-4) + "px";
	this.contentHolder.style.height = (this.content.offsetHeight-4) + "px";
}

MissionDialogParent.prototype.onInit = function()
{
    MissionDialogParent._instance = this;
    this.reset();
    this.start();
}

MissionDialogParent.prototype.reset = function()
{
    $(this.childHolder).empty();
    UI.show(false, [this.retreatLimitBox, this.goalHBox, this.goalRadioHBox, this.fromCityBox, this.selectButton, this.selectButtonLabel, this.specialUnitImage,
        this.specialUnitCountRow, this.alliedAttackBox, this.assistanceBox, this.deathBox, this.etaGridRow, this.missionCostBox,
        this.capacityBox, this.capacity, this.missionSpeedBox, this.moveResourcesSpacer, this.campTravelCostBox, this.campCostBox]);
    
    COM(this.inviteOrAssist).selectedIndex = 0;
    COM(this.inviteCombo).selectedIndex = 0;
}

MissionDialogParent.prototype.getSpeed = function()
{
	return COM(this.speedSlider).selectedOption.value;
}

MissionDialogParent.prototype.getGoal = function()
{
	var item = COM(this.goalRadioButtons).selectedItem;
	return item ? item.data : null;
}

MissionDialogParent.prototype.setSpeed = function(val)
{
	COM(this.speedSlider).selectedIndex = val;
}

MissionDialogParent.prototype.start = function()
{
    if(this.child)
    {
	    this.childHolder.appendChild(this.child.DOM);
	    this.childHolder.style.display = "";
    }
    else
    {
    	this.childHolder.style.display = "none";
    	return;
    }

    var childOrder = this.child.missionOrder;

    this.child.updateFromEstate();
    this.setInitialSpeedValue();
    childOrder.speed = this.getSpeed();
    childOrder.setFromEstate(this.estate);
    childOrder.setToField(this.target);
    childOrder.toFieldXYZ = this.target.getLocationXYZ();
    childOrder.allyAcceleration = MissionOrder.isAcceleratedByOwnedField(this.target, FUser.CURRENT_USER);

    if (this.target.hasEstate())
    {
        this.targetCityName.innerHTML = Strings.safeHtml(I18.formatEstateName(this.target.estate.getName(), childOrder.toFieldXYZ));
        this.targetUserName.innerHTML = Strings.safeHtml(FUser.getUserNameForMessages(this.target.estate.ownerUserName));
    }
    else
    {
        this.targetCityName.innerHTML = Strings.safeHtml(this.target.toString());
        this.targetUserName.innerHTML = Strings.safeHtml(I18.f("ESTATE_OF_NOONE"));
    }

    this.updateGoal();
    childOrder.refreshTravelDuration();
    
    COM(this.etaGridRow).onArriveTimeTooltip = $.proxy(this.child.onArriveTimeTooltip, this.child);
    COM(this.etaGridRow).onReturnTimeTooltip = $.proxy(this.child.onReturnTimeTooltip, this.child);
    
    this.tick();
}

MissionDialogParent.prototype.setInitialSpeedValue = function()
{
    this.setSpeed(this.child.missionOrder.getPreferedSpeed());
}

MissionDialogParent.prototype.init = function(prepare, target)
{
    this._prepare = prepare;
    this.target = target;
    this.onInit();
    this.child.init();
    if (this.shouldStart)
    {
        this.shouldStart = false;
        this.start();
    }
}

MissionDialogParent.prototype.forceUpdate = function()
{
	console.log(this);
}

MissionDialogParent.prototype.update = function(prepare)
{
    this._prepare = prepare;
    this.child.update(prepare);
    this.tick();
}

MissionDialogParent.prototype.getOriginId = function(citiesCombo)
{
    return this.child.getOriginId(citiesCombo);
}

MissionDialogParent.prototype.tick = function()
{
    this.child.updateTicks();
    COM(this.etaGridRow).update(this.child.missionOrder);
    this.updateCost();

    this.setNotification();
    COM(this.apply).enabled = !Quarantine.contains(this);

    //this.validateNow();
    this.child.tick();
    /*
    if (this.child.hasDeathBuffs)
    {
        Style.assignTip(deathRate, " ");
    } else {
        Style.removeTip(deathRate);
    }
    */
}

MissionDialogParent.prototype.setNotification = function(text, color)
{
    //this.notification.innerHTML = text;
    //this.notification.style.color = Effects.RED;
    
    COM(this.apply).reason = text;
}

MissionDialogParent.prototype.updateCost = function()
{
    var requiredCost = this.child.missionOrder.calculateCost();
    var cost = COM(this.cost);
    cost.capacity = this.estate.bank.copy();
    cost.update(requiredCost, this.estate.race);
    this._isEnoughCost = cost.capacity.greaterOrEqualsTo(requiredCost);
}

MissionDialogParent.prototype.getEstate = function()
{
    return this._prepare.estate;
}

MissionDialogParent.prototype.getPrepareInfo = function()
{
    return this._prepare;
}

MissionDialogParent.prototype.updateGoal = function()
{
    var text = "";
    var destroyRadioVisible = false;
    var captureRadioVisible = false;
    
    var ic = COM(this.inviteCombo).selectedItem;

    if (COM(this.inviteOrAssist).selectedIndex == 1 && ic && ic.value.__className__ == "FMissionGroup")
    {
        this.lockGoal(ic.value.goal);
    }
    else if (this.target.hasEstate() && this.target.estate.hasImprisonedHero)
    {
        this.lockGoal(MissionAttackGoal.RESCUE_HERO);
    }
    else if (this.target.hasCatapult())
    {
        this.lockGoal(MissionAttackGoal.DESTROY_CATAPULT);
    }
    else
    {
        UI.show(!this.target.hasCatapult(), [this.lootRadio]);
        this.lootRadio.DOM.style.display = "";
        this.slavesRadio.DOM.style.display = !this.target.hasStonehenge() ? "" : "none";
        destroyRadioVisible = this.target.hasPit() || this.target.hasLake() || this.target.hasCity() || this.target.hasCastle() || this.target.hasGrail();
        this.destroyRadio.DOM.style.display = destroyRadioVisible ? "" : "none";
        captureRadioVisible = this.target.hasPit() || this.target.hasMine() || this.target.hasLake() || this.target.hasGrotto() || this.target.hasGrail();
        this.captureRadio.DOM.style.display = captureRadioVisible ? "" : "none";
        this.captureCastleRadio.DOM.style.display = this.target.hasCastle() && FUser.CURRENT_USER.isInRegisteredClan() ? "" : "none";
        this.destroyCampRadio.DOM.style.display = this.target.hasCamp() ? "" : "none";
        this.destroyCityRadio.DOM.style.display = this.target.hasCity() && FConfig.IS_SURVIVAL ? "" : "none";
        this.destroyCatapultRadio.DOM.style.display = this.target.hasCatapult() ? "" : "none";
        this.rescueHeroRadio.DOM.style.display = "none";
    }
    
    if (destroyRadioVisible)
    {
        if (this.target.hasPit())
        {
            text = I18.f("MISSION_GOAL_DESTROYBUILDINGS_IN_PIT");
        }
        else if (this.target.hasLake())
        {
            text = I18.f("MISSION_GOAL_DESTROYBUILDINGS_IN_LAKE");
        }
        else if (this.target.hasGrail())
        {
            text = I18.f("MISSION_GOAL_DESTROYBUILDINGS_IN_GRAIL");
        }
        else if (this.target.hasCity())
        {
            text = I18.f("MISSION_GOAL_DESTROYBUILDINGS_IN_SECTORS");
        }
        else
        {
            text = I18.f("MISSION_GOAL_DESTROYBUILDINGS");
        }
		
		text = I18.f("MISSION_GOAL_DESTROYBUILDINGS");
		
        this.destroyRadio.label = text;
        this.destroyRadio.refresh();
    }

    if (captureRadioVisible)
    {
        if (this.target.hasPit())
        {
            text = I18.f("CAPTURE_PIT_FORTIFICATION_WARN");
        }
        else if (this.target.hasLake())
        {
            text = I18.f("CAPTURE_LAKE_FORTIFICATION_WARN");
        }
        else if (this.target.hasGrail())
        {
            text = I18.f("CAPTURE_GRAIL_FORTIFICATION_WARN");
        }
        //captureRadio.toolTip = text;
        //captureRadio.setStyle("textDecoration", text != "" ? "underline" : "none");
    }
    
    if (this.captureCastleRadio.DOM.style.display != "none")
    {
        text = I18.f("CAPTURE_CASTLE_FORTIFICATION_WARN");
        //captureRadio.toolTip = text;
        //captureRadio.setStyle("textDecoration", "underline");
    }
    if (this.destroyCityRadio.DOM.style.display != "none")
    {
        //destroyCityRadio.toolTip = I18.DESTROY_CITY_FORTIFICATION_WARN.f();
        //destroyCityRadio.setStyle("textDecoration", "underline");
    }
}

MissionDialogParent.prototype.lockGoal = function(goal)
{
    var val = goal.name ? goal.name : goal;
	
	for(var i=0; i<this.allGoalRadios.length; i++)
	{
		var b = COM(this.allGoalRadios[i]).value.name == val;
		this.allGoalRadios[i].DOM.style.display = b ? "" : "none";
		if(b)
		{
			COM(this.goalRadioButtons).selectedIndex = i;
		}
	}
}

MissionDialogParent.prototype.getRealRetreatLimit = function()
{
    return COM(this.retreatLimit).value;
}

MissionDialogParent.prototype.isMissionsLimitReached = function()
{
    return this._prepare.missionsCount >= FUser.CURRENT_USER.getScienceValue(Science.ARMY_MANAGEMENT) + FConfig.MAX_MISSIONS;
}

MissionDialogParent.prototype.isEnoughCost = function()
{
    return this._isEnoughCost;
}

MissionDialogParent.prototype.cityChanged = function(c)
{
    this.onCityChange(c.id);
}

MissionDialogParent.prototype.onApply = function()
{
    if(COM(this.apply).warning)
    {
    	Alert.create(COM(this.apply).warning, "", $.proxy(function()
    	{
    		this.doApply();
    	}, this));
    }
    else
    {
    	this.doApply();
    }
}

MissionDialogParent.prototype.doApply = function()
{
	if (!Quarantine.contains(this))
    {
        Quarantine.put(this);
        COM(this.apply).enabled = false;
        this.child.onApply();
        this.onResult(this.child.missionOrder);
    }
}

MissionDialogParent.prototype.onChangeSpeed = function()
{
    this.child.missionOrder.speed = this.getSpeed();
    this.child.missionOrder.refreshTravelDuration();
    this.tick();
}

MissionDialogParent.prototype.noSpecialUnitsAvailable = function(unitType)
{
    this.setNotification(I18.noFreeUnitsMessage(unitType));
    //COM(this.apply).enabled = false;
}

MissionDialogParent.prototype.specialUnitsInUnavailableSector = function(unitType)
{
    this.setNotification(I18.specialUnitsInUnavailableSectorMessage(unitType));
    //COM(this.apply).enabled = false;
}

MissionDialogParent.prototype.onRetreatLimitChanged = function(e)
{
    this.tick();
}

MissionDialogParent.prototype.getIsAttackOrAssistance = function()
{
    return this.childClass == "MissionAttackDialog" || this.childClass == "MissionAssistanceDialog";
}

MissionDialogParent.prototype.getSelectedGoal = function()
{
    return this.getGoal();
}

MissionDialogParent.prototype.onCapacityTooltip = function()
{
	if(this.child.onCapacityTooltip) this.child.onCapacityTooltip();
}

MissionDialogParent.prototype.onDeathTooltip = function()
{
	if(this.child.onDeathTooltip) this.child.onDeathTooltip();
}