function MissionEtaGridRow()
{
	this.singleLine = false;
	this.showReturnTime = true;
	
	this.onArriveTimeTooltip = function(){};
	this.onReturnTimeTooltip = function(){};
}

MissionEtaGridRow.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.arrivalTime, $.proxy(this.showArrivalTimeToolTip, this));
	COM.bindExclusiveClick(this.returningTime, $.proxy(this.showReturningTimeToolTip, this));
}

MissionEtaGridRow.prototype.update = function(missionOrder)
{
    if (missionOrder.hasSpeedBuffs)
    {
        if (missionOrder.isTravelDurationOverbusted())
        {
            this.arrivalTime.style.color = Style.COLOR_OVERFLOW;
            this.returningTime.style.color = Style.COLOR_OVERFLOW;
        }
        else
        {
            this.arrivalTime.style.color = Style.COLOR_POSITIVE;
            this.returningTime.style.color = Style.COLOR_POSITIVE;
        }
    }
    else
    {
        this.arrivalTime.style.color = "#000";
        this.returningTime.style.color = "#000";
    }
    
    //this.arrivalPeriod.innerHTML = Tick.toTimeLeft(missionOrder.arriveTick - missionOrder.startTick);
    //this.arrivalTime.innerHTML = Tick.toTimeFutureSeconds(missionOrder.arriveTick);
    //this.returningPeriod.innerHTML = Tick.toTimeLeft(missionOrder.returnTick - missionOrder.startTick);
    //this.returningTime.innerHTML = Tick.toTimeFutureSeconds(missionOrder.returnTick);
    
    this.arrivalTime.innerHTML = I18.getMegaString("THIS_HAPPENS_IN_SECS", {time: Tick.toTimeFutureSeconds(missionOrder.arriveTick), period: Tick.toTimeLeft(missionOrder.arriveTick - missionOrder.startTick)});
    this.returningTime.innerHTML = I18.getMegaString("THIS_HAPPENS_IN_SECS", {time: Tick.toTimeFutureSeconds(missionOrder.returnTick), period: Tick.toTimeLeft(missionOrder.returnTick - missionOrder.startTick)});
    
    if(this.showReturnTime)
    {
    	//this.returnTimeLabel.innerHTML = I18.f("MISSION_ETA");
    	this.returnBox.style.display = "";
    }
    else
    {
    	//this.returnTimeLabel.innerHTML = I18.f("MISSION_TIME_OF_ARRIVAL");
    	this.returnBox.style.display = "none";
    }
}

MissionEtaGridRow.prototype.resetComponentProperties = function()
{
}

MissionEtaGridRow.prototype.showArrivalTimeToolTip = function()
{
	this.onArriveTimeTooltip();
}

MissionEtaGridRow.prototype.showReturningTimeToolTip = function()
{
	this.onReturnTimeTooltip();
}