function MissionSettlerDialog()
{
	callParentConstructor(MissionSettlerDialog.prototype, this);
}

extendClass(MissionSettlerDialog.prototype, MissionDialogChild.prototype);

MissionSettlerDialog.prototype.setupParentComponentsVisibility = function()
{
    UI.show(true, [this.parentDialog.specialUnitImage, this.parentDialog.missionCostBox]);
    this.showTravelMissionsComponents();
}

MissionSettlerDialog.prototype.setupParentComponentsProperties = function()
{
    //this.parentDialog.goal.innerHTML = I18.f("MISSION_GOAL_SETTLER");
	this.parentDialog.setCaption(I18.f("MISSION_GOAL_SETTLER"));
    this.parentDialog.costLabel.innerHTML = I18.f("FOUND_NEW_CITY_COST");
    
    var su = COM(this.parentDialog.specialUnit);
    su.utype = UnitType.SETTLER;
    su.showCount = false;
    su.update(0, -1);
}

MissionSettlerDialog.prototype.createMissionOrder = function()
{
    this.missionOrder = new MissionSettlerOrder();
}

MissionSettlerDialog.prototype.tick = function()
{
    superMethod(MissionSettlerDialog.prototype, "tick", this)();
    
    var race = this.info.estate.race;
    COM(this.parentDialog.cost).update(this.missionOrder.getNewCityResources(race), race);
    var cap = new Funds();
    for(var i=0; i<Resource.FUNDS_RESOURCES.length; i++)
    {
    	cap.setValue(Resource.FUNDS_RESOURCES[i], Number.MAX_VALUE);
    }
    
    COM(this.parentDialog.cost).capacity = cap;
    
    if (!this.checkMissionCommonConstraints(this.estate))
    {
        //COM(this.parentDialog.apply).enabled = false;
    }
    else if (this.parentDialog.prepareInfo.citiesLimitReached)
    {
        this.setNotification(I18.f("MISSION_CITIES_LIMIT_REACHED"));
        //COM(this.parentDialog.apply).enabled = false;
    }
    else if (this.parentDialog.isMissionsLimitReached())
    {
        this.setNotification(I18.f("MISSIONS_LIMIT_REACHED"));
        //COM(this.parentDialog.apply).enabled = false;
    }
    else if (!this.info.estate.hasFreeSpecialUnits(UnitType.SETTLER))
    {
        this.parentDialog.noSpecialUnitsAvailable(UnitType.SETTLER);
    }
    else if (this.info.estate.isGateClosed())
    {
        this.setNotification(I18.getMissionEntranceClosedMessage(this.info.estate.__className__ = "FOuterEstate"));
        //COM(this.parentDialog.apply).enabled = false;
    }
}