function ObservationDialog()
{
	callParentConstructor(ObservationDialog.prototype, this);
}

extendClass(ObservationDialog.prototype, InstantActionDialog.prototype);

ObservationDialog.prototype.getSpecialUnitType = function()
{
    return UnitType.PROPHET;
}

ObservationDialog.prototype.createMissionOrder = function()
{
    this.missionOrder = new MissionObservationOrder();
}

ObservationDialog.prototype.setOrderCount = function(value)
{
    this.missionOrder.count = value*1;
}

ObservationDialog.prototype.onResult = function(order)
{
    var count = order.count;
    if (this.parentDialog.estate && this.target.estate)
    {
        Service.city.callMethod("performObservation", [this.parentDialog.estate.id, this.target.estate.id, count],
            $.proxy(function(result)
            {
                this.parentDialog.close();
                COM.create("ObservationResultDialog").popup(null, result, this.parentDialog.estate.owner.race);
            }, this),
            $.proxy(function(e)
            {
                if (e.__className__ == "EstateNotFoundException")
                {
                    e.showMessageAndStay();
                    return true;
                }
               
				this.parentDialog.close();
				
				return false;
             }, this));
    }
}


ObservationDialog.prototype.tick = function()
{
    superMethod(ObservationDialog.prototype, "tick", this)();
    
    if (this.canApply && this.info.estate.isGateClosed())
    {
        this.setNotification(this.info.estate.__className__ == "FPit" ? I18.f("CANT_OBSERVE_CAUSE_TUNNEL_IS_CLOSED") : I18.f("CANT_OBSERVE_CAUSE_GATE_IS_CLOSED"));
        this.canApply = false;
    }
}

ObservationDialog.prototype.getNecessaryScience = function()
{
    return Science.OBSERVATION;
}