function SelectBuildingToDestroyDialog()
{
	callParentConstructor(SelectBuildingToDestroyDialog.prototype, this);
	
	this.onResult = null;
	this.race = null;
	this.type = null;
	
	this.onSelect = $.proxy(this.onSelect, this);
}

extendClass(SelectBuildingToDestroyDialog.prototype, Dialog.prototype);

SelectBuildingToDestroyDialog.popup = function(race, type, onResult)
{
	var res = COM.create("SelectBuildingToDestroyDialog");
	res.setupAndPopup(race, type, onResult);
	return res;
}

SelectBuildingToDestroyDialog.prototype.setupAndPopup = function(race, type, onResult)
{
    var res = COM.create("SelectBuildingToDestroyDialog");
    this.race = race;
    this.type = type;
    this.onResult = onResult;
    this.popup();
    this.init();
}

SelectBuildingToDestroyDialog.prototype.__construct = function()
{
	this.skin = "black";
	this.headerCloseBox.style.display = "none";
	
	this.header.style.display = "none";
	
	this.scroll = new iScroll(this.scrollContainer, {scrollbarColor: '#784f0b'});
}

SelectBuildingToDestroyDialog.prototype.init = function()
{
    //this.setCaption(I18.f("SELECT_BUILDING_TO_DESTROY"));
    this.initBuildings(this.race);
}

SelectBuildingToDestroyDialog.prototype.initBuildings = function(race)
{
    //this.setCaption(I18.f("SELECT_BUILDING_TO_DESTROY"));
    
    var bt;
    for (var i = 0, len = BType.values.length; i < len; i++)
	{
		bt = BType.values[i];
		if (bt.name != BType.CASTLEGATE.name)
		{
            if (this.filterBuildingTypes(bt, race))
            {
            	this.addBuilding(bt, race);
            }
        }
	}
	
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
}

SelectBuildingToDestroyDialog.prototype.addBuilding = function(bt, race) 
{
    var src = Assets.B_findByOrNull(race, bt);
    if (src)
    {
        this.buildingsContainer.appendChild(this.createBuildingImage(race, bt, src));
    }
}

SelectBuildingToDestroyDialog.prototype.filterBuildingTypes = function(bt, race)
{
	return this.type ? bt.canBeBuiltIn(race, this.type) : bt.canBeBuiltOnSector(race);
}

SelectBuildingToDestroyDialog.prototype.createBuildingImage = function(race, bt, src)
{
    var img = document.createElement("img");
    img.src = STATIC_URL + src;
    img.bt = bt;
    COM.bindExclusiveClick(img, this.onSelect);
	return img;
}

SelectBuildingToDestroyDialog.prototype.onSelect = function(e)
{
	this.onResult(e.currentTarget.bt);
	this.close();
}