function MissionAssistanceOrder()
{
	callParentConstructor(MissionAssistanceOrder.prototype, this);
	
	this.assistanceDurationTicks = FConfig.ASSISTANCE_DURATION_MIN;
}

extendClass(MissionAssistanceOrder.prototype, MilitaryMissionOrder.prototype);

MissionAssistanceOrder.prototype.__CLS__ = "game.model.mission.MissionAssistanceOrder";

MissionAssistanceOrder.prototype.getExecuteDuration = function()
{
    return this.assistanceDurationTicks;
}

MissionAssistanceOrder.prototype.getTravelDurationMultiplier = function()
{
    var speedup = superMethod(MissionAssistanceOrder.prototype, "getTravelDurationMultiplier", this)();
    speedup += FBuff.sumOfTerrainBuffs(this.getToField().buffs, this.incomingSpeedBuffType, this.getFromEstate(), this.getToField());
    return speedup;
}


MissionAssistanceOrder.prototype.getHasSpeedBuffs = function()
{
    return superMethod(MissionAssistanceOrder.prototype, "getHasSpeedBuffs", this)() ||
    	   FBuff.hasBuff(this.getToField().buffs, this.incomingSpeedBuffType, null, FEstate.tickNowForEstate(this.getFromEstate()));
}

MissionAssistanceOrder.prototype.getIncomingSpeedBuffType = function()
{
    return BuffType.INCOMING_ASSIST_TIME;
}