function MissionAttackOrder()
{
	callParentConstructor(MissionAttackOrder.prototype, this);
	
	this.typeToDestroy = null;
    this.goal = null;
    this.joinMissionId = 0;
    this.clanInvited = false;
    this.alliesInvited = false;
    this.assistanceDurationTicks = 0;
}

extendClass(MissionAttackOrder.prototype, MilitaryMissionOrder.prototype);

MissionAttackOrder.prototype.__CLS__ = "game.model.mission.MissionAttackOrder";

MissionAttackOrder.prototype.updateTicks = function(group)
{
    if (!group)
    {
        superMethod(MissionAttackOrder.prototype, "updateTicks", this)(group);
    }
    else
    {
        this.startTick = Tick.now();
        this.arriveTick = group.arriveTick;
        this.returnTick = this.arriveTick + this.getTravelDuration();
        this.clientDuration = -1;
    }
}

MissionAttackOrder.prototype.getExecuteDuration = function()
{
    return this.assistanceDurationTicks;
}

MissionAttackOrder.prototype.willJoinInTime = function(group)
{
    if (!group)
    {
        return true;
    }
    return Tick.now() + this.getTravelDuration() <= group.arriveTick;
}


MissionAttackOrder.prototype.getTravelDurationMultiplier = function()
{
    var speedup = superMethod(MissionAttackOrder.prototype, "getTravelDurationMultiplier", this)();
    speedup += FBuff.sumOfTerrainBuffs(this.getToField().buffs, this.incomingSpeedBuffType, this.getFromEstate(), this.getToField());
    return speedup;
}

MissionAttackOrder.prototype.getHasSpeedBuffs = function()
{
    return superMethod(MissionAttackOrder.prototype, "getHasSpeedBuffs", this)() || FBuff.hasBuff(this.getToField().buffs, this.incomingSpeedBuffType, null, FEstate.tickNowForEstate(this.getFromEstate()));
}

MissionAttackOrder.prototype.getIncomingSpeedBuffType = function()
{
    return BuffType.INCOMING_ATTACK_TIME;
}