function MissionCampOrder()
{
	callParentConstructor(MissionCampOrder.prototype, this);
}

extendClass(MissionCampOrder.prototype, MilitaryMissionOrder.prototype);

MissionCampOrder.prototype.__CLS__ = "game.model.mission.MissionCampOrder";

MissionCampOrder.prototype.getExecuteDuration = function()
{
    return FConfig.CAMP_CREATION_TIME;
}

MissionCampOrder.prototype.getTravelDurationMultiplier = function()
{
    var speedup = superMethod(MissionCampOrder.prototype, "getTravelDurationMultiplier", this)();
    speedup += FBuff.sumOfTerrainBuffs(this.getToField().buffs, this.incomingSpeedBuffType, this.getFromEstate(), this.getToField());
    return speedup;
}

MissionCampOrder.prototype.getHasSpeedBuffs = function()
{
    return superMethod(MissionCampOrder.prototype, "getHasSpeedBuffs", this)() || FBuff.hasBuff(this.getToField().buffs, this.incomingSpeedBuffType, null, FEstate.tickNowForEstate(this.getFromEstate()))
}

MissionCampOrder.prototype.getIncomingSpeedBuffType = function()
{
    return BuffType.INCOMING_CAMP_MISSION_TIME;
}

MissionCampOrder.prototype.getCostGold = function()
{
    // difference from base: ARMY_RATION doesn't affect EXECUTION
    return Math.max(0, this.getBaseExecutionCost() + this.getBaseTravelCost() * (1 + this.getFromEstate().sumOfBuffs(BuffType.ARMY_RATION)));
}