function MissionExpeditionOrder()
{
	callParentConstructor(MissionExpeditionOrder.prototype, this);
}

extendClass(MissionExpeditionOrder.prototype, MissionOrder.prototype);

MissionExpeditionOrder.prototype.__CLS__ = "game.model.mission.MissionExpeditionOrder";

MissionExpeditionOrder.prototype.calculateCost = function()
{
    return new Funds();
}

MissionExpeditionOrder.prototype.getTravelDurationMultiplier = function()
{
    var speedup = 1;
    if (this.getFromEstate().buffs)
    {
        speedup += FBuff.sumOfTerrainBuffs(this.getFromEstate().buffs, this.outcomingSpeedBuffType, this.getFromEstate(), this.getToField());
    }
    speedup += FBuff.sumOfTerrainBuffs(this.getToField().buffs, this.incomingSpeedBuffType, this.getFromEstate(), this.getToField());
    if (this.getFromEstate().isMagicActive(BType.EXPEDITION))
    {
        speedup *= 1 + ServiceHelper.getGloabalServiceDecl(BType.EXPEDITION.name, 0).getValue();
    }
    return speedup;
}

MissionExpeditionOrder.prototype.getHasSpeedBuffs = function()
{
    return this.getFromEstate().hasBuff(this.outcomingSpeedBuffType)
            || this.getFromEstate().isMagicActive(BType.EXPEDITION)
            || FBuff.hasBuff(this.getToField().buffs, this.incomingSpeedBuffType, null, FEstate.tickNowForEstate(this.getFromEstate()));
}

MissionExpeditionOrder.prototype.getIncomingSpeedBuffType = function()
{
    return BuffType.INCOMING_EXPEDITORS_MISSION_TIME;
}

MissionExpeditionOrder.prototype.getOutcomingSpeedBuffType = function()
{
    return BuffType.EXPEDITORS_MISSION_TIME;
}

MissionExpeditionOrder.prototype.getPreferedSpeed = function()
{
    return FUser.CURRENT_USER.settings.expeditionMissionSpeed;
}