function MissionMoveResourcesOrder()
{
	callParentConstructor(MissionMoveResourcesOrder.prototype, this);
	
	this.res = new Funds();
}

extendClass(MissionMoveResourcesOrder.prototype, MissionOrder.prototype);

MissionMoveResourcesOrder.prototype.__CLS__ = "game.model.mission.MissionMoveResourcesOrder";

MissionMoveResourcesOrder.prototype.calculateCost = function()
{
    return this.res.multiplyCopy(this.getCurrentTax()).ceil();
}

MissionMoveResourcesOrder.prototype.getCurrentTax = function()
{
    return MissionSpeed.getMoveResourceTax(this.speed);
}

MissionMoveResourcesOrder.prototype.getTravelDurationMultiplier = function()
{
    var speedup = 1;
    if (this.getFromEstate().buffs)
    {
        speedup += FBuff.sumOfTerrainBuffs(this.getFromEstate().buffs, this.outcomingSpeedBuffType, this.getFromEstate(), this.getToField());
    }
    speedup += FBuff.sumOfTerrainBuffs(this.getToField().buffs, this.incomingSpeedBuffType, this.getFromEstate(), this.getToField());
    if (this.getFromEstate().isMagicActive(BType.MERCHANT))
    {
        speedup *= 1 + ServiceHelper.getGloabalServiceDecl(BType.MERCHANT.name, 0).getValue();
    }
    return speedup;
}

MissionMoveResourcesOrder.prototype.getHasSpeedBuffs = function()
{
    return this.getFromEstate().hasBuff(BuffType.MERCHANTS_MISSION_TIME)
        || this.getFromEstate().isMagicActive(BType.MERCHANT)
        || FBuff.hasBuff(this.getToField().buffs, this.incomingSpeedBuffType, null, FEstate.tickNowForEstate(this.getFromEstate()));
}

MissionMoveResourcesOrder.prototype.getIncomingSpeedBuffType = function()
{
    return BuffType.INCOMING_MERCHANTS_MISSION_TIME;
}

MissionMoveResourcesOrder.prototype.getOutcomingSpeedBuffType = function()
{
    return BuffType.MERCHANTS_MISSION_TIME;
}

MissionMoveResourcesOrder.prototype.getPreferedSpeed = function()
{
    return FUser.CURRENT_USER.settings.moveResourcesMissionSpeed;
}

MissionMoveResourcesOrder.prototype.prepareForRequest = function()
{
	var ret = superMethod(MissionMoveResourcesOrder.prototype, "prepareForRequest", this)();
	ret.res =
	{
		__CLS__: "game.model.Funds",
		gold : ret.res.gold,
		wood : ret.res.wood,
		stone : ret.res.stone,
		grain : ret.res.grain,
		iron : ret.res.iron,
		people : ret.res.people,
	}
	
	return ret;
}