function LocalFeaturesTab()
{
	this.user = null;
	
	this.__defineGetter__("estate", this.getEstate);
	this.__defineSetter__("estate", this.setEstate);
}

LocalFeaturesTab.prototype.__construct = function()
{
	$(this.citySelector).on("change", $.proxy(this.onCityChange, this));
}

LocalFeaturesTab.prototype.getEstate = function()
{
    return ServiceHelper.estate;
}

LocalFeaturesTab.prototype.setEstate = function(e)
{
    ServiceHelper.estate = e;
}

LocalFeaturesTab.prototype.fitLayout = function(container)
{
	//console.log(container);
	//this.grid.style.width = container.width + "px";
	this.grid.style.height = (container.height - this.citySelectorRow.offsetHeight) + "px";
	this.refresh();
}

LocalFeaturesTab.prototype.refresh = function()
{
	COM(this.grid).refresh();
}

LocalFeaturesTab.prototype.createChangeArchitectureRow = function()
{
	var r = document.createElement("row");
	var c;
	
	c = document.createElement("cell");
	c.style.fontWeight = "bold";
	c.innerHTML = I18.f("LOCAL_CHANGE_ARCHITECTURE");
	r.appendChild(c);
	
	c = document.createElement("cell");
	c.innerHTML = I18.f("ONE_TIME");
	r.appendChild(c);
	
	c = document.createElement("cell");
	c.style.whiteSpace = "nowrap";
	var com = COM.create("IconAndValue");
	this.changeArchitecturePrice = com.DOM;
	com.source = STATIC_INTERFACE_URL + CommonAssets.ICON_PEARL;
	c.appendChild(this.changeArchitecturePrice);
	r.appendChild(c);
	
	c = document.createElement("cell");
	var com = COM.create("SimpleButton");
	this.changeArchitectureButton = com.DOM;
	COM.bindExclusiveClick(this.changeArchitectureButton, $.proxy(this.changeArchitecture, this));
	com.caption = I18.f("GO_ON");
	c.appendChild(this.changeArchitectureButton);
	r.appendChild(c);
	
	c = document.createElement("cell");
	r.appendChild(c);
	
	return r;
}

LocalFeaturesTab.prototype.init = function(user, links, e)
{
    this.user = user;

    COM(this.citySelector).updateCities(links);
    COM(this.citySelector).enabled = !Boolean(e);
    if (!e)
    {
        var estateId = this.user.getEstateWithFeatureWarning();
        if (!estateId)
        {
            //estateId = GlobalSelectionCitiesCombo.selectedCityId;
            estateId = APP.getCityMediator().estate.id;
        }
        if (estateId) 
        {
            COM(this.citySelector).cityId = estateId;
            Service.city.callMethod("getById", [COM(this.citySelector).city.id], $.proxy(function(e)
            {
                this.update(e);
            }, this));
        }
    }
    else
    {
        this.update(e);
    }
    var entries = FConfig.LOCAL_SERVICES;
    var grid = COM(this.grid);
    
    for (var i = 0; i < entries.length; i++)
    {
        if (!entries[i].isHidden())
        {
            var grow = COM.create("ServiceGridRow");
            grow.init(user, this.estate, entries[i], ServiceHelper.orderLocalService, ServiceHelper.setLocalAutoOrder);
            
            grid.addItem(grow, i);
        }
    }
    
    this.changeArchitectureRow = this.createChangeArchitectureRow();
    grid.addItem({DOM: this.changeArchitectureRow}, i);
    //grid.addItem(this.reorderBuildinsRow, i+2);
}

LocalFeaturesTab.prototype.update = function(e)
{
    this.estate = e;
    this.tick();
    
    this.refresh();
}

LocalFeaturesTab.prototype.tick = function()
{
    if (this.estate)
    {
        var items = COM(this.grid).items;
        
        var row;
        for(var i=0; i<items.length; i++)
        {
        	row = COM(items[i]);
        	if(row)
        	{
        		if (row.getSelectedItem() && row.getSelectedItem().estateTypes)
        		{
                    UI.show(row.getSelectedItem().estateTypes.contains(this.estate.getEstateType()), [row], $.proxy(function()
                    {
                        row.tick(this.user, this.estate);
                    }, this));
                }
                else
                {
                    row.tick(this.user, this.estate);
                }
        	}
        }

        UI.show(this.estate.__className__ == "FCity", [this.changeArchitectureRow], $.proxy(function()
        {
            var price = FConfig.getCitySkinPriceRange(this.estate.owner.race, this.estate.getSkinIndex());
            COM(this.changeArchitecturePrice).value = price.toString();
            if (this.estate.owner.pearl < price.min)
            {
                COM(this.changeArchitectureButton).reason = I18.f("PREMIUM_ACCOUNT_NOT_ENOUGH_RESOURCES");
                //changeArchitectureButton.enabled = false;
                Style.FUNDS_FULL.applyTo(this.changeArchitecturePrice);
            }
            else
            {
                Style.FUNDS.applyTo(this.changeArchitecturePrice);
                COM(this.changeArchitectureButton).enabled = this.user.username == FUser.CURRENT_USER.username;
                this.changeArchitectureButton.reason = "";
            }
        }, this));

        /*
        UI.show(this.estate.__className__ == "FCity" || this.estate.__className__ ==  "FPit", [this.reorderBuildinsRow], $.proxy(function()
        {
            if (this.estate.owner.pearl < FConfig.PEARL_REORDER_BUILDINGS_PRICE)
            {
                COM(this.reorderBuildinsButton).reason = I18.f("PREMIUM_ACCOUNT_NOT_ENOUGH_RESOURCES");
                //reorderBuildinsButton.enabled = false;
                Style.FUNDS_FULL.applyTo(this.reorderBuildinsPrice);
            }
            else
            {
                COM(this.reorderBuildinsButton).enabled = this.user.username == FUser.CURRENT_USER.username;
                COM(this.reorderBuildinsButton).reason = "";
                Style.FUNDS.applyTo(this.reorderBuildinsPrice);
            }
        }, this));
        */
    }
}

LocalFeaturesTab.prototype.onCityChange = function()
{
    Service.city.callMethod("getById", [COM(this.citySelector).selectedItem.data.id], $.proxy(function(e)
    {
        this.update(e);
    }, this));
}

LocalFeaturesTab.prototype.changeArchitecture = function()
{
    var d = ChangeCitySkinDialog.create(this.estate);
    d.onCityUpdated = $.proxy(this.update, this);
    d.popup(this);
}

LocalFeaturesTab.prototype.reorderBuildins = function()
{
    console.log("ReorderBuildingsDialog not implemented");
    //ReorderBuildingsDialog.popup(null, estate);
}