function MandatoryOffersDialog()
{
    callParentConstructor(MandatoryOffersDialog.prototype, this);

    this.account = null;
    this.timer = null;
}

extendClass(MandatoryOffersDialog.prototype, Dialog.prototype);

MandatoryOffersDialog.prototype.__construct = function()
{
    this.userCanClose = false;

    COM.bindExclusiveClick(this.finishButton, $.proxy(this.finish, this));
    COM.bindExclusiveClick(this.exitToPortalButton, Service.goToPortal);
    COM.bindExclusiveClick(this.freePearlButton, function()
	{
		TapJoyHelper.showOffers(FUser.CURRENT_USER.username + "@" + FConfig.SERVER_ID);
	});

	COM.bindExclusiveClick(this.obtainPearlButton, function()
    {
        ObtainPearlDialog.popup(null, true);
    });
};

MandatoryOffersDialog.prototype.__destruct = function()
{
    clearInterval(this.timer);
};

MandatoryOffersDialog.prototype.update = function(e, show)
{
    APP.showLoader();
    PortalService.account.callMethod("getMandatoryOffersPearl", [], $.proxy(function(mandatoryOffersPearl)
    {
        if (show) {
            this.popup();
            this.updateImpl(mandatoryOffersPearl);
        }
        else
        {
            this.updateImpl(mandatoryOffersPearl);
        }
        APP.hideLoader();
    }, this));
};

MandatoryOffersDialog.prototype.updateImpl = function(mandatoryOffersPearl)
{
    if(mandatoryOffersPearl.asNumber) mandatoryOffersPearl = mandatoryOffersPearl.asNumber();

    COM(this.freePearlButton).caption = I18.f("START_MANDATORY_OFFERS");
    COM(this.exitToPortalButton).caption = I18.f("LOGOUT");
    COM(this.obtainPearlButton).caption = I18.f("BUY_MANDATORY_OFFERS_PEARL", FPortalConfig.MANDATORY_OFFERS_PEARL_REQUIRED - mandatoryOffersPearl);

    this.advisor.src = STATIC_INTERFACE_URL + Assets.getAdvisor(FUser.CURRENT_USER.race);
    var done = mandatoryOffersPearl >= FPortalConfig.MANDATORY_OFFERS_PEARL_REQUIRED;

    //done = true;

    var txt = "";

    if(done)
    {
        txt = I18.f("MANDATORY_OFFERS_DONE", mandatoryOffersPearl, FPortalConfig.MANDATORY_OFFERS_PEARL_REWARD, FPortalConfig.MANDATORY_OFFERS_PEARL_REWARD);
    }
    else
    {
        txt = I18.f("MANDATORY_OFFERS_ACTIVE_MOBILE",
            mandatoryOffersPearl,
            FPortalConfig.MANDATORY_OFFERS_PEARL_REQUIRED,
            FPortalConfig.MANDATORY_OFFERS_PEARL_REWARD,
            FPortalConfig.MANDATORY_OFFERS_PEARL_REQUIRED + FPortalConfig.MANDATORY_OFFERS_PEARL_REWARD);
    }

    this.descLabel.innerHTML = txt;

    this.serverLabel.innerHTML = I18.f("MANDATORY_OFFERS_SERVER");

    if(done)
    {
        this.serverGroup.style.visibility = "visible";

        COM(this.serversComboBox).dataProvider = Arrays.filter(this.account.servers, function(server)
        {
            return server.offersAccess && server.offersAccess.name == OffersAccess.ENABLED.name;
        });
        if (!COM(this.serversComboBox).selectedItem)
        {
            COM(this.serversComboBox).selectedItem = this.account.findServer(FConfig.SERVER_ID);
        }

        this.obtainPearlButton.style.visibility = "hidden";
        this.freePearlButton.style.visibility = "hidden";

        this.finishButton.style.display = "block";
        this.exitToPortalButton.style.display = "none";
        this.obtainPearlButton.style.display = "none";
    }
    else
    {
        this.serverGroup.style.visibility = "hidden";

        this.finishButton.style.display = "none";
        this.exitToPortalButton.style.display = "block";
    }

    UI.show(!done, [this.freePearlButton]);

    COM(this.finishButton).caption = done ? I18.f("FINISH_MANDATORY_OFFERS") : I18.f("CLOSE");
    COM(this.finishButton).reason = done ? null : I18.f("MANDATORY_OFFERS_REQUIRED", mandatoryOffersPearl, FPortalConfig.MANDATORY_OFFERS_PEARL_REQUIRED);

    if (!done && !this.timer)
    {
        this.timer = setInterval($.proxy(this.update, this), 10000);
    }
    if (done && this.timer)
    {
        clearInterval(this.timer);
    }

    this.obtainPearlButton.style.display = "none";
};

MandatoryOffersDialog.prototype.finish = function()
{
    PortalService.account.callMethod("finishMandatoryOffers", [COM(this.serversComboBox).selectedItem.data.id], function()
    {
        PortalService.account.callMethod("enterGame", [FConfig.SERVER_ID, FUser.CURRENT_USER.identCookie, null], function()
        {
            window.location.reload(true);
        });
    })
};

MandatoryOffersDialog.prototype.exitToPortal = function()
{
    Service.goToPortal();
};

MandatoryOffersDialog.instance = null;

MandatoryOffersDialog.popup = function()
{
    if(!MandatoryOffersDialog.instance)
    {
        MandatoryOffersDialog.instance = COM.create("MandatoryOffersDialog");

        APP.showLoader();
        PortalService.loginFromServer(function(fpc)
        {
            PortalService.getConfig(function(fpc)
            {
                FPortalConfig.load(fpc);
                PortalService.account.callMethod("getAccount", [], function(account)
                {
                    MandatoryOffersDialog.instance.account = account;
                    MandatoryOffersDialog.instance.update(null, true);
                    APP.hideLoader();
                });
            });
        }, []);

        //ObtainPearlDialog.popup();
    }
};