function SubscriptionExpiredDialog()
{
	callParentConstructor(SubscriptionExpiredDialog.prototype, this);
	
	this.userCanClose = false;
	this.timer = null;
}

extendClass(SubscriptionExpiredDialog.prototype, Dialog.prototype);

SubscriptionExpiredDialog.instance = null;
SubscriptionExpiredDialog.popup = function()
{
    var cu = APP.getCurrentMediator();
    if(cu)
    {
    	cu.stopAllTickers();
    }
    
    if (!SubscriptionExpiredDialog.instance)
    {
        SubscriptionExpiredDialog.instance = COM.create("SubscriptionExpiredDialog");
        SubscriptionExpiredDialog.instance.popup();
    }
}

SubscriptionExpiredDialog.prototype.__construct = function()
{
	this.scroll = new iScroll(this.descriptionWrapper, {scrollbarColor: '#784f0b'});
	
	var items = ServiceGridRow.getComboItems(ServiceHelper.getGlobalService(ServiceDecl.SUBSCRIPTION));
	
	var op;
	var cb = COM(this.subscriptionCombo);
	for(var i=0; i<items.length; i++)
	{
		cb.addOption(i, items[i], false);
	}
	cb.selectedIndex = 0;
	
	$(this.subscriptionCombo).on("change", $.proxy(this.periodChanged, this));
	COM.bindExclusiveClick(this.playForFreeButton, $.proxy(this.onPlayForFree, this));
	COM.bindExclusiveClick(this.buyButton, $.proxy(this.onExtendSubscription, this));
	
	this.setCaption(I18.f("SUBSCRIPTION"));
	this.update();
}

SubscriptionExpiredDialog.prototype.__destruct = function()
{
	var cu = APP.getCurrentMediator();
    if(cu)
    {
    	cu.onConnectionGain();
    }
}

SubscriptionExpiredDialog.prototype.showRoutine = function()
{
    SubscriptionExpiredDialog.instance.updateCurrentUser();

    this.timer = setInterval($.proxy(this.updateCurrentUser, this), 10000);
}

SubscriptionExpiredDialog.prototype.updateCurrentUser = function(e)
{
    Service.user.callMethod("getCurrentUser", [], $.proxy(function(u)
    {
        FUser.updateCurrentUser(u);
        this.update();
    }, this));
}

SubscriptionExpiredDialog.prototype.closeRoutine = function()
{
    clearInterval(this.timer);
}

SubscriptionExpiredDialog.prototype.update = function()
{
    this.title.innerHTML = FUser.CURRENT_USER.avatarState == "PROMO" ? I18.f("PROMO_EXPIRED") : I18.f("SUBSCRIPTION_EXPIRED");
    this.description.innerHTML = I18.f("SUBSCRIPTION_DESC", [FConfig.PREMIUM_MESSAGE_ARCHIVE_CAPACITY, FConfig.PREMIUM_CONTACT_LIST_CAPACITY, FUser.CURRENT_USER.withdrawalEnabled ? I18.f("WITHDRAWAL") : I18.f("WITHDRAWAL_TO_PORTAL")]);
	
    this.periodChanged();
    
    setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
}

SubscriptionExpiredDialog.prototype.periodChanged = function()
{
    var currentPrice = ServiceHelper.getGloabalServiceDecl(ServiceDecl.SUBSCRIPTION, COM(this.subscriptionCombo).selectedIndex).price;
    COM(this.price).update(currentPrice);
    
    var reason;
    if (FUser.CURRENT_USER.withdrawalForbiddenInSession)
    {
        reason = I18.f("PREMIUM_ACCOUNT_FORBIDDEN_COUNTRY");
    }
    else if (FUser.CURRENT_USER.pearl < currentPrice)
    {
        reason = I18.f("PREMIUM_ACCOUNT_NOT_ENOUGH_RESOURCES");
    }
    else
    {
        reason = "";
    }
    
    COM(this.buyButton).reason = reason;
}

SubscriptionExpiredDialog.prototype.onPlayForFree = function()
{
    ChooseFreeConfirmation.popup(this, $.proxy(function()
    {
        Service.user.callMethod("chooseFree", [], this.reloadPage);
    }, this));
}

SubscriptionExpiredDialog.prototype.onExtendSubscription = function()
{
    ServiceHelper.orderGlobalService(ServiceDecl.SUBSCRIPTION, COM(this.subscriptionCombo).selectedIndex, null, null, this.reloadPage, null);
}

SubscriptionExpiredDialog.prototype.reloadPage = function(arg)
{
    APP.navigate();
}