function FQuest()
{
	this.__defineGetter__('showTimer', this.getShowTimer);
	this.__defineSetter__('showTimer', this.setShowTimer);

	this.id = 0;
	this.name = '';
	this.state = null; // QuestState 
	this.header = '';
	this.body = '';
	this.lastChangeTick = 0;
	this.unread = false;
	this.pendingReward = false;
	this.rewards = null; // ArrayCollection <FQuestReward>
	this.pic = '';
	this.pearls = 0;
	this.failed = false;
	this.timeoutTick = 0;
	this.progress = 0;
	this.progressFrom = 0;
	this.failProgress = 0;
	this.failProgressFrom = 0;
	this.lastEducational = false;
	this.allowedUnderAttack = false;
	this.allowedWithAttack = false;
}

FQuest.prototype.__CLS__ = 'game.service.quest.FQuest';
FQuest.prototype.__className__ = 'FQuest';

FQuest.prototype.id = 0;
FQuest.prototype.name = '';
FQuest.prototype.state = null; // QuestState 
FQuest.prototype.header = '';
FQuest.prototype.body = '';
FQuest.prototype.lastChangeTick = 0;
FQuest.prototype.unread = false;
FQuest.prototype.pendingReward = false;
FQuest.prototype.rewards = null; // ArrayCollection <FQuestReward>
FQuest.prototype.pic = '';
FQuest.prototype.pearls = 0;
FQuest.prototype.failed = false;
FQuest.prototype.timeoutTick = 0;
FQuest.prototype.progress = 0;
FQuest.prototype.progressFrom = 0;
FQuest.prototype.failProgress = 0;
FQuest.prototype.failProgressFrom = 0;
FQuest.prototype.lastEducational = false;
FQuest.prototype.allowedUnderAttack = false;
FQuest.prototype.allowedWithAttack = false;

FQuest.prototype.compareTo = function(other)
{
    if (!(other.__className__ == 'FQuest')) 
    {
        throw new Error("Could not compare: wrong type");
    }
    var otherQuest = other;

    if (this.pendingReward && !other.pendingReward) 
    {
        return 1;
    } 
    else if (!this.pendingReward && other.pendingReward) 
    {
        return -1;
    }

    var timestampDiff = other.lastChangeTick - this.lastChangeTick;
    return timestampDiff == 0 ? this.id - other.id : timestampDiff;
}

FQuest.prototype.getShowTimer = function()
{
    return this.timeoutTick != 0 && this.state && this.state.name == QuestState.ACTIVE.name;
}
FQuest.prototype.setShowTimer = function(val) {}

FQuest.sortByLastChange = function(q1, q2)
{
    return NumberUtils.compareTo(q2.lastChangeTick, q1.lastChangeTick);
}

FQuest.prototype.toString = function() { return "FQuest{id=" + String(this.id) + ",name=" + String(this.name) + ",state=" + String(this.state) + "}"; }
