function QuestDetails()
{
	callParentConstructor(this);
	
	this.scroll = null;
	
	this.data = null;
	this.quest = null;
	this.quests = null;
	this.reward_dialog = null;
	this.update = null;
	
	this.onUpdateReceived = null;
}

extendClass(QuestDetails.prototype, Dialog.prototype);

QuestDetails.prototype.__construct = function()
{
	superMethod(QuestDetails.prototype, '__construct', this)();
	
	this.scroll = new iScroll(this.contentWrapper.parentNode);
	
	COM.bindExclusiveClick(this.rewardButton, $.proxy(function()
	{
		this.onGetReward();
	}, this));
}

QuestDetails.prototype.popup = function(quest, updateQuestView)
{
	superMethod(QuestDetails.prototype, "popup", this)();
	
	this.fullScreen();
		
	this.quest = quest;
	this.setCaption(quest.header);
   	this.onDataChange();
  	
  	COM(this.rewardButton).setSkin("green");
  	
  	this.onUpdateReceived = updateQuestView;
	
	HintArrow.EXPAND_QUEST.hide();
	HintArrow.GET_REWARD.hide();
	
	if(quest.unread)
	{
		Service.quest.callMethod("markAsRead", [quest.name]);
		quest.unread = false;
		
		APP.updateHints();
	}
}

QuestDetails.prototype.refreshScroll = function(timeout)
{
	if(!timeout) timeout = 500;
	setTimeout($.proxy(this.scroll.refresh, this.scroll), timeout);
}

QuestDetails.prototype.onShow = function()
{
	this.scrollContainer.style.height = (this.content.offsetHeight-8)+"px";
	this.refreshScroll(1000);
}

QuestDetails.create = function(quest,updateQuestView)
{	
	var d = COM.create('QuestDetails');
	d.popup(quest,updateQuestView);
    /*
    d.onResult = onResult;
    d.allowAccessEstatesBox.checked = Boolean(allowAccessEstates);
    d.allowAccessMissionsBox.checked = Boolean(allowAccessMission);
    d.accessEstatesChanged();
    */
}

QuestDetails.prototype.onInit = function()
{
	//ChangeWatcher.watch(this, "data", onDataChange);
}

QuestDetails.prototype.onDataChange = function()
{
	$.proxy(this.addBody(), this);

	//$(this.headerLabel).html(this.quest.header);
	
	$(this.headerLabel).css("font-weight", this.quest.unread ? "bold" : "normal");
	$(this.headerLabel).toggleClass("unread", Boolean(this.quest.unread));
	
	if (UI.show(this.quest.failProgressFrom != 0 && this.quest.failProgress != 0, [this.failProgressLabel]))
	{
		$(this.failProgressLabel).html(I18.f('QUEST_FAIL_PROGRESS', [this.quest.failProgress, this.quest.failProgressFrom]));
	}
	if (UI.show(this.quest.progressFrom != 0, [this.progressLabel]))
	{
		$(this.progressLabel).html(I18.f('QUEST_PROGRESS', [this.quest.progress, this.quest.progressFrom]));
	}
	if (UI.show(this.quest.showTimer, [this.timeoutView]))
	{
	    this.timeoutView.title = I18.f('QUEST_TIMEOUT', Tick.toTimeFuture(this.quest.timeoutTick));
	    COM(this.timeoutView).value = this.quest.timeoutTick;
	}
	
	UI.show(this.quest.failed, [this.failLabel]);
	UI.show(this.quest.pendingReward, [this.rewardButton]);
	
	this.refreshScroll();
}

QuestDetails.prototype.newTextPartController = function(view, x, y, w, h)
{
/*
	var sprite:Sprite = new Sprite();
	var canvasWrapper:Canvas = new Canvas();
	canvasWrapper.rawChildren.addChild(sprite);
	canvasWrapper.layoutDirection = LayoutDirection.LTR;
	canvasWrapper.x = x;
	canvasWrapper.y = y;
	canvasWrapper.width = w;
	canvasWrapper.height = h;
	view.rawChildren.addChild(canvasWrapper);
	return new ContainerController(sprite, w, h);
*/
}

QuestDetails.prototype.turnOnBody = function()
{
	Assets.waitCanShowQuest(this.data, this.addBody);
}

QuestDetails.prototype.addBody = function()
{
	var reg = new RegExp('((<br/?>)+(\x0a+)?(\x0c)?){2,}', 'igm');
	$(this.bodyBox).html(this.quest.body.replace(reg, "<br/><br/>"));
	QuestHtmlFlowConverter.convert(this.bodyBox);
	
	//this.img.src = STATIC_URL + Assets.getAdvisor(FUser.CURRENT_USER.race);
	this.pic.src = QuestDetails.getQuestPicturePath(this.quest.pic);
		
	$(this.bodyBox).append($("<div>&nbsp;</div>")).attr('quest', this.quest.name);
	
	this.addRewardView();
	this.addPayView();
	
	$("#LINK_IN_QUEST", this.bodyBox).each(function(i, obj)
	{
	    var href = obj.href + "";
	    obj.href = "javascript: void(0)";
	    obj.target = "";
	    obj.addEventListener("click", function()
	    {
	        var w = window.open(href, "_blank");
            if (w['show']) w.show();
            Service.city.callMethod("buttonPressed", ["LINK_IN_QUEST"]);

            if(QuestsView.instance) QuestsView.instance.refresh();
        });
	});
	
	HintArrow.EXPAND_QUEST.understood(this.quest.name);
}

QuestDetails.onQuestIoError = function(e)
{
}

QuestDetails.getQuestPicturePath = function(name)
{
	//return STATIC_INTERFACE_URL + "quests/" + FUser.CURRENT_USER.race.name.toLowerCase() + "/" + name;
	return Service.getUrl("/quests/" + FUser.CURRENT_USER.race.name.toLowerCase() + "/" + name);
}

QuestDetails.prototype.afterGetReward = function(quest, qbox)
{
	var d = document.createElement("div");
	d.innerHTML = I18.f("REWARD_SUCCESSFULLY_RECEIVED");
	
	var results = [d];
	if (qbox.lastRewardEffects) 
	{
	    for (var i = 0, len = qbox.lastRewardEffects.length; i < len; i++)
	    {
	    	var ce = qbox.lastRewardEffects[i];
	    	switch (ce.type.name) 
	        {
	            case CastEffectType.OBTAINED_ARTIFACT.name:
	                results.push(ArtifactPic.create(ce.params[0], []).DOM);
	                break;
	                
	            case CastEffectType.OBTAINED_PEARL.name:
	                results.push(I18.box(I18.f('CAST_EFFECT_OBTAINED_PEARL'), ce.params[0]));
	                break;
	                
	            case CastEffectType.POST_ON_WALL.name:
	                break;
	        }
	    }
	}
	
	var a = Alert.create(results);
	
	//this.collapse();
	if(this.onUpdateReceived) this.onUpdateReceived(qbox);
	
	if(this.reward_dialog)
	{
		this.reward_dialog.close();
	}
	
	a.onClose = $.proxy(function()
	{
		this.onAlertClose();
	},this);
}

QuestDetails.prototype.update = function()
{
	
}

QuestDetails.prototype.onAlertClose = function()
{	
	this.close();
}

QuestDetails.prototype.onGetReward = function(e)
{
	this.reward_dialog = COM.create("RewardDialog");
	this.reward_dialog.setCaption(I18.f("QUEST_SUCCESS"));
	this.reward_dialog.popup(this.quest, $.proxy(this.afterGetReward, this), $.proxy(this.onUpdateReceived, this));
	this.reward_dialog.onClose = $.proxy(this.onQuestDetailsClose, this);

	HintArrow.GET_REWARD.understood(this.quest.name);
	
	return false;
		
	//e.stopPropagation();
}

QuestDetails.prototype.onQuestDetailsClose = function(data)
{
	/////////////////////////////////////////////////////////////
	this.onUpdateReceived(data);
	this.close();
}

QuestDetails.prototype.addRewardView = function()
{
	var lbl = document.createElement('div');
	$(this.bodyBox).append(lbl);

	$(lbl).html("<b>"+I18.f('REWARD') + ":"+"</b>");
	//lbl.setStyle("fontWeight", "bold");
	
	EffectsView.createDescriptiveView(this.bodyBox, this.quest.rewards, true, false, false, false);
	
	if (!this.quest.allowedWithAttack) 
	{
	    $(this.bodyBox).append("<div>" + I18.getMegaString('QUEST_ERROR_WITH_ATTACK', FConfig) + "</div>");
	} 
	else if (!this.quest.allowedUnderAttack) 
	{
	    $(this.bodyBox).append("<div>" + I18.getMegaString('QUEST_ERROR_UNDER_ATTACK', FConfig) + "</div>");
	}
}

QuestDetails.prototype.addPayView = function()
{
	if (this.quest.pearls != 0 && !this.quest.pendingReward && !this.quest.failed) 
	{
	    var btn = COM.create('SimpleButton');
	    btn.setSkin("green");	    
     	$(this.bodyBox).append("<p>");
	    $(this.bodyBox).append(btn.DOM);
	    btn.caption = I18.f('COMPLETE_QUEST');
	    COM.bindExclusiveClick(btn.DOM, $.proxy(this.complete, this));
	}
}

QuestDetails.prototype.addDuplicateRewardView = function()
{
	UI.show(true, [this.duplicateRewardButton]);
}

QuestDetails.prototype.complete = function(e)
{
	var d = COM.create("PayForQuestDialog");
	d.onClose = $.proxy(function()
	{
		this.onAlertClose();
	},this);
	
	d.popup(FUser.CURRENT_USER, this.quest, $.proxy(function()
	{
		Service.quest.callMethod("payForQuest",[this.quest.name], $.proxy(this.yesPayForQuestDialog,this), 
	    $.proxy(this.noPayForQuestDialog,this));
	},this));

	/*
	new PayForQuestDialog().popup(this, FUser.CURRENT_USER, quest, function ():void 
	{
	    Service.quest.payForQuest(quest.name).handle(function (qbox:FQuestBox):void 
	    {
	        FUser.CURRENT_USER.pearl = qbox.userPearl;
	        onUpdateReceived(qbox);
	    }, function (error:Error):Boolean 
	    {
	        if (GameException.isDisplayable(error)) 
	        {
	            GameAlert.doShow((error as GameException).getMessage());
	            return true;
	        }
	        return false;
	    });
	});
	*/
}

QuestDetails.prototype.yesPayForQuestDialog = function(qbox)
{
	console.log(qbox);
	FUser.CURRENT_USER.pearl = qbox.userPearl;
    this.onUpdateReceived(qbox);
}

QuestDetails.prototype.noPayForQuestDialog = function(error)
{
	if (GameException.isDisplayable(error)) 
    {
       	var alert_text = error.getMessage();
		var a = Alert.create(alert_text);
		a.onClose = $.proxy(this.onAlertClose,this);
        return true;
    }
    return false;
}