function QuestHtmlFlowConverter()
{
}

QuestHtmlFlowConverter.matches = [
	new RegExp('{short-referal-link}', 'igm'),
	new RegExp('<a id="social-share-button:(.*)">(.*)</a>', 'igm')
]

QuestHtmlFlowConverter.convert = function(container)
{
	var html = container.innerHTML;
	
	for(var i=0; i<QuestHtmlFlowConverter.matches.length; i++)
	{
		html = html.replace(QuestHtmlFlowConverter.matches[i], QuestHtmlFlowConverter.walkFlow);
	}
	
	container.innerHTML = html;
	
	var tags = $("quest-flow-tag", container);
	for(var i=0; i<tags.length; i++)
	{
		QuestHtmlFlowConverter.customTagVisitor($(tags[i]));
	}
}

QuestHtmlFlowConverter.walkFlow = function(str, p, p2)
{
    var type = "";
    var tid = "";
    var text = "";
    
    if(str.indexOf("social-share-button") >= 0)
    {
    	type = "social";
    	tid = p;
    	text = p2;
    }
	else if(str.indexOf("short-referal-link") >= 0)
	{
		type = "referal";
	}
	
	return "<quest-flow-tag type='"+type+"' tid='"+tid+"'>"+text+"</quest-flow-tag>";
}

QuestHtmlFlowConverter.customTagVisitor = function(tag)
{
    var type = tag.attr("type");
    var tid = tag.attr("tid");
    
    if(type == "social")
    {
    	var socialType = tid.toUpperCase();
    	var publisher = SocialPublisher[socialType];
    	if (publisher)
    	{
            var b = QuestHtmlFlowConverter.createSocialShareButton(publisher, tag.html());
            tag.html("");
            tag.append(b);
        }
    }
    else if(type == "referal")
    {
    	var b = COM.create("SimpleButton");
    	b.caption = I18.f("COPY_APPRENTICE_LINK");
    	tag.html("");
    	tag.append($("<br/>"));
    	tag.append(b.DOM);
    	tag.append($("<br/>"));
    	
    	COM.bindExclusiveClick(b.DOM, function()
    	{
    		if(window.clipboard)
			{
				clipboard.copy(FConfig.computeShortRefLink(FUser.CURRENT_USER.portalId));
			}
    	});
    }
}

QuestHtmlFlowConverter.createSocialShareButton = function(publisher, publication)
{
    var img = document.createElement("img");
    img.src = STATIC_INTERFACE_URL + publisher.icon;
    img.width = 32;
    img.height = 32;
    img.align = "absmiddle";
    
    COM.bindExclusiveClick(img, function()
    {
    	publisher.publish(publication);
        Service.city.callMethod("buttonPressed", ["SOCIAL_SHARE_BUTTON"]);
    });
   
	return img;
}