function QuestMembersList()
{
	callParentConstructor(this);
	this.__defineGetter__('selected', function()
	{
	    var selRenderer = null//membersList.selected as ClanMemberRenderer;
	    if (selRenderer) 
	    {
	        return selRenderer.data;
	    } 
        return null;
	});
	
	this.questViewDialog = null;
	this.visibleItems = 0;
	
	this.quests = null;
	
	this.pager = null;
}

extendClass(QuestMembersList.prototype, ScrollableList.prototype);

QuestMembersList.prototype.__construct = function()
{
	superMethod(this, '__construct')();
	this.setHeader(null);
	
	this.scroll.options.onScrollMove = $.proxy(function()
	{
		this.changePageDirection = this.scroll.y < 0 ? 1 : -1;
	}, this);
	
	this.scroll.options.onScrollEnd = $.proxy(function(e)
	{
		if(!this.changePageDirection) return;

		var p = this.pager.page + this.changePageDirection;
		if (p < 0 || p >= this.pager.total) return;

		this.pager.page = p;
		this.pager.showHint(true);
		this.refreshContent();
	}, this);
}

QuestMembersList.prototype.fitLayout = function(container)
{
	this.list.style.height = container.height+"px";
	this.wrapper.style.height = container.height+"px";
}

QuestMembersList.prototype.update = function(quests, h)
{
	var data = [];
	for (var prop in quests)
	{
		if (!isNaN(parseInt(prop))) data[parseInt(prop)] = quests[prop];
	}
	
	this.quests = data;

	this.refreshContent();
	
	if(this.questViewDialog && this.questViewDialog.updateArrows) this.questViewDialog.updateArrows();
}

QuestMembersList.prototype.refreshContent = function()
{
	if(this.quests)
	{
		var data = [];
		var from = this.pager.page * QuestsView.ITEMS_ON_PAGE;
		var to = from + QuestsView.ITEMS_ON_PAGE;
		
		for(var i=from; i<to && i<this.quests.length; i++)
		{
			data.push(this.quests[i]);
		}
		
		this.dataProvider = data;
	}
	
	this.refresh();
	
	var items = this.items;
	var h = Math.floor(this.list.offsetHeight / QuestsView.ITEMS_ON_PAGE) + 1;
	
	for(var i=0; i<items.length; i++)
	{
		items[i].style.height = h+"px";
	}
}

QuestMembersList.prototype.tick = function()
{
    for (var i = 0, len = this.items.length; i < len; i++)
    {
    	COM(this.items[i]).tick();
    }
}

QuestMembersList.prototype.createRenderer = function(data)
{
	var renderer = COM.create('QuestMembersListItem');
	renderer.data = data;
	renderer.parent = this;
    
    $(renderer.DOM).css({'cursor': this.allowControl ? 'pointer' : 'default'});
    COM.bindExclusiveClick(renderer.DOM, $.proxy(this.showQuestInfo, this));
    
    return renderer;
}

QuestMembersList.prototype.showQuestInfo = function(e)
{	
	if (this.scroll && (this.scroll.directionX || this.scroll.directionY)) return false;
	var renderer = COM(e.currentTarget);
	
	//QuestDetails.create(renderer._data, this.putUpdateActiveQuests/*,this.dataProvider*/);
	
	renderer.showUnread(false);

	var d = COM.create("QuestDetails");
	d.popup(renderer._data, $.proxy(this.putUpdateActiveQuests, this));
	
	return d;
}

QuestMembersList.prototype.putUpdateActiveQuests = function(qb)
{	
	if(qb)
	{
		Arrays.sort(qb.currentQuests);
		this.update(qb.currentQuests);
	}
}