function QuestMembersListItem()
{
	callParentConstructor(this);
	
	this.__defineGetter__('member', this.getMember);
	this.__defineSetter__('member', this.setMember);
	

}

extendClass(QuestMembersListItem.prototype, ScrollableListItem.prototype);

QuestMembersListItem.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.rewardButton1, $.proxy(this.getReward, this));
}

QuestMembersListItem.prototype.getMember = function()
{
    return this._data;
}
QuestMembersListItem.prototype.setMember = function(val)
{
    this.data = val;
}

QuestMembersListItem.prototype.onError = function(e)
{
	/*
    if ((e.__className__ == 'ClanException')) 
    {
        Alert.create(e.getMessage());
        return true;
    }
    return false;
    */
}

QuestMembersListItem.prototype.refresh = function()
{
	if (!this.data)
    {
        return;
    }
   
   	this.header.innerHTML = this.member.header;
    
    if (UI.show(this.member.failProgressFrom != 0 && this.member.failProgress != 0, [this.failProgressLabel]))
	{
		$(this.failProgressLabel).html(I18.f('QUEST_FAIL_PROGRESS', [this.member.failProgress, this.member.failProgressFrom]));
	}
	if (UI.show(this.member.progressFrom != 0, [this.progressLabel]))
	{
		$(this.progressLabel).html(I18.f('QUEST_PROGRESS', [this.member.progress, this.member.progressFrom]));
	}
	if (UI.show(this.member.showTimer, [this.timeoutView]))
	{
	    this.timeoutView.title = I18.f('QUEST_TIMEOUT', Tick.toTimeFuture(this.member.timeoutTick));
	    COM(this.timeoutView).value = this.member.timeoutTick;
	}
	
	this.showUnread(this.data.unread);
	
	COM(this.rewardButton1).setSkin("green");
	
	UI.show(this.member.failed, [this.failLabel]);
	UI.show(this.member.pendingReward, [this.rewardButton1]);
}

QuestMembersListItem.prototype.showUnread = function(val)
{
	this.header.className = val ? "" : "text-narrow-regular";
}

QuestMembersListItem.prototype.onTooltip = function(e)
{
    //e.toolTip = EstateStarsClanView.createAsTip(data.user, null, false, false, true)
}

QuestMembersListItem.prototype.getReward = function(e)
{
	var d = this.parent.showQuestInfo({currentTarget: this.DOM});
	d.onShow = function()
	{
		d.DOM.style.display = "none";
	}
	d.onGetReward();
	
	e.stopImmediatePropagation();
}