function QuestsView()
{
	callParentConstructor(QuestsView.prototype, this);

	this.dialogBody = null;
		
	this.quests = null;
	this.completedQuests = null;
	
	this.completedQuests = [];
	this.firstTime = false;
	this.ticker = null;
	this.tournamentBlinker = null;
	this.showOnUpdateId = -1;

    QuestsView.instance = this;
}

extendClass(QuestsView.prototype, Dialog.prototype);

QuestsView.ITEMS_ON_PAGE = 6;
QuestsView.instance = null;

QuestsView.prototype.__construct = function()
{
	this.fullScreen();
	this.refresh();
	
	this.setCaption(I18.f("QUESTS"));
}

QuestsView.isOpen = false;

QuestsView.prototype.popup = function(firstTime)
{
	superMethod(QuestsView.prototype, "popup", this)();

	FUser.CURRENT_USER.settings.questLastClickTick = Tick.now();
	this.firstTime = firstTime;

	QuestsView.isOpen = true;
	
	COM(this.switcher).onChange = $.proxy(this.onSwitcherChange, this);
	
	this.headerCaptionBox.style.display = COM(COM(this.switcher).levels).items.length < 4 ? "" : "none";
	
	this.showActiveQuests();
}

QuestsView.prototype.fitLayout = function(container)
{
	superMethod(QuestsView.prototype, "fitLayout", this)(container);
	
	this.fitChildView();
}

QuestsView.prototype.fitChildView = function()
{
	if(this.dialogBody)
	{
		this.dialogBody.fitLayout({width: this.content.offsetWidth, height: this.content.offsetHeight});
	}
}

QuestsView.prototype.onClose = function()
{
	QuestsView.isOpen = false;
	
	HintArrow.EXPAND_QUEST.hide();
	HintArrow.GET_REWARD.hide();

    QuestsView.instance = null;
}

QuestsView.prototype.onSwitcherChange = function(e)
{	
	//console.log("onSwitcherChange");	
	
	//this.clearQuestView();
	var tab = COM(this.switcher).tab;
	if (tab == 0) this.showActiveQuests();
	else if (tab == 1) this.showCompleteTasks();
	else if (tab == 2) this.showFlagsTournament();
	else if (tab == 3) this.showGrottoTournament();
	
	this.fitChildView();
}

QuestsView.prototype.showActiveQuests = function()
{
	this.clearQuestView();
	this.dialogBody = COM.create("QuestMembersList");
	this.dialogBody.questViewDialog = this;
	
	this.dialogBody.pager = COM(this.pager);
	COM(this.pager).onSelect = $.proxy(this.dialogBody.refreshContent, this.dialogBody);
	
	this.questDialogBody.appendChild(this.dialogBody.DOM);	
	Service.quest.callMethod("getQuests", [], $.proxy(this.updateActiveQuests, this));
	
	this.pagerContainer.style.display = "";
	
	this.updateArrows();
}

QuestsView.prototype.updateActiveQuests = function(qBox)
{	
	Arrays.sort(qBox.currentQuests);
	
    COM(this.pager).setIndexAndCount(0, Math.ceil(qBox.currentQuests.length / QuestsView.ITEMS_ON_PAGE));
	
	var h = $(this.wrapper).height() - $(this.header).height();
	if (this.dialogBody) COM(this.dialogBody).update(qBox.currentQuests, h);

    this.quests = qBox;
    
    if (!this.ticker)
    {
        this.ticker = new Ticker(1000, $.proxy(this.onTick, this));
        this.ticker.start();
    }
    
    this.updateArrows();
}

QuestsView.prototype.showCompleteTasks = function()
{
	this.clearQuestView();
	
	this.dialogBody = COM.create("QuestMembersList");
	this.dialogBody.questViewDialog = this;
	
	this.dialogBody.pager = COM(this.pager);
	COM(this.pager).onSelect = $.proxy(this.dialogBody.refreshContent, this.dialogBody);
	
	this.questDialogBody.appendChild(this.dialogBody.DOM);
	Service.quest.callMethod("getCompletedQuests", [], $.proxy(this.updateCompletedQuests, this));
	
	this.pagerContainer.style.display = "";	
	this.updateArrows();	
}

QuestsView.prototype.updateCompletedQuests = function(qBox)
{
	Arrays.sort(qBox);
	
    COM(this.pager).setIndexAndCount(0, Math.ceil(qBox.length / QuestsView.ITEMS_ON_PAGE));
	
	var h = $(this.wrapper).height() - $(this.header).height();
	if (this.dialogBody) COM(this.dialogBody).update(qBox, h);
	
	this.completedQuests = qBox;
}

QuestsView.prototype.showFlagsTournament = function()
{
	this.clearQuestView();	
	this.dialogBody = COM.create("TournamentTab");
	this.dialogBody.questViewDialog = this;
	this.dialogBody.isFlag = true;
	Service.quest.callMethod("tournamentTabVisited", [], $.proxy(this.dialogBody.update,this));
    this.questDialogBody.appendChild(this.dialogBody.DOM);
	
	this.pagerContainer.style.display = "none";
	this.updateArrows();
}


QuestsView.prototype.showGrottoTournament = function()
{
	this.clearQuestView();	
	
	this.dialogBody = COM.create("TournamentTab");
	this.dialogBody.questViewDialog = this;
	this.dialogBody.isFlag = false;
	
	Service.quest.callMethod("tournamentGrottoTabVisited", [], $.proxy(this.dialogBody.update,this));                 
	this.questDialogBody.appendChild(this.dialogBody.DOM);
	
	this.pagerContainer.style.display = "none";
	this.updateArrows();
}

QuestsView.prototype.onCurrentQuestsUpdated = function()
{
    if (this.firstTime)
    {
        if (currentQuests.renderers.length > 0)
        {
            this.updateArrows();
        }
        this.firstTime = false;
    }
    if (this.showOnUpdateId > 0)
    {
    	for (var i=0; i<currentQuests.renderers.length; i++)
    	{
    		var qd = currentQuests.renderers[i];
    		if (qd.quest.id == this.showOnUpdateId)
            {
                if (qd.quest.state == QuestState.WAIT_REWARD)
                {
                    qd.addDuplicateRewardView();
                }
                break;
            }
    	}
	}
}

QuestsView.prototype.updateArrows = function()
{
	/*
	if (currentQuests == null)
	{
        return;
    }
    */

    if (COM(this.switcher).tab == 0)
    {
        var readHint = FUser.CURRENT_USER.findHint(HintType.READ_QUEST);
        var rewardHint = FUser.CURRENT_USER.findHint(HintType.GET_REWARD);
        
        if (readHint || rewardHint)
        {
            var qd;
            for(var i=0, len=this.dialogBody.items.length; i<len; i++)
            {
            	qd = COM(this.dialogBody.items[i]);
            	
            	if (readHint && qd.data.name == readHint.quest)
            	{
                    HintArrow.EXPAND_QUEST.show(qd, readHint, this.DOM);
                    break;
                }
                
                if (rewardHint && qd.data.name == rewardHint.quest && qd.rewardButton1.style.display != "none")
                {
                    HintArrow.GET_REWARD.show(qd.rewardButton1, rewardHint, this.DOM);
                    break;
                }
            }
        }
    }
    else
    {
        HintArrow.EXPAND_QUEST.hide();
        HintArrow.GET_REWARD.hide();
    }
}

QuestsView.prototype.onTick = function(dt)
{	
	if (this.quests.nextUpdate != 0 && this.quests.nextUpdate < Tick.now()) 
	{
		console.log("onTick");		
        Service.quest.callMethod("getQuests", [], $.proxy(this.updateActiveQuests, this));
    }
}

QuestsView.prototype.questExpandHandler = function(r/*:QuestDetails*/)
{
    if (r.data.unread) 
    {
        r.data.unread = false;
        r.onDataChange(null);
		Service.quest.callMethod("markAsRead", [r.data.name]);
    }
    if (r.data.pearls > 0)
    {
        this.showOnUpdateId = r.data.id;
    } 
    else 
    {
        this.showOnUpdateId = -1;
    }
}

QuestsView.prototype.refresh = function()
{
	//Service.quest.callMethod("getQuests", [], $.proxy(this.updateActiveQuests, this));

    this.onSwitcherChange();
}

QuestsView.prototype.clearQuestView = function()
{
	if (this.dialogBody)
	{
		COM(this.dialogBody).destroy();
	} 
}

QuestsView.showDialog = function()
{
	var dialog = COM.create("QuestsView");
	dialog.popup();
}