function RewardDialog()
{
	callParentConstructor(this);
	
	this.scroll = null;
	this.quest = null;
	this.onUpdate = null;	
	this.spawn_temp = null;
	this.onUpdateQuestView = null;
	
	this.__defineGetter__("rewardBox", this.getRewardBox);
}

extendClass(RewardDialog.prototype, ChooseRewardDialog.prototype);

RewardDialog.prototype.__construct = function()
{
	superMethod(RewardDialog.prototype, '__construct', this)();
	this.fullScreen();

	this.scroll = new iScroll(this.scrollWrapper, {scrollbarColor: '#784f0b'});

	COM.bindExclusiveClick(this.getRewardButton, $.proxy(function(e)
	{
		this.onAllChoosen(e.currentTarget);
	}, this));
	COM.bindExclusiveClick(this.closeButton, $.proxy(this.close, this));
}

RewardDialog.prototype.getRewardBox = function()
{
	return this.rewardDesc;
}

RewardDialog.prototype.popup = function(quest, onUpdateReceived, onUpdateQuestView)
{
	this.quest = quest;
	this.onUpdate = onUpdateReceived;
	this.onUpdateQuestView = $.proxy(onUpdateQuestView, this);

	COM(this.getRewardButton).setSkin("green");
	
	superMethod(RewardDialog.prototype, "popup", this)();
	
	//$.proxy(this.onAllChoosen(), this);
	
	//this.addRewardView();
}

RewardDialog.prototype.onShow = function()
{
	this.scrollWrapper.style.height = (this.content.offsetHeight - 10) + "px";
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
}

RewardDialog.prototype.spawnRewardsDialog = function()
{
	if (!this.spawn_temp) this.spawn_temp = EffectsView.createQuestActivationView($.proxy(this.onOuterDialogChosen,this), this.rewardDesc, this.quest.rewards, null);
	return this.spawn_temp;
}

RewardDialog.prototype.onAllChosenSpecific = function(rewardData)
{
    Service.quest.callMethod("getReward", [this.quest.name,rewardData],$.proxy(this.onNewUpdate, this),$.proxy(this.handleFail, this));
}

RewardDialog.prototype.onNewUpdate = function(e)
{
	this.onUpdate(this.quest,e);
}

RewardDialog.prototype.handleFail = function(e)
{
	if(e.__className__ == "CantStartMissionException")
	{
		Alert.create(I18.monsterAttackError(e.type));
	}
	else if(GameException.isDisplayable(e))
	{
		Alert.create(e.getMessage());
	}
	
	//a.onClose = $.proxy(this.onAlertClose,this);
	
	/*
    getRewardButton.enabled = true;
    if (e is CantStartMissionException) {
        GameAlert.doShow(I18h.monsterAttackError((e as GameException).type));
        return true;
    } else if (GameException.isDisplayable(e)) {
        GameAlert.doShow(GameException(e).getMessage());
        return true;
    }
    */
    return true;
}

RewardDialog.prototype.onAlertClose = function()
{
	this.close();
}

RewardDialog.prototype.init = function()
{
    if (UI.show(this.quest.lastEducational, [this.advisor, this.educationLabel]))
	{
		this.advisor.src = STATIC_URL+Assets.getAdvisor(FUser.CURRENT_USER.race);
    }
}

RewardDialog.prototype.addRewardView = function()
{
	
	var lbl = document.createElement('div');
	$(this.rewardText).append(lbl);
	
	EffectsView.createDescriptiveView(this.rewardText, this.quest.rewards, true, false, false, false);	
	
	if (!this.quest.allowedWithAttack) 
	{
	    $(this.rewardText).append(I18.getMegaString('QUEST_ERROR_WITH_ATTACK', FConfig));
	} 
	else if (!this.quest.allowedUnderAttack) 
	{
	    $(this.rewardText).append(I18.getMegaString('QUEST_ERROR_UNDER_ATTACK', FConfig));
	}
	
}