function RatingList()
{
	callParentConstructor(this);
	this.__defineGetter__('selected', function()
	{
	    var selRenderer = null//membersList.selected as ClanMemberRenderer;
	    if (selRenderer) 
	    {
	        return selRenderer.data;
	    } 
        return null;
	});
	this.visibleItems = 25;
	this.topTab = 0;

	this.searchResult = "";
}

extendClass(RatingList.prototype, ScrollableList.prototype);

RatingList.prototype.__construct = function()
{
	superMethod(this, '__construct')();
	//this.setHeader(["null","adfkadnsjk","asdljkfasklj"]);
}

RatingList.prototype.update = function(rating,selectedTopTab,h)
{	
	this.searchResult = rating.searchResult;
	rating = rating.users;
	this.topTab = selectedTopTab;
	var data = [];
	for (var prop in rating)
	{
		if (!isNaN(parseInt(prop))) data[parseInt(prop)] = rating[prop];
	}	
	this.dataProvider = data;
	this.refresh();
	
	var dh = selectedTopTab == (2 || 3) ? 128 : 105;
	var h = h-$(this.header).height()-dh + "px";
	$(this.list).css({ 'height': h });
}

RatingList.prototype.tick = function()
{
    for (var i = 0, len = this.items.length; i < len; i++)
    {
    	COM(this.items[i]).tick();
    }
}

RatingList.prototype.updateChildren = function()
{
	if (!this.dataProvider)
	{
		return this.clearChildren(0);
	}
	
	this.clearChildren(this.dataProvider.length);
	while(this.content.children.length < this.dataProvider.length)
	{
		var item = this.createRenderer();
		this.content.appendChild(item.DOM);
		//COM.bindExclusiveClick(item.DOM, $.proxy(this.itemClick, this));
	}
	
	for (var i = 0, len = this.dataProvider.length; i < len; i++)
	{
		COM(this.content.children[i]).data = this.dataProvider[i];
		
		var data = this.dataProvider[i];
		if (this.searchResult && data && !data.isClan)
		{
			if (this.searchResult == data.user.username)
			{
				COM(this.content.children[i]).setSkin("highlighted_r");
			}
		}
		if (this.searchResult && data && data.isClan)
		{
			if (this.searchResult == data.user.clanName)
			{
				COM(this.content.children[i]).setSkin("highlighted_r");
			}
		}
	}
	
	this.refreshHeight();	
	
	/*
	var c = this.content;
	$('header cell', this.list).each(function(n, obj){
		$(obj).css({ 'width': $('cell', c)[n].offsetWidth });
	});
	*/
	
	this.refreshHeader();
}

RatingList.prototype.createRenderer = function(data)
{
	var renderer;
	
	if (this.topTab == 0) renderer = COM.create('RatingListItem');
	if (this.topTab == 1) renderer = COM.create('RatingClanListItem');
	if (this.topTab == 2) renderer = COM.create('RatingTournamentListItem');

	$(renderer.DOM).css({'cursor': this.allowControl ? 'pointer' : 'default'});
    COM.bindExclusiveClick(renderer.DOM, $.proxy(this.showUserDialog, this));

    return renderer;
}


RatingList.prototype.showUserDialog = function(e)
{	
	if (this.scroll && (this.scroll.directionX || this.scroll.directionY)) return false;
	var renderer = COM(e.currentTarget);
	var d = COM.create("UserInfoDialog");
	d.popup(renderer._data.user);

}
