function RatingSheet()
{
	callParentConstructor(RatingSheet.prototype, this);
	this.scroll = null;

	this.selectedUsername = "";
	this.rightPanelExpanded = false;
	this.dropDownMenuExpanded = false;
	
	
	this.selectedTopTab = 0;
	this.currentRatingType = null;
	this.ratingList = null;
}

extendClass(RatingSheet.prototype, Dialog.prototype);

RatingSheet.prototype.__construct = function()
{	
	superMethod(RatingSheet.prototype, '__construct', this)();
	this.fullScreen();
	COM(this.pager).onSelect = $.proxy(function(n, cnt){
		this.changePage(n,cnt);
	}, this);
}

RatingSheet.instance = null;

RatingSheet.prototype.popup = function(username)
{
	superMethod(RatingSheet.prototype, "popup", this)();
	
	this.selectedUsername = username ? username : FUser.CURRENT_USER.username;
         
   	this.setDialogStyle();
	this.shade.style.display = "none";
   	//COM(this.searchField).setSize(6);      

	COM(this.searchButton).setIcon(STATIC_INTERFACE_URL + "kingdom/search.png");
      
   	COM.bindExclusiveClick(this.topLevelHolderButton, $.proxy(function(e)
	{
		if (this.rightPanelExpanded) this.toogleRightPanel();
		
		this.shade.style.display = "";				
		this.toogleDropDownMenu();
	}, this));   
   
   
   	COM.bindExclusiveClick(this.shade, $.proxy(function(e)
	{
		this.shade.style.display = "none";
		if (this.dropDownMenuExpanded) this.toogleDropDownMenu();
		if (this.rightPanelExpanded) this.toogleRightPanel();
	}, this));
   
   	COM.bindExclusiveClick(this.stackButton, $.proxy(function(e)
	{
		if (this.dropDownMenuExpanded) this.toogleDropDownMenu();
		this.toogleRightPanel();
		e.stopImmediatePropagation();
		return false;
	}, this));				   
    
    COM.bindExclusiveClick(this.users, $.proxy(function(e)
	{
		this.changeTopLevelTab(0);
		this.changeTab();
		this.toogleDropDownMenu();		
		COM(this.stackButton).setCaption(I18.f("EMPIRE_POWER"));		
	}, this));
	
	COM.bindExclusiveClick(this.clans, $.proxy(function(e)
	{
		this.changeTopLevelTab(1);
		this.changeTab();
		this.toogleDropDownMenu();
		COM(this.stackButton).setCaption(I18.f("CLAN_EMPIRE_POWER"));
	}, this));
	
	this.brotherhoodRating.style.display = FConfig.BROTHERHOOD_ACTIVE ? "" : "none";
	this.frags.style.display = FConfig.IS_SURVIVAL ? "" : "none";		
	this.clanBrotherhoodRating.style.display = FConfig.BROTHERHOOD_ACTIVE ? "" : "none";		
	this.tournaments.style.display = FUser.CURRENT_USER.tournamentExists || FUser.CURRENT_USER.tournamentGrottoExists ? "" : "none";
	this.tournamentFlag.style.display = FUser.CURRENT_USER.tournamentExists ? "" : "none";
	this.tournamentGrotto.style.display = FUser.CURRENT_USER.tournamentGrottoExists ? "" : "none";
		
	COM.bindExclusiveClick(this.tournaments, $.proxy(function(e)
	{
		this.changeTopLevelTab(2);
		this.changeTab();
		this.toogleDropDownMenu();
		var caption = FUser.CURRENT_USER.tournamentExists ? I18.f("TOURNAMENT_FLAG") : I18.f("TOURNAMENT_GROTTO")
		COM(this.stackButton).setCaption(caption);
	}, this));
	
	var onTabClick = $.proxy(function(e)
	{
		COM(this.stackButton).setCaption($(e.target).text());
		$(e.target).parent().children().removeClass("currentTab");
		$(e.target).addClass("currentTab");
		
		this.showUserRating(e.target);
		this.toogleRightPanel();
		
		e.stopImmediatePropagation();
		return false;
	}, this);
	
	$(this.ratingTabHolder).children().on(CLICK_EVENT, onTabClick);
	
	var onClanTabClick = $.proxy(function(e)
	{
		COM(this.stackButton).setCaption($(e.target).text());
		
		$(e.target).parent().children().removeClass("currentTab");
		$(e.target).addClass("currentTab");
		
		this.showClanRating(e.target);
		this.toogleRightPanel();

		e.stopImmediatePropagation();
		return false;
	}, this);
	$(this.ratingClanTabHolder).children().on(CLICK_EVENT, onClanTabClick);
	
	var onTournamentTabClick = $.proxy(function(e)
	{
		COM(this.stackButton).setCaption($(e.target).text());
		
		$(e.target).parent().children().removeClass("currentTab");
		$(e.target).addClass("currentTab");
		
		this.showTournamentRating(e.target);
		this.toogleRightPanel();

		e.stopImmediatePropagation();
		return false;
	}, this);

	$(this.ratingTournamentTabHolder).children().on(CLICK_EVENT, onTournamentTabClick);
		
	COM.bindExclusiveClick(this.searchButton, $.proxy(function()
	{
		this.search();
		this.toogleRightPanel();
	}, this));
		
	this.changeTopLevelTab(0);
	this.changeTab();
	
	COM(this.pager).enabled = true;
}


RatingSheet.prototype.changePage = function(n, cnt)
{		
	APP.showLoader();
	
	if (this.selectedTopTab == 0)
	{
		Service.user.callMethod("getRatingMobile",[this.currentRatingType, this.selectedUsername, n, false],$.proxy(function(e)
		{
			this.createList(e);
			
		},this),$.proxy(this.handlerError,this));
	}
	else if (this.selectedTopTab == 1)
	{
		Service.user.callMethod("getClanRatingMobile",[this.currentRatingType, this.selectedUsername, n],$.proxy(function(e)
		{
			this.createList(e);
		},this),$.proxy(this.handlerError,this));
	}
	else
	{
		Service.user.callMethod("getRatingMobile",[this.currentRatingType, this.selectedUsername, n, false],$.proxy(function(e)
		{
			this.createList(e);
		},this),$.proxy(this.handlerError,this));
	}	
}

RatingSheet.prototype.clearRating = function()
{
	if (this.ratingList) this.ratingList.destroy();
}

RatingSheet.prototype.showUserRating = function(target)
{
	if (target)
	{
		var ratingType;
		var name = $(target).attr("name");
		switch (name)
		{
			case "empirePower" :  ratingType = RatingType.EMPIRE_POWER; break;	
			case "armyPower" :  	ratingType = RatingType.ARMY_POWER;	break;
			case "fractionLoyality" :  ratingType = RatingType.FRACTION_LOYALTY; break;
			case "heroRating" :  ratingType = RatingType.HERO; break;
			case "brotherhoodRating" :  ratingType = RatingType.BROTHERHOOD; break;
			case "frags" :  ratingType = RatingType.FRAGS; break;
			case "monsterKiller" :  ratingType = RatingType.MONSTER_KILLER; break;
		}
		this.currentRatingType = ratingType;
	}
	else
	{
		this.currentRatingType = RatingType.EMPIRE_POWER;
	}
	var userName = (COM(this.searchField).getValue() == "") ? this.selectedUsername : COM(this.searchField).getValue();
			
	Service.user.callMethod("getRatingMobile",[this.currentRatingType, userName, -1, false],$.proxy(function(e)
	{
		this.createList(e);		
	},this),$.proxy(this.handlerError,this));
}

RatingSheet.prototype.showClanRating = function(target)
{
	if (target)
	{
		var ratingType;
		var name = $(target).attr("name");
		switch (name)
		{
			case "clanEmpirePower" :  ratingType = RatingType.EMPIRE_POWER; break;
			case "clanArmyPower" :  	ratingType = RatingType.ARMY_POWER;	break;
			case "clanFractionLoyalty" :  ratingType = RatingType.FRACTION_LOYALTY; break;
			case "heroRating" :  ratingType = RatingType.HERO; break;
			case "clanBrotherhoodRating" :  ratingType = RatingType.BROTHERHOOD; break;
			case "monsterKiller" :  ratingType = RatingType.FRAGS; break;
		}		
		this.currentRatingType = ratingType;
	}
	else
	{
		this.currentRatingType = RatingType.EMPIRE_POWER;
	}
		
	var userName = (COM(this.searchField).getValue() == "") ? this.selectedUsername : COM(this.searchField).getValue();
	Service.user.callMethod("getClanRatingMobile",[this.currentRatingType, userName, -1],$.proxy(function(e)
	{
		this.createList(e);
	},this),$.proxy(this.handlerError,this));
}

RatingSheet.prototype.showTournamentRating = function(target)
{
	if (target)
	{
		var ratingType;
		var name = $(target).attr("name");
		switch (name)
		{
			case "tournamentFlag" :  ratingType = RatingType.TOURNAMENT_FLAG; break;
			case "tournamentGrotto" :  	ratingType = RatingType.TOURNAMENT_GROTTO;	break;
		}
		this.currentRatingType = ratingType;
	}
	else
	{
		this.currentRatingType = RatingType.TOURNAMENT_FLAG;
	}
	var userName = (COM(this.searchField).getValue() == "") ? this.selectedUsername : COM(this.searchField).getValue();
	Service.user.callMethod("getRatingMobile",[this.currentRatingType, userName, -1, false],$.proxy(function(e)
	{
		this.createList(e);
	},this),$.proxy(this.handlerError,this));
}

RatingSheet.prototype.createList = function(rating)
{
	COM(this.progress).update(rating.titlePoints < rating.nextTitle ?
		rating.titlePoints : rating.nextTitle, rating.nextTitle);
		
	this.selectedUsername = rating.searchResult;
	
	var listHeader = [];
	if (this.selectedTopTab ==0)
	{
		listHeader = [/*I18.f("RATING")*/'#',I18.f("PLAYER"),I18.f("RACE"),I18.f("POINTS"),I18.f("TITLE"),I18.f("CLAN")];
	}
	else if (this.selectedTopTab == 1)
	{
		listHeader = [/*I18.f("RATING")*/'#',I18.f("CLAN"),I18.f("TYPE"),I18.f("POINTS"),I18.f("PLAYERS"),I18.f("CASTLES")];
	}
	else
	{
		listHeader = [/*I18.f("RATING")*/'#',I18.f("PLAYER"),I18.f("RACE"),I18.f(this.currentRatingType.name == RatingType.TOURNAMENT_FLAG.name ? "FLAG_SETS_MOBILE" : "GROTTO_SETS_MOBILE"),I18.f("TITLE"),I18.f("CLAN")];		
		if (!FConfig.CASTLES_ENABLED) listHeader.pop();
	}	
	
	this.clearRating();

	var h = $(this.wrapper).height() - $(this.header).height();

	COM(this.pager).page = rating.currentPage;
	COM(this.pager).total = rating.pagesCount;

	COM(this.pager).setIndexAndCount(rating.currentPage, rating.pagesCount);
	
	this.ratingList = COM.create("RatingList");
	this.ratingList.setHeader(listHeader);
	this.ratingList.update(rating, this.selectedTopTab,h);
	this.listBody.appendChild(this.ratingList.DOM);
	
	var items = this.ratingList.items;
	var h = Math.floor(this.ratingList.list.offsetHeight / 10) - 2;
	
	for(var i=0; i<items.length; i++)
	{
		items[i].style.height = h+"px";
	}
	
	this.ratingList.scroll.options.onScrollMove = $.proxy(function()
	{
		this.changePageDirection = this.ratingList.scroll.y < 0 ? 1 : -1;
	}, this);
	
	this.ratingList.scroll.options.onScrollEnd = $.proxy(function()
	{
		var pager = COM(this.pager);
		var p = pager.page + this.changePageDirection;
		if (p < 0 || p >= pager.total) return;
		
		pager.page = p;
		pager.showHint(true);
		this.changePage(p, pager.total);
	}, this);
	
	APP.hideLoader();
}

RatingSheet.prototype.handlerError = function(error)
{
	if (GameException.isDisplayable(error)) 
    {
       	var alert_text = error.getMessage();
		var a = Alert.create(alert_text);
		//a.onClose = $.proxy(this.onAlertClose,this);
		
		COM(this.searchField).setValue("");
		this.selectedUsername = FUser.CURRENT_USER.username;	
		return true;
    }
    return false;
}

RatingSheet.prototype.toogleDropDownMenu = function()
{
	if(this.dropDownMenuExpanded)
	{
		this.shade.style.display = "none";
		this.hideDropDownMenu();
	}
	else
	{
		this.shade.style.display = "";
		this.showDropDownMenu();
	}
}

RatingSheet.prototype.hideDropDownMenu = function()
{
	this.dropDownMenu.style.display = "none";
	this.dropDownMenuExpanded = false;
}

RatingSheet.prototype.showDropDownMenu = function()
{	
	this.tournaments.style.display = FUser.CURRENT_USER.tournamentExists || FUser.CURRENT_USER.tournamentGrottoExists ? "" : "none";
	this.dropDownMenu.style.display = "";
	this.dropDownMenuExpanded = true;
	
	this.dropDownMenu.style.left = getObjectX(COM(this.topLevelHolderButton).wrapper) + "px";
	this.dropDownMenu.style.width = COM(this.topLevelHolderButton).DOM.offsetWidth + "px";
}

RatingSheet.prototype.toogleRightPanel = function()
{
	if(this.rightPanelExpanded)
	{
		this.shade.style.display = "none";
		this.hidePanels();
	}
	else
	{
		this.shade.style.display = "";
		this.showRightPanel();
	}
}

RatingSheet.prototype.hidePanels = function()
{
	/*
	this.DOM.style.webkitTransitionDuration = "300ms";
	this.DOM.style.webkitTransform = "translate3d(0px, 0px, 0px)";
	this.rightPanelExpanded = false;
	*/
	$(this.DOM).removeClass("rightPanelExpanded");
	this.rightPanelExpanded = false;
}

RatingSheet.prototype.showRightPanel = function()
{
	/*
	this.DOM.style.webkitTransitionDuration = "300ms";
	this.DOM.style.webkitTransform = "translate3d(-480px, 0px, 0px)";
	this.rightPanelExpanded = true;
	*/
	$(this.DOM).addClass("rightPanelExpanded");
	this.rightPanelExpanded = true;
}

RatingSheet.prototype.changeTab = function(e)
{
	if (this.selectedTopTab == 0) this.showUserRating();
	if (this.selectedTopTab == 1) this.showClanRating();
	if (this.selectedTopTab == 2) this.showTournamentRating();
}

RatingSheet.prototype.getSelectedTab = function()
{
    return RatingTabParent(ExtendedTabNavigator(this.stack.selectedChild).selectedChild);
}

RatingSheet.prototype.sendLetter = function()
{
    MailBoxView.i().sendMessage(this.getSelectedTab().getSelectedUser().user.username);
}

RatingSheet.prototype.showUser = function()
{
    UserInfoDialog.popup(this.getSelectedTab().getSelectedUser().user.username);
}

RatingSheet.prototype.onTooltip = function(e/*:ToolTipEvent*/, o/*:Object*/)
{
    e.toolTip = EstateStarsClanView.createAsTip(FRatingData(o).user, null, false, FRatingData(o).isClan);
}

RatingSheet.prototype.printFraction = function(race)
{
    return I18.getFractionName(race);
}

RatingSheet.prototype.initTab = function(e)
{
    RatingTabParent(e.currentTarget).init(selectedUsername);
}

RatingSheet.prototype.updateProgress = function(r)
{
    this.progress.setProgress(r.titlePoints < r.nextTitle ? r.titlePoints : r.nextTitle, r.nextTitle);
    //this.progress.toolTip = formatter.format(r.titlePoints) + " / " + formatter.format(r.nextTitle);
}

RatingSheet.prototype.search = function()
{
   	//this.selectedUsername = COM(this.searchField).getValue();
    this.changeTab();
}

RatingSheet.prototype.clearUsername = function()
{
    this.selectedUsername = null;
}

RatingSheet.prototype.selectedTopTab = 0;

RatingSheet.prototype.changeTopLevelTab = function(index)
{
   	this.selectedTopTab = index;   
   	var caption,icon,l;

	if (index==0)
	{		
		this.ratingTabHolder.style.display = "";
		this.ratingClanTabHolder.style.display = "none";
		this.ratingTournamentTabHolder.style.display = "none";
		caption = I18.f("RATING_USERS");
		icon = STATIC_INTERFACE_URL + "shared/rating/users.png";
		$(this.ratingTabHolder).children().removeClass("currentTab");
		$(this.ratingTabHolder).find(':first-child').addClass("currentTab");		
	} 
	if (index==1)
	{
		this.ratingTabHolder.style.display = "none";
		this.ratingClanTabHolder.style.display = "";
		this.ratingTournamentTabHolder.style.display = "none";
		caption = I18.f("RATING_CLANS");
		icon = STATIC_INTERFACE_URL + "shared/rating/clans.png";
		$(this.ratingClanTabHolder).children().removeClass("currentTab");
		$(this.ratingClanTabHolder).find(':first-child').addClass("currentTab");
	} 
	if (index==2)
	{		
		this.ratingTabHolder.style.display = "none";
		this.ratingClanTabHolder.style.display = "none";
		this.ratingTournamentTabHolder.style.display = "";
		
		caption = I18.f("RATING_TOURNAMENTS");
		icon = STATIC_INTERFACE_URL + "shared/rating/tournaments.png";
		$(this.ratingTournamentTabHolder).children().removeClass("currentTab");
		$(this.ratingTournamentTabHolder).find(':first-child').addClass("currentTab");
	} 
   	COM(this.topLevelHolderButton).setCaption(caption);
   	COM(this.topLevelHolderButton).setIcon(icon);   	   	
   	   	
    this.stack.selectedIndex = index;
    this.selectedTopTab = index;        
}

RatingSheet.prototype.mouseOverTopTab = function(index, isOver)
{	
	/*
    var color = index == selectedTopTab ? COLOR_SELECTED : (isOver ? COLOR_HOVER : COLOR_UNSELECTED);
    UIComponent(topLevelHolder.getChildAt(index)).setStyle("backgroundColor", color);
    */    
}

RatingSheet.showDialog = function(username)
{
	var dialog = COM.create("RatingSheet");
	dialog.popup(username);
}

RatingSheet.prototype.fitLayout = function(container)
{
	if("ontouchstart" in window && document.body.scrollTop > 1)
	{
		return;
	}
	
	if(!container) container = {width: window.innerWidth, height: window.innerHeight};
	
	superMethod(RatingSheet.prototype, "fitLayout", this)(container);
	/*
	this.closeContactsShader.style.width = container.width + "px";
	this.closeContactsShader.style.height = container.height + "px";
	*/
	var padding = parseFloat($("> contentwrapper", this.wrapper).css("padding-right"));
	
	this.extendedTabNavigator.style.left = (container.width-padding)-2 + "px";
	this.extendedTabNavigator.style.height = container.height + "px";
	if ($(this.header).height()>0)
	{
		this.extendedTabNavigator.style.top = $(this.header).height()*(-1) + "px";
		this.extendedTabNavigatorHeader.style.height = $(this.header).height() + "px";
		
		/*
		this.topLevelHolder.style.left = container.width-$(this.stackButton).width()-
		$(this.topLevelHolderButton).width()-140 + "px";
		*/

		//this.pager.style.height = container.height-$(this.header).height()-padding + 'px';
		//this.pagerBox.style.top = 0 + 'px';
		//this.pagerBox.style.left = (container.width-padding)-35 + "px";
		//this.pagerBox.style.left = 10 + "px";
	} 	
		
	this.shade.style.width = window.innerWidth + "px";
	this.shade.style.height = window.innerHeight + "px";
}

RatingSheet.prototype.setDialogStyle = function()
{		
	
}