function RatingSheet()
{
	callParentConstructor(RatingSheet.prototype, this);
	this.scroll = null;

	this.selectedUsername = "";
	this.rightPanelExpanded = false;
	this.dropDownMenuExpanded = false;
	
	
	this.selectedTopTab = 0;
}

extendClass(RatingSheet.prototype, Dialog.prototype);

RatingSheet.prototype.__construct = function()
{
	superMethod(RatingSheet.prototype, '__construct', this)();
	this.fullScreen();
}

RatingSheet.instance = null;

RatingSheet.prototype.popup = function(specialUser)
{
	superMethod(RatingSheet.prototype, "popup", this)();
	specialUser = !specialUser ? "" : specialUser;

   	COM(this.progress).update(7,10);
   	COM(this.searchField).setSize(6);
   
   	COM.bindExclusiveClick(this.topLevelHolderButton, $.proxy(function(e)
	{
		this.toogleDropDownMenu();
	}, this));
   
   	COM.bindExclusiveClick(this.stack, $.proxy(function(e)
	{
		this.toggleRightPanel();
	}, this));
    
    COM.bindExclusiveClick(this.users, $.proxy(function(e)
	{
		this.changeTopLevelTab(0);
		this.toogleDropDownMenu();
	}, this));
	
	COM.bindExclusiveClick(this.clans, $.proxy(function(e)
	{
		this.changeTopLevelTab(1);
		this.toogleDropDownMenu();
	}, this));
	
	COM.bindExclusiveClick(this.tournaments, $.proxy(function(e)
	{
		this.changeTopLevelTab(2);
		this.toogleDropDownMenu();
	}, this));

	this.changeTopLevelTab(0);
	this.changeTab();
}

RatingSheet.prototype.toogleDropDownMenu = function()
{
	if(this.dropDownMenuExpanded)
	{
		this.hideDropDownMenu();
	}
	else
	{
		this.showDropDownMenu();
	}
}

RatingSheet.prototype.hideDropDownMenu = function()
{
	this.dropDownMenu.style.display = "none";
	this.dropDownMenuExpanded = false;
}

RatingSheet.prototype.showDropDownMenu = function()
{	
	this.tournaments.style.display = FUser.CURRENT_USER.tournamentExists || FUser.CURRENT_USER.tournamentGrottoExists ? "" : "none";
	this.dropDownMenu.style.display = "";
	this.dropDownMenuExpanded = true;
}

RatingSheet.prototype.toggleRightPanel = function()
{
	if(this.rightPanelExpanded)
	{
		this.hidePanels();
	}
	else
	{
		this.showRightPanel();
	}
}

RatingSheet.prototype.hidePanels = function()
{
	//this.DOM.style.webkitTransitionDuration = "300ms";
	//this.DOM.style.webkitTransform = "translate3d(0px, 0px, 0px)";
	$(this.DOM).removeClass("rightPanelExpanded");
	this.rightPanelExpanded = false;
}

RatingSheet.prototype.showRightPanel = function()
{
	//this.DOM.style.webkitTransitionDuration = "300ms";
	//this.DOM.style.webkitTransform = "translate3d(-480px, 0px, 0px)";
	$(this.DOM).addClass("rightPanelExpanded");
	this.rightPanelExpanded = true;
}

RatingSheet.prototype.changeTab = function()
{
    this.getSelectedTab().init(this.selectedUsername);
}

RatingSheet.prototype.getSelectedTab = function()
{
    return RatingTabParent(ExtendedTabNavigator(this.stack.selectedChild).selectedChild);
}

RatingSheet.prototype.sendLetter = function()
{
    MailBoxView.i().sendMessage(this.getSelectedTab().getSelectedUser().user.username);
}

RatingSheet.prototype.showUser = function()
{
    UserInfoDialog.popup(this.getSelectedTab().getSelectedUser().user.username);
}

RatingSheet.prototype.onTooltip = function(e/*:ToolTipEvent*/, o/*:Object*/)
{
    e.toolTip = EstateStarsClanView.createAsTip(FRatingData(o).user, null, false, FRatingData(o).isClan);
}

RatingSheet.prototype.printFraction = function(race)
{
    return I18.getFractionName(race);
}

RatingSheet.prototype.initTab = function(e)
{
    RatingTabParent(e.currentTarget).init(selectedUsername);
}

RatingSheet.prototype.updateProgress = function(r)
{
    this.progress.setProgress(r.titlePoints < r.nextTitle ? r.titlePoints : r.nextTitle, r.nextTitle);
    //this.progress.toolTip = formatter.format(r.titlePoints) + " / " + formatter.format(r.nextTitle);
}

RatingSheet.prototype.search = function()
{
    this.selectedUsername = searchField.text;
    this.changeTab();
}

RatingSheet.prototype.clearUsername = function()
{
    this.selectedUsername = null;
}

RatingSheet.prototype.selectedTopTab = 0;


RatingSheet.prototype.changeTopLevelTab = function(index)
{
   	var caption;
	if (index==0) caption = I18.f("RATING_USERS");
	if (index==1) caption = I18.f("RATING_CLANS");
	if (index==2) caption = I18.f("RATING_TOURNAMENTS");
   	COM(this.topLevelHolderButton).setCaption(caption);
   	   	
    this.stack.selectedIndex = index;
    this.selectedTopTab = index;
}

RatingSheet.prototype.mouseOverTopTab = function(index, isOver)
{	
}

RatingSheet.showDialog = function()
{
	var dialog = COM.create("RatingSheet");
	dialog.popup();
}

RatingSheet.prototype.fitLayout = function(container)
{	
	superMethod(RatingSheet.prototype, "fitLayout", this)(container);
}
