function SocialPublisher(icon, handler)
{
	this.icon = icon;
	this.handler = handler;
	
	this.__defineGetter__("name", this.getName);
}

SocialPublisher.prototype.publish = function(publication)
{
    var params = {
        "social-type": this.name,
        "current-user-name": FUser.CURRENT_USER.username,
        "current-user-portal-id": FUser.CURRENT_USER.portalId,
        "short-referal-link": FConfig.computeShortRefLink(FUser.CURRENT_USER.portalId),
        "portal-url": FConfig.getPortalAddress(),
        "server": FConfig.getServerShortName()
    };
    var link = I18.getMegaString("SOCIAL_PUBLICATION_" + publication + "_LINK", params);
    var title = I18.getMegaString("SOCIAL_PUBLICATION_" + publication + "_TITLE", params);
    var body = I18.getMegaString("SOCIAL_PUBLICATION_" + publication + "_BODY", params);
    var img = I18.getMegaString("SOCIAL_PUBLICATION_" + publication + "_IMAGE", params);
    this.handler(link, title, body, img);
}

SocialPublisher.prototype.getName = function()
{
    for(var key in SocialPublisher)
    {
    	if(SocialPublisher[key] == this) return key;
    }
}

// http://vk.com/pages?oid=-1&p=Публикация_сторонних_страниц
SocialPublisher.VK = new SocialPublisher(Assets.SOCIAL_NETWORK_VK,
        function (link, title, body, image)
        {
            SocialPublisher.openWindow("http://vk.com/share.php", {
                url:link,
                title:title,
                description:body,
                image:image
            });
        });

// http://dev.odnoklassniki.ru/wiki/display/plugins/Social+Plugins
SocialPublisher.OK = new SocialPublisher(Assets.SOCIAL_NETWORK_OK,
        function (link, title, body, image)
        {
            var url = SocialPublisher.formatUrl(FConfig.getPortalAddress() + "pub", {l:link, t:title, b:body, i:image});
            SocialPublisher.openWindow("http://www.odnoklassniki.ru/dk", {
                "st.cmd":"addShare",
                "st._surl":url
            });
        });

// http://api.mail.ru/sites/plugins/share/extended/
SocialPublisher.MM = new SocialPublisher(Assets.SOCIAL_NETWORK_MM,
        function (link, title, body, image)
        {
            SocialPublisher.openWindow("http://connect.mail.ru/share", {
                url:link,
                title:title,
                description:body,
                imageurl:image
            });
        });

// http://www.facebook.com/note.php?note_id=407822831963
SocialPublisher.FB = new SocialPublisher(Assets.SOCIAL_NETWORK_FB,
        function (link, title, body, image)
        {
            SocialPublisher.openWindow("https://www.facebook.com/dialog/feed",
                {   app_id:133734186794274,
                    link:link,
                    caption:title,
                    description:body,
                    picture:image,
                    redirect_uri: "https://www.facebook.com/"
                }
            );
        });

// https://dev.twitter.com/docs/intents
SocialPublisher.TW = new SocialPublisher(Assets.SOCIAL_NETWORK_TW,
        function (link, title, body, image)
        {
            SocialPublisher.openWindow("https://twitter.com/intent/tweet", {
                url:link,
                text:title + "\n" + body
            });
        });

SocialPublisher.openWindow = function(root, params)
{
    var windowUrl = SocialPublisher.formatUrl(root, params);
    var w = window.open(windowUrl, "_blank");
    if (w['show']) w.show();
}

SocialPublisher.formatUrl = function(root, params)
{
    var data = "";
    for (var key in params) {
        if (data != "") {
            data += "&";
        }
        data += (key + "=" + encodeURIComponent(params[key]));
    }
    return root + "?" + data;
}