function FHeroConfig()
{
    this.staticUrl = null;
    this.assetRegion = null;
    this.etag = null;
    this.assetSize = null;
    this.layoutDirection = null;

    this.localeStrings = null;
    this.clientTexts = null;

    this.passives = null;

    this.heroSpells = null;
    this.heroTemplates = null;
    this.heroClasses = null;
    this.branches = null;

    this.artifactSpells = null;
    this.artifacts = null;
    this.sets = null;

    this.scrollSpells = null;
    this.scrolls = null;

    this.BEFORE_ATTACK_BLOCK = null;
    this.BEFORE_ATTACK_FEATURES_BLOCK = null;

    this.configId = null;
}

FHeroConfig._instance = new FHeroConfig();

FHeroConfig.prototype.__CLS__ = "game.service.FHeroConfig";

FHeroConfig.i = function()
{
    return FHeroConfig._instance;
}

FHeroConfig.load = function(config)
{
    FHeroConfig._instance = config;

    FConfig.STATIC_URL = config.staticUrl;
    FConfig.ASSET_REGION = config.assetRegion;
    FConfig.ETAG = config.etag;
    FConfig.ASSET_SIZE = config.assetSize;

    I18.load(config.localeStrings);
    FConfig.clientTexts = config.clientTexts;
    FConfig.BEFORE_ATTACK_BLOCK = config.BEFORE_ATTACK_BLOCK;
    FConfig.BEFORE_ATTACK_FEATURES_BLOCK = config.BEFORE_ATTACK_FEATURES_BLOCK;

    switch (HeropediaViewType.getFromFlashVars())
    {
        case HeropediaViewType.HEROES:
            FConfig.passives = config.passives;
            FConfig.spells = config.heroSpells;
            FConfig.branches = config.branches;
            break;
        case HeropediaViewType.ARTIFACTS:
            FConfig.passives = config.passives;
            FConfig.spells = config.artifactSpells;
            config.fixSets();
            break;
        case HeropediaViewType.SCROLLS:
            FConfig.spells = config.scrollSpells;
            break;
    }

    var user = FUser.CURRENT_USER = new FUser();
    user.race = Race.HUMAN;
}

FHeroConfig.prototype.fixSets = function()
{
    if (this.sets)
    {
        var keys = this.sets.keys, setName, set, artifact;
        for(var i=0; i<keys.length; i++)
        {
        	setName = keys[i];
        	set = this.sets.getValue(setName);
        	for(var n=0; n<set.artifacts.length; n++)
        	{
        		artifact = this.artifacts.getValue(set.artifacts[n]);
        		artifact.setName = setName;
                artifact.setLevel = set.level;
                artifact.setPassive = set.passive;
        	}
        }
    }
}