function HeroConfigView()
{
	this.view = null;
}

HeroConfigView.prototype.__construct = function()
{
	this.view = this.createView();
	this.view.parent = this;
    
    this.scroll = new iScroll(this.scrollContainer);
    
    this.container.appendChild(this.view.DOM);

    var cb = COM(this.serverTypes);

    for(var i=0; i<GameServerType.NORMAL.length; i++)
    {
        if(I18.strings["ALT_GAME_SERVER_TYPE_" + GameServerType.NORMAL[i].name]) cb.addOption(i, GameServerType.NORMAL[i].label);
    }

    $(cb.DOM).on("change", $.proxy(this.onServerTypeChange, this));
    cb.selectedIndex = 0;
    cb.refresh();

    this.update();
}

HeroConfigView.prototype.refreshScroll = function()
{
	setTimeout($.proxy(this.scroll.refresh, this.scroll), 500);
}

HeroConfigView.prototype.update = function()
{
	if(this.view.update) this.view.update();
}

HeroConfigView.prototype.createView = function()
{
    switch (HeropediaViewType.getFromFlashVars().name)
    {
        case HeropediaViewType.HEROES.name:
            return COM.create("HeroTemplatesView");
        case HeropediaViewType.ARTIFACTS.name:
            return COM.create("ArtifactsView");
        case HeropediaViewType.SCROLLS.name:
            return COM.create("ScrollsView");
        default:
            return null;
    }
}

HeroConfigView.prototype.onServerTypeChange = function()
{
    var serverType = GameServerType.NORMAL[COM(this.serverTypes).value];
    HeroConfigLoader.i().load(serverType, $.proxy(function()
    {
        this.update();
    }, this));
}