function HeroTemplatesView()
{
	this.heroTemplateNames = [];
	this.baseSkillBranch = SkillBranch.createNewBranch(null, 3);
	this.specialitySkillBranch = SkillBranch.createNewBranch(null);
}

HeroTemplatesView.prototype.__construct = function()
{
	this.heroHasClassLabel.innerHTML = I18.f("HERO_HAS_CLASS");
	this.heroClassBasicSkillsLabel.innerHTML = I18.f("HERO_CLASS_DEFINES_BASIC_SKILLS");
	this.skillLevelLabel.innerHTML = I18.f("SKILL_LEVEL");
	this.heroClassSpecLabel.innerHTML = I18.f("HERO_CLASS_HAS_SPECIALITIES");
	this.skillBranchLabel.innerHTML = I18.f("SKILL_BRANCH_HAS_ACTIVES_AND_PASSIVES");
	this.skillLevelLabel2.innerHTML = I18.f("SKILL_LEVEL");
	this.heroOtherBranchesLabel.innerHTML = I18.f("HERO_HAS_OTHER_BRANCHES");
	
	COM(this.heroClasses).onChange = $.proxy(this.onHeroClassChange, this);
	
	var cb = COM(this.baseSkillLevels);
	for(var i=1; i<=5; i++) cb.addItem(i, i, i==1);
	cb.onChange = $.proxy(this.onBaseSkillLevelChange, this);
	
	var cb = COM(this.specialitySkillLevels);
	for(var i=1; i<=5; i++) cb.addItem(i, i, i==1);
	cb.onChange = $.proxy(this.onSpecialitySkillLevelChange, this);
	
	$(this.heroTemplates).on("change", $.proxy(this.onHeroTemplateChange, this));
	
	this.updateHeroClass();
	
	Arrays.fill(this.baseSkillBranch.levels, COM(this.baseSkillLevels).value);
    Arrays.fill(this.specialitySkillBranch.levels, COM(this.specialitySkillLevels).value);
}

HeroTemplatesView.prototype.updateHeroClass = function()
{
    var classes = Arrays.filter(FHeroConfig.i().heroClasses.keys, function (name)
	{
		var templates = FHeroConfig.i().heroTemplates.values;
		for(var i=0; i<templates.length; i++)
		{
			if (templates[i].enabled && templates[i].heroClass == name)
			{
				return true;
			}
		}
		return false;
	}).sort();
    
    var cb = COM(this.heroClasses);
    cb.clear();
    
    for(var i=0; i<classes.length; i++)
    {
    	cb.addItem(I18.getHeroClassName(classes[i]), classes[i], i==0);
    }
    
    this.onHeroClassChange();
}

HeroTemplatesView.prototype.update = function()
{
    this.updateHeroClass();
    this.parent.refreshScroll();
}

HeroTemplatesView.prototype.onHeroClassChange = function()
{
    var heroClass = FHeroConfig.i().heroClasses.getValue(COM(this.heroClasses).value);
    this.baseSkillBranch.name = heroClass.baseBranch;
    
    this.updateSkills(this.baseSkills, this.baseSkillBranch);
    this.updateHeroTemplate();
}

HeroTemplatesView.prototype.updateHeroTemplate = function()
{
    this.heroTemplateNames = Arrays.filter(FHeroConfig.i().heroTemplates.keys, $.proxy(function(name)
    {
        var template = FHeroConfig.i().heroTemplates.getValue(name);
        return template.enabled && template.heroClass == COM(this.heroClasses).value;
    }, this)).sort();
    
    COM(this.heroTemplates).dataProvider = Arrays.map(this.heroTemplateNames, function(name)
    {
        return I18.getBranchName(FHeroConfig.i().heroTemplates.getValue(name).initialBranch);
    });
    COM(this.heroTemplates).selectedIndex = 0;
    this.onHeroTemplateChange()
}

HeroTemplatesView.prototype.updateSkills = function(container, branch)
{
    for (var i = 0; i < branch.levels.length; i++)
    {
        COM(container.children[i]).update(branch, i, null, new FHero(), null);
    }
}

HeroTemplatesView.prototype.onBaseSkillLevelChange = function(val)
{
    Arrays.fill(this.baseSkillBranch.levels, COM(this.baseSkillLevels).value);
    this.updateSkills(this.baseSkills, this.baseSkillBranch);
}

HeroTemplatesView.prototype.onSpecialitySkillLevelChange = function(val)
{
    Arrays.fill(this.specialitySkillBranch.levels, COM(this.specialitySkillLevels).value);
    this.updateSkills(this.specialitySkills, this.specialitySkillBranch);
}

HeroTemplatesView.prototype.onHeroTemplateChange = function()
{
    if (COM(this.heroTemplates).selectedIndex < 0)
    {
        return;
    }
    this.updateHero();
}

HeroTemplatesView.prototype.updateHero = function()
{
    var heroTemplateName = this.heroTemplateNames[COM(this.heroTemplates).selectedIndex];
    var heroTemplate = FHeroConfig.i().heroTemplates.getValue(heroTemplateName);
    this.maleFace.src = STATIC_INTERFACE_URL + Assets.getHeroFace(heroTemplate.maleFace);
    this.femaleFace.src = STATIC_INTERFACE_URL + Assets.getHeroFace(heroTemplate.femaleFace);
    this.specialitySkillBranch.name = heroTemplate.initialBranch;
    this.updateSkills(this.specialitySkills, this.specialitySkillBranch);
}