function FeedbackDialog()
{
	callParentConstructor(FeedbackDialog.prototype, this);
}

extendClass(FeedbackDialog.prototype, Dialog.prototype);

FeedbackDialog.create = function(onSend, email)
{
	var fd = COM.create('FeedbackDialog');
	
	fd.onSend = onSend || function(){};
	COM(fd.from).value = email || '';
	
	fd.popup();
	fd.refresh();
	
	return fd;
}

FeedbackDialog.prototype.__construct = function()
{
	superMethod(FeedbackDialog.prototype, '__construct', this)();
	
	this.fullScreen();
	
	COM.bindExclusiveClick(this.send, $.proxy(this.doSend, this));
	
	var refresh = $.proxy(this.refresh, this);
	$(this.from).on('keyup', refresh);
	$(this.subject).on('keyup', refresh);
	$(this.message).on('keyup', refresh);
}

FeedbackDialog.prototype.onSend = function(from, subject, content){};

FeedbackDialog.prototype.refresh = function()
{
    var fromIsValid = /^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/.test(COM(this.from).value);
    var subjectIsValid = COM(this.subject).value.length > 0;
    var contentIsValid = this.message.value.length > 0;
    
    $(this.fromLabel).toggleClass('negative', !fromIsValid);
    $(this.subjectLabel).toggleClass('negative', !subjectIsValid);
    $(this.charsCount).toggleClass('negative', !contentIsValid);

    this.charsCount.innerHTML = this.message.value.length + "/" + this.message.getAttribute('maxlength');
    COM(this.send).reason = (fromIsValid && subjectIsValid && contentIsValid) ? null : I18.f('NEED_TO_FILL_DATA');
}

FeedbackDialog.prototype.doSend = function()
{
	this.onSend(COM(this.from).value, COM(this.subject).value, this.message.value);
	this.close();
}
