function LoginScreenView()
{
	this.captcha = null;
}

LoginScreenView.prototype.captcha = null;

LoginScreenView.prototype.__construct = function()
{
	APP.changeGameServer(null);
	
	COM.bindExclusiveClick(this.login, $.proxy(this.doLogin, this));
	COM(this.username).inputValue.maxLength = 15;
	COM(this.password).inputValue.maxLength = 20;
	
	if (APP.autoLogin)
	{
		COM(this.username).value = APP.autoLogin.login;
		COM(this.password).value = APP.autoLogin.password;
		COM(this.autoLogin).checked = true;
	}
	else
	{
		COM(this.username).value = APP.lastLoginName || '';
	}
	
	document.onkeyup = $.proxy(function(e)
	{
		if(e.which == 13) this.doLogin();
		return false;
		
	}, this);
	
	COM.bindExclusiveClick(this.forgotPassword, $.proxy(this.restorePassword, this));
}

LoginScreenView.prototype.__destruct = function()
{
	document.onkeyup = null;
}

LoginScreenView.prototype.doLogin = function()
{
	document.onkeyup = null;
	APP.showLoader();
	if (document.activeElement && document.activeElement['blur']) 
	{
		document.activeElement.blur();
	}
	
	COM(this.username).valid = null;
	COM(this.password).valid = null;
	
	var params = 
	{
		username: COM(this.username).value,
		password: COM(this.password).value,
		autologin: COM(this.autoLogin).checked,
		captcha: this.captcha,
	};
	
	PortalService.login(params, 
		$.proxy(this.handleLogin, this),
		$.proxy(function(){
			APP.hideLoader();
		}, this)
	);
	
	this.captcha = null;
}

LoginScreenView.prototype.handleLogin = function(response)
{
	try
	{
		if (response.result == "ok")
		{
			APP.lastLoginName = COM(this.username).value;
			APP.autoLogin = COM(this.autoLogin).checked ? { login: COM(this.username).value, password: COM(this.password).value } : null;
			PurchasesManager.onUserLogin(APP.lastLoginName, null);
			GAHelper.sendEvent("portal", "login", COM(this.username).value);
			APP.route('ServerSelect');
		}
		else if (response.errorText == "WRONG_CAPTCHA")
		{
			CaptchaDialog.create($.proxy(function(val){
				this.captcha = val;
				this.doLogin();
			}, this))
		}
		else
		{
			console.error(response.errorText);
			throw new Error(response.errorText);
		}
	}
	catch (e)
	{
		console.log("LOGIN ERROR = " + e.message);

		var message = "";
		switch(e.message)
		{
			case "wrong version":
				message = I18.f('UPGRADE_CLIENT_MESSAGE');
				break;
			case "account banned":
				message = I18.f('ACCOUNT_IS_BANNED');
				break;
			case "wrong account":
				message = I18.f('WRONG_ACCOUNT');
				COM(this.username).valid = false;
				break;
			case "internal error":
				message = I18.f('INTERNAL_ERROR');
				break;
			default:
				 message = I18.f('SERVER_FAIL');
		};
		
		Alert.create(message, I18.f('ERROR'));
		document.onkeyup = $.proxy(function(e)
		{
			if(e.which == 13) this.doLogin();
			return false;
			
		}, this);
	}
	APP.hideLoader();
}

LoginScreenView.prototype.restorePassword = function()
{
	RestorePasswordDialog.create(COM(this.username).value);
}
