function MergeServerDialog()
{
	callParentConstructor(MergeServerDialog.prototype, this);
}

extendClass(MergeServerDialog.prototype, Dialog.prototype);

MergeServerDialog.prototype.__construct = function()
{
	this.fullScreen();
	this.mergeServerWarning.innerHTML = I18.f('MERGE_SERVER_WARNING', DateUtils.formatWithDateAndSeconds(Tick.toMs(FPortalConfig.MERGE_SERVER_TIME)));

    $(this.selectButton).on(CLICK_EVENT, $.proxy(this.onSelect, this));
    $(this.selectLaterButton).on(CLICK_EVENT, $.proxy(this.onSelectLater, this));

}

MergeServerDialog.prototype.fromServerId = '';
MergeServerDialog.prototype.toServerId = '';
MergeServerDialog.prototype.servers = [];

MergeServerDialog.prototype.account = null; // FAccount

MergeServerDialog.popup = function(account, fromServerId, toServerId, servers)
{
    var dialog = COM.create('MergeServerDialog');
    dialog.servers = servers;
    dialog.account = account;
    dialog.fromServerId = fromServerId;
    dialog.toServerId = toServerId;

    dialog.popup();
    return dialog;
}

MergeServerDialog.prototype.onShow = function()
{
    var dp = [];
    for (var i = 0, len = this.servers.length; i < len; i++)
    {
    	dp.push({
    		value: this.servers[i], 
    		label: this.labelFunction(this.servers[i])
    	});
    }
    COM(this.serversCombo).dataProvider = dp;
    COM(this.serversCombo).selectedIndex = -1;
    
    setTimeout($.proxy(function(){
   		this.scroll = new iScroll(this.mergeServerWarning.parentNode, {});
    }, this), 500);
}

MergeServerDialog.prototype.onSelect = function()
{
	var toServerId = COM(this.serversCombo).selectedIndex < 0 ? null : COM(this.serversCombo).value;
	if (toServerId && this.toServerId != toServerId) 
	{
		this.toServerId = toServerId;
		PortalService.account.callMethod('selectServerToMoveAvatar', [this.fromServerId, this.toServerId], $.proxy(function(rsp){
			
			console.log("SERVER SELECTED", rsp);
			this.close();
			
		}, this));
	} 
	else 
	{
		this.close();
	}
}

MergeServerDialog.prototype.onSelectLater = function()
{
    this.close();
}

MergeServerDialog.prototype.labelFunction = function(data)
{
	for (var i = 0, len = this.account.servers.length; i < len; i++)
    {
		if (this.account.servers[i].id == data) 
		{
			return this.account.servers[i].displayName;
		}
	}
	return "";
}
