function ServerList()
{
	this.data = [];
	this.serverItems = [];
	this.scroll = null;
	this.onEnter = null;
}

ServerList.prototype.__construct = function()
{
	this.scroll = new iScroll(this.items.parentNode, {bounce: false, hScroll: false});
}

ServerList.prototype.getData = function(i)
{
	return this.data[i];
}

ServerList.prototype.getItem = function(i)
{
	return this.serverItems[i];
}

ServerList.prototype.setItems = function(arr)
{
	this.clearItems();
	
	this.data = arr;
	this.itemsCount = this.data.length;
	
	for (var i = 0; i < this.itemsCount; i++)
	{
		var item = COM.create('ServerListItem', {n:i});
		item.onEnter = this.onEnter;
		this.items.appendChild(item.DOM);
		this.serverItems.push(item);
		item.setItem(this.data[i]);
	}
	
	this.refreshScroll(300);
}

ServerList.prototype.clearItems = function()
{
	COM.clear(this.items);

	this.serverItems = [];
	this.data = [];
	
	this.itemsCount = 0;
}

ServerList.prototype.refreshScroll = function(timeout)
{
	if (timeout) return setTimeout($.proxy(this.refreshScroll, this), timeout*1);
	if (!this.scroll) return;
	this.scroll.refresh();
}
