function WelcomeScreenView()
{

}

WelcomeScreenView.prototype.__construct = function()
{
	UI.show(false, [APP.backButton]);
	Session.set('lastAuthSN', null);
	PortalService.logout($.proxy(this.init, this));
	UI.show(APP.language == 'ru', [this.DOM.querySelector('sn-box *[sn=vk]')]);

	this._socialPopupRef = null;
}

WelcomeScreenView.prototype.init = function()
{
	APP.changeGameServer(null);

	COM.bindExclusiveClick(this.login, function(e){
		APP.route('LoginScreenView');
		e.stopImmediatePropagation();
		return false;
	});

	COM.bindExclusiveClick(this.register, function(e){
		APP.showLoader();
		APP.route('RegisterSelectRace');
		e.stopImmediatePropagation();
		return false;
	});

	COM.bindExclusiveClick(this.social, $.proxy(this.loginSoc, this));
}

WelcomeScreenView.prototype.loginSoc = function(e)
{
	var type = e.currentTarget.getAttribute('sn');
	var target = PortalService.getUrl("/page/social_auth_target.jsp");
	var url = PortalService.getUrl("/socauth?mlSocType=" + type + "&mlTarget=" + target);
	var self = this;

	APP.showLoader();
	Session.set('lastAuthSN', type);

	var onLoadStart = $.proxy(this.handleLoginSoc, this);
	var onLoadStop = function(event)
	{
		APP.hideLoader();
        if(self._socialPopupRef) self._socialPopupRef.show();
	}

	var errorCounterHack = 0;
	var onLoadError = function(event)
    {
		if(self._socialPopupRef) {
			self._socialPopupRef.close();
			self._socialPopupRef = null;
		}

        if (errorCounterHack == 0)
        {
        	errorCounterHack++;
        	showPopup();
        }
        else
        {
	        APP.hideLoader();
	        Alert.create(I18.f('CLIENT_KNOWS_ERROR_TRY_AGAIN_LATER'), I18.f('ERROR'));
        }
    }

	var showPopup = function()
	{
		self._socialPopupRef = window.open(url, 'SocAuthWin', 'hidden=yes,location=no', true);
		self._socialPopupRef.addEventListener('loadstart', onLoadStart);
		self._socialPopupRef.addEventListener('loadstop', onLoadStop);
		self._socialPopupRef.addEventListener('loaderror', onLoadError);
	}
	showPopup();
}

WelcomeScreenView.prototype.handleLoginSoc = function(event)
{
	var target = PortalService.getUrl("/page/social_auth_target.jsp");
	if (event.url.substring(0, target.length) != target) return;

	this._socialPopupRef.close();
	this._socialPopupRef = null;

	var url = document.createElement('a');
	url.href = event.url;

	var paramStr = (url.search ? url.search.substring(1).split('&') : []), params = {};
	while (paramStr.length) {
		var p = (paramStr.shift() || '').split('=');
		params[p.shift()] = p.shift();
	}

	var token = params['PORTAL_AUTH_TOKEN'] || null;
	var error = (params['error'] || '').replace('+', ' ');
	if (token) {
		APP.PORTAL_AUTH_TOKEN = decodeURIComponent(token);

		/*
		 var sid = url.pathname.split(';');
		 sid = (sid.length > 1) ? sid.pop().split('=').pop() : APP.PORTAL_SESSION;
		 APP.PORTAL_SESSION = sid;
		 ajaxInit();
		 */

		APP.showLoader();

		PortalService.account.callMethod('loginFromServerMobile', [APP.PORTAL_AUTH_TOKEN],
			function (data) {
				APP.onPortalConfig(data);
				PortalService.account.callMethod('getAccount', [],
					function (data) {
						APP.hideLoader();
						Session.set('portalAccount', data);
						APP.lastLoginName = APP.PORTAL_AUTH_TOKEN.split('@').shift();
						APP.route('ServerSelect');
					},
					function (data) {
						APP.hideLoader();
						console.debug('ACCOUNT ERROR: ' + JSON.stringify(data));
						APP.route();
					}
				);
			},
			function () {
				Session.set('lastAuthSN', null);
				Alert.create(I18.f('SERVER_FAIL'), I18.f('ERROR'));
			}
		);
	}
	else if (error) {
		var message = "";
		switch (error) {
			case "wrong account":
				// auth OK, account does not exist
				Alert.create(I18.f('PROMPT_REGISTER'), null, function () {
					APP.route('RegisterSelectRace');
				});
				return;
			case "account banned":
				message = I18.f('ACCOUNT_IS_BANNED');
				break;
			case "internal error":
				message = I18.f('INTERNAL_ERROR');
				break;
			default:
				message = I18.f('SERVER_FAIL');
		}
		;

		if (message) {
			Session.set('lastAuthSN', null);
			Alert.create(message, I18.f('ERROR'));
		}
	}
	else {
		Session.set('lastAuthSN', null);
		console.warn("SN UNKNOWN RESPONSE: " + JSON.stringify(params));
	}
}
