function FinanceEpayOutputTab()
{
	this.info = null;
	this.account = null;
}

FinanceEpayOutputTab.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.ok, $.proxy(this.onOk, this));
	
	$(this.amountInput).on("change", $.proxy(this.validate, this));
	
	COM.bindExclusiveClick(this.frodInfo, $.proxy(this.onFrodInfo, this));
	this.frodInfo.src = STATIC_INTERFACE_URL + "login/frod_info.png";
}

FinanceEpayOutputTab.prototype.fitLayout = function(container)
{
}

FinanceEpayOutputTab.prototype.refresh = function()
{
    PortalService.account.callMethod("getFrod", [], $.proxy(function(newInfo)
    {
        this.info = newInfo;
        this.validate();
    }, this));
}

FinanceEpayOutputTab.prototype.update = function(acc)
{
    this.account = acc;
    this.validate();
}

FinanceEpayOutputTab.prototype.validate = function()
{
    if (!this.account || !this.info)
    {
        return;
    }
    
    this.onAccount.innerHTML = FPortalConfig.formatPearl(this.info.balance);
    this.outputMinRest.innerHTML = FPortalConfig.formatPearl(this.info.frod);
    this.outputAvaible.innerHTML = FPortalConfig.formatPearl(Math.max(0, this.info.balance*1 - this.info.frod*1));
    this.outputMinAmount.innerHTML = FPortalConfig.formatPearl(FPortalConfig.OUT_TRANSACTION_MIN);
    this.outputCommision.innerHTML = FOutputMoneyInfo.formatCommission(FPortalConfig.OUT_TRANSACTION_PERCENT, FPortalConfig.OUT_TRANSACTION_CHARGE);

    if (!FPortalConfig.PAYMENTS_ALLOWED && this.account.role.name == Role.USER.name)
    {
        COM(this.ok).reason = I18.f("PAYMENTS_NOT_ALLOWED");
    }
    else
    {
        var amountMld = FPortalConfig.toMld(NumberUtils.toNumberOrZero(COM(this.amountInput).value));
        if (NumberUtils.compareTo(amountMld, this.info.balance*1 - this.info.frod*1) > 0)
        {
            COM(this.ok).reason = I18.f("NOT_ENOUGH_MDOLLARS", I18.f("PORTAL_CURRENCY"));
        }
        else if (amountMld < FPortalConfig.OUT_TRANSACTION_MIN)
        {
            COM(this.ok).reason = I18.f("AMOUNT_TOO_SMALL");
        }
        else if (this.info.pendingTransactionsCount >= FPortalConfig.MAX_TRANSACTION_PENDINGS_PER_USER)
        {
            COM(this.ok).reason = I18.f("TOO_MANY_PENDING_OUTPUTS");
        }
        else
        {
            COM(this.ok).reason = "";
        }
    }
    
    this.outputTotal.innerHTML = I18.f("USD", I18.formatNumber(FPortalConfig.calcOutputAmount(NumberUtils.toNumberOrZero(COM(this.amountInput).value))));
}

FinanceEpayOutputTab.prototype.onOk = function()
{
    var amount = FPortalConfig.toMld(COM(this.amountInput).value);
    PortalService.account.callMethod("outputToEpay", [{"data": amount}],
            $.proxy(function (newInfo)
            {
                this.info = newInfo;
                this.validate();
                Alert.create(I18.f("EPAY_OUT_PENDING", Tick.toTimeLeftFull(FPortalConfig.OUT_TRANSACTION_DELAY, true)));
            }, this));
}

FinanceEpayOutputTab.prototype.onFrodInfo = function()
{
    var d = COM.create("FrodInfoDialog");
    d.popup(this);
}