function FinanceManualOutputTab()
{
	this.info = null;
    this.account = null;
}

FinanceManualOutputTab.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.ok, $.proxy(this.onOkClick, this));
	
	COM.bindExclusiveClick(this.frodInfo, $.proxy(this.onFrodInfo, this));
	this.frodInfo.src = STATIC_INTERFACE_URL + "login/frod_info.png";
	
	$(this.amount).on("change", $.proxy(this.validate, this));
	$(this.purse).on("change", $.proxy(this.validate, this));
	
	this.scroll = new iScroll(this.scrollWrapper);
}

FinanceManualOutputTab.prototype.fitLayout = function(c)
{
	this.scrollWrapper.style.width = c.width+"px";
	this.scrollWrapper.style.height = c.height+"px";
}

FinanceManualOutputTab.prototype.refresh = function()
{
    PortalService.account.callMethod("getFrod", [], $.proxy(function (newInfo)
    {
        this.info = newInfo;
        this.validate();
        
        setTimeout($.proxy(this.scroll.refresh, this.scroll), 300);
        
    }, this));
}

FinanceManualOutputTab.prototype.update = function(acc)
{
    this.account = acc;
    this.validate();
}

FinanceManualOutputTab.prototype.onOkClick = function()
{
    PortalService.account.callMethod("outputToManual", [COM(this.purse).value, {"data": FPortalConfig.toMld(COM(this.amount).value)}], $.proxy(function (newInfo)
    {
        this.info = newInfo;
        this.validate();
        Alert.create(I18.f("OUT_DONE", Tick.toTimeLeftFull(FPortalConfig.OUT_TRANSACTION_DELAY, true)));
    }, this));
}

FinanceManualOutputTab.prototype.validate = function()
{
    if (!this.account || !this.info)
    {
        return;
    }
    
    this.onAccount.innerHTML = FPortalConfig.formatPearl(this.info.balance);
    this.outputMinRest.innerHTML = FPortalConfig.formatPearl(this.info.frod);
    this.outputAvaible.innerHTML = FPortalConfig.formatPearl(Math.max(0, this.info.balance*1 - this.info.frod*1));
    this.minAmount.innerHTML = FPortalConfig.formatPearl(FPortalConfig.OUT_TRANSACTION_MIN);
    this.outputComission.innerHTML = FOutputMoneyInfo.formatCommission(FPortalConfig.OUT_TRANSACTION_PERCENT, FPortalConfig.OUT_TRANSACTION_CHARGE);
    this.outputPurse.innerHTML = FinanceManualOutputTab.i18Account('OUTPUT_PURSE', FPortalConfig.MANUAL_OUTCOME_ACCOUNT);
    this.outcomeWarning.innerHTML = I18.htmlFlow(FinanceManualOutputTab.i18Account('OUTCOME_WARNING', FPortalConfig.MANUAL_OUTCOME_ACCOUNT));

    var amountMld = FPortalConfig.toMld(NumberUtils.toNumberOrZero(COM(this.amount).value));
    if (!FPortalConfig.PAYMENTS_ALLOWED && this.account.role.name == Role.USER.name)
    {
        COM(this.ok).reason = I18.f("PAYMENTS_NOT_ALLOWED");
    }
    else if (NumberUtils.compareTo(amountMld, this.info.balance*1 - this.info.frod*1) > 0)
    {
        COM(this.ok).reason = I18.f("NOT_ENOUGH_MDOLLARS", I18.f("PORTAL_CURRENCY"));
    }
    else if (amountMld < FPortalConfig.OUT_TRANSACTION_MIN)
    {
        COM(this.ok).reason = I18.f("AMOUNT_TOO_SMALL");
    }
    else if (this.info.pendingTransactionsCount >= FPortalConfig.MAX_TRANSACTION_PENDINGS_PER_USER)
    {
        COM(this.ok).reason = I18.f("TOO_MANY_PENDING_OUTPUTS");
    }
    else if (!Strings.isValidEmail(COM(this.purse).value))
    {
        COM(this.ok).reason = I18.f("NOT_CORRECT_PAYPAL_EMAIL");
    }
    else
    {
        COM(this.ok).reason = "";
    }
    
    this.outputTotal.innerHTML = I18.f("USD", I18.formatNumber(FPortalConfig.calcOutputAmount(NumberUtils.toNumberOrZero(COM(this.amount).value))));
}

FinanceManualOutputTab.prototype.onFrodInfo = function()
{
    var d = COM.create("FrodInfoDialog");
    d.popup(this);
}

FinanceManualOutputTab.i18Account = function(key, account)
{
    return I18.getString(key + "_" + account.replace('@', '').toUpperCase())
}