function FinancePartnerTab()
{
	this.account = null;
	this.info = null;
}

FinancePartnerTab.onMoreInfo = function()
{
    var d = COM.create("PartnerDetailedInfo");
    d.popup();
}

FinancePartnerTab.onToExcel = function()
{
    var w = window.open(PortalService.portalUrl + "/partners-report.csv", "_blank");
    w.show();
}

FinancePartnerTab.prototype.__construct = function()
{
	COM(this.moreInfo).caption = I18.f("DETAILS");
	COM(this.export).caption = I18.f("EXPORT");
	
	COM.bindExclusiveClick(this.moreInfo, FinancePartnerTab.onMoreInfo);
	COM.bindExclusiveClick(this.export, FinancePartnerTab.onToExcel);
	
	COM.bindExclusiveClick(this.copyLinkButton, $.proxy(this.copyLink, this));
	COM.bindExclusiveClick(this.bannerLink, $.proxy(this.showBanners, this));
	
	this.scroll = new iScroll(this.scrollWrapper);
}

FinancePartnerTab.prototype.fitLayout = function(container)
{
	this.scrollWrapper.style.width = container.width + "px";
	this.scrollWrapper.style.height = (container.height-16) + "px";
}

FinancePartnerTab.prototype.refresh = function()
{
    PortalService.account.callMethod("getPartnerInfo", [], $.proxy(function(newInfo)
    {
        this.info = newInfo;
        
        //hack
        /*
        if(FPortalConfig.MAT_REF_USER_LINK)
        {
        	this.info.link = StringUtil.substitute(FPortalConfig.MAT_REF_USER_LINK, [this.account.id]);
        	this.link.style.display = "none";
        }
        */
        
        this.update();
    }, this));
    
    setTimeout($.proxy(this.scroll.refresh, this.scroll), 500);
}

FinancePartnerTab.prototype.update = function()
{
	this.infoText.innerHTML = I18.f("FINANCE_PARTNER_INFO", this.info.percent * 100);
	this.link.innerHTML = this.info.link;
	
	this.frodInfo.innerHTML = I18.f("FINANCE_PARTNER_INFO_SHORT", this.info.refCount, FPortalConfig.formatPearl(this.info.revenue));
}

FinancePartnerTab.prototype.showBanners = function()
{
	var url = Strings.format(FPortalConfig.AFFILIATE_BANNERS_LINK, this.info.bonusId);
	
	var w = window.open(url, "_blank");
	w.show();
}

FinancePartnerTab.prototype.copyLink = function()
{
    if(window.clipboard)
	{
		clipboard.copy(this.info.link);
	}
}