function FinancePendingItem()
{
	this.data = null;
	this.parent = null;
}

FinancePendingItem.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.readyLabel, $.proxy(function()
	{
		if(this.parent) this.parent.onFinishClick(this.data);
	}, this));
	
	COM.bindExclusiveClick(this.inProgressLabel, $.proxy(function()
	{
		if(this.parent) this.parent.openPaymentDataTab(this.data.account_to_purse);
	}, this));
	
	this.cancelButton.src = STATIC_INTERFACE_URL + "shared/icons/close.png";
	COM.bindExclusiveClick(this.cancelButton, $.proxy(function()
	{
		if(this.parent) this.parent.onCancelClick(this.data);
	}, this));
}

FinancePendingItem.prototype.refresh = function()
{
	if(!this.data || !this.parent) return;
	
	this.source.innerHTML = this.parent.sourceLabelFunction(this.data);
	this.destination.innerHTML = this.parent.destinationLabelFunction(this.data);
	this.operation.innerHTML = this.parent.operationLabelFunction(this.data);
	this.total.innerHTML = this.data.amount_real;
	
	if(this.data.status.name == OutcomeStatus.INITIATED.name)
	{
		this.initiatedCell.style.display = "";
		
		var d = FinanceDialog.convertFinanceDate(this.data.transaction_timestamp);
		
		this.initiatedCell.innerHTML = DateUtils.formatWithDate(d.getTime() + FPortalConfig.OUT_TRANSACTION_DELAY * 1000);
	}
	else
	{
		this.initiatedCell.style.display = "none";
	}
	
	if(FPortalConfig.EPAY_OUTCOME_ENABLED)
	{
		this.outcomeCell.style.display = "";
		
		if(this.data.status.name == OutcomeStatus.READY.name)
		{
			this.readyLabel.style.display = "";
			this.readyLabel.innerHTML = I18.f("FINISH_WITHDRAW");
		}
		else
		{
			this.readyLabel.style.display = "none";
		}
		
		if(this.data.status.name == OutcomeStatus.IN_PROGRESS.name)
		{
			this.inProgressLabel.style.display = "";
			this.inProgressLabel.innerHTML = I18.f("VIEW_WITHDRAW");
		}
		else
		{
			this.inProgressLabel.style.display = "none";
		}
	}
	else
	{
		this.outcomeCell.style.display = "none";
	}
	
	if(this.data.status.name == OutcomeStatus.INITIATED.name)
	{
		this.cancelCell.style.display = "";
	}
	else
	{
		this.cancelCell.style.display = "none";
	}
}