function FinancePendingTab()
{
	callParentConstructor(FinancePendingTab.prototype, this);
	
	this.pending = [];
}

extendClass(FinancePendingTab.prototype, FinanceTabParent.prototype);

FinancePendingTab.prototype.__construct = function()
{
	COM(this.grid).setHeader([I18.f("SOURCE"), I18.f("DESTINATION"), I18.f("OPERATION"), I18.f("TOTAL_PRICE_USD"), I18.f("FINISH")]);
	COM(this.grid).rendererClass = "FinancePendingItem";
}

FinancePendingTab.prototype.fitLayout = function(container)
{
	this.grid.style.width = (container.width-4)+"px";
	this.grid.style.height = container.height+"px";
}

FinancePendingTab.prototype.refresh = function()
{
    PortalService.account.callMethod("getPendingOutcomes", [], $.proxy(this.update, this));
}

FinancePendingTab.prototype.update = function(pending)
{
    this.pending = pending;
    COM(this.grid).dataProvider = pending;
    
    var items = COM(this.grid).items;
    var item;
    for(var i=0; i<items.length; i++)
    {
    	item = COM(items[i]);
    	item.parent = this;
    	item.refresh();
    }
    
    COM(this.grid).refreshHeader();
}

FinancePendingTab.prototype.onCancelClick = function(t)
{
    if (t)
    {
        Alert.create(I18.f("CANCEL_TRANSACTION"), "", $.proxy(function()
        {
            PortalService.account.callMethod("cancelPendingTransaction", [t.transaction_id], $.proxy(function()
            {
                this.refresh();
            }, this));
        }, this));
    }
}

FinancePendingTab.prototype.onFinishClick = function(outcome)
{
    Alert.create(I18.f("FINISH_WITHDRAW_CONFIRMATION"), "", $.proxy(function()
    {
        PortalService.account.callMethod("finishOutputToEpay", [outcome.transaction_id], $.proxy(function(hash)
        {
            this.openPaymentDataTab(hash);
            this.refresh();
        }, this));
    }, this));
}

FinancePendingTab.prototype.openPaymentDataTab = function(hash)
{
    var url = FPortalConfig.EPAY_OUTPUT_IFRAME_URL.replace("{hash}", hash);
    var w = window.open(url, "_blank");
    w.show();
}

FinancePendingTab.prototype.getSelected = function()
{
    return COM(this.grid).selectedIndex >= 0 ? this.pending[COM(this.grid).selectedIndex] : null;
}

FinancePendingTab.prototype.sourceLabelFunction = function(item, column)
{
    return I18.f("PERSONAL_CABINET");
}

FinancePendingTab.prototype.destinationLabelFunction = function(item, column)
{
    return this.getContractorName(item.account_to);
}

FinancePendingTab.prototype.operationLabelFunction = function(item, column)
{
    return TransactionOperation.TO_PAYMENT.getDisplayName();
}

FinancePendingTab.prototype.finishLabelFunction = function(item, column)
{
    return DateUtils.formatWithDate(item.transaction_timestamp.getTime() + FPortalConfig.OUT_TRANSACTION_DELAY);
}