function FinanceTabParent()
{
	this.account = null;
    this.detailed = false;
}

FinanceTabParent.getOperationName = function(item)
{
    var t = item;
    if (t.operation.name == TransactionOperation.SUBSCRIPTION.name)
    {
        return t.operation.getDisplayName(DateUtils.formatWithDate(t.subsctibeTill.getTime()));
    }
    return t.operation.getDisplayName();
}

FinanceTabParent.getAmount = function(item)
{
    var t = item;
    var result;
    if (!t.subsctibeTill || !NumberUtils.equals(Number(t.amount), 0))
    {
        result = FPortalConfig.toPearlStr(t.amount);
    }
    else if (t.isFromQuest)
    {
        result = I18.f("QUEST");
    }
    return result;
}

FinanceTabParent.getAmountReal = function(item)
{
    return I18.formatNumber(item.amountReal*1);
}

FinanceTabParent.prototype.getContractorName = function(name)
{
    var result;
    if (FinanceTabParent.isServerAccount(name))
    {
        var fgs = this.account.findServer(name);
        result = fgs ? fgs.displayName : name;
    }
    else if (FinanceTabParent.isPaymentAccount(name))
    {
        if (name == "@pending_outcome" || name == "@webmoney_invoice")
        {
            result = "webmoney";
        }
        else if (name == "@paypal_outcome" || name == "@paypal_outcome_pend")
        {
            result = "PayPal";
        }
        else if (name == "@mbook_outcome" || name == "@mbook_outcome_pend")
        {
            result = "MoneyBookers";
        }
        else if (name == "@epay_outcome_pend" || name == "@epay_outcome")
        {
            result = "epay";
        }
        else if (name == "@ifree_pending")
        {
            result = "SMS";
        }
        else if (name == "@partner_bonuses")
        {
            result = I18.f("FINANCE_PARTNER_LABEL");
        }
        else if (name == "@g2s")
        {
            result = "Gate2Shop";
        }
        else if (name == "@social_network")
        {
            result = "Social Network";
        }
        else
        {
            result = name.substr(1);
        }
    }
    else if (this.account && name == this.account.username)
    {
        result = I18.f("PERSONAL_CABINET");
    }
    else
    {
        result = name;
    }
    return result;
}

FinanceTabParent.isPaymentAccount = function(account)
{
    return account.charAt(0) == '@';
}

FinanceTabParent.isServerAccount = function(account)
{
    return account.charAt(0) == '$';
}

FinanceTabParent.prototype.dateLabelFunction = function(item, column)
{
    if(this.detailed)
    {
        return DateUtils.formatWithDateAndSeconds(item.date.getTime());
    }
    else
    {
        return DateUtils.formatWithDate(item.date.getTime());
    }
}

FinanceTabParent.getComment = function(item, column)
{
    if (item.initiator && item.initiator != item.destination)
    {
        return I18.f("GIFT_FROM", item.initiator);
    }
    if (item.operation.name == TransactionOperation.REFERAL_CANCEL.name)
    {
        return I18.getString("REFERAL", [item.comment]);
    }
    else
    {
        return item.comment;
    }
}