function FinanceWebmoneyOutputTab()
{
	this.info = null;
    this.account = null;
}

FinanceWebmoneyOutputTab.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.ok, $.proxy(this.onOkClick, this));
	
	COM.bindExclusiveClick(this.frodInfo, $.proxy(this.onFrodInfo, this));
	this.frodInfo.src = STATIC_INTERFACE_URL + "login/frod_info.png";
	
	$(this.amount).on("change", $.proxy(this.validate, this));
	$(this.purse).on("change", $.proxy(this.validate, this));
}

FinanceWebmoneyOutputTab.prototype.refresh = function()
{
    PortalService.account.callMethod("getFrod", [], $.proxy(function(newInfo)
    {
        this.info = newInfo;
        this.validate();
        
    }, this));
}

FinanceWebmoneyOutputTab.prototype.update = function(acc)
{
    this.account = acc;
    this.validate();
}

FinanceWebmoneyOutputTab.prototype.onOkClick = function()
{
    if(!this.validatePurse()) return;
    
    PortalService.account.callMethod("outputToWebmoney", [COM(this.purse).value, {"data": FPortalConfig.toMld(COM(this.amount).value*1)}], $.proxy(function (newInfo)
    {
        this.info = newInfo;
        this.validate();
        Alert.create(I18.f("OUT_DONE", Tick.toTimeLeftFull(FPortalConfig.OUT_TRANSACTION_DELAY, true)));
    }, this));
}

FinanceWebmoneyOutputTab.prototype.validatePurse = function()
{
	return (COM(this.purse).value.length == 13 && COM(this.purse).value.lastIndexOf("Z") == 0);
}

FinanceWebmoneyOutputTab.prototype.validate = function()
{
    if (!this.account || !this.info)
    {
        return;
    }
    
    this.onAccount.innerHTML = FPortalConfig.formatPearl(this.info.balance);
    this.outputMinRest.innerHTML = FPortalConfig.formatPearl(this.info.frod);
    this.outputAvaible.innerHTML = FPortalConfig.formatPearl(Math.max(0, this.info.balance*1 - this.info.frod*1));
    this.outputMinAmount.innerHTML = FPortalConfig.formatPearl(FPortalConfig.OUT_TRANSACTION_MIN);
    this.outputCommision.innerHTML = FOutputMoneyInfo.formatCommission(FPortalConfig.OUT_TRANSACTION_PERCENT, FPortalConfig.OUT_TRANSACTION_CHARGE);

    var amountMld = FPortalConfig.toMld(NumberUtils.toNumberOrZero(COM(this.amount).value));
    if (!FPortalConfig.PAYMENTS_ALLOWED && this.account.role.name == Role.USER.name)
    {
        COM(this.ok).reason = I18.f("PAYMENTS_NOT_ALLOWED");
    }
    else if (NumberUtils.compareTo(amountMld, this.info.balance*1 - this.info.frod*1) > 0)
    {
        COM(this.ok).reason = I18.f("NOT_ENOUGH_MDOLLARS", I18.f("PORTAL_CURRENCY"));
    }
    else if (amountMld < FPortalConfig.OUT_TRANSACTION_MIN)
    {
        COM(this.ok).reason = I18.f("AMOUNT_TOO_SMALL");
    }
    else if (this.info.pendingTransactionsCount >= FPortalConfig.MAX_TRANSACTION_PENDINGS_PER_USER)
    {
        COM(this.ok).reason = I18.f("TOO_MANY_PENDING_OUTPUTS");
    }
    else if (!this.validatePurse())
    {
        COM(this.ok).reason = I18.f("NOT_CORRECT_WMZ_ID");
    }
    else
    {
        COM(this.ok).reason = "";
    }
    
    this.outputTotal.innerHTML = I18.f("USD", I18.formatNumber(FPortalConfig.calcOutputAmount(NumberUtils.toNumberOrZero(COM(this.amount).value))));
}

FinanceWebmoneyOutputTab.prototype.onFrodInfo = function()
{
    var d = COM.create("FrodInfoDialog");
    d.popup(this);
}