function FrodInfoDialog()
{
	callParentConstructor(FrodInfoDialog.prototype, this);
	
	this.frods = [];
}

extendClass(FrodInfoDialog.prototype, Dialog.prototype);

FrodInfoDialog.prototype.__construct = function()
{
	COM(this.grid).setHeader([I18.f("FROD_DATE"), I18.f("TOTAL_PRICE")]);
	
	this.setCaption(I18.f("OUTPUT_MIN_REST"));
}

FrodInfoDialog.prototype.onShow = function()
{
	this.refresh();
}

FrodInfoDialog.prototype.refresh = function()
{
    PortalService.account.callMethod("getFrods", [], $.proxy(this.update, this));
}

FrodInfoDialog.prototype.update = function(frods)
{
    this.frods = frods;
    
    var data = [];
    for(var i=0; i<frods.length; i++)
    {
    	data.push([this.dateLabelFunction(frods[i]), this.amountLabelFunction(frods[i])]);
    }
    
    COM(this.grid).dataProvider = data;
}

FrodInfoDialog.prototype.dateLabelFunction = function(item, column)
{
    var d = FinanceDialog.convertFinanceDate(item.finishDate);
    return DateUtils.formatWithDate(d.getTime());
}

FrodInfoDialog.prototype.amountLabelFunction = function(item, column)
{
    return FPortalConfig.formatPearl(item.amount);
}