function PartnerDetailedInfo()
{
	callParentConstructor(PartnerDetailedInfo.prototype, this);
}

extendClass(PartnerDetailedInfo.prototype, Dialog.prototype);

PartnerDetailedInfo.prototype.__construct = function()
{
	superMethod(PartnerDetailedInfo.prototype, "__construct", this)();
	
	this.setCaption(I18.f("PARTNER_DETAILS_TEXT"));
	
	COM(this.grid).setHeader([I18.f("PLAYER"), I18.f("PARTNER_DETAILS_BONUS")]);
}

PartnerDetailedInfo.prototype.fitLayout = function(container)
{
	superMethod(PartnerDetailedInfo.prototype, "fitLayout", this)(container);
	
	this.grid.style.width = (this.content.offsetWidth-4) + "px";
	this.grid.style.height = this.content.offsetHeight + "px";
}

PartnerDetailedInfo.prototype.popup = function(parent)
{
	superMethod(PartnerDetailedInfo.prototype, "popup", this)(parent);
	
	this.refresh();
}

PartnerDetailedInfo.prototype.refresh = function(index)
{
    PortalService.account.callMethod("getPartnerDetailedInfo", [0], $.proxy(this.update, this));
}

PartnerDetailedInfo.prototype.update = function(detailed)
{
    console.log(detailed);
    
    var grid = COM(this.grid);
    
    grid.clearChildren();
    
    var row, data;
    for(var i=0; i<detailed.parnerInfo.length; i++)
    {
    	data = detailed.parnerInfo[i];
    	
    	row = COM.create("ScrollableListItem");
    	
    	row.data = [data.username, PartnerDetailedInfo.amountLabelFunction(data)];
    	
    	grid.addItem(row);
    }
}

PartnerDetailedInfo.prototype.onChangePage = function(index)
{
    this.refresh(index);
}

PartnerDetailedInfo.amountLabelFunction = function(item, column)
{
    return FPortalConfig.formatPearl(item.bonus);
}