function SelectLanguageDialog()
{
	callParentConstructor(SelectLanguageDialog.prototype, this);
	
	this.zone = null;
	this._zones = [];
	this.__defineGetter__('zones', this.getZones);
	this.__defineSetter__('zones', this.setZones);
}

extendClass(SelectLanguageDialog.prototype, Dialog.prototype);

SelectLanguageDialog.prototype.zone = '';
SelectLanguageDialog.prototype._zones = [];

SelectLanguageDialog.prototype.onSelect = function(c) {}

SelectLanguageDialog.create = function(zone, zones, onSelect)
{
	var d = COM.create('SelectLanguageDialog');
	
	d.onSelect = onSelect;
	d.zone = zone;
	d.zones = zones;

	d.popup();
	
	return d;
}

SelectLanguageDialog.prototype.__construct = function()
{
	COM.bindExclusiveClick(this.ok, $.proxy(this.onOKClick, this));
	this.onZoneClick = $.proxy(this.onZoneClick, this);
}

SelectLanguageDialog.prototype.getZones = function()
{
	return this._zones;
}

SelectLanguageDialog.prototype.setZones = function(val)
{
	this._zones = val;
	var len = this._zones.length;
	while (this.content.children.length > len)
	{
		COM(this.content.children[0]).destroy();
	}
	while (this.content.children.length < len)
	{
		
		var btn = CountryButton.createForDialog(this.onZoneClick);
		this.content.appendChild(btn.DOM);
	}
	
	for (var i = 0; i < len; i++)
	{
		COM(this.content.children[i]).zone = this._zones[i];
		COM(this.content.children[i]).selected = (this._zones[i].equals(this.zone));
	}
}

SelectLanguageDialog.prototype.onZoneClick = function(e)
{
	$('> *', this.content).removeClass('selected');
	COM(e.currentTarget).selected = true;
	this.zone = COM(e.currentTarget).zone;
}

SelectLanguageDialog.prototype.onOKClick = function(e)
{
	if (typeof this.onSelect == 'function') 
	{
		this.onSelect(this.zone);
	}
	this.close();
}

