function RegisterCreateAccount()
{
}

RegisterCreateAccount.prototype.USERNAME_REGEXP = /^[a-zA-Z0-9]{3,15}$/;
RegisterCreateAccount.prototype.race = null; //Race
RegisterCreateAccount.prototype.onRegisterSuccess = null; //Function

RegisterCreateAccount.prototype.duplicateUsernames = {};
RegisterCreateAccount.prototype.duplicateEmail = '';

RegisterCreateAccount.prototype.emailChanged = false;
RegisterCreateAccount.prototype.usernameChanged = false;
RegisterCreateAccount.prototype.passwordChanged = false;

RegisterCreateAccount.prototype.reg = null; //FRegistration

RegisterCreateAccount.prototype.__construct = function()
{
	COM(this.usernameInput).inputValue.maxLength = 15;
	COM(this.passwordInput).inputValue.maxLength = 20;
	
    this.race = APP.registration.race;
    this.server = APP.registration.server;
    if (!this.server)
    {
    	console.error('No server selected to create account...');
    	APP.route('WelcomeScreenView');
    }
    this.reg = FRegistration.createDefault("", this.race);
    this.reg.serverId = APP.registration.server.id;
    
    //ExternalInterface.addCallback("onSocialRegistration", onSocialRegistration);

	$(this.usernameInput).on('keyup', $.proxy(this.onUsernameChange, this));
	$(this.emailInput).on('keyup', $.proxy(this.onEmailChange, this));
	$(this.passwordInput).on('keyup', $.proxy(this.onPasswordChange, this));

	COM.bindExclusiveClick(this.social, $.proxy(this.fillSocialInfo, this));
	COM.bindExclusiveClick(this.submitButton, $.proxy(this.onRegisterClicked, this));
	this.validateForm();
	
	if (Session.get('lastAuthSN'))
	{
		this.fillSocialInfo();
	}
	
	UI.show(APP.language == 'ru', [this.DOM.querySelector('sn-box *[sn=vk]')]);
} 

RegisterCreateAccount.prototype.fillSocialInfo = function(e) 
{
   	var type = e ? e.currentTarget.getAttribute('sn') : Session.get('lastAuthSN');
	Session.set('lastAuthSN', type);

    var race = APP.registration.race;
    var target = APP.registration.server.url + "social_reg_target.jsp";
    var url = PortalService.getUrl("/socauth?mlSocType=" + type + "&mlTarget=" + target + "&regRace=" + race.name);
    
    APP.showLoader();
    
    var popup;
    
	var onLoadStart = $.proxy(this.handleLoginSoc, this);
	var onLoadStop = function(event)
	{
        APP.hideLoader();
        if(popup) popup.show();
	}
	
	var errorCounterHack = 0;
	var onLoadError = function(event)
    {
        if(popup) popup.close();
        if (errorCounterHack == 0)
        {
        	errorCounterHack++;
        	showPopup();
        }
        else
        {
	        APP.hideLoader();
	        Alert.create(I18.f('CLIENT_KNOWS_ERROR_TRY_AGAIN_LATER'), I18.f('ERROR'));
        }
    }
	
	var showPopup = function()
	{
		if(window.open['clearCookies']) window.open.clearCookies();
    	popup = window.open(url, 'SocAuthWin', 'hidden=yes');
		popup.addEventListener('loadstart', onLoadStart);
		popup.addEventListener('loadstop', onLoadStop);
	    popup.addEventListener('loaderror', onLoadError);
		popup.addEventListener('exit', APP.hideLoader);
	}
	showPopup();
}

RegisterCreateAccount.prototype.handleLoginSoc = function(event)
{
	var target = APP.registration.server.url + "social_reg_target.jsp"
	if (event.url.substring(0, target.length) != target) return;
	event.target.close();
	var url = document.createElement('a');
	url.href = event.url;
	var paramStr = (url.search ? url.search.substring(1).split('&') : []), params = {};
	while (paramStr.length)
	{
		var p = (paramStr.shift() || '').split('=');
		params[p.shift()] = decodeURIComponent(p.shift());
	}
	
	console.log("SOCREG PORTAL_AUTH_TOKEN: " + JSON.stringify(params));
	
	this.onSocialRegistration(params['extId'], params['fname'], params['lname'], params['email'], params['sig'])
}


/* --------------------------------------------------------------------------------------------------------- */
/*
private static function onCreatingComplete():void {
    ExternalInterface.call("onRegistrationDialogShown");
}
*/

RegisterCreateAccount.WEAK_PASSWORDS = ["000000", "111111",
"11111111", "112233", "121212", "123123", "123456", "1234567", "12345678", "123456789", "131313", "232323",
"654321", "666666", "696969", "777777", "7777777", "8675309", "987654", "aaaaaa", "abc123", "abc123",
"abcdef", "abgrtyu", "access", "access14", "action", "albert", "alberto", "alexis", "alejandra",
"alejandro", "amanda", "amateur", "america", "andrea", "andrew", "angela", "angels", "animal", "anthony",
"apollo", "apples", "arsenal", "arthur", "asdfgh", "asdfgh", "ashley", "asshole", "august", "austin",
"badboy", "bailey", "banana", "barney", "baseball", "batman", "beatriz", "beaver", "beavis", "bigcock",
"bigdaddy", "bigdick", "bigdog", "bigtits", "birdie", "bitches", "biteme", "blazer", "blonde", "blondes",
"blowjob", "blowme", "bond007", "bonita", "bonnie", "booboo", "booger", "boomer", "boston", "brandon",
"brandy", "braves", "brazil", "bronco", "broncos", "bulldog", "buster", "butter", "butthead", "calvin",
"camaro", "cameron", "canada", "captain", "carlos", "carter", "casper", "charles", "charlie", "cheese",
"chelsea", "chester", "chicago", "chicken", "cocacola", "coffee", "college", "compaq", "computer", "cookie",
"cooper", "corvette", "cowboy", "cowboys", "crystal", "cumming", "cumshot", "dakota", "dallas", "daniel",
"danielle", "debbie", "dennis", "diablo", "diamond", "doctor", "doggie", "dolphin", "dolphins", "donald",
"dragon", "dreams", "driver", "eagle1", "eagles", "edward", "einstein", "erotic", "estrella", "extreme",
"falcon", "fender", "ferrari", "firebird", "fishing", "florida", "flower", "flyers", "football", "forever",
"freddy", "freedom", "fucked", "fucker", "fucking", "fuckme", "fuckyou", "gandalf", "gateway", "gators",
"gemini", "george", "giants", "ginger", "golden", "golfer", "gordon", "gregory", "guitar", "gunner",
"hammer", "hannah", "hardcore", "harley", "heather", "helpme", "hentai", "hockey", "hooters", "horney",
"hotdog", "hunter", "hunting", "iceman", "iloveyou", "internet", "iwantu", "jackie", "jackson", "jaguar",
"jasmine", "jasper", "jennifer", "jeremy", "jessica", "johnny", "johnson", "jordan", "joseph", "joshua",
"junior", "justin", "killer", "knight", "ladies", "lakers", "lauren", "leather", "legend", "letmein",
"letmein", "little", "london", "lovers", "maddog", "madison", "maggie", "magnum", "marine", "mariposa",
"marlboro", "martin", "marvin", "master", "matrix", "matthew", "maverick", "maxwell", "melissa", "member",
"mercedes", "merlin", "michael", "michelle", "mickey", "midnight", "miller", "mistress", "monica", "monkey",
"monkey", "monster", "morgan", "mother", "mountain", "muffin", "murphy", "mustang", "naked", "nascar",
"nathan", "naughty", "ncc1701", "newyork", "nicholas", "nicole", "nipple", "nipples", "oliver", "orange",
"packers", "panther", "panties", "parker", "password", "password", "password1", "password12", "password123",
"patrick", "peaches", "peanut", "pepper", "phantom", "phoenix", "player", "please", "pookie", "porsche",
"prince", "princess", "private", "purple", "pussies", "qazwsx", "qwerty", "qwertyui", "rabbit", "rachel",
"racing", "raiders", "rainbow", "ranger", "rangers", "rebecca", "redskins", "redsox", "redwings", "richard",
"robert", "roberto", "rocket", "rosebud", "runner", "rush2112", "russia", "samantha", "sammy", "samson",
"sandra", "saturn", "scooby", "scooter", "scorpio", "scorpion", "sebastian", "secret", "sexsex", "shadow",
"shannon", "shaved", "sierra", "silver", "skippy", "slayer", "smokey", "snoopy", "soccer", "sophie",
"spanky", "sparky", "spider", "squirt", "srinivas", "startrek", "starwars", "steelers", "steven", "sticky",
"stupid", "success", "suckit", "summer", "sunshine", "superman", "surfer", "swimming", "sydney", "tequiero",
"taylor", "tennis", "teresa", "tester", "testing", "theman", "thomas", "thunder", "thx1138", "tiffany",
"tigers", "tigger", "tomcat", "topgun", "toyota", "travis", "trouble", "trustno1", "tucker", "turtle",
"twitter", "united", "vagina", "victor", "victoria", "viking", "voodoo", "voyager", "walter", "warrior",
"welcome", "whatever", "william", "willie", "wilson", "winner", "winston", "winter", "wizard", "xavier",
"xxxxxx", "xxxxxxxx", "yamaha", "yankee", "yankees", "yellow", "zxcvbn", "zxcvbnm", "zzzzzz"];

RegisterCreateAccount.prototype.validateForm = function()
{
    var username = COM(this.usernameInput).value, usernameOk = this.isValidUsername(username) && !(username in this.duplicateUsernames);
    var email = COM(this.emailInput).value, emailOk = Strings.isValidEmail(email) && email != this.duplicateEmail;
    var password = COM(this.passwordInput).value, passwordReason = null;
    
    if (!password) passwordReason = I18.f('NEED_TO_FILL_PASSWORD');
    else if (password.length < 6) passwordReason = I18.f('PASSWORD_MIN_LENGTH', 6);
    else if (
    	(RegisterCreateAccount.WEAK_PASSWORDS.indexOf(password) >= 0)
    	|| (/(.)\1{5}/.test(password) || /((.)\2){3}/.test(password))
    	
    ) passwordReason = I18.f('PASSWORD_TOO_SIMPLE');

    COM(this.usernameInput).valid = (this.usernameChanged && username.length) ? !!usernameOk : undefined;
    COM(this.emailInput).valid = (this.emailChanged && email.length) ? !!emailOk : undefined;
    COM(this.passwordInput).valid = (this.passwordChanged && password.length) ? !passwordReason : undefined;

    var reason = [];
    if (!usernameOk) reason.push(I18.f('NEED_TO_FILL_USERNAME'));
    if (!emailOk) reason.push((!this.duplicateEmail || (email != this.duplicateEmail)) 
    	? I18.f('NEED_TO_FILL_EMAIL') 
    	: I18.f('REGISTRATION_ERROR_ALREADY_EXISTS_EMAIL')
    );
    if (passwordReason) reason.push(passwordReason);
    //if (reason.length > 0) reason.unshift('U:'+username + ' P:'+password + ' E:'+email);
	COM(this.submitButton).reason = reason;
}

RegisterCreateAccount.prototype.onSocialRegistration = function(uid, fname, lname, email, sig)
{
    this.reg.socialUid = uid;
    this.reg.socialUidSig = sig;
    this.reg.socialFName = fname;
    this.reg.socialLName = lname;
    COM(this.emailInput).value = email;

    this.register($.proxy(this.handleRegisterSocial, this));
}

RegisterCreateAccount.prototype.onRegisterClicked = function()
{
    this.reg.username = COM(this.usernameInput).value;
    this.reg.email = COM(this.emailInput).value;
    this.reg.password = COM(this.passwordInput).value;

    this.register($.proxy(this.handleRegister, this));
}

RegisterCreateAccount.prototype.register = function(okCallback)
{
    APP.showLoader();
    
    var platform = "ios";
    var type = "phone";
    
    if(window.device)
    {
    	platform = window.device.platform.toLowerCase();
    	type = window.device.isTablet ? "tablet" : "phone";
    }
	
	this.reg.referer = "mobile_" + platform + "_" + type;
	this.reg.landing = "mobile";
	this.reg.device = MATHelper.getDeviceId();
	
	MATHelper.trackAction(FPortalConfig.MAT_REGISTRATION_EVENT);
	
	PortalService.account.callMethod('register', [this.reg],
    	okCallback,
    	$.proxy(this.handleFail, this)
    );
}

RegisterCreateAccount.prototype.isValidUsername = function(username)
{
    return this.USERNAME_REGEXP.test(username);
}

RegisterCreateAccount.prototype.handleClientKnownException = function(e)
{
    var ge = e.gameException || e;
    if (ge.__className__ == 'SaveInProgressException') 
    {
        ServerSavingAlert.onException(ge.timeout, this.onRegisterSuccess);
    } 
    else if (ge.__className__ == 'CreateAvatarException') 
    {
        Alert.create(I18.f('CREATE_AVATAR_ERROR_SERVER_FULL_RACE')).onClose = Service.goToPortal;
    } 
    else if (ge) 
    {
        Alert.create(ge.getMessage());
    }
}

RegisterCreateAccount.prototype.handleRegister = function(result) // FRegistrationResult
{
    APP.PORTAL_AUTH_TOKEN = result.portalToken;
	Session.set('lastAuthSN', null);
    
    //console.log('REGISTERED ' + JSON.stringify(result));
    
	var params = 
	{
		username: COM(this.usernameInput).value,
		password: COM(this.passwordInput).value,
		autologin: true,
		captcha: null,
	};
	
	PortalService.login(params, $.proxy(this.onRegisterSuccess, this));
}

RegisterCreateAccount.prototype.handleRegisterSocial = function(result)
{
	APP.PORTAL_AUTH_TOKEN = result.portalToken;
	
	this.onRegisterSuccess({"result": "ok"});
}

RegisterCreateAccount.prototype.onRegisterSuccess = function(response)
{
	try
	{
		if (response.result == "ok")
		{
			APP.lastLoginName = COM(this.usernameInput).value;

			PortalService.account.callMethod('loginFromServerMobile', [APP.PORTAL_AUTH_TOKEN],
				$.proxy(function(data){
					
					PortalService.account.callMethod("enterGame", [this.server.id, APP.PORTAL_AUTH_TOKEN, ""], 
						
						$.proxy(function(response){
							
		    				Service.switchTo(this.server.url);
							Service.user.callMethod("login", [APP.PORTAL_AUTH_TOKEN], $.proxy(function()
							{
								APP.hideLoader();
								if (typeof response != "string") 
								{
									return; //this.requestError();
								}
								
								var url = response.split("?").shift();
								
								Session.set('gameServerIcon', APP.registration.server.gameServerIcon);
								Session.set('gameServerName', APP.registration.server.gameServerName);
								Session.set('gameServerOnline', APP.registration.server.gameServerOnline);
								
								Session.set('gameServerURL', url);
								
								GAHelper.sendEvent("portal", "registration", COM(this.usernameInput).value);
								GAHelper.sendEvent("portal", "enterGame", APP.registration.server.id);
								
								APP.navigate("game.html");
							}, this));
							
						}, this), 
						
						$.proxy(function(response){
						    APP.hideLoader();
							console.log('ERROR', response);
							return;
						}, this)
						
					);
				}, this),
				
				$.proxy(function(data){
					
					return this.requestError();
					
				}, this)
			);
			return;
		}
		else if (response.erroPhilrText == "WRONG_CAPTCHA")
		{
			Alert.create('CAPTCHA');
			console.warn('CAPTCHA', response);
			//$(this.captcha.DOM).show("", "", I18.f('CAPTCHA_PROMPT'));
		}
		else
		{
			//console.log(response);
			throw new Error(response.errorText);
		}
	}
	catch (e)
	{
		var message = "";
		switch(e.message)
		{
			case "account banned":
				message = I18.f('ACCOUNT_IS_BANNED');
				break;
			case "wrong account":
				message = I18.f('WRONG_ACCOUNT');
				COM(this.usernameInput).valid = false;
				break;
			case "internal error":
				message = I18.f('INTERNAL_ERROR');
				break;
			default:
				 message = I18.f('SERVER_FAIL');
		};
		
		Session.set('lastAuthSN', null);
		Alert.create(message, I18.f('ERROR'));
		APP.route('LoginScreenView');
	}
}

RegisterCreateAccount.prototype.handleFail = function(e)
{
    APP.hideLoader();
    if (e.__className__ == 'RegistrationException') 
    {
        this.validateForm();

        var showAlert = true;
        var re = e;
        if (re.isReferalInfolWrong()) 
        {
        } 
        else if (re.isUsernameWrong()) 
        {
            this.duplicateUsernames[COM(this.usernameInput).value] = null;
            COM(this.usernameInput).valid = false;
            
            /*
            if (viewStack.selectedChild == registrationBox && re.isUsernameAlreadyExists() && re.availableUsernames != null && re.availableUsernames.length > 0) 
            {
                var ga = GameAlert.doShowSelect(I18.REGISTRATION_ERROR_ALREADY_EXISTS_WITH_PROPOSE.f(), re.availableUsernames.source, 0,
                        function (item:String, index:int):void {
                            usernameInput.text = item;
                            usernameInput.selectRange(0, usernameInput.text.length);
                            validateForm();
                        }
                );
                ga.yesButton.label = I18.f('SELECT');
                ga.noButton.label = I18.f('CANCEL');
            }
            if (viewStack.selectedChild == registrationChooser) 
            {
                viewStack.selectedChild = registrationBox;
                showAlert = false;
            }
            */
        } 
        else if (re.isCaptchaWrong()) 
        {
            showAlert = false;
            CaptchaDialog.create($.proxy(function(captcha){
            	this.reg.captcha = captcha;
            	this.register();
            }, this));
        } 
        else if (re.isPasswordWrong()) 
        {
        } 
        else if (re.isEmailWrong()) 
        {
            this.duplicateEmail = COM(this.emailInput).value;
            COM(this.emailInput).valid = false;
            COM(this.submitButton).reason = re.getMessage();
        }
        else if (e.type == "SOCIAL_ALREADY_EXISTS") 
        {
        	return this.handleSocialAlreadyExists(e);
        }
        if (showAlert) 
        {
            Alert.create(re.getMessage());
        }
        return true;
    } 
    else if (e.__className__ == 'ClientKnowsException')
    {
        if (e.type == "SOCIAL_ALREADY_EXISTS") 
        {
        	return this.handleSocialAlreadyExists();
        }
        
        this.handleClientKnownException(e);
        this.validateForm();
        Session.set('lastAuthSN', null);
        return true;
    }
    return false;
}

RegisterCreateAccount.prototype.handleSocialAlreadyExists = function(e)
{
	var ge = e['gameException'] || e;
	
	var a = Alert.createWithActions(ge.getMessage(), I18.f('ERROR'), [
		{ 
			caption: I18.f('REGISTER'), skin: 'green', 
			onclick: function(){
	    		this.fillSocialInfo();
	    		a.close();
			}
		},
		{ 
			caption: I18.f('ENTER'), skin: 'yellow', 
			onclick: function(){
	    		a.close();
	    		Session.set('lastAuthSN', null);
	    		APP.route('WelcomeScreenView');
			}
		}
	], this);
	
	this.reg.clearSocial();
    return true;
}

RegisterCreateAccount.prototype.onEmailChange = function()
{
    this.emailChanged = true;
    this.validateForm();
}

RegisterCreateAccount.prototype.onUsernameChange = function()
{
    this.usernameChanged = true;
    this.validateForm();
}

RegisterCreateAccount.prototype.onPasswordChange = function()
{
    this.passwordChanged = true;
    this.validateForm();
}

function onSocialRegistration(uid, fname, lname, email, sig) {
    //document.getElementById("gain2f").onSocialRegistration(uid, fname, lname, email, sig);
    console.log('onSocialRegistration', uid, fname, lname, email, sig);
}

