var pingInterval;
function startUp()
{
	console.clear();
	console.groupCollapsed('LOADING...');
	console.profile('Preload');
	
	//CSS
	console.groupCollapsed('CSS');
	
	for(var i=0; i<CONFIG.css.length; i++)
	{
		if (!APP.isCordova) console.info(CONFIG.css[i]);
		getCSS(CONFIG.css[i]);
	}
	
	if(PHONE_MODE)
	{
		getCSS("phone");
	}

	console.log("ANDROID MODE = " + ANDROID_MODE);

	if(ANDROID_MODE)
	{
		console.log("GET ANDROID CSS");

		getCSS("android");
		
		if(PHONE_MODE)
		{
			getCSS("android_phone");
		}
	}
	
	console.groupEnd();
	
	//Listeners
	if(!("ontouchstart" in window)) window.addEventListener("resize", APP.fitLayout);
	
	APP.preload();
	//APP.fitLayout();
};

if(window.cordova)
{
    console.log("GAME CORDOVA STARTUP");
    document.addEventListener('deviceready', startUp, false);
}
else
{
    console.log("GAME BROWSER STARTUP");
    $(startUp);
}

var APP = new (function()
{
	this.LTR = true;
	this.isSocialNetwork = false;
	
	var cityMediator = null;
    var kingdomMediator = null;
    var currentMediator = null;
    var advisor = null;
    
    this.hexesSize = {width: 92, height: 54};
    this.hexesOffset = {left: -78, top: 48};
    
    this.imagesCache = {};
    
    this.ticksIsPaused = false;
    
    this.scienceView = null;
    
    this.pauseTicks = function()
    {
    	APP.ticksIsPaused = true;
    }
    
    this.resumeTicks = function()
    {
    	APP.ticksIsPaused = false;
    }
    
    
    this.lastWindowSize = {width: 0, height: 0};
    this.fitLayout = function(force)
    {
    	var container = {width: window.innerWidth, height: window.innerHeight};
    	
    	if(!force && container.width == APP.lastWindowSize.width && container.height == APP.lastWindowSize.height)
    	{
    		return;
    	}
    	
    	$("#preloader").css({"width": container.width, "height": container.height});
    	$("#preloader").css({"background-size": container.width+"px "+container.height+"px"});
    	
    	$("#preloadBox").css({"margin-top": (container.height/6 * 4)+"px"});
    	
    	$("#cityLoader").css({"width": container.width, "height": container.height});
    	
    	APP.lastWindowSize.width = container.width;
    	APP.lastWindowSize.height = container.height;
    	
    	var e = $.Event('fitlayout', {container: container});
    	
    	$(window).trigger(e);
    	
    	if (kingdomMediator) kingdomMediator.fitLayout(container);
    	if (cityMediator) cityMediator.fitLayout(container);
    	
    	//document.body.style.height = container.height + 'px';
    }
	
	this.preload = function()
	{
		APP.showPreloader();
		APP.fitLayout(true);
		
		if(window.PurchasesManager && !window.PurchasesManager.ready)
		{
			PurchasesManager.init();
		}
		
		console.groupCollapsed('SCRIPTS');
		var inc = include_once(CONFIG.scripts);
		
		console.time('Scripts loading');
		//console.log('LOADING ENVIRONMENT...');
		inc.progress(function(url, left, total)
		{
			APP.setPreloaderProgress(30 - left*30/total);
			var tmp = url.split('/');
			if (!APP.isCordova) console.info(url);
			if(left > 0) 
			{
				APP.setPreloaderTitle("Loading engine: " + tmp[tmp.length-1]);
			}

			APP.fitLayout(true);
		});
		
		inc.pipe(function(){
			
			var url = Session.get('portalURL');
			if (url)
			{
				PortalService.switchTo(url);
			}
			
			url = Session.get("gameServerURL");
			if(!url || (typeof url != 'string'))
			{
				Service.goToPortal();
				return;
			}
			
			Service.url = url.split("?")[0];
			Service.switchTo(Service.url);
			
			APP.setPreloaderProgress(50);
			APP.setPreloaderTitle('Loading server config');
			
			var q = [];
			q.push(APP.reloadConfig());
			
			return $.when.apply(null, q);
			
		}) // loading scripts
		.pipe(function(){
			
			console.log('ENVIRONMENT READY');
			console.groupEnd();
			console.timeEnd('Scripts loading');
			
			COM.init({basePath: 'app/classes'});
			
			console.time('Components loading');
			var d = COM.load(CONFIG.components);
			var total = CONFIG.components.length*1;
			
			console.groupCollapsed('COMPONENTS');
			d.progress(function(s)
			{
				APP.setPreloaderTitle('Loading components: ' + s);
				APP.setPreloaderProgress(60 + (total - CONFIG.components.length)/total * 30);
				if (!APP.isCordova) console.info(s);
			});
			
			return d;
			
			
		}) // loading components
		.pipe(function()
		{
			console.log('COMPONENTS PRELOADED');
			console.groupEnd();
			console.timeEnd('Components loading');
			
			delete CONFIG;
			
			$('head > script').remove();
			
			console.profileEnd();
			console.groupEnd();
			
			console.groupCollapsed('INIT...');
			console.profile('Init');
			console.time('Initialized');
			PurchasesManager.onUserLogin(APP.lastLoginName, FConfig.SERVER_ID);

			APP.init();
		});


	}
	
	this.clearImagesCache = function()
	{
		for(var i in APP.preloadImages)
		{
			delete APP.preloadImages[i];
		}
		
		APP.preloadImages = {};
	}
	
	this.addPreloadImages = function(data, baseURL)
	{
		for(var i in data)
		{
			if(typeof data[i] == "function") continue;
			
			if(typeof data[i] == "object") APP.addPreloadImages(data[i], baseURL);
			else
			{
				var img = new Image();
				img.src = baseURL + data[i];
				APP.imagesCache[data[i]] = img;
			}
		}
	}
	
	this.waitPreloadImages = function(callback)
	{
		var itemsLoaded = 0;
		var itemsTotal = 0;
		
		for(var key in APP.imagesCache)
		{
			if(APP.imagesCache[key].complete) itemsLoaded++;
			itemsTotal++;
		}

		if(itemsLoaded >= itemsTotal)
		{
			callback();
			return;
		}
		else
		{
			//APP.setPreloaderProgress(50 + (itemsLoaded/itemsTotal) * 45);
			setTimeout(function()
			{
				APP.waitPreloadImages(callback);
			}, 50);
		}
	}
	
	this.globalError = function(err)
	{
		var views = Array.prototype.slice.call(document.querySelectorAll('body > *'), 0);
		var errNode = document.querySelector('#globalErrorText');
		for (var i = 0; i < views.length; i++)
		{
			views[i].style.visibility = (err === null) ^ (views[i].getAttribute('id') == errNode.getAttribute('id')) ? '' : 'hidden';
		}
		
		if (UI.show(err !== null, [errNode]))
		{
			APP.hideLoader();
			$('#globalErrorText').html(err);
		}
	}
	
	this.getPreloadImage = function(key)
	{
		return APP.imagesCache[key];
	}
	
	this.reloadConfig = function(callback)
	{
		var d = $.Deferred();
		
		Service.getConfig(function(data)
		{
			$.extend(FConfig, data);
			FConfig.load();
			d.resolve();
			if(callback) callback();
		});
		
		return d;
	}
	
	this.hideCityPanels = function()
	{
		cityMediator.hideCityPanels();
	}
	
	this.showCityPanels = function()
	{
		cityMediator.showCityPanels();
	}
	
	this.init = function()
	{
		if(window.PushManager && !window.PushManager.ready)
		{
			PushManager.init();
		}
		
		if(window.PurchasesManager && !window.PurchasesManager.ready)
		{
			PurchasesManager.init();
		}
		
		this.scienceView = COM.create("ScienceView");
		this.scienceView.DOM.style.display = "none";
		MailBoxView.i();
		
		APP.setPreloaderTitle("Loading city");
		APP.setPreloaderProgress(95);
		
		//Global ping
		APP.ping(30000);
		//Update local time
		setInterval(Tick.updateLocalTime, 100);
		
		cityMediator = COM.create("CityMediator");
		$("#content").append(cityMediator.DOM);
		
		kingdomMediator = COM.create("KingdomMediator");
		kingdomMediator.DOM.style.display = "none";
		$("#content").append(kingdomMediator.DOM);
		
		//currentMediator = cityMediator;
		
		//GLOBAL EVENTS
		
		Events.onShowCity.add(APP, function (id)
		{
            //cityMediator.showEstate(id);
            APP.showCity(id);
        });
        
        Events.onShowEspionageResult.add(APP, function(er)
        {
            var fromCity = APP.currentScreenIsCity();
            APP.setAsScreen(cityMediator);
            cityMediator.showEspionageResult(er, fromCity);
        });
        
        Events.onShowExpeditionResult.add(APP, function(city)
        {
            var fromCity = APP.currentScreenIsCity();
            APP.setAsScreen(cityMediator);
            cityMediator.showExpeditionResult(city, fromCity);
        });
        
        Events.onShowKingdom.add(APP, function(id)
        {
            APP.setAsScreen(kingdomMediator);
            kingdomMediator.show(id);
        });
        
        Events.onShowingAnimationChange.add(APP, function(isShowingAniation)
        {
            /*
            if (cityMediator.cityView.initialized)
            {
                cityMediator.cityView.hexes.setShowingAnimation(isShowingAniation);
            }
            */
        });
        
        Events.onReloadConfig.add(APP, function(ignore)
        {
            console.log("LOAD CONFIG");
            APP.reloadConfig();
        });
        
        Events.onResourceChooserStepIndexChanged.add(APP, function(newIndex)
        {
            if(newIndex)
			{
				Service.user.callMethod("updateResourceChooserStepIndex", [newIndex]);
			}
        });
        
        Events.onArmyChooserStepIndexChanged.add(APP, function(newIndex)
        {
            if(newIndex)
			{
				Service.user.callMethod("updateArmyChooserStepIndex", [newIndex]);
			}
        });
		
		setTimeout(function()
		{
			APP.fitLayout(true);
		}, 600);
		
		APP.enterGame(null, APP.PORTAL_AUTH_TOKEN);
		
		DragManager.init();
		
		document.addEventListener(CLICK_EVENT, function(){
			APP.playSound();
		});
		
		console.profileEnd();
		console.timeEnd('Initialized');
		console.groupEnd();
		
		APP.refreshBackgroundMusic();
		
		initDebug();
	}
	
	this.onDeviceReady = function()
	{
		
	}
	
	this.stopAllTickers = function()
	{
		if(cityMediator) cityMediator.stopAllTickers();
		if(kingdomMediator) kingdomMediator.stopAllTickers();
	}
	
	this.resumeAllTickers = function()
	{
		if(cityMediator && currentMediator == cityMediator) cityMediator.onConnectionGain();
		if(kingdomMediator && currentMediator == kingdomMediator) kingdomMediator.onConnectionGain();
	}
	
	this.enterGame = function(fakeRace, identCookie)
	{
		Service.user.callMethod("getCurrentUser", [], function(user)
		{
			if (FUser.isGuestUser(identCookie) && fakeRace)
			{
				APP.enterGameGuest(fakeRace, identCookie);
			}
			else if (fakeRace)
			{
				APP.enterGameFake(fakeRace, identCookie);
			}
			else
			{
				APP.enterGameNormal();
			}
		});
	}
	
	this.enterGameNormal = function()
	{
		//Service.city.callMethod("getById", new EstateId(60, 11, 27), function(fc) { cityMediator.showEstate(fc.id, fc); });
		
		console.log("Get capital");
		var estateHandler = function(fc)
		{
			APP.showCity();
			cityMediator.showEstate(fc.id, fc);
		}
		
		if (DEBUG_MODE.OVERRIDE_ESTATE)
		{
			var id = DEBUG_MODE.OVERRIDE_ESTATE.split(/[^0-9]/);
			Service.city.callMethod("getById", [new EstateId(~~id.shift(),~~id.shift(),~~id.shift())], estateHandler, APP.onEnterCapitalError);
		}
		else
		{
			Service.user.callMethod("getCapital", [], estateHandler, APP.onEnterCapitalError);
		}
	}
	
	this.enterGameGuest = function(fakeRace, identCookie)
	{
        var socId = null;
        Service.user.callMethod("enterGuest", [fakeRace, identCookie, socId], function(guest)
        {
            FUser.updateCurrentUser(guest);
            APP.enterGameNormal();
        }, APP.onEnterCapitalError);
    }

    this.enterGameFake = function(fakeRace, identCookie)
    {
    }
    
    this.onEnterCapitalError = function(e)
    {
        if (e.__className__ == "AccessDeniedException")
        {
            Alert.create(e.getMessage()).onClose = Service.goToPortal;
            return true;
        }
        
        /*
        if (e.__className__ == "EstateNotFoundException")
        {
            Alert.create(e.getMessage()).onClose = Service.goToPortal;
            return true;
        }
        */

        if (e.__className__ == "SaveInProgressException")
        {
            Tick.updateTick(Tick.timeInMs() / 1000);
            ServerSavingAlert.onException(e.timeout, APP.enterGameNormal);
           
            return true;
        }
        return false;
    }
	
	this.hideMainContent = function()
	{
		if(cityMediator)
		{
			cityMediator.DOM.style.display = "none";
		}
    	if(kingdomMediator)
    	{
    		kingdomMediator.DOM.style.display = "none";
    	}
	}
	
	this.showMainContent = function()
	{
		if(cityMediator)
		{
			cityMediator.DOM.style.display = "block";
		}
    	if(kingdomMediator)
    	{
    		kingdomMediator.DOM.style.display = "block";
    	}
	}
	
	this.updateCity = function(location)
	{
		cityMediator.showEstate(location);
	}
	
	this.showCity = function(location, fromKingdom)
	{
		this.hidePreloader();
		
		cityMediator.DOM.style.display = "block";
		kingdomMediator.DOM.style.display = "none";
		
		currentMediator = cityMediator;
		
		if(location)
		{
			if(!location.equals(cityMediator._estate.id))
			{
				APP.showLoader();
				if(fromKingdom) cityMediator.toFullUpdateEstateMode();
			}
			cityMediator.showEstate(location);
		}
	}
	
	this.showKingdom = function(location)
	{
		this.hidePreloader();
		
		cityMediator.DOM.style.display = "none";
		kingdomMediator.DOM.style.display = "block";
		
		currentMediator = kingdomMediator;
		
		if(location)
		{
			kingdomMediator.xy = new XY(location.x, location.y);
			kingdomMediator.showKingdom();
		}
	}
	
	this.popup = function(obj)
	{
		$("#popup").append(obj);
		if (typeof obj.fitLayout == 'function')
		{
			obj.fitLayout({width: window.innerWidth, height: window.innerHeight});
		}
	}
	
	this.keyboard = function(kbd)
	{
		if (kbd)
		{
			iScroll.enabled = false;
			APP.pauseTicks();
			
			var fit = {width: window.innerWidth, height: window.innerHeight};
			$('#keyboardContainer').css(fit)
				.show(0)
				.on(CLICK_EVENT, $.proxy(function(){ 
					this.triggerKey('enter'); 
				}, kbd))
			;
			$("#keyboard").append(kbd.DOM);
			if (typeof kbd.fitLayout == 'function')
			{
				kbd.fitLayout(fit);
			}
			
			var el = $(kbd.target.DOM || kbd.input), 
				cns = $('#keyboardContainer > canvas'), 
				ctx = cns[0].getContext('2d'),
				rect = {
					x: el.offset().left - $(window).scrollLeft(), 
					y: el.offset().top - $(window).scrollTop(),
					w: el[0].offsetWidth,
					h: el[0].offsetHeight,
				}
			;
			
			cns.fadeTo(0, 0);
			cns[0].width = fit.width;
			cns[0].height = fit.height;

			ctx.fillSytle = 'rgba(0,0,0,0.3)';
			ctx.fillRect(0, 0, fit.width, fit.height);
			ctx.globalCompositeOperation = 'xor'
			ctx.fillRect(rect.x, rect.y, rect.w, rect.h);

			cns
				.on([CLICK_EVENT,MOUSE_DOWN_EVENT,MOUSE_MOVE_EVENT,MOUSE_UP_EVENT].join(','), function(e){
					e.preventDefault();
					e.stopImmediatePropagation();
					return false;
				})
				.fadeTo(0, 0.3)
			;
		}
		else
		{
			iScroll.enabled = true;
			APP.resumeTicks();
			
			$('#keyboardContainer').off(CLICK_EVENT).hide();
			$('#keyboardContainer > canvas')
				.off([CLICK_EVENT,MOUSE_DOWN_EVENT,MOUSE_MOVE_EVENT,MOUSE_UP_EVENT].join(','))
				.hide(0)
			;
		}
	}
	
	this.setPreloaderProgress = function(value)
	{
		$("#preloadBar").css("width", value*2.9);
		$("#preloadBar").css("background-size", "auto, auto, "+(value*2.9 - 17)+"px 21px");
	}
	
	this.setPreloaderTitle = function(value)
	{
		var t = document.querySelector('#preloadTitle');
		if (!t.innerHTML)
		{
			t.innerHTML = (window.I18 && I18.loaded)
				? I18.f("BROWSER_VERSION_ON", PortalService.getUrl(), PortalService.getUrl())
				: Session.get('PRELOADER_TITLE') || ''
			;
		} 
	}
	
	this.showPreloader = function()
	{
		document.getElementById("preloader").style.display = "block";
	}
	
	this.hidePreloader = function()
	{
		setTimeout(function()
		{
			document.getElementById("preloader").style.display = "none";
		}, 1000);
	}
	
	this.showLoader = function()
	{
		document.getElementById("cityLoader").style.display = "block";
	}
	
	this.hideLoader = function()
	{
		document.getElementById("cityLoader").style.display = "none";
	}
	
	this.ping = function(t)
	{
		if (typeof t != 'undefined')
		{
			clearInterval(pingInterval);
			if (t) pingInterval = setInterval(APP.ping, t);
			else return;
		}
		
		Service.user.callMethod("ping", []);
		PortalService.account.callMethod("ping", []);
	}
	
	this.setAsScreen = function(mediator)
	{
		if(mediator === cityMediator)
		{
			APP.showCity();
		}
		
		if(mediator === kingdomMediator)
		{
			APP.showKingdom();
		}
	}
	
	this.currentScreenIsCity = function()
	{
		return currentMediator === cityMediator;
	}
	
	this.currentScreenIsKingdom = function()
	{
		return currentMediator === kingdomMediator;
	}
	
	this.getCurrentMediator = function()
	{
		return currentMediator;
	}
	
	this.getContentContainer = function()
	{
		return this.getCurrentMediator().DOM;
	}
	
	this.getCityMediator = function()
	{
		return cityMediator;
	}
	
	this.getKingdomMediator = function()
	{
		return kingdomMediator;
	}
	
	this.navigate = function(url, noCache, target)
	{
		noCache = typeof noCache == 'undefined' ? true : !!noCache;
		if (url)
		{
			return target ? window.open(url, target) : window.location.href = url;
		}
		return window.location.reload(noCache);
	}
	
	this.updateHints = function()
	{
		setTimeout(function()
		{
			if(APP.currentScreenIsCity())
			{
				//console.log("************ UPDATE CITY ************");
				
				APP.getCityMediator().viewComponent.updateFooter(APP.getCityMediator().estate);
				APP.getCityMediator().viewComponent.updateArrows();
			}
			
			if(APP.currentScreenIsKingdom())
			{
				//console.log("************ UPDATE KINGDOM ************");
				
				APP.getKingdomMediator().kv.updateEstateArrows();
				APP.getKingdomMediator().kv.updateArrows();
			}
		}, 500);
	}

	this.__defineGetter__('deviceLanguage', function(){ return navigator.language.toUpperCase().split(/[^a-zA-Z]/).shift(); });
	
	this.__defineGetter__('contentContainer', this.getContentContainer);
	
	this.__defineGetter__('lastLoginName', function(){ return Storage.get('lastLoginName'); });
	this.__defineSetter__('lastLoginName', function(val){ return Storage.set('lastLoginName', val || null); });
	
	this.__defineGetter__('language', function(){ return Storage.get('language') || this.deviceLanguage; });
	this.__defineSetter__('language', function(val){ return Storage.set('language', val || null); });
	
	this.__defineGetter__('PORTAL_SESSION', function(){ return Session.get('PORTAL_SESSION'); });
	this.__defineSetter__('PORTAL_SESSION', function(val){ Session.set('PORTAL_SESSION', val || null); });
	
	this.__defineGetter__('PORTAL_AUTH_TOKEN', function(){ return Session.get('PORTAL_AUTH_TOKEN'); });
	this.__defineSetter__('PORTAL_AUTH_TOKEN', function(val){ Session.set('PORTAL_AUTH_TOKEN', val || null); });

	this.__defineGetter__('authorized', function(){ return !!this.PORTAL_AUTH_TOKEN; });
	
	this.__defineGetter__('isCordova', function(){ return ('ontouchstart' in window); });
	
	this.specialSound = null;
	this.playSound = function(src)
	{
		var path = "";
		if(ANDROID_MODE)
		{
			path = window.location.href.split('/');
			path.pop();
			path = path.join('/')+'/';
		}
		src = path + ('static/sound/' + (src || this.specialSound || 'click') + '.mp3');
		this.specialSound = null;

		if (!APP.SOUND_ENABLED) return;
		
		var snd;
		if (window['Media'])
		{
			// use cordova Media plugin
			snd = new Media(src);
		}
		else
		{
			snd = document.querySelector('#game-sound');
			if (!snd)
			{
				snd = document.createElement('audio');
				snd.setAttribute('id', 'game-sound');
				document.body.appendChild(snd);
			}
			snd.setAttribute('src', src);
		}
		if (snd && snd['play']) snd.play();
	}
	
	this.backgroundMusic = null;
	this.backgroundMusicTimer = null;
	this.refreshBackgroundMusic = function()
	{
		var path = "";
		if(ANDROID_MODE) 
		{
			path = window.location.href.split('/');
			path.pop();
			path = path.join('/')+'/';
		}
		var src = path + 'static/sound/my_lands_theame2.mp3';
		var flag = this.MUSIC_ENABLED;
		if (window['Media'])
		{
			// use cordova Media plugin
			if (!this.backgroundMusic)
			{
				this.backgroundMusic = new Media(src,
					$.proxy(function(){ /* SUCCESS */ }, this),
					$.proxy(function(err){ console.warn('Media error: ' + JSON.stringify(err)) }, this),
					$.proxy(function(status){
						if (this.MUSIC_ENABLED && status == Media.MEDIA_STOPPED)
						{
							this.backgroundMusic.seekTo(0);
							this.backgroundMusic.play();
						}
					}, this)
				);
				this.backgroundMusic.setVolume(0.5);
			}
		}
		else
		{
			// use HTML5 audio tag
			if (!this.backgroundMusic)
			{
				this.backgroundMusic = document.createElement('audio');
				this.backgroundMusic.setAttribute('id', 'background-music');
				this.backgroundMusic.setAttribute('autoplay', 'autoplay');
				this.backgroundMusic.setAttribute('loop', 'loop');
				this.backgroundMusic.setAttribute('src', src);
				this.backgroundMusic['volume'] = 0.5;
				document.body.appendChild(this.backgroundMusic);
			}
		}
		if (this.backgroundMusic)
		{
			var fn = this.backgroundMusic[flag ? 'play' : 'pause'];
			if (typeof fn == 'function') fn.call(this.backgroundMusic);
		}
	}
	
	this.stopBackgroundMusic = function()
	{
		if(this.backgroundMusic)
		{
			this.backgroundMusic.pause();
			this.backgroundMusic = null;
		}
	}
	
	this.__defineGetter__('MUSIC_ENABLED', function(){ 
		if (Storage.get('MUSIC_ENABLED') === null) Storage.set('MUSIC_ENABLED', true);
		return !!Storage.get('MUSIC_ENABLED'); 
	});
	this.__defineSetter__('MUSIC_ENABLED', function(val){ 
		val = !!val;
		Storage.set('MUSIC_ENABLED', val);
		this.refreshBackgroundMusic();
	});

	this.__defineGetter__('SOUND_ENABLED', function(){ 
		if (Storage.get('SOUND_ENABLED') === null) Storage.set('SOUND_ENABLED', true);
		return !!Storage.get('SOUND_ENABLED'); 
	});
	this.__defineSetter__('SOUND_ENABLED', function(val){ 
		val = !!val;
		Storage.set('SOUND_ENABLED', val);
	});
	
	return this;
})();