var Storage = new (function(){
	
	this.isEnabled = function()
	{
		return !!localStorage;
	}
	
	this.get = function(key)
	{
		if (!this.isEnabled()) return null;
		var val = localStorage.getItem(key);
		return (val && val != 'undefined') ? JSON.parse(val) : null;
	}
	
	this.set = function(key, val)
	{
		if (!this.isEnabled()) return null;
		if (val) val = JSON.stringify(val);
		return localStorage.setItem(key, val);
	}
	
	this.clear = function()
	{
		if (!this.isEnabled()) return null;
		return localStorage.clear();
	}
	
	return this;
	
})();
