var pingInterval = null;

var PRELOAD_IMAGES = [
	"common/logo.png",
	"common/social/facebook.png",
	"common/social/vkontakte.png",
	"common/social/twitter.png",
	"common/dialog_decor_lt.png",
	"common/dialog_decor_ct.png",
	"common/dialog_caption.png",
	"common/dialog_decor_rt.png",
	"common/dialog_bg2.png",
	"common/dialog_bg1.png",
	"common/dialog_decor_lb.png",
	"common/dialog_decor_rb.png",
	"common/dialog_decor_cb.png",
	"common/input/checkbox-square.png",
	"common/input/checkbox-square-checked.png",
	"common/input/dropdown.png",
	"common/picker.png",
	"common/picker_active.png",
	"buttons/left.png",
	"buttons/green.png",
	"buttons/right.png",
	"buttons/yellow.png",
	"buttons/yellow_down.png",
	"buttons/green.png",
	"buttons/green_down.png",
	"buttons/red.png",
	"buttons/red_down.png",
	"buttons/disabled.png",
	"icons/back.png",
	"icons/back2.png",
	"login/round_icon_busy.png",
	"login/button_delete_avatar.png",
	"login/can_enter_server.png",
	"login/server_military_free.png",
	"login/server_miner_free.png",
	"login/race_human.png",
	"login/race_elf.png",
	"login/race_demon.png",
	"login/race_drow.png",
];

var startUp = function()
  {
    document.querySelector('Body > Portal').style.opacity = 0;
    APP.showLoader();
    while (CONFIG.css.length > 0)
    {
        getCSS(CONFIG.css.shift());
    }

    if(PHONE_MODE)
    {
        getCSS("phone");
    }

    if(ANDROID_MODE)
    {
        getCSS("android");

        if(PHONE_MODE)
        {
            getCSS("android_phone");
        }

        if(window.androidIDFA)
        {
            androidIDFA.getAdId(function(data) {

                console.log(BuildInfo.packageName);
                console.log(BuildInfo.version);
                console.log(JSON.stringify(data.adId));

                MATHelper.setUp("android", BuildInfo.packageName, BuildInfo.version, data.adId);
            }, function(){
				MATHelper.setUp("android", BuildInfo.packageName, BuildInfo.version, null);
				MATHelper.randomDeviceId();
			});
        }
        else {
			MATHelper.setUp("android", BuildInfo.packageName, BuildInfo.version, null);
			MATHelper.randomDeviceId();
		}
    }

    var PRELOAD_STEPS = [

        function()
        {
            var d = $.Deferred();

            var onload = function()
            {
                for (var i = 0; i < PRELOAD_IMAGES.length; i++)
                {
                    if (this.src == PRELOAD_IMAGES[i].src)
                    {
                        PRELOAD_IMAGES.splice(i, 1);
                        if (!PRELOAD_IMAGES.length)
                        {
                            console.log("LOAD: images loaded");
                            d.resolve();
                        }
                        return;
                    }
                }
            };

            for (var i = 0; i < PRELOAD_IMAGES.length; i++)
            {
                var src = PRELOAD_IMAGES[i];

                PRELOAD_IMAGES[i] = new Image();
                PRELOAD_IMAGES[i].src = STATIC_INTERFACE_URL + src;
                PRELOAD_IMAGES[i].onload = onload;
                PRELOAD_IMAGES[i].onerror = onload;
            }
            for (var i = 0; i < PRELOAD_IMAGES.length; i++)
            {
                if (PRELOAD_IMAGES[i].complete)
                {
                    onload.call(PRELOAD_IMAGES[i]);
                    i--;
                }
            }
            return d;
        },

        function()
        {
            var d = $.Deferred();
            console.log("LOAD: loading zones...");
            PortalService.getZones(function(data)
            {
                console.log("LOAD: loaded zones");
                PortalService.switchToZone(null, function(){
                    d.resolve();
                });

            });
            return d;
        },

        function()
        {
            COM.init({basePath: 'app/classes'});
            return COM.load(CONFIG.components);
        },

        function()
        {
            delete CONFIG;

            COM.parseStaticData(document.body);
            COM.parseDOMElement(document.body);

            APP.langButton.zone = ZoneInfo.find(PortalService.portalInfo.thisZone);
            APP.langButton.onSelect = APP.changeZone;

            APP.backButton = COM.create('BackButton');
            UI.show(false, [APP.backButton]);
            document.querySelector('body > Back-Box').appendChild(APP.backButton.DOM);

            APP.route();
            APP.hideLoader();
            document.querySelector('Body > Portal').style.opacity = 1;

            clearInterval(pingInterval);
            pingInterval = setInterval(PortalService.ping, 30*1000);
            refreshDebugInfo();

            if(!("ontouchstart" in window)) window.addEventListener("resize", APP.fitLayout);
            APP.fitLayout();

            if (!window.open['clearCookies']) window.open['clearCookies'] = function(){};
            $('body').removeClass('first-init');
            $('> first-init', document.body).remove();

            //MATHelper.setUp("ios", "com.mlgame.mylands", "1.1", "3791DA63-D136-42CD-97AA-38803692C9CB");
            MATHelper.start();
            setTimeout(function(){
                var displayVersion = 'web';
                if (MATHelper.VERSION)
                {
                    // displayVersion = MATHelper.VERSION.split('.');
                    // if (ANDROID_MODE) displayVersion.pop();
                    // displayVersion = displayVersion.join('.');
					displayVersion = MATHelper.VERSION;
                }
                document.body.setAttribute('data-content', "v." + displayVersion);
            }, 2000);
            APP.onReady('preload');
        }
    ]

    var inc = include_once(CONFIG.scripts);
    while (PRELOAD_STEPS.length)
    {
        inc = inc.pipe(PRELOAD_STEPS.shift());
    }
  };

if(window.cordova)
{
    console.log("CORDOVA HERE");
    document.addEventListener('deviceready', startUp, false);
}
else
{
    $(startUp);
}

var APP = new (function()
{
	var self = this;
	
	var history = [], currentView = '';
	
	this.registration = {
		signupInfo: null,
		server: null,
		race: null,
		terms: false
	}
	
	function autoRoute()
	{
		history = [], currentView = '';
		var view = 'WelcomeScreenView';
		if (APP.lastLoginName)
		{
			view = 'LoginScreenView'; history.push('WelcomeScreenView');
			if (APP.authorized)
			{
				view = 'ServerSelect'; 
				history.push('LoginScreenView');
			}
		}
		return view;
	}
	
	function animateScreens(prev, next)
	{
		var dist = window.innerWidth*2, t = 100;
		$(next.DOM)
			.transition({opacity:0, scale: [1,0]}, 0)
			.transition({opacity:1, scale: [1,1]}, t)
		;
		$(prev.DOM)
			.transition({opacity:0, scale: [1,0]}, t, function(){ 
				prev.destroy();
			})
		;
	}
	
	function animateBack(prev, next)
	{
		UI.show(false, [APP.backButton]);
		var dist = window.innerWidth*2, t = 300;
		$(next.DOM)
			.transition({opacity:0, scale: [0,1]}, 0)
			.transition({opacity:1, scale: [1,1]}, t)
		;
		$(prev.DOM)
			.transition({opacity:0, scale: [0,1]}, t, function(){ 
				prev.destroy();
				UI.show(history.length, [APP.backButton]);
			})
		;
	}
	
	function changeScreen(fn)
	{
		var prev = COM(document.querySelector('body > portal').children[0]);
		var next = COM.create(currentView);

		if (fn)
		{
			$(APP.contentContainer).append(next.DOM);
			if (prev) fn(prev, next);
		}
		else
		{
			APP.showLoader();
			if (prev) prev.destroy();
			$(APP.contentContainer).append(next.DOM);
			APP.hideLoader();
		}
		next.DOM.style.pointerEvents = 'none';
		setTimeout(function(){
			next.DOM.style.pointerEvents = 'auto';
		}, 300);
	}
	
	this._readyFlags = {device: false, preload: false};
	this.onReady = function(evtName)
	{
		if (evtName) this._readyFlags[evtName] = true;
		for (var prop in this._readyFlags) if (!this._readyFlags[prop]) return;
		
		GAHelper.sendEvent("portal", "start", this.langButton.zone ? this.langButton.zone.key : "");
	}
	
	this.onDeviceReady = function()
	{
		this.onReady('device');
	}
	
	this.fitLayout = function()
	{
		//document.body.style.width = window.innerWidth + 'px';
		//document.body.style.height = window.innerHeight + 'px';
	}
	
	this.back = function()
	{
		if (!history.length) return;
		currentView = history.pop();
		changeScreen(/*animateBack*/);
	}
	
	this.route = function(view)
	{
		view = view || autoRoute();
		if (currentView) 
		{
			if (currentView == view) return;
			history.push(currentView);
		}
		
		// hardcoded history fix
		var fixedHistory = {
			"WelcomeScreenView": [],
			"LoginScreenView": ["WelcomeScreenView"],
		}
		if (fixedHistory[view]) history = fixedHistory[view];
		
		UI.show(history.length, [this.backButton]);
		
		currentView = view;
		changeScreen();
		
		if(window.PushManager && !window.PushManager.ready)
		{
			PushManager.init();
		}
		
		if(window.PurchasesManager && !window.PurchasesManager.ready)
		{
			PurchasesManager.init();
		}
		
		preventScroll();
	}
	
	this.globalError = function(err)
	{
		var view = COM(document.querySelector('body > portal').children[0]);
		if (view) UI.show(err === null, [view]);
		
		if (UI.show(err !== null, [document.querySelector('#globalErrorText')]))
		{
			APP.hideLoader();
			$('#globalErrorText').html(err);
		}
	}
	
	this.reloadConfig = function(callback)
	{
		var d = $.Deferred();
		
		PortalService.getConfig(function(data)
		{
			APP.onPortalConfig(data);
			d.resolve();
			if (callback) callback();
		});
		return d;
	}

	this.onPortalConfig = function(data)
	{
		FPortalConfig.load(data);

        Session.set('TAPJOY_ENABLED', FPortalConfig.TAPJOY_ENABLED);
        Session.set('TAPJOY_SDK_KEY_ANDROID', FPortalConfig.TAPJOY_SDK_KEY_ANDROID);
        Session.set('TAPJOY_SDK_KEY_IOS', FPortalConfig.TAPJOY_SDK_KEY_IOS);
        Session.set('TAPJOY_OFFERWALL_NAME_ANDROID', FPortalConfig.TAPJOY_OFFERWALL_NAME_ANDROID);
        Session.set('TAPJOY_OFFERWALL_NAME_IOS', FPortalConfig.TAPJOY_OFFERWALL_NAME_IOS);

		Session.set('PRELOADER_TITLE', I18.f("BROWSER_VERSION_ON", PortalService.getUrl(), PortalService.getUrl()));
	}
	
	this.changeZone = function(zone)
	{
		APP.globalError(null);
		document.querySelector('#globalErrorText').style.visibility = 'hidden';
		
		var refresh = PortalService.zone && zone && (PortalService.zone.language != zone.language);
		PortalService.switchToZone(zone);
		APP.clear();
		
		// to reload components localization
		if (refresh) 
		{
			APP.navigate("index.html");
		}
	}
	
	this.changeGameServer = function(server, url)
	{
		if (typeof server == 'undefined') server = Session.get('gameServer');
		
		APP.registration.server = server;
		Session.set('gameServer', server || null);
		Session.set('gameServerURL', url || (server ? server.url : null));
		Session.set('gameServerIcon', server ? server.gameServerIcon : null);
		Session.set('gameServerName', server ? server.gameServerName : null);
		Session.set('gameServerOnline', server ? server.gameServerOnline : null);
	}
	
	this.clear = function()
	{
		this.lastLoginName = null;
		this.logout();
	}
	
	this.logout = function()
	{
		PortalService.logout(function()
		{
			Session.clear(); 
			APP.navigate();
		});
	}
	
	this.popup = function(obj)
	{
		$("#popup").append(obj);
		if (typeof obj.fitLayout == 'function')
		{
			obj.fitLayout({width: window.innerWidth, height: window.innerHeight});
		}
	}
	
	this.getContentContainer = function()
	{
		return document.querySelector('body > Portal');
	}
	
	this.showTerms = function()
	{
		var w = window.open(PortalService.getUrl('/page/license_mobile.jsp'), '_blank');
		if (w.show) w.show();
	}
	
	this.showLoader = function()
	{
		document.getElementById("cityLoader").style.display = "block";
	}
	
	this.hideLoader = function()
	{
		document.getElementById("cityLoader").style.display = "none";
	}
	
	this.navigate = function(url, noCache, target)
	{
		noCache = typeof noCache == 'undefined' ? true : !!noCache;
		if (url)
		{
			return target ? window.open(url, target) : (window.location.href = url);
		}
		return window.location.reload(noCache);
	}
	
	this.playSound = function(src)
	{
		if (!APP.SOUND_ENABLED) return;
		var path = "";
		if(ANDROID_MODE)
		{
			path = window.location.href.split('/');
			path.pop();
			path = path.join('/')+'/';
		}
		src = path + (src || 'static/sound/click.mp3');
		
		var snd;
		if (window['Media'])
		{
			// use cordova Media plugin
			snd = new Media(src);
		}
		else
		{
			snd = document.querySelector('#game-sound');
			if (!snd)
			{
				snd = document.createElement('audio');
				snd.setAttribute('id', 'game-sound');
				document.body.appendChild(snd);
			}
			snd.setAttribute('src', src);
		}
		if (snd && snd['play']) snd.play();
	}
	
	this.keyboard = function(kbd)
	{
		if (kbd)
		{
			iScroll.enabled = false;
			
			var fit = {width: window.innerWidth, height: window.innerHeight};
			$('#keyboardContainer').css(fit)
				.show(0)
				.on(CLICK_EVENT, $.proxy(function(){ 
					this.triggerKey('enter'); 
				}, kbd))
			;
			$("#keyboard").append(kbd.DOM);
			if (typeof kbd.fitLayout == 'function')
			{
				kbd.fitLayout(fit);
			}
			
			var el = $(kbd.target.DOM || kbd.input), 
				cns = $('#keyboardContainer > canvas'), 
				ctx = cns[0].getContext('2d'),
				rect = {
					x: el.offset().left - $(window).scrollLeft(), 
					y: el.offset().top - $(window).scrollTop(),
					w: el[0].offsetWidth,
					h: el[0].offsetHeight,
				}
			;
			
			cns.fadeTo(0, 0);
			cns[0].width = fit.width;
			cns[0].height = fit.height;

			ctx.fillSytle = 'rgba(0,0,0,0.3)';
			ctx.fillRect(0, 0, fit.width, fit.height);
			ctx.globalCompositeOperation = 'xor'
			ctx.fillRect(rect.x, rect.y, rect.w, rect.h);

			cns
				.on([CLICK_EVENT,MOUSE_DOWN_EVENT,MOUSE_MOVE_EVENT,MOUSE_UP_EVENT].join(','), function(e){
					e.preventDefault();
					e.stopImmediatePropagation();
					return false;
				})
				.fadeTo(0, 0.3)
			;
		}
		else
		{
			iScroll.enabled = true;
			
			$('#keyboardContainer').off(CLICK_EVENT).hide();
			$('#keyboardContainer > canvas')
				.off([CLICK_EVENT,MOUSE_DOWN_EVENT,MOUSE_MOVE_EVENT,MOUSE_UP_EVENT].join(','))
				.hide(0)
			;
		}
	}
	
	this.__defineGetter__('deviceLanguage', function(){ return navigator.language.toUpperCase().split(/[^a-zA-Z]/).shift(); });
	
	this.__defineGetter__('contentContainer', this.getContentContainer);
	this.__defineGetter__('langButton', function(){ return COM(document.querySelector('body > Language-Select > CountryButton')); });
	
	this.__defineGetter__('lastLoginName', function(){ return Storage.get('lastLoginName'); });
	this.__defineSetter__('lastLoginName', function(val){ return Storage.set('lastLoginName', val || null); });
	
	this.__defineGetter__('autoLogin', function(){ return Storage.get('autoLogin'); });
	this.__defineSetter__('autoLogin', function(val){ return Storage.set('autoLogin', val || null); });
	
	this.__defineGetter__('language', function(){ return Storage.get('language') || APP.deviceLanguage; });
	this.__defineSetter__('language', function(val){ return Storage.set('language', val || null); });
	
	this.__defineGetter__('PORTAL_SESSION', function(){ return Session.get('PORTAL_SESSION'); });
	this.__defineSetter__('PORTAL_SESSION', function(val){ Session.set('PORTAL_SESSION', val || null); });
	
	this.__defineGetter__('PORTAL_AUTH_TOKEN', function(){ return Session.get('PORTAL_AUTH_TOKEN'); });
	this.__defineSetter__('PORTAL_AUTH_TOKEN', function(val){ Session.set('PORTAL_AUTH_TOKEN', val || null); });

	this.__defineGetter__('authorized', function(){ return this.PORTAL_AUTH_TOKEN; });
	
	this.__defineGetter__('isCordova', function(){ return ('ontouchstart' in window); });
	
	return this;
	
})(); 