// ----------------------------------------------------------------------------
// --= COMMON CONFIG =---------------------------------------------------------
// ----------------------------------------------------------------------------
if (!window['DEBUG_MODE']) window['DEBUG_MODE'] = {};
if (!window['ENTRY_POINT']) window['ENTRY_POINT'] = 'http://mlgame.co.uk/';

// ----------------------------------------------------------------------------
// --= COMMON INCLUDES =-------------------------------------------------------
// ----------------------------------------------------------------------------

var CONFIG = {
	
	css: [
	
		'game',
		'dialog',
		'components',
		'finance',
		
	],
	
	scripts: [

		'app/libs/Component.js',
		'app/classes/common/keyboard/VirtualKeyboard.js',
		'app/classes/game/util/Arrays.js',
		'app/classes/game/util/events.js',
		'app/classes/game/util/Tick.js',
		'app/classes/game/util/I18.js',
		'app/classes/game/util/UI.js',
		'app/classes/game/util/Enum.js',
		'app/classes/game/util/Strings.js',
		'app/classes/game/util/DateUtils.js',
		'app/classes/game/util/NumberUtils.js',
		'app/classes/game/util/FMap.js',
		'app/classes/game/service/FConfig.js',
		'app/classes/game/service/exceptions.js',
		'app/classes/game/service/service.js',
		'app/classes/game/view/assets.js',
		'app/classes/game/model/portal/FPortalResponse.js',
		'app/classes/game/model/portal/FPortalConfig.js',
		'app/classes/game/model/portal/FAccount.js',
		'app/classes/game/model/portal/FGameServer.js',
		'app/classes/game/model/portal/FGameServerConfig.js',
		'app/classes/game/model/Race.js',
		
	],
	
	components: [
		'common/list/ScrollPager',
		'common/list/ScrollableListItem',
		'common/list/ScrollableList',
		'common/keyboard/NumericKeyboard',
		'common/input/Input',
		'common/input/TextInput',
		'common/input/NumberInput',
		'common/input/NumericStepper',
		'common/input/CheckBox',
		'common/input/RadioButton',
		'common/input/RadioGroup',
		'common/input/ComboBoxOption',
		'common/input/ComboBox',
		'game/view/common/Dialog',
		'game/view/common/Alert',
		'game/view/common/TipDialog',
		'game/view/common/SimpleButton',
		'game/view/common/CustomButton',
		'game/view/common/RoundButton',
		'game/view/common/CheckBoxButton',
		'game/view/common/CheckBoxButtonsGroup',
		'game/view/common/ButtonsCombo',
		'game/view/common/Pager',
		'game/view/common/slider/HSlider',
		'game/view/finance/TransferDialog',
		'game/view/finance/TransferTabParent',
		'game/view/finance/TransferToServerTab',
		'game/view/finance/TransferFromServerTab',
		'game/view/finance/FinanceInputTab',
		'portal/FeedbackDialog',
	],
}

// ----------------------------------------------------------------------------
// --= LOCALIZATION =----------------------------------------------------------
// ----------------------------------------------------------------------------

var CONNECTION_ERROR_STRINGS = 
{
	EN: {
		ERROR_RETRY_BUTTON: "Try again",
		ERROR_TITLE_SERVER_DOWN: "The server is currently not available",
		ERROR_MESSAGE_SERVER_DOWN: "The server will be available soon",
		ERROR_TITLE_CONNECTION_DOWN: "Server connection failed",
		ERROR_MESSAGE_CONNECTION_DOWN: "Please, make sure your internet connection is active",
	},
	
	RU: {
		ERROR_RETRY_BUTTON: "Подключиться",
		ERROR_TITLE_SERVER_DOWN: "В данный момент сервер недоступен",
		ERROR_MESSAGE_SERVER_DOWN: "Доступ к серверу вскоре будет возобновлен",
		ERROR_TITLE_CONNECTION_DOWN: 'Не удалось подключиться к серверу',
		ERROR_MESSAGE_CONNECTION_DOWN: 'Пожалуйста, проверьте, активно ли Ваше интернет соединение',
	},

	DE: {
		ERROR_RETRY_BUTTON: "Verbinden",
		ERROR_TITLE_SERVER_DOWN: "Der Server ist derzeit nicht erreichbar",
		ERROR_MESSAGE_SERVER_DOWN: "Der Zugang zum Server wird gleich wiederhegestellt",
		ERROR_TITLE_CONNECTION_DOWN: "Verbindung zum Server fehlgeschlagen",
		ERROR_MESSAGE_CONNECTION_DOWN: "Bitte, stellen Sie sicher, dass Ihre Internetverbindung aktiv ist",
	},
	
	FR: {
		ERROR_RETRY_BUTTON: "Se connecter",
		ERROR_TITLE_SERVER_DOWN: "Le serveur n’est pas accessible pour l'instant",
		ERROR_MESSAGE_SERVER_DOWN: "L'accès au serveur sera repris dans peu de temps",
		ERROR_TITLE_CONNECTION_DOWN: "La connexion avec le serveur a échouée",
		ERROR_MESSAGE_CONNECTION_DOWN: "Veuillez vérifier votre connexion Internet, s'il vous plaît",
	},
	
	IT: {
		ERROR_RETRY_BUTTON: "Connettersi",
		ERROR_TITLE_SERVER_DOWN: "In questo momento il server è innaccessibile",
		ERROR_MESSAGE_SERVER_DOWN: "Il server sarà accessibile in breve",
		ERROR_TITLE_CONNECTION_DOWN: "Connessione con il server fallita",
		ERROR_MESSAGE_CONNECTION_DOWN: "Comprovi, per favore, che la Sua connessione internet sia attiva",
	},
	
	SE: {
		ERROR_RETRY_BUTTON: "Try again",
		ERROR_TITLE_SERVER_DOWN: "The server is currently not available",
		ERROR_MESSAGE_SERVER_DOWN: "The server will be available soon",
		ERROR_TITLE_CONNECTION_DOWN: "Server connection failed",
		ERROR_MESSAGE_CONNECTION_DOWN: "Please, make sure your internet connection is active",
	},
}

var LOCALE_STRINGS_MOBILE = 
{
	SELECT_LANGUAGE: "Выберите язык",
	PLAY_NOW: "Играть сейчас!",
	ALREADY_HAVE_ACCOUNT: "У меня есть аккаунт",
	LOGIN_WITH: "Вход с помощью",
	
	CAPTCHA: "Капча",
	
	RESTORE: "Восстановить",
	RESTORE_LOGIN_OR_EMAIL: "Логин или E-mail",
	
	LOGIN_HINT: "Имя персонажа (Логин)",

	REGISTRATION: "Регистрация",
	REGISTER_WITH: "Регистрация с помощью",
	EMAIL: "E-mail",
	
	SERVERS_LIST_TITLE : "ВЫБОР СЕРВЕРА",
	SERVERS_LIST_TYPE : "Тип",
	SERVERS_LIST_SERVER : "Сервер",
	SERVERS_LIST_REGISTERED : "Рег",
	SERVERS_LIST_ACTIVE : "Акт",
	SERVERS_LIST_ONLINE : "Онл",
	SERVERS_LIST_STATUS : "Статус",
	SERVERS_LIST_PRELOADER : "Загрузка...",
	
	SESSION_EXPIRED: "Авторизация на сервере потеряна.<br/>Возможно под Вашим логином вошли с другого компьютера.<br/><br/>Также авторизация может теряться при апгрейде сервера или при проблемах со связью с сервером.",
	
	//--------------------------------------------------------
	
	MESSAGE: "Сообщение",
	ERROR: "Ошибка",
	MAIL: "Сообщение",
	
	ADVISOR: "Советник",
	
	GARRISON: "Гарнизон",
	SETTINGS: "Настройки",
	HELP: "Справка",
	RATING: "Рейтинг",
	MISSIONS: "Миссии",
	CHEAST: "Сундук",
	SCIENCE: "Наука",
	ALLIES: "Союзники",
	HIDEOUT: "Убежище",
	CALCULATOR: "Калькулятор",
	SET_TRADER: "Комплекты",
	FIRE_HERO: "Уволить",
	HERO_OWNER: "Владелец",
	
	MESSAGE_DISTRIBUTED_WORKERS: "Все здания заполнены рабочими и учеными из незанятого населения", 
	MESSAGE_DISTRIBUTED_BUILDERS: "Все здания заполнены строителями из незанятого населения", 
	
	EXPERIENCE: "Опыт",
	MANA: "Мана",
	LVL_X: "{0} ур.",
	HERO_CASTS_TITLE: "Заклинания на герое",
	HERO_NO_CASTS: "На герое нет заклинаний",
	
	ALLIED_ARMIES: "Союзные войска {0} из {1}",
	NO_ALLIED_ARMIES: "Нет союзных войск",
	
	MOVE_TO_HIDEOUT: "Переместить в убежище",
	MOVE_TO_HIDEOUT_COST: "Стоимость<br/>перемещения",
	
	TRAINS: 'Тренирует',
	NO_TRAINING: 'Сейчас никто не тренируется',
	
	RESOURCES_TO_LOOT: 'Можно награбить',
	
	STAT_ATTACK: 'Атака',
	STAT_DEFENCE: 'Защита',
	STAT_HEALTH: 'Здоровье',
	STAT_VICTIM: 'Хорошо атакуют',
	STAT_PERSECUTOR: 'Плохая защита',
	STAT_SPECIAL_ABILITY: 'Специальные умения',
	
	C_B_TIP_DIPLOMATIC_HALL_ALLOWS_TO_MAKE_ALLIANCES: 'Позволяет заключать союзы, назначать заместителей, вступать в кланы, брать учеников.',
	
	MOVE_CAPITAL: "Перенести",
	
	CLAN_ACTION_ENTER_CLAN_WAREHOUSE: "Склады",
	CLAN_ACTION_ENTER_CLAN_RESERVATION: "Резервация",
	CLAN_ACTION_TRANSFORM_CLAN: "Преобразовать",
	DESTROY_CLAN: "Расформировать",
	CLAN_HISTORY: "Архив",
	CREATE_QUESTION: "Создать",
	
	ESPIONAGE_RESULT: "Результаты шпионажа",
	OBSERVATION_RESULT: "Результаты наблюдения",
	MISSION_CREATED: "Миссия отправлена",
	
	UNIT_LEVEL: "Уровень юнита",
	
	KILLED_ARMY_TIP: "Погребено армий (по очкам)",
	PROLONGATE_LIFETIME: "Время жизни",
	INCREASE_DEFENCE: "Защита",
	CHANGE_SKIN_BUTTON_SHORT: "Архитектура",
	SELECT_CITY_SKIN: "Выберите новую архитектуру ратуши",
	
	MARKET_BUY_INFO_LINE_LOTS: "Лотов: {0}",
	
	MESSAGE_FILTER_SYSTEM_TOOLTIP: "Губернатор",
	MESSAGE_FILTER_MILITARY_TOOLTIP: "Военачальник",
	MESSAGE_FILTER_MAGIC_TOOLTIP: "Придворный маг",
	MESSAGE_FILTER_USER_TOOLTIP: "Игроки",
	MESSAGE_FILTER_CLAN_TOOLTIP: "Клан",
	MESSAGE_FILTER_ADMIN_TOOLTIP: "Администрация",
	
	ALL_CONTACTS: "Все",
	ADD_CONTACT: "Добавить контакт",
	ADD_TO_IGNORE: "Добавить в черный список",
	CLAN_WARMINISTER: "В.министр",
	
	ADMINISTRATION_CONTACT: "Администрация",
	ADMINISTRATION_CONTACT_DESCR: "Пишите, если возникают сложности",
	EDIT_CONTACT: "Редакирование контакта",
	CONTACT_NOT_IN_CLAN: "Не в клане",
	
	MAILS_DELETED: "Письма удалены",
	MAILS_MARK_AS_READ: "Письма помечены как прочитанные",
	MAILS_MOVED_TO_ARCHIVE: "Письма перемещены в архив",
	
	RESURRECTOR_DESCRIPTION: "Воскрешение Ваших войск, погибших на защите",
	RESURRECTOR_NO_ARMY: "У вас нет войск, которые можно воскресить",
	
	MANAGE_TEMPLE_ASK: "На время, часы:",
	MANAGE_TEMPLE_ASK2: "Попросить защиты от:",
	
	ADD_TO_BUILD_QUEUE: "В очередь",
	RESOURCES_NEEDED: "Необходимо ресурсов:",
	
	AUTOEXPEDITION_PAUSED: "Не завершено предыдущее иследование королевства, начатое <div class='text-big'>{0:tick-date-seconds}</div>",
	
	REPUTATION: "Репутация",
	UNIT_LEVEL: "Уровень юнита",
	
	DONT_SHOW_FAR_FUTURE_ATTACKS: "Не отображать предупреждение на кнопке \u00abМиссии\u00bb, если до входящей атаки осталось более {0:on-duration}",
	CANCEL_MISSION: "Отменить миссию",
	CANCEL_MISSION_CONFIRMATION: "Вы действительно хотите отменить эту миссию?",
	MISSION_DETAILS: "Информация о миссии",
	MISSION_CAPTION: "Миссию выполняют:",
	
	SPECIALIZATIONS: "Специализации",
	LEARN: "Изучить",
	REPLACE: "Заменить",
	ADD_TO_QUEUE: "В очередь",
	IMPROVE: "Улучшить",
	EXPAND: "Расширить",
	DONATE: "Пожертвовать",
	REMOVE_FROM_QUEUE: "Убрать из очереди",
	
	ORDER_ENTER_COORDS: "Введите координаты владения",
	
	ARTIFACT_FILTER_ANY_LEVEL: "Любой уровень",
	ARTIFACT_FILTER_ANY: "Все",
	ARTIFACT_FILTER_SCROLL: "Свитки",
	ARTIFACT_FILTER_ARTIFACT: "Артефакты",
	ARTIFACT_FILTER_CRYSTAL: "Кристаллы",
	ARTIFACT_FILTER_BOTTLE: "Зелья",
	
	ARTIFACT_TYPE_ARTIFACT_NAME: "Артефакт",
	ARTIFACT_TYPE_CRYSTAL_NAME: "Кристалл",
	ARTIFACT_TYPE_SCROLL_NAME: "Свиток",
	ARTIFACT_TYPE_EXP_BOTTLE_NAME: "Эликсир",
	ARTIFACT_TYPE_MANA_BOTTLE_NAME: "Эликсир",
	SKILL_NAME: "Навык героя",
	
	CAST_CAUSE_TOURNAMENT_SERVICE_NAME: "Турнир",
	CAST_CAUSE_TOURNAMENT_GROTTO_SERVICE_NAME: "Турнир",
	CAST_CAUSE_SERVICE_NAME: "Магия",
	CAST_CAUSE_APPRENTICE_REWARD_NAME: "Награда",
	CAST_CAUSE_QUEST_REWARD_NAME: "Награда",
	CAST_CAUSE_PERSONAL_EVENT_NAME: "Эффект",
	CAST_CAUSE_SCIENCE_LABOUR_SERVICE_NAME: "Магия",
	CAST_CAUSE_SCIENCE_MILITARY_SERVICE_NAME: "Магия",
	CAST_CAUSE_ARTIFACT_NAME: "Артефакт",
	CAST_CAUSE_SET_NAME: "Комплект",
	CAST_CAUSE_SPELL_NAME: "Заклинание",
	CAST_CAUSE_PASSIVE_NAME: "Навык",
	CAST_CAUSE_HALL_PASSIVE_NAME: "",
	CAST_CAUSE_CLAN_BONUS_NAME: "Клановый бонус",
	CAST_CAUSE_CASTLE_STANDARD_NAME: "Штандарт замка",
	CAST_CAUSE_FRIENDS_NAME: "Друзья",
	CAST_CAUSE_MAIL_EVERY_YEAR_REWARD_NAME: "Награда",
	CAST_CAUSE_UNKNOWN_NAME: "Эффект",
	
	PORTAL_PERL_TRANSFER: "Кошелек на портале",
	
	BROWSER_VERSION_ON: "Браузерная версия игры доступна по адресу: <a href='#' onclick=\"window.open('{0}', '_system');\" target='_blank'>{1}</a>",
	
	NO_APPRENTICES: "Нет учеников",
	
	EXPORT: "Экспорт",
	DETAILS: "Подробности",
	
	TRANSFER_NO_RESOURCES: "Нечего передавать",
	TRANSFER_NO_TARGET: "Выберите, куда передавать",
	
	PURCHASE_COMPLETE: "Оплата совершена успешно. ЧЖ будут зачислены в ближайшее время.",
	
	PROMPT_REGISTER: "Вы хотите перейти к созданию игрового акаунта?",
	DELETE_AVATAR: "Удалить персонажа",
	UNDELETE_AVATAR: "Отменить удаление",
	
	OWNER_DELETION_PENDING_MESSAGE: 'Персонаж удаляется.<br/>Отмените удаление, чтобы иметь возможность играть на этом сервере.',
	
	MOVE_ALL: "Выбрать все",
	
	CURRENT_QUESTS_MOBILE: "Текущие",
	FULFILLED_QUESTS_MOBILE: "Выполненные",
	TOURNAMENT_FLAG_MOBILE: "Сбор флагов",
	TOURNAMENT_GROTTO_MOBILE: "Соленые озера",
	
	CONNECTION_STATUS_LOST_EXPLAIN: 'Невозможно подключиться к серверу. Возможно, у Вас отключен WiFi или Ваше устройство переведено в режим "В самолете".',
	
	PERL_TRANSFER: "Кошелек",
	
	ADD_CELL: "Расширить",
	
	CONFIRM_CAPACITY_CHANGE_CAPTION: "Объём складов",
	CONFIRM_CAPACITY_CHANGE: "Вы изменили объём складов.<br/>Применить сделанные Вами изменения?",
	
	NEED_TO_FILL_DATA: "Вы указали не все необходимые данные",
	CLAN_ERROR_TRANSFORMATION_RUNNING: "Вопрос преобразования клана в Монархический находится на голосовании",
	
	FLAG_SETS_MOBILE: "Комплектов",
	GROTTO_SETS_MOBILE: "Удержаний",
	
	EXPEL_APPRENTICE_CONFIRMATION: "Вы действительно хотите отказаться от ученика {0}?",
	RELEASE_APPRENTICE_CONFIRMATION: "Вы действительно хотите выпустить ученика {0}?",
	
	NEED_TO_FILL: "Необходимо ввести",
	NEED_TO_FILL_USERNAME: "Необходимо ввести логин",
	NEED_TO_FILL_CAPTCHA: "Необходимо ввести код на картинке",
	NEED_TO_FILL_LICENCE: "Необходимо принять лицензию",
	NEED_TO_FILL_PASSWORD: "Необходимо ввести пароль",
	NEED_TO_FILL_EMAIL: "Необходимо ввести Email",
	REGISTRATION_ERROR_ALREADY_EXISTS: "Пользователь с указанным именем уже существует. Задайте другое имя.",
	REGISTRATION_ERROR_ALREADY_EXISTS_WITH_PROPOSE: "Пользователь с указанным именем уже существует. Выберите одно из предложенных или задайте другое имя:",
	REGISTRATION_ERROR_ALREADY_EXISTS_EMAIL: "Вы уже зарегистрированы в игре с этим email. Вернитесь на страницу входа в игру и войдите под своим старым логином. Если Вы не помните свой логин или пароль - нажмите кнопку \"Забыли пароль\" на странице входа",
	REGISTRATION_ERROR_WRONG_CAPTCHA: "Вы неправильно ввели символы на картинке",
	REGISTRATION_ERROR_WRONG_USERNAME: "Некорректное имя пользователя. Задайте другое имя.",
	REGISTRATION_ERROR_WRONG_EMAIL: "Некорректный email, задайте другой.",
	REGISTRATION_ERROR_WRONG_PASSWORD: "Некорректный пароль, задайте другой.",
	REGISTRATION_ERROR_SIMPLE_PASSWORD: "В целях безопасности запрещено вводить столь простые пароли. Введите более сложный пароль.",
	REGISTRATION_ERROR_WRONG_REF_INFO: "Вы регистрируетесь с недействительным бонусом. Перейдите еще раз по бонусной ссылке для дополнительной информации или откажитесь от бонуса.",
	REGISTRATION_ERROR_NO_INVITE: "У Вас нет приглашения на этот сервер. Если Вы регистрировались по ссылке, попробуйте еще.",
	REGISTRATION_ERROR_WRONG_EXT_DATA: "Произошла ошибка взаимодействия с сервером соц. сети.",
	REGISTRATION_ERROR_SOCIAL_ALREADY_EXISTS: "Вы уже зарегистрированы в игре через эту соц.сеть. Вернитесь на страницу логина и нажмите на кнопку \"Войти с помощью соц.сети\"",
	REGISTRATION_ERROR_WRONG_SOCIAL_UID: "Не удалось зарегистрироваться через эту соц сеть, попробуйте другую",
	REGISTRATION_ERROR_REGISTRATION_CLOSED: "Регистрация закрыта",

	ENABLE_MUSIC: "Воспроизводить фоновая музыку",
	ENABLE_SOUND: "Воспроизводить звуки",
}

// InAppBrowser overrides and global listeners
var IABGlobal = { 
	windowFeatures: { 
		location: 'yes', 
		hidden: 'yes', 
		closebuttoncaption: 'X' 
	}
};

