var MATHelper = {
	
	ADVERTISER_ID: "18448",
	CONVERSION_KEY: "2b26946e6a958ef30f0475196935b1ed",
	
	PLATFORM: null,
	BUNDLE_ID: null,
	VERSION: null,
	
	DEVICE_ID: null,
	
	isReady: function()
	{
		return (MATHelper.PLATFORM &&
		   		MATHelper.ADVERTISER_ID &&
		   		MATHelper.BUNDLE_ID &&
		   		MATHelper.VERSION &&
		   		MATHelper.DEVICE_ID);
	},
	
	setUp: function(platform, bundle_id, version, device_id)
	{
		console.log('MAT init '+bundle_id+' '+version+' on '+platform+': ' + device_id);
		MATHelper.PLATFORM = (platform == "android" ? MobileAppTracker.PLATFORM_ANDROID : MobileAppTracker.PLATFORM_IOS);
		MATHelper.BUNDLE_ID = bundle_id;
		MATHelper.VERSION = version;
		MATHelper.DEVICE_ID = device_id;
	},
	
	start: function(callback)
	{
		var mobileAppTracker = window.plugins ? window.plugins.matPlugin : null;
		if (mobileAppTracker)
		{
			var gaidWrapper = window.plugins.gaidWrapperPlugin;
			var ifaWrapper = window.plugins.ifaWrapperPlugin;
			
			if (ifaWrapper || gaidWrapper)
			{
				MATHelper.PLATFORM = ifaWrapper ? 'ios' : 'android';
				
				mobileAppTracker.initTracker(function(){
					
					console.log("MATPlugin init success!");
					mobileAppTracker.measureSession(function(){
	
						console.log("MATPlugin measureSession success!");
	
						if (gaidWrapper)
						{
							gaidWrapper.getGoogleAdvertisingId(function(result){
								console.log("MATPlugin GAID " + result.gaid);
								MATHelper.DEVICE_ID = result.gaid;
								
								if (new RegExp('\\s+').test(MATHelper.DEVICE_ID))
								{
									MATHelper.randomDeviceId();
									console.warn("MATPlugin invalid GAID: " + result.gaid);
								}
								else
								{
									mobileAppTracker.setGoogleAdvertisingId(function(){
										
										console.log("MATPlugin setGoogleAdvertisingId success!");
										
										MATHelper.trackAction = function(action, callback)
										{
											mobileAppTracker.measureAction((callback || null), null, action, null, null, null);
										}
										
										if (typeof callback == 'function') callback();
		
									}, function(){

										MATHelper.randomDeviceId();
										console.log("MATPlugin setGoogleAdvertisingId failed!");
										
									}, result.gaid, result.isLAT);
								}
							
							}, function(){

								MATHelper.randomDeviceId();
								console.log("MATPlugin GAID failed!");
								
							});
						}
	
						if (ifaWrapper)
						{
							ifaWrapper.getAppleAdvertisingIdentifier(function(result){
							
								console.log("MATPlugin IFA " + result.ifa);
								MATHelper.DEVICE_ID = result.ifa;
								
								if (new RegExp('\\s+').test(MATHelper.DEVICE_ID))
								{
									MATHelper.randomDeviceId();
									console.warn("MATPlugin invalid IFA: " + result.ifa);
								}
								else
								{
									mobileAppTracker.setAppleAdvertisingIdentifier(function(){
										
										console.log("MATPlugin setAppleAdvertisingIdentifier success!");
										
										MATHelper.trackAction = function(action, callback)
										{
											mobileAppTracker.measureAction((callback || null), null, action, null, null, null);
										}
										
										if (typeof callback == 'function') callback();
										
									}, function(){
										
										console.log("MATPlugin setAppleAdvertisingIdentifier failed!");
										
									}, result.ifa, result.trackingEnabled);
								}
							
							}, function(){
								
								console.log("MATPlugin IFA failed!");
								
							});
						}
	
					}, function(){
						console.log("MATPlugin measureSession failed!");
					});
	
					
				}, function(){
					
					console.log("MATPlugin init failed!");
					
				}, MATHelper.ADVERTISER_ID, MATHelper.CONVERSION_KEY);

				return;
			}
		}
		
		if(!MATHelper.isReady())
		{
			if (!Storage.get('DEVICE_GUID')) Storage.set('DEVICE_GUID', 'MOBILE-'+GUID());
			MATHelper.DEVICE_ID = Storage.get('DEVICE_GUID');
			if (new RegExp('\\s+').test(MATHelper.DEVICE_ID))
			{
				MATHelper.randomDeviceId();
				console.warn("MATPlugin invalid DEVICE_ID. Random ID generated instead.");
			}
			return;
		}
		
		MobileAppTracker.init(MATHelper.ADVERTISER_ID, MATHelper.BUNDLE_ID, MATHelper.PLATFORM, MATHelper.VERSION);

		if (new RegExp('\\s+').test(MATHelper.DEVICE_ID))
		{
			MATHelper.randomDeviceId();
			console.warn("MATPlugin invalid DEVICE_ID. Random ID generated instead.");
		}
		
		MobileAppTracker.setDeviceId(MATHelper.DEVICE_ID);
		MobileAppTracker.setUserId(MATHelper.DEVICE_ID);
		
		if(MATHelper.PLATFORM == MobileAppTracker.PLATFORM_IOS) MobileAppTracker.setAppleAdvertisingIdentifier(MATHelper.DEVICE_ID);
		if(MATHelper.PLATFORM == MobileAppTracker.PLATFORM_ANDROID) MobileAppTracker.setGoogleAdvertisingId(MATHelper.DEVICE_ID);
		
		MobileAppTracker.trackSession(callback ? callback : null);
	},
	
	trackAction: function(action, callback)
	{
		if(!MATHelper.isReady()) return;
		
		MobileAppTracker.trackAction(action, null, null, null, (callback ? callback : null));
	},

	randomDeviceId: function(){
		var id = Storage.get('RANDOM_DEVICE_ID') || 'RANDOM-' + (new Date).getTime() + '-' + (1000000000 + Math.round(Math.random() * 999999999));
		Storage.set('RANDOM_DEVICE_ID', id);
		MATHelper.DEVICE_ID = id;
		return id;
	},

	getDeviceId: function(){
		// XXX: https://jira.elyland.net/browse/MLGAMEMOBILE-622
		if (!MATHelper.DEVICE_ID || MATHelper.DEVICE_ID == 'null' || MATHelper.DEVICE_ID == 'undefined' || MATHelper.DEVICE_ID == 'false') {
			MATHelper.randomDeviceId();
		}
		return MATHelper.DEVICE_ID;
	}
};

// ('android', 'com.mlgame.mylands', '0.0.1.1', '5f896411-307e-488a-b0e0-53842a864c8d');