var MailAssets =
{
	ALLY_STATUS_ACTIVE : "shared/mail/ally_status_active.png",
	ALLY_STATUS_BREAKING : "shared/mail/ally_status_breaking.png",
	ALLY_STATUS_PROPOSED_TO_ME : "shared/mail/ally_status_proposed_to_me.png",
	ALLY_STATUS_PROPOSED_BY_ME : "shared/mail/ally_status_proposed_by_me.png",

	MESSAGE_ICON_SYSTEM : "shared/mail/system_message.png",
	MESSAGE_ICON_MILITARY : "shared/mail/military_message.png",
	MESSAGE_ICON_MAGIC : "shared/mail/magic_message.png",
	MESSAGE_ICON_USER : "shared/mail/user_message.png",
	MESSAGE_ICON_CLAN : "shared/mail/clan_message.png",
	MESSAGE_ICON_ADMIN : "shared/mail/admin_message.png",

	BUTTON_MAIL_SMALL : "shared/button_mail_small.png",
	BUTTON_HAT : "shared/mail/button_hat.png",

	BUTTON_FILTER_ALL : "shared/mail/button_filter_all.png",
	BUTTON_FILTER_SYSTEM : "shared/mail/button_filter_system.png",
	BUTTON_FILTER_MILITARY : "shared/mail/button_filter_military.png",
	BUTTON_FILTER_MAGIC : "shared/mail/button_filter_magic.png",
	BUTTON_FILTER_USER : "shared/mail/button_filter_user.png",
	BUTTON_FILTER_CLAN : "shared/mail/button_filter_clan.png",
	BUTTON_FILTER_ADMIN : "shared/mail/button_filter_admin.png",

	BUTTON_SENT: "shared/mail/button_sent.png",
	BUTTON_ARCHIVE : "shared/mail/button_archive.png",
	BUTTON_MARK_READ : "shared/mail/button_mark_read.png",
	BUTTON_DELETE : "shared/mail/button_delete.png"
}

MailAssets.getAllyStatusIcon = function(status, proposedToMe)
{
	switch (status.name)
	{
		case AllianceStatus.ACTIVE.name:
			return MailAssets.ALLY_STATUS_ACTIVE;
		case AllianceStatus.PROPOSED.name:
			return proposedToMe ? MailAssets.ALLY_STATUS_PROPOSED_TO_ME : MailAssets.ALLY_STATUS_PROPOSED_BY_ME;
		case AllianceStatus.BREAKING.name:
			return MailAssets.ALLY_STATUS_BREAKING;
		case AllianceStatus.NONE.name:
			return null;
		default:
			throw Error("Cannot find icon for ally status: " + status);
	}
}

MailAssets.getPeaceStateIcon = function(state)
{
	switch (state.name)
	{
		case ClanDeclarationState.EFFECTIVE.name:
			return MailAssets.ALLY_STATUS_ACTIVE;
		case ClanDeclarationState.OUTCOMING.name:
			return MailAssets.ALLY_STATUS_PROPOSED_BY_ME;
		case ClanDeclarationState.INCOMING.name:
			return MailAssets.ALLY_STATUS_PROPOSED_TO_ME;
		default:
			throw Error("Invalid peace state");
	}
}
var SmileAssets =
{
	SMILE_ANGRY : "shared/smiles/free/angry.gif",
	SMILE_LAUGH : "shared/smiles/free/laugh.gif",
	SMILE_SAD : "shared/smiles/free/sad.gif",
	SMILE_SMILE : "shared/smiles/free/smile.gif",
	SMILE_GIRL : "shared/smiles/free/girl_smile.gif",

	// premium only
	SMILE_THUMBS_UP : "shared/smiles/payment/thumbs_up.gif",
	SMILE_AFRAID : "shared/smiles/payment/afraid.gif",
	SMILE_AGGRESSIVE : "shared/smiles/payment/aggressive.gif",
	SMILE_BLINK : "shared/smiles/payment/blink.gif",
	SMILE_CRY : "shared/smiles/payment/cry.gif",
	SMILE_EVRIKA : "shared/smiles/payment/evrika!.gif",
	SMILE_FLAG : "shared/smiles/payment/flag.gif",
	SMILE_FLOWER : "shared/smiles/payment/flower.gif",
	SMILE_HELP : "shared/smiles/payment/help!.gif",
	SMILE_HONOR : "shared/smiles/payment/honor.gif",
	SMILE_KING : "shared/smiles/payment/king.gif",
	SMILE_KISS : "shared/smiles/payment/kiss.gif",
	SMILE_KISS_LIGHT : "shared/smiles/payment/kiss_light.gif",
	SMILE_CONTUSION : "shared/smiles/payment/kontuzia.gif",
	SMILE_MODEST : "shared/smiles/payment/modest.gif",
	SMILE_NO : "shared/smiles/payment/no.gif",
	SMILE_BEER : "shared/smiles/payment/pivo.gif",
	SMILE_RICH : "shared/smiles/payment/rich.gif",
	SMILE_SILENCE : "shared/smiles/payment/silence.gif",
	SMILE_SLEEPER : "shared/smiles/payment/sleeper.gif",
	SMILE_SPY : "shared/smiles/payment/spy.gif",
	SMILE_WEARY : "shared/smiles/payment/weary.gif",
	SMILE_WHITE_FLAG : "shared/smiles/payment/white_flag.gif",
	SMILE_WOUNDED : "shared/smiles/payment/wounded.gif",
	SMILE_YES : "shared/smiles/payment/yes.gif",
	SMILE_CHAMPAGNE : "shared/smiles/payment/NY/champagne.gif",
	SMILE_DED_MOROZ : "shared/smiles/payment/NY/DedMoroz.gif",
	SMILE_OLEN : "shared/smiles/payment/NY/olen.gif",
	SMILE_SANTA_CLAUS : "shared/smiles/payment/NY/SantaClaus.gif",
	SMILE_SNEGKI : "shared/smiles/payment/NY/snegki.gif",
	SMILE_SNEGOVIK : "shared/smiles/payment/NY/snegovik.gif",
	SMILE_SNEGURKA : "shared/smiles/payment/NY/snegurka.gif",
	SMILE_XLOPUSKA : "shared/smiles/payment/NY/xlopushka.gif",

	// valentine
	SMILE_BALOON : "shared/smiles/valentine/baloon.gif",
	SMILE_FLOWERV : "shared/smiles/valentine/flowerv.gif",
	SMILE_GUITAR : "shared/smiles/valentine/guitar.gif",
	SMILE_KISSV : "shared/smiles/valentine/kissv.gif",
	SMILE_TANGO : "shared/smiles/valentine/tango.gif",
	SMILE_TEDDY : "shared/smiles/valentine/teddy.gif",

	// bastille
	SMILE_EIFFEL_TOWER : "shared/smiles/bastille/eiffel_tower.gif",
	SMILE_FRENCH_CANNON : "shared/smiles/bastille/french_cannon.gif",
	SMILE_FRENCH_FLAG : "shared/smiles/bastille/french_flag.gif",
	SMILE_FRENCH_KID_HORSE : "shared/smiles/bastille/french_kid_horse.gif",
	SMILE_FRENCH_PAINT : "shared/smiles/bastille/french_paint.gif",
	SMILE_FRENCH_TOWER : "shared/smiles/bastille/french_tower.gif",

	// ferragosto
	SMILE_ITALIAN_BALLOONS : "shared/smiles/ferragosto/italian_balloons.gif",
	SMILE_ITALIAN_CAP : "shared/smiles/ferragosto/italian_cap.gif",
	SMILE_ITALIAN_FLAG : "shared/smiles/ferragosto/italian_flag.gif",
	SMILE_ON_THE_BEACH : "shared/smiles/ferragosto/on_the_beach.gif",
	SMILE_SUN : "shared/smiles/ferragosto/sun.gif",
	SMILE_SWIMMING : "shared/smiles/ferragosto/swimming.gif",

	// 9 may
	SMILE_9MAY_CANNON : "shared/smiles/9May_smiles/cannon.gif",
	SMILE_9MAY_ETERNAL_FLAME : "shared/smiles/9May_smiles/eternal_flame.gif",
	SMILE_9MAY_MARSH : "shared/smiles/9May_smiles/marsh.gif",
	SMILE_9MAY_MEDAL : "shared/smiles/9May_smiles/medal.gif",
	SMILE_9MAY_OFFICER : "shared/smiles/9May_smiles/officer.gif",
	SMILE_9MAY_ORDEN : "shared/smiles/9May_smiles/orden.gif",

	//Easter
	SMILE_EASTER_ANGEL : "shared/smiles/Easter_smiles/angel.gif",
	SMILE_EASTER_CANDLE : "shared/smiles/Easter_smiles/candle.gif",
	SMILE_EASTER_PAINT_EGG : "shared/smiles/Easter_smiles/paintEgg.gif",
	SMILE_EASTER_PASOCHKA : "shared/smiles/Easter_smiles/pasochka.gif",
	SMILE_EASTER_PISANKI : "shared/smiles/Easter_smiles/pisanki.gif",
	SMILE_EASTER_VBITKI : "shared/smiles/Easter_smiles/vbitki.gif",

	//Halloween
	SMILE_HALLOWEEN_BABA_YAGA : "shared/smiles/Halloween_smiles/babaYaga.gif",
	SMILE_HALLOWEEN_CASPER : "shared/smiles/Halloween_smiles/casper.gif",
	SMILE_HALLOWEEN_DEMON : "shared/smiles/Halloween_smiles/demon.gif",
	SMILE_HALLOWEEN_PUMPKIN : "shared/smiles/Halloween_smiles/pumpkin.gif",
	SMILE_HALLOWEEN_SPIDER : "shared/smiles/Halloween_smiles/spider.gif",
	SMILE_HALLOWEEN_WIZARD : "shared/smiles/Halloween_smiles/wizard.gif",

	//OctoberFest
	SMILE_OCTOBERFEST_BARREL : "shared/smiles/Octoberfest_smiles/barrel.gif",
	SMILE_OCTOBERFEST_BARREL_ROLLS : "shared/smiles/Octoberfest_smiles/barrel_rolls.gif",
	SMILE_OCTOBERFEST_BAVARIA : "shared/smiles/Octoberfest_smiles/bavaria.gif",
	SMILE_OCTOBERFEST_BEER_FOAM : "shared/smiles/Octoberfest_smiles/beer_foam.gif",
	SMILE_OCTOBERFEST_DRUNK : "shared/smiles/Octoberfest_smiles/drunk.gif",
	SMILE_OCTOBERFEST_PI_PI : "shared/smiles/Octoberfest_smiles/pi_pi.gif",

	//StPatrica
	SMILE_ST_PATRICA_GORSHO4EK : "shared/smiles/StPatrica/Gorsho4ek.gif",
	SMILE_ST_PATRICA_GREEN_BEER : "shared/smiles/StPatrica/Green_Beer.gif",
	SMILE_ST_PATRICA_HI : "shared/smiles/StPatrica/Hi.gif",
	SMILE_ST_PATRICA_KLEVER_GIRL : "shared/smiles/StPatrica/Klever_girl.gif",
	SMILE_ST_PATRICA_KLEVER_MAN : "shared/smiles/StPatrica/Klever_man.gif",
	SMILE_ST_PATRICA_VOLYNA : "shared/smiles/StPatrica/Volyna.gif"
}

var CommonAssets =
{
	HEX_EMPTY : "shared/city/hex_alpha.png",
	HEX_ERROR : "shared/city/hex_error.png",
	BUILDING_LEVEL : "shared/city/building_level.png",
	BUILDING_LEVEL_WARNING : "shared/city/building_level_warning.png",
	COUNTDOWN_BG : "shared/city/countdown_bg.png",

	// resource cells
	CELL_GRAIN : "shared/city/cells/grain.png",
	CELL_STONE : "shared/city/cells/stone.png",
	CELL_IRON : "shared/city/cells/iron.png",
	CELL_GOLD : "shared/city/cells/gold.png",
	CELL_GRAIN_UNREACHABLE : "shared/city/cells/grain_outer.png",
	CELL_STONE_UNREACHABLE : "shared/city/cells/stone_outer.png",
	CELL_IRON_UNREACHABLE : "shared/city/cells/iron_outer.png",

	CELL_NOTHING : "shared/city/cells/nothing.png",
	CELL_GRID : "shared/city/cells/grid.gif",

	LOCK : "shared/icons/lock.png",
	MENU_BUTTON_LOCKED : "shared/city/menu/button_locked.png",

	//blockers
	BLOCKER_LAKE : "shared/city/cells/blocker_lake.png",
	BLOCKER_ROCK : "shared/city/cells/blocker_rock.png",
	BLOCKER_TREE : "shared/city/cells/blocker_tree.png",
	BLOCKER_DARKTREE : "shared/city/cells/blocker_darktree.png",

	// icons
	ICON_WOOD : "shared/icons/resources/wood.png",
	ICON_WOOD_NY : "shared/icons/resources/ny_wood.png",
	ICON_GRAIN : "shared/icons/resources/grain.png",
	ICON_STONE : "shared/icons/resources/stone.png",
	ICON_IRON : "shared/icons/resources/iron.png",
	ICON_GOLD : "shared/icons/resources/gold.png",

	ICON_ANCIENT_MAGIC_CLICKABLE : "shared/icons/ancient_magic_clickable.png",
	ICON_ANCIENT_MAGIC_IN_PROGRESS : "shared/icons/ancient_magic_in_progress.png",
	ICON_MAGIC_CLOSE_GATE : "shared/icons/close_gate.png",
	ICON_MAGIC_CHANGE_SKIN : "shared/icons/cityhall/icon-architecture.png",
	ICON_MAGIC_FINISH_NOW : "shared/icons/momentary_building.png",
	ICON_MAGIC_PROLONGATE : "shared/icons/cityhall/icon-prolongate.png",
	ICON_NEWS : "shared/icons/news.png",

	ICON_TIME : "shared/icons/time.png",
	ICON_KNOWLEDGE : "shared/icons/knowledge.png",
	ICON_GODPOINT : "shared/icons/godpoint.png",
	INPROGRESS_BUILD : "shared/icons/inprogress_build.png",
	INPROGRESS_UPGRADE : "shared/icons/inprogress_upgrade.png",
	INPROGRESS_UPGRADE_UNIT : "shared/icons/inprogress_upgrade_unit.png",
	INPROGRESS_FROZEN : "shared/icons/inprogress_frozen.png",
	INPROGRESS_REPAIR : "shared/icons/inprogress_repair.png",
	CRYSTAL_SIGN : "shared/icons/crystal_sign.png",
	CRYSTAL_SIGN_SMALL : "shared/icons/crystal_sign_small.png",
	BROKEN : "shared/icons/broken.png",

	BUTTON_HIDEOUT : "shared/city/button_hideout.png",
	BUTTON_ALLIES : "shared/city/button_allies.png",
	BUTTON_HIDEOUT_LOCKED : "shared/city/button_hideout_locked.png",
	BUTTON_ALLIES_LOCKED : "shared/city/button_allies_locked.png",

	ROUND_MENU_CITY : "shared/city/menu/round_menu_city.png",
	ROUND_MENU_KINGDOM : "shared/city/menu/round_menu_kingdom.png",
	BUTTON_ENTER : "shared/city/menu/button_enter.png",
	BUTTON_UPGRADE : "shared/city/menu/button_upgrade.png",
	BUTTON_PERFECT : "shared/city/menu/button_perfect.png",
	BUTTON_REPAIR : "shared/city/menu/button_repair.png",
	BUTTON_DESTROY : "shared/city/menu/button_destroy.png",
	BUTTON_FINISH : "shared/city/menu/button_speed_building.png",
	BUTTON_ENTER_DEPUTY : "shared/kingdom/button_enter_estate.png",

	BUTTON_MAIL : "shared/kingdom/menu/button_mail.png",
	BUTTON_GIFT : "shared/kingdom/menu/button_gift.png",

	// city UI elements
	CITY_HEADER_BODY : "shared/city/top_panel_1.jpg",
	CITY_HEADER_EDGE : "shared/city/top_panel_2.png",
	CITY_FOOTER_BODY : "shared/city/bottom_panel_1.jpg",
	CITY_FOOTER_EDGE : "shared/city/bottom_panel_2.png",

	CITY_HEADER_BW_PANEL : "shared/city/panel_bw.png",

	BUTTON_BUILDERS : "shared/city/button_builders.png",
	BUTTON_WORKERS : "shared/city/button_workers.png",

	CITY_ARMY_SLOTS : "shared/city/army_slots.png",
	CITY_ARMY_4_SLOTS : "shared/city/army_4_slots.png",
	CITY_HERO_SLOT : "shared/city/hero_slot.png",

	// pearl chest
	PEARL_CHEST : "shared/chest.png",

	// navigation
	NAVIGATION_PREVIOUS : "shared/city/previous.png",
	NAVIGATION_NEXT : "shared/city/next.png",

	// stats
	STAT_ATTACK : "shared/icons/stats/attack.png",
	STAT_DEFENCE : "shared/icons/stats/defence.png",
	STAT_HEALTH : "shared/icons/stats/health.png",
	STAT_PERSECUTOR : "shared/icons/stats/persecutor.png",
	STAT_VICTIM : "shared/icons/stats/victim.png",
	STAT_STRENGTH : "shared/icons/stats/gate_strength.png",

	UNIT_TYPE_SCAVENGER : "shared/icons/stats/type_scavenger.png",
	UNIT_TYPE_MELEE : "shared/icons/stats/type_melee.png",
	UNIT_TYPE_CAVALRY : "shared/icons/stats/type_cavalry.png",
	UNIT_TYPE_FLYER : "shared/icons/stats/type_flyer.png",
	UNIT_TYPE_RANGER : "shared/icons/stats/type_ranger.png",
	UNIT_TYPE_HEALER : "shared/icons/stats/type_healer.png",
	UNIT_TYPE_MINER : "shared/icons/stats/type_miner.png",
	UNIT_TYPE_MAGE : "shared/icons/stats/type_mage.png",

	// killed units in the cityhall
	KILLED_ICON : "shared/icons/stats/killed.png",

	// science
	SCIENCE_ICON : "shared/city/science_icon.png",

	EMPTY_SCIENCE : "shared/science/empty_science.png",
	ADD_TO_QUEUE : "shared/science/add_science.png",
	SCIENCE_CAPITAL : "shared/science/capital.png",
	SCIENCE_MARKET : "shared/science/market.png",
	SCIENCE_BUILDING : "shared/science/building.png",
	SCIENCE_COLONIZATION : "shared/science/colonization.png",
	SCIENCE_TREASURY : "shared/science/treasury.png",
	SCIENCE_OUTER_ESTATES : "shared/science/outer_estates.png",
	SCIENCE_ESPIONAGE : "shared/science/espionage.png",
	SCIENCE_CARTOGRAPHY : "shared/science/cartography.png",
	SCIENCE_ARMY_MANAGEMENT : "shared/science/army_management.png",
	SCIENCE_OBSERVATION : "shared/science/observation.png",
	SCIENCE_REPAIRING : "shared/science/repairing.png",
	SCIENCE_DIPLOMACY : "shared/science/diplomacy.png",
	SCIENCE_CLANS : "shared/science/clans.png",
	SCIENCE_CASTLES : "shared/science/castles.png",
	SCIENCE_SECTORS : "shared/science/sectors.png",
	SCIENCE_HIDEOUT : "shared/science/shelter.png",
	SCIENCE_HIDDEN_RESOURCES : "shared/science/hiding_place.png",
	SCIENCE_MERCHANT : "shared/science/merchant.png",
	SCIENCE_TERRAFORMING : "shared/science/terraforming.png",
	SCIENCE_FORTIFICATION : "shared/science/fortification.png",
	SCIENCE_TOWER : "shared/science/tower.png",
	SCIENCE_MAGIC_TOWER : "shared/science/magic_tower.png",
	SCIENCE_TEMPLE : "shared/science/temple.png",
	SCIENCE_RESURRECTOR : "shared/science/resurrector.png",
	SCIENCE_ANTI_ESPIONAGE : "shared/science/anty_espionage.png",
	SCIENCE_ANTI_OBSERVATION : "shared/science/anty_observation.png",
	SCIENCE_GATE : "shared/science/gate.png",
	SCIENCE_GEOLOGY : "shared/science/building_on_resources.png",
	SCIENCE_WAREHOUSE : "shared/science/storehouse_improvement.png",
	SCIENCE_ADD_CELL : "shared/science/add_cell.png",
	SCIENCE_LABOUR_SERVICE : "shared/science/labour_service.png",
	SCIENCE_MILITARY_SERVICE : "shared/science/military_service.png",

	SCIENCE_SPEC_EMPTY : "shared/science/spec_empty.png",
	SCIENCE_SPEC_TRADER : "shared/science/spec_trader.png",
	SCIENCE_SPEC_CLERIC : "shared/science/spec_cleric.png",
	SCIENCE_SPEC_MINER : "shared/science/spec_miner.png",
	SCIENCE_SPEC_BENEFACTOR : "shared/science/spec_benefactor.png",
	SCIENCE_SPEC_ARCHITECT : "shared/science/spec_architect.png",
	SCIENCE_SPEC_DEFENDER : "shared/science/spec_defender.png",

	SCIENCE_DIS_SPEC_EMPTY : "shared/science/spec_empty.png",
	SCIENCE_DIS_SPEC_TRADER : "shared/science/spec_trader_dis.png",
	SCIENCE_DIS_SPEC_CLERIC : "shared/science/spec_cleric_dis.png",
	SCIENCE_DIS_SPEC_MINER : "shared/science/spec_miner_dis.png",
	SCIENCE_DIS_SPEC_BENEFACTOR : "shared/science/spec_benefactor_dis.png",
	SCIENCE_DIS_SPEC_ARCHITECT : "shared/science/spec_architect_dis.png",
	SCIENCE_DIS_SPEC_DEFENDER : "shared/science/spec_defender_dis.png",

	SCIENCE_HEROES : "shared/science/heroes.png",
	SCIENCE_HEROES_SKILL : "shared/science/heroes_skill.png",
	SCIENCE_PRISON : "shared/science/prison.png",
	SCIENCE_CAMPS : "shared/science/camps.png",
	SCIENCE_ALCHEMY : "shared/science/alchemy.png",

	SCIENCE_MELEE : "shared/science/melee.png",
	SCIENCE_SCAVENGER : "shared/science/scavenger.png",
	SCIENCE_RANGER : "shared/science/range.png",
	SCIENCE_HEALER : "shared/science/healer.png",
	SCIENCE_MINER : "shared/science/miner.png",
	SCIENCE_CAVALRY : "shared/science/cavalry.png",
	SCIENCE_FLYER : "shared/science/flyer.png",
	SCIENCE_MAGE : "shared/science/mage.png",

	SPECIALIZATION_RESEARCH : "shared/science/specialization_research.png",

	ARROW_RIGHT : "shared/arrow_2right.png",

	// miscellaneous
	CARD_LOCKED : "shared/city/locked_card.png",
	CARD_LOCKED_MINI : "shared/city/locked_card_mini.png",
	LOCKED_BUILDING : "shared/city/locked_building.png",
	LOCKED_HERO : "shared/city/locked_hero.jpg",

	//gifts
	GIFT_FLOWER : "shared/gifts/good/flower.png",
	GIFT_MEDAL : "shared/gifts/good/medal.png",
	GIFT_BEER : "shared/gifts/good/pivo.png",
	GIFT_BLACK : "shared/gifts/bad/black.png",
	GIFT_MONEY : "shared/gifts/bad/money.png",
	GIFT_GUILLOTINE : "shared/gifts/bad/giliotina.png",
	GIFT_PRIDE : "shared/gifts/bad/pride.png",
	GIFT_VUDU : "shared/gifts/bad/vudu.png",

	GIFT_DAR_BOGOV : "shared/gifts/good/dar_bogov1.png",
	GIFT_DAR_BOGOV_2 : "shared/gifts/good/dar_bogov2.png",
	GIFT_DAR_BOGOV_3 : "shared/gifts/good/dar_bogov3.png",
	GIFT_FRACTION_ADMIRAL_1 : "shared/gifts/good/fractionadmiral1.png",
	GIFT_FRACTION_ADMIRAL_2 : "shared/gifts/good/fractionadmiral2.png",
	GIFT_FRACTION_ADMIRAL_3 : "shared/gifts/good/fractionadmiral3.png",
	GIFT_FRACTION_VETERAN_1 : "shared/gifts/good/fractionveteran1.png",
	GIFT_FRACTION_VETERAN_2 : "shared/gifts/good/fractionveteran2.png",
	GIFT_FRACTION_VETERAN_3 : "shared/gifts/good/fractionveteran3.png",
	GIFT_LOOT_1 : "shared/gifts/good/grabeg1.png",
	GIFT_LOOT_2 : "shared/gifts/good/grabeg2.png",
	GIFT_LOOT_3 : "shared/gifts/good/grabeg3.png",
	GIFT_CLAN_1 : "shared/gifts/good/klan1.png",
	GIFT_CLAN_2 : "shared/gifts/good/klan2.png",
	GIFT_CLAN_3 : "shared/gifts/good/klan3.png",
	GIFT_CLAN_ARMY_1 : "shared/gifts/good/klan_army1.png",
	GIFT_CLAN_ARMY_2 : "shared/gifts/good/klan_army2.png",
	GIFT_CLAN_ARMY_3 : "shared/gifts/good/klan_army3.png",
	GIFT_CLAN_ARMY_ORDER_1 : "shared/gifts/good/klan_army_orden1.png",
	GIFT_CLAN_ARMY_ORDER_2 : "shared/gifts/good/klan_army_orden2.png",
	GIFT_CLAN_ARMY_ORDER_3 : "shared/gifts/good/klan_army_orden3.png",
	GIFT_CLAN_ORDER_1 : "shared/gifts/good/klan_orden1.png",
	GIFT_CLAN_ORDER_2 : "shared/gifts/good/klan_orden2.png",
	GIFT_CLAN_ORDER_3 : "shared/gifts/good/klan_orden3.png",
	GIFT_PIT_VETERAN_1 : "shared/gifts/good/kop_veteran1.png",
	GIFT_PIT_VETERAN_2 : "shared/gifts/good/kop_veteran2.png",
	GIFT_PIT_VETERAN_3 : "shared/gifts/good/kop_veteran3.png",
	GIFT_MERCHANT_1 : "shared/gifts/good/kupec1.png",
	GIFT_MERCHANT_2 : "shared/gifts/good/kupec2.png",
	GIFT_MERCHANT_3 : "shared/gifts/good/kupec3.png",
	GIFT_MEDAL_BRONZE : "shared/gifts/good/medal_bronza.png",
	GIFT_MEDAL_GOLD : "shared/gifts/good/medal_gold.png",
	GIFT_MEDAL_GOLD_SPY : "shared/gifts/good/medal_gold_spy.png",
	GIFT_MEDAL_SILVER : "shared/gifts/good/medal_silver.png",
	GIFT_DESTROY_BUILDING_1 : "shared/gifts/good/razrush_zdaniy1.png",
	GIFT_DESTROY_BUILDING_2 : "shared/gifts/good/razrush_zdaniy2.png",
	GIFT_DESTROY_BUILDING_3 : "shared/gifts/good/razrush_zdaniy3.png",
	GIFT_RUIN_VETERAN_1 : "shared/gifts/good/ruinveteran1.png",
	GIFT_RUIN_VETERAN_2 : "shared/gifts/good/ruinveteran2.png",
	GIFT_RUIN_VETERAN_3 : "shared/gifts/good/ruinveteran3.png",
	GIFT_LAKE_VETERAN_1 : "shared/gifts/good/sol_ozera_veteran1.png",
	GIFT_LAKE_VETERAN_2 : "shared/gifts/good/sol_ozera_veteran2.png",
	GIFT_LAKE_VETERAN_3 : "shared/gifts/good/sol_ozera_veteran3.png",
	GIFT_GROUP_ATTACK_1 : "shared/gifts/good/sovmes_ataka1.png",
	GIFT_GROUP_ATTACK_2 : "shared/gifts/good/sovmes_ataka2.png",
	GIFT_GROUP_ATTACK_3 : "shared/gifts/good/sovmes_ataka3.png",
	GIFT_SPY_1 : "shared/gifts/good/spy1.png",
	GIFT_SPY_2 : "shared/gifts/good/spy2.png",
	GIFT_SPY_3 : "shared/gifts/good/spy3.png",
	GIFT_BUILDING_1 : "shared/gifts/good/stroyka1.png",
	GIFT_BUILDING_2 : "shared/gifts/good/stroyka2.png",
	GIFT_BUILDING_3 : "shared/gifts/good/stroyka3.png",
	GIFT_SUPER_ORDEN : "shared/gifts/good/superorden.png",
	GIFT_TRADER_1 : "shared/gifts/good/torgovec1.png",
	GIFT_TRADER_2 : "shared/gifts/good/torgovec2.png",
	GIFT_TRADER_3 : "shared/gifts/good/torgovec3.png",
	GIFT_SLAVE_TAKING_1 : "shared/gifts/good/ugon_rabov1.png",
	GIFT_SLAVE_TAKING_2 : "shared/gifts/good/ugon_rabov2.png",
	GIFT_SLAVE_TAKING_3 : "shared/gifts/good/ugon_rabov3.png",
	GIFT_MISS_ML_1 : "shared/gifts/good/miss1.png",
	GIFT_MISS_ML_2 : "shared/gifts/good/miss2.png",
	GIFT_MISS_ML_3 : "shared/gifts/good/miss3.png",
	GIFT_MISTER_ML_1 : "shared/gifts/good/mister1.png",
	GIFT_MISTER_ML_2 : "shared/gifts/good/mister2.png",
	GIFT_MISTER_ML_3 : "shared/gifts/good/mister3.png",
	GIFT_SCROLL : "shared/gifts/good/svitok.png",
	GIFT_SCROLL_1 : "shared/gifts/good/svitok1.png",
	GIFT_SCROLL_2 : "shared/gifts/good/svitok2.png",
	GIFT_SCROLL_3 : "shared/gifts/good/svitok3.png",
	FRIEND_HELPER : "shared/gifts/socnetwork/friend_helper.png",
	FRIEND_RECRUITER : "shared/gifts/socnetwork/friend_recruiter.png",

	GIFT_NY_BALL : "shared/gifts/good/NY_ball.png",
	GIFT_NY_BUNNY : "shared/gifts/good/NY_bunny.png",
	GIFT_NY_CHAMPAGNE : "shared/gifts/good/NY_Champagne.png",
	GIFT_NY_PRESENTS : "shared/gifts/good/NY_presents.png",
	GIFT_NY_SANTA : "shared/gifts/good/NY_Santa.png",
	GIFT_NY_SNOWFLAKE : "shared/gifts/good/NY_snowflake.png",

	GIFT_14FEBR_HEART : "shared/gifts/good/14febr_heart.png",
	GIFT_23FEBR_1 : "shared/gifts/good/23febr_1.png",
	GIFT_23FEBR_2 : "shared/gifts/good/23febr_2.png",
	GIFT_8MARTA_1 : "shared/gifts/good/8marta_1.png",
	GIFT_8MARTA_2 : "shared/gifts/good/8marta_2.png",
	GIFT_DEFENDER : "shared/gifts/good/defender.png",
	GIFT_NIMBUS : "shared/gifts/good/nimbus.png",
	GIFT_WREATH : "shared/gifts/good/wreath.png",
	GIFT_APRIL1 : "shared/gifts/good/april1.png",

	GIFT_DANCE : "shared/gifts/bastille/dance.png",
	GIFT_EIFFEL_TOWER : "shared/gifts/bastille/eiffel_tower.png",
	GIFT_FRENCH_FLAG : "shared/gifts/bastille/french_flag.png",
	GIFT_FRENCH_MARCHING : "shared/gifts/bastille/french_marching.png",
	GIFT_FRENCH_WOMAN : "shared/gifts/bastille/french_woman.png",
	GIFT_KNIGHT_WITH_FRENCH_FLAG : "shared/gifts/bastille/knight_with_french_flag.png",

	GIFT_ITALIAN_BALLOONS : "shared/gifts/ferragosto/italian_balloons.png",
	GIFT_ITALIAN_BEACH : "shared/gifts/ferragosto/italian_beach.png",
	GIFT_ITALIAN_FIREWORKS : "shared/gifts/ferragosto/italian_fireworks.png",
	GIFT_ITALIAN_FLAG : "shared/gifts/ferragosto/italian_flag.png",
	GIFT_KNIGHT_ON_THE_BEACH : "shared/gifts/ferragosto/knight_on_the_beach.png",
	GIFT_SUNNY_ITALY : "shared/gifts/ferragosto/sunny_italy.png",

	GIFT_TOURNAMENT : "shared/gifts/good/tournament_win.png",
	GIFT_TOURNAMENT_GROTTO : "shared/gifts/good/tournament_grotto_win.png",
	GIFT_FRAGS : "shared/gifts/good/frags.png",

	GIFT_DRAGON : "shared/gifts/bad/dragon.png",
	GIFT_STRIKE : "shared/gifts/bad/strike.png",
	GIFT_SCHELBAN : "shared/gifts/bad/schelban.png",
	GIFT_SPY_KILLER : "shared/gifts/bad/spy_killer.png",
	GIFT_NINJA : "shared/gifts/good/ninja.png",
	GIFT_THRONE : "shared/gifts/good/throne.png",
	GIFT_KONAN : "shared/gifts/good/konan.png",
	GIFT_YOUNG_KNIGHT : "shared/gifts/good/young_knight.png",

	GIFT_SNOW_BALL2 : "shared/gifts/holiday/snow_ball2.png",
	GIFT_OLEN : "shared/gifts/holiday/olen.png",
	GIFT_ANGEL : "shared/gifts/holiday/angel.png",
	GIFT_ANGEL_TRUMPET : "shared/gifts/holiday/angel_trumpet.png",
	GIFT_MONSTER_ELKA : "shared/gifts/holiday/monster_elka.png",
	GIFT_MONSTERS : "shared/gifts/holiday/monsters.png",
	GIFT_SANTA_ARBALET : "shared/gifts/holiday/santa_arbalet.png",
	GIFT_SANTA_SUPERHERO : "shared/gifts/holiday/santa_superhero.png",

	GIFT_DRAZNILKA : "shared/gifts/bad/draznilka.png",
	GIFT_MONSTR_HA_HA : "shared/gifts/bad/monstr_ha_ha.png",
	GIFT_TACHKA_CHEREPA : "shared/gifts/bad/tachka_cherepa.png",
	GIFT_BLACK_GEM : "shared/gifts/good/black_gem.png",
	GIFT_HERO_HORSE : "shared/gifts/good/hero_horse.png",
	GIFT_TORTIK3 : "shared/gifts/good/tortik3.png",

	GIFT_CAKE : "shared/gifts/valentine/cake.png",
	GIFT_CANDIES : "shared/gifts/valentine/candies.png",
	GIFT_DANCING_BEARS : "shared/gifts/valentine/dancing_bears.png",

	GIFT_DRAGON_HEART : "shared/gifts/valentine/dragon_heart.png",
	GIFT_FIELD_FLOWERS : "shared/gifts/valentine/field_flowers.png",
	GIFT_FLYING_TEDDY : "shared/gifts/valentine/flying_teddy.png",
	GIFT_HEART_BUTTERFLIES : "shared/gifts/valentine/heart_butterflies.png",
	GIFT_ORCHID : "shared/gifts/valentine/orchid.png",
	GIFT_PEGASUS : "shared/gifts/valentine/pegasus.png",
	GIFT_SUPERMACHO : "shared/gifts/valentine/supermacho.png",
	GIFT_TEDDY_BEAR : "shared/gifts/valentine/teddy_bear.png",
	GIFT_KNIGHT_FLOWERS : "shared/gifts/valentine/knight_flowers.png",

	GIFT_CLOVER : "shared/gifts/stpatrick/clover.png",
	GIFT_COINS : "shared/gifts/stpatrick/coins.png",
	GIFT_GOLDPOT : "shared/gifts/stpatrick/goldpot.png",
	GIFT_GREEN_BEER : "shared/gifts/stpatrick/greenbeer.png",
	GIFT_LEPRECHAUN_BAGPIPE : "shared/gifts/stpatrick/leprechaunbagpipe.png",
	GIFT_LEPRECHAUN_GOLD : "shared/gifts/stpatrick/leprechaungold.png",

	GIFT_GOLD_MENTOR : "shared/gifts/mentor/gold_mentor.png",
	GIFT_SILVER_MENTOR : "shared/gifts/mentor/silver_mentor.png",

	GIFT_GOLD_PRISON : "shared/gifts/hero/gold_prison.png",
	GIFT_SILVER_PRISON : "shared/gifts/hero/silver_prison.png",

	GIFT_HERO46 : "shared/gifts/hero/hero46.png",
	GIFT_HERO_1SPELL100 : "shared/gifts/hero/hero_1spell100.png",
	GIFT_HERO_2SPELL100 : "shared/gifts/hero/hero_2spell100.png",
	GIFT_HERO_3SPELL100 : "shared/gifts/hero/hero_3spell100.png",
	GIFT_HERO_4SPELL100 : "shared/gifts/hero/hero_4spell100.png",
	GIFT_HERO_5SPELL100 : "shared/gifts/hero/hero_5spell100.png",
	GIFT_HERO_ARTMEDAL : "shared/gifts/hero/hero_artmedal.png",
	GIFT_HERO_DES : "shared/gifts/hero/hero_des.png",
	GIFT_HERO_EXP : "shared/gifts/hero/hero_exp.png",
	GIFT_HERO_GRAB : "shared/gifts/hero/hero_grab.png",
	GIFT_HERO_KILLER : "shared/gifts/hero/hero_killer.png",
	GIFT_HERO_MANA : "shared/gifts/hero/hero_mana.png",
	GIFT_HERO_MONSTER100 : "shared/gifts/hero/hero_monster100.png",
	GIFT_HERO_OSV : "shared/gifts/hero/hero_osv.png",
	GIFT_HERO_RUINART : "shared/gifts/hero/hero_ruinart.png",
	GIFT_HERO_RUINSCROLL : "shared/gifts/hero/hero_ruinscroll.png",
	GIFT_HERO_SDES : "shared/gifts/hero/hero_sdes.png",
	GIFT_HERO_SGRAB : "shared/gifts/hero/hero_sgrab.png",
	GIFT_HERO_SOSV : "shared/gifts/hero/hero_sosv.png",
	GIFT_HERO_SPELL100 : "shared/gifts/hero/hero_spell100.png",
	GIFT_HERO_SZAH : "shared/gifts/hero/hero_szah.png",
	GIFT_HERO_ZAH : "shared/gifts/hero/hero_zah.png",

	GIFT_OF_ACCORDION : "shared/gifts/Octoberfest/accordion.png",
	GIFT_OF_BARREL : "shared/gifts/Octoberfest/Barrel.png",
	GIFT_OF_BEER_BARREL : "shared/gifts/Octoberfest/Beer_barrel.png",
	GIFT_OF_BEER_GIRL : "shared/gifts/Octoberfest/beer_girl.png",
	GIFT_OF_BEER_PINT : "shared/gifts/Octoberfest/beer_pint.png",
	GIFT_OF_BRUDERSHAFT : "shared/gifts/Octoberfest/BruderShaft.png",

	GIFT_HELLO_BATS : "shared/gifts/Helloween/Bats.png",
	GIFT_HELLO_BLACK_CAT : "shared/gifts/Helloween/BlackCat.png",
	GIFT_HELLO_GHOST : "shared/gifts/Helloween/Ghost.png",
	GIFT_HELLO_SKULL : "shared/gifts/Helloween/Skull.png",
	GIFT_HELLO_SPIDER : "shared/gifts/Helloween/Spider.png",
	GIFT_HELLO_WITCH : "shared/gifts/Helloween/Witch.png",
	GIFT_HELLO_EYE : "shared/gifts/Helloween/Eye.png",
	GIFT_HELLO_PUMPKIN : "shared/gifts/Helloween/pampkin.png",

	GIFT_EASTER_CHICKEN : "shared/gifts/Easter/Chicken.png",
	GIFT_EASTER_EGG1 : "shared/gifts/Easter/Egg1.png",
	GIFT_EASTER_EGG2 : "shared/gifts/Easter/Egg2.png",
	GIFT_EASTER_EGGML : "shared/gifts/Easter/EggML.png",
	GIFT_EASTER_EGG_HERO : "shared/gifts/Easter/Egg_Hero.png",
	GIFT_EASTER_ANGEL_LAMB : "shared/gifts/Easter/Angel_Lamb.png",
	GIFT_EASTER_CHOCOLATE_RABBIT : "shared/gifts/Easter/ChocolateRabbit.png",
	GIFT_EASTER_RABBIT_HERBAL : "shared/gifts/Easter/Rabbit_Herbal.png",
	GIFT_EASTER_SIMNEL : "shared/gifts/Easter/Simnel.png",

	GIFT_9MAY_ETERNAL_FLAME : "shared/gifts/9_May/9may_Eternal_flame.png",
	GIFT_9MAY_FLAG_KNIGHT : "shared/gifts/9_May/9may_Flag_Knight.png",
	GIFT_9MAY_MEDAL : "shared/gifts/9_May/9may_medal.png",
	GIFT_9MAY_PARADE : "shared/gifts/9_May/9may_Parade.png",

	GIFT_8MARCH_1 : "shared/gifts/8_March/8_march_1.png",
	GIFT_8MARCH_2 : "shared/gifts/8_March/8_march_2.png",
	GIFT_8MARCH_HERBERS : "shared/gifts/8_March/Herbers.png",
	GIFT_8MARCH_KNIGHT_COOK_CAKE : "shared/gifts/8_March/KnightCookCake.png",

	GIFT_MLD_BALLONS : "shared/gifts/MyLands_Day/Ballons_MyLands.png",
	GIFT_MLD_FIREWORKS : "shared/gifts/MyLands_Day/Fireworks_MyLands.png",
	GIFT_MLD_PARADE : "shared/gifts/MyLands_Day/Parade_MyLands.png",
	GIFT_MLD_EGG_DRAGON : "shared/gifts/MyLands_Day/Egg_dragon_MyLands.png",

	GIFT_KB_LAMB : "shared/gifts/KurbanBayram/lamb.png",
	GIFT_KB_LAMB_BOW : "shared/gifts/KurbanBayram/lamb_bow.png",
	GIFT_KB_GOLD_RAM : "shared/gifts/KurbanBayram/gold_ram.png",
	GIFT_KB_KNIGHT_LAMB : "shared/gifts/KurbanBayram/Knight_lamb.png",
	GIFT_KB_MEAT : "shared/gifts/KurbanBayram/Meat.png",
	GIFT_KB_ST_SOFIA : "shared/gifts/KurbanBayram/StSofia.png",

	GIFT_MEDAL_BROTHERHOOD : "shared/gifts/good/medal_brotherhood.png",
	GIFT_HERO_IN_CHAINS : "shared/gifts/good/medal_hero_in_chains.png",

	COMBO_BOT : "shared/city/combo/combo_bot.png",
	COMBO_MID : "shared/city/combo/combo_mid.png",
	COMBO_TOP : "shared/city/combo/combo_top.png",

	QUEUE_EDGE : "shared/city/queue_edge.png",

	ICON_BLINK : "shared/icons/icon_blink.png",
	DESTROY_CLAN : "shared/icons/destroy_clan_icon.png",
	BUTTON_ROLE : "shared/icons/button_role.png",
	UNDESTROY_CLAN : "shared/icons/undestroy_clan_icon.png",
	CLAN_SETTINGS : "shared/icons/clan_settings_icon.png",
	CLAN_DONATE : "shared/icons/clan_donate_icon.png",
	STAR_ICON : "shared/kingdom/star.png",
	STAR_ICON_EMPTY : "shared/kingdom/star_empty.png",
	BUTTON_ACCEPT : "shared/icons/accept.png",
	CLAN_QUESTIONS : "shared/icons/clan_questions.png",
	MONARCHICAL_CLAN : "shared/icons/monarchic_clan.png",
	DEMOCRATIC_CLAN : "shared/icons/democratic_clan.png",
	IMPEACHMENT : "shared/icons/impeachment_icon.png",

	ICON_REORDER_BUILDINGS : "shared/icons/cityhall/icon-reorder.png",
	ICON_RENAME_CITY : "shared/icons/cityhall/icon-rename.png",
	ICON_INCREASE_DEFENSE : "shared/icons/cityhall/icon-defense.png",

	REST : "shared/city/rest.png",

	//army/resource equalizer / slider
	EQUALIZER_SLIDER : "shared/city/equalizer/up_down.png",
	EQUALIZER_SLIDER_SMALL : "shared/city/equalizer/up_down_small.png",
	EQUALIZER_SLIDER_TINY : "shared/city/equalizer/up_down_tiny.png",
	EQUALIZER_ALL_DOWN : "shared/city/equalizer/all_down.png",
	EQUALIZER_ALL_UP : "shared/city/equalizer/all_up.png",
	EQUALIZER_APPLY : "shared/city/equalizer/apply.png",
	EQUALIZER_SWITCH : "shared/city/equalizer/button_numb.png",

	SELECT_BUILDING : "shared/select_building.png",

	HINT_ARROW_TOP : "shared/arrow_top.png",
	HINT_ARROW_BOTTOM : "shared/arrow_bottom.png",
	HINT_ARROW_RIGHT : "shared/arrow_right.png",
	HINT_ARROW_LEFT : "shared/arrow_left.png",

	BUTTON_CLOSE : "shared/kingdom/menu/button_close.png",

	//combat calculator
	ADD_PARTICIPANT : "shared/calc/btn_add.png",
	REMOVE_PARTICIPANT : "shared/calc/btn_remove.png",
	MARK_SELF : "shared/calc/mark_iam.png",
	ADD_TOWER_BUTTON : "shared/calc/add_tower_button.png",
	TOWER : "shared/calc/tower.png",
	MAGIC_TOWER : "shared/calc/magic_tower.png",
	FORTIFICATION : "shared/calc/fortification.png",
	CASTLEGATE : "shared/calc/castlegate.png",
	SHOW_CALC : "shared/calc/show_calculator.png",
	SHOW_CALC_FOR_MISSION : "shared/calc/show_calculator_mission.png",
	CLEAR_CALC_BUTTON : "shared/calc/clear_calculator_button.png",

	CANCEL_MISSION : "shared/button_cancel_mission.png",
	MISSION_SPEED : "shared/button_mission_speed.png",

	// flags
	FLAG_RED : "shared/city/flags/flag_red.png",
	FLAG_GREEN : "shared/city/flags/flag_green.png",
	FLAG_BLUE : "shared/city/flags/flag_blue.png",
	FLAG_ALL : "shared/city/flags/flag_all.png",
	RAKUSHKA : "shared/rakushka.png",

	BUTTON_FILTER_ADMIN_BLINKING : "shared/mail/button_filter_admin_blinking.png",

	BUTTON_RATING_USERS : "shared/icons/rating_users.png",
	BUTTON_RATING_CLANS : "shared/icons/rating_clans.png",
	BUTTON_RATING_TOURNAMENTS : "shared/icons/rating_tournaments.png",

	BUTTON_MENTOR_REWARD : "shared/icons/mentor_reward_button.png",
	ICON_MENTOR_REWARD : "shared/icons/mentor_reward.png",

	PWNED_PIC : "shared/survival/pwned_by_pic.jpg",
	APOCALYPSE_STARTED : "shared/survival/apocalypse_started.png",
	YOUR_FRACTION_WIN : "shared/survival/your_fraction_win.png",

	CLAN_ACTIONS : "shared/icons/button_role.png",
	CLAN_LEADER : "shared/icons/clan_leader.png",
	CLAN_CAPACITORS_MANAGER : "shared/icons/clan_capacitors_manager.png",
	CLAN_MISSIONS_VIEWER : "shared/icons/clan_missions_viewer.png",

	PEACE_POINT : "shared/icons/peace_point.png",
	WAR_POINT : "shared/icons/war_point.png",
	HALL_OF_FAME : "shared/icons/cityhall/icon-halloffame.png",
	CLAN_MEMBERS : "shared/icons/cityhall/icon-clan-members.png",
	STANDARD_INCOMING_ATTACK_SPEED : "shared/city/standards/peace/incoming_attack_speed.png",
	STANDARD_ARTIFACT_HUNTER : "shared/city/standards/peace/artifact_hunter.png",
	STANDARD_CASTLE_BUILD_QUEUE : "shared/city/standards/peace/castle_build_queue.png",
	STANDARD_CASTLE_MAX_DEFENSE : "shared/city/standards/peace/castle_max_defense.png",
	STANDARD_CASTLE_GATE_DEFENSE : "shared/city/standards/peace/castle_gate_defense.png",
	STANDARD_EXPEDITORS_SPEED : "shared/city/standards/peace/expeditors_speed.png",
	STANDARD_MERCHANTS_SPEED : "shared/city/standards/peace/merchants_speed.png",
	STANDARD_ALCHEMIST : "shared/city/standards/peace/alchemist.png",
	STANDARD_ARENA : "shared/city/standards/peace/arena.png",
	STANDARD_MAGES_SUPPRESS_ATTACK : "shared/city/standards/peace/mages_suppress_attack.png",
	STANDARD_ATTACK : "shared/city/standards/war/attack.png",
	STANDARD_CASTLE_ASSIST_HEALTH : "shared/city/standards/peace/castle_assist_health.png",
	STANDARD_CASTLE_ATTACK : "shared/city/standards/war/castle_attack.png",
	STANDARD_CASTLE_UNITS_AUTOORDER : "shared/city/standards/war/castle_units_autoorder.png",
	STANDARD_ENEMY_ATTACK : "shared/city/standards/war/enemy_attack.png",
	STANDARD_FORTIFICATION : "shared/city/standards/war/fortification.png",
	STANDARD_MAGIC_TOWER : "shared/city/standards/war/magic_tower.png",
	STANDARD_TOWER : "shared/city/standards/war/tower.png",
	STANDARD_HEALTH_BONUS_AGAINST_MONSTER : "shared/city/standards/war/health_bonus_against_monster.png",
	STANDARD_MILITARY_PRODUCTION : "shared/city/standards/war/military_production.png",
	STANDARD_MAGE_ATTACK : "shared/city/standards/war/mage_attack.png",

	DISTRIBUTE_RESOURCES : "shared/icons/distribute.png",

	DECLARE_WAR_ICON : "shared/icons/declare_war.png",
	START_WAR_ICON : "shared/icons/start_war.png",

	BROTHERHOOD_ICON : "shared/icons/cityhall/icon-brotherhood.png",
	BROTHERHOOD_BLINK : "shared/icons/brotherhood_blink.png",

	PEARL_PANEL : "shared/pearl_panel.png",

	ICON_HERO : "shared/icons/tabs/hero.png",
	ICON_SKILLS : "shared/icons/tabs/skills.png",
	ICON_SPELLS : "shared/icons/tabs/spells.png",
	ICON_ARTIFACT_STORE : "shared/icons/tabs/artifact_store.png",
	ICON_ARTIFACT_TRADER : "shared/icons/tabs/artifact_trader.png",
	ICON_SET_TRADER : "shared/icons/tabs/set_trader.png",
	ICON_HERO_EXCHANGE : "shared/icons/tabs/hero_exchange.png",
	ICON_ALCHEMY : "shared/icons/tabs/alchemy.png",
	ICON_RUNE_MASTER : "shared/icons/tabs/runemaster.png",

	ICON_PEARL : "shared/icons/resources/pearl.png",

	STATUS_ON : "shared/icons/status_on.png",
	STATUS_OFF : "shared/icons/status_off.png",
	STATUS_WARNING : "shared/icons/status_warning.png",
	STATUS_UNKNOWN : "shared/icons/status_unknown.png"
};

CommonAssets.getContactStatus = function(status)
{
	switch (status.name)
	{
		case ContactStatus.ONLINE.name:
			return CommonAssets.STATUS_ON;
		case ContactStatus.OFFLINE.name:
			return CommonAssets.STATUS_OFF;
		case ContactStatus.UNKNOWN.name:
			return CommonAssets.STATUS_UNKNOWN;
		default:
			throw Error("Cannot find icon for contact status: " + status.name);
	}
}

CommonAssets.getClanRoleIcon = function(r)
{
	if (r)
		switch (r.name)
		{
			case ClanRole.LEADER.name:
				return CommonAssets.CLAN_LEADER;
			case ClanRole.TREASURER.name:
				return CommonAssets.CLAN_CAPACITORS_MANAGER;
			case ClanRole.WARMINISTER.name:
				return CommonAssets.CLAN_MISSIONS_VIEWER;
		}
	return null;
}
var Assets =
{
	ICON_OK : "shared/ok.png",
	ICON_ERROR : "shared/error.png",
	ICON_CITY : "shared/icons/city.png",
	ICON_CAPITAL : "shared/icons/city_c.png",
	ICON_LAKE : "shared/icons/mine_pearl.png",
	ICON_CAMP : "shared/icons/camp.png",
	ICON_GROTTO : "shared/icons/grotto.png",
	ICON_FAKE_CITY : "shared/icons/city_fake.png",
	ICON_PIT : "shared/icons/pit.png",
	ICON_MINE_STONE : "shared/icons/mine_stone.png",
	ICON_MINE_IRON : "shared/icons/mine_iron.png",
	ICON_MINE_GOLD : "shared/icons/mine_gold.png",
	ICON_CASTLE : "shared/icons/clan.png",
	ICON_GRAIL : "shared/icons/grail.png",

	MOUNTAIN_BLAMBA : "shared/city/background_nb/mountain.jpg",
	DESERT_BLAMBA : "shared/city/background_nb/desert.jpg",
	FOREST_BLAMBA : "shared/city/background_nb/forest.jpg",
	STEPPE_BLAMBA : "shared/city/background_nb/steppe.jpg",
	MAGICFOREST_BLAMBA : "shared/city/background_nb/magic_forest.jpg",
	CURSEDFOREST_BLAMBA : "shared/city/background_nb/cursed_forest.jpg",
	HOLYLAND_BLAMBA : "shared/city/background_nb/holly_land.jpg",
	DEADLAND_BLAMBA : "shared/city/background_nb/dead_land.jpg",

	MINE_GOLD_BLAMBA : "shared/city/mine/gold.png",
	MINE_STONE_BLAMBA : "shared/city/mine/stone.png",
	MINE_IRON_BLAMBA : "shared/city/mine/iron.png",

	RUIN_BLAMBA : "shared/city/mine/ruin.png",
	RUIN_NY_BLAMBA : "shared/city/mine/ny_ruin.png",
	EVIL_BLAMBA : "shared/city/mine/evil.png",
	EVIL_NY_BLAMBA : "shared/city/mine/ny_evil.png",
	LAKE_BLAMBA : "shared/city/mine/lake.png",
	GRAIL_BLAMBA : "shared/city/mine/grail.png",
	STONEHENGE_BLAMBA : "shared/city/mine/stonehenge.png",
	CATAPULT_BLAMBA : "shared/city/mine/catapult.png",

	CAMP_BLAMBA : "shared/city/background_nb/camp.png",
	GROTTO_BLAMBA : "shared/city/background_nb/grotto.png",

	MAGIC_BOOST_WINDMILL : "shared/icons/pearl/increase_output.png",
	MAGIC_BOOST_SAWMILL : "shared/icons/pearl/increase_output.png",
	MAGIC_BOOST_MINE_IRON : "shared/icons/pearl/increase_output.png",
	MAGIC_BOOST_MINE_STONE : "shared/icons/pearl/increase_output.png",
	MAGIC_BOOST_MINE_GOLD : "shared/icons/pearl/increase_output.png",
	MAGIC_BOOST_SHOP : "shared/icons/pearl/increase_output.png",
	MAGIC_BOOST_HOUSES : "shared/icons/pearl/increase_population.png",
	MAGIC_FINISH_ANTISPYGUILD : "shared/icons/pearl/speed_up_antispy.png",
	MAGIC_FINISH_SETTLER : "shared/icons/pearl/speed_up_colonizer.png",
	MAGIC_FINISH_MIRROR_TOWER : "shared/icons/pearl/speed_up_mirror.png",
	MAGIC_AUTO_EXPEDITION : "shared/icons/pearl/speed_up_expeditor.png",
	MAGIC_BOOST_ALCHEMIST : "shared/icons/pearl/speed_up_science.png",
	MAGIC_TEMPLE : "shared/icons/pearl/speed_up_benefaction.png",
	MAGIC_SPECIAL_MISSION : "shared/icons/pearl/speed_up_special_mission.png",
	SUBSCRIPTION : "shared/icons/pearl/subscription.png",
	
	SOCIAL_NETWORK_VK: "shared/social/vk.png",
    SOCIAL_NETWORK_OK: "shared/social/ok.png",
    SOCIAL_NETWORK_MM: "shared/social/mm.png",
    SOCIAL_NETWORK_FB: "shared/social/fb.png",
    SOCIAL_NETWORK_TW: "shared/social/tw.png",

	bg :
	{
		Mountain : "shared/city/background/mountain.jpg",
		Desert : "shared/city/background/desert.jpg",
		Forest : "shared/city/background/forest.jpg",
		Steppe : "shared/city/background/steppe.jpg",
		MagicForest : "shared/city/background/magic_forest.jpg",
		CursedForest : "shared/city/background/cursed_forest.jpg",
		HolyLand : "shared/city/background/holly_land.jpg",
		DeadLand : "shared/city/background/dead_land.jpg",
		Mine : "shared/city/background/mine.jpg"
	},

	Demon :
	{
		Buildings :
		{
			CITYHALL_0 : "demon/buildings/cityhall_0.png",
			CITYHALL_1 : "demon/buildings/cityhall_1.png",
			CITYHALL_2 : "demon/buildings/cityhall_2.png",
			CITYHALL_3 : "demon/buildings/cityhall_3.png",
			CITYHALL_4 : "demon/buildings/cityhall_4.png",
			CITYHALL_5 : "demon/buildings/cityhall_5.png",
			CITYHALL_NY_0 : "demon/buildings/ny_cityhall_0.png",
			CITYHALL_NY_1 : "demon/buildings/ny_cityhall_1.png",
			CITYHALL_NY_2 : "demon/buildings/ny_cityhall_2.png",
			CITYHALL_NY_3 : "demon/buildings/ny_cityhall_3.png",
			CITYHALL_NY_4 : "demon/buildings/ny_cityhall_4.png",
			CITYHALL_NY_5 : "demon/buildings/ny_cityhall_5.png",

			// buildings
			HOUSES : "demon/buildings/houses.png",
			WAREHOUSE : "demon/buildings/warehouse.png",
			CLAN_RESERVATION : "demon/buildings/clan_reservation.png",
			CLAN_WAREHOUSE : "demon/buildings/clan_warehouse.png",
			MARKET : "demon/buildings/other/market.png",
			EXPEDITION : "demon/buildings/other/exped.png",
			ALCHEMIST : "demon/buildings/alchemist.png",
			// buildings: mining
			MINE_IRON : "demon/buildings/mine_iron.png",
			MINE_STONE : "demon/buildings/mine_stone.png",
			MINE_GOLD : "demon/buildings/mine_gold.png",
			SAWMILL : "demon/buildings/sawmill.png",
			WINDMILL : "demon/buildings/windmill.png",
			SHOP : "demon/buildings/shop.png",
			RECOVERY : "demon/buildings/recovery.png",
			TERRAFORMER : "demon/buildings/terraformer.png",
			// buildings: defence
			TOWER : "demon/buildings/tower.png",
			FORTIFICATION : "demon/buildings/fortification.png",
			MAGIC_TOWER : "demon/buildings/magic_tower.png",
			// buildings: military
			MELEE : "demon/buildings/military/melee.png",
			SCAVENGER : "demon/buildings/military/scavenger.png",
			RANGER : "demon/buildings/military/range.png",
			HEALER : "demon/buildings/military/healer.png",
			MINER : "demon/buildings/military/miner.png",
			CAVALRY : "demon/buildings/military/cavalry.png",
			FLYER : "demon/buildings/military/flyer.png",
			MAGE : "demon/buildings/military/mage.png",

			// special
			MERCHANT : "demon/buildings/other/merch_guild.png",
			SETTLER : "demon/buildings/other/colony.png",
			SPYGUILD : "demon/buildings/other/spy_guild.png",
			ANTISPYGUILD : "demon/buildings/other/antispy_guild.png",
			DIPLOMAT : "demon/buildings/other/diplomat.png",
			DIPLOMAT_BLINK : "demon/buildings/other/diplomat_blink.png",
			TAVERN_BLINK : "demon/buildings/other/tavern_blink.png",
			PROPHET_TOWER : "demon/buildings/other/watch_tower.png",
			MIRROR_TOWER : "demon/buildings/other/antiwatch_tower.png",

			TEMPLE : "demon/buildings/other/temple.png",
			RESURRECTOR : "demon/buildings/other/resurrector.png",

			TAVERN : "demon/buildings/other/tavern.png",
			ARTIFACT_STORE : "demon/buildings/other/artefacts.png",
			PRISON : "demon/buildings/other/prison.png"
		},

		Specific :
		{
			CELL_COBBLES : "demon/cobbles.png",
			PEOPLE_ALL : "demon/people_all.png",
			PEOPLE_BUSY : "demon/people_busy.png",
			PEOPLE_FREE : "demon/people_free.png",

			// walls
			WALL_01 : "demon/wall/wall_01.png",
			WALL_12 : "demon/wall/wall_12.png",
			WALL_23 : "demon/wall/wall_23.png",
			WALL_34 : "demon/wall/wall_34.png",
			WALL_45 : "demon/wall/wall_45.png",
			WALL_50 : "demon/wall/wall_50.png",
			WALL_23_OPEN : "demon/wall/wall_23_open.png",
			WALL_23_CLOSED : "demon/wall/wall_23_closed.png",
			WALL_23_OPEN_BROKEN : "demon/wall/wall_23_open_broken.png"
		},

		Cards :
		{
			BACK : "demon/cards/back.png",
			BACK_MINI : "demon/cards/back_mini.jpg",

			MELEE_1 : "demon/cards/melee_1.jpg",
			MELEE_2 : "demon/cards/melee_2.jpg",
			MELEE_3 : "demon/cards/melee_3.jpg",
			MELEE_4 : "demon/cards/melee_3.jpg",
			SCAVENGER_1 : "demon/cards/scavenger_1.jpg",
			SCAVENGER_2 : "demon/cards/scavenger_2.jpg",
			SCAVENGER_3 : "demon/cards/scavenger_3.jpg",
			SCAVENGER_4 : "demon/cards/scavenger_3.jpg",
			RANGER_1 : "demon/cards/range_1.jpg",
			RANGER_2 : "demon/cards/range_2.jpg",
			RANGER_3 : "demon/cards/range_3.jpg",
			RANGER_4 : "demon/cards/range_3.jpg",
			HEALER_1 : "demon/cards/healer_1.jpg",
			HEALER_2 : "demon/cards/healer_2.jpg",
			HEALER_3 : "demon/cards/healer_3.jpg",
			HEALER_4 : "demon/cards/healer_3.jpg",
			MINER_1 : "demon/cards/miner_1.jpg",
			MINER_2 : "demon/cards/miner_2.jpg",
			MINER_3 : "demon/cards/miner_3.jpg",
			MINER_4 : "demon/cards/miner_3.jpg",
			CAVALRY_1 : "demon/cards/cavalry_1.jpg",
			CAVALRY_2 : "demon/cards/cavalry_2.jpg",
			CAVALRY_3 : "demon/cards/cavalry_3.jpg",
			CAVALRY_4 : "demon/cards/cavalry_3.jpg",
			FLYER_1 : "demon/cards/flyer_1.jpg",
			FLYER_2 : "demon/cards/flyer_2.jpg",
			FLYER_3 : "demon/cards/flyer_3.jpg",
			FLYER_4 : "demon/cards/flyer_3.jpg",
			MAGE_1 : "demon/cards/mage_1.jpg",
			MAGE_2 : "demon/cards/mage_2.jpg",
			MAGE_3 : "demon/cards/mage_3.jpg",
			MAGE_4 : "demon/cards/mage_3.jpg",

			TOWER : "demon/cards/tower.jpg",
			MAGIC_TOWER : "demon/cards/mag_tower.jpg",
			TOWER_MINI : "demon/cards/tower_mini.jpg",
			MAGIC_TOWER_MINI : "demon/cards/mag_tower_mini.jpg",

			MERCHANT_1 : "demon/cards/civil/merchant_1.jpg",
			SPY_1 : "demon/cards/civil/spy.jpg",
			ANTISPY_1 : "demon/cards/civil/antispy.jpg",
			EXPEDITOR_1 : "demon/cards/civil/Expeditor.jpg",
			SETTLER_1 : "demon/cards/civil/colonizer_1.jpg",
			PROPHET_1 : "demon/cards/civil/prophet.jpg",
			MIRROR_1 : "demon/cards/civil/mirror.jpg",

			BACK_HERO : "demon/cards/back_hero.jpg",

			ADVISOR : "demon/advisor.png",
			ADVISOR_NY : "demon/ny_advisor.png",
			ADVISOR_ANIMATED : "demon/advisor.png",
			ADVISOR_ANIMATED_NY : "demon/ny_advisor.png"
		}
	},

	Drow :
	{
		Buildings :
		{
			CITYHALL_0 : "drow/buildings/cityhall_0.png",
			CITYHALL_1 : "drow/buildings/cityhall_1.png",
			CITYHALL_2 : "drow/buildings/cityhall_2.png",
			CITYHALL_3 : "drow/buildings/cityhall_3.png",
			CITYHALL_4 : "drow/buildings/cityhall_4.png",
			CITYHALL_5 : "drow/buildings/cityhall_5.png",
			CITYHALL_NY_0 : "drow/buildings/ny_cityhall_0.png",
			CITYHALL_NY_1 : "drow/buildings/ny_cityhall_1.png",
			CITYHALL_NY_2 : "drow/buildings/ny_cityhall_2.png",
			CITYHALL_NY_3 : "drow/buildings/ny_cityhall_3.png",
			CITYHALL_NY_4 : "drow/buildings/ny_cityhall_4.png",
			CITYHALL_NY_5 : "drow/buildings/ny_cityhall_5.png",

			// buildings
			HOUSES : "drow/buildings/houses.png",
			WAREHOUSE : "drow/buildings/warehouse.png",
			CLAN_RESERVATION : "drow/buildings/clan_reservation.png",
			CLAN_WAREHOUSE : "drow/buildings/clan_warehouse.png",
			MARKET : "drow/buildings/other/market.png",
			EXPEDITION : "drow/buildings/other/exped.png",
			ALCHEMIST : "drow/buildings/alchemist.png",
			// buildings: mining
			MINE_IRON : "drow/buildings/mine_iron.png",
			MINE_STONE : "drow/buildings/mine_stone.png",
			MINE_GOLD : "drow/buildings/mine_gold.png",
			SAWMILL : "drow/buildings/sawmill.png",
			WINDMILL : "drow/buildings/windmill.png",
			SHOP : "drow/buildings/shop.png",
			RECOVERY : "drow/buildings/recovery.png",
			TERRAFORMER : "drow/buildings/terraformer.png",
			// buildings: defence
			TOWER : "drow/buildings/tower.png",
			FORTIFICATION : "drow/buildings/fortification.png",
			MAGIC_TOWER : "drow/buildings/magic_tower.png",
			// buildings: military
			MELEE : "drow/buildings/military/melee.png",
			SCAVENGER : "drow/buildings/military/scavenger.png",
			RANGER : "drow/buildings/military/range.png",
			HEALER : "drow/buildings/military/healer.png",
			MINER : "drow/buildings/military/miner.png",
			CAVALRY : "drow/buildings/military/cavalry.png",
			FLYER : "drow/buildings/military/flyer.png",
			MAGE : "drow/buildings/military/mage.png",

			// special
			MERCHANT : "drow/buildings/other/merch_guild.png",
			SETTLER : "drow/buildings/other/colony.png",
			SPYGUILD : "drow/buildings/other/spy_guild.png",
			ANTISPYGUILD : "drow/buildings/other/antispy_guild.png",
			DIPLOMAT : "drow/buildings/other/diplomat.png",
			DIPLOMAT_BLINK : "drow/buildings/other/diplomat_blink.png",
			TAVERN_BLINK : "drow/buildings/other/tavern_blink.png",
			PROPHET_TOWER : "drow/buildings/other/watch_tower.png",
			MIRROR_TOWER : "drow/buildings/other/antiwatch_tower.png",

			TEMPLE : "drow/buildings/other/temple.png",
			RESURRECTOR : "drow/buildings/other/resurrector.png",

			TAVERN : "drow/buildings/other/tavern.png",
			ARTIFACT_STORE : "drow/buildings/other/artefacts.png",
			PRISON : "drow/buildings/other/prison.png"
		},

		Specific :
		{
			CELL_COBBLES : "drow/cobbles.png",
			PEOPLE_ALL : "drow/people_all.png",
			PEOPLE_BUSY : "drow/people_busy.png",
			PEOPLE_FREE : "drow/people_free.png",

			// walls
			WALL_01 : "drow/wall/wall_01.png",
			WALL_12 : "drow/wall/wall_12.png",
			WALL_23 : "drow/wall/wall_23.png",
			WALL_34 : "drow/wall/wall_34.png",
			WALL_45 : "drow/wall/wall_45.png",
			WALL_50 : "drow/wall/wall_50.png",
			WALL_23_OPEN : "drow/wall/wall_23_open.png",
			WALL_23_CLOSED : "drow/wall/wall_23_closed.png",
			WALL_23_OPEN_BROKEN : "drow/wall/wall_23_open_broken.png"
		},

		Cards :
		{
			// unit cards
			BACK : "drow/cards/back.png",
			BACK_MINI : "drow/cards/back_mini.jpg",

			MELEE_1 : "drow/cards/melee_1.jpg",
			MELEE_2 : "drow/cards/melee_2.jpg",
			MELEE_3 : "drow/cards/melee_3.jpg",
			MELEE_4 : "drow/cards/melee_3.jpg",
			SCAVENGER_1 : "drow/cards/scavenger_1.jpg",
			SCAVENGER_2 : "drow/cards/scavenger_2.jpg",
			SCAVENGER_3 : "drow/cards/scavenger_3.jpg",
			SCAVENGER_4 : "drow/cards/scavenger_3.jpg",
			RANGER_1 : "drow/cards/range_1.jpg",
			RANGER_2 : "drow/cards/range_2.jpg",
			RANGER_3 : "drow/cards/range_3.jpg",
			RANGER_4 : "drow/cards/range_3.jpg",
			HEALER_1 : "drow/cards/healer_1.jpg",
			HEALER_2 : "drow/cards/healer_2.jpg",
			HEALER_3 : "drow/cards/healer_3.jpg",
			HEALER_4 : "drow/cards/healer_3.jpg",
			MINER_1 : "drow/cards/miner_1.jpg",
			MINER_2 : "drow/cards/miner_2.jpg",
			MINER_3 : "drow/cards/miner_3.jpg",
			MINER_4 : "drow/cards/miner_3.jpg",
			CAVALRY_1 : "drow/cards/cavalry_1.jpg",
			CAVALRY_2 : "drow/cards/cavalry_2.jpg",
			CAVALRY_3 : "drow/cards/cavalry_3.jpg",
			CAVALRY_4 : "drow/cards/cavalry_3.jpg",
			FLYER_1 : "drow/cards/flyer_1.jpg",
			FLYER_2 : "drow/cards/flyer_2.jpg",
			FLYER_3 : "drow/cards/flyer_3.jpg",
			FLYER_4 : "drow/cards/flyer_3.jpg",
			MAGE_1 : "drow/cards/mage_1.jpg",
			MAGE_2 : "drow/cards/mage_2.jpg",
			MAGE_3 : "drow/cards/mage_3.jpg",
			MAGE_4 : "drow/cards/mage_3.jpg",

			TOWER : "drow/cards/tower.jpg",
			MAGIC_TOWER : "drow/cards/mag_tower.jpg",
			TOWER_MINI : "drow/cards/tower_mini.jpg",
			MAGIC_TOWER_MINI : "drow/cards/mag_tower_mini.jpg",

			MERCHANT_1 : "drow/cards/civil/merchant_1.jpg",
			SETTLER_1 : "drow/cards/civil/colonizer_1.jpg",
			SPY_1 : "drow/cards/civil/spy.jpg",
			ANTISPY_1 : "drow/cards/civil/antispy.jpg",
			EXPEDITOR_1 : "drow/cards/civil/Expeditor.jpg",
			PROPHET_1 : "drow/cards/civil/prophet.jpg",
			MIRROR_1 : "drow/cards/civil/mirror.jpg",

			BACK_HERO : "drow/cards/back_hero.jpg",

			ADVISOR : "drow/advisor.png",
			ADVISOR_NY : "drow/ny_advisor.png",
			ADVISOR_ANIMATED : "drow/advisor.png",
			ADVISOR_ANIMATED_NY : "drow/ny_advisor.png"
		}
	},

	Elf :
	{
		Buildings :
		{
			CITYHALL_0 : "elf/buildings/cityhall_0.png",
			CITYHALL_1 : "elf/buildings/cityhall_1.png",
			CITYHALL_2 : "elf/buildings/cityhall_2.png",
			CITYHALL_3 : "elf/buildings/cityhall_3.png",
			CITYHALL_4 : "elf/buildings/cityhall_4.png",
			CITYHALL_5 : "elf/buildings/cityhall_5.png",
			CITYHALL_NY_0 : "elf/buildings/ny_cityhall_0.png",
			CITYHALL_NY_1 : "elf/buildings/ny_cityhall_1.png",
			CITYHALL_NY_2 : "elf/buildings/ny_cityhall_2.png",
			CITYHALL_NY_3 : "elf/buildings/ny_cityhall_3.png",
			CITYHALL_NY_4 : "elf/buildings/ny_cityhall_4.png",
			CITYHALL_NY_5 : "elf/buildings/ny_cityhall_5.png",

			// buildings
			HOUSES : "elf/buildings/houses.png",
			WAREHOUSE : "elf/buildings/warehouse.png",
			CLAN_RESERVATION : "elf/buildings/clan_reservation.png",
			CLAN_WAREHOUSE : "elf/buildings/clan_warehouse.png",
			MARKET : "elf/buildings/other/market.png",
			EXPEDITION : "elf/buildings/other/exped.png",
			ALCHEMIST : "elf/buildings/alchemist.png",
			// buildings: mining
			MINE_IRON : "elf/buildings/mine_iron.png",
			MINE_STONE : "elf/buildings/mine_stone.png",
			MINE_GOLD : "elf/buildings/mine_gold.png",
			SAWMILL : "elf/buildings/sawmill.png",
			WINDMILL : "elf/buildings/windmill.png",
			SHOP : "elf/buildings/shop.png",
			RECOVERY : "elf/buildings/recovery.png",
			TERRAFORMER : "elf/buildings/terraformer.png",
			// buildings: defence
			TOWER : "elf/buildings/tower.png",
			FORTIFICATION : "elf/buildings/fortification.png",
			MAGIC_TOWER : "elf/buildings/magic_tower.png",
			// buildings: military
			MELEE : "elf/buildings/military/melee.png",
			SCAVENGER : "elf/buildings/military/scavenger.png",
			RANGER : "elf/buildings/military/range.png",
			HEALER : "elf/buildings/military/healer.png",
			MINER : "elf/buildings/military/miner.png",
			CAVALRY : "elf/buildings/military/cavalry.png",
			FLYER : "elf/buildings/military/flyer.png",
			MAGE : "elf/buildings/military/mage.png",

			// special
			MERCHANT : "elf/buildings/other/merch_guild.png",
			SETTLER : "elf/buildings/other/colony.png",
			SPYGUILD : "elf/buildings/other/spy_guild.png",
			ANTISPYGUILD : "elf/buildings/other/antispy_guild.png",
			DIPLOMAT : "elf/buildings/other/diplomat.png",
			DIPLOMAT_BLINK : "elf/buildings/other/diplomat_blink.png",
			TAVERN_BLINK : "elf/buildings/other/tavern_blink.png",
			PROPHET_TOWER : "elf/buildings/other/watch_tower.png",
			MIRROR_TOWER : "elf/buildings/other/antiwatch_tower.png",

			TEMPLE : "elf/buildings/other/temple.png",
			RESURRECTOR : "elf/buildings/other/resurrector.png",

			TAVERN : "elf/buildings/other/tavern.png",
			ARTIFACT_STORE : "elf/buildings/other/artefacts.png",
			PRISON : "elf/buildings/other/prison.png"
		},

		Specific :
		{
			//
			CELL_COBBLES : "elf/cobbles.png",
			PEOPLE_ALL : "elf/people_all.png",
			PEOPLE_BUSY : "elf/people_busy.png",
			PEOPLE_FREE : "elf/people_free.png",

			// walls
			WALL_01 : "elf/wall/wall_01.png",
			WALL_12 : "elf/wall/wall_12.png",
			WALL_23 : "elf/wall/wall_23.png",
			WALL_34 : "elf/wall/wall_34.png",
			WALL_45 : "elf/wall/wall_45.png",
			WALL_50 : "elf/wall/wall_50.png",
			WALL_23_OPEN : "elf/wall/wall_23_open.png",
			WALL_23_CLOSED : "elf/wall/wall_23_closed.png",
			WALL_23_OPEN_BROKEN : "elf/wall/wall_23_open_broken.png"
		},

		Cards :
		{
			// unit cards
			BACK : "elf/cards/back.png",
			BACK_MINI : "elf/cards/back_mini.jpg",

			MELEE_1 : "elf/cards/melee_1.jpg",
			MELEE_2 : "elf/cards/melee_2.jpg",
			MELEE_3 : "elf/cards/melee_3.jpg",
			MELEE_4 : "elf/cards/melee_3.jpg",
			SCAVENGER_1 : "elf/cards/scavenger_1.jpg",
			SCAVENGER_2 : "elf/cards/scavenger_2.jpg",
			SCAVENGER_3 : "elf/cards/scavenger_3.jpg",
			SCAVENGER_4 : "elf/cards/scavenger_3.jpg",
			RANGER_1 : "elf/cards/range_1.jpg",
			RANGER_2 : "elf/cards/range_2.jpg",
			RANGER_3 : "elf/cards/range_3.jpg",
			RANGER_4 : "elf/cards/range_3.jpg",
			HEALER_1 : "elf/cards/healer_1.jpg",
			HEALER_2 : "elf/cards/healer_2.jpg",
			HEALER_3 : "elf/cards/healer_3.jpg",
			HEALER_4 : "elf/cards/healer_3.jpg",
			MINER_1 : "elf/cards/miner_1.jpg",
			MINER_2 : "elf/cards/miner_2.jpg",
			MINER_3 : "elf/cards/miner_3.jpg",
			MINER_4 : "elf/cards/miner_3.jpg",
			CAVALRY_1 : "elf/cards/cavalry_1.jpg",
			CAVALRY_2 : "elf/cards/cavalry_2.jpg",
			CAVALRY_3 : "elf/cards/cavalry_3.jpg",
			CAVALRY_4 : "elf/cards/cavalry_3.jpg",
			FLYER_1 : "elf/cards/flyer_1.jpg",
			FLYER_2 : "elf/cards/flyer_2.jpg",
			FLYER_3 : "elf/cards/flyer_3.jpg",
			FLYER_4 : "elf/cards/flyer_3.jpg",
			MAGE_1 : "elf/cards/mage_1.jpg",
			MAGE_2 : "elf/cards/mage_2.jpg",
			MAGE_3 : "elf/cards/mage_3.jpg",
			MAGE_4 : "elf/cards/mage_3.jpg",

			TOWER : "elf/cards/tower.jpg",
			MAGIC_TOWER : "elf/cards/mag_tower.jpg",
			TOWER_MINI : "elf/cards/tower_mini.jpg",
			MAGIC_TOWER_MINI : "elf/cards/mag_tower_mini.jpg",

			MERCHANT_1 : "elf/cards/civil/merchant_1.jpg",
			SETTLER_1 : "elf/cards/civil/colonizer_1.jpg",
			SPY_1 : "elf/cards/civil/spy.jpg",
			ANTISPY_1 : "elf/cards/civil/antispy.jpg",
			EXPEDITOR_1 : "elf/cards/civil/Expeditor.jpg",
			PROPHET_1 : "elf/cards/civil/prophet.jpg",
			MIRROR_1 : "elf/cards/civil/mirror.jpg",

			BACK_HERO : "elf/cards/back_hero.jpg",

			ADVISOR : "elf/advisor.png",
			ADVISOR_NY : "elf/ny_advisor.png",
			ADVISOR_ANIMATED : "elf/advisor.png",
			ADVISOR_ANIMATED_NY : "elf/ny_advisor.png"
		}
	},

	Human :
	{
		Buildings :
		{
			CITYHALL_0 : "human/buildings/cityhall_0.png",
			CITYHALL_1 : "human/buildings/cityhall_1.png",
			CITYHALL_2 : "human/buildings/cityhall_2.png",
			CITYHALL_3 : "human/buildings/cityhall_3.png",
			CITYHALL_4 : "human/buildings/cityhall_4.png",
			CITYHALL_5 : "human/buildings/cityhall_5.png",
			CITYHALL_NY_0 : "human/buildings/ny_cityhall_0.png",
			CITYHALL_NY_1 : "human/buildings/ny_cityhall_1.png",
			CITYHALL_NY_2 : "human/buildings/ny_cityhall_2.png",
			CITYHALL_NY_3 : "human/buildings/ny_cityhall_3.png",
			CITYHALL_NY_4 : "human/buildings/ny_cityhall_4.png",
			CITYHALL_NY_5 : "human/buildings/ny_cityhall_5.png",
			// buildings
			HOUSES : "human/buildings/houses.png",
			WAREHOUSE : "human/buildings/warehouse.png",
			CLAN_RESERVATION : "human/buildings/clan_reservation.png",
			CLAN_WAREHOUSE : "human/buildings/clan_warehouse.png",
			MARKET : "human/buildings/other/market.png",
			EXPEDITION : "human/buildings/other/exped.png",
			ALCHEMIST : "human/buildings/alchemist.png",
			// buildings: mining
			MINE_IRON : "human/buildings/mine_iron.png",
			MINE_STONE : "human/buildings/mine_stone.png",
			MINE_GOLD : "human/buildings/mine_gold.png",
			SAWMILL : "human/buildings/sawmill.png",
			WINDMILL : "human/buildings/windmill.png",
			SHOP : "human/buildings/shop.png",
			RECOVERY : "human/buildings/recovery.png",
			TERRAFORMER : "human/buildings/terraformer.png",
			// buildings: defence
			TOWER : "human/buildings/tower.png",
			FORTIFICATION : "human/buildings/fortification.png",
			MAGIC_TOWER : "human/buildings/magic_tower.png",
			// buildings: military
			MELEE : "human/buildings/military/melee.png",
			SCAVENGER : "human/buildings/military/scavenger.png",
			RANGER : "human/buildings/military/range.png",
			HEALER : "human/buildings/military/healer.png",
			MINER : "human/buildings/military/miner.png",
			CAVALRY : "human/buildings/military/cavalry.png",
			FLYER : "human/buildings/military/flyer.png",
			MAGE : "human/buildings/military/mage.png",

			// special
			MERCHANT : "human/buildings/other/merch_guild.png",
			SETTLER : "human/buildings/other/colony.png",
			SPYGUILD : "human/buildings/other/spy_guild.png",
			ANTISPYGUILD : "human/buildings/other/antispy_guild.png",
			DIPLOMAT : "human/buildings/other/diplomat.png",
			DIPLOMAT_BLINK : "human/buildings/other/diplomat_blink.png",
			TAVERN_BLINK : "human/buildings/other/tavern_blink.png",
			PROPHET_TOWER : "human/buildings/other/watch_tower.png",
			MIRROR_TOWER : "human/buildings/other/antiwatch_tower.png",

			TEMPLE : "human/buildings/other/temple.png",
			RESURRECTOR : "human/buildings/other/resurrector.png",

			TAVERN : "human/buildings/other/tavern.png",
			ARTIFACT_STORE : "human/buildings/other/artefacts.png",
			PRISON : "human/buildings/other/prison.png"
		},

		Specific :
		{
			//
			CELL_COBBLES : "human/cobbles.png",
			PEOPLE_ALL : "human/people_all.png",
			PEOPLE_BUSY : "human/people_busy.png",
			PEOPLE_FREE : "human/people_free.png",

			// walls
			WALL_01 : "human/wall/wall_01.png",
			WALL_12 : "human/wall/wall_12.png",
			WALL_23 : "human/wall/wall_23.png",
			WALL_34 : "human/wall/wall_34.png",
			WALL_45 : "human/wall/wall_45.png",
			WALL_50 : "human/wall/wall_50.png",
			WALL_23_OPEN : "human/wall/wall_23_open.png",
			WALL_23_CLOSED : "human/wall/wall_23_closed.png",
			WALL_23_OPEN_BROKEN : "human/wall/wall_23_open_broken.png"
		},

		Cards :
		{
			// unit cards
			BACK : "human/cards/back.png",
			BACK_MINI : "human/cards/back_mini.jpg",

			MELEE_1 : "human/cards/melee_1.jpg",
			MELEE_2 : "human/cards/melee_2.jpg",
			MELEE_3 : "human/cards/melee_3.jpg",
			MELEE_4 : "human/cards/melee_3.jpg",
			SCAVENGER_1 : "human/cards/scavenger_1.jpg",
			SCAVENGER_2 : "human/cards/scavenger_2.jpg",
			SCAVENGER_3 : "human/cards/scavenger_3.jpg",
			SCAVENGER_4 : "human/cards/scavenger_3.jpg",
			RANGER_1 : "human/cards/range_1.jpg",
			RANGER_2 : "human/cards/range_2.jpg",
			RANGER_3 : "human/cards/range_3.jpg",
			RANGER_4 : "human/cards/range_3.jpg",
			HEALER_1 : "human/cards/healer_1.jpg",
			HEALER_2 : "human/cards/healer_2.jpg",
			HEALER_3 : "human/cards/healer_3.jpg",
			HEALER_4 : "human/cards/healer_3.jpg",
			MINER_1 : "human/cards/miner_1.jpg",
			MINER_2 : "human/cards/miner_2.jpg",
			MINER_3 : "human/cards/miner_3.jpg",
			MINER_4 : "human/cards/miner_3.jpg",
			CAVALRY_1 : "human/cards/cavalry_1.jpg",
			CAVALRY_2 : "human/cards/cavalry_2.jpg",
			CAVALRY_3 : "human/cards/cavalry_3.jpg",
			CAVALRY_4 : "human/cards/cavalry_3.jpg",
			FLYER_1 : "human/cards/flyer_1.jpg",
			FLYER_2 : "human/cards/flyer_2.jpg",
			FLYER_3 : "human/cards/flyer_3.jpg",
			FLYER_4 : "human/cards/flyer_3.jpg",
			MAGE_1 : "human/cards/mage_1.jpg",
			MAGE_2 : "human/cards/mage_2.jpg",
			MAGE_3 : "human/cards/mage_3.jpg",
			MAGE_4 : "human/cards/mage_3.jpg",

			TOWER : "human/cards/tower.jpg",
			MAGIC_TOWER : "human/cards/mag_tower.jpg",
			TOWER_MINI : "human/cards/tower_mini.jpg",
			MAGIC_TOWER_MINI : "human/cards/mag_tower_mini.jpg",

			MERCHANT_1 : "human/cards/civil/merchant_1.jpg",
			SETTLER_1 : "human/cards/civil/colonizer_1.jpg",
			SPY_1 : "human/cards/civil/spy.jpg",
			ANTISPY_1 : "human/cards/civil/antispy.jpg",
			EXPEDITOR_1 : "human/cards/civil/Expeditor.jpg",
			PROPHET_1 : "human/cards/civil/prophet.jpg",
			MIRROR_1 : "human/cards/civil/mirror.jpg",

			BACK_HERO : "human/cards/back_hero.jpg",

			ADVISOR : "human/advisor.png",
			ADVISOR_NY : "human/ny_advisor.png",
			ADVISOR_ANIMATED : "human/advisor.png",
			ADVISOR_ANIMATED_NY : "human/ny_advisor.png"
		}
	},

	Monster :
	{
		Buildings :
		{
			CASTLEHALL_0 : "monsters/buildings/castlehall_0.png",
			CASTLEHALL_1 : "monsters/buildings/castlehall_1.png",
			CASTLEHALL_2 : "monsters/buildings/castlehall_2.png",
			CASTLEHALL_3 : "monsters/buildings/castlehall_3.png",
			CASTLEHALL_4 : "monsters/buildings/castlehall_4.png",
			CASTLEHALL_5 : "monsters/buildings/castlehall_5.png",
			// buildings
			HOUSES : "monsters/buildings/houses.png",
			WAREHOUSE : "monsters/buildings/warehouse.png",
			CLAN_RESERVATION : "monsters/buildings/clan_reservation.png",
			CLAN_WAREHOUSE : "monsters/buildings/clan_warehouse.png",
			CASTLEGATE : "monsters/buildings/castle_gate.png",
			CASTLEGATE_EMPTY : "monsters/buildings/castle_gate_empty.png",
			MARKET : "monsters/buildings/other/market.png",
			// buildings: defence
			TOWER : "monsters/buildings/tower.png",
			FORTIFICATION : "monsters/buildings/fortification.png",
			MAGIC_TOWER : "monsters/buildings/magic_tower.png",
			// buildings: military
			MELEE : "monsters/buildings/military/melee.png",
			SCAVENGER : "monsters/buildings/military/scavenger.png",
			RANGER : "monsters/buildings/military/range.png",
			HEALER : "monsters/buildings/military/healer.png",
			MINER : "monsters/buildings/military/miner.png",
			CAVALRY : "monsters/buildings/military/cavalry.png",
			FLYER : "monsters/buildings/military/flyer.png",
			MAGE : "monsters/buildings/military/mage.png",

			// special
			ANTISPYGUILD : "monsters/buildings/other/antispy_guild.png",
			CLAN_DIPLOMAT : "monsters/buildings/other/diplomat.png",
			MIRROR_TOWER : "monsters/buildings/other/antiwatch_tower.png",
			ARENA : "monsters/buildings/other/arena.png",
			RESURRECTOR : "monsters/buildings/other/resurrector.png",
			WORKSHOP : "monsters/buildings/workshop.png"
		},

		Specific :
		{
			//
			CELL_COBBLES : "monsters/cobbles.png",
			PEOPLE_ALL : "monsters/people_all.png",
			PEOPLE_BUSY : "monsters/people_busy.png",
			PEOPLE_FREE : "monsters/people_free.png",

			// walls
			WALL_01 : "monsters/wall/wall_01.png",
			WALL_12 : "monsters/wall/wall_12.png",
			WALL_23 : "monsters/wall/wall_23.png",
			WALL_34 : "monsters/wall/wall_34.png",
			WALL_45 : "monsters/wall/wall_45.png",
			WALL_50 : "monsters/wall/wall_50.png"
		},

		Cards :
		{
			// unit cards
			BACK : "monsters/cards/back.png",
			BACK_MINI : "monsters/cards/back_mini.jpg",

			MELEE_1 : "monsters/cards/melee_1.jpg",
			MELEE_2 : "monsters/cards/melee_2.jpg",
			MELEE_3 : "monsters/cards/melee_3.jpg",
			MELEE_4 : "monsters/cards/melee_3.jpg",
			SCAVENGER_1 : "monsters/cards/scavenger_1.jpg",
			SCAVENGER_2 : "monsters/cards/scavenger_2.jpg",
			SCAVENGER_3 : "monsters/cards/scavenger_3.jpg",
			SCAVENGER_4 : "monsters/cards/scavenger_3.jpg",
			RANGER_1 : "monsters/cards/range_1.jpg",
			RANGER_2 : "monsters/cards/range_2.jpg",
			RANGER_3 : "monsters/cards/range_3.jpg",
			RANGER_4 : "monsters/cards/range_3.jpg",
			HEALER_1 : "monsters/cards/healer_1.jpg",
			HEALER_2 : "monsters/cards/healer_2.jpg",
			HEALER_3 : "monsters/cards/healer_3.jpg",
			HEALER_4 : "monsters/cards/healer_3.jpg",
			MINER_1 : "monsters/cards/miner_1.jpg",
			MINER_2 : "monsters/cards/miner_2.jpg",
			MINER_3 : "monsters/cards/miner_3.jpg",
			MINER_4 : "monsters/cards/miner_3.jpg",
			CAVALRY_1 : "monsters/cards/cavalry_1.jpg",
			CAVALRY_2 : "monsters/cards/cavalry_2.jpg",
			CAVALRY_3 : "monsters/cards/cavalry_3.jpg",
			CAVALRY_4 : "monsters/cards/cavalry_3.jpg",
			FLYER_1 : "monsters/cards/flyer_1.jpg",
			FLYER_2 : "monsters/cards/flyer_2.jpg",
			FLYER_3 : "monsters/cards/flyer_3.jpg",
			FLYER_4 : "monsters/cards/flyer_3.jpg",
			MAGE_1 : "monsters/cards/mage_1.jpg",
			MAGE_2 : "monsters/cards/mage_2.jpg",
			MAGE_3 : "monsters/cards/mage_3.jpg",
			MAGE_4 : "monsters/cards/mage_3.jpg",

			BACK_HERO : "monsters/cards/back_hero.jpg",

			MERCHANT_1 : "monsters/cards/civil/merchant_1.jpg",
			ANTISPY_1 : "monsters/cards/civil/antispy.jpg",
			MIRROR_1 : "monsters/cards/civil/mirror.jpg",

			TOWER : "monsters/cards/tower.jpg",
			MAGIC_TOWER : "monsters/cards/mag_tower.jpg",
			CASTLEGATE : "monsters/cards/castlegate.jpg",
			TOWER_MINI : "monsters/cards/tower_mini.jpg",
			MAGIC_TOWER_MINI : "monsters/cards/mag_tower_mini.jpg",
			CATAPULT_1 : "monsters/cards/catapult.jpg"
		}
	},

	OuterBuildings :
	{
		PITHALL : "shared/city/mine/pit_hall.png",
		MINEHALL_GOLD : "shared/city/mine/gold_hall.png",
		MINEHALL_STONE : "shared/city/mine/stone_hall.png",
		MINEHALL_IRON : "shared/city/mine/iron_hall.png",
		RUINHALL : "shared/city/mine/ruin_hall.png",

		EVILHALL : "shared/city/mine/evil_hall.png",
		EVILHALL_NY : "shared/city/mine/ny_evil_hall.png",

		ABANDONED_MERCHANT : "shared/city/mine/abandoned_guild.png",

		PIT_GATE_CLOSED : "shared/city/mine/mine_gate_closed.png",
		PIT_GATE_OPEN : "shared/city/mine/mine_gate_open.png",

		LAKEHALL : "shared/city/mine/lake_hall.png",
		CAMPHALL : "shared/city/mine/camp_hall.png",
		GROTTOHALL : "shared/city/mine/grotto_hall.png",
		
		GRAILHALL : "shared/city/mine/grail_hall.png",
		STONEHENGEHALL : "shared/city/mine/stonehenge_hall.png",
		CATAPULTHALL : "shared/city/mine/catapult_hall.png"
	},

	Heroes :
	{
		'HERO_BORDER' : 'shared/heroes/hero_border.png',
		'HERO_SLOT' : 'shared/heroes/hero_slot.png',

		'BUTTON_DOWN' : 'shared/heroes/hero_button_down.png',
		'BUTTON_UP' : 'shared/heroes/hero_button_up.png',
		'BUTTON_RIGHT' : 'shared/heroes/hero_button_right.png',
		'BUTTON_LEFT' : 'shared/heroes/hero_button_left.png',

		'MAGIC_ANIMATION' : 'shared/heroes/magic.swf',

		'CAST_ARROW_UP' : 'shared/heroes/cast_arrow_up.png',
		'CAST_ARROW_DOWN' : 'shared/heroes/cast_arrow_down.png',
		'CAST_ARROW_LEFT' : 'shared/heroes/cast_arrow_left.png',
		'CAST_ARROW_RIGHT' : 'shared/heroes/cast_arrow_right.png',

		'UPSET_HERO' : 'shared/heroes/upset_hero.png',

		'HERO_BACK_DEMON' : 'shared/heroes/faces/back_demon.png',
		'HERO_BACK_DROW' : 'shared/heroes/faces/back_drow.png',
		'HERO_BACK_ELF' : 'shared/heroes/faces/back_elf.png',
		'HERO_BACK_HUMAN' : 'shared/heroes/faces/back_human.png',
		'HERO_BACK_MONSTER' : 'shared/heroes/faces/back_human.png',
		'HERO_FACE_ANIM' : 'shared/heroes/hero_face_anim.swf',

		'MINER_FEMALE' : 'shared/heroes/faces/MINER_FEMALE.png',
		'TRUEVISOR_FEMALE' : 'shared/heroes/faces/TRUEVISOR_FEMALE.png',
		'ILLUSIONIST_FEMALE' : 'shared/heroes/faces/ILLUSIONIST_FEMALE.png',
		'GURU_MALE' : 'shared/heroes/faces/GURU_MALE.png',
		'BUILDER_MALE' : 'shared/heroes/faces/BUILDER_MALE.png',
		'CLERIC_MALE' : 'shared/heroes/faces/CLERIC_MALE.png',
		'DEFENDER_MALE' : 'shared/heroes/faces/DEFENDER_MALE.png',
		'BOMBERMAN_FEMALE' : 'shared/heroes/faces/BOMBERMAN_FEMALE.png',
		'GURU_FEMALE' : 'shared/heroes/faces/GURU_FEMALE.png',
		'DEFENDER_FEMALE' : 'shared/heroes/faces/DEFENDER_FEMALE.png',
		'ILLUSIONIST_MALE' : 'shared/heroes/faces/ILLUSIONIST_MALE.png',
		'SCOUT_FEMALE' : 'shared/heroes/faces/SCOUT_FEMALE.png',
		'NECROMANT_FEMALE' : 'shared/heroes/faces/NECROMANT_FEMALE.png',
		'SABOTEUR_MALE' : 'shared/heroes/faces/SABOTEUR_MALE.png',
		'TRUEVISOR_MALE' : 'shared/heroes/faces/TRUEVISOR_MALE.png',
		'SCOUT_MALE' : 'shared/heroes/faces/SCOUT_MALE.png',
		'ENGEE_GOOD2' : 'shared/heroes/faces/ENGEE_GOOD2.png',
		'PALADIN_FEMALE' : 'shared/heroes/faces/PALADIN_FEMALE.png',
		'WARRIOR_MALE' : 'shared/heroes/faces/WARRIOR_MALE.png',
		'SABOTEUR_FEMALE' : 'shared/heroes/faces/SABOTEUR_FEMALE.png',
		'MERCH_BAD1' : 'shared/heroes/faces/MERCH_BAD1.png',
		'TRADER_MALE' : 'shared/heroes/faces/TRADER_MALE.png',
		'TRADER_FEMALE' : 'shared/heroes/faces/TRADER_FEMALE.png',
		'CLERIC_FEMALE' : 'shared/heroes/faces/CLERIC_FEMALE.png',
		'BOMBERMAN_MALE' : 'shared/heroes/faces/BOMBERMAN_MALE.png',
		'WARRIOR_FEMALE' : 'shared/heroes/faces/WARRIOR_FEMALE.png',
		'BATTLE_MAGE_FEMALE' : 'shared/heroes/faces/BATTLE_MAGE_FEMALE.png',
		'BUILDER_FEMALE' : 'shared/heroes/faces/BUILDER_FEMALE.png',
		'NECROMANT_MALE' : 'shared/heroes/faces/NECROMANT_MALE.png',
		'MINER_MALE' : 'shared/heroes/faces/MINER_MALE.png',
		'PALADIN_MALE' : 'shared/heroes/faces/PALADIN_MALE.png',
		'BATTLE_MAGE_MALE' : 'shared/heroes/faces/BATTLE_MAGE_MALE.png',
		'PEACEMAKER_MALE' : 'shared/heroes/faces/PEACEMAKER_MALE.png',
		'PEACEMAKER_FEMALE' : 'shared/heroes/faces/PEACEMAKER_FEMALE.png',
		'JUGGERNAUT_MALE' : 'shared/heroes/faces/JUGGERNAUT_MALE.png',
		'JUGGERNAUT_FEMALE' : 'shared/heroes/faces/JUGGERNAUT_FEMALE.png',
		'WARLOCK_MALE' : 'shared/heroes/faces/WARLOCK_MALE.png',
		'WARLOCK_FEMALE' : 'shared/heroes/faces/WARLOCK_FEMALE.png',
		'HOLDER_MALE' : 'shared/heroes/faces/HOLDER_MALE.png',
		'HOLDER_FEMALE' : 'shared/heroes/faces/HOLDER_FEMALE.png',

		//autogenerated text goes here
//autogenerated text goes here

	    //CASTS
	    'CAST_AGGRORUINS_1_CAST': "shared/heroes/casts/aggroruins_1_cast.png",
	    'CAST_AGGRORUINS_2_CAST': "shared/heroes/casts/aggroruins_2_cast.png",
	    'CAST_ALCHEMIST': "shared/heroes/casts/alchemist.png",
	    'CAST_ALCH_ARTUPGRADE_2_CAST': "shared/heroes/casts/alch_artupgrade_2_cast.png",
	    'CAST_ALCH_BUILD_1_CAST': "shared/heroes/casts/alch_build_1_cast.png",
	    'CAST_ALCH_BUILD_3_CAST': "shared/heroes/casts/alch_build_3_cast.png",
	    'CAST_ANABIOZ': "shared/heroes/casts/anabioz.png",
	    'CAST_ANGEL5_CHEST': "shared/heroes/casts/angel5_chest.png",
	    'CAST_ANGEL5_HEAD': "shared/heroes/casts/angel5_head.png",
	    'CAST_ANGEL5_ITEM': "shared/heroes/casts/angel5_item.png",
	    'CAST_ANGEL5_LEFT_HAND': "shared/heroes/casts/angel5_left_hand.png",
	    'CAST_ANGEL5_RIGHT_HAND': "shared/heroes/casts/angel5_right_hand.png",
	    'CAST_ANTIMAGIYA': "shared/heroes/casts/antimagiya.png",
	    'CAST_ARABIAN2_CHEST': "shared/heroes/casts/arabian2_chest.png",
	    'CAST_ARABIAN2_HEAD': "shared/heroes/casts/arabian2_head.png",
	    'CAST_ARABIAN2_LEFT_HAND': "shared/heroes/casts/arabian2_left_hand.png",
	    'CAST_ARABIAN2_NECK': "shared/heroes/casts/arabian2_neck.png",
	    'CAST_ARABIAN2_RIGHT_HAND': "shared/heroes/casts/arabian2_right_hand.png",
	    'CAST_ARBALET4_CHEST': "shared/heroes/casts/arbalet4_chest.png",
	    'CAST_ARBALET4_FINGER': "shared/heroes/casts/arbalet4_finger.png",
	    'CAST_ARBALET4_HEAD': "shared/heroes/casts/arbalet4_head.png",
	    'CAST_ARBALET4_LEFT_HAND': "shared/heroes/casts/arbalet4_left_hand.png",
	    'CAST_ARCHER2_CHEST': "shared/heroes/casts/archer2_chest.png",
	    'CAST_ARCHER2_FINGER': "shared/heroes/casts/archer2_finger.png",
	    'CAST_ARCHER2_HEAD': "shared/heroes/casts/archer2_head.png",
	    'CAST_ARCHER2_ITEM': "shared/heroes/casts/archer2_item.png",
	    'CAST_ARCHER2_LEFT_HAND': "shared/heroes/casts/archer2_left_hand.png",
	    'CAST_ARCHER2_NECK': "shared/heroes/casts/archer2_neck.png",
	    'CAST_ARENA': "shared/heroes/casts/arena.png",
	    'CAST_ARMAGEDDON': "shared/heroes/casts/armageddon.png",
	    'CAST_ARMAGEDDON_CASTLE': "shared/heroes/casts/armageddon_castle.png",
	    'CAST_ARTEFAKTHANTER': "shared/heroes/casts/artefakthanter.png",
		'CAST_ARTIFACT_CHANCE': "shared/heroes/casts/artifact_chance.png",
	    'CAST_ARTIFACT_HUNTER': "shared/heroes/casts/artifact_hunter.png",
	    'CAST_ASASSIN2_FINGER': "shared/heroes/casts/asassin2_finger.png",
	    'CAST_ASASSIN2_HEAD': "shared/heroes/casts/asassin2_head.png",
	    'CAST_ASASSIN2_ITEM': "shared/heroes/casts/asassin2_item.png",
	    'CAST_ASASSIN2_LEFT_HAND': "shared/heroes/casts/asassin2_left_hand.png",
	    'CAST_ASASSIN2_RIGHT_HAND': "shared/heroes/casts/asassin2_right_hand.png",
	    'CAST_ASASSIN': "shared/heroes/casts/asassin.png",
	    'CAST_ATTACK': "shared/heroes/casts/attack.png",
	    'CAST_BALLISTA': "shared/heroes/casts/ballista.png",
	    'CAST_BARBARIAN2_CHEST': "shared/heroes/casts/barbarian2_chest.png",
	    'CAST_BARBARIAN2_FINGER': "shared/heroes/casts/barbarian2_finger.png",
	    'CAST_BARBARIAN2_HEAD': "shared/heroes/casts/barbarian2_head.png",
	    'CAST_BARBARIAN2_LEFT_HAND': "shared/heroes/casts/barbarian2_left_hand.png",
	    'CAST_BARBARIAN2_NECK': "shared/heroes/casts/barbarian2_neck.png",
	    'CAST_BARBARIAN2_RIGHT_HAND': "shared/heroes/casts/barbarian2_right_hand.png",
	    'CAST_BARBARIAN': "shared/heroes/casts/barbarian.png",
	    'CAST_BAROBALISTA': "shared/heroes/casts/barobalista.png",
	    'CAST_BEAST2_CHEST': "shared/heroes/casts/beast2_chest.png",
	    'CAST_BEAST2_FINGER': "shared/heroes/casts/beast2_finger.png",
	    'CAST_BEAST2_HEAD': "shared/heroes/casts/beast2_head.png",
	    'CAST_BEAST2_ITEM': "shared/heroes/casts/beast2_item.png",
	    'CAST_BEAST2_LEFT_HAND': "shared/heroes/casts/beast2_left_hand.png",
	    'CAST_BEAST2_NECK': "shared/heroes/casts/beast2_neck.png",
	    'CAST_BEAST2_RIGHT_HAND': "shared/heroes/casts/beast2_right_hand.png",
	    'CAST_BEAST': "shared/heroes/casts/beast.png",
	    'CAST_BEREJNYI_ZAHVAT': "shared/heroes/casts/berejnyi_zahvat.png",
	    'CAST_BESSTRASHIE': "shared/heroes/casts/besstrashie.png",
	    'CAST_BLACK5_CHEST': "shared/heroes/casts/black5_chest.png",
	    'CAST_BLACK5_FINGER': "shared/heroes/casts/black5_finger.png",
	    'CAST_BLACK5_LEFT_HAND': "shared/heroes/casts/black5_left_hand.png",
	    'CAST_BLACK5_NECK': "shared/heroes/casts/black5_neck.png",
	    'CAST_BLACK5_RIGHT_HAND': "shared/heroes/casts/black5_right_hand.png",
	    'CAST_BLACK': "shared/heroes/casts/black.png",
	    'CAST_BLOODY_STEEL3_CHEST': "shared/heroes/casts/bloody_steel3_chest.png",
	    'CAST_BLOODY_STEEL3_FINGER': "shared/heroes/casts/bloody_steel3_finger.png",
	    'CAST_BLOODY_STEEL3_HEAD': "shared/heroes/casts/bloody_steel3_head.png",
	    'CAST_BLOODY_STEEL3_ITEM': "shared/heroes/casts/bloody_steel3_item.png",
	    'CAST_BLOODY_STEEL3_LEFT_HAND': "shared/heroes/casts/bloody_steel3_left_hand.png",
	    'CAST_BLOODY_STEEL3_RIGHT_HAND': "shared/heroes/casts/bloody_steel3_right_hand.png",
	    'CAST_BP_ARMOR_HERO_BOOST_1_CAST': "shared/heroes/casts/bp_armor_hero_boost_1_cast.png",
	    'CAST_BP_ARMOR_HERO_BOOST_2_CAST': "shared/heroes/casts/bp_armor_hero_boost_2_cast.png",
	    'CAST_BP_ARMOR_HERO_BOOST_3_CAST': "shared/heroes/casts/bp_armor_hero_boost_3_cast.png",
	    'CAST_BP_ARMYNOEAT_1_CAST': "shared/heroes/casts/bp_armynoeat_1_cast.png",
	    'CAST_BP_ARMY_BOOST_1_CAST': "shared/heroes/casts/bp_army_boost_1_cast.png",
	    'CAST_BP_ARMY_BOOST_2_CAST': "shared/heroes/casts/bp_army_boost_2_cast.png",
	    'CAST_BP_ARMY_BOOST_3_CAST': "shared/heroes/casts/bp_army_boost_3_cast.png",
	    'CAST_BP_ARMY_BOOST_4_CAST': "shared/heroes/casts/bp_army_boost_4_cast.png",
	    'CAST_BP_ARMY_BOOST_5_CAST': "shared/heroes/casts/bp_army_boost_5_cast.png",
	    'CAST_BP_ARMY_STRANGELOOK_1_CAST': "shared/heroes/casts/bp_army_strangelook_1_cast.png",
        'CAST_BP_CATAPULT_3_CAST': "shared/heroes/casts/bp_catapult_3_cast.png",
	    'CAST_BP_HEROLVLUP_HELP_4_CAST': "shared/heroes/casts/bp_herolvlup_help_4_cast.png",
	    'CAST_BP_HEROSKILL_BOOST_1_CAST': "shared/heroes/casts/bp_heroskill_boost_1_cast.png",
	    'CAST_BP_HEROSKILL_BOOST_2_CAST': "shared/heroes/casts/bp_heroskill_boost_2_cast.png",
	    'CAST_BP_HEROSKILL_BOOST_3_CAST': "shared/heroes/casts/bp_heroskill_boost_3_cast.png",
	    'CAST_BP_HEROWAR_HELP_2_CAST': "shared/heroes/casts/bp_herowar_help_2_cast.png",
	    'CAST_BP_HEROWAR_HELP_3_CAST': "shared/heroes/casts/bp_herowar_help_3_cast.png",
	    'CAST_BP_HERO_EXPBOOST_1_CAST': "shared/heroes/casts/bp_hero_expboost_1_cast.png",
	    'CAST_BP_PRISON_BOOST_1_CAST': "shared/heroes/casts/bp_prison_boost_1_cast.png",
	    'CAST_BP_PRISON_BOOST_2_CAST': "shared/heroes/casts/bp_prison_boost_2_cast.png",
	    'CAST_BP_RESOURCES_BOOST_1_CAST': "shared/heroes/casts/bp_resources_boost_1_cast.png",
	    'CAST_BP_RESOURCES_BOOST_2_CAST': "shared/heroes/casts/bp_resources_boost_2_cast.png",
	    'CAST_BP_UNIT_BOOST_1_CAST': "shared/heroes/casts/bp_unit_boost_1_cast.png",
	    'CAST_BP_UNIT_BOOST_2_CAST': "shared/heroes/casts/bp_unit_boost_2_cast.png",
	    'CAST_BP_UNIT_BOOST_3_CAST': "shared/heroes/casts/bp_unit_boost_3_cast.png",
	    'CAST_BP_UNIT_BOOST_4_CAST': "shared/heroes/casts/bp_unit_boost_4_cast.png",
	    'CAST_BRIKOL': "shared/heroes/casts/brikol.png",
	    'CAST_BRIKOL_CASTLE': "shared/heroes/casts/brikol_castle.png",
	    'CAST_BRODYACHIE_DUHI': "shared/heroes/casts/brodyachie_duhi.png",
	    'CAST_CAMP_MERCHANTS': "shared/heroes/casts/camp_merchants.png",
	    'CAST_CASTLE_ASSIST_HEALTH': "shared/heroes/casts/castle_assist_health.png",
	    'CAST_CASTLE_ATTACK': "shared/heroes/casts/castle_attack.png",
	    'CAST_CASTLE_BUILD_QUEUE': "shared/heroes/casts/castle_build_queue.png",
	    'CAST_CASTLE_GATE_DEFENSE': "shared/heroes/casts/castle_gate_defense.png",
	    'CAST_CASTLE_MAX_DEFENSE': "shared/heroes/casts/castle_max_defense.png",
	    'CAST_CASTLE_UNITS_AUTOORDER': "shared/heroes/casts/castle_units_autoorder.png",
	    'CAST_CHAINMAIL2_CHEST': "shared/heroes/casts/chainmail2_chest.png",
	    'CAST_CHAINMAIL2_HEAD': "shared/heroes/casts/chainmail2_head.png",
	    'CAST_CHAINMAIL2_LEFT_HAND': "shared/heroes/casts/chainmail2_left_hand.png",
	    'CAST_CHAINMAIL2_NECK': "shared/heroes/casts/chainmail2_neck.png",
	    'CAST_CHAINMAIL2_RIGHT_HAND': "shared/heroes/casts/chainmail2_right_hand.png",
	    'CAST_CHAINMAIL': "shared/heroes/casts/chainmail.png",
	    'CAST_CHUMA': "shared/heroes/casts/chuma.png",
	    'CAST_CH_DEF_1_CAST': "shared/heroes/casts/ch_def_1_cast.png",
	    'CAST_CH_DONATE_2_CAST': "shared/heroes/casts/ch_donate_2_cast.png",
	    'CAST_CH_PEACE_1_CAST': "shared/heroes/casts/ch_peace_1_cast.png",
	    'CAST_CH_WAR_2_CAST': "shared/heroes/casts/ch_war_2_cast.png",
	    'CAST_COLD3_CHEST': "shared/heroes/casts/cold3_chest.png",
	    'CAST_COLD3_HEAD': "shared/heroes/casts/cold3_head.png",
	    'CAST_COLD3_ITEM': "shared/heroes/casts/cold3_item.png",
	    'CAST_COLD3_LEFT_HAND': "shared/heroes/casts/cold3_left_hand.png",
	    'CAST_COLD3_NECK': "shared/heroes/casts/cold3_neck.png",
	    'CAST_COLD3_RIGHT_HAND': "shared/heroes/casts/cold3_right_hand.png",
	    'CAST_COLD': "shared/heroes/casts/cold.png",
	    'CAST_CONQUISTADOR3_FINGER': "shared/heroes/casts/conquistador3_finger.png",
	    'CAST_CONQUISTADOR3_HEAD': "shared/heroes/casts/conquistador3_head.png",
	    'CAST_CONQUISTADOR3_LEFT_HAND': "shared/heroes/casts/conquistador3_left_hand.png",
	    'CAST_CONQUISTADOR3_NECK': "shared/heroes/casts/conquistador3_neck.png",
	    'CAST_CONQUISTADOR3_RIGHT_HAND': "shared/heroes/casts/conquistador3_right_hand.png",
	    'CAST_CRIMSON3_CHEST': "shared/heroes/casts/crimson3_chest.png",
	    'CAST_CRIMSON3_FINGER': "shared/heroes/casts/crimson3_finger.png",
	    'CAST_CRIMSON3_HEAD': "shared/heroes/casts/crimson3_head.png",
	    'CAST_CRIMSON3_ITEM': "shared/heroes/casts/crimson3_item.png",
	    'CAST_CRIMSON3_LEFT_HAND': "shared/heroes/casts/crimson3_left_hand.png",
	    'CAST_CRIMSON3_NECK': "shared/heroes/casts/crimson3_neck.png",
	    'CAST_CRIMSON3_RIGHT_HAND': "shared/heroes/casts/crimson3_right_hand.png",
	    'CAST_DALNEE_NABLYUDENIE': "shared/heroes/casts/dalnee_nablyudenie.png",
	    'CAST_DALNIE_ISSLEDOVANIYA': "shared/heroes/casts/dalnie_issledovaniya.png",
	    'CAST_DALNIE_ZAKUPKI': "shared/heroes/casts/dalnie_zakupki.png",
	    'CAST_DALNII_SHPIONAJ': "shared/heroes/casts/dalnii_shpionaj.png",
	    'CAST_DEZINFORMACIYA': "shared/heroes/casts/dezinformaciya.png",
	    'CAST_DEZINFORMACIYA_CASTLE': "shared/heroes/casts/dezinformaciya_castle.png",
	    'CAST_DIKIY_UZAS': "shared/heroes/casts/dikiy_uzas.png",
	    'CAST_DIVERSIYA_ANTISHPIONOV': "shared/heroes/casts/diversiya_antishpionov.png",
	    'CAST_DIVERSIYA_BASHEN': "shared/heroes/casts/diversiya_bashen.png",
	    'CAST_DIVERSIYA_DOBYCHI': "shared/heroes/casts/diversiya_dobychi.png",
	    'CAST_DIVERSIYA_DOMOV': "shared/heroes/casts/diversiya_domov.png",
	    'CAST_DIVERSIYA_ISSLEDOVATELEI': "shared/heroes/casts/diversiya_issledovatelei.png",
	    'CAST_DIVERSIYA_ISSLEDOVATELEI_MONSTR': "shared/heroes/casts/diversiya_issledovatelei_monstr.png",
	    'CAST_DIVERSIYA_KUPCOV': "shared/heroes/casts/diversiya_kupcov.png",
	    'CAST_DIVERSIYA_LABORATORII': "shared/heroes/casts/diversiya_laboratorii.png",
	    'CAST_DIVERSIYA_MAGICHESKIH_BASHEN': "shared/heroes/casts/diversiya_magicheskih_bashen.png",
	    'CAST_DIVERSIYA_NA_RYNKE': "shared/heroes/casts/diversiya_na_rynke.png",
	    'CAST_DIVERSIYA_PROVIDCEV': "shared/heroes/casts/diversiya_providcev.png",
	    'CAST_DIVERSIYA_SHPIONOV': "shared/heroes/casts/diversiya_shpionov.png",
	    'CAST_DIVERSIYA_SKLADOV': "shared/heroes/casts/diversiya_skladov.png",
	    'CAST_DIVERSIYA_TRENIROVOK': "shared/heroes/casts/diversiya_trenirovok.png",
	    'CAST_DIVERSIYA_VOSKRESITELYA': "shared/heroes/casts/diversiya_voskresitelya.png",
	    'CAST_DIVERSIYA_V_HRAME': "shared/heroes/casts/diversiya_v_hrame.png",
	    'CAST_DIVERSIYA_V_LAVOK': "shared/heroes/casts/diversiya_v_lavok.png",
	    'CAST_DIVERSIYA_ZERKAL': "shared/heroes/casts/diversiya_zerkal.png",
	    'CAST_DIVERSIYA_ZERKAL_I_ANTISHPIONOV': "shared/heroes/casts/diversiya_zerkal_i_antishpionov.png",
	    'CAST_DOBIVAT_RANENYH': "shared/heroes/casts/dobivat_ranenyh.png",
	    'CAST_DOBIVAT_RANENYH_CASTLE': "shared/heroes/casts/dobivat_ranenyh_castle.png",
	    'CAST_DOZORNYI': "shared/heroes/casts/dozornyi.png",
	    'CAST_DRAGON4_CHEST': "shared/heroes/casts/dragon4_chest.png",
	    'CAST_DRAGON4_HEAD': "shared/heroes/casts/dragon4_head.png",
	    'CAST_DRAGON4_ITEM': "shared/heroes/casts/dragon4_item.png",
	    'CAST_DRAGON4_LEFT_HAND': "shared/heroes/casts/dragon4_left_hand.png",
	    'CAST_DRAGON4_LEGS': "shared/heroes/casts/dragon4_legs.png",
	    'CAST_DRAGON4_RIGHT_HAND': "shared/heroes/casts/dragon4_right_hand.png",
	    'CAST_DRAGON': "shared/heroes/casts/dragon.png",
	    'CAST_DUH_ALTRUIZMA': "shared/heroes/casts/duh_altruizma.png",
	    'CAST_DUH_ALTRUIZMA_CASTLE': "shared/heroes/casts/duh_altruizma_castle.png",
	    'CAST_DUH_PRESLEDOVANIYA_ZEMLI_DEMONOV': "shared/heroes/casts/duh_presledovaniya_zemli_demonov.png",
	    'CAST_DUH_PRESLEDOVANIYA_ZEMLI_DEMONOV_CASTLE': "shared/heroes/casts/duh_presledovaniya_zemli_demonov_castle.png",
	    'CAST_DUH_PRESLEDOVANIYA_ZEMLI_DROU': "shared/heroes/casts/duh_presledovaniya_zemli_drou.png",
	    'CAST_DUH_PRESLEDOVANIYA_ZEMLI_DROU_CASTLE': "shared/heroes/casts/duh_presledovaniya_zemli_drou_castle.png",
	    'CAST_DUH_PRESLEDOVANIYA_ZEMLI_ELFOV': "shared/heroes/casts/duh_presledovaniya_zemli_elfov.png",
	    'CAST_DUH_PRESLEDOVANIYA_ZEMLI_ELFOV_CASTLE': "shared/heroes/casts/duh_presledovaniya_zemli_elfov_castle.png",
	    'CAST_DUH_PRESLEDOVANIYA_ZEMLI_LYUDEI': "shared/heroes/casts/duh_presledovaniya_zemli_lyudei.png",
	    'CAST_DUH_PRESLEDOVANIYA_ZEMLI_LYUDEI_CASTLE': "shared/heroes/casts/duh_presledovaniya_zemli_lyudei_castle.png",
	    'CAST_DUH_ZASCHITY_ZEMLI_ELFOV': "shared/heroes/casts/duh_zaschity_zemli_elfov.png",
	    'CAST_DUH_ZASCHITY_ZEMLI_ELFOV_CASTLE': "shared/heroes/casts/duh_zaschity_zemli_elfov_castle.png",
	    'CAST_DUH_ZASCHITY_ZEMLI_LYUDEI': "shared/heroes/casts/duh_zaschity_zemli_lyudei.png",
	    'CAST_DUH_ZASCHITY_ZEMLI_LYUDEI_CASTLE': "shared/heroes/casts/duh_zaschity_zemli_lyudei_castle.png",
	    'CAST_DUH_ZASCHITY_ZEMLI__DEMONOV': "shared/heroes/casts/duh_zaschity_zemli__demonov.png",
	    'CAST_DUH_ZASCHITY_ZEMLI__DEMONOV_CASTLE': "shared/heroes/casts/duh_zaschity_zemli__demonov_castle.png",
	    'CAST_DUH_ZASCHITY_ZEMLI__DROU': "shared/heroes/casts/duh_zaschity_zemli__drou.png",
	    'CAST_DUH_ZASCHITY_ZEMLI__DROU_CASTLE': "shared/heroes/casts/duh_zaschity_zemli__drou_castle.png",
	    'CAST_EAGLE4_CHEST': "shared/heroes/casts/eagle4_chest.png",
	    'CAST_EAGLE4_FINGER': "shared/heroes/casts/eagle4_finger.png",
	    'CAST_EAGLE4_ITEM': "shared/heroes/casts/eagle4_item.png",
	    'CAST_EAGLE4_LEFT_HAND': "shared/heroes/casts/eagle4_left_hand.png",
	    'CAST_EAGLE4_NECK': "shared/heroes/casts/eagle4_neck.png",
	    'CAST_EAGLE4_RIGHT_HAND': "shared/heroes/casts/eagle4_right_hand.png",
	    'CAST_EINARM': "shared/heroes/casts/einarm.png",
	    'CAST_EINARM_CASTLE': "shared/heroes/casts/einarm_castle.png",
	    'CAST_EKONOMNAYA_TRENIROVKA': "shared/heroes/casts/ekonomnaya_trenirovka.png",
	    'CAST_EKONOMNAYA_TRENIROVKA_LEKAREI': "shared/heroes/casts/ekonomnaya_trenirovka_lekarei.png",
	    'CAST_EKONOMNAYA_TRENIROVKA_MAGOV': "shared/heroes/casts/ekonomnaya_trenirovka_magov.png",
	    'CAST_ELFIISKOE_DEREVO': "shared/heroes/casts/elfiiskoe_derevo.png",
	    'CAST_ELVEN1_CHEST': "shared/heroes/casts/elven1_chest.png",
	    'CAST_ELVEN1_FINGER': "shared/heroes/casts/elven1_finger.png",
	    'CAST_ELVEN1_HEAD': "shared/heroes/casts/elven1_head.png",
	    'CAST_ELVEN1_ITEM': "shared/heroes/casts/elven1_item.png",
	    'CAST_ELVEN1_LEFT_HAND': "shared/heroes/casts/elven1_left_hand.png",
	    'CAST_ELVEN': "shared/heroes/casts/elven.png",
	    'CAST_ENEMY_ATTACK': "shared/heroes/casts/enemy_attack.png",
	    'CAST_EXPEDITORS_SPEED': "shared/heroes/casts/expeditors_speed.png",
	    'CAST_FLAG_FIND_2_CAST': "shared/heroes/casts/flag_find_2_cast.png",
	    'CAST_FLAG_PAYFORBONUS_1_CAST': "shared/heroes/casts/flag_payforbonus_1_cast.png",
	    'CAST_FLAG_REWARD_2_CAST': "shared/heroes/casts/flag_reward_2_cast.png",
	    'CAST_FLAG_REWARD_3_CAST': "shared/heroes/casts/flag_reward_3_cast.png",
	    'CAST_FLAG_REWARD_4_CAST': "shared/heroes/casts/flag_reward_4_cast.png",
	    'CAST_FONTAN_MANY': "shared/heroes/casts/fontan_many.png",
	    'CAST_FORRESTER1_FINGER': "shared/heroes/casts/forrester1_finger.png",
	    'CAST_FORRESTER1_LEFT_HAND': "shared/heroes/casts/forrester1_left_hand.png",
	    'CAST_FORRESTER1_NECK': "shared/heroes/casts/forrester1_neck.png",
	    'CAST_FORRESTER1_RIGHT_HAND': "shared/heroes/casts/forrester1_right_hand.png",
	    'CAST_FORTIFICATION': "shared/heroes/casts/fortification.png",
	    'CAST_FOX4_LEFT_HAND': "shared/heroes/casts/fox4_left_hand.png",
	    'CAST_FOX4_RIGHT_HAND': "shared/heroes/casts/fox4_right_hand.png",
	    'CAST_FRACTION_RATING_7_CAST': "shared/heroes/casts/fraction_rating_7_cast.png",
	    'CAST_FRACTION_RATING_8_CAST': "shared/heroes/casts/fraction_rating_8_cast.png",
	    'CAST_FROST_STEEL2_CHEST': "shared/heroes/casts/frost_steel2_chest.png",
	    'CAST_FROST_STEEL2_FINGER': "shared/heroes/casts/frost_steel2_finger.png",
	    'CAST_FROST_STEEL2_HEAD': "shared/heroes/casts/frost_steel2_head.png",
	    'CAST_FROST_STEEL2_LEFT_HAND': "shared/heroes/casts/frost_steel2_left_hand.png",
	    'CAST_FROST_STEEL2_NECK': "shared/heroes/casts/frost_steel2_neck.png",
	    'CAST_FROST_STEEL2_RIGHT_HAND': "shared/heroes/casts/frost_steel2_right_hand.png",
	    'CAST_GENERATOR_BURI': "shared/heroes/casts/generator_buri.png",
	    'CAST_GENERATOR_BURI_CASTLE': "shared/heroes/casts/generator_buri_castle.png",
	    'CAST_GENERATOR_BURI_MONSTR': "shared/heroes/casts/generator_buri_monstr.png",
	    'CAST_GLOBALNOE_ZAVERSHENIE_POSTROEK': "shared/heroes/casts/globalnoe_zavershenie_postroek.png",
	    'CAST_GNOMY_UCHENYE': "shared/heroes/casts/gnomy_uchenye.png",
	    'CAST_GORNYE_INSTRUMENTY': "shared/heroes/casts/gornye_instrumenty.png",
	    'CAST_GORNYI_KAMUFLYAJ': "shared/heroes/casts/gornyi_kamuflyaj.png",
	    'CAST_GORNYI_KAMUFLYAJ_CASTLE': "shared/heroes/casts/gornyi_kamuflyaj_castle.png",
	    'CAST_GRAIL_10_CAST': "shared/heroes/casts/grail_10_cast.png",
        'CAST_GRAIL_50000BP_CAST' : "shared/heroes/casts/grail_50000bp_cast.png",
	    'CAST_GREEN3_CHEST': "shared/heroes/casts/green3_chest.png",
	    'CAST_GREEN3_FINGER': "shared/heroes/casts/green3_finger.png",
	    'CAST_GREEN3_LEFT_HAND': "shared/heroes/casts/green3_left_hand.png",
	    'CAST_GREEN3_LEGS': "shared/heroes/casts/green3_legs.png",
	    'CAST_GREEN3_NECK': "shared/heroes/casts/green3_neck.png",
	    'CAST_GREEN3_RIGHT_HAND': "shared/heroes/casts/green3_right_hand.png",
	    'CAST_HAMMER3_CHEST': "shared/heroes/casts/hammer3_chest.png",
	    'CAST_HAMMER3_FINGER': "shared/heroes/casts/hammer3_finger.png",
	    'CAST_HAMMER3_HEAD': "shared/heroes/casts/hammer3_head.png",
	    'CAST_HAMMER3_ITEM': "shared/heroes/casts/hammer3_item.png",
	    'CAST_HAMMER3_LEFT_HAND': "shared/heroes/casts/hammer3_left_hand.png",
	    'CAST_HAMMER3_LEGS': "shared/heroes/casts/hammer3_legs.png",
	    'CAST_HAMMER3_NECK': "shared/heroes/casts/hammer3_neck.png",
	    'CAST_HAMMER3_RIGHT_HAND': "shared/heroes/casts/hammer3_right_hand.png",
	    'CAST_HEALTH_BONUS_AGAINST_MONSTER': "shared/heroes/casts/health_bonus_against_monster.png",
		'CAST_HERO_EXP': "shared/heroes/casts/hero_exp.png",
	    'CAST_HIMICHESKII_SINTEZ': "shared/heroes/casts/himicheskii_sintez.png",
	    'CAST_ILLYUZIYA_GEROYA': "shared/heroes/casts/illyuziya_geroya.png",
	    'CAST_INCOMING_ATTACK_SPEED': "shared/heroes/casts/incoming_attack_speed.png",
		'CAST_INQUISITOR4_CHEST' : 'shared/heroes/casts/inquisitor4_chest.png',
		'CAST_INQUISITOR4_FINGER' : 'shared/heroes/casts/inquisitor4_finger.png',
		'CAST_INQUISITOR4_HEAD' : 'shared/heroes/casts/inquisitor4_head.png',
		'CAST_INQUISITOR4_ITEM' : 'shared/heroes/casts/inquisitor4_item.png',
		'CAST_INQUISITOR4_NECK' : 'shared/heroes/casts/inquisitor4_neck.png',
		'CAST_INQUISITOR4_LEFT_HAND' : 'shared/heroes/casts/inquisitor4_left_hand.png',
		'CAST_INQUISITOR4_RIGHT_HAND' : 'shared/heroes/casts/inquisitor4_right_hand.png',
	    'CAST_IRON2_CHEST': "shared/heroes/casts/iron2_chest.png",
	    'CAST_IRON2_FINGER': "shared/heroes/casts/iron2_finger.png",
	    'CAST_IRON2_HEAD': "shared/heroes/casts/iron2_head.png",
	    'CAST_IRON2_ITEM': "shared/heroes/casts/iron2_item.png",
	    'CAST_IRON2_LEFT_HAND': "shared/heroes/casts/iron2_left_hand.png",
	    'CAST_IRON2_LEGS': "shared/heroes/casts/iron2_legs.png",
	    'CAST_IRON2_NECK': "shared/heroes/casts/iron2_neck.png",
	    'CAST_IRON2_RIGHT_HAND': "shared/heroes/casts/iron2_right_hand.png",
	    'CAST_IRON': "shared/heroes/casts/iron.png",
	    'CAST_ISSLEDOVAT_KOROLEVSTVO': "shared/heroes/casts/issledovat_korolevstvo.png",
	    'CAST_ISTINNOE_ZRENIE_GEROYA': "shared/heroes/casts/istinnoe_zrenie_geroya.png",
	    'CAST_ISTINNOE_ZRENIE_VLADENIYA': "shared/heroes/casts/istinnoe_zrenie_vladeniya.png",
	    'CAST_ISTINNOE_ZRENIE_VLADENIYA_CASTLE': "shared/heroes/casts/istinnoe_zrenie_vladeniya_castle.png",
	    'CAST_JALOST': "shared/heroes/casts/jalost.png",
	    'CAST_JELEZO_DROU': "shared/heroes/casts/jelezo_drou.png",
	    'CAST_JERTVA': "shared/heroes/casts/jertva.png",
	    'CAST_JESTER3_CHEST': "shared/heroes/casts/jester3_chest.png",
	    'CAST_JESTER3_FINGER': "shared/heroes/casts/jester3_finger.png",
	    'CAST_JESTER3_HEAD': "shared/heroes/casts/jester3_head.png",
	    'CAST_JESTER3_ITEM': "shared/heroes/casts/jester3_item.png",
	    'CAST_JESTER3_LEFT_HAND': "shared/heroes/casts/jester3_left_hand.png",
	    'CAST_JESTER3_LEGS': "shared/heroes/casts/jester3_legs.png",
	    'CAST_JESTER3_NECK': "shared/heroes/casts/jester3_neck.png",
	    'CAST_KAMEN_DEMONOV': "shared/heroes/casts/kamen_demonov.png",
	    'CAST_KARANTIN': "shared/heroes/casts/karantin.png",
	    'CAST_KATAPULTA': "shared/heroes/casts/katapulta.png",
	    'CAST_KING3_LEFT_HAND': "shared/heroes/casts/king3_left_hand.png",
	    'CAST_KING3_RIGHT_HAND': "shared/heroes/casts/king3_right_hand.png",
		'CAST_KING5_CHEST' : 'shared/heroes/casts/king5_chest.png',
		'CAST_KING5_FINGER' : 'shared/heroes/casts/king5_finger.png',
		'CAST_KING5_HEAD' : 'shared/heroes/casts/king5_head.png',
		'CAST_KING5_ITEM' : 'shared/heroes/casts/king5_item.png',
		'CAST_KING5_LEFT_HAND' : 'shared/heroes/casts/king5_left_hand.png',
		'CAST_KING5_NECK' : 'shared/heroes/casts/king5_nech.png',
		'CAST_KING5_RIGHT_HAND' : 'shared/heroes/casts/king5_right_hand.png',
	    'CAST_KLANOVYI_PLEN': "shared/heroes/casts/klanovyi_plen.png",
	    'CAST_KNIGA_MUDROSTI': "shared/heroes/casts/kniga_mudrosti.png",
	    'CAST_KNIGA_ZNANII': "shared/heroes/casts/kniga_znanii.png",
	    'CAST_KOLCO_DEMONOV': "shared/heroes/casts/kolco_demonov.png",
	    'CAST_KULTIVACIYA_POCHVY': "shared/heroes/casts/kultivaciya_pochvy.png",
	    'CAST_LATTICE2_CHEST': "shared/heroes/casts/lattice2_chest.png",
	    'CAST_LATTICE2_FINGER': "shared/heroes/casts/lattice2_finger.png",
	    'CAST_LATTICE2_HEAD': "shared/heroes/casts/lattice2_head.png",
	    'CAST_LATTICE2_LEFT_HAND': "shared/heroes/casts/lattice2_left_hand.png",
	    'CAST_LATTICE2_LEGS': "shared/heroes/casts/lattice2_legs.png",
	    'CAST_LATTICE2_NECK': "shared/heroes/casts/lattice2_neck.png",
	    'CAST_LATTICE2_RIGHT_HAND': "shared/heroes/casts/lattice2_right_hand.png",
	    'CAST_LATTICE': "shared/heroes/casts/lattice.png",
	    'CAST_LEECH4_CHEST': "shared/heroes/casts/leech4_chest.png",
	    'CAST_LEECH4_HEAD': "shared/heroes/casts/leech4_head.png",
	    'CAST_LEECH4_ITEM': "shared/heroes/casts/leech4_item.png",
	    'CAST_LEECH4_LEFT_HAND': "shared/heroes/casts/leech4_left_hand.png",
	    'CAST_LEECH4_LEGS': "shared/heroes/casts/leech4_legs.png",
	    'CAST_LEECH4_NECK': "shared/heroes/casts/leech4_neck.png",
	    'CAST_LEECH': "shared/heroes/casts/leech.png",
		'CAST_LEGIONARY3_CHEST' : 'shared/heroes/casts/legionary3_chest.png',
		'CAST_LEGIONARY3_FINGER' : 'shared/heroes/casts/legionary3_finger.png',
		'CAST_LEGIONARY3_HEAD' : 'shared/heroes/casts/legionary3_head.png',
		'CAST_LEGIONARY3_ITEM' : 'shared/heroes/casts/legionary3_item.png',
		'CAST_LEGIONARY3_LEFT_HAND' : 'shared/heroes/casts/legionary3_left_hand.png',
		'CAST_LEGIONARY3_NECK' : 'shared/heroes/casts/legionary3_neck.png',
		'CAST_LEGIONARY3_WAIST' : 'shared/heroes/casts/legionary3_waist.png',
    	'CAST_LEGIONARY3_RIGHT_HAND' : 'shared/heroes/casts/legionary3_right_hand.png',	    'CAST_LESNOI_KAMUFLYAJ': "shared/heroes/casts/lesnoi_kamuflyaj.png",
		'CAST_LESNOI_KAMUFLYAJ_CASTLE': "shared/heroes/casts/lesnoi_kamuflyaj_castle.png",
	    'CAST_LETAYUSCHIE_PRESLEDOVATELI': "shared/heroes/casts/letayuschie_presledovateli.png",
	    'CAST_LETAYUSCHIE_PRESLEDOVATELI_CASTLE': "shared/heroes/casts/letayuschie_presledovateli_castle.png",
	    'CAST_LOCKED_CAST': "shared/heroes/casts/locked_cast.png",
	    'CAST_LOGGER2_LEFT_HAND': "shared/heroes/casts/logger2_left_hand.png",
	    'CAST_LOGGER2_LEGS': "shared/heroes/casts/logger2_legs.png",
	    'CAST_LOGGER2_NECK': "shared/heroes/casts/logger2_neck.png",
	    'CAST_LOGGER2_RIGHT_HAND': "shared/heroes/casts/logger2_right_hand.png",
	    'CAST_LOVUSHKA': "shared/heroes/casts/lovushka.png",
	    'CAST_LOVUSHKA_CASTLE': "shared/heroes/casts/lovushka_castle.png",
	    'CAST_LOVUSHKA_SJIGATEL_MANY': "shared/heroes/casts/lovushka_sjigatel_many.png",
	    'CAST_LUCHNIKI_PRESLEDOVATELI': "shared/heroes/casts/luchniki_presledovateli.png",
	    'CAST_LUCHNIKI_PRESLEDOVATELI_CASTLE': "shared/heroes/casts/luchniki_presledovateli_castle.png",
	    'CAST_LYUBOV_K_ARHITEKTURE': "shared/heroes/casts/lyubov_k_arhitekture.png",
	    'CAST_LYUBOV_K_ARHITEKTURE_CASTLE': "shared/heroes/casts/lyubov_k_arhitekture_castle.png",
	    'CAST_MAGES_SUPPRESS_ATTACK': "shared/heroes/casts/mages_suppress_attack.png",
	    'CAST_MAGE_ATTACK': "shared/heroes/casts/mage_attack.png",
	    'CAST_MAGIC_CRYSTALL5_CHEST': "shared/heroes/casts/magic_crystall5_chest.png",
	    'CAST_MAGIC_CRYSTALL5_FINGER': "shared/heroes/casts/magic_crystall5_finger.png",
	    'CAST_MAGIC_CRYSTALL5_HEAD': "shared/heroes/casts/magic_crystall5_head.png",
	    'CAST_MAGIC_CRYSTALL5_ITEM': "shared/heroes/casts/magic_crystall5_item.png",
	    'CAST_MAGIC_CRYSTALL5_LEFT_HAND': "shared/heroes/casts/magic_crystall5_left_hand.png",
	    'CAST_MAGIC_CRYSTALL5_RIGHT_HAND': "shared/heroes/casts/magic_crystall5_right_hand.png",
	    'CAST_MAGIC_TOWER': "shared/heroes/casts/magic_tower.png",
	    'CAST_MAGI_ZASCHITNIKI': "shared/heroes/casts/magi_zaschitniki.png",
	    'CAST_MARINE2_CHEST': "shared/heroes/casts/marine2_chest.png",
	    'CAST_MARINE2_HEAD': "shared/heroes/casts/marine2_head.png",
	    'CAST_MARINE2_ITEM': "shared/heroes/casts/marine2_item.png",
	    'CAST_MARINE2_LEFT_HAND': "shared/heroes/casts/marine2_left_hand.png",
	    'CAST_MARINE2_NECK': "shared/heroes/casts/marine2_neck.png",
	    'CAST_MARINE': "shared/heroes/casts/marine.png",
	    'CAST_MARODERSTVO': "shared/heroes/casts/maroderstvo.png",
	    'CAST_MASTERSTVO_OBORONY': "shared/heroes/casts/masterstvo_oborony.png",
	    'CAST_MASTERSTVO_OBORONY_CASTLE': "shared/heroes/casts/masterstvo_oborony_castle.png",
	    'CAST_MASTER_BASHEN': "shared/heroes/casts/master_bashen.png",
	    'CAST_MEDLENNIY_VPK': "shared/heroes/casts/medlenniy_vpk.png",
	    'CAST_MERCHANTS_SPEED': "shared/heroes/casts/merchants_speed.png",
	    'CAST_MILITARY_PRODUCTION': "shared/heroes/casts/military_production.png",
	    'CAST_MOBILIZACIYA': "shared/heroes/casts/mobilizaciya.png",
	    'CAST_MOBILIZACIYA_CASTLE': "shared/heroes/casts/mobilizaciya_castle.png",
	    'CAST_MODERNIZACIYA_UKREPLENII': "shared/heroes/casts/modernizaciya_ukreplenii.png",
	    'CAST_MODERNIZACIYA_UKREPLENII_CASTLE': "shared/heroes/casts/modernizaciya_ukreplenii_castle.png",
	    'CAST_MONOPOLIYA': "shared/heroes/casts/monopoliya.png",
	    'CAST_MONSTER_RETREAT': "shared/heroes/casts/monster_retreat.png",
	    'CAST_NASLAT_BOLEZN': "shared/heroes/casts/naslat_bolezn.png",
	    'CAST_NASLAT_MONSTROV': "shared/heroes/casts/naslat_monstrov.png",
	    'CAST_NEKROMANSIYA_SOYUZNIKA': "shared/heroes/casts/nekromansiya_soyuznika.png",
	    'CAST_NEKROMANSIYA_SOYUZNIKA_CASTLE': "shared/heroes/casts/nekromansiya_soyuznika_castle.png",
	    'CAST_NEKROMANSIYA_SVOIH_VOISK': "shared/heroes/casts/nekromansiya_svoih_voisk.png",
	    'CAST_NEKROMANSIYA_SVOIH_VOISK_CASTLE': "shared/heroes/casts/nekromansiya_svoih_voisk_castle.png",
	    'CAST_NEPODVIZNIE_DUHI': "shared/heroes/casts/nepodviznie_duhi.png",
	    'CAST_NEUDACHA_PROTIVNIKU': "shared/heroes/casts/neudacha_protivniku.png",
	    'CAST_NEVIDIMOST': "shared/heroes/casts/nevidimost.png",
	    'CAST_OBEREG_ISSLEDOVATELEI': "shared/heroes/casts/obereg_issledovatelei.png",
	    'CAST_OBEREG_KUPCOV': "shared/heroes/casts/obereg_kupcov.png",
	    'CAST_OBHOD_KODEKSA': "shared/heroes/casts/obhod_kodeksa.png",
	    'CAST_OHRANA_SKLADOV': "shared/heroes/casts/ohrana_skladov.png",
	    'CAST_OHRANA_SOYUZNIKA': "shared/heroes/casts/ohrana_soyuznika.png",
	    'CAST_OHRANA_SOYUZNIKA_CASTLE': "shared/heroes/casts/ohrana_soyuznika_castle.png",
	    'CAST_OKO_ISSLEDOVATELYA': "shared/heroes/casts/oko_issledovatelya.png",
	    'CAST_OPTIMIZACIYA_HRANENIYA': "shared/heroes/casts/optimizaciya_hraneniya.png",
	    'CAST_OSADNAYA_BASHNYA': "shared/heroes/casts/osadnaya_bashnya.png",
	    'CAST_OSTANOVIT_NEGATIVNOE_SOBYTIE': "shared/heroes/casts/ostanovit_negativnoe_sobytie.png",
	    'CAST_OSTOROJNOST_V_NAPADENII': "shared/heroes/casts/ostorojnost_v_napadenii.png",
	    'CAST_OSTOROJNOST_V_ZASCHITE': "shared/heroes/casts/ostorojnost_v_zaschite.png",
	    'CAST_OSVOBODITEL_GEROEV': "shared/heroes/casts/osvoboditel_geroev.png",
	    'CAST_OTKAZ_SLUJIT': "shared/heroes/casts/otkaz_slujit.png",
	    'CAST_OTRAVIT_VODU': "shared/heroes/casts/otravit_vodu.png",
	    'CAST_PATHFINDER1_CHEST': "shared/heroes/casts/pathfinder1_chest.png",
	    'CAST_PATHFINDER1_HEAD': "shared/heroes/casts/pathfinder1_head.png",
	    'CAST_PATHFINDER1_ITEM': "shared/heroes/casts/pathfinder1_item.png",
	    'CAST_PATHFINDER1_LEFT_HAND': "shared/heroes/casts/pathfinder1_left_hand.png",
	    'CAST_PATHFINDER1_NECK': "shared/heroes/casts/pathfinder1_neck.png",
	    'CAST_PATHFINDER1_RIGHT_HAND': "shared/heroes/casts/pathfinder1_right_hand.png",
	    'CAST_PATHFINDER': "shared/heroes/casts/pathfinder.png",
	    'CAST_PERENOSNOE_UKREPLENIE': "shared/heroes/casts/perenosnoe_ukreplenie.png",
	    'CAST_PHARAON4_CHEST': "shared/heroes/casts/pharaon4_chest.png",
	    'CAST_PHARAON4_FINGER': "shared/heroes/casts/pharaon4_finger.png",
	    'CAST_PHARAON4_HEAD': "shared/heroes/casts/pharaon4_head.png",
	    'CAST_PHARAON4_LEFT_HAND': "shared/heroes/casts/pharaon4_left_hand.png",
	    'CAST_PLACDARM_PEREBROSKI': "shared/heroes/casts/placdarm_perebroski.png",
	    'CAST_PLANARNYI_PEREHOD': "shared/heroes/casts/planarnyi_perehod.png",
	    'CAST_PLENENIE_DUSH': "shared/heroes/casts/plenenie_dush.png",
	    'CAST_POBOCHNAYA_PRIBYL': "shared/heroes/casts/pobochnaya_pribyl.png",
	    'CAST_PODAVITEL_BASHEN': "shared/heroes/casts/podavitel_bashen.png",
	    'CAST_PODAVITEL_MAGICHESKIH_BASHEN': "shared/heroes/casts/podavitel_magicheskih_bashen.png",
	    'CAST_PODAVLENIE_LEKAREI': "shared/heroes/casts/podavlenie_lekarei.png",
	    'CAST_PODAVLENIE_LEKAREI_CASTLE': "shared/heroes/casts/podavlenie_lekarei_castle.png",
	    'CAST_PODAVLENIE_MAGOV': "shared/heroes/casts/podavlenie_magov.png",
	    'CAST_PODAVLENIE_MAGOV_CASTLE': "shared/heroes/casts/podavlenie_magov_castle.png",
	    'CAST_PODAVLENIE_MONSTROV': "shared/heroes/casts/podavlenie_monstrov.png",
	    'CAST_PODAVLENUIE_VSEH_VOYSK': "shared/heroes/casts/podavlenuie_vseh_voysk.png",
	    'CAST_PODJOG': "shared/heroes/casts/podjog.png",
	    'CAST_PODNYATIE_UPOKOENNYH': "shared/heroes/casts/podnyatie_upokoennyh.png",
	    'CAST_PODNYAT_UBITYH_VRAGOV': "shared/heroes/casts/podnyat_ubityh_vragov.png",
	    'CAST_PODNYAT_UBITYH_VRAGOV_CASTLE': "shared/heroes/casts/podnyat_ubityh_vragov_castle.png",
	    'CAST_POHODNYE_ANTISHPIONY': "shared/heroes/casts/pohodnye_antishpiony.png",
	    'CAST_POHODNYE_PROVIDCY': "shared/heroes/casts/pohodnye_providcy.png",
	    'CAST_POHODNYE_SHPIONY': "shared/heroes/casts/pohodnye_shpiony.png",
	    'CAST_POHODNYE_ZERKALA': "shared/heroes/casts/pohodnye_zerkala.png",
	    'CAST_POISK_KOPI': "shared/heroes/casts/poisk_kopi.png",
	    'CAST_POISK_OZERA': "shared/heroes/casts/poisk_ozera.png",
	    'CAST_POISK_RUINY': "shared/heroes/casts/poisk_ruiny.png",
	    'CAST_POJAR': "shared/heroes/casts/pojar.png",
	    'CAST_POJERTVOVAT_MANU': "shared/heroes/casts/pojertvovat_manu.png",
	    'CAST_POLNAYA_OSTANOVKA': "shared/heroes/casts/polnaya_ostanovka.png",
	    'CAST_POSLANIE_IZ_ADA': "shared/heroes/casts/poslanie_iz_ada.png",
	    'CAST_PRAZDNIK': "shared/heroes/casts/prazdnik.png",
	    'CAST_PREDANNOST': "shared/heroes/casts/predannost.png",
	    'CAST_PREDATOR4_CHEST': "shared/heroes/casts/predator4_chest.png",
	    'CAST_PREDATOR4_FINGER': "shared/heroes/casts/predator4_finger.png",
	    'CAST_PREDATOR4_HEAD': "shared/heroes/casts/predator4_head.png",
	    'CAST_PREDATOR4_ITEM': "shared/heroes/casts/predator4_item.png",
	    'CAST_PREDATOR4_LEFT_HAND': "shared/heroes/casts/predator4_left_hand.png",
	    'CAST_PREDATOR4_RIGHT_HAND': "shared/heroes/casts/predator4_right_hand.png",
	    'CAST_PREDATOR': "shared/heroes/casts/predator.png",
	    'CAST_PREKRATIT_PRITOK_MONSTROV': "shared/heroes/casts/prekratit_pritok_monstrov.png",
	    'CAST_PRISPOSOBITSYA_K_MESTNOSTI': "shared/heroes/casts/prisposobitsya_k_mestnosti.png",
	    'CAST_PRISPOSOBITSYA_K_MESTNOSTI_CASTLE': "shared/heroes/casts/prisposobitsya_k_mestnosti_castle.png",
	    'CAST_PRITOK_MONSTROV': "shared/heroes/casts/pritok_monstrov.png",
	    'CAST_PRIZYV_ANTISHPIONOV': "shared/heroes/casts/prizyv_antishpionov.png",
	    'CAST_PRIZYV_ANTISHPIONOV_CASTLE': "shared/heroes/casts/prizyv_antishpionov_castle.png",
	    'CAST_PRIZYV_DREVNIH': "shared/heroes/casts/prizyv_drevnih.png",
	    'CAST_PRIZYV_ISSLEDOVATELEI': "shared/heroes/casts/prizyv_issledovatelei.png",
	    'CAST_PRIZYV_KONNIKOV': "shared/heroes/casts/prizyv_konnikov.png",
	    'CAST_PRIZYV_KONNIKOV_CASTLE': "shared/heroes/casts/prizyv_konnikov_castle.png",
	    'CAST_PRIZYV_KUPCOV': "shared/heroes/casts/prizyv_kupcov.png",
	    'CAST_PRIZYV_LEKAREI': "shared/heroes/casts/prizyv_lekarei.png",
	    'CAST_PRIZYV_LEKAREI_CASTLE': "shared/heroes/casts/prizyv_lekarei_castle.png",
	    'CAST_PRIZYV_LETAYUSCHIH': "shared/heroes/casts/prizyv_letayuschih.png",
	    'CAST_PRIZYV_LETAYUSCHIH_CASTLE': "shared/heroes/casts/prizyv_letayuschih_castle.png",
	    'CAST_PRIZYV_MAGOV': "shared/heroes/casts/prizyv_magov.png",
	    'CAST_PRIZYV_MAGOV_CASTLE': "shared/heroes/casts/prizyv_magov_castle.png",
	    'CAST_PRIZYV_NAEMNIKOV': "shared/heroes/casts/prizyv_naemnikov.png",
	    'CAST_PRIZYV_NAEMNIKOV_CASTLE': "shared/heroes/casts/prizyv_naemnikov_castle.png",
	    'CAST_PRIZYV_NOSILSCHIKOV': "shared/heroes/casts/prizyv_nosilschikov.png",
	    'CAST_PRIZYV_NOSILSCHIKOV_CASTLE': "shared/heroes/casts/prizyv_nosilschikov_castle.png",
	    'CAST_PRIZYV_POSELENCA': "shared/heroes/casts/prizyv_poselenca.png",
	    'CAST_PRIZYV_PROVIDCEV': "shared/heroes/casts/prizyv_providcev.png",
	    'CAST_PRIZYV_SHPIONOV': "shared/heroes/casts/prizyv_shpionov.png",
	    'CAST_PRIZYV_STRELKOV': "shared/heroes/casts/prizyv_strelkov.png",
	    'CAST_PRIZYV_STRELKOV_CASTLE': "shared/heroes/casts/prizyv_strelkov_castle.png",
	    'CAST_PRIZYV_VOINOV': "shared/heroes/casts/prizyv_voinov.png",
	    'CAST_PRIZYV_VOINOV_CASTLE': "shared/heroes/casts/prizyv_voinov_castle.png",
	    'CAST_PRIZYV_ZERKAL': "shared/heroes/casts/prizyv_zerkal.png",
	    'CAST_PRIZYV_ZERKAL_CASTLE': "shared/heroes/casts/prizyv_zerkal_castle.png",
	    'CAST_PROKLYATE_BASHEN': "shared/heroes/casts/proklyate_bashen.png",
	    'CAST_PROKLYATE_BLIZORUKOSTI': "shared/heroes/casts/proklyate_blizorukosti.png",
	    'CAST_PROKLYATE_BOLOTO': "shared/heroes/casts/proklyate_boloto.png",
	    'CAST_PROKLYATE_DOMOV': "shared/heroes/casts/proklyate_domov.png",
	    'CAST_PROKLYATE_HLEBOROBOV': "shared/heroes/casts/proklyate_hleborobov.png",
	    'CAST_PROKLYATE_ISSLEDOVATELEI': "shared/heroes/casts/proklyate_issledovatelei.png",
	    'CAST_PROKLYATE_JADNOST': "shared/heroes/casts/proklyate_jadnost.png",
	    'CAST_PROKLYATE_KAMNETESOV': "shared/heroes/casts/proklyate_kamnetesov.png",
	    'CAST_PROKLYATE_KARTOGRAFII': "shared/heroes/casts/proklyate_kartografii.png",
	    'CAST_PROKLYATE_KUPCOV': "shared/heroes/casts/proklyate_kupcov.png",
	    'CAST_PROKLYATE_LAVOCHNIKOV': "shared/heroes/casts/proklyate_lavochnikov.png",
	    'CAST_PROKLYATE_LESORUBOV': "shared/heroes/casts/proklyate_lesorubov.png",
	    'CAST_PROKLYATE_MAGICHESKIH_BASHEN': "shared/heroes/casts/proklyate_magicheskih_bashen.png",
	    'CAST_PROKLYATE_MANY': "shared/heroes/casts/proklyate_many.png",
	    'CAST_PROKLYATE_MAYAK': "shared/heroes/casts/proklyate_mayak.png",
	    'CAST_PROKLYATE_NASLAT_GOLOD': "shared/heroes/casts/proklyate_naslat_golod.png",
	    'CAST_PROKLYATE_NEUDACHA': "shared/heroes/casts/proklyate_neudacha.png",
	    'CAST_PROKLYATE_OTRAVLENIE_POCHVY': "shared/heroes/casts/proklyate_otravlenie_pochvy.png",
	    'CAST_PROKLYATE_OTSTUPNIKA': "shared/heroes/casts/proklyate_otstupnika.png",
	    'CAST_PROKLYATE_PROVIDENIYA': "shared/heroes/casts/proklyate_provideniya.png",
	    'CAST_PROKLYATE_RAZVOROVYVANIE': "shared/heroes/casts/proklyate_razvorovyvanie.png",
	    'CAST_PROKLYATE_RUDOKOPOV': "shared/heroes/casts/proklyate_rudokopov.png",
	    'CAST_PROKLYATE_SHPIONAJA': "shared/heroes/casts/proklyate_shpionaja.png",
	    'CAST_PROKLYATE_SLABOST_VOISK': "shared/heroes/casts/proklyate_slabost_voisk.png",
	    'CAST_PROKLYATE_SMERT_ISSLEDOVATELYAM': "shared/heroes/casts/proklyate_smert_issledovatelyam.png",
	    'CAST_PROKLYATE_SMERT_KUPCAM': "shared/heroes/casts/proklyate_smert_kupcam.png",
	    'CAST_PROKLYATE_SNIJENIE_ZASCHITY': "shared/heroes/casts/proklyate_snijenie_zaschity.png",
	    'CAST_PROKLYATE_STROITELEI': "shared/heroes/casts/proklyate_stroitelei.png",
	    'CAST_PROKLYATE_TORGOVLI': "shared/heroes/casts/proklyate_torgovli.png",
	    'CAST_PROKLYATE_TRENEROV': "shared/heroes/casts/proklyate_trenerov.png",
	    'CAST_PROKLYATE_UYAZVIMOST': "shared/heroes/casts/proklyate_uyazvimost.png",
	    'CAST_PROKLYATE_ZOLOTOISKATELEI': "shared/heroes/casts/proklyate_zolotoiskatelei.png",
	    'CAST_PROKLYATYE_UKREPLENIYA': "shared/heroes/casts/proklyatye_ukrepleniya.png",
	    'CAST_PROSVETLENIE': "shared/heroes/casts/prosvetlenie.png",
	    'CAST_PROSVETLENIE_SOYUZNIKA': "shared/heroes/casts/prosvetlenie_soyuznika.png",
	    'CAST_PUSTYNNYI_KAMUFLYAJ': "shared/heroes/casts/pustynnyi_kamuflyaj.png",
	    'CAST_PUSTYNNYI_KAMUFLYAJ_CASTLE': "shared/heroes/casts/pustynnyi_kamuflyaj_castle.png",
	    'CAST_RADIUS_ZAKLINANII': "shared/heroes/casts/radius_zaklinanii.png",
	    'CAST_RAM3_CHEST': "shared/heroes/casts/ram3_chest.png",
	    'CAST_RAM3_HEAD': "shared/heroes/casts/ram3_head.png",
	    'CAST_RAM3_ITEM': "shared/heroes/casts/ram3_item.png",
	    'CAST_RAM3_LEFT_HAND': "shared/heroes/casts/ram3_left_hand.png",
	    'CAST_RAM3_NECK': "shared/heroes/casts/ram3_neck.png",
	    'CAST_RAM3_RIGHT_HAND': "shared/heroes/casts/ram3_right_hand.png",
	    'CAST_RASSHIRENIE_MANY': "shared/heroes/casts/rasshirenie_many.png",
	    'CAST_RASSHIRENIE_MISSII': "shared/heroes/casts/rasshirenie_missii.png",
	    'CAST_RASSHIRENIE_STROITELSTVA': "shared/heroes/casts/rasshirenie_stroitelstva.png",
	    'CAST_RASSHIRENIE_STROITELSTVA_CASTLE': "shared/heroes/casts/rasshirenie_stroitelstva_castle.png",
	    'CAST_RAZBORKA_ZDANII': "shared/heroes/casts/razborka_zdanii.png",
	    'CAST_RAZDUT_ARMIYU': "shared/heroes/casts/razdut_armiyu.png",
	    'CAST_RAZDUT_ARMIYU_CASTLE': "shared/heroes/casts/razdut_armiyu_castle.png",
	    'CAST_RAZDUT_ARMIYU_S_GEROEM': "shared/heroes/casts/razdut_armiyu_s_geroem.png",
	    'CAST_RAZGRABLENIE': "shared/heroes/casts/razgrablenie.png",
	    'CAST_RAZGRABLENIE_KOPEI': "shared/heroes/casts/razgrablenie_kopei.png",
	    'CAST_REGENERACIYA_MANY': "shared/heroes/casts/regeneraciya_many.png",
	    'CAST_REKREACIYA_ZEMLI': "shared/heroes/casts/rekreaciya_zemli.png",
	    'CAST_REZERV': "shared/heroes/casts/rezerv.png",
	    'CAST_SABOTAJ_RABOTY': "shared/heroes/casts/sabotaj_raboty.png",
	    'CAST_SABOTAJ_STROITELSTVA': "shared/heroes/casts/sabotaj_stroitelstva.png",
	    'CAST_SABOTAJ_STROITELSTVA_MONSTR': "shared/heroes/casts/sabotaj_stroitelstva_monstr.png",
	    'CAST_SABOTAJ_STROITELSTVA_MONSTR_INFECTION': "shared/heroes/casts/sabotaj_stroitelstva_monstr_infection.png",
	    'CAST_SBOR_TROFEEV': "shared/heroes/casts/sbor_trofeev.png",
	    'CAST_SCARAB_LORD5_CHEST': "shared/heroes/casts/scarab_lord5_chest.png",
	    'CAST_SCARAB_LORD5_HEAD': "shared/heroes/casts/scarab_lord5_head.png",
	    'CAST_SCARAB_LORD5_ITEM': "shared/heroes/casts/scarab_lord5_item.png",
	    'CAST_SCARAB_LORD5_LEFT_HAND': "shared/heroes/casts/scarab_lord5_left_hand.png",
	    'CAST_SHKOLA_MAGII': "shared/heroes/casts/shkola_magii.png",
	    'CAST_SHKOLA_MAGII_CASTLE': "shared/heroes/casts/shkola_magii_castle.png",
	    'CAST_SHRON': "shared/heroes/casts/shron.png",
	    'CAST_SILA_SOYUZNIKU': "shared/heroes/casts/sila_soyuzniku.png",
	    'CAST_SILA_SOYUZNIKU_CASTLE': "shared/heroes/casts/sila_soyuzniku_castle.png",
	    'CAST_SILA_VOISK': "shared/heroes/casts/sila_voisk.png",
	    'CAST_SILA_VOISK_CASTLE': "shared/heroes/casts/sila_voisk_castle.png",
	    'CAST_SILVER4_CHEST': "shared/heroes/casts/silver4_chest.png",
	    'CAST_SILVER4_HEAD': "shared/heroes/casts/silver4_head.png",
	    'CAST_SILVER4_ITEM': "shared/heroes/casts/silver4_item.png",
	    'CAST_SILVER4_LEFT_HAND': "shared/heroes/casts/silver4_left_hand.png",
	    'CAST_SILVER4_RIGHT_HAND': "shared/heroes/casts/silver4_right_hand.png",
	    'CAST_SKOROST_GEROYA': "shared/heroes/casts/skorost_geroya.png",
	    'CAST_SKOVAT_ARMIYU': "shared/heroes/casts/skovat_armiyu.png",
	    'CAST_SKOVAT_GEROYA': "shared/heroes/casts/skovat_geroya.png",
	    'CAST_SLABOST_MAGOV': "shared/heroes/casts/slabost_magov.png",
	    'CAST_SLABOST_MAGOV_CASTLE': "shared/heroes/casts/slabost_magov_castle.png",
	    'CAST_SLABOST_PRESLEDOVATELEI': "shared/heroes/casts/slabost_presledovatelei.png",
	    'CAST_SLABOST_PRESLEDOVATELEI_CASTLE': "shared/heroes/casts/slabost_presledovatelei_castle.png",
	    'CAST_SLABOST_PROTIVNIKA': "shared/heroes/casts/slabost_protivnika.png",
	    'CAST_SLABOST_VSEH_MAGOV': "shared/heroes/casts/slabost_vseh_magov.png",
	    'CAST_SLABOST_VSEH_MAGOV_CASTLE': "shared/heroes/casts/slabost_vseh_magov_castle.png",
	    'CAST_SMENA_SPECIALIZACII': "shared/heroes/casts/smena_specializacii.png",
	    'CAST_SMOLYANYE_CHANY_V_GORODE': "shared/heroes/casts/smolyanye_chany_v_gorode.png",
	    'CAST_SMOLYANYE_CHANY_V_GORODE_CASTLE': "shared/heroes/casts/smolyanye_chany_v_gorode_castle.png",
	    'CAST_SNIJENIE_OPYTA': "shared/heroes/casts/snijenie_opyta.png",
	    'CAST_SNIJENIE_OPYTA_CASTLE': "shared/heroes/casts/snijenie_opyta_castle.png",
	    'CAST_SNYATIE_OTSTUPNIKA': "shared/heroes/casts/snyatie_otstupnika.png",
	    'CAST_SNYATIE_ZVANII': "shared/heroes/casts/snyatie_zvanii.png",
	    'CAST_SODERJANIE_LEKAREI': "shared/heroes/casts/soderjanie_lekarei.png",
	    'CAST_SODERJANIE_LEKAREI_CASTLE': "shared/heroes/casts/soderjanie_lekarei_castle.png",
	    'CAST_SODERJANIE_LETAYUSCHIH': "shared/heroes/casts/soderjanie_letayuschih.png",
	    'CAST_SODERJANIE_LETAYUSCHIH_CASTLE': "shared/heroes/casts/soderjanie_letayuschih_castle.png",
	    'CAST_SODERJANIE_LUCHNIKOV': "shared/heroes/casts/soderjanie_luchnikov.png",
	    'CAST_SODERJANIE_LUCHNIKOV_CASTLE': "shared/heroes/casts/soderjanie_luchnikov_castle.png",
	    'CAST_SODERJANIE_MAGOV': "shared/heroes/casts/soderjanie_magov.png",
	    'CAST_SODERJANIE_MAGOV_CASTLE': "shared/heroes/casts/soderjanie_magov_castle.png",
	    'CAST_SODERJANIE_NAEMNIKOV': "shared/heroes/casts/soderjanie_naemnikov.png",
	    'CAST_SODERJANIE_NAEMNIKOV_CASTLE': "shared/heroes/casts/soderjanie_naemnikov_castle.png",
	    'CAST_SODERJANIE_VOINOV': "shared/heroes/casts/soderjanie_voinov.png",
	    'CAST_SODERJANIE_VOINOV_CASTLE': "shared/heroes/casts/soderjanie_voinov_castle.png",
	    'CAST_SODERJANIE_VSADNIKOV': "shared/heroes/casts/soderjanie_vsadnikov.png",
	    'CAST_SODERJANIE_VSADNIKOV_CASTLE': "shared/heroes/casts/soderjanie_vsadnikov_castle.png",
	    'CAST_SOLDIER3_CHEST': "shared/heroes/casts/soldier3_chest.png",
	    'CAST_SOLDIER3_ITEM': "shared/heroes/casts/soldier3_item.png",
	    'CAST_SOLDIER3_LEFT_HAND': "shared/heroes/casts/soldier3_left_hand.png",
	    'CAST_SOLDIER3_NECK': "shared/heroes/casts/soldier3_neck.png",
	    'CAST_SOLDIER3_RIGHT_HAND': "shared/heroes/casts/soldier3_right_hand.png",
	    'CAST_SOLDIER': "shared/heroes/casts/soldier.png",
	    'CAST_SOZDAT_DEREVO': "shared/heroes/casts/sozdat_derevo.png",
	    'CAST_SOZDAT_JELEZO': "shared/heroes/casts/sozdat_jelezo.png",
	    'CAST_SOZDAT_KAMEN': "shared/heroes/casts/sozdat_kamen.png",
	    'CAST_SOZDAT_NASELENIE': "shared/heroes/casts/sozdat_naselenie.png",
	    'CAST_SOZDAT_ZLAKI': "shared/heroes/casts/sozdat_zlaki.png",
	    'CAST_SOZDAT_ZOLOTO': "shared/heroes/casts/sozdat_zoloto.png",
	    'CAST_SPRINGALD': "shared/heroes/casts/springald.png",
	    'CAST_SPRINGALD_CASTLE': "shared/heroes/casts/springald_castle.png",
	    'CAST_STEPNOI_KAMUFLYAJ': "shared/heroes/casts/stepnoi_kamuflyaj.png",
	    'CAST_STEPNOI_KAMUFLYAJ_CASTLE': "shared/heroes/casts/stepnoi_kamuflyaj_castle.png",
	    'CAST_STONEHENGE_7_BP_SPELL': "shared/heroes/casts/stonehenge_7_bp_spell.png",
	    'CAST_STROITELNYI_BUM': "shared/heroes/casts/stroitelnyi_bum.png",
	    'CAST_SUPERNEKROMANSIYA': "shared/heroes/casts/supernekromansiya.png",
	    'CAST_SUPERNEKROMANSIYA_CASTLE': "shared/heroes/casts/supernekromansiya_castle.png",
	    'CAST_SUPER_DIVERSIYA': "shared/heroes/casts/super_diversiya.png",
	    'CAST_SVERHDALNII_SHPIONAJ': "shared/heroes/casts/sverhdalnii_shpionaj.png",
	    'CAST_SVYAZ_S_SOYUZNIKAMI': "shared/heroes/casts/svyaz_s_soyuznikami.png",
	    'CAST_TAKTIKA_ISPOLZOVANIYA_UKREPLENII': "shared/heroes/casts/taktika_ispolzovaniya_ukreplenii.png",
	    'CAST_TARAN': "shared/heroes/casts/taran.png",
	    'CAST_TELEPORT_GEROYA': "shared/heroes/casts/teleport_geroya.png",
	    'CAST_TELEPORT_RESURSOV': "shared/heroes/casts/teleport_resursov.png",
	    'CAST_TEMPLAR1_CHEST': "shared/heroes/casts/templar1_chest.png",
	    'CAST_TEMPLAR1_FINGER': "shared/heroes/casts/templar1_finger.png",
	    'CAST_TEMPLAR1_HEAD': "shared/heroes/casts/templar1_head.png",
	    'CAST_TEMPLAR1_ITEM': "shared/heroes/casts/templar1_item.png",
	    'CAST_TEMPLAR1_LEFT_HAND': "shared/heroes/casts/templar1_left_hand.png",
	    'CAST_TEMPLAR1_NECK': "shared/heroes/casts/templar1_neck.png",
	    'CAST_TEMPLAR1_RIGHT_HAND': "shared/heroes/casts/templar1_right_hand.png",
	    'CAST_TEMPLAR': "shared/heroes/casts/templar.png",
	    'CAST_TOWER': "shared/heroes/casts/tower.png",
	    'CAST_TREBUCHET': "shared/heroes/casts/trebuchet.png",
	    'CAST_TREBUCHET_CASTLE': "shared/heroes/casts/trebuchet_castle.png",
	    'CAST_TROYANSKII_KON': "shared/heroes/casts/troyanskii_kon.png",
	    'CAST_TROYANSKII_KON_CASTLE': "shared/heroes/casts/troyanskii_kon_castle.png",
	    'CAST_TUMAN': "shared/heroes/casts/tuman.png",
	    'CAST_TUMANNYI_FANTOM': "shared/heroes/casts/tumannyi_fantom.png",
	    'CAST_UDACHA': "shared/heroes/casts/udacha.png",
	    'CAST_UDACHA_CASTLE': "shared/heroes/casts/udacha_castle.png",
	    'CAST_UDACHA_SOYUZNIKU': "shared/heroes/casts/udacha_soyuzniku.png",
	    'CAST_UDACHA_SOYUZNIKU_CASTLE': "shared/heroes/casts/udacha_soyuzniku_castle.png",
	    'CAST_UGROTTO_REWARD_3_CAST': "shared/heroes/casts/ugrotto_reward_3_cast.png",
	    'CAST_UGROTTO_WIN10_ACHIV_CAST': "shared/heroes/casts/ugrotto_win10_achiv_cast.png",
	    'CAST_UJAS': "shared/heroes/casts/ujas.png",
	    'CAST_UJAS_CASTLE': "shared/heroes/casts/ujas_castle.png",
	    'CAST_UKREPIT_ZDANIYA': "shared/heroes/casts/ukrepit_zdaniya.png",
	    'CAST_UKREPIT_ZDANIYA_CASTLE': "shared/heroes/casts/ukrepit_zdaniya_castle.png",
	    'CAST_ULUCHSHENIE_KAMENOLOMEN': "shared/heroes/casts/uluchshenie_kamenolomen.png",
	    'CAST_ULUCHSHENIE_LABORATORII': "shared/heroes/casts/uluchshenie_laboratorii.png",
	    'CAST_ULUCHSHENIE_LAVOK': "shared/heroes/casts/uluchshenie_lavok.png",
	    'CAST_ULUCHSHENIE_LEKAREI': "shared/heroes/casts/uluchshenie_lekarei.png",
	    'CAST_ULUCHSHENIE_LEKAREI_CASTLE': "shared/heroes/casts/uluchshenie_lekarei_castle.png",
	    'CAST_ULUCHSHENIE_LEKAREI_SOYUZNIKA': "shared/heroes/casts/uluchshenie_lekarei_soyuznika.png",
	    'CAST_ULUCHSHENIE_LEKAREI_SOYUZNIKA_CASTLE': "shared/heroes/casts/uluchshenie_lekarei_soyuznika_castle.png",
	    'CAST_ULUCHSHENIE_LESOPILOK': "shared/heroes/casts/uluchshenie_lesopilok.png",
	    'CAST_ULUCHSHENIE_MAGICHESKIH_BASHEN': "shared/heroes/casts/uluchshenie_magicheskih_bashen.png",
	    'CAST_ULUCHSHENIE_MAGICHESKIH_BASHEN_CASTLE': "shared/heroes/casts/uluchshenie_magicheskih_bashen_castle.png",
	    'CAST_ULUCHSHENIE_MAGOV': "shared/heroes/casts/uluchshenie_magov.png",
	    'CAST_ULUCHSHENIE_MELNIC': "shared/heroes/casts/uluchshenie_melnic.png",
	    'CAST_ULUCHSHENIE_OBYCHNYH_BASHEN': "shared/heroes/casts/uluchshenie_obychnyh_bashen.png",
	    'CAST_ULUCHSHENIE_OBYCHNYH_BASHEN_CASTLE': "shared/heroes/casts/uluchshenie_obychnyh_bashen_castle.png",
	    'CAST_ULUCHSHENIE_PRIISKOV': "shared/heroes/casts/uluchshenie_priiskov.png",
	    'CAST_ULUCHSHENIE_RUDNIKOV': "shared/heroes/casts/uluchshenie_rudnikov.png",
	    'CAST_ULUCHSHENIE_VOSKRESITELYA': "shared/heroes/casts/uluchshenie_voskresitelya.png",
	    'CAST_ULUCHSHENIE_ZEMLI': "shared/heroes/casts/uluchshenie_zemli.png",
	    'CAST_ULUCHSHENYI_OTBOR': "shared/heroes/casts/uluchshenyi_otbor.png",
	    'CAST_UNDEAD2_CHEST': "shared/heroes/casts/undead2_chest.png",
	    'CAST_UNDEAD2_FINGER': "shared/heroes/casts/undead2_finger.png",
	    'CAST_UNDEAD2_HEAD': "shared/heroes/casts/undead2_head.png",
	    'CAST_UNDEAD2_LEFT_HAND': "shared/heroes/casts/undead2_left_hand.png",
	    'CAST_UNDEAD2_NECK': "shared/heroes/casts/undead2_neck.png",
	    'CAST_UNDEAD2_RIGHT_HAND': "shared/heroes/casts/undead2_right_hand.png",
	    'CAST_UNDEAD': "shared/heroes/casts/undead.png",
	    'CAST_UNICHTOJITEL_DEMONOV': "shared/heroes/casts/unichtojitel_demonov.png",
	    'CAST_UNICHTOJITEL_DROU': "shared/heroes/casts/unichtojitel_drou.png",
	    'CAST_UNICHTOJITEL_ELFOV': "shared/heroes/casts/unichtojitel_elfov.png",
	    'CAST_UNICHTOJITEL_LYUDEI': "shared/heroes/casts/unichtojitel_lyudei.png",
	    'CAST_UNICHTOJITEL_MONSTROV': "shared/heroes/casts/unichtojitel_monstrov.png",
	    'CAST_UNKNOWN': "shared/heroes/casts/unknown.png",
	    'CAST_UREZANNYI_PAEK': "shared/heroes/casts/urezannyi_paek.png",
	    'CAST_USKORENIE_ISSLEDOVATELEI': "shared/heroes/casts/uskorenie_issledovatelei.png",
	    'CAST_USKORENIE_KUPCOV': "shared/heroes/casts/uskorenie_kupcov.png",
	    'CAST_USKORENIE_PRIEZJIM_KUPCAM': "shared/heroes/casts/uskorenie_priezjim_kupcam.png",
	    'CAST_USKORENIE_STROITELSTVA': "shared/heroes/casts/uskorenie_stroitelstva.png",
	    'CAST_USKORENIE_TRENIROVOK': "shared/heroes/casts/uskorenie_trenirovok.png",
	    'CAST_USKORENIE_TRENIROVOK_CASTLE': "shared/heroes/casts/uskorenie_trenirovok_castle.png",
	    'CAST_USKORENNIY_REMONT': "shared/heroes/casts/uskorenniy_remont.png",
	    'CAST_USKORENNOE_ZASELENIE': "shared/heroes/casts/uskorennoe_zaselenie.png",
	    'CAST_USTOICHIVOST_LEKAREI': "shared/heroes/casts/ustoichivost_lekarei.png",
	    'CAST_USTOICHIVOST_LEKAREI_CASTLE': "shared/heroes/casts/ustoichivost_lekarei_castle.png",
	    'CAST_USTOICHIVOST_LETASCHIH': "shared/heroes/casts/ustoichivost_letaschih.png",
	    'CAST_USTOICHIVOST_LETASCHIH_CASTLE': "shared/heroes/casts/ustoichivost_letaschih_castle.png",
	    'CAST_USTOICHIVOST_MAGOV': "shared/heroes/casts/ustoichivost_magov.png",
	    'CAST_USTOICHIVOST_MAGOV_CASTLE': "shared/heroes/casts/ustoichivost_magov_castle.png",
	    'CAST_USTOICHIVOST_NOSILSCHIKOV': "shared/heroes/casts/ustoichivost_nosilschikov.png",
	    'CAST_USTOICHIVOST_NOSILSCHIKOV_CASTLE': "shared/heroes/casts/ustoichivost_nosilschikov_castle.png",
	    'CAST_USTOICHIVOST_SOYUZNIKOV': "shared/heroes/casts/ustoichivost_soyuznikov.png",
	    'CAST_USTOICHIVOST_SOYUZNIKOV_CASTLE': "shared/heroes/casts/ustoichivost_soyuznikov_castle.png",
	    'CAST_USTOICHIVOST_STRELKOV': "shared/heroes/casts/ustoichivost_strelkov.png",
	    'CAST_USTOICHIVOST_STRELKOV_CASTLE': "shared/heroes/casts/ustoichivost_strelkov_castle.png",
	    'CAST_USTOICHIVOST_VOINOV': "shared/heroes/casts/ustoichivost_voinov.png",
	    'CAST_USTOICHIVOST_VOINOV_CASTLE': "shared/heroes/casts/ustoichivost_voinov_castle.png",
	    'CAST_USTOICHIVOST_VSADNIKOV': "shared/heroes/casts/ustoichivost_vsadnikov.png",
	    'CAST_USTOICHIVOST_VSADNIKOV_CASTLE': "shared/heroes/casts/ustoichivost_vsadnikov_castle.png",
	    'CAST_USTRANENIE_SHTRAFA_ZEMLI': "shared/heroes/casts/ustranenie_shtrafa_zemli.png",
	    'CAST_UVELICHENIE_POVOZOK': "shared/heroes/casts/uvelichenie_povozok.png",
	    'CAST_UYAZVIMOST_NAPADAYUSCHIH': "shared/heroes/casts/uyazvimost_napadayuschih.png",
	    'CAST_UYAZVIMOST_NAPADAYUSCHIH_CASTLE': "shared/heroes/casts/uyazvimost_napadayuschih_castle.png",
	    'CAST_VELIKAYA_KORONA': "shared/heroes/casts/velikaya_korona.png",
	    'CAST_VELIKAYA_MUDROST': "shared/heroes/casts/velikaya_mudrost.png",
	    'CAST_VIRUS': "shared/heroes/casts/virus.png",
	    'CAST_VIRUSNAYA_LOVUSHKA': "shared/heroes/casts/virusnaya_lovushka.png",
	    'CAST_VOINY_PRESLEDOVATELI': "shared/heroes/casts/voiny_presledovateli.png",
	    'CAST_VOINY_PRESLEDOVATELI_CASTLE': "shared/heroes/casts/voiny_presledovateli_castle.png",
	    'CAST_VOLSHEBNOE_DEREVO': "shared/heroes/casts/volshebnoe_derevo.png",
	    'CAST_VOLSHEBNYI_KAMEN': "shared/heroes/casts/volshebnyi_kamen.png",
	    'CAST_VOLSHEBNYI_KOLOS': "shared/heroes/casts/volshebnyi_kolos.png",
	    'CAST_VOLSHEBNYI_SAMORODOK': "shared/heroes/casts/volshebnyi_samorodok.png",
	    'CAST_VOLSHEBNYI_SLITOK': "shared/heroes/casts/volshebnyi_slitok.png",
	    'CAST_VOODUSHEVLENIE_MAGOV': "shared/heroes/casts/voodushevlenie_magov.png",
	    'CAST_VOODUSHEVLENIE_MAGOV_CASTLE': "shared/heroes/casts/voodushevlenie_magov_castle.png",
	    'CAST_VOSSTANOVLENIE_SIL': "shared/heroes/casts/vosstanovlenie_sil.png",
	    'CAST_VSADNIKI_PRESLEDOVATELI': "shared/heroes/casts/vsadniki_presledovateli.png",
	    'CAST_VSADNIKI_PRESLEDOVATELI_CASTLE': "shared/heroes/casts/vsadniki_presledovateli_castle.png",
	    'CAST_VSEOBSCHAYA_NEUDACHA': "shared/heroes/casts/vseobschaya_neudacha.png",
	    'CAST_VSEOBSCHAYA_NEUDACHA_CASTLE': "shared/heroes/casts/vseobschaya_neudacha_castle.png",
	    'CAST_VSEOBSCHAYA_SLABOST': "shared/heroes/casts/vseobschaya_slabost.png",
	    'CAST_VSEOBSCHAYA_SLABOST_CASTLE': "shared/heroes/casts/vseobschaya_slabost_castle.png",
	    'CAST_VSEOBSCHEE_PRESLEDOVANIE': "shared/heroes/casts/vseobschee_presledovanie.png",
	    'CAST_VSEOBSCHEE_PRESLEDOVANIE_CASTLE': "shared/heroes/casts/vseobschee_presledovanie_castle.png",
	    'CAST_VSPLESK_MANY': "shared/heroes/casts/vsplesk_many.png",
	    'CAST_VYNOSLIVOST_ARMII': "shared/heroes/casts/vynoslivost_armii.png",
	    'CAST_VYNOSLIVOST_ARMII_CASTLE': "shared/heroes/casts/vynoslivost_armii_castle.png",
	    'CAST_VYNOSLIVOST_MAGOV': "shared/heroes/casts/vynoslivost_magov.png",
	    'CAST_VYNOSLIVOST_MAGOV_CASTLE': "shared/heroes/casts/vynoslivost_magov_castle.png",
	    'CAST_VYNOSLIVOST_NOSILSCHIKOV': "shared/heroes/casts/vynoslivost_nosilschikov.png",
	    'CAST_VYNOSLIVOST_SOYUZNIKOV': "shared/heroes/casts/vynoslivost_soyuznikov.png",
	    'CAST_VYNOSLIVOST_SOYUZNIKOV_CASTLE': "shared/heroes/casts/vynoslivost_soyuznikov_castle.png",
	    'CAST_VYSOSAT_MANU': "shared/heroes/casts/vysosat_manu.png",
	    'CAST_VYYAVLYAT_VOROTA': "shared/heroes/casts/vyyavlyat_vorota.png",
	    'CAST_WARDER2_CHEST': "shared/heroes/casts/warder2_chest.png",
	    'CAST_WARDER2_HEAD': "shared/heroes/casts/warder2_head.png",
	    'CAST_WARDER2_LEFT_HAND': "shared/heroes/casts/warder2_left_hand.png",
	    'CAST_WARDER2_NECK': "shared/heroes/casts/warder2_neck.png",
	    'CAST_WARDER2_RIGHT_HAND': "shared/heroes/casts/warder2_right_hand.png",
	    'CAST_WINDRIDER1_CHEST': "shared/heroes/casts/windrider1_chest.png",
	    'CAST_WINDRIDER1_FINGER': "shared/heroes/casts/windrider1_finger.png",
	    'CAST_WINDRIDER1_HEAD': "shared/heroes/casts/windrider1_head.png",
	    'CAST_WINDRIDER1_LEFT_HAND': "shared/heroes/casts/windrider1_left_hand.png",
	    'CAST_WINDRIDER1_RIGHT_HAND': "shared/heroes/casts/windrider1_right_hand.png",
	    'CAST_WOLF3_CHEST': "shared/heroes/casts/wolf3_chest.png",
	    'CAST_WOLF3_FINGER': "shared/heroes/casts/wolf3_finger.png",
	    'CAST_WOLF3_HEAD': "shared/heroes/casts/wolf3_head.png",
	    'CAST_WOLF3_LEFT_HAND': "shared/heroes/casts/wolf3_left_hand.png",
	    'CAST_WOLF3_NECK': "shared/heroes/casts/wolf3_neck.png",
	    'CAST_WOLF3_RIGHT_HAND': "shared/heroes/casts/wolf3_right_hand.png",
	    'CAST_YAROST_GOR': "shared/heroes/casts/yarost_gor.png",
	    'CAST_YAROST_GOR_CASTLE': "shared/heroes/casts/yarost_gor_castle.png",
	    'CAST_YAROST_LESA': "shared/heroes/casts/yarost_lesa.png",
	    'CAST_YAROST_LESA_CASTLE': "shared/heroes/casts/yarost_lesa_castle.png",
	    'CAST_YAROST_LETAYUSCHIH_DEMONOV': "shared/heroes/casts/yarost_letayuschih_demonov.png",
	    'CAST_YAROST_LETAYUSCHIH_DROU': "shared/heroes/casts/yarost_letayuschih_drou.png",
	    'CAST_YAROST_LETAYUSCHIH_ELFOV': "shared/heroes/casts/yarost_letayuschih_elfov.png",
	    'CAST_YAROST_LETAYUSCHIH_LYUDEI': "shared/heroes/casts/yarost_letayuschih_lyudei.png",
	    'CAST_YAROST_MAGOV': "shared/heroes/casts/yarost_magov.png",
	    'CAST_YAROST_MERTVOI_ZEMLI_CASTLE': "shared/heroes/casts/yarost_mertvoi_zemli_castle.png",
	    'CAST_YAROST_PROKLYATIH_LESOV_CASTLE': "shared/heroes/casts/yarost_proklyatih_lesov_castle.png",
	    'CAST_YAROST_PUSTYNI': "shared/heroes/casts/yarost_pustyni.png",
	    'CAST_YAROST_PUSTYNI_CASTLE': "shared/heroes/casts/yarost_pustyni_castle.png",
	    'CAST_YAROST_STEPI': "shared/heroes/casts/yarost_stepi.png",
	    'CAST_YAROST_STEPI_CASTLE': "shared/heroes/casts/yarost_stepi_castle.png",
	    'CAST_YAROST_STRELKOV_DEMONOV': "shared/heroes/casts/yarost_strelkov_demonov.png",
	    'CAST_YAROST_STRELKOV_DROU': "shared/heroes/casts/yarost_strelkov_drou.png",
	    'CAST_YAROST_STRELKOV_ELFOV': "shared/heroes/casts/yarost_strelkov_elfov.png",
	    'CAST_YAROST_STRELKOV_LYUDEI': "shared/heroes/casts/yarost_strelkov_lyudei.png",
	    'CAST_YAROST_SVYASHENNOI_ZEMLI_CASTLE': "shared/heroes/casts/yarost_svyashennoi_zemli_castle.png",
	    'CAST_YAROST_VOINOV_DEMONOV': "shared/heroes/casts/yarost_voinov_demonov.png",
	    'CAST_YAROST_VOINOV_DROU': "shared/heroes/casts/yarost_voinov_drou.png",
	    'CAST_YAROST_VOINOV_ELFOV': "shared/heroes/casts/yarost_voinov_elfov.png",
	    'CAST_YAROST_VOINOV_LYUDEI': "shared/heroes/casts/yarost_voinov_lyudei.png",
	    'CAST_YAROST_VOLSHEBNOGO_LESA_CASTLE': "shared/heroes/casts/yarost_volshebnogo_lesa_castle.png",
	    'CAST_YAROST_VSADNIKOV_DEMONOV': "shared/heroes/casts/yarost_vsadnikov_demonov.png",
	    'CAST_YAROST_VSADNIKOV_DROU': "shared/heroes/casts/yarost_vsadnikov_drou.png",
	    'CAST_YAROST_VSADNIKOV_ELFOV': "shared/heroes/casts/yarost_vsadnikov_elfov.png",
	    'CAST_YAROST_VSADNIKOV_LYUDEI': "shared/heroes/casts/yarost_vsadnikov_lyudei.png",
	    'CAST_YAROST_VSEH_LETAYUSCHIH': "shared/heroes/casts/yarost_vseh_letayuschih.png",
	    'CAST_YAROST_VSEH_LETAYUSCHIH_CASTLE': "shared/heroes/casts/yarost_vseh_letayuschih_castle.png",
	    'CAST_YAROST_VSEH_STRELKOV': "shared/heroes/casts/yarost_vseh_strelkov.png",
	    'CAST_YAROST_VSEH_STRELKOV_CASTLE': "shared/heroes/casts/yarost_vseh_strelkov_castle.png",
	    'CAST_YAROST_VSEH_VOINOV': "shared/heroes/casts/yarost_vseh_voinov.png",
	    'CAST_YAROST_VSEH_VOINOV_CASTLE': "shared/heroes/casts/yarost_vseh_voinov_castle.png",
	    'CAST_YAROST_VSEH_VSADNIKOV': "shared/heroes/casts/yarost_vseh_vsadnikov.png",
	    'CAST_YAROST_VSEH_VSADNIKOV_CASTLE': "shared/heroes/casts/yarost_vseh_vsadnikov_castle.png",
	    'CAST_YELLOW3_CHEST': "shared/heroes/casts/yellow3_chest.png",
	    'CAST_YELLOW3_FINGER': "shared/heroes/casts/yellow3_finger.png",
	    'CAST_YELLOW3_HEAD': "shared/heroes/casts/yellow3_head.png",
	    'CAST_YELLOW3_ITEM': "shared/heroes/casts/yellow3_item.png",
	    'CAST_YELLOW3_LEFT_HAND': "shared/heroes/casts/yellow3_left_hand.png",
	    'CAST_YELLOW3_NECK': "shared/heroes/casts/yellow3_neck.png",
	    'CAST_YELLOW3_RIGHT_HAND': "shared/heroes/casts/yellow3_right_hand.png",
	    'CAST_YELLOW': "shared/heroes/casts/yellow.png",
	    'CAST_ZABASTOVKA_ALHIMIKOV': "shared/heroes/casts/zabastovka_alhimikov.png",
	    'CAST_ZABASTOVKA_HLEBOROBOV': "shared/heroes/casts/zabastovka_hleborobov.png",
	    'CAST_ZABASTOVKA_ISSLEDOVATELEI': "shared/heroes/casts/zabastovka_issledovatelei.png",
	    'CAST_ZABASTOVKA_KAMNETESOV': "shared/heroes/casts/zabastovka_kamnetesov.png",
	    'CAST_ZABASTOVKA_LESORUBOV': "shared/heroes/casts/zabastovka_lesorubov.png",
	    'CAST_ZABASTOVKA_RUDOKOPOV': "shared/heroes/casts/zabastovka_rudokopov.png",
	    'CAST_ZABASTOVKA_TRENEROV': "shared/heroes/casts/zabastovka_trenerov.png",
	    'CAST_ZAMASKIROVAT_ARMIYU': "shared/heroes/casts/zamaskirovat_armiyu.png",
	    'CAST_ZAMASKIROVAT_ARMIYU_CASTLE': "shared/heroes/casts/zamaskirovat_armiyu_castle.png",
	    'CAST_ZAMEDLENIE_CASTLE': "shared/heroes/casts/zamedlenie_castle.png",
	    'CAST_ZASCHITA': "shared/heroes/casts/zaschita.png",
	    'CAST_ZASCHITA_CASTLE': "shared/heroes/casts/zaschita_castle.png",
	    'CAST_ZASCHITA_GEROYA_OT_MAGII': "shared/heroes/casts/zaschita_geroya_ot_magii.png",
	    'CAST_ZASCHITA_GEROYA_OT_MAGII_MONSTR': "shared/heroes/casts/zaschita_geroya_ot_magii_monstr.png",
	    'CAST_ZASCHITA_GEROYA_OT_NAPADENII_MONSTROV': "shared/heroes/casts/zaschita_geroya_ot_napadenii_monstrov.png",
	    'CAST_ZASCHITA_MAGOV': "shared/heroes/casts/zaschita_magov.png",
	    'CAST_ZASCHITA_MAGOV_CASTLE': "shared/heroes/casts/zaschita_magov_castle.png",
	    'CAST_ZASCHITA_OT_MARODERSTVA_CASTLE': "shared/heroes/casts/zaschita_ot_maroderstva_castle.png",
	    'CAST_ZASCHITA_OT_SBORA_TROFEEV_CASTLE': "shared/heroes/casts/zaschita_ot_sbora_trofeev_castle.png",
	    'CAST_ZASCHITA_OT_UKREPLENII': "shared/heroes/casts/zaschita_ot_ukreplenii.png",
	    'CAST_ZASCHITA_SOYUZNIKU': "shared/heroes/casts/zaschita_soyuzniku.png",
	    'CAST_ZASCHITA_VLADENIYA_OT_MAGII': "shared/heroes/casts/zaschita_vladeniya_ot_magii.png",
	    'CAST_ZASCHITA_VLADENIYA_OT_MAGII_CASTLE': "shared/heroes/casts/zaschita_vladeniya_ot_magii_castle.png",
	    'CAST_ZASCHITA_VLADENIYA_OT_NAPADENII_MONSTROV': "shared/heroes/casts/zaschita_vladeniya_ot_napadenii_monstrov.png",
	    'CAST_ZAVESCHANIE_MONSTROV': "shared/heroes/casts/zaveschanie_monstrov.png",
	    'CAST_ZAVESCHANIE_MONSTROV_MONSTR': "shared/heroes/casts/zaveschanie_monstrov_monstr.png",
	    'CAST_ZEMLETRYASENIE': "shared/heroes/casts/zemletryasenie.png",
	    'CAST_ZEMLETRYASENIE_CASTLE': "shared/heroes/casts/zemletryasenie_castle.png",
	    'CAST_ZLAKI_LYUDEI': "shared/heroes/casts/zlaki_lyudei.png",
	    'CAST_ZNANIE_POVADOK_MONSTROV': "shared/heroes/casts/znanie_povadok_monstrov.png",
	    'CAST_ZNANIE_SLABYH_MEST_MONSTROV': "shared/heroes/casts/znanie_slabyh_mest_monstrov.png"

		//autogenerated text ends here
	}
}

Assets.getRaceAssets = function(r)
{
	switch((r || Race.MONSTER).name)
	{
		case Race.DEMON.name:
			return {
				buildings : this.Demon.Buildings,
				cards : this.Demon.Cards,
				specific : this.Demon.Specific
			};
		case Race.DROW.name:
			return {
				buildings : this.Drow.Buildings,
				cards : this.Drow.Cards,
				specific : this.Drow.Specific
			};
		case Race.ELF.name:
			return {
				buildings : this.Elf.Buildings,
				cards : this.Elf.Cards,
				specific : this.Elf.Specific
			};
		case Race.HUMAN.name:
			return {
				buildings : this.Human.Buildings,
				cards : this.Human.Cards,
				specific : this.Human.Specific
			};
		case Race.CASTLE_MONSTER.name:
		case Race.MONSTER.name:
			return {
				buildings : this.Monster.Buildings,
				cards : this.Monster.Cards,
				specific : this.Monster.Specific
			};
	}
	return null;
}

Assets.ICON_findBy = function(r)
{
	switch (r.name)
	{
		case Resource.WOOD.name:
			//return FConfig.isNewYearAssets() ? CommonAssets.ICON_WOOD_NY : CommonAssets.ICON_WOOD;
			return CommonAssets.ICON_WOOD;
		case Resource.GRAIN.name:
			return CommonAssets.ICON_GRAIN;
		case Resource.STONE.name:
			return CommonAssets.ICON_STONE;
		case Resource.IRON.name:
			return CommonAssets.ICON_IRON;
		case Resource.GOLD.name:
			return CommonAssets.ICON_GOLD;
		case Resource.PEOPLE.name:
			return null;
		default:
			throw Error("Unknown resource: " + r);
	}
}

Assets.getCellResource = function(r, isReachable)
{
	switch(r.name)
	{
		case Resource.GRAIN.name:
			return isReachable ? CommonAssets.CELL_GRAIN : CommonAssets.CELL_GRAIN_UNREACHABLE;
		case Resource.STONE.name:
			return isReachable ? CommonAssets.CELL_STONE : CommonAssets.CELL_STONE_UNREACHABLE;
		case Resource.IRON.name:
			return isReachable ? CommonAssets.CELL_IRON : CommonAssets.CELL_IRON_UNREACHABLE;
		case Resource.GOLD.name:
			return CommonAssets.CELL_GOLD;
		default:
			throw Error("Unknown resource: " + r);
	}
}

Assets.getMineHall = function(r)
{
	switch(r.name)
	{
		case Resource.STONE.name:
			return Assets.OuterBuildings.MINEHALL_STONE;
		case Resource.IRON.name:
			return Assets.OuterBuildings.MINEHALL_IRON;
		case Resource.GOLD.name:
			return Assets.OuterBuildings.MINEHALL_GOLD;
		default:
			throw Error("Unknown resource: " + r.name);
	}
}

Assets.B_findByOrNull = function(r, bt, res, skin, suffix)
{
	var ra = Assets.getRaceAssets(r);
	switch (bt.name)
	{
		case BType.MINEHALL.name:
			return Assets.getMineHall(res);
		case BType.EVILHALL.name:
			return FConfig.isNewYearAssets() ? Assets.OuterBuildings.EVILHALL_NY : Assets.OuterBuildings.EVILHALL;
		case BType.PITHALL.name:
		case BType.RUINHALL.name:
		case BType.LAKEHALL.name:
		case BType.ABANDONED_MERCHANT.name:
		case BType.GROTTOHALL.name:
		case BType.CAMPHALL.name:
		case BType.GRAILHALL.name:
		case BType.STONEHENGEHALL.name:
		case BType.CATAPULTHALL.name:
			return Assets.OuterBuildings[bt.name];
		case BType.CITYHALL.name:
			return ra.buildings[(FConfig.isNewYearAssets() ? "CITYHALL_NY_" : "CITYHALL_") + skin];
		case BType.CASTLEHALL.name:
			return ra.buildings["CASTLEHALL_" + skin];
		default:
			return ra.buildings[bt.name + (!suffix ? "" : "_" + suffix)];
	}
}

Assets.B_findBy = function(r, bt, res, skin, suffix)
{
	var result = Assets.B_findByOrNull(r, bt, res, skin, suffix);
	if (result == null)
	{
		throw Error("Unknown BuildingType: (" + r.name + ") " + bt.name + (suffix == null ? "" : "_" + suffix));
	}
	return result;
}

Assets.getMineIcon = function(r)
{
	switch (r.name)
	{
		case Resource.STONE.name:
			return Assets.ICON_MINE_STONE;
		case Resource.IRON.name:
			return Assets.ICON_MINE_IRON;
		case Resource.GOLD.name:
			return Assets.ICON_MINE_GOLD;
		default:
			throw Error("Unknown mine: " + r);
	}
}

Assets.WALL_23_OPEN = function(r, isBroken)
{
	if (r.name != Race.CASTLE_MONSTER.name && isBroken)
	{
		return Assets.getRaceAssets(r).specific.WALL_23_OPEN_BROKEN;
	}
	else
	{
		return Assets.getRaceAssets(r).specific.WALL_23_OPEN;
	}
}

Assets.WALL_23_CLOSED = function(r)
{
	return Assets.getRaceAssets(r).specific.WALL_23_CLOSED;
}

Assets.getAllPeopleIcon = function(race)
{
	return Assets.getRaceAssets(race).specific.PEOPLE_ALL;
}

Assets.getFreePeopleIcon = function(race)
{
	return Assets.getRaceAssets(race).specific.PEOPLE_FREE;
}

Assets.getBusyPeopleIcon = function(race)
{
	return Assets.getRaceAssets(race).specific.PEOPLE_BUSY;
}

Assets.getAdvisor = function(r)
{
	var cards = Assets.getRaceAssets(r).cards;
	
    var res = FConfig.isNewYearAssets() ? cards.ADVISOR_NY : cards.ADVISOR;
    if (!res) res = "";
    return res;
}

Assets.getAdvisorAnimated = function(r)
{
	return Assets.getAdvisor(r);
}

Assets.getUnitTypeIcon = function(utype)
{
	return CommonAssets["UNIT_TYPE_" + utype.name];
}

Assets.getScienceImage = function(s)
{
	return CommonAssets["SCIENCE_" + (s ? s.name : "")];
}

Assets.getDisabledScienceImage = function(s)
{
	return CommonAssets["SCIENCE_DIS_" + s.name];
}

Assets.getSpellImage = function(s)
{
	return Assets.getSkillImage(s);
}

Assets.getSpellImageForScroll = function(s)
{
	return Assets.getSkillImage(s);
}

Assets.getSkillImageRaw = function(s)
{
	var pic = SkillAssets["SKILL_" + s];

    if (pic)
    {
        return pic;
    }

    s = s.replace("_INFECTION", "").replace("_ANCIENT", "");
    pic = SkillAssets["SKILL_" + s];
    if (!pic)
    {
        pic = SkillAssets["SKILL_" + s + "_PASSIVE"];
    }
    return pic ? pic : SkillAssets.SKILL_UNKNOWN;
};

Assets.getSkillImage = function(s)
{
	var pic = Assets.getSkillImageRaw(s);
	return pic ? pic : SkillAssets.SKILL_UNKNOWN;
};

Assets.getArtifactSpellImage = function(s)
{
    var pic = ArtifactAssets[s];

    if (pic)
    {
        return pic;
    }

    s = s.replace("_INFECTION", "").replace("_ANCIENT", "");
    pic = ArtifactAssets[s];
    return pic;
};

Assets.getKingdomCityImage = function(r, skinIndex)
{
	return KingdomAssets[r.name + "_CITY_" + skinIndex];
}

Assets.getKingdomOuterEstateImage = function(estate)
{
	switch(estate.type.name)
	{
		case EstateType.PIT.name:
			return KingdomAssets.PIT;
		case EstateType.MINE.name:
			return KingdomAssets["MINE_" + estate.resources[0].name];
		case EstateType.LAKE.name:
			return KingdomAssets.LAKE;
		case EstateType.RUIN.name:
			return KingdomAssets.RUIN;
		case EstateType.CAMP.name:
			return KingdomAssets.CAMP;
		case EstateType.EVIL.name:
			return KingdomAssets.EVIL;
		case EstateType.GROTTO.name:
			return KingdomAssets.GROTTO;
		case EstateType.GRAIL.name:
		    return KingdomAssets.GRAIL;
		case EstateType.STONEHENGE.name:
		    return KingdomAssets.STONEHENGE;
		case EstateType.CATAPULT.name:
		    return KingdomAssets.CATAPULT;
		case EstateType.CASTLE.name:
			return KingdomAssets["CASTLE_" + estate.skinIndex];
		default:
			throw Error("Unknown estate type " + state.type.name);
	}
}

Assets.getUnitBackFor = function(r, mini)
{
	var asset = Assets.getRaceAssets(r);
	if (!asset.cards)
	{
		throw Error("There is no cards for race " + r.name);
	}
	var res = mini ? asset.cards.BACK_MINI : asset.cards.BACK;

	if (!res)
	{
		throw Error("There is no back image for race " + r.name);
	}
	return res;
}

Assets.getGiftImage = function(name)
{
	var result = GiftAssets["GIFT_" + name.toUpperCase()];
	if (!result)
	{
		return GiftAssets.GIFT_MEDAL;
	}

	return result;
}

Assets.getHeroFace = function(heroFace)
{
	return CommonHeroAssets[heroFace];
}

Assets.getHeroBack = function(r)
{
	return (r && r.name != Race.CASTLE_MONSTER.name) ? CommonHeroAssets["HERO_BACK_" + r.name] : CommonHeroAssets["HERO_BACK_MONSTER"];
}

Assets.getLockedHero = function(r)
{
	return Assets.getRaceAssets(r).cards.BACK_HERO;
}

Assets.getHeroDollBack = function(h)
{
	if (!h) return HeroAssets.HERO_DOLL_BACK_MALE;
	return h.male ? HeroAssets.HERO_DOLL_BACK_MALE : HeroAssets.HERO_DOLL_BACK_FEMALE;
}

Assets.getUnitImageFor = function(r, ut, level)
{
	if(typeof level == "undefined") level = 0;
	var res = Assets.getRaceAssets(r).cards[ut.name + "_" + UnitType.normalize(level)];
	if (!res)
	{
		throw Error("There is no image for unit type " + ut.name + " race " + r.name + " level " + level);
	}
	return res;
}

Assets.getUnitBorderFor = function(r, level)
{
    return Assets.getRaceAssets(r).cards["UNIT_BORDER_" + UnitType.normalize(level)];
};

Assets.getUnitBorderClassFor = function(r, level)
{
    return level < 4 ? "" : "level4";
};

Assets.getSkillStub = function(heroClass)
{
	return SkillAssets["SKILL_STUB_" + heroClass];
};

Assets.B_locked = function(r)
{
	return CommonAssets.LOCKED_BUILDING;
};

Assets.getArtifact = function(a)
{
	var pic = ArtifactAssets[a.pic.replace("_GLOW", "")];
	return pic || ArtifactAssets['UNKNOWN_ARTIFACT_' + a.level] || ArtifactAssets.UNKNOWN_ARTIFACT;
};

Assets.hasGlow = function(a)
{
    return Strings.endsWith(a.pic, "_GLOW");
};

Assets.getScroll = function(a)
{
	return ArtifactAssets["SCROLL_" + a.level];
};

Assets.getTowerImageFor = function(r, bt, level, mini)
{
    if (level < 1)
    {
        return Assets.getUnitBackFor(r, mini);
    }
    var type = mini ? bt.name + "_MINI" : bt.name;
    var res = Assets.getRaceAssets(r).cards[type];
    if (!res)
    {
        throw Error("There is no tower image "+bt.name+" for race "+r.name+" level " + level);
    }
    return res;
}

Assets.getCastImage = function(s)
{
	if (!s)
	{
		s = "";
	}
	var pic = CommonHeroAssets["CAST_" + s];
	if (pic)
	{
		return pic;
	}
	s = s.replace("_INFECTION", "");
	pic = CommonHeroAssets["CAST_" + s];
	if (pic)
	{
		return pic;
	}
	s = s.replace("_PASSIVE", "");
	s = s.replace("_ANCIENT", "");
	pic = CommonHeroAssets["CAST_" + s];
	if (pic)
	{
		return pic;
	}
	return CommonHeroAssets.CAST_UNKNOWN;
}
var CommonHeroAssets = Assets.Heroes;

var HeroAssets =
{
	//heroes
	SELECT_HERO_ARROW_LEFT : "shared/heroes/arrow_left.png",
	SELECT_HERO_ARROW_RIGHT : "shared/heroes/arrow_right.png",
	HERO_DOLL_BACK_MALE : "shared/heroes/hero_doll_back_male.png",
	HERO_DOLL_BACK_FEMALE : "shared/heroes/hero_doll_back_female.png",
	ARTIFACT_SLOT : "shared/heroes/artifact_slot.png",
	ARTIFACT_SLOT_SIMPLE : "shared/heroes/artifact_slot_simple.png",
	DELETE_HERO : "shared/heroes/button_deleteHero.png",

	//dialogs
	DIALOG_LEFT_BOTTOM : "shared/heroes/dialog/left_bottom.png",
	DIALOG_RIGHT_BOTTOM : "shared/heroes/dialog/right_bottom.png",
	DIALOG_LEFT_TOP : "shared/heroes/dialog/left_top.png",
	DIALOG_RIGHT_TOP : "shared/heroes/dialog/right_top.png",
	DIALOG_LINE_BOTTOM : "shared/heroes/dialog/line_bottom.png",
	DIALOG_LINE_LEFT : "shared/heroes/dialog/line_left.png",
	DIALOG_LINE_RIGHT : "shared/heroes/dialog/line_right.png",
	DIALOG_LINE_TOP : "shared/heroes/dialog/line_top.png",

	BOX_BACK_TEXTURE : "shared/heroes/box/back_texture.jpg",
	BOX_LEFT_BOTTOM : "shared/heroes/box/line_corner_left_bottom.png",
	BOX_RIGHT_BOTTOM : "shared/heroes/box/line_corner_right_bottom.png",
	BOX_LEFT_TOP : "shared/heroes/box/line_corner_left_top.png",
	BOX_RIGHT_TOP : "shared/heroes/box/line_corner_right_top.png",
	BOX_LINE_BOTTOM : "shared/heroes/box/line_hero_bottom.png",
	BOX_LINE_LEFT : "shared/heroes/box/line_hero_left.png",
	BOX_LINE_RIGHT : "shared/heroes/box/line_hero_right.png",
	BOX_LINE_TOP : "shared/heroes/box/line_hero_top.png",

	TRADER : "shared/heroes/dialog/trader.png",
	ARTIFACT_STORE : "shared/heroes/dialog/artifact_store.png",
	REDISTRIBUTE_SKILLS_BUTTON : "shared/heroes/redistribution_skills.png",
	ALTAR : "shared/heroes/pentagram.png",
	RUNE_MASTER : "shared/heroes/dialog/runemaster.jpg",

	ARTIFACT_SET_SALE : "shared/heroes/artifact_set_sale.png",

	ADD_BRANCH_BUTTON : "shared/heroes/button_new_branch.png",
	ADD_BRANCH_BUTTON_ANIMATION : "shared/heroes/button_new_branch.swf",

	TIMER_LOCK : "shared/heroes/timer_lock.png"
}

var GiftAssets =
{
	GIFT_FLOWER : "shared/gifts/good/flower.png",
	GIFT_MEDAL : "shared/gifts/good/medal.png",
	GIFT_BEER : "shared/gifts/good/pivo.png",
	GIFT_BLACK : "shared/gifts/bad/black.png",
	GIFT_MONEY : "shared/gifts/bad/money.png",
	GIFT_GUILLOTINE : "shared/gifts/bad/giliotina.png",
	GIFT_PRIDE : "shared/gifts/bad/pride.png",
	GIFT_VUDU : "shared/gifts/bad/vudu.png",

	GIFT_DAR_BOGOV : "shared/gifts/good/dar_bogov1.png",
	GIFT_DAR_BOGOV_2 : "shared/gifts/good/dar_bogov2.png",
	GIFT_DAR_BOGOV_3 : "shared/gifts/good/dar_bogov3.png",
	GIFT_FRACTION_ADMIRAL_1 : "shared/gifts/good/fractionadmiral1.png",
	GIFT_FRACTION_ADMIRAL_2 : "shared/gifts/good/fractionadmiral2.png",
	GIFT_FRACTION_ADMIRAL_3 : "shared/gifts/good/fractionadmiral3.png",
	GIFT_FRACTION_VETERAN_1 : "shared/gifts/good/fractionveteran1.png",
	GIFT_FRACTION_VETERAN_2 : "shared/gifts/good/fractionveteran2.png",
	GIFT_FRACTION_VETERAN_3 : "shared/gifts/good/fractionveteran3.png",
	GIFT_LOOT_1 : "shared/gifts/good/grabeg1.png",
	GIFT_LOOT_2 : "shared/gifts/good/grabeg2.png",
	GIFT_LOOT_3 : "shared/gifts/good/grabeg3.png",
	GIFT_CLAN_1 : "shared/gifts/good/klan1.png",
	GIFT_CLAN_2 : "shared/gifts/good/klan2.png",
	GIFT_CLAN_3 : "shared/gifts/good/klan3.png",
	GIFT_CLAN_ARMY_1 : "shared/gifts/good/klan_army1.png",
	GIFT_CLAN_ARMY_2 : "shared/gifts/good/klan_army2.png",
	GIFT_CLAN_ARMY_3 : "shared/gifts/good/klan_army3.png",
	GIFT_CLAN_ARMY_ORDER_1 : "shared/gifts/good/klan_army_orden1.png",
	GIFT_CLAN_ARMY_ORDER_2 : "shared/gifts/good/klan_army_orden2.png",
	GIFT_CLAN_ARMY_ORDER_3 : "shared/gifts/good/klan_army_orden3.png",
	GIFT_CLAN_ORDER_1 : "shared/gifts/good/klan_orden1.png",
	GIFT_CLAN_ORDER_2 : "shared/gifts/good/klan_orden2.png",
	GIFT_CLAN_ORDER_3 : "shared/gifts/good/klan_orden3.png",
	GIFT_PIT_VETERAN_1 : "shared/gifts/good/kop_veteran1.png",
	GIFT_PIT_VETERAN_2 : "shared/gifts/good/kop_veteran2.png",
	GIFT_PIT_VETERAN_3 : "shared/gifts/good/kop_veteran3.png",
	GIFT_MERCHANT_1 : "shared/gifts/good/kupec1.png",
	GIFT_MERCHANT_2 : "shared/gifts/good/kupec2.png",
	GIFT_MERCHANT_3 : "shared/gifts/good/kupec3.png",
	GIFT_MEDAL_BRONZE : "shared/gifts/good/medal_bronza.png",
	GIFT_MEDAL_GOLD : "shared/gifts/good/medal_gold.png",
	GIFT_MEDAL_GOLD_SPY : "shared/gifts/good/medal_gold_spy.png",
	GIFT_MEDAL_SILVER : "shared/gifts/good/medal_silver.png",
	GIFT_DESTROY_BUILDING_1 : "shared/gifts/good/razrush_zdaniy1.png",
	GIFT_DESTROY_BUILDING_2 : "shared/gifts/good/razrush_zdaniy2.png",
	GIFT_DESTROY_BUILDING_3 : "shared/gifts/good/razrush_zdaniy3.png",
	GIFT_RUIN_VETERAN_1 : "shared/gifts/good/ruinveteran1.png",
	GIFT_RUIN_VETERAN_2 : "shared/gifts/good/ruinveteran2.png",
	GIFT_RUIN_VETERAN_3 : "shared/gifts/good/ruinveteran3.png",
	GIFT_LAKE_VETERAN_1 : "shared/gifts/good/sol_ozera_veteran1.png",
	GIFT_LAKE_VETERAN_2 : "shared/gifts/good/sol_ozera_veteran2.png",
	GIFT_LAKE_VETERAN_3 : "shared/gifts/good/sol_ozera_veteran3.png",
	GIFT_GROUP_ATTACK_1 : "shared/gifts/good/sovmes_ataka1.png",
	GIFT_GROUP_ATTACK_2 : "shared/gifts/good/sovmes_ataka2.png",
	GIFT_GROUP_ATTACK_3 : "shared/gifts/good/sovmes_ataka3.png",
	GIFT_SPY_1 : "shared/gifts/good/spy1.png",
	GIFT_SPY_2 : "shared/gifts/good/spy2.png",
	GIFT_SPY_3 : "shared/gifts/good/spy3.png",
	GIFT_BUILDING_1 : "shared/gifts/good/stroyka1.png",
	GIFT_BUILDING_2 : "shared/gifts/good/stroyka2.png",
	GIFT_BUILDING_3 : "shared/gifts/good/stroyka3.png",
	GIFT_SUPER_ORDEN : "shared/gifts/good/superorden.png",
	GIFT_TRADER_1 : "shared/gifts/good/torgovec1.png",
	GIFT_TRADER_2 : "shared/gifts/good/torgovec2.png",
	GIFT_TRADER_3 : "shared/gifts/good/torgovec3.png",
	GIFT_SLAVE_TAKING_1 : "shared/gifts/good/ugon_rabov1.png",
	GIFT_SLAVE_TAKING_2 : "shared/gifts/good/ugon_rabov2.png",
	GIFT_SLAVE_TAKING_3 : "shared/gifts/good/ugon_rabov3.png",
	GIFT_MISS_ML_1 : "shared/gifts/good/miss1.png",
	GIFT_MISS_ML_2 : "shared/gifts/good/miss2.png",
	GIFT_MISS_ML_3 : "shared/gifts/good/miss3.png",
	GIFT_MISTER_ML_1 : "shared/gifts/good/mister1.png",
	GIFT_MISTER_ML_2 : "shared/gifts/good/mister2.png",
	GIFT_MISTER_ML_3 : "shared/gifts/good/mister3.png",
	GIFT_SCROLL : "shared/gifts/good/svitok.png",
	GIFT_SCROLL_1 : "shared/gifts/good/svitok1.png",
	GIFT_SCROLL_2 : "shared/gifts/good/svitok2.png",
	GIFT_SCROLL_3 : "shared/gifts/good/svitok3.png",

	GIFT_NY_BALL : "shared/gifts/good/NY_ball.png",
	GIFT_NY_BUNNY : "shared/gifts/good/NY_bunny.png",
	GIFT_NY_CHAMPAGNE : "shared/gifts/good/NY_Champagne.png",
	GIFT_NY_PRESENTS : "shared/gifts/good/NY_presents.png",
	GIFT_NY_SANTA : "shared/gifts/good/NY_Santa.png",
	GIFT_NY_SNOWFLAKE : "shared/gifts/good/NY_snowflake.png",

	GIFT_14FEBR_HEART : "shared/gifts/good/14febr_heart.png",
	GIFT_23FEBR_1 : "shared/gifts/good/23febr_1.png",
	GIFT_23FEBR_2 : "shared/gifts/good/23febr_2.png",
	GIFT_DEFENDER : "shared/gifts/good/defender.png",
	GIFT_NIMBUS : "shared/gifts/good/nimbus.png",
	GIFT_WREATH : "shared/gifts/good/wreath.png",
	GIFT_APRIL1 : "shared/gifts/good/april1.png",

	GIFT_DANCE : "shared/gifts/bastille/dance.png",
	GIFT_EIFFEL_TOWER : "shared/gifts/bastille/eiffel_tower.png",
	GIFT_FRENCH_FLAG : "shared/gifts/bastille/french_flag.png",
	GIFT_FRENCH_MARCHING : "shared/gifts/bastille/french_marching.png",
	GIFT_FRENCH_WOMAN : "shared/gifts/bastille/french_woman.png",
	GIFT_KNIGHT_WITH_FRENCH_FLAG : "shared/gifts/bastille/knight_with_french_flag.png",

	GIFT_ITALIAN_BALLOONS : "shared/gifts/ferragosto/italian_balloons.png",
	GIFT_ITALIAN_BEACH : "shared/gifts/ferragosto/italian_beach.png",
	GIFT_ITALIAN_FIREWORKS : "shared/gifts/ferragosto/italian_fireworks.png",
	GIFT_ITALIAN_FLAG : "shared/gifts/ferragosto/italian_flag.png",
	GIFT_KNIGHT_ON_THE_BEACH : "shared/gifts/ferragosto/knight_on_the_beach.png",
	GIFT_SUNNY_ITALY : "shared/gifts/ferragosto/sunny_italy.png",

	GIFT_TOURNAMENT : "shared/gifts/good/tournament_win.png",
	GIFT_TOURNAMENT_GROTTO : "shared/gifts/good/tournament_grotto_win.png",
	GIFT_FRAGS : "shared/gifts/good/frags.png",

	GIFT_DRAGON : "shared/gifts/bad/dragon.png",
	GIFT_STRIKE : "shared/gifts/bad/strike.png",
	GIFT_SCHELBAN : "shared/gifts/bad/schelban.png",
	GIFT_SPY_KILLER : "shared/gifts/bad/spy_killer.png",
	GIFT_NINJA : "shared/gifts/good/ninja.png",
	GIFT_THRONE : "shared/gifts/good/throne.png",
	GIFT_KONAN : "shared/gifts/good/konan.png",
	GIFT_YOUNG_KNIGHT : "shared/gifts/good/young_knight.png",

	GIFT_SNOW_BALL2 : "shared/gifts/holiday/snow_ball2.png",
	GIFT_OLEN : "shared/gifts/holiday/olen.png",
	GIFT_ANGEL : "shared/gifts/holiday/angel.png",
	GIFT_ANGEL_TRUMPET : "shared/gifts/holiday/angel_trumpet.png",
	GIFT_MONSTER_ELKA : "shared/gifts/holiday/monster_elka.png",
	GIFT_MONSTERS : "shared/gifts/holiday/monsters.png",
	GIFT_SANTA_ARBALET : "shared/gifts/holiday/santa_arbalet.png",
	GIFT_SANTA_SUPERHERO : "shared/gifts/holiday/santa_superhero.png",

	GIFT_DRAZNILKA : "shared/gifts/bad/draznilka.png",
	GIFT_MONSTR_HA_HA : "shared/gifts/bad/monstr_ha_ha.png",
	GIFT_TACHKA_CHEREPA : "shared/gifts/bad/tachka_cherepa.png",
	GIFT_BLACK_GEM : "shared/gifts/good/black_gem.png",
	GIFT_HERO_HORSE : "shared/gifts/good/hero_horse.png",
	GIFT_TORTIK3 : "shared/gifts/good/tortik3.png",

	GIFT_CAKE : "shared/gifts/valentine/cake.png",
	GIFT_CANDIES : "shared/gifts/valentine/candies.png",
	GIFT_DANCING_BEARS : "shared/gifts/valentine/dancing_bears.png",

	GIFT_DRAGON_HEART : "shared/gifts/valentine/dragon_heart.png",
	GIFT_FIELD_FLOWERS : "shared/gifts/valentine/field_flowers.png",
	GIFT_FLYING_TEDDY : "shared/gifts/valentine/flying_teddy.png",
	GIFT_HEART_BUTTERFLIES : "shared/gifts/valentine/heart_butterflies.png",
	GIFT_ORCHID : "shared/gifts/valentine/orchid.png",
	GIFT_PEGASUS : "shared/gifts/valentine/pegasus.png",
	GIFT_SUPERMACHO : "shared/gifts/valentine/supermacho.png",
	GIFT_TEDDY_BEAR : "shared/gifts/valentine/teddy_bear.png",
	GIFT_KNIGHT_FLOWERS : "shared/gifts/valentine/knight_flowers.png",

	GIFT_CLOVER : "shared/gifts/stpatrick/clover.png",
	GIFT_COINS : "shared/gifts/stpatrick/coins.png",
	GIFT_GOLDPOT : "shared/gifts/stpatrick/goldpot.png",
	GIFT_GREEN_BEER : "shared/gifts/stpatrick/greenbeer.png",
	GIFT_LEPRECHAUN_BAGPIPE : "shared/gifts/stpatrick/leprechaunbagpipe.png",
	GIFT_LEPRECHAUN_GOLD : "shared/gifts/stpatrick/leprechaungold.png",

	GIFT_GOLD_MENTOR : "shared/gifts/mentor/gold_mentor.png",
	GIFT_SILVER_MENTOR : "shared/gifts/mentor/silver_mentor.png",

	GIFT_GOLD_PRISON : "shared/gifts/hero/gold_prison.png",
	GIFT_SILVER_PRISON : "shared/gifts/hero/silver_prison.png",

	GIFT_HERO46 : "shared/gifts/hero/hero46.png",
	GIFT_HERO_1SPELL100 : "shared/gifts/hero/hero_1spell100.png",
	GIFT_HERO_2SPELL100 : "shared/gifts/hero/hero_2spell100.png",
	GIFT_HERO_3SPELL100 : "shared/gifts/hero/hero_3spell100.png",
	GIFT_HERO_4SPELL100 : "shared/gifts/hero/hero_4spell100.png",
	GIFT_HERO_5SPELL100 : "shared/gifts/hero/hero_5spell100.png",
	GIFT_HERO_ARTMEDAL : "shared/gifts/hero/hero_artmedal.png",
	GIFT_HERO_DES : "shared/gifts/hero/hero_des.png",
	GIFT_HERO_EXP : "shared/gifts/hero/hero_exp.png",
	GIFT_HERO_GRAB : "shared/gifts/hero/hero_grab.png",
	GIFT_HERO_KILLER : "shared/gifts/hero/hero_killer.png",
	GIFT_HERO_MANA : "shared/gifts/hero/hero_mana.png",
	GIFT_HERO_MONSTER100 : "shared/gifts/hero/hero_monster100.png",
	GIFT_HERO_OSV : "shared/gifts/hero/hero_osv.png",
	GIFT_HERO_RUINART : "shared/gifts/hero/hero_ruinart.png",
	GIFT_HERO_RUINSCROLL : "shared/gifts/hero/hero_ruinscroll.png",
	GIFT_HERO_SDES : "shared/gifts/hero/hero_sdes.png",
	GIFT_HERO_SGRAB : "shared/gifts/hero/hero_sgrab.png",
	GIFT_HERO_SOSV : "shared/gifts/hero/hero_sosv.png",
	GIFT_HERO_SPELL100 : "shared/gifts/hero/hero_spell100.png",
	GIFT_HERO_SZAH : "shared/gifts/hero/hero_szah.png",
	GIFT_HERO_ZAH : "shared/gifts/hero/hero_zah.png",

	GIFT_OF_ACCORDION : "shared/gifts/Octoberfest/accordion.png",
	GIFT_OF_BARREL : "shared/gifts/Octoberfest/Barrel.png",
	GIFT_OF_BEER_BARREL : "shared/gifts/Octoberfest/Beer_barrel.png",
	GIFT_OF_BEER_GIRL : "shared/gifts/Octoberfest/beer_girl.png",
	GIFT_OF_BEER_PINT : "shared/gifts/Octoberfest/beer_pint.png",
	GIFT_OF_BRUDERSHAFT : "shared/gifts/Octoberfest/BruderShaft.png",

	GIFT_HELLO_BATS : "shared/gifts/Helloween/Bats.png",
	GIFT_HELLO_BLACK_CAT : "shared/gifts/Helloween/BlackCat.png",
	GIFT_HELLO_GHOST : "shared/gifts/Helloween/Ghost.png",
	GIFT_HELLO_SKULL : "shared/gifts/Helloween/Skull.png",
	GIFT_HELLO_SPIDER : "shared/gifts/Helloween/Spider.png",
	GIFT_HELLO_WITCH : "shared/gifts/Helloween/Witch.png",
	GIFT_HELLO_EYE : "shared/gifts/Helloween/Eye.png",
	GIFT_HELLO_PUMPKIN : "shared/gifts/Helloween/pampkin.png",

	GIFT_EASTER_CHICKEN : "shared/gifts/Easter/Chicken.png",
	GIFT_EASTER_EGG1 : "shared/gifts/Easter/Egg1.png",
	GIFT_EASTER_EGG2 : "shared/gifts/Easter/Egg2.png",
	GIFT_EASTER_EGGML : "shared/gifts/Easter/EggML.png",
	GIFT_EASTER_EGG_HERO : "shared/gifts/Easter/Egg_Hero.png",
	GIFT_EASTER_ANGEL_LAMB : "shared/gifts/Easter/Angel_Lamb.png",
	GIFT_EASTER_CHOCOLATE_RABBIT : "shared/gifts/Easter/ChocolateRabbit.png",
	GIFT_EASTER_RABBIT_HERBAL : "shared/gifts/Easter/Rabbit_Herbal.png",
	GIFT_EASTER_SIMNEL : "shared/gifts/Easter/Simnel.png",

	GIFT_9MAY_ETERNAL_FLAME : "shared/gifts/9_May/9may_Eternal_flame.png",
	GIFT_9MAY_FLAG_KNIGHT : "shared/gifts/9_May/9may_Flag_Knight.png",
	GIFT_9MAY_MEDAL : "shared/gifts/9_May/9may_medal.png",
	GIFT_9MAY_PARADE : "shared/gifts/9_May/9may_Parade.png",

	GIFT_8MARCH_1 : "shared/gifts/8_March/8_march_1.png",
	GIFT_8MARCH_2 : "shared/gifts/8_March/8_march_2.png",
	GIFT_8MARCH_HERBERS : "shared/gifts/8_March/Herbers.png",
	GIFT_8MARCH_KNIGHT_COOK_CAKE : "shared/gifts/8_March/KnightCookCake.png",

	GIFT_MLD_BALLONS : "shared/gifts/MyLands_Day/Ballons_MyLands.png",
	GIFT_MLD_FIREWORKS : "shared/gifts/MyLands_Day/Fireworks_MyLands.png",
	GIFT_MLD_PARADE : "shared/gifts/MyLands_Day/Parade_MyLands.png",
	GIFT_MLD_EGG_DRAGON : "shared/gifts/MyLands_Day/Egg_dragon_MyLands.png",

	GIFT_KB_LAMB : "shared/gifts/KurbanBayram/lamb.png",
	GIFT_KB_LAMB_BOW : "shared/gifts/KurbanBayram/lamb_bow.png",
	GIFT_KB_GOLD_RAM : "shared/gifts/KurbanBayram/gold_ram.png",
	GIFT_KB_KNIGHT_LAMB : "shared/gifts/KurbanBayram/Knight_lamb.png",
	GIFT_KB_MEAT : "shared/gifts/KurbanBayram/Meat.png",
	GIFT_KB_ST_SOFIA : "shared/gifts/KurbanBayram/StSofia.png",

	GIFT_MEDAL_BROTHERHOOD : "shared/gifts/good/medal_brotherhood.png",
	GIFT_HERO_IN_CHAINS : "shared/gifts/good/medal_hero_in_chains.png",

	FRIEND_HELPER : "shared/gifts/socnetwork/friend_helper.png",
	FRIEND_RECRUITER : "shared/gifts/socnetwork/friend_recruiter.png"
}

var ArtifactAssets =
{
    "UNKNOWN_ARTIFACT" : "shared/artifacts/unknown.png",
    "UNKNOWN_ARTIFACT_1" : "shared/artifacts/unknown_1.png",
    "UNKNOWN_ARTIFACT_2" : "shared/artifacts/unknown_2.png",
    "UNKNOWN_ARTIFACT_3" : "shared/artifacts/unknown_3.png",
    "UNKNOWN_ARTIFACT_4" : "shared/artifacts/unknown_4.png",
    "UNKNOWN_ARTIFACT_5" : "shared/artifacts/unknown_5.png",
    "UNDEFINED_ITEM" : "shared/artifacts/undefined.png",
    "ARTIFACT_UPGRADE_EFFECT" : "shared/artifacts/artifact_upgrade_effect.swf",
    "ARTIFACT_UPGRADE_EFFECT_STATIC" : "shared/artifacts/artifact_upgrade_effect.png",
    "ELEKSIR_MANI_1" : "shared/artifacts/mana1.png",
    "ELEKSIR_MANI_2" : "shared/artifacts/mana2.png",
    "ELEKSIR_MANI_3" : "shared/artifacts/mana3.png",
    "ELEKSIR_MANI_4" : "shared/artifacts/mana4.png",
    "ELEKSIR_MANI_5" : "shared/artifacts/mana5.png",
    "ELEKSIR_OPITA_1" : "shared/artifacts/exp1.png",
    "ELEKSIR_OPITA_2" : "shared/artifacts/exp2.png",
    "ELEKSIR_OPITA_3" : "shared/artifacts/exp3.png",
    "ELEKSIR_OPITA_4" : "shared/artifacts/exp4.png",
    "ELEKSIR_OPITA_5" : "shared/artifacts/exp5.png",
    "RED_CRYSTAL" : "shared/artifacts/red_crystal.png",
    "GREEN_CRYSTAL" : "shared/artifacts/green_crystal.png",
    "BLUE_CRYSTAL" : "shared/artifacts/blue_crystal.png",
    "YELLOW_CRYSTAL" : "shared/artifacts/yellow_crystal.png",
    "PINK_CRYSTAL" : "shared/artifacts/pink_crystal.png",
    "RUNE_EO" : "shared/artifacts/rune/eo.png",
    "RUNE_F" : "shared/artifacts/rune/f.png",
    "RUNE_H" : "shared/artifacts/rune/h.png",
    "RUNE_IA" : "shared/artifacts/rune/ia.png",
    "RUNE_R" : "shared/artifacts/rune/r.png",
    "RUNE_T" : "shared/artifacts/rune/t.png",
    "RUNE_TH" : "shared/artifacts/rune/th.png",
    "RUNE_U" : "shared/artifacts/rune/u.png",
    "RUNE_X" : "shared/artifacts/rune/x.png",
    "RUNE_EO_PASSIVE" : "shared/artifacts/rune/eo_icon.png",
    "RUNE_F_PASSIVE" : "shared/artifacts/rune/f_icon.png",
    "RUNE_H_PASSIVE" : "shared/artifacts/rune/h_icon.png",
    "RUNE_IA_PASSIVE" : "shared/artifacts/rune/ia_icon.png",
    "RUNE_R_PASSIVE" : "shared/artifacts/rune/r_icon.png",
    "RUNE_T_PASSIVE" : "shared/artifacts/rune/t_icon.png",
    "RUNE_TH_PASSIVE" : "shared/artifacts/rune/th_icon.png",
    "RUNE_U_PASSIVE" : "shared/artifacts/rune/u_icon.png",
    "RUNE_X_PASSIVE" : "shared/artifacts/rune/x_icon.png",
    "SCROLL_1" : "shared/slots/scroll_1.png",
    "SCROLL_2" : "shared/slots/scroll_2.png",
    "SCROLL_3" : "shared/slots/scroll_3.png",
    "SCROLL_4" : "shared/slots/scroll_4.png",
    "SCROLL_5" : "shared/slots/scroll_5.png",
    "ELVEN1_CHEST" : "shared/artifacts/1/elven/wear.png",
    "ELVEN1_FINGER" : "shared/artifacts/1/elven/ring.png",
    "ELVEN1_HEAD" : "shared/artifacts/1/elven/helmet.png",
    "ELVEN1_ITEM" : "shared/artifacts/1/elven/item.png",
    "ELVEN1_LEFT_HAND" : "shared/artifacts/1/elven/weapon.png",
    "ELVEN1_LEGS" : "shared/artifacts/1/elven/footwear.png",
    "ELVEN1_NECK" : "shared/artifacts/1/elven/necklace.png",
    "ELVEN1_WAIST" : "shared/artifacts/1/elven/belt.png",
    "FORRESTER1_CHEST" : "shared/artifacts/1/forrester/wear.png",
    "FORRESTER1_FINGER" : "shared/artifacts/1/forrester/ring.png",
    "FORRESTER1_HEAD" : "shared/artifacts/1/forrester/helmet.png",
    "FORRESTER1_ITEM" : "shared/artifacts/1/forrester/item.png",
    "FORRESTER1_LEFT_HAND" : "shared/artifacts/1/forrester/weapon.png",
    "FORRESTER1_LEGS" : "shared/artifacts/1/forrester/footwear.png",
    "FORRESTER1_NECK" : "shared/artifacts/1/forrester/necklace.png",
    "FORRESTER1_RIGHT_HAND" : "shared/artifacts/1/forrester/shield.png",
    "FORRESTER1_WAIST" : "shared/artifacts/1/forrester/belt.png",
    "PATHFINDER1_CHEST" : "shared/artifacts/1/pathfinder/wear.png",
    "PATHFINDER1_FINGER" : "shared/artifacts/1/pathfinder/ring.png",
    "PATHFINDER1_HEAD" : "shared/artifacts/1/pathfinder/helmet.png",
    "PATHFINDER1_ITEM" : "shared/artifacts/1/pathfinder/item.png",
    "PATHFINDER1_LEFT_HAND" : "shared/artifacts/1/pathfinder/weapon.png",
    "PATHFINDER1_LEGS" : "shared/artifacts/1/pathfinder/footwear.png",
    "PATHFINDER1_NECK" : "shared/artifacts/1/pathfinder/necklace.png",
    "PATHFINDER1_RIGHT_HAND" : "shared/artifacts/1/pathfinder/shield.png",
    "PATHFINDER1_WAIST" : "shared/artifacts/1/pathfinder/belt.png",
    "TEMPLAR1_CHEST" : "shared/artifacts/1/templar/wear.png",
    "TEMPLAR1_FINGER" : "shared/artifacts/1/templar/ring.png",
    "TEMPLAR1_HEAD" : "shared/artifacts/1/templar/helmet.png",
    "TEMPLAR1_ITEM" : "shared/artifacts/1/templar/item.png",
    "TEMPLAR1_LEFT_HAND" : "shared/artifacts/1/templar/weapon.png",
    "TEMPLAR1_LEGS" : "shared/artifacts/1/templar/footwear.png",
    "TEMPLAR1_NECK" : "shared/artifacts/1/templar/necklace.png",
    "TEMPLAR1_RIGHT_HAND" : "shared/artifacts/1/templar/shield.png",
    "TEMPLAR1_WAIST" : "shared/artifacts/1/templar/belt.png",
    "WINDRIDER1_CHEST" : "shared/artifacts/1/windrider/wear.png",
    "WINDRIDER1_FINGER" : "shared/artifacts/1/windrider/ring.png",
    "WINDRIDER1_HEAD" : "shared/artifacts/1/windrider/helmet.png",
    "WINDRIDER1_ITEM" : "shared/artifacts/1/windrider/item.png",
    "WINDRIDER1_LEFT_HAND" : "shared/artifacts/1/windrider/weapon.png",
    "WINDRIDER1_LEGS" : "shared/artifacts/1/windrider/footwear.png",
    "WINDRIDER1_NECK" : "shared/artifacts/1/windrider/necklace.png",
    "WINDRIDER1_RIGHT_HAND" : "shared/artifacts/1/windrider/shield.png",
    "WINDRIDER1_WAIST" : "shared/artifacts/1/windrider/belt.png",
    "ARABIAN2_CHEST" : "shared/artifacts/2/arabian/wear.png",
    "ARABIAN2_FINGER" : "shared/artifacts/2/arabian/ring.png",
    "ARABIAN2_HEAD" : "shared/artifacts/2/arabian/helmet.png",
    "ARABIAN2_ITEM" : "shared/artifacts/2/arabian/item.png",
    "ARABIAN2_LEFT_HAND" : "shared/artifacts/2/arabian/weapon.png",
    "ARABIAN2_LEGS" : "shared/artifacts/2/arabian/footwear.png",
    "ARABIAN2_NECK" : "shared/artifacts/2/arabian/necklace.png",
    "ARABIAN2_RIGHT_HAND" : "shared/artifacts/2/arabian/shield.png",
    "ARABIAN2_WAIST" : "shared/artifacts/2/arabian/belt.png",
    "ARCHER2_CHEST" : "shared/artifacts/2/archer/wear.png",
    "ARCHER2_FINGER" : "shared/artifacts/2/archer/ring.png",
    "ARCHER2_HEAD" : "shared/artifacts/2/archer/helmet.png",
    "ARCHER2_ITEM" : "shared/artifacts/2/archer/item.png",
    "ARCHER2_LEFT_HAND" : "shared/artifacts/2/archer/weapon.png",
    "ARCHER2_LEGS" : "shared/artifacts/2/archer/footwear.png",
    "ARCHER2_NECK" : "shared/artifacts/2/archer/necklace.png",
    "ARCHER2_WAIST" : "shared/artifacts/2/archer/belt.png",
    "ASASSIN2_CHEST" : "shared/artifacts/2/asassin/wear.png",
    "ASASSIN2_FINGER" : "shared/artifacts/2/asassin/ring.png",
    "ASASSIN2_HEAD" : "shared/artifacts/2/asassin/helmet.png",
    "ASASSIN2_ITEM" : "shared/artifacts/2/asassin/item.png",
    "ASASSIN2_LEFT_HAND" : "shared/artifacts/2/asassin/weapon.png",
    "ASASSIN2_LEGS" : "shared/artifacts/2/asassin/footwear.png",
    "ASASSIN2_NECK" : "shared/artifacts/2/asassin/necklace.png",
    "ASASSIN2_RIGHT_HAND" : "shared/artifacts/2/asassin/weapon_offhand.png",
    "ASASSIN2_WAIST" : "shared/artifacts/2/asassin/belt.png",
    "BARBARIAN2_CHEST" : "shared/artifacts/2/barbarian/wear.png",
    "BARBARIAN2_FINGER" : "shared/artifacts/2/barbarian/ring.png",
    "BARBARIAN2_HEAD" : "shared/artifacts/2/barbarian/helmet.png",
    "BARBARIAN2_ITEM" : "shared/artifacts/2/barbarian/item.png",
    "BARBARIAN2_LEFT_HAND" : "shared/artifacts/2/barbarian/weapon.png",
    "BARBARIAN2_LEGS" : "shared/artifacts/2/barbarian/footwear.png",
    "BARBARIAN2_NECK" : "shared/artifacts/2/barbarian/necklace.png",
    "BARBARIAN2_RIGHT_HAND" : "shared/artifacts/2/barbarian/weapon_offhand.png",
    "BARBARIAN2_WAIST" : "shared/artifacts/2/barbarian/belt.png",
    "BEAST2_CHEST" : "shared/artifacts/2/beast/wear.png",
    "BEAST2_FINGER" : "shared/artifacts/2/beast/ring.png",
    "BEAST2_HEAD" : "shared/artifacts/2/beast/helmet.png",
    "BEAST2_ITEM" : "shared/artifacts/2/beast/item.png",
    "BEAST2_LEFT_HAND" : "shared/artifacts/2/beast/weapon.png",
    "BEAST2_LEGS" : "shared/artifacts/2/beast/footwear.png",
    "BEAST2_NECK" : "shared/artifacts/2/beast/necklace.png",
    "BEAST2_RIGHT_HAND" : "shared/artifacts/2/beast/weapon_offhand.png",
    "BEAST2_WAIST" : "shared/artifacts/2/beast/belt.png",
    "CHAINMAIL2_CHEST" : "shared/artifacts/2/chainmail/wear.png",
    "CHAINMAIL2_FINGER" : "shared/artifacts/2/chainmail/ring.png",
    "CHAINMAIL2_HEAD" : "shared/artifacts/2/chainmail/helmet.png",
    "CHAINMAIL2_ITEM" : "shared/artifacts/2/chainmail/item.png",
    "CHAINMAIL2_LEFT_HAND" : "shared/artifacts/2/chainmail/weapon.png",
    "CHAINMAIL2_LEGS" : "shared/artifacts/2/chainmail/footwear.png",
    "CHAINMAIL2_NECK" : "shared/artifacts/2/chainmail/necklace.png",
    "CHAINMAIL2_RIGHT_HAND" : "shared/artifacts/2/chainmail/weapon_offhand.png",
    "CHAINMAIL2_WAIST" : "shared/artifacts/2/chainmail/belt.png",
    "FROST_STEEL2_CHEST" : "shared/artifacts/2/frost_steel/wear.png",
    "FROST_STEEL2_FINGER" : "shared/artifacts/2/frost_steel/ring.png",
    "FROST_STEEL2_HEAD" : "shared/artifacts/2/frost_steel/helmet.png",
    "FROST_STEEL2_ITEM" : "shared/artifacts/2/frost_steel/item.png",
    "FROST_STEEL2_LEFT_HAND" : "shared/artifacts/2/frost_steel/weapon.png",
    "FROST_STEEL2_LEGS" : "shared/artifacts/2/frost_steel/footwear.png",
    "FROST_STEEL2_NECK" : "shared/artifacts/2/frost_steel/necklace.png",
    "FROST_STEEL2_RIGHT_HAND" : "shared/artifacts/2/frost_steel/weapon_offhand.png",
    "FROST_STEEL2_WAIST" : "shared/artifacts/2/frost_steel/belt.png",
    "IRON2_CHEST" : "shared/artifacts/2/iron/wear.png",
    "IRON2_FINGER" : "shared/artifacts/2/iron/ring.png",
    "IRON2_HEAD" : "shared/artifacts/2/iron/helmet.png",
    "IRON2_ITEM" : "shared/artifacts/2/iron/artefact.png",
    "IRON2_LEFT_HAND" : "shared/artifacts/2/iron/weapon.png",
    "IRON2_LEGS" : "shared/artifacts/2/iron/footwear.png",
    "IRON2_NECK" : "shared/artifacts/2/iron/necklace.png",
    "IRON2_RIGHT_HAND" : "shared/artifacts/2/iron/weapon_offhand.png",
    "IRON2_WAIST" : "shared/artifacts/2/iron/belt.png",
    "LATTICE2_CHEST" : "shared/artifacts/2/lattice/wear.png",
    "LATTICE2_FINGER" : "shared/artifacts/2/lattice/ring.png",
    "LATTICE2_HEAD" : "shared/artifacts/2/lattice/helmet.png",
    "LATTICE2_ITEM" : "shared/artifacts/2/lattice/item.png",
    "LATTICE2_LEFT_HAND" : "shared/artifacts/2/lattice/weapon.png",
    "LATTICE2_LEGS" : "shared/artifacts/2/lattice/footwear.png",
    "LATTICE2_NECK" : "shared/artifacts/2/lattice/necklace.png",
    "LATTICE2_RIGHT_HAND" : "shared/artifacts/2/lattice/weapon_offhand.png",
    "LATTICE2_WAIST" : "shared/artifacts/2/lattice/belt.png",
    "LOGGER2_CHEST" : "shared/artifacts/2/logger/wear.png",
    "LOGGER2_FINGER" : "shared/artifacts/2/logger/ring.png",
    "LOGGER2_HEAD" : "shared/artifacts/2/logger/helmet.png",
    "LOGGER2_ITEM" : "shared/artifacts/2/logger/item.png",
    "LOGGER2_LEFT_HAND" : "shared/artifacts/2/logger/weapon.png",
    "LOGGER2_LEGS" : "shared/artifacts/2/logger/footwear.png",
    "LOGGER2_NECK" : "shared/artifacts/2/logger/necklace.png",
    "LOGGER2_RIGHT_HAND" : "shared/artifacts/2/logger/shield.png",
    "LOGGER2_WAIST" : "shared/artifacts/2/logger/belt.png",
    "MARINE2_CHEST" : "shared/artifacts/2/marine/wear.png",
    "MARINE2_FINGER" : "shared/artifacts/2/marine/ring.png",
    "MARINE2_HEAD" : "shared/artifacts/2/marine/helmet.png",
    "MARINE2_ITEM" : "shared/artifacts/2/marine/item.png",
    "MARINE2_LEFT_HAND" : "shared/artifacts/2/marine/weapon.png",
    "MARINE2_LEGS" : "shared/artifacts/2/marine/footwear.png",
    "MARINE2_NECK" : "shared/artifacts/2/marine/necklace.png",
    "MARINE2_WAIST" : "shared/artifacts/2/marine/belt.png",
    "UNDEAD2_CHEST" : "shared/artifacts/2/undead/wear.png",
    "UNDEAD2_FINGER" : "shared/artifacts/2/undead/ring.png",
    "UNDEAD2_HEAD" : "shared/artifacts/2/undead/helmet.png",
    "UNDEAD2_ITEM" : "shared/artifacts/2/undead/item.png",
    "UNDEAD2_LEFT_HAND" : "shared/artifacts/2/undead/weapon.png",
    "UNDEAD2_LEGS" : "shared/artifacts/2/undead/footwear.png",
    "UNDEAD2_NECK" : "shared/artifacts/2/undead/necklace.png",
    "UNDEAD2_RIGHT_HAND" : "shared/artifacts/2/undead/weapon_offhand.png",
    "UNDEAD2_WAIST" : "shared/artifacts/2/undead/belt.png",
    "WARDER2_CHEST" : "shared/artifacts/2/warder/wear.png",
    "WARDER2_FINGER" : "shared/artifacts/2/warder/ring.png",
    "WARDER2_HEAD" : "shared/artifacts/2/warder/helmet.png",
    "WARDER2_ITEM" : "shared/artifacts/2/warder/item.png",
    "WARDER2_LEFT_HAND" : "shared/artifacts/2/warder/weapon.png",
    "WARDER2_LEGS" : "shared/artifacts/2/warder/footwear.png",
    "WARDER2_NECK" : "shared/artifacts/2/warder/necklace.png",
    "WARDER2_RIGHT_HAND" : "shared/artifacts/2/warder/weapon_offhand.png",
    "WARDER2_WAIST" : "shared/artifacts/2/warder/belt.png",
    "BLOODY_STEEL3_CHEST" : "shared/artifacts/3/bloody_steel/wear.png",
    "BLOODY_STEEL3_FINGER" : "shared/artifacts/3/bloody_steel/ring.png",
    "BLOODY_STEEL3_HEAD" : "shared/artifacts/3/bloody_steel/helmet.png",
    "BLOODY_STEEL3_ITEM" : "shared/artifacts/3/bloody_steel/item.png",
    "BLOODY_STEEL3_LEFT_HAND" : "shared/artifacts/3/bloody_steel/weapon.png",
    "BLOODY_STEEL3_LEGS" : "shared/artifacts/3/bloody_steel/footwear.png",
    "BLOODY_STEEL3_NECK" : "shared/artifacts/3/bloody_steel/necklace.png",
    "BLOODY_STEEL3_RIGHT_HAND" : "shared/artifacts/3/bloody_steel/weapon_offhand.png",
    "BLOODY_STEEL3_WAIST" : "shared/artifacts/3/bloody_steel/belt.png",
    "COLD3_CHEST" : "shared/artifacts/3/cold/torso.png",
    "COLD3_FINGER" : "shared/artifacts/3/cold/ring.png",
    "COLD3_HEAD" : "shared/artifacts/3/cold/helmet.png",
    "COLD3_ITEM" : "shared/artifacts/3/cold/item.png",
    "COLD3_LEFT_HAND" : "shared/artifacts/3/cold/weapon.png",
    "COLD3_LEGS" : "shared/artifacts/3/cold/footwear.png",
    "COLD3_NECK" : "shared/artifacts/3/cold/necklace.png",
    "COLD3_RIGHT_HAND" : "shared/artifacts/3/cold/weapon_offhand.png",
    "COLD3_WAIST" : "shared/artifacts/3/cold/belt.png",
    "CONQUISTADOR3_CHEST" : "shared/artifacts/3/conquistador/wear.png",
    "CONQUISTADOR3_FINGER" : "shared/artifacts/3/conquistador/ring.png",
    "CONQUISTADOR3_HEAD" : "shared/artifacts/3/conquistador/head.png",
    "CONQUISTADOR3_ITEM" : "shared/artifacts/3/conquistador/item.png",
    "CONQUISTADOR3_LEFT_HAND" : "shared/artifacts/3/conquistador/weapon.png",
    "CONQUISTADOR3_LEGS" : "shared/artifacts/3/conquistador/feet.png",
    "CONQUISTADOR3_NECK" : "shared/artifacts/3/conquistador/necklace.png",
    "CONQUISTADOR3_RIGHT_HAND" : "shared/artifacts/3/conquistador/shield.png",
    "CONQUISTADOR3_WAIST" : "shared/artifacts/3/conquistador/belt.png",
    "CRIMSON3_CHEST" : "shared/artifacts/3/crimson/wear.png",
    "CRIMSON3_FINGER" : "shared/artifacts/3/crimson/ring.png",
    "CRIMSON3_HEAD" : "shared/artifacts/3/crimson/helmet.png",
    "CRIMSON3_ITEM" : "shared/artifacts/3/crimson/item.png",
    "CRIMSON3_LEFT_HAND" : "shared/artifacts/3/crimson/weapon.png",
    "CRIMSON3_LEGS" : "shared/artifacts/3/crimson/footwear.png",
    "CRIMSON3_NECK" : "shared/artifacts/3/crimson/necklace.png",
    "CRIMSON3_RIGHT_HAND" : "shared/artifacts/3/crimson/weapon_offhand.png",
    "CRIMSON3_WAIST" : "shared/artifacts/3/crimson/belt.png",
    "GREEN3_CHEST" : "shared/artifacts/3/green/wear.png",
    "GREEN3_FINGER" : "shared/artifacts/3/green/ring.png",
    "GREEN3_HEAD" : "shared/artifacts/3/green/helmet.png",
    "GREEN3_ITEM" : "shared/artifacts/3/green/item.png",
    "GREEN3_LEFT_HAND" : "shared/artifacts/3/green/weapon.png",
    "GREEN3_LEGS" : "shared/artifacts/3/green/footwear.png",
    "GREEN3_NECK" : "shared/artifacts/3/green/necklace.png",
    "GREEN3_RIGHT_HAND" : "shared/artifacts/3/green/weapon_offhand.png",
    "GREEN3_WAIST" : "shared/artifacts/3/green/belt.png",
    "HAMMER3_CHEST" : "shared/artifacts/3/hammer/wear.png",
    "HAMMER3_FINGER" : "shared/artifacts/3/hammer/ring.png",
    "HAMMER3_HEAD" : "shared/artifacts/3/hammer/helmet.png",
    "HAMMER3_ITEM" : "shared/artifacts/3/hammer/item.png",
    "HAMMER3_LEFT_HAND" : "shared/artifacts/3/hammer/weapon.png",
    "HAMMER3_LEGS" : "shared/artifacts/3/hammer/footwear.png",
    "HAMMER3_NECK" : "shared/artifacts/3/hammer/necklace.png",
    "HAMMER3_RIGHT_HAND" : "shared/artifacts/3/hammer/weapon_offhand.png",
    "HAMMER3_WAIST" : "shared/artifacts/3/hammer/belt.png",
    "JESTER3_CHEST" : "shared/artifacts/3/jester/wear.png",
    "JESTER3_FINGER" : "shared/artifacts/3/jester/ring.png",
    "JESTER3_HEAD" : "shared/artifacts/3/jester/helmet.png",
    "JESTER3_ITEM" : "shared/artifacts/3/jester/item.png",
    "JESTER3_LEFT_HAND" : "shared/artifacts/3/jester/weapon.png",
    "JESTER3_LEGS" : "shared/artifacts/3/jester/footwear.png",
    "JESTER3_NECK" : "shared/artifacts/3/jester/necklace.png",
    "JESTER3_WAIST" : "shared/artifacts/3/jester/belt.png",
    "KING3_CHEST" : "shared/artifacts/3/king/wear.png",
    "KING3_FINGER" : "shared/artifacts/3/king/ring.png",
    "KING3_HEAD" : "shared/artifacts/3/king/helmet.png",
    "KING3_ITEM" : "shared/artifacts/3/king/item.png",
    "KING3_LEFT_HAND" : "shared/artifacts/3/king/weapon.png",
    "KING3_LEGS" : "shared/artifacts/3/king/footwear.png",
    "KING3_NECK" : "shared/artifacts/3/king/necklace.png",
    "KING3_RIGHT_HAND" : "shared/artifacts/3/king/weapon_offhand.png",
    "KING3_WAIST" : "shared/artifacts/3/king/belt.png",
    "LEGIONARY3_CHEST" : "shared/artifacts/3/legionary/wear.png",
    "LEGIONARY3_FINGER" : "shared/artifacts/3/legionary/ring.png",
    "LEGIONARY3_HEAD" : "shared/artifacts/3/legionary/helmet.png",
    "LEGIONARY3_ITEM" : "shared/artifacts/3/legionary/item.png",
    "LEGIONARY3_LEFT_HAND" : "shared/artifacts/3/legionary/weapon.png",
    "LEGIONARY3_LEGS" : "shared/artifacts/3/legionary/footwear.png",
    "LEGIONARY3_NECK" : "shared/artifacts/3/legionary/necklace.png",
    "LEGIONARY3_RIGHT_HAND" : "shared/artifacts/3/legionary/weapon_offhand.png",
    "LEGIONARY3_WAIST" : "shared/artifacts/3/legionary/belt.png",
    "RAM3_CHEST" : "shared/artifacts/3/ram/wear.png",
    "RAM3_FINGER" : "shared/artifacts/3/ram/ring.png",
    "RAM3_HEAD" : "shared/artifacts/3/ram/helmet.png",
    "RAM3_ITEM" : "shared/artifacts/3/ram/item.png",
    "RAM3_LEFT_HAND" : "shared/artifacts/3/ram/weapon.png",
    "RAM3_LEGS" : "shared/artifacts/3/ram/footwear.png",
    "RAM3_NECK" : "shared/artifacts/3/ram/necklace.png",
    "RAM3_RIGHT_HAND" : "shared/artifacts/3/ram/weapon_offhand.png",
    "RAM3_WAIST" : "shared/artifacts/3/ram/belt.png",
    "SOLDIER3_CHEST" : "shared/artifacts/3/soldier/wear.png",
    "SOLDIER3_FINGER" : "shared/artifacts/3/soldier/ring.png",
    "SOLDIER3_HEAD" : "shared/artifacts/3/soldier/helmet.png",
    "SOLDIER3_ITEM" : "shared/artifacts/3/soldier/item.png",
    "SOLDIER3_LEFT_HAND" : "shared/artifacts/3/soldier/weapon.png",
    "SOLDIER3_LEGS" : "shared/artifacts/3/soldier/footwear.png",
    "SOLDIER3_NECK" : "shared/artifacts/3/soldier/necklace.png",
    "SOLDIER3_RIGHT_HAND" : "shared/artifacts/3/soldier/weapon_offhand.png",
    "SOLDIER3_WAIST" : "shared/artifacts/3/soldier/belt.png",
    "WOLF3_CHEST" : "shared/artifacts/3/wolf/wear.png",
    "WOLF3_FINGER" : "shared/artifacts/3/wolf/ring.png",
    "WOLF3_HEAD" : "shared/artifacts/3/wolf/helmet.png",
    "WOLF3_ITEM" : "shared/artifacts/3/wolf/item.png",
    "WOLF3_LEFT_HAND" : "shared/artifacts/3/wolf/weapon.png",
    "WOLF3_LEGS" : "shared/artifacts/3/wolf/footwear.png",
    "WOLF3_NECK" : "shared/artifacts/3/wolf/necklace.png",
    "WOLF3_RIGHT_HAND" : "shared/artifacts/3/wolf/weapon_offhand.png",
    "WOLF3_WAIST" : "shared/artifacts/3/wolf/belt.png",
    "YELLOW3_CHEST" : "shared/artifacts/3/yellow/wear.png",
    "YELLOW3_FINGER" : "shared/artifacts/3/yellow/ring.png",
    "YELLOW3_HEAD" : "shared/artifacts/3/yellow/helmet.png",
    "YELLOW3_ITEM" : "shared/artifacts/3/yellow/item.png",
    "YELLOW3_LEFT_HAND" : "shared/artifacts/3/yellow/weapon.png",
    "YELLOW3_LEGS" : "shared/artifacts/3/yellow/footwear.png",
    "YELLOW3_NECK" : "shared/artifacts/3/yellow/necklace.png",
    "YELLOW3_RIGHT_HAND" : "shared/artifacts/3/yellow/weapon_offhand.png",
    "YELLOW3_WAIST" : "shared/artifacts/3/yellow/belt.png",
    "ARBALET4_CHEST" : "shared/artifacts/4/arbalet/wear.png",
    "ARBALET4_FINGER" : "shared/artifacts/4/arbalet/ring.png",
    "ARBALET4_HEAD" : "shared/artifacts/4/arbalet/helmet.png",
    "ARBALET4_ITEM" : "shared/artifacts/4/arbalet/item.png",
    "ARBALET4_LEFT_HAND" : "shared/artifacts/4/arbalet/weapon.png",
    "ARBALET4_LEGS" : "shared/artifacts/4/arbalet/footwear.png",
    "ARBALET4_NECK" : "shared/artifacts/4/arbalet/necklace.png",
    "ARBALET4_WAIST" : "shared/artifacts/4/arbalet/belt.png",
    "DRAGON4_CHEST" : "shared/artifacts/4/dragon/wear.png",
    "DRAGON4_FINGER" : "shared/artifacts/4/dragon/ring.png",
    "DRAGON4_HEAD" : "shared/artifacts/4/dragon/helmet.png",
    "DRAGON4_ITEM" : "shared/artifacts/4/dragon/item.png",
    "DRAGON4_LEFT_HAND" : "shared/artifacts/4/dragon/weapon.png",
    "DRAGON4_LEGS" : "shared/artifacts/4/dragon/footwear.png",
    "DRAGON4_NECK" : "shared/artifacts/4/dragon/necklace.png",
    "DRAGON4_RIGHT_HAND" : "shared/artifacts/4/dragon/weapon_offhand.png",
    "DRAGON4_WAIST" : "shared/artifacts/4/dragon/belt.png",
    "EAGLE4_CHEST" : "shared/artifacts/4/eagle/wear.png",
    "EAGLE4_FINGER" : "shared/artifacts/4/eagle/ring.png",
    "EAGLE4_HEAD" : "shared/artifacts/4/eagle/helmet.png",
    "EAGLE4_ITEM" : "shared/artifacts/4/eagle/item.png",
    "EAGLE4_LEFT_HAND" : "shared/artifacts/4/eagle/weapon.png",
    "EAGLE4_LEGS" : "shared/artifacts/4/eagle/footwear.png",
    "EAGLE4_NECK" : "shared/artifacts/4/eagle/necklace.png",
    "EAGLE4_RIGHT_HAND" : "shared/artifacts/4/eagle/weapon_offhand.png",
    "EAGLE4_WAIST" : "shared/artifacts/4/eagle/belt.png",
    "FOX4_CHEST" : "shared/artifacts/4/fox/wear.png",
    "FOX4_FINGER" : "shared/artifacts/4/fox/ring.png",
    "FOX4_HEAD" : "shared/artifacts/4/fox/helmet.png",
    "FOX4_ITEM" : "shared/artifacts/4/fox/item.png",
    "FOX4_LEFT_HAND" : "shared/artifacts/4/fox/weapon.png",
    "FOX4_LEGS" : "shared/artifacts/4/fox/footwear.png",
    "FOX4_NECK" : "shared/artifacts/4/fox/necklace.png",
    "FOX4_RIGHT_HAND" : "shared/artifacts/4/fox/weapon_offhand.png",
    "FOX4_WAIST" : "shared/artifacts/4/fox/belt.png",
    "INQUISITOR4_CHEST" : "shared/artifacts/4/inquisitor/wear.png",
    "INQUISITOR4_FINGER" : "shared/artifacts/4/inquisitor/ring.png",
    "INQUISITOR4_HEAD" : "shared/artifacts/4/inquisitor/helmet.png",
    "INQUISITOR4_ITEM" : "shared/artifacts/4/inquisitor/item.png",
    "INQUISITOR4_LEFT_HAND" : "shared/artifacts/4/inquisitor/weapon.png",
    "INQUISITOR4_LEGS" : "shared/artifacts/4/inquisitor/footwear.png",
    "INQUISITOR4_NECK" : "shared/artifacts/4/inquisitor/necklace.png",
    "INQUISITOR4_RIGHT_HAND" : "shared/artifacts/4/inquisitor/weapon_offhand.png",
    "INQUISITOR4_WAIST" : "shared/artifacts/4/inquisitor/belt.png",
    "LEECH4_CHEST" : "shared/artifacts/4/leech/wear.png",
    "LEECH4_FINGER" : "shared/artifacts/4/leech/ring.png",
    "LEECH4_HEAD" : "shared/artifacts/4/leech/helmet.png",
    "LEECH4_ITEM" : "shared/artifacts/4/leech/item.png",
    "LEECH4_LEFT_HAND" : "shared/artifacts/4/leech/weapon.png",
    "LEECH4_LEGS" : "shared/artifacts/4/leech/feet.png",
    "LEECH4_NECK" : "shared/artifacts/4/leech/necklace.png",
    "LEECH4_RIGHT_HAND" : "shared/artifacts/4/leech/weapon_offhand.png",
    "LEECH4_WAIST" : "shared/artifacts/4/leech/belt.png",
    "PHARAON4_CHEST" : "shared/artifacts/4/pharaon/wear.png",
    "PHARAON4_FINGER" : "shared/artifacts/4/pharaon/ring.png",
    "PHARAON4_HEAD" : "shared/artifacts/4/pharaon/helmet.png",
    "PHARAON4_ITEM" : "shared/artifacts/4/pharaon/item.png",
    "PHARAON4_LEFT_HAND" : "shared/artifacts/4/pharaon/weapon.png",
    "PHARAON4_LEGS" : "shared/artifacts/4/pharaon/footwear.png",
    "PHARAON4_NECK" : "shared/artifacts/4/pharaon/necklace.png",
    "PHARAON4_WAIST" : "shared/artifacts/4/pharaon/belt.png",
    "PREDATOR4_CHEST" : "shared/artifacts/4/predator/wear.png",
    "PREDATOR4_FINGER" : "shared/artifacts/4/predator/ring.png",
    "PREDATOR4_HEAD" : "shared/artifacts/4/predator/helmet.png",
    "PREDATOR4_ITEM" : "shared/artifacts/4/predator/item.png",
    "PREDATOR4_LEFT_HAND" : "shared/artifacts/4/predator/weapon.png",
    "PREDATOR4_LEGS" : "shared/artifacts/4/predator/footwear.png",
    "PREDATOR4_NECK" : "shared/artifacts/4/predator/necklace.png",
    "PREDATOR4_RIGHT_HAND" : "shared/artifacts/4/predator/weapon_offhand.png",
    "PREDATOR4_WAIST" : "shared/artifacts/4/predator/belt.png",
    "SILVER4_CHEST" : "shared/artifacts/4/silver/wear.png",
    "SILVER4_FINGER" : "shared/artifacts/4/silver/ring.png",
    "SILVER4_HEAD" : "shared/artifacts/4/silver/helmet.png",
    "SILVER4_ITEM" : "shared/artifacts/4/silver/item.png",
    "SILVER4_LEFT_HAND" : "shared/artifacts/4/silver/weapon.png",
    "SILVER4_LEGS" : "shared/artifacts/4/silver/footwear.png",
    "SILVER4_NECK" : "shared/artifacts/4/silver/necklace.png",
    "SILVER4_RIGHT_HAND" : "shared/artifacts/4/silver/weapon_offhand.png",
    "SILVER4_WAIST" : "shared/artifacts/4/silver/belt.png",
    "ANGEL5_CHEST" : "shared/artifacts/5/angel/wear.png",
    "ANGEL5_FINGER" : "shared/artifacts/5/angel/ring.png",
    "ANGEL5_HEAD" : "shared/artifacts/5/angel/helmet.png",
    "ANGEL5_ITEM" : "shared/artifacts/5/angel/item.png",
    "ANGEL5_LEFT_HAND" : "shared/artifacts/5/angel/weapon.png",
    "ANGEL5_LEGS" : "shared/artifacts/5/angel/footwear.png",
    "ANGEL5_NECK" : "shared/artifacts/5/angel/necklace.png",
    "ANGEL5_RIGHT_HAND" : "shared/artifacts/5/angel/weapon_offhand.png",
    "ANGEL5_WAIST" : "shared/artifacts/5/angel/belt.png",
    "BLACK5_CHEST" : "shared/artifacts/5/black/wear.png",
    "BLACK5_FINGER" : "shared/artifacts/5/black/ring.png",
    "BLACK5_HEAD" : "shared/artifacts/5/black/helmet.png",
    "BLACK5_ITEM" : "shared/artifacts/5/black/item.png",
    "BLACK5_LEFT_HAND" : "shared/artifacts/5/black/weapon.png",
    "BLACK5_LEGS" : "shared/artifacts/5/black/footwear.png",
    "BLACK5_NECK" : "shared/artifacts/5/black/necklace.png",
    "BLACK5_RIGHT_HAND" : "shared/artifacts/5/black/weapon_offhand.png",
    "BLACK5_WAIST" : "shared/artifacts/5/black/belt.png",
    "KING5_CHEST" : "shared/artifacts/5/king/wear.png",
    "KING5_FINGER" : "shared/artifacts/5/king/ring.png",
    "KING5_HEAD" : "shared/artifacts/5/king/helmet.png",
    "KING5_ITEM" : "shared/artifacts/5/king/item.png",
    "KING5_LEFT_HAND" : "shared/artifacts/5/king/weapon.png",
    "KING5_LEGS" : "shared/artifacts/5/king/footwear.png",
    "KING5_NECK" : "shared/artifacts/5/king/necklace.png",
    "KING5_RIGHT_HAND" : "shared/artifacts/5/king/weapon_offhand.png",
    "KING5_WAIST" : "shared/artifacts/5/king/belt.png",
    "MAGIC_CRYSTALL5_CHEST" : "shared/artifacts/5/magic_crystall/wear.png",
    "MAGIC_CRYSTALL5_FINGER" : "shared/artifacts/5/magic_crystall/ring.png",
    "MAGIC_CRYSTALL5_HEAD" : "shared/artifacts/5/magic_crystall/helmet.png",
    "MAGIC_CRYSTALL5_ITEM" : "shared/artifacts/5/magic_crystall/item.png",
    "MAGIC_CRYSTALL5_LEFT_HAND" : "shared/artifacts/5/magic_crystall/weapon.png",
    "MAGIC_CRYSTALL5_LEGS" : "shared/artifacts/5/magic_crystall/footwear.png",
    "MAGIC_CRYSTALL5_NECK" : "shared/artifacts/5/magic_crystall/necklace.png",
    "MAGIC_CRYSTALL5_RIGHT_HAND" : "shared/artifacts/5/magic_crystall/weapon_offhand.png",
    "MAGIC_CRYSTALL5_WAIST" : "shared/artifacts/5/magic_crystall/belt.png",
    "SCARAB_LORD5_CHEST" : "shared/artifacts/5/scarab_lord/wear.png",
    "SCARAB_LORD5_FINGER" : "shared/artifacts/5/scarab_lord/ring.png",
    "SCARAB_LORD5_HEAD" : "shared/artifacts/5/scarab_lord/helmet.png",
    "SCARAB_LORD5_ITEM" : "shared/artifacts/5/scarab_lord/item.png",
    "SCARAB_LORD5_LEFT_HAND" : "shared/artifacts/5/scarab_lord/weapon.png",
    "SCARAB_LORD5_LEGS" : "shared/artifacts/5/scarab_lord/footwear.png",
    "SCARAB_LORD5_NECK" : "shared/artifacts/5/scarab_lord/necklace.png",
    "SCARAB_LORD5_WAIST" : "shared/artifacts/5/scarab_lord/belt.png"
}

var SkillAssets =
{
	"SKILL_UNKNOWN": "shared/heroes/skills/skill_unknown.png",
	"SKILL_BORDER": "shared/heroes/skills/skill_slot.png",
	"SKILL_ACTIVE_BORDER": "shared/heroes/skills/skill_active.png",

	"SKILL_STUB_MAGE": "shared/heroes/skills/skill_stub_mage.png",
	"SKILL_STUB_STRATEG": "shared/heroes/skills/skill_stub_warrior.png",
	"SKILL_STUB_GOVERNOR": "shared/heroes/skills/skill_stub_miner.png",
	"SKILL_STUB_MONSTER_RULER": "shared/heroes/skills/skill_stub_monster.png",

//autogenerated text goes here

    //PASSIVES

	"SKILL_ARTEFAKTHANTER_PASSIVE": "shared/heroes/skills/passives/artefakthanter.png",
	"SKILL_BEREJNYI_ZAHVAT_PASSIVE": "shared/heroes/skills/passives/berejnyi_zahvat.png",
	"SKILL_BESSTRASHIE_PASSIVE": "shared/heroes/skills/passives/besstrashie.png",
	"SKILL_DALNEE_NABLYUDENIE_PASSIVE": "shared/heroes/skills/passives/dalnee_nablyudenie.png",
	"SKILL_DALNIE_ZAKUPKI_PASSIVE": "shared/heroes/skills/passives/dalnie_zakupki.png",
	"SKILL_DALNII_SHPIONAJ_PASSIVE": "shared/heroes/skills/passives/dalnii_shpionaj.png",
	"SKILL_DIKIY_UZAS_PASSIVE": "shared/heroes/skills/passives/dikiy_uzas.png",
	"SKILL_DIVERSIYA_ISSLEDOVATELEI_MONSTR_PASSIVE": "shared/heroes/skills/passives/diversiya_issledovatelei_monstr.png",
	"SKILL_DOBIVAT_RANENYH_NAV_PASSIVE": "shared/heroes/skills/passives/dobivat_ranenyh_nav.png",
	"SKILL_DOPOLNITELNYI_DOHOD_PASSIVE": "shared/heroes/skills/passives/dopolnitelnyi_dohod.png",
	"SKILL_DUH_ALTRUIZMA_PASSIVE": "shared/heroes/skills/passives/duh_altruizma.png",
	"SKILL_EKONOMNAYA_TRENIROVKA_PASSIVE": "shared/heroes/skills/passives/ekonomnaya_trenirovka.png",
	"SKILL_GENERATOR_BURI_MONSTR_PASSIVE": "shared/heroes/skills/passives/generator_buri_monstr.png",
	"SKILL_LOVUSHKA_PASSIVE": "shared/heroes/skills/passives/lovushka.png",
	"SKILL_MARODERSTVO_PASSIVE": "shared/heroes/skills/passives/maroderstvo.png",
	"SKILL_MASTERSTVO_OBORONY_PASSIVE": "shared/heroes/skills/passives/masterstvo_oborony.png",
	"SKILL_MASTER_BASHEN_PASSIVE": "shared/heroes/skills/passives/master_bashen.png",
	"SKILL_MONOPOLIYA_PASSIVE": "shared/heroes/skills/passives/monopoliya.png",
	"SKILL_NEKROMANSIYA_SVOIH_VOISK_PASSIVE": "shared/heroes/skills/passives/nekromansiya_svoih_voisk.png",
	"SKILL_NEUDACHA_PROTIVNIKU_PASSIVE": "shared/heroes/skills/passives/neudacha_protivniku.png",
	"SKILL_OHRANA_SOYUZNIKA_PASSIVE": "shared/heroes/skills/passives/ohrana_soyuznika.png",
	"SKILL_OSTOROJNOST_V_NAPADENII_PASSIVE": "shared/heroes/skills/passives/ostorojnost_v_napadenii.png",
	"SKILL_PERENOSNOE_UKREPLENIE_PASSIVE": "shared/heroes/skills/passives/perenosnoe_ukreplenie.png",
	"SKILL_PLENENIE_DUSH_PASSIVE": "shared/heroes/skills/passives/plenenie_dush.png",
	"SKILL_POBOCHNAYA_PRIBYL_PASSIVE": "shared/heroes/skills/passives/pobochnaya_pribyl.png",
	"SKILL_PODAVITEL_MAGICHESKIH_BASHEN_PASSIVE": "shared/heroes/skills/passives/podavitel_magicheskih_bashen.png",
	"SKILL_PODAVLENIE_LEKAREI_PASSIVE": "shared/heroes/skills/passives/podavlenie_lekarei.png",
	"SKILL_PODAVLENUIE_VSEH_VOYSK_PASSIVE": "shared/heroes/skills/passives/podavlenuie_vseh_voysk.png",
	"SKILL_POJAR_PASSIVE": "shared/heroes/skills/passives/pojar.png",
	"SKILL_POSLANIE_IZ_ADA_PASSIVE": "shared/heroes/skills/passives/poslanie_iz_ada.png",
	"SKILL_PRITOK_MONSTROV_PASSIVE": "shared/heroes/skills/passives/pritok_monstrov.png",
	"SKILL_RAZGRABLENIE_PASSIVE": "shared/heroes/skills/passives/razgrablenie.png",
	"SKILL_REGENERACIYA_MANY_PASSIVE": "shared/heroes/skills/passives/regeneraciya_many.png",
	"SKILL_SABOTAJ_STROITELSTVA_MONSTR_PASSIVE": "shared/heroes/skills/passives/sabotaj_stroitelstva_monstr.png",
	"SKILL_SBOR_TROFEEV_PASSIVE": "shared/heroes/skills/passives/sbor_trofeev.png",
	"SKILL_SHKOLA_MAGII_PASSIVE": "shared/heroes/skills/passives/shkola_magii.png",
	"SKILL_SHRON_PASSIVE": "shared/heroes/skills/passives/shron.png",
	"SKILL_SILA_SOYUZNIKU_PASSIVE": "shared/heroes/skills/passives/sila_soyuzniku.png",
	"SKILL_SILA_VOISK_PASSIVE": "shared/heroes/skills/passives/sila_voisk.png",
	"SKILL_SKOROST_GEROYA_PASSIVE": "shared/heroes/skills/passives/skorost_geroya.png",
	"SKILL_SLABOST_MAGOV_PASSIVE": "shared/heroes/skills/passives/slabost_magov.png",
	"SKILL_SNIJENIE_OPYTA_PASSIVE": "shared/heroes/skills/passives/snijenie_opyta.png",
	"SKILL_SNYATIE_OTSTUPNIKA_PASSIVE": "shared/heroes/skills/passives/snyatie_otstupnika.png",
	"SKILL_SODERJANIE_LEKAREI_PASSIVE": "shared/heroes/skills/passives/soderjanie_lekarei.png",
	"SKILL_SODERJANIE_MAGOV_PASSIVE": "shared/heroes/skills/passives/soderjanie_magov.png",
	"SKILL_SUPERNEKROMANSIYA_PASSIVE": "shared/heroes/skills/passives/supernekromansiya.png",
	"SKILL_TAKTIKA_ISPOLZOVANIYA_UKREPLENII_PASSIVE": "shared/heroes/skills/passives/taktika_ispolzovaniya_ukreplenii.png",
	"SKILL_UKREPIT_ZDANIYA_PASSIVE": "shared/heroes/skills/passives/ukrepit_zdaniya.png",
	"SKILL_ULUCHSHENIE_LEKAREI_PASSIVE": "shared/heroes/skills/passives/uluchshenie_lekarei.png",
	"SKILL_ULUCHSHENIE_VOSKRESITELYA_PASSIVE": "shared/heroes/skills/passives/uluchshenie_voskresitelya.png",
	"SKILL_ULUCHSHENYI_OTBOR_PASSIVE": "shared/heroes/skills/passives/uluchshenyi_otbor.png",
	"SKILL_UNICHTOJITEL_MONSTROV_PASSIVE": "shared/heroes/skills/passives/unichtojitel_monstrov.png",
	"SKILL_USKORENIE_ISSLEDOVATELEI_PASSIVE": "shared/heroes/skills/passives/uskorenie_issledovatelei.png",
	"SKILL_USKORENIE_STROITELSTVA_PASSIVE": "shared/heroes/skills/passives/uskorenie_stroitelstva.png",
	"SKILL_USKORENNAYA_TRENIROVKA_PASSIVE": "shared/heroes/skills/passives/uskorennaya_trenirovka.png",
	"SKILL_UVELICHENIE_POVOZOK_PASSIVE": "shared/heroes/skills/passives/uvelichenie_povozok.png",
	"SKILL_UYAZVIMOST_NAPADAYUSCHIH_PASSIVE": "shared/heroes/skills/passives/uyazvimost_napadayuschih.png",
	"SKILL_VELIKAYA_KORONA_PASSIVE": "shared/heroes/skills/passives/velikaya_korona.png",
	"SKILL_VYNOSLIVOST_ARMII_PASSIVE": "shared/heroes/skills/passives/vynoslivost_armii.png",
	"SKILL_VYNOSLIVOST_SOYUZNIKOV_PASSIVE": "shared/heroes/skills/passives/vynoslivost_soyuznikov.png",
	"SKILL_VYSOSAT_MANU_PASSIVE": "shared/heroes/skills/passives/vysosat_manu.png",
	"SKILL_YAROST_MAGOV_PASSIVE": "shared/heroes/skills/passives/yarost_magov.png",
	"SKILL_ZASCHITA_GEROYA_OT_MAGII_MONSTR_PASSIVE": "shared/heroes/skills/passives/zaschita_geroya_ot_magii_monstr.png",
	"SKILL_ZASCHITA_GEROYA_OT_MAGII_PASSIVE": "shared/heroes/skills/passives/zaschita_geroya_ot_magii.png",
	"SKILL_ZASCHITA_MAGOV_PASSIVE": "shared/heroes/skills/passives/zaschita_magov.png",
	"SKILL_ZASCHITA_OT_UKREPLENII_PASSIVE": "shared/heroes/skills/passives/zaschita_ot_ukreplenii.png",
	"SKILL_ZASCHITA_PASSIVE": "shared/heroes/skills/passives/zaschita.png",
	"SKILL_ZAVESCHANIE_MONSTROV_MONSTR_PASSIVE": "shared/heroes/skills/passives/zaveschanie_monstrov_monstr.png",
	"SKILL_ZAVESCHANIE_MONSTROV_PASSIVE": "shared/heroes/skills/passives/zaveschanie_monstrov.png",


    //ACTIVES

	"SKILL_ANABIOZ": "shared/heroes/skills/actives/anabioz.png",
	"SKILL_ANTIMAGIYA": "shared/heroes/skills/actives/antimagiya.png",
	"SKILL_ARMAGEDDON": "shared/heroes/skills/actives/armageddon.png",
	"SKILL_ARMAGEDDON_CASTLE": "shared/heroes/skills/actives/armageddon_castle.png",
	"SKILL_ARTEFAKTHANTER": "shared/heroes/skills/actives/artefakthanter.png",
	"SKILL_BALLISTA": "shared/heroes/skills/actives/ballista.png",
	"SKILL_BEREJNYI_ZAHVAT": "shared/heroes/skills/actives/berejnyi_zahvat.png",
	"SKILL_BESSTRASHIE": "shared/heroes/skills/actives/besstrashie.png",
	"SKILL_BRIKOL": "shared/heroes/skills/actives/brikol.png",
	"SKILL_BRIKOL_CASTLE": "shared/heroes/skills/actives/brikol_castle.png",
	"SKILL_BRODYACHIE_DUHI": "shared/heroes/skills/actives/brodyachie_duhi.png",
	"SKILL_CAMP_MERCHANTS": "shared/heroes/skills/actives/camp_merchants.png",
	"SKILL_CHUMA": "shared/heroes/skills/actives/chuma.png",
	"SKILL_DALNEE_NABLYUDENIE": "shared/heroes/skills/actives/dalnee_nablyudenie.png",
	"SKILL_DALNIE_ISSLEDOVANIYA": "shared/heroes/skills/actives/dalnie_issledovaniya.png",
	"SKILL_DALNIE_ZAKUPKI": "shared/heroes/skills/actives/dalnie_zakupki.png",
	"SKILL_DALNII_SHPIONAJ": "shared/heroes/skills/actives/dalnii_shpionaj.png",
	"SKILL_DEMOBILIZACIYA": "shared/heroes/skills/actives/demobilizaciya.png",
	"SKILL_DEZINFORMACIYA": "shared/heroes/skills/actives/dezinformaciya.png",
	"SKILL_DEZINFORMACIYA_CASTLE": "shared/heroes/skills/actives/dezinformaciya_castle.png",
	"SKILL_DIVERSIYA_ANTISHPIONOV": "shared/heroes/skills/actives/diversiya_antishpionov.png",
	"SKILL_DIVERSIYA_BASHEN": "shared/heroes/skills/actives/diversiya_bashen.png",
	"SKILL_DIVERSIYA_DOBYCHI": "shared/heroes/skills/actives/diversiya_dobychi.png",
	"SKILL_DIVERSIYA_DOMOV": "shared/heroes/skills/actives/diversiya_domov.png",
	"SKILL_DIVERSIYA_ISSLEDOVATELEI": "shared/heroes/skills/actives/diversiya_issledovatelei.png",
	"SKILL_DIVERSIYA_ISSLEDOVATELEI_MONSTR": "shared/heroes/skills/actives/diversiya_issledovatelei_monstr.png",
	"SKILL_DIVERSIYA_KUPCOV": "shared/heroes/skills/actives/diversiya_kupcov.png",
	"SKILL_DIVERSIYA_LABORATORII": "shared/heroes/skills/actives/diversiya_laboratorii.png",
	"SKILL_DIVERSIYA_MAGICHESKIH_BASHEN": "shared/heroes/skills/actives/diversiya_magicheskih_bashen.png",
	"SKILL_DIVERSIYA_NA_RYNKE": "shared/heroes/skills/actives/diversiya_na_rynke.png",
	"SKILL_DIVERSIYA_PROVIDCEV": "shared/heroes/skills/actives/diversiya_providcev.png",
	"SKILL_DIVERSIYA_SHPIONOV": "shared/heroes/skills/actives/diversiya_shpionov.png",
	"SKILL_DIVERSIYA_SKLADOV": "shared/heroes/skills/actives/diversiya_skladov.png",
	"SKILL_DIVERSIYA_TRENIROVOK": "shared/heroes/skills/actives/diversiya_trenirovok.png",
	"SKILL_DIVERSIYA_VOSKRESITELYA": "shared/heroes/skills/actives/diversiya_voskresitelya.png",
	"SKILL_DIVERSIYA_V_HRAME": "shared/heroes/skills/actives/diversiya_v_hrame.png",
	"SKILL_DIVERSIYA_V_LAVOK": "shared/heroes/skills/actives/diversiya_v_lavok.png",
	"SKILL_DIVERSIYA_ZERKAL": "shared/heroes/skills/actives/diversiya_zerkal.png",
	"SKILL_DIVERSIYA_ZERKAL_I_ANTISHPIONOV": "shared/heroes/skills/actives/diversiya_zerkal_i_antishpionov.png",
	"SKILL_DOBIVAT_RANENYH": "shared/heroes/skills/actives/dobivat_ranenyh.png",
	"SKILL_DOBIVAT_RANENYH_CASTLE": "shared/heroes/skills/actives/dobivat_ranenyh_castle.png",
	"SKILL_DOZORNYI": "shared/heroes/skills/actives/dozornyi.png",
	"SKILL_DUH_ALTRUIZMA": "shared/heroes/skills/actives/duh_altruizma.png",
	"SKILL_DUH_ALTRUIZMA_CASTLE": "shared/heroes/skills/actives/duh_altruizma_castle.png",
	"SKILL_DUH_PRESLEDOVANIYA_ZEMLI_DEMONOV": "shared/heroes/skills/actives/duh_presledovaniya_zemli_demonov.png",
	"SKILL_DUH_PRESLEDOVANIYA_ZEMLI_DEMONOV_CASTLE": "shared/heroes/skills/actives/duh_presledovaniya_zemli_demonov_castle.png",
	"SKILL_DUH_PRESLEDOVANIYA_ZEMLI_DROU": "shared/heroes/skills/actives/duh_presledovaniya_zemli_drou.png",
	"SKILL_DUH_PRESLEDOVANIYA_ZEMLI_DROU_CASTLE": "shared/heroes/skills/actives/duh_presledovaniya_zemli_drou_castle.png",
	"SKILL_DUH_PRESLEDOVANIYA_ZEMLI_ELFOV": "shared/heroes/skills/actives/duh_presledovaniya_zemli_elfov.png",
	"SKILL_DUH_PRESLEDOVANIYA_ZEMLI_ELFOV_CASTLE": "shared/heroes/skills/actives/duh_presledovaniya_zemli_elfov_castle.png",
	"SKILL_DUH_PRESLEDOVANIYA_ZEMLI_LYUDEI": "shared/heroes/skills/actives/duh_presledovaniya_zemli_lyudei.png",
	"SKILL_DUH_PRESLEDOVANIYA_ZEMLI_LYUDEI_CASTLE": "shared/heroes/skills/actives/duh_presledovaniya_zemli_lyudei_castle.png",
	"SKILL_DUH_ZASCHITY_ZEMLI_ELFOV": "shared/heroes/skills/actives/duh_zaschity_zemli_elfov.png",
	"SKILL_DUH_ZASCHITY_ZEMLI_ELFOV_CASTLE": "shared/heroes/skills/actives/duh_zaschity_zemli_elfov_castle.png",
	"SKILL_DUH_ZASCHITY_ZEMLI_LYUDEI": "shared/heroes/skills/actives/duh_zaschity_zemli_lyudei.png",
	"SKILL_DUH_ZASCHITY_ZEMLI_LYUDEI_CASTLE": "shared/heroes/skills/actives/duh_zaschity_zemli_lyudei_castle.png",
	"SKILL_DUH_ZASCHITY_ZEMLI__DEMONOV": "shared/heroes/skills/actives/duh_zaschity_zemli__demonov.png",
	"SKILL_DUH_ZASCHITY_ZEMLI__DEMONOV_CASTLE": "shared/heroes/skills/actives/duh_zaschity_zemli__demonov_castle.png",
	"SKILL_DUH_ZASCHITY_ZEMLI__DROU": "shared/heroes/skills/actives/duh_zaschity_zemli__drou.png",
	"SKILL_DUH_ZASCHITY_ZEMLI__DROU_CASTLE": "shared/heroes/skills/actives/duh_zaschity_zemli__drou_castle.png",
	"SKILL_EINARM": "shared/heroes/skills/actives/einarm.png",
	"SKILL_EINARM_CASTLE": "shared/heroes/skills/actives/einarm_castle.png",
	"SKILL_EKONOMNAYA_TRENIROVKA": "shared/heroes/skills/actives/ekonomnaya_trenirovka.png",
	"SKILL_EKONOMNAYA_TRENIROVKA_LEKAREI": "shared/heroes/skills/actives/ekonomnaya_trenirovka_lekarei.png",
	"SKILL_EKONOMNAYA_TRENIROVKA_MAGOV": "shared/heroes/skills/actives/ekonomnaya_trenirovka_magov.png",
	"SKILL_ELFIISKOE_DEREVO": "shared/heroes/skills/actives/elfiiskoe_derevo.png",
	"SKILL_FONTAN_MANY": "shared/heroes/skills/actives/fontan_many.png",
	"SKILL_GENERATOR_BURI": "shared/heroes/skills/actives/generator_buri.png",
	"SKILL_GENERATOR_BURI_CASTLE": "shared/heroes/skills/actives/generator_buri_castle.png",
	"SKILL_GLOBALNOE_ZAVERSHENIE_POSTROEK": "shared/heroes/skills/actives/globalnoe_zavershenie_postroek.png",
	"SKILL_GNOMY_UCHENYE": "shared/heroes/skills/actives/gnomy_uchenye.png",
	"SKILL_GORNYE_INSTRUMENTY": "shared/heroes/skills/actives/gornye_instrumenty.png",
	"SKILL_GORNYI_KAMUFLYAJ": "shared/heroes/skills/actives/gornyi_kamuflyaj.png",
	"SKILL_GORNYI_KAMUFLYAJ_CASTLE": "shared/heroes/skills/actives/gornyi_kamuflyaj_castle.png",
	"SKILL_HIMICHESKII_SINTEZ": "shared/heroes/skills/actives/himicheskii_sintez.png",
	"SKILL_ILLYUZIYA_GEROYA": "shared/heroes/skills/actives/illyuziya_geroya.png",
	"SKILL_ISSLEDOVAT_KOROLEVSTVO": "shared/heroes/skills/actives/issledovat_korolevstvo.png",
	"SKILL_ISTINNOE_ZRENIE_GEROYA": "shared/heroes/skills/actives/istinnoe_zrenie_geroya.png",
	"SKILL_ISTINNOE_ZRENIE_VLADENIYA": "shared/heroes/skills/actives/istinnoe_zrenie_vladeniya.png",
	"SKILL_ISTINNOE_ZRENIE_VLADENIYA_CASTLE": "shared/heroes/skills/actives/istinnoe_zrenie_vladeniya_castle.png",
	"SKILL_JELEZO_DROU": "shared/heroes/skills/actives/jelezo_drou.png",
	"SKILL_JERTVA": "shared/heroes/skills/actives/jertva.png",
	"SKILL_KAMEN_DEMONOV": "shared/heroes/skills/actives/kamen_demonov.png",
	"SKILL_KARANTIN": "shared/heroes/skills/actives/karantin.png",
	"SKILL_KATAPULTA": "shared/heroes/skills/actives/katapulta.png",
	"SKILL_KLANOVYI_PLEN": "shared/heroes/skills/actives/klanovyi_plen.png",
	"SKILL_KNIGA_MUDROSTI": "shared/heroes/skills/actives/kniga_mudrosti.png",
	"SKILL_KNIGA_ZNANII": "shared/heroes/skills/actives/kniga_znanii.png",
	"SKILL_KOLCO_DEMONOV": "shared/heroes/skills/actives/kolco_demonov.png",
	"SKILL_KULTIVACIYA_POCHVY": "shared/heroes/skills/actives/kultivaciya_pochvy.png",
	"SKILL_LESNOI_KAMUFLYAJ": "shared/heroes/skills/actives/lesnoi_kamuflyaj.png",
	"SKILL_LESNOI_KAMUFLYAJ_CASTLE": "shared/heroes/skills/actives/lesnoi_kamuflyaj_castle.png",
	"SKILL_LETAYUSCHIE_PRESLEDOVATELI": "shared/heroes/skills/actives/letayuschie_presledovateli.png",
	"SKILL_LETAYUSCHIE_PRESLEDOVATELI_CASTLE": "shared/heroes/skills/actives/letayuschie_presledovateli_castle.png",
	"SKILL_LOVUSHKA": "shared/heroes/skills/actives/lovushka.png",
	"SKILL_LOVUSHKA_CASTLE": "shared/heroes/skills/actives/lovushka_castle.png",
	"SKILL_LOVUSHKA_SJIGATEL_MANY": "shared/heroes/skills/actives/lovushka_sjigatel_many.png",
	"SKILL_LUCHNIKI_PRESLEDOVATELI": "shared/heroes/skills/actives/luchniki_presledovateli.png",
	"SKILL_LUCHNIKI_PRESLEDOVATELI_CASTLE": "shared/heroes/skills/actives/luchniki_presledovateli_castle.png",
	"SKILL_LYUBOV_K_ARHITEKTURE": "shared/heroes/skills/actives/lyubov_k_arhitekture.png",
	"SKILL_LYUBOV_K_ARHITEKTURE_CASTLE": "shared/heroes/skills/actives/lyubov_k_arhitekture_castle.png",
	"SKILL_MAGI_ZASCHITNIKI": "shared/heroes/skills/actives/magi_zaschitniki.png",
	"SKILL_MARODERSTVO": "shared/heroes/skills/actives/maroderstvo.png",
	"SKILL_MASTERSTVO_OBORONY": "shared/heroes/skills/actives/masterstvo_oborony.png",
	"SKILL_MASTERSTVO_OBORONY_CASTLE": "shared/heroes/skills/actives/masterstvo_oborony_castle.png",
	"SKILL_MASTER_BASHEN": "shared/heroes/skills/actives/master_bashen.png",
	"SKILL_MEDLENNIY_VPK": "shared/heroes/skills/actives/medlenniy_vpk.png",
	"SKILL_MOBILIZACIYA": "shared/heroes/skills/actives/mobilizaciya.png",
	"SKILL_MOBILIZACIYA_CASTLE": "shared/heroes/skills/actives/mobilizaciya_castle.png",
	"SKILL_MODERNIZACIYA_UKREPLENII": "shared/heroes/skills/actives/modernizaciya_ukreplenii.png",
	"SKILL_MODERNIZACIYA_UKREPLENII_CASTLE": "shared/heroes/skills/actives/modernizaciya_ukreplenii_castle.png",
	"SKILL_MONOPOLIYA": "shared/heroes/skills/actives/monopoliya.png",
	"SKILL_NASLAT_BOLEZN": "shared/heroes/skills/actives/naslat_bolezn.png",
	"SKILL_NASLAT_MONSTROV": "shared/heroes/skills/actives/naslat_monstrov.png",
	"SKILL_NEKROMANSIYA_SOYUZNIKA": "shared/heroes/skills/actives/nekromansiya_soyuznika.png",
	"SKILL_NEKROMANSIYA_SOYUZNIKA_CASTLE": "shared/heroes/skills/actives/nekromansiya_soyuznika_castle.png",
	"SKILL_NEKROMANSIYA_SVOIH_VOISK": "shared/heroes/skills/actives/nekromansiya_svoih_voisk.png",
	"SKILL_NEKROMANSIYA_SVOIH_VOISK_CASTLE": "shared/heroes/skills/actives/nekromansiya_svoih_voisk_castle.png",
	"SKILL_NEPODVIZNIE_DUHI": "shared/heroes/skills/actives/nepodviznie_duhi.png",
	"SKILL_NEVIDIMOST": "shared/heroes/skills/actives/nevidimost.png",
	"SKILL_OBEREG_ISSLEDOVATELEI": "shared/heroes/skills/actives/obereg_issledovatelei.png",
	"SKILL_OBEREG_KUPCOV": "shared/heroes/skills/actives/obereg_kupcov.png",
	"SKILL_OBHOD_KODEKSA": "shared/heroes/skills/actives/obhod_kodeksa.png",
	"SKILL_OHRANA_SKLADOV": "shared/heroes/skills/actives/ohrana_skladov.png",
	"SKILL_OHRANA_SOYUZNIKA": "shared/heroes/skills/actives/ohrana_soyuznika.png",
	"SKILL_OHRANA_SOYUZNIKA_CASTLE": "shared/heroes/skills/actives/ohrana_soyuznika_castle.png",
	"SKILL_OKO_ISSLEDOVATELYA": "shared/heroes/skills/actives/oko_issledovatelya.png",
	"SKILL_OPTIMIZACIYA_HRANENIYA": "shared/heroes/skills/actives/optimizaciya_hraneniya.png",
	"SKILL_OSADNAYA_BASHNYA": "shared/heroes/skills/actives/osadnaya_bashnya.png",
	"SKILL_OSTANOVIT_NEGATIVNOE_SOBYTIE": "shared/heroes/skills/actives/ostanovit_negativnoe_sobytie.png",
	"SKILL_OSTOROJNOST_V_NAPADENII": "shared/heroes/skills/actives/ostorojnost_v_napadenii.png",
	"SKILL_OSTOROJNOST_V_ZASCHITE": "shared/heroes/skills/actives/ostorojnost_v_zaschite.png",
	"SKILL_OSVOBODITEL_GEROEV": "shared/heroes/skills/actives/osvoboditel_geroev.png",
	"SKILL_OTKAZ_SLUJIT": "shared/heroes/skills/actives/otkaz_slujit.png",
	"SKILL_OTRAVIT_VODU": "shared/heroes/skills/actives/otravit_vodu.png",
	"SKILL_PERENOSNOE_UKREPLENIE": "shared/heroes/skills/actives/perenosnoe_ukreplenie.png",
	"SKILL_PLACDARM_PEREBROSKI": "shared/heroes/skills/actives/placdarm_perebroski.png",
	"SKILL_PLANARNYI_PEREHOD": "shared/heroes/skills/actives/planarnyi_perehod.png",
	"SKILL_PLENENIE_DUSH": "shared/heroes/skills/actives/plenenie_dush.png",
	"SKILL_POBOCHNAYA_PRIBYL": "shared/heroes/skills/actives/pobochnaya_pribyl.png",
	"SKILL_PODAVITEL_BASHEN": "shared/heroes/skills/actives/podavitel_bashen.png",
	"SKILL_PODAVITEL_MAGICHESKIH_BASHEN": "shared/heroes/skills/actives/podavitel_magicheskih_bashen.png",
	"SKILL_PODAVLENIE_LEKAREI": "shared/heroes/skills/actives/podavlenie_lekarei.png",
	"SKILL_PODAVLENIE_LEKAREI_CASTLE": "shared/heroes/skills/actives/podavlenie_lekarei_castle.png",
	"SKILL_PODAVLENIE_MAGOV": "shared/heroes/skills/actives/podavlenie_magov.png",
	"SKILL_PODAVLENIE_MAGOV_CASTLE": "shared/heroes/skills/actives/podavlenie_magov_castle.png",
	"SKILL_PODAVLENIE_MONSTROV": "shared/heroes/skills/actives/podavlenie_monstrov.png",
	"SKILL_PODJOG": "shared/heroes/skills/actives/podjog.png",
	"SKILL_PODNYATIE_UPOKOENNYH": "shared/heroes/skills/actives/podnyatie_upokoennyh.png",
	"SKILL_PODNYAT_UBITYH_VRAGOV": "shared/heroes/skills/actives/podnyat_ubityh_vragov.png",
	"SKILL_PODNYAT_UBITYH_VRAGOV_CASTLE": "shared/heroes/skills/actives/podnyat_ubityh_vragov_castle.png",
	"SKILL_POHODNYE_ANTISHPIONY": "shared/heroes/skills/actives/pohodnye_antishpiony.png",
	"SKILL_POHODNYE_PROVIDCY": "shared/heroes/skills/actives/pohodnye_providcy.png",
	"SKILL_POHODNYE_SHPIONY": "shared/heroes/skills/actives/pohodnye_shpiony.png",
	"SKILL_POHODNYE_ZERKALA": "shared/heroes/skills/actives/pohodnye_zerkala.png",
	"SKILL_POISK_KOPI": "shared/heroes/skills/actives/poisk_kopi.png",
	"SKILL_POISK_OZERA": "shared/heroes/skills/actives/poisk_ozera.png",
	"SKILL_POISK_RUINY": "shared/heroes/skills/actives/poisk_ruiny.png",
	"SKILL_POJAR": "shared/heroes/skills/actives/pojar.png",
	"SKILL_POJERTVOVAT_MANU": "shared/heroes/skills/actives/pojertvovat_manu.png",
	"SKILL_POLNAYA_OSTANOVKA": "shared/heroes/skills/actives/polnaya_ostanovka.png",
	"SKILL_PRAZDNIK": "shared/heroes/skills/actives/prazdnik.png",
	"SKILL_PREDANNOST": "shared/heroes/skills/actives/predannost.png",
	"SKILL_PREKRATIT_PRITOK_MONSTROV": "shared/heroes/skills/actives/prekratit_pritok_monstrov.png",
	"SKILL_PRISPOSOBITSYA_K_MESTNOSTI": "shared/heroes/skills/actives/prisposobitsya_k_mestnosti.png",
	"SKILL_PRISPOSOBITSYA_K_MESTNOSTI_CASTLE": "shared/heroes/skills/actives/prisposobitsya_k_mestnosti_castle.png",
	"SKILL_PRITOK_MONSTROV": "shared/heroes/skills/actives/pritok_monstrov.png",
	"SKILL_PRIZYV_ANTISHPIONOV": "shared/heroes/skills/actives/prizyv_antishpionov.png",
	"SKILL_PRIZYV_ANTISHPIONOV_CASTLE": "shared/heroes/skills/actives/prizyv_antishpionov_castle.png",
	"SKILL_PRIZYV_DREVNIH": "shared/heroes/skills/actives/prizyv_drevnih.png",
	"SKILL_PRIZYV_ISSLEDOVATELEI": "shared/heroes/skills/actives/prizyv_issledovatelei.png",
	"SKILL_PRIZYV_KONNIKOV": "shared/heroes/skills/actives/prizyv_konnikov.png",
	"SKILL_PRIZYV_KONNIKOV_CASTLE": "shared/heroes/skills/actives/prizyv_konnikov_castle.png",
	"SKILL_PRIZYV_KUPCOV": "shared/heroes/skills/actives/prizyv_kupcov.png",
	"SKILL_PRIZYV_LEKAREI": "shared/heroes/skills/actives/prizyv_lekarei.png",
	"SKILL_PRIZYV_LEKAREI_CASTLE": "shared/heroes/skills/actives/prizyv_lekarei_castle.png",
	"SKILL_PRIZYV_LETAYUSCHIH": "shared/heroes/skills/actives/prizyv_letayuschih.png",
	"SKILL_PRIZYV_LETAYUSCHIH_CASTLE": "shared/heroes/skills/actives/prizyv_letayuschih_castle.png",
	"SKILL_PRIZYV_MAGOV": "shared/heroes/skills/actives/prizyv_magov.png",
	"SKILL_PRIZYV_MAGOV_CASTLE": "shared/heroes/skills/actives/prizyv_magov_castle.png",
	"SKILL_PRIZYV_NAEMNIKOV": "shared/heroes/skills/actives/prizyv_naemnikov.png",
	"SKILL_PRIZYV_NAEMNIKOV_CASTLE": "shared/heroes/skills/actives/prizyv_naemnikov_castle.png",
	"SKILL_PRIZYV_NOSILSCHIKOV": "shared/heroes/skills/actives/prizyv_nosilschikov.png",
	"SKILL_PRIZYV_NOSILSCHIKOV_CASTLE": "shared/heroes/skills/actives/prizyv_nosilschikov_castle.png",
	"SKILL_PRIZYV_POSELENCA": "shared/heroes/skills/actives/prizyv_poselenca.png",
	"SKILL_PRIZYV_PROVIDCEV": "shared/heroes/skills/actives/prizyv_providcev.png",
	"SKILL_PRIZYV_SHPIONOV": "shared/heroes/skills/actives/prizyv_shpionov.png",
	"SKILL_PRIZYV_STRELKOV": "shared/heroes/skills/actives/prizyv_strelkov.png",
	"SKILL_PRIZYV_STRELKOV_CASTLE": "shared/heroes/skills/actives/prizyv_strelkov_castle.png",
	"SKILL_PRIZYV_VOINOV": "shared/heroes/skills/actives/prizyv_voinov.png",
	"SKILL_PRIZYV_VOINOV_CASTLE": "shared/heroes/skills/actives/prizyv_voinov_castle.png",
	"SKILL_PRIZYV_ZERKAL": "shared/heroes/skills/actives/prizyv_zerkal.png",
	"SKILL_PRIZYV_ZERKAL_CASTLE": "shared/heroes/skills/actives/prizyv_zerkal_castle.png",
	"SKILL_PROKLYATE_BASHEN": "shared/heroes/skills/actives/proklyate_bashen.png",
	"SKILL_PROKLYATE_BLIZORUKOSTI": "shared/heroes/skills/actives/proklyate_blizorukosti.png",
	"SKILL_PROKLYATE_BOLOTO": "shared/heroes/skills/actives/proklyate_boloto.png",
	"SKILL_PROKLYATE_DOMOV": "shared/heroes/skills/actives/proklyate_domov.png",
	"SKILL_PROKLYATE_HLEBOROBOV": "shared/heroes/skills/actives/proklyate_hleborobov.png",
	"SKILL_PROKLYATE_ISSLEDOVATELEI": "shared/heroes/skills/actives/proklyate_issledovatelei.png",
	"SKILL_PROKLYATE_JADNOST": "shared/heroes/skills/actives/proklyate_jadnost.png",
	"SKILL_PROKLYATE_KAMNETESOV": "shared/heroes/skills/actives/proklyate_kamnetesov.png",
	"SKILL_PROKLYATE_KARTOGRAFII": "shared/heroes/skills/actives/proklyate_kartografii.png",
	"SKILL_PROKLYATE_KUPCOV": "shared/heroes/skills/actives/proklyate_kupcov.png",
	"SKILL_PROKLYATE_LAVOCHNIKOV": "shared/heroes/skills/actives/proklyate_lavochnikov.png",
	"SKILL_PROKLYATE_LESORUBOV": "shared/heroes/skills/actives/proklyate_lesorubov.png",
	"SKILL_PROKLYATE_MAGICHESKIH_BASHEN": "shared/heroes/skills/actives/proklyate_magicheskih_bashen.png",
	"SKILL_PROKLYATE_MANY": "shared/heroes/skills/actives/proklyate_many.png",
	"SKILL_PROKLYATE_MAYAK": "shared/heroes/skills/actives/proklyate_mayak.png",
	"SKILL_PROKLYATE_NASLAT_GOLOD": "shared/heroes/skills/actives/proklyate_naslat_golod.png",
	"SKILL_PROKLYATE_NEUDACHA": "shared/heroes/skills/actives/proklyate_neudacha.png",
	"SKILL_PROKLYATE_OTRAVLENIE_POCHVY": "shared/heroes/skills/actives/proklyate_otravlenie_pochvy.png",
	"SKILL_PROKLYATE_OTSTUPNIKA": "shared/heroes/skills/actives/proklyate_otstupnika.png",
	"SKILL_PROKLYATE_PROVIDENIYA": "shared/heroes/skills/actives/proklyate_provideniya.png",
	"SKILL_PROKLYATE_RAZVOROVYVANIE": "shared/heroes/skills/actives/proklyate_razvorovyvanie.png",
	"SKILL_PROKLYATE_RUDOKOPOV": "shared/heroes/skills/actives/proklyate_rudokopov.png",
	"SKILL_PROKLYATE_SHPIONAJA": "shared/heroes/skills/actives/proklyate_shpionaja.png",
	"SKILL_PROKLYATE_SLABOST_VOISK": "shared/heroes/skills/actives/proklyate_slabost_voisk.png",
	"SKILL_PROKLYATE_SMERT_ISSLEDOVATELYAM": "shared/heroes/skills/actives/proklyate_smert_issledovatelyam.png",
	"SKILL_PROKLYATE_SMERT_KUPCAM": "shared/heroes/skills/actives/proklyate_smert_kupcam.png",
	"SKILL_PROKLYATE_SNIJENIE_ZASCHITY": "shared/heroes/skills/actives/proklyate_snijenie_zaschity.png",
	"SKILL_PROKLYATE_STROITELEI": "shared/heroes/skills/actives/proklyate_stroitelei.png",
	"SKILL_PROKLYATE_TORGOVLI": "shared/heroes/skills/actives/proklyate_torgovli.png",
	"SKILL_PROKLYATE_TRENEROV": "shared/heroes/skills/actives/proklyate_trenerov.png",
	"SKILL_PROKLYATE_UYAZVIMOST": "shared/heroes/skills/actives/proklyate_uyazvimost.png",
	"SKILL_PROKLYATE_ZOLOTOISKATELEI": "shared/heroes/skills/actives/proklyate_zolotoiskatelei.png",
	"SKILL_PROKLYATYE_UKREPLENIYA": "shared/heroes/skills/actives/proklyatye_ukrepleniya.png",
	"SKILL_PROSVETLENIE": "shared/heroes/skills/actives/prosvetlenie.png",
	"SKILL_PROSVETLENIE_SOYUZNIKA": "shared/heroes/skills/actives/prosvetlenie_soyuznika.png",
	"SKILL_PUSTYNNYI_KAMUFLYAJ": "shared/heroes/skills/actives/pustynnyi_kamuflyaj.png",
	"SKILL_PUSTYNNYI_KAMUFLYAJ_CASTLE": "shared/heroes/skills/actives/pustynnyi_kamuflyaj_castle.png",
	"SKILL_RADIUS_ZAKLINANII": "shared/heroes/skills/actives/radius_zaklinanii.png",
	"SKILL_RASSHIRENIE_MANY": "shared/heroes/skills/actives/rasshirenie_many.png",
	"SKILL_RASSHIRENIE_MISSII": "shared/heroes/skills/actives/rasshirenie_missii.png",
	"SKILL_RASSHIRENIE_STROITELSTVA": "shared/heroes/skills/actives/rasshirenie_stroitelstva.png",
	"SKILL_RASSHIRENIE_STROITELSTVA_CASTLE": "shared/heroes/skills/actives/rasshirenie_stroitelstva_castle.png",
	"SKILL_RAZDUT_ARMIYU": "shared/heroes/skills/actives/razdut_armiyu.png",
	"SKILL_RAZDUT_ARMIYU_CASTLE": "shared/heroes/skills/actives/razdut_armiyu_castle.png",
	"SKILL_RAZDUT_ARMIYU_S_GEROEM": "shared/heroes/skills/actives/razdut_armiyu_s_geroem.png",
	"SKILL_RAZGRABLENIE": "shared/heroes/skills/actives/razgrablenie.png",
	"SKILL_RAZGRABLENIE_KOPEI": "shared/heroes/skills/actives/razgrablenie_kopei.png",
	"SKILL_REKREACIYA_ZEMLI": "shared/heroes/skills/actives/rekreaciya_zemli.png",
	"SKILL_REZERV": "shared/heroes/skills/actives/rezerv.png",
	"SKILL_SABOTAJ_RABOTY": "shared/heroes/skills/actives/sabotaj_raboty.png",
	"SKILL_SABOTAJ_STROITELSTVA": "shared/heroes/skills/actives/sabotaj_stroitelstva.png",
	"SKILL_SBOR_TROFEEV": "shared/heroes/skills/actives/sbor_trofeev.png",
	"SKILL_SHKOLA_MAGII": "shared/heroes/skills/actives/shkola_magii.png",
	"SKILL_SHKOLA_MAGII_CASTLE": "shared/heroes/skills/actives/shkola_magii_castle.png",
	"SKILL_SHRON": "shared/heroes/skills/actives/shron.png",
	"SKILL_SILA_SOYUZNIKU": "shared/heroes/skills/actives/sila_soyuzniku.png",
	"SKILL_SILA_SOYUZNIKU_CASTLE": "shared/heroes/skills/actives/sila_soyuzniku_castle.png",
	"SKILL_SILA_VOISK": "shared/heroes/skills/actives/sila_voisk.png",
	"SKILL_SILA_VOISK_CASTLE": "shared/heroes/skills/actives/sila_voisk_castle.png",
	"SKILL_SKOVAT_ARMIYU": "shared/heroes/skills/actives/skovat_armiyu.png",
	"SKILL_SKOVAT_GEROYA": "shared/heroes/skills/actives/skovat_geroya.png",
	"SKILL_SLABOST_MAGOV": "shared/heroes/skills/actives/slabost_magov.png",
	"SKILL_SLABOST_MAGOV_CASTLE": "shared/heroes/skills/actives/slabost_magov_castle.png",
	"SKILL_SLABOST_PRESLEDOVATELEI": "shared/heroes/skills/actives/slabost_presledovatelei.png",
	"SKILL_SLABOST_PRESLEDOVATELEI_CASTLE": "shared/heroes/skills/actives/slabost_presledovatelei_castle.png",
	"SKILL_SLABOST_PROTIVNIKA": "shared/heroes/skills/actives/slabost_protivnika.png",
	"SKILL_SLABOST_VSEH_MAGOV": "shared/heroes/skills/actives/slabost_vseh_magov.png",
	"SKILL_SLABOST_VSEH_MAGOV_CASTLE": "shared/heroes/skills/actives/slabost_vseh_magov_castle.png",
	"SKILL_SMENA_SPECIALIZACII": "shared/heroes/skills/actives/smena_specializacii.png",
	"SKILL_SMOLYANYE_CHANY_V_GORODE": "shared/heroes/skills/actives/smolyanye_chany_v_gorode.png",
	"SKILL_SMOLYANYE_CHANY_V_GORODE_CASTLE": "shared/heroes/skills/actives/smolyanye_chany_v_gorode_castle.png",
	"SKILL_SNIJENIE_OPYTA": "shared/heroes/skills/actives/snijenie_opyta.png",
	"SKILL_SNIJENIE_OPYTA_CASTLE": "shared/heroes/skills/actives/snijenie_opyta_castle.png",
	"SKILL_SNYATIE_OTSTUPNIKA": "shared/heroes/skills/actives/snyatie_otstupnika.png",
	"SKILL_SNYATIE_ZVANII": "shared/heroes/skills/actives/snyatie_zvanii.png",
	"SKILL_SODERJANIE_LEKAREI": "shared/heroes/skills/actives/soderjanie_lekarei.png",
	"SKILL_SODERJANIE_LEKAREI_CASTLE": "shared/heroes/skills/actives/soderjanie_lekarei_castle.png",
	"SKILL_SODERJANIE_LETAYUSCHIH": "shared/heroes/skills/actives/soderjanie_letayuschih.png",
	"SKILL_SODERJANIE_LETAYUSCHIH_CASTLE": "shared/heroes/skills/actives/soderjanie_letayuschih_castle.png",
	"SKILL_SODERJANIE_LUCHNIKOV": "shared/heroes/skills/actives/soderjanie_luchnikov.png",
	"SKILL_SODERJANIE_LUCHNIKOV_CASTLE": "shared/heroes/skills/actives/soderjanie_luchnikov_castle.png",
	"SKILL_SODERJANIE_MAGOV": "shared/heroes/skills/actives/soderjanie_magov.png",
	"SKILL_SODERJANIE_MAGOV_CASTLE": "shared/heroes/skills/actives/soderjanie_magov_castle.png",
	"SKILL_SODERJANIE_NAEMNIKOV": "shared/heroes/skills/actives/soderjanie_naemnikov.png",
	"SKILL_SODERJANIE_NAEMNIKOV_CASTLE": "shared/heroes/skills/actives/soderjanie_naemnikov_castle.png",
	"SKILL_SODERJANIE_VOINOV": "shared/heroes/skills/actives/soderjanie_voinov.png",
	"SKILL_SODERJANIE_VOINOV_CASTLE": "shared/heroes/skills/actives/soderjanie_voinov_castle.png",
	"SKILL_SODERJANIE_VSADNIKOV": "shared/heroes/skills/actives/soderjanie_vsadnikov.png",
	"SKILL_SODERJANIE_VSADNIKOV_CASTLE": "shared/heroes/skills/actives/soderjanie_vsadnikov_castle.png",
	"SKILL_SOZDAT_DEREVO": "shared/heroes/skills/actives/sozdat_derevo.png",
	"SKILL_SOZDAT_JELEZO": "shared/heroes/skills/actives/sozdat_jelezo.png",
	"SKILL_SOZDAT_KAMEN": "shared/heroes/skills/actives/sozdat_kamen.png",
	"SKILL_SOZDAT_NASELENIE": "shared/heroes/skills/actives/sozdat_naselenie.png",
	"SKILL_SOZDAT_ZLAKI": "shared/heroes/skills/actives/sozdat_zlaki.png",
	"SKILL_SOZDAT_ZOLOTO": "shared/heroes/skills/actives/sozdat_zoloto.png",
	"SKILL_SPRINGALD": "shared/heroes/skills/actives/springald.png",
	"SKILL_SPRINGALD_CASTLE": "shared/heroes/skills/actives/springald_castle.png",
	"SKILL_STEPNOI_KAMUFLYAJ": "shared/heroes/skills/actives/stepnoi_kamuflyaj.png",
	"SKILL_STEPNOI_KAMUFLYAJ_CASTLE": "shared/heroes/skills/actives/stepnoi_kamuflyaj_castle.png",
	'SKILL_STONEHENGE_7_BP_SPELL': "shared/heroes/skills/actives/stonehenge_7_bp_spell.png",
	"SKILL_STROITELNYI_BUM": "shared/heroes/skills/actives/stroitelnyi_bum.png",
	"SKILL_SUPERNEKROMANSIYA": "shared/heroes/skills/actives/supernekromansiya.png",
	"SKILL_SUPERNEKROMANSIYA_CASTLE": "shared/heroes/skills/actives/supernekromansiya_castle.png",
	"SKILL_SUPER_DIVERSIYA": "shared/heroes/skills/actives/super_diversiya.png",
	"SKILL_SVERHDALNII_SHPIONAJ": "shared/heroes/skills/actives/sverhdalnii_shpionaj.png",
	"SKILL_SVYAZ_S_SOYUZNIKAMI": "shared/heroes/skills/actives/svyaz_s_soyuznikami.png",
	"SKILL_TAKTIKA_ISPOLZOVANIYA_UKREPLENII": "shared/heroes/skills/actives/taktika_ispolzovaniya_ukreplenii.png",
	"SKILL_TARAN": "shared/heroes/skills/actives/taran.png",
	"SKILL_TELEPORT_GEROYA": "shared/heroes/skills/actives/teleport_geroya.png",
	"SKILL_TELEPORT_RESURSOV": "shared/heroes/skills/actives/teleport_resursov.png",
	"SKILL_TREBUCHET": "shared/heroes/skills/actives/trebuchet.png",
	"SKILL_TREBUCHET_CASTLE": "shared/heroes/skills/actives/trebuchet_castle.png",
	"SKILL_TROYANSKII_KON": "shared/heroes/skills/actives/troyanskii_kon.png",
	"SKILL_TROYANSKII_KON_CASTLE": "shared/heroes/skills/actives/troyanskii_kon_castle.png",
	"SKILL_TUMAN": "shared/heroes/skills/actives/tuman.png",
	"SKILL_TUMANNYI_FANTOM": "shared/heroes/skills/actives/tumannyi_fantom.png",
	"SKILL_UDACHA": "shared/heroes/skills/actives/udacha.png",
	"SKILL_UDACHA_CASTLE": "shared/heroes/skills/actives/udacha_castle.png",
	"SKILL_UDACHA_SOYUZNIKU": "shared/heroes/skills/actives/udacha_soyuzniku.png",
	"SKILL_UDACHA_SOYUZNIKU_CASTLE": "shared/heroes/skills/actives/udacha_soyuzniku_castle.png",
	"SKILL_UJAS": "shared/heroes/skills/actives/ujas.png",
	"SKILL_UJAS_CASTLE": "shared/heroes/skills/actives/ujas_castle.png",
	"SKILL_UKREPIT_ZDANIYA": "shared/heroes/skills/actives/ukrepit_zdaniya.png",
	"SKILL_UKREPIT_ZDANIYA_CASTLE": "shared/heroes/skills/actives/ukrepit_zdaniya_castle.png",
	"SKILL_ULUCHSHENIE_KAMENOLOMEN": "shared/heroes/skills/actives/uluchshenie_kamenolomen.png",
	"SKILL_ULUCHSHENIE_LABORATORII": "shared/heroes/skills/actives/uluchshenie_laboratorii.png",
	"SKILL_ULUCHSHENIE_LAVOK": "shared/heroes/skills/actives/uluchshenie_lavok.png",
	"SKILL_ULUCHSHENIE_LEKAREI": "shared/heroes/skills/actives/uluchshenie_lekarei.png",
	"SKILL_ULUCHSHENIE_LEKAREI_CASTLE": "shared/heroes/skills/actives/uluchshenie_lekarei_castle.png",
	"SKILL_ULUCHSHENIE_LEKAREI_SOYUZNIKA": "shared/heroes/skills/actives/uluchshenie_lekarei_soyuznika.png",
	"SKILL_ULUCHSHENIE_LEKAREI_SOYUZNIKA_CASTLE": "shared/heroes/skills/actives/uluchshenie_lekarei_soyuznika_castle.png",
	"SKILL_ULUCHSHENIE_LESOPILOK": "shared/heroes/skills/actives/uluchshenie_lesopilok.png",
	"SKILL_ULUCHSHENIE_MAGICHESKIH_BASHEN": "shared/heroes/skills/actives/uluchshenie_magicheskih_bashen.png",
	"SKILL_ULUCHSHENIE_MAGICHESKIH_BASHEN_CASTLE": "shared/heroes/skills/actives/uluchshenie_magicheskih_bashen_castle.png",
	"SKILL_ULUCHSHENIE_MAGOV": "shared/heroes/skills/actives/uluchshenie_magov.png",
	"SKILL_ULUCHSHENIE_MELNIC": "shared/heroes/skills/actives/uluchshenie_melnic.png",
	"SKILL_ULUCHSHENIE_OBYCHNYH_BASHEN": "shared/heroes/skills/actives/uluchshenie_obychnyh_bashen.png",
	"SKILL_ULUCHSHENIE_OBYCHNYH_BASHEN_CASTLE": "shared/heroes/skills/actives/uluchshenie_obychnyh_bashen_castle.png",
	"SKILL_ULUCHSHENIE_PRIISKOV": "shared/heroes/skills/actives/uluchshenie_priiskov.png",
	"SKILL_ULUCHSHENIE_RUDNIKOV": "shared/heroes/skills/actives/uluchshenie_rudnikov.png",
	"SKILL_ULUCHSHENIE_ZEMLI": "shared/heroes/skills/actives/uluchshenie_zemli.png",
	"SKILL_ULUCHSHENYI_OTBOR": "shared/heroes/skills/actives/uluchshenyi_otbor.png",
	"SKILL_UNICHTOJITEL_DEMONOV": "shared/heroes/skills/actives/unichtojitel_demonov.png",
	"SKILL_UNICHTOJITEL_DROU": "shared/heroes/skills/actives/unichtojitel_drou.png",
	"SKILL_UNICHTOJITEL_ELFOV": "shared/heroes/skills/actives/unichtojitel_elfov.png",
	"SKILL_UNICHTOJITEL_LYUDEI": "shared/heroes/skills/actives/unichtojitel_lyudei.png",
	"SKILL_UNICHTOJITEL_MONSTROV": "shared/heroes/skills/actives/unichtojitel_monstrov.png",
	"SKILL_UREZANNYI_PAEK": "shared/heroes/skills/actives/urezannyi_paek.png",
	"SKILL_USKORENIE_ISSLEDOVATELEI": "shared/heroes/skills/actives/uskorenie_issledovatelei.png",
	"SKILL_USKORENIE_KUPCOV": "shared/heroes/skills/actives/uskorenie_kupcov.png",
	"SKILL_USKORENIE_PRIEZJIM_KUPCAM": "shared/heroes/skills/actives/uskorenie_priezjim_kupcam.png",
	"SKILL_USKORENIE_TRENIROVOK": "shared/heroes/skills/actives/uskorenie_trenirovok.png",
	"SKILL_USKORENIE_TRENIROVOK_CASTLE": "shared/heroes/skills/actives/uskorenie_trenirovok_castle.png",
	"SKILL_USKORENNIY_REMONT": "shared/heroes/skills/actives/uskorenniy_remont.png",
	"SKILL_USKORENNOE_ZASELENIE": "shared/heroes/skills/actives/uskorennoe_zaselenie.png",
	"SKILL_USTOICHIVOST_LEKAREI": "shared/heroes/skills/actives/ustoichivost_lekarei.png",
	"SKILL_USTOICHIVOST_LEKAREI_CASTLE": "shared/heroes/skills/actives/ustoichivost_lekarei_castle.png",
	"SKILL_USTOICHIVOST_LETASCHIH": "shared/heroes/skills/actives/ustoichivost_letaschih.png",
	"SKILL_USTOICHIVOST_LETASCHIH_CASTLE": "shared/heroes/skills/actives/ustoichivost_letaschih_castle.png",
	"SKILL_USTOICHIVOST_MAGOV": "shared/heroes/skills/actives/ustoichivost_magov.png",
	"SKILL_USTOICHIVOST_MAGOV_CASTLE": "shared/heroes/skills/actives/ustoichivost_magov_castle.png",
	"SKILL_USTOICHIVOST_NOSILSCHIKOV": "shared/heroes/skills/actives/ustoichivost_nosilschikov.png",
	"SKILL_USTOICHIVOST_NOSILSCHIKOV_CASTLE": "shared/heroes/skills/actives/ustoichivost_nosilschikov_castle.png",
	"SKILL_USTOICHIVOST_SOYUZNIKOV": "shared/heroes/skills/actives/ustoichivost_soyuznikov.png",
	"SKILL_USTOICHIVOST_SOYUZNIKOV_CASTLE": "shared/heroes/skills/actives/ustoichivost_soyuznikov_castle.png",
	"SKILL_USTOICHIVOST_STRELKOV": "shared/heroes/skills/actives/ustoichivost_strelkov.png",
	"SKILL_USTOICHIVOST_STRELKOV_CASTLE": "shared/heroes/skills/actives/ustoichivost_strelkov_castle.png",
	"SKILL_USTOICHIVOST_VOINOV": "shared/heroes/skills/actives/ustoichivost_voinov.png",
	"SKILL_USTOICHIVOST_VOINOV_CASTLE": "shared/heroes/skills/actives/ustoichivost_voinov_castle.png",
	"SKILL_USTOICHIVOST_VSADNIKOV": "shared/heroes/skills/actives/ustoichivost_vsadnikov.png",
	"SKILL_USTOICHIVOST_VSADNIKOV_CASTLE": "shared/heroes/skills/actives/ustoichivost_vsadnikov_castle.png",
	"SKILL_USTRANENIE_SHTRAFA_ZEMLI": "shared/heroes/skills/actives/ustranenie_shtrafa_zemli.png",
	"SKILL_UVELICHENIE_POVOZOK": "shared/heroes/skills/actives/uvelichenie_povozok.png",
	"SKILL_UYAZVIMOST_NAPADAYUSCHIH": "shared/heroes/skills/actives/uyazvimost_napadayuschih.png",
	"SKILL_UYAZVIMOST_NAPADAYUSCHIH_CASTLE": "shared/heroes/skills/actives/uyazvimost_napadayuschih_castle.png",
	"SKILL_VELIKAYA_KORONA": "shared/heroes/skills/actives/velikaya_korona.png",
	"SKILL_VELIKAYA_MUDROST": "shared/heroes/skills/actives/velikaya_mudrost.png",
	"SKILL_VIRUS": "shared/heroes/skills/actives/virus.png",
	"SKILL_VOINY_PRESLEDOVATELI": "shared/heroes/skills/actives/voiny_presledovateli.png",
	"SKILL_VOINY_PRESLEDOVATELI_CASTLE": "shared/heroes/skills/actives/voiny_presledovateli_castle.png",
	"SKILL_VOLSHEBNOE_DEREVO": "shared/heroes/skills/actives/volshebnoe_derevo.png",
	"SKILL_VOLSHEBNYI_KAMEN": "shared/heroes/skills/actives/volshebnyi_kamen.png",
	"SKILL_VOLSHEBNYI_KOLOS": "shared/heroes/skills/actives/volshebnyi_kolos.png",
	"SKILL_VOLSHEBNYI_SAMORODOK": "shared/heroes/skills/actives/volshebnyi_samorodok.png",
	"SKILL_VOLSHEBNYI_SLITOK": "shared/heroes/skills/actives/volshebnyi_slitok.png",
	"SKILL_VOODUSHEVLENIE_MAGOV": "shared/heroes/skills/actives/voodushevlenie_magov.png",
	"SKILL_VOODUSHEVLENIE_MAGOV_CASTLE": "shared/heroes/skills/actives/voodushevlenie_magov_castle.png",
	"SKILL_VOSSTANOVLENIE_SIL": "shared/heroes/skills/actives/vosstanovlenie_sil.png",
	"SKILL_VSADNIKI_PRESLEDOVATELI": "shared/heroes/skills/actives/vsadniki_presledovateli.png",
	"SKILL_VSADNIKI_PRESLEDOVATELI_CASTLE": "shared/heroes/skills/actives/vsadniki_presledovateli_castle.png",
	"SKILL_VSEOBSCHAYA_NEUDACHA": "shared/heroes/skills/actives/vseobschaya_neudacha.png",
	"SKILL_VSEOBSCHAYA_NEUDACHA_CASTLE": "shared/heroes/skills/actives/vseobschaya_neudacha_castle.png",
	"SKILL_VSEOBSCHAYA_SLABOST": "shared/heroes/skills/actives/vseobschaya_slabost.png",
	"SKILL_VSEOBSCHAYA_SLABOST_CASTLE": "shared/heroes/skills/actives/vseobschaya_slabost_castle.png",
	"SKILL_VSEOBSCHEE_PRESLEDOVANIE": "shared/heroes/skills/actives/vseobschee_presledovanie.png",
	"SKILL_VSEOBSCHEE_PRESLEDOVANIE_CASTLE": "shared/heroes/skills/actives/vseobschee_presledovanie_castle.png",
	"SKILL_VSPLESK_MANY": "shared/heroes/skills/actives/vsplesk_many.png",
	"SKILL_VYNOSLIVOST_ARMII": "shared/heroes/skills/actives/vynoslivost_armii.png",
	"SKILL_VYNOSLIVOST_ARMII_CASTLE": "shared/heroes/skills/actives/vynoslivost_armii_castle.png",
	"SKILL_VYNOSLIVOST_MAGOV": "shared/heroes/skills/actives/vynoslivost_magov.png",
	"SKILL_VYNOSLIVOST_MAGOV_CASTLE": "shared/heroes/skills/actives/vynoslivost_magov_castle.png",
	"SKILL_VYNOSLIVOST_NOSILSCHIKOV": "shared/heroes/skills/actives/vynoslivost_nosilschikov.png",
	"SKILL_VYNOSLIVOST_SOYUZNIKOV": "shared/heroes/skills/actives/vynoslivost_soyuznikov.png",
	"SKILL_VYNOSLIVOST_SOYUZNIKOV_CASTLE": "shared/heroes/skills/actives/vynoslivost_soyuznikov_castle.png",
	"SKILL_VYSOSAT_MANU": "shared/heroes/skills/actives/vysosat_manu.png",
	"SKILL_VYYAVLYAT_VOROTA": "shared/heroes/skills/actives/vyyavlyat_vorota.png",
	"SKILL_YAROST_GOR": "shared/heroes/skills/actives/yarost_gor.png",
	"SKILL_YAROST_GOR_CASTLE": "shared/heroes/skills/actives/yarost_gor_castle.png",
	"SKILL_YAROST_LESA": "shared/heroes/skills/actives/yarost_lesa.png",
	"SKILL_YAROST_LESA_CASTLE": "shared/heroes/skills/actives/yarost_lesa_castle.png",
	"SKILL_YAROST_LETAYUSCHIH_DEMONOV": "shared/heroes/skills/actives/yarost_letayuschih_demonov.png",
	"SKILL_YAROST_LETAYUSCHIH_DROU": "shared/heroes/skills/actives/yarost_letayuschih_drou.png",
	"SKILL_YAROST_LETAYUSCHIH_ELFOV": "shared/heroes/skills/actives/yarost_letayuschih_elfov.png",
	"SKILL_YAROST_LETAYUSCHIH_LYUDEI": "shared/heroes/skills/actives/yarost_letayuschih_lyudei.png",
	"SKILL_YAROST_MAGOV": "shared/heroes/skills/actives/yarost_magov.png",
	"SKILL_YAROST_MERTVOI_ZEMLI_CASTLE": "shared/heroes/skills/actives/yarost_mertvoi_zemli_castle.png",
	"SKILL_YAROST_PROKLYATIH_LESOV_CASTLE": "shared/heroes/skills/actives/yarost_proklyatih_lesov_castle.png",
	"SKILL_YAROST_PUSTYNI": "shared/heroes/skills/actives/yarost_pustyni.png",
	"SKILL_YAROST_PUSTYNI_CASTLE": "shared/heroes/skills/actives/yarost_pustyni_castle.png",
	"SKILL_YAROST_STEPI": "shared/heroes/skills/actives/yarost_stepi.png",
	"SKILL_YAROST_STEPI_CASTLE": "shared/heroes/skills/actives/yarost_stepi_castle.png",
	"SKILL_YAROST_STRELKOV_DEMONOV": "shared/heroes/skills/actives/yarost_strelkov_demonov.png",
	"SKILL_YAROST_STRELKOV_DROU": "shared/heroes/skills/actives/yarost_strelkov_drou.png",
	"SKILL_YAROST_STRELKOV_ELFOV": "shared/heroes/skills/actives/yarost_strelkov_elfov.png",
	"SKILL_YAROST_STRELKOV_LYUDEI": "shared/heroes/skills/actives/yarost_strelkov_lyudei.png",
	"SKILL_YAROST_SVYASHENNOI_ZEMLI_CASTLE": "shared/heroes/skills/actives/yarost_svyashennoi_zemli_castle.png",
	"SKILL_YAROST_VOINOV_DEMONOV": "shared/heroes/skills/actives/yarost_voinov_demonov.png",
	"SKILL_YAROST_VOINOV_DROU": "shared/heroes/skills/actives/yarost_voinov_drou.png",
	"SKILL_YAROST_VOINOV_ELFOV": "shared/heroes/skills/actives/yarost_voinov_elfov.png",
	"SKILL_YAROST_VOINOV_LYUDEI": "shared/heroes/skills/actives/yarost_voinov_lyudei.png",
	"SKILL_YAROST_VOLSHEBNOGO_LESA_CASTLE": "shared/heroes/skills/actives/yarost_volshebnogo_lesa_castle.png",
	"SKILL_YAROST_VSADNIKOV_DEMONOV": "shared/heroes/skills/actives/yarost_vsadnikov_demonov.png",
	"SKILL_YAROST_VSADNIKOV_DROU": "shared/heroes/skills/actives/yarost_vsadnikov_drou.png",
	"SKILL_YAROST_VSADNIKOV_ELFOV": "shared/heroes/skills/actives/yarost_vsadnikov_elfov.png",
	"SKILL_YAROST_VSADNIKOV_LYUDEI": "shared/heroes/skills/actives/yarost_vsadnikov_lyudei.png",
	"SKILL_YAROST_VSEH_LETAYUSCHIH": "shared/heroes/skills/actives/yarost_vseh_letayuschih.png",
	"SKILL_YAROST_VSEH_LETAYUSCHIH_CASTLE": "shared/heroes/skills/actives/yarost_vseh_letayuschih_castle.png",
	"SKILL_YAROST_VSEH_STRELKOV": "shared/heroes/skills/actives/yarost_vseh_strelkov.png",
	"SKILL_YAROST_VSEH_STRELKOV_CASTLE": "shared/heroes/skills/actives/yarost_vseh_strelkov_castle.png",
	"SKILL_YAROST_VSEH_VOINOV": "shared/heroes/skills/actives/yarost_vseh_voinov.png",
	"SKILL_YAROST_VSEH_VOINOV_CASTLE": "shared/heroes/skills/actives/yarost_vseh_voinov_castle.png",
	"SKILL_YAROST_VSEH_VSADNIKOV": "shared/heroes/skills/actives/yarost_vseh_vsadnikov.png",
	"SKILL_YAROST_VSEH_VSADNIKOV_CASTLE": "shared/heroes/skills/actives/yarost_vseh_vsadnikov_castle.png",
	"SKILL_ZABASTOVKA_ALHIMIKOV": "shared/heroes/skills/actives/zabastovka_alhimikov.png",
	"SKILL_ZABASTOVKA_HLEBOROBOV": "shared/heroes/skills/actives/zabastovka_hleborobov.png",
	"SKILL_ZABASTOVKA_ISSLEDOVATELEI": "shared/heroes/skills/actives/zabastovka_issledovatelei.png",
	"SKILL_ZABASTOVKA_KAMNETESOV": "shared/heroes/skills/actives/zabastovka_kamnetesov.png",
	"SKILL_ZABASTOVKA_LESORUBOV": "shared/heroes/skills/actives/zabastovka_lesorubov.png",
	"SKILL_ZABASTOVKA_RUDOKOPOV": "shared/heroes/skills/actives/zabastovka_rudokopov.png",
	"SKILL_ZABASTOVKA_TRENEROV": "shared/heroes/skills/actives/zabastovka_trenerov.png",
	"SKILL_ZAMASKIROVAT_ARMIYU": "shared/heroes/skills/actives/zamaskirovat_armiyu.png",
	"SKILL_ZAMASKIROVAT_ARMIYU_CASTLE": "shared/heroes/skills/actives/zamaskirovat_armiyu_castle.png",
	"SKILL_ZAMEDLENIE_CASTLE": "shared/heroes/skills/actives/zamedlenie_castle.png",
	"SKILL_ZASCHITA": "shared/heroes/skills/actives/zaschita.png",
	"SKILL_ZASCHITA_CASTLE": "shared/heroes/skills/actives/zaschita_castle.png",
	"SKILL_ZASCHITA_GEROYA_OT_MAGII": "shared/heroes/skills/actives/zaschita_geroya_ot_magii.png",
	"SKILL_ZASCHITA_GEROYA_OT_NAPADENII_MONSTROV": "shared/heroes/skills/actives/zaschita_geroya_ot_napadenii_monstrov.png",
	"SKILL_ZASCHITA_MAGOV": "shared/heroes/skills/actives/zaschita_magov.png",
	"SKILL_ZASCHITA_MAGOV_CASTLE": "shared/heroes/skills/actives/zaschita_magov_castle.png",
	"SKILL_ZASCHITA_OT_MARODERSTVA_CASTLE": "shared/heroes/skills/actives/zaschita_ot_maroderstva_castle.png",
	"SKILL_ZASCHITA_OT_SBORA_TROFEEV_CASTLE": "shared/heroes/skills/actives/zaschita_ot_sbora_trofeev_castle.png",
	"SKILL_ZASCHITA_OT_UKREPLENII": "shared/heroes/skills/actives/zaschita_ot_ukreplenii.png",
	"SKILL_ZASCHITA_SOYUZNIKU": "shared/heroes/skills/actives/zaschita_soyuzniku.png",
	"SKILL_ZASCHITA_VLADENIYA_OT_MAGII": "shared/heroes/skills/actives/zaschita_vladeniya_ot_magii.png",
	"SKILL_ZASCHITA_VLADENIYA_OT_MAGII_CASTLE": "shared/heroes/skills/actives/zaschita_vladeniya_ot_magii_castle.png",
	"SKILL_ZASCHITA_VLADENIYA_OT_NAPADENII_MONSTROV": "shared/heroes/skills/actives/zaschita_vladeniya_ot_napadenii_monstrov.png",
	"SKILL_ZAVESCHANIE_MONSTROV": "shared/heroes/skills/actives/zaveschanie_monstrov.png",
	"SKILL_ZEMLETRYASENIE": "shared/heroes/skills/actives/zemletryasenie.png",
	"SKILL_ZEMLETRYASENIE_CASTLE": "shared/heroes/skills/actives/zemletryasenie_castle.png",
	"SKILL_ZLAKI_LYUDEI": "shared/heroes/skills/actives/zlaki_lyudei.png",
	"SKILL_ZNANIE_POVADOK_MONSTROV": "shared/heroes/skills/actives/znanie_povadok_monstrov.png",
	"SKILL_ZNANIE_SLABYH_MEST_MONSTROV": "shared/heroes/skills/actives/znanie_slabyh_mest_monstrov.png"

//autogenerated text ends here
}

var KingdomAssets =
{
	MINI_MAP : "kingdom/mini_map.jpg",

	DROW_CITY_0 : "drow/city_0.png",
	DROW_CITY_1 : "drow/city_1.png",
	DROW_CITY_2 : "drow/city_2.png",
	DROW_CITY_3 : "drow/city_3.png",
	DROW_CITY_4 : "drow/city_4.png",
	DROW_CITY_5 : "drow/city_5.png",

	ELF_CITY_0 : "elf/city_0.png",
	ELF_CITY_1 : "elf/city_1.png",
	ELF_CITY_2 : "elf/city_2.png",
	ELF_CITY_3 : "elf/city_3.png",
	ELF_CITY_4 : "elf/city_4.png",
	ELF_CITY_5 : "elf/city_5.png",

	DEMON_CITY_0 : "demon/city_0.png",
	DEMON_CITY_1 : "demon/city_1.png",
	DEMON_CITY_2 : "demon/city_2.png",
	DEMON_CITY_3 : "demon/city_3.png",
	DEMON_CITY_4 : "demon/city_4.png",
	DEMON_CITY_5 : "demon/city_5.png",

	HUMAN_CITY_0 : "human/city_0.png",
	HUMAN_CITY_1 : "human/city_1.png",
	HUMAN_CITY_2 : "human/city_2.png",
	HUMAN_CITY_3 : "human/city_3.png",
	HUMAN_CITY_4 : "human/city_4.png",
	HUMAN_CITY_5 : "human/city_5.png",

	GRID : "shared/kingdom/grid.gif",
	PIT : "shared/kingdom/mine_build.png",
	MINE_IRON : "shared/kingdom/iron.png",
	MINE_STONE : "shared/kingdom/stone.png",
	MINE_GOLD : "shared/kingdom/gold.png",

	LAKE : "shared/kingdom/lake.png",
	RUIN : "shared/kingdom/ruin_kingdom_hall.png",
	CAMP : "shared/kingdom/camp.png",
	GROTTO : "shared/kingdom/grotto.png",
	EVIL : "shared/kingdom/resident_evil.png",
	GRAIL : "shared/kingdom/grail.png",
	STONEHENGE : "shared/kingdom/stonehenge.png",
	CATAPULT : "shared/kingdom/catapult.png",

	CASTLE_0 : "shared/kingdom/castle_0.png",
	CASTLE_1 : "shared/kingdom/castle_1.png",
	CASTLE_2 : "shared/kingdom/castle_2.png",
	CASTLE_3 : "shared/kingdom/castle_3.png",
	CASTLE_4 : "shared/kingdom/castle_4.png",
	CASTLE_5 : "shared/kingdom/castle_5.png",

	VAGONETTE_IRON : "shared/kingdom/mine_vagonette_iron.png",
	VAGONETTE_STONE : "shared/kingdom/mine_vagonette_stone.png",
	VAGONETTE_GOLD : "shared/kingdom/mine_vagonette_gold.png",

	T_MOUNTAIN_0 : "shared/kingdom/terrain/cliff_0.png",
	T_MOUNTAIN_1 : "shared/kingdom/terrain/cliff_1.png",
	T_MOUNTAIN_2 : "shared/kingdom/terrain/cliff_2.png",
	T_MOUNTAIN_3 : "shared/kingdom/terrain/cliff_3.png",
	T_MOUNTAIN_B : "shared/kingdom/terrain/cliff_b.png",

	T_DESERT_0 : "shared/kingdom/terrain/desert_0.png",
	T_DESERT_1 : "shared/kingdom/terrain/desert_1.png",
	T_DESERT_2 : "shared/kingdom/terrain/desert_2.png",
	T_DESERT_3 : "shared/kingdom/terrain/desert_3.png",
	T_DESERT_B : "shared/kingdom/terrain/desert_b.png",

	T_FOREST_0 : "shared/kingdom/terrain/forest_0.png",
	T_FOREST_1 : "shared/kingdom/terrain/forest_1.png",
	T_FOREST_2 : "shared/kingdom/terrain/forest_2.png",
	T_FOREST_3 : "shared/kingdom/terrain/forest_3.png",
	T_FOREST_B : "shared/kingdom/terrain/forest_b.png",

	T_STEPPE_0 : "shared/kingdom/terrain/steppe_0.png",
	T_STEPPE_1 : "shared/kingdom/terrain/steppe_1.png",
	T_STEPPE_2 : "shared/kingdom/terrain/steppe_2.png",
	T_STEPPE_3 : "shared/kingdom/terrain/steppe_3.png",
	T_STEPPE_B : "shared/kingdom/terrain/steppe_b.png",

	T_MAGICFOREST_0 : "shared/kingdom/terrain/magic_0.png",
	T_MAGICFOREST_1 : "shared/kingdom/terrain/magic_1.png",
	T_MAGICFOREST_2 : "shared/kingdom/terrain/magic_2.png",
	T_MAGICFOREST_3 : "shared/kingdom/terrain/magic_3.png",
	T_MAGICFOREST_B : "shared/kingdom/terrain/magic_b.png",

	T_CURSEDFOREST_0 : "shared/kingdom/terrain/cursed_0.png",
	T_CURSEDFOREST_1 : "shared/kingdom/terrain/cursed_1.png",
	T_CURSEDFOREST_2 : "shared/kingdom/terrain/cursed_2.png",
	T_CURSEDFOREST_3 : "shared/kingdom/terrain/cursed_3.png",
	T_CURSEDFOREST_B : "shared/kingdom/terrain/cursed_b.png",

	T_HOLYLAND_0 : "shared/kingdom/terrain/holy_0.png",
	T_HOLYLAND_1 : "shared/kingdom/terrain/holy_1.png",
	T_HOLYLAND_2 : "shared/kingdom/terrain/holy_2.png",
	T_HOLYLAND_3 : "shared/kingdom/terrain/holy_3.png",
	T_HOLYLAND_B : "shared/kingdom/terrain/holy_b.png",

	T_DEADLAND_0 : "shared/kingdom/terrain/dead_0.png",
	T_DEADLAND_1 : "shared/kingdom/terrain/dead_1.png",
	T_DEADLAND_2 : "shared/kingdom/terrain/dead_2.png",
	T_DEADLAND_3 : "shared/kingdom/terrain/dead_3.png",
	T_DEADLAND_B : "shared/kingdom/terrain/dead_b.png",

	T_UNDERGROUND_B : "shared/kingdom/terrain/mine.png",

	BUTTON_ASSISTANCE : "shared/kingdom/menu/button_assistance.png",
	BUTTON_ATTACK : "shared/kingdom/menu/button_attack.png",
	BUTTON_INFO : "shared/kingdom/menu/button_info.png",
	BUTTON_REFUSE : "shared/kingdom/menu/button_refuse.png",
	BUTTON_VIEW_REPORT : "shared/kingdom/menu/button_view_report.png",
	BUTTON_MOVE_ARMY : "shared/kingdom/menu/button_move_army.png",
	BUTTON_MOVE_RESOURCES : "shared/kingdom/menu/button_move_resources.png",
	BUTTON_OBSERVATION : "shared/kingdom/menu/button_observation.png",
	BUTTON_SETTLE : "shared/kingdom/menu/button_settle.png",
	BUTTON_SPY : "shared/kingdom/menu/button_spy.png",
	BUTTON_EXPEDITION : "shared/kingdom/menu/button_expedition.png",
	BUTTON_FORGIVE_BETRAYER : "shared/kingdom/menu/button_forgive_betrayer.png",
	BUTTON_SHARE : "shared/kingdom/menu/button_share.png",
	BUTTON_CAST : "shared/kingdom/menu/button_cast.png",
	BUTTON_CAMP : "shared/kingdom/menu/button_camp.png",

	BUTTON_ENTER_ESTATE : "shared/kingdom/button_enter_estate.png",

	HEADER : "shared/kingdom/header.jpg",
	FOOTER : "shared/kingdom/footer.jpg",
	LEFT_MAP : "shared/kingdom/left_map.jpg",
	RIGHT_MAP : "shared/kingdom/right_map.jpg",
	GO : "shared/kingdom/go.png",

	NAVIGATE_WEST : "shared/kingdom/arrow_west.png",
	NAVIGATE_EAST : "shared/kingdom/arrow_east.png",
	NAVIGATE_NORTH : "shared/kingdom/arrow_nord.png",
	NAVIGATE_SOUTH : "shared/kingdom/arrow_south.png",

	ANCIENTS_DEFENSE : "shared/kingdom/ancients_defense.png",
	CLOSED_GATE_ICON : "shared/kingdom/closed_gate_icon.png",
	FLAG : "shared/kingdom/flag.png",
	MAGIC_DEFENSE : "shared/kingdom/magic_defense_ani.swf",
	MAGIC_DEFENSE_STATIC : "shared/kingdom/magic_defense.png",
	MAGIC_DISABLE : "shared/kingdom/magic_disable_ani.swf",
	MAGIC_DISABLE_STATIC : "shared/kingdom/magic_disable.png",
	KINGDOM_ANIMATIONS_0 : "shared/kingdom/kingdom_animation_crown.swf",
	KINGDOM_ANIMATIONS_1 : "shared/kingdom/kingdom_animation_fireworks.swf",
	KINGDOM_ANIMATIONS_2 : "shared/kingdom/kingdom_animation_skulls.swf",
	KINGDOM_ANIMATIONS_3 : "shared/kingdom/kingdom_animation_fireplace.swf",
	KINGDOM_ANIMATIONS_4 : "shared/kingdom/kingdom_animation_test.swf",
	KINGDOM_STATIC_0 : "shared/kingdom/crown.png",
	KINGDOM_STATIC_1 : "shared/kingdom/fireworks.png",
	KINGDOM_STATIC_2 : "shared/kingdom/skulls.png",
	KINGDOM_STATIC_3 : "shared/kingdom/fire.png",

	THEBESTGAME_ANYMATION : "shared/kingdom/thebestgame_2011_action3.swf",
	THEBESTGAME_STATIC : "shared/kingdom/thebestgame_2011.png"
}

KingdomAssets.KINGDOM_STATIC_4 = KingdomAssets.KINGDOM_ANIMATIONS_4;

var LoginAssets = {}
LoginAssets.getServerStatusIcon = function(server)
{
    if (!server) return 'login/server_closed.png';
    if (server.isSaveInProgress) return 'login/round_icon_busy.png';
    if (!server.available) return 'login/server_closed.png';
    if (server.avatarExists) return 'login/can_enter_server.png';
    if (!server.hasInvite) return 'login/server_closed.png';
    if (!server.registrationAllowed) return 'login/server_closed.png';
    return 'login/can_register_server.png';
}

LoginAssets.getServerIcon = function(server)
{
    if (!server) return '';
	return 'login/server_' + server.type.name.toLowerCase() + '_' + (server.config.foreverVip ? 'paid' : 'free') + '.png';
}

